// CaboCha -- Yet Another Japanese Dependency Parser
//
//  $Id: char_category.h 41 2008-01-20 09:31:34Z taku-ku $;
//
//  Copyright(C) 2001-2012 Taku Kudo <taku@chasen.org>
#ifndef CABOCHA_CHAR_CATEGORY_H_
#define CABOCHA_CHAR_CATEGORY_H_

namespace CaboCha {

  enum {
    OTHER,
    KANJI,
    SYMBOL,
    HYPHEN,
    MONEY,
    ALPHANUMERIC,
    KANJINUMERIC,
    CAPALPHA,
    ALPHA,
    HIRAGANA,
    KATAKANA,
    GREEK,
    CYRILLIC,
    SPACE
  };

  static const unsigned char char_category[65536] = {
    OTHER,        /* 0x0 */
    OTHER,        /* 0x1 */
    OTHER,        /* 0x2 */
    OTHER,        /* 0x3 */
    OTHER,        /* 0x4 */
    OTHER,        /* 0x5 */
    OTHER,        /* 0x6 */
    OTHER,        /* 0x7 */
    OTHER,        /* 0x8 */
    SPACE,        /* 0x9 */
    SPACE,        /* 0xa */
    SPACE,        /* 0xb */
    OTHER,        /* 0xc */
    OTHER,        /* 0xd */
    OTHER,        /* 0xe */
    OTHER,        /* 0xf */
    OTHER,        /* 0x10 */
    OTHER,        /* 0x11 */
    OTHER,        /* 0x12 */
    OTHER,        /* 0x13 */
    OTHER,        /* 0x14 */
    OTHER,        /* 0x15 */
    OTHER,        /* 0x16 */
    OTHER,        /* 0x17 */
    OTHER,        /* 0x18 */
    OTHER,        /* 0x19 */
    OTHER,        /* 0x1a */
    OTHER,        /* 0x1b */
    OTHER,        /* 0x1c */
    OTHER,        /* 0x1d */
    OTHER,        /* 0x1e */
    OTHER,        /* 0x1f */
    SPACE,        /* 0x20 */
    SYMBOL,        /* 0x21 */
    SYMBOL,        /* 0x22 */
    SYMBOL,        /* 0x23 */
    SYMBOL,        /* 0x24 */
    SYMBOL,        /* 0x25 */
    SYMBOL,        /* 0x26 */
    SYMBOL,        /* 0x27 */
    SYMBOL,        /* 0x28 */
    SYMBOL,        /* 0x29 */
    SYMBOL,        /* 0x2a */
    SYMBOL,        /* 0x2b */
    SYMBOL,        /* 0x2c */
    SYMBOL,        /* 0x2d */
    SYMBOL,        /* 0x2e */
    SYMBOL,        /* 0x2f */
    ALPHANUMERIC,        /* 0x30 */
    ALPHANUMERIC,        /* 0x31 */
    ALPHANUMERIC,        /* 0x32 */
    ALPHANUMERIC,        /* 0x33 */
    ALPHANUMERIC,        /* 0x34 */
    ALPHANUMERIC,        /* 0x35 */
    ALPHANUMERIC,        /* 0x36 */
    ALPHANUMERIC,        /* 0x37 */
    ALPHANUMERIC,        /* 0x38 */
    ALPHANUMERIC,        /* 0x39 */
    SYMBOL,        /* 0x3a */
    SYMBOL,        /* 0x3b */
    SYMBOL,        /* 0x3c */
    SYMBOL,        /* 0x3d */
    SYMBOL,        /* 0x3e */
    SYMBOL,        /* 0x3f */
    SYMBOL,        /* 0x40 */
    ALPHA,        /* 0x41 */
    ALPHA,        /* 0x42 */
    ALPHA,        /* 0x43 */
    ALPHA,        /* 0x44 */
    ALPHA,        /* 0x45 */
    ALPHA,        /* 0x46 */
    ALPHA,        /* 0x47 */
    ALPHA,        /* 0x48 */
    ALPHA,        /* 0x49 */
    ALPHA,        /* 0x4a */
    ALPHA,        /* 0x4b */
    ALPHA,        /* 0x4c */
    ALPHA,        /* 0x4d */
    ALPHA,        /* 0x4e */
    ALPHA,        /* 0x4f */
    ALPHA,        /* 0x50 */
    ALPHA,        /* 0x51 */
    ALPHA,        /* 0x52 */
    ALPHA,        /* 0x53 */
    ALPHA,        /* 0x54 */
    ALPHA,        /* 0x55 */
    ALPHA,        /* 0x56 */
    ALPHA,        /* 0x57 */
    ALPHA,        /* 0x58 */
    ALPHA,        /* 0x59 */
    ALPHA,        /* 0x5a */
    SYMBOL,        /* 0x5b */
    SYMBOL,        /* 0x5c */
    SYMBOL,        /* 0x5d */
    SYMBOL,        /* 0x5e */
    SYMBOL,        /* 0x5f */
    SYMBOL,        /* 0x60 */
    ALPHA,        /* 0x61 */
    ALPHA,        /* 0x62 */
    ALPHA,        /* 0x63 */
    ALPHA,        /* 0x64 */
    ALPHA,        /* 0x65 */
    ALPHA,        /* 0x66 */
    ALPHA,        /* 0x67 */
    ALPHA,        /* 0x68 */
    ALPHA,        /* 0x69 */
    ALPHA,        /* 0x6a */
    ALPHA,        /* 0x6b */
    ALPHA,        /* 0x6c */
    ALPHA,        /* 0x6d */
    ALPHA,        /* 0x6e */
    ALPHA,        /* 0x6f */
    ALPHA,        /* 0x70 */
    ALPHA,        /* 0x71 */
    ALPHA,        /* 0x72 */
    ALPHA,        /* 0x73 */
    ALPHA,        /* 0x74 */
    ALPHA,        /* 0x75 */
    ALPHA,        /* 0x76 */
    ALPHA,        /* 0x77 */
    ALPHA,        /* 0x78 */
    ALPHA,        /* 0x79 */
    ALPHA,        /* 0x7a */
    SYMBOL,        /* 0x7b */
    SYMBOL,        /* 0x7c */
    SYMBOL,        /* 0x7d */
    SYMBOL,        /* 0x7e */
    OTHER,        /* 0x7f */
    OTHER,        /* 0x80 */
    OTHER,        /* 0x81 */
    OTHER,        /* 0x82 */
    OTHER,        /* 0x83 */
    OTHER,        /* 0x84 */
    OTHER,        /* 0x85 */
    OTHER,        /* 0x86 */
    OTHER,        /* 0x87 */
    OTHER,        /* 0x88 */
    OTHER,        /* 0x89 */
    OTHER,        /* 0x8a */
    OTHER,        /* 0x8b */
    OTHER,        /* 0x8c */
    OTHER,        /* 0x8d */
    OTHER,        /* 0x8e */
    OTHER,        /* 0x8f */
    OTHER,        /* 0x90 */
    OTHER,        /* 0x91 */
    OTHER,        /* 0x92 */
    OTHER,        /* 0x93 */
    OTHER,        /* 0x94 */
    OTHER,        /* 0x95 */
    OTHER,        /* 0x96 */
    OTHER,        /* 0x97 */
    OTHER,        /* 0x98 */
    OTHER,        /* 0x99 */
    OTHER,        /* 0x9a */
    OTHER,        /* 0x9b */
    OTHER,        /* 0x9c */
    OTHER,        /* 0x9d */
    OTHER,        /* 0x9e */
    OTHER,        /* 0x9f */
    OTHER,        /* 0xa0 */
    SYMBOL,        /* 0xa1 */
    SYMBOL,        /* 0xa2 */
    SYMBOL,        /* 0xa3 */
    SYMBOL,        /* 0xa4 */
    SYMBOL,        /* 0xa5 */
    SYMBOL,        /* 0xa6 */
    SYMBOL,        /* 0xa7 */
    SYMBOL,        /* 0xa8 */
    SYMBOL,        /* 0xa9 */
    SYMBOL,        /* 0xaa */
    SYMBOL,        /* 0xab */
    SYMBOL,        /* 0xac */
    SYMBOL,        /* 0xad */
    SYMBOL,        /* 0xae */
    SYMBOL,        /* 0xaf */
    SYMBOL,        /* 0xb0 */
    SYMBOL,        /* 0xb1 */
    SYMBOL,        /* 0xb2 */
    SYMBOL,        /* 0xb3 */
    SYMBOL,        /* 0xb4 */
    SYMBOL,        /* 0xb5 */
    SYMBOL,        /* 0xb6 */
    SYMBOL,        /* 0xb7 */
    SYMBOL,        /* 0xb8 */
    SYMBOL,        /* 0xb9 */
    SYMBOL,        /* 0xba */
    SYMBOL,        /* 0xbb */
    SYMBOL,        /* 0xbc */
    SYMBOL,        /* 0xbd */
    SYMBOL,        /* 0xbe */
    SYMBOL,        /* 0xbf */
    ALPHA,        /* 0xc0 */
    ALPHA,        /* 0xc1 */
    ALPHA,        /* 0xc2 */
    ALPHA,        /* 0xc3 */
    ALPHA,        /* 0xc4 */
    ALPHA,        /* 0xc5 */
    ALPHA,        /* 0xc6 */
    ALPHA,        /* 0xc7 */
    ALPHA,        /* 0xc8 */
    ALPHA,        /* 0xc9 */
    ALPHA,        /* 0xca */
    ALPHA,        /* 0xcb */
    ALPHA,        /* 0xcc */
    ALPHA,        /* 0xcd */
    ALPHA,        /* 0xce */
    ALPHA,        /* 0xcf */
    ALPHA,        /* 0xd0 */
    ALPHA,        /* 0xd1 */
    ALPHA,        /* 0xd2 */
    ALPHA,        /* 0xd3 */
    ALPHA,        /* 0xd4 */
    ALPHA,        /* 0xd5 */
    ALPHA,        /* 0xd6 */
    ALPHA,        /* 0xd7 */
    ALPHA,        /* 0xd8 */
    ALPHA,        /* 0xd9 */
    ALPHA,        /* 0xda */
    ALPHA,        /* 0xdb */
    ALPHA,        /* 0xdc */
    ALPHA,        /* 0xdd */
    ALPHA,        /* 0xde */
    ALPHA,        /* 0xdf */
    ALPHA,        /* 0xe0 */
    ALPHA,        /* 0xe1 */
    ALPHA,        /* 0xe2 */
    ALPHA,        /* 0xe3 */
    ALPHA,        /* 0xe4 */
    ALPHA,        /* 0xe5 */
    ALPHA,        /* 0xe6 */
    ALPHA,        /* 0xe7 */
    ALPHA,        /* 0xe8 */
    ALPHA,        /* 0xe9 */
    ALPHA,        /* 0xea */
    ALPHA,        /* 0xeb */
    ALPHA,        /* 0xec */
    ALPHA,        /* 0xed */
    ALPHA,        /* 0xee */
    ALPHA,        /* 0xef */
    ALPHA,        /* 0xf0 */
    ALPHA,        /* 0xf1 */
    ALPHA,        /* 0xf2 */
    ALPHA,        /* 0xf3 */
    ALPHA,        /* 0xf4 */
    ALPHA,        /* 0xf5 */
    ALPHA,        /* 0xf6 */
    ALPHA,        /* 0xf7 */
    ALPHA,        /* 0xf8 */
    ALPHA,        /* 0xf9 */
    ALPHA,        /* 0xfa */
    ALPHA,        /* 0xfb */
    ALPHA,        /* 0xfc */
    ALPHA,        /* 0xfd */
    ALPHA,        /* 0xfe */
    ALPHA,        /* 0xff */
    ALPHA,        /* 0x100 */
    ALPHA,        /* 0x101 */
    ALPHA,        /* 0x102 */
    ALPHA,        /* 0x103 */
    ALPHA,        /* 0x104 */
    ALPHA,        /* 0x105 */
    ALPHA,        /* 0x106 */
    ALPHA,        /* 0x107 */
    ALPHA,        /* 0x108 */
    ALPHA,        /* 0x109 */
    ALPHA,        /* 0x10a */
    ALPHA,        /* 0x10b */
    ALPHA,        /* 0x10c */
    ALPHA,        /* 0x10d */
    ALPHA,        /* 0x10e */
    ALPHA,        /* 0x10f */
    ALPHA,        /* 0x110 */
    ALPHA,        /* 0x111 */
    ALPHA,        /* 0x112 */
    ALPHA,        /* 0x113 */
    ALPHA,        /* 0x114 */
    ALPHA,        /* 0x115 */
    ALPHA,        /* 0x116 */
    ALPHA,        /* 0x117 */
    ALPHA,        /* 0x118 */
    ALPHA,        /* 0x119 */
    ALPHA,        /* 0x11a */
    ALPHA,        /* 0x11b */
    ALPHA,        /* 0x11c */
    ALPHA,        /* 0x11d */
    ALPHA,        /* 0x11e */
    ALPHA,        /* 0x11f */
    ALPHA,        /* 0x120 */
    ALPHA,        /* 0x121 */
    ALPHA,        /* 0x122 */
    ALPHA,        /* 0x123 */
    ALPHA,        /* 0x124 */
    ALPHA,        /* 0x125 */
    ALPHA,        /* 0x126 */
    ALPHA,        /* 0x127 */
    ALPHA,        /* 0x128 */
    ALPHA,        /* 0x129 */
    ALPHA,        /* 0x12a */
    ALPHA,        /* 0x12b */
    ALPHA,        /* 0x12c */
    ALPHA,        /* 0x12d */
    ALPHA,        /* 0x12e */
    ALPHA,        /* 0x12f */
    ALPHA,        /* 0x130 */
    ALPHA,        /* 0x131 */
    ALPHA,        /* 0x132 */
    ALPHA,        /* 0x133 */
    ALPHA,        /* 0x134 */
    ALPHA,        /* 0x135 */
    ALPHA,        /* 0x136 */
    ALPHA,        /* 0x137 */
    ALPHA,        /* 0x138 */
    ALPHA,        /* 0x139 */
    ALPHA,        /* 0x13a */
    ALPHA,        /* 0x13b */
    ALPHA,        /* 0x13c */
    ALPHA,        /* 0x13d */
    ALPHA,        /* 0x13e */
    ALPHA,        /* 0x13f */
    ALPHA,        /* 0x140 */
    ALPHA,        /* 0x141 */
    ALPHA,        /* 0x142 */
    ALPHA,        /* 0x143 */
    ALPHA,        /* 0x144 */
    ALPHA,        /* 0x145 */
    ALPHA,        /* 0x146 */
    ALPHA,        /* 0x147 */
    ALPHA,        /* 0x148 */
    ALPHA,        /* 0x149 */
    ALPHA,        /* 0x14a */
    ALPHA,        /* 0x14b */
    ALPHA,        /* 0x14c */
    ALPHA,        /* 0x14d */
    ALPHA,        /* 0x14e */
    ALPHA,        /* 0x14f */
    ALPHA,        /* 0x150 */
    ALPHA,        /* 0x151 */
    ALPHA,        /* 0x152 */
    ALPHA,        /* 0x153 */
    ALPHA,        /* 0x154 */
    ALPHA,        /* 0x155 */
    ALPHA,        /* 0x156 */
    ALPHA,        /* 0x157 */
    ALPHA,        /* 0x158 */
    ALPHA,        /* 0x159 */
    ALPHA,        /* 0x15a */
    ALPHA,        /* 0x15b */
    ALPHA,        /* 0x15c */
    ALPHA,        /* 0x15d */
    ALPHA,        /* 0x15e */
    ALPHA,        /* 0x15f */
    ALPHA,        /* 0x160 */
    ALPHA,        /* 0x161 */
    ALPHA,        /* 0x162 */
    ALPHA,        /* 0x163 */
    ALPHA,        /* 0x164 */
    ALPHA,        /* 0x165 */
    ALPHA,        /* 0x166 */
    ALPHA,        /* 0x167 */
    ALPHA,        /* 0x168 */
    ALPHA,        /* 0x169 */
    ALPHA,        /* 0x16a */
    ALPHA,        /* 0x16b */
    ALPHA,        /* 0x16c */
    ALPHA,        /* 0x16d */
    ALPHA,        /* 0x16e */
    ALPHA,        /* 0x16f */
    ALPHA,        /* 0x170 */
    ALPHA,        /* 0x171 */
    ALPHA,        /* 0x172 */
    ALPHA,        /* 0x173 */
    ALPHA,        /* 0x174 */
    ALPHA,        /* 0x175 */
    ALPHA,        /* 0x176 */
    ALPHA,        /* 0x177 */
    ALPHA,        /* 0x178 */
    ALPHA,        /* 0x179 */
    ALPHA,        /* 0x17a */
    ALPHA,        /* 0x17b */
    ALPHA,        /* 0x17c */
    ALPHA,        /* 0x17d */
    ALPHA,        /* 0x17e */
    ALPHA,        /* 0x17f */
    ALPHA,        /* 0x180 */
    ALPHA,        /* 0x181 */
    ALPHA,        /* 0x182 */
    ALPHA,        /* 0x183 */
    ALPHA,        /* 0x184 */
    ALPHA,        /* 0x185 */
    ALPHA,        /* 0x186 */
    ALPHA,        /* 0x187 */
    ALPHA,        /* 0x188 */
    ALPHA,        /* 0x189 */
    ALPHA,        /* 0x18a */
    ALPHA,        /* 0x18b */
    ALPHA,        /* 0x18c */
    ALPHA,        /* 0x18d */
    ALPHA,        /* 0x18e */
    ALPHA,        /* 0x18f */
    ALPHA,        /* 0x190 */
    ALPHA,        /* 0x191 */
    ALPHA,        /* 0x192 */
    ALPHA,        /* 0x193 */
    ALPHA,        /* 0x194 */
    ALPHA,        /* 0x195 */
    ALPHA,        /* 0x196 */
    ALPHA,        /* 0x197 */
    ALPHA,        /* 0x198 */
    ALPHA,        /* 0x199 */
    ALPHA,        /* 0x19a */
    ALPHA,        /* 0x19b */
    ALPHA,        /* 0x19c */
    ALPHA,        /* 0x19d */
    ALPHA,        /* 0x19e */
    ALPHA,        /* 0x19f */
    ALPHA,        /* 0x1a0 */
    ALPHA,        /* 0x1a1 */
    ALPHA,        /* 0x1a2 */
    ALPHA,        /* 0x1a3 */
    ALPHA,        /* 0x1a4 */
    ALPHA,        /* 0x1a5 */
    ALPHA,        /* 0x1a6 */
    ALPHA,        /* 0x1a7 */
    ALPHA,        /* 0x1a8 */
    ALPHA,        /* 0x1a9 */
    ALPHA,        /* 0x1aa */
    ALPHA,        /* 0x1ab */
    ALPHA,        /* 0x1ac */
    ALPHA,        /* 0x1ad */
    ALPHA,        /* 0x1ae */
    ALPHA,        /* 0x1af */
    ALPHA,        /* 0x1b0 */
    ALPHA,        /* 0x1b1 */
    ALPHA,        /* 0x1b2 */
    ALPHA,        /* 0x1b3 */
    ALPHA,        /* 0x1b4 */
    ALPHA,        /* 0x1b5 */
    ALPHA,        /* 0x1b6 */
    ALPHA,        /* 0x1b7 */
    ALPHA,        /* 0x1b8 */
    ALPHA,        /* 0x1b9 */
    ALPHA,        /* 0x1ba */
    ALPHA,        /* 0x1bb */
    ALPHA,        /* 0x1bc */
    ALPHA,        /* 0x1bd */
    ALPHA,        /* 0x1be */
    ALPHA,        /* 0x1bf */
    ALPHA,        /* 0x1c0 */
    ALPHA,        /* 0x1c1 */
    ALPHA,        /* 0x1c2 */
    ALPHA,        /* 0x1c3 */
    ALPHA,        /* 0x1c4 */
    ALPHA,        /* 0x1c5 */
    ALPHA,        /* 0x1c6 */
    ALPHA,        /* 0x1c7 */
    ALPHA,        /* 0x1c8 */
    ALPHA,        /* 0x1c9 */
    ALPHA,        /* 0x1ca */
    ALPHA,        /* 0x1cb */
    ALPHA,        /* 0x1cc */
    ALPHA,        /* 0x1cd */
    ALPHA,        /* 0x1ce */
    ALPHA,        /* 0x1cf */
    ALPHA,        /* 0x1d0 */
    ALPHA,        /* 0x1d1 */
    ALPHA,        /* 0x1d2 */
    ALPHA,        /* 0x1d3 */
    ALPHA,        /* 0x1d4 */
    ALPHA,        /* 0x1d5 */
    ALPHA,        /* 0x1d6 */
    ALPHA,        /* 0x1d7 */
    ALPHA,        /* 0x1d8 */
    ALPHA,        /* 0x1d9 */
    ALPHA,        /* 0x1da */
    ALPHA,        /* 0x1db */
    ALPHA,        /* 0x1dc */
    ALPHA,        /* 0x1dd */
    ALPHA,        /* 0x1de */
    ALPHA,        /* 0x1df */
    ALPHA,        /* 0x1e0 */
    ALPHA,        /* 0x1e1 */
    ALPHA,        /* 0x1e2 */
    ALPHA,        /* 0x1e3 */
    ALPHA,        /* 0x1e4 */
    ALPHA,        /* 0x1e5 */
    ALPHA,        /* 0x1e6 */
    ALPHA,        /* 0x1e7 */
    ALPHA,        /* 0x1e8 */
    ALPHA,        /* 0x1e9 */
    ALPHA,        /* 0x1ea */
    ALPHA,        /* 0x1eb */
    ALPHA,        /* 0x1ec */
    ALPHA,        /* 0x1ed */
    ALPHA,        /* 0x1ee */
    ALPHA,        /* 0x1ef */
    ALPHA,        /* 0x1f0 */
    ALPHA,        /* 0x1f1 */
    ALPHA,        /* 0x1f2 */
    ALPHA,        /* 0x1f3 */
    ALPHA,        /* 0x1f4 */
    ALPHA,        /* 0x1f5 */
    ALPHA,        /* 0x1f6 */
    ALPHA,        /* 0x1f7 */
    ALPHA,        /* 0x1f8 */
    ALPHA,        /* 0x1f9 */
    ALPHA,        /* 0x1fa */
    ALPHA,        /* 0x1fb */
    ALPHA,        /* 0x1fc */
    ALPHA,        /* 0x1fd */
    ALPHA,        /* 0x1fe */
    ALPHA,        /* 0x1ff */
    ALPHA,        /* 0x200 */
    ALPHA,        /* 0x201 */
    ALPHA,        /* 0x202 */
    ALPHA,        /* 0x203 */
    ALPHA,        /* 0x204 */
    ALPHA,        /* 0x205 */
    ALPHA,        /* 0x206 */
    ALPHA,        /* 0x207 */
    ALPHA,        /* 0x208 */
    ALPHA,        /* 0x209 */
    ALPHA,        /* 0x20a */
    ALPHA,        /* 0x20b */
    ALPHA,        /* 0x20c */
    ALPHA,        /* 0x20d */
    ALPHA,        /* 0x20e */
    ALPHA,        /* 0x20f */
    ALPHA,        /* 0x210 */
    ALPHA,        /* 0x211 */
    ALPHA,        /* 0x212 */
    ALPHA,        /* 0x213 */
    ALPHA,        /* 0x214 */
    ALPHA,        /* 0x215 */
    ALPHA,        /* 0x216 */
    ALPHA,        /* 0x217 */
    ALPHA,        /* 0x218 */
    ALPHA,        /* 0x219 */
    ALPHA,        /* 0x21a */
    ALPHA,        /* 0x21b */
    ALPHA,        /* 0x21c */
    ALPHA,        /* 0x21d */
    ALPHA,        /* 0x21e */
    ALPHA,        /* 0x21f */
    ALPHA,        /* 0x220 */
    ALPHA,        /* 0x221 */
    ALPHA,        /* 0x222 */
    ALPHA,        /* 0x223 */
    ALPHA,        /* 0x224 */
    ALPHA,        /* 0x225 */
    ALPHA,        /* 0x226 */
    ALPHA,        /* 0x227 */
    ALPHA,        /* 0x228 */
    ALPHA,        /* 0x229 */
    ALPHA,        /* 0x22a */
    ALPHA,        /* 0x22b */
    ALPHA,        /* 0x22c */
    ALPHA,        /* 0x22d */
    ALPHA,        /* 0x22e */
    ALPHA,        /* 0x22f */
    ALPHA,        /* 0x230 */
    ALPHA,        /* 0x231 */
    ALPHA,        /* 0x232 */
    ALPHA,        /* 0x233 */
    ALPHA,        /* 0x234 */
    ALPHA,        /* 0x235 */
    ALPHA,        /* 0x236 */
    OTHER,        /* 0x237 */
    OTHER,        /* 0x238 */
    OTHER,        /* 0x239 */
    OTHER,        /* 0x23a */
    OTHER,        /* 0x23b */
    OTHER,        /* 0x23c */
    OTHER,        /* 0x23d */
    OTHER,        /* 0x23e */
    OTHER,        /* 0x23f */
    OTHER,        /* 0x240 */
    OTHER,        /* 0x241 */
    OTHER,        /* 0x242 */
    OTHER,        /* 0x243 */
    OTHER,        /* 0x244 */
    OTHER,        /* 0x245 */
    OTHER,        /* 0x246 */
    OTHER,        /* 0x247 */
    OTHER,        /* 0x248 */
    OTHER,        /* 0x249 */
    OTHER,        /* 0x24a */
    OTHER,        /* 0x24b */
    OTHER,        /* 0x24c */
    OTHER,        /* 0x24d */
    OTHER,        /* 0x24e */
    OTHER,        /* 0x24f */
    OTHER,        /* 0x250 */
    OTHER,        /* 0x251 */
    OTHER,        /* 0x252 */
    OTHER,        /* 0x253 */
    OTHER,        /* 0x254 */
    OTHER,        /* 0x255 */
    OTHER,        /* 0x256 */
    OTHER,        /* 0x257 */
    OTHER,        /* 0x258 */
    OTHER,        /* 0x259 */
    OTHER,        /* 0x25a */
    OTHER,        /* 0x25b */
    OTHER,        /* 0x25c */
    OTHER,        /* 0x25d */
    OTHER,        /* 0x25e */
    OTHER,        /* 0x25f */
    OTHER,        /* 0x260 */
    OTHER,        /* 0x261 */
    OTHER,        /* 0x262 */
    OTHER,        /* 0x263 */
    OTHER,        /* 0x264 */
    OTHER,        /* 0x265 */
    OTHER,        /* 0x266 */
    OTHER,        /* 0x267 */
    OTHER,        /* 0x268 */
    OTHER,        /* 0x269 */
    OTHER,        /* 0x26a */
    OTHER,        /* 0x26b */
    OTHER,        /* 0x26c */
    OTHER,        /* 0x26d */
    OTHER,        /* 0x26e */
    OTHER,        /* 0x26f */
    OTHER,        /* 0x270 */
    OTHER,        /* 0x271 */
    OTHER,        /* 0x272 */
    OTHER,        /* 0x273 */
    OTHER,        /* 0x274 */
    OTHER,        /* 0x275 */
    OTHER,        /* 0x276 */
    OTHER,        /* 0x277 */
    OTHER,        /* 0x278 */
    OTHER,        /* 0x279 */
    OTHER,        /* 0x27a */
    OTHER,        /* 0x27b */
    OTHER,        /* 0x27c */
    OTHER,        /* 0x27d */
    OTHER,        /* 0x27e */
    OTHER,        /* 0x27f */
    OTHER,        /* 0x280 */
    OTHER,        /* 0x281 */
    OTHER,        /* 0x282 */
    OTHER,        /* 0x283 */
    OTHER,        /* 0x284 */
    OTHER,        /* 0x285 */
    OTHER,        /* 0x286 */
    OTHER,        /* 0x287 */
    OTHER,        /* 0x288 */
    OTHER,        /* 0x289 */
    OTHER,        /* 0x28a */
    OTHER,        /* 0x28b */
    OTHER,        /* 0x28c */
    OTHER,        /* 0x28d */
    OTHER,        /* 0x28e */
    OTHER,        /* 0x28f */
    OTHER,        /* 0x290 */
    OTHER,        /* 0x291 */
    OTHER,        /* 0x292 */
    OTHER,        /* 0x293 */
    OTHER,        /* 0x294 */
    OTHER,        /* 0x295 */
    OTHER,        /* 0x296 */
    OTHER,        /* 0x297 */
    OTHER,        /* 0x298 */
    OTHER,        /* 0x299 */
    OTHER,        /* 0x29a */
    OTHER,        /* 0x29b */
    OTHER,        /* 0x29c */
    OTHER,        /* 0x29d */
    OTHER,        /* 0x29e */
    OTHER,        /* 0x29f */
    OTHER,        /* 0x2a0 */
    OTHER,        /* 0x2a1 */
    OTHER,        /* 0x2a2 */
    OTHER,        /* 0x2a3 */
    OTHER,        /* 0x2a4 */
    OTHER,        /* 0x2a5 */
    OTHER,        /* 0x2a6 */
    OTHER,        /* 0x2a7 */
    OTHER,        /* 0x2a8 */
    OTHER,        /* 0x2a9 */
    OTHER,        /* 0x2aa */
    OTHER,        /* 0x2ab */
    OTHER,        /* 0x2ac */
    OTHER,        /* 0x2ad */
    OTHER,        /* 0x2ae */
    OTHER,        /* 0x2af */
    OTHER,        /* 0x2b0 */
    OTHER,        /* 0x2b1 */
    OTHER,        /* 0x2b2 */
    OTHER,        /* 0x2b3 */
    OTHER,        /* 0x2b4 */
    OTHER,        /* 0x2b5 */
    OTHER,        /* 0x2b6 */
    OTHER,        /* 0x2b7 */
    OTHER,        /* 0x2b8 */
    OTHER,        /* 0x2b9 */
    OTHER,        /* 0x2ba */
    OTHER,        /* 0x2bb */
    OTHER,        /* 0x2bc */
    OTHER,        /* 0x2bd */
    OTHER,        /* 0x2be */
    OTHER,        /* 0x2bf */
    OTHER,        /* 0x2c0 */
    OTHER,        /* 0x2c1 */
    OTHER,        /* 0x2c2 */
    OTHER,        /* 0x2c3 */
    OTHER,        /* 0x2c4 */
    OTHER,        /* 0x2c5 */
    OTHER,        /* 0x2c6 */
    OTHER,        /* 0x2c7 */
    OTHER,        /* 0x2c8 */
    OTHER,        /* 0x2c9 */
    OTHER,        /* 0x2ca */
    OTHER,        /* 0x2cb */
    OTHER,        /* 0x2cc */
    OTHER,        /* 0x2cd */
    OTHER,        /* 0x2ce */
    OTHER,        /* 0x2cf */
    OTHER,        /* 0x2d0 */
    OTHER,        /* 0x2d1 */
    OTHER,        /* 0x2d2 */
    OTHER,        /* 0x2d3 */
    OTHER,        /* 0x2d4 */
    OTHER,        /* 0x2d5 */
    OTHER,        /* 0x2d6 */
    OTHER,        /* 0x2d7 */
    OTHER,        /* 0x2d8 */
    OTHER,        /* 0x2d9 */
    OTHER,        /* 0x2da */
    OTHER,        /* 0x2db */
    OTHER,        /* 0x2dc */
    OTHER,        /* 0x2dd */
    OTHER,        /* 0x2de */
    OTHER,        /* 0x2df */
    OTHER,        /* 0x2e0 */
    OTHER,        /* 0x2e1 */
    OTHER,        /* 0x2e2 */
    OTHER,        /* 0x2e3 */
    OTHER,        /* 0x2e4 */
    OTHER,        /* 0x2e5 */
    OTHER,        /* 0x2e6 */
    OTHER,        /* 0x2e7 */
    OTHER,        /* 0x2e8 */
    OTHER,        /* 0x2e9 */
    OTHER,        /* 0x2ea */
    OTHER,        /* 0x2eb */
    OTHER,        /* 0x2ec */
    OTHER,        /* 0x2ed */
    OTHER,        /* 0x2ee */
    OTHER,        /* 0x2ef */
    OTHER,        /* 0x2f0 */
    OTHER,        /* 0x2f1 */
    OTHER,        /* 0x2f2 */
    OTHER,        /* 0x2f3 */
    OTHER,        /* 0x2f4 */
    OTHER,        /* 0x2f5 */
    OTHER,        /* 0x2f6 */
    OTHER,        /* 0x2f7 */
    OTHER,        /* 0x2f8 */
    OTHER,        /* 0x2f9 */
    OTHER,        /* 0x2fa */
    OTHER,        /* 0x2fb */
    OTHER,        /* 0x2fc */
    OTHER,        /* 0x2fd */
    OTHER,        /* 0x2fe */
    OTHER,        /* 0x2ff */
    OTHER,        /* 0x300 */
    OTHER,        /* 0x301 */
    OTHER,        /* 0x302 */
    OTHER,        /* 0x303 */
    OTHER,        /* 0x304 */
    OTHER,        /* 0x305 */
    OTHER,        /* 0x306 */
    OTHER,        /* 0x307 */
    OTHER,        /* 0x308 */
    OTHER,        /* 0x309 */
    OTHER,        /* 0x30a */
    OTHER,        /* 0x30b */
    OTHER,        /* 0x30c */
    OTHER,        /* 0x30d */
    OTHER,        /* 0x30e */
    OTHER,        /* 0x30f */
    OTHER,        /* 0x310 */
    OTHER,        /* 0x311 */
    OTHER,        /* 0x312 */
    OTHER,        /* 0x313 */
    OTHER,        /* 0x314 */
    OTHER,        /* 0x315 */
    OTHER,        /* 0x316 */
    OTHER,        /* 0x317 */
    OTHER,        /* 0x318 */
    OTHER,        /* 0x319 */
    OTHER,        /* 0x31a */
    OTHER,        /* 0x31b */
    OTHER,        /* 0x31c */
    OTHER,        /* 0x31d */
    OTHER,        /* 0x31e */
    OTHER,        /* 0x31f */
    OTHER,        /* 0x320 */
    OTHER,        /* 0x321 */
    OTHER,        /* 0x322 */
    OTHER,        /* 0x323 */
    OTHER,        /* 0x324 */
    OTHER,        /* 0x325 */
    OTHER,        /* 0x326 */
    OTHER,        /* 0x327 */
    OTHER,        /* 0x328 */
    OTHER,        /* 0x329 */
    OTHER,        /* 0x32a */
    OTHER,        /* 0x32b */
    OTHER,        /* 0x32c */
    OTHER,        /* 0x32d */
    OTHER,        /* 0x32e */
    OTHER,        /* 0x32f */
    OTHER,        /* 0x330 */
    OTHER,        /* 0x331 */
    OTHER,        /* 0x332 */
    OTHER,        /* 0x333 */
    OTHER,        /* 0x334 */
    OTHER,        /* 0x335 */
    OTHER,        /* 0x336 */
    OTHER,        /* 0x337 */
    OTHER,        /* 0x338 */
    OTHER,        /* 0x339 */
    OTHER,        /* 0x33a */
    OTHER,        /* 0x33b */
    OTHER,        /* 0x33c */
    OTHER,        /* 0x33d */
    OTHER,        /* 0x33e */
    OTHER,        /* 0x33f */
    OTHER,        /* 0x340 */
    OTHER,        /* 0x341 */
    OTHER,        /* 0x342 */
    OTHER,        /* 0x343 */
    OTHER,        /* 0x344 */
    OTHER,        /* 0x345 */
    OTHER,        /* 0x346 */
    OTHER,        /* 0x347 */
    OTHER,        /* 0x348 */
    OTHER,        /* 0x349 */
    OTHER,        /* 0x34a */
    OTHER,        /* 0x34b */
    OTHER,        /* 0x34c */
    OTHER,        /* 0x34d */
    OTHER,        /* 0x34e */
    OTHER,        /* 0x34f */
    OTHER,        /* 0x350 */
    OTHER,        /* 0x351 */
    OTHER,        /* 0x352 */
    OTHER,        /* 0x353 */
    OTHER,        /* 0x354 */
    OTHER,        /* 0x355 */
    OTHER,        /* 0x356 */
    OTHER,        /* 0x357 */
    OTHER,        /* 0x358 */
    OTHER,        /* 0x359 */
    OTHER,        /* 0x35a */
    OTHER,        /* 0x35b */
    OTHER,        /* 0x35c */
    OTHER,        /* 0x35d */
    OTHER,        /* 0x35e */
    OTHER,        /* 0x35f */
    OTHER,        /* 0x360 */
    OTHER,        /* 0x361 */
    OTHER,        /* 0x362 */
    OTHER,        /* 0x363 */
    OTHER,        /* 0x364 */
    OTHER,        /* 0x365 */
    OTHER,        /* 0x366 */
    OTHER,        /* 0x367 */
    OTHER,        /* 0x368 */
    OTHER,        /* 0x369 */
    OTHER,        /* 0x36a */
    OTHER,        /* 0x36b */
    OTHER,        /* 0x36c */
    OTHER,        /* 0x36d */
    OTHER,        /* 0x36e */
    OTHER,        /* 0x36f */
    OTHER,        /* 0x370 */
    OTHER,        /* 0x371 */
    OTHER,        /* 0x372 */
    OTHER,        /* 0x373 */
    GREEK,        /* 0x374 */
    GREEK,        /* 0x375 */
    GREEK,        /* 0x376 */
    GREEK,        /* 0x377 */
    GREEK,        /* 0x378 */
    GREEK,        /* 0x379 */
    GREEK,        /* 0x37a */
    GREEK,        /* 0x37b */
    GREEK,        /* 0x37c */
    GREEK,        /* 0x37d */
    GREEK,        /* 0x37e */
    GREEK,        /* 0x37f */
    GREEK,        /* 0x380 */
    GREEK,        /* 0x381 */
    GREEK,        /* 0x382 */
    GREEK,        /* 0x383 */
    GREEK,        /* 0x384 */
    GREEK,        /* 0x385 */
    GREEK,        /* 0x386 */
    GREEK,        /* 0x387 */
    GREEK,        /* 0x388 */
    GREEK,        /* 0x389 */
    GREEK,        /* 0x38a */
    GREEK,        /* 0x38b */
    GREEK,        /* 0x38c */
    GREEK,        /* 0x38d */
    GREEK,        /* 0x38e */
    GREEK,        /* 0x38f */
    GREEK,        /* 0x390 */
    GREEK,        /* 0x391 */
    GREEK,        /* 0x392 */
    GREEK,        /* 0x393 */
    GREEK,        /* 0x394 */
    GREEK,        /* 0x395 */
    GREEK,        /* 0x396 */
    GREEK,        /* 0x397 */
    GREEK,        /* 0x398 */
    GREEK,        /* 0x399 */
    GREEK,        /* 0x39a */
    GREEK,        /* 0x39b */
    GREEK,        /* 0x39c */
    GREEK,        /* 0x39d */
    GREEK,        /* 0x39e */
    GREEK,        /* 0x39f */
    GREEK,        /* 0x3a0 */
    GREEK,        /* 0x3a1 */
    GREEK,        /* 0x3a2 */
    GREEK,        /* 0x3a3 */
    GREEK,        /* 0x3a4 */
    GREEK,        /* 0x3a5 */
    GREEK,        /* 0x3a6 */
    GREEK,        /* 0x3a7 */
    GREEK,        /* 0x3a8 */
    GREEK,        /* 0x3a9 */
    GREEK,        /* 0x3aa */
    GREEK,        /* 0x3ab */
    GREEK,        /* 0x3ac */
    GREEK,        /* 0x3ad */
    GREEK,        /* 0x3ae */
    GREEK,        /* 0x3af */
    GREEK,        /* 0x3b0 */
    GREEK,        /* 0x3b1 */
    GREEK,        /* 0x3b2 */
    GREEK,        /* 0x3b3 */
    GREEK,        /* 0x3b4 */
    GREEK,        /* 0x3b5 */
    GREEK,        /* 0x3b6 */
    GREEK,        /* 0x3b7 */
    GREEK,        /* 0x3b8 */
    GREEK,        /* 0x3b9 */
    GREEK,        /* 0x3ba */
    GREEK,        /* 0x3bb */
    GREEK,        /* 0x3bc */
    GREEK,        /* 0x3bd */
    GREEK,        /* 0x3be */
    GREEK,        /* 0x3bf */
    GREEK,        /* 0x3c0 */
    GREEK,        /* 0x3c1 */
    GREEK,        /* 0x3c2 */
    GREEK,        /* 0x3c3 */
    GREEK,        /* 0x3c4 */
    GREEK,        /* 0x3c5 */
    GREEK,        /* 0x3c6 */
    GREEK,        /* 0x3c7 */
    GREEK,        /* 0x3c8 */
    GREEK,        /* 0x3c9 */
    GREEK,        /* 0x3ca */
    GREEK,        /* 0x3cb */
    GREEK,        /* 0x3cc */
    GREEK,        /* 0x3cd */
    GREEK,        /* 0x3ce */
    GREEK,        /* 0x3cf */
    GREEK,        /* 0x3d0 */
    GREEK,        /* 0x3d1 */
    GREEK,        /* 0x3d2 */
    GREEK,        /* 0x3d3 */
    GREEK,        /* 0x3d4 */
    GREEK,        /* 0x3d5 */
    GREEK,        /* 0x3d6 */
    GREEK,        /* 0x3d7 */
    GREEK,        /* 0x3d8 */
    GREEK,        /* 0x3d9 */
    GREEK,        /* 0x3da */
    GREEK,        /* 0x3db */
    GREEK,        /* 0x3dc */
    GREEK,        /* 0x3dd */
    GREEK,        /* 0x3de */
    GREEK,        /* 0x3df */
    GREEK,        /* 0x3e0 */
    GREEK,        /* 0x3e1 */
    GREEK,        /* 0x3e2 */
    GREEK,        /* 0x3e3 */
    GREEK,        /* 0x3e4 */
    GREEK,        /* 0x3e5 */
    GREEK,        /* 0x3e6 */
    GREEK,        /* 0x3e7 */
    GREEK,        /* 0x3e8 */
    GREEK,        /* 0x3e9 */
    GREEK,        /* 0x3ea */
    GREEK,        /* 0x3eb */
    GREEK,        /* 0x3ec */
    GREEK,        /* 0x3ed */
    GREEK,        /* 0x3ee */
    GREEK,        /* 0x3ef */
    GREEK,        /* 0x3f0 */
    GREEK,        /* 0x3f1 */
    GREEK,        /* 0x3f2 */
    GREEK,        /* 0x3f3 */
    GREEK,        /* 0x3f4 */
    GREEK,        /* 0x3f5 */
    GREEK,        /* 0x3f6 */
    GREEK,        /* 0x3f7 */
    GREEK,        /* 0x3f8 */
    GREEK,        /* 0x3f9 */
    GREEK,        /* 0x3fa */
    GREEK,        /* 0x3fb */
    OTHER,        /* 0x3fc */
    OTHER,        /* 0x3fd */
    OTHER,        /* 0x3fe */
    OTHER,        /* 0x3ff */
    CYRILLIC,        /* 0x400 */
    CYRILLIC,        /* 0x401 */
    CYRILLIC,        /* 0x402 */
    CYRILLIC,        /* 0x403 */
    CYRILLIC,        /* 0x404 */
    CYRILLIC,        /* 0x405 */
    CYRILLIC,        /* 0x406 */
    CYRILLIC,        /* 0x407 */
    CYRILLIC,        /* 0x408 */
    CYRILLIC,        /* 0x409 */
    CYRILLIC,        /* 0x40a */
    CYRILLIC,        /* 0x40b */
    CYRILLIC,        /* 0x40c */
    CYRILLIC,        /* 0x40d */
    CYRILLIC,        /* 0x40e */
    CYRILLIC,        /* 0x40f */
    CYRILLIC,        /* 0x410 */
    CYRILLIC,        /* 0x411 */
    CYRILLIC,        /* 0x412 */
    CYRILLIC,        /* 0x413 */
    CYRILLIC,        /* 0x414 */
    CYRILLIC,        /* 0x415 */
    CYRILLIC,        /* 0x416 */
    CYRILLIC,        /* 0x417 */
    CYRILLIC,        /* 0x418 */
    CYRILLIC,        /* 0x419 */
    CYRILLIC,        /* 0x41a */
    CYRILLIC,        /* 0x41b */
    CYRILLIC,        /* 0x41c */
    CYRILLIC,        /* 0x41d */
    CYRILLIC,        /* 0x41e */
    CYRILLIC,        /* 0x41f */
    CYRILLIC,        /* 0x420 */
    CYRILLIC,        /* 0x421 */
    CYRILLIC,        /* 0x422 */
    CYRILLIC,        /* 0x423 */
    CYRILLIC,        /* 0x424 */
    CYRILLIC,        /* 0x425 */
    CYRILLIC,        /* 0x426 */
    CYRILLIC,        /* 0x427 */
    CYRILLIC,        /* 0x428 */
    CYRILLIC,        /* 0x429 */
    CYRILLIC,        /* 0x42a */
    CYRILLIC,        /* 0x42b */
    CYRILLIC,        /* 0x42c */
    CYRILLIC,        /* 0x42d */
    CYRILLIC,        /* 0x42e */
    CYRILLIC,        /* 0x42f */
    CYRILLIC,        /* 0x430 */
    CYRILLIC,        /* 0x431 */
    CYRILLIC,        /* 0x432 */
    CYRILLIC,        /* 0x433 */
    CYRILLIC,        /* 0x434 */
    CYRILLIC,        /* 0x435 */
    CYRILLIC,        /* 0x436 */
    CYRILLIC,        /* 0x437 */
    CYRILLIC,        /* 0x438 */
    CYRILLIC,        /* 0x439 */
    CYRILLIC,        /* 0x43a */
    CYRILLIC,        /* 0x43b */
    CYRILLIC,        /* 0x43c */
    CYRILLIC,        /* 0x43d */
    CYRILLIC,        /* 0x43e */
    CYRILLIC,        /* 0x43f */
    CYRILLIC,        /* 0x440 */
    CYRILLIC,        /* 0x441 */
    CYRILLIC,        /* 0x442 */
    CYRILLIC,        /* 0x443 */
    CYRILLIC,        /* 0x444 */
    CYRILLIC,        /* 0x445 */
    CYRILLIC,        /* 0x446 */
    CYRILLIC,        /* 0x447 */
    CYRILLIC,        /* 0x448 */
    CYRILLIC,        /* 0x449 */
    CYRILLIC,        /* 0x44a */
    CYRILLIC,        /* 0x44b */
    CYRILLIC,        /* 0x44c */
    CYRILLIC,        /* 0x44d */
    CYRILLIC,        /* 0x44e */
    CYRILLIC,        /* 0x44f */
    CYRILLIC,        /* 0x450 */
    CYRILLIC,        /* 0x451 */
    CYRILLIC,        /* 0x452 */
    CYRILLIC,        /* 0x453 */
    CYRILLIC,        /* 0x454 */
    CYRILLIC,        /* 0x455 */
    CYRILLIC,        /* 0x456 */
    CYRILLIC,        /* 0x457 */
    CYRILLIC,        /* 0x458 */
    CYRILLIC,        /* 0x459 */
    CYRILLIC,        /* 0x45a */
    CYRILLIC,        /* 0x45b */
    CYRILLIC,        /* 0x45c */
    CYRILLIC,        /* 0x45d */
    CYRILLIC,        /* 0x45e */
    CYRILLIC,        /* 0x45f */
    CYRILLIC,        /* 0x460 */
    CYRILLIC,        /* 0x461 */
    CYRILLIC,        /* 0x462 */
    CYRILLIC,        /* 0x463 */
    CYRILLIC,        /* 0x464 */
    CYRILLIC,        /* 0x465 */
    CYRILLIC,        /* 0x466 */
    CYRILLIC,        /* 0x467 */
    CYRILLIC,        /* 0x468 */
    CYRILLIC,        /* 0x469 */
    CYRILLIC,        /* 0x46a */
    CYRILLIC,        /* 0x46b */
    CYRILLIC,        /* 0x46c */
    CYRILLIC,        /* 0x46d */
    CYRILLIC,        /* 0x46e */
    CYRILLIC,        /* 0x46f */
    CYRILLIC,        /* 0x470 */
    CYRILLIC,        /* 0x471 */
    CYRILLIC,        /* 0x472 */
    CYRILLIC,        /* 0x473 */
    CYRILLIC,        /* 0x474 */
    CYRILLIC,        /* 0x475 */
    CYRILLIC,        /* 0x476 */
    CYRILLIC,        /* 0x477 */
    CYRILLIC,        /* 0x478 */
    CYRILLIC,        /* 0x479 */
    CYRILLIC,        /* 0x47a */
    CYRILLIC,        /* 0x47b */
    CYRILLIC,        /* 0x47c */
    CYRILLIC,        /* 0x47d */
    CYRILLIC,        /* 0x47e */
    CYRILLIC,        /* 0x47f */
    CYRILLIC,        /* 0x480 */
    CYRILLIC,        /* 0x481 */
    CYRILLIC,        /* 0x482 */
    CYRILLIC,        /* 0x483 */
    CYRILLIC,        /* 0x484 */
    CYRILLIC,        /* 0x485 */
    CYRILLIC,        /* 0x486 */
    CYRILLIC,        /* 0x487 */
    CYRILLIC,        /* 0x488 */
    CYRILLIC,        /* 0x489 */
    CYRILLIC,        /* 0x48a */
    CYRILLIC,        /* 0x48b */
    CYRILLIC,        /* 0x48c */
    CYRILLIC,        /* 0x48d */
    CYRILLIC,        /* 0x48e */
    CYRILLIC,        /* 0x48f */
    CYRILLIC,        /* 0x490 */
    CYRILLIC,        /* 0x491 */
    CYRILLIC,        /* 0x492 */
    CYRILLIC,        /* 0x493 */
    CYRILLIC,        /* 0x494 */
    CYRILLIC,        /* 0x495 */
    CYRILLIC,        /* 0x496 */
    CYRILLIC,        /* 0x497 */
    CYRILLIC,        /* 0x498 */
    CYRILLIC,        /* 0x499 */
    CYRILLIC,        /* 0x49a */
    CYRILLIC,        /* 0x49b */
    CYRILLIC,        /* 0x49c */
    CYRILLIC,        /* 0x49d */
    CYRILLIC,        /* 0x49e */
    CYRILLIC,        /* 0x49f */
    CYRILLIC,        /* 0x4a0 */
    CYRILLIC,        /* 0x4a1 */
    CYRILLIC,        /* 0x4a2 */
    CYRILLIC,        /* 0x4a3 */
    CYRILLIC,        /* 0x4a4 */
    CYRILLIC,        /* 0x4a5 */
    CYRILLIC,        /* 0x4a6 */
    CYRILLIC,        /* 0x4a7 */
    CYRILLIC,        /* 0x4a8 */
    CYRILLIC,        /* 0x4a9 */
    CYRILLIC,        /* 0x4aa */
    CYRILLIC,        /* 0x4ab */
    CYRILLIC,        /* 0x4ac */
    CYRILLIC,        /* 0x4ad */
    CYRILLIC,        /* 0x4ae */
    CYRILLIC,        /* 0x4af */
    CYRILLIC,        /* 0x4b0 */
    CYRILLIC,        /* 0x4b1 */
    CYRILLIC,        /* 0x4b2 */
    CYRILLIC,        /* 0x4b3 */
    CYRILLIC,        /* 0x4b4 */
    CYRILLIC,        /* 0x4b5 */
    CYRILLIC,        /* 0x4b6 */
    CYRILLIC,        /* 0x4b7 */
    CYRILLIC,        /* 0x4b8 */
    CYRILLIC,        /* 0x4b9 */
    CYRILLIC,        /* 0x4ba */
    CYRILLIC,        /* 0x4bb */
    CYRILLIC,        /* 0x4bc */
    CYRILLIC,        /* 0x4bd */
    CYRILLIC,        /* 0x4be */
    CYRILLIC,        /* 0x4bf */
    CYRILLIC,        /* 0x4c0 */
    CYRILLIC,        /* 0x4c1 */
    CYRILLIC,        /* 0x4c2 */
    CYRILLIC,        /* 0x4c3 */
    CYRILLIC,        /* 0x4c4 */
    CYRILLIC,        /* 0x4c5 */
    CYRILLIC,        /* 0x4c6 */
    CYRILLIC,        /* 0x4c7 */
    CYRILLIC,        /* 0x4c8 */
    CYRILLIC,        /* 0x4c9 */
    CYRILLIC,        /* 0x4ca */
    CYRILLIC,        /* 0x4cb */
    CYRILLIC,        /* 0x4cc */
    CYRILLIC,        /* 0x4cd */
    CYRILLIC,        /* 0x4ce */
    CYRILLIC,        /* 0x4cf */
    CYRILLIC,        /* 0x4d0 */
    CYRILLIC,        /* 0x4d1 */
    CYRILLIC,        /* 0x4d2 */
    CYRILLIC,        /* 0x4d3 */
    CYRILLIC,        /* 0x4d4 */
    CYRILLIC,        /* 0x4d5 */
    CYRILLIC,        /* 0x4d6 */
    CYRILLIC,        /* 0x4d7 */
    CYRILLIC,        /* 0x4d8 */
    CYRILLIC,        /* 0x4d9 */
    CYRILLIC,        /* 0x4da */
    CYRILLIC,        /* 0x4db */
    CYRILLIC,        /* 0x4dc */
    CYRILLIC,        /* 0x4dd */
    CYRILLIC,        /* 0x4de */
    CYRILLIC,        /* 0x4df */
    CYRILLIC,        /* 0x4e0 */
    CYRILLIC,        /* 0x4e1 */
    CYRILLIC,        /* 0x4e2 */
    CYRILLIC,        /* 0x4e3 */
    CYRILLIC,        /* 0x4e4 */
    CYRILLIC,        /* 0x4e5 */
    CYRILLIC,        /* 0x4e6 */
    CYRILLIC,        /* 0x4e7 */
    CYRILLIC,        /* 0x4e8 */
    CYRILLIC,        /* 0x4e9 */
    CYRILLIC,        /* 0x4ea */
    CYRILLIC,        /* 0x4eb */
    CYRILLIC,        /* 0x4ec */
    CYRILLIC,        /* 0x4ed */
    CYRILLIC,        /* 0x4ee */
    CYRILLIC,        /* 0x4ef */
    CYRILLIC,        /* 0x4f0 */
    CYRILLIC,        /* 0x4f1 */
    CYRILLIC,        /* 0x4f2 */
    CYRILLIC,        /* 0x4f3 */
    CYRILLIC,        /* 0x4f4 */
    CYRILLIC,        /* 0x4f5 */
    CYRILLIC,        /* 0x4f6 */
    CYRILLIC,        /* 0x4f7 */
    CYRILLIC,        /* 0x4f8 */
    CYRILLIC,        /* 0x4f9 */
    OTHER,        /* 0x4fa */
    OTHER,        /* 0x4fb */
    OTHER,        /* 0x4fc */
    OTHER,        /* 0x4fd */
    OTHER,        /* 0x4fe */
    OTHER,        /* 0x4ff */
    CYRILLIC,        /* 0x500 */
    CYRILLIC,        /* 0x501 */
    CYRILLIC,        /* 0x502 */
    CYRILLIC,        /* 0x503 */
    CYRILLIC,        /* 0x504 */
    CYRILLIC,        /* 0x505 */
    CYRILLIC,        /* 0x506 */
    CYRILLIC,        /* 0x507 */
    CYRILLIC,        /* 0x508 */
    CYRILLIC,        /* 0x509 */
    CYRILLIC,        /* 0x50a */
    CYRILLIC,        /* 0x50b */
    CYRILLIC,        /* 0x50c */
    CYRILLIC,        /* 0x50d */
    CYRILLIC,        /* 0x50e */
    CYRILLIC,        /* 0x50f */
    OTHER,        /* 0x510 */
    OTHER,        /* 0x511 */
    OTHER,        /* 0x512 */
    OTHER,        /* 0x513 */
    OTHER,        /* 0x514 */
    OTHER,        /* 0x515 */
    OTHER,        /* 0x516 */
    OTHER,        /* 0x517 */
    OTHER,        /* 0x518 */
    OTHER,        /* 0x519 */
    OTHER,        /* 0x51a */
    OTHER,        /* 0x51b */
    OTHER,        /* 0x51c */
    OTHER,        /* 0x51d */
    OTHER,        /* 0x51e */
    OTHER,        /* 0x51f */
    OTHER,        /* 0x520 */
    OTHER,        /* 0x521 */
    OTHER,        /* 0x522 */
    OTHER,        /* 0x523 */
    OTHER,        /* 0x524 */
    OTHER,        /* 0x525 */
    OTHER,        /* 0x526 */
    OTHER,        /* 0x527 */
    OTHER,        /* 0x528 */
    OTHER,        /* 0x529 */
    OTHER,        /* 0x52a */
    OTHER,        /* 0x52b */
    OTHER,        /* 0x52c */
    OTHER,        /* 0x52d */
    OTHER,        /* 0x52e */
    OTHER,        /* 0x52f */
    OTHER,        /* 0x530 */
    OTHER,        /* 0x531 */
    OTHER,        /* 0x532 */
    OTHER,        /* 0x533 */
    OTHER,        /* 0x534 */
    OTHER,        /* 0x535 */
    OTHER,        /* 0x536 */
    OTHER,        /* 0x537 */
    OTHER,        /* 0x538 */
    OTHER,        /* 0x539 */
    OTHER,        /* 0x53a */
    OTHER,        /* 0x53b */
    OTHER,        /* 0x53c */
    OTHER,        /* 0x53d */
    OTHER,        /* 0x53e */
    OTHER,        /* 0x53f */
    OTHER,        /* 0x540 */
    OTHER,        /* 0x541 */
    OTHER,        /* 0x542 */
    OTHER,        /* 0x543 */
    OTHER,        /* 0x544 */
    OTHER,        /* 0x545 */
    OTHER,        /* 0x546 */
    OTHER,        /* 0x547 */
    OTHER,        /* 0x548 */
    OTHER,        /* 0x549 */
    OTHER,        /* 0x54a */
    OTHER,        /* 0x54b */
    OTHER,        /* 0x54c */
    OTHER,        /* 0x54d */
    OTHER,        /* 0x54e */
    OTHER,        /* 0x54f */
    OTHER,        /* 0x550 */
    OTHER,        /* 0x551 */
    OTHER,        /* 0x552 */
    OTHER,        /* 0x553 */
    OTHER,        /* 0x554 */
    OTHER,        /* 0x555 */
    OTHER,        /* 0x556 */
    OTHER,        /* 0x557 */
    OTHER,        /* 0x558 */
    OTHER,        /* 0x559 */
    OTHER,        /* 0x55a */
    OTHER,        /* 0x55b */
    OTHER,        /* 0x55c */
    OTHER,        /* 0x55d */
    OTHER,        /* 0x55e */
    OTHER,        /* 0x55f */
    OTHER,        /* 0x560 */
    OTHER,        /* 0x561 */
    OTHER,        /* 0x562 */
    OTHER,        /* 0x563 */
    OTHER,        /* 0x564 */
    OTHER,        /* 0x565 */
    OTHER,        /* 0x566 */
    OTHER,        /* 0x567 */
    OTHER,        /* 0x568 */
    OTHER,        /* 0x569 */
    OTHER,        /* 0x56a */
    OTHER,        /* 0x56b */
    OTHER,        /* 0x56c */
    OTHER,        /* 0x56d */
    OTHER,        /* 0x56e */
    OTHER,        /* 0x56f */
    OTHER,        /* 0x570 */
    OTHER,        /* 0x571 */
    OTHER,        /* 0x572 */
    OTHER,        /* 0x573 */
    OTHER,        /* 0x574 */
    OTHER,        /* 0x575 */
    OTHER,        /* 0x576 */
    OTHER,        /* 0x577 */
    OTHER,        /* 0x578 */
    OTHER,        /* 0x579 */
    OTHER,        /* 0x57a */
    OTHER,        /* 0x57b */
    OTHER,        /* 0x57c */
    OTHER,        /* 0x57d */
    OTHER,        /* 0x57e */
    OTHER,        /* 0x57f */
    OTHER,        /* 0x580 */
    OTHER,        /* 0x581 */
    OTHER,        /* 0x582 */
    OTHER,        /* 0x583 */
    OTHER,        /* 0x584 */
    OTHER,        /* 0x585 */
    OTHER,        /* 0x586 */
    OTHER,        /* 0x587 */
    OTHER,        /* 0x588 */
    OTHER,        /* 0x589 */
    OTHER,        /* 0x58a */
    OTHER,        /* 0x58b */
    OTHER,        /* 0x58c */
    OTHER,        /* 0x58d */
    OTHER,        /* 0x58e */
    OTHER,        /* 0x58f */
    OTHER,        /* 0x590 */
    OTHER,        /* 0x591 */
    OTHER,        /* 0x592 */
    OTHER,        /* 0x593 */
    OTHER,        /* 0x594 */
    OTHER,        /* 0x595 */
    OTHER,        /* 0x596 */
    OTHER,        /* 0x597 */
    OTHER,        /* 0x598 */
    OTHER,        /* 0x599 */
    OTHER,        /* 0x59a */
    OTHER,        /* 0x59b */
    OTHER,        /* 0x59c */
    OTHER,        /* 0x59d */
    OTHER,        /* 0x59e */
    OTHER,        /* 0x59f */
    OTHER,        /* 0x5a0 */
    OTHER,        /* 0x5a1 */
    OTHER,        /* 0x5a2 */
    OTHER,        /* 0x5a3 */
    OTHER,        /* 0x5a4 */
    OTHER,        /* 0x5a5 */
    OTHER,        /* 0x5a6 */
    OTHER,        /* 0x5a7 */
    OTHER,        /* 0x5a8 */
    OTHER,        /* 0x5a9 */
    OTHER,        /* 0x5aa */
    OTHER,        /* 0x5ab */
    OTHER,        /* 0x5ac */
    OTHER,        /* 0x5ad */
    OTHER,        /* 0x5ae */
    OTHER,        /* 0x5af */
    OTHER,        /* 0x5b0 */
    OTHER,        /* 0x5b1 */
    OTHER,        /* 0x5b2 */
    OTHER,        /* 0x5b3 */
    OTHER,        /* 0x5b4 */
    OTHER,        /* 0x5b5 */
    OTHER,        /* 0x5b6 */
    OTHER,        /* 0x5b7 */
    OTHER,        /* 0x5b8 */
    OTHER,        /* 0x5b9 */
    OTHER,        /* 0x5ba */
    OTHER,        /* 0x5bb */
    OTHER,        /* 0x5bc */
    OTHER,        /* 0x5bd */
    OTHER,        /* 0x5be */
    OTHER,        /* 0x5bf */
    OTHER,        /* 0x5c0 */
    OTHER,        /* 0x5c1 */
    OTHER,        /* 0x5c2 */
    OTHER,        /* 0x5c3 */
    OTHER,        /* 0x5c4 */
    OTHER,        /* 0x5c5 */
    OTHER,        /* 0x5c6 */
    OTHER,        /* 0x5c7 */
    OTHER,        /* 0x5c8 */
    OTHER,        /* 0x5c9 */
    OTHER,        /* 0x5ca */
    OTHER,        /* 0x5cb */
    OTHER,        /* 0x5cc */
    OTHER,        /* 0x5cd */
    OTHER,        /* 0x5ce */
    OTHER,        /* 0x5cf */
    OTHER,        /* 0x5d0 */
    OTHER,        /* 0x5d1 */
    OTHER,        /* 0x5d2 */
    OTHER,        /* 0x5d3 */
    OTHER,        /* 0x5d4 */
    OTHER,        /* 0x5d5 */
    OTHER,        /* 0x5d6 */
    OTHER,        /* 0x5d7 */
    OTHER,        /* 0x5d8 */
    OTHER,        /* 0x5d9 */
    OTHER,        /* 0x5da */
    OTHER,        /* 0x5db */
    OTHER,        /* 0x5dc */
    OTHER,        /* 0x5dd */
    OTHER,        /* 0x5de */
    OTHER,        /* 0x5df */
    OTHER,        /* 0x5e0 */
    OTHER,        /* 0x5e1 */
    OTHER,        /* 0x5e2 */
    OTHER,        /* 0x5e3 */
    OTHER,        /* 0x5e4 */
    OTHER,        /* 0x5e5 */
    OTHER,        /* 0x5e6 */
    OTHER,        /* 0x5e7 */
    OTHER,        /* 0x5e8 */
    OTHER,        /* 0x5e9 */
    OTHER,        /* 0x5ea */
    OTHER,        /* 0x5eb */
    OTHER,        /* 0x5ec */
    OTHER,        /* 0x5ed */
    OTHER,        /* 0x5ee */
    OTHER,        /* 0x5ef */
    OTHER,        /* 0x5f0 */
    OTHER,        /* 0x5f1 */
    OTHER,        /* 0x5f2 */
    OTHER,        /* 0x5f3 */
    OTHER,        /* 0x5f4 */
    OTHER,        /* 0x5f5 */
    OTHER,        /* 0x5f6 */
    OTHER,        /* 0x5f7 */
    OTHER,        /* 0x5f8 */
    OTHER,        /* 0x5f9 */
    OTHER,        /* 0x5fa */
    OTHER,        /* 0x5fb */
    OTHER,        /* 0x5fc */
    OTHER,        /* 0x5fd */
    OTHER,        /* 0x5fe */
    OTHER,        /* 0x5ff */
    OTHER,        /* 0x600 */
    OTHER,        /* 0x601 */
    OTHER,        /* 0x602 */
    OTHER,        /* 0x603 */
    OTHER,        /* 0x604 */
    OTHER,        /* 0x605 */
    OTHER,        /* 0x606 */
    OTHER,        /* 0x607 */
    OTHER,        /* 0x608 */
    OTHER,        /* 0x609 */
    OTHER,        /* 0x60a */
    OTHER,        /* 0x60b */
    OTHER,        /* 0x60c */
    OTHER,        /* 0x60d */
    OTHER,        /* 0x60e */
    OTHER,        /* 0x60f */
    OTHER,        /* 0x610 */
    OTHER,        /* 0x611 */
    OTHER,        /* 0x612 */
    OTHER,        /* 0x613 */
    OTHER,        /* 0x614 */
    OTHER,        /* 0x615 */
    OTHER,        /* 0x616 */
    OTHER,        /* 0x617 */
    OTHER,        /* 0x618 */
    OTHER,        /* 0x619 */
    OTHER,        /* 0x61a */
    OTHER,        /* 0x61b */
    OTHER,        /* 0x61c */
    OTHER,        /* 0x61d */
    OTHER,        /* 0x61e */
    OTHER,        /* 0x61f */
    OTHER,        /* 0x620 */
    OTHER,        /* 0x621 */
    OTHER,        /* 0x622 */
    OTHER,        /* 0x623 */
    OTHER,        /* 0x624 */
    OTHER,        /* 0x625 */
    OTHER,        /* 0x626 */
    OTHER,        /* 0x627 */
    OTHER,        /* 0x628 */
    OTHER,        /* 0x629 */
    OTHER,        /* 0x62a */
    OTHER,        /* 0x62b */
    OTHER,        /* 0x62c */
    OTHER,        /* 0x62d */
    OTHER,        /* 0x62e */
    OTHER,        /* 0x62f */
    OTHER,        /* 0x630 */
    OTHER,        /* 0x631 */
    OTHER,        /* 0x632 */
    OTHER,        /* 0x633 */
    OTHER,        /* 0x634 */
    OTHER,        /* 0x635 */
    OTHER,        /* 0x636 */
    OTHER,        /* 0x637 */
    OTHER,        /* 0x638 */
    OTHER,        /* 0x639 */
    OTHER,        /* 0x63a */
    OTHER,        /* 0x63b */
    OTHER,        /* 0x63c */
    OTHER,        /* 0x63d */
    OTHER,        /* 0x63e */
    OTHER,        /* 0x63f */
    OTHER,        /* 0x640 */
    OTHER,        /* 0x641 */
    OTHER,        /* 0x642 */
    OTHER,        /* 0x643 */
    OTHER,        /* 0x644 */
    OTHER,        /* 0x645 */
    OTHER,        /* 0x646 */
    OTHER,        /* 0x647 */
    OTHER,        /* 0x648 */
    OTHER,        /* 0x649 */
    OTHER,        /* 0x64a */
    OTHER,        /* 0x64b */
    OTHER,        /* 0x64c */
    OTHER,        /* 0x64d */
    OTHER,        /* 0x64e */
    OTHER,        /* 0x64f */
    OTHER,        /* 0x650 */
    OTHER,        /* 0x651 */
    OTHER,        /* 0x652 */
    OTHER,        /* 0x653 */
    OTHER,        /* 0x654 */
    OTHER,        /* 0x655 */
    OTHER,        /* 0x656 */
    OTHER,        /* 0x657 */
    OTHER,        /* 0x658 */
    OTHER,        /* 0x659 */
    OTHER,        /* 0x65a */
    OTHER,        /* 0x65b */
    OTHER,        /* 0x65c */
    OTHER,        /* 0x65d */
    OTHER,        /* 0x65e */
    OTHER,        /* 0x65f */
    OTHER,        /* 0x660 */
    OTHER,        /* 0x661 */
    OTHER,        /* 0x662 */
    OTHER,        /* 0x663 */
    OTHER,        /* 0x664 */
    OTHER,        /* 0x665 */
    OTHER,        /* 0x666 */
    OTHER,        /* 0x667 */
    OTHER,        /* 0x668 */
    OTHER,        /* 0x669 */
    OTHER,        /* 0x66a */
    OTHER,        /* 0x66b */
    OTHER,        /* 0x66c */
    OTHER,        /* 0x66d */
    OTHER,        /* 0x66e */
    OTHER,        /* 0x66f */
    OTHER,        /* 0x670 */
    OTHER,        /* 0x671 */
    OTHER,        /* 0x672 */
    OTHER,        /* 0x673 */
    OTHER,        /* 0x674 */
    OTHER,        /* 0x675 */
    OTHER,        /* 0x676 */
    OTHER,        /* 0x677 */
    OTHER,        /* 0x678 */
    OTHER,        /* 0x679 */
    OTHER,        /* 0x67a */
    OTHER,        /* 0x67b */
    OTHER,        /* 0x67c */
    OTHER,        /* 0x67d */
    OTHER,        /* 0x67e */
    OTHER,        /* 0x67f */
    OTHER,        /* 0x680 */
    OTHER,        /* 0x681 */
    OTHER,        /* 0x682 */
    OTHER,        /* 0x683 */
    OTHER,        /* 0x684 */
    OTHER,        /* 0x685 */
    OTHER,        /* 0x686 */
    OTHER,        /* 0x687 */
    OTHER,        /* 0x688 */
    OTHER,        /* 0x689 */
    OTHER,        /* 0x68a */
    OTHER,        /* 0x68b */
    OTHER,        /* 0x68c */
    OTHER,        /* 0x68d */
    OTHER,        /* 0x68e */
    OTHER,        /* 0x68f */
    OTHER,        /* 0x690 */
    OTHER,        /* 0x691 */
    OTHER,        /* 0x692 */
    OTHER,        /* 0x693 */
    OTHER,        /* 0x694 */
    OTHER,        /* 0x695 */
    OTHER,        /* 0x696 */
    OTHER,        /* 0x697 */
    OTHER,        /* 0x698 */
    OTHER,        /* 0x699 */
    OTHER,        /* 0x69a */
    OTHER,        /* 0x69b */
    OTHER,        /* 0x69c */
    OTHER,        /* 0x69d */
    OTHER,        /* 0x69e */
    OTHER,        /* 0x69f */
    OTHER,        /* 0x6a0 */
    OTHER,        /* 0x6a1 */
    OTHER,        /* 0x6a2 */
    OTHER,        /* 0x6a3 */
    OTHER,        /* 0x6a4 */
    OTHER,        /* 0x6a5 */
    OTHER,        /* 0x6a6 */
    OTHER,        /* 0x6a7 */
    OTHER,        /* 0x6a8 */
    OTHER,        /* 0x6a9 */
    OTHER,        /* 0x6aa */
    OTHER,        /* 0x6ab */
    OTHER,        /* 0x6ac */
    OTHER,        /* 0x6ad */
    OTHER,        /* 0x6ae */
    OTHER,        /* 0x6af */
    OTHER,        /* 0x6b0 */
    OTHER,        /* 0x6b1 */
    OTHER,        /* 0x6b2 */
    OTHER,        /* 0x6b3 */
    OTHER,        /* 0x6b4 */
    OTHER,        /* 0x6b5 */
    OTHER,        /* 0x6b6 */
    OTHER,        /* 0x6b7 */
    OTHER,        /* 0x6b8 */
    OTHER,        /* 0x6b9 */
    OTHER,        /* 0x6ba */
    OTHER,        /* 0x6bb */
    OTHER,        /* 0x6bc */
    OTHER,        /* 0x6bd */
    OTHER,        /* 0x6be */
    OTHER,        /* 0x6bf */
    OTHER,        /* 0x6c0 */
    OTHER,        /* 0x6c1 */
    OTHER,        /* 0x6c2 */
    OTHER,        /* 0x6c3 */
    OTHER,        /* 0x6c4 */
    OTHER,        /* 0x6c5 */
    OTHER,        /* 0x6c6 */
    OTHER,        /* 0x6c7 */
    OTHER,        /* 0x6c8 */
    OTHER,        /* 0x6c9 */
    OTHER,        /* 0x6ca */
    OTHER,        /* 0x6cb */
    OTHER,        /* 0x6cc */
    OTHER,        /* 0x6cd */
    OTHER,        /* 0x6ce */
    OTHER,        /* 0x6cf */
    OTHER,        /* 0x6d0 */
    OTHER,        /* 0x6d1 */
    OTHER,        /* 0x6d2 */
    OTHER,        /* 0x6d3 */
    OTHER,        /* 0x6d4 */
    OTHER,        /* 0x6d5 */
    OTHER,        /* 0x6d6 */
    OTHER,        /* 0x6d7 */
    OTHER,        /* 0x6d8 */
    OTHER,        /* 0x6d9 */
    OTHER,        /* 0x6da */
    OTHER,        /* 0x6db */
    OTHER,        /* 0x6dc */
    OTHER,        /* 0x6dd */
    OTHER,        /* 0x6de */
    OTHER,        /* 0x6df */
    OTHER,        /* 0x6e0 */
    OTHER,        /* 0x6e1 */
    OTHER,        /* 0x6e2 */
    OTHER,        /* 0x6e3 */
    OTHER,        /* 0x6e4 */
    OTHER,        /* 0x6e5 */
    OTHER,        /* 0x6e6 */
    OTHER,        /* 0x6e7 */
    OTHER,        /* 0x6e8 */
    OTHER,        /* 0x6e9 */
    OTHER,        /* 0x6ea */
    OTHER,        /* 0x6eb */
    OTHER,        /* 0x6ec */
    OTHER,        /* 0x6ed */
    OTHER,        /* 0x6ee */
    OTHER,        /* 0x6ef */
    OTHER,        /* 0x6f0 */
    OTHER,        /* 0x6f1 */
    OTHER,        /* 0x6f2 */
    OTHER,        /* 0x6f3 */
    OTHER,        /* 0x6f4 */
    OTHER,        /* 0x6f5 */
    OTHER,        /* 0x6f6 */
    OTHER,        /* 0x6f7 */
    OTHER,        /* 0x6f8 */
    OTHER,        /* 0x6f9 */
    OTHER,        /* 0x6fa */
    OTHER,        /* 0x6fb */
    OTHER,        /* 0x6fc */
    OTHER,        /* 0x6fd */
    OTHER,        /* 0x6fe */
    OTHER,        /* 0x6ff */
    OTHER,        /* 0x700 */
    OTHER,        /* 0x701 */
    OTHER,        /* 0x702 */
    OTHER,        /* 0x703 */
    OTHER,        /* 0x704 */
    OTHER,        /* 0x705 */
    OTHER,        /* 0x706 */
    OTHER,        /* 0x707 */
    OTHER,        /* 0x708 */
    OTHER,        /* 0x709 */
    OTHER,        /* 0x70a */
    OTHER,        /* 0x70b */
    OTHER,        /* 0x70c */
    OTHER,        /* 0x70d */
    OTHER,        /* 0x70e */
    OTHER,        /* 0x70f */
    OTHER,        /* 0x710 */
    OTHER,        /* 0x711 */
    OTHER,        /* 0x712 */
    OTHER,        /* 0x713 */
    OTHER,        /* 0x714 */
    OTHER,        /* 0x715 */
    OTHER,        /* 0x716 */
    OTHER,        /* 0x717 */
    OTHER,        /* 0x718 */
    OTHER,        /* 0x719 */
    OTHER,        /* 0x71a */
    OTHER,        /* 0x71b */
    OTHER,        /* 0x71c */
    OTHER,        /* 0x71d */
    OTHER,        /* 0x71e */
    OTHER,        /* 0x71f */
    OTHER,        /* 0x720 */
    OTHER,        /* 0x721 */
    OTHER,        /* 0x722 */
    OTHER,        /* 0x723 */
    OTHER,        /* 0x724 */
    OTHER,        /* 0x725 */
    OTHER,        /* 0x726 */
    OTHER,        /* 0x727 */
    OTHER,        /* 0x728 */
    OTHER,        /* 0x729 */
    OTHER,        /* 0x72a */
    OTHER,        /* 0x72b */
    OTHER,        /* 0x72c */
    OTHER,        /* 0x72d */
    OTHER,        /* 0x72e */
    OTHER,        /* 0x72f */
    OTHER,        /* 0x730 */
    OTHER,        /* 0x731 */
    OTHER,        /* 0x732 */
    OTHER,        /* 0x733 */
    OTHER,        /* 0x734 */
    OTHER,        /* 0x735 */
    OTHER,        /* 0x736 */
    OTHER,        /* 0x737 */
    OTHER,        /* 0x738 */
    OTHER,        /* 0x739 */
    OTHER,        /* 0x73a */
    OTHER,        /* 0x73b */
    OTHER,        /* 0x73c */
    OTHER,        /* 0x73d */
    OTHER,        /* 0x73e */
    OTHER,        /* 0x73f */
    OTHER,        /* 0x740 */
    OTHER,        /* 0x741 */
    OTHER,        /* 0x742 */
    OTHER,        /* 0x743 */
    OTHER,        /* 0x744 */
    OTHER,        /* 0x745 */
    OTHER,        /* 0x746 */
    OTHER,        /* 0x747 */
    OTHER,        /* 0x748 */
    OTHER,        /* 0x749 */
    OTHER,        /* 0x74a */
    OTHER,        /* 0x74b */
    OTHER,        /* 0x74c */
    OTHER,        /* 0x74d */
    OTHER,        /* 0x74e */
    OTHER,        /* 0x74f */
    OTHER,        /* 0x750 */
    OTHER,        /* 0x751 */
    OTHER,        /* 0x752 */
    OTHER,        /* 0x753 */
    OTHER,        /* 0x754 */
    OTHER,        /* 0x755 */
    OTHER,        /* 0x756 */
    OTHER,        /* 0x757 */
    OTHER,        /* 0x758 */
    OTHER,        /* 0x759 */
    OTHER,        /* 0x75a */
    OTHER,        /* 0x75b */
    OTHER,        /* 0x75c */
    OTHER,        /* 0x75d */
    OTHER,        /* 0x75e */
    OTHER,        /* 0x75f */
    OTHER,        /* 0x760 */
    OTHER,        /* 0x761 */
    OTHER,        /* 0x762 */
    OTHER,        /* 0x763 */
    OTHER,        /* 0x764 */
    OTHER,        /* 0x765 */
    OTHER,        /* 0x766 */
    OTHER,        /* 0x767 */
    OTHER,        /* 0x768 */
    OTHER,        /* 0x769 */
    OTHER,        /* 0x76a */
    OTHER,        /* 0x76b */
    OTHER,        /* 0x76c */
    OTHER,        /* 0x76d */
    OTHER,        /* 0x76e */
    OTHER,        /* 0x76f */
    OTHER,        /* 0x770 */
    OTHER,        /* 0x771 */
    OTHER,        /* 0x772 */
    OTHER,        /* 0x773 */
    OTHER,        /* 0x774 */
    OTHER,        /* 0x775 */
    OTHER,        /* 0x776 */
    OTHER,        /* 0x777 */
    OTHER,        /* 0x778 */
    OTHER,        /* 0x779 */
    OTHER,        /* 0x77a */
    OTHER,        /* 0x77b */
    OTHER,        /* 0x77c */
    OTHER,        /* 0x77d */
    OTHER,        /* 0x77e */
    OTHER,        /* 0x77f */
    OTHER,        /* 0x780 */
    OTHER,        /* 0x781 */
    OTHER,        /* 0x782 */
    OTHER,        /* 0x783 */
    OTHER,        /* 0x784 */
    OTHER,        /* 0x785 */
    OTHER,        /* 0x786 */
    OTHER,        /* 0x787 */
    OTHER,        /* 0x788 */
    OTHER,        /* 0x789 */
    OTHER,        /* 0x78a */
    OTHER,        /* 0x78b */
    OTHER,        /* 0x78c */
    OTHER,        /* 0x78d */
    OTHER,        /* 0x78e */
    OTHER,        /* 0x78f */
    OTHER,        /* 0x790 */
    OTHER,        /* 0x791 */
    OTHER,        /* 0x792 */
    OTHER,        /* 0x793 */
    OTHER,        /* 0x794 */
    OTHER,        /* 0x795 */
    OTHER,        /* 0x796 */
    OTHER,        /* 0x797 */
    OTHER,        /* 0x798 */
    OTHER,        /* 0x799 */
    OTHER,        /* 0x79a */
    OTHER,        /* 0x79b */
    OTHER,        /* 0x79c */
    OTHER,        /* 0x79d */
    OTHER,        /* 0x79e */
    OTHER,        /* 0x79f */
    OTHER,        /* 0x7a0 */
    OTHER,        /* 0x7a1 */
    OTHER,        /* 0x7a2 */
    OTHER,        /* 0x7a3 */
    OTHER,        /* 0x7a4 */
    OTHER,        /* 0x7a5 */
    OTHER,        /* 0x7a6 */
    OTHER,        /* 0x7a7 */
    OTHER,        /* 0x7a8 */
    OTHER,        /* 0x7a9 */
    OTHER,        /* 0x7aa */
    OTHER,        /* 0x7ab */
    OTHER,        /* 0x7ac */
    OTHER,        /* 0x7ad */
    OTHER,        /* 0x7ae */
    OTHER,        /* 0x7af */
    OTHER,        /* 0x7b0 */
    OTHER,        /* 0x7b1 */
    OTHER,        /* 0x7b2 */
    OTHER,        /* 0x7b3 */
    OTHER,        /* 0x7b4 */
    OTHER,        /* 0x7b5 */
    OTHER,        /* 0x7b6 */
    OTHER,        /* 0x7b7 */
    OTHER,        /* 0x7b8 */
    OTHER,        /* 0x7b9 */
    OTHER,        /* 0x7ba */
    OTHER,        /* 0x7bb */
    OTHER,        /* 0x7bc */
    OTHER,        /* 0x7bd */
    OTHER,        /* 0x7be */
    OTHER,        /* 0x7bf */
    OTHER,        /* 0x7c0 */
    OTHER,        /* 0x7c1 */
    OTHER,        /* 0x7c2 */
    OTHER,        /* 0x7c3 */
    OTHER,        /* 0x7c4 */
    OTHER,        /* 0x7c5 */
    OTHER,        /* 0x7c6 */
    OTHER,        /* 0x7c7 */
    OTHER,        /* 0x7c8 */
    OTHER,        /* 0x7c9 */
    OTHER,        /* 0x7ca */
    OTHER,        /* 0x7cb */
    OTHER,        /* 0x7cc */
    OTHER,        /* 0x7cd */
    OTHER,        /* 0x7ce */
    OTHER,        /* 0x7cf */
    OTHER,        /* 0x7d0 */
    OTHER,        /* 0x7d1 */
    OTHER,        /* 0x7d2 */
    OTHER,        /* 0x7d3 */
    OTHER,        /* 0x7d4 */
    OTHER,        /* 0x7d5 */
    OTHER,        /* 0x7d6 */
    OTHER,        /* 0x7d7 */
    OTHER,        /* 0x7d8 */
    OTHER,        /* 0x7d9 */
    OTHER,        /* 0x7da */
    OTHER,        /* 0x7db */
    OTHER,        /* 0x7dc */
    OTHER,        /* 0x7dd */
    OTHER,        /* 0x7de */
    OTHER,        /* 0x7df */
    OTHER,        /* 0x7e0 */
    OTHER,        /* 0x7e1 */
    OTHER,        /* 0x7e2 */
    OTHER,        /* 0x7e3 */
    OTHER,        /* 0x7e4 */
    OTHER,        /* 0x7e5 */
    OTHER,        /* 0x7e6 */
    OTHER,        /* 0x7e7 */
    OTHER,        /* 0x7e8 */
    OTHER,        /* 0x7e9 */
    OTHER,        /* 0x7ea */
    OTHER,        /* 0x7eb */
    OTHER,        /* 0x7ec */
    OTHER,        /* 0x7ed */
    OTHER,        /* 0x7ee */
    OTHER,        /* 0x7ef */
    OTHER,        /* 0x7f0 */
    OTHER,        /* 0x7f1 */
    OTHER,        /* 0x7f2 */
    OTHER,        /* 0x7f3 */
    OTHER,        /* 0x7f4 */
    OTHER,        /* 0x7f5 */
    OTHER,        /* 0x7f6 */
    OTHER,        /* 0x7f7 */
    OTHER,        /* 0x7f8 */
    OTHER,        /* 0x7f9 */
    OTHER,        /* 0x7fa */
    OTHER,        /* 0x7fb */
    OTHER,        /* 0x7fc */
    OTHER,        /* 0x7fd */
    OTHER,        /* 0x7fe */
    OTHER,        /* 0x7ff */
    OTHER,        /* 0x800 */
    OTHER,        /* 0x801 */
    OTHER,        /* 0x802 */
    OTHER,        /* 0x803 */
    OTHER,        /* 0x804 */
    OTHER,        /* 0x805 */
    OTHER,        /* 0x806 */
    OTHER,        /* 0x807 */
    OTHER,        /* 0x808 */
    OTHER,        /* 0x809 */
    OTHER,        /* 0x80a */
    OTHER,        /* 0x80b */
    OTHER,        /* 0x80c */
    OTHER,        /* 0x80d */
    OTHER,        /* 0x80e */
    OTHER,        /* 0x80f */
    OTHER,        /* 0x810 */
    OTHER,        /* 0x811 */
    OTHER,        /* 0x812 */
    OTHER,        /* 0x813 */
    OTHER,        /* 0x814 */
    OTHER,        /* 0x815 */
    OTHER,        /* 0x816 */
    OTHER,        /* 0x817 */
    OTHER,        /* 0x818 */
    OTHER,        /* 0x819 */
    OTHER,        /* 0x81a */
    OTHER,        /* 0x81b */
    OTHER,        /* 0x81c */
    OTHER,        /* 0x81d */
    OTHER,        /* 0x81e */
    OTHER,        /* 0x81f */
    OTHER,        /* 0x820 */
    OTHER,        /* 0x821 */
    OTHER,        /* 0x822 */
    OTHER,        /* 0x823 */
    OTHER,        /* 0x824 */
    OTHER,        /* 0x825 */
    OTHER,        /* 0x826 */
    OTHER,        /* 0x827 */
    OTHER,        /* 0x828 */
    OTHER,        /* 0x829 */
    OTHER,        /* 0x82a */
    OTHER,        /* 0x82b */
    OTHER,        /* 0x82c */
    OTHER,        /* 0x82d */
    OTHER,        /* 0x82e */
    OTHER,        /* 0x82f */
    OTHER,        /* 0x830 */
    OTHER,        /* 0x831 */
    OTHER,        /* 0x832 */
    OTHER,        /* 0x833 */
    OTHER,        /* 0x834 */
    OTHER,        /* 0x835 */
    OTHER,        /* 0x836 */
    OTHER,        /* 0x837 */
    OTHER,        /* 0x838 */
    OTHER,        /* 0x839 */
    OTHER,        /* 0x83a */
    OTHER,        /* 0x83b */
    OTHER,        /* 0x83c */
    OTHER,        /* 0x83d */
    OTHER,        /* 0x83e */
    OTHER,        /* 0x83f */
    OTHER,        /* 0x840 */
    OTHER,        /* 0x841 */
    OTHER,        /* 0x842 */
    OTHER,        /* 0x843 */
    OTHER,        /* 0x844 */
    OTHER,        /* 0x845 */
    OTHER,        /* 0x846 */
    OTHER,        /* 0x847 */
    OTHER,        /* 0x848 */
    OTHER,        /* 0x849 */
    OTHER,        /* 0x84a */
    OTHER,        /* 0x84b */
    OTHER,        /* 0x84c */
    OTHER,        /* 0x84d */
    OTHER,        /* 0x84e */
    OTHER,        /* 0x84f */
    OTHER,        /* 0x850 */
    OTHER,        /* 0x851 */
    OTHER,        /* 0x852 */
    OTHER,        /* 0x853 */
    OTHER,        /* 0x854 */
    OTHER,        /* 0x855 */
    OTHER,        /* 0x856 */
    OTHER,        /* 0x857 */
    OTHER,        /* 0x858 */
    OTHER,        /* 0x859 */
    OTHER,        /* 0x85a */
    OTHER,        /* 0x85b */
    OTHER,        /* 0x85c */
    OTHER,        /* 0x85d */
    OTHER,        /* 0x85e */
    OTHER,        /* 0x85f */
    OTHER,        /* 0x860 */
    OTHER,        /* 0x861 */
    OTHER,        /* 0x862 */
    OTHER,        /* 0x863 */
    OTHER,        /* 0x864 */
    OTHER,        /* 0x865 */
    OTHER,        /* 0x866 */
    OTHER,        /* 0x867 */
    OTHER,        /* 0x868 */
    OTHER,        /* 0x869 */
    OTHER,        /* 0x86a */
    OTHER,        /* 0x86b */
    OTHER,        /* 0x86c */
    OTHER,        /* 0x86d */
    OTHER,        /* 0x86e */
    OTHER,        /* 0x86f */
    OTHER,        /* 0x870 */
    OTHER,        /* 0x871 */
    OTHER,        /* 0x872 */
    OTHER,        /* 0x873 */
    OTHER,        /* 0x874 */
    OTHER,        /* 0x875 */
    OTHER,        /* 0x876 */
    OTHER,        /* 0x877 */
    OTHER,        /* 0x878 */
    OTHER,        /* 0x879 */
    OTHER,        /* 0x87a */
    OTHER,        /* 0x87b */
    OTHER,        /* 0x87c */
    OTHER,        /* 0x87d */
    OTHER,        /* 0x87e */
    OTHER,        /* 0x87f */
    OTHER,        /* 0x880 */
    OTHER,        /* 0x881 */
    OTHER,        /* 0x882 */
    OTHER,        /* 0x883 */
    OTHER,        /* 0x884 */
    OTHER,        /* 0x885 */
    OTHER,        /* 0x886 */
    OTHER,        /* 0x887 */
    OTHER,        /* 0x888 */
    OTHER,        /* 0x889 */
    OTHER,        /* 0x88a */
    OTHER,        /* 0x88b */
    OTHER,        /* 0x88c */
    OTHER,        /* 0x88d */
    OTHER,        /* 0x88e */
    OTHER,        /* 0x88f */
    OTHER,        /* 0x890 */
    OTHER,        /* 0x891 */
    OTHER,        /* 0x892 */
    OTHER,        /* 0x893 */
    OTHER,        /* 0x894 */
    OTHER,        /* 0x895 */
    OTHER,        /* 0x896 */
    OTHER,        /* 0x897 */
    OTHER,        /* 0x898 */
    OTHER,        /* 0x899 */
    OTHER,        /* 0x89a */
    OTHER,        /* 0x89b */
    OTHER,        /* 0x89c */
    OTHER,        /* 0x89d */
    OTHER,        /* 0x89e */
    OTHER,        /* 0x89f */
    OTHER,        /* 0x8a0 */
    OTHER,        /* 0x8a1 */
    OTHER,        /* 0x8a2 */
    OTHER,        /* 0x8a3 */
    OTHER,        /* 0x8a4 */
    OTHER,        /* 0x8a5 */
    OTHER,        /* 0x8a6 */
    OTHER,        /* 0x8a7 */
    OTHER,        /* 0x8a8 */
    OTHER,        /* 0x8a9 */
    OTHER,        /* 0x8aa */
    OTHER,        /* 0x8ab */
    OTHER,        /* 0x8ac */
    OTHER,        /* 0x8ad */
    OTHER,        /* 0x8ae */
    OTHER,        /* 0x8af */
    OTHER,        /* 0x8b0 */
    OTHER,        /* 0x8b1 */
    OTHER,        /* 0x8b2 */
    OTHER,        /* 0x8b3 */
    OTHER,        /* 0x8b4 */
    OTHER,        /* 0x8b5 */
    OTHER,        /* 0x8b6 */
    OTHER,        /* 0x8b7 */
    OTHER,        /* 0x8b8 */
    OTHER,        /* 0x8b9 */
    OTHER,        /* 0x8ba */
    OTHER,        /* 0x8bb */
    OTHER,        /* 0x8bc */
    OTHER,        /* 0x8bd */
    OTHER,        /* 0x8be */
    OTHER,        /* 0x8bf */
    OTHER,        /* 0x8c0 */
    OTHER,        /* 0x8c1 */
    OTHER,        /* 0x8c2 */
    OTHER,        /* 0x8c3 */
    OTHER,        /* 0x8c4 */
    OTHER,        /* 0x8c5 */
    OTHER,        /* 0x8c6 */
    OTHER,        /* 0x8c7 */
    OTHER,        /* 0x8c8 */
    OTHER,        /* 0x8c9 */
    OTHER,        /* 0x8ca */
    OTHER,        /* 0x8cb */
    OTHER,        /* 0x8cc */
    OTHER,        /* 0x8cd */
    OTHER,        /* 0x8ce */
    OTHER,        /* 0x8cf */
    OTHER,        /* 0x8d0 */
    OTHER,        /* 0x8d1 */
    OTHER,        /* 0x8d2 */
    OTHER,        /* 0x8d3 */
    OTHER,        /* 0x8d4 */
    OTHER,        /* 0x8d5 */
    OTHER,        /* 0x8d6 */
    OTHER,        /* 0x8d7 */
    OTHER,        /* 0x8d8 */
    OTHER,        /* 0x8d9 */
    OTHER,        /* 0x8da */
    OTHER,        /* 0x8db */
    OTHER,        /* 0x8dc */
    OTHER,        /* 0x8dd */
    OTHER,        /* 0x8de */
    OTHER,        /* 0x8df */
    OTHER,        /* 0x8e0 */
    OTHER,        /* 0x8e1 */
    OTHER,        /* 0x8e2 */
    OTHER,        /* 0x8e3 */
    OTHER,        /* 0x8e4 */
    OTHER,        /* 0x8e5 */
    OTHER,        /* 0x8e6 */
    OTHER,        /* 0x8e7 */
    OTHER,        /* 0x8e8 */
    OTHER,        /* 0x8e9 */
    OTHER,        /* 0x8ea */
    OTHER,        /* 0x8eb */
    OTHER,        /* 0x8ec */
    OTHER,        /* 0x8ed */
    OTHER,        /* 0x8ee */
    OTHER,        /* 0x8ef */
    OTHER,        /* 0x8f0 */
    OTHER,        /* 0x8f1 */
    OTHER,        /* 0x8f2 */
    OTHER,        /* 0x8f3 */
    OTHER,        /* 0x8f4 */
    OTHER,        /* 0x8f5 */
    OTHER,        /* 0x8f6 */
    OTHER,        /* 0x8f7 */
    OTHER,        /* 0x8f8 */
    OTHER,        /* 0x8f9 */
    OTHER,        /* 0x8fa */
    OTHER,        /* 0x8fb */
    OTHER,        /* 0x8fc */
    OTHER,        /* 0x8fd */
    OTHER,        /* 0x8fe */
    OTHER,        /* 0x8ff */
    OTHER,        /* 0x900 */
    OTHER,        /* 0x901 */
    OTHER,        /* 0x902 */
    OTHER,        /* 0x903 */
    OTHER,        /* 0x904 */
    OTHER,        /* 0x905 */
    OTHER,        /* 0x906 */
    OTHER,        /* 0x907 */
    OTHER,        /* 0x908 */
    OTHER,        /* 0x909 */
    OTHER,        /* 0x90a */
    OTHER,        /* 0x90b */
    OTHER,        /* 0x90c */
    OTHER,        /* 0x90d */
    OTHER,        /* 0x90e */
    OTHER,        /* 0x90f */
    OTHER,        /* 0x910 */
    OTHER,        /* 0x911 */
    OTHER,        /* 0x912 */
    OTHER,        /* 0x913 */
    OTHER,        /* 0x914 */
    OTHER,        /* 0x915 */
    OTHER,        /* 0x916 */
    OTHER,        /* 0x917 */
    OTHER,        /* 0x918 */
    OTHER,        /* 0x919 */
    OTHER,        /* 0x91a */
    OTHER,        /* 0x91b */
    OTHER,        /* 0x91c */
    OTHER,        /* 0x91d */
    OTHER,        /* 0x91e */
    OTHER,        /* 0x91f */
    OTHER,        /* 0x920 */
    OTHER,        /* 0x921 */
    OTHER,        /* 0x922 */
    OTHER,        /* 0x923 */
    OTHER,        /* 0x924 */
    OTHER,        /* 0x925 */
    OTHER,        /* 0x926 */
    OTHER,        /* 0x927 */
    OTHER,        /* 0x928 */
    OTHER,        /* 0x929 */
    OTHER,        /* 0x92a */
    OTHER,        /* 0x92b */
    OTHER,        /* 0x92c */
    OTHER,        /* 0x92d */
    OTHER,        /* 0x92e */
    OTHER,        /* 0x92f */
    OTHER,        /* 0x930 */
    OTHER,        /* 0x931 */
    OTHER,        /* 0x932 */
    OTHER,        /* 0x933 */
    OTHER,        /* 0x934 */
    OTHER,        /* 0x935 */
    OTHER,        /* 0x936 */
    OTHER,        /* 0x937 */
    OTHER,        /* 0x938 */
    OTHER,        /* 0x939 */
    OTHER,        /* 0x93a */
    OTHER,        /* 0x93b */
    OTHER,        /* 0x93c */
    OTHER,        /* 0x93d */
    OTHER,        /* 0x93e */
    OTHER,        /* 0x93f */
    OTHER,        /* 0x940 */
    OTHER,        /* 0x941 */
    OTHER,        /* 0x942 */
    OTHER,        /* 0x943 */
    OTHER,        /* 0x944 */
    OTHER,        /* 0x945 */
    OTHER,        /* 0x946 */
    OTHER,        /* 0x947 */
    OTHER,        /* 0x948 */
    OTHER,        /* 0x949 */
    OTHER,        /* 0x94a */
    OTHER,        /* 0x94b */
    OTHER,        /* 0x94c */
    OTHER,        /* 0x94d */
    OTHER,        /* 0x94e */
    OTHER,        /* 0x94f */
    OTHER,        /* 0x950 */
    OTHER,        /* 0x951 */
    OTHER,        /* 0x952 */
    OTHER,        /* 0x953 */
    OTHER,        /* 0x954 */
    OTHER,        /* 0x955 */
    OTHER,        /* 0x956 */
    OTHER,        /* 0x957 */
    OTHER,        /* 0x958 */
    OTHER,        /* 0x959 */
    OTHER,        /* 0x95a */
    OTHER,        /* 0x95b */
    OTHER,        /* 0x95c */
    OTHER,        /* 0x95d */
    OTHER,        /* 0x95e */
    OTHER,        /* 0x95f */
    OTHER,        /* 0x960 */
    OTHER,        /* 0x961 */
    OTHER,        /* 0x962 */
    OTHER,        /* 0x963 */
    OTHER,        /* 0x964 */
    OTHER,        /* 0x965 */
    OTHER,        /* 0x966 */
    OTHER,        /* 0x967 */
    OTHER,        /* 0x968 */
    OTHER,        /* 0x969 */
    OTHER,        /* 0x96a */
    OTHER,        /* 0x96b */
    OTHER,        /* 0x96c */
    OTHER,        /* 0x96d */
    OTHER,        /* 0x96e */
    OTHER,        /* 0x96f */
    OTHER,        /* 0x970 */
    OTHER,        /* 0x971 */
    OTHER,        /* 0x972 */
    OTHER,        /* 0x973 */
    OTHER,        /* 0x974 */
    OTHER,        /* 0x975 */
    OTHER,        /* 0x976 */
    OTHER,        /* 0x977 */
    OTHER,        /* 0x978 */
    OTHER,        /* 0x979 */
    OTHER,        /* 0x97a */
    OTHER,        /* 0x97b */
    OTHER,        /* 0x97c */
    OTHER,        /* 0x97d */
    OTHER,        /* 0x97e */
    OTHER,        /* 0x97f */
    OTHER,        /* 0x980 */
    OTHER,        /* 0x981 */
    OTHER,        /* 0x982 */
    OTHER,        /* 0x983 */
    OTHER,        /* 0x984 */
    OTHER,        /* 0x985 */
    OTHER,        /* 0x986 */
    OTHER,        /* 0x987 */
    OTHER,        /* 0x988 */
    OTHER,        /* 0x989 */
    OTHER,        /* 0x98a */
    OTHER,        /* 0x98b */
    OTHER,        /* 0x98c */
    OTHER,        /* 0x98d */
    OTHER,        /* 0x98e */
    OTHER,        /* 0x98f */
    OTHER,        /* 0x990 */
    OTHER,        /* 0x991 */
    OTHER,        /* 0x992 */
    OTHER,        /* 0x993 */
    OTHER,        /* 0x994 */
    OTHER,        /* 0x995 */
    OTHER,        /* 0x996 */
    OTHER,        /* 0x997 */
    OTHER,        /* 0x998 */
    OTHER,        /* 0x999 */
    OTHER,        /* 0x99a */
    OTHER,        /* 0x99b */
    OTHER,        /* 0x99c */
    OTHER,        /* 0x99d */
    OTHER,        /* 0x99e */
    OTHER,        /* 0x99f */
    OTHER,        /* 0x9a0 */
    OTHER,        /* 0x9a1 */
    OTHER,        /* 0x9a2 */
    OTHER,        /* 0x9a3 */
    OTHER,        /* 0x9a4 */
    OTHER,        /* 0x9a5 */
    OTHER,        /* 0x9a6 */
    OTHER,        /* 0x9a7 */
    OTHER,        /* 0x9a8 */
    OTHER,        /* 0x9a9 */
    OTHER,        /* 0x9aa */
    OTHER,        /* 0x9ab */
    OTHER,        /* 0x9ac */
    OTHER,        /* 0x9ad */
    OTHER,        /* 0x9ae */
    OTHER,        /* 0x9af */
    OTHER,        /* 0x9b0 */
    OTHER,        /* 0x9b1 */
    OTHER,        /* 0x9b2 */
    OTHER,        /* 0x9b3 */
    OTHER,        /* 0x9b4 */
    OTHER,        /* 0x9b5 */
    OTHER,        /* 0x9b6 */
    OTHER,        /* 0x9b7 */
    OTHER,        /* 0x9b8 */
    OTHER,        /* 0x9b9 */
    OTHER,        /* 0x9ba */
    OTHER,        /* 0x9bb */
    OTHER,        /* 0x9bc */
    OTHER,        /* 0x9bd */
    OTHER,        /* 0x9be */
    OTHER,        /* 0x9bf */
    OTHER,        /* 0x9c0 */
    OTHER,        /* 0x9c1 */
    OTHER,        /* 0x9c2 */
    OTHER,        /* 0x9c3 */
    OTHER,        /* 0x9c4 */
    OTHER,        /* 0x9c5 */
    OTHER,        /* 0x9c6 */
    OTHER,        /* 0x9c7 */
    OTHER,        /* 0x9c8 */
    OTHER,        /* 0x9c9 */
    OTHER,        /* 0x9ca */
    OTHER,        /* 0x9cb */
    OTHER,        /* 0x9cc */
    OTHER,        /* 0x9cd */
    OTHER,        /* 0x9ce */
    OTHER,        /* 0x9cf */
    OTHER,        /* 0x9d0 */
    OTHER,        /* 0x9d1 */
    OTHER,        /* 0x9d2 */
    OTHER,        /* 0x9d3 */
    OTHER,        /* 0x9d4 */
    OTHER,        /* 0x9d5 */
    OTHER,        /* 0x9d6 */
    OTHER,        /* 0x9d7 */
    OTHER,        /* 0x9d8 */
    OTHER,        /* 0x9d9 */
    OTHER,        /* 0x9da */
    OTHER,        /* 0x9db */
    OTHER,        /* 0x9dc */
    OTHER,        /* 0x9dd */
    OTHER,        /* 0x9de */
    OTHER,        /* 0x9df */
    OTHER,        /* 0x9e0 */
    OTHER,        /* 0x9e1 */
    OTHER,        /* 0x9e2 */
    OTHER,        /* 0x9e3 */
    OTHER,        /* 0x9e4 */
    OTHER,        /* 0x9e5 */
    OTHER,        /* 0x9e6 */
    OTHER,        /* 0x9e7 */
    OTHER,        /* 0x9e8 */
    OTHER,        /* 0x9e9 */
    OTHER,        /* 0x9ea */
    OTHER,        /* 0x9eb */
    OTHER,        /* 0x9ec */
    OTHER,        /* 0x9ed */
    OTHER,        /* 0x9ee */
    OTHER,        /* 0x9ef */
    OTHER,        /* 0x9f0 */
    OTHER,        /* 0x9f1 */
    OTHER,        /* 0x9f2 */
    OTHER,        /* 0x9f3 */
    OTHER,        /* 0x9f4 */
    OTHER,        /* 0x9f5 */
    OTHER,        /* 0x9f6 */
    OTHER,        /* 0x9f7 */
    OTHER,        /* 0x9f8 */
    OTHER,        /* 0x9f9 */
    OTHER,        /* 0x9fa */
    OTHER,        /* 0x9fb */
    OTHER,        /* 0x9fc */
    OTHER,        /* 0x9fd */
    OTHER,        /* 0x9fe */
    OTHER,        /* 0x9ff */
    OTHER,        /* 0xa00 */
    OTHER,        /* 0xa01 */
    OTHER,        /* 0xa02 */
    OTHER,        /* 0xa03 */
    OTHER,        /* 0xa04 */
    OTHER,        /* 0xa05 */
    OTHER,        /* 0xa06 */
    OTHER,        /* 0xa07 */
    OTHER,        /* 0xa08 */
    OTHER,        /* 0xa09 */
    OTHER,        /* 0xa0a */
    OTHER,        /* 0xa0b */
    OTHER,        /* 0xa0c */
    OTHER,        /* 0xa0d */
    OTHER,        /* 0xa0e */
    OTHER,        /* 0xa0f */
    OTHER,        /* 0xa10 */
    OTHER,        /* 0xa11 */
    OTHER,        /* 0xa12 */
    OTHER,        /* 0xa13 */
    OTHER,        /* 0xa14 */
    OTHER,        /* 0xa15 */
    OTHER,        /* 0xa16 */
    OTHER,        /* 0xa17 */
    OTHER,        /* 0xa18 */
    OTHER,        /* 0xa19 */
    OTHER,        /* 0xa1a */
    OTHER,        /* 0xa1b */
    OTHER,        /* 0xa1c */
    OTHER,        /* 0xa1d */
    OTHER,        /* 0xa1e */
    OTHER,        /* 0xa1f */
    OTHER,        /* 0xa20 */
    OTHER,        /* 0xa21 */
    OTHER,        /* 0xa22 */
    OTHER,        /* 0xa23 */
    OTHER,        /* 0xa24 */
    OTHER,        /* 0xa25 */
    OTHER,        /* 0xa26 */
    OTHER,        /* 0xa27 */
    OTHER,        /* 0xa28 */
    OTHER,        /* 0xa29 */
    OTHER,        /* 0xa2a */
    OTHER,        /* 0xa2b */
    OTHER,        /* 0xa2c */
    OTHER,        /* 0xa2d */
    OTHER,        /* 0xa2e */
    OTHER,        /* 0xa2f */
    OTHER,        /* 0xa30 */
    OTHER,        /* 0xa31 */
    OTHER,        /* 0xa32 */
    OTHER,        /* 0xa33 */
    OTHER,        /* 0xa34 */
    OTHER,        /* 0xa35 */
    OTHER,        /* 0xa36 */
    OTHER,        /* 0xa37 */
    OTHER,        /* 0xa38 */
    OTHER,        /* 0xa39 */
    OTHER,        /* 0xa3a */
    OTHER,        /* 0xa3b */
    OTHER,        /* 0xa3c */
    OTHER,        /* 0xa3d */
    OTHER,        /* 0xa3e */
    OTHER,        /* 0xa3f */
    OTHER,        /* 0xa40 */
    OTHER,        /* 0xa41 */
    OTHER,        /* 0xa42 */
    OTHER,        /* 0xa43 */
    OTHER,        /* 0xa44 */
    OTHER,        /* 0xa45 */
    OTHER,        /* 0xa46 */
    OTHER,        /* 0xa47 */
    OTHER,        /* 0xa48 */
    OTHER,        /* 0xa49 */
    OTHER,        /* 0xa4a */
    OTHER,        /* 0xa4b */
    OTHER,        /* 0xa4c */
    OTHER,        /* 0xa4d */
    OTHER,        /* 0xa4e */
    OTHER,        /* 0xa4f */
    OTHER,        /* 0xa50 */
    OTHER,        /* 0xa51 */
    OTHER,        /* 0xa52 */
    OTHER,        /* 0xa53 */
    OTHER,        /* 0xa54 */
    OTHER,        /* 0xa55 */
    OTHER,        /* 0xa56 */
    OTHER,        /* 0xa57 */
    OTHER,        /* 0xa58 */
    OTHER,        /* 0xa59 */
    OTHER,        /* 0xa5a */
    OTHER,        /* 0xa5b */
    OTHER,        /* 0xa5c */
    OTHER,        /* 0xa5d */
    OTHER,        /* 0xa5e */
    OTHER,        /* 0xa5f */
    OTHER,        /* 0xa60 */
    OTHER,        /* 0xa61 */
    OTHER,        /* 0xa62 */
    OTHER,        /* 0xa63 */
    OTHER,        /* 0xa64 */
    OTHER,        /* 0xa65 */
    OTHER,        /* 0xa66 */
    OTHER,        /* 0xa67 */
    OTHER,        /* 0xa68 */
    OTHER,        /* 0xa69 */
    OTHER,        /* 0xa6a */
    OTHER,        /* 0xa6b */
    OTHER,        /* 0xa6c */
    OTHER,        /* 0xa6d */
    OTHER,        /* 0xa6e */
    OTHER,        /* 0xa6f */
    OTHER,        /* 0xa70 */
    OTHER,        /* 0xa71 */
    OTHER,        /* 0xa72 */
    OTHER,        /* 0xa73 */
    OTHER,        /* 0xa74 */
    OTHER,        /* 0xa75 */
    OTHER,        /* 0xa76 */
    OTHER,        /* 0xa77 */
    OTHER,        /* 0xa78 */
    OTHER,        /* 0xa79 */
    OTHER,        /* 0xa7a */
    OTHER,        /* 0xa7b */
    OTHER,        /* 0xa7c */
    OTHER,        /* 0xa7d */
    OTHER,        /* 0xa7e */
    OTHER,        /* 0xa7f */
    OTHER,        /* 0xa80 */
    OTHER,        /* 0xa81 */
    OTHER,        /* 0xa82 */
    OTHER,        /* 0xa83 */
    OTHER,        /* 0xa84 */
    OTHER,        /* 0xa85 */
    OTHER,        /* 0xa86 */
    OTHER,        /* 0xa87 */
    OTHER,        /* 0xa88 */
    OTHER,        /* 0xa89 */
    OTHER,        /* 0xa8a */
    OTHER,        /* 0xa8b */
    OTHER,        /* 0xa8c */
    OTHER,        /* 0xa8d */
    OTHER,        /* 0xa8e */
    OTHER,        /* 0xa8f */
    OTHER,        /* 0xa90 */
    OTHER,        /* 0xa91 */
    OTHER,        /* 0xa92 */
    OTHER,        /* 0xa93 */
    OTHER,        /* 0xa94 */
    OTHER,        /* 0xa95 */
    OTHER,        /* 0xa96 */
    OTHER,        /* 0xa97 */
    OTHER,        /* 0xa98 */
    OTHER,        /* 0xa99 */
    OTHER,        /* 0xa9a */
    OTHER,        /* 0xa9b */
    OTHER,        /* 0xa9c */
    OTHER,        /* 0xa9d */
    OTHER,        /* 0xa9e */
    OTHER,        /* 0xa9f */
    OTHER,        /* 0xaa0 */
    OTHER,        /* 0xaa1 */
    OTHER,        /* 0xaa2 */
    OTHER,        /* 0xaa3 */
    OTHER,        /* 0xaa4 */
    OTHER,        /* 0xaa5 */
    OTHER,        /* 0xaa6 */
    OTHER,        /* 0xaa7 */
    OTHER,        /* 0xaa8 */
    OTHER,        /* 0xaa9 */
    OTHER,        /* 0xaaa */
    OTHER,        /* 0xaab */
    OTHER,        /* 0xaac */
    OTHER,        /* 0xaad */
    OTHER,        /* 0xaae */
    OTHER,        /* 0xaaf */
    OTHER,        /* 0xab0 */
    OTHER,        /* 0xab1 */
    OTHER,        /* 0xab2 */
    OTHER,        /* 0xab3 */
    OTHER,        /* 0xab4 */
    OTHER,        /* 0xab5 */
    OTHER,        /* 0xab6 */
    OTHER,        /* 0xab7 */
    OTHER,        /* 0xab8 */
    OTHER,        /* 0xab9 */
    OTHER,        /* 0xaba */
    OTHER,        /* 0xabb */
    OTHER,        /* 0xabc */
    OTHER,        /* 0xabd */
    OTHER,        /* 0xabe */
    OTHER,        /* 0xabf */
    OTHER,        /* 0xac0 */
    OTHER,        /* 0xac1 */
    OTHER,        /* 0xac2 */
    OTHER,        /* 0xac3 */
    OTHER,        /* 0xac4 */
    OTHER,        /* 0xac5 */
    OTHER,        /* 0xac6 */
    OTHER,        /* 0xac7 */
    OTHER,        /* 0xac8 */
    OTHER,        /* 0xac9 */
    OTHER,        /* 0xaca */
    OTHER,        /* 0xacb */
    OTHER,        /* 0xacc */
    OTHER,        /* 0xacd */
    OTHER,        /* 0xace */
    OTHER,        /* 0xacf */
    OTHER,        /* 0xad0 */
    OTHER,        /* 0xad1 */
    OTHER,        /* 0xad2 */
    OTHER,        /* 0xad3 */
    OTHER,        /* 0xad4 */
    OTHER,        /* 0xad5 */
    OTHER,        /* 0xad6 */
    OTHER,        /* 0xad7 */
    OTHER,        /* 0xad8 */
    OTHER,        /* 0xad9 */
    OTHER,        /* 0xada */
    OTHER,        /* 0xadb */
    OTHER,        /* 0xadc */
    OTHER,        /* 0xadd */
    OTHER,        /* 0xade */
    OTHER,        /* 0xadf */
    OTHER,        /* 0xae0 */
    OTHER,        /* 0xae1 */
    OTHER,        /* 0xae2 */
    OTHER,        /* 0xae3 */
    OTHER,        /* 0xae4 */
    OTHER,        /* 0xae5 */
    OTHER,        /* 0xae6 */
    OTHER,        /* 0xae7 */
    OTHER,        /* 0xae8 */
    OTHER,        /* 0xae9 */
    OTHER,        /* 0xaea */
    OTHER,        /* 0xaeb */
    OTHER,        /* 0xaec */
    OTHER,        /* 0xaed */
    OTHER,        /* 0xaee */
    OTHER,        /* 0xaef */
    OTHER,        /* 0xaf0 */
    OTHER,        /* 0xaf1 */
    OTHER,        /* 0xaf2 */
    OTHER,        /* 0xaf3 */
    OTHER,        /* 0xaf4 */
    OTHER,        /* 0xaf5 */
    OTHER,        /* 0xaf6 */
    OTHER,        /* 0xaf7 */
    OTHER,        /* 0xaf8 */
    OTHER,        /* 0xaf9 */
    OTHER,        /* 0xafa */
    OTHER,        /* 0xafb */
    OTHER,        /* 0xafc */
    OTHER,        /* 0xafd */
    OTHER,        /* 0xafe */
    OTHER,        /* 0xaff */
    OTHER,        /* 0xb00 */
    OTHER,        /* 0xb01 */
    OTHER,        /* 0xb02 */
    OTHER,        /* 0xb03 */
    OTHER,        /* 0xb04 */
    OTHER,        /* 0xb05 */
    OTHER,        /* 0xb06 */
    OTHER,        /* 0xb07 */
    OTHER,        /* 0xb08 */
    OTHER,        /* 0xb09 */
    OTHER,        /* 0xb0a */
    OTHER,        /* 0xb0b */
    OTHER,        /* 0xb0c */
    OTHER,        /* 0xb0d */
    OTHER,        /* 0xb0e */
    OTHER,        /* 0xb0f */
    OTHER,        /* 0xb10 */
    OTHER,        /* 0xb11 */
    OTHER,        /* 0xb12 */
    OTHER,        /* 0xb13 */
    OTHER,        /* 0xb14 */
    OTHER,        /* 0xb15 */
    OTHER,        /* 0xb16 */
    OTHER,        /* 0xb17 */
    OTHER,        /* 0xb18 */
    OTHER,        /* 0xb19 */
    OTHER,        /* 0xb1a */
    OTHER,        /* 0xb1b */
    OTHER,        /* 0xb1c */
    OTHER,        /* 0xb1d */
    OTHER,        /* 0xb1e */
    OTHER,        /* 0xb1f */
    OTHER,        /* 0xb20 */
    OTHER,        /* 0xb21 */
    OTHER,        /* 0xb22 */
    OTHER,        /* 0xb23 */
    OTHER,        /* 0xb24 */
    OTHER,        /* 0xb25 */
    OTHER,        /* 0xb26 */
    OTHER,        /* 0xb27 */
    OTHER,        /* 0xb28 */
    OTHER,        /* 0xb29 */
    OTHER,        /* 0xb2a */
    OTHER,        /* 0xb2b */
    OTHER,        /* 0xb2c */
    OTHER,        /* 0xb2d */
    OTHER,        /* 0xb2e */
    OTHER,        /* 0xb2f */
    OTHER,        /* 0xb30 */
    OTHER,        /* 0xb31 */
    OTHER,        /* 0xb32 */
    OTHER,        /* 0xb33 */
    OTHER,        /* 0xb34 */
    OTHER,        /* 0xb35 */
    OTHER,        /* 0xb36 */
    OTHER,        /* 0xb37 */
    OTHER,        /* 0xb38 */
    OTHER,        /* 0xb39 */
    OTHER,        /* 0xb3a */
    OTHER,        /* 0xb3b */
    OTHER,        /* 0xb3c */
    OTHER,        /* 0xb3d */
    OTHER,        /* 0xb3e */
    OTHER,        /* 0xb3f */
    OTHER,        /* 0xb40 */
    OTHER,        /* 0xb41 */
    OTHER,        /* 0xb42 */
    OTHER,        /* 0xb43 */
    OTHER,        /* 0xb44 */
    OTHER,        /* 0xb45 */
    OTHER,        /* 0xb46 */
    OTHER,        /* 0xb47 */
    OTHER,        /* 0xb48 */
    OTHER,        /* 0xb49 */
    OTHER,        /* 0xb4a */
    OTHER,        /* 0xb4b */
    OTHER,        /* 0xb4c */
    OTHER,        /* 0xb4d */
    OTHER,        /* 0xb4e */
    OTHER,        /* 0xb4f */
    OTHER,        /* 0xb50 */
    OTHER,        /* 0xb51 */
    OTHER,        /* 0xb52 */
    OTHER,        /* 0xb53 */
    OTHER,        /* 0xb54 */
    OTHER,        /* 0xb55 */
    OTHER,        /* 0xb56 */
    OTHER,        /* 0xb57 */
    OTHER,        /* 0xb58 */
    OTHER,        /* 0xb59 */
    OTHER,        /* 0xb5a */
    OTHER,        /* 0xb5b */
    OTHER,        /* 0xb5c */
    OTHER,        /* 0xb5d */
    OTHER,        /* 0xb5e */
    OTHER,        /* 0xb5f */
    OTHER,        /* 0xb60 */
    OTHER,        /* 0xb61 */
    OTHER,        /* 0xb62 */
    OTHER,        /* 0xb63 */
    OTHER,        /* 0xb64 */
    OTHER,        /* 0xb65 */
    OTHER,        /* 0xb66 */
    OTHER,        /* 0xb67 */
    OTHER,        /* 0xb68 */
    OTHER,        /* 0xb69 */
    OTHER,        /* 0xb6a */
    OTHER,        /* 0xb6b */
    OTHER,        /* 0xb6c */
    OTHER,        /* 0xb6d */
    OTHER,        /* 0xb6e */
    OTHER,        /* 0xb6f */
    OTHER,        /* 0xb70 */
    OTHER,        /* 0xb71 */
    OTHER,        /* 0xb72 */
    OTHER,        /* 0xb73 */
    OTHER,        /* 0xb74 */
    OTHER,        /* 0xb75 */
    OTHER,        /* 0xb76 */
    OTHER,        /* 0xb77 */
    OTHER,        /* 0xb78 */
    OTHER,        /* 0xb79 */
    OTHER,        /* 0xb7a */
    OTHER,        /* 0xb7b */
    OTHER,        /* 0xb7c */
    OTHER,        /* 0xb7d */
    OTHER,        /* 0xb7e */
    OTHER,        /* 0xb7f */
    OTHER,        /* 0xb80 */
    OTHER,        /* 0xb81 */
    OTHER,        /* 0xb82 */
    OTHER,        /* 0xb83 */
    OTHER,        /* 0xb84 */
    OTHER,        /* 0xb85 */
    OTHER,        /* 0xb86 */
    OTHER,        /* 0xb87 */
    OTHER,        /* 0xb88 */
    OTHER,        /* 0xb89 */
    OTHER,        /* 0xb8a */
    OTHER,        /* 0xb8b */
    OTHER,        /* 0xb8c */
    OTHER,        /* 0xb8d */
    OTHER,        /* 0xb8e */
    OTHER,        /* 0xb8f */
    OTHER,        /* 0xb90 */
    OTHER,        /* 0xb91 */
    OTHER,        /* 0xb92 */
    OTHER,        /* 0xb93 */
    OTHER,        /* 0xb94 */
    OTHER,        /* 0xb95 */
    OTHER,        /* 0xb96 */
    OTHER,        /* 0xb97 */
    OTHER,        /* 0xb98 */
    OTHER,        /* 0xb99 */
    OTHER,        /* 0xb9a */
    OTHER,        /* 0xb9b */
    OTHER,        /* 0xb9c */
    OTHER,        /* 0xb9d */
    OTHER,        /* 0xb9e */
    OTHER,        /* 0xb9f */
    OTHER,        /* 0xba0 */
    OTHER,        /* 0xba1 */
    OTHER,        /* 0xba2 */
    OTHER,        /* 0xba3 */
    OTHER,        /* 0xba4 */
    OTHER,        /* 0xba5 */
    OTHER,        /* 0xba6 */
    OTHER,        /* 0xba7 */
    OTHER,        /* 0xba8 */
    OTHER,        /* 0xba9 */
    OTHER,        /* 0xbaa */
    OTHER,        /* 0xbab */
    OTHER,        /* 0xbac */
    OTHER,        /* 0xbad */
    OTHER,        /* 0xbae */
    OTHER,        /* 0xbaf */
    OTHER,        /* 0xbb0 */
    OTHER,        /* 0xbb1 */
    OTHER,        /* 0xbb2 */
    OTHER,        /* 0xbb3 */
    OTHER,        /* 0xbb4 */
    OTHER,        /* 0xbb5 */
    OTHER,        /* 0xbb6 */
    OTHER,        /* 0xbb7 */
    OTHER,        /* 0xbb8 */
    OTHER,        /* 0xbb9 */
    OTHER,        /* 0xbba */
    OTHER,        /* 0xbbb */
    OTHER,        /* 0xbbc */
    OTHER,        /* 0xbbd */
    OTHER,        /* 0xbbe */
    OTHER,        /* 0xbbf */
    OTHER,        /* 0xbc0 */
    OTHER,        /* 0xbc1 */
    OTHER,        /* 0xbc2 */
    OTHER,        /* 0xbc3 */
    OTHER,        /* 0xbc4 */
    OTHER,        /* 0xbc5 */
    OTHER,        /* 0xbc6 */
    OTHER,        /* 0xbc7 */
    OTHER,        /* 0xbc8 */
    OTHER,        /* 0xbc9 */
    OTHER,        /* 0xbca */
    OTHER,        /* 0xbcb */
    OTHER,        /* 0xbcc */
    OTHER,        /* 0xbcd */
    OTHER,        /* 0xbce */
    OTHER,        /* 0xbcf */
    OTHER,        /* 0xbd0 */
    OTHER,        /* 0xbd1 */
    OTHER,        /* 0xbd2 */
    OTHER,        /* 0xbd3 */
    OTHER,        /* 0xbd4 */
    OTHER,        /* 0xbd5 */
    OTHER,        /* 0xbd6 */
    OTHER,        /* 0xbd7 */
    OTHER,        /* 0xbd8 */
    OTHER,        /* 0xbd9 */
    OTHER,        /* 0xbda */
    OTHER,        /* 0xbdb */
    OTHER,        /* 0xbdc */
    OTHER,        /* 0xbdd */
    OTHER,        /* 0xbde */
    OTHER,        /* 0xbdf */
    OTHER,        /* 0xbe0 */
    OTHER,        /* 0xbe1 */
    OTHER,        /* 0xbe2 */
    OTHER,        /* 0xbe3 */
    OTHER,        /* 0xbe4 */
    OTHER,        /* 0xbe5 */
    OTHER,        /* 0xbe6 */
    OTHER,        /* 0xbe7 */
    OTHER,        /* 0xbe8 */
    OTHER,        /* 0xbe9 */
    OTHER,        /* 0xbea */
    OTHER,        /* 0xbeb */
    OTHER,        /* 0xbec */
    OTHER,        /* 0xbed */
    OTHER,        /* 0xbee */
    OTHER,        /* 0xbef */
    OTHER,        /* 0xbf0 */
    OTHER,        /* 0xbf1 */
    OTHER,        /* 0xbf2 */
    OTHER,        /* 0xbf3 */
    OTHER,        /* 0xbf4 */
    OTHER,        /* 0xbf5 */
    OTHER,        /* 0xbf6 */
    OTHER,        /* 0xbf7 */
    OTHER,        /* 0xbf8 */
    OTHER,        /* 0xbf9 */
    OTHER,        /* 0xbfa */
    OTHER,        /* 0xbfb */
    OTHER,        /* 0xbfc */
    OTHER,        /* 0xbfd */
    OTHER,        /* 0xbfe */
    OTHER,        /* 0xbff */
    OTHER,        /* 0xc00 */
    OTHER,        /* 0xc01 */
    OTHER,        /* 0xc02 */
    OTHER,        /* 0xc03 */
    OTHER,        /* 0xc04 */
    OTHER,        /* 0xc05 */
    OTHER,        /* 0xc06 */
    OTHER,        /* 0xc07 */
    OTHER,        /* 0xc08 */
    OTHER,        /* 0xc09 */
    OTHER,        /* 0xc0a */
    OTHER,        /* 0xc0b */
    OTHER,        /* 0xc0c */
    OTHER,        /* 0xc0d */
    OTHER,        /* 0xc0e */
    OTHER,        /* 0xc0f */
    OTHER,        /* 0xc10 */
    OTHER,        /* 0xc11 */
    OTHER,        /* 0xc12 */
    OTHER,        /* 0xc13 */
    OTHER,        /* 0xc14 */
    OTHER,        /* 0xc15 */
    OTHER,        /* 0xc16 */
    OTHER,        /* 0xc17 */
    OTHER,        /* 0xc18 */
    OTHER,        /* 0xc19 */
    OTHER,        /* 0xc1a */
    OTHER,        /* 0xc1b */
    OTHER,        /* 0xc1c */
    OTHER,        /* 0xc1d */
    OTHER,        /* 0xc1e */
    OTHER,        /* 0xc1f */
    OTHER,        /* 0xc20 */
    OTHER,        /* 0xc21 */
    OTHER,        /* 0xc22 */
    OTHER,        /* 0xc23 */
    OTHER,        /* 0xc24 */
    OTHER,        /* 0xc25 */
    OTHER,        /* 0xc26 */
    OTHER,        /* 0xc27 */
    OTHER,        /* 0xc28 */
    OTHER,        /* 0xc29 */
    OTHER,        /* 0xc2a */
    OTHER,        /* 0xc2b */
    OTHER,        /* 0xc2c */
    OTHER,        /* 0xc2d */
    OTHER,        /* 0xc2e */
    OTHER,        /* 0xc2f */
    OTHER,        /* 0xc30 */
    OTHER,        /* 0xc31 */
    OTHER,        /* 0xc32 */
    OTHER,        /* 0xc33 */
    OTHER,        /* 0xc34 */
    OTHER,        /* 0xc35 */
    OTHER,        /* 0xc36 */
    OTHER,        /* 0xc37 */
    OTHER,        /* 0xc38 */
    OTHER,        /* 0xc39 */
    OTHER,        /* 0xc3a */
    OTHER,        /* 0xc3b */
    OTHER,        /* 0xc3c */
    OTHER,        /* 0xc3d */
    OTHER,        /* 0xc3e */
    OTHER,        /* 0xc3f */
    OTHER,        /* 0xc40 */
    OTHER,        /* 0xc41 */
    OTHER,        /* 0xc42 */
    OTHER,        /* 0xc43 */
    OTHER,        /* 0xc44 */
    OTHER,        /* 0xc45 */
    OTHER,        /* 0xc46 */
    OTHER,        /* 0xc47 */
    OTHER,        /* 0xc48 */
    OTHER,        /* 0xc49 */
    OTHER,        /* 0xc4a */
    OTHER,        /* 0xc4b */
    OTHER,        /* 0xc4c */
    OTHER,        /* 0xc4d */
    OTHER,        /* 0xc4e */
    OTHER,        /* 0xc4f */
    OTHER,        /* 0xc50 */
    OTHER,        /* 0xc51 */
    OTHER,        /* 0xc52 */
    OTHER,        /* 0xc53 */
    OTHER,        /* 0xc54 */
    OTHER,        /* 0xc55 */
    OTHER,        /* 0xc56 */
    OTHER,        /* 0xc57 */
    OTHER,        /* 0xc58 */
    OTHER,        /* 0xc59 */
    OTHER,        /* 0xc5a */
    OTHER,        /* 0xc5b */
    OTHER,        /* 0xc5c */
    OTHER,        /* 0xc5d */
    OTHER,        /* 0xc5e */
    OTHER,        /* 0xc5f */
    OTHER,        /* 0xc60 */
    OTHER,        /* 0xc61 */
    OTHER,        /* 0xc62 */
    OTHER,        /* 0xc63 */
    OTHER,        /* 0xc64 */
    OTHER,        /* 0xc65 */
    OTHER,        /* 0xc66 */
    OTHER,        /* 0xc67 */
    OTHER,        /* 0xc68 */
    OTHER,        /* 0xc69 */
    OTHER,        /* 0xc6a */
    OTHER,        /* 0xc6b */
    OTHER,        /* 0xc6c */
    OTHER,        /* 0xc6d */
    OTHER,        /* 0xc6e */
    OTHER,        /* 0xc6f */
    OTHER,        /* 0xc70 */
    OTHER,        /* 0xc71 */
    OTHER,        /* 0xc72 */
    OTHER,        /* 0xc73 */
    OTHER,        /* 0xc74 */
    OTHER,        /* 0xc75 */
    OTHER,        /* 0xc76 */
    OTHER,        /* 0xc77 */
    OTHER,        /* 0xc78 */
    OTHER,        /* 0xc79 */
    OTHER,        /* 0xc7a */
    OTHER,        /* 0xc7b */
    OTHER,        /* 0xc7c */
    OTHER,        /* 0xc7d */
    OTHER,        /* 0xc7e */
    OTHER,        /* 0xc7f */
    OTHER,        /* 0xc80 */
    OTHER,        /* 0xc81 */
    OTHER,        /* 0xc82 */
    OTHER,        /* 0xc83 */
    OTHER,        /* 0xc84 */
    OTHER,        /* 0xc85 */
    OTHER,        /* 0xc86 */
    OTHER,        /* 0xc87 */
    OTHER,        /* 0xc88 */
    OTHER,        /* 0xc89 */
    OTHER,        /* 0xc8a */
    OTHER,        /* 0xc8b */
    OTHER,        /* 0xc8c */
    OTHER,        /* 0xc8d */
    OTHER,        /* 0xc8e */
    OTHER,        /* 0xc8f */
    OTHER,        /* 0xc90 */
    OTHER,        /* 0xc91 */
    OTHER,        /* 0xc92 */
    OTHER,        /* 0xc93 */
    OTHER,        /* 0xc94 */
    OTHER,        /* 0xc95 */
    OTHER,        /* 0xc96 */
    OTHER,        /* 0xc97 */
    OTHER,        /* 0xc98 */
    OTHER,        /* 0xc99 */
    OTHER,        /* 0xc9a */
    OTHER,        /* 0xc9b */
    OTHER,        /* 0xc9c */
    OTHER,        /* 0xc9d */
    OTHER,        /* 0xc9e */
    OTHER,        /* 0xc9f */
    OTHER,        /* 0xca0 */
    OTHER,        /* 0xca1 */
    OTHER,        /* 0xca2 */
    OTHER,        /* 0xca3 */
    OTHER,        /* 0xca4 */
    OTHER,        /* 0xca5 */
    OTHER,        /* 0xca6 */
    OTHER,        /* 0xca7 */
    OTHER,        /* 0xca8 */
    OTHER,        /* 0xca9 */
    OTHER,        /* 0xcaa */
    OTHER,        /* 0xcab */
    OTHER,        /* 0xcac */
    OTHER,        /* 0xcad */
    OTHER,        /* 0xcae */
    OTHER,        /* 0xcaf */
    OTHER,        /* 0xcb0 */
    OTHER,        /* 0xcb1 */
    OTHER,        /* 0xcb2 */
    OTHER,        /* 0xcb3 */
    OTHER,        /* 0xcb4 */
    OTHER,        /* 0xcb5 */
    OTHER,        /* 0xcb6 */
    OTHER,        /* 0xcb7 */
    OTHER,        /* 0xcb8 */
    OTHER,        /* 0xcb9 */
    OTHER,        /* 0xcba */
    OTHER,        /* 0xcbb */
    OTHER,        /* 0xcbc */
    OTHER,        /* 0xcbd */
    OTHER,        /* 0xcbe */
    OTHER,        /* 0xcbf */
    OTHER,        /* 0xcc0 */
    OTHER,        /* 0xcc1 */
    OTHER,        /* 0xcc2 */
    OTHER,        /* 0xcc3 */
    OTHER,        /* 0xcc4 */
    OTHER,        /* 0xcc5 */
    OTHER,        /* 0xcc6 */
    OTHER,        /* 0xcc7 */
    OTHER,        /* 0xcc8 */
    OTHER,        /* 0xcc9 */
    OTHER,        /* 0xcca */
    OTHER,        /* 0xccb */
    OTHER,        /* 0xccc */
    OTHER,        /* 0xccd */
    OTHER,        /* 0xcce */
    OTHER,        /* 0xccf */
    OTHER,        /* 0xcd0 */
    OTHER,        /* 0xcd1 */
    OTHER,        /* 0xcd2 */
    OTHER,        /* 0xcd3 */
    OTHER,        /* 0xcd4 */
    OTHER,        /* 0xcd5 */
    OTHER,        /* 0xcd6 */
    OTHER,        /* 0xcd7 */
    OTHER,        /* 0xcd8 */
    OTHER,        /* 0xcd9 */
    OTHER,        /* 0xcda */
    OTHER,        /* 0xcdb */
    OTHER,        /* 0xcdc */
    OTHER,        /* 0xcdd */
    OTHER,        /* 0xcde */
    OTHER,        /* 0xcdf */
    OTHER,        /* 0xce0 */
    OTHER,        /* 0xce1 */
    OTHER,        /* 0xce2 */
    OTHER,        /* 0xce3 */
    OTHER,        /* 0xce4 */
    OTHER,        /* 0xce5 */
    OTHER,        /* 0xce6 */
    OTHER,        /* 0xce7 */
    OTHER,        /* 0xce8 */
    OTHER,        /* 0xce9 */
    OTHER,        /* 0xcea */
    OTHER,        /* 0xceb */
    OTHER,        /* 0xcec */
    OTHER,        /* 0xced */
    OTHER,        /* 0xcee */
    OTHER,        /* 0xcef */
    OTHER,        /* 0xcf0 */
    OTHER,        /* 0xcf1 */
    OTHER,        /* 0xcf2 */
    OTHER,        /* 0xcf3 */
    OTHER,        /* 0xcf4 */
    OTHER,        /* 0xcf5 */
    OTHER,        /* 0xcf6 */
    OTHER,        /* 0xcf7 */
    OTHER,        /* 0xcf8 */
    OTHER,        /* 0xcf9 */
    OTHER,        /* 0xcfa */
    OTHER,        /* 0xcfb */
    OTHER,        /* 0xcfc */
    OTHER,        /* 0xcfd */
    OTHER,        /* 0xcfe */
    OTHER,        /* 0xcff */
    OTHER,        /* 0xd00 */
    OTHER,        /* 0xd01 */
    OTHER,        /* 0xd02 */
    OTHER,        /* 0xd03 */
    OTHER,        /* 0xd04 */
    OTHER,        /* 0xd05 */
    OTHER,        /* 0xd06 */
    OTHER,        /* 0xd07 */
    OTHER,        /* 0xd08 */
    OTHER,        /* 0xd09 */
    OTHER,        /* 0xd0a */
    OTHER,        /* 0xd0b */
    OTHER,        /* 0xd0c */
    OTHER,        /* 0xd0d */
    OTHER,        /* 0xd0e */
    OTHER,        /* 0xd0f */
    OTHER,        /* 0xd10 */
    OTHER,        /* 0xd11 */
    OTHER,        /* 0xd12 */
    OTHER,        /* 0xd13 */
    OTHER,        /* 0xd14 */
    OTHER,        /* 0xd15 */
    OTHER,        /* 0xd16 */
    OTHER,        /* 0xd17 */
    OTHER,        /* 0xd18 */
    OTHER,        /* 0xd19 */
    OTHER,        /* 0xd1a */
    OTHER,        /* 0xd1b */
    OTHER,        /* 0xd1c */
    OTHER,        /* 0xd1d */
    OTHER,        /* 0xd1e */
    OTHER,        /* 0xd1f */
    OTHER,        /* 0xd20 */
    OTHER,        /* 0xd21 */
    OTHER,        /* 0xd22 */
    OTHER,        /* 0xd23 */
    OTHER,        /* 0xd24 */
    OTHER,        /* 0xd25 */
    OTHER,        /* 0xd26 */
    OTHER,        /* 0xd27 */
    OTHER,        /* 0xd28 */
    OTHER,        /* 0xd29 */
    OTHER,        /* 0xd2a */
    OTHER,        /* 0xd2b */
    OTHER,        /* 0xd2c */
    OTHER,        /* 0xd2d */
    OTHER,        /* 0xd2e */
    OTHER,        /* 0xd2f */
    OTHER,        /* 0xd30 */
    OTHER,        /* 0xd31 */
    OTHER,        /* 0xd32 */
    OTHER,        /* 0xd33 */
    OTHER,        /* 0xd34 */
    OTHER,        /* 0xd35 */
    OTHER,        /* 0xd36 */
    OTHER,        /* 0xd37 */
    OTHER,        /* 0xd38 */
    OTHER,        /* 0xd39 */
    OTHER,        /* 0xd3a */
    OTHER,        /* 0xd3b */
    OTHER,        /* 0xd3c */
    OTHER,        /* 0xd3d */
    OTHER,        /* 0xd3e */
    OTHER,        /* 0xd3f */
    OTHER,        /* 0xd40 */
    OTHER,        /* 0xd41 */
    OTHER,        /* 0xd42 */
    OTHER,        /* 0xd43 */
    OTHER,        /* 0xd44 */
    OTHER,        /* 0xd45 */
    OTHER,        /* 0xd46 */
    OTHER,        /* 0xd47 */
    OTHER,        /* 0xd48 */
    OTHER,        /* 0xd49 */
    OTHER,        /* 0xd4a */
    OTHER,        /* 0xd4b */
    OTHER,        /* 0xd4c */
    OTHER,        /* 0xd4d */
    OTHER,        /* 0xd4e */
    OTHER,        /* 0xd4f */
    OTHER,        /* 0xd50 */
    OTHER,        /* 0xd51 */
    OTHER,        /* 0xd52 */
    OTHER,        /* 0xd53 */
    OTHER,        /* 0xd54 */
    OTHER,        /* 0xd55 */
    OTHER,        /* 0xd56 */
    OTHER,        /* 0xd57 */
    OTHER,        /* 0xd58 */
    OTHER,        /* 0xd59 */
    OTHER,        /* 0xd5a */
    OTHER,        /* 0xd5b */
    OTHER,        /* 0xd5c */
    OTHER,        /* 0xd5d */
    OTHER,        /* 0xd5e */
    OTHER,        /* 0xd5f */
    OTHER,        /* 0xd60 */
    OTHER,        /* 0xd61 */
    OTHER,        /* 0xd62 */
    OTHER,        /* 0xd63 */
    OTHER,        /* 0xd64 */
    OTHER,        /* 0xd65 */
    OTHER,        /* 0xd66 */
    OTHER,        /* 0xd67 */
    OTHER,        /* 0xd68 */
    OTHER,        /* 0xd69 */
    OTHER,        /* 0xd6a */
    OTHER,        /* 0xd6b */
    OTHER,        /* 0xd6c */
    OTHER,        /* 0xd6d */
    OTHER,        /* 0xd6e */
    OTHER,        /* 0xd6f */
    OTHER,        /* 0xd70 */
    OTHER,        /* 0xd71 */
    OTHER,        /* 0xd72 */
    OTHER,        /* 0xd73 */
    OTHER,        /* 0xd74 */
    OTHER,        /* 0xd75 */
    OTHER,        /* 0xd76 */
    OTHER,        /* 0xd77 */
    OTHER,        /* 0xd78 */
    OTHER,        /* 0xd79 */
    OTHER,        /* 0xd7a */
    OTHER,        /* 0xd7b */
    OTHER,        /* 0xd7c */
    OTHER,        /* 0xd7d */
    OTHER,        /* 0xd7e */
    OTHER,        /* 0xd7f */
    OTHER,        /* 0xd80 */
    OTHER,        /* 0xd81 */
    OTHER,        /* 0xd82 */
    OTHER,        /* 0xd83 */
    OTHER,        /* 0xd84 */
    OTHER,        /* 0xd85 */
    OTHER,        /* 0xd86 */
    OTHER,        /* 0xd87 */
    OTHER,        /* 0xd88 */
    OTHER,        /* 0xd89 */
    OTHER,        /* 0xd8a */
    OTHER,        /* 0xd8b */
    OTHER,        /* 0xd8c */
    OTHER,        /* 0xd8d */
    OTHER,        /* 0xd8e */
    OTHER,        /* 0xd8f */
    OTHER,        /* 0xd90 */
    OTHER,        /* 0xd91 */
    OTHER,        /* 0xd92 */
    OTHER,        /* 0xd93 */
    OTHER,        /* 0xd94 */
    OTHER,        /* 0xd95 */
    OTHER,        /* 0xd96 */
    OTHER,        /* 0xd97 */
    OTHER,        /* 0xd98 */
    OTHER,        /* 0xd99 */
    OTHER,        /* 0xd9a */
    OTHER,        /* 0xd9b */
    OTHER,        /* 0xd9c */
    OTHER,        /* 0xd9d */
    OTHER,        /* 0xd9e */
    OTHER,        /* 0xd9f */
    OTHER,        /* 0xda0 */
    OTHER,        /* 0xda1 */
    OTHER,        /* 0xda2 */
    OTHER,        /* 0xda3 */
    OTHER,        /* 0xda4 */
    OTHER,        /* 0xda5 */
    OTHER,        /* 0xda6 */
    OTHER,        /* 0xda7 */
    OTHER,        /* 0xda8 */
    OTHER,        /* 0xda9 */
    OTHER,        /* 0xdaa */
    OTHER,        /* 0xdab */
    OTHER,        /* 0xdac */
    OTHER,        /* 0xdad */
    OTHER,        /* 0xdae */
    OTHER,        /* 0xdaf */
    OTHER,        /* 0xdb0 */
    OTHER,        /* 0xdb1 */
    OTHER,        /* 0xdb2 */
    OTHER,        /* 0xdb3 */
    OTHER,        /* 0xdb4 */
    OTHER,        /* 0xdb5 */
    OTHER,        /* 0xdb6 */
    OTHER,        /* 0xdb7 */
    OTHER,        /* 0xdb8 */
    OTHER,        /* 0xdb9 */
    OTHER,        /* 0xdba */
    OTHER,        /* 0xdbb */
    OTHER,        /* 0xdbc */
    OTHER,        /* 0xdbd */
    OTHER,        /* 0xdbe */
    OTHER,        /* 0xdbf */
    OTHER,        /* 0xdc0 */
    OTHER,        /* 0xdc1 */
    OTHER,        /* 0xdc2 */
    OTHER,        /* 0xdc3 */
    OTHER,        /* 0xdc4 */
    OTHER,        /* 0xdc5 */
    OTHER,        /* 0xdc6 */
    OTHER,        /* 0xdc7 */
    OTHER,        /* 0xdc8 */
    OTHER,        /* 0xdc9 */
    OTHER,        /* 0xdca */
    OTHER,        /* 0xdcb */
    OTHER,        /* 0xdcc */
    OTHER,        /* 0xdcd */
    OTHER,        /* 0xdce */
    OTHER,        /* 0xdcf */
    OTHER,        /* 0xdd0 */
    OTHER,        /* 0xdd1 */
    OTHER,        /* 0xdd2 */
    OTHER,        /* 0xdd3 */
    OTHER,        /* 0xdd4 */
    OTHER,        /* 0xdd5 */
    OTHER,        /* 0xdd6 */
    OTHER,        /* 0xdd7 */
    OTHER,        /* 0xdd8 */
    OTHER,        /* 0xdd9 */
    OTHER,        /* 0xdda */
    OTHER,        /* 0xddb */
    OTHER,        /* 0xddc */
    OTHER,        /* 0xddd */
    OTHER,        /* 0xdde */
    OTHER,        /* 0xddf */
    OTHER,        /* 0xde0 */
    OTHER,        /* 0xde1 */
    OTHER,        /* 0xde2 */
    OTHER,        /* 0xde3 */
    OTHER,        /* 0xde4 */
    OTHER,        /* 0xde5 */
    OTHER,        /* 0xde6 */
    OTHER,        /* 0xde7 */
    OTHER,        /* 0xde8 */
    OTHER,        /* 0xde9 */
    OTHER,        /* 0xdea */
    OTHER,        /* 0xdeb */
    OTHER,        /* 0xdec */
    OTHER,        /* 0xded */
    OTHER,        /* 0xdee */
    OTHER,        /* 0xdef */
    OTHER,        /* 0xdf0 */
    OTHER,        /* 0xdf1 */
    OTHER,        /* 0xdf2 */
    OTHER,        /* 0xdf3 */
    OTHER,        /* 0xdf4 */
    OTHER,        /* 0xdf5 */
    OTHER,        /* 0xdf6 */
    OTHER,        /* 0xdf7 */
    OTHER,        /* 0xdf8 */
    OTHER,        /* 0xdf9 */
    OTHER,        /* 0xdfa */
    OTHER,        /* 0xdfb */
    OTHER,        /* 0xdfc */
    OTHER,        /* 0xdfd */
    OTHER,        /* 0xdfe */
    OTHER,        /* 0xdff */
    OTHER,        /* 0xe00 */
    OTHER,        /* 0xe01 */
    OTHER,        /* 0xe02 */
    OTHER,        /* 0xe03 */
    OTHER,        /* 0xe04 */
    OTHER,        /* 0xe05 */
    OTHER,        /* 0xe06 */
    OTHER,        /* 0xe07 */
    OTHER,        /* 0xe08 */
    OTHER,        /* 0xe09 */
    OTHER,        /* 0xe0a */
    OTHER,        /* 0xe0b */
    OTHER,        /* 0xe0c */
    OTHER,        /* 0xe0d */
    OTHER,        /* 0xe0e */
    OTHER,        /* 0xe0f */
    OTHER,        /* 0xe10 */
    OTHER,        /* 0xe11 */
    OTHER,        /* 0xe12 */
    OTHER,        /* 0xe13 */
    OTHER,        /* 0xe14 */
    OTHER,        /* 0xe15 */
    OTHER,        /* 0xe16 */
    OTHER,        /* 0xe17 */
    OTHER,        /* 0xe18 */
    OTHER,        /* 0xe19 */
    OTHER,        /* 0xe1a */
    OTHER,        /* 0xe1b */
    OTHER,        /* 0xe1c */
    OTHER,        /* 0xe1d */
    OTHER,        /* 0xe1e */
    OTHER,        /* 0xe1f */
    OTHER,        /* 0xe20 */
    OTHER,        /* 0xe21 */
    OTHER,        /* 0xe22 */
    OTHER,        /* 0xe23 */
    OTHER,        /* 0xe24 */
    OTHER,        /* 0xe25 */
    OTHER,        /* 0xe26 */
    OTHER,        /* 0xe27 */
    OTHER,        /* 0xe28 */
    OTHER,        /* 0xe29 */
    OTHER,        /* 0xe2a */
    OTHER,        /* 0xe2b */
    OTHER,        /* 0xe2c */
    OTHER,        /* 0xe2d */
    OTHER,        /* 0xe2e */
    OTHER,        /* 0xe2f */
    OTHER,        /* 0xe30 */
    OTHER,        /* 0xe31 */
    OTHER,        /* 0xe32 */
    OTHER,        /* 0xe33 */
    OTHER,        /* 0xe34 */
    OTHER,        /* 0xe35 */
    OTHER,        /* 0xe36 */
    OTHER,        /* 0xe37 */
    OTHER,        /* 0xe38 */
    OTHER,        /* 0xe39 */
    OTHER,        /* 0xe3a */
    OTHER,        /* 0xe3b */
    OTHER,        /* 0xe3c */
    OTHER,        /* 0xe3d */
    OTHER,        /* 0xe3e */
    OTHER,        /* 0xe3f */
    OTHER,        /* 0xe40 */
    OTHER,        /* 0xe41 */
    OTHER,        /* 0xe42 */
    OTHER,        /* 0xe43 */
    OTHER,        /* 0xe44 */
    OTHER,        /* 0xe45 */
    OTHER,        /* 0xe46 */
    OTHER,        /* 0xe47 */
    OTHER,        /* 0xe48 */
    OTHER,        /* 0xe49 */
    OTHER,        /* 0xe4a */
    OTHER,        /* 0xe4b */
    OTHER,        /* 0xe4c */
    OTHER,        /* 0xe4d */
    OTHER,        /* 0xe4e */
    OTHER,        /* 0xe4f */
    OTHER,        /* 0xe50 */
    OTHER,        /* 0xe51 */
    OTHER,        /* 0xe52 */
    OTHER,        /* 0xe53 */
    OTHER,        /* 0xe54 */
    OTHER,        /* 0xe55 */
    OTHER,        /* 0xe56 */
    OTHER,        /* 0xe57 */
    OTHER,        /* 0xe58 */
    OTHER,        /* 0xe59 */
    OTHER,        /* 0xe5a */
    OTHER,        /* 0xe5b */
    OTHER,        /* 0xe5c */
    OTHER,        /* 0xe5d */
    OTHER,        /* 0xe5e */
    OTHER,        /* 0xe5f */
    OTHER,        /* 0xe60 */
    OTHER,        /* 0xe61 */
    OTHER,        /* 0xe62 */
    OTHER,        /* 0xe63 */
    OTHER,        /* 0xe64 */
    OTHER,        /* 0xe65 */
    OTHER,        /* 0xe66 */
    OTHER,        /* 0xe67 */
    OTHER,        /* 0xe68 */
    OTHER,        /* 0xe69 */
    OTHER,        /* 0xe6a */
    OTHER,        /* 0xe6b */
    OTHER,        /* 0xe6c */
    OTHER,        /* 0xe6d */
    OTHER,        /* 0xe6e */
    OTHER,        /* 0xe6f */
    OTHER,        /* 0xe70 */
    OTHER,        /* 0xe71 */
    OTHER,        /* 0xe72 */
    OTHER,        /* 0xe73 */
    OTHER,        /* 0xe74 */
    OTHER,        /* 0xe75 */
    OTHER,        /* 0xe76 */
    OTHER,        /* 0xe77 */
    OTHER,        /* 0xe78 */
    OTHER,        /* 0xe79 */
    OTHER,        /* 0xe7a */
    OTHER,        /* 0xe7b */
    OTHER,        /* 0xe7c */
    OTHER,        /* 0xe7d */
    OTHER,        /* 0xe7e */
    OTHER,        /* 0xe7f */
    OTHER,        /* 0xe80 */
    OTHER,        /* 0xe81 */
    OTHER,        /* 0xe82 */
    OTHER,        /* 0xe83 */
    OTHER,        /* 0xe84 */
    OTHER,        /* 0xe85 */
    OTHER,        /* 0xe86 */
    OTHER,        /* 0xe87 */
    OTHER,        /* 0xe88 */
    OTHER,        /* 0xe89 */
    OTHER,        /* 0xe8a */
    OTHER,        /* 0xe8b */
    OTHER,        /* 0xe8c */
    OTHER,        /* 0xe8d */
    OTHER,        /* 0xe8e */
    OTHER,        /* 0xe8f */
    OTHER,        /* 0xe90 */
    OTHER,        /* 0xe91 */
    OTHER,        /* 0xe92 */
    OTHER,        /* 0xe93 */
    OTHER,        /* 0xe94 */
    OTHER,        /* 0xe95 */
    OTHER,        /* 0xe96 */
    OTHER,        /* 0xe97 */
    OTHER,        /* 0xe98 */
    OTHER,        /* 0xe99 */
    OTHER,        /* 0xe9a */
    OTHER,        /* 0xe9b */
    OTHER,        /* 0xe9c */
    OTHER,        /* 0xe9d */
    OTHER,        /* 0xe9e */
    OTHER,        /* 0xe9f */
    OTHER,        /* 0xea0 */
    OTHER,        /* 0xea1 */
    OTHER,        /* 0xea2 */
    OTHER,        /* 0xea3 */
    OTHER,        /* 0xea4 */
    OTHER,        /* 0xea5 */
    OTHER,        /* 0xea6 */
    OTHER,        /* 0xea7 */
    OTHER,        /* 0xea8 */
    OTHER,        /* 0xea9 */
    OTHER,        /* 0xeaa */
    OTHER,        /* 0xeab */
    OTHER,        /* 0xeac */
    OTHER,        /* 0xead */
    OTHER,        /* 0xeae */
    OTHER,        /* 0xeaf */
    OTHER,        /* 0xeb0 */
    OTHER,        /* 0xeb1 */
    OTHER,        /* 0xeb2 */
    OTHER,        /* 0xeb3 */
    OTHER,        /* 0xeb4 */
    OTHER,        /* 0xeb5 */
    OTHER,        /* 0xeb6 */
    OTHER,        /* 0xeb7 */
    OTHER,        /* 0xeb8 */
    OTHER,        /* 0xeb9 */
    OTHER,        /* 0xeba */
    OTHER,        /* 0xebb */
    OTHER,        /* 0xebc */
    OTHER,        /* 0xebd */
    OTHER,        /* 0xebe */
    OTHER,        /* 0xebf */
    OTHER,        /* 0xec0 */
    OTHER,        /* 0xec1 */
    OTHER,        /* 0xec2 */
    OTHER,        /* 0xec3 */
    OTHER,        /* 0xec4 */
    OTHER,        /* 0xec5 */
    OTHER,        /* 0xec6 */
    OTHER,        /* 0xec7 */
    OTHER,        /* 0xec8 */
    OTHER,        /* 0xec9 */
    OTHER,        /* 0xeca */
    OTHER,        /* 0xecb */
    OTHER,        /* 0xecc */
    OTHER,        /* 0xecd */
    OTHER,        /* 0xece */
    OTHER,        /* 0xecf */
    OTHER,        /* 0xed0 */
    OTHER,        /* 0xed1 */
    OTHER,        /* 0xed2 */
    OTHER,        /* 0xed3 */
    OTHER,        /* 0xed4 */
    OTHER,        /* 0xed5 */
    OTHER,        /* 0xed6 */
    OTHER,        /* 0xed7 */
    OTHER,        /* 0xed8 */
    OTHER,        /* 0xed9 */
    OTHER,        /* 0xeda */
    OTHER,        /* 0xedb */
    OTHER,        /* 0xedc */
    OTHER,        /* 0xedd */
    OTHER,        /* 0xede */
    OTHER,        /* 0xedf */
    OTHER,        /* 0xee0 */
    OTHER,        /* 0xee1 */
    OTHER,        /* 0xee2 */
    OTHER,        /* 0xee3 */
    OTHER,        /* 0xee4 */
    OTHER,        /* 0xee5 */
    OTHER,        /* 0xee6 */
    OTHER,        /* 0xee7 */
    OTHER,        /* 0xee8 */
    OTHER,        /* 0xee9 */
    OTHER,        /* 0xeea */
    OTHER,        /* 0xeeb */
    OTHER,        /* 0xeec */
    OTHER,        /* 0xeed */
    OTHER,        /* 0xeee */
    OTHER,        /* 0xeef */
    OTHER,        /* 0xef0 */
    OTHER,        /* 0xef1 */
    OTHER,        /* 0xef2 */
    OTHER,        /* 0xef3 */
    OTHER,        /* 0xef4 */
    OTHER,        /* 0xef5 */
    OTHER,        /* 0xef6 */
    OTHER,        /* 0xef7 */
    OTHER,        /* 0xef8 */
    OTHER,        /* 0xef9 */
    OTHER,        /* 0xefa */
    OTHER,        /* 0xefb */
    OTHER,        /* 0xefc */
    OTHER,        /* 0xefd */
    OTHER,        /* 0xefe */
    OTHER,        /* 0xeff */
    OTHER,        /* 0xf00 */
    OTHER,        /* 0xf01 */
    OTHER,        /* 0xf02 */
    OTHER,        /* 0xf03 */
    OTHER,        /* 0xf04 */
    OTHER,        /* 0xf05 */
    OTHER,        /* 0xf06 */
    OTHER,        /* 0xf07 */
    OTHER,        /* 0xf08 */
    OTHER,        /* 0xf09 */
    OTHER,        /* 0xf0a */
    OTHER,        /* 0xf0b */
    OTHER,        /* 0xf0c */
    OTHER,        /* 0xf0d */
    OTHER,        /* 0xf0e */
    OTHER,        /* 0xf0f */
    OTHER,        /* 0xf10 */
    OTHER,        /* 0xf11 */
    OTHER,        /* 0xf12 */
    OTHER,        /* 0xf13 */
    OTHER,        /* 0xf14 */
    OTHER,        /* 0xf15 */
    OTHER,        /* 0xf16 */
    OTHER,        /* 0xf17 */
    OTHER,        /* 0xf18 */
    OTHER,        /* 0xf19 */
    OTHER,        /* 0xf1a */
    OTHER,        /* 0xf1b */
    OTHER,        /* 0xf1c */
    OTHER,        /* 0xf1d */
    OTHER,        /* 0xf1e */
    OTHER,        /* 0xf1f */
    OTHER,        /* 0xf20 */
    OTHER,        /* 0xf21 */
    OTHER,        /* 0xf22 */
    OTHER,        /* 0xf23 */
    OTHER,        /* 0xf24 */
    OTHER,        /* 0xf25 */
    OTHER,        /* 0xf26 */
    OTHER,        /* 0xf27 */
    OTHER,        /* 0xf28 */
    OTHER,        /* 0xf29 */
    OTHER,        /* 0xf2a */
    OTHER,        /* 0xf2b */
    OTHER,        /* 0xf2c */
    OTHER,        /* 0xf2d */
    OTHER,        /* 0xf2e */
    OTHER,        /* 0xf2f */
    OTHER,        /* 0xf30 */
    OTHER,        /* 0xf31 */
    OTHER,        /* 0xf32 */
    OTHER,        /* 0xf33 */
    OTHER,        /* 0xf34 */
    OTHER,        /* 0xf35 */
    OTHER,        /* 0xf36 */
    OTHER,        /* 0xf37 */
    OTHER,        /* 0xf38 */
    OTHER,        /* 0xf39 */
    OTHER,        /* 0xf3a */
    OTHER,        /* 0xf3b */
    OTHER,        /* 0xf3c */
    OTHER,        /* 0xf3d */
    OTHER,        /* 0xf3e */
    OTHER,        /* 0xf3f */
    OTHER,        /* 0xf40 */
    OTHER,        /* 0xf41 */
    OTHER,        /* 0xf42 */
    OTHER,        /* 0xf43 */
    OTHER,        /* 0xf44 */
    OTHER,        /* 0xf45 */
    OTHER,        /* 0xf46 */
    OTHER,        /* 0xf47 */
    OTHER,        /* 0xf48 */
    OTHER,        /* 0xf49 */
    OTHER,        /* 0xf4a */
    OTHER,        /* 0xf4b */
    OTHER,        /* 0xf4c */
    OTHER,        /* 0xf4d */
    OTHER,        /* 0xf4e */
    OTHER,        /* 0xf4f */
    OTHER,        /* 0xf50 */
    OTHER,        /* 0xf51 */
    OTHER,        /* 0xf52 */
    OTHER,        /* 0xf53 */
    OTHER,        /* 0xf54 */
    OTHER,        /* 0xf55 */
    OTHER,        /* 0xf56 */
    OTHER,        /* 0xf57 */
    OTHER,        /* 0xf58 */
    OTHER,        /* 0xf59 */
    OTHER,        /* 0xf5a */
    OTHER,        /* 0xf5b */
    OTHER,        /* 0xf5c */
    OTHER,        /* 0xf5d */
    OTHER,        /* 0xf5e */
    OTHER,        /* 0xf5f */
    OTHER,        /* 0xf60 */
    OTHER,        /* 0xf61 */
    OTHER,        /* 0xf62 */
    OTHER,        /* 0xf63 */
    OTHER,        /* 0xf64 */
    OTHER,        /* 0xf65 */
    OTHER,        /* 0xf66 */
    OTHER,        /* 0xf67 */
    OTHER,        /* 0xf68 */
    OTHER,        /* 0xf69 */
    OTHER,        /* 0xf6a */
    OTHER,        /* 0xf6b */
    OTHER,        /* 0xf6c */
    OTHER,        /* 0xf6d */
    OTHER,        /* 0xf6e */
    OTHER,        /* 0xf6f */
    OTHER,        /* 0xf70 */
    OTHER,        /* 0xf71 */
    OTHER,        /* 0xf72 */
    OTHER,        /* 0xf73 */
    OTHER,        /* 0xf74 */
    OTHER,        /* 0xf75 */
    OTHER,        /* 0xf76 */
    OTHER,        /* 0xf77 */
    OTHER,        /* 0xf78 */
    OTHER,        /* 0xf79 */
    OTHER,        /* 0xf7a */
    OTHER,        /* 0xf7b */
    OTHER,        /* 0xf7c */
    OTHER,        /* 0xf7d */
    OTHER,        /* 0xf7e */
    OTHER,        /* 0xf7f */
    OTHER,        /* 0xf80 */
    OTHER,        /* 0xf81 */
    OTHER,        /* 0xf82 */
    OTHER,        /* 0xf83 */
    OTHER,        /* 0xf84 */
    OTHER,        /* 0xf85 */
    OTHER,        /* 0xf86 */
    OTHER,        /* 0xf87 */
    OTHER,        /* 0xf88 */
    OTHER,        /* 0xf89 */
    OTHER,        /* 0xf8a */
    OTHER,        /* 0xf8b */
    OTHER,        /* 0xf8c */
    OTHER,        /* 0xf8d */
    OTHER,        /* 0xf8e */
    OTHER,        /* 0xf8f */
    OTHER,        /* 0xf90 */
    OTHER,        /* 0xf91 */
    OTHER,        /* 0xf92 */
    OTHER,        /* 0xf93 */
    OTHER,        /* 0xf94 */
    OTHER,        /* 0xf95 */
    OTHER,        /* 0xf96 */
    OTHER,        /* 0xf97 */
    OTHER,        /* 0xf98 */
    OTHER,        /* 0xf99 */
    OTHER,        /* 0xf9a */
    OTHER,        /* 0xf9b */
    OTHER,        /* 0xf9c */
    OTHER,        /* 0xf9d */
    OTHER,        /* 0xf9e */
    OTHER,        /* 0xf9f */
    OTHER,        /* 0xfa0 */
    OTHER,        /* 0xfa1 */
    OTHER,        /* 0xfa2 */
    OTHER,        /* 0xfa3 */
    OTHER,        /* 0xfa4 */
    OTHER,        /* 0xfa5 */
    OTHER,        /* 0xfa6 */
    OTHER,        /* 0xfa7 */
    OTHER,        /* 0xfa8 */
    OTHER,        /* 0xfa9 */
    OTHER,        /* 0xfaa */
    OTHER,        /* 0xfab */
    OTHER,        /* 0xfac */
    OTHER,        /* 0xfad */
    OTHER,        /* 0xfae */
    OTHER,        /* 0xfaf */
    OTHER,        /* 0xfb0 */
    OTHER,        /* 0xfb1 */
    OTHER,        /* 0xfb2 */
    OTHER,        /* 0xfb3 */
    OTHER,        /* 0xfb4 */
    OTHER,        /* 0xfb5 */
    OTHER,        /* 0xfb6 */
    OTHER,        /* 0xfb7 */
    OTHER,        /* 0xfb8 */
    OTHER,        /* 0xfb9 */
    OTHER,        /* 0xfba */
    OTHER,        /* 0xfbb */
    OTHER,        /* 0xfbc */
    OTHER,        /* 0xfbd */
    OTHER,        /* 0xfbe */
    OTHER,        /* 0xfbf */
    OTHER,        /* 0xfc0 */
    OTHER,        /* 0xfc1 */
    OTHER,        /* 0xfc2 */
    OTHER,        /* 0xfc3 */
    OTHER,        /* 0xfc4 */
    OTHER,        /* 0xfc5 */
    OTHER,        /* 0xfc6 */
    OTHER,        /* 0xfc7 */
    OTHER,        /* 0xfc8 */
    OTHER,        /* 0xfc9 */
    OTHER,        /* 0xfca */
    OTHER,        /* 0xfcb */
    OTHER,        /* 0xfcc */
    OTHER,        /* 0xfcd */
    OTHER,        /* 0xfce */
    OTHER,        /* 0xfcf */
    OTHER,        /* 0xfd0 */
    OTHER,        /* 0xfd1 */
    OTHER,        /* 0xfd2 */
    OTHER,        /* 0xfd3 */
    OTHER,        /* 0xfd4 */
    OTHER,        /* 0xfd5 */
    OTHER,        /* 0xfd6 */
    OTHER,        /* 0xfd7 */
    OTHER,        /* 0xfd8 */
    OTHER,        /* 0xfd9 */
    OTHER,        /* 0xfda */
    OTHER,        /* 0xfdb */
    OTHER,        /* 0xfdc */
    OTHER,        /* 0xfdd */
    OTHER,        /* 0xfde */
    OTHER,        /* 0xfdf */
    OTHER,        /* 0xfe0 */
    OTHER,        /* 0xfe1 */
    OTHER,        /* 0xfe2 */
    OTHER,        /* 0xfe3 */
    OTHER,        /* 0xfe4 */
    OTHER,        /* 0xfe5 */
    OTHER,        /* 0xfe6 */
    OTHER,        /* 0xfe7 */
    OTHER,        /* 0xfe8 */
    OTHER,        /* 0xfe9 */
    OTHER,        /* 0xfea */
    OTHER,        /* 0xfeb */
    OTHER,        /* 0xfec */
    OTHER,        /* 0xfed */
    OTHER,        /* 0xfee */
    OTHER,        /* 0xfef */
    OTHER,        /* 0xff0 */
    OTHER,        /* 0xff1 */
    OTHER,        /* 0xff2 */
    OTHER,        /* 0xff3 */
    OTHER,        /* 0xff4 */
    OTHER,        /* 0xff5 */
    OTHER,        /* 0xff6 */
    OTHER,        /* 0xff7 */
    OTHER,        /* 0xff8 */
    OTHER,        /* 0xff9 */
    OTHER,        /* 0xffa */
    OTHER,        /* 0xffb */
    OTHER,        /* 0xffc */
    OTHER,        /* 0xffd */
    OTHER,        /* 0xffe */
    OTHER,        /* 0xfff */
    OTHER,        /* 0x1000 */
    OTHER,        /* 0x1001 */
    OTHER,        /* 0x1002 */
    OTHER,        /* 0x1003 */
    OTHER,        /* 0x1004 */
    OTHER,        /* 0x1005 */
    OTHER,        /* 0x1006 */
    OTHER,        /* 0x1007 */
    OTHER,        /* 0x1008 */
    OTHER,        /* 0x1009 */
    OTHER,        /* 0x100a */
    OTHER,        /* 0x100b */
    OTHER,        /* 0x100c */
    OTHER,        /* 0x100d */
    OTHER,        /* 0x100e */
    OTHER,        /* 0x100f */
    OTHER,        /* 0x1010 */
    OTHER,        /* 0x1011 */
    OTHER,        /* 0x1012 */
    OTHER,        /* 0x1013 */
    OTHER,        /* 0x1014 */
    OTHER,        /* 0x1015 */
    OTHER,        /* 0x1016 */
    OTHER,        /* 0x1017 */
    OTHER,        /* 0x1018 */
    OTHER,        /* 0x1019 */
    OTHER,        /* 0x101a */
    OTHER,        /* 0x101b */
    OTHER,        /* 0x101c */
    OTHER,        /* 0x101d */
    OTHER,        /* 0x101e */
    OTHER,        /* 0x101f */
    OTHER,        /* 0x1020 */
    OTHER,        /* 0x1021 */
    OTHER,        /* 0x1022 */
    OTHER,        /* 0x1023 */
    OTHER,        /* 0x1024 */
    OTHER,        /* 0x1025 */
    OTHER,        /* 0x1026 */
    OTHER,        /* 0x1027 */
    OTHER,        /* 0x1028 */
    OTHER,        /* 0x1029 */
    OTHER,        /* 0x102a */
    OTHER,        /* 0x102b */
    OTHER,        /* 0x102c */
    OTHER,        /* 0x102d */
    OTHER,        /* 0x102e */
    OTHER,        /* 0x102f */
    OTHER,        /* 0x1030 */
    OTHER,        /* 0x1031 */
    OTHER,        /* 0x1032 */
    OTHER,        /* 0x1033 */
    OTHER,        /* 0x1034 */
    OTHER,        /* 0x1035 */
    OTHER,        /* 0x1036 */
    OTHER,        /* 0x1037 */
    OTHER,        /* 0x1038 */
    OTHER,        /* 0x1039 */
    OTHER,        /* 0x103a */
    OTHER,        /* 0x103b */
    OTHER,        /* 0x103c */
    OTHER,        /* 0x103d */
    OTHER,        /* 0x103e */
    OTHER,        /* 0x103f */
    OTHER,        /* 0x1040 */
    OTHER,        /* 0x1041 */
    OTHER,        /* 0x1042 */
    OTHER,        /* 0x1043 */
    OTHER,        /* 0x1044 */
    OTHER,        /* 0x1045 */
    OTHER,        /* 0x1046 */
    OTHER,        /* 0x1047 */
    OTHER,        /* 0x1048 */
    OTHER,        /* 0x1049 */
    OTHER,        /* 0x104a */
    OTHER,        /* 0x104b */
    OTHER,        /* 0x104c */
    OTHER,        /* 0x104d */
    OTHER,        /* 0x104e */
    OTHER,        /* 0x104f */
    OTHER,        /* 0x1050 */
    OTHER,        /* 0x1051 */
    OTHER,        /* 0x1052 */
    OTHER,        /* 0x1053 */
    OTHER,        /* 0x1054 */
    OTHER,        /* 0x1055 */
    OTHER,        /* 0x1056 */
    OTHER,        /* 0x1057 */
    OTHER,        /* 0x1058 */
    OTHER,        /* 0x1059 */
    OTHER,        /* 0x105a */
    OTHER,        /* 0x105b */
    OTHER,        /* 0x105c */
    OTHER,        /* 0x105d */
    OTHER,        /* 0x105e */
    OTHER,        /* 0x105f */
    OTHER,        /* 0x1060 */
    OTHER,        /* 0x1061 */
    OTHER,        /* 0x1062 */
    OTHER,        /* 0x1063 */
    OTHER,        /* 0x1064 */
    OTHER,        /* 0x1065 */
    OTHER,        /* 0x1066 */
    OTHER,        /* 0x1067 */
    OTHER,        /* 0x1068 */
    OTHER,        /* 0x1069 */
    OTHER,        /* 0x106a */
    OTHER,        /* 0x106b */
    OTHER,        /* 0x106c */
    OTHER,        /* 0x106d */
    OTHER,        /* 0x106e */
    OTHER,        /* 0x106f */
    OTHER,        /* 0x1070 */
    OTHER,        /* 0x1071 */
    OTHER,        /* 0x1072 */
    OTHER,        /* 0x1073 */
    OTHER,        /* 0x1074 */
    OTHER,        /* 0x1075 */
    OTHER,        /* 0x1076 */
    OTHER,        /* 0x1077 */
    OTHER,        /* 0x1078 */
    OTHER,        /* 0x1079 */
    OTHER,        /* 0x107a */
    OTHER,        /* 0x107b */
    OTHER,        /* 0x107c */
    OTHER,        /* 0x107d */
    OTHER,        /* 0x107e */
    OTHER,        /* 0x107f */
    OTHER,        /* 0x1080 */
    OTHER,        /* 0x1081 */
    OTHER,        /* 0x1082 */
    OTHER,        /* 0x1083 */
    OTHER,        /* 0x1084 */
    OTHER,        /* 0x1085 */
    OTHER,        /* 0x1086 */
    OTHER,        /* 0x1087 */
    OTHER,        /* 0x1088 */
    OTHER,        /* 0x1089 */
    OTHER,        /* 0x108a */
    OTHER,        /* 0x108b */
    OTHER,        /* 0x108c */
    OTHER,        /* 0x108d */
    OTHER,        /* 0x108e */
    OTHER,        /* 0x108f */
    OTHER,        /* 0x1090 */
    OTHER,        /* 0x1091 */
    OTHER,        /* 0x1092 */
    OTHER,        /* 0x1093 */
    OTHER,        /* 0x1094 */
    OTHER,        /* 0x1095 */
    OTHER,        /* 0x1096 */
    OTHER,        /* 0x1097 */
    OTHER,        /* 0x1098 */
    OTHER,        /* 0x1099 */
    OTHER,        /* 0x109a */
    OTHER,        /* 0x109b */
    OTHER,        /* 0x109c */
    OTHER,        /* 0x109d */
    OTHER,        /* 0x109e */
    OTHER,        /* 0x109f */
    OTHER,        /* 0x10a0 */
    OTHER,        /* 0x10a1 */
    OTHER,        /* 0x10a2 */
    OTHER,        /* 0x10a3 */
    OTHER,        /* 0x10a4 */
    OTHER,        /* 0x10a5 */
    OTHER,        /* 0x10a6 */
    OTHER,        /* 0x10a7 */
    OTHER,        /* 0x10a8 */
    OTHER,        /* 0x10a9 */
    OTHER,        /* 0x10aa */
    OTHER,        /* 0x10ab */
    OTHER,        /* 0x10ac */
    OTHER,        /* 0x10ad */
    OTHER,        /* 0x10ae */
    OTHER,        /* 0x10af */
    OTHER,        /* 0x10b0 */
    OTHER,        /* 0x10b1 */
    OTHER,        /* 0x10b2 */
    OTHER,        /* 0x10b3 */
    OTHER,        /* 0x10b4 */
    OTHER,        /* 0x10b5 */
    OTHER,        /* 0x10b6 */
    OTHER,        /* 0x10b7 */
    OTHER,        /* 0x10b8 */
    OTHER,        /* 0x10b9 */
    OTHER,        /* 0x10ba */
    OTHER,        /* 0x10bb */
    OTHER,        /* 0x10bc */
    OTHER,        /* 0x10bd */
    OTHER,        /* 0x10be */
    OTHER,        /* 0x10bf */
    OTHER,        /* 0x10c0 */
    OTHER,        /* 0x10c1 */
    OTHER,        /* 0x10c2 */
    OTHER,        /* 0x10c3 */
    OTHER,        /* 0x10c4 */
    OTHER,        /* 0x10c5 */
    OTHER,        /* 0x10c6 */
    OTHER,        /* 0x10c7 */
    OTHER,        /* 0x10c8 */
    OTHER,        /* 0x10c9 */
    OTHER,        /* 0x10ca */
    OTHER,        /* 0x10cb */
    OTHER,        /* 0x10cc */
    OTHER,        /* 0x10cd */
    OTHER,        /* 0x10ce */
    OTHER,        /* 0x10cf */
    OTHER,        /* 0x10d0 */
    OTHER,        /* 0x10d1 */
    OTHER,        /* 0x10d2 */
    OTHER,        /* 0x10d3 */
    OTHER,        /* 0x10d4 */
    OTHER,        /* 0x10d5 */
    OTHER,        /* 0x10d6 */
    OTHER,        /* 0x10d7 */
    OTHER,        /* 0x10d8 */
    OTHER,        /* 0x10d9 */
    OTHER,        /* 0x10da */
    OTHER,        /* 0x10db */
    OTHER,        /* 0x10dc */
    OTHER,        /* 0x10dd */
    OTHER,        /* 0x10de */
    OTHER,        /* 0x10df */
    OTHER,        /* 0x10e0 */
    OTHER,        /* 0x10e1 */
    OTHER,        /* 0x10e2 */
    OTHER,        /* 0x10e3 */
    OTHER,        /* 0x10e4 */
    OTHER,        /* 0x10e5 */
    OTHER,        /* 0x10e6 */
    OTHER,        /* 0x10e7 */
    OTHER,        /* 0x10e8 */
    OTHER,        /* 0x10e9 */
    OTHER,        /* 0x10ea */
    OTHER,        /* 0x10eb */
    OTHER,        /* 0x10ec */
    OTHER,        /* 0x10ed */
    OTHER,        /* 0x10ee */
    OTHER,        /* 0x10ef */
    OTHER,        /* 0x10f0 */
    OTHER,        /* 0x10f1 */
    OTHER,        /* 0x10f2 */
    OTHER,        /* 0x10f3 */
    OTHER,        /* 0x10f4 */
    OTHER,        /* 0x10f5 */
    OTHER,        /* 0x10f6 */
    OTHER,        /* 0x10f7 */
    OTHER,        /* 0x10f8 */
    OTHER,        /* 0x10f9 */
    OTHER,        /* 0x10fa */
    OTHER,        /* 0x10fb */
    OTHER,        /* 0x10fc */
    OTHER,        /* 0x10fd */
    OTHER,        /* 0x10fe */
    OTHER,        /* 0x10ff */
    OTHER,        /* 0x1100 */
    OTHER,        /* 0x1101 */
    OTHER,        /* 0x1102 */
    OTHER,        /* 0x1103 */
    OTHER,        /* 0x1104 */
    OTHER,        /* 0x1105 */
    OTHER,        /* 0x1106 */
    OTHER,        /* 0x1107 */
    OTHER,        /* 0x1108 */
    OTHER,        /* 0x1109 */
    OTHER,        /* 0x110a */
    OTHER,        /* 0x110b */
    OTHER,        /* 0x110c */
    OTHER,        /* 0x110d */
    OTHER,        /* 0x110e */
    OTHER,        /* 0x110f */
    OTHER,        /* 0x1110 */
    OTHER,        /* 0x1111 */
    OTHER,        /* 0x1112 */
    OTHER,        /* 0x1113 */
    OTHER,        /* 0x1114 */
    OTHER,        /* 0x1115 */
    OTHER,        /* 0x1116 */
    OTHER,        /* 0x1117 */
    OTHER,        /* 0x1118 */
    OTHER,        /* 0x1119 */
    OTHER,        /* 0x111a */
    OTHER,        /* 0x111b */
    OTHER,        /* 0x111c */
    OTHER,        /* 0x111d */
    OTHER,        /* 0x111e */
    OTHER,        /* 0x111f */
    OTHER,        /* 0x1120 */
    OTHER,        /* 0x1121 */
    OTHER,        /* 0x1122 */
    OTHER,        /* 0x1123 */
    OTHER,        /* 0x1124 */
    OTHER,        /* 0x1125 */
    OTHER,        /* 0x1126 */
    OTHER,        /* 0x1127 */
    OTHER,        /* 0x1128 */
    OTHER,        /* 0x1129 */
    OTHER,        /* 0x112a */
    OTHER,        /* 0x112b */
    OTHER,        /* 0x112c */
    OTHER,        /* 0x112d */
    OTHER,        /* 0x112e */
    OTHER,        /* 0x112f */
    OTHER,        /* 0x1130 */
    OTHER,        /* 0x1131 */
    OTHER,        /* 0x1132 */
    OTHER,        /* 0x1133 */
    OTHER,        /* 0x1134 */
    OTHER,        /* 0x1135 */
    OTHER,        /* 0x1136 */
    OTHER,        /* 0x1137 */
    OTHER,        /* 0x1138 */
    OTHER,        /* 0x1139 */
    OTHER,        /* 0x113a */
    OTHER,        /* 0x113b */
    OTHER,        /* 0x113c */
    OTHER,        /* 0x113d */
    OTHER,        /* 0x113e */
    OTHER,        /* 0x113f */
    OTHER,        /* 0x1140 */
    OTHER,        /* 0x1141 */
    OTHER,        /* 0x1142 */
    OTHER,        /* 0x1143 */
    OTHER,        /* 0x1144 */
    OTHER,        /* 0x1145 */
    OTHER,        /* 0x1146 */
    OTHER,        /* 0x1147 */
    OTHER,        /* 0x1148 */
    OTHER,        /* 0x1149 */
    OTHER,        /* 0x114a */
    OTHER,        /* 0x114b */
    OTHER,        /* 0x114c */
    OTHER,        /* 0x114d */
    OTHER,        /* 0x114e */
    OTHER,        /* 0x114f */
    OTHER,        /* 0x1150 */
    OTHER,        /* 0x1151 */
    OTHER,        /* 0x1152 */
    OTHER,        /* 0x1153 */
    OTHER,        /* 0x1154 */
    OTHER,        /* 0x1155 */
    OTHER,        /* 0x1156 */
    OTHER,        /* 0x1157 */
    OTHER,        /* 0x1158 */
    OTHER,        /* 0x1159 */
    OTHER,        /* 0x115a */
    OTHER,        /* 0x115b */
    OTHER,        /* 0x115c */
    OTHER,        /* 0x115d */
    OTHER,        /* 0x115e */
    OTHER,        /* 0x115f */
    OTHER,        /* 0x1160 */
    OTHER,        /* 0x1161 */
    OTHER,        /* 0x1162 */
    OTHER,        /* 0x1163 */
    OTHER,        /* 0x1164 */
    OTHER,        /* 0x1165 */
    OTHER,        /* 0x1166 */
    OTHER,        /* 0x1167 */
    OTHER,        /* 0x1168 */
    OTHER,        /* 0x1169 */
    OTHER,        /* 0x116a */
    OTHER,        /* 0x116b */
    OTHER,        /* 0x116c */
    OTHER,        /* 0x116d */
    OTHER,        /* 0x116e */
    OTHER,        /* 0x116f */
    OTHER,        /* 0x1170 */
    OTHER,        /* 0x1171 */
    OTHER,        /* 0x1172 */
    OTHER,        /* 0x1173 */
    OTHER,        /* 0x1174 */
    OTHER,        /* 0x1175 */
    OTHER,        /* 0x1176 */
    OTHER,        /* 0x1177 */
    OTHER,        /* 0x1178 */
    OTHER,        /* 0x1179 */
    OTHER,        /* 0x117a */
    OTHER,        /* 0x117b */
    OTHER,        /* 0x117c */
    OTHER,        /* 0x117d */
    OTHER,        /* 0x117e */
    OTHER,        /* 0x117f */
    OTHER,        /* 0x1180 */
    OTHER,        /* 0x1181 */
    OTHER,        /* 0x1182 */
    OTHER,        /* 0x1183 */
    OTHER,        /* 0x1184 */
    OTHER,        /* 0x1185 */
    OTHER,        /* 0x1186 */
    OTHER,        /* 0x1187 */
    OTHER,        /* 0x1188 */
    OTHER,        /* 0x1189 */
    OTHER,        /* 0x118a */
    OTHER,        /* 0x118b */
    OTHER,        /* 0x118c */
    OTHER,        /* 0x118d */
    OTHER,        /* 0x118e */
    OTHER,        /* 0x118f */
    OTHER,        /* 0x1190 */
    OTHER,        /* 0x1191 */
    OTHER,        /* 0x1192 */
    OTHER,        /* 0x1193 */
    OTHER,        /* 0x1194 */
    OTHER,        /* 0x1195 */
    OTHER,        /* 0x1196 */
    OTHER,        /* 0x1197 */
    OTHER,        /* 0x1198 */
    OTHER,        /* 0x1199 */
    OTHER,        /* 0x119a */
    OTHER,        /* 0x119b */
    OTHER,        /* 0x119c */
    OTHER,        /* 0x119d */
    OTHER,        /* 0x119e */
    OTHER,        /* 0x119f */
    OTHER,        /* 0x11a0 */
    OTHER,        /* 0x11a1 */
    OTHER,        /* 0x11a2 */
    OTHER,        /* 0x11a3 */
    OTHER,        /* 0x11a4 */
    OTHER,        /* 0x11a5 */
    OTHER,        /* 0x11a6 */
    OTHER,        /* 0x11a7 */
    OTHER,        /* 0x11a8 */
    OTHER,        /* 0x11a9 */
    OTHER,        /* 0x11aa */
    OTHER,        /* 0x11ab */
    OTHER,        /* 0x11ac */
    OTHER,        /* 0x11ad */
    OTHER,        /* 0x11ae */
    OTHER,        /* 0x11af */
    OTHER,        /* 0x11b0 */
    OTHER,        /* 0x11b1 */
    OTHER,        /* 0x11b2 */
    OTHER,        /* 0x11b3 */
    OTHER,        /* 0x11b4 */
    OTHER,        /* 0x11b5 */
    OTHER,        /* 0x11b6 */
    OTHER,        /* 0x11b7 */
    OTHER,        /* 0x11b8 */
    OTHER,        /* 0x11b9 */
    OTHER,        /* 0x11ba */
    OTHER,        /* 0x11bb */
    OTHER,        /* 0x11bc */
    OTHER,        /* 0x11bd */
    OTHER,        /* 0x11be */
    OTHER,        /* 0x11bf */
    OTHER,        /* 0x11c0 */
    OTHER,        /* 0x11c1 */
    OTHER,        /* 0x11c2 */
    OTHER,        /* 0x11c3 */
    OTHER,        /* 0x11c4 */
    OTHER,        /* 0x11c5 */
    OTHER,        /* 0x11c6 */
    OTHER,        /* 0x11c7 */
    OTHER,        /* 0x11c8 */
    OTHER,        /* 0x11c9 */
    OTHER,        /* 0x11ca */
    OTHER,        /* 0x11cb */
    OTHER,        /* 0x11cc */
    OTHER,        /* 0x11cd */
    OTHER,        /* 0x11ce */
    OTHER,        /* 0x11cf */
    OTHER,        /* 0x11d0 */
    OTHER,        /* 0x11d1 */
    OTHER,        /* 0x11d2 */
    OTHER,        /* 0x11d3 */
    OTHER,        /* 0x11d4 */
    OTHER,        /* 0x11d5 */
    OTHER,        /* 0x11d6 */
    OTHER,        /* 0x11d7 */
    OTHER,        /* 0x11d8 */
    OTHER,        /* 0x11d9 */
    OTHER,        /* 0x11da */
    OTHER,        /* 0x11db */
    OTHER,        /* 0x11dc */
    OTHER,        /* 0x11dd */
    OTHER,        /* 0x11de */
    OTHER,        /* 0x11df */
    OTHER,        /* 0x11e0 */
    OTHER,        /* 0x11e1 */
    OTHER,        /* 0x11e2 */
    OTHER,        /* 0x11e3 */
    OTHER,        /* 0x11e4 */
    OTHER,        /* 0x11e5 */
    OTHER,        /* 0x11e6 */
    OTHER,        /* 0x11e7 */
    OTHER,        /* 0x11e8 */
    OTHER,        /* 0x11e9 */
    OTHER,        /* 0x11ea */
    OTHER,        /* 0x11eb */
    OTHER,        /* 0x11ec */
    OTHER,        /* 0x11ed */
    OTHER,        /* 0x11ee */
    OTHER,        /* 0x11ef */
    OTHER,        /* 0x11f0 */
    OTHER,        /* 0x11f1 */
    OTHER,        /* 0x11f2 */
    OTHER,        /* 0x11f3 */
    OTHER,        /* 0x11f4 */
    OTHER,        /* 0x11f5 */
    OTHER,        /* 0x11f6 */
    OTHER,        /* 0x11f7 */
    OTHER,        /* 0x11f8 */
    OTHER,        /* 0x11f9 */
    OTHER,        /* 0x11fa */
    OTHER,        /* 0x11fb */
    OTHER,        /* 0x11fc */
    OTHER,        /* 0x11fd */
    OTHER,        /* 0x11fe */
    OTHER,        /* 0x11ff */
    OTHER,        /* 0x1200 */
    OTHER,        /* 0x1201 */
    OTHER,        /* 0x1202 */
    OTHER,        /* 0x1203 */
    OTHER,        /* 0x1204 */
    OTHER,        /* 0x1205 */
    OTHER,        /* 0x1206 */
    OTHER,        /* 0x1207 */
    OTHER,        /* 0x1208 */
    OTHER,        /* 0x1209 */
    OTHER,        /* 0x120a */
    OTHER,        /* 0x120b */
    OTHER,        /* 0x120c */
    OTHER,        /* 0x120d */
    OTHER,        /* 0x120e */
    OTHER,        /* 0x120f */
    OTHER,        /* 0x1210 */
    OTHER,        /* 0x1211 */
    OTHER,        /* 0x1212 */
    OTHER,        /* 0x1213 */
    OTHER,        /* 0x1214 */
    OTHER,        /* 0x1215 */
    OTHER,        /* 0x1216 */
    OTHER,        /* 0x1217 */
    OTHER,        /* 0x1218 */
    OTHER,        /* 0x1219 */
    OTHER,        /* 0x121a */
    OTHER,        /* 0x121b */
    OTHER,        /* 0x121c */
    OTHER,        /* 0x121d */
    OTHER,        /* 0x121e */
    OTHER,        /* 0x121f */
    OTHER,        /* 0x1220 */
    OTHER,        /* 0x1221 */
    OTHER,        /* 0x1222 */
    OTHER,        /* 0x1223 */
    OTHER,        /* 0x1224 */
    OTHER,        /* 0x1225 */
    OTHER,        /* 0x1226 */
    OTHER,        /* 0x1227 */
    OTHER,        /* 0x1228 */
    OTHER,        /* 0x1229 */
    OTHER,        /* 0x122a */
    OTHER,        /* 0x122b */
    OTHER,        /* 0x122c */
    OTHER,        /* 0x122d */
    OTHER,        /* 0x122e */
    OTHER,        /* 0x122f */
    OTHER,        /* 0x1230 */
    OTHER,        /* 0x1231 */
    OTHER,        /* 0x1232 */
    OTHER,        /* 0x1233 */
    OTHER,        /* 0x1234 */
    OTHER,        /* 0x1235 */
    OTHER,        /* 0x1236 */
    OTHER,        /* 0x1237 */
    OTHER,        /* 0x1238 */
    OTHER,        /* 0x1239 */
    OTHER,        /* 0x123a */
    OTHER,        /* 0x123b */
    OTHER,        /* 0x123c */
    OTHER,        /* 0x123d */
    OTHER,        /* 0x123e */
    OTHER,        /* 0x123f */
    OTHER,        /* 0x1240 */
    OTHER,        /* 0x1241 */
    OTHER,        /* 0x1242 */
    OTHER,        /* 0x1243 */
    OTHER,        /* 0x1244 */
    OTHER,        /* 0x1245 */
    OTHER,        /* 0x1246 */
    OTHER,        /* 0x1247 */
    OTHER,        /* 0x1248 */
    OTHER,        /* 0x1249 */
    OTHER,        /* 0x124a */
    OTHER,        /* 0x124b */
    OTHER,        /* 0x124c */
    OTHER,        /* 0x124d */
    OTHER,        /* 0x124e */
    OTHER,        /* 0x124f */
    OTHER,        /* 0x1250 */
    OTHER,        /* 0x1251 */
    OTHER,        /* 0x1252 */
    OTHER,        /* 0x1253 */
    OTHER,        /* 0x1254 */
    OTHER,        /* 0x1255 */
    OTHER,        /* 0x1256 */
    OTHER,        /* 0x1257 */
    OTHER,        /* 0x1258 */
    OTHER,        /* 0x1259 */
    OTHER,        /* 0x125a */
    OTHER,        /* 0x125b */
    OTHER,        /* 0x125c */
    OTHER,        /* 0x125d */
    OTHER,        /* 0x125e */
    OTHER,        /* 0x125f */
    OTHER,        /* 0x1260 */
    OTHER,        /* 0x1261 */
    OTHER,        /* 0x1262 */
    OTHER,        /* 0x1263 */
    OTHER,        /* 0x1264 */
    OTHER,        /* 0x1265 */
    OTHER,        /* 0x1266 */
    OTHER,        /* 0x1267 */
    OTHER,        /* 0x1268 */
    OTHER,        /* 0x1269 */
    OTHER,        /* 0x126a */
    OTHER,        /* 0x126b */
    OTHER,        /* 0x126c */
    OTHER,        /* 0x126d */
    OTHER,        /* 0x126e */
    OTHER,        /* 0x126f */
    OTHER,        /* 0x1270 */
    OTHER,        /* 0x1271 */
    OTHER,        /* 0x1272 */
    OTHER,        /* 0x1273 */
    OTHER,        /* 0x1274 */
    OTHER,        /* 0x1275 */
    OTHER,        /* 0x1276 */
    OTHER,        /* 0x1277 */
    OTHER,        /* 0x1278 */
    OTHER,        /* 0x1279 */
    OTHER,        /* 0x127a */
    OTHER,        /* 0x127b */
    OTHER,        /* 0x127c */
    OTHER,        /* 0x127d */
    OTHER,        /* 0x127e */
    OTHER,        /* 0x127f */
    OTHER,        /* 0x1280 */
    OTHER,        /* 0x1281 */
    OTHER,        /* 0x1282 */
    OTHER,        /* 0x1283 */
    OTHER,        /* 0x1284 */
    OTHER,        /* 0x1285 */
    OTHER,        /* 0x1286 */
    OTHER,        /* 0x1287 */
    OTHER,        /* 0x1288 */
    OTHER,        /* 0x1289 */
    OTHER,        /* 0x128a */
    OTHER,        /* 0x128b */
    OTHER,        /* 0x128c */
    OTHER,        /* 0x128d */
    OTHER,        /* 0x128e */
    OTHER,        /* 0x128f */
    OTHER,        /* 0x1290 */
    OTHER,        /* 0x1291 */
    OTHER,        /* 0x1292 */
    OTHER,        /* 0x1293 */
    OTHER,        /* 0x1294 */
    OTHER,        /* 0x1295 */
    OTHER,        /* 0x1296 */
    OTHER,        /* 0x1297 */
    OTHER,        /* 0x1298 */
    OTHER,        /* 0x1299 */
    OTHER,        /* 0x129a */
    OTHER,        /* 0x129b */
    OTHER,        /* 0x129c */
    OTHER,        /* 0x129d */
    OTHER,        /* 0x129e */
    OTHER,        /* 0x129f */
    OTHER,        /* 0x12a0 */
    OTHER,        /* 0x12a1 */
    OTHER,        /* 0x12a2 */
    OTHER,        /* 0x12a3 */
    OTHER,        /* 0x12a4 */
    OTHER,        /* 0x12a5 */
    OTHER,        /* 0x12a6 */
    OTHER,        /* 0x12a7 */
    OTHER,        /* 0x12a8 */
    OTHER,        /* 0x12a9 */
    OTHER,        /* 0x12aa */
    OTHER,        /* 0x12ab */
    OTHER,        /* 0x12ac */
    OTHER,        /* 0x12ad */
    OTHER,        /* 0x12ae */
    OTHER,        /* 0x12af */
    OTHER,        /* 0x12b0 */
    OTHER,        /* 0x12b1 */
    OTHER,        /* 0x12b2 */
    OTHER,        /* 0x12b3 */
    OTHER,        /* 0x12b4 */
    OTHER,        /* 0x12b5 */
    OTHER,        /* 0x12b6 */
    OTHER,        /* 0x12b7 */
    OTHER,        /* 0x12b8 */
    OTHER,        /* 0x12b9 */
    OTHER,        /* 0x12ba */
    OTHER,        /* 0x12bb */
    OTHER,        /* 0x12bc */
    OTHER,        /* 0x12bd */
    OTHER,        /* 0x12be */
    OTHER,        /* 0x12bf */
    OTHER,        /* 0x12c0 */
    OTHER,        /* 0x12c1 */
    OTHER,        /* 0x12c2 */
    OTHER,        /* 0x12c3 */
    OTHER,        /* 0x12c4 */
    OTHER,        /* 0x12c5 */
    OTHER,        /* 0x12c6 */
    OTHER,        /* 0x12c7 */
    OTHER,        /* 0x12c8 */
    OTHER,        /* 0x12c9 */
    OTHER,        /* 0x12ca */
    OTHER,        /* 0x12cb */
    OTHER,        /* 0x12cc */
    OTHER,        /* 0x12cd */
    OTHER,        /* 0x12ce */
    OTHER,        /* 0x12cf */
    OTHER,        /* 0x12d0 */
    OTHER,        /* 0x12d1 */
    OTHER,        /* 0x12d2 */
    OTHER,        /* 0x12d3 */
    OTHER,        /* 0x12d4 */
    OTHER,        /* 0x12d5 */
    OTHER,        /* 0x12d6 */
    OTHER,        /* 0x12d7 */
    OTHER,        /* 0x12d8 */
    OTHER,        /* 0x12d9 */
    OTHER,        /* 0x12da */
    OTHER,        /* 0x12db */
    OTHER,        /* 0x12dc */
    OTHER,        /* 0x12dd */
    OTHER,        /* 0x12de */
    OTHER,        /* 0x12df */
    OTHER,        /* 0x12e0 */
    OTHER,        /* 0x12e1 */
    OTHER,        /* 0x12e2 */
    OTHER,        /* 0x12e3 */
    OTHER,        /* 0x12e4 */
    OTHER,        /* 0x12e5 */
    OTHER,        /* 0x12e6 */
    OTHER,        /* 0x12e7 */
    OTHER,        /* 0x12e8 */
    OTHER,        /* 0x12e9 */
    OTHER,        /* 0x12ea */
    OTHER,        /* 0x12eb */
    OTHER,        /* 0x12ec */
    OTHER,        /* 0x12ed */
    OTHER,        /* 0x12ee */
    OTHER,        /* 0x12ef */
    OTHER,        /* 0x12f0 */
    OTHER,        /* 0x12f1 */
    OTHER,        /* 0x12f2 */
    OTHER,        /* 0x12f3 */
    OTHER,        /* 0x12f4 */
    OTHER,        /* 0x12f5 */
    OTHER,        /* 0x12f6 */
    OTHER,        /* 0x12f7 */
    OTHER,        /* 0x12f8 */
    OTHER,        /* 0x12f9 */
    OTHER,        /* 0x12fa */
    OTHER,        /* 0x12fb */
    OTHER,        /* 0x12fc */
    OTHER,        /* 0x12fd */
    OTHER,        /* 0x12fe */
    OTHER,        /* 0x12ff */
    OTHER,        /* 0x1300 */
    OTHER,        /* 0x1301 */
    OTHER,        /* 0x1302 */
    OTHER,        /* 0x1303 */
    OTHER,        /* 0x1304 */
    OTHER,        /* 0x1305 */
    OTHER,        /* 0x1306 */
    OTHER,        /* 0x1307 */
    OTHER,        /* 0x1308 */
    OTHER,        /* 0x1309 */
    OTHER,        /* 0x130a */
    OTHER,        /* 0x130b */
    OTHER,        /* 0x130c */
    OTHER,        /* 0x130d */
    OTHER,        /* 0x130e */
    OTHER,        /* 0x130f */
    OTHER,        /* 0x1310 */
    OTHER,        /* 0x1311 */
    OTHER,        /* 0x1312 */
    OTHER,        /* 0x1313 */
    OTHER,        /* 0x1314 */
    OTHER,        /* 0x1315 */
    OTHER,        /* 0x1316 */
    OTHER,        /* 0x1317 */
    OTHER,        /* 0x1318 */
    OTHER,        /* 0x1319 */
    OTHER,        /* 0x131a */
    OTHER,        /* 0x131b */
    OTHER,        /* 0x131c */
    OTHER,        /* 0x131d */
    OTHER,        /* 0x131e */
    OTHER,        /* 0x131f */
    OTHER,        /* 0x1320 */
    OTHER,        /* 0x1321 */
    OTHER,        /* 0x1322 */
    OTHER,        /* 0x1323 */
    OTHER,        /* 0x1324 */
    OTHER,        /* 0x1325 */
    OTHER,        /* 0x1326 */
    OTHER,        /* 0x1327 */
    OTHER,        /* 0x1328 */
    OTHER,        /* 0x1329 */
    OTHER,        /* 0x132a */
    OTHER,        /* 0x132b */
    OTHER,        /* 0x132c */
    OTHER,        /* 0x132d */
    OTHER,        /* 0x132e */
    OTHER,        /* 0x132f */
    OTHER,        /* 0x1330 */
    OTHER,        /* 0x1331 */
    OTHER,        /* 0x1332 */
    OTHER,        /* 0x1333 */
    OTHER,        /* 0x1334 */
    OTHER,        /* 0x1335 */
    OTHER,        /* 0x1336 */
    OTHER,        /* 0x1337 */
    OTHER,        /* 0x1338 */
    OTHER,        /* 0x1339 */
    OTHER,        /* 0x133a */
    OTHER,        /* 0x133b */
    OTHER,        /* 0x133c */
    OTHER,        /* 0x133d */
    OTHER,        /* 0x133e */
    OTHER,        /* 0x133f */
    OTHER,        /* 0x1340 */
    OTHER,        /* 0x1341 */
    OTHER,        /* 0x1342 */
    OTHER,        /* 0x1343 */
    OTHER,        /* 0x1344 */
    OTHER,        /* 0x1345 */
    OTHER,        /* 0x1346 */
    OTHER,        /* 0x1347 */
    OTHER,        /* 0x1348 */
    OTHER,        /* 0x1349 */
    OTHER,        /* 0x134a */
    OTHER,        /* 0x134b */
    OTHER,        /* 0x134c */
    OTHER,        /* 0x134d */
    OTHER,        /* 0x134e */
    OTHER,        /* 0x134f */
    OTHER,        /* 0x1350 */
    OTHER,        /* 0x1351 */
    OTHER,        /* 0x1352 */
    OTHER,        /* 0x1353 */
    OTHER,        /* 0x1354 */
    OTHER,        /* 0x1355 */
    OTHER,        /* 0x1356 */
    OTHER,        /* 0x1357 */
    OTHER,        /* 0x1358 */
    OTHER,        /* 0x1359 */
    OTHER,        /* 0x135a */
    OTHER,        /* 0x135b */
    OTHER,        /* 0x135c */
    OTHER,        /* 0x135d */
    OTHER,        /* 0x135e */
    OTHER,        /* 0x135f */
    OTHER,        /* 0x1360 */
    OTHER,        /* 0x1361 */
    OTHER,        /* 0x1362 */
    OTHER,        /* 0x1363 */
    OTHER,        /* 0x1364 */
    OTHER,        /* 0x1365 */
    OTHER,        /* 0x1366 */
    OTHER,        /* 0x1367 */
    OTHER,        /* 0x1368 */
    OTHER,        /* 0x1369 */
    OTHER,        /* 0x136a */
    OTHER,        /* 0x136b */
    OTHER,        /* 0x136c */
    OTHER,        /* 0x136d */
    OTHER,        /* 0x136e */
    OTHER,        /* 0x136f */
    OTHER,        /* 0x1370 */
    OTHER,        /* 0x1371 */
    OTHER,        /* 0x1372 */
    OTHER,        /* 0x1373 */
    OTHER,        /* 0x1374 */
    OTHER,        /* 0x1375 */
    OTHER,        /* 0x1376 */
    OTHER,        /* 0x1377 */
    OTHER,        /* 0x1378 */
    OTHER,        /* 0x1379 */
    OTHER,        /* 0x137a */
    OTHER,        /* 0x137b */
    OTHER,        /* 0x137c */
    OTHER,        /* 0x137d */
    OTHER,        /* 0x137e */
    OTHER,        /* 0x137f */
    OTHER,        /* 0x1380 */
    OTHER,        /* 0x1381 */
    OTHER,        /* 0x1382 */
    OTHER,        /* 0x1383 */
    OTHER,        /* 0x1384 */
    OTHER,        /* 0x1385 */
    OTHER,        /* 0x1386 */
    OTHER,        /* 0x1387 */
    OTHER,        /* 0x1388 */
    OTHER,        /* 0x1389 */
    OTHER,        /* 0x138a */
    OTHER,        /* 0x138b */
    OTHER,        /* 0x138c */
    OTHER,        /* 0x138d */
    OTHER,        /* 0x138e */
    OTHER,        /* 0x138f */
    OTHER,        /* 0x1390 */
    OTHER,        /* 0x1391 */
    OTHER,        /* 0x1392 */
    OTHER,        /* 0x1393 */
    OTHER,        /* 0x1394 */
    OTHER,        /* 0x1395 */
    OTHER,        /* 0x1396 */
    OTHER,        /* 0x1397 */
    OTHER,        /* 0x1398 */
    OTHER,        /* 0x1399 */
    OTHER,        /* 0x139a */
    OTHER,        /* 0x139b */
    OTHER,        /* 0x139c */
    OTHER,        /* 0x139d */
    OTHER,        /* 0x139e */
    OTHER,        /* 0x139f */
    OTHER,        /* 0x13a0 */
    OTHER,        /* 0x13a1 */
    OTHER,        /* 0x13a2 */
    OTHER,        /* 0x13a3 */
    OTHER,        /* 0x13a4 */
    OTHER,        /* 0x13a5 */
    OTHER,        /* 0x13a6 */
    OTHER,        /* 0x13a7 */
    OTHER,        /* 0x13a8 */
    OTHER,        /* 0x13a9 */
    OTHER,        /* 0x13aa */
    OTHER,        /* 0x13ab */
    OTHER,        /* 0x13ac */
    OTHER,        /* 0x13ad */
    OTHER,        /* 0x13ae */
    OTHER,        /* 0x13af */
    OTHER,        /* 0x13b0 */
    OTHER,        /* 0x13b1 */
    OTHER,        /* 0x13b2 */
    OTHER,        /* 0x13b3 */
    OTHER,        /* 0x13b4 */
    OTHER,        /* 0x13b5 */
    OTHER,        /* 0x13b6 */
    OTHER,        /* 0x13b7 */
    OTHER,        /* 0x13b8 */
    OTHER,        /* 0x13b9 */
    OTHER,        /* 0x13ba */
    OTHER,        /* 0x13bb */
    OTHER,        /* 0x13bc */
    OTHER,        /* 0x13bd */
    OTHER,        /* 0x13be */
    OTHER,        /* 0x13bf */
    OTHER,        /* 0x13c0 */
    OTHER,        /* 0x13c1 */
    OTHER,        /* 0x13c2 */
    OTHER,        /* 0x13c3 */
    OTHER,        /* 0x13c4 */
    OTHER,        /* 0x13c5 */
    OTHER,        /* 0x13c6 */
    OTHER,        /* 0x13c7 */
    OTHER,        /* 0x13c8 */
    OTHER,        /* 0x13c9 */
    OTHER,        /* 0x13ca */
    OTHER,        /* 0x13cb */
    OTHER,        /* 0x13cc */
    OTHER,        /* 0x13cd */
    OTHER,        /* 0x13ce */
    OTHER,        /* 0x13cf */
    OTHER,        /* 0x13d0 */
    OTHER,        /* 0x13d1 */
    OTHER,        /* 0x13d2 */
    OTHER,        /* 0x13d3 */
    OTHER,        /* 0x13d4 */
    OTHER,        /* 0x13d5 */
    OTHER,        /* 0x13d6 */
    OTHER,        /* 0x13d7 */
    OTHER,        /* 0x13d8 */
    OTHER,        /* 0x13d9 */
    OTHER,        /* 0x13da */
    OTHER,        /* 0x13db */
    OTHER,        /* 0x13dc */
    OTHER,        /* 0x13dd */
    OTHER,        /* 0x13de */
    OTHER,        /* 0x13df */
    OTHER,        /* 0x13e0 */
    OTHER,        /* 0x13e1 */
    OTHER,        /* 0x13e2 */
    OTHER,        /* 0x13e3 */
    OTHER,        /* 0x13e4 */
    OTHER,        /* 0x13e5 */
    OTHER,        /* 0x13e6 */
    OTHER,        /* 0x13e7 */
    OTHER,        /* 0x13e8 */
    OTHER,        /* 0x13e9 */
    OTHER,        /* 0x13ea */
    OTHER,        /* 0x13eb */
    OTHER,        /* 0x13ec */
    OTHER,        /* 0x13ed */
    OTHER,        /* 0x13ee */
    OTHER,        /* 0x13ef */
    OTHER,        /* 0x13f0 */
    OTHER,        /* 0x13f1 */
    OTHER,        /* 0x13f2 */
    OTHER,        /* 0x13f3 */
    OTHER,        /* 0x13f4 */
    OTHER,        /* 0x13f5 */
    OTHER,        /* 0x13f6 */
    OTHER,        /* 0x13f7 */
    OTHER,        /* 0x13f8 */
    OTHER,        /* 0x13f9 */
    OTHER,        /* 0x13fa */
    OTHER,        /* 0x13fb */
    OTHER,        /* 0x13fc */
    OTHER,        /* 0x13fd */
    OTHER,        /* 0x13fe */
    OTHER,        /* 0x13ff */
    OTHER,        /* 0x1400 */
    OTHER,        /* 0x1401 */
    OTHER,        /* 0x1402 */
    OTHER,        /* 0x1403 */
    OTHER,        /* 0x1404 */
    OTHER,        /* 0x1405 */
    OTHER,        /* 0x1406 */
    OTHER,        /* 0x1407 */
    OTHER,        /* 0x1408 */
    OTHER,        /* 0x1409 */
    OTHER,        /* 0x140a */
    OTHER,        /* 0x140b */
    OTHER,        /* 0x140c */
    OTHER,        /* 0x140d */
    OTHER,        /* 0x140e */
    OTHER,        /* 0x140f */
    OTHER,        /* 0x1410 */
    OTHER,        /* 0x1411 */
    OTHER,        /* 0x1412 */
    OTHER,        /* 0x1413 */
    OTHER,        /* 0x1414 */
    OTHER,        /* 0x1415 */
    OTHER,        /* 0x1416 */
    OTHER,        /* 0x1417 */
    OTHER,        /* 0x1418 */
    OTHER,        /* 0x1419 */
    OTHER,        /* 0x141a */
    OTHER,        /* 0x141b */
    OTHER,        /* 0x141c */
    OTHER,        /* 0x141d */
    OTHER,        /* 0x141e */
    OTHER,        /* 0x141f */
    OTHER,        /* 0x1420 */
    OTHER,        /* 0x1421 */
    OTHER,        /* 0x1422 */
    OTHER,        /* 0x1423 */
    OTHER,        /* 0x1424 */
    OTHER,        /* 0x1425 */
    OTHER,        /* 0x1426 */
    OTHER,        /* 0x1427 */
    OTHER,        /* 0x1428 */
    OTHER,        /* 0x1429 */
    OTHER,        /* 0x142a */
    OTHER,        /* 0x142b */
    OTHER,        /* 0x142c */
    OTHER,        /* 0x142d */
    OTHER,        /* 0x142e */
    OTHER,        /* 0x142f */
    OTHER,        /* 0x1430 */
    OTHER,        /* 0x1431 */
    OTHER,        /* 0x1432 */
    OTHER,        /* 0x1433 */
    OTHER,        /* 0x1434 */
    OTHER,        /* 0x1435 */
    OTHER,        /* 0x1436 */
    OTHER,        /* 0x1437 */
    OTHER,        /* 0x1438 */
    OTHER,        /* 0x1439 */
    OTHER,        /* 0x143a */
    OTHER,        /* 0x143b */
    OTHER,        /* 0x143c */
    OTHER,        /* 0x143d */
    OTHER,        /* 0x143e */
    OTHER,        /* 0x143f */
    OTHER,        /* 0x1440 */
    OTHER,        /* 0x1441 */
    OTHER,        /* 0x1442 */
    OTHER,        /* 0x1443 */
    OTHER,        /* 0x1444 */
    OTHER,        /* 0x1445 */
    OTHER,        /* 0x1446 */
    OTHER,        /* 0x1447 */
    OTHER,        /* 0x1448 */
    OTHER,        /* 0x1449 */
    OTHER,        /* 0x144a */
    OTHER,        /* 0x144b */
    OTHER,        /* 0x144c */
    OTHER,        /* 0x144d */
    OTHER,        /* 0x144e */
    OTHER,        /* 0x144f */
    OTHER,        /* 0x1450 */
    OTHER,        /* 0x1451 */
    OTHER,        /* 0x1452 */
    OTHER,        /* 0x1453 */
    OTHER,        /* 0x1454 */
    OTHER,        /* 0x1455 */
    OTHER,        /* 0x1456 */
    OTHER,        /* 0x1457 */
    OTHER,        /* 0x1458 */
    OTHER,        /* 0x1459 */
    OTHER,        /* 0x145a */
    OTHER,        /* 0x145b */
    OTHER,        /* 0x145c */
    OTHER,        /* 0x145d */
    OTHER,        /* 0x145e */
    OTHER,        /* 0x145f */
    OTHER,        /* 0x1460 */
    OTHER,        /* 0x1461 */
    OTHER,        /* 0x1462 */
    OTHER,        /* 0x1463 */
    OTHER,        /* 0x1464 */
    OTHER,        /* 0x1465 */
    OTHER,        /* 0x1466 */
    OTHER,        /* 0x1467 */
    OTHER,        /* 0x1468 */
    OTHER,        /* 0x1469 */
    OTHER,        /* 0x146a */
    OTHER,        /* 0x146b */
    OTHER,        /* 0x146c */
    OTHER,        /* 0x146d */
    OTHER,        /* 0x146e */
    OTHER,        /* 0x146f */
    OTHER,        /* 0x1470 */
    OTHER,        /* 0x1471 */
    OTHER,        /* 0x1472 */
    OTHER,        /* 0x1473 */
    OTHER,        /* 0x1474 */
    OTHER,        /* 0x1475 */
    OTHER,        /* 0x1476 */
    OTHER,        /* 0x1477 */
    OTHER,        /* 0x1478 */
    OTHER,        /* 0x1479 */
    OTHER,        /* 0x147a */
    OTHER,        /* 0x147b */
    OTHER,        /* 0x147c */
    OTHER,        /* 0x147d */
    OTHER,        /* 0x147e */
    OTHER,        /* 0x147f */
    OTHER,        /* 0x1480 */
    OTHER,        /* 0x1481 */
    OTHER,        /* 0x1482 */
    OTHER,        /* 0x1483 */
    OTHER,        /* 0x1484 */
    OTHER,        /* 0x1485 */
    OTHER,        /* 0x1486 */
    OTHER,        /* 0x1487 */
    OTHER,        /* 0x1488 */
    OTHER,        /* 0x1489 */
    OTHER,        /* 0x148a */
    OTHER,        /* 0x148b */
    OTHER,        /* 0x148c */
    OTHER,        /* 0x148d */
    OTHER,        /* 0x148e */
    OTHER,        /* 0x148f */
    OTHER,        /* 0x1490 */
    OTHER,        /* 0x1491 */
    OTHER,        /* 0x1492 */
    OTHER,        /* 0x1493 */
    OTHER,        /* 0x1494 */
    OTHER,        /* 0x1495 */
    OTHER,        /* 0x1496 */
    OTHER,        /* 0x1497 */
    OTHER,        /* 0x1498 */
    OTHER,        /* 0x1499 */
    OTHER,        /* 0x149a */
    OTHER,        /* 0x149b */
    OTHER,        /* 0x149c */
    OTHER,        /* 0x149d */
    OTHER,        /* 0x149e */
    OTHER,        /* 0x149f */
    OTHER,        /* 0x14a0 */
    OTHER,        /* 0x14a1 */
    OTHER,        /* 0x14a2 */
    OTHER,        /* 0x14a3 */
    OTHER,        /* 0x14a4 */
    OTHER,        /* 0x14a5 */
    OTHER,        /* 0x14a6 */
    OTHER,        /* 0x14a7 */
    OTHER,        /* 0x14a8 */
    OTHER,        /* 0x14a9 */
    OTHER,        /* 0x14aa */
    OTHER,        /* 0x14ab */
    OTHER,        /* 0x14ac */
    OTHER,        /* 0x14ad */
    OTHER,        /* 0x14ae */
    OTHER,        /* 0x14af */
    OTHER,        /* 0x14b0 */
    OTHER,        /* 0x14b1 */
    OTHER,        /* 0x14b2 */
    OTHER,        /* 0x14b3 */
    OTHER,        /* 0x14b4 */
    OTHER,        /* 0x14b5 */
    OTHER,        /* 0x14b6 */
    OTHER,        /* 0x14b7 */
    OTHER,        /* 0x14b8 */
    OTHER,        /* 0x14b9 */
    OTHER,        /* 0x14ba */
    OTHER,        /* 0x14bb */
    OTHER,        /* 0x14bc */
    OTHER,        /* 0x14bd */
    OTHER,        /* 0x14be */
    OTHER,        /* 0x14bf */
    OTHER,        /* 0x14c0 */
    OTHER,        /* 0x14c1 */
    OTHER,        /* 0x14c2 */
    OTHER,        /* 0x14c3 */
    OTHER,        /* 0x14c4 */
    OTHER,        /* 0x14c5 */
    OTHER,        /* 0x14c6 */
    OTHER,        /* 0x14c7 */
    OTHER,        /* 0x14c8 */
    OTHER,        /* 0x14c9 */
    OTHER,        /* 0x14ca */
    OTHER,        /* 0x14cb */
    OTHER,        /* 0x14cc */
    OTHER,        /* 0x14cd */
    OTHER,        /* 0x14ce */
    OTHER,        /* 0x14cf */
    OTHER,        /* 0x14d0 */
    OTHER,        /* 0x14d1 */
    OTHER,        /* 0x14d2 */
    OTHER,        /* 0x14d3 */
    OTHER,        /* 0x14d4 */
    OTHER,        /* 0x14d5 */
    OTHER,        /* 0x14d6 */
    OTHER,        /* 0x14d7 */
    OTHER,        /* 0x14d8 */
    OTHER,        /* 0x14d9 */
    OTHER,        /* 0x14da */
    OTHER,        /* 0x14db */
    OTHER,        /* 0x14dc */
    OTHER,        /* 0x14dd */
    OTHER,        /* 0x14de */
    OTHER,        /* 0x14df */
    OTHER,        /* 0x14e0 */
    OTHER,        /* 0x14e1 */
    OTHER,        /* 0x14e2 */
    OTHER,        /* 0x14e3 */
    OTHER,        /* 0x14e4 */
    OTHER,        /* 0x14e5 */
    OTHER,        /* 0x14e6 */
    OTHER,        /* 0x14e7 */
    OTHER,        /* 0x14e8 */
    OTHER,        /* 0x14e9 */
    OTHER,        /* 0x14ea */
    OTHER,        /* 0x14eb */
    OTHER,        /* 0x14ec */
    OTHER,        /* 0x14ed */
    OTHER,        /* 0x14ee */
    OTHER,        /* 0x14ef */
    OTHER,        /* 0x14f0 */
    OTHER,        /* 0x14f1 */
    OTHER,        /* 0x14f2 */
    OTHER,        /* 0x14f3 */
    OTHER,        /* 0x14f4 */
    OTHER,        /* 0x14f5 */
    OTHER,        /* 0x14f6 */
    OTHER,        /* 0x14f7 */
    OTHER,        /* 0x14f8 */
    OTHER,        /* 0x14f9 */
    OTHER,        /* 0x14fa */
    OTHER,        /* 0x14fb */
    OTHER,        /* 0x14fc */
    OTHER,        /* 0x14fd */
    OTHER,        /* 0x14fe */
    OTHER,        /* 0x14ff */
    OTHER,        /* 0x1500 */
    OTHER,        /* 0x1501 */
    OTHER,        /* 0x1502 */
    OTHER,        /* 0x1503 */
    OTHER,        /* 0x1504 */
    OTHER,        /* 0x1505 */
    OTHER,        /* 0x1506 */
    OTHER,        /* 0x1507 */
    OTHER,        /* 0x1508 */
    OTHER,        /* 0x1509 */
    OTHER,        /* 0x150a */
    OTHER,        /* 0x150b */
    OTHER,        /* 0x150c */
    OTHER,        /* 0x150d */
    OTHER,        /* 0x150e */
    OTHER,        /* 0x150f */
    OTHER,        /* 0x1510 */
    OTHER,        /* 0x1511 */
    OTHER,        /* 0x1512 */
    OTHER,        /* 0x1513 */
    OTHER,        /* 0x1514 */
    OTHER,        /* 0x1515 */
    OTHER,        /* 0x1516 */
    OTHER,        /* 0x1517 */
    OTHER,        /* 0x1518 */
    OTHER,        /* 0x1519 */
    OTHER,        /* 0x151a */
    OTHER,        /* 0x151b */
    OTHER,        /* 0x151c */
    OTHER,        /* 0x151d */
    OTHER,        /* 0x151e */
    OTHER,        /* 0x151f */
    OTHER,        /* 0x1520 */
    OTHER,        /* 0x1521 */
    OTHER,        /* 0x1522 */
    OTHER,        /* 0x1523 */
    OTHER,        /* 0x1524 */
    OTHER,        /* 0x1525 */
    OTHER,        /* 0x1526 */
    OTHER,        /* 0x1527 */
    OTHER,        /* 0x1528 */
    OTHER,        /* 0x1529 */
    OTHER,        /* 0x152a */
    OTHER,        /* 0x152b */
    OTHER,        /* 0x152c */
    OTHER,        /* 0x152d */
    OTHER,        /* 0x152e */
    OTHER,        /* 0x152f */
    OTHER,        /* 0x1530 */
    OTHER,        /* 0x1531 */
    OTHER,        /* 0x1532 */
    OTHER,        /* 0x1533 */
    OTHER,        /* 0x1534 */
    OTHER,        /* 0x1535 */
    OTHER,        /* 0x1536 */
    OTHER,        /* 0x1537 */
    OTHER,        /* 0x1538 */
    OTHER,        /* 0x1539 */
    OTHER,        /* 0x153a */
    OTHER,        /* 0x153b */
    OTHER,        /* 0x153c */
    OTHER,        /* 0x153d */
    OTHER,        /* 0x153e */
    OTHER,        /* 0x153f */
    OTHER,        /* 0x1540 */
    OTHER,        /* 0x1541 */
    OTHER,        /* 0x1542 */
    OTHER,        /* 0x1543 */
    OTHER,        /* 0x1544 */
    OTHER,        /* 0x1545 */
    OTHER,        /* 0x1546 */
    OTHER,        /* 0x1547 */
    OTHER,        /* 0x1548 */
    OTHER,        /* 0x1549 */
    OTHER,        /* 0x154a */
    OTHER,        /* 0x154b */
    OTHER,        /* 0x154c */
    OTHER,        /* 0x154d */
    OTHER,        /* 0x154e */
    OTHER,        /* 0x154f */
    OTHER,        /* 0x1550 */
    OTHER,        /* 0x1551 */
    OTHER,        /* 0x1552 */
    OTHER,        /* 0x1553 */
    OTHER,        /* 0x1554 */
    OTHER,        /* 0x1555 */
    OTHER,        /* 0x1556 */
    OTHER,        /* 0x1557 */
    OTHER,        /* 0x1558 */
    OTHER,        /* 0x1559 */
    OTHER,        /* 0x155a */
    OTHER,        /* 0x155b */
    OTHER,        /* 0x155c */
    OTHER,        /* 0x155d */
    OTHER,        /* 0x155e */
    OTHER,        /* 0x155f */
    OTHER,        /* 0x1560 */
    OTHER,        /* 0x1561 */
    OTHER,        /* 0x1562 */
    OTHER,        /* 0x1563 */
    OTHER,        /* 0x1564 */
    OTHER,        /* 0x1565 */
    OTHER,        /* 0x1566 */
    OTHER,        /* 0x1567 */
    OTHER,        /* 0x1568 */
    OTHER,        /* 0x1569 */
    OTHER,        /* 0x156a */
    OTHER,        /* 0x156b */
    OTHER,        /* 0x156c */
    OTHER,        /* 0x156d */
    OTHER,        /* 0x156e */
    OTHER,        /* 0x156f */
    OTHER,        /* 0x1570 */
    OTHER,        /* 0x1571 */
    OTHER,        /* 0x1572 */
    OTHER,        /* 0x1573 */
    OTHER,        /* 0x1574 */
    OTHER,        /* 0x1575 */
    OTHER,        /* 0x1576 */
    OTHER,        /* 0x1577 */
    OTHER,        /* 0x1578 */
    OTHER,        /* 0x1579 */
    OTHER,        /* 0x157a */
    OTHER,        /* 0x157b */
    OTHER,        /* 0x157c */
    OTHER,        /* 0x157d */
    OTHER,        /* 0x157e */
    OTHER,        /* 0x157f */
    OTHER,        /* 0x1580 */
    OTHER,        /* 0x1581 */
    OTHER,        /* 0x1582 */
    OTHER,        /* 0x1583 */
    OTHER,        /* 0x1584 */
    OTHER,        /* 0x1585 */
    OTHER,        /* 0x1586 */
    OTHER,        /* 0x1587 */
    OTHER,        /* 0x1588 */
    OTHER,        /* 0x1589 */
    OTHER,        /* 0x158a */
    OTHER,        /* 0x158b */
    OTHER,        /* 0x158c */
    OTHER,        /* 0x158d */
    OTHER,        /* 0x158e */
    OTHER,        /* 0x158f */
    OTHER,        /* 0x1590 */
    OTHER,        /* 0x1591 */
    OTHER,        /* 0x1592 */
    OTHER,        /* 0x1593 */
    OTHER,        /* 0x1594 */
    OTHER,        /* 0x1595 */
    OTHER,        /* 0x1596 */
    OTHER,        /* 0x1597 */
    OTHER,        /* 0x1598 */
    OTHER,        /* 0x1599 */
    OTHER,        /* 0x159a */
    OTHER,        /* 0x159b */
    OTHER,        /* 0x159c */
    OTHER,        /* 0x159d */
    OTHER,        /* 0x159e */
    OTHER,        /* 0x159f */
    OTHER,        /* 0x15a0 */
    OTHER,        /* 0x15a1 */
    OTHER,        /* 0x15a2 */
    OTHER,        /* 0x15a3 */
    OTHER,        /* 0x15a4 */
    OTHER,        /* 0x15a5 */
    OTHER,        /* 0x15a6 */
    OTHER,        /* 0x15a7 */
    OTHER,        /* 0x15a8 */
    OTHER,        /* 0x15a9 */
    OTHER,        /* 0x15aa */
    OTHER,        /* 0x15ab */
    OTHER,        /* 0x15ac */
    OTHER,        /* 0x15ad */
    OTHER,        /* 0x15ae */
    OTHER,        /* 0x15af */
    OTHER,        /* 0x15b0 */
    OTHER,        /* 0x15b1 */
    OTHER,        /* 0x15b2 */
    OTHER,        /* 0x15b3 */
    OTHER,        /* 0x15b4 */
    OTHER,        /* 0x15b5 */
    OTHER,        /* 0x15b6 */
    OTHER,        /* 0x15b7 */
    OTHER,        /* 0x15b8 */
    OTHER,        /* 0x15b9 */
    OTHER,        /* 0x15ba */
    OTHER,        /* 0x15bb */
    OTHER,        /* 0x15bc */
    OTHER,        /* 0x15bd */
    OTHER,        /* 0x15be */
    OTHER,        /* 0x15bf */
    OTHER,        /* 0x15c0 */
    OTHER,        /* 0x15c1 */
    OTHER,        /* 0x15c2 */
    OTHER,        /* 0x15c3 */
    OTHER,        /* 0x15c4 */
    OTHER,        /* 0x15c5 */
    OTHER,        /* 0x15c6 */
    OTHER,        /* 0x15c7 */
    OTHER,        /* 0x15c8 */
    OTHER,        /* 0x15c9 */
    OTHER,        /* 0x15ca */
    OTHER,        /* 0x15cb */
    OTHER,        /* 0x15cc */
    OTHER,        /* 0x15cd */
    OTHER,        /* 0x15ce */
    OTHER,        /* 0x15cf */
    OTHER,        /* 0x15d0 */
    OTHER,        /* 0x15d1 */
    OTHER,        /* 0x15d2 */
    OTHER,        /* 0x15d3 */
    OTHER,        /* 0x15d4 */
    OTHER,        /* 0x15d5 */
    OTHER,        /* 0x15d6 */
    OTHER,        /* 0x15d7 */
    OTHER,        /* 0x15d8 */
    OTHER,        /* 0x15d9 */
    OTHER,        /* 0x15da */
    OTHER,        /* 0x15db */
    OTHER,        /* 0x15dc */
    OTHER,        /* 0x15dd */
    OTHER,        /* 0x15de */
    OTHER,        /* 0x15df */
    OTHER,        /* 0x15e0 */
    OTHER,        /* 0x15e1 */
    OTHER,        /* 0x15e2 */
    OTHER,        /* 0x15e3 */
    OTHER,        /* 0x15e4 */
    OTHER,        /* 0x15e5 */
    OTHER,        /* 0x15e6 */
    OTHER,        /* 0x15e7 */
    OTHER,        /* 0x15e8 */
    OTHER,        /* 0x15e9 */
    OTHER,        /* 0x15ea */
    OTHER,        /* 0x15eb */
    OTHER,        /* 0x15ec */
    OTHER,        /* 0x15ed */
    OTHER,        /* 0x15ee */
    OTHER,        /* 0x15ef */
    OTHER,        /* 0x15f0 */
    OTHER,        /* 0x15f1 */
    OTHER,        /* 0x15f2 */
    OTHER,        /* 0x15f3 */
    OTHER,        /* 0x15f4 */
    OTHER,        /* 0x15f5 */
    OTHER,        /* 0x15f6 */
    OTHER,        /* 0x15f7 */
    OTHER,        /* 0x15f8 */
    OTHER,        /* 0x15f9 */
    OTHER,        /* 0x15fa */
    OTHER,        /* 0x15fb */
    OTHER,        /* 0x15fc */
    OTHER,        /* 0x15fd */
    OTHER,        /* 0x15fe */
    OTHER,        /* 0x15ff */
    OTHER,        /* 0x1600 */
    OTHER,        /* 0x1601 */
    OTHER,        /* 0x1602 */
    OTHER,        /* 0x1603 */
    OTHER,        /* 0x1604 */
    OTHER,        /* 0x1605 */
    OTHER,        /* 0x1606 */
    OTHER,        /* 0x1607 */
    OTHER,        /* 0x1608 */
    OTHER,        /* 0x1609 */
    OTHER,        /* 0x160a */
    OTHER,        /* 0x160b */
    OTHER,        /* 0x160c */
    OTHER,        /* 0x160d */
    OTHER,        /* 0x160e */
    OTHER,        /* 0x160f */
    OTHER,        /* 0x1610 */
    OTHER,        /* 0x1611 */
    OTHER,        /* 0x1612 */
    OTHER,        /* 0x1613 */
    OTHER,        /* 0x1614 */
    OTHER,        /* 0x1615 */
    OTHER,        /* 0x1616 */
    OTHER,        /* 0x1617 */
    OTHER,        /* 0x1618 */
    OTHER,        /* 0x1619 */
    OTHER,        /* 0x161a */
    OTHER,        /* 0x161b */
    OTHER,        /* 0x161c */
    OTHER,        /* 0x161d */
    OTHER,        /* 0x161e */
    OTHER,        /* 0x161f */
    OTHER,        /* 0x1620 */
    OTHER,        /* 0x1621 */
    OTHER,        /* 0x1622 */
    OTHER,        /* 0x1623 */
    OTHER,        /* 0x1624 */
    OTHER,        /* 0x1625 */
    OTHER,        /* 0x1626 */
    OTHER,        /* 0x1627 */
    OTHER,        /* 0x1628 */
    OTHER,        /* 0x1629 */
    OTHER,        /* 0x162a */
    OTHER,        /* 0x162b */
    OTHER,        /* 0x162c */
    OTHER,        /* 0x162d */
    OTHER,        /* 0x162e */
    OTHER,        /* 0x162f */
    OTHER,        /* 0x1630 */
    OTHER,        /* 0x1631 */
    OTHER,        /* 0x1632 */
    OTHER,        /* 0x1633 */
    OTHER,        /* 0x1634 */
    OTHER,        /* 0x1635 */
    OTHER,        /* 0x1636 */
    OTHER,        /* 0x1637 */
    OTHER,        /* 0x1638 */
    OTHER,        /* 0x1639 */
    OTHER,        /* 0x163a */
    OTHER,        /* 0x163b */
    OTHER,        /* 0x163c */
    OTHER,        /* 0x163d */
    OTHER,        /* 0x163e */
    OTHER,        /* 0x163f */
    OTHER,        /* 0x1640 */
    OTHER,        /* 0x1641 */
    OTHER,        /* 0x1642 */
    OTHER,        /* 0x1643 */
    OTHER,        /* 0x1644 */
    OTHER,        /* 0x1645 */
    OTHER,        /* 0x1646 */
    OTHER,        /* 0x1647 */
    OTHER,        /* 0x1648 */
    OTHER,        /* 0x1649 */
    OTHER,        /* 0x164a */
    OTHER,        /* 0x164b */
    OTHER,        /* 0x164c */
    OTHER,        /* 0x164d */
    OTHER,        /* 0x164e */
    OTHER,        /* 0x164f */
    OTHER,        /* 0x1650 */
    OTHER,        /* 0x1651 */
    OTHER,        /* 0x1652 */
    OTHER,        /* 0x1653 */
    OTHER,        /* 0x1654 */
    OTHER,        /* 0x1655 */
    OTHER,        /* 0x1656 */
    OTHER,        /* 0x1657 */
    OTHER,        /* 0x1658 */
    OTHER,        /* 0x1659 */
    OTHER,        /* 0x165a */
    OTHER,        /* 0x165b */
    OTHER,        /* 0x165c */
    OTHER,        /* 0x165d */
    OTHER,        /* 0x165e */
    OTHER,        /* 0x165f */
    OTHER,        /* 0x1660 */
    OTHER,        /* 0x1661 */
    OTHER,        /* 0x1662 */
    OTHER,        /* 0x1663 */
    OTHER,        /* 0x1664 */
    OTHER,        /* 0x1665 */
    OTHER,        /* 0x1666 */
    OTHER,        /* 0x1667 */
    OTHER,        /* 0x1668 */
    OTHER,        /* 0x1669 */
    OTHER,        /* 0x166a */
    OTHER,        /* 0x166b */
    OTHER,        /* 0x166c */
    OTHER,        /* 0x166d */
    OTHER,        /* 0x166e */
    OTHER,        /* 0x166f */
    OTHER,        /* 0x1670 */
    OTHER,        /* 0x1671 */
    OTHER,        /* 0x1672 */
    OTHER,        /* 0x1673 */
    OTHER,        /* 0x1674 */
    OTHER,        /* 0x1675 */
    OTHER,        /* 0x1676 */
    OTHER,        /* 0x1677 */
    OTHER,        /* 0x1678 */
    OTHER,        /* 0x1679 */
    OTHER,        /* 0x167a */
    OTHER,        /* 0x167b */
    OTHER,        /* 0x167c */
    OTHER,        /* 0x167d */
    OTHER,        /* 0x167e */
    OTHER,        /* 0x167f */
    OTHER,        /* 0x1680 */
    OTHER,        /* 0x1681 */
    OTHER,        /* 0x1682 */
    OTHER,        /* 0x1683 */
    OTHER,        /* 0x1684 */
    OTHER,        /* 0x1685 */
    OTHER,        /* 0x1686 */
    OTHER,        /* 0x1687 */
    OTHER,        /* 0x1688 */
    OTHER,        /* 0x1689 */
    OTHER,        /* 0x168a */
    OTHER,        /* 0x168b */
    OTHER,        /* 0x168c */
    OTHER,        /* 0x168d */
    OTHER,        /* 0x168e */
    OTHER,        /* 0x168f */
    OTHER,        /* 0x1690 */
    OTHER,        /* 0x1691 */
    OTHER,        /* 0x1692 */
    OTHER,        /* 0x1693 */
    OTHER,        /* 0x1694 */
    OTHER,        /* 0x1695 */
    OTHER,        /* 0x1696 */
    OTHER,        /* 0x1697 */
    OTHER,        /* 0x1698 */
    OTHER,        /* 0x1699 */
    OTHER,        /* 0x169a */
    OTHER,        /* 0x169b */
    OTHER,        /* 0x169c */
    OTHER,        /* 0x169d */
    OTHER,        /* 0x169e */
    OTHER,        /* 0x169f */
    OTHER,        /* 0x16a0 */
    OTHER,        /* 0x16a1 */
    OTHER,        /* 0x16a2 */
    OTHER,        /* 0x16a3 */
    OTHER,        /* 0x16a4 */
    OTHER,        /* 0x16a5 */
    OTHER,        /* 0x16a6 */
    OTHER,        /* 0x16a7 */
    OTHER,        /* 0x16a8 */
    OTHER,        /* 0x16a9 */
    OTHER,        /* 0x16aa */
    OTHER,        /* 0x16ab */
    OTHER,        /* 0x16ac */
    OTHER,        /* 0x16ad */
    OTHER,        /* 0x16ae */
    OTHER,        /* 0x16af */
    OTHER,        /* 0x16b0 */
    OTHER,        /* 0x16b1 */
    OTHER,        /* 0x16b2 */
    OTHER,        /* 0x16b3 */
    OTHER,        /* 0x16b4 */
    OTHER,        /* 0x16b5 */
    OTHER,        /* 0x16b6 */
    OTHER,        /* 0x16b7 */
    OTHER,        /* 0x16b8 */
    OTHER,        /* 0x16b9 */
    OTHER,        /* 0x16ba */
    OTHER,        /* 0x16bb */
    OTHER,        /* 0x16bc */
    OTHER,        /* 0x16bd */
    OTHER,        /* 0x16be */
    OTHER,        /* 0x16bf */
    OTHER,        /* 0x16c0 */
    OTHER,        /* 0x16c1 */
    OTHER,        /* 0x16c2 */
    OTHER,        /* 0x16c3 */
    OTHER,        /* 0x16c4 */
    OTHER,        /* 0x16c5 */
    OTHER,        /* 0x16c6 */
    OTHER,        /* 0x16c7 */
    OTHER,        /* 0x16c8 */
    OTHER,        /* 0x16c9 */
    OTHER,        /* 0x16ca */
    OTHER,        /* 0x16cb */
    OTHER,        /* 0x16cc */
    OTHER,        /* 0x16cd */
    OTHER,        /* 0x16ce */
    OTHER,        /* 0x16cf */
    OTHER,        /* 0x16d0 */
    OTHER,        /* 0x16d1 */
    OTHER,        /* 0x16d2 */
    OTHER,        /* 0x16d3 */
    OTHER,        /* 0x16d4 */
    OTHER,        /* 0x16d5 */
    OTHER,        /* 0x16d6 */
    OTHER,        /* 0x16d7 */
    OTHER,        /* 0x16d8 */
    OTHER,        /* 0x16d9 */
    OTHER,        /* 0x16da */
    OTHER,        /* 0x16db */
    OTHER,        /* 0x16dc */
    OTHER,        /* 0x16dd */
    OTHER,        /* 0x16de */
    OTHER,        /* 0x16df */
    OTHER,        /* 0x16e0 */
    OTHER,        /* 0x16e1 */
    OTHER,        /* 0x16e2 */
    OTHER,        /* 0x16e3 */
    OTHER,        /* 0x16e4 */
    OTHER,        /* 0x16e5 */
    OTHER,        /* 0x16e6 */
    OTHER,        /* 0x16e7 */
    OTHER,        /* 0x16e8 */
    OTHER,        /* 0x16e9 */
    OTHER,        /* 0x16ea */
    OTHER,        /* 0x16eb */
    OTHER,        /* 0x16ec */
    OTHER,        /* 0x16ed */
    OTHER,        /* 0x16ee */
    OTHER,        /* 0x16ef */
    OTHER,        /* 0x16f0 */
    OTHER,        /* 0x16f1 */
    OTHER,        /* 0x16f2 */
    OTHER,        /* 0x16f3 */
    OTHER,        /* 0x16f4 */
    OTHER,        /* 0x16f5 */
    OTHER,        /* 0x16f6 */
    OTHER,        /* 0x16f7 */
    OTHER,        /* 0x16f8 */
    OTHER,        /* 0x16f9 */
    OTHER,        /* 0x16fa */
    OTHER,        /* 0x16fb */
    OTHER,        /* 0x16fc */
    OTHER,        /* 0x16fd */
    OTHER,        /* 0x16fe */
    OTHER,        /* 0x16ff */
    OTHER,        /* 0x1700 */
    OTHER,        /* 0x1701 */
    OTHER,        /* 0x1702 */
    OTHER,        /* 0x1703 */
    OTHER,        /* 0x1704 */
    OTHER,        /* 0x1705 */
    OTHER,        /* 0x1706 */
    OTHER,        /* 0x1707 */
    OTHER,        /* 0x1708 */
    OTHER,        /* 0x1709 */
    OTHER,        /* 0x170a */
    OTHER,        /* 0x170b */
    OTHER,        /* 0x170c */
    OTHER,        /* 0x170d */
    OTHER,        /* 0x170e */
    OTHER,        /* 0x170f */
    OTHER,        /* 0x1710 */
    OTHER,        /* 0x1711 */
    OTHER,        /* 0x1712 */
    OTHER,        /* 0x1713 */
    OTHER,        /* 0x1714 */
    OTHER,        /* 0x1715 */
    OTHER,        /* 0x1716 */
    OTHER,        /* 0x1717 */
    OTHER,        /* 0x1718 */
    OTHER,        /* 0x1719 */
    OTHER,        /* 0x171a */
    OTHER,        /* 0x171b */
    OTHER,        /* 0x171c */
    OTHER,        /* 0x171d */
    OTHER,        /* 0x171e */
    OTHER,        /* 0x171f */
    OTHER,        /* 0x1720 */
    OTHER,        /* 0x1721 */
    OTHER,        /* 0x1722 */
    OTHER,        /* 0x1723 */
    OTHER,        /* 0x1724 */
    OTHER,        /* 0x1725 */
    OTHER,        /* 0x1726 */
    OTHER,        /* 0x1727 */
    OTHER,        /* 0x1728 */
    OTHER,        /* 0x1729 */
    OTHER,        /* 0x172a */
    OTHER,        /* 0x172b */
    OTHER,        /* 0x172c */
    OTHER,        /* 0x172d */
    OTHER,        /* 0x172e */
    OTHER,        /* 0x172f */
    OTHER,        /* 0x1730 */
    OTHER,        /* 0x1731 */
    OTHER,        /* 0x1732 */
    OTHER,        /* 0x1733 */
    OTHER,        /* 0x1734 */
    OTHER,        /* 0x1735 */
    OTHER,        /* 0x1736 */
    OTHER,        /* 0x1737 */
    OTHER,        /* 0x1738 */
    OTHER,        /* 0x1739 */
    OTHER,        /* 0x173a */
    OTHER,        /* 0x173b */
    OTHER,        /* 0x173c */
    OTHER,        /* 0x173d */
    OTHER,        /* 0x173e */
    OTHER,        /* 0x173f */
    OTHER,        /* 0x1740 */
    OTHER,        /* 0x1741 */
    OTHER,        /* 0x1742 */
    OTHER,        /* 0x1743 */
    OTHER,        /* 0x1744 */
    OTHER,        /* 0x1745 */
    OTHER,        /* 0x1746 */
    OTHER,        /* 0x1747 */
    OTHER,        /* 0x1748 */
    OTHER,        /* 0x1749 */
    OTHER,        /* 0x174a */
    OTHER,        /* 0x174b */
    OTHER,        /* 0x174c */
    OTHER,        /* 0x174d */
    OTHER,        /* 0x174e */
    OTHER,        /* 0x174f */
    OTHER,        /* 0x1750 */
    OTHER,        /* 0x1751 */
    OTHER,        /* 0x1752 */
    OTHER,        /* 0x1753 */
    OTHER,        /* 0x1754 */
    OTHER,        /* 0x1755 */
    OTHER,        /* 0x1756 */
    OTHER,        /* 0x1757 */
    OTHER,        /* 0x1758 */
    OTHER,        /* 0x1759 */
    OTHER,        /* 0x175a */
    OTHER,        /* 0x175b */
    OTHER,        /* 0x175c */
    OTHER,        /* 0x175d */
    OTHER,        /* 0x175e */
    OTHER,        /* 0x175f */
    OTHER,        /* 0x1760 */
    OTHER,        /* 0x1761 */
    OTHER,        /* 0x1762 */
    OTHER,        /* 0x1763 */
    OTHER,        /* 0x1764 */
    OTHER,        /* 0x1765 */
    OTHER,        /* 0x1766 */
    OTHER,        /* 0x1767 */
    OTHER,        /* 0x1768 */
    OTHER,        /* 0x1769 */
    OTHER,        /* 0x176a */
    OTHER,        /* 0x176b */
    OTHER,        /* 0x176c */
    OTHER,        /* 0x176d */
    OTHER,        /* 0x176e */
    OTHER,        /* 0x176f */
    OTHER,        /* 0x1770 */
    OTHER,        /* 0x1771 */
    OTHER,        /* 0x1772 */
    OTHER,        /* 0x1773 */
    OTHER,        /* 0x1774 */
    OTHER,        /* 0x1775 */
    OTHER,        /* 0x1776 */
    OTHER,        /* 0x1777 */
    OTHER,        /* 0x1778 */
    OTHER,        /* 0x1779 */
    OTHER,        /* 0x177a */
    OTHER,        /* 0x177b */
    OTHER,        /* 0x177c */
    OTHER,        /* 0x177d */
    OTHER,        /* 0x177e */
    OTHER,        /* 0x177f */
    OTHER,        /* 0x1780 */
    OTHER,        /* 0x1781 */
    OTHER,        /* 0x1782 */
    OTHER,        /* 0x1783 */
    OTHER,        /* 0x1784 */
    OTHER,        /* 0x1785 */
    OTHER,        /* 0x1786 */
    OTHER,        /* 0x1787 */
    OTHER,        /* 0x1788 */
    OTHER,        /* 0x1789 */
    OTHER,        /* 0x178a */
    OTHER,        /* 0x178b */
    OTHER,        /* 0x178c */
    OTHER,        /* 0x178d */
    OTHER,        /* 0x178e */
    OTHER,        /* 0x178f */
    OTHER,        /* 0x1790 */
    OTHER,        /* 0x1791 */
    OTHER,        /* 0x1792 */
    OTHER,        /* 0x1793 */
    OTHER,        /* 0x1794 */
    OTHER,        /* 0x1795 */
    OTHER,        /* 0x1796 */
    OTHER,        /* 0x1797 */
    OTHER,        /* 0x1798 */
    OTHER,        /* 0x1799 */
    OTHER,        /* 0x179a */
    OTHER,        /* 0x179b */
    OTHER,        /* 0x179c */
    OTHER,        /* 0x179d */
    OTHER,        /* 0x179e */
    OTHER,        /* 0x179f */
    OTHER,        /* 0x17a0 */
    OTHER,        /* 0x17a1 */
    OTHER,        /* 0x17a2 */
    OTHER,        /* 0x17a3 */
    OTHER,        /* 0x17a4 */
    OTHER,        /* 0x17a5 */
    OTHER,        /* 0x17a6 */
    OTHER,        /* 0x17a7 */
    OTHER,        /* 0x17a8 */
    OTHER,        /* 0x17a9 */
    OTHER,        /* 0x17aa */
    OTHER,        /* 0x17ab */
    OTHER,        /* 0x17ac */
    OTHER,        /* 0x17ad */
    OTHER,        /* 0x17ae */
    OTHER,        /* 0x17af */
    OTHER,        /* 0x17b0 */
    OTHER,        /* 0x17b1 */
    OTHER,        /* 0x17b2 */
    OTHER,        /* 0x17b3 */
    OTHER,        /* 0x17b4 */
    OTHER,        /* 0x17b5 */
    OTHER,        /* 0x17b6 */
    OTHER,        /* 0x17b7 */
    OTHER,        /* 0x17b8 */
    OTHER,        /* 0x17b9 */
    OTHER,        /* 0x17ba */
    OTHER,        /* 0x17bb */
    OTHER,        /* 0x17bc */
    OTHER,        /* 0x17bd */
    OTHER,        /* 0x17be */
    OTHER,        /* 0x17bf */
    OTHER,        /* 0x17c0 */
    OTHER,        /* 0x17c1 */
    OTHER,        /* 0x17c2 */
    OTHER,        /* 0x17c3 */
    OTHER,        /* 0x17c4 */
    OTHER,        /* 0x17c5 */
    OTHER,        /* 0x17c6 */
    OTHER,        /* 0x17c7 */
    OTHER,        /* 0x17c8 */
    OTHER,        /* 0x17c9 */
    OTHER,        /* 0x17ca */
    OTHER,        /* 0x17cb */
    OTHER,        /* 0x17cc */
    OTHER,        /* 0x17cd */
    OTHER,        /* 0x17ce */
    OTHER,        /* 0x17cf */
    OTHER,        /* 0x17d0 */
    OTHER,        /* 0x17d1 */
    OTHER,        /* 0x17d2 */
    OTHER,        /* 0x17d3 */
    OTHER,        /* 0x17d4 */
    OTHER,        /* 0x17d5 */
    OTHER,        /* 0x17d6 */
    OTHER,        /* 0x17d7 */
    OTHER,        /* 0x17d8 */
    OTHER,        /* 0x17d9 */
    OTHER,        /* 0x17da */
    OTHER,        /* 0x17db */
    OTHER,        /* 0x17dc */
    OTHER,        /* 0x17dd */
    OTHER,        /* 0x17de */
    OTHER,        /* 0x17df */
    OTHER,        /* 0x17e0 */
    OTHER,        /* 0x17e1 */
    OTHER,        /* 0x17e2 */
    OTHER,        /* 0x17e3 */
    OTHER,        /* 0x17e4 */
    OTHER,        /* 0x17e5 */
    OTHER,        /* 0x17e6 */
    OTHER,        /* 0x17e7 */
    OTHER,        /* 0x17e8 */
    OTHER,        /* 0x17e9 */
    OTHER,        /* 0x17ea */
    OTHER,        /* 0x17eb */
    OTHER,        /* 0x17ec */
    OTHER,        /* 0x17ed */
    OTHER,        /* 0x17ee */
    OTHER,        /* 0x17ef */
    OTHER,        /* 0x17f0 */
    OTHER,        /* 0x17f1 */
    OTHER,        /* 0x17f2 */
    OTHER,        /* 0x17f3 */
    OTHER,        /* 0x17f4 */
    OTHER,        /* 0x17f5 */
    OTHER,        /* 0x17f6 */
    OTHER,        /* 0x17f7 */
    OTHER,        /* 0x17f8 */
    OTHER,        /* 0x17f9 */
    OTHER,        /* 0x17fa */
    OTHER,        /* 0x17fb */
    OTHER,        /* 0x17fc */
    OTHER,        /* 0x17fd */
    OTHER,        /* 0x17fe */
    OTHER,        /* 0x17ff */
    OTHER,        /* 0x1800 */
    OTHER,        /* 0x1801 */
    OTHER,        /* 0x1802 */
    OTHER,        /* 0x1803 */
    OTHER,        /* 0x1804 */
    OTHER,        /* 0x1805 */
    OTHER,        /* 0x1806 */
    OTHER,        /* 0x1807 */
    OTHER,        /* 0x1808 */
    OTHER,        /* 0x1809 */
    OTHER,        /* 0x180a */
    OTHER,        /* 0x180b */
    OTHER,        /* 0x180c */
    OTHER,        /* 0x180d */
    OTHER,        /* 0x180e */
    OTHER,        /* 0x180f */
    OTHER,        /* 0x1810 */
    OTHER,        /* 0x1811 */
    OTHER,        /* 0x1812 */
    OTHER,        /* 0x1813 */
    OTHER,        /* 0x1814 */
    OTHER,        /* 0x1815 */
    OTHER,        /* 0x1816 */
    OTHER,        /* 0x1817 */
    OTHER,        /* 0x1818 */
    OTHER,        /* 0x1819 */
    OTHER,        /* 0x181a */
    OTHER,        /* 0x181b */
    OTHER,        /* 0x181c */
    OTHER,        /* 0x181d */
    OTHER,        /* 0x181e */
    OTHER,        /* 0x181f */
    OTHER,        /* 0x1820 */
    OTHER,        /* 0x1821 */
    OTHER,        /* 0x1822 */
    OTHER,        /* 0x1823 */
    OTHER,        /* 0x1824 */
    OTHER,        /* 0x1825 */
    OTHER,        /* 0x1826 */
    OTHER,        /* 0x1827 */
    OTHER,        /* 0x1828 */
    OTHER,        /* 0x1829 */
    OTHER,        /* 0x182a */
    OTHER,        /* 0x182b */
    OTHER,        /* 0x182c */
    OTHER,        /* 0x182d */
    OTHER,        /* 0x182e */
    OTHER,        /* 0x182f */
    OTHER,        /* 0x1830 */
    OTHER,        /* 0x1831 */
    OTHER,        /* 0x1832 */
    OTHER,        /* 0x1833 */
    OTHER,        /* 0x1834 */
    OTHER,        /* 0x1835 */
    OTHER,        /* 0x1836 */
    OTHER,        /* 0x1837 */
    OTHER,        /* 0x1838 */
    OTHER,        /* 0x1839 */
    OTHER,        /* 0x183a */
    OTHER,        /* 0x183b */
    OTHER,        /* 0x183c */
    OTHER,        /* 0x183d */
    OTHER,        /* 0x183e */
    OTHER,        /* 0x183f */
    OTHER,        /* 0x1840 */
    OTHER,        /* 0x1841 */
    OTHER,        /* 0x1842 */
    OTHER,        /* 0x1843 */
    OTHER,        /* 0x1844 */
    OTHER,        /* 0x1845 */
    OTHER,        /* 0x1846 */
    OTHER,        /* 0x1847 */
    OTHER,        /* 0x1848 */
    OTHER,        /* 0x1849 */
    OTHER,        /* 0x184a */
    OTHER,        /* 0x184b */
    OTHER,        /* 0x184c */
    OTHER,        /* 0x184d */
    OTHER,        /* 0x184e */
    OTHER,        /* 0x184f */
    OTHER,        /* 0x1850 */
    OTHER,        /* 0x1851 */
    OTHER,        /* 0x1852 */
    OTHER,        /* 0x1853 */
    OTHER,        /* 0x1854 */
    OTHER,        /* 0x1855 */
    OTHER,        /* 0x1856 */
    OTHER,        /* 0x1857 */
    OTHER,        /* 0x1858 */
    OTHER,        /* 0x1859 */
    OTHER,        /* 0x185a */
    OTHER,        /* 0x185b */
    OTHER,        /* 0x185c */
    OTHER,        /* 0x185d */
    OTHER,        /* 0x185e */
    OTHER,        /* 0x185f */
    OTHER,        /* 0x1860 */
    OTHER,        /* 0x1861 */
    OTHER,        /* 0x1862 */
    OTHER,        /* 0x1863 */
    OTHER,        /* 0x1864 */
    OTHER,        /* 0x1865 */
    OTHER,        /* 0x1866 */
    OTHER,        /* 0x1867 */
    OTHER,        /* 0x1868 */
    OTHER,        /* 0x1869 */
    OTHER,        /* 0x186a */
    OTHER,        /* 0x186b */
    OTHER,        /* 0x186c */
    OTHER,        /* 0x186d */
    OTHER,        /* 0x186e */
    OTHER,        /* 0x186f */
    OTHER,        /* 0x1870 */
    OTHER,        /* 0x1871 */
    OTHER,        /* 0x1872 */
    OTHER,        /* 0x1873 */
    OTHER,        /* 0x1874 */
    OTHER,        /* 0x1875 */
    OTHER,        /* 0x1876 */
    OTHER,        /* 0x1877 */
    OTHER,        /* 0x1878 */
    OTHER,        /* 0x1879 */
    OTHER,        /* 0x187a */
    OTHER,        /* 0x187b */
    OTHER,        /* 0x187c */
    OTHER,        /* 0x187d */
    OTHER,        /* 0x187e */
    OTHER,        /* 0x187f */
    OTHER,        /* 0x1880 */
    OTHER,        /* 0x1881 */
    OTHER,        /* 0x1882 */
    OTHER,        /* 0x1883 */
    OTHER,        /* 0x1884 */
    OTHER,        /* 0x1885 */
    OTHER,        /* 0x1886 */
    OTHER,        /* 0x1887 */
    OTHER,        /* 0x1888 */
    OTHER,        /* 0x1889 */
    OTHER,        /* 0x188a */
    OTHER,        /* 0x188b */
    OTHER,        /* 0x188c */
    OTHER,        /* 0x188d */
    OTHER,        /* 0x188e */
    OTHER,        /* 0x188f */
    OTHER,        /* 0x1890 */
    OTHER,        /* 0x1891 */
    OTHER,        /* 0x1892 */
    OTHER,        /* 0x1893 */
    OTHER,        /* 0x1894 */
    OTHER,        /* 0x1895 */
    OTHER,        /* 0x1896 */
    OTHER,        /* 0x1897 */
    OTHER,        /* 0x1898 */
    OTHER,        /* 0x1899 */
    OTHER,        /* 0x189a */
    OTHER,        /* 0x189b */
    OTHER,        /* 0x189c */
    OTHER,        /* 0x189d */
    OTHER,        /* 0x189e */
    OTHER,        /* 0x189f */
    OTHER,        /* 0x18a0 */
    OTHER,        /* 0x18a1 */
    OTHER,        /* 0x18a2 */
    OTHER,        /* 0x18a3 */
    OTHER,        /* 0x18a4 */
    OTHER,        /* 0x18a5 */
    OTHER,        /* 0x18a6 */
    OTHER,        /* 0x18a7 */
    OTHER,        /* 0x18a8 */
    OTHER,        /* 0x18a9 */
    OTHER,        /* 0x18aa */
    OTHER,        /* 0x18ab */
    OTHER,        /* 0x18ac */
    OTHER,        /* 0x18ad */
    OTHER,        /* 0x18ae */
    OTHER,        /* 0x18af */
    OTHER,        /* 0x18b0 */
    OTHER,        /* 0x18b1 */
    OTHER,        /* 0x18b2 */
    OTHER,        /* 0x18b3 */
    OTHER,        /* 0x18b4 */
    OTHER,        /* 0x18b5 */
    OTHER,        /* 0x18b6 */
    OTHER,        /* 0x18b7 */
    OTHER,        /* 0x18b8 */
    OTHER,        /* 0x18b9 */
    OTHER,        /* 0x18ba */
    OTHER,        /* 0x18bb */
    OTHER,        /* 0x18bc */
    OTHER,        /* 0x18bd */
    OTHER,        /* 0x18be */
    OTHER,        /* 0x18bf */
    OTHER,        /* 0x18c0 */
    OTHER,        /* 0x18c1 */
    OTHER,        /* 0x18c2 */
    OTHER,        /* 0x18c3 */
    OTHER,        /* 0x18c4 */
    OTHER,        /* 0x18c5 */
    OTHER,        /* 0x18c6 */
    OTHER,        /* 0x18c7 */
    OTHER,        /* 0x18c8 */
    OTHER,        /* 0x18c9 */
    OTHER,        /* 0x18ca */
    OTHER,        /* 0x18cb */
    OTHER,        /* 0x18cc */
    OTHER,        /* 0x18cd */
    OTHER,        /* 0x18ce */
    OTHER,        /* 0x18cf */
    OTHER,        /* 0x18d0 */
    OTHER,        /* 0x18d1 */
    OTHER,        /* 0x18d2 */
    OTHER,        /* 0x18d3 */
    OTHER,        /* 0x18d4 */
    OTHER,        /* 0x18d5 */
    OTHER,        /* 0x18d6 */
    OTHER,        /* 0x18d7 */
    OTHER,        /* 0x18d8 */
    OTHER,        /* 0x18d9 */
    OTHER,        /* 0x18da */
    OTHER,        /* 0x18db */
    OTHER,        /* 0x18dc */
    OTHER,        /* 0x18dd */
    OTHER,        /* 0x18de */
    OTHER,        /* 0x18df */
    OTHER,        /* 0x18e0 */
    OTHER,        /* 0x18e1 */
    OTHER,        /* 0x18e2 */
    OTHER,        /* 0x18e3 */
    OTHER,        /* 0x18e4 */
    OTHER,        /* 0x18e5 */
    OTHER,        /* 0x18e6 */
    OTHER,        /* 0x18e7 */
    OTHER,        /* 0x18e8 */
    OTHER,        /* 0x18e9 */
    OTHER,        /* 0x18ea */
    OTHER,        /* 0x18eb */
    OTHER,        /* 0x18ec */
    OTHER,        /* 0x18ed */
    OTHER,        /* 0x18ee */
    OTHER,        /* 0x18ef */
    OTHER,        /* 0x18f0 */
    OTHER,        /* 0x18f1 */
    OTHER,        /* 0x18f2 */
    OTHER,        /* 0x18f3 */
    OTHER,        /* 0x18f4 */
    OTHER,        /* 0x18f5 */
    OTHER,        /* 0x18f6 */
    OTHER,        /* 0x18f7 */
    OTHER,        /* 0x18f8 */
    OTHER,        /* 0x18f9 */
    OTHER,        /* 0x18fa */
    OTHER,        /* 0x18fb */
    OTHER,        /* 0x18fc */
    OTHER,        /* 0x18fd */
    OTHER,        /* 0x18fe */
    OTHER,        /* 0x18ff */
    OTHER,        /* 0x1900 */
    OTHER,        /* 0x1901 */
    OTHER,        /* 0x1902 */
    OTHER,        /* 0x1903 */
    OTHER,        /* 0x1904 */
    OTHER,        /* 0x1905 */
    OTHER,        /* 0x1906 */
    OTHER,        /* 0x1907 */
    OTHER,        /* 0x1908 */
    OTHER,        /* 0x1909 */
    OTHER,        /* 0x190a */
    OTHER,        /* 0x190b */
    OTHER,        /* 0x190c */
    OTHER,        /* 0x190d */
    OTHER,        /* 0x190e */
    OTHER,        /* 0x190f */
    OTHER,        /* 0x1910 */
    OTHER,        /* 0x1911 */
    OTHER,        /* 0x1912 */
    OTHER,        /* 0x1913 */
    OTHER,        /* 0x1914 */
    OTHER,        /* 0x1915 */
    OTHER,        /* 0x1916 */
    OTHER,        /* 0x1917 */
    OTHER,        /* 0x1918 */
    OTHER,        /* 0x1919 */
    OTHER,        /* 0x191a */
    OTHER,        /* 0x191b */
    OTHER,        /* 0x191c */
    OTHER,        /* 0x191d */
    OTHER,        /* 0x191e */
    OTHER,        /* 0x191f */
    OTHER,        /* 0x1920 */
    OTHER,        /* 0x1921 */
    OTHER,        /* 0x1922 */
    OTHER,        /* 0x1923 */
    OTHER,        /* 0x1924 */
    OTHER,        /* 0x1925 */
    OTHER,        /* 0x1926 */
    OTHER,        /* 0x1927 */
    OTHER,        /* 0x1928 */
    OTHER,        /* 0x1929 */
    OTHER,        /* 0x192a */
    OTHER,        /* 0x192b */
    OTHER,        /* 0x192c */
    OTHER,        /* 0x192d */
    OTHER,        /* 0x192e */
    OTHER,        /* 0x192f */
    OTHER,        /* 0x1930 */
    OTHER,        /* 0x1931 */
    OTHER,        /* 0x1932 */
    OTHER,        /* 0x1933 */
    OTHER,        /* 0x1934 */
    OTHER,        /* 0x1935 */
    OTHER,        /* 0x1936 */
    OTHER,        /* 0x1937 */
    OTHER,        /* 0x1938 */
    OTHER,        /* 0x1939 */
    OTHER,        /* 0x193a */
    OTHER,        /* 0x193b */
    OTHER,        /* 0x193c */
    OTHER,        /* 0x193d */
    OTHER,        /* 0x193e */
    OTHER,        /* 0x193f */
    OTHER,        /* 0x1940 */
    OTHER,        /* 0x1941 */
    OTHER,        /* 0x1942 */
    OTHER,        /* 0x1943 */
    OTHER,        /* 0x1944 */
    OTHER,        /* 0x1945 */
    OTHER,        /* 0x1946 */
    OTHER,        /* 0x1947 */
    OTHER,        /* 0x1948 */
    OTHER,        /* 0x1949 */
    OTHER,        /* 0x194a */
    OTHER,        /* 0x194b */
    OTHER,        /* 0x194c */
    OTHER,        /* 0x194d */
    OTHER,        /* 0x194e */
    OTHER,        /* 0x194f */
    OTHER,        /* 0x1950 */
    OTHER,        /* 0x1951 */
    OTHER,        /* 0x1952 */
    OTHER,        /* 0x1953 */
    OTHER,        /* 0x1954 */
    OTHER,        /* 0x1955 */
    OTHER,        /* 0x1956 */
    OTHER,        /* 0x1957 */
    OTHER,        /* 0x1958 */
    OTHER,        /* 0x1959 */
    OTHER,        /* 0x195a */
    OTHER,        /* 0x195b */
    OTHER,        /* 0x195c */
    OTHER,        /* 0x195d */
    OTHER,        /* 0x195e */
    OTHER,        /* 0x195f */
    OTHER,        /* 0x1960 */
    OTHER,        /* 0x1961 */
    OTHER,        /* 0x1962 */
    OTHER,        /* 0x1963 */
    OTHER,        /* 0x1964 */
    OTHER,        /* 0x1965 */
    OTHER,        /* 0x1966 */
    OTHER,        /* 0x1967 */
    OTHER,        /* 0x1968 */
    OTHER,        /* 0x1969 */
    OTHER,        /* 0x196a */
    OTHER,        /* 0x196b */
    OTHER,        /* 0x196c */
    OTHER,        /* 0x196d */
    OTHER,        /* 0x196e */
    OTHER,        /* 0x196f */
    OTHER,        /* 0x1970 */
    OTHER,        /* 0x1971 */
    OTHER,        /* 0x1972 */
    OTHER,        /* 0x1973 */
    OTHER,        /* 0x1974 */
    OTHER,        /* 0x1975 */
    OTHER,        /* 0x1976 */
    OTHER,        /* 0x1977 */
    OTHER,        /* 0x1978 */
    OTHER,        /* 0x1979 */
    OTHER,        /* 0x197a */
    OTHER,        /* 0x197b */
    OTHER,        /* 0x197c */
    OTHER,        /* 0x197d */
    OTHER,        /* 0x197e */
    OTHER,        /* 0x197f */
    OTHER,        /* 0x1980 */
    OTHER,        /* 0x1981 */
    OTHER,        /* 0x1982 */
    OTHER,        /* 0x1983 */
    OTHER,        /* 0x1984 */
    OTHER,        /* 0x1985 */
    OTHER,        /* 0x1986 */
    OTHER,        /* 0x1987 */
    OTHER,        /* 0x1988 */
    OTHER,        /* 0x1989 */
    OTHER,        /* 0x198a */
    OTHER,        /* 0x198b */
    OTHER,        /* 0x198c */
    OTHER,        /* 0x198d */
    OTHER,        /* 0x198e */
    OTHER,        /* 0x198f */
    OTHER,        /* 0x1990 */
    OTHER,        /* 0x1991 */
    OTHER,        /* 0x1992 */
    OTHER,        /* 0x1993 */
    OTHER,        /* 0x1994 */
    OTHER,        /* 0x1995 */
    OTHER,        /* 0x1996 */
    OTHER,        /* 0x1997 */
    OTHER,        /* 0x1998 */
    OTHER,        /* 0x1999 */
    OTHER,        /* 0x199a */
    OTHER,        /* 0x199b */
    OTHER,        /* 0x199c */
    OTHER,        /* 0x199d */
    OTHER,        /* 0x199e */
    OTHER,        /* 0x199f */
    OTHER,        /* 0x19a0 */
    OTHER,        /* 0x19a1 */
    OTHER,        /* 0x19a2 */
    OTHER,        /* 0x19a3 */
    OTHER,        /* 0x19a4 */
    OTHER,        /* 0x19a5 */
    OTHER,        /* 0x19a6 */
    OTHER,        /* 0x19a7 */
    OTHER,        /* 0x19a8 */
    OTHER,        /* 0x19a9 */
    OTHER,        /* 0x19aa */
    OTHER,        /* 0x19ab */
    OTHER,        /* 0x19ac */
    OTHER,        /* 0x19ad */
    OTHER,        /* 0x19ae */
    OTHER,        /* 0x19af */
    OTHER,        /* 0x19b0 */
    OTHER,        /* 0x19b1 */
    OTHER,        /* 0x19b2 */
    OTHER,        /* 0x19b3 */
    OTHER,        /* 0x19b4 */
    OTHER,        /* 0x19b5 */
    OTHER,        /* 0x19b6 */
    OTHER,        /* 0x19b7 */
    OTHER,        /* 0x19b8 */
    OTHER,        /* 0x19b9 */
    OTHER,        /* 0x19ba */
    OTHER,        /* 0x19bb */
    OTHER,        /* 0x19bc */
    OTHER,        /* 0x19bd */
    OTHER,        /* 0x19be */
    OTHER,        /* 0x19bf */
    OTHER,        /* 0x19c0 */
    OTHER,        /* 0x19c1 */
    OTHER,        /* 0x19c2 */
    OTHER,        /* 0x19c3 */
    OTHER,        /* 0x19c4 */
    OTHER,        /* 0x19c5 */
    OTHER,        /* 0x19c6 */
    OTHER,        /* 0x19c7 */
    OTHER,        /* 0x19c8 */
    OTHER,        /* 0x19c9 */
    OTHER,        /* 0x19ca */
    OTHER,        /* 0x19cb */
    OTHER,        /* 0x19cc */
    OTHER,        /* 0x19cd */
    OTHER,        /* 0x19ce */
    OTHER,        /* 0x19cf */
    OTHER,        /* 0x19d0 */
    OTHER,        /* 0x19d1 */
    OTHER,        /* 0x19d2 */
    OTHER,        /* 0x19d3 */
    OTHER,        /* 0x19d4 */
    OTHER,        /* 0x19d5 */
    OTHER,        /* 0x19d6 */
    OTHER,        /* 0x19d7 */
    OTHER,        /* 0x19d8 */
    OTHER,        /* 0x19d9 */
    OTHER,        /* 0x19da */
    OTHER,        /* 0x19db */
    OTHER,        /* 0x19dc */
    OTHER,        /* 0x19dd */
    OTHER,        /* 0x19de */
    OTHER,        /* 0x19df */
    OTHER,        /* 0x19e0 */
    OTHER,        /* 0x19e1 */
    OTHER,        /* 0x19e2 */
    OTHER,        /* 0x19e3 */
    OTHER,        /* 0x19e4 */
    OTHER,        /* 0x19e5 */
    OTHER,        /* 0x19e6 */
    OTHER,        /* 0x19e7 */
    OTHER,        /* 0x19e8 */
    OTHER,        /* 0x19e9 */
    OTHER,        /* 0x19ea */
    OTHER,        /* 0x19eb */
    OTHER,        /* 0x19ec */
    OTHER,        /* 0x19ed */
    OTHER,        /* 0x19ee */
    OTHER,        /* 0x19ef */
    OTHER,        /* 0x19f0 */
    OTHER,        /* 0x19f1 */
    OTHER,        /* 0x19f2 */
    OTHER,        /* 0x19f3 */
    OTHER,        /* 0x19f4 */
    OTHER,        /* 0x19f5 */
    OTHER,        /* 0x19f6 */
    OTHER,        /* 0x19f7 */
    OTHER,        /* 0x19f8 */
    OTHER,        /* 0x19f9 */
    OTHER,        /* 0x19fa */
    OTHER,        /* 0x19fb */
    OTHER,        /* 0x19fc */
    OTHER,        /* 0x19fd */
    OTHER,        /* 0x19fe */
    OTHER,        /* 0x19ff */
    OTHER,        /* 0x1a00 */
    OTHER,        /* 0x1a01 */
    OTHER,        /* 0x1a02 */
    OTHER,        /* 0x1a03 */
    OTHER,        /* 0x1a04 */
    OTHER,        /* 0x1a05 */
    OTHER,        /* 0x1a06 */
    OTHER,        /* 0x1a07 */
    OTHER,        /* 0x1a08 */
    OTHER,        /* 0x1a09 */
    OTHER,        /* 0x1a0a */
    OTHER,        /* 0x1a0b */
    OTHER,        /* 0x1a0c */
    OTHER,        /* 0x1a0d */
    OTHER,        /* 0x1a0e */
    OTHER,        /* 0x1a0f */
    OTHER,        /* 0x1a10 */
    OTHER,        /* 0x1a11 */
    OTHER,        /* 0x1a12 */
    OTHER,        /* 0x1a13 */
    OTHER,        /* 0x1a14 */
    OTHER,        /* 0x1a15 */
    OTHER,        /* 0x1a16 */
    OTHER,        /* 0x1a17 */
    OTHER,        /* 0x1a18 */
    OTHER,        /* 0x1a19 */
    OTHER,        /* 0x1a1a */
    OTHER,        /* 0x1a1b */
    OTHER,        /* 0x1a1c */
    OTHER,        /* 0x1a1d */
    OTHER,        /* 0x1a1e */
    OTHER,        /* 0x1a1f */
    OTHER,        /* 0x1a20 */
    OTHER,        /* 0x1a21 */
    OTHER,        /* 0x1a22 */
    OTHER,        /* 0x1a23 */
    OTHER,        /* 0x1a24 */
    OTHER,        /* 0x1a25 */
    OTHER,        /* 0x1a26 */
    OTHER,        /* 0x1a27 */
    OTHER,        /* 0x1a28 */
    OTHER,        /* 0x1a29 */
    OTHER,        /* 0x1a2a */
    OTHER,        /* 0x1a2b */
    OTHER,        /* 0x1a2c */
    OTHER,        /* 0x1a2d */
    OTHER,        /* 0x1a2e */
    OTHER,        /* 0x1a2f */
    OTHER,        /* 0x1a30 */
    OTHER,        /* 0x1a31 */
    OTHER,        /* 0x1a32 */
    OTHER,        /* 0x1a33 */
    OTHER,        /* 0x1a34 */
    OTHER,        /* 0x1a35 */
    OTHER,        /* 0x1a36 */
    OTHER,        /* 0x1a37 */
    OTHER,        /* 0x1a38 */
    OTHER,        /* 0x1a39 */
    OTHER,        /* 0x1a3a */
    OTHER,        /* 0x1a3b */
    OTHER,        /* 0x1a3c */
    OTHER,        /* 0x1a3d */
    OTHER,        /* 0x1a3e */
    OTHER,        /* 0x1a3f */
    OTHER,        /* 0x1a40 */
    OTHER,        /* 0x1a41 */
    OTHER,        /* 0x1a42 */
    OTHER,        /* 0x1a43 */
    OTHER,        /* 0x1a44 */
    OTHER,        /* 0x1a45 */
    OTHER,        /* 0x1a46 */
    OTHER,        /* 0x1a47 */
    OTHER,        /* 0x1a48 */
    OTHER,        /* 0x1a49 */
    OTHER,        /* 0x1a4a */
    OTHER,        /* 0x1a4b */
    OTHER,        /* 0x1a4c */
    OTHER,        /* 0x1a4d */
    OTHER,        /* 0x1a4e */
    OTHER,        /* 0x1a4f */
    OTHER,        /* 0x1a50 */
    OTHER,        /* 0x1a51 */
    OTHER,        /* 0x1a52 */
    OTHER,        /* 0x1a53 */
    OTHER,        /* 0x1a54 */
    OTHER,        /* 0x1a55 */
    OTHER,        /* 0x1a56 */
    OTHER,        /* 0x1a57 */
    OTHER,        /* 0x1a58 */
    OTHER,        /* 0x1a59 */
    OTHER,        /* 0x1a5a */
    OTHER,        /* 0x1a5b */
    OTHER,        /* 0x1a5c */
    OTHER,        /* 0x1a5d */
    OTHER,        /* 0x1a5e */
    OTHER,        /* 0x1a5f */
    OTHER,        /* 0x1a60 */
    OTHER,        /* 0x1a61 */
    OTHER,        /* 0x1a62 */
    OTHER,        /* 0x1a63 */
    OTHER,        /* 0x1a64 */
    OTHER,        /* 0x1a65 */
    OTHER,        /* 0x1a66 */
    OTHER,        /* 0x1a67 */
    OTHER,        /* 0x1a68 */
    OTHER,        /* 0x1a69 */
    OTHER,        /* 0x1a6a */
    OTHER,        /* 0x1a6b */
    OTHER,        /* 0x1a6c */
    OTHER,        /* 0x1a6d */
    OTHER,        /* 0x1a6e */
    OTHER,        /* 0x1a6f */
    OTHER,        /* 0x1a70 */
    OTHER,        /* 0x1a71 */
    OTHER,        /* 0x1a72 */
    OTHER,        /* 0x1a73 */
    OTHER,        /* 0x1a74 */
    OTHER,        /* 0x1a75 */
    OTHER,        /* 0x1a76 */
    OTHER,        /* 0x1a77 */
    OTHER,        /* 0x1a78 */
    OTHER,        /* 0x1a79 */
    OTHER,        /* 0x1a7a */
    OTHER,        /* 0x1a7b */
    OTHER,        /* 0x1a7c */
    OTHER,        /* 0x1a7d */
    OTHER,        /* 0x1a7e */
    OTHER,        /* 0x1a7f */
    OTHER,        /* 0x1a80 */
    OTHER,        /* 0x1a81 */
    OTHER,        /* 0x1a82 */
    OTHER,        /* 0x1a83 */
    OTHER,        /* 0x1a84 */
    OTHER,        /* 0x1a85 */
    OTHER,        /* 0x1a86 */
    OTHER,        /* 0x1a87 */
    OTHER,        /* 0x1a88 */
    OTHER,        /* 0x1a89 */
    OTHER,        /* 0x1a8a */
    OTHER,        /* 0x1a8b */
    OTHER,        /* 0x1a8c */
    OTHER,        /* 0x1a8d */
    OTHER,        /* 0x1a8e */
    OTHER,        /* 0x1a8f */
    OTHER,        /* 0x1a90 */
    OTHER,        /* 0x1a91 */
    OTHER,        /* 0x1a92 */
    OTHER,        /* 0x1a93 */
    OTHER,        /* 0x1a94 */
    OTHER,        /* 0x1a95 */
    OTHER,        /* 0x1a96 */
    OTHER,        /* 0x1a97 */
    OTHER,        /* 0x1a98 */
    OTHER,        /* 0x1a99 */
    OTHER,        /* 0x1a9a */
    OTHER,        /* 0x1a9b */
    OTHER,        /* 0x1a9c */
    OTHER,        /* 0x1a9d */
    OTHER,        /* 0x1a9e */
    OTHER,        /* 0x1a9f */
    OTHER,        /* 0x1aa0 */
    OTHER,        /* 0x1aa1 */
    OTHER,        /* 0x1aa2 */
    OTHER,        /* 0x1aa3 */
    OTHER,        /* 0x1aa4 */
    OTHER,        /* 0x1aa5 */
    OTHER,        /* 0x1aa6 */
    OTHER,        /* 0x1aa7 */
    OTHER,        /* 0x1aa8 */
    OTHER,        /* 0x1aa9 */
    OTHER,        /* 0x1aaa */
    OTHER,        /* 0x1aab */
    OTHER,        /* 0x1aac */
    OTHER,        /* 0x1aad */
    OTHER,        /* 0x1aae */
    OTHER,        /* 0x1aaf */
    OTHER,        /* 0x1ab0 */
    OTHER,        /* 0x1ab1 */
    OTHER,        /* 0x1ab2 */
    OTHER,        /* 0x1ab3 */
    OTHER,        /* 0x1ab4 */
    OTHER,        /* 0x1ab5 */
    OTHER,        /* 0x1ab6 */
    OTHER,        /* 0x1ab7 */
    OTHER,        /* 0x1ab8 */
    OTHER,        /* 0x1ab9 */
    OTHER,        /* 0x1aba */
    OTHER,        /* 0x1abb */
    OTHER,        /* 0x1abc */
    OTHER,        /* 0x1abd */
    OTHER,        /* 0x1abe */
    OTHER,        /* 0x1abf */
    OTHER,        /* 0x1ac0 */
    OTHER,        /* 0x1ac1 */
    OTHER,        /* 0x1ac2 */
    OTHER,        /* 0x1ac3 */
    OTHER,        /* 0x1ac4 */
    OTHER,        /* 0x1ac5 */
    OTHER,        /* 0x1ac6 */
    OTHER,        /* 0x1ac7 */
    OTHER,        /* 0x1ac8 */
    OTHER,        /* 0x1ac9 */
    OTHER,        /* 0x1aca */
    OTHER,        /* 0x1acb */
    OTHER,        /* 0x1acc */
    OTHER,        /* 0x1acd */
    OTHER,        /* 0x1ace */
    OTHER,        /* 0x1acf */
    OTHER,        /* 0x1ad0 */
    OTHER,        /* 0x1ad1 */
    OTHER,        /* 0x1ad2 */
    OTHER,        /* 0x1ad3 */
    OTHER,        /* 0x1ad4 */
    OTHER,        /* 0x1ad5 */
    OTHER,        /* 0x1ad6 */
    OTHER,        /* 0x1ad7 */
    OTHER,        /* 0x1ad8 */
    OTHER,        /* 0x1ad9 */
    OTHER,        /* 0x1ada */
    OTHER,        /* 0x1adb */
    OTHER,        /* 0x1adc */
    OTHER,        /* 0x1add */
    OTHER,        /* 0x1ade */
    OTHER,        /* 0x1adf */
    OTHER,        /* 0x1ae0 */
    OTHER,        /* 0x1ae1 */
    OTHER,        /* 0x1ae2 */
    OTHER,        /* 0x1ae3 */
    OTHER,        /* 0x1ae4 */
    OTHER,        /* 0x1ae5 */
    OTHER,        /* 0x1ae6 */
    OTHER,        /* 0x1ae7 */
    OTHER,        /* 0x1ae8 */
    OTHER,        /* 0x1ae9 */
    OTHER,        /* 0x1aea */
    OTHER,        /* 0x1aeb */
    OTHER,        /* 0x1aec */
    OTHER,        /* 0x1aed */
    OTHER,        /* 0x1aee */
    OTHER,        /* 0x1aef */
    OTHER,        /* 0x1af0 */
    OTHER,        /* 0x1af1 */
    OTHER,        /* 0x1af2 */
    OTHER,        /* 0x1af3 */
    OTHER,        /* 0x1af4 */
    OTHER,        /* 0x1af5 */
    OTHER,        /* 0x1af6 */
    OTHER,        /* 0x1af7 */
    OTHER,        /* 0x1af8 */
    OTHER,        /* 0x1af9 */
    OTHER,        /* 0x1afa */
    OTHER,        /* 0x1afb */
    OTHER,        /* 0x1afc */
    OTHER,        /* 0x1afd */
    OTHER,        /* 0x1afe */
    OTHER,        /* 0x1aff */
    OTHER,        /* 0x1b00 */
    OTHER,        /* 0x1b01 */
    OTHER,        /* 0x1b02 */
    OTHER,        /* 0x1b03 */
    OTHER,        /* 0x1b04 */
    OTHER,        /* 0x1b05 */
    OTHER,        /* 0x1b06 */
    OTHER,        /* 0x1b07 */
    OTHER,        /* 0x1b08 */
    OTHER,        /* 0x1b09 */
    OTHER,        /* 0x1b0a */
    OTHER,        /* 0x1b0b */
    OTHER,        /* 0x1b0c */
    OTHER,        /* 0x1b0d */
    OTHER,        /* 0x1b0e */
    OTHER,        /* 0x1b0f */
    OTHER,        /* 0x1b10 */
    OTHER,        /* 0x1b11 */
    OTHER,        /* 0x1b12 */
    OTHER,        /* 0x1b13 */
    OTHER,        /* 0x1b14 */
    OTHER,        /* 0x1b15 */
    OTHER,        /* 0x1b16 */
    OTHER,        /* 0x1b17 */
    OTHER,        /* 0x1b18 */
    OTHER,        /* 0x1b19 */
    OTHER,        /* 0x1b1a */
    OTHER,        /* 0x1b1b */
    OTHER,        /* 0x1b1c */
    OTHER,        /* 0x1b1d */
    OTHER,        /* 0x1b1e */
    OTHER,        /* 0x1b1f */
    OTHER,        /* 0x1b20 */
    OTHER,        /* 0x1b21 */
    OTHER,        /* 0x1b22 */
    OTHER,        /* 0x1b23 */
    OTHER,        /* 0x1b24 */
    OTHER,        /* 0x1b25 */
    OTHER,        /* 0x1b26 */
    OTHER,        /* 0x1b27 */
    OTHER,        /* 0x1b28 */
    OTHER,        /* 0x1b29 */
    OTHER,        /* 0x1b2a */
    OTHER,        /* 0x1b2b */
    OTHER,        /* 0x1b2c */
    OTHER,        /* 0x1b2d */
    OTHER,        /* 0x1b2e */
    OTHER,        /* 0x1b2f */
    OTHER,        /* 0x1b30 */
    OTHER,        /* 0x1b31 */
    OTHER,        /* 0x1b32 */
    OTHER,        /* 0x1b33 */
    OTHER,        /* 0x1b34 */
    OTHER,        /* 0x1b35 */
    OTHER,        /* 0x1b36 */
    OTHER,        /* 0x1b37 */
    OTHER,        /* 0x1b38 */
    OTHER,        /* 0x1b39 */
    OTHER,        /* 0x1b3a */
    OTHER,        /* 0x1b3b */
    OTHER,        /* 0x1b3c */
    OTHER,        /* 0x1b3d */
    OTHER,        /* 0x1b3e */
    OTHER,        /* 0x1b3f */
    OTHER,        /* 0x1b40 */
    OTHER,        /* 0x1b41 */
    OTHER,        /* 0x1b42 */
    OTHER,        /* 0x1b43 */
    OTHER,        /* 0x1b44 */
    OTHER,        /* 0x1b45 */
    OTHER,        /* 0x1b46 */
    OTHER,        /* 0x1b47 */
    OTHER,        /* 0x1b48 */
    OTHER,        /* 0x1b49 */
    OTHER,        /* 0x1b4a */
    OTHER,        /* 0x1b4b */
    OTHER,        /* 0x1b4c */
    OTHER,        /* 0x1b4d */
    OTHER,        /* 0x1b4e */
    OTHER,        /* 0x1b4f */
    OTHER,        /* 0x1b50 */
    OTHER,        /* 0x1b51 */
    OTHER,        /* 0x1b52 */
    OTHER,        /* 0x1b53 */
    OTHER,        /* 0x1b54 */
    OTHER,        /* 0x1b55 */
    OTHER,        /* 0x1b56 */
    OTHER,        /* 0x1b57 */
    OTHER,        /* 0x1b58 */
    OTHER,        /* 0x1b59 */
    OTHER,        /* 0x1b5a */
    OTHER,        /* 0x1b5b */
    OTHER,        /* 0x1b5c */
    OTHER,        /* 0x1b5d */
    OTHER,        /* 0x1b5e */
    OTHER,        /* 0x1b5f */
    OTHER,        /* 0x1b60 */
    OTHER,        /* 0x1b61 */
    OTHER,        /* 0x1b62 */
    OTHER,        /* 0x1b63 */
    OTHER,        /* 0x1b64 */
    OTHER,        /* 0x1b65 */
    OTHER,        /* 0x1b66 */
    OTHER,        /* 0x1b67 */
    OTHER,        /* 0x1b68 */
    OTHER,        /* 0x1b69 */
    OTHER,        /* 0x1b6a */
    OTHER,        /* 0x1b6b */
    OTHER,        /* 0x1b6c */
    OTHER,        /* 0x1b6d */
    OTHER,        /* 0x1b6e */
    OTHER,        /* 0x1b6f */
    OTHER,        /* 0x1b70 */
    OTHER,        /* 0x1b71 */
    OTHER,        /* 0x1b72 */
    OTHER,        /* 0x1b73 */
    OTHER,        /* 0x1b74 */
    OTHER,        /* 0x1b75 */
    OTHER,        /* 0x1b76 */
    OTHER,        /* 0x1b77 */
    OTHER,        /* 0x1b78 */
    OTHER,        /* 0x1b79 */
    OTHER,        /* 0x1b7a */
    OTHER,        /* 0x1b7b */
    OTHER,        /* 0x1b7c */
    OTHER,        /* 0x1b7d */
    OTHER,        /* 0x1b7e */
    OTHER,        /* 0x1b7f */
    OTHER,        /* 0x1b80 */
    OTHER,        /* 0x1b81 */
    OTHER,        /* 0x1b82 */
    OTHER,        /* 0x1b83 */
    OTHER,        /* 0x1b84 */
    OTHER,        /* 0x1b85 */
    OTHER,        /* 0x1b86 */
    OTHER,        /* 0x1b87 */
    OTHER,        /* 0x1b88 */
    OTHER,        /* 0x1b89 */
    OTHER,        /* 0x1b8a */
    OTHER,        /* 0x1b8b */
    OTHER,        /* 0x1b8c */
    OTHER,        /* 0x1b8d */
    OTHER,        /* 0x1b8e */
    OTHER,        /* 0x1b8f */
    OTHER,        /* 0x1b90 */
    OTHER,        /* 0x1b91 */
    OTHER,        /* 0x1b92 */
    OTHER,        /* 0x1b93 */
    OTHER,        /* 0x1b94 */
    OTHER,        /* 0x1b95 */
    OTHER,        /* 0x1b96 */
    OTHER,        /* 0x1b97 */
    OTHER,        /* 0x1b98 */
    OTHER,        /* 0x1b99 */
    OTHER,        /* 0x1b9a */
    OTHER,        /* 0x1b9b */
    OTHER,        /* 0x1b9c */
    OTHER,        /* 0x1b9d */
    OTHER,        /* 0x1b9e */
    OTHER,        /* 0x1b9f */
    OTHER,        /* 0x1ba0 */
    OTHER,        /* 0x1ba1 */
    OTHER,        /* 0x1ba2 */
    OTHER,        /* 0x1ba3 */
    OTHER,        /* 0x1ba4 */
    OTHER,        /* 0x1ba5 */
    OTHER,        /* 0x1ba6 */
    OTHER,        /* 0x1ba7 */
    OTHER,        /* 0x1ba8 */
    OTHER,        /* 0x1ba9 */
    OTHER,        /* 0x1baa */
    OTHER,        /* 0x1bab */
    OTHER,        /* 0x1bac */
    OTHER,        /* 0x1bad */
    OTHER,        /* 0x1bae */
    OTHER,        /* 0x1baf */
    OTHER,        /* 0x1bb0 */
    OTHER,        /* 0x1bb1 */
    OTHER,        /* 0x1bb2 */
    OTHER,        /* 0x1bb3 */
    OTHER,        /* 0x1bb4 */
    OTHER,        /* 0x1bb5 */
    OTHER,        /* 0x1bb6 */
    OTHER,        /* 0x1bb7 */
    OTHER,        /* 0x1bb8 */
    OTHER,        /* 0x1bb9 */
    OTHER,        /* 0x1bba */
    OTHER,        /* 0x1bbb */
    OTHER,        /* 0x1bbc */
    OTHER,        /* 0x1bbd */
    OTHER,        /* 0x1bbe */
    OTHER,        /* 0x1bbf */
    OTHER,        /* 0x1bc0 */
    OTHER,        /* 0x1bc1 */
    OTHER,        /* 0x1bc2 */
    OTHER,        /* 0x1bc3 */
    OTHER,        /* 0x1bc4 */
    OTHER,        /* 0x1bc5 */
    OTHER,        /* 0x1bc6 */
    OTHER,        /* 0x1bc7 */
    OTHER,        /* 0x1bc8 */
    OTHER,        /* 0x1bc9 */
    OTHER,        /* 0x1bca */
    OTHER,        /* 0x1bcb */
    OTHER,        /* 0x1bcc */
    OTHER,        /* 0x1bcd */
    OTHER,        /* 0x1bce */
    OTHER,        /* 0x1bcf */
    OTHER,        /* 0x1bd0 */
    OTHER,        /* 0x1bd1 */
    OTHER,        /* 0x1bd2 */
    OTHER,        /* 0x1bd3 */
    OTHER,        /* 0x1bd4 */
    OTHER,        /* 0x1bd5 */
    OTHER,        /* 0x1bd6 */
    OTHER,        /* 0x1bd7 */
    OTHER,        /* 0x1bd8 */
    OTHER,        /* 0x1bd9 */
    OTHER,        /* 0x1bda */
    OTHER,        /* 0x1bdb */
    OTHER,        /* 0x1bdc */
    OTHER,        /* 0x1bdd */
    OTHER,        /* 0x1bde */
    OTHER,        /* 0x1bdf */
    OTHER,        /* 0x1be0 */
    OTHER,        /* 0x1be1 */
    OTHER,        /* 0x1be2 */
    OTHER,        /* 0x1be3 */
    OTHER,        /* 0x1be4 */
    OTHER,        /* 0x1be5 */
    OTHER,        /* 0x1be6 */
    OTHER,        /* 0x1be7 */
    OTHER,        /* 0x1be8 */
    OTHER,        /* 0x1be9 */
    OTHER,        /* 0x1bea */
    OTHER,        /* 0x1beb */
    OTHER,        /* 0x1bec */
    OTHER,        /* 0x1bed */
    OTHER,        /* 0x1bee */
    OTHER,        /* 0x1bef */
    OTHER,        /* 0x1bf0 */
    OTHER,        /* 0x1bf1 */
    OTHER,        /* 0x1bf2 */
    OTHER,        /* 0x1bf3 */
    OTHER,        /* 0x1bf4 */
    OTHER,        /* 0x1bf5 */
    OTHER,        /* 0x1bf6 */
    OTHER,        /* 0x1bf7 */
    OTHER,        /* 0x1bf8 */
    OTHER,        /* 0x1bf9 */
    OTHER,        /* 0x1bfa */
    OTHER,        /* 0x1bfb */
    OTHER,        /* 0x1bfc */
    OTHER,        /* 0x1bfd */
    OTHER,        /* 0x1bfe */
    OTHER,        /* 0x1bff */
    OTHER,        /* 0x1c00 */
    OTHER,        /* 0x1c01 */
    OTHER,        /* 0x1c02 */
    OTHER,        /* 0x1c03 */
    OTHER,        /* 0x1c04 */
    OTHER,        /* 0x1c05 */
    OTHER,        /* 0x1c06 */
    OTHER,        /* 0x1c07 */
    OTHER,        /* 0x1c08 */
    OTHER,        /* 0x1c09 */
    OTHER,        /* 0x1c0a */
    OTHER,        /* 0x1c0b */
    OTHER,        /* 0x1c0c */
    OTHER,        /* 0x1c0d */
    OTHER,        /* 0x1c0e */
    OTHER,        /* 0x1c0f */
    OTHER,        /* 0x1c10 */
    OTHER,        /* 0x1c11 */
    OTHER,        /* 0x1c12 */
    OTHER,        /* 0x1c13 */
    OTHER,        /* 0x1c14 */
    OTHER,        /* 0x1c15 */
    OTHER,        /* 0x1c16 */
    OTHER,        /* 0x1c17 */
    OTHER,        /* 0x1c18 */
    OTHER,        /* 0x1c19 */
    OTHER,        /* 0x1c1a */
    OTHER,        /* 0x1c1b */
    OTHER,        /* 0x1c1c */
    OTHER,        /* 0x1c1d */
    OTHER,        /* 0x1c1e */
    OTHER,        /* 0x1c1f */
    OTHER,        /* 0x1c20 */
    OTHER,        /* 0x1c21 */
    OTHER,        /* 0x1c22 */
    OTHER,        /* 0x1c23 */
    OTHER,        /* 0x1c24 */
    OTHER,        /* 0x1c25 */
    OTHER,        /* 0x1c26 */
    OTHER,        /* 0x1c27 */
    OTHER,        /* 0x1c28 */
    OTHER,        /* 0x1c29 */
    OTHER,        /* 0x1c2a */
    OTHER,        /* 0x1c2b */
    OTHER,        /* 0x1c2c */
    OTHER,        /* 0x1c2d */
    OTHER,        /* 0x1c2e */
    OTHER,        /* 0x1c2f */
    OTHER,        /* 0x1c30 */
    OTHER,        /* 0x1c31 */
    OTHER,        /* 0x1c32 */
    OTHER,        /* 0x1c33 */
    OTHER,        /* 0x1c34 */
    OTHER,        /* 0x1c35 */
    OTHER,        /* 0x1c36 */
    OTHER,        /* 0x1c37 */
    OTHER,        /* 0x1c38 */
    OTHER,        /* 0x1c39 */
    OTHER,        /* 0x1c3a */
    OTHER,        /* 0x1c3b */
    OTHER,        /* 0x1c3c */
    OTHER,        /* 0x1c3d */
    OTHER,        /* 0x1c3e */
    OTHER,        /* 0x1c3f */
    OTHER,        /* 0x1c40 */
    OTHER,        /* 0x1c41 */
    OTHER,        /* 0x1c42 */
    OTHER,        /* 0x1c43 */
    OTHER,        /* 0x1c44 */
    OTHER,        /* 0x1c45 */
    OTHER,        /* 0x1c46 */
    OTHER,        /* 0x1c47 */
    OTHER,        /* 0x1c48 */
    OTHER,        /* 0x1c49 */
    OTHER,        /* 0x1c4a */
    OTHER,        /* 0x1c4b */
    OTHER,        /* 0x1c4c */
    OTHER,        /* 0x1c4d */
    OTHER,        /* 0x1c4e */
    OTHER,        /* 0x1c4f */
    OTHER,        /* 0x1c50 */
    OTHER,        /* 0x1c51 */
    OTHER,        /* 0x1c52 */
    OTHER,        /* 0x1c53 */
    OTHER,        /* 0x1c54 */
    OTHER,        /* 0x1c55 */
    OTHER,        /* 0x1c56 */
    OTHER,        /* 0x1c57 */
    OTHER,        /* 0x1c58 */
    OTHER,        /* 0x1c59 */
    OTHER,        /* 0x1c5a */
    OTHER,        /* 0x1c5b */
    OTHER,        /* 0x1c5c */
    OTHER,        /* 0x1c5d */
    OTHER,        /* 0x1c5e */
    OTHER,        /* 0x1c5f */
    OTHER,        /* 0x1c60 */
    OTHER,        /* 0x1c61 */
    OTHER,        /* 0x1c62 */
    OTHER,        /* 0x1c63 */
    OTHER,        /* 0x1c64 */
    OTHER,        /* 0x1c65 */
    OTHER,        /* 0x1c66 */
    OTHER,        /* 0x1c67 */
    OTHER,        /* 0x1c68 */
    OTHER,        /* 0x1c69 */
    OTHER,        /* 0x1c6a */
    OTHER,        /* 0x1c6b */
    OTHER,        /* 0x1c6c */
    OTHER,        /* 0x1c6d */
    OTHER,        /* 0x1c6e */
    OTHER,        /* 0x1c6f */
    OTHER,        /* 0x1c70 */
    OTHER,        /* 0x1c71 */
    OTHER,        /* 0x1c72 */
    OTHER,        /* 0x1c73 */
    OTHER,        /* 0x1c74 */
    OTHER,        /* 0x1c75 */
    OTHER,        /* 0x1c76 */
    OTHER,        /* 0x1c77 */
    OTHER,        /* 0x1c78 */
    OTHER,        /* 0x1c79 */
    OTHER,        /* 0x1c7a */
    OTHER,        /* 0x1c7b */
    OTHER,        /* 0x1c7c */
    OTHER,        /* 0x1c7d */
    OTHER,        /* 0x1c7e */
    OTHER,        /* 0x1c7f */
    OTHER,        /* 0x1c80 */
    OTHER,        /* 0x1c81 */
    OTHER,        /* 0x1c82 */
    OTHER,        /* 0x1c83 */
    OTHER,        /* 0x1c84 */
    OTHER,        /* 0x1c85 */
    OTHER,        /* 0x1c86 */
    OTHER,        /* 0x1c87 */
    OTHER,        /* 0x1c88 */
    OTHER,        /* 0x1c89 */
    OTHER,        /* 0x1c8a */
    OTHER,        /* 0x1c8b */
    OTHER,        /* 0x1c8c */
    OTHER,        /* 0x1c8d */
    OTHER,        /* 0x1c8e */
    OTHER,        /* 0x1c8f */
    OTHER,        /* 0x1c90 */
    OTHER,        /* 0x1c91 */
    OTHER,        /* 0x1c92 */
    OTHER,        /* 0x1c93 */
    OTHER,        /* 0x1c94 */
    OTHER,        /* 0x1c95 */
    OTHER,        /* 0x1c96 */
    OTHER,        /* 0x1c97 */
    OTHER,        /* 0x1c98 */
    OTHER,        /* 0x1c99 */
    OTHER,        /* 0x1c9a */
    OTHER,        /* 0x1c9b */
    OTHER,        /* 0x1c9c */
    OTHER,        /* 0x1c9d */
    OTHER,        /* 0x1c9e */
    OTHER,        /* 0x1c9f */
    OTHER,        /* 0x1ca0 */
    OTHER,        /* 0x1ca1 */
    OTHER,        /* 0x1ca2 */
    OTHER,        /* 0x1ca3 */
    OTHER,        /* 0x1ca4 */
    OTHER,        /* 0x1ca5 */
    OTHER,        /* 0x1ca6 */
    OTHER,        /* 0x1ca7 */
    OTHER,        /* 0x1ca8 */
    OTHER,        /* 0x1ca9 */
    OTHER,        /* 0x1caa */
    OTHER,        /* 0x1cab */
    OTHER,        /* 0x1cac */
    OTHER,        /* 0x1cad */
    OTHER,        /* 0x1cae */
    OTHER,        /* 0x1caf */
    OTHER,        /* 0x1cb0 */
    OTHER,        /* 0x1cb1 */
    OTHER,        /* 0x1cb2 */
    OTHER,        /* 0x1cb3 */
    OTHER,        /* 0x1cb4 */
    OTHER,        /* 0x1cb5 */
    OTHER,        /* 0x1cb6 */
    OTHER,        /* 0x1cb7 */
    OTHER,        /* 0x1cb8 */
    OTHER,        /* 0x1cb9 */
    OTHER,        /* 0x1cba */
    OTHER,        /* 0x1cbb */
    OTHER,        /* 0x1cbc */
    OTHER,        /* 0x1cbd */
    OTHER,        /* 0x1cbe */
    OTHER,        /* 0x1cbf */
    OTHER,        /* 0x1cc0 */
    OTHER,        /* 0x1cc1 */
    OTHER,        /* 0x1cc2 */
    OTHER,        /* 0x1cc3 */
    OTHER,        /* 0x1cc4 */
    OTHER,        /* 0x1cc5 */
    OTHER,        /* 0x1cc6 */
    OTHER,        /* 0x1cc7 */
    OTHER,        /* 0x1cc8 */
    OTHER,        /* 0x1cc9 */
    OTHER,        /* 0x1cca */
    OTHER,        /* 0x1ccb */
    OTHER,        /* 0x1ccc */
    OTHER,        /* 0x1ccd */
    OTHER,        /* 0x1cce */
    OTHER,        /* 0x1ccf */
    OTHER,        /* 0x1cd0 */
    OTHER,        /* 0x1cd1 */
    OTHER,        /* 0x1cd2 */
    OTHER,        /* 0x1cd3 */
    OTHER,        /* 0x1cd4 */
    OTHER,        /* 0x1cd5 */
    OTHER,        /* 0x1cd6 */
    OTHER,        /* 0x1cd7 */
    OTHER,        /* 0x1cd8 */
    OTHER,        /* 0x1cd9 */
    OTHER,        /* 0x1cda */
    OTHER,        /* 0x1cdb */
    OTHER,        /* 0x1cdc */
    OTHER,        /* 0x1cdd */
    OTHER,        /* 0x1cde */
    OTHER,        /* 0x1cdf */
    OTHER,        /* 0x1ce0 */
    OTHER,        /* 0x1ce1 */
    OTHER,        /* 0x1ce2 */
    OTHER,        /* 0x1ce3 */
    OTHER,        /* 0x1ce4 */
    OTHER,        /* 0x1ce5 */
    OTHER,        /* 0x1ce6 */
    OTHER,        /* 0x1ce7 */
    OTHER,        /* 0x1ce8 */
    OTHER,        /* 0x1ce9 */
    OTHER,        /* 0x1cea */
    OTHER,        /* 0x1ceb */
    OTHER,        /* 0x1cec */
    OTHER,        /* 0x1ced */
    OTHER,        /* 0x1cee */
    OTHER,        /* 0x1cef */
    OTHER,        /* 0x1cf0 */
    OTHER,        /* 0x1cf1 */
    OTHER,        /* 0x1cf2 */
    OTHER,        /* 0x1cf3 */
    OTHER,        /* 0x1cf4 */
    OTHER,        /* 0x1cf5 */
    OTHER,        /* 0x1cf6 */
    OTHER,        /* 0x1cf7 */
    OTHER,        /* 0x1cf8 */
    OTHER,        /* 0x1cf9 */
    OTHER,        /* 0x1cfa */
    OTHER,        /* 0x1cfb */
    OTHER,        /* 0x1cfc */
    OTHER,        /* 0x1cfd */
    OTHER,        /* 0x1cfe */
    OTHER,        /* 0x1cff */
    OTHER,        /* 0x1d00 */
    OTHER,        /* 0x1d01 */
    OTHER,        /* 0x1d02 */
    OTHER,        /* 0x1d03 */
    OTHER,        /* 0x1d04 */
    OTHER,        /* 0x1d05 */
    OTHER,        /* 0x1d06 */
    OTHER,        /* 0x1d07 */
    OTHER,        /* 0x1d08 */
    OTHER,        /* 0x1d09 */
    OTHER,        /* 0x1d0a */
    OTHER,        /* 0x1d0b */
    OTHER,        /* 0x1d0c */
    OTHER,        /* 0x1d0d */
    OTHER,        /* 0x1d0e */
    OTHER,        /* 0x1d0f */
    OTHER,        /* 0x1d10 */
    OTHER,        /* 0x1d11 */
    OTHER,        /* 0x1d12 */
    OTHER,        /* 0x1d13 */
    OTHER,        /* 0x1d14 */
    OTHER,        /* 0x1d15 */
    OTHER,        /* 0x1d16 */
    OTHER,        /* 0x1d17 */
    OTHER,        /* 0x1d18 */
    OTHER,        /* 0x1d19 */
    OTHER,        /* 0x1d1a */
    OTHER,        /* 0x1d1b */
    OTHER,        /* 0x1d1c */
    OTHER,        /* 0x1d1d */
    OTHER,        /* 0x1d1e */
    OTHER,        /* 0x1d1f */
    OTHER,        /* 0x1d20 */
    OTHER,        /* 0x1d21 */
    OTHER,        /* 0x1d22 */
    OTHER,        /* 0x1d23 */
    OTHER,        /* 0x1d24 */
    OTHER,        /* 0x1d25 */
    OTHER,        /* 0x1d26 */
    OTHER,        /* 0x1d27 */
    OTHER,        /* 0x1d28 */
    OTHER,        /* 0x1d29 */
    OTHER,        /* 0x1d2a */
    OTHER,        /* 0x1d2b */
    OTHER,        /* 0x1d2c */
    OTHER,        /* 0x1d2d */
    OTHER,        /* 0x1d2e */
    OTHER,        /* 0x1d2f */
    OTHER,        /* 0x1d30 */
    OTHER,        /* 0x1d31 */
    OTHER,        /* 0x1d32 */
    OTHER,        /* 0x1d33 */
    OTHER,        /* 0x1d34 */
    OTHER,        /* 0x1d35 */
    OTHER,        /* 0x1d36 */
    OTHER,        /* 0x1d37 */
    OTHER,        /* 0x1d38 */
    OTHER,        /* 0x1d39 */
    OTHER,        /* 0x1d3a */
    OTHER,        /* 0x1d3b */
    OTHER,        /* 0x1d3c */
    OTHER,        /* 0x1d3d */
    OTHER,        /* 0x1d3e */
    OTHER,        /* 0x1d3f */
    OTHER,        /* 0x1d40 */
    OTHER,        /* 0x1d41 */
    OTHER,        /* 0x1d42 */
    OTHER,        /* 0x1d43 */
    OTHER,        /* 0x1d44 */
    OTHER,        /* 0x1d45 */
    OTHER,        /* 0x1d46 */
    OTHER,        /* 0x1d47 */
    OTHER,        /* 0x1d48 */
    OTHER,        /* 0x1d49 */
    OTHER,        /* 0x1d4a */
    OTHER,        /* 0x1d4b */
    OTHER,        /* 0x1d4c */
    OTHER,        /* 0x1d4d */
    OTHER,        /* 0x1d4e */
    OTHER,        /* 0x1d4f */
    OTHER,        /* 0x1d50 */
    OTHER,        /* 0x1d51 */
    OTHER,        /* 0x1d52 */
    OTHER,        /* 0x1d53 */
    OTHER,        /* 0x1d54 */
    OTHER,        /* 0x1d55 */
    OTHER,        /* 0x1d56 */
    OTHER,        /* 0x1d57 */
    OTHER,        /* 0x1d58 */
    OTHER,        /* 0x1d59 */
    OTHER,        /* 0x1d5a */
    OTHER,        /* 0x1d5b */
    OTHER,        /* 0x1d5c */
    OTHER,        /* 0x1d5d */
    OTHER,        /* 0x1d5e */
    OTHER,        /* 0x1d5f */
    OTHER,        /* 0x1d60 */
    OTHER,        /* 0x1d61 */
    OTHER,        /* 0x1d62 */
    OTHER,        /* 0x1d63 */
    OTHER,        /* 0x1d64 */
    OTHER,        /* 0x1d65 */
    OTHER,        /* 0x1d66 */
    OTHER,        /* 0x1d67 */
    OTHER,        /* 0x1d68 */
    OTHER,        /* 0x1d69 */
    OTHER,        /* 0x1d6a */
    OTHER,        /* 0x1d6b */
    OTHER,        /* 0x1d6c */
    OTHER,        /* 0x1d6d */
    OTHER,        /* 0x1d6e */
    OTHER,        /* 0x1d6f */
    OTHER,        /* 0x1d70 */
    OTHER,        /* 0x1d71 */
    OTHER,        /* 0x1d72 */
    OTHER,        /* 0x1d73 */
    OTHER,        /* 0x1d74 */
    OTHER,        /* 0x1d75 */
    OTHER,        /* 0x1d76 */
    OTHER,        /* 0x1d77 */
    OTHER,        /* 0x1d78 */
    OTHER,        /* 0x1d79 */
    OTHER,        /* 0x1d7a */
    OTHER,        /* 0x1d7b */
    OTHER,        /* 0x1d7c */
    OTHER,        /* 0x1d7d */
    OTHER,        /* 0x1d7e */
    OTHER,        /* 0x1d7f */
    OTHER,        /* 0x1d80 */
    OTHER,        /* 0x1d81 */
    OTHER,        /* 0x1d82 */
    OTHER,        /* 0x1d83 */
    OTHER,        /* 0x1d84 */
    OTHER,        /* 0x1d85 */
    OTHER,        /* 0x1d86 */
    OTHER,        /* 0x1d87 */
    OTHER,        /* 0x1d88 */
    OTHER,        /* 0x1d89 */
    OTHER,        /* 0x1d8a */
    OTHER,        /* 0x1d8b */
    OTHER,        /* 0x1d8c */
    OTHER,        /* 0x1d8d */
    OTHER,        /* 0x1d8e */
    OTHER,        /* 0x1d8f */
    OTHER,        /* 0x1d90 */
    OTHER,        /* 0x1d91 */
    OTHER,        /* 0x1d92 */
    OTHER,        /* 0x1d93 */
    OTHER,        /* 0x1d94 */
    OTHER,        /* 0x1d95 */
    OTHER,        /* 0x1d96 */
    OTHER,        /* 0x1d97 */
    OTHER,        /* 0x1d98 */
    OTHER,        /* 0x1d99 */
    OTHER,        /* 0x1d9a */
    OTHER,        /* 0x1d9b */
    OTHER,        /* 0x1d9c */
    OTHER,        /* 0x1d9d */
    OTHER,        /* 0x1d9e */
    OTHER,        /* 0x1d9f */
    OTHER,        /* 0x1da0 */
    OTHER,        /* 0x1da1 */
    OTHER,        /* 0x1da2 */
    OTHER,        /* 0x1da3 */
    OTHER,        /* 0x1da4 */
    OTHER,        /* 0x1da5 */
    OTHER,        /* 0x1da6 */
    OTHER,        /* 0x1da7 */
    OTHER,        /* 0x1da8 */
    OTHER,        /* 0x1da9 */
    OTHER,        /* 0x1daa */
    OTHER,        /* 0x1dab */
    OTHER,        /* 0x1dac */
    OTHER,        /* 0x1dad */
    OTHER,        /* 0x1dae */
    OTHER,        /* 0x1daf */
    OTHER,        /* 0x1db0 */
    OTHER,        /* 0x1db1 */
    OTHER,        /* 0x1db2 */
    OTHER,        /* 0x1db3 */
    OTHER,        /* 0x1db4 */
    OTHER,        /* 0x1db5 */
    OTHER,        /* 0x1db6 */
    OTHER,        /* 0x1db7 */
    OTHER,        /* 0x1db8 */
    OTHER,        /* 0x1db9 */
    OTHER,        /* 0x1dba */
    OTHER,        /* 0x1dbb */
    OTHER,        /* 0x1dbc */
    OTHER,        /* 0x1dbd */
    OTHER,        /* 0x1dbe */
    OTHER,        /* 0x1dbf */
    OTHER,        /* 0x1dc0 */
    OTHER,        /* 0x1dc1 */
    OTHER,        /* 0x1dc2 */
    OTHER,        /* 0x1dc3 */
    OTHER,        /* 0x1dc4 */
    OTHER,        /* 0x1dc5 */
    OTHER,        /* 0x1dc6 */
    OTHER,        /* 0x1dc7 */
    OTHER,        /* 0x1dc8 */
    OTHER,        /* 0x1dc9 */
    OTHER,        /* 0x1dca */
    OTHER,        /* 0x1dcb */
    OTHER,        /* 0x1dcc */
    OTHER,        /* 0x1dcd */
    OTHER,        /* 0x1dce */
    OTHER,        /* 0x1dcf */
    OTHER,        /* 0x1dd0 */
    OTHER,        /* 0x1dd1 */
    OTHER,        /* 0x1dd2 */
    OTHER,        /* 0x1dd3 */
    OTHER,        /* 0x1dd4 */
    OTHER,        /* 0x1dd5 */
    OTHER,        /* 0x1dd6 */
    OTHER,        /* 0x1dd7 */
    OTHER,        /* 0x1dd8 */
    OTHER,        /* 0x1dd9 */
    OTHER,        /* 0x1dda */
    OTHER,        /* 0x1ddb */
    OTHER,        /* 0x1ddc */
    OTHER,        /* 0x1ddd */
    OTHER,        /* 0x1dde */
    OTHER,        /* 0x1ddf */
    OTHER,        /* 0x1de0 */
    OTHER,        /* 0x1de1 */
    OTHER,        /* 0x1de2 */
    OTHER,        /* 0x1de3 */
    OTHER,        /* 0x1de4 */
    OTHER,        /* 0x1de5 */
    OTHER,        /* 0x1de6 */
    OTHER,        /* 0x1de7 */
    OTHER,        /* 0x1de8 */
    OTHER,        /* 0x1de9 */
    OTHER,        /* 0x1dea */
    OTHER,        /* 0x1deb */
    OTHER,        /* 0x1dec */
    OTHER,        /* 0x1ded */
    OTHER,        /* 0x1dee */
    OTHER,        /* 0x1def */
    OTHER,        /* 0x1df0 */
    OTHER,        /* 0x1df1 */
    OTHER,        /* 0x1df2 */
    OTHER,        /* 0x1df3 */
    OTHER,        /* 0x1df4 */
    OTHER,        /* 0x1df5 */
    OTHER,        /* 0x1df6 */
    OTHER,        /* 0x1df7 */
    OTHER,        /* 0x1df8 */
    OTHER,        /* 0x1df9 */
    OTHER,        /* 0x1dfa */
    OTHER,        /* 0x1dfb */
    OTHER,        /* 0x1dfc */
    OTHER,        /* 0x1dfd */
    OTHER,        /* 0x1dfe */
    OTHER,        /* 0x1dff */
    ALPHA,        /* 0x1e00 */
    ALPHA,        /* 0x1e01 */
    ALPHA,        /* 0x1e02 */
    ALPHA,        /* 0x1e03 */
    ALPHA,        /* 0x1e04 */
    ALPHA,        /* 0x1e05 */
    ALPHA,        /* 0x1e06 */
    ALPHA,        /* 0x1e07 */
    ALPHA,        /* 0x1e08 */
    ALPHA,        /* 0x1e09 */
    ALPHA,        /* 0x1e0a */
    ALPHA,        /* 0x1e0b */
    ALPHA,        /* 0x1e0c */
    ALPHA,        /* 0x1e0d */
    ALPHA,        /* 0x1e0e */
    ALPHA,        /* 0x1e0f */
    ALPHA,        /* 0x1e10 */
    ALPHA,        /* 0x1e11 */
    ALPHA,        /* 0x1e12 */
    ALPHA,        /* 0x1e13 */
    ALPHA,        /* 0x1e14 */
    ALPHA,        /* 0x1e15 */
    ALPHA,        /* 0x1e16 */
    ALPHA,        /* 0x1e17 */
    ALPHA,        /* 0x1e18 */
    ALPHA,        /* 0x1e19 */
    ALPHA,        /* 0x1e1a */
    ALPHA,        /* 0x1e1b */
    ALPHA,        /* 0x1e1c */
    ALPHA,        /* 0x1e1d */
    ALPHA,        /* 0x1e1e */
    ALPHA,        /* 0x1e1f */
    ALPHA,        /* 0x1e20 */
    ALPHA,        /* 0x1e21 */
    ALPHA,        /* 0x1e22 */
    ALPHA,        /* 0x1e23 */
    ALPHA,        /* 0x1e24 */
    ALPHA,        /* 0x1e25 */
    ALPHA,        /* 0x1e26 */
    ALPHA,        /* 0x1e27 */
    ALPHA,        /* 0x1e28 */
    ALPHA,        /* 0x1e29 */
    ALPHA,        /* 0x1e2a */
    ALPHA,        /* 0x1e2b */
    ALPHA,        /* 0x1e2c */
    ALPHA,        /* 0x1e2d */
    ALPHA,        /* 0x1e2e */
    ALPHA,        /* 0x1e2f */
    ALPHA,        /* 0x1e30 */
    ALPHA,        /* 0x1e31 */
    ALPHA,        /* 0x1e32 */
    ALPHA,        /* 0x1e33 */
    ALPHA,        /* 0x1e34 */
    ALPHA,        /* 0x1e35 */
    ALPHA,        /* 0x1e36 */
    ALPHA,        /* 0x1e37 */
    ALPHA,        /* 0x1e38 */
    ALPHA,        /* 0x1e39 */
    ALPHA,        /* 0x1e3a */
    ALPHA,        /* 0x1e3b */
    ALPHA,        /* 0x1e3c */
    ALPHA,        /* 0x1e3d */
    ALPHA,        /* 0x1e3e */
    ALPHA,        /* 0x1e3f */
    ALPHA,        /* 0x1e40 */
    ALPHA,        /* 0x1e41 */
    ALPHA,        /* 0x1e42 */
    ALPHA,        /* 0x1e43 */
    ALPHA,        /* 0x1e44 */
    ALPHA,        /* 0x1e45 */
    ALPHA,        /* 0x1e46 */
    ALPHA,        /* 0x1e47 */
    ALPHA,        /* 0x1e48 */
    ALPHA,        /* 0x1e49 */
    ALPHA,        /* 0x1e4a */
    ALPHA,        /* 0x1e4b */
    ALPHA,        /* 0x1e4c */
    ALPHA,        /* 0x1e4d */
    ALPHA,        /* 0x1e4e */
    ALPHA,        /* 0x1e4f */
    ALPHA,        /* 0x1e50 */
    ALPHA,        /* 0x1e51 */
    ALPHA,        /* 0x1e52 */
    ALPHA,        /* 0x1e53 */
    ALPHA,        /* 0x1e54 */
    ALPHA,        /* 0x1e55 */
    ALPHA,        /* 0x1e56 */
    ALPHA,        /* 0x1e57 */
    ALPHA,        /* 0x1e58 */
    ALPHA,        /* 0x1e59 */
    ALPHA,        /* 0x1e5a */
    ALPHA,        /* 0x1e5b */
    ALPHA,        /* 0x1e5c */
    ALPHA,        /* 0x1e5d */
    ALPHA,        /* 0x1e5e */
    ALPHA,        /* 0x1e5f */
    ALPHA,        /* 0x1e60 */
    ALPHA,        /* 0x1e61 */
    ALPHA,        /* 0x1e62 */
    ALPHA,        /* 0x1e63 */
    ALPHA,        /* 0x1e64 */
    ALPHA,        /* 0x1e65 */
    ALPHA,        /* 0x1e66 */
    ALPHA,        /* 0x1e67 */
    ALPHA,        /* 0x1e68 */
    ALPHA,        /* 0x1e69 */
    ALPHA,        /* 0x1e6a */
    ALPHA,        /* 0x1e6b */
    ALPHA,        /* 0x1e6c */
    ALPHA,        /* 0x1e6d */
    ALPHA,        /* 0x1e6e */
    ALPHA,        /* 0x1e6f */
    ALPHA,        /* 0x1e70 */
    ALPHA,        /* 0x1e71 */
    ALPHA,        /* 0x1e72 */
    ALPHA,        /* 0x1e73 */
    ALPHA,        /* 0x1e74 */
    ALPHA,        /* 0x1e75 */
    ALPHA,        /* 0x1e76 */
    ALPHA,        /* 0x1e77 */
    ALPHA,        /* 0x1e78 */
    ALPHA,        /* 0x1e79 */
    ALPHA,        /* 0x1e7a */
    ALPHA,        /* 0x1e7b */
    ALPHA,        /* 0x1e7c */
    ALPHA,        /* 0x1e7d */
    ALPHA,        /* 0x1e7e */
    ALPHA,        /* 0x1e7f */
    ALPHA,        /* 0x1e80 */
    ALPHA,        /* 0x1e81 */
    ALPHA,        /* 0x1e82 */
    ALPHA,        /* 0x1e83 */
    ALPHA,        /* 0x1e84 */
    ALPHA,        /* 0x1e85 */
    ALPHA,        /* 0x1e86 */
    ALPHA,        /* 0x1e87 */
    ALPHA,        /* 0x1e88 */
    ALPHA,        /* 0x1e89 */
    ALPHA,        /* 0x1e8a */
    ALPHA,        /* 0x1e8b */
    ALPHA,        /* 0x1e8c */
    ALPHA,        /* 0x1e8d */
    ALPHA,        /* 0x1e8e */
    ALPHA,        /* 0x1e8f */
    ALPHA,        /* 0x1e90 */
    ALPHA,        /* 0x1e91 */
    ALPHA,        /* 0x1e92 */
    ALPHA,        /* 0x1e93 */
    ALPHA,        /* 0x1e94 */
    ALPHA,        /* 0x1e95 */
    ALPHA,        /* 0x1e96 */
    ALPHA,        /* 0x1e97 */
    ALPHA,        /* 0x1e98 */
    ALPHA,        /* 0x1e99 */
    ALPHA,        /* 0x1e9a */
    ALPHA,        /* 0x1e9b */
    ALPHA,        /* 0x1e9c */
    ALPHA,        /* 0x1e9d */
    ALPHA,        /* 0x1e9e */
    ALPHA,        /* 0x1e9f */
    ALPHA,        /* 0x1ea0 */
    ALPHA,        /* 0x1ea1 */
    ALPHA,        /* 0x1ea2 */
    ALPHA,        /* 0x1ea3 */
    ALPHA,        /* 0x1ea4 */
    ALPHA,        /* 0x1ea5 */
    ALPHA,        /* 0x1ea6 */
    ALPHA,        /* 0x1ea7 */
    ALPHA,        /* 0x1ea8 */
    ALPHA,        /* 0x1ea9 */
    ALPHA,        /* 0x1eaa */
    ALPHA,        /* 0x1eab */
    ALPHA,        /* 0x1eac */
    ALPHA,        /* 0x1ead */
    ALPHA,        /* 0x1eae */
    ALPHA,        /* 0x1eaf */
    ALPHA,        /* 0x1eb0 */
    ALPHA,        /* 0x1eb1 */
    ALPHA,        /* 0x1eb2 */
    ALPHA,        /* 0x1eb3 */
    ALPHA,        /* 0x1eb4 */
    ALPHA,        /* 0x1eb5 */
    ALPHA,        /* 0x1eb6 */
    ALPHA,        /* 0x1eb7 */
    ALPHA,        /* 0x1eb8 */
    ALPHA,        /* 0x1eb9 */
    ALPHA,        /* 0x1eba */
    ALPHA,        /* 0x1ebb */
    ALPHA,        /* 0x1ebc */
    ALPHA,        /* 0x1ebd */
    ALPHA,        /* 0x1ebe */
    ALPHA,        /* 0x1ebf */
    ALPHA,        /* 0x1ec0 */
    ALPHA,        /* 0x1ec1 */
    ALPHA,        /* 0x1ec2 */
    ALPHA,        /* 0x1ec3 */
    ALPHA,        /* 0x1ec4 */
    ALPHA,        /* 0x1ec5 */
    ALPHA,        /* 0x1ec6 */
    ALPHA,        /* 0x1ec7 */
    ALPHA,        /* 0x1ec8 */
    ALPHA,        /* 0x1ec9 */
    ALPHA,        /* 0x1eca */
    ALPHA,        /* 0x1ecb */
    ALPHA,        /* 0x1ecc */
    ALPHA,        /* 0x1ecd */
    ALPHA,        /* 0x1ece */
    ALPHA,        /* 0x1ecf */
    ALPHA,        /* 0x1ed0 */
    ALPHA,        /* 0x1ed1 */
    ALPHA,        /* 0x1ed2 */
    ALPHA,        /* 0x1ed3 */
    ALPHA,        /* 0x1ed4 */
    ALPHA,        /* 0x1ed5 */
    ALPHA,        /* 0x1ed6 */
    ALPHA,        /* 0x1ed7 */
    ALPHA,        /* 0x1ed8 */
    ALPHA,        /* 0x1ed9 */
    ALPHA,        /* 0x1eda */
    ALPHA,        /* 0x1edb */
    ALPHA,        /* 0x1edc */
    ALPHA,        /* 0x1edd */
    ALPHA,        /* 0x1ede */
    ALPHA,        /* 0x1edf */
    ALPHA,        /* 0x1ee0 */
    ALPHA,        /* 0x1ee1 */
    ALPHA,        /* 0x1ee2 */
    ALPHA,        /* 0x1ee3 */
    ALPHA,        /* 0x1ee4 */
    ALPHA,        /* 0x1ee5 */
    ALPHA,        /* 0x1ee6 */
    ALPHA,        /* 0x1ee7 */
    ALPHA,        /* 0x1ee8 */
    ALPHA,        /* 0x1ee9 */
    ALPHA,        /* 0x1eea */
    ALPHA,        /* 0x1eeb */
    ALPHA,        /* 0x1eec */
    ALPHA,        /* 0x1eed */
    ALPHA,        /* 0x1eee */
    ALPHA,        /* 0x1eef */
    ALPHA,        /* 0x1ef0 */
    ALPHA,        /* 0x1ef1 */
    ALPHA,        /* 0x1ef2 */
    ALPHA,        /* 0x1ef3 */
    ALPHA,        /* 0x1ef4 */
    ALPHA,        /* 0x1ef5 */
    ALPHA,        /* 0x1ef6 */
    ALPHA,        /* 0x1ef7 */
    ALPHA,        /* 0x1ef8 */
    ALPHA,        /* 0x1ef9 */
    OTHER,        /* 0x1efa */
    OTHER,        /* 0x1efb */
    OTHER,        /* 0x1efc */
    OTHER,        /* 0x1efd */
    OTHER,        /* 0x1efe */
    OTHER,        /* 0x1eff */
    OTHER,        /* 0x1f00 */
    OTHER,        /* 0x1f01 */
    OTHER,        /* 0x1f02 */
    OTHER,        /* 0x1f03 */
    OTHER,        /* 0x1f04 */
    OTHER,        /* 0x1f05 */
    OTHER,        /* 0x1f06 */
    OTHER,        /* 0x1f07 */
    OTHER,        /* 0x1f08 */
    OTHER,        /* 0x1f09 */
    OTHER,        /* 0x1f0a */
    OTHER,        /* 0x1f0b */
    OTHER,        /* 0x1f0c */
    OTHER,        /* 0x1f0d */
    OTHER,        /* 0x1f0e */
    OTHER,        /* 0x1f0f */
    OTHER,        /* 0x1f10 */
    OTHER,        /* 0x1f11 */
    OTHER,        /* 0x1f12 */
    OTHER,        /* 0x1f13 */
    OTHER,        /* 0x1f14 */
    OTHER,        /* 0x1f15 */
    OTHER,        /* 0x1f16 */
    OTHER,        /* 0x1f17 */
    OTHER,        /* 0x1f18 */
    OTHER,        /* 0x1f19 */
    OTHER,        /* 0x1f1a */
    OTHER,        /* 0x1f1b */
    OTHER,        /* 0x1f1c */
    OTHER,        /* 0x1f1d */
    OTHER,        /* 0x1f1e */
    OTHER,        /* 0x1f1f */
    OTHER,        /* 0x1f20 */
    OTHER,        /* 0x1f21 */
    OTHER,        /* 0x1f22 */
    OTHER,        /* 0x1f23 */
    OTHER,        /* 0x1f24 */
    OTHER,        /* 0x1f25 */
    OTHER,        /* 0x1f26 */
    OTHER,        /* 0x1f27 */
    OTHER,        /* 0x1f28 */
    OTHER,        /* 0x1f29 */
    OTHER,        /* 0x1f2a */
    OTHER,        /* 0x1f2b */
    OTHER,        /* 0x1f2c */
    OTHER,        /* 0x1f2d */
    OTHER,        /* 0x1f2e */
    OTHER,        /* 0x1f2f */
    OTHER,        /* 0x1f30 */
    OTHER,        /* 0x1f31 */
    OTHER,        /* 0x1f32 */
    OTHER,        /* 0x1f33 */
    OTHER,        /* 0x1f34 */
    OTHER,        /* 0x1f35 */
    OTHER,        /* 0x1f36 */
    OTHER,        /* 0x1f37 */
    OTHER,        /* 0x1f38 */
    OTHER,        /* 0x1f39 */
    OTHER,        /* 0x1f3a */
    OTHER,        /* 0x1f3b */
    OTHER,        /* 0x1f3c */
    OTHER,        /* 0x1f3d */
    OTHER,        /* 0x1f3e */
    OTHER,        /* 0x1f3f */
    OTHER,        /* 0x1f40 */
    OTHER,        /* 0x1f41 */
    OTHER,        /* 0x1f42 */
    OTHER,        /* 0x1f43 */
    OTHER,        /* 0x1f44 */
    OTHER,        /* 0x1f45 */
    OTHER,        /* 0x1f46 */
    OTHER,        /* 0x1f47 */
    OTHER,        /* 0x1f48 */
    OTHER,        /* 0x1f49 */
    OTHER,        /* 0x1f4a */
    OTHER,        /* 0x1f4b */
    OTHER,        /* 0x1f4c */
    OTHER,        /* 0x1f4d */
    OTHER,        /* 0x1f4e */
    OTHER,        /* 0x1f4f */
    OTHER,        /* 0x1f50 */
    OTHER,        /* 0x1f51 */
    OTHER,        /* 0x1f52 */
    OTHER,        /* 0x1f53 */
    OTHER,        /* 0x1f54 */
    OTHER,        /* 0x1f55 */
    OTHER,        /* 0x1f56 */
    OTHER,        /* 0x1f57 */
    OTHER,        /* 0x1f58 */
    OTHER,        /* 0x1f59 */
    OTHER,        /* 0x1f5a */
    OTHER,        /* 0x1f5b */
    OTHER,        /* 0x1f5c */
    OTHER,        /* 0x1f5d */
    OTHER,        /* 0x1f5e */
    OTHER,        /* 0x1f5f */
    OTHER,        /* 0x1f60 */
    OTHER,        /* 0x1f61 */
    OTHER,        /* 0x1f62 */
    OTHER,        /* 0x1f63 */
    OTHER,        /* 0x1f64 */
    OTHER,        /* 0x1f65 */
    OTHER,        /* 0x1f66 */
    OTHER,        /* 0x1f67 */
    OTHER,        /* 0x1f68 */
    OTHER,        /* 0x1f69 */
    OTHER,        /* 0x1f6a */
    OTHER,        /* 0x1f6b */
    OTHER,        /* 0x1f6c */
    OTHER,        /* 0x1f6d */
    OTHER,        /* 0x1f6e */
    OTHER,        /* 0x1f6f */
    OTHER,        /* 0x1f70 */
    OTHER,        /* 0x1f71 */
    OTHER,        /* 0x1f72 */
    OTHER,        /* 0x1f73 */
    OTHER,        /* 0x1f74 */
    OTHER,        /* 0x1f75 */
    OTHER,        /* 0x1f76 */
    OTHER,        /* 0x1f77 */
    OTHER,        /* 0x1f78 */
    OTHER,        /* 0x1f79 */
    OTHER,        /* 0x1f7a */
    OTHER,        /* 0x1f7b */
    OTHER,        /* 0x1f7c */
    OTHER,        /* 0x1f7d */
    OTHER,        /* 0x1f7e */
    OTHER,        /* 0x1f7f */
    OTHER,        /* 0x1f80 */
    OTHER,        /* 0x1f81 */
    OTHER,        /* 0x1f82 */
    OTHER,        /* 0x1f83 */
    OTHER,        /* 0x1f84 */
    OTHER,        /* 0x1f85 */
    OTHER,        /* 0x1f86 */
    OTHER,        /* 0x1f87 */
    OTHER,        /* 0x1f88 */
    OTHER,        /* 0x1f89 */
    OTHER,        /* 0x1f8a */
    OTHER,        /* 0x1f8b */
    OTHER,        /* 0x1f8c */
    OTHER,        /* 0x1f8d */
    OTHER,        /* 0x1f8e */
    OTHER,        /* 0x1f8f */
    OTHER,        /* 0x1f90 */
    OTHER,        /* 0x1f91 */
    OTHER,        /* 0x1f92 */
    OTHER,        /* 0x1f93 */
    OTHER,        /* 0x1f94 */
    OTHER,        /* 0x1f95 */
    OTHER,        /* 0x1f96 */
    OTHER,        /* 0x1f97 */
    OTHER,        /* 0x1f98 */
    OTHER,        /* 0x1f99 */
    OTHER,        /* 0x1f9a */
    OTHER,        /* 0x1f9b */
    OTHER,        /* 0x1f9c */
    OTHER,        /* 0x1f9d */
    OTHER,        /* 0x1f9e */
    OTHER,        /* 0x1f9f */
    OTHER,        /* 0x1fa0 */
    OTHER,        /* 0x1fa1 */
    OTHER,        /* 0x1fa2 */
    OTHER,        /* 0x1fa3 */
    OTHER,        /* 0x1fa4 */
    OTHER,        /* 0x1fa5 */
    OTHER,        /* 0x1fa6 */
    OTHER,        /* 0x1fa7 */
    OTHER,        /* 0x1fa8 */
    OTHER,        /* 0x1fa9 */
    OTHER,        /* 0x1faa */
    OTHER,        /* 0x1fab */
    OTHER,        /* 0x1fac */
    OTHER,        /* 0x1fad */
    OTHER,        /* 0x1fae */
    OTHER,        /* 0x1faf */
    OTHER,        /* 0x1fb0 */
    OTHER,        /* 0x1fb1 */
    OTHER,        /* 0x1fb2 */
    OTHER,        /* 0x1fb3 */
    OTHER,        /* 0x1fb4 */
    OTHER,        /* 0x1fb5 */
    OTHER,        /* 0x1fb6 */
    OTHER,        /* 0x1fb7 */
    OTHER,        /* 0x1fb8 */
    OTHER,        /* 0x1fb9 */
    OTHER,        /* 0x1fba */
    OTHER,        /* 0x1fbb */
    OTHER,        /* 0x1fbc */
    OTHER,        /* 0x1fbd */
    OTHER,        /* 0x1fbe */
    OTHER,        /* 0x1fbf */
    OTHER,        /* 0x1fc0 */
    OTHER,        /* 0x1fc1 */
    OTHER,        /* 0x1fc2 */
    OTHER,        /* 0x1fc3 */
    OTHER,        /* 0x1fc4 */
    OTHER,        /* 0x1fc5 */
    OTHER,        /* 0x1fc6 */
    OTHER,        /* 0x1fc7 */
    OTHER,        /* 0x1fc8 */
    OTHER,        /* 0x1fc9 */
    OTHER,        /* 0x1fca */
    OTHER,        /* 0x1fcb */
    OTHER,        /* 0x1fcc */
    OTHER,        /* 0x1fcd */
    OTHER,        /* 0x1fce */
    OTHER,        /* 0x1fcf */
    OTHER,        /* 0x1fd0 */
    OTHER,        /* 0x1fd1 */
    OTHER,        /* 0x1fd2 */
    OTHER,        /* 0x1fd3 */
    OTHER,        /* 0x1fd4 */
    OTHER,        /* 0x1fd5 */
    OTHER,        /* 0x1fd6 */
    OTHER,        /* 0x1fd7 */
    OTHER,        /* 0x1fd8 */
    OTHER,        /* 0x1fd9 */
    OTHER,        /* 0x1fda */
    OTHER,        /* 0x1fdb */
    OTHER,        /* 0x1fdc */
    OTHER,        /* 0x1fdd */
    OTHER,        /* 0x1fde */
    OTHER,        /* 0x1fdf */
    OTHER,        /* 0x1fe0 */
    OTHER,        /* 0x1fe1 */
    OTHER,        /* 0x1fe2 */
    OTHER,        /* 0x1fe3 */
    OTHER,        /* 0x1fe4 */
    OTHER,        /* 0x1fe5 */
    OTHER,        /* 0x1fe6 */
    OTHER,        /* 0x1fe7 */
    OTHER,        /* 0x1fe8 */
    OTHER,        /* 0x1fe9 */
    OTHER,        /* 0x1fea */
    OTHER,        /* 0x1feb */
    OTHER,        /* 0x1fec */
    OTHER,        /* 0x1fed */
    OTHER,        /* 0x1fee */
    OTHER,        /* 0x1fef */
    OTHER,        /* 0x1ff0 */
    OTHER,        /* 0x1ff1 */
    OTHER,        /* 0x1ff2 */
    OTHER,        /* 0x1ff3 */
    OTHER,        /* 0x1ff4 */
    OTHER,        /* 0x1ff5 */
    OTHER,        /* 0x1ff6 */
    OTHER,        /* 0x1ff7 */
    OTHER,        /* 0x1ff8 */
    OTHER,        /* 0x1ff9 */
    OTHER,        /* 0x1ffa */
    OTHER,        /* 0x1ffb */
    OTHER,        /* 0x1ffc */
    OTHER,        /* 0x1ffd */
    OTHER,        /* 0x1ffe */
    OTHER,        /* 0x1fff */
    SYMBOL,        /* 0x2000 */
    SYMBOL,        /* 0x2001 */
    SYMBOL,        /* 0x2002 */
    SYMBOL,        /* 0x2003 */
    SYMBOL,        /* 0x2004 */
    SYMBOL,        /* 0x2005 */
    SYMBOL,        /* 0x2006 */
    SYMBOL,        /* 0x2007 */
    SYMBOL,        /* 0x2008 */
    SYMBOL,        /* 0x2009 */
    SYMBOL,        /* 0x200a */
    SYMBOL,        /* 0x200b */
    SYMBOL,        /* 0x200c */
    SYMBOL,        /* 0x200d */
    SYMBOL,        /* 0x200e */
    SYMBOL,        /* 0x200f */
    SYMBOL,        /* 0x2010 */
    SYMBOL,        /* 0x2011 */
    SYMBOL,        /* 0x2012 */
    SYMBOL,        /* 0x2013 */
    SYMBOL,        /* 0x2014 */
    SYMBOL,        /* 0x2015 */
    SYMBOL,        /* 0x2016 */
    SYMBOL,        /* 0x2017 */
    SYMBOL,        /* 0x2018 */
    SYMBOL,        /* 0x2019 */
    SYMBOL,        /* 0x201a */
    SYMBOL,        /* 0x201b */
    SYMBOL,        /* 0x201c */
    SYMBOL,        /* 0x201d */
    SYMBOL,        /* 0x201e */
    SYMBOL,        /* 0x201f */
    SYMBOL,        /* 0x2020 */
    SYMBOL,        /* 0x2021 */
    SYMBOL,        /* 0x2022 */
    SYMBOL,        /* 0x2023 */
    SYMBOL,        /* 0x2024 */
    SYMBOL,        /* 0x2025 */
    SYMBOL,        /* 0x2026 */
    SYMBOL,        /* 0x2027 */
    SYMBOL,        /* 0x2028 */
    SYMBOL,        /* 0x2029 */
    SYMBOL,        /* 0x202a */
    SYMBOL,        /* 0x202b */
    SYMBOL,        /* 0x202c */
    SYMBOL,        /* 0x202d */
    SYMBOL,        /* 0x202e */
    SYMBOL,        /* 0x202f */
    SYMBOL,        /* 0x2030 */
    SYMBOL,        /* 0x2031 */
    SYMBOL,        /* 0x2032 */
    SYMBOL,        /* 0x2033 */
    SYMBOL,        /* 0x2034 */
    SYMBOL,        /* 0x2035 */
    SYMBOL,        /* 0x2036 */
    SYMBOL,        /* 0x2037 */
    SYMBOL,        /* 0x2038 */
    SYMBOL,        /* 0x2039 */
    SYMBOL,        /* 0x203a */
    SYMBOL,        /* 0x203b */
    SYMBOL,        /* 0x203c */
    SYMBOL,        /* 0x203d */
    SYMBOL,        /* 0x203e */
    SYMBOL,        /* 0x203f */
    SYMBOL,        /* 0x2040 */
    SYMBOL,        /* 0x2041 */
    SYMBOL,        /* 0x2042 */
    SYMBOL,        /* 0x2043 */
    SYMBOL,        /* 0x2044 */
    SYMBOL,        /* 0x2045 */
    SYMBOL,        /* 0x2046 */
    SYMBOL,        /* 0x2047 */
    SYMBOL,        /* 0x2048 */
    SYMBOL,        /* 0x2049 */
    SYMBOL,        /* 0x204a */
    SYMBOL,        /* 0x204b */
    SYMBOL,        /* 0x204c */
    SYMBOL,        /* 0x204d */
    SYMBOL,        /* 0x204e */
    SYMBOL,        /* 0x204f */
    SYMBOL,        /* 0x2050 */
    SYMBOL,        /* 0x2051 */
    SYMBOL,        /* 0x2052 */
    SYMBOL,        /* 0x2053 */
    SYMBOL,        /* 0x2054 */
    SYMBOL,        /* 0x2055 */
    SYMBOL,        /* 0x2056 */
    SYMBOL,        /* 0x2057 */
    SYMBOL,        /* 0x2058 */
    SYMBOL,        /* 0x2059 */
    SYMBOL,        /* 0x205a */
    SYMBOL,        /* 0x205b */
    SYMBOL,        /* 0x205c */
    SYMBOL,        /* 0x205d */
    SYMBOL,        /* 0x205e */
    SYMBOL,        /* 0x205f */
    SYMBOL,        /* 0x2060 */
    SYMBOL,        /* 0x2061 */
    SYMBOL,        /* 0x2062 */
    SYMBOL,        /* 0x2063 */
    SYMBOL,        /* 0x2064 */
    SYMBOL,        /* 0x2065 */
    SYMBOL,        /* 0x2066 */
    SYMBOL,        /* 0x2067 */
    SYMBOL,        /* 0x2068 */
    SYMBOL,        /* 0x2069 */
    SYMBOL,        /* 0x206a */
    SYMBOL,        /* 0x206b */
    SYMBOL,        /* 0x206c */
    SYMBOL,        /* 0x206d */
    SYMBOL,        /* 0x206e */
    SYMBOL,        /* 0x206f */
    ALPHANUMERIC,        /* 0x2070 */
    ALPHANUMERIC,        /* 0x2071 */
    ALPHANUMERIC,        /* 0x2072 */
    ALPHANUMERIC,        /* 0x2073 */
    ALPHANUMERIC,        /* 0x2074 */
    ALPHANUMERIC,        /* 0x2075 */
    ALPHANUMERIC,        /* 0x2076 */
    ALPHANUMERIC,        /* 0x2077 */
    ALPHANUMERIC,        /* 0x2078 */
    ALPHANUMERIC,        /* 0x2079 */
    ALPHANUMERIC,        /* 0x207a */
    ALPHANUMERIC,        /* 0x207b */
    ALPHANUMERIC,        /* 0x207c */
    ALPHANUMERIC,        /* 0x207d */
    ALPHANUMERIC,        /* 0x207e */
    ALPHANUMERIC,        /* 0x207f */
    ALPHANUMERIC,        /* 0x2080 */
    ALPHANUMERIC,        /* 0x2081 */
    ALPHANUMERIC,        /* 0x2082 */
    ALPHANUMERIC,        /* 0x2083 */
    ALPHANUMERIC,        /* 0x2084 */
    ALPHANUMERIC,        /* 0x2085 */
    ALPHANUMERIC,        /* 0x2086 */
    ALPHANUMERIC,        /* 0x2087 */
    ALPHANUMERIC,        /* 0x2088 */
    ALPHANUMERIC,        /* 0x2089 */
    ALPHANUMERIC,        /* 0x208a */
    ALPHANUMERIC,        /* 0x208b */
    ALPHANUMERIC,        /* 0x208c */
    ALPHANUMERIC,        /* 0x208d */
    ALPHANUMERIC,        /* 0x208e */
    ALPHANUMERIC,        /* 0x208f */
    ALPHANUMERIC,        /* 0x2090 */
    ALPHANUMERIC,        /* 0x2091 */
    ALPHANUMERIC,        /* 0x2092 */
    ALPHANUMERIC,        /* 0x2093 */
    ALPHANUMERIC,        /* 0x2094 */
    ALPHANUMERIC,        /* 0x2095 */
    ALPHANUMERIC,        /* 0x2096 */
    ALPHANUMERIC,        /* 0x2097 */
    ALPHANUMERIC,        /* 0x2098 */
    ALPHANUMERIC,        /* 0x2099 */
    ALPHANUMERIC,        /* 0x209a */
    ALPHANUMERIC,        /* 0x209b */
    ALPHANUMERIC,        /* 0x209c */
    ALPHANUMERIC,        /* 0x209d */
    ALPHANUMERIC,        /* 0x209e */
    ALPHANUMERIC,        /* 0x209f */
    SYMBOL,        /* 0x20a0 */
    SYMBOL,        /* 0x20a1 */
    SYMBOL,        /* 0x20a2 */
    SYMBOL,        /* 0x20a3 */
    SYMBOL,        /* 0x20a4 */
    SYMBOL,        /* 0x20a5 */
    SYMBOL,        /* 0x20a6 */
    SYMBOL,        /* 0x20a7 */
    SYMBOL,        /* 0x20a8 */
    SYMBOL,        /* 0x20a9 */
    SYMBOL,        /* 0x20aa */
    SYMBOL,        /* 0x20ab */
    SYMBOL,        /* 0x20ac */
    SYMBOL,        /* 0x20ad */
    SYMBOL,        /* 0x20ae */
    SYMBOL,        /* 0x20af */
    SYMBOL,        /* 0x20b0 */
    SYMBOL,        /* 0x20b1 */
    SYMBOL,        /* 0x20b2 */
    SYMBOL,        /* 0x20b3 */
    SYMBOL,        /* 0x20b4 */
    SYMBOL,        /* 0x20b5 */
    SYMBOL,        /* 0x20b6 */
    SYMBOL,        /* 0x20b7 */
    SYMBOL,        /* 0x20b8 */
    SYMBOL,        /* 0x20b9 */
    SYMBOL,        /* 0x20ba */
    SYMBOL,        /* 0x20bb */
    SYMBOL,        /* 0x20bc */
    SYMBOL,        /* 0x20bd */
    SYMBOL,        /* 0x20be */
    SYMBOL,        /* 0x20bf */
    SYMBOL,        /* 0x20c0 */
    SYMBOL,        /* 0x20c1 */
    SYMBOL,        /* 0x20c2 */
    SYMBOL,        /* 0x20c3 */
    SYMBOL,        /* 0x20c4 */
    SYMBOL,        /* 0x20c5 */
    SYMBOL,        /* 0x20c6 */
    SYMBOL,        /* 0x20c7 */
    SYMBOL,        /* 0x20c8 */
    SYMBOL,        /* 0x20c9 */
    SYMBOL,        /* 0x20ca */
    SYMBOL,        /* 0x20cb */
    SYMBOL,        /* 0x20cc */
    SYMBOL,        /* 0x20cd */
    SYMBOL,        /* 0x20ce */
    SYMBOL,        /* 0x20cf */
    SYMBOL,        /* 0x20d0 */
    SYMBOL,        /* 0x20d1 */
    SYMBOL,        /* 0x20d2 */
    SYMBOL,        /* 0x20d3 */
    SYMBOL,        /* 0x20d4 */
    SYMBOL,        /* 0x20d5 */
    SYMBOL,        /* 0x20d6 */
    SYMBOL,        /* 0x20d7 */
    SYMBOL,        /* 0x20d8 */
    SYMBOL,        /* 0x20d9 */
    SYMBOL,        /* 0x20da */
    SYMBOL,        /* 0x20db */
    SYMBOL,        /* 0x20dc */
    SYMBOL,        /* 0x20dd */
    SYMBOL,        /* 0x20de */
    SYMBOL,        /* 0x20df */
    SYMBOL,        /* 0x20e0 */
    SYMBOL,        /* 0x20e1 */
    SYMBOL,        /* 0x20e2 */
    SYMBOL,        /* 0x20e3 */
    SYMBOL,        /* 0x20e4 */
    SYMBOL,        /* 0x20e5 */
    SYMBOL,        /* 0x20e6 */
    SYMBOL,        /* 0x20e7 */
    SYMBOL,        /* 0x20e8 */
    SYMBOL,        /* 0x20e9 */
    SYMBOL,        /* 0x20ea */
    SYMBOL,        /* 0x20eb */
    SYMBOL,        /* 0x20ec */
    SYMBOL,        /* 0x20ed */
    SYMBOL,        /* 0x20ee */
    SYMBOL,        /* 0x20ef */
    SYMBOL,        /* 0x20f0 */
    SYMBOL,        /* 0x20f1 */
    SYMBOL,        /* 0x20f2 */
    SYMBOL,        /* 0x20f3 */
    SYMBOL,        /* 0x20f4 */
    SYMBOL,        /* 0x20f5 */
    SYMBOL,        /* 0x20f6 */
    SYMBOL,        /* 0x20f7 */
    SYMBOL,        /* 0x20f8 */
    SYMBOL,        /* 0x20f9 */
    SYMBOL,        /* 0x20fa */
    SYMBOL,        /* 0x20fb */
    SYMBOL,        /* 0x20fc */
    SYMBOL,        /* 0x20fd */
    SYMBOL,        /* 0x20fe */
    SYMBOL,        /* 0x20ff */
    SYMBOL,        /* 0x2100 */
    SYMBOL,        /* 0x2101 */
    SYMBOL,        /* 0x2102 */
    SYMBOL,        /* 0x2103 */
    SYMBOL,        /* 0x2104 */
    SYMBOL,        /* 0x2105 */
    SYMBOL,        /* 0x2106 */
    SYMBOL,        /* 0x2107 */
    SYMBOL,        /* 0x2108 */
    SYMBOL,        /* 0x2109 */
    SYMBOL,        /* 0x210a */
    SYMBOL,        /* 0x210b */
    SYMBOL,        /* 0x210c */
    SYMBOL,        /* 0x210d */
    SYMBOL,        /* 0x210e */
    SYMBOL,        /* 0x210f */
    SYMBOL,        /* 0x2110 */
    SYMBOL,        /* 0x2111 */
    SYMBOL,        /* 0x2112 */
    SYMBOL,        /* 0x2113 */
    SYMBOL,        /* 0x2114 */
    SYMBOL,        /* 0x2115 */
    SYMBOL,        /* 0x2116 */
    SYMBOL,        /* 0x2117 */
    SYMBOL,        /* 0x2118 */
    SYMBOL,        /* 0x2119 */
    SYMBOL,        /* 0x211a */
    SYMBOL,        /* 0x211b */
    SYMBOL,        /* 0x211c */
    SYMBOL,        /* 0x211d */
    SYMBOL,        /* 0x211e */
    SYMBOL,        /* 0x211f */
    SYMBOL,        /* 0x2120 */
    SYMBOL,        /* 0x2121 */
    SYMBOL,        /* 0x2122 */
    SYMBOL,        /* 0x2123 */
    SYMBOL,        /* 0x2124 */
    SYMBOL,        /* 0x2125 */
    SYMBOL,        /* 0x2126 */
    SYMBOL,        /* 0x2127 */
    SYMBOL,        /* 0x2128 */
    SYMBOL,        /* 0x2129 */
    SYMBOL,        /* 0x212a */
    SYMBOL,        /* 0x212b */
    SYMBOL,        /* 0x212c */
    SYMBOL,        /* 0x212d */
    SYMBOL,        /* 0x212e */
    SYMBOL,        /* 0x212f */
    SYMBOL,        /* 0x2130 */
    SYMBOL,        /* 0x2131 */
    SYMBOL,        /* 0x2132 */
    SYMBOL,        /* 0x2133 */
    SYMBOL,        /* 0x2134 */
    SYMBOL,        /* 0x2135 */
    SYMBOL,        /* 0x2136 */
    SYMBOL,        /* 0x2137 */
    SYMBOL,        /* 0x2138 */
    SYMBOL,        /* 0x2139 */
    SYMBOL,        /* 0x213a */
    SYMBOL,        /* 0x213b */
    SYMBOL,        /* 0x213c */
    SYMBOL,        /* 0x213d */
    SYMBOL,        /* 0x213e */
    SYMBOL,        /* 0x213f */
    SYMBOL,        /* 0x2140 */
    SYMBOL,        /* 0x2141 */
    SYMBOL,        /* 0x2142 */
    SYMBOL,        /* 0x2143 */
    SYMBOL,        /* 0x2144 */
    SYMBOL,        /* 0x2145 */
    SYMBOL,        /* 0x2146 */
    SYMBOL,        /* 0x2147 */
    SYMBOL,        /* 0x2148 */
    SYMBOL,        /* 0x2149 */
    SYMBOL,        /* 0x214a */
    SYMBOL,        /* 0x214b */
    SYMBOL,        /* 0x214c */
    SYMBOL,        /* 0x214d */
    SYMBOL,        /* 0x214e */
    SYMBOL,        /* 0x214f */
    ALPHANUMERIC,        /* 0x2150 */
    ALPHANUMERIC,        /* 0x2151 */
    ALPHANUMERIC,        /* 0x2152 */
    ALPHANUMERIC,        /* 0x2153 */
    ALPHANUMERIC,        /* 0x2154 */
    ALPHANUMERIC,        /* 0x2155 */
    ALPHANUMERIC,        /* 0x2156 */
    ALPHANUMERIC,        /* 0x2157 */
    ALPHANUMERIC,        /* 0x2158 */
    ALPHANUMERIC,        /* 0x2159 */
    ALPHANUMERIC,        /* 0x215a */
    ALPHANUMERIC,        /* 0x215b */
    ALPHANUMERIC,        /* 0x215c */
    ALPHANUMERIC,        /* 0x215d */
    ALPHANUMERIC,        /* 0x215e */
    ALPHANUMERIC,        /* 0x215f */
    ALPHANUMERIC,        /* 0x2160 */
    ALPHANUMERIC,        /* 0x2161 */
    ALPHANUMERIC,        /* 0x2162 */
    ALPHANUMERIC,        /* 0x2163 */
    ALPHANUMERIC,        /* 0x2164 */
    ALPHANUMERIC,        /* 0x2165 */
    ALPHANUMERIC,        /* 0x2166 */
    ALPHANUMERIC,        /* 0x2167 */
    ALPHANUMERIC,        /* 0x2168 */
    ALPHANUMERIC,        /* 0x2169 */
    ALPHANUMERIC,        /* 0x216a */
    ALPHANUMERIC,        /* 0x216b */
    ALPHANUMERIC,        /* 0x216c */
    ALPHANUMERIC,        /* 0x216d */
    ALPHANUMERIC,        /* 0x216e */
    ALPHANUMERIC,        /* 0x216f */
    ALPHANUMERIC,        /* 0x2170 */
    ALPHANUMERIC,        /* 0x2171 */
    ALPHANUMERIC,        /* 0x2172 */
    ALPHANUMERIC,        /* 0x2173 */
    ALPHANUMERIC,        /* 0x2174 */
    ALPHANUMERIC,        /* 0x2175 */
    ALPHANUMERIC,        /* 0x2176 */
    ALPHANUMERIC,        /* 0x2177 */
    ALPHANUMERIC,        /* 0x2178 */
    ALPHANUMERIC,        /* 0x2179 */
    ALPHANUMERIC,        /* 0x217a */
    ALPHANUMERIC,        /* 0x217b */
    ALPHANUMERIC,        /* 0x217c */
    ALPHANUMERIC,        /* 0x217d */
    ALPHANUMERIC,        /* 0x217e */
    ALPHANUMERIC,        /* 0x217f */
    ALPHANUMERIC,        /* 0x2180 */
    ALPHANUMERIC,        /* 0x2181 */
    ALPHANUMERIC,        /* 0x2182 */
    ALPHANUMERIC,        /* 0x2183 */
    ALPHANUMERIC,        /* 0x2184 */
    ALPHANUMERIC,        /* 0x2185 */
    ALPHANUMERIC,        /* 0x2186 */
    ALPHANUMERIC,        /* 0x2187 */
    ALPHANUMERIC,        /* 0x2188 */
    ALPHANUMERIC,        /* 0x2189 */
    ALPHANUMERIC,        /* 0x218a */
    ALPHANUMERIC,        /* 0x218b */
    ALPHANUMERIC,        /* 0x218c */
    ALPHANUMERIC,        /* 0x218d */
    ALPHANUMERIC,        /* 0x218e */
    ALPHANUMERIC,        /* 0x218f */
    SYMBOL,        /* 0x2190 */
    SYMBOL,        /* 0x2191 */
    SYMBOL,        /* 0x2192 */
    SYMBOL,        /* 0x2193 */
    SYMBOL,        /* 0x2194 */
    SYMBOL,        /* 0x2195 */
    SYMBOL,        /* 0x2196 */
    SYMBOL,        /* 0x2197 */
    SYMBOL,        /* 0x2198 */
    SYMBOL,        /* 0x2199 */
    SYMBOL,        /* 0x219a */
    SYMBOL,        /* 0x219b */
    SYMBOL,        /* 0x219c */
    SYMBOL,        /* 0x219d */
    SYMBOL,        /* 0x219e */
    SYMBOL,        /* 0x219f */
    SYMBOL,        /* 0x21a0 */
    SYMBOL,        /* 0x21a1 */
    SYMBOL,        /* 0x21a2 */
    SYMBOL,        /* 0x21a3 */
    SYMBOL,        /* 0x21a4 */
    SYMBOL,        /* 0x21a5 */
    SYMBOL,        /* 0x21a6 */
    SYMBOL,        /* 0x21a7 */
    SYMBOL,        /* 0x21a8 */
    SYMBOL,        /* 0x21a9 */
    SYMBOL,        /* 0x21aa */
    SYMBOL,        /* 0x21ab */
    SYMBOL,        /* 0x21ac */
    SYMBOL,        /* 0x21ad */
    SYMBOL,        /* 0x21ae */
    SYMBOL,        /* 0x21af */
    SYMBOL,        /* 0x21b0 */
    SYMBOL,        /* 0x21b1 */
    SYMBOL,        /* 0x21b2 */
    SYMBOL,        /* 0x21b3 */
    SYMBOL,        /* 0x21b4 */
    SYMBOL,        /* 0x21b5 */
    SYMBOL,        /* 0x21b6 */
    SYMBOL,        /* 0x21b7 */
    SYMBOL,        /* 0x21b8 */
    SYMBOL,        /* 0x21b9 */
    SYMBOL,        /* 0x21ba */
    SYMBOL,        /* 0x21bb */
    SYMBOL,        /* 0x21bc */
    SYMBOL,        /* 0x21bd */
    SYMBOL,        /* 0x21be */
    SYMBOL,        /* 0x21bf */
    SYMBOL,        /* 0x21c0 */
    SYMBOL,        /* 0x21c1 */
    SYMBOL,        /* 0x21c2 */
    SYMBOL,        /* 0x21c3 */
    SYMBOL,        /* 0x21c4 */
    SYMBOL,        /* 0x21c5 */
    SYMBOL,        /* 0x21c6 */
    SYMBOL,        /* 0x21c7 */
    SYMBOL,        /* 0x21c8 */
    SYMBOL,        /* 0x21c9 */
    SYMBOL,        /* 0x21ca */
    SYMBOL,        /* 0x21cb */
    SYMBOL,        /* 0x21cc */
    SYMBOL,        /* 0x21cd */
    SYMBOL,        /* 0x21ce */
    SYMBOL,        /* 0x21cf */
    SYMBOL,        /* 0x21d0 */
    SYMBOL,        /* 0x21d1 */
    SYMBOL,        /* 0x21d2 */
    SYMBOL,        /* 0x21d3 */
    SYMBOL,        /* 0x21d4 */
    SYMBOL,        /* 0x21d5 */
    SYMBOL,        /* 0x21d6 */
    SYMBOL,        /* 0x21d7 */
    SYMBOL,        /* 0x21d8 */
    SYMBOL,        /* 0x21d9 */
    SYMBOL,        /* 0x21da */
    SYMBOL,        /* 0x21db */
    SYMBOL,        /* 0x21dc */
    SYMBOL,        /* 0x21dd */
    SYMBOL,        /* 0x21de */
    SYMBOL,        /* 0x21df */
    SYMBOL,        /* 0x21e0 */
    SYMBOL,        /* 0x21e1 */
    SYMBOL,        /* 0x21e2 */
    SYMBOL,        /* 0x21e3 */
    SYMBOL,        /* 0x21e4 */
    SYMBOL,        /* 0x21e5 */
    SYMBOL,        /* 0x21e6 */
    SYMBOL,        /* 0x21e7 */
    SYMBOL,        /* 0x21e8 */
    SYMBOL,        /* 0x21e9 */
    SYMBOL,        /* 0x21ea */
    SYMBOL,        /* 0x21eb */
    SYMBOL,        /* 0x21ec */
    SYMBOL,        /* 0x21ed */
    SYMBOL,        /* 0x21ee */
    SYMBOL,        /* 0x21ef */
    SYMBOL,        /* 0x21f0 */
    SYMBOL,        /* 0x21f1 */
    SYMBOL,        /* 0x21f2 */
    SYMBOL,        /* 0x21f3 */
    SYMBOL,        /* 0x21f4 */
    SYMBOL,        /* 0x21f5 */
    SYMBOL,        /* 0x21f6 */
    SYMBOL,        /* 0x21f7 */
    SYMBOL,        /* 0x21f8 */
    SYMBOL,        /* 0x21f9 */
    SYMBOL,        /* 0x21fa */
    SYMBOL,        /* 0x21fb */
    SYMBOL,        /* 0x21fc */
    SYMBOL,        /* 0x21fd */
    SYMBOL,        /* 0x21fe */
    SYMBOL,        /* 0x21ff */
    SYMBOL,        /* 0x2200 */
    SYMBOL,        /* 0x2201 */
    SYMBOL,        /* 0x2202 */
    SYMBOL,        /* 0x2203 */
    SYMBOL,        /* 0x2204 */
    SYMBOL,        /* 0x2205 */
    SYMBOL,        /* 0x2206 */
    SYMBOL,        /* 0x2207 */
    SYMBOL,        /* 0x2208 */
    SYMBOL,        /* 0x2209 */
    SYMBOL,        /* 0x220a */
    SYMBOL,        /* 0x220b */
    SYMBOL,        /* 0x220c */
    SYMBOL,        /* 0x220d */
    SYMBOL,        /* 0x220e */
    SYMBOL,        /* 0x220f */
    SYMBOL,        /* 0x2210 */
    SYMBOL,        /* 0x2211 */
    SYMBOL,        /* 0x2212 */
    SYMBOL,        /* 0x2213 */
    SYMBOL,        /* 0x2214 */
    SYMBOL,        /* 0x2215 */
    SYMBOL,        /* 0x2216 */
    SYMBOL,        /* 0x2217 */
    SYMBOL,        /* 0x2218 */
    SYMBOL,        /* 0x2219 */
    SYMBOL,        /* 0x221a */
    SYMBOL,        /* 0x221b */
    SYMBOL,        /* 0x221c */
    SYMBOL,        /* 0x221d */
    SYMBOL,        /* 0x221e */
    SYMBOL,        /* 0x221f */
    SYMBOL,        /* 0x2220 */
    SYMBOL,        /* 0x2221 */
    SYMBOL,        /* 0x2222 */
    SYMBOL,        /* 0x2223 */
    SYMBOL,        /* 0x2224 */
    SYMBOL,        /* 0x2225 */
    SYMBOL,        /* 0x2226 */
    SYMBOL,        /* 0x2227 */
    SYMBOL,        /* 0x2228 */
    SYMBOL,        /* 0x2229 */
    SYMBOL,        /* 0x222a */
    SYMBOL,        /* 0x222b */
    SYMBOL,        /* 0x222c */
    SYMBOL,        /* 0x222d */
    SYMBOL,        /* 0x222e */
    SYMBOL,        /* 0x222f */
    SYMBOL,        /* 0x2230 */
    SYMBOL,        /* 0x2231 */
    SYMBOL,        /* 0x2232 */
    SYMBOL,        /* 0x2233 */
    SYMBOL,        /* 0x2234 */
    SYMBOL,        /* 0x2235 */
    SYMBOL,        /* 0x2236 */
    SYMBOL,        /* 0x2237 */
    SYMBOL,        /* 0x2238 */
    SYMBOL,        /* 0x2239 */
    SYMBOL,        /* 0x223a */
    SYMBOL,        /* 0x223b */
    SYMBOL,        /* 0x223c */
    SYMBOL,        /* 0x223d */
    SYMBOL,        /* 0x223e */
    SYMBOL,        /* 0x223f */
    SYMBOL,        /* 0x2240 */
    SYMBOL,        /* 0x2241 */
    SYMBOL,        /* 0x2242 */
    SYMBOL,        /* 0x2243 */
    SYMBOL,        /* 0x2244 */
    SYMBOL,        /* 0x2245 */
    SYMBOL,        /* 0x2246 */
    SYMBOL,        /* 0x2247 */
    SYMBOL,        /* 0x2248 */
    SYMBOL,        /* 0x2249 */
    SYMBOL,        /* 0x224a */
    SYMBOL,        /* 0x224b */
    SYMBOL,        /* 0x224c */
    SYMBOL,        /* 0x224d */
    SYMBOL,        /* 0x224e */
    SYMBOL,        /* 0x224f */
    SYMBOL,        /* 0x2250 */
    SYMBOL,        /* 0x2251 */
    SYMBOL,        /* 0x2252 */
    SYMBOL,        /* 0x2253 */
    SYMBOL,        /* 0x2254 */
    SYMBOL,        /* 0x2255 */
    SYMBOL,        /* 0x2256 */
    SYMBOL,        /* 0x2257 */
    SYMBOL,        /* 0x2258 */
    SYMBOL,        /* 0x2259 */
    SYMBOL,        /* 0x225a */
    SYMBOL,        /* 0x225b */
    SYMBOL,        /* 0x225c */
    SYMBOL,        /* 0x225d */
    SYMBOL,        /* 0x225e */
    SYMBOL,        /* 0x225f */
    SYMBOL,        /* 0x2260 */
    SYMBOL,        /* 0x2261 */
    SYMBOL,        /* 0x2262 */
    SYMBOL,        /* 0x2263 */
    SYMBOL,        /* 0x2264 */
    SYMBOL,        /* 0x2265 */
    SYMBOL,        /* 0x2266 */
    SYMBOL,        /* 0x2267 */
    SYMBOL,        /* 0x2268 */
    SYMBOL,        /* 0x2269 */
    SYMBOL,        /* 0x226a */
    SYMBOL,        /* 0x226b */
    SYMBOL,        /* 0x226c */
    SYMBOL,        /* 0x226d */
    SYMBOL,        /* 0x226e */
    SYMBOL,        /* 0x226f */
    SYMBOL,        /* 0x2270 */
    SYMBOL,        /* 0x2271 */
    SYMBOL,        /* 0x2272 */
    SYMBOL,        /* 0x2273 */
    SYMBOL,        /* 0x2274 */
    SYMBOL,        /* 0x2275 */
    SYMBOL,        /* 0x2276 */
    SYMBOL,        /* 0x2277 */
    SYMBOL,        /* 0x2278 */
    SYMBOL,        /* 0x2279 */
    SYMBOL,        /* 0x227a */
    SYMBOL,        /* 0x227b */
    SYMBOL,        /* 0x227c */
    SYMBOL,        /* 0x227d */
    SYMBOL,        /* 0x227e */
    SYMBOL,        /* 0x227f */
    SYMBOL,        /* 0x2280 */
    SYMBOL,        /* 0x2281 */
    SYMBOL,        /* 0x2282 */
    SYMBOL,        /* 0x2283 */
    SYMBOL,        /* 0x2284 */
    SYMBOL,        /* 0x2285 */
    SYMBOL,        /* 0x2286 */
    SYMBOL,        /* 0x2287 */
    SYMBOL,        /* 0x2288 */
    SYMBOL,        /* 0x2289 */
    SYMBOL,        /* 0x228a */
    SYMBOL,        /* 0x228b */
    SYMBOL,        /* 0x228c */
    SYMBOL,        /* 0x228d */
    SYMBOL,        /* 0x228e */
    SYMBOL,        /* 0x228f */
    SYMBOL,        /* 0x2290 */
    SYMBOL,        /* 0x2291 */
    SYMBOL,        /* 0x2292 */
    SYMBOL,        /* 0x2293 */
    SYMBOL,        /* 0x2294 */
    SYMBOL,        /* 0x2295 */
    SYMBOL,        /* 0x2296 */
    SYMBOL,        /* 0x2297 */
    SYMBOL,        /* 0x2298 */
    SYMBOL,        /* 0x2299 */
    SYMBOL,        /* 0x229a */
    SYMBOL,        /* 0x229b */
    SYMBOL,        /* 0x229c */
    SYMBOL,        /* 0x229d */
    SYMBOL,        /* 0x229e */
    SYMBOL,        /* 0x229f */
    SYMBOL,        /* 0x22a0 */
    SYMBOL,        /* 0x22a1 */
    SYMBOL,        /* 0x22a2 */
    SYMBOL,        /* 0x22a3 */
    SYMBOL,        /* 0x22a4 */
    SYMBOL,        /* 0x22a5 */
    SYMBOL,        /* 0x22a6 */
    SYMBOL,        /* 0x22a7 */
    SYMBOL,        /* 0x22a8 */
    SYMBOL,        /* 0x22a9 */
    SYMBOL,        /* 0x22aa */
    SYMBOL,        /* 0x22ab */
    SYMBOL,        /* 0x22ac */
    SYMBOL,        /* 0x22ad */
    SYMBOL,        /* 0x22ae */
    SYMBOL,        /* 0x22af */
    SYMBOL,        /* 0x22b0 */
    SYMBOL,        /* 0x22b1 */
    SYMBOL,        /* 0x22b2 */
    SYMBOL,        /* 0x22b3 */
    SYMBOL,        /* 0x22b4 */
    SYMBOL,        /* 0x22b5 */
    SYMBOL,        /* 0x22b6 */
    SYMBOL,        /* 0x22b7 */
    SYMBOL,        /* 0x22b8 */
    SYMBOL,        /* 0x22b9 */
    SYMBOL,        /* 0x22ba */
    SYMBOL,        /* 0x22bb */
    SYMBOL,        /* 0x22bc */
    SYMBOL,        /* 0x22bd */
    SYMBOL,        /* 0x22be */
    SYMBOL,        /* 0x22bf */
    SYMBOL,        /* 0x22c0 */
    SYMBOL,        /* 0x22c1 */
    SYMBOL,        /* 0x22c2 */
    SYMBOL,        /* 0x22c3 */
    SYMBOL,        /* 0x22c4 */
    SYMBOL,        /* 0x22c5 */
    SYMBOL,        /* 0x22c6 */
    SYMBOL,        /* 0x22c7 */
    SYMBOL,        /* 0x22c8 */
    SYMBOL,        /* 0x22c9 */
    SYMBOL,        /* 0x22ca */
    SYMBOL,        /* 0x22cb */
    SYMBOL,        /* 0x22cc */
    SYMBOL,        /* 0x22cd */
    SYMBOL,        /* 0x22ce */
    SYMBOL,        /* 0x22cf */
    SYMBOL,        /* 0x22d0 */
    SYMBOL,        /* 0x22d1 */
    SYMBOL,        /* 0x22d2 */
    SYMBOL,        /* 0x22d3 */
    SYMBOL,        /* 0x22d4 */
    SYMBOL,        /* 0x22d5 */
    SYMBOL,        /* 0x22d6 */
    SYMBOL,        /* 0x22d7 */
    SYMBOL,        /* 0x22d8 */
    SYMBOL,        /* 0x22d9 */
    SYMBOL,        /* 0x22da */
    SYMBOL,        /* 0x22db */
    SYMBOL,        /* 0x22dc */
    SYMBOL,        /* 0x22dd */
    SYMBOL,        /* 0x22de */
    SYMBOL,        /* 0x22df */
    SYMBOL,        /* 0x22e0 */
    SYMBOL,        /* 0x22e1 */
    SYMBOL,        /* 0x22e2 */
    SYMBOL,        /* 0x22e3 */
    SYMBOL,        /* 0x22e4 */
    SYMBOL,        /* 0x22e5 */
    SYMBOL,        /* 0x22e6 */
    SYMBOL,        /* 0x22e7 */
    SYMBOL,        /* 0x22e8 */
    SYMBOL,        /* 0x22e9 */
    SYMBOL,        /* 0x22ea */
    SYMBOL,        /* 0x22eb */
    SYMBOL,        /* 0x22ec */
    SYMBOL,        /* 0x22ed */
    SYMBOL,        /* 0x22ee */
    SYMBOL,        /* 0x22ef */
    SYMBOL,        /* 0x22f0 */
    SYMBOL,        /* 0x22f1 */
    SYMBOL,        /* 0x22f2 */
    SYMBOL,        /* 0x22f3 */
    SYMBOL,        /* 0x22f4 */
    SYMBOL,        /* 0x22f5 */
    SYMBOL,        /* 0x22f6 */
    SYMBOL,        /* 0x22f7 */
    SYMBOL,        /* 0x22f8 */
    SYMBOL,        /* 0x22f9 */
    SYMBOL,        /* 0x22fa */
    SYMBOL,        /* 0x22fb */
    SYMBOL,        /* 0x22fc */
    SYMBOL,        /* 0x22fd */
    SYMBOL,        /* 0x22fe */
    SYMBOL,        /* 0x22ff */
    SYMBOL,        /* 0x2300 */
    SYMBOL,        /* 0x2301 */
    SYMBOL,        /* 0x2302 */
    SYMBOL,        /* 0x2303 */
    SYMBOL,        /* 0x2304 */
    SYMBOL,        /* 0x2305 */
    SYMBOL,        /* 0x2306 */
    SYMBOL,        /* 0x2307 */
    SYMBOL,        /* 0x2308 */
    SYMBOL,        /* 0x2309 */
    SYMBOL,        /* 0x230a */
    SYMBOL,        /* 0x230b */
    SYMBOL,        /* 0x230c */
    SYMBOL,        /* 0x230d */
    SYMBOL,        /* 0x230e */
    SYMBOL,        /* 0x230f */
    SYMBOL,        /* 0x2310 */
    SYMBOL,        /* 0x2311 */
    SYMBOL,        /* 0x2312 */
    SYMBOL,        /* 0x2313 */
    SYMBOL,        /* 0x2314 */
    SYMBOL,        /* 0x2315 */
    SYMBOL,        /* 0x2316 */
    SYMBOL,        /* 0x2317 */
    SYMBOL,        /* 0x2318 */
    SYMBOL,        /* 0x2319 */
    SYMBOL,        /* 0x231a */
    SYMBOL,        /* 0x231b */
    SYMBOL,        /* 0x231c */
    SYMBOL,        /* 0x231d */
    SYMBOL,        /* 0x231e */
    SYMBOL,        /* 0x231f */
    SYMBOL,        /* 0x2320 */
    SYMBOL,        /* 0x2321 */
    SYMBOL,        /* 0x2322 */
    SYMBOL,        /* 0x2323 */
    SYMBOL,        /* 0x2324 */
    SYMBOL,        /* 0x2325 */
    SYMBOL,        /* 0x2326 */
    SYMBOL,        /* 0x2327 */
    SYMBOL,        /* 0x2328 */
    SYMBOL,        /* 0x2329 */
    SYMBOL,        /* 0x232a */
    SYMBOL,        /* 0x232b */
    SYMBOL,        /* 0x232c */
    SYMBOL,        /* 0x232d */
    SYMBOL,        /* 0x232e */
    SYMBOL,        /* 0x232f */
    SYMBOL,        /* 0x2330 */
    SYMBOL,        /* 0x2331 */
    SYMBOL,        /* 0x2332 */
    SYMBOL,        /* 0x2333 */
    SYMBOL,        /* 0x2334 */
    SYMBOL,        /* 0x2335 */
    SYMBOL,        /* 0x2336 */
    SYMBOL,        /* 0x2337 */
    SYMBOL,        /* 0x2338 */
    SYMBOL,        /* 0x2339 */
    SYMBOL,        /* 0x233a */
    SYMBOL,        /* 0x233b */
    SYMBOL,        /* 0x233c */
    SYMBOL,        /* 0x233d */
    SYMBOL,        /* 0x233e */
    SYMBOL,        /* 0x233f */
    SYMBOL,        /* 0x2340 */
    SYMBOL,        /* 0x2341 */
    SYMBOL,        /* 0x2342 */
    SYMBOL,        /* 0x2343 */
    SYMBOL,        /* 0x2344 */
    SYMBOL,        /* 0x2345 */
    SYMBOL,        /* 0x2346 */
    SYMBOL,        /* 0x2347 */
    SYMBOL,        /* 0x2348 */
    SYMBOL,        /* 0x2349 */
    SYMBOL,        /* 0x234a */
    SYMBOL,        /* 0x234b */
    SYMBOL,        /* 0x234c */
    SYMBOL,        /* 0x234d */
    SYMBOL,        /* 0x234e */
    SYMBOL,        /* 0x234f */
    SYMBOL,        /* 0x2350 */
    SYMBOL,        /* 0x2351 */
    SYMBOL,        /* 0x2352 */
    SYMBOL,        /* 0x2353 */
    SYMBOL,        /* 0x2354 */
    SYMBOL,        /* 0x2355 */
    SYMBOL,        /* 0x2356 */
    SYMBOL,        /* 0x2357 */
    SYMBOL,        /* 0x2358 */
    SYMBOL,        /* 0x2359 */
    SYMBOL,        /* 0x235a */
    SYMBOL,        /* 0x235b */
    SYMBOL,        /* 0x235c */
    SYMBOL,        /* 0x235d */
    SYMBOL,        /* 0x235e */
    SYMBOL,        /* 0x235f */
    SYMBOL,        /* 0x2360 */
    SYMBOL,        /* 0x2361 */
    SYMBOL,        /* 0x2362 */
    SYMBOL,        /* 0x2363 */
    SYMBOL,        /* 0x2364 */
    SYMBOL,        /* 0x2365 */
    SYMBOL,        /* 0x2366 */
    SYMBOL,        /* 0x2367 */
    SYMBOL,        /* 0x2368 */
    SYMBOL,        /* 0x2369 */
    SYMBOL,        /* 0x236a */
    SYMBOL,        /* 0x236b */
    SYMBOL,        /* 0x236c */
    SYMBOL,        /* 0x236d */
    SYMBOL,        /* 0x236e */
    SYMBOL,        /* 0x236f */
    SYMBOL,        /* 0x2370 */
    SYMBOL,        /* 0x2371 */
    SYMBOL,        /* 0x2372 */
    SYMBOL,        /* 0x2373 */
    SYMBOL,        /* 0x2374 */
    SYMBOL,        /* 0x2375 */
    SYMBOL,        /* 0x2376 */
    SYMBOL,        /* 0x2377 */
    SYMBOL,        /* 0x2378 */
    SYMBOL,        /* 0x2379 */
    SYMBOL,        /* 0x237a */
    SYMBOL,        /* 0x237b */
    SYMBOL,        /* 0x237c */
    SYMBOL,        /* 0x237d */
    SYMBOL,        /* 0x237e */
    SYMBOL,        /* 0x237f */
    SYMBOL,        /* 0x2380 */
    SYMBOL,        /* 0x2381 */
    SYMBOL,        /* 0x2382 */
    SYMBOL,        /* 0x2383 */
    SYMBOL,        /* 0x2384 */
    SYMBOL,        /* 0x2385 */
    SYMBOL,        /* 0x2386 */
    SYMBOL,        /* 0x2387 */
    SYMBOL,        /* 0x2388 */
    SYMBOL,        /* 0x2389 */
    SYMBOL,        /* 0x238a */
    SYMBOL,        /* 0x238b */
    SYMBOL,        /* 0x238c */
    SYMBOL,        /* 0x238d */
    SYMBOL,        /* 0x238e */
    SYMBOL,        /* 0x238f */
    SYMBOL,        /* 0x2390 */
    SYMBOL,        /* 0x2391 */
    SYMBOL,        /* 0x2392 */
    SYMBOL,        /* 0x2393 */
    SYMBOL,        /* 0x2394 */
    SYMBOL,        /* 0x2395 */
    SYMBOL,        /* 0x2396 */
    SYMBOL,        /* 0x2397 */
    SYMBOL,        /* 0x2398 */
    SYMBOL,        /* 0x2399 */
    SYMBOL,        /* 0x239a */
    SYMBOL,        /* 0x239b */
    SYMBOL,        /* 0x239c */
    SYMBOL,        /* 0x239d */
    SYMBOL,        /* 0x239e */
    SYMBOL,        /* 0x239f */
    SYMBOL,        /* 0x23a0 */
    SYMBOL,        /* 0x23a1 */
    SYMBOL,        /* 0x23a2 */
    SYMBOL,        /* 0x23a3 */
    SYMBOL,        /* 0x23a4 */
    SYMBOL,        /* 0x23a5 */
    SYMBOL,        /* 0x23a6 */
    SYMBOL,        /* 0x23a7 */
    SYMBOL,        /* 0x23a8 */
    SYMBOL,        /* 0x23a9 */
    SYMBOL,        /* 0x23aa */
    SYMBOL,        /* 0x23ab */
    SYMBOL,        /* 0x23ac */
    SYMBOL,        /* 0x23ad */
    SYMBOL,        /* 0x23ae */
    SYMBOL,        /* 0x23af */
    SYMBOL,        /* 0x23b0 */
    SYMBOL,        /* 0x23b1 */
    SYMBOL,        /* 0x23b2 */
    SYMBOL,        /* 0x23b3 */
    SYMBOL,        /* 0x23b4 */
    SYMBOL,        /* 0x23b5 */
    SYMBOL,        /* 0x23b6 */
    SYMBOL,        /* 0x23b7 */
    SYMBOL,        /* 0x23b8 */
    SYMBOL,        /* 0x23b9 */
    SYMBOL,        /* 0x23ba */
    SYMBOL,        /* 0x23bb */
    SYMBOL,        /* 0x23bc */
    SYMBOL,        /* 0x23bd */
    SYMBOL,        /* 0x23be */
    SYMBOL,        /* 0x23bf */
    SYMBOL,        /* 0x23c0 */
    SYMBOL,        /* 0x23c1 */
    SYMBOL,        /* 0x23c2 */
    SYMBOL,        /* 0x23c3 */
    SYMBOL,        /* 0x23c4 */
    SYMBOL,        /* 0x23c5 */
    SYMBOL,        /* 0x23c6 */
    SYMBOL,        /* 0x23c7 */
    SYMBOL,        /* 0x23c8 */
    SYMBOL,        /* 0x23c9 */
    SYMBOL,        /* 0x23ca */
    SYMBOL,        /* 0x23cb */
    SYMBOL,        /* 0x23cc */
    SYMBOL,        /* 0x23cd */
    SYMBOL,        /* 0x23ce */
    SYMBOL,        /* 0x23cf */
    SYMBOL,        /* 0x23d0 */
    SYMBOL,        /* 0x23d1 */
    SYMBOL,        /* 0x23d2 */
    SYMBOL,        /* 0x23d3 */
    SYMBOL,        /* 0x23d4 */
    SYMBOL,        /* 0x23d5 */
    SYMBOL,        /* 0x23d6 */
    SYMBOL,        /* 0x23d7 */
    SYMBOL,        /* 0x23d8 */
    SYMBOL,        /* 0x23d9 */
    SYMBOL,        /* 0x23da */
    SYMBOL,        /* 0x23db */
    SYMBOL,        /* 0x23dc */
    SYMBOL,        /* 0x23dd */
    SYMBOL,        /* 0x23de */
    SYMBOL,        /* 0x23df */
    SYMBOL,        /* 0x23e0 */
    SYMBOL,        /* 0x23e1 */
    SYMBOL,        /* 0x23e2 */
    SYMBOL,        /* 0x23e3 */
    SYMBOL,        /* 0x23e4 */
    SYMBOL,        /* 0x23e5 */
    SYMBOL,        /* 0x23e6 */
    SYMBOL,        /* 0x23e7 */
    SYMBOL,        /* 0x23e8 */
    SYMBOL,        /* 0x23e9 */
    SYMBOL,        /* 0x23ea */
    SYMBOL,        /* 0x23eb */
    SYMBOL,        /* 0x23ec */
    SYMBOL,        /* 0x23ed */
    SYMBOL,        /* 0x23ee */
    SYMBOL,        /* 0x23ef */
    SYMBOL,        /* 0x23f0 */
    SYMBOL,        /* 0x23f1 */
    SYMBOL,        /* 0x23f2 */
    SYMBOL,        /* 0x23f3 */
    SYMBOL,        /* 0x23f4 */
    SYMBOL,        /* 0x23f5 */
    SYMBOL,        /* 0x23f6 */
    SYMBOL,        /* 0x23f7 */
    SYMBOL,        /* 0x23f8 */
    SYMBOL,        /* 0x23f9 */
    SYMBOL,        /* 0x23fa */
    SYMBOL,        /* 0x23fb */
    SYMBOL,        /* 0x23fc */
    SYMBOL,        /* 0x23fd */
    SYMBOL,        /* 0x23fe */
    SYMBOL,        /* 0x23ff */
    OTHER,        /* 0x2400 */
    OTHER,        /* 0x2401 */
    OTHER,        /* 0x2402 */
    OTHER,        /* 0x2403 */
    OTHER,        /* 0x2404 */
    OTHER,        /* 0x2405 */
    OTHER,        /* 0x2406 */
    OTHER,        /* 0x2407 */
    OTHER,        /* 0x2408 */
    OTHER,        /* 0x2409 */
    OTHER,        /* 0x240a */
    OTHER,        /* 0x240b */
    OTHER,        /* 0x240c */
    OTHER,        /* 0x240d */
    OTHER,        /* 0x240e */
    OTHER,        /* 0x240f */
    OTHER,        /* 0x2410 */
    OTHER,        /* 0x2411 */
    OTHER,        /* 0x2412 */
    OTHER,        /* 0x2413 */
    OTHER,        /* 0x2414 */
    OTHER,        /* 0x2415 */
    OTHER,        /* 0x2416 */
    OTHER,        /* 0x2417 */
    OTHER,        /* 0x2418 */
    OTHER,        /* 0x2419 */
    OTHER,        /* 0x241a */
    OTHER,        /* 0x241b */
    OTHER,        /* 0x241c */
    OTHER,        /* 0x241d */
    OTHER,        /* 0x241e */
    OTHER,        /* 0x241f */
    OTHER,        /* 0x2420 */
    OTHER,        /* 0x2421 */
    OTHER,        /* 0x2422 */
    OTHER,        /* 0x2423 */
    OTHER,        /* 0x2424 */
    OTHER,        /* 0x2425 */
    OTHER,        /* 0x2426 */
    OTHER,        /* 0x2427 */
    OTHER,        /* 0x2428 */
    OTHER,        /* 0x2429 */
    OTHER,        /* 0x242a */
    OTHER,        /* 0x242b */
    OTHER,        /* 0x242c */
    OTHER,        /* 0x242d */
    OTHER,        /* 0x242e */
    OTHER,        /* 0x242f */
    OTHER,        /* 0x2430 */
    OTHER,        /* 0x2431 */
    OTHER,        /* 0x2432 */
    OTHER,        /* 0x2433 */
    OTHER,        /* 0x2434 */
    OTHER,        /* 0x2435 */
    OTHER,        /* 0x2436 */
    OTHER,        /* 0x2437 */
    OTHER,        /* 0x2438 */
    OTHER,        /* 0x2439 */
    OTHER,        /* 0x243a */
    OTHER,        /* 0x243b */
    OTHER,        /* 0x243c */
    OTHER,        /* 0x243d */
    OTHER,        /* 0x243e */
    OTHER,        /* 0x243f */
    OTHER,        /* 0x2440 */
    OTHER,        /* 0x2441 */
    OTHER,        /* 0x2442 */
    OTHER,        /* 0x2443 */
    OTHER,        /* 0x2444 */
    OTHER,        /* 0x2445 */
    OTHER,        /* 0x2446 */
    OTHER,        /* 0x2447 */
    OTHER,        /* 0x2448 */
    OTHER,        /* 0x2449 */
    OTHER,        /* 0x244a */
    OTHER,        /* 0x244b */
    OTHER,        /* 0x244c */
    OTHER,        /* 0x244d */
    OTHER,        /* 0x244e */
    OTHER,        /* 0x244f */
    OTHER,        /* 0x2450 */
    OTHER,        /* 0x2451 */
    OTHER,        /* 0x2452 */
    OTHER,        /* 0x2453 */
    OTHER,        /* 0x2454 */
    OTHER,        /* 0x2455 */
    OTHER,        /* 0x2456 */
    OTHER,        /* 0x2457 */
    OTHER,        /* 0x2458 */
    OTHER,        /* 0x2459 */
    OTHER,        /* 0x245a */
    OTHER,        /* 0x245b */
    OTHER,        /* 0x245c */
    OTHER,        /* 0x245d */
    OTHER,        /* 0x245e */
    OTHER,        /* 0x245f */
    SYMBOL,        /* 0x2460 */
    SYMBOL,        /* 0x2461 */
    SYMBOL,        /* 0x2462 */
    SYMBOL,        /* 0x2463 */
    SYMBOL,        /* 0x2464 */
    SYMBOL,        /* 0x2465 */
    SYMBOL,        /* 0x2466 */
    SYMBOL,        /* 0x2467 */
    SYMBOL,        /* 0x2468 */
    SYMBOL,        /* 0x2469 */
    SYMBOL,        /* 0x246a */
    SYMBOL,        /* 0x246b */
    SYMBOL,        /* 0x246c */
    SYMBOL,        /* 0x246d */
    SYMBOL,        /* 0x246e */
    SYMBOL,        /* 0x246f */
    SYMBOL,        /* 0x2470 */
    SYMBOL,        /* 0x2471 */
    SYMBOL,        /* 0x2472 */
    SYMBOL,        /* 0x2473 */
    SYMBOL,        /* 0x2474 */
    SYMBOL,        /* 0x2475 */
    SYMBOL,        /* 0x2476 */
    SYMBOL,        /* 0x2477 */
    SYMBOL,        /* 0x2478 */
    SYMBOL,        /* 0x2479 */
    SYMBOL,        /* 0x247a */
    SYMBOL,        /* 0x247b */
    SYMBOL,        /* 0x247c */
    SYMBOL,        /* 0x247d */
    SYMBOL,        /* 0x247e */
    SYMBOL,        /* 0x247f */
    SYMBOL,        /* 0x2480 */
    SYMBOL,        /* 0x2481 */
    SYMBOL,        /* 0x2482 */
    SYMBOL,        /* 0x2483 */
    SYMBOL,        /* 0x2484 */
    SYMBOL,        /* 0x2485 */
    SYMBOL,        /* 0x2486 */
    SYMBOL,        /* 0x2487 */
    SYMBOL,        /* 0x2488 */
    SYMBOL,        /* 0x2489 */
    SYMBOL,        /* 0x248a */
    SYMBOL,        /* 0x248b */
    SYMBOL,        /* 0x248c */
    SYMBOL,        /* 0x248d */
    SYMBOL,        /* 0x248e */
    SYMBOL,        /* 0x248f */
    SYMBOL,        /* 0x2490 */
    SYMBOL,        /* 0x2491 */
    SYMBOL,        /* 0x2492 */
    SYMBOL,        /* 0x2493 */
    SYMBOL,        /* 0x2494 */
    SYMBOL,        /* 0x2495 */
    SYMBOL,        /* 0x2496 */
    SYMBOL,        /* 0x2497 */
    SYMBOL,        /* 0x2498 */
    SYMBOL,        /* 0x2499 */
    SYMBOL,        /* 0x249a */
    SYMBOL,        /* 0x249b */
    SYMBOL,        /* 0x249c */
    SYMBOL,        /* 0x249d */
    SYMBOL,        /* 0x249e */
    SYMBOL,        /* 0x249f */
    SYMBOL,        /* 0x24a0 */
    SYMBOL,        /* 0x24a1 */
    SYMBOL,        /* 0x24a2 */
    SYMBOL,        /* 0x24a3 */
    SYMBOL,        /* 0x24a4 */
    SYMBOL,        /* 0x24a5 */
    SYMBOL,        /* 0x24a6 */
    SYMBOL,        /* 0x24a7 */
    SYMBOL,        /* 0x24a8 */
    SYMBOL,        /* 0x24a9 */
    SYMBOL,        /* 0x24aa */
    SYMBOL,        /* 0x24ab */
    SYMBOL,        /* 0x24ac */
    SYMBOL,        /* 0x24ad */
    SYMBOL,        /* 0x24ae */
    SYMBOL,        /* 0x24af */
    SYMBOL,        /* 0x24b0 */
    SYMBOL,        /* 0x24b1 */
    SYMBOL,        /* 0x24b2 */
    SYMBOL,        /* 0x24b3 */
    SYMBOL,        /* 0x24b4 */
    SYMBOL,        /* 0x24b5 */
    SYMBOL,        /* 0x24b6 */
    SYMBOL,        /* 0x24b7 */
    SYMBOL,        /* 0x24b8 */
    SYMBOL,        /* 0x24b9 */
    SYMBOL,        /* 0x24ba */
    SYMBOL,        /* 0x24bb */
    SYMBOL,        /* 0x24bc */
    SYMBOL,        /* 0x24bd */
    SYMBOL,        /* 0x24be */
    SYMBOL,        /* 0x24bf */
    SYMBOL,        /* 0x24c0 */
    SYMBOL,        /* 0x24c1 */
    SYMBOL,        /* 0x24c2 */
    SYMBOL,        /* 0x24c3 */
    SYMBOL,        /* 0x24c4 */
    SYMBOL,        /* 0x24c5 */
    SYMBOL,        /* 0x24c6 */
    SYMBOL,        /* 0x24c7 */
    SYMBOL,        /* 0x24c8 */
    SYMBOL,        /* 0x24c9 */
    SYMBOL,        /* 0x24ca */
    SYMBOL,        /* 0x24cb */
    SYMBOL,        /* 0x24cc */
    SYMBOL,        /* 0x24cd */
    SYMBOL,        /* 0x24ce */
    SYMBOL,        /* 0x24cf */
    SYMBOL,        /* 0x24d0 */
    SYMBOL,        /* 0x24d1 */
    SYMBOL,        /* 0x24d2 */
    SYMBOL,        /* 0x24d3 */
    SYMBOL,        /* 0x24d4 */
    SYMBOL,        /* 0x24d5 */
    SYMBOL,        /* 0x24d6 */
    SYMBOL,        /* 0x24d7 */
    SYMBOL,        /* 0x24d8 */
    SYMBOL,        /* 0x24d9 */
    SYMBOL,        /* 0x24da */
    SYMBOL,        /* 0x24db */
    SYMBOL,        /* 0x24dc */
    SYMBOL,        /* 0x24dd */
    SYMBOL,        /* 0x24de */
    SYMBOL,        /* 0x24df */
    SYMBOL,        /* 0x24e0 */
    SYMBOL,        /* 0x24e1 */
    SYMBOL,        /* 0x24e2 */
    SYMBOL,        /* 0x24e3 */
    SYMBOL,        /* 0x24e4 */
    SYMBOL,        /* 0x24e5 */
    SYMBOL,        /* 0x24e6 */
    SYMBOL,        /* 0x24e7 */
    SYMBOL,        /* 0x24e8 */
    SYMBOL,        /* 0x24e9 */
    SYMBOL,        /* 0x24ea */
    SYMBOL,        /* 0x24eb */
    SYMBOL,        /* 0x24ec */
    SYMBOL,        /* 0x24ed */
    SYMBOL,        /* 0x24ee */
    SYMBOL,        /* 0x24ef */
    SYMBOL,        /* 0x24f0 */
    SYMBOL,        /* 0x24f1 */
    SYMBOL,        /* 0x24f2 */
    SYMBOL,        /* 0x24f3 */
    SYMBOL,        /* 0x24f4 */
    SYMBOL,        /* 0x24f5 */
    SYMBOL,        /* 0x24f6 */
    SYMBOL,        /* 0x24f7 */
    SYMBOL,        /* 0x24f8 */
    SYMBOL,        /* 0x24f9 */
    SYMBOL,        /* 0x24fa */
    SYMBOL,        /* 0x24fb */
    SYMBOL,        /* 0x24fc */
    SYMBOL,        /* 0x24fd */
    SYMBOL,        /* 0x24fe */
    SYMBOL,        /* 0x24ff */
    OTHER,        /* 0x2500 */
    SYMBOL,        /* 0x2501 */
    SYMBOL,        /* 0x2502 */
    SYMBOL,        /* 0x2503 */
    SYMBOL,        /* 0x2504 */
    SYMBOL,        /* 0x2505 */
    SYMBOL,        /* 0x2506 */
    SYMBOL,        /* 0x2507 */
    SYMBOL,        /* 0x2508 */
    SYMBOL,        /* 0x2509 */
    SYMBOL,        /* 0x250a */
    SYMBOL,        /* 0x250b */
    SYMBOL,        /* 0x250c */
    SYMBOL,        /* 0x250d */
    SYMBOL,        /* 0x250e */
    SYMBOL,        /* 0x250f */
    SYMBOL,        /* 0x2510 */
    SYMBOL,        /* 0x2511 */
    SYMBOL,        /* 0x2512 */
    SYMBOL,        /* 0x2513 */
    SYMBOL,        /* 0x2514 */
    SYMBOL,        /* 0x2515 */
    SYMBOL,        /* 0x2516 */
    SYMBOL,        /* 0x2517 */
    SYMBOL,        /* 0x2518 */
    SYMBOL,        /* 0x2519 */
    SYMBOL,        /* 0x251a */
    SYMBOL,        /* 0x251b */
    SYMBOL,        /* 0x251c */
    SYMBOL,        /* 0x251d */
    SYMBOL,        /* 0x251e */
    SYMBOL,        /* 0x251f */
    SYMBOL,        /* 0x2520 */
    SYMBOL,        /* 0x2521 */
    SYMBOL,        /* 0x2522 */
    SYMBOL,        /* 0x2523 */
    SYMBOL,        /* 0x2524 */
    SYMBOL,        /* 0x2525 */
    SYMBOL,        /* 0x2526 */
    SYMBOL,        /* 0x2527 */
    SYMBOL,        /* 0x2528 */
    SYMBOL,        /* 0x2529 */
    SYMBOL,        /* 0x252a */
    SYMBOL,        /* 0x252b */
    SYMBOL,        /* 0x252c */
    SYMBOL,        /* 0x252d */
    SYMBOL,        /* 0x252e */
    SYMBOL,        /* 0x252f */
    SYMBOL,        /* 0x2530 */
    SYMBOL,        /* 0x2531 */
    SYMBOL,        /* 0x2532 */
    SYMBOL,        /* 0x2533 */
    SYMBOL,        /* 0x2534 */
    SYMBOL,        /* 0x2535 */
    SYMBOL,        /* 0x2536 */
    SYMBOL,        /* 0x2537 */
    SYMBOL,        /* 0x2538 */
    SYMBOL,        /* 0x2539 */
    SYMBOL,        /* 0x253a */
    SYMBOL,        /* 0x253b */
    SYMBOL,        /* 0x253c */
    SYMBOL,        /* 0x253d */
    SYMBOL,        /* 0x253e */
    SYMBOL,        /* 0x253f */
    SYMBOL,        /* 0x2540 */
    SYMBOL,        /* 0x2541 */
    SYMBOL,        /* 0x2542 */
    SYMBOL,        /* 0x2543 */
    SYMBOL,        /* 0x2544 */
    SYMBOL,        /* 0x2545 */
    SYMBOL,        /* 0x2546 */
    SYMBOL,        /* 0x2547 */
    SYMBOL,        /* 0x2548 */
    SYMBOL,        /* 0x2549 */
    SYMBOL,        /* 0x254a */
    SYMBOL,        /* 0x254b */
    SYMBOL,        /* 0x254c */
    SYMBOL,        /* 0x254d */
    SYMBOL,        /* 0x254e */
    SYMBOL,        /* 0x254f */
    SYMBOL,        /* 0x2550 */
    SYMBOL,        /* 0x2551 */
    SYMBOL,        /* 0x2552 */
    SYMBOL,        /* 0x2553 */
    SYMBOL,        /* 0x2554 */
    SYMBOL,        /* 0x2555 */
    SYMBOL,        /* 0x2556 */
    SYMBOL,        /* 0x2557 */
    SYMBOL,        /* 0x2558 */
    SYMBOL,        /* 0x2559 */
    SYMBOL,        /* 0x255a */
    SYMBOL,        /* 0x255b */
    SYMBOL,        /* 0x255c */
    SYMBOL,        /* 0x255d */
    SYMBOL,        /* 0x255e */
    SYMBOL,        /* 0x255f */
    SYMBOL,        /* 0x2560 */
    SYMBOL,        /* 0x2561 */
    SYMBOL,        /* 0x2562 */
    SYMBOL,        /* 0x2563 */
    SYMBOL,        /* 0x2564 */
    SYMBOL,        /* 0x2565 */
    SYMBOL,        /* 0x2566 */
    SYMBOL,        /* 0x2567 */
    SYMBOL,        /* 0x2568 */
    SYMBOL,        /* 0x2569 */
    SYMBOL,        /* 0x256a */
    SYMBOL,        /* 0x256b */
    SYMBOL,        /* 0x256c */
    SYMBOL,        /* 0x256d */
    SYMBOL,        /* 0x256e */
    SYMBOL,        /* 0x256f */
    SYMBOL,        /* 0x2570 */
    SYMBOL,        /* 0x2571 */
    SYMBOL,        /* 0x2572 */
    SYMBOL,        /* 0x2573 */
    SYMBOL,        /* 0x2574 */
    SYMBOL,        /* 0x2575 */
    SYMBOL,        /* 0x2576 */
    SYMBOL,        /* 0x2577 */
    SYMBOL,        /* 0x2578 */
    SYMBOL,        /* 0x2579 */
    SYMBOL,        /* 0x257a */
    SYMBOL,        /* 0x257b */
    SYMBOL,        /* 0x257c */
    SYMBOL,        /* 0x257d */
    SYMBOL,        /* 0x257e */
    SYMBOL,        /* 0x257f */
    SYMBOL,        /* 0x2580 */
    SYMBOL,        /* 0x2581 */
    SYMBOL,        /* 0x2582 */
    SYMBOL,        /* 0x2583 */
    SYMBOL,        /* 0x2584 */
    SYMBOL,        /* 0x2585 */
    SYMBOL,        /* 0x2586 */
    SYMBOL,        /* 0x2587 */
    SYMBOL,        /* 0x2588 */
    SYMBOL,        /* 0x2589 */
    SYMBOL,        /* 0x258a */
    SYMBOL,        /* 0x258b */
    SYMBOL,        /* 0x258c */
    SYMBOL,        /* 0x258d */
    SYMBOL,        /* 0x258e */
    SYMBOL,        /* 0x258f */
    SYMBOL,        /* 0x2590 */
    SYMBOL,        /* 0x2591 */
    SYMBOL,        /* 0x2592 */
    SYMBOL,        /* 0x2593 */
    SYMBOL,        /* 0x2594 */
    SYMBOL,        /* 0x2595 */
    SYMBOL,        /* 0x2596 */
    SYMBOL,        /* 0x2597 */
    SYMBOL,        /* 0x2598 */
    SYMBOL,        /* 0x2599 */
    SYMBOL,        /* 0x259a */
    SYMBOL,        /* 0x259b */
    SYMBOL,        /* 0x259c */
    SYMBOL,        /* 0x259d */
    SYMBOL,        /* 0x259e */
    SYMBOL,        /* 0x259f */
    SYMBOL,        /* 0x25a0 */
    SYMBOL,        /* 0x25a1 */
    SYMBOL,        /* 0x25a2 */
    SYMBOL,        /* 0x25a3 */
    SYMBOL,        /* 0x25a4 */
    SYMBOL,        /* 0x25a5 */
    SYMBOL,        /* 0x25a6 */
    SYMBOL,        /* 0x25a7 */
    SYMBOL,        /* 0x25a8 */
    SYMBOL,        /* 0x25a9 */
    SYMBOL,        /* 0x25aa */
    SYMBOL,        /* 0x25ab */
    SYMBOL,        /* 0x25ac */
    SYMBOL,        /* 0x25ad */
    SYMBOL,        /* 0x25ae */
    SYMBOL,        /* 0x25af */
    SYMBOL,        /* 0x25b0 */
    SYMBOL,        /* 0x25b1 */
    SYMBOL,        /* 0x25b2 */
    SYMBOL,        /* 0x25b3 */
    SYMBOL,        /* 0x25b4 */
    SYMBOL,        /* 0x25b5 */
    SYMBOL,        /* 0x25b6 */
    SYMBOL,        /* 0x25b7 */
    SYMBOL,        /* 0x25b8 */
    SYMBOL,        /* 0x25b9 */
    SYMBOL,        /* 0x25ba */
    SYMBOL,        /* 0x25bb */
    SYMBOL,        /* 0x25bc */
    SYMBOL,        /* 0x25bd */
    SYMBOL,        /* 0x25be */
    SYMBOL,        /* 0x25bf */
    SYMBOL,        /* 0x25c0 */
    SYMBOL,        /* 0x25c1 */
    SYMBOL,        /* 0x25c2 */
    SYMBOL,        /* 0x25c3 */
    SYMBOL,        /* 0x25c4 */
    SYMBOL,        /* 0x25c5 */
    SYMBOL,        /* 0x25c6 */
    SYMBOL,        /* 0x25c7 */
    SYMBOL,        /* 0x25c8 */
    SYMBOL,        /* 0x25c9 */
    SYMBOL,        /* 0x25ca */
    SYMBOL,        /* 0x25cb */
    SYMBOL,        /* 0x25cc */
    SYMBOL,        /* 0x25cd */
    SYMBOL,        /* 0x25ce */
    SYMBOL,        /* 0x25cf */
    SYMBOL,        /* 0x25d0 */
    SYMBOL,        /* 0x25d1 */
    SYMBOL,        /* 0x25d2 */
    SYMBOL,        /* 0x25d3 */
    SYMBOL,        /* 0x25d4 */
    SYMBOL,        /* 0x25d5 */
    SYMBOL,        /* 0x25d6 */
    SYMBOL,        /* 0x25d7 */
    SYMBOL,        /* 0x25d8 */
    SYMBOL,        /* 0x25d9 */
    SYMBOL,        /* 0x25da */
    SYMBOL,        /* 0x25db */
    SYMBOL,        /* 0x25dc */
    SYMBOL,        /* 0x25dd */
    SYMBOL,        /* 0x25de */
    SYMBOL,        /* 0x25df */
    SYMBOL,        /* 0x25e0 */
    SYMBOL,        /* 0x25e1 */
    SYMBOL,        /* 0x25e2 */
    SYMBOL,        /* 0x25e3 */
    SYMBOL,        /* 0x25e4 */
    SYMBOL,        /* 0x25e5 */
    SYMBOL,        /* 0x25e6 */
    SYMBOL,        /* 0x25e7 */
    SYMBOL,        /* 0x25e8 */
    SYMBOL,        /* 0x25e9 */
    SYMBOL,        /* 0x25ea */
    SYMBOL,        /* 0x25eb */
    SYMBOL,        /* 0x25ec */
    SYMBOL,        /* 0x25ed */
    SYMBOL,        /* 0x25ee */
    SYMBOL,        /* 0x25ef */
    SYMBOL,        /* 0x25f0 */
    SYMBOL,        /* 0x25f1 */
    SYMBOL,        /* 0x25f2 */
    SYMBOL,        /* 0x25f3 */
    SYMBOL,        /* 0x25f4 */
    SYMBOL,        /* 0x25f5 */
    SYMBOL,        /* 0x25f6 */
    SYMBOL,        /* 0x25f7 */
    SYMBOL,        /* 0x25f8 */
    SYMBOL,        /* 0x25f9 */
    SYMBOL,        /* 0x25fa */
    SYMBOL,        /* 0x25fb */
    SYMBOL,        /* 0x25fc */
    SYMBOL,        /* 0x25fd */
    SYMBOL,        /* 0x25fe */
    SYMBOL,        /* 0x25ff */
    SYMBOL,        /* 0x2600 */
    SYMBOL,        /* 0x2601 */
    SYMBOL,        /* 0x2602 */
    SYMBOL,        /* 0x2603 */
    SYMBOL,        /* 0x2604 */
    SYMBOL,        /* 0x2605 */
    SYMBOL,        /* 0x2606 */
    SYMBOL,        /* 0x2607 */
    SYMBOL,        /* 0x2608 */
    SYMBOL,        /* 0x2609 */
    SYMBOL,        /* 0x260a */
    SYMBOL,        /* 0x260b */
    SYMBOL,        /* 0x260c */
    SYMBOL,        /* 0x260d */
    SYMBOL,        /* 0x260e */
    SYMBOL,        /* 0x260f */
    SYMBOL,        /* 0x2610 */
    SYMBOL,        /* 0x2611 */
    SYMBOL,        /* 0x2612 */
    SYMBOL,        /* 0x2613 */
    SYMBOL,        /* 0x2614 */
    SYMBOL,        /* 0x2615 */
    SYMBOL,        /* 0x2616 */
    SYMBOL,        /* 0x2617 */
    SYMBOL,        /* 0x2618 */
    SYMBOL,        /* 0x2619 */
    SYMBOL,        /* 0x261a */
    SYMBOL,        /* 0x261b */
    SYMBOL,        /* 0x261c */
    SYMBOL,        /* 0x261d */
    SYMBOL,        /* 0x261e */
    SYMBOL,        /* 0x261f */
    SYMBOL,        /* 0x2620 */
    SYMBOL,        /* 0x2621 */
    SYMBOL,        /* 0x2622 */
    SYMBOL,        /* 0x2623 */
    SYMBOL,        /* 0x2624 */
    SYMBOL,        /* 0x2625 */
    SYMBOL,        /* 0x2626 */
    SYMBOL,        /* 0x2627 */
    SYMBOL,        /* 0x2628 */
    SYMBOL,        /* 0x2629 */
    SYMBOL,        /* 0x262a */
    SYMBOL,        /* 0x262b */
    SYMBOL,        /* 0x262c */
    SYMBOL,        /* 0x262d */
    SYMBOL,        /* 0x262e */
    SYMBOL,        /* 0x262f */
    SYMBOL,        /* 0x2630 */
    SYMBOL,        /* 0x2631 */
    SYMBOL,        /* 0x2632 */
    SYMBOL,        /* 0x2633 */
    SYMBOL,        /* 0x2634 */
    SYMBOL,        /* 0x2635 */
    SYMBOL,        /* 0x2636 */
    SYMBOL,        /* 0x2637 */
    SYMBOL,        /* 0x2638 */
    SYMBOL,        /* 0x2639 */
    SYMBOL,        /* 0x263a */
    SYMBOL,        /* 0x263b */
    SYMBOL,        /* 0x263c */
    SYMBOL,        /* 0x263d */
    SYMBOL,        /* 0x263e */
    SYMBOL,        /* 0x263f */
    SYMBOL,        /* 0x2640 */
    SYMBOL,        /* 0x2641 */
    SYMBOL,        /* 0x2642 */
    SYMBOL,        /* 0x2643 */
    SYMBOL,        /* 0x2644 */
    SYMBOL,        /* 0x2645 */
    SYMBOL,        /* 0x2646 */
    SYMBOL,        /* 0x2647 */
    SYMBOL,        /* 0x2648 */
    SYMBOL,        /* 0x2649 */
    SYMBOL,        /* 0x264a */
    SYMBOL,        /* 0x264b */
    SYMBOL,        /* 0x264c */
    SYMBOL,        /* 0x264d */
    SYMBOL,        /* 0x264e */
    SYMBOL,        /* 0x264f */
    SYMBOL,        /* 0x2650 */
    SYMBOL,        /* 0x2651 */
    SYMBOL,        /* 0x2652 */
    SYMBOL,        /* 0x2653 */
    SYMBOL,        /* 0x2654 */
    SYMBOL,        /* 0x2655 */
    SYMBOL,        /* 0x2656 */
    SYMBOL,        /* 0x2657 */
    SYMBOL,        /* 0x2658 */
    SYMBOL,        /* 0x2659 */
    SYMBOL,        /* 0x265a */
    SYMBOL,        /* 0x265b */
    SYMBOL,        /* 0x265c */
    SYMBOL,        /* 0x265d */
    SYMBOL,        /* 0x265e */
    SYMBOL,        /* 0x265f */
    SYMBOL,        /* 0x2660 */
    SYMBOL,        /* 0x2661 */
    SYMBOL,        /* 0x2662 */
    SYMBOL,        /* 0x2663 */
    SYMBOL,        /* 0x2664 */
    SYMBOL,        /* 0x2665 */
    SYMBOL,        /* 0x2666 */
    SYMBOL,        /* 0x2667 */
    SYMBOL,        /* 0x2668 */
    SYMBOL,        /* 0x2669 */
    SYMBOL,        /* 0x266a */
    SYMBOL,        /* 0x266b */
    SYMBOL,        /* 0x266c */
    SYMBOL,        /* 0x266d */
    SYMBOL,        /* 0x266e */
    SYMBOL,        /* 0x266f */
    SYMBOL,        /* 0x2670 */
    SYMBOL,        /* 0x2671 */
    SYMBOL,        /* 0x2672 */
    SYMBOL,        /* 0x2673 */
    SYMBOL,        /* 0x2674 */
    SYMBOL,        /* 0x2675 */
    SYMBOL,        /* 0x2676 */
    SYMBOL,        /* 0x2677 */
    SYMBOL,        /* 0x2678 */
    SYMBOL,        /* 0x2679 */
    SYMBOL,        /* 0x267a */
    SYMBOL,        /* 0x267b */
    SYMBOL,        /* 0x267c */
    SYMBOL,        /* 0x267d */
    SYMBOL,        /* 0x267e */
    SYMBOL,        /* 0x267f */
    SYMBOL,        /* 0x2680 */
    SYMBOL,        /* 0x2681 */
    SYMBOL,        /* 0x2682 */
    SYMBOL,        /* 0x2683 */
    SYMBOL,        /* 0x2684 */
    SYMBOL,        /* 0x2685 */
    SYMBOL,        /* 0x2686 */
    SYMBOL,        /* 0x2687 */
    SYMBOL,        /* 0x2688 */
    SYMBOL,        /* 0x2689 */
    SYMBOL,        /* 0x268a */
    SYMBOL,        /* 0x268b */
    SYMBOL,        /* 0x268c */
    SYMBOL,        /* 0x268d */
    SYMBOL,        /* 0x268e */
    SYMBOL,        /* 0x268f */
    SYMBOL,        /* 0x2690 */
    SYMBOL,        /* 0x2691 */
    SYMBOL,        /* 0x2692 */
    SYMBOL,        /* 0x2693 */
    SYMBOL,        /* 0x2694 */
    SYMBOL,        /* 0x2695 */
    SYMBOL,        /* 0x2696 */
    SYMBOL,        /* 0x2697 */
    SYMBOL,        /* 0x2698 */
    SYMBOL,        /* 0x2699 */
    SYMBOL,        /* 0x269a */
    SYMBOL,        /* 0x269b */
    SYMBOL,        /* 0x269c */
    SYMBOL,        /* 0x269d */
    SYMBOL,        /* 0x269e */
    SYMBOL,        /* 0x269f */
    SYMBOL,        /* 0x26a0 */
    SYMBOL,        /* 0x26a1 */
    SYMBOL,        /* 0x26a2 */
    SYMBOL,        /* 0x26a3 */
    SYMBOL,        /* 0x26a4 */
    SYMBOL,        /* 0x26a5 */
    SYMBOL,        /* 0x26a6 */
    SYMBOL,        /* 0x26a7 */
    SYMBOL,        /* 0x26a8 */
    SYMBOL,        /* 0x26a9 */
    SYMBOL,        /* 0x26aa */
    SYMBOL,        /* 0x26ab */
    SYMBOL,        /* 0x26ac */
    SYMBOL,        /* 0x26ad */
    SYMBOL,        /* 0x26ae */
    SYMBOL,        /* 0x26af */
    SYMBOL,        /* 0x26b0 */
    SYMBOL,        /* 0x26b1 */
    SYMBOL,        /* 0x26b2 */
    SYMBOL,        /* 0x26b3 */
    SYMBOL,        /* 0x26b4 */
    SYMBOL,        /* 0x26b5 */
    SYMBOL,        /* 0x26b6 */
    SYMBOL,        /* 0x26b7 */
    SYMBOL,        /* 0x26b8 */
    SYMBOL,        /* 0x26b9 */
    SYMBOL,        /* 0x26ba */
    SYMBOL,        /* 0x26bb */
    SYMBOL,        /* 0x26bc */
    SYMBOL,        /* 0x26bd */
    SYMBOL,        /* 0x26be */
    SYMBOL,        /* 0x26bf */
    SYMBOL,        /* 0x26c0 */
    SYMBOL,        /* 0x26c1 */
    SYMBOL,        /* 0x26c2 */
    SYMBOL,        /* 0x26c3 */
    SYMBOL,        /* 0x26c4 */
    SYMBOL,        /* 0x26c5 */
    SYMBOL,        /* 0x26c6 */
    SYMBOL,        /* 0x26c7 */
    SYMBOL,        /* 0x26c8 */
    SYMBOL,        /* 0x26c9 */
    SYMBOL,        /* 0x26ca */
    SYMBOL,        /* 0x26cb */
    SYMBOL,        /* 0x26cc */
    SYMBOL,        /* 0x26cd */
    SYMBOL,        /* 0x26ce */
    SYMBOL,        /* 0x26cf */
    SYMBOL,        /* 0x26d0 */
    SYMBOL,        /* 0x26d1 */
    SYMBOL,        /* 0x26d2 */
    SYMBOL,        /* 0x26d3 */
    SYMBOL,        /* 0x26d4 */
    SYMBOL,        /* 0x26d5 */
    SYMBOL,        /* 0x26d6 */
    SYMBOL,        /* 0x26d7 */
    SYMBOL,        /* 0x26d8 */
    SYMBOL,        /* 0x26d9 */
    SYMBOL,        /* 0x26da */
    SYMBOL,        /* 0x26db */
    SYMBOL,        /* 0x26dc */
    SYMBOL,        /* 0x26dd */
    SYMBOL,        /* 0x26de */
    SYMBOL,        /* 0x26df */
    SYMBOL,        /* 0x26e0 */
    SYMBOL,        /* 0x26e1 */
    SYMBOL,        /* 0x26e2 */
    SYMBOL,        /* 0x26e3 */
    SYMBOL,        /* 0x26e4 */
    SYMBOL,        /* 0x26e5 */
    SYMBOL,        /* 0x26e6 */
    SYMBOL,        /* 0x26e7 */
    SYMBOL,        /* 0x26e8 */
    SYMBOL,        /* 0x26e9 */
    SYMBOL,        /* 0x26ea */
    SYMBOL,        /* 0x26eb */
    SYMBOL,        /* 0x26ec */
    SYMBOL,        /* 0x26ed */
    SYMBOL,        /* 0x26ee */
    SYMBOL,        /* 0x26ef */
    SYMBOL,        /* 0x26f0 */
    SYMBOL,        /* 0x26f1 */
    SYMBOL,        /* 0x26f2 */
    SYMBOL,        /* 0x26f3 */
    SYMBOL,        /* 0x26f4 */
    SYMBOL,        /* 0x26f5 */
    SYMBOL,        /* 0x26f6 */
    SYMBOL,        /* 0x26f7 */
    SYMBOL,        /* 0x26f8 */
    SYMBOL,        /* 0x26f9 */
    SYMBOL,        /* 0x26fa */
    SYMBOL,        /* 0x26fb */
    SYMBOL,        /* 0x26fc */
    SYMBOL,        /* 0x26fd */
    SYMBOL,        /* 0x26fe */
    OTHER,        /* 0x26ff */
    SYMBOL,        /* 0x2700 */
    SYMBOL,        /* 0x2701 */
    SYMBOL,        /* 0x2702 */
    SYMBOL,        /* 0x2703 */
    SYMBOL,        /* 0x2704 */
    SYMBOL,        /* 0x2705 */
    SYMBOL,        /* 0x2706 */
    SYMBOL,        /* 0x2707 */
    SYMBOL,        /* 0x2708 */
    SYMBOL,        /* 0x2709 */
    SYMBOL,        /* 0x270a */
    SYMBOL,        /* 0x270b */
    SYMBOL,        /* 0x270c */
    SYMBOL,        /* 0x270d */
    SYMBOL,        /* 0x270e */
    SYMBOL,        /* 0x270f */
    SYMBOL,        /* 0x2710 */
    SYMBOL,        /* 0x2711 */
    SYMBOL,        /* 0x2712 */
    SYMBOL,        /* 0x2713 */
    SYMBOL,        /* 0x2714 */
    SYMBOL,        /* 0x2715 */
    SYMBOL,        /* 0x2716 */
    SYMBOL,        /* 0x2717 */
    SYMBOL,        /* 0x2718 */
    SYMBOL,        /* 0x2719 */
    SYMBOL,        /* 0x271a */
    SYMBOL,        /* 0x271b */
    SYMBOL,        /* 0x271c */
    SYMBOL,        /* 0x271d */
    SYMBOL,        /* 0x271e */
    SYMBOL,        /* 0x271f */
    SYMBOL,        /* 0x2720 */
    SYMBOL,        /* 0x2721 */
    SYMBOL,        /* 0x2722 */
    SYMBOL,        /* 0x2723 */
    SYMBOL,        /* 0x2724 */
    SYMBOL,        /* 0x2725 */
    SYMBOL,        /* 0x2726 */
    SYMBOL,        /* 0x2727 */
    SYMBOL,        /* 0x2728 */
    SYMBOL,        /* 0x2729 */
    SYMBOL,        /* 0x272a */
    SYMBOL,        /* 0x272b */
    SYMBOL,        /* 0x272c */
    SYMBOL,        /* 0x272d */
    SYMBOL,        /* 0x272e */
    SYMBOL,        /* 0x272f */
    SYMBOL,        /* 0x2730 */
    SYMBOL,        /* 0x2731 */
    SYMBOL,        /* 0x2732 */
    SYMBOL,        /* 0x2733 */
    SYMBOL,        /* 0x2734 */
    SYMBOL,        /* 0x2735 */
    SYMBOL,        /* 0x2736 */
    SYMBOL,        /* 0x2737 */
    SYMBOL,        /* 0x2738 */
    SYMBOL,        /* 0x2739 */
    SYMBOL,        /* 0x273a */
    SYMBOL,        /* 0x273b */
    SYMBOL,        /* 0x273c */
    SYMBOL,        /* 0x273d */
    SYMBOL,        /* 0x273e */
    SYMBOL,        /* 0x273f */
    SYMBOL,        /* 0x2740 */
    SYMBOL,        /* 0x2741 */
    SYMBOL,        /* 0x2742 */
    SYMBOL,        /* 0x2743 */
    SYMBOL,        /* 0x2744 */
    SYMBOL,        /* 0x2745 */
    SYMBOL,        /* 0x2746 */
    SYMBOL,        /* 0x2747 */
    SYMBOL,        /* 0x2748 */
    SYMBOL,        /* 0x2749 */
    SYMBOL,        /* 0x274a */
    SYMBOL,        /* 0x274b */
    SYMBOL,        /* 0x274c */
    SYMBOL,        /* 0x274d */
    SYMBOL,        /* 0x274e */
    SYMBOL,        /* 0x274f */
    SYMBOL,        /* 0x2750 */
    SYMBOL,        /* 0x2751 */
    SYMBOL,        /* 0x2752 */
    SYMBOL,        /* 0x2753 */
    SYMBOL,        /* 0x2754 */
    SYMBOL,        /* 0x2755 */
    SYMBOL,        /* 0x2756 */
    SYMBOL,        /* 0x2757 */
    SYMBOL,        /* 0x2758 */
    SYMBOL,        /* 0x2759 */
    SYMBOL,        /* 0x275a */
    SYMBOL,        /* 0x275b */
    SYMBOL,        /* 0x275c */
    SYMBOL,        /* 0x275d */
    SYMBOL,        /* 0x275e */
    SYMBOL,        /* 0x275f */
    SYMBOL,        /* 0x2760 */
    SYMBOL,        /* 0x2761 */
    SYMBOL,        /* 0x2762 */
    SYMBOL,        /* 0x2763 */
    SYMBOL,        /* 0x2764 */
    SYMBOL,        /* 0x2765 */
    SYMBOL,        /* 0x2766 */
    SYMBOL,        /* 0x2767 */
    SYMBOL,        /* 0x2768 */
    SYMBOL,        /* 0x2769 */
    SYMBOL,        /* 0x276a */
    SYMBOL,        /* 0x276b */
    SYMBOL,        /* 0x276c */
    SYMBOL,        /* 0x276d */
    SYMBOL,        /* 0x276e */
    SYMBOL,        /* 0x276f */
    SYMBOL,        /* 0x2770 */
    SYMBOL,        /* 0x2771 */
    SYMBOL,        /* 0x2772 */
    SYMBOL,        /* 0x2773 */
    SYMBOL,        /* 0x2774 */
    SYMBOL,        /* 0x2775 */
    SYMBOL,        /* 0x2776 */
    SYMBOL,        /* 0x2777 */
    SYMBOL,        /* 0x2778 */
    SYMBOL,        /* 0x2779 */
    SYMBOL,        /* 0x277a */
    SYMBOL,        /* 0x277b */
    SYMBOL,        /* 0x277c */
    SYMBOL,        /* 0x277d */
    SYMBOL,        /* 0x277e */
    SYMBOL,        /* 0x277f */
    SYMBOL,        /* 0x2780 */
    SYMBOL,        /* 0x2781 */
    SYMBOL,        /* 0x2782 */
    SYMBOL,        /* 0x2783 */
    SYMBOL,        /* 0x2784 */
    SYMBOL,        /* 0x2785 */
    SYMBOL,        /* 0x2786 */
    SYMBOL,        /* 0x2787 */
    SYMBOL,        /* 0x2788 */
    SYMBOL,        /* 0x2789 */
    SYMBOL,        /* 0x278a */
    SYMBOL,        /* 0x278b */
    SYMBOL,        /* 0x278c */
    SYMBOL,        /* 0x278d */
    SYMBOL,        /* 0x278e */
    SYMBOL,        /* 0x278f */
    SYMBOL,        /* 0x2790 */
    SYMBOL,        /* 0x2791 */
    SYMBOL,        /* 0x2792 */
    SYMBOL,        /* 0x2793 */
    SYMBOL,        /* 0x2794 */
    SYMBOL,        /* 0x2795 */
    SYMBOL,        /* 0x2796 */
    SYMBOL,        /* 0x2797 */
    SYMBOL,        /* 0x2798 */
    SYMBOL,        /* 0x2799 */
    SYMBOL,        /* 0x279a */
    SYMBOL,        /* 0x279b */
    SYMBOL,        /* 0x279c */
    SYMBOL,        /* 0x279d */
    SYMBOL,        /* 0x279e */
    SYMBOL,        /* 0x279f */
    SYMBOL,        /* 0x27a0 */
    SYMBOL,        /* 0x27a1 */
    SYMBOL,        /* 0x27a2 */
    SYMBOL,        /* 0x27a3 */
    SYMBOL,        /* 0x27a4 */
    SYMBOL,        /* 0x27a5 */
    SYMBOL,        /* 0x27a6 */
    SYMBOL,        /* 0x27a7 */
    SYMBOL,        /* 0x27a8 */
    SYMBOL,        /* 0x27a9 */
    SYMBOL,        /* 0x27aa */
    SYMBOL,        /* 0x27ab */
    SYMBOL,        /* 0x27ac */
    SYMBOL,        /* 0x27ad */
    SYMBOL,        /* 0x27ae */
    SYMBOL,        /* 0x27af */
    SYMBOL,        /* 0x27b0 */
    SYMBOL,        /* 0x27b1 */
    SYMBOL,        /* 0x27b2 */
    SYMBOL,        /* 0x27b3 */
    SYMBOL,        /* 0x27b4 */
    SYMBOL,        /* 0x27b5 */
    SYMBOL,        /* 0x27b6 */
    SYMBOL,        /* 0x27b7 */
    SYMBOL,        /* 0x27b8 */
    SYMBOL,        /* 0x27b9 */
    SYMBOL,        /* 0x27ba */
    SYMBOL,        /* 0x27bb */
    SYMBOL,        /* 0x27bc */
    SYMBOL,        /* 0x27bd */
    SYMBOL,        /* 0x27be */
    SYMBOL,        /* 0x27bf */
    SYMBOL,        /* 0x27c0 */
    SYMBOL,        /* 0x27c1 */
    SYMBOL,        /* 0x27c2 */
    SYMBOL,        /* 0x27c3 */
    SYMBOL,        /* 0x27c4 */
    SYMBOL,        /* 0x27c5 */
    SYMBOL,        /* 0x27c6 */
    SYMBOL,        /* 0x27c7 */
    SYMBOL,        /* 0x27c8 */
    SYMBOL,        /* 0x27c9 */
    SYMBOL,        /* 0x27ca */
    SYMBOL,        /* 0x27cb */
    SYMBOL,        /* 0x27cc */
    SYMBOL,        /* 0x27cd */
    SYMBOL,        /* 0x27ce */
    SYMBOL,        /* 0x27cf */
    SYMBOL,        /* 0x27d0 */
    SYMBOL,        /* 0x27d1 */
    SYMBOL,        /* 0x27d2 */
    SYMBOL,        /* 0x27d3 */
    SYMBOL,        /* 0x27d4 */
    SYMBOL,        /* 0x27d5 */
    SYMBOL,        /* 0x27d6 */
    SYMBOL,        /* 0x27d7 */
    SYMBOL,        /* 0x27d8 */
    SYMBOL,        /* 0x27d9 */
    SYMBOL,        /* 0x27da */
    SYMBOL,        /* 0x27db */
    SYMBOL,        /* 0x27dc */
    SYMBOL,        /* 0x27dd */
    SYMBOL,        /* 0x27de */
    SYMBOL,        /* 0x27df */
    SYMBOL,        /* 0x27e0 */
    SYMBOL,        /* 0x27e1 */
    SYMBOL,        /* 0x27e2 */
    SYMBOL,        /* 0x27e3 */
    SYMBOL,        /* 0x27e4 */
    SYMBOL,        /* 0x27e5 */
    SYMBOL,        /* 0x27e6 */
    SYMBOL,        /* 0x27e7 */
    SYMBOL,        /* 0x27e8 */
    SYMBOL,        /* 0x27e9 */
    SYMBOL,        /* 0x27ea */
    SYMBOL,        /* 0x27eb */
    SYMBOL,        /* 0x27ec */
    SYMBOL,        /* 0x27ed */
    SYMBOL,        /* 0x27ee */
    SYMBOL,        /* 0x27ef */
    SYMBOL,        /* 0x27f0 */
    SYMBOL,        /* 0x27f1 */
    SYMBOL,        /* 0x27f2 */
    SYMBOL,        /* 0x27f3 */
    SYMBOL,        /* 0x27f4 */
    SYMBOL,        /* 0x27f5 */
    SYMBOL,        /* 0x27f6 */
    SYMBOL,        /* 0x27f7 */
    SYMBOL,        /* 0x27f8 */
    SYMBOL,        /* 0x27f9 */
    SYMBOL,        /* 0x27fa */
    SYMBOL,        /* 0x27fb */
    SYMBOL,        /* 0x27fc */
    SYMBOL,        /* 0x27fd */
    SYMBOL,        /* 0x27fe */
    SYMBOL,        /* 0x27ff */
    SYMBOL,        /* 0x2800 */
    SYMBOL,        /* 0x2801 */
    SYMBOL,        /* 0x2802 */
    SYMBOL,        /* 0x2803 */
    SYMBOL,        /* 0x2804 */
    SYMBOL,        /* 0x2805 */
    SYMBOL,        /* 0x2806 */
    SYMBOL,        /* 0x2807 */
    SYMBOL,        /* 0x2808 */
    SYMBOL,        /* 0x2809 */
    SYMBOL,        /* 0x280a */
    SYMBOL,        /* 0x280b */
    SYMBOL,        /* 0x280c */
    SYMBOL,        /* 0x280d */
    SYMBOL,        /* 0x280e */
    SYMBOL,        /* 0x280f */
    SYMBOL,        /* 0x2810 */
    SYMBOL,        /* 0x2811 */
    SYMBOL,        /* 0x2812 */
    SYMBOL,        /* 0x2813 */
    SYMBOL,        /* 0x2814 */
    SYMBOL,        /* 0x2815 */
    SYMBOL,        /* 0x2816 */
    SYMBOL,        /* 0x2817 */
    SYMBOL,        /* 0x2818 */
    SYMBOL,        /* 0x2819 */
    SYMBOL,        /* 0x281a */
    SYMBOL,        /* 0x281b */
    SYMBOL,        /* 0x281c */
    SYMBOL,        /* 0x281d */
    SYMBOL,        /* 0x281e */
    SYMBOL,        /* 0x281f */
    SYMBOL,        /* 0x2820 */
    SYMBOL,        /* 0x2821 */
    SYMBOL,        /* 0x2822 */
    SYMBOL,        /* 0x2823 */
    SYMBOL,        /* 0x2824 */
    SYMBOL,        /* 0x2825 */
    SYMBOL,        /* 0x2826 */
    SYMBOL,        /* 0x2827 */
    SYMBOL,        /* 0x2828 */
    SYMBOL,        /* 0x2829 */
    SYMBOL,        /* 0x282a */
    SYMBOL,        /* 0x282b */
    SYMBOL,        /* 0x282c */
    SYMBOL,        /* 0x282d */
    SYMBOL,        /* 0x282e */
    SYMBOL,        /* 0x282f */
    SYMBOL,        /* 0x2830 */
    SYMBOL,        /* 0x2831 */
    SYMBOL,        /* 0x2832 */
    SYMBOL,        /* 0x2833 */
    SYMBOL,        /* 0x2834 */
    SYMBOL,        /* 0x2835 */
    SYMBOL,        /* 0x2836 */
    SYMBOL,        /* 0x2837 */
    SYMBOL,        /* 0x2838 */
    SYMBOL,        /* 0x2839 */
    SYMBOL,        /* 0x283a */
    SYMBOL,        /* 0x283b */
    SYMBOL,        /* 0x283c */
    SYMBOL,        /* 0x283d */
    SYMBOL,        /* 0x283e */
    SYMBOL,        /* 0x283f */
    SYMBOL,        /* 0x2840 */
    SYMBOL,        /* 0x2841 */
    SYMBOL,        /* 0x2842 */
    SYMBOL,        /* 0x2843 */
    SYMBOL,        /* 0x2844 */
    SYMBOL,        /* 0x2845 */
    SYMBOL,        /* 0x2846 */
    SYMBOL,        /* 0x2847 */
    SYMBOL,        /* 0x2848 */
    SYMBOL,        /* 0x2849 */
    SYMBOL,        /* 0x284a */
    SYMBOL,        /* 0x284b */
    SYMBOL,        /* 0x284c */
    SYMBOL,        /* 0x284d */
    SYMBOL,        /* 0x284e */
    SYMBOL,        /* 0x284f */
    SYMBOL,        /* 0x2850 */
    SYMBOL,        /* 0x2851 */
    SYMBOL,        /* 0x2852 */
    SYMBOL,        /* 0x2853 */
    SYMBOL,        /* 0x2854 */
    SYMBOL,        /* 0x2855 */
    SYMBOL,        /* 0x2856 */
    SYMBOL,        /* 0x2857 */
    SYMBOL,        /* 0x2858 */
    SYMBOL,        /* 0x2859 */
    SYMBOL,        /* 0x285a */
    SYMBOL,        /* 0x285b */
    SYMBOL,        /* 0x285c */
    SYMBOL,        /* 0x285d */
    SYMBOL,        /* 0x285e */
    SYMBOL,        /* 0x285f */
    SYMBOL,        /* 0x2860 */
    SYMBOL,        /* 0x2861 */
    SYMBOL,        /* 0x2862 */
    SYMBOL,        /* 0x2863 */
    SYMBOL,        /* 0x2864 */
    SYMBOL,        /* 0x2865 */
    SYMBOL,        /* 0x2866 */
    SYMBOL,        /* 0x2867 */
    SYMBOL,        /* 0x2868 */
    SYMBOL,        /* 0x2869 */
    SYMBOL,        /* 0x286a */
    SYMBOL,        /* 0x286b */
    SYMBOL,        /* 0x286c */
    SYMBOL,        /* 0x286d */
    SYMBOL,        /* 0x286e */
    SYMBOL,        /* 0x286f */
    SYMBOL,        /* 0x2870 */
    SYMBOL,        /* 0x2871 */
    SYMBOL,        /* 0x2872 */
    SYMBOL,        /* 0x2873 */
    SYMBOL,        /* 0x2874 */
    SYMBOL,        /* 0x2875 */
    SYMBOL,        /* 0x2876 */
    SYMBOL,        /* 0x2877 */
    SYMBOL,        /* 0x2878 */
    SYMBOL,        /* 0x2879 */
    SYMBOL,        /* 0x287a */
    SYMBOL,        /* 0x287b */
    SYMBOL,        /* 0x287c */
    SYMBOL,        /* 0x287d */
    SYMBOL,        /* 0x287e */
    SYMBOL,        /* 0x287f */
    SYMBOL,        /* 0x2880 */
    SYMBOL,        /* 0x2881 */
    SYMBOL,        /* 0x2882 */
    SYMBOL,        /* 0x2883 */
    SYMBOL,        /* 0x2884 */
    SYMBOL,        /* 0x2885 */
    SYMBOL,        /* 0x2886 */
    SYMBOL,        /* 0x2887 */
    SYMBOL,        /* 0x2888 */
    SYMBOL,        /* 0x2889 */
    SYMBOL,        /* 0x288a */
    SYMBOL,        /* 0x288b */
    SYMBOL,        /* 0x288c */
    SYMBOL,        /* 0x288d */
    SYMBOL,        /* 0x288e */
    SYMBOL,        /* 0x288f */
    SYMBOL,        /* 0x2890 */
    SYMBOL,        /* 0x2891 */
    SYMBOL,        /* 0x2892 */
    SYMBOL,        /* 0x2893 */
    SYMBOL,        /* 0x2894 */
    SYMBOL,        /* 0x2895 */
    SYMBOL,        /* 0x2896 */
    SYMBOL,        /* 0x2897 */
    SYMBOL,        /* 0x2898 */
    SYMBOL,        /* 0x2899 */
    SYMBOL,        /* 0x289a */
    SYMBOL,        /* 0x289b */
    SYMBOL,        /* 0x289c */
    SYMBOL,        /* 0x289d */
    SYMBOL,        /* 0x289e */
    SYMBOL,        /* 0x289f */
    SYMBOL,        /* 0x28a0 */
    SYMBOL,        /* 0x28a1 */
    SYMBOL,        /* 0x28a2 */
    SYMBOL,        /* 0x28a3 */
    SYMBOL,        /* 0x28a4 */
    SYMBOL,        /* 0x28a5 */
    SYMBOL,        /* 0x28a6 */
    SYMBOL,        /* 0x28a7 */
    SYMBOL,        /* 0x28a8 */
    SYMBOL,        /* 0x28a9 */
    SYMBOL,        /* 0x28aa */
    SYMBOL,        /* 0x28ab */
    SYMBOL,        /* 0x28ac */
    SYMBOL,        /* 0x28ad */
    SYMBOL,        /* 0x28ae */
    SYMBOL,        /* 0x28af */
    SYMBOL,        /* 0x28b0 */
    SYMBOL,        /* 0x28b1 */
    SYMBOL,        /* 0x28b2 */
    SYMBOL,        /* 0x28b3 */
    SYMBOL,        /* 0x28b4 */
    SYMBOL,        /* 0x28b5 */
    SYMBOL,        /* 0x28b6 */
    SYMBOL,        /* 0x28b7 */
    SYMBOL,        /* 0x28b8 */
    SYMBOL,        /* 0x28b9 */
    SYMBOL,        /* 0x28ba */
    SYMBOL,        /* 0x28bb */
    SYMBOL,        /* 0x28bc */
    SYMBOL,        /* 0x28bd */
    SYMBOL,        /* 0x28be */
    SYMBOL,        /* 0x28bf */
    SYMBOL,        /* 0x28c0 */
    SYMBOL,        /* 0x28c1 */
    SYMBOL,        /* 0x28c2 */
    SYMBOL,        /* 0x28c3 */
    SYMBOL,        /* 0x28c4 */
    SYMBOL,        /* 0x28c5 */
    SYMBOL,        /* 0x28c6 */
    SYMBOL,        /* 0x28c7 */
    SYMBOL,        /* 0x28c8 */
    SYMBOL,        /* 0x28c9 */
    SYMBOL,        /* 0x28ca */
    SYMBOL,        /* 0x28cb */
    SYMBOL,        /* 0x28cc */
    SYMBOL,        /* 0x28cd */
    SYMBOL,        /* 0x28ce */
    SYMBOL,        /* 0x28cf */
    SYMBOL,        /* 0x28d0 */
    SYMBOL,        /* 0x28d1 */
    SYMBOL,        /* 0x28d2 */
    SYMBOL,        /* 0x28d3 */
    SYMBOL,        /* 0x28d4 */
    SYMBOL,        /* 0x28d5 */
    SYMBOL,        /* 0x28d6 */
    SYMBOL,        /* 0x28d7 */
    SYMBOL,        /* 0x28d8 */
    SYMBOL,        /* 0x28d9 */
    SYMBOL,        /* 0x28da */
    SYMBOL,        /* 0x28db */
    SYMBOL,        /* 0x28dc */
    SYMBOL,        /* 0x28dd */
    SYMBOL,        /* 0x28de */
    SYMBOL,        /* 0x28df */
    SYMBOL,        /* 0x28e0 */
    SYMBOL,        /* 0x28e1 */
    SYMBOL,        /* 0x28e2 */
    SYMBOL,        /* 0x28e3 */
    SYMBOL,        /* 0x28e4 */
    SYMBOL,        /* 0x28e5 */
    SYMBOL,        /* 0x28e6 */
    SYMBOL,        /* 0x28e7 */
    SYMBOL,        /* 0x28e8 */
    SYMBOL,        /* 0x28e9 */
    SYMBOL,        /* 0x28ea */
    SYMBOL,        /* 0x28eb */
    SYMBOL,        /* 0x28ec */
    SYMBOL,        /* 0x28ed */
    SYMBOL,        /* 0x28ee */
    SYMBOL,        /* 0x28ef */
    SYMBOL,        /* 0x28f0 */
    SYMBOL,        /* 0x28f1 */
    SYMBOL,        /* 0x28f2 */
    SYMBOL,        /* 0x28f3 */
    SYMBOL,        /* 0x28f4 */
    SYMBOL,        /* 0x28f5 */
    SYMBOL,        /* 0x28f6 */
    SYMBOL,        /* 0x28f7 */
    SYMBOL,        /* 0x28f8 */
    SYMBOL,        /* 0x28f9 */
    SYMBOL,        /* 0x28fa */
    SYMBOL,        /* 0x28fb */
    SYMBOL,        /* 0x28fc */
    SYMBOL,        /* 0x28fd */
    SYMBOL,        /* 0x28fe */
    SYMBOL,        /* 0x28ff */
    SYMBOL,        /* 0x2900 */
    SYMBOL,        /* 0x2901 */
    SYMBOL,        /* 0x2902 */
    SYMBOL,        /* 0x2903 */
    SYMBOL,        /* 0x2904 */
    SYMBOL,        /* 0x2905 */
    SYMBOL,        /* 0x2906 */
    SYMBOL,        /* 0x2907 */
    SYMBOL,        /* 0x2908 */
    SYMBOL,        /* 0x2909 */
    SYMBOL,        /* 0x290a */
    SYMBOL,        /* 0x290b */
    SYMBOL,        /* 0x290c */
    SYMBOL,        /* 0x290d */
    SYMBOL,        /* 0x290e */
    SYMBOL,        /* 0x290f */
    SYMBOL,        /* 0x2910 */
    SYMBOL,        /* 0x2911 */
    SYMBOL,        /* 0x2912 */
    SYMBOL,        /* 0x2913 */
    SYMBOL,        /* 0x2914 */
    SYMBOL,        /* 0x2915 */
    SYMBOL,        /* 0x2916 */
    SYMBOL,        /* 0x2917 */
    SYMBOL,        /* 0x2918 */
    SYMBOL,        /* 0x2919 */
    SYMBOL,        /* 0x291a */
    SYMBOL,        /* 0x291b */
    SYMBOL,        /* 0x291c */
    SYMBOL,        /* 0x291d */
    SYMBOL,        /* 0x291e */
    SYMBOL,        /* 0x291f */
    SYMBOL,        /* 0x2920 */
    SYMBOL,        /* 0x2921 */
    SYMBOL,        /* 0x2922 */
    SYMBOL,        /* 0x2923 */
    SYMBOL,        /* 0x2924 */
    SYMBOL,        /* 0x2925 */
    SYMBOL,        /* 0x2926 */
    SYMBOL,        /* 0x2927 */
    SYMBOL,        /* 0x2928 */
    SYMBOL,        /* 0x2929 */
    SYMBOL,        /* 0x292a */
    SYMBOL,        /* 0x292b */
    SYMBOL,        /* 0x292c */
    SYMBOL,        /* 0x292d */
    SYMBOL,        /* 0x292e */
    SYMBOL,        /* 0x292f */
    SYMBOL,        /* 0x2930 */
    SYMBOL,        /* 0x2931 */
    SYMBOL,        /* 0x2932 */
    SYMBOL,        /* 0x2933 */
    SYMBOL,        /* 0x2934 */
    SYMBOL,        /* 0x2935 */
    SYMBOL,        /* 0x2936 */
    SYMBOL,        /* 0x2937 */
    SYMBOL,        /* 0x2938 */
    SYMBOL,        /* 0x2939 */
    SYMBOL,        /* 0x293a */
    SYMBOL,        /* 0x293b */
    SYMBOL,        /* 0x293c */
    SYMBOL,        /* 0x293d */
    SYMBOL,        /* 0x293e */
    SYMBOL,        /* 0x293f */
    SYMBOL,        /* 0x2940 */
    SYMBOL,        /* 0x2941 */
    SYMBOL,        /* 0x2942 */
    SYMBOL,        /* 0x2943 */
    SYMBOL,        /* 0x2944 */
    SYMBOL,        /* 0x2945 */
    SYMBOL,        /* 0x2946 */
    SYMBOL,        /* 0x2947 */
    SYMBOL,        /* 0x2948 */
    SYMBOL,        /* 0x2949 */
    SYMBOL,        /* 0x294a */
    SYMBOL,        /* 0x294b */
    SYMBOL,        /* 0x294c */
    SYMBOL,        /* 0x294d */
    SYMBOL,        /* 0x294e */
    SYMBOL,        /* 0x294f */
    SYMBOL,        /* 0x2950 */
    SYMBOL,        /* 0x2951 */
    SYMBOL,        /* 0x2952 */
    SYMBOL,        /* 0x2953 */
    SYMBOL,        /* 0x2954 */
    SYMBOL,        /* 0x2955 */
    SYMBOL,        /* 0x2956 */
    SYMBOL,        /* 0x2957 */
    SYMBOL,        /* 0x2958 */
    SYMBOL,        /* 0x2959 */
    SYMBOL,        /* 0x295a */
    SYMBOL,        /* 0x295b */
    SYMBOL,        /* 0x295c */
    SYMBOL,        /* 0x295d */
    SYMBOL,        /* 0x295e */
    SYMBOL,        /* 0x295f */
    SYMBOL,        /* 0x2960 */
    SYMBOL,        /* 0x2961 */
    SYMBOL,        /* 0x2962 */
    SYMBOL,        /* 0x2963 */
    SYMBOL,        /* 0x2964 */
    SYMBOL,        /* 0x2965 */
    SYMBOL,        /* 0x2966 */
    SYMBOL,        /* 0x2967 */
    SYMBOL,        /* 0x2968 */
    SYMBOL,        /* 0x2969 */
    SYMBOL,        /* 0x296a */
    SYMBOL,        /* 0x296b */
    SYMBOL,        /* 0x296c */
    SYMBOL,        /* 0x296d */
    SYMBOL,        /* 0x296e */
    SYMBOL,        /* 0x296f */
    SYMBOL,        /* 0x2970 */
    SYMBOL,        /* 0x2971 */
    SYMBOL,        /* 0x2972 */
    SYMBOL,        /* 0x2973 */
    SYMBOL,        /* 0x2974 */
    SYMBOL,        /* 0x2975 */
    SYMBOL,        /* 0x2976 */
    SYMBOL,        /* 0x2977 */
    SYMBOL,        /* 0x2978 */
    SYMBOL,        /* 0x2979 */
    SYMBOL,        /* 0x297a */
    SYMBOL,        /* 0x297b */
    SYMBOL,        /* 0x297c */
    SYMBOL,        /* 0x297d */
    SYMBOL,        /* 0x297e */
    SYMBOL,        /* 0x297f */
    OTHER,        /* 0x2980 */
    OTHER,        /* 0x2981 */
    OTHER,        /* 0x2982 */
    OTHER,        /* 0x2983 */
    OTHER,        /* 0x2984 */
    OTHER,        /* 0x2985 */
    OTHER,        /* 0x2986 */
    OTHER,        /* 0x2987 */
    OTHER,        /* 0x2988 */
    OTHER,        /* 0x2989 */
    OTHER,        /* 0x298a */
    OTHER,        /* 0x298b */
    OTHER,        /* 0x298c */
    OTHER,        /* 0x298d */
    OTHER,        /* 0x298e */
    OTHER,        /* 0x298f */
    OTHER,        /* 0x2990 */
    OTHER,        /* 0x2991 */
    OTHER,        /* 0x2992 */
    OTHER,        /* 0x2993 */
    OTHER,        /* 0x2994 */
    OTHER,        /* 0x2995 */
    OTHER,        /* 0x2996 */
    OTHER,        /* 0x2997 */
    OTHER,        /* 0x2998 */
    OTHER,        /* 0x2999 */
    OTHER,        /* 0x299a */
    OTHER,        /* 0x299b */
    OTHER,        /* 0x299c */
    OTHER,        /* 0x299d */
    OTHER,        /* 0x299e */
    OTHER,        /* 0x299f */
    OTHER,        /* 0x29a0 */
    OTHER,        /* 0x29a1 */
    OTHER,        /* 0x29a2 */
    OTHER,        /* 0x29a3 */
    OTHER,        /* 0x29a4 */
    OTHER,        /* 0x29a5 */
    OTHER,        /* 0x29a6 */
    OTHER,        /* 0x29a7 */
    OTHER,        /* 0x29a8 */
    OTHER,        /* 0x29a9 */
    OTHER,        /* 0x29aa */
    OTHER,        /* 0x29ab */
    OTHER,        /* 0x29ac */
    OTHER,        /* 0x29ad */
    OTHER,        /* 0x29ae */
    OTHER,        /* 0x29af */
    OTHER,        /* 0x29b0 */
    OTHER,        /* 0x29b1 */
    OTHER,        /* 0x29b2 */
    OTHER,        /* 0x29b3 */
    OTHER,        /* 0x29b4 */
    OTHER,        /* 0x29b5 */
    OTHER,        /* 0x29b6 */
    OTHER,        /* 0x29b7 */
    OTHER,        /* 0x29b8 */
    OTHER,        /* 0x29b9 */
    OTHER,        /* 0x29ba */
    OTHER,        /* 0x29bb */
    OTHER,        /* 0x29bc */
    OTHER,        /* 0x29bd */
    OTHER,        /* 0x29be */
    OTHER,        /* 0x29bf */
    OTHER,        /* 0x29c0 */
    OTHER,        /* 0x29c1 */
    OTHER,        /* 0x29c2 */
    OTHER,        /* 0x29c3 */
    OTHER,        /* 0x29c4 */
    OTHER,        /* 0x29c5 */
    OTHER,        /* 0x29c6 */
    OTHER,        /* 0x29c7 */
    OTHER,        /* 0x29c8 */
    OTHER,        /* 0x29c9 */
    OTHER,        /* 0x29ca */
    OTHER,        /* 0x29cb */
    OTHER,        /* 0x29cc */
    OTHER,        /* 0x29cd */
    OTHER,        /* 0x29ce */
    OTHER,        /* 0x29cf */
    OTHER,        /* 0x29d0 */
    OTHER,        /* 0x29d1 */
    OTHER,        /* 0x29d2 */
    OTHER,        /* 0x29d3 */
    OTHER,        /* 0x29d4 */
    OTHER,        /* 0x29d5 */
    OTHER,        /* 0x29d6 */
    OTHER,        /* 0x29d7 */
    OTHER,        /* 0x29d8 */
    OTHER,        /* 0x29d9 */
    OTHER,        /* 0x29da */
    OTHER,        /* 0x29db */
    OTHER,        /* 0x29dc */
    OTHER,        /* 0x29dd */
    OTHER,        /* 0x29de */
    OTHER,        /* 0x29df */
    OTHER,        /* 0x29e0 */
    OTHER,        /* 0x29e1 */
    OTHER,        /* 0x29e2 */
    OTHER,        /* 0x29e3 */
    OTHER,        /* 0x29e4 */
    OTHER,        /* 0x29e5 */
    OTHER,        /* 0x29e6 */
    OTHER,        /* 0x29e7 */
    OTHER,        /* 0x29e8 */
    OTHER,        /* 0x29e9 */
    OTHER,        /* 0x29ea */
    OTHER,        /* 0x29eb */
    OTHER,        /* 0x29ec */
    OTHER,        /* 0x29ed */
    OTHER,        /* 0x29ee */
    OTHER,        /* 0x29ef */
    OTHER,        /* 0x29f0 */
    OTHER,        /* 0x29f1 */
    OTHER,        /* 0x29f2 */
    OTHER,        /* 0x29f3 */
    OTHER,        /* 0x29f4 */
    OTHER,        /* 0x29f5 */
    OTHER,        /* 0x29f6 */
    OTHER,        /* 0x29f7 */
    OTHER,        /* 0x29f8 */
    OTHER,        /* 0x29f9 */
    OTHER,        /* 0x29fa */
    OTHER,        /* 0x29fb */
    OTHER,        /* 0x29fc */
    OTHER,        /* 0x29fd */
    OTHER,        /* 0x29fe */
    OTHER,        /* 0x29ff */
    SYMBOL,        /* 0x2a00 */
    SYMBOL,        /* 0x2a01 */
    SYMBOL,        /* 0x2a02 */
    SYMBOL,        /* 0x2a03 */
    SYMBOL,        /* 0x2a04 */
    SYMBOL,        /* 0x2a05 */
    SYMBOL,        /* 0x2a06 */
    SYMBOL,        /* 0x2a07 */
    SYMBOL,        /* 0x2a08 */
    SYMBOL,        /* 0x2a09 */
    SYMBOL,        /* 0x2a0a */
    SYMBOL,        /* 0x2a0b */
    SYMBOL,        /* 0x2a0c */
    SYMBOL,        /* 0x2a0d */
    SYMBOL,        /* 0x2a0e */
    SYMBOL,        /* 0x2a0f */
    SYMBOL,        /* 0x2a10 */
    SYMBOL,        /* 0x2a11 */
    SYMBOL,        /* 0x2a12 */
    SYMBOL,        /* 0x2a13 */
    SYMBOL,        /* 0x2a14 */
    SYMBOL,        /* 0x2a15 */
    SYMBOL,        /* 0x2a16 */
    SYMBOL,        /* 0x2a17 */
    SYMBOL,        /* 0x2a18 */
    SYMBOL,        /* 0x2a19 */
    SYMBOL,        /* 0x2a1a */
    SYMBOL,        /* 0x2a1b */
    SYMBOL,        /* 0x2a1c */
    SYMBOL,        /* 0x2a1d */
    SYMBOL,        /* 0x2a1e */
    SYMBOL,        /* 0x2a1f */
    SYMBOL,        /* 0x2a20 */
    SYMBOL,        /* 0x2a21 */
    SYMBOL,        /* 0x2a22 */
    SYMBOL,        /* 0x2a23 */
    SYMBOL,        /* 0x2a24 */
    SYMBOL,        /* 0x2a25 */
    SYMBOL,        /* 0x2a26 */
    SYMBOL,        /* 0x2a27 */
    SYMBOL,        /* 0x2a28 */
    SYMBOL,        /* 0x2a29 */
    SYMBOL,        /* 0x2a2a */
    SYMBOL,        /* 0x2a2b */
    SYMBOL,        /* 0x2a2c */
    SYMBOL,        /* 0x2a2d */
    SYMBOL,        /* 0x2a2e */
    SYMBOL,        /* 0x2a2f */
    SYMBOL,        /* 0x2a30 */
    SYMBOL,        /* 0x2a31 */
    SYMBOL,        /* 0x2a32 */
    SYMBOL,        /* 0x2a33 */
    SYMBOL,        /* 0x2a34 */
    SYMBOL,        /* 0x2a35 */
    SYMBOL,        /* 0x2a36 */
    SYMBOL,        /* 0x2a37 */
    SYMBOL,        /* 0x2a38 */
    SYMBOL,        /* 0x2a39 */
    SYMBOL,        /* 0x2a3a */
    SYMBOL,        /* 0x2a3b */
    SYMBOL,        /* 0x2a3c */
    SYMBOL,        /* 0x2a3d */
    SYMBOL,        /* 0x2a3e */
    SYMBOL,        /* 0x2a3f */
    SYMBOL,        /* 0x2a40 */
    SYMBOL,        /* 0x2a41 */
    SYMBOL,        /* 0x2a42 */
    SYMBOL,        /* 0x2a43 */
    SYMBOL,        /* 0x2a44 */
    SYMBOL,        /* 0x2a45 */
    SYMBOL,        /* 0x2a46 */
    SYMBOL,        /* 0x2a47 */
    SYMBOL,        /* 0x2a48 */
    SYMBOL,        /* 0x2a49 */
    SYMBOL,        /* 0x2a4a */
    SYMBOL,        /* 0x2a4b */
    SYMBOL,        /* 0x2a4c */
    SYMBOL,        /* 0x2a4d */
    SYMBOL,        /* 0x2a4e */
    SYMBOL,        /* 0x2a4f */
    SYMBOL,        /* 0x2a50 */
    SYMBOL,        /* 0x2a51 */
    SYMBOL,        /* 0x2a52 */
    SYMBOL,        /* 0x2a53 */
    SYMBOL,        /* 0x2a54 */
    SYMBOL,        /* 0x2a55 */
    SYMBOL,        /* 0x2a56 */
    SYMBOL,        /* 0x2a57 */
    SYMBOL,        /* 0x2a58 */
    SYMBOL,        /* 0x2a59 */
    SYMBOL,        /* 0x2a5a */
    SYMBOL,        /* 0x2a5b */
    SYMBOL,        /* 0x2a5c */
    SYMBOL,        /* 0x2a5d */
    SYMBOL,        /* 0x2a5e */
    SYMBOL,        /* 0x2a5f */
    SYMBOL,        /* 0x2a60 */
    SYMBOL,        /* 0x2a61 */
    SYMBOL,        /* 0x2a62 */
    SYMBOL,        /* 0x2a63 */
    SYMBOL,        /* 0x2a64 */
    SYMBOL,        /* 0x2a65 */
    SYMBOL,        /* 0x2a66 */
    SYMBOL,        /* 0x2a67 */
    SYMBOL,        /* 0x2a68 */
    SYMBOL,        /* 0x2a69 */
    SYMBOL,        /* 0x2a6a */
    SYMBOL,        /* 0x2a6b */
    SYMBOL,        /* 0x2a6c */
    SYMBOL,        /* 0x2a6d */
    SYMBOL,        /* 0x2a6e */
    SYMBOL,        /* 0x2a6f */
    SYMBOL,        /* 0x2a70 */
    SYMBOL,        /* 0x2a71 */
    SYMBOL,        /* 0x2a72 */
    SYMBOL,        /* 0x2a73 */
    SYMBOL,        /* 0x2a74 */
    SYMBOL,        /* 0x2a75 */
    SYMBOL,        /* 0x2a76 */
    SYMBOL,        /* 0x2a77 */
    SYMBOL,        /* 0x2a78 */
    SYMBOL,        /* 0x2a79 */
    SYMBOL,        /* 0x2a7a */
    SYMBOL,        /* 0x2a7b */
    SYMBOL,        /* 0x2a7c */
    SYMBOL,        /* 0x2a7d */
    SYMBOL,        /* 0x2a7e */
    SYMBOL,        /* 0x2a7f */
    SYMBOL,        /* 0x2a80 */
    SYMBOL,        /* 0x2a81 */
    SYMBOL,        /* 0x2a82 */
    SYMBOL,        /* 0x2a83 */
    SYMBOL,        /* 0x2a84 */
    SYMBOL,        /* 0x2a85 */
    SYMBOL,        /* 0x2a86 */
    SYMBOL,        /* 0x2a87 */
    SYMBOL,        /* 0x2a88 */
    SYMBOL,        /* 0x2a89 */
    SYMBOL,        /* 0x2a8a */
    SYMBOL,        /* 0x2a8b */
    SYMBOL,        /* 0x2a8c */
    SYMBOL,        /* 0x2a8d */
    SYMBOL,        /* 0x2a8e */
    SYMBOL,        /* 0x2a8f */
    SYMBOL,        /* 0x2a90 */
    SYMBOL,        /* 0x2a91 */
    SYMBOL,        /* 0x2a92 */
    SYMBOL,        /* 0x2a93 */
    SYMBOL,        /* 0x2a94 */
    SYMBOL,        /* 0x2a95 */
    SYMBOL,        /* 0x2a96 */
    SYMBOL,        /* 0x2a97 */
    SYMBOL,        /* 0x2a98 */
    SYMBOL,        /* 0x2a99 */
    SYMBOL,        /* 0x2a9a */
    SYMBOL,        /* 0x2a9b */
    SYMBOL,        /* 0x2a9c */
    SYMBOL,        /* 0x2a9d */
    SYMBOL,        /* 0x2a9e */
    SYMBOL,        /* 0x2a9f */
    SYMBOL,        /* 0x2aa0 */
    SYMBOL,        /* 0x2aa1 */
    SYMBOL,        /* 0x2aa2 */
    SYMBOL,        /* 0x2aa3 */
    SYMBOL,        /* 0x2aa4 */
    SYMBOL,        /* 0x2aa5 */
    SYMBOL,        /* 0x2aa6 */
    SYMBOL,        /* 0x2aa7 */
    SYMBOL,        /* 0x2aa8 */
    SYMBOL,        /* 0x2aa9 */
    SYMBOL,        /* 0x2aaa */
    SYMBOL,        /* 0x2aab */
    SYMBOL,        /* 0x2aac */
    SYMBOL,        /* 0x2aad */
    SYMBOL,        /* 0x2aae */
    SYMBOL,        /* 0x2aaf */
    SYMBOL,        /* 0x2ab0 */
    SYMBOL,        /* 0x2ab1 */
    SYMBOL,        /* 0x2ab2 */
    SYMBOL,        /* 0x2ab3 */
    SYMBOL,        /* 0x2ab4 */
    SYMBOL,        /* 0x2ab5 */
    SYMBOL,        /* 0x2ab6 */
    SYMBOL,        /* 0x2ab7 */
    SYMBOL,        /* 0x2ab8 */
    SYMBOL,        /* 0x2ab9 */
    SYMBOL,        /* 0x2aba */
    SYMBOL,        /* 0x2abb */
    SYMBOL,        /* 0x2abc */
    SYMBOL,        /* 0x2abd */
    SYMBOL,        /* 0x2abe */
    SYMBOL,        /* 0x2abf */
    SYMBOL,        /* 0x2ac0 */
    SYMBOL,        /* 0x2ac1 */
    SYMBOL,        /* 0x2ac2 */
    SYMBOL,        /* 0x2ac3 */
    SYMBOL,        /* 0x2ac4 */
    SYMBOL,        /* 0x2ac5 */
    SYMBOL,        /* 0x2ac6 */
    SYMBOL,        /* 0x2ac7 */
    SYMBOL,        /* 0x2ac8 */
    SYMBOL,        /* 0x2ac9 */
    SYMBOL,        /* 0x2aca */
    SYMBOL,        /* 0x2acb */
    SYMBOL,        /* 0x2acc */
    SYMBOL,        /* 0x2acd */
    SYMBOL,        /* 0x2ace */
    SYMBOL,        /* 0x2acf */
    SYMBOL,        /* 0x2ad0 */
    SYMBOL,        /* 0x2ad1 */
    SYMBOL,        /* 0x2ad2 */
    SYMBOL,        /* 0x2ad3 */
    SYMBOL,        /* 0x2ad4 */
    SYMBOL,        /* 0x2ad5 */
    SYMBOL,        /* 0x2ad6 */
    SYMBOL,        /* 0x2ad7 */
    SYMBOL,        /* 0x2ad8 */
    SYMBOL,        /* 0x2ad9 */
    SYMBOL,        /* 0x2ada */
    SYMBOL,        /* 0x2adb */
    SYMBOL,        /* 0x2adc */
    SYMBOL,        /* 0x2add */
    SYMBOL,        /* 0x2ade */
    SYMBOL,        /* 0x2adf */
    SYMBOL,        /* 0x2ae0 */
    SYMBOL,        /* 0x2ae1 */
    SYMBOL,        /* 0x2ae2 */
    SYMBOL,        /* 0x2ae3 */
    SYMBOL,        /* 0x2ae4 */
    SYMBOL,        /* 0x2ae5 */
    SYMBOL,        /* 0x2ae6 */
    SYMBOL,        /* 0x2ae7 */
    SYMBOL,        /* 0x2ae8 */
    SYMBOL,        /* 0x2ae9 */
    SYMBOL,        /* 0x2aea */
    SYMBOL,        /* 0x2aeb */
    SYMBOL,        /* 0x2aec */
    SYMBOL,        /* 0x2aed */
    SYMBOL,        /* 0x2aee */
    SYMBOL,        /* 0x2aef */
    SYMBOL,        /* 0x2af0 */
    SYMBOL,        /* 0x2af1 */
    SYMBOL,        /* 0x2af2 */
    SYMBOL,        /* 0x2af3 */
    SYMBOL,        /* 0x2af4 */
    SYMBOL,        /* 0x2af5 */
    SYMBOL,        /* 0x2af6 */
    SYMBOL,        /* 0x2af7 */
    SYMBOL,        /* 0x2af8 */
    SYMBOL,        /* 0x2af9 */
    SYMBOL,        /* 0x2afa */
    SYMBOL,        /* 0x2afb */
    SYMBOL,        /* 0x2afc */
    SYMBOL,        /* 0x2afd */
    SYMBOL,        /* 0x2afe */
    SYMBOL,        /* 0x2aff */
    SYMBOL,        /* 0x2b00 */
    SYMBOL,        /* 0x2b01 */
    SYMBOL,        /* 0x2b02 */
    SYMBOL,        /* 0x2b03 */
    SYMBOL,        /* 0x2b04 */
    SYMBOL,        /* 0x2b05 */
    SYMBOL,        /* 0x2b06 */
    SYMBOL,        /* 0x2b07 */
    SYMBOL,        /* 0x2b08 */
    SYMBOL,        /* 0x2b09 */
    SYMBOL,        /* 0x2b0a */
    SYMBOL,        /* 0x2b0b */
    SYMBOL,        /* 0x2b0c */
    SYMBOL,        /* 0x2b0d */
    SYMBOL,        /* 0x2b0e */
    SYMBOL,        /* 0x2b0f */
    SYMBOL,        /* 0x2b10 */
    SYMBOL,        /* 0x2b11 */
    SYMBOL,        /* 0x2b12 */
    SYMBOL,        /* 0x2b13 */
    SYMBOL,        /* 0x2b14 */
    SYMBOL,        /* 0x2b15 */
    SYMBOL,        /* 0x2b16 */
    SYMBOL,        /* 0x2b17 */
    SYMBOL,        /* 0x2b18 */
    SYMBOL,        /* 0x2b19 */
    SYMBOL,        /* 0x2b1a */
    SYMBOL,        /* 0x2b1b */
    SYMBOL,        /* 0x2b1c */
    SYMBOL,        /* 0x2b1d */
    SYMBOL,        /* 0x2b1e */
    SYMBOL,        /* 0x2b1f */
    SYMBOL,        /* 0x2b20 */
    SYMBOL,        /* 0x2b21 */
    SYMBOL,        /* 0x2b22 */
    SYMBOL,        /* 0x2b23 */
    SYMBOL,        /* 0x2b24 */
    SYMBOL,        /* 0x2b25 */
    SYMBOL,        /* 0x2b26 */
    SYMBOL,        /* 0x2b27 */
    SYMBOL,        /* 0x2b28 */
    SYMBOL,        /* 0x2b29 */
    SYMBOL,        /* 0x2b2a */
    SYMBOL,        /* 0x2b2b */
    SYMBOL,        /* 0x2b2c */
    SYMBOL,        /* 0x2b2d */
    SYMBOL,        /* 0x2b2e */
    SYMBOL,        /* 0x2b2f */
    SYMBOL,        /* 0x2b30 */
    SYMBOL,        /* 0x2b31 */
    SYMBOL,        /* 0x2b32 */
    SYMBOL,        /* 0x2b33 */
    SYMBOL,        /* 0x2b34 */
    SYMBOL,        /* 0x2b35 */
    SYMBOL,        /* 0x2b36 */
    SYMBOL,        /* 0x2b37 */
    SYMBOL,        /* 0x2b38 */
    SYMBOL,        /* 0x2b39 */
    SYMBOL,        /* 0x2b3a */
    SYMBOL,        /* 0x2b3b */
    SYMBOL,        /* 0x2b3c */
    SYMBOL,        /* 0x2b3d */
    SYMBOL,        /* 0x2b3e */
    SYMBOL,        /* 0x2b3f */
    SYMBOL,        /* 0x2b40 */
    SYMBOL,        /* 0x2b41 */
    SYMBOL,        /* 0x2b42 */
    SYMBOL,        /* 0x2b43 */
    SYMBOL,        /* 0x2b44 */
    SYMBOL,        /* 0x2b45 */
    SYMBOL,        /* 0x2b46 */
    SYMBOL,        /* 0x2b47 */
    SYMBOL,        /* 0x2b48 */
    SYMBOL,        /* 0x2b49 */
    SYMBOL,        /* 0x2b4a */
    SYMBOL,        /* 0x2b4b */
    SYMBOL,        /* 0x2b4c */
    SYMBOL,        /* 0x2b4d */
    SYMBOL,        /* 0x2b4e */
    SYMBOL,        /* 0x2b4f */
    SYMBOL,        /* 0x2b50 */
    SYMBOL,        /* 0x2b51 */
    SYMBOL,        /* 0x2b52 */
    SYMBOL,        /* 0x2b53 */
    SYMBOL,        /* 0x2b54 */
    SYMBOL,        /* 0x2b55 */
    SYMBOL,        /* 0x2b56 */
    SYMBOL,        /* 0x2b57 */
    SYMBOL,        /* 0x2b58 */
    SYMBOL,        /* 0x2b59 */
    SYMBOL,        /* 0x2b5a */
    SYMBOL,        /* 0x2b5b */
    SYMBOL,        /* 0x2b5c */
    SYMBOL,        /* 0x2b5d */
    SYMBOL,        /* 0x2b5e */
    SYMBOL,        /* 0x2b5f */
    SYMBOL,        /* 0x2b60 */
    SYMBOL,        /* 0x2b61 */
    SYMBOL,        /* 0x2b62 */
    SYMBOL,        /* 0x2b63 */
    SYMBOL,        /* 0x2b64 */
    SYMBOL,        /* 0x2b65 */
    SYMBOL,        /* 0x2b66 */
    SYMBOL,        /* 0x2b67 */
    SYMBOL,        /* 0x2b68 */
    SYMBOL,        /* 0x2b69 */
    SYMBOL,        /* 0x2b6a */
    SYMBOL,        /* 0x2b6b */
    SYMBOL,        /* 0x2b6c */
    SYMBOL,        /* 0x2b6d */
    SYMBOL,        /* 0x2b6e */
    SYMBOL,        /* 0x2b6f */
    SYMBOL,        /* 0x2b70 */
    SYMBOL,        /* 0x2b71 */
    SYMBOL,        /* 0x2b72 */
    SYMBOL,        /* 0x2b73 */
    SYMBOL,        /* 0x2b74 */
    SYMBOL,        /* 0x2b75 */
    SYMBOL,        /* 0x2b76 */
    SYMBOL,        /* 0x2b77 */
    SYMBOL,        /* 0x2b78 */
    SYMBOL,        /* 0x2b79 */
    SYMBOL,        /* 0x2b7a */
    SYMBOL,        /* 0x2b7b */
    SYMBOL,        /* 0x2b7c */
    SYMBOL,        /* 0x2b7d */
    SYMBOL,        /* 0x2b7e */
    SYMBOL,        /* 0x2b7f */
    SYMBOL,        /* 0x2b80 */
    SYMBOL,        /* 0x2b81 */
    SYMBOL,        /* 0x2b82 */
    SYMBOL,        /* 0x2b83 */
    SYMBOL,        /* 0x2b84 */
    SYMBOL,        /* 0x2b85 */
    SYMBOL,        /* 0x2b86 */
    SYMBOL,        /* 0x2b87 */
    SYMBOL,        /* 0x2b88 */
    SYMBOL,        /* 0x2b89 */
    SYMBOL,        /* 0x2b8a */
    SYMBOL,        /* 0x2b8b */
    SYMBOL,        /* 0x2b8c */
    SYMBOL,        /* 0x2b8d */
    SYMBOL,        /* 0x2b8e */
    SYMBOL,        /* 0x2b8f */
    SYMBOL,        /* 0x2b90 */
    SYMBOL,        /* 0x2b91 */
    SYMBOL,        /* 0x2b92 */
    SYMBOL,        /* 0x2b93 */
    SYMBOL,        /* 0x2b94 */
    SYMBOL,        /* 0x2b95 */
    SYMBOL,        /* 0x2b96 */
    SYMBOL,        /* 0x2b97 */
    SYMBOL,        /* 0x2b98 */
    SYMBOL,        /* 0x2b99 */
    SYMBOL,        /* 0x2b9a */
    SYMBOL,        /* 0x2b9b */
    SYMBOL,        /* 0x2b9c */
    SYMBOL,        /* 0x2b9d */
    SYMBOL,        /* 0x2b9e */
    SYMBOL,        /* 0x2b9f */
    SYMBOL,        /* 0x2ba0 */
    SYMBOL,        /* 0x2ba1 */
    SYMBOL,        /* 0x2ba2 */
    SYMBOL,        /* 0x2ba3 */
    SYMBOL,        /* 0x2ba4 */
    SYMBOL,        /* 0x2ba5 */
    SYMBOL,        /* 0x2ba6 */
    SYMBOL,        /* 0x2ba7 */
    SYMBOL,        /* 0x2ba8 */
    SYMBOL,        /* 0x2ba9 */
    SYMBOL,        /* 0x2baa */
    SYMBOL,        /* 0x2bab */
    SYMBOL,        /* 0x2bac */
    SYMBOL,        /* 0x2bad */
    SYMBOL,        /* 0x2bae */
    SYMBOL,        /* 0x2baf */
    SYMBOL,        /* 0x2bb0 */
    SYMBOL,        /* 0x2bb1 */
    SYMBOL,        /* 0x2bb2 */
    SYMBOL,        /* 0x2bb3 */
    SYMBOL,        /* 0x2bb4 */
    SYMBOL,        /* 0x2bb5 */
    SYMBOL,        /* 0x2bb6 */
    SYMBOL,        /* 0x2bb7 */
    SYMBOL,        /* 0x2bb8 */
    SYMBOL,        /* 0x2bb9 */
    SYMBOL,        /* 0x2bba */
    SYMBOL,        /* 0x2bbb */
    SYMBOL,        /* 0x2bbc */
    SYMBOL,        /* 0x2bbd */
    SYMBOL,        /* 0x2bbe */
    SYMBOL,        /* 0x2bbf */
    SYMBOL,        /* 0x2bc0 */
    SYMBOL,        /* 0x2bc1 */
    SYMBOL,        /* 0x2bc2 */
    SYMBOL,        /* 0x2bc3 */
    SYMBOL,        /* 0x2bc4 */
    SYMBOL,        /* 0x2bc5 */
    SYMBOL,        /* 0x2bc6 */
    SYMBOL,        /* 0x2bc7 */
    SYMBOL,        /* 0x2bc8 */
    SYMBOL,        /* 0x2bc9 */
    SYMBOL,        /* 0x2bca */
    SYMBOL,        /* 0x2bcb */
    SYMBOL,        /* 0x2bcc */
    SYMBOL,        /* 0x2bcd */
    SYMBOL,        /* 0x2bce */
    SYMBOL,        /* 0x2bcf */
    SYMBOL,        /* 0x2bd0 */
    SYMBOL,        /* 0x2bd1 */
    SYMBOL,        /* 0x2bd2 */
    SYMBOL,        /* 0x2bd3 */
    SYMBOL,        /* 0x2bd4 */
    SYMBOL,        /* 0x2bd5 */
    SYMBOL,        /* 0x2bd6 */
    SYMBOL,        /* 0x2bd7 */
    SYMBOL,        /* 0x2bd8 */
    SYMBOL,        /* 0x2bd9 */
    SYMBOL,        /* 0x2bda */
    SYMBOL,        /* 0x2bdb */
    SYMBOL,        /* 0x2bdc */
    SYMBOL,        /* 0x2bdd */
    SYMBOL,        /* 0x2bde */
    SYMBOL,        /* 0x2bdf */
    SYMBOL,        /* 0x2be0 */
    SYMBOL,        /* 0x2be1 */
    SYMBOL,        /* 0x2be2 */
    SYMBOL,        /* 0x2be3 */
    SYMBOL,        /* 0x2be4 */
    SYMBOL,        /* 0x2be5 */
    SYMBOL,        /* 0x2be6 */
    SYMBOL,        /* 0x2be7 */
    SYMBOL,        /* 0x2be8 */
    SYMBOL,        /* 0x2be9 */
    SYMBOL,        /* 0x2bea */
    SYMBOL,        /* 0x2beb */
    SYMBOL,        /* 0x2bec */
    SYMBOL,        /* 0x2bed */
    SYMBOL,        /* 0x2bee */
    SYMBOL,        /* 0x2bef */
    SYMBOL,        /* 0x2bf0 */
    SYMBOL,        /* 0x2bf1 */
    SYMBOL,        /* 0x2bf2 */
    SYMBOL,        /* 0x2bf3 */
    SYMBOL,        /* 0x2bf4 */
    SYMBOL,        /* 0x2bf5 */
    SYMBOL,        /* 0x2bf6 */
    SYMBOL,        /* 0x2bf7 */
    SYMBOL,        /* 0x2bf8 */
    SYMBOL,        /* 0x2bf9 */
    SYMBOL,        /* 0x2bfa */
    SYMBOL,        /* 0x2bfb */
    SYMBOL,        /* 0x2bfc */
    SYMBOL,        /* 0x2bfd */
    SYMBOL,        /* 0x2bfe */
    SYMBOL,        /* 0x2bff */
    OTHER,        /* 0x2c00 */
    OTHER,        /* 0x2c01 */
    OTHER,        /* 0x2c02 */
    OTHER,        /* 0x2c03 */
    OTHER,        /* 0x2c04 */
    OTHER,        /* 0x2c05 */
    OTHER,        /* 0x2c06 */
    OTHER,        /* 0x2c07 */
    OTHER,        /* 0x2c08 */
    OTHER,        /* 0x2c09 */
    OTHER,        /* 0x2c0a */
    OTHER,        /* 0x2c0b */
    OTHER,        /* 0x2c0c */
    OTHER,        /* 0x2c0d */
    OTHER,        /* 0x2c0e */
    OTHER,        /* 0x2c0f */
    OTHER,        /* 0x2c10 */
    OTHER,        /* 0x2c11 */
    OTHER,        /* 0x2c12 */
    OTHER,        /* 0x2c13 */
    OTHER,        /* 0x2c14 */
    OTHER,        /* 0x2c15 */
    OTHER,        /* 0x2c16 */
    OTHER,        /* 0x2c17 */
    OTHER,        /* 0x2c18 */
    OTHER,        /* 0x2c19 */
    OTHER,        /* 0x2c1a */
    OTHER,        /* 0x2c1b */
    OTHER,        /* 0x2c1c */
    OTHER,        /* 0x2c1d */
    OTHER,        /* 0x2c1e */
    OTHER,        /* 0x2c1f */
    OTHER,        /* 0x2c20 */
    OTHER,        /* 0x2c21 */
    OTHER,        /* 0x2c22 */
    OTHER,        /* 0x2c23 */
    OTHER,        /* 0x2c24 */
    OTHER,        /* 0x2c25 */
    OTHER,        /* 0x2c26 */
    OTHER,        /* 0x2c27 */
    OTHER,        /* 0x2c28 */
    OTHER,        /* 0x2c29 */
    OTHER,        /* 0x2c2a */
    OTHER,        /* 0x2c2b */
    OTHER,        /* 0x2c2c */
    OTHER,        /* 0x2c2d */
    OTHER,        /* 0x2c2e */
    OTHER,        /* 0x2c2f */
    OTHER,        /* 0x2c30 */
    OTHER,        /* 0x2c31 */
    OTHER,        /* 0x2c32 */
    OTHER,        /* 0x2c33 */
    OTHER,        /* 0x2c34 */
    OTHER,        /* 0x2c35 */
    OTHER,        /* 0x2c36 */
    OTHER,        /* 0x2c37 */
    OTHER,        /* 0x2c38 */
    OTHER,        /* 0x2c39 */
    OTHER,        /* 0x2c3a */
    OTHER,        /* 0x2c3b */
    OTHER,        /* 0x2c3c */
    OTHER,        /* 0x2c3d */
    OTHER,        /* 0x2c3e */
    OTHER,        /* 0x2c3f */
    OTHER,        /* 0x2c40 */
    OTHER,        /* 0x2c41 */
    OTHER,        /* 0x2c42 */
    OTHER,        /* 0x2c43 */
    OTHER,        /* 0x2c44 */
    OTHER,        /* 0x2c45 */
    OTHER,        /* 0x2c46 */
    OTHER,        /* 0x2c47 */
    OTHER,        /* 0x2c48 */
    OTHER,        /* 0x2c49 */
    OTHER,        /* 0x2c4a */
    OTHER,        /* 0x2c4b */
    OTHER,        /* 0x2c4c */
    OTHER,        /* 0x2c4d */
    OTHER,        /* 0x2c4e */
    OTHER,        /* 0x2c4f */
    OTHER,        /* 0x2c50 */
    OTHER,        /* 0x2c51 */
    OTHER,        /* 0x2c52 */
    OTHER,        /* 0x2c53 */
    OTHER,        /* 0x2c54 */
    OTHER,        /* 0x2c55 */
    OTHER,        /* 0x2c56 */
    OTHER,        /* 0x2c57 */
    OTHER,        /* 0x2c58 */
    OTHER,        /* 0x2c59 */
    OTHER,        /* 0x2c5a */
    OTHER,        /* 0x2c5b */
    OTHER,        /* 0x2c5c */
    OTHER,        /* 0x2c5d */
    OTHER,        /* 0x2c5e */
    OTHER,        /* 0x2c5f */
    OTHER,        /* 0x2c60 */
    OTHER,        /* 0x2c61 */
    OTHER,        /* 0x2c62 */
    OTHER,        /* 0x2c63 */
    OTHER,        /* 0x2c64 */
    OTHER,        /* 0x2c65 */
    OTHER,        /* 0x2c66 */
    OTHER,        /* 0x2c67 */
    OTHER,        /* 0x2c68 */
    OTHER,        /* 0x2c69 */
    OTHER,        /* 0x2c6a */
    OTHER,        /* 0x2c6b */
    OTHER,        /* 0x2c6c */
    OTHER,        /* 0x2c6d */
    OTHER,        /* 0x2c6e */
    OTHER,        /* 0x2c6f */
    OTHER,        /* 0x2c70 */
    OTHER,        /* 0x2c71 */
    OTHER,        /* 0x2c72 */
    OTHER,        /* 0x2c73 */
    OTHER,        /* 0x2c74 */
    OTHER,        /* 0x2c75 */
    OTHER,        /* 0x2c76 */
    OTHER,        /* 0x2c77 */
    OTHER,        /* 0x2c78 */
    OTHER,        /* 0x2c79 */
    OTHER,        /* 0x2c7a */
    OTHER,        /* 0x2c7b */
    OTHER,        /* 0x2c7c */
    OTHER,        /* 0x2c7d */
    OTHER,        /* 0x2c7e */
    OTHER,        /* 0x2c7f */
    OTHER,        /* 0x2c80 */
    OTHER,        /* 0x2c81 */
    OTHER,        /* 0x2c82 */
    OTHER,        /* 0x2c83 */
    OTHER,        /* 0x2c84 */
    OTHER,        /* 0x2c85 */
    OTHER,        /* 0x2c86 */
    OTHER,        /* 0x2c87 */
    OTHER,        /* 0x2c88 */
    OTHER,        /* 0x2c89 */
    OTHER,        /* 0x2c8a */
    OTHER,        /* 0x2c8b */
    OTHER,        /* 0x2c8c */
    OTHER,        /* 0x2c8d */
    OTHER,        /* 0x2c8e */
    OTHER,        /* 0x2c8f */
    OTHER,        /* 0x2c90 */
    OTHER,        /* 0x2c91 */
    OTHER,        /* 0x2c92 */
    OTHER,        /* 0x2c93 */
    OTHER,        /* 0x2c94 */
    OTHER,        /* 0x2c95 */
    OTHER,        /* 0x2c96 */
    OTHER,        /* 0x2c97 */
    OTHER,        /* 0x2c98 */
    OTHER,        /* 0x2c99 */
    OTHER,        /* 0x2c9a */
    OTHER,        /* 0x2c9b */
    OTHER,        /* 0x2c9c */
    OTHER,        /* 0x2c9d */
    OTHER,        /* 0x2c9e */
    OTHER,        /* 0x2c9f */
    OTHER,        /* 0x2ca0 */
    OTHER,        /* 0x2ca1 */
    OTHER,        /* 0x2ca2 */
    OTHER,        /* 0x2ca3 */
    OTHER,        /* 0x2ca4 */
    OTHER,        /* 0x2ca5 */
    OTHER,        /* 0x2ca6 */
    OTHER,        /* 0x2ca7 */
    OTHER,        /* 0x2ca8 */
    OTHER,        /* 0x2ca9 */
    OTHER,        /* 0x2caa */
    OTHER,        /* 0x2cab */
    OTHER,        /* 0x2cac */
    OTHER,        /* 0x2cad */
    OTHER,        /* 0x2cae */
    OTHER,        /* 0x2caf */
    OTHER,        /* 0x2cb0 */
    OTHER,        /* 0x2cb1 */
    OTHER,        /* 0x2cb2 */
    OTHER,        /* 0x2cb3 */
    OTHER,        /* 0x2cb4 */
    OTHER,        /* 0x2cb5 */
    OTHER,        /* 0x2cb6 */
    OTHER,        /* 0x2cb7 */
    OTHER,        /* 0x2cb8 */
    OTHER,        /* 0x2cb9 */
    OTHER,        /* 0x2cba */
    OTHER,        /* 0x2cbb */
    OTHER,        /* 0x2cbc */
    OTHER,        /* 0x2cbd */
    OTHER,        /* 0x2cbe */
    OTHER,        /* 0x2cbf */
    OTHER,        /* 0x2cc0 */
    OTHER,        /* 0x2cc1 */
    OTHER,        /* 0x2cc2 */
    OTHER,        /* 0x2cc3 */
    OTHER,        /* 0x2cc4 */
    OTHER,        /* 0x2cc5 */
    OTHER,        /* 0x2cc6 */
    OTHER,        /* 0x2cc7 */
    OTHER,        /* 0x2cc8 */
    OTHER,        /* 0x2cc9 */
    OTHER,        /* 0x2cca */
    OTHER,        /* 0x2ccb */
    OTHER,        /* 0x2ccc */
    OTHER,        /* 0x2ccd */
    OTHER,        /* 0x2cce */
    OTHER,        /* 0x2ccf */
    OTHER,        /* 0x2cd0 */
    OTHER,        /* 0x2cd1 */
    OTHER,        /* 0x2cd2 */
    OTHER,        /* 0x2cd3 */
    OTHER,        /* 0x2cd4 */
    OTHER,        /* 0x2cd5 */
    OTHER,        /* 0x2cd6 */
    OTHER,        /* 0x2cd7 */
    OTHER,        /* 0x2cd8 */
    OTHER,        /* 0x2cd9 */
    OTHER,        /* 0x2cda */
    OTHER,        /* 0x2cdb */
    OTHER,        /* 0x2cdc */
    OTHER,        /* 0x2cdd */
    OTHER,        /* 0x2cde */
    OTHER,        /* 0x2cdf */
    OTHER,        /* 0x2ce0 */
    OTHER,        /* 0x2ce1 */
    OTHER,        /* 0x2ce2 */
    OTHER,        /* 0x2ce3 */
    OTHER,        /* 0x2ce4 */
    OTHER,        /* 0x2ce5 */
    OTHER,        /* 0x2ce6 */
    OTHER,        /* 0x2ce7 */
    OTHER,        /* 0x2ce8 */
    OTHER,        /* 0x2ce9 */
    OTHER,        /* 0x2cea */
    OTHER,        /* 0x2ceb */
    OTHER,        /* 0x2cec */
    OTHER,        /* 0x2ced */
    OTHER,        /* 0x2cee */
    OTHER,        /* 0x2cef */
    OTHER,        /* 0x2cf0 */
    OTHER,        /* 0x2cf1 */
    OTHER,        /* 0x2cf2 */
    OTHER,        /* 0x2cf3 */
    OTHER,        /* 0x2cf4 */
    OTHER,        /* 0x2cf5 */
    OTHER,        /* 0x2cf6 */
    OTHER,        /* 0x2cf7 */
    OTHER,        /* 0x2cf8 */
    OTHER,        /* 0x2cf9 */
    OTHER,        /* 0x2cfa */
    OTHER,        /* 0x2cfb */
    OTHER,        /* 0x2cfc */
    OTHER,        /* 0x2cfd */
    OTHER,        /* 0x2cfe */
    OTHER,        /* 0x2cff */
    OTHER,        /* 0x2d00 */
    OTHER,        /* 0x2d01 */
    OTHER,        /* 0x2d02 */
    OTHER,        /* 0x2d03 */
    OTHER,        /* 0x2d04 */
    OTHER,        /* 0x2d05 */
    OTHER,        /* 0x2d06 */
    OTHER,        /* 0x2d07 */
    OTHER,        /* 0x2d08 */
    OTHER,        /* 0x2d09 */
    OTHER,        /* 0x2d0a */
    OTHER,        /* 0x2d0b */
    OTHER,        /* 0x2d0c */
    OTHER,        /* 0x2d0d */
    OTHER,        /* 0x2d0e */
    OTHER,        /* 0x2d0f */
    OTHER,        /* 0x2d10 */
    OTHER,        /* 0x2d11 */
    OTHER,        /* 0x2d12 */
    OTHER,        /* 0x2d13 */
    OTHER,        /* 0x2d14 */
    OTHER,        /* 0x2d15 */
    OTHER,        /* 0x2d16 */
    OTHER,        /* 0x2d17 */
    OTHER,        /* 0x2d18 */
    OTHER,        /* 0x2d19 */
    OTHER,        /* 0x2d1a */
    OTHER,        /* 0x2d1b */
    OTHER,        /* 0x2d1c */
    OTHER,        /* 0x2d1d */
    OTHER,        /* 0x2d1e */
    OTHER,        /* 0x2d1f */
    OTHER,        /* 0x2d20 */
    OTHER,        /* 0x2d21 */
    OTHER,        /* 0x2d22 */
    OTHER,        /* 0x2d23 */
    OTHER,        /* 0x2d24 */
    OTHER,        /* 0x2d25 */
    OTHER,        /* 0x2d26 */
    OTHER,        /* 0x2d27 */
    OTHER,        /* 0x2d28 */
    OTHER,        /* 0x2d29 */
    OTHER,        /* 0x2d2a */
    OTHER,        /* 0x2d2b */
    OTHER,        /* 0x2d2c */
    OTHER,        /* 0x2d2d */
    OTHER,        /* 0x2d2e */
    OTHER,        /* 0x2d2f */
    OTHER,        /* 0x2d30 */
    OTHER,        /* 0x2d31 */
    OTHER,        /* 0x2d32 */
    OTHER,        /* 0x2d33 */
    OTHER,        /* 0x2d34 */
    OTHER,        /* 0x2d35 */
    OTHER,        /* 0x2d36 */
    OTHER,        /* 0x2d37 */
    OTHER,        /* 0x2d38 */
    OTHER,        /* 0x2d39 */
    OTHER,        /* 0x2d3a */
    OTHER,        /* 0x2d3b */
    OTHER,        /* 0x2d3c */
    OTHER,        /* 0x2d3d */
    OTHER,        /* 0x2d3e */
    OTHER,        /* 0x2d3f */
    OTHER,        /* 0x2d40 */
    OTHER,        /* 0x2d41 */
    OTHER,        /* 0x2d42 */
    OTHER,        /* 0x2d43 */
    OTHER,        /* 0x2d44 */
    OTHER,        /* 0x2d45 */
    OTHER,        /* 0x2d46 */
    OTHER,        /* 0x2d47 */
    OTHER,        /* 0x2d48 */
    OTHER,        /* 0x2d49 */
    OTHER,        /* 0x2d4a */
    OTHER,        /* 0x2d4b */
    OTHER,        /* 0x2d4c */
    OTHER,        /* 0x2d4d */
    OTHER,        /* 0x2d4e */
    OTHER,        /* 0x2d4f */
    OTHER,        /* 0x2d50 */
    OTHER,        /* 0x2d51 */
    OTHER,        /* 0x2d52 */
    OTHER,        /* 0x2d53 */
    OTHER,        /* 0x2d54 */
    OTHER,        /* 0x2d55 */
    OTHER,        /* 0x2d56 */
    OTHER,        /* 0x2d57 */
    OTHER,        /* 0x2d58 */
    OTHER,        /* 0x2d59 */
    OTHER,        /* 0x2d5a */
    OTHER,        /* 0x2d5b */
    OTHER,        /* 0x2d5c */
    OTHER,        /* 0x2d5d */
    OTHER,        /* 0x2d5e */
    OTHER,        /* 0x2d5f */
    OTHER,        /* 0x2d60 */
    OTHER,        /* 0x2d61 */
    OTHER,        /* 0x2d62 */
    OTHER,        /* 0x2d63 */
    OTHER,        /* 0x2d64 */
    OTHER,        /* 0x2d65 */
    OTHER,        /* 0x2d66 */
    OTHER,        /* 0x2d67 */
    OTHER,        /* 0x2d68 */
    OTHER,        /* 0x2d69 */
    OTHER,        /* 0x2d6a */
    OTHER,        /* 0x2d6b */
    OTHER,        /* 0x2d6c */
    OTHER,        /* 0x2d6d */
    OTHER,        /* 0x2d6e */
    OTHER,        /* 0x2d6f */
    OTHER,        /* 0x2d70 */
    OTHER,        /* 0x2d71 */
    OTHER,        /* 0x2d72 */
    OTHER,        /* 0x2d73 */
    OTHER,        /* 0x2d74 */
    OTHER,        /* 0x2d75 */
    OTHER,        /* 0x2d76 */
    OTHER,        /* 0x2d77 */
    OTHER,        /* 0x2d78 */
    OTHER,        /* 0x2d79 */
    OTHER,        /* 0x2d7a */
    OTHER,        /* 0x2d7b */
    OTHER,        /* 0x2d7c */
    OTHER,        /* 0x2d7d */
    OTHER,        /* 0x2d7e */
    OTHER,        /* 0x2d7f */
    OTHER,        /* 0x2d80 */
    OTHER,        /* 0x2d81 */
    OTHER,        /* 0x2d82 */
    OTHER,        /* 0x2d83 */
    OTHER,        /* 0x2d84 */
    OTHER,        /* 0x2d85 */
    OTHER,        /* 0x2d86 */
    OTHER,        /* 0x2d87 */
    OTHER,        /* 0x2d88 */
    OTHER,        /* 0x2d89 */
    OTHER,        /* 0x2d8a */
    OTHER,        /* 0x2d8b */
    OTHER,        /* 0x2d8c */
    OTHER,        /* 0x2d8d */
    OTHER,        /* 0x2d8e */
    OTHER,        /* 0x2d8f */
    OTHER,        /* 0x2d90 */
    OTHER,        /* 0x2d91 */
    OTHER,        /* 0x2d92 */
    OTHER,        /* 0x2d93 */
    OTHER,        /* 0x2d94 */
    OTHER,        /* 0x2d95 */
    OTHER,        /* 0x2d96 */
    OTHER,        /* 0x2d97 */
    OTHER,        /* 0x2d98 */
    OTHER,        /* 0x2d99 */
    OTHER,        /* 0x2d9a */
    OTHER,        /* 0x2d9b */
    OTHER,        /* 0x2d9c */
    OTHER,        /* 0x2d9d */
    OTHER,        /* 0x2d9e */
    OTHER,        /* 0x2d9f */
    OTHER,        /* 0x2da0 */
    OTHER,        /* 0x2da1 */
    OTHER,        /* 0x2da2 */
    OTHER,        /* 0x2da3 */
    OTHER,        /* 0x2da4 */
    OTHER,        /* 0x2da5 */
    OTHER,        /* 0x2da6 */
    OTHER,        /* 0x2da7 */
    OTHER,        /* 0x2da8 */
    OTHER,        /* 0x2da9 */
    OTHER,        /* 0x2daa */
    OTHER,        /* 0x2dab */
    OTHER,        /* 0x2dac */
    OTHER,        /* 0x2dad */
    OTHER,        /* 0x2dae */
    OTHER,        /* 0x2daf */
    OTHER,        /* 0x2db0 */
    OTHER,        /* 0x2db1 */
    OTHER,        /* 0x2db2 */
    OTHER,        /* 0x2db3 */
    OTHER,        /* 0x2db4 */
    OTHER,        /* 0x2db5 */
    OTHER,        /* 0x2db6 */
    OTHER,        /* 0x2db7 */
    OTHER,        /* 0x2db8 */
    OTHER,        /* 0x2db9 */
    OTHER,        /* 0x2dba */
    OTHER,        /* 0x2dbb */
    OTHER,        /* 0x2dbc */
    OTHER,        /* 0x2dbd */
    OTHER,        /* 0x2dbe */
    OTHER,        /* 0x2dbf */
    OTHER,        /* 0x2dc0 */
    OTHER,        /* 0x2dc1 */
    OTHER,        /* 0x2dc2 */
    OTHER,        /* 0x2dc3 */
    OTHER,        /* 0x2dc4 */
    OTHER,        /* 0x2dc5 */
    OTHER,        /* 0x2dc6 */
    OTHER,        /* 0x2dc7 */
    OTHER,        /* 0x2dc8 */
    OTHER,        /* 0x2dc9 */
    OTHER,        /* 0x2dca */
    OTHER,        /* 0x2dcb */
    OTHER,        /* 0x2dcc */
    OTHER,        /* 0x2dcd */
    OTHER,        /* 0x2dce */
    OTHER,        /* 0x2dcf */
    OTHER,        /* 0x2dd0 */
    OTHER,        /* 0x2dd1 */
    OTHER,        /* 0x2dd2 */
    OTHER,        /* 0x2dd3 */
    OTHER,        /* 0x2dd4 */
    OTHER,        /* 0x2dd5 */
    OTHER,        /* 0x2dd6 */
    OTHER,        /* 0x2dd7 */
    OTHER,        /* 0x2dd8 */
    OTHER,        /* 0x2dd9 */
    OTHER,        /* 0x2dda */
    OTHER,        /* 0x2ddb */
    OTHER,        /* 0x2ddc */
    OTHER,        /* 0x2ddd */
    OTHER,        /* 0x2dde */
    OTHER,        /* 0x2ddf */
    OTHER,        /* 0x2de0 */
    OTHER,        /* 0x2de1 */
    OTHER,        /* 0x2de2 */
    OTHER,        /* 0x2de3 */
    OTHER,        /* 0x2de4 */
    OTHER,        /* 0x2de5 */
    OTHER,        /* 0x2de6 */
    OTHER,        /* 0x2de7 */
    OTHER,        /* 0x2de8 */
    OTHER,        /* 0x2de9 */
    OTHER,        /* 0x2dea */
    OTHER,        /* 0x2deb */
    OTHER,        /* 0x2dec */
    OTHER,        /* 0x2ded */
    OTHER,        /* 0x2dee */
    OTHER,        /* 0x2def */
    OTHER,        /* 0x2df0 */
    OTHER,        /* 0x2df1 */
    OTHER,        /* 0x2df2 */
    OTHER,        /* 0x2df3 */
    OTHER,        /* 0x2df4 */
    OTHER,        /* 0x2df5 */
    OTHER,        /* 0x2df6 */
    OTHER,        /* 0x2df7 */
    OTHER,        /* 0x2df8 */
    OTHER,        /* 0x2df9 */
    OTHER,        /* 0x2dfa */
    OTHER,        /* 0x2dfb */
    OTHER,        /* 0x2dfc */
    OTHER,        /* 0x2dfd */
    OTHER,        /* 0x2dfe */
    OTHER,        /* 0x2dff */
    OTHER,        /* 0x2e00 */
    OTHER,        /* 0x2e01 */
    OTHER,        /* 0x2e02 */
    OTHER,        /* 0x2e03 */
    OTHER,        /* 0x2e04 */
    OTHER,        /* 0x2e05 */
    OTHER,        /* 0x2e06 */
    OTHER,        /* 0x2e07 */
    OTHER,        /* 0x2e08 */
    OTHER,        /* 0x2e09 */
    OTHER,        /* 0x2e0a */
    OTHER,        /* 0x2e0b */
    OTHER,        /* 0x2e0c */
    OTHER,        /* 0x2e0d */
    OTHER,        /* 0x2e0e */
    OTHER,        /* 0x2e0f */
    OTHER,        /* 0x2e10 */
    OTHER,        /* 0x2e11 */
    OTHER,        /* 0x2e12 */
    OTHER,        /* 0x2e13 */
    OTHER,        /* 0x2e14 */
    OTHER,        /* 0x2e15 */
    OTHER,        /* 0x2e16 */
    OTHER,        /* 0x2e17 */
    OTHER,        /* 0x2e18 */
    OTHER,        /* 0x2e19 */
    OTHER,        /* 0x2e1a */
    OTHER,        /* 0x2e1b */
    OTHER,        /* 0x2e1c */
    OTHER,        /* 0x2e1d */
    OTHER,        /* 0x2e1e */
    OTHER,        /* 0x2e1f */
    OTHER,        /* 0x2e20 */
    OTHER,        /* 0x2e21 */
    OTHER,        /* 0x2e22 */
    OTHER,        /* 0x2e23 */
    OTHER,        /* 0x2e24 */
    OTHER,        /* 0x2e25 */
    OTHER,        /* 0x2e26 */
    OTHER,        /* 0x2e27 */
    OTHER,        /* 0x2e28 */
    OTHER,        /* 0x2e29 */
    OTHER,        /* 0x2e2a */
    OTHER,        /* 0x2e2b */
    OTHER,        /* 0x2e2c */
    OTHER,        /* 0x2e2d */
    OTHER,        /* 0x2e2e */
    OTHER,        /* 0x2e2f */
    OTHER,        /* 0x2e30 */
    OTHER,        /* 0x2e31 */
    OTHER,        /* 0x2e32 */
    OTHER,        /* 0x2e33 */
    OTHER,        /* 0x2e34 */
    OTHER,        /* 0x2e35 */
    OTHER,        /* 0x2e36 */
    OTHER,        /* 0x2e37 */
    OTHER,        /* 0x2e38 */
    OTHER,        /* 0x2e39 */
    OTHER,        /* 0x2e3a */
    OTHER,        /* 0x2e3b */
    OTHER,        /* 0x2e3c */
    OTHER,        /* 0x2e3d */
    OTHER,        /* 0x2e3e */
    OTHER,        /* 0x2e3f */
    OTHER,        /* 0x2e40 */
    OTHER,        /* 0x2e41 */
    OTHER,        /* 0x2e42 */
    OTHER,        /* 0x2e43 */
    OTHER,        /* 0x2e44 */
    OTHER,        /* 0x2e45 */
    OTHER,        /* 0x2e46 */
    OTHER,        /* 0x2e47 */
    OTHER,        /* 0x2e48 */
    OTHER,        /* 0x2e49 */
    OTHER,        /* 0x2e4a */
    OTHER,        /* 0x2e4b */
    OTHER,        /* 0x2e4c */
    OTHER,        /* 0x2e4d */
    OTHER,        /* 0x2e4e */
    OTHER,        /* 0x2e4f */
    OTHER,        /* 0x2e50 */
    OTHER,        /* 0x2e51 */
    OTHER,        /* 0x2e52 */
    OTHER,        /* 0x2e53 */
    OTHER,        /* 0x2e54 */
    OTHER,        /* 0x2e55 */
    OTHER,        /* 0x2e56 */
    OTHER,        /* 0x2e57 */
    OTHER,        /* 0x2e58 */
    OTHER,        /* 0x2e59 */
    OTHER,        /* 0x2e5a */
    OTHER,        /* 0x2e5b */
    OTHER,        /* 0x2e5c */
    OTHER,        /* 0x2e5d */
    OTHER,        /* 0x2e5e */
    OTHER,        /* 0x2e5f */
    OTHER,        /* 0x2e60 */
    OTHER,        /* 0x2e61 */
    OTHER,        /* 0x2e62 */
    OTHER,        /* 0x2e63 */
    OTHER,        /* 0x2e64 */
    OTHER,        /* 0x2e65 */
    OTHER,        /* 0x2e66 */
    OTHER,        /* 0x2e67 */
    OTHER,        /* 0x2e68 */
    OTHER,        /* 0x2e69 */
    OTHER,        /* 0x2e6a */
    OTHER,        /* 0x2e6b */
    OTHER,        /* 0x2e6c */
    OTHER,        /* 0x2e6d */
    OTHER,        /* 0x2e6e */
    OTHER,        /* 0x2e6f */
    OTHER,        /* 0x2e70 */
    OTHER,        /* 0x2e71 */
    OTHER,        /* 0x2e72 */
    OTHER,        /* 0x2e73 */
    OTHER,        /* 0x2e74 */
    OTHER,        /* 0x2e75 */
    OTHER,        /* 0x2e76 */
    OTHER,        /* 0x2e77 */
    OTHER,        /* 0x2e78 */
    OTHER,        /* 0x2e79 */
    OTHER,        /* 0x2e7a */
    OTHER,        /* 0x2e7b */
    OTHER,        /* 0x2e7c */
    OTHER,        /* 0x2e7d */
    OTHER,        /* 0x2e7e */
    OTHER,        /* 0x2e7f */
    KANJI,        /* 0x2e80 */
    KANJI,        /* 0x2e81 */
    KANJI,        /* 0x2e82 */
    KANJI,        /* 0x2e83 */
    KANJI,        /* 0x2e84 */
    KANJI,        /* 0x2e85 */
    KANJI,        /* 0x2e86 */
    KANJI,        /* 0x2e87 */
    KANJI,        /* 0x2e88 */
    KANJI,        /* 0x2e89 */
    KANJI,        /* 0x2e8a */
    KANJI,        /* 0x2e8b */
    KANJI,        /* 0x2e8c */
    KANJI,        /* 0x2e8d */
    KANJI,        /* 0x2e8e */
    KANJI,        /* 0x2e8f */
    KANJI,        /* 0x2e90 */
    KANJI,        /* 0x2e91 */
    KANJI,        /* 0x2e92 */
    KANJI,        /* 0x2e93 */
    KANJI,        /* 0x2e94 */
    KANJI,        /* 0x2e95 */
    KANJI,        /* 0x2e96 */
    KANJI,        /* 0x2e97 */
    KANJI,        /* 0x2e98 */
    KANJI,        /* 0x2e99 */
    KANJI,        /* 0x2e9a */
    KANJI,        /* 0x2e9b */
    KANJI,        /* 0x2e9c */
    KANJI,        /* 0x2e9d */
    KANJI,        /* 0x2e9e */
    KANJI,        /* 0x2e9f */
    KANJI,        /* 0x2ea0 */
    KANJI,        /* 0x2ea1 */
    KANJI,        /* 0x2ea2 */
    KANJI,        /* 0x2ea3 */
    KANJI,        /* 0x2ea4 */
    KANJI,        /* 0x2ea5 */
    KANJI,        /* 0x2ea6 */
    KANJI,        /* 0x2ea7 */
    KANJI,        /* 0x2ea8 */
    KANJI,        /* 0x2ea9 */
    KANJI,        /* 0x2eaa */
    KANJI,        /* 0x2eab */
    KANJI,        /* 0x2eac */
    KANJI,        /* 0x2ead */
    KANJI,        /* 0x2eae */
    KANJI,        /* 0x2eaf */
    KANJI,        /* 0x2eb0 */
    KANJI,        /* 0x2eb1 */
    KANJI,        /* 0x2eb2 */
    KANJI,        /* 0x2eb3 */
    KANJI,        /* 0x2eb4 */
    KANJI,        /* 0x2eb5 */
    KANJI,        /* 0x2eb6 */
    KANJI,        /* 0x2eb7 */
    KANJI,        /* 0x2eb8 */
    KANJI,        /* 0x2eb9 */
    KANJI,        /* 0x2eba */
    KANJI,        /* 0x2ebb */
    KANJI,        /* 0x2ebc */
    KANJI,        /* 0x2ebd */
    KANJI,        /* 0x2ebe */
    KANJI,        /* 0x2ebf */
    KANJI,        /* 0x2ec0 */
    KANJI,        /* 0x2ec1 */
    KANJI,        /* 0x2ec2 */
    KANJI,        /* 0x2ec3 */
    KANJI,        /* 0x2ec4 */
    KANJI,        /* 0x2ec5 */
    KANJI,        /* 0x2ec6 */
    KANJI,        /* 0x2ec7 */
    KANJI,        /* 0x2ec8 */
    KANJI,        /* 0x2ec9 */
    KANJI,        /* 0x2eca */
    KANJI,        /* 0x2ecb */
    KANJI,        /* 0x2ecc */
    KANJI,        /* 0x2ecd */
    KANJI,        /* 0x2ece */
    KANJI,        /* 0x2ecf */
    KANJI,        /* 0x2ed0 */
    KANJI,        /* 0x2ed1 */
    KANJI,        /* 0x2ed2 */
    KANJI,        /* 0x2ed3 */
    KANJI,        /* 0x2ed4 */
    KANJI,        /* 0x2ed5 */
    KANJI,        /* 0x2ed6 */
    KANJI,        /* 0x2ed7 */
    KANJI,        /* 0x2ed8 */
    KANJI,        /* 0x2ed9 */
    KANJI,        /* 0x2eda */
    KANJI,        /* 0x2edb */
    KANJI,        /* 0x2edc */
    KANJI,        /* 0x2edd */
    KANJI,        /* 0x2ede */
    KANJI,        /* 0x2edf */
    KANJI,        /* 0x2ee0 */
    KANJI,        /* 0x2ee1 */
    KANJI,        /* 0x2ee2 */
    KANJI,        /* 0x2ee3 */
    KANJI,        /* 0x2ee4 */
    KANJI,        /* 0x2ee5 */
    KANJI,        /* 0x2ee6 */
    KANJI,        /* 0x2ee7 */
    KANJI,        /* 0x2ee8 */
    KANJI,        /* 0x2ee9 */
    KANJI,        /* 0x2eea */
    KANJI,        /* 0x2eeb */
    KANJI,        /* 0x2eec */
    KANJI,        /* 0x2eed */
    KANJI,        /* 0x2eee */
    KANJI,        /* 0x2eef */
    KANJI,        /* 0x2ef0 */
    KANJI,        /* 0x2ef1 */
    KANJI,        /* 0x2ef2 */
    KANJI,        /* 0x2ef3 */
    OTHER,        /* 0x2ef4 */
    OTHER,        /* 0x2ef5 */
    OTHER,        /* 0x2ef6 */
    OTHER,        /* 0x2ef7 */
    OTHER,        /* 0x2ef8 */
    OTHER,        /* 0x2ef9 */
    OTHER,        /* 0x2efa */
    OTHER,        /* 0x2efb */
    OTHER,        /* 0x2efc */
    OTHER,        /* 0x2efd */
    OTHER,        /* 0x2efe */
    OTHER,        /* 0x2eff */
    KANJI,        /* 0x2f00 */
    KANJI,        /* 0x2f01 */
    KANJI,        /* 0x2f02 */
    KANJI,        /* 0x2f03 */
    KANJI,        /* 0x2f04 */
    KANJI,        /* 0x2f05 */
    KANJI,        /* 0x2f06 */
    KANJI,        /* 0x2f07 */
    KANJI,        /* 0x2f08 */
    KANJI,        /* 0x2f09 */
    KANJI,        /* 0x2f0a */
    KANJI,        /* 0x2f0b */
    KANJI,        /* 0x2f0c */
    KANJI,        /* 0x2f0d */
    KANJI,        /* 0x2f0e */
    KANJI,        /* 0x2f0f */
    KANJI,        /* 0x2f10 */
    KANJI,        /* 0x2f11 */
    KANJI,        /* 0x2f12 */
    KANJI,        /* 0x2f13 */
    KANJI,        /* 0x2f14 */
    KANJI,        /* 0x2f15 */
    KANJI,        /* 0x2f16 */
    KANJI,        /* 0x2f17 */
    KANJI,        /* 0x2f18 */
    KANJI,        /* 0x2f19 */
    KANJI,        /* 0x2f1a */
    KANJI,        /* 0x2f1b */
    KANJI,        /* 0x2f1c */
    KANJI,        /* 0x2f1d */
    KANJI,        /* 0x2f1e */
    KANJI,        /* 0x2f1f */
    KANJI,        /* 0x2f20 */
    KANJI,        /* 0x2f21 */
    KANJI,        /* 0x2f22 */
    KANJI,        /* 0x2f23 */
    KANJI,        /* 0x2f24 */
    KANJI,        /* 0x2f25 */
    KANJI,        /* 0x2f26 */
    KANJI,        /* 0x2f27 */
    KANJI,        /* 0x2f28 */
    KANJI,        /* 0x2f29 */
    KANJI,        /* 0x2f2a */
    KANJI,        /* 0x2f2b */
    KANJI,        /* 0x2f2c */
    KANJI,        /* 0x2f2d */
    KANJI,        /* 0x2f2e */
    KANJI,        /* 0x2f2f */
    KANJI,        /* 0x2f30 */
    KANJI,        /* 0x2f31 */
    KANJI,        /* 0x2f32 */
    KANJI,        /* 0x2f33 */
    KANJI,        /* 0x2f34 */
    KANJI,        /* 0x2f35 */
    KANJI,        /* 0x2f36 */
    KANJI,        /* 0x2f37 */
    KANJI,        /* 0x2f38 */
    KANJI,        /* 0x2f39 */
    KANJI,        /* 0x2f3a */
    KANJI,        /* 0x2f3b */
    KANJI,        /* 0x2f3c */
    KANJI,        /* 0x2f3d */
    KANJI,        /* 0x2f3e */
    KANJI,        /* 0x2f3f */
    KANJI,        /* 0x2f40 */
    KANJI,        /* 0x2f41 */
    KANJI,        /* 0x2f42 */
    KANJI,        /* 0x2f43 */
    KANJI,        /* 0x2f44 */
    KANJI,        /* 0x2f45 */
    KANJI,        /* 0x2f46 */
    KANJI,        /* 0x2f47 */
    KANJI,        /* 0x2f48 */
    KANJI,        /* 0x2f49 */
    KANJI,        /* 0x2f4a */
    KANJI,        /* 0x2f4b */
    KANJI,        /* 0x2f4c */
    KANJI,        /* 0x2f4d */
    KANJI,        /* 0x2f4e */
    KANJI,        /* 0x2f4f */
    KANJI,        /* 0x2f50 */
    KANJI,        /* 0x2f51 */
    KANJI,        /* 0x2f52 */
    KANJI,        /* 0x2f53 */
    KANJI,        /* 0x2f54 */
    KANJI,        /* 0x2f55 */
    KANJI,        /* 0x2f56 */
    KANJI,        /* 0x2f57 */
    KANJI,        /* 0x2f58 */
    KANJI,        /* 0x2f59 */
    KANJI,        /* 0x2f5a */
    KANJI,        /* 0x2f5b */
    KANJI,        /* 0x2f5c */
    KANJI,        /* 0x2f5d */
    KANJI,        /* 0x2f5e */
    KANJI,        /* 0x2f5f */
    KANJI,        /* 0x2f60 */
    KANJI,        /* 0x2f61 */
    KANJI,        /* 0x2f62 */
    KANJI,        /* 0x2f63 */
    KANJI,        /* 0x2f64 */
    KANJI,        /* 0x2f65 */
    KANJI,        /* 0x2f66 */
    KANJI,        /* 0x2f67 */
    KANJI,        /* 0x2f68 */
    KANJI,        /* 0x2f69 */
    KANJI,        /* 0x2f6a */
    KANJI,        /* 0x2f6b */
    KANJI,        /* 0x2f6c */
    KANJI,        /* 0x2f6d */
    KANJI,        /* 0x2f6e */
    KANJI,        /* 0x2f6f */
    KANJI,        /* 0x2f70 */
    KANJI,        /* 0x2f71 */
    KANJI,        /* 0x2f72 */
    KANJI,        /* 0x2f73 */
    KANJI,        /* 0x2f74 */
    KANJI,        /* 0x2f75 */
    KANJI,        /* 0x2f76 */
    KANJI,        /* 0x2f77 */
    KANJI,        /* 0x2f78 */
    KANJI,        /* 0x2f79 */
    KANJI,        /* 0x2f7a */
    KANJI,        /* 0x2f7b */
    KANJI,        /* 0x2f7c */
    KANJI,        /* 0x2f7d */
    KANJI,        /* 0x2f7e */
    KANJI,        /* 0x2f7f */
    KANJI,        /* 0x2f80 */
    KANJI,        /* 0x2f81 */
    KANJI,        /* 0x2f82 */
    KANJI,        /* 0x2f83 */
    KANJI,        /* 0x2f84 */
    KANJI,        /* 0x2f85 */
    KANJI,        /* 0x2f86 */
    KANJI,        /* 0x2f87 */
    KANJI,        /* 0x2f88 */
    KANJI,        /* 0x2f89 */
    KANJI,        /* 0x2f8a */
    KANJI,        /* 0x2f8b */
    KANJI,        /* 0x2f8c */
    KANJI,        /* 0x2f8d */
    KANJI,        /* 0x2f8e */
    KANJI,        /* 0x2f8f */
    KANJI,        /* 0x2f90 */
    KANJI,        /* 0x2f91 */
    KANJI,        /* 0x2f92 */
    KANJI,        /* 0x2f93 */
    KANJI,        /* 0x2f94 */
    KANJI,        /* 0x2f95 */
    KANJI,        /* 0x2f96 */
    KANJI,        /* 0x2f97 */
    KANJI,        /* 0x2f98 */
    KANJI,        /* 0x2f99 */
    KANJI,        /* 0x2f9a */
    KANJI,        /* 0x2f9b */
    KANJI,        /* 0x2f9c */
    KANJI,        /* 0x2f9d */
    KANJI,        /* 0x2f9e */
    KANJI,        /* 0x2f9f */
    KANJI,        /* 0x2fa0 */
    KANJI,        /* 0x2fa1 */
    KANJI,        /* 0x2fa2 */
    KANJI,        /* 0x2fa3 */
    KANJI,        /* 0x2fa4 */
    KANJI,        /* 0x2fa5 */
    KANJI,        /* 0x2fa6 */
    KANJI,        /* 0x2fa7 */
    KANJI,        /* 0x2fa8 */
    KANJI,        /* 0x2fa9 */
    KANJI,        /* 0x2faa */
    KANJI,        /* 0x2fab */
    KANJI,        /* 0x2fac */
    KANJI,        /* 0x2fad */
    KANJI,        /* 0x2fae */
    KANJI,        /* 0x2faf */
    KANJI,        /* 0x2fb0 */
    KANJI,        /* 0x2fb1 */
    KANJI,        /* 0x2fb2 */
    KANJI,        /* 0x2fb3 */
    KANJI,        /* 0x2fb4 */
    KANJI,        /* 0x2fb5 */
    KANJI,        /* 0x2fb6 */
    KANJI,        /* 0x2fb7 */
    KANJI,        /* 0x2fb8 */
    KANJI,        /* 0x2fb9 */
    KANJI,        /* 0x2fba */
    KANJI,        /* 0x2fbb */
    KANJI,        /* 0x2fbc */
    KANJI,        /* 0x2fbd */
    KANJI,        /* 0x2fbe */
    KANJI,        /* 0x2fbf */
    KANJI,        /* 0x2fc0 */
    KANJI,        /* 0x2fc1 */
    KANJI,        /* 0x2fc2 */
    KANJI,        /* 0x2fc3 */
    KANJI,        /* 0x2fc4 */
    KANJI,        /* 0x2fc5 */
    KANJI,        /* 0x2fc6 */
    KANJI,        /* 0x2fc7 */
    KANJI,        /* 0x2fc8 */
    KANJI,        /* 0x2fc9 */
    KANJI,        /* 0x2fca */
    KANJI,        /* 0x2fcb */
    KANJI,        /* 0x2fcc */
    KANJI,        /* 0x2fcd */
    KANJI,        /* 0x2fce */
    KANJI,        /* 0x2fcf */
    KANJI,        /* 0x2fd0 */
    KANJI,        /* 0x2fd1 */
    KANJI,        /* 0x2fd2 */
    KANJI,        /* 0x2fd3 */
    KANJI,        /* 0x2fd4 */
    KANJI,        /* 0x2fd5 */
    OTHER,        /* 0x2fd6 */
    OTHER,        /* 0x2fd7 */
    OTHER,        /* 0x2fd8 */
    OTHER,        /* 0x2fd9 */
    OTHER,        /* 0x2fda */
    OTHER,        /* 0x2fdb */
    OTHER,        /* 0x2fdc */
    OTHER,        /* 0x2fdd */
    OTHER,        /* 0x2fde */
    OTHER,        /* 0x2fdf */
    OTHER,        /* 0x2fe0 */
    OTHER,        /* 0x2fe1 */
    OTHER,        /* 0x2fe2 */
    OTHER,        /* 0x2fe3 */
    OTHER,        /* 0x2fe4 */
    OTHER,        /* 0x2fe5 */
    OTHER,        /* 0x2fe6 */
    OTHER,        /* 0x2fe7 */
    OTHER,        /* 0x2fe8 */
    OTHER,        /* 0x2fe9 */
    OTHER,        /* 0x2fea */
    OTHER,        /* 0x2feb */
    OTHER,        /* 0x2fec */
    OTHER,        /* 0x2fed */
    OTHER,        /* 0x2fee */
    OTHER,        /* 0x2fef */
    OTHER,        /* 0x2ff0 */
    OTHER,        /* 0x2ff1 */
    OTHER,        /* 0x2ff2 */
    OTHER,        /* 0x2ff3 */
    OTHER,        /* 0x2ff4 */
    OTHER,        /* 0x2ff5 */
    OTHER,        /* 0x2ff6 */
    OTHER,        /* 0x2ff7 */
    OTHER,        /* 0x2ff8 */
    OTHER,        /* 0x2ff9 */
    OTHER,        /* 0x2ffa */
    OTHER,        /* 0x2ffb */
    OTHER,        /* 0x2ffc */
    OTHER,        /* 0x2ffd */
    OTHER,        /* 0x2ffe */
    OTHER,        /* 0x2fff */
    SYMBOL,        /* 0x3000 */
    SYMBOL,        /* 0x3001 */
    SYMBOL,        /* 0x3002 */
    SYMBOL,        /* 0x3003 */
    SYMBOL,        /* 0x3004 */
    SYMBOL,        /* 0x3005 */
    SYMBOL,        /* 0x3006 */
    SYMBOL,        /* 0x3007 */
    SYMBOL,        /* 0x3008 */
    SYMBOL,        /* 0x3009 */
    SYMBOL,        /* 0x300a */
    SYMBOL,        /* 0x300b */
    SYMBOL,        /* 0x300c */
    SYMBOL,        /* 0x300d */
    SYMBOL,        /* 0x300e */
    SYMBOL,        /* 0x300f */
    SYMBOL,        /* 0x3010 */
    SYMBOL,        /* 0x3011 */
    SYMBOL,        /* 0x3012 */
    SYMBOL,        /* 0x3013 */
    SYMBOL,        /* 0x3014 */
    SYMBOL,        /* 0x3015 */
    SYMBOL,        /* 0x3016 */
    SYMBOL,        /* 0x3017 */
    SYMBOL,        /* 0x3018 */
    SYMBOL,        /* 0x3019 */
    SYMBOL,        /* 0x301a */
    SYMBOL,        /* 0x301b */
    SYMBOL,        /* 0x301c */
    SYMBOL,        /* 0x301d */
    SYMBOL,        /* 0x301e */
    SYMBOL,        /* 0x301f */
    SYMBOL,        /* 0x3020 */
    SYMBOL,        /* 0x3021 */
    SYMBOL,        /* 0x3022 */
    SYMBOL,        /* 0x3023 */
    SYMBOL,        /* 0x3024 */
    SYMBOL,        /* 0x3025 */
    SYMBOL,        /* 0x3026 */
    SYMBOL,        /* 0x3027 */
    SYMBOL,        /* 0x3028 */
    SYMBOL,        /* 0x3029 */
    SYMBOL,        /* 0x302a */
    SYMBOL,        /* 0x302b */
    SYMBOL,        /* 0x302c */
    SYMBOL,        /* 0x302d */
    SYMBOL,        /* 0x302e */
    SYMBOL,        /* 0x302f */
    SYMBOL,        /* 0x3030 */
    SYMBOL,        /* 0x3031 */
    SYMBOL,        /* 0x3032 */
    SYMBOL,        /* 0x3033 */
    SYMBOL,        /* 0x3034 */
    SYMBOL,        /* 0x3035 */
    SYMBOL,        /* 0x3036 */
    SYMBOL,        /* 0x3037 */
    SYMBOL,        /* 0x3038 */
    SYMBOL,        /* 0x3039 */
    SYMBOL,        /* 0x303a */
    SYMBOL,        /* 0x303b */
    SYMBOL,        /* 0x303c */
    SYMBOL,        /* 0x303d */
    SYMBOL,        /* 0x303e */
    SYMBOL,        /* 0x303f */
    OTHER,        /* 0x3040 */
    HIRAGANA,        /* 0x3041 */
    HIRAGANA,        /* 0x3042 */
    HIRAGANA,        /* 0x3043 */
    HIRAGANA,        /* 0x3044 */
    HIRAGANA,        /* 0x3045 */
    HIRAGANA,        /* 0x3046 */
    HIRAGANA,        /* 0x3047 */
    HIRAGANA,        /* 0x3048 */
    HIRAGANA,        /* 0x3049 */
    HIRAGANA,        /* 0x304a */
    HIRAGANA,        /* 0x304b */
    HIRAGANA,        /* 0x304c */
    HIRAGANA,        /* 0x304d */
    HIRAGANA,        /* 0x304e */
    HIRAGANA,        /* 0x304f */
    HIRAGANA,        /* 0x3050 */
    HIRAGANA,        /* 0x3051 */
    HIRAGANA,        /* 0x3052 */
    HIRAGANA,        /* 0x3053 */
    HIRAGANA,        /* 0x3054 */
    HIRAGANA,        /* 0x3055 */
    HIRAGANA,        /* 0x3056 */
    HIRAGANA,        /* 0x3057 */
    HIRAGANA,        /* 0x3058 */
    HIRAGANA,        /* 0x3059 */
    HIRAGANA,        /* 0x305a */
    HIRAGANA,        /* 0x305b */
    HIRAGANA,        /* 0x305c */
    HIRAGANA,        /* 0x305d */
    HIRAGANA,        /* 0x305e */
    HIRAGANA,        /* 0x305f */
    HIRAGANA,        /* 0x3060 */
    HIRAGANA,        /* 0x3061 */
    HIRAGANA,        /* 0x3062 */
    HIRAGANA,        /* 0x3063 */
    HIRAGANA,        /* 0x3064 */
    HIRAGANA,        /* 0x3065 */
    HIRAGANA,        /* 0x3066 */
    HIRAGANA,        /* 0x3067 */
    HIRAGANA,        /* 0x3068 */
    HIRAGANA,        /* 0x3069 */
    HIRAGANA,        /* 0x306a */
    HIRAGANA,        /* 0x306b */
    HIRAGANA,        /* 0x306c */
    HIRAGANA,        /* 0x306d */
    HIRAGANA,        /* 0x306e */
    HIRAGANA,        /* 0x306f */
    HIRAGANA,        /* 0x3070 */
    HIRAGANA,        /* 0x3071 */
    HIRAGANA,        /* 0x3072 */
    HIRAGANA,        /* 0x3073 */
    HIRAGANA,        /* 0x3074 */
    HIRAGANA,        /* 0x3075 */
    HIRAGANA,        /* 0x3076 */
    HIRAGANA,        /* 0x3077 */
    HIRAGANA,        /* 0x3078 */
    HIRAGANA,        /* 0x3079 */
    HIRAGANA,        /* 0x307a */
    HIRAGANA,        /* 0x307b */
    HIRAGANA,        /* 0x307c */
    HIRAGANA,        /* 0x307d */
    HIRAGANA,        /* 0x307e */
    HIRAGANA,        /* 0x307f */
    HIRAGANA,        /* 0x3080 */
    HIRAGANA,        /* 0x3081 */
    HIRAGANA,        /* 0x3082 */
    HIRAGANA,        /* 0x3083 */
    HIRAGANA,        /* 0x3084 */
    HIRAGANA,        /* 0x3085 */
    HIRAGANA,        /* 0x3086 */
    HIRAGANA,        /* 0x3087 */
    HIRAGANA,        /* 0x3088 */
    HIRAGANA,        /* 0x3089 */
    HIRAGANA,        /* 0x308a */
    HIRAGANA,        /* 0x308b */
    HIRAGANA,        /* 0x308c */
    HIRAGANA,        /* 0x308d */
    HIRAGANA,        /* 0x308e */
    HIRAGANA,        /* 0x308f */
    HIRAGANA,        /* 0x3090 */
    HIRAGANA,        /* 0x3091 */
    HIRAGANA,        /* 0x3092 */
    HIRAGANA,        /* 0x3093 */
    HIRAGANA,        /* 0x3094 */
    HIRAGANA,        /* 0x3095 */
    HIRAGANA,        /* 0x3096 */
    HIRAGANA,        /* 0x3097 */
    HIRAGANA,        /* 0x3098 */
    HIRAGANA,        /* 0x3099 */
    HIRAGANA,        /* 0x309a */
    HIRAGANA,        /* 0x309b */
    HIRAGANA,        /* 0x309c */
    HIRAGANA,        /* 0x309d */
    HIRAGANA,        /* 0x309e */
    HIRAGANA,        /* 0x309f */
    OTHER,        /* 0x30a0 */
    KATAKANA,        /* 0x30a1 */
    KATAKANA,        /* 0x30a2 */
    KATAKANA,        /* 0x30a3 */
    KATAKANA,        /* 0x30a4 */
    KATAKANA,        /* 0x30a5 */
    KATAKANA,        /* 0x30a6 */
    KATAKANA,        /* 0x30a7 */
    KATAKANA,        /* 0x30a8 */
    KATAKANA,        /* 0x30a9 */
    KATAKANA,        /* 0x30aa */
    KATAKANA,        /* 0x30ab */
    KATAKANA,        /* 0x30ac */
    KATAKANA,        /* 0x30ad */
    KATAKANA,        /* 0x30ae */
    KATAKANA,        /* 0x30af */
    KATAKANA,        /* 0x30b0 */
    KATAKANA,        /* 0x30b1 */
    KATAKANA,        /* 0x30b2 */
    KATAKANA,        /* 0x30b3 */
    KATAKANA,        /* 0x30b4 */
    KATAKANA,        /* 0x30b5 */
    KATAKANA,        /* 0x30b6 */
    KATAKANA,        /* 0x30b7 */
    KATAKANA,        /* 0x30b8 */
    KATAKANA,        /* 0x30b9 */
    KATAKANA,        /* 0x30ba */
    KATAKANA,        /* 0x30bb */
    KATAKANA,        /* 0x30bc */
    KATAKANA,        /* 0x30bd */
    KATAKANA,        /* 0x30be */
    KATAKANA,        /* 0x30bf */
    KATAKANA,        /* 0x30c0 */
    KATAKANA,        /* 0x30c1 */
    KATAKANA,        /* 0x30c2 */
    KATAKANA,        /* 0x30c3 */
    KATAKANA,        /* 0x30c4 */
    KATAKANA,        /* 0x30c5 */
    KATAKANA,        /* 0x30c6 */
    KATAKANA,        /* 0x30c7 */
    KATAKANA,        /* 0x30c8 */
    KATAKANA,        /* 0x30c9 */
    KATAKANA,        /* 0x30ca */
    KATAKANA,        /* 0x30cb */
    KATAKANA,        /* 0x30cc */
    KATAKANA,        /* 0x30cd */
    KATAKANA,        /* 0x30ce */
    KATAKANA,        /* 0x30cf */
    KATAKANA,        /* 0x30d0 */
    KATAKANA,        /* 0x30d1 */
    KATAKANA,        /* 0x30d2 */
    KATAKANA,        /* 0x30d3 */
    KATAKANA,        /* 0x30d4 */
    KATAKANA,        /* 0x30d5 */
    KATAKANA,        /* 0x30d6 */
    KATAKANA,        /* 0x30d7 */
    KATAKANA,        /* 0x30d8 */
    KATAKANA,        /* 0x30d9 */
    KATAKANA,        /* 0x30da */
    KATAKANA,        /* 0x30db */
    KATAKANA,        /* 0x30dc */
    KATAKANA,        /* 0x30dd */
    KATAKANA,        /* 0x30de */
    KATAKANA,        /* 0x30df */
    KATAKANA,        /* 0x30e0 */
    KATAKANA,        /* 0x30e1 */
    KATAKANA,        /* 0x30e2 */
    KATAKANA,        /* 0x30e3 */
    KATAKANA,        /* 0x30e4 */
    KATAKANA,        /* 0x30e5 */
    KATAKANA,        /* 0x30e6 */
    KATAKANA,        /* 0x30e7 */
    KATAKANA,        /* 0x30e8 */
    KATAKANA,        /* 0x30e9 */
    KATAKANA,        /* 0x30ea */
    KATAKANA,        /* 0x30eb */
    KATAKANA,        /* 0x30ec */
    KATAKANA,        /* 0x30ed */
    KATAKANA,        /* 0x30ee */
    KATAKANA,        /* 0x30ef */
    KATAKANA,        /* 0x30f0 */
    KATAKANA,        /* 0x30f1 */
    KATAKANA,        /* 0x30f2 */
    KATAKANA,        /* 0x30f3 */
    KATAKANA,        /* 0x30f4 */
    KATAKANA,        /* 0x30f5 */
    KATAKANA,        /* 0x30f6 */
    KATAKANA,        /* 0x30f7 */
    KATAKANA,        /* 0x30f8 */
    KATAKANA,        /* 0x30f9 */
    KATAKANA,        /* 0x30fa */
    KATAKANA,        /* 0x30fb */
    KATAKANA,        /* 0x30fc */
    KATAKANA,        /* 0x30fd */
    KATAKANA,        /* 0x30fe */
    KATAKANA,        /* 0x30ff */
    OTHER,        /* 0x3100 */
    OTHER,        /* 0x3101 */
    OTHER,        /* 0x3102 */
    OTHER,        /* 0x3103 */
    OTHER,        /* 0x3104 */
    OTHER,        /* 0x3105 */
    OTHER,        /* 0x3106 */
    OTHER,        /* 0x3107 */
    OTHER,        /* 0x3108 */
    OTHER,        /* 0x3109 */
    OTHER,        /* 0x310a */
    OTHER,        /* 0x310b */
    OTHER,        /* 0x310c */
    OTHER,        /* 0x310d */
    OTHER,        /* 0x310e */
    OTHER,        /* 0x310f */
    OTHER,        /* 0x3110 */
    OTHER,        /* 0x3111 */
    OTHER,        /* 0x3112 */
    OTHER,        /* 0x3113 */
    OTHER,        /* 0x3114 */
    OTHER,        /* 0x3115 */
    OTHER,        /* 0x3116 */
    OTHER,        /* 0x3117 */
    OTHER,        /* 0x3118 */
    OTHER,        /* 0x3119 */
    OTHER,        /* 0x311a */
    OTHER,        /* 0x311b */
    OTHER,        /* 0x311c */
    OTHER,        /* 0x311d */
    OTHER,        /* 0x311e */
    OTHER,        /* 0x311f */
    OTHER,        /* 0x3120 */
    OTHER,        /* 0x3121 */
    OTHER,        /* 0x3122 */
    OTHER,        /* 0x3123 */
    OTHER,        /* 0x3124 */
    OTHER,        /* 0x3125 */
    OTHER,        /* 0x3126 */
    OTHER,        /* 0x3127 */
    OTHER,        /* 0x3128 */
    OTHER,        /* 0x3129 */
    OTHER,        /* 0x312a */
    OTHER,        /* 0x312b */
    OTHER,        /* 0x312c */
    OTHER,        /* 0x312d */
    OTHER,        /* 0x312e */
    OTHER,        /* 0x312f */
    OTHER,        /* 0x3130 */
    OTHER,        /* 0x3131 */
    OTHER,        /* 0x3132 */
    OTHER,        /* 0x3133 */
    OTHER,        /* 0x3134 */
    OTHER,        /* 0x3135 */
    OTHER,        /* 0x3136 */
    OTHER,        /* 0x3137 */
    OTHER,        /* 0x3138 */
    OTHER,        /* 0x3139 */
    OTHER,        /* 0x313a */
    OTHER,        /* 0x313b */
    OTHER,        /* 0x313c */
    OTHER,        /* 0x313d */
    OTHER,        /* 0x313e */
    OTHER,        /* 0x313f */
    OTHER,        /* 0x3140 */
    OTHER,        /* 0x3141 */
    OTHER,        /* 0x3142 */
    OTHER,        /* 0x3143 */
    OTHER,        /* 0x3144 */
    OTHER,        /* 0x3145 */
    OTHER,        /* 0x3146 */
    OTHER,        /* 0x3147 */
    OTHER,        /* 0x3148 */
    OTHER,        /* 0x3149 */
    OTHER,        /* 0x314a */
    OTHER,        /* 0x314b */
    OTHER,        /* 0x314c */
    OTHER,        /* 0x314d */
    OTHER,        /* 0x314e */
    OTHER,        /* 0x314f */
    OTHER,        /* 0x3150 */
    OTHER,        /* 0x3151 */
    OTHER,        /* 0x3152 */
    OTHER,        /* 0x3153 */
    OTHER,        /* 0x3154 */
    OTHER,        /* 0x3155 */
    OTHER,        /* 0x3156 */
    OTHER,        /* 0x3157 */
    OTHER,        /* 0x3158 */
    OTHER,        /* 0x3159 */
    OTHER,        /* 0x315a */
    OTHER,        /* 0x315b */
    OTHER,        /* 0x315c */
    OTHER,        /* 0x315d */
    OTHER,        /* 0x315e */
    OTHER,        /* 0x315f */
    OTHER,        /* 0x3160 */
    OTHER,        /* 0x3161 */
    OTHER,        /* 0x3162 */
    OTHER,        /* 0x3163 */
    OTHER,        /* 0x3164 */
    OTHER,        /* 0x3165 */
    OTHER,        /* 0x3166 */
    OTHER,        /* 0x3167 */
    OTHER,        /* 0x3168 */
    OTHER,        /* 0x3169 */
    OTHER,        /* 0x316a */
    OTHER,        /* 0x316b */
    OTHER,        /* 0x316c */
    OTHER,        /* 0x316d */
    OTHER,        /* 0x316e */
    OTHER,        /* 0x316f */
    OTHER,        /* 0x3170 */
    OTHER,        /* 0x3171 */
    OTHER,        /* 0x3172 */
    OTHER,        /* 0x3173 */
    OTHER,        /* 0x3174 */
    OTHER,        /* 0x3175 */
    OTHER,        /* 0x3176 */
    OTHER,        /* 0x3177 */
    OTHER,        /* 0x3178 */
    OTHER,        /* 0x3179 */
    OTHER,        /* 0x317a */
    OTHER,        /* 0x317b */
    OTHER,        /* 0x317c */
    OTHER,        /* 0x317d */
    OTHER,        /* 0x317e */
    OTHER,        /* 0x317f */
    OTHER,        /* 0x3180 */
    OTHER,        /* 0x3181 */
    OTHER,        /* 0x3182 */
    OTHER,        /* 0x3183 */
    OTHER,        /* 0x3184 */
    OTHER,        /* 0x3185 */
    OTHER,        /* 0x3186 */
    OTHER,        /* 0x3187 */
    OTHER,        /* 0x3188 */
    OTHER,        /* 0x3189 */
    OTHER,        /* 0x318a */
    OTHER,        /* 0x318b */
    OTHER,        /* 0x318c */
    OTHER,        /* 0x318d */
    OTHER,        /* 0x318e */
    OTHER,        /* 0x318f */
    OTHER,        /* 0x3190 */
    OTHER,        /* 0x3191 */
    OTHER,        /* 0x3192 */
    OTHER,        /* 0x3193 */
    OTHER,        /* 0x3194 */
    OTHER,        /* 0x3195 */
    OTHER,        /* 0x3196 */
    OTHER,        /* 0x3197 */
    OTHER,        /* 0x3198 */
    OTHER,        /* 0x3199 */
    OTHER,        /* 0x319a */
    OTHER,        /* 0x319b */
    OTHER,        /* 0x319c */
    OTHER,        /* 0x319d */
    OTHER,        /* 0x319e */
    OTHER,        /* 0x319f */
    OTHER,        /* 0x31a0 */
    OTHER,        /* 0x31a1 */
    OTHER,        /* 0x31a2 */
    OTHER,        /* 0x31a3 */
    OTHER,        /* 0x31a4 */
    OTHER,        /* 0x31a5 */
    OTHER,        /* 0x31a6 */
    OTHER,        /* 0x31a7 */
    OTHER,        /* 0x31a8 */
    OTHER,        /* 0x31a9 */
    OTHER,        /* 0x31aa */
    OTHER,        /* 0x31ab */
    OTHER,        /* 0x31ac */
    OTHER,        /* 0x31ad */
    OTHER,        /* 0x31ae */
    OTHER,        /* 0x31af */
    OTHER,        /* 0x31b0 */
    OTHER,        /* 0x31b1 */
    OTHER,        /* 0x31b2 */
    OTHER,        /* 0x31b3 */
    OTHER,        /* 0x31b4 */
    OTHER,        /* 0x31b5 */
    OTHER,        /* 0x31b6 */
    OTHER,        /* 0x31b7 */
    OTHER,        /* 0x31b8 */
    OTHER,        /* 0x31b9 */
    OTHER,        /* 0x31ba */
    OTHER,        /* 0x31bb */
    OTHER,        /* 0x31bc */
    OTHER,        /* 0x31bd */
    OTHER,        /* 0x31be */
    OTHER,        /* 0x31bf */
    OTHER,        /* 0x31c0 */
    OTHER,        /* 0x31c1 */
    OTHER,        /* 0x31c2 */
    OTHER,        /* 0x31c3 */
    OTHER,        /* 0x31c4 */
    OTHER,        /* 0x31c5 */
    OTHER,        /* 0x31c6 */
    OTHER,        /* 0x31c7 */
    OTHER,        /* 0x31c8 */
    OTHER,        /* 0x31c9 */
    OTHER,        /* 0x31ca */
    OTHER,        /* 0x31cb */
    OTHER,        /* 0x31cc */
    OTHER,        /* 0x31cd */
    OTHER,        /* 0x31ce */
    OTHER,        /* 0x31cf */
    OTHER,        /* 0x31d0 */
    OTHER,        /* 0x31d1 */
    OTHER,        /* 0x31d2 */
    OTHER,        /* 0x31d3 */
    OTHER,        /* 0x31d4 */
    OTHER,        /* 0x31d5 */
    OTHER,        /* 0x31d6 */
    OTHER,        /* 0x31d7 */
    OTHER,        /* 0x31d8 */
    OTHER,        /* 0x31d9 */
    OTHER,        /* 0x31da */
    OTHER,        /* 0x31db */
    OTHER,        /* 0x31dc */
    OTHER,        /* 0x31dd */
    OTHER,        /* 0x31de */
    OTHER,        /* 0x31df */
    OTHER,        /* 0x31e0 */
    OTHER,        /* 0x31e1 */
    OTHER,        /* 0x31e2 */
    OTHER,        /* 0x31e3 */
    OTHER,        /* 0x31e4 */
    OTHER,        /* 0x31e5 */
    OTHER,        /* 0x31e6 */
    OTHER,        /* 0x31e7 */
    OTHER,        /* 0x31e8 */
    OTHER,        /* 0x31e9 */
    OTHER,        /* 0x31ea */
    OTHER,        /* 0x31eb */
    OTHER,        /* 0x31ec */
    OTHER,        /* 0x31ed */
    OTHER,        /* 0x31ee */
    OTHER,        /* 0x31ef */
    KATAKANA,        /* 0x31f0 */
    KATAKANA,        /* 0x31f1 */
    KATAKANA,        /* 0x31f2 */
    KATAKANA,        /* 0x31f3 */
    KATAKANA,        /* 0x31f4 */
    KATAKANA,        /* 0x31f5 */
    KATAKANA,        /* 0x31f6 */
    KATAKANA,        /* 0x31f7 */
    KATAKANA,        /* 0x31f8 */
    KATAKANA,        /* 0x31f9 */
    KATAKANA,        /* 0x31fa */
    KATAKANA,        /* 0x31fb */
    KATAKANA,        /* 0x31fc */
    KATAKANA,        /* 0x31fd */
    KATAKANA,        /* 0x31fe */
    KATAKANA,        /* 0x31ff */
    SYMBOL,        /* 0x3200 */
    SYMBOL,        /* 0x3201 */
    SYMBOL,        /* 0x3202 */
    SYMBOL,        /* 0x3203 */
    SYMBOL,        /* 0x3204 */
    SYMBOL,        /* 0x3205 */
    SYMBOL,        /* 0x3206 */
    SYMBOL,        /* 0x3207 */
    SYMBOL,        /* 0x3208 */
    SYMBOL,        /* 0x3209 */
    SYMBOL,        /* 0x320a */
    SYMBOL,        /* 0x320b */
    SYMBOL,        /* 0x320c */
    SYMBOL,        /* 0x320d */
    SYMBOL,        /* 0x320e */
    SYMBOL,        /* 0x320f */
    SYMBOL,        /* 0x3210 */
    SYMBOL,        /* 0x3211 */
    SYMBOL,        /* 0x3212 */
    SYMBOL,        /* 0x3213 */
    SYMBOL,        /* 0x3214 */
    SYMBOL,        /* 0x3215 */
    SYMBOL,        /* 0x3216 */
    SYMBOL,        /* 0x3217 */
    SYMBOL,        /* 0x3218 */
    SYMBOL,        /* 0x3219 */
    SYMBOL,        /* 0x321a */
    SYMBOL,        /* 0x321b */
    SYMBOL,        /* 0x321c */
    SYMBOL,        /* 0x321d */
    SYMBOL,        /* 0x321e */
    SYMBOL,        /* 0x321f */
    SYMBOL,        /* 0x3220 */
    SYMBOL,        /* 0x3221 */
    SYMBOL,        /* 0x3222 */
    SYMBOL,        /* 0x3223 */
    SYMBOL,        /* 0x3224 */
    SYMBOL,        /* 0x3225 */
    SYMBOL,        /* 0x3226 */
    SYMBOL,        /* 0x3227 */
    SYMBOL,        /* 0x3228 */
    SYMBOL,        /* 0x3229 */
    SYMBOL,        /* 0x322a */
    SYMBOL,        /* 0x322b */
    SYMBOL,        /* 0x322c */
    SYMBOL,        /* 0x322d */
    SYMBOL,        /* 0x322e */
    SYMBOL,        /* 0x322f */
    SYMBOL,        /* 0x3230 */
    SYMBOL,        /* 0x3231 */
    SYMBOL,        /* 0x3232 */
    SYMBOL,        /* 0x3233 */
    SYMBOL,        /* 0x3234 */
    SYMBOL,        /* 0x3235 */
    SYMBOL,        /* 0x3236 */
    SYMBOL,        /* 0x3237 */
    SYMBOL,        /* 0x3238 */
    SYMBOL,        /* 0x3239 */
    SYMBOL,        /* 0x323a */
    SYMBOL,        /* 0x323b */
    SYMBOL,        /* 0x323c */
    SYMBOL,        /* 0x323d */
    SYMBOL,        /* 0x323e */
    SYMBOL,        /* 0x323f */
    SYMBOL,        /* 0x3240 */
    SYMBOL,        /* 0x3241 */
    SYMBOL,        /* 0x3242 */
    SYMBOL,        /* 0x3243 */
    SYMBOL,        /* 0x3244 */
    SYMBOL,        /* 0x3245 */
    SYMBOL,        /* 0x3246 */
    SYMBOL,        /* 0x3247 */
    SYMBOL,        /* 0x3248 */
    SYMBOL,        /* 0x3249 */
    SYMBOL,        /* 0x324a */
    SYMBOL,        /* 0x324b */
    SYMBOL,        /* 0x324c */
    SYMBOL,        /* 0x324d */
    SYMBOL,        /* 0x324e */
    SYMBOL,        /* 0x324f */
    SYMBOL,        /* 0x3250 */
    SYMBOL,        /* 0x3251 */
    SYMBOL,        /* 0x3252 */
    SYMBOL,        /* 0x3253 */
    SYMBOL,        /* 0x3254 */
    SYMBOL,        /* 0x3255 */
    SYMBOL,        /* 0x3256 */
    SYMBOL,        /* 0x3257 */
    SYMBOL,        /* 0x3258 */
    SYMBOL,        /* 0x3259 */
    SYMBOL,        /* 0x325a */
    SYMBOL,        /* 0x325b */
    SYMBOL,        /* 0x325c */
    SYMBOL,        /* 0x325d */
    SYMBOL,        /* 0x325e */
    SYMBOL,        /* 0x325f */
    SYMBOL,        /* 0x3260 */
    SYMBOL,        /* 0x3261 */
    SYMBOL,        /* 0x3262 */
    SYMBOL,        /* 0x3263 */
    SYMBOL,        /* 0x3264 */
    SYMBOL,        /* 0x3265 */
    SYMBOL,        /* 0x3266 */
    SYMBOL,        /* 0x3267 */
    SYMBOL,        /* 0x3268 */
    SYMBOL,        /* 0x3269 */
    SYMBOL,        /* 0x326a */
    SYMBOL,        /* 0x326b */
    SYMBOL,        /* 0x326c */
    SYMBOL,        /* 0x326d */
    SYMBOL,        /* 0x326e */
    SYMBOL,        /* 0x326f */
    SYMBOL,        /* 0x3270 */
    SYMBOL,        /* 0x3271 */
    SYMBOL,        /* 0x3272 */
    SYMBOL,        /* 0x3273 */
    SYMBOL,        /* 0x3274 */
    SYMBOL,        /* 0x3275 */
    SYMBOL,        /* 0x3276 */
    SYMBOL,        /* 0x3277 */
    SYMBOL,        /* 0x3278 */
    SYMBOL,        /* 0x3279 */
    SYMBOL,        /* 0x327a */
    SYMBOL,        /* 0x327b */
    SYMBOL,        /* 0x327c */
    SYMBOL,        /* 0x327d */
    SYMBOL,        /* 0x327e */
    SYMBOL,        /* 0x327f */
    SYMBOL,        /* 0x3280 */
    SYMBOL,        /* 0x3281 */
    SYMBOL,        /* 0x3282 */
    SYMBOL,        /* 0x3283 */
    SYMBOL,        /* 0x3284 */
    SYMBOL,        /* 0x3285 */
    SYMBOL,        /* 0x3286 */
    SYMBOL,        /* 0x3287 */
    SYMBOL,        /* 0x3288 */
    SYMBOL,        /* 0x3289 */
    SYMBOL,        /* 0x328a */
    SYMBOL,        /* 0x328b */
    SYMBOL,        /* 0x328c */
    SYMBOL,        /* 0x328d */
    SYMBOL,        /* 0x328e */
    SYMBOL,        /* 0x328f */
    SYMBOL,        /* 0x3290 */
    SYMBOL,        /* 0x3291 */
    SYMBOL,        /* 0x3292 */
    SYMBOL,        /* 0x3293 */
    SYMBOL,        /* 0x3294 */
    SYMBOL,        /* 0x3295 */
    SYMBOL,        /* 0x3296 */
    SYMBOL,        /* 0x3297 */
    SYMBOL,        /* 0x3298 */
    SYMBOL,        /* 0x3299 */
    SYMBOL,        /* 0x329a */
    SYMBOL,        /* 0x329b */
    SYMBOL,        /* 0x329c */
    SYMBOL,        /* 0x329d */
    SYMBOL,        /* 0x329e */
    SYMBOL,        /* 0x329f */
    SYMBOL,        /* 0x32a0 */
    SYMBOL,        /* 0x32a1 */
    SYMBOL,        /* 0x32a2 */
    SYMBOL,        /* 0x32a3 */
    SYMBOL,        /* 0x32a4 */
    SYMBOL,        /* 0x32a5 */
    SYMBOL,        /* 0x32a6 */
    SYMBOL,        /* 0x32a7 */
    SYMBOL,        /* 0x32a8 */
    SYMBOL,        /* 0x32a9 */
    SYMBOL,        /* 0x32aa */
    SYMBOL,        /* 0x32ab */
    SYMBOL,        /* 0x32ac */
    SYMBOL,        /* 0x32ad */
    SYMBOL,        /* 0x32ae */
    SYMBOL,        /* 0x32af */
    SYMBOL,        /* 0x32b0 */
    SYMBOL,        /* 0x32b1 */
    SYMBOL,        /* 0x32b2 */
    SYMBOL,        /* 0x32b3 */
    SYMBOL,        /* 0x32b4 */
    SYMBOL,        /* 0x32b5 */
    SYMBOL,        /* 0x32b6 */
    SYMBOL,        /* 0x32b7 */
    SYMBOL,        /* 0x32b8 */
    SYMBOL,        /* 0x32b9 */
    SYMBOL,        /* 0x32ba */
    SYMBOL,        /* 0x32bb */
    SYMBOL,        /* 0x32bc */
    SYMBOL,        /* 0x32bd */
    SYMBOL,        /* 0x32be */
    SYMBOL,        /* 0x32bf */
    SYMBOL,        /* 0x32c0 */
    SYMBOL,        /* 0x32c1 */
    SYMBOL,        /* 0x32c2 */
    SYMBOL,        /* 0x32c3 */
    SYMBOL,        /* 0x32c4 */
    SYMBOL,        /* 0x32c5 */
    SYMBOL,        /* 0x32c6 */
    SYMBOL,        /* 0x32c7 */
    SYMBOL,        /* 0x32c8 */
    SYMBOL,        /* 0x32c9 */
    SYMBOL,        /* 0x32ca */
    SYMBOL,        /* 0x32cb */
    SYMBOL,        /* 0x32cc */
    SYMBOL,        /* 0x32cd */
    SYMBOL,        /* 0x32ce */
    SYMBOL,        /* 0x32cf */
    SYMBOL,        /* 0x32d0 */
    SYMBOL,        /* 0x32d1 */
    SYMBOL,        /* 0x32d2 */
    SYMBOL,        /* 0x32d3 */
    SYMBOL,        /* 0x32d4 */
    SYMBOL,        /* 0x32d5 */
    SYMBOL,        /* 0x32d6 */
    SYMBOL,        /* 0x32d7 */
    SYMBOL,        /* 0x32d8 */
    SYMBOL,        /* 0x32d9 */
    SYMBOL,        /* 0x32da */
    SYMBOL,        /* 0x32db */
    SYMBOL,        /* 0x32dc */
    SYMBOL,        /* 0x32dd */
    SYMBOL,        /* 0x32de */
    SYMBOL,        /* 0x32df */
    SYMBOL,        /* 0x32e0 */
    SYMBOL,        /* 0x32e1 */
    SYMBOL,        /* 0x32e2 */
    SYMBOL,        /* 0x32e3 */
    SYMBOL,        /* 0x32e4 */
    SYMBOL,        /* 0x32e5 */
    SYMBOL,        /* 0x32e6 */
    SYMBOL,        /* 0x32e7 */
    SYMBOL,        /* 0x32e8 */
    SYMBOL,        /* 0x32e9 */
    SYMBOL,        /* 0x32ea */
    SYMBOL,        /* 0x32eb */
    SYMBOL,        /* 0x32ec */
    SYMBOL,        /* 0x32ed */
    SYMBOL,        /* 0x32ee */
    SYMBOL,        /* 0x32ef */
    SYMBOL,        /* 0x32f0 */
    SYMBOL,        /* 0x32f1 */
    SYMBOL,        /* 0x32f2 */
    SYMBOL,        /* 0x32f3 */
    SYMBOL,        /* 0x32f4 */
    SYMBOL,        /* 0x32f5 */
    SYMBOL,        /* 0x32f6 */
    SYMBOL,        /* 0x32f7 */
    SYMBOL,        /* 0x32f8 */
    SYMBOL,        /* 0x32f9 */
    SYMBOL,        /* 0x32fa */
    SYMBOL,        /* 0x32fb */
    SYMBOL,        /* 0x32fc */
    SYMBOL,        /* 0x32fd */
    SYMBOL,        /* 0x32fe */
    OTHER,        /* 0x32ff */
    SYMBOL,        /* 0x3300 */
    SYMBOL,        /* 0x3301 */
    SYMBOL,        /* 0x3302 */
    SYMBOL,        /* 0x3303 */
    SYMBOL,        /* 0x3304 */
    SYMBOL,        /* 0x3305 */
    SYMBOL,        /* 0x3306 */
    SYMBOL,        /* 0x3307 */
    SYMBOL,        /* 0x3308 */
    SYMBOL,        /* 0x3309 */
    SYMBOL,        /* 0x330a */
    SYMBOL,        /* 0x330b */
    SYMBOL,        /* 0x330c */
    SYMBOL,        /* 0x330d */
    SYMBOL,        /* 0x330e */
    SYMBOL,        /* 0x330f */
    SYMBOL,        /* 0x3310 */
    SYMBOL,        /* 0x3311 */
    SYMBOL,        /* 0x3312 */
    SYMBOL,        /* 0x3313 */
    SYMBOL,        /* 0x3314 */
    SYMBOL,        /* 0x3315 */
    SYMBOL,        /* 0x3316 */
    SYMBOL,        /* 0x3317 */
    SYMBOL,        /* 0x3318 */
    SYMBOL,        /* 0x3319 */
    SYMBOL,        /* 0x331a */
    SYMBOL,        /* 0x331b */
    SYMBOL,        /* 0x331c */
    SYMBOL,        /* 0x331d */
    SYMBOL,        /* 0x331e */
    SYMBOL,        /* 0x331f */
    SYMBOL,        /* 0x3320 */
    SYMBOL,        /* 0x3321 */
    SYMBOL,        /* 0x3322 */
    SYMBOL,        /* 0x3323 */
    SYMBOL,        /* 0x3324 */
    SYMBOL,        /* 0x3325 */
    SYMBOL,        /* 0x3326 */
    SYMBOL,        /* 0x3327 */
    SYMBOL,        /* 0x3328 */
    SYMBOL,        /* 0x3329 */
    SYMBOL,        /* 0x332a */
    SYMBOL,        /* 0x332b */
    SYMBOL,        /* 0x332c */
    SYMBOL,        /* 0x332d */
    SYMBOL,        /* 0x332e */
    SYMBOL,        /* 0x332f */
    SYMBOL,        /* 0x3330 */
    SYMBOL,        /* 0x3331 */
    SYMBOL,        /* 0x3332 */
    SYMBOL,        /* 0x3333 */
    SYMBOL,        /* 0x3334 */
    SYMBOL,        /* 0x3335 */
    SYMBOL,        /* 0x3336 */
    SYMBOL,        /* 0x3337 */
    SYMBOL,        /* 0x3338 */
    SYMBOL,        /* 0x3339 */
    SYMBOL,        /* 0x333a */
    SYMBOL,        /* 0x333b */
    SYMBOL,        /* 0x333c */
    SYMBOL,        /* 0x333d */
    SYMBOL,        /* 0x333e */
    SYMBOL,        /* 0x333f */
    SYMBOL,        /* 0x3340 */
    SYMBOL,        /* 0x3341 */
    SYMBOL,        /* 0x3342 */
    SYMBOL,        /* 0x3343 */
    SYMBOL,        /* 0x3344 */
    SYMBOL,        /* 0x3345 */
    SYMBOL,        /* 0x3346 */
    SYMBOL,        /* 0x3347 */
    SYMBOL,        /* 0x3348 */
    SYMBOL,        /* 0x3349 */
    SYMBOL,        /* 0x334a */
    SYMBOL,        /* 0x334b */
    SYMBOL,        /* 0x334c */
    SYMBOL,        /* 0x334d */
    SYMBOL,        /* 0x334e */
    SYMBOL,        /* 0x334f */
    SYMBOL,        /* 0x3350 */
    SYMBOL,        /* 0x3351 */
    SYMBOL,        /* 0x3352 */
    SYMBOL,        /* 0x3353 */
    SYMBOL,        /* 0x3354 */
    SYMBOL,        /* 0x3355 */
    SYMBOL,        /* 0x3356 */
    SYMBOL,        /* 0x3357 */
    SYMBOL,        /* 0x3358 */
    SYMBOL,        /* 0x3359 */
    SYMBOL,        /* 0x335a */
    SYMBOL,        /* 0x335b */
    SYMBOL,        /* 0x335c */
    SYMBOL,        /* 0x335d */
    SYMBOL,        /* 0x335e */
    SYMBOL,        /* 0x335f */
    SYMBOL,        /* 0x3360 */
    SYMBOL,        /* 0x3361 */
    SYMBOL,        /* 0x3362 */
    SYMBOL,        /* 0x3363 */
    SYMBOL,        /* 0x3364 */
    SYMBOL,        /* 0x3365 */
    SYMBOL,        /* 0x3366 */
    SYMBOL,        /* 0x3367 */
    SYMBOL,        /* 0x3368 */
    SYMBOL,        /* 0x3369 */
    SYMBOL,        /* 0x336a */
    SYMBOL,        /* 0x336b */
    SYMBOL,        /* 0x336c */
    SYMBOL,        /* 0x336d */
    SYMBOL,        /* 0x336e */
    SYMBOL,        /* 0x336f */
    SYMBOL,        /* 0x3370 */
    SYMBOL,        /* 0x3371 */
    SYMBOL,        /* 0x3372 */
    SYMBOL,        /* 0x3373 */
    SYMBOL,        /* 0x3374 */
    SYMBOL,        /* 0x3375 */
    SYMBOL,        /* 0x3376 */
    SYMBOL,        /* 0x3377 */
    SYMBOL,        /* 0x3378 */
    SYMBOL,        /* 0x3379 */
    SYMBOL,        /* 0x337a */
    SYMBOL,        /* 0x337b */
    SYMBOL,        /* 0x337c */
    SYMBOL,        /* 0x337d */
    SYMBOL,        /* 0x337e */
    SYMBOL,        /* 0x337f */
    SYMBOL,        /* 0x3380 */
    SYMBOL,        /* 0x3381 */
    SYMBOL,        /* 0x3382 */
    SYMBOL,        /* 0x3383 */
    SYMBOL,        /* 0x3384 */
    SYMBOL,        /* 0x3385 */
    SYMBOL,        /* 0x3386 */
    SYMBOL,        /* 0x3387 */
    SYMBOL,        /* 0x3388 */
    SYMBOL,        /* 0x3389 */
    SYMBOL,        /* 0x338a */
    SYMBOL,        /* 0x338b */
    SYMBOL,        /* 0x338c */
    SYMBOL,        /* 0x338d */
    SYMBOL,        /* 0x338e */
    SYMBOL,        /* 0x338f */
    SYMBOL,        /* 0x3390 */
    SYMBOL,        /* 0x3391 */
    SYMBOL,        /* 0x3392 */
    SYMBOL,        /* 0x3393 */
    SYMBOL,        /* 0x3394 */
    SYMBOL,        /* 0x3395 */
    SYMBOL,        /* 0x3396 */
    SYMBOL,        /* 0x3397 */
    SYMBOL,        /* 0x3398 */
    SYMBOL,        /* 0x3399 */
    SYMBOL,        /* 0x339a */
    SYMBOL,        /* 0x339b */
    SYMBOL,        /* 0x339c */
    SYMBOL,        /* 0x339d */
    SYMBOL,        /* 0x339e */
    SYMBOL,        /* 0x339f */
    SYMBOL,        /* 0x33a0 */
    SYMBOL,        /* 0x33a1 */
    SYMBOL,        /* 0x33a2 */
    SYMBOL,        /* 0x33a3 */
    SYMBOL,        /* 0x33a4 */
    SYMBOL,        /* 0x33a5 */
    SYMBOL,        /* 0x33a6 */
    SYMBOL,        /* 0x33a7 */
    SYMBOL,        /* 0x33a8 */
    SYMBOL,        /* 0x33a9 */
    SYMBOL,        /* 0x33aa */
    SYMBOL,        /* 0x33ab */
    SYMBOL,        /* 0x33ac */
    SYMBOL,        /* 0x33ad */
    SYMBOL,        /* 0x33ae */
    SYMBOL,        /* 0x33af */
    SYMBOL,        /* 0x33b0 */
    SYMBOL,        /* 0x33b1 */
    SYMBOL,        /* 0x33b2 */
    SYMBOL,        /* 0x33b3 */
    SYMBOL,        /* 0x33b4 */
    SYMBOL,        /* 0x33b5 */
    SYMBOL,        /* 0x33b6 */
    SYMBOL,        /* 0x33b7 */
    SYMBOL,        /* 0x33b8 */
    SYMBOL,        /* 0x33b9 */
    SYMBOL,        /* 0x33ba */
    SYMBOL,        /* 0x33bb */
    SYMBOL,        /* 0x33bc */
    SYMBOL,        /* 0x33bd */
    SYMBOL,        /* 0x33be */
    SYMBOL,        /* 0x33bf */
    SYMBOL,        /* 0x33c0 */
    SYMBOL,        /* 0x33c1 */
    SYMBOL,        /* 0x33c2 */
    SYMBOL,        /* 0x33c3 */
    SYMBOL,        /* 0x33c4 */
    SYMBOL,        /* 0x33c5 */
    SYMBOL,        /* 0x33c6 */
    SYMBOL,        /* 0x33c7 */
    SYMBOL,        /* 0x33c8 */
    SYMBOL,        /* 0x33c9 */
    SYMBOL,        /* 0x33ca */
    SYMBOL,        /* 0x33cb */
    SYMBOL,        /* 0x33cc */
    SYMBOL,        /* 0x33cd */
    SYMBOL,        /* 0x33ce */
    SYMBOL,        /* 0x33cf */
    SYMBOL,        /* 0x33d0 */
    SYMBOL,        /* 0x33d1 */
    SYMBOL,        /* 0x33d2 */
    SYMBOL,        /* 0x33d3 */
    SYMBOL,        /* 0x33d4 */
    SYMBOL,        /* 0x33d5 */
    SYMBOL,        /* 0x33d6 */
    SYMBOL,        /* 0x33d7 */
    SYMBOL,        /* 0x33d8 */
    SYMBOL,        /* 0x33d9 */
    SYMBOL,        /* 0x33da */
    SYMBOL,        /* 0x33db */
    SYMBOL,        /* 0x33dc */
    SYMBOL,        /* 0x33dd */
    SYMBOL,        /* 0x33de */
    SYMBOL,        /* 0x33df */
    SYMBOL,        /* 0x33e0 */
    SYMBOL,        /* 0x33e1 */
    SYMBOL,        /* 0x33e2 */
    SYMBOL,        /* 0x33e3 */
    SYMBOL,        /* 0x33e4 */
    SYMBOL,        /* 0x33e5 */
    SYMBOL,        /* 0x33e6 */
    SYMBOL,        /* 0x33e7 */
    SYMBOL,        /* 0x33e8 */
    SYMBOL,        /* 0x33e9 */
    SYMBOL,        /* 0x33ea */
    SYMBOL,        /* 0x33eb */
    SYMBOL,        /* 0x33ec */
    SYMBOL,        /* 0x33ed */
    SYMBOL,        /* 0x33ee */
    SYMBOL,        /* 0x33ef */
    SYMBOL,        /* 0x33f0 */
    SYMBOL,        /* 0x33f1 */
    SYMBOL,        /* 0x33f2 */
    SYMBOL,        /* 0x33f3 */
    SYMBOL,        /* 0x33f4 */
    SYMBOL,        /* 0x33f5 */
    SYMBOL,        /* 0x33f6 */
    SYMBOL,        /* 0x33f7 */
    SYMBOL,        /* 0x33f8 */
    SYMBOL,        /* 0x33f9 */
    SYMBOL,        /* 0x33fa */
    SYMBOL,        /* 0x33fb */
    SYMBOL,        /* 0x33fc */
    SYMBOL,        /* 0x33fd */
    SYMBOL,        /* 0x33fe */
    SYMBOL,        /* 0x33ff */
    KANJI,        /* 0x3400 */
    KANJI,        /* 0x3401 */
    KANJI,        /* 0x3402 */
    KANJI,        /* 0x3403 */
    KANJI,        /* 0x3404 */
    KANJI,        /* 0x3405 */
    KANJI,        /* 0x3406 */
    KANJI,        /* 0x3407 */
    KANJI,        /* 0x3408 */
    KANJI,        /* 0x3409 */
    KANJI,        /* 0x340a */
    KANJI,        /* 0x340b */
    KANJI,        /* 0x340c */
    KANJI,        /* 0x340d */
    KANJI,        /* 0x340e */
    KANJI,        /* 0x340f */
    KANJI,        /* 0x3410 */
    KANJI,        /* 0x3411 */
    KANJI,        /* 0x3412 */
    KANJI,        /* 0x3413 */
    KANJI,        /* 0x3414 */
    KANJI,        /* 0x3415 */
    KANJI,        /* 0x3416 */
    KANJI,        /* 0x3417 */
    KANJI,        /* 0x3418 */
    KANJI,        /* 0x3419 */
    KANJI,        /* 0x341a */
    KANJI,        /* 0x341b */
    KANJI,        /* 0x341c */
    KANJI,        /* 0x341d */
    KANJI,        /* 0x341e */
    KANJI,        /* 0x341f */
    KANJI,        /* 0x3420 */
    KANJI,        /* 0x3421 */
    KANJI,        /* 0x3422 */
    KANJI,        /* 0x3423 */
    KANJI,        /* 0x3424 */
    KANJI,        /* 0x3425 */
    KANJI,        /* 0x3426 */
    KANJI,        /* 0x3427 */
    KANJI,        /* 0x3428 */
    KANJI,        /* 0x3429 */
    KANJI,        /* 0x342a */
    KANJI,        /* 0x342b */
    KANJI,        /* 0x342c */
    KANJI,        /* 0x342d */
    KANJI,        /* 0x342e */
    KANJI,        /* 0x342f */
    KANJI,        /* 0x3430 */
    KANJI,        /* 0x3431 */
    KANJI,        /* 0x3432 */
    KANJI,        /* 0x3433 */
    KANJI,        /* 0x3434 */
    KANJI,        /* 0x3435 */
    KANJI,        /* 0x3436 */
    KANJI,        /* 0x3437 */
    KANJI,        /* 0x3438 */
    KANJI,        /* 0x3439 */
    KANJI,        /* 0x343a */
    KANJI,        /* 0x343b */
    KANJI,        /* 0x343c */
    KANJI,        /* 0x343d */
    KANJI,        /* 0x343e */
    KANJI,        /* 0x343f */
    KANJI,        /* 0x3440 */
    KANJI,        /* 0x3441 */
    KANJI,        /* 0x3442 */
    KANJI,        /* 0x3443 */
    KANJI,        /* 0x3444 */
    KANJI,        /* 0x3445 */
    KANJI,        /* 0x3446 */
    KANJI,        /* 0x3447 */
    KANJI,        /* 0x3448 */
    KANJI,        /* 0x3449 */
    KANJI,        /* 0x344a */
    KANJI,        /* 0x344b */
    KANJI,        /* 0x344c */
    KANJI,        /* 0x344d */
    KANJI,        /* 0x344e */
    KANJI,        /* 0x344f */
    KANJI,        /* 0x3450 */
    KANJI,        /* 0x3451 */
    KANJI,        /* 0x3452 */
    KANJI,        /* 0x3453 */
    KANJI,        /* 0x3454 */
    KANJI,        /* 0x3455 */
    KANJI,        /* 0x3456 */
    KANJI,        /* 0x3457 */
    KANJI,        /* 0x3458 */
    KANJI,        /* 0x3459 */
    KANJI,        /* 0x345a */
    KANJI,        /* 0x345b */
    KANJI,        /* 0x345c */
    KANJI,        /* 0x345d */
    KANJI,        /* 0x345e */
    KANJI,        /* 0x345f */
    KANJI,        /* 0x3460 */
    KANJI,        /* 0x3461 */
    KANJI,        /* 0x3462 */
    KANJI,        /* 0x3463 */
    KANJI,        /* 0x3464 */
    KANJI,        /* 0x3465 */
    KANJI,        /* 0x3466 */
    KANJI,        /* 0x3467 */
    KANJI,        /* 0x3468 */
    KANJI,        /* 0x3469 */
    KANJI,        /* 0x346a */
    KANJI,        /* 0x346b */
    KANJI,        /* 0x346c */
    KANJI,        /* 0x346d */
    KANJI,        /* 0x346e */
    KANJI,        /* 0x346f */
    KANJI,        /* 0x3470 */
    KANJI,        /* 0x3471 */
    KANJI,        /* 0x3472 */
    KANJI,        /* 0x3473 */
    KANJI,        /* 0x3474 */
    KANJI,        /* 0x3475 */
    KANJI,        /* 0x3476 */
    KANJI,        /* 0x3477 */
    KANJI,        /* 0x3478 */
    KANJI,        /* 0x3479 */
    KANJI,        /* 0x347a */
    KANJI,        /* 0x347b */
    KANJI,        /* 0x347c */
    KANJI,        /* 0x347d */
    KANJI,        /* 0x347e */
    KANJI,        /* 0x347f */
    KANJI,        /* 0x3480 */
    KANJI,        /* 0x3481 */
    KANJI,        /* 0x3482 */
    KANJI,        /* 0x3483 */
    KANJI,        /* 0x3484 */
    KANJI,        /* 0x3485 */
    KANJI,        /* 0x3486 */
    KANJI,        /* 0x3487 */
    KANJI,        /* 0x3488 */
    KANJI,        /* 0x3489 */
    KANJI,        /* 0x348a */
    KANJI,        /* 0x348b */
    KANJI,        /* 0x348c */
    KANJI,        /* 0x348d */
    KANJI,        /* 0x348e */
    KANJI,        /* 0x348f */
    KANJI,        /* 0x3490 */
    KANJI,        /* 0x3491 */
    KANJI,        /* 0x3492 */
    KANJI,        /* 0x3493 */
    KANJI,        /* 0x3494 */
    KANJI,        /* 0x3495 */
    KANJI,        /* 0x3496 */
    KANJI,        /* 0x3497 */
    KANJI,        /* 0x3498 */
    KANJI,        /* 0x3499 */
    KANJI,        /* 0x349a */
    KANJI,        /* 0x349b */
    KANJI,        /* 0x349c */
    KANJI,        /* 0x349d */
    KANJI,        /* 0x349e */
    KANJI,        /* 0x349f */
    KANJI,        /* 0x34a0 */
    KANJI,        /* 0x34a1 */
    KANJI,        /* 0x34a2 */
    KANJI,        /* 0x34a3 */
    KANJI,        /* 0x34a4 */
    KANJI,        /* 0x34a5 */
    KANJI,        /* 0x34a6 */
    KANJI,        /* 0x34a7 */
    KANJI,        /* 0x34a8 */
    KANJI,        /* 0x34a9 */
    KANJI,        /* 0x34aa */
    KANJI,        /* 0x34ab */
    KANJI,        /* 0x34ac */
    KANJI,        /* 0x34ad */
    KANJI,        /* 0x34ae */
    KANJI,        /* 0x34af */
    KANJI,        /* 0x34b0 */
    KANJI,        /* 0x34b1 */
    KANJI,        /* 0x34b2 */
    KANJI,        /* 0x34b3 */
    KANJI,        /* 0x34b4 */
    KANJI,        /* 0x34b5 */
    KANJI,        /* 0x34b6 */
    KANJI,        /* 0x34b7 */
    KANJI,        /* 0x34b8 */
    KANJI,        /* 0x34b9 */
    KANJI,        /* 0x34ba */
    KANJI,        /* 0x34bb */
    KANJI,        /* 0x34bc */
    KANJI,        /* 0x34bd */
    KANJI,        /* 0x34be */
    KANJI,        /* 0x34bf */
    KANJI,        /* 0x34c0 */
    KANJI,        /* 0x34c1 */
    KANJI,        /* 0x34c2 */
    KANJI,        /* 0x34c3 */
    KANJI,        /* 0x34c4 */
    KANJI,        /* 0x34c5 */
    KANJI,        /* 0x34c6 */
    KANJI,        /* 0x34c7 */
    KANJI,        /* 0x34c8 */
    KANJI,        /* 0x34c9 */
    KANJI,        /* 0x34ca */
    KANJI,        /* 0x34cb */
    KANJI,        /* 0x34cc */
    KANJI,        /* 0x34cd */
    KANJI,        /* 0x34ce */
    KANJI,        /* 0x34cf */
    KANJI,        /* 0x34d0 */
    KANJI,        /* 0x34d1 */
    KANJI,        /* 0x34d2 */
    KANJI,        /* 0x34d3 */
    KANJI,        /* 0x34d4 */
    KANJI,        /* 0x34d5 */
    KANJI,        /* 0x34d6 */
    KANJI,        /* 0x34d7 */
    KANJI,        /* 0x34d8 */
    KANJI,        /* 0x34d9 */
    KANJI,        /* 0x34da */
    KANJI,        /* 0x34db */
    KANJI,        /* 0x34dc */
    KANJI,        /* 0x34dd */
    KANJI,        /* 0x34de */
    KANJI,        /* 0x34df */
    KANJI,        /* 0x34e0 */
    KANJI,        /* 0x34e1 */
    KANJI,        /* 0x34e2 */
    KANJI,        /* 0x34e3 */
    KANJI,        /* 0x34e4 */
    KANJI,        /* 0x34e5 */
    KANJI,        /* 0x34e6 */
    KANJI,        /* 0x34e7 */
    KANJI,        /* 0x34e8 */
    KANJI,        /* 0x34e9 */
    KANJI,        /* 0x34ea */
    KANJI,        /* 0x34eb */
    KANJI,        /* 0x34ec */
    KANJI,        /* 0x34ed */
    KANJI,        /* 0x34ee */
    KANJI,        /* 0x34ef */
    KANJI,        /* 0x34f0 */
    KANJI,        /* 0x34f1 */
    KANJI,        /* 0x34f2 */
    KANJI,        /* 0x34f3 */
    KANJI,        /* 0x34f4 */
    KANJI,        /* 0x34f5 */
    KANJI,        /* 0x34f6 */
    KANJI,        /* 0x34f7 */
    KANJI,        /* 0x34f8 */
    KANJI,        /* 0x34f9 */
    KANJI,        /* 0x34fa */
    KANJI,        /* 0x34fb */
    KANJI,        /* 0x34fc */
    KANJI,        /* 0x34fd */
    KANJI,        /* 0x34fe */
    KANJI,        /* 0x34ff */
    KANJI,        /* 0x3500 */
    KANJI,        /* 0x3501 */
    KANJI,        /* 0x3502 */
    KANJI,        /* 0x3503 */
    KANJI,        /* 0x3504 */
    KANJI,        /* 0x3505 */
    KANJI,        /* 0x3506 */
    KANJI,        /* 0x3507 */
    KANJI,        /* 0x3508 */
    KANJI,        /* 0x3509 */
    KANJI,        /* 0x350a */
    KANJI,        /* 0x350b */
    KANJI,        /* 0x350c */
    KANJI,        /* 0x350d */
    KANJI,        /* 0x350e */
    KANJI,        /* 0x350f */
    KANJI,        /* 0x3510 */
    KANJI,        /* 0x3511 */
    KANJI,        /* 0x3512 */
    KANJI,        /* 0x3513 */
    KANJI,        /* 0x3514 */
    KANJI,        /* 0x3515 */
    KANJI,        /* 0x3516 */
    KANJI,        /* 0x3517 */
    KANJI,        /* 0x3518 */
    KANJI,        /* 0x3519 */
    KANJI,        /* 0x351a */
    KANJI,        /* 0x351b */
    KANJI,        /* 0x351c */
    KANJI,        /* 0x351d */
    KANJI,        /* 0x351e */
    KANJI,        /* 0x351f */
    KANJI,        /* 0x3520 */
    KANJI,        /* 0x3521 */
    KANJI,        /* 0x3522 */
    KANJI,        /* 0x3523 */
    KANJI,        /* 0x3524 */
    KANJI,        /* 0x3525 */
    KANJI,        /* 0x3526 */
    KANJI,        /* 0x3527 */
    KANJI,        /* 0x3528 */
    KANJI,        /* 0x3529 */
    KANJI,        /* 0x352a */
    KANJI,        /* 0x352b */
    KANJI,        /* 0x352c */
    KANJI,        /* 0x352d */
    KANJI,        /* 0x352e */
    KANJI,        /* 0x352f */
    KANJI,        /* 0x3530 */
    KANJI,        /* 0x3531 */
    KANJI,        /* 0x3532 */
    KANJI,        /* 0x3533 */
    KANJI,        /* 0x3534 */
    KANJI,        /* 0x3535 */
    KANJI,        /* 0x3536 */
    KANJI,        /* 0x3537 */
    KANJI,        /* 0x3538 */
    KANJI,        /* 0x3539 */
    KANJI,        /* 0x353a */
    KANJI,        /* 0x353b */
    KANJI,        /* 0x353c */
    KANJI,        /* 0x353d */
    KANJI,        /* 0x353e */
    KANJI,        /* 0x353f */
    KANJI,        /* 0x3540 */
    KANJI,        /* 0x3541 */
    KANJI,        /* 0x3542 */
    KANJI,        /* 0x3543 */
    KANJI,        /* 0x3544 */
    KANJI,        /* 0x3545 */
    KANJI,        /* 0x3546 */
    KANJI,        /* 0x3547 */
    KANJI,        /* 0x3548 */
    KANJI,        /* 0x3549 */
    KANJI,        /* 0x354a */
    KANJI,        /* 0x354b */
    KANJI,        /* 0x354c */
    KANJI,        /* 0x354d */
    KANJI,        /* 0x354e */
    KANJI,        /* 0x354f */
    KANJI,        /* 0x3550 */
    KANJI,        /* 0x3551 */
    KANJI,        /* 0x3552 */
    KANJI,        /* 0x3553 */
    KANJI,        /* 0x3554 */
    KANJI,        /* 0x3555 */
    KANJI,        /* 0x3556 */
    KANJI,        /* 0x3557 */
    KANJI,        /* 0x3558 */
    KANJI,        /* 0x3559 */
    KANJI,        /* 0x355a */
    KANJI,        /* 0x355b */
    KANJI,        /* 0x355c */
    KANJI,        /* 0x355d */
    KANJI,        /* 0x355e */
    KANJI,        /* 0x355f */
    KANJI,        /* 0x3560 */
    KANJI,        /* 0x3561 */
    KANJI,        /* 0x3562 */
    KANJI,        /* 0x3563 */
    KANJI,        /* 0x3564 */
    KANJI,        /* 0x3565 */
    KANJI,        /* 0x3566 */
    KANJI,        /* 0x3567 */
    KANJI,        /* 0x3568 */
    KANJI,        /* 0x3569 */
    KANJI,        /* 0x356a */
    KANJI,        /* 0x356b */
    KANJI,        /* 0x356c */
    KANJI,        /* 0x356d */
    KANJI,        /* 0x356e */
    KANJI,        /* 0x356f */
    KANJI,        /* 0x3570 */
    KANJI,        /* 0x3571 */
    KANJI,        /* 0x3572 */
    KANJI,        /* 0x3573 */
    KANJI,        /* 0x3574 */
    KANJI,        /* 0x3575 */
    KANJI,        /* 0x3576 */
    KANJI,        /* 0x3577 */
    KANJI,        /* 0x3578 */
    KANJI,        /* 0x3579 */
    KANJI,        /* 0x357a */
    KANJI,        /* 0x357b */
    KANJI,        /* 0x357c */
    KANJI,        /* 0x357d */
    KANJI,        /* 0x357e */
    KANJI,        /* 0x357f */
    KANJI,        /* 0x3580 */
    KANJI,        /* 0x3581 */
    KANJI,        /* 0x3582 */
    KANJI,        /* 0x3583 */
    KANJI,        /* 0x3584 */
    KANJI,        /* 0x3585 */
    KANJI,        /* 0x3586 */
    KANJI,        /* 0x3587 */
    KANJI,        /* 0x3588 */
    KANJI,        /* 0x3589 */
    KANJI,        /* 0x358a */
    KANJI,        /* 0x358b */
    KANJI,        /* 0x358c */
    KANJI,        /* 0x358d */
    KANJI,        /* 0x358e */
    KANJI,        /* 0x358f */
    KANJI,        /* 0x3590 */
    KANJI,        /* 0x3591 */
    KANJI,        /* 0x3592 */
    KANJI,        /* 0x3593 */
    KANJI,        /* 0x3594 */
    KANJI,        /* 0x3595 */
    KANJI,        /* 0x3596 */
    KANJI,        /* 0x3597 */
    KANJI,        /* 0x3598 */
    KANJI,        /* 0x3599 */
    KANJI,        /* 0x359a */
    KANJI,        /* 0x359b */
    KANJI,        /* 0x359c */
    KANJI,        /* 0x359d */
    KANJI,        /* 0x359e */
    KANJI,        /* 0x359f */
    KANJI,        /* 0x35a0 */
    KANJI,        /* 0x35a1 */
    KANJI,        /* 0x35a2 */
    KANJI,        /* 0x35a3 */
    KANJI,        /* 0x35a4 */
    KANJI,        /* 0x35a5 */
    KANJI,        /* 0x35a6 */
    KANJI,        /* 0x35a7 */
    KANJI,        /* 0x35a8 */
    KANJI,        /* 0x35a9 */
    KANJI,        /* 0x35aa */
    KANJI,        /* 0x35ab */
    KANJI,        /* 0x35ac */
    KANJI,        /* 0x35ad */
    KANJI,        /* 0x35ae */
    KANJI,        /* 0x35af */
    KANJI,        /* 0x35b0 */
    KANJI,        /* 0x35b1 */
    KANJI,        /* 0x35b2 */
    KANJI,        /* 0x35b3 */
    KANJI,        /* 0x35b4 */
    KANJI,        /* 0x35b5 */
    KANJI,        /* 0x35b6 */
    KANJI,        /* 0x35b7 */
    KANJI,        /* 0x35b8 */
    KANJI,        /* 0x35b9 */
    KANJI,        /* 0x35ba */
    KANJI,        /* 0x35bb */
    KANJI,        /* 0x35bc */
    KANJI,        /* 0x35bd */
    KANJI,        /* 0x35be */
    KANJI,        /* 0x35bf */
    KANJI,        /* 0x35c0 */
    KANJI,        /* 0x35c1 */
    KANJI,        /* 0x35c2 */
    KANJI,        /* 0x35c3 */
    KANJI,        /* 0x35c4 */
    KANJI,        /* 0x35c5 */
    KANJI,        /* 0x35c6 */
    KANJI,        /* 0x35c7 */
    KANJI,        /* 0x35c8 */
    KANJI,        /* 0x35c9 */
    KANJI,        /* 0x35ca */
    KANJI,        /* 0x35cb */
    KANJI,        /* 0x35cc */
    KANJI,        /* 0x35cd */
    KANJI,        /* 0x35ce */
    KANJI,        /* 0x35cf */
    KANJI,        /* 0x35d0 */
    KANJI,        /* 0x35d1 */
    KANJI,        /* 0x35d2 */
    KANJI,        /* 0x35d3 */
    KANJI,        /* 0x35d4 */
    KANJI,        /* 0x35d5 */
    KANJI,        /* 0x35d6 */
    KANJI,        /* 0x35d7 */
    KANJI,        /* 0x35d8 */
    KANJI,        /* 0x35d9 */
    KANJI,        /* 0x35da */
    KANJI,        /* 0x35db */
    KANJI,        /* 0x35dc */
    KANJI,        /* 0x35dd */
    KANJI,        /* 0x35de */
    KANJI,        /* 0x35df */
    KANJI,        /* 0x35e0 */
    KANJI,        /* 0x35e1 */
    KANJI,        /* 0x35e2 */
    KANJI,        /* 0x35e3 */
    KANJI,        /* 0x35e4 */
    KANJI,        /* 0x35e5 */
    KANJI,        /* 0x35e6 */
    KANJI,        /* 0x35e7 */
    KANJI,        /* 0x35e8 */
    KANJI,        /* 0x35e9 */
    KANJI,        /* 0x35ea */
    KANJI,        /* 0x35eb */
    KANJI,        /* 0x35ec */
    KANJI,        /* 0x35ed */
    KANJI,        /* 0x35ee */
    KANJI,        /* 0x35ef */
    KANJI,        /* 0x35f0 */
    KANJI,        /* 0x35f1 */
    KANJI,        /* 0x35f2 */
    KANJI,        /* 0x35f3 */
    KANJI,        /* 0x35f4 */
    KANJI,        /* 0x35f5 */
    KANJI,        /* 0x35f6 */
    KANJI,        /* 0x35f7 */
    KANJI,        /* 0x35f8 */
    KANJI,        /* 0x35f9 */
    KANJI,        /* 0x35fa */
    KANJI,        /* 0x35fb */
    KANJI,        /* 0x35fc */
    KANJI,        /* 0x35fd */
    KANJI,        /* 0x35fe */
    KANJI,        /* 0x35ff */
    KANJI,        /* 0x3600 */
    KANJI,        /* 0x3601 */
    KANJI,        /* 0x3602 */
    KANJI,        /* 0x3603 */
    KANJI,        /* 0x3604 */
    KANJI,        /* 0x3605 */
    KANJI,        /* 0x3606 */
    KANJI,        /* 0x3607 */
    KANJI,        /* 0x3608 */
    KANJI,        /* 0x3609 */
    KANJI,        /* 0x360a */
    KANJI,        /* 0x360b */
    KANJI,        /* 0x360c */
    KANJI,        /* 0x360d */
    KANJI,        /* 0x360e */
    KANJI,        /* 0x360f */
    KANJI,        /* 0x3610 */
    KANJI,        /* 0x3611 */
    KANJI,        /* 0x3612 */
    KANJI,        /* 0x3613 */
    KANJI,        /* 0x3614 */
    KANJI,        /* 0x3615 */
    KANJI,        /* 0x3616 */
    KANJI,        /* 0x3617 */
    KANJI,        /* 0x3618 */
    KANJI,        /* 0x3619 */
    KANJI,        /* 0x361a */
    KANJI,        /* 0x361b */
    KANJI,        /* 0x361c */
    KANJI,        /* 0x361d */
    KANJI,        /* 0x361e */
    KANJI,        /* 0x361f */
    KANJI,        /* 0x3620 */
    KANJI,        /* 0x3621 */
    KANJI,        /* 0x3622 */
    KANJI,        /* 0x3623 */
    KANJI,        /* 0x3624 */
    KANJI,        /* 0x3625 */
    KANJI,        /* 0x3626 */
    KANJI,        /* 0x3627 */
    KANJI,        /* 0x3628 */
    KANJI,        /* 0x3629 */
    KANJI,        /* 0x362a */
    KANJI,        /* 0x362b */
    KANJI,        /* 0x362c */
    KANJI,        /* 0x362d */
    KANJI,        /* 0x362e */
    KANJI,        /* 0x362f */
    KANJI,        /* 0x3630 */
    KANJI,        /* 0x3631 */
    KANJI,        /* 0x3632 */
    KANJI,        /* 0x3633 */
    KANJI,        /* 0x3634 */
    KANJI,        /* 0x3635 */
    KANJI,        /* 0x3636 */
    KANJI,        /* 0x3637 */
    KANJI,        /* 0x3638 */
    KANJI,        /* 0x3639 */
    KANJI,        /* 0x363a */
    KANJI,        /* 0x363b */
    KANJI,        /* 0x363c */
    KANJI,        /* 0x363d */
    KANJI,        /* 0x363e */
    KANJI,        /* 0x363f */
    KANJI,        /* 0x3640 */
    KANJI,        /* 0x3641 */
    KANJI,        /* 0x3642 */
    KANJI,        /* 0x3643 */
    KANJI,        /* 0x3644 */
    KANJI,        /* 0x3645 */
    KANJI,        /* 0x3646 */
    KANJI,        /* 0x3647 */
    KANJI,        /* 0x3648 */
    KANJI,        /* 0x3649 */
    KANJI,        /* 0x364a */
    KANJI,        /* 0x364b */
    KANJI,        /* 0x364c */
    KANJI,        /* 0x364d */
    KANJI,        /* 0x364e */
    KANJI,        /* 0x364f */
    KANJI,        /* 0x3650 */
    KANJI,        /* 0x3651 */
    KANJI,        /* 0x3652 */
    KANJI,        /* 0x3653 */
    KANJI,        /* 0x3654 */
    KANJI,        /* 0x3655 */
    KANJI,        /* 0x3656 */
    KANJI,        /* 0x3657 */
    KANJI,        /* 0x3658 */
    KANJI,        /* 0x3659 */
    KANJI,        /* 0x365a */
    KANJI,        /* 0x365b */
    KANJI,        /* 0x365c */
    KANJI,        /* 0x365d */
    KANJI,        /* 0x365e */
    KANJI,        /* 0x365f */
    KANJI,        /* 0x3660 */
    KANJI,        /* 0x3661 */
    KANJI,        /* 0x3662 */
    KANJI,        /* 0x3663 */
    KANJI,        /* 0x3664 */
    KANJI,        /* 0x3665 */
    KANJI,        /* 0x3666 */
    KANJI,        /* 0x3667 */
    KANJI,        /* 0x3668 */
    KANJI,        /* 0x3669 */
    KANJI,        /* 0x366a */
    KANJI,        /* 0x366b */
    KANJI,        /* 0x366c */
    KANJI,        /* 0x366d */
    KANJI,        /* 0x366e */
    KANJI,        /* 0x366f */
    KANJI,        /* 0x3670 */
    KANJI,        /* 0x3671 */
    KANJI,        /* 0x3672 */
    KANJI,        /* 0x3673 */
    KANJI,        /* 0x3674 */
    KANJI,        /* 0x3675 */
    KANJI,        /* 0x3676 */
    KANJI,        /* 0x3677 */
    KANJI,        /* 0x3678 */
    KANJI,        /* 0x3679 */
    KANJI,        /* 0x367a */
    KANJI,        /* 0x367b */
    KANJI,        /* 0x367c */
    KANJI,        /* 0x367d */
    KANJI,        /* 0x367e */
    KANJI,        /* 0x367f */
    KANJI,        /* 0x3680 */
    KANJI,        /* 0x3681 */
    KANJI,        /* 0x3682 */
    KANJI,        /* 0x3683 */
    KANJI,        /* 0x3684 */
    KANJI,        /* 0x3685 */
    KANJI,        /* 0x3686 */
    KANJI,        /* 0x3687 */
    KANJI,        /* 0x3688 */
    KANJI,        /* 0x3689 */
    KANJI,        /* 0x368a */
    KANJI,        /* 0x368b */
    KANJI,        /* 0x368c */
    KANJI,        /* 0x368d */
    KANJI,        /* 0x368e */
    KANJI,        /* 0x368f */
    KANJI,        /* 0x3690 */
    KANJI,        /* 0x3691 */
    KANJI,        /* 0x3692 */
    KANJI,        /* 0x3693 */
    KANJI,        /* 0x3694 */
    KANJI,        /* 0x3695 */
    KANJI,        /* 0x3696 */
    KANJI,        /* 0x3697 */
    KANJI,        /* 0x3698 */
    KANJI,        /* 0x3699 */
    KANJI,        /* 0x369a */
    KANJI,        /* 0x369b */
    KANJI,        /* 0x369c */
    KANJI,        /* 0x369d */
    KANJI,        /* 0x369e */
    KANJI,        /* 0x369f */
    KANJI,        /* 0x36a0 */
    KANJI,        /* 0x36a1 */
    KANJI,        /* 0x36a2 */
    KANJI,        /* 0x36a3 */
    KANJI,        /* 0x36a4 */
    KANJI,        /* 0x36a5 */
    KANJI,        /* 0x36a6 */
    KANJI,        /* 0x36a7 */
    KANJI,        /* 0x36a8 */
    KANJI,        /* 0x36a9 */
    KANJI,        /* 0x36aa */
    KANJI,        /* 0x36ab */
    KANJI,        /* 0x36ac */
    KANJI,        /* 0x36ad */
    KANJI,        /* 0x36ae */
    KANJI,        /* 0x36af */
    KANJI,        /* 0x36b0 */
    KANJI,        /* 0x36b1 */
    KANJI,        /* 0x36b2 */
    KANJI,        /* 0x36b3 */
    KANJI,        /* 0x36b4 */
    KANJI,        /* 0x36b5 */
    KANJI,        /* 0x36b6 */
    KANJI,        /* 0x36b7 */
    KANJI,        /* 0x36b8 */
    KANJI,        /* 0x36b9 */
    KANJI,        /* 0x36ba */
    KANJI,        /* 0x36bb */
    KANJI,        /* 0x36bc */
    KANJI,        /* 0x36bd */
    KANJI,        /* 0x36be */
    KANJI,        /* 0x36bf */
    KANJI,        /* 0x36c0 */
    KANJI,        /* 0x36c1 */
    KANJI,        /* 0x36c2 */
    KANJI,        /* 0x36c3 */
    KANJI,        /* 0x36c4 */
    KANJI,        /* 0x36c5 */
    KANJI,        /* 0x36c6 */
    KANJI,        /* 0x36c7 */
    KANJI,        /* 0x36c8 */
    KANJI,        /* 0x36c9 */
    KANJI,        /* 0x36ca */
    KANJI,        /* 0x36cb */
    KANJI,        /* 0x36cc */
    KANJI,        /* 0x36cd */
    KANJI,        /* 0x36ce */
    KANJI,        /* 0x36cf */
    KANJI,        /* 0x36d0 */
    KANJI,        /* 0x36d1 */
    KANJI,        /* 0x36d2 */
    KANJI,        /* 0x36d3 */
    KANJI,        /* 0x36d4 */
    KANJI,        /* 0x36d5 */
    KANJI,        /* 0x36d6 */
    KANJI,        /* 0x36d7 */
    KANJI,        /* 0x36d8 */
    KANJI,        /* 0x36d9 */
    KANJI,        /* 0x36da */
    KANJI,        /* 0x36db */
    KANJI,        /* 0x36dc */
    KANJI,        /* 0x36dd */
    KANJI,        /* 0x36de */
    KANJI,        /* 0x36df */
    KANJI,        /* 0x36e0 */
    KANJI,        /* 0x36e1 */
    KANJI,        /* 0x36e2 */
    KANJI,        /* 0x36e3 */
    KANJI,        /* 0x36e4 */
    KANJI,        /* 0x36e5 */
    KANJI,        /* 0x36e6 */
    KANJI,        /* 0x36e7 */
    KANJI,        /* 0x36e8 */
    KANJI,        /* 0x36e9 */
    KANJI,        /* 0x36ea */
    KANJI,        /* 0x36eb */
    KANJI,        /* 0x36ec */
    KANJI,        /* 0x36ed */
    KANJI,        /* 0x36ee */
    KANJI,        /* 0x36ef */
    KANJI,        /* 0x36f0 */
    KANJI,        /* 0x36f1 */
    KANJI,        /* 0x36f2 */
    KANJI,        /* 0x36f3 */
    KANJI,        /* 0x36f4 */
    KANJI,        /* 0x36f5 */
    KANJI,        /* 0x36f6 */
    KANJI,        /* 0x36f7 */
    KANJI,        /* 0x36f8 */
    KANJI,        /* 0x36f9 */
    KANJI,        /* 0x36fa */
    KANJI,        /* 0x36fb */
    KANJI,        /* 0x36fc */
    KANJI,        /* 0x36fd */
    KANJI,        /* 0x36fe */
    KANJI,        /* 0x36ff */
    KANJI,        /* 0x3700 */
    KANJI,        /* 0x3701 */
    KANJI,        /* 0x3702 */
    KANJI,        /* 0x3703 */
    KANJI,        /* 0x3704 */
    KANJI,        /* 0x3705 */
    KANJI,        /* 0x3706 */
    KANJI,        /* 0x3707 */
    KANJI,        /* 0x3708 */
    KANJI,        /* 0x3709 */
    KANJI,        /* 0x370a */
    KANJI,        /* 0x370b */
    KANJI,        /* 0x370c */
    KANJI,        /* 0x370d */
    KANJI,        /* 0x370e */
    KANJI,        /* 0x370f */
    KANJI,        /* 0x3710 */
    KANJI,        /* 0x3711 */
    KANJI,        /* 0x3712 */
    KANJI,        /* 0x3713 */
    KANJI,        /* 0x3714 */
    KANJI,        /* 0x3715 */
    KANJI,        /* 0x3716 */
    KANJI,        /* 0x3717 */
    KANJI,        /* 0x3718 */
    KANJI,        /* 0x3719 */
    KANJI,        /* 0x371a */
    KANJI,        /* 0x371b */
    KANJI,        /* 0x371c */
    KANJI,        /* 0x371d */
    KANJI,        /* 0x371e */
    KANJI,        /* 0x371f */
    KANJI,        /* 0x3720 */
    KANJI,        /* 0x3721 */
    KANJI,        /* 0x3722 */
    KANJI,        /* 0x3723 */
    KANJI,        /* 0x3724 */
    KANJI,        /* 0x3725 */
    KANJI,        /* 0x3726 */
    KANJI,        /* 0x3727 */
    KANJI,        /* 0x3728 */
    KANJI,        /* 0x3729 */
    KANJI,        /* 0x372a */
    KANJI,        /* 0x372b */
    KANJI,        /* 0x372c */
    KANJI,        /* 0x372d */
    KANJI,        /* 0x372e */
    KANJI,        /* 0x372f */
    KANJI,        /* 0x3730 */
    KANJI,        /* 0x3731 */
    KANJI,        /* 0x3732 */
    KANJI,        /* 0x3733 */
    KANJI,        /* 0x3734 */
    KANJI,        /* 0x3735 */
    KANJI,        /* 0x3736 */
    KANJI,        /* 0x3737 */
    KANJI,        /* 0x3738 */
    KANJI,        /* 0x3739 */
    KANJI,        /* 0x373a */
    KANJI,        /* 0x373b */
    KANJI,        /* 0x373c */
    KANJI,        /* 0x373d */
    KANJI,        /* 0x373e */
    KANJI,        /* 0x373f */
    KANJI,        /* 0x3740 */
    KANJI,        /* 0x3741 */
    KANJI,        /* 0x3742 */
    KANJI,        /* 0x3743 */
    KANJI,        /* 0x3744 */
    KANJI,        /* 0x3745 */
    KANJI,        /* 0x3746 */
    KANJI,        /* 0x3747 */
    KANJI,        /* 0x3748 */
    KANJI,        /* 0x3749 */
    KANJI,        /* 0x374a */
    KANJI,        /* 0x374b */
    KANJI,        /* 0x374c */
    KANJI,        /* 0x374d */
    KANJI,        /* 0x374e */
    KANJI,        /* 0x374f */
    KANJI,        /* 0x3750 */
    KANJI,        /* 0x3751 */
    KANJI,        /* 0x3752 */
    KANJI,        /* 0x3753 */
    KANJI,        /* 0x3754 */
    KANJI,        /* 0x3755 */
    KANJI,        /* 0x3756 */
    KANJI,        /* 0x3757 */
    KANJI,        /* 0x3758 */
    KANJI,        /* 0x3759 */
    KANJI,        /* 0x375a */
    KANJI,        /* 0x375b */
    KANJI,        /* 0x375c */
    KANJI,        /* 0x375d */
    KANJI,        /* 0x375e */
    KANJI,        /* 0x375f */
    KANJI,        /* 0x3760 */
    KANJI,        /* 0x3761 */
    KANJI,        /* 0x3762 */
    KANJI,        /* 0x3763 */
    KANJI,        /* 0x3764 */
    KANJI,        /* 0x3765 */
    KANJI,        /* 0x3766 */
    KANJI,        /* 0x3767 */
    KANJI,        /* 0x3768 */
    KANJI,        /* 0x3769 */
    KANJI,        /* 0x376a */
    KANJI,        /* 0x376b */
    KANJI,        /* 0x376c */
    KANJI,        /* 0x376d */
    KANJI,        /* 0x376e */
    KANJI,        /* 0x376f */
    KANJI,        /* 0x3770 */
    KANJI,        /* 0x3771 */
    KANJI,        /* 0x3772 */
    KANJI,        /* 0x3773 */
    KANJI,        /* 0x3774 */
    KANJI,        /* 0x3775 */
    KANJI,        /* 0x3776 */
    KANJI,        /* 0x3777 */
    KANJI,        /* 0x3778 */
    KANJI,        /* 0x3779 */
    KANJI,        /* 0x377a */
    KANJI,        /* 0x377b */
    KANJI,        /* 0x377c */
    KANJI,        /* 0x377d */
    KANJI,        /* 0x377e */
    KANJI,        /* 0x377f */
    KANJI,        /* 0x3780 */
    KANJI,        /* 0x3781 */
    KANJI,        /* 0x3782 */
    KANJI,        /* 0x3783 */
    KANJI,        /* 0x3784 */
    KANJI,        /* 0x3785 */
    KANJI,        /* 0x3786 */
    KANJI,        /* 0x3787 */
    KANJI,        /* 0x3788 */
    KANJI,        /* 0x3789 */
    KANJI,        /* 0x378a */
    KANJI,        /* 0x378b */
    KANJI,        /* 0x378c */
    KANJI,        /* 0x378d */
    KANJI,        /* 0x378e */
    KANJI,        /* 0x378f */
    KANJI,        /* 0x3790 */
    KANJI,        /* 0x3791 */
    KANJI,        /* 0x3792 */
    KANJI,        /* 0x3793 */
    KANJI,        /* 0x3794 */
    KANJI,        /* 0x3795 */
    KANJI,        /* 0x3796 */
    KANJI,        /* 0x3797 */
    KANJI,        /* 0x3798 */
    KANJI,        /* 0x3799 */
    KANJI,        /* 0x379a */
    KANJI,        /* 0x379b */
    KANJI,        /* 0x379c */
    KANJI,        /* 0x379d */
    KANJI,        /* 0x379e */
    KANJI,        /* 0x379f */
    KANJI,        /* 0x37a0 */
    KANJI,        /* 0x37a1 */
    KANJI,        /* 0x37a2 */
    KANJI,        /* 0x37a3 */
    KANJI,        /* 0x37a4 */
    KANJI,        /* 0x37a5 */
    KANJI,        /* 0x37a6 */
    KANJI,        /* 0x37a7 */
    KANJI,        /* 0x37a8 */
    KANJI,        /* 0x37a9 */
    KANJI,        /* 0x37aa */
    KANJI,        /* 0x37ab */
    KANJI,        /* 0x37ac */
    KANJI,        /* 0x37ad */
    KANJI,        /* 0x37ae */
    KANJI,        /* 0x37af */
    KANJI,        /* 0x37b0 */
    KANJI,        /* 0x37b1 */
    KANJI,        /* 0x37b2 */
    KANJI,        /* 0x37b3 */
    KANJI,        /* 0x37b4 */
    KANJI,        /* 0x37b5 */
    KANJI,        /* 0x37b6 */
    KANJI,        /* 0x37b7 */
    KANJI,        /* 0x37b8 */
    KANJI,        /* 0x37b9 */
    KANJI,        /* 0x37ba */
    KANJI,        /* 0x37bb */
    KANJI,        /* 0x37bc */
    KANJI,        /* 0x37bd */
    KANJI,        /* 0x37be */
    KANJI,        /* 0x37bf */
    KANJI,        /* 0x37c0 */
    KANJI,        /* 0x37c1 */
    KANJI,        /* 0x37c2 */
    KANJI,        /* 0x37c3 */
    KANJI,        /* 0x37c4 */
    KANJI,        /* 0x37c5 */
    KANJI,        /* 0x37c6 */
    KANJI,        /* 0x37c7 */
    KANJI,        /* 0x37c8 */
    KANJI,        /* 0x37c9 */
    KANJI,        /* 0x37ca */
    KANJI,        /* 0x37cb */
    KANJI,        /* 0x37cc */
    KANJI,        /* 0x37cd */
    KANJI,        /* 0x37ce */
    KANJI,        /* 0x37cf */
    KANJI,        /* 0x37d0 */
    KANJI,        /* 0x37d1 */
    KANJI,        /* 0x37d2 */
    KANJI,        /* 0x37d3 */
    KANJI,        /* 0x37d4 */
    KANJI,        /* 0x37d5 */
    KANJI,        /* 0x37d6 */
    KANJI,        /* 0x37d7 */
    KANJI,        /* 0x37d8 */
    KANJI,        /* 0x37d9 */
    KANJI,        /* 0x37da */
    KANJI,        /* 0x37db */
    KANJI,        /* 0x37dc */
    KANJI,        /* 0x37dd */
    KANJI,        /* 0x37de */
    KANJI,        /* 0x37df */
    KANJI,        /* 0x37e0 */
    KANJI,        /* 0x37e1 */
    KANJI,        /* 0x37e2 */
    KANJI,        /* 0x37e3 */
    KANJI,        /* 0x37e4 */
    KANJI,        /* 0x37e5 */
    KANJI,        /* 0x37e6 */
    KANJI,        /* 0x37e7 */
    KANJI,        /* 0x37e8 */
    KANJI,        /* 0x37e9 */
    KANJI,        /* 0x37ea */
    KANJI,        /* 0x37eb */
    KANJI,        /* 0x37ec */
    KANJI,        /* 0x37ed */
    KANJI,        /* 0x37ee */
    KANJI,        /* 0x37ef */
    KANJI,        /* 0x37f0 */
    KANJI,        /* 0x37f1 */
    KANJI,        /* 0x37f2 */
    KANJI,        /* 0x37f3 */
    KANJI,        /* 0x37f4 */
    KANJI,        /* 0x37f5 */
    KANJI,        /* 0x37f6 */
    KANJI,        /* 0x37f7 */
    KANJI,        /* 0x37f8 */
    KANJI,        /* 0x37f9 */
    KANJI,        /* 0x37fa */
    KANJI,        /* 0x37fb */
    KANJI,        /* 0x37fc */
    KANJI,        /* 0x37fd */
    KANJI,        /* 0x37fe */
    KANJI,        /* 0x37ff */
    KANJI,        /* 0x3800 */
    KANJI,        /* 0x3801 */
    KANJI,        /* 0x3802 */
    KANJI,        /* 0x3803 */
    KANJI,        /* 0x3804 */
    KANJI,        /* 0x3805 */
    KANJI,        /* 0x3806 */
    KANJI,        /* 0x3807 */
    KANJI,        /* 0x3808 */
    KANJI,        /* 0x3809 */
    KANJI,        /* 0x380a */
    KANJI,        /* 0x380b */
    KANJI,        /* 0x380c */
    KANJI,        /* 0x380d */
    KANJI,        /* 0x380e */
    KANJI,        /* 0x380f */
    KANJI,        /* 0x3810 */
    KANJI,        /* 0x3811 */
    KANJI,        /* 0x3812 */
    KANJI,        /* 0x3813 */
    KANJI,        /* 0x3814 */
    KANJI,        /* 0x3815 */
    KANJI,        /* 0x3816 */
    KANJI,        /* 0x3817 */
    KANJI,        /* 0x3818 */
    KANJI,        /* 0x3819 */
    KANJI,        /* 0x381a */
    KANJI,        /* 0x381b */
    KANJI,        /* 0x381c */
    KANJI,        /* 0x381d */
    KANJI,        /* 0x381e */
    KANJI,        /* 0x381f */
    KANJI,        /* 0x3820 */
    KANJI,        /* 0x3821 */
    KANJI,        /* 0x3822 */
    KANJI,        /* 0x3823 */
    KANJI,        /* 0x3824 */
    KANJI,        /* 0x3825 */
    KANJI,        /* 0x3826 */
    KANJI,        /* 0x3827 */
    KANJI,        /* 0x3828 */
    KANJI,        /* 0x3829 */
    KANJI,        /* 0x382a */
    KANJI,        /* 0x382b */
    KANJI,        /* 0x382c */
    KANJI,        /* 0x382d */
    KANJI,        /* 0x382e */
    KANJI,        /* 0x382f */
    KANJI,        /* 0x3830 */
    KANJI,        /* 0x3831 */
    KANJI,        /* 0x3832 */
    KANJI,        /* 0x3833 */
    KANJI,        /* 0x3834 */
    KANJI,        /* 0x3835 */
    KANJI,        /* 0x3836 */
    KANJI,        /* 0x3837 */
    KANJI,        /* 0x3838 */
    KANJI,        /* 0x3839 */
    KANJI,        /* 0x383a */
    KANJI,        /* 0x383b */
    KANJI,        /* 0x383c */
    KANJI,        /* 0x383d */
    KANJI,        /* 0x383e */
    KANJI,        /* 0x383f */
    KANJI,        /* 0x3840 */
    KANJI,        /* 0x3841 */
    KANJI,        /* 0x3842 */
    KANJI,        /* 0x3843 */
    KANJI,        /* 0x3844 */
    KANJI,        /* 0x3845 */
    KANJI,        /* 0x3846 */
    KANJI,        /* 0x3847 */
    KANJI,        /* 0x3848 */
    KANJI,        /* 0x3849 */
    KANJI,        /* 0x384a */
    KANJI,        /* 0x384b */
    KANJI,        /* 0x384c */
    KANJI,        /* 0x384d */
    KANJI,        /* 0x384e */
    KANJI,        /* 0x384f */
    KANJI,        /* 0x3850 */
    KANJI,        /* 0x3851 */
    KANJI,        /* 0x3852 */
    KANJI,        /* 0x3853 */
    KANJI,        /* 0x3854 */
    KANJI,        /* 0x3855 */
    KANJI,        /* 0x3856 */
    KANJI,        /* 0x3857 */
    KANJI,        /* 0x3858 */
    KANJI,        /* 0x3859 */
    KANJI,        /* 0x385a */
    KANJI,        /* 0x385b */
    KANJI,        /* 0x385c */
    KANJI,        /* 0x385d */
    KANJI,        /* 0x385e */
    KANJI,        /* 0x385f */
    KANJI,        /* 0x3860 */
    KANJI,        /* 0x3861 */
    KANJI,        /* 0x3862 */
    KANJI,        /* 0x3863 */
    KANJI,        /* 0x3864 */
    KANJI,        /* 0x3865 */
    KANJI,        /* 0x3866 */
    KANJI,        /* 0x3867 */
    KANJI,        /* 0x3868 */
    KANJI,        /* 0x3869 */
    KANJI,        /* 0x386a */
    KANJI,        /* 0x386b */
    KANJI,        /* 0x386c */
    KANJI,        /* 0x386d */
    KANJI,        /* 0x386e */
    KANJI,        /* 0x386f */
    KANJI,        /* 0x3870 */
    KANJI,        /* 0x3871 */
    KANJI,        /* 0x3872 */
    KANJI,        /* 0x3873 */
    KANJI,        /* 0x3874 */
    KANJI,        /* 0x3875 */
    KANJI,        /* 0x3876 */
    KANJI,        /* 0x3877 */
    KANJI,        /* 0x3878 */
    KANJI,        /* 0x3879 */
    KANJI,        /* 0x387a */
    KANJI,        /* 0x387b */
    KANJI,        /* 0x387c */
    KANJI,        /* 0x387d */
    KANJI,        /* 0x387e */
    KANJI,        /* 0x387f */
    KANJI,        /* 0x3880 */
    KANJI,        /* 0x3881 */
    KANJI,        /* 0x3882 */
    KANJI,        /* 0x3883 */
    KANJI,        /* 0x3884 */
    KANJI,        /* 0x3885 */
    KANJI,        /* 0x3886 */
    KANJI,        /* 0x3887 */
    KANJI,        /* 0x3888 */
    KANJI,        /* 0x3889 */
    KANJI,        /* 0x388a */
    KANJI,        /* 0x388b */
    KANJI,        /* 0x388c */
    KANJI,        /* 0x388d */
    KANJI,        /* 0x388e */
    KANJI,        /* 0x388f */
    KANJI,        /* 0x3890 */
    KANJI,        /* 0x3891 */
    KANJI,        /* 0x3892 */
    KANJI,        /* 0x3893 */
    KANJI,        /* 0x3894 */
    KANJI,        /* 0x3895 */
    KANJI,        /* 0x3896 */
    KANJI,        /* 0x3897 */
    KANJI,        /* 0x3898 */
    KANJI,        /* 0x3899 */
    KANJI,        /* 0x389a */
    KANJI,        /* 0x389b */
    KANJI,        /* 0x389c */
    KANJI,        /* 0x389d */
    KANJI,        /* 0x389e */
    KANJI,        /* 0x389f */
    KANJI,        /* 0x38a0 */
    KANJI,        /* 0x38a1 */
    KANJI,        /* 0x38a2 */
    KANJI,        /* 0x38a3 */
    KANJI,        /* 0x38a4 */
    KANJI,        /* 0x38a5 */
    KANJI,        /* 0x38a6 */
    KANJI,        /* 0x38a7 */
    KANJI,        /* 0x38a8 */
    KANJI,        /* 0x38a9 */
    KANJI,        /* 0x38aa */
    KANJI,        /* 0x38ab */
    KANJI,        /* 0x38ac */
    KANJI,        /* 0x38ad */
    KANJI,        /* 0x38ae */
    KANJI,        /* 0x38af */
    KANJI,        /* 0x38b0 */
    KANJI,        /* 0x38b1 */
    KANJI,        /* 0x38b2 */
    KANJI,        /* 0x38b3 */
    KANJI,        /* 0x38b4 */
    KANJI,        /* 0x38b5 */
    KANJI,        /* 0x38b6 */
    KANJI,        /* 0x38b7 */
    KANJI,        /* 0x38b8 */
    KANJI,        /* 0x38b9 */
    KANJI,        /* 0x38ba */
    KANJI,        /* 0x38bb */
    KANJI,        /* 0x38bc */
    KANJI,        /* 0x38bd */
    KANJI,        /* 0x38be */
    KANJI,        /* 0x38bf */
    KANJI,        /* 0x38c0 */
    KANJI,        /* 0x38c1 */
    KANJI,        /* 0x38c2 */
    KANJI,        /* 0x38c3 */
    KANJI,        /* 0x38c4 */
    KANJI,        /* 0x38c5 */
    KANJI,        /* 0x38c6 */
    KANJI,        /* 0x38c7 */
    KANJI,        /* 0x38c8 */
    KANJI,        /* 0x38c9 */
    KANJI,        /* 0x38ca */
    KANJI,        /* 0x38cb */
    KANJI,        /* 0x38cc */
    KANJI,        /* 0x38cd */
    KANJI,        /* 0x38ce */
    KANJI,        /* 0x38cf */
    KANJI,        /* 0x38d0 */
    KANJI,        /* 0x38d1 */
    KANJI,        /* 0x38d2 */
    KANJI,        /* 0x38d3 */
    KANJI,        /* 0x38d4 */
    KANJI,        /* 0x38d5 */
    KANJI,        /* 0x38d6 */
    KANJI,        /* 0x38d7 */
    KANJI,        /* 0x38d8 */
    KANJI,        /* 0x38d9 */
    KANJI,        /* 0x38da */
    KANJI,        /* 0x38db */
    KANJI,        /* 0x38dc */
    KANJI,        /* 0x38dd */
    KANJI,        /* 0x38de */
    KANJI,        /* 0x38df */
    KANJI,        /* 0x38e0 */
    KANJI,        /* 0x38e1 */
    KANJI,        /* 0x38e2 */
    KANJI,        /* 0x38e3 */
    KANJI,        /* 0x38e4 */
    KANJI,        /* 0x38e5 */
    KANJI,        /* 0x38e6 */
    KANJI,        /* 0x38e7 */
    KANJI,        /* 0x38e8 */
    KANJI,        /* 0x38e9 */
    KANJI,        /* 0x38ea */
    KANJI,        /* 0x38eb */
    KANJI,        /* 0x38ec */
    KANJI,        /* 0x38ed */
    KANJI,        /* 0x38ee */
    KANJI,        /* 0x38ef */
    KANJI,        /* 0x38f0 */
    KANJI,        /* 0x38f1 */
    KANJI,        /* 0x38f2 */
    KANJI,        /* 0x38f3 */
    KANJI,        /* 0x38f4 */
    KANJI,        /* 0x38f5 */
    KANJI,        /* 0x38f6 */
    KANJI,        /* 0x38f7 */
    KANJI,        /* 0x38f8 */
    KANJI,        /* 0x38f9 */
    KANJI,        /* 0x38fa */
    KANJI,        /* 0x38fb */
    KANJI,        /* 0x38fc */
    KANJI,        /* 0x38fd */
    KANJI,        /* 0x38fe */
    KANJI,        /* 0x38ff */
    KANJI,        /* 0x3900 */
    KANJI,        /* 0x3901 */
    KANJI,        /* 0x3902 */
    KANJI,        /* 0x3903 */
    KANJI,        /* 0x3904 */
    KANJI,        /* 0x3905 */
    KANJI,        /* 0x3906 */
    KANJI,        /* 0x3907 */
    KANJI,        /* 0x3908 */
    KANJI,        /* 0x3909 */
    KANJI,        /* 0x390a */
    KANJI,        /* 0x390b */
    KANJI,        /* 0x390c */
    KANJI,        /* 0x390d */
    KANJI,        /* 0x390e */
    KANJI,        /* 0x390f */
    KANJI,        /* 0x3910 */
    KANJI,        /* 0x3911 */
    KANJI,        /* 0x3912 */
    KANJI,        /* 0x3913 */
    KANJI,        /* 0x3914 */
    KANJI,        /* 0x3915 */
    KANJI,        /* 0x3916 */
    KANJI,        /* 0x3917 */
    KANJI,        /* 0x3918 */
    KANJI,        /* 0x3919 */
    KANJI,        /* 0x391a */
    KANJI,        /* 0x391b */
    KANJI,        /* 0x391c */
    KANJI,        /* 0x391d */
    KANJI,        /* 0x391e */
    KANJI,        /* 0x391f */
    KANJI,        /* 0x3920 */
    KANJI,        /* 0x3921 */
    KANJI,        /* 0x3922 */
    KANJI,        /* 0x3923 */
    KANJI,        /* 0x3924 */
    KANJI,        /* 0x3925 */
    KANJI,        /* 0x3926 */
    KANJI,        /* 0x3927 */
    KANJI,        /* 0x3928 */
    KANJI,        /* 0x3929 */
    KANJI,        /* 0x392a */
    KANJI,        /* 0x392b */
    KANJI,        /* 0x392c */
    KANJI,        /* 0x392d */
    KANJI,        /* 0x392e */
    KANJI,        /* 0x392f */
    KANJI,        /* 0x3930 */
    KANJI,        /* 0x3931 */
    KANJI,        /* 0x3932 */
    KANJI,        /* 0x3933 */
    KANJI,        /* 0x3934 */
    KANJI,        /* 0x3935 */
    KANJI,        /* 0x3936 */
    KANJI,        /* 0x3937 */
    KANJI,        /* 0x3938 */
    KANJI,        /* 0x3939 */
    KANJI,        /* 0x393a */
    KANJI,        /* 0x393b */
    KANJI,        /* 0x393c */
    KANJI,        /* 0x393d */
    KANJI,        /* 0x393e */
    KANJI,        /* 0x393f */
    KANJI,        /* 0x3940 */
    KANJI,        /* 0x3941 */
    KANJI,        /* 0x3942 */
    KANJI,        /* 0x3943 */
    KANJI,        /* 0x3944 */
    KANJI,        /* 0x3945 */
    KANJI,        /* 0x3946 */
    KANJI,        /* 0x3947 */
    KANJI,        /* 0x3948 */
    KANJI,        /* 0x3949 */
    KANJI,        /* 0x394a */
    KANJI,        /* 0x394b */
    KANJI,        /* 0x394c */
    KANJI,        /* 0x394d */
    KANJI,        /* 0x394e */
    KANJI,        /* 0x394f */
    KANJI,        /* 0x3950 */
    KANJI,        /* 0x3951 */
    KANJI,        /* 0x3952 */
    KANJI,        /* 0x3953 */
    KANJI,        /* 0x3954 */
    KANJI,        /* 0x3955 */
    KANJI,        /* 0x3956 */
    KANJI,        /* 0x3957 */
    KANJI,        /* 0x3958 */
    KANJI,        /* 0x3959 */
    KANJI,        /* 0x395a */
    KANJI,        /* 0x395b */
    KANJI,        /* 0x395c */
    KANJI,        /* 0x395d */
    KANJI,        /* 0x395e */
    KANJI,        /* 0x395f */
    KANJI,        /* 0x3960 */
    KANJI,        /* 0x3961 */
    KANJI,        /* 0x3962 */
    KANJI,        /* 0x3963 */
    KANJI,        /* 0x3964 */
    KANJI,        /* 0x3965 */
    KANJI,        /* 0x3966 */
    KANJI,        /* 0x3967 */
    KANJI,        /* 0x3968 */
    KANJI,        /* 0x3969 */
    KANJI,        /* 0x396a */
    KANJI,        /* 0x396b */
    KANJI,        /* 0x396c */
    KANJI,        /* 0x396d */
    KANJI,        /* 0x396e */
    KANJI,        /* 0x396f */
    KANJI,        /* 0x3970 */
    KANJI,        /* 0x3971 */
    KANJI,        /* 0x3972 */
    KANJI,        /* 0x3973 */
    KANJI,        /* 0x3974 */
    KANJI,        /* 0x3975 */
    KANJI,        /* 0x3976 */
    KANJI,        /* 0x3977 */
    KANJI,        /* 0x3978 */
    KANJI,        /* 0x3979 */
    KANJI,        /* 0x397a */
    KANJI,        /* 0x397b */
    KANJI,        /* 0x397c */
    KANJI,        /* 0x397d */
    KANJI,        /* 0x397e */
    KANJI,        /* 0x397f */
    KANJI,        /* 0x3980 */
    KANJI,        /* 0x3981 */
    KANJI,        /* 0x3982 */
    KANJI,        /* 0x3983 */
    KANJI,        /* 0x3984 */
    KANJI,        /* 0x3985 */
    KANJI,        /* 0x3986 */
    KANJI,        /* 0x3987 */
    KANJI,        /* 0x3988 */
    KANJI,        /* 0x3989 */
    KANJI,        /* 0x398a */
    KANJI,        /* 0x398b */
    KANJI,        /* 0x398c */
    KANJI,        /* 0x398d */
    KANJI,        /* 0x398e */
    KANJI,        /* 0x398f */
    KANJI,        /* 0x3990 */
    KANJI,        /* 0x3991 */
    KANJI,        /* 0x3992 */
    KANJI,        /* 0x3993 */
    KANJI,        /* 0x3994 */
    KANJI,        /* 0x3995 */
    KANJI,        /* 0x3996 */
    KANJI,        /* 0x3997 */
    KANJI,        /* 0x3998 */
    KANJI,        /* 0x3999 */
    KANJI,        /* 0x399a */
    KANJI,        /* 0x399b */
    KANJI,        /* 0x399c */
    KANJI,        /* 0x399d */
    KANJI,        /* 0x399e */
    KANJI,        /* 0x399f */
    KANJI,        /* 0x39a0 */
    KANJI,        /* 0x39a1 */
    KANJI,        /* 0x39a2 */
    KANJI,        /* 0x39a3 */
    KANJI,        /* 0x39a4 */
    KANJI,        /* 0x39a5 */
    KANJI,        /* 0x39a6 */
    KANJI,        /* 0x39a7 */
    KANJI,        /* 0x39a8 */
    KANJI,        /* 0x39a9 */
    KANJI,        /* 0x39aa */
    KANJI,        /* 0x39ab */
    KANJI,        /* 0x39ac */
    KANJI,        /* 0x39ad */
    KANJI,        /* 0x39ae */
    KANJI,        /* 0x39af */
    KANJI,        /* 0x39b0 */
    KANJI,        /* 0x39b1 */
    KANJI,        /* 0x39b2 */
    KANJI,        /* 0x39b3 */
    KANJI,        /* 0x39b4 */
    KANJI,        /* 0x39b5 */
    KANJI,        /* 0x39b6 */
    KANJI,        /* 0x39b7 */
    KANJI,        /* 0x39b8 */
    KANJI,        /* 0x39b9 */
    KANJI,        /* 0x39ba */
    KANJI,        /* 0x39bb */
    KANJI,        /* 0x39bc */
    KANJI,        /* 0x39bd */
    KANJI,        /* 0x39be */
    KANJI,        /* 0x39bf */
    KANJI,        /* 0x39c0 */
    KANJI,        /* 0x39c1 */
    KANJI,        /* 0x39c2 */
    KANJI,        /* 0x39c3 */
    KANJI,        /* 0x39c4 */
    KANJI,        /* 0x39c5 */
    KANJI,        /* 0x39c6 */
    KANJI,        /* 0x39c7 */
    KANJI,        /* 0x39c8 */
    KANJI,        /* 0x39c9 */
    KANJI,        /* 0x39ca */
    KANJI,        /* 0x39cb */
    KANJI,        /* 0x39cc */
    KANJI,        /* 0x39cd */
    KANJI,        /* 0x39ce */
    KANJI,        /* 0x39cf */
    KANJI,        /* 0x39d0 */
    KANJI,        /* 0x39d1 */
    KANJI,        /* 0x39d2 */
    KANJI,        /* 0x39d3 */
    KANJI,        /* 0x39d4 */
    KANJI,        /* 0x39d5 */
    KANJI,        /* 0x39d6 */
    KANJI,        /* 0x39d7 */
    KANJI,        /* 0x39d8 */
    KANJI,        /* 0x39d9 */
    KANJI,        /* 0x39da */
    KANJI,        /* 0x39db */
    KANJI,        /* 0x39dc */
    KANJI,        /* 0x39dd */
    KANJI,        /* 0x39de */
    KANJI,        /* 0x39df */
    KANJI,        /* 0x39e0 */
    KANJI,        /* 0x39e1 */
    KANJI,        /* 0x39e2 */
    KANJI,        /* 0x39e3 */
    KANJI,        /* 0x39e4 */
    KANJI,        /* 0x39e5 */
    KANJI,        /* 0x39e6 */
    KANJI,        /* 0x39e7 */
    KANJI,        /* 0x39e8 */
    KANJI,        /* 0x39e9 */
    KANJI,        /* 0x39ea */
    KANJI,        /* 0x39eb */
    KANJI,        /* 0x39ec */
    KANJI,        /* 0x39ed */
    KANJI,        /* 0x39ee */
    KANJI,        /* 0x39ef */
    KANJI,        /* 0x39f0 */
    KANJI,        /* 0x39f1 */
    KANJI,        /* 0x39f2 */
    KANJI,        /* 0x39f3 */
    KANJI,        /* 0x39f4 */
    KANJI,        /* 0x39f5 */
    KANJI,        /* 0x39f6 */
    KANJI,        /* 0x39f7 */
    KANJI,        /* 0x39f8 */
    KANJI,        /* 0x39f9 */
    KANJI,        /* 0x39fa */
    KANJI,        /* 0x39fb */
    KANJI,        /* 0x39fc */
    KANJI,        /* 0x39fd */
    KANJI,        /* 0x39fe */
    KANJI,        /* 0x39ff */
    KANJI,        /* 0x3a00 */
    KANJI,        /* 0x3a01 */
    KANJI,        /* 0x3a02 */
    KANJI,        /* 0x3a03 */
    KANJI,        /* 0x3a04 */
    KANJI,        /* 0x3a05 */
    KANJI,        /* 0x3a06 */
    KANJI,        /* 0x3a07 */
    KANJI,        /* 0x3a08 */
    KANJI,        /* 0x3a09 */
    KANJI,        /* 0x3a0a */
    KANJI,        /* 0x3a0b */
    KANJI,        /* 0x3a0c */
    KANJI,        /* 0x3a0d */
    KANJI,        /* 0x3a0e */
    KANJI,        /* 0x3a0f */
    KANJI,        /* 0x3a10 */
    KANJI,        /* 0x3a11 */
    KANJI,        /* 0x3a12 */
    KANJI,        /* 0x3a13 */
    KANJI,        /* 0x3a14 */
    KANJI,        /* 0x3a15 */
    KANJI,        /* 0x3a16 */
    KANJI,        /* 0x3a17 */
    KANJI,        /* 0x3a18 */
    KANJI,        /* 0x3a19 */
    KANJI,        /* 0x3a1a */
    KANJI,        /* 0x3a1b */
    KANJI,        /* 0x3a1c */
    KANJI,        /* 0x3a1d */
    KANJI,        /* 0x3a1e */
    KANJI,        /* 0x3a1f */
    KANJI,        /* 0x3a20 */
    KANJI,        /* 0x3a21 */
    KANJI,        /* 0x3a22 */
    KANJI,        /* 0x3a23 */
    KANJI,        /* 0x3a24 */
    KANJI,        /* 0x3a25 */
    KANJI,        /* 0x3a26 */
    KANJI,        /* 0x3a27 */
    KANJI,        /* 0x3a28 */
    KANJI,        /* 0x3a29 */
    KANJI,        /* 0x3a2a */
    KANJI,        /* 0x3a2b */
    KANJI,        /* 0x3a2c */
    KANJI,        /* 0x3a2d */
    KANJI,        /* 0x3a2e */
    KANJI,        /* 0x3a2f */
    KANJI,        /* 0x3a30 */
    KANJI,        /* 0x3a31 */
    KANJI,        /* 0x3a32 */
    KANJI,        /* 0x3a33 */
    KANJI,        /* 0x3a34 */
    KANJI,        /* 0x3a35 */
    KANJI,        /* 0x3a36 */
    KANJI,        /* 0x3a37 */
    KANJI,        /* 0x3a38 */
    KANJI,        /* 0x3a39 */
    KANJI,        /* 0x3a3a */
    KANJI,        /* 0x3a3b */
    KANJI,        /* 0x3a3c */
    KANJI,        /* 0x3a3d */
    KANJI,        /* 0x3a3e */
    KANJI,        /* 0x3a3f */
    KANJI,        /* 0x3a40 */
    KANJI,        /* 0x3a41 */
    KANJI,        /* 0x3a42 */
    KANJI,        /* 0x3a43 */
    KANJI,        /* 0x3a44 */
    KANJI,        /* 0x3a45 */
    KANJI,        /* 0x3a46 */
    KANJI,        /* 0x3a47 */
    KANJI,        /* 0x3a48 */
    KANJI,        /* 0x3a49 */
    KANJI,        /* 0x3a4a */
    KANJI,        /* 0x3a4b */
    KANJI,        /* 0x3a4c */
    KANJI,        /* 0x3a4d */
    KANJI,        /* 0x3a4e */
    KANJI,        /* 0x3a4f */
    KANJI,        /* 0x3a50 */
    KANJI,        /* 0x3a51 */
    KANJI,        /* 0x3a52 */
    KANJI,        /* 0x3a53 */
    KANJI,        /* 0x3a54 */
    KANJI,        /* 0x3a55 */
    KANJI,        /* 0x3a56 */
    KANJI,        /* 0x3a57 */
    KANJI,        /* 0x3a58 */
    KANJI,        /* 0x3a59 */
    KANJI,        /* 0x3a5a */
    KANJI,        /* 0x3a5b */
    KANJI,        /* 0x3a5c */
    KANJI,        /* 0x3a5d */
    KANJI,        /* 0x3a5e */
    KANJI,        /* 0x3a5f */
    KANJI,        /* 0x3a60 */
    KANJI,        /* 0x3a61 */
    KANJI,        /* 0x3a62 */
    KANJI,        /* 0x3a63 */
    KANJI,        /* 0x3a64 */
    KANJI,        /* 0x3a65 */
    KANJI,        /* 0x3a66 */
    KANJI,        /* 0x3a67 */
    KANJI,        /* 0x3a68 */
    KANJI,        /* 0x3a69 */
    KANJI,        /* 0x3a6a */
    KANJI,        /* 0x3a6b */
    KANJI,        /* 0x3a6c */
    KANJI,        /* 0x3a6d */
    KANJI,        /* 0x3a6e */
    KANJI,        /* 0x3a6f */
    KANJI,        /* 0x3a70 */
    KANJI,        /* 0x3a71 */
    KANJI,        /* 0x3a72 */
    KANJI,        /* 0x3a73 */
    KANJI,        /* 0x3a74 */
    KANJI,        /* 0x3a75 */
    KANJI,        /* 0x3a76 */
    KANJI,        /* 0x3a77 */
    KANJI,        /* 0x3a78 */
    KANJI,        /* 0x3a79 */
    KANJI,        /* 0x3a7a */
    KANJI,        /* 0x3a7b */
    KANJI,        /* 0x3a7c */
    KANJI,        /* 0x3a7d */
    KANJI,        /* 0x3a7e */
    KANJI,        /* 0x3a7f */
    KANJI,        /* 0x3a80 */
    KANJI,        /* 0x3a81 */
    KANJI,        /* 0x3a82 */
    KANJI,        /* 0x3a83 */
    KANJI,        /* 0x3a84 */
    KANJI,        /* 0x3a85 */
    KANJI,        /* 0x3a86 */
    KANJI,        /* 0x3a87 */
    KANJI,        /* 0x3a88 */
    KANJI,        /* 0x3a89 */
    KANJI,        /* 0x3a8a */
    KANJI,        /* 0x3a8b */
    KANJI,        /* 0x3a8c */
    KANJI,        /* 0x3a8d */
    KANJI,        /* 0x3a8e */
    KANJI,        /* 0x3a8f */
    KANJI,        /* 0x3a90 */
    KANJI,        /* 0x3a91 */
    KANJI,        /* 0x3a92 */
    KANJI,        /* 0x3a93 */
    KANJI,        /* 0x3a94 */
    KANJI,        /* 0x3a95 */
    KANJI,        /* 0x3a96 */
    KANJI,        /* 0x3a97 */
    KANJI,        /* 0x3a98 */
    KANJI,        /* 0x3a99 */
    KANJI,        /* 0x3a9a */
    KANJI,        /* 0x3a9b */
    KANJI,        /* 0x3a9c */
    KANJI,        /* 0x3a9d */
    KANJI,        /* 0x3a9e */
    KANJI,        /* 0x3a9f */
    KANJI,        /* 0x3aa0 */
    KANJI,        /* 0x3aa1 */
    KANJI,        /* 0x3aa2 */
    KANJI,        /* 0x3aa3 */
    KANJI,        /* 0x3aa4 */
    KANJI,        /* 0x3aa5 */
    KANJI,        /* 0x3aa6 */
    KANJI,        /* 0x3aa7 */
    KANJI,        /* 0x3aa8 */
    KANJI,        /* 0x3aa9 */
    KANJI,        /* 0x3aaa */
    KANJI,        /* 0x3aab */
    KANJI,        /* 0x3aac */
    KANJI,        /* 0x3aad */
    KANJI,        /* 0x3aae */
    KANJI,        /* 0x3aaf */
    KANJI,        /* 0x3ab0 */
    KANJI,        /* 0x3ab1 */
    KANJI,        /* 0x3ab2 */
    KANJI,        /* 0x3ab3 */
    KANJI,        /* 0x3ab4 */
    KANJI,        /* 0x3ab5 */
    KANJI,        /* 0x3ab6 */
    KANJI,        /* 0x3ab7 */
    KANJI,        /* 0x3ab8 */
    KANJI,        /* 0x3ab9 */
    KANJI,        /* 0x3aba */
    KANJI,        /* 0x3abb */
    KANJI,        /* 0x3abc */
    KANJI,        /* 0x3abd */
    KANJI,        /* 0x3abe */
    KANJI,        /* 0x3abf */
    KANJI,        /* 0x3ac0 */
    KANJI,        /* 0x3ac1 */
    KANJI,        /* 0x3ac2 */
    KANJI,        /* 0x3ac3 */
    KANJI,        /* 0x3ac4 */
    KANJI,        /* 0x3ac5 */
    KANJI,        /* 0x3ac6 */
    KANJI,        /* 0x3ac7 */
    KANJI,        /* 0x3ac8 */
    KANJI,        /* 0x3ac9 */
    KANJI,        /* 0x3aca */
    KANJI,        /* 0x3acb */
    KANJI,        /* 0x3acc */
    KANJI,        /* 0x3acd */
    KANJI,        /* 0x3ace */
    KANJI,        /* 0x3acf */
    KANJI,        /* 0x3ad0 */
    KANJI,        /* 0x3ad1 */
    KANJI,        /* 0x3ad2 */
    KANJI,        /* 0x3ad3 */
    KANJI,        /* 0x3ad4 */
    KANJI,        /* 0x3ad5 */
    KANJI,        /* 0x3ad6 */
    KANJI,        /* 0x3ad7 */
    KANJI,        /* 0x3ad8 */
    KANJI,        /* 0x3ad9 */
    KANJI,        /* 0x3ada */
    KANJI,        /* 0x3adb */
    KANJI,        /* 0x3adc */
    KANJI,        /* 0x3add */
    KANJI,        /* 0x3ade */
    KANJI,        /* 0x3adf */
    KANJI,        /* 0x3ae0 */
    KANJI,        /* 0x3ae1 */
    KANJI,        /* 0x3ae2 */
    KANJI,        /* 0x3ae3 */
    KANJI,        /* 0x3ae4 */
    KANJI,        /* 0x3ae5 */
    KANJI,        /* 0x3ae6 */
    KANJI,        /* 0x3ae7 */
    KANJI,        /* 0x3ae8 */
    KANJI,        /* 0x3ae9 */
    KANJI,        /* 0x3aea */
    KANJI,        /* 0x3aeb */
    KANJI,        /* 0x3aec */
    KANJI,        /* 0x3aed */
    KANJI,        /* 0x3aee */
    KANJI,        /* 0x3aef */
    KANJI,        /* 0x3af0 */
    KANJI,        /* 0x3af1 */
    KANJI,        /* 0x3af2 */
    KANJI,        /* 0x3af3 */
    KANJI,        /* 0x3af4 */
    KANJI,        /* 0x3af5 */
    KANJI,        /* 0x3af6 */
    KANJI,        /* 0x3af7 */
    KANJI,        /* 0x3af8 */
    KANJI,        /* 0x3af9 */
    KANJI,        /* 0x3afa */
    KANJI,        /* 0x3afb */
    KANJI,        /* 0x3afc */
    KANJI,        /* 0x3afd */
    KANJI,        /* 0x3afe */
    KANJI,        /* 0x3aff */
    KANJI,        /* 0x3b00 */
    KANJI,        /* 0x3b01 */
    KANJI,        /* 0x3b02 */
    KANJI,        /* 0x3b03 */
    KANJI,        /* 0x3b04 */
    KANJI,        /* 0x3b05 */
    KANJI,        /* 0x3b06 */
    KANJI,        /* 0x3b07 */
    KANJI,        /* 0x3b08 */
    KANJI,        /* 0x3b09 */
    KANJI,        /* 0x3b0a */
    KANJI,        /* 0x3b0b */
    KANJI,        /* 0x3b0c */
    KANJI,        /* 0x3b0d */
    KANJI,        /* 0x3b0e */
    KANJI,        /* 0x3b0f */
    KANJI,        /* 0x3b10 */
    KANJI,        /* 0x3b11 */
    KANJI,        /* 0x3b12 */
    KANJI,        /* 0x3b13 */
    KANJI,        /* 0x3b14 */
    KANJI,        /* 0x3b15 */
    KANJI,        /* 0x3b16 */
    KANJI,        /* 0x3b17 */
    KANJI,        /* 0x3b18 */
    KANJI,        /* 0x3b19 */
    KANJI,        /* 0x3b1a */
    KANJI,        /* 0x3b1b */
    KANJI,        /* 0x3b1c */
    KANJI,        /* 0x3b1d */
    KANJI,        /* 0x3b1e */
    KANJI,        /* 0x3b1f */
    KANJI,        /* 0x3b20 */
    KANJI,        /* 0x3b21 */
    KANJI,        /* 0x3b22 */
    KANJI,        /* 0x3b23 */
    KANJI,        /* 0x3b24 */
    KANJI,        /* 0x3b25 */
    KANJI,        /* 0x3b26 */
    KANJI,        /* 0x3b27 */
    KANJI,        /* 0x3b28 */
    KANJI,        /* 0x3b29 */
    KANJI,        /* 0x3b2a */
    KANJI,        /* 0x3b2b */
    KANJI,        /* 0x3b2c */
    KANJI,        /* 0x3b2d */
    KANJI,        /* 0x3b2e */
    KANJI,        /* 0x3b2f */
    KANJI,        /* 0x3b30 */
    KANJI,        /* 0x3b31 */
    KANJI,        /* 0x3b32 */
    KANJI,        /* 0x3b33 */
    KANJI,        /* 0x3b34 */
    KANJI,        /* 0x3b35 */
    KANJI,        /* 0x3b36 */
    KANJI,        /* 0x3b37 */
    KANJI,        /* 0x3b38 */
    KANJI,        /* 0x3b39 */
    KANJI,        /* 0x3b3a */
    KANJI,        /* 0x3b3b */
    KANJI,        /* 0x3b3c */
    KANJI,        /* 0x3b3d */
    KANJI,        /* 0x3b3e */
    KANJI,        /* 0x3b3f */
    KANJI,        /* 0x3b40 */
    KANJI,        /* 0x3b41 */
    KANJI,        /* 0x3b42 */
    KANJI,        /* 0x3b43 */
    KANJI,        /* 0x3b44 */
    KANJI,        /* 0x3b45 */
    KANJI,        /* 0x3b46 */
    KANJI,        /* 0x3b47 */
    KANJI,        /* 0x3b48 */
    KANJI,        /* 0x3b49 */
    KANJI,        /* 0x3b4a */
    KANJI,        /* 0x3b4b */
    KANJI,        /* 0x3b4c */
    KANJI,        /* 0x3b4d */
    KANJI,        /* 0x3b4e */
    KANJI,        /* 0x3b4f */
    KANJI,        /* 0x3b50 */
    KANJI,        /* 0x3b51 */
    KANJI,        /* 0x3b52 */
    KANJI,        /* 0x3b53 */
    KANJI,        /* 0x3b54 */
    KANJI,        /* 0x3b55 */
    KANJI,        /* 0x3b56 */
    KANJI,        /* 0x3b57 */
    KANJI,        /* 0x3b58 */
    KANJI,        /* 0x3b59 */
    KANJI,        /* 0x3b5a */
    KANJI,        /* 0x3b5b */
    KANJI,        /* 0x3b5c */
    KANJI,        /* 0x3b5d */
    KANJI,        /* 0x3b5e */
    KANJI,        /* 0x3b5f */
    KANJI,        /* 0x3b60 */
    KANJI,        /* 0x3b61 */
    KANJI,        /* 0x3b62 */
    KANJI,        /* 0x3b63 */
    KANJI,        /* 0x3b64 */
    KANJI,        /* 0x3b65 */
    KANJI,        /* 0x3b66 */
    KANJI,        /* 0x3b67 */
    KANJI,        /* 0x3b68 */
    KANJI,        /* 0x3b69 */
    KANJI,        /* 0x3b6a */
    KANJI,        /* 0x3b6b */
    KANJI,        /* 0x3b6c */
    KANJI,        /* 0x3b6d */
    KANJI,        /* 0x3b6e */
    KANJI,        /* 0x3b6f */
    KANJI,        /* 0x3b70 */
    KANJI,        /* 0x3b71 */
    KANJI,        /* 0x3b72 */
    KANJI,        /* 0x3b73 */
    KANJI,        /* 0x3b74 */
    KANJI,        /* 0x3b75 */
    KANJI,        /* 0x3b76 */
    KANJI,        /* 0x3b77 */
    KANJI,        /* 0x3b78 */
    KANJI,        /* 0x3b79 */
    KANJI,        /* 0x3b7a */
    KANJI,        /* 0x3b7b */
    KANJI,        /* 0x3b7c */
    KANJI,        /* 0x3b7d */
    KANJI,        /* 0x3b7e */
    KANJI,        /* 0x3b7f */
    KANJI,        /* 0x3b80 */
    KANJI,        /* 0x3b81 */
    KANJI,        /* 0x3b82 */
    KANJI,        /* 0x3b83 */
    KANJI,        /* 0x3b84 */
    KANJI,        /* 0x3b85 */
    KANJI,        /* 0x3b86 */
    KANJI,        /* 0x3b87 */
    KANJI,        /* 0x3b88 */
    KANJI,        /* 0x3b89 */
    KANJI,        /* 0x3b8a */
    KANJI,        /* 0x3b8b */
    KANJI,        /* 0x3b8c */
    KANJI,        /* 0x3b8d */
    KANJI,        /* 0x3b8e */
    KANJI,        /* 0x3b8f */
    KANJI,        /* 0x3b90 */
    KANJI,        /* 0x3b91 */
    KANJI,        /* 0x3b92 */
    KANJI,        /* 0x3b93 */
    KANJI,        /* 0x3b94 */
    KANJI,        /* 0x3b95 */
    KANJI,        /* 0x3b96 */
    KANJI,        /* 0x3b97 */
    KANJI,        /* 0x3b98 */
    KANJI,        /* 0x3b99 */
    KANJI,        /* 0x3b9a */
    KANJI,        /* 0x3b9b */
    KANJI,        /* 0x3b9c */
    KANJI,        /* 0x3b9d */
    KANJI,        /* 0x3b9e */
    KANJI,        /* 0x3b9f */
    KANJI,        /* 0x3ba0 */
    KANJI,        /* 0x3ba1 */
    KANJI,        /* 0x3ba2 */
    KANJI,        /* 0x3ba3 */
    KANJI,        /* 0x3ba4 */
    KANJI,        /* 0x3ba5 */
    KANJI,        /* 0x3ba6 */
    KANJI,        /* 0x3ba7 */
    KANJI,        /* 0x3ba8 */
    KANJI,        /* 0x3ba9 */
    KANJI,        /* 0x3baa */
    KANJI,        /* 0x3bab */
    KANJI,        /* 0x3bac */
    KANJI,        /* 0x3bad */
    KANJI,        /* 0x3bae */
    KANJI,        /* 0x3baf */
    KANJI,        /* 0x3bb0 */
    KANJI,        /* 0x3bb1 */
    KANJI,        /* 0x3bb2 */
    KANJI,        /* 0x3bb3 */
    KANJI,        /* 0x3bb4 */
    KANJI,        /* 0x3bb5 */
    KANJI,        /* 0x3bb6 */
    KANJI,        /* 0x3bb7 */
    KANJI,        /* 0x3bb8 */
    KANJI,        /* 0x3bb9 */
    KANJI,        /* 0x3bba */
    KANJI,        /* 0x3bbb */
    KANJI,        /* 0x3bbc */
    KANJI,        /* 0x3bbd */
    KANJI,        /* 0x3bbe */
    KANJI,        /* 0x3bbf */
    KANJI,        /* 0x3bc0 */
    KANJI,        /* 0x3bc1 */
    KANJI,        /* 0x3bc2 */
    KANJI,        /* 0x3bc3 */
    KANJI,        /* 0x3bc4 */
    KANJI,        /* 0x3bc5 */
    KANJI,        /* 0x3bc6 */
    KANJI,        /* 0x3bc7 */
    KANJI,        /* 0x3bc8 */
    KANJI,        /* 0x3bc9 */
    KANJI,        /* 0x3bca */
    KANJI,        /* 0x3bcb */
    KANJI,        /* 0x3bcc */
    KANJI,        /* 0x3bcd */
    KANJI,        /* 0x3bce */
    KANJI,        /* 0x3bcf */
    KANJI,        /* 0x3bd0 */
    KANJI,        /* 0x3bd1 */
    KANJI,        /* 0x3bd2 */
    KANJI,        /* 0x3bd3 */
    KANJI,        /* 0x3bd4 */
    KANJI,        /* 0x3bd5 */
    KANJI,        /* 0x3bd6 */
    KANJI,        /* 0x3bd7 */
    KANJI,        /* 0x3bd8 */
    KANJI,        /* 0x3bd9 */
    KANJI,        /* 0x3bda */
    KANJI,        /* 0x3bdb */
    KANJI,        /* 0x3bdc */
    KANJI,        /* 0x3bdd */
    KANJI,        /* 0x3bde */
    KANJI,        /* 0x3bdf */
    KANJI,        /* 0x3be0 */
    KANJI,        /* 0x3be1 */
    KANJI,        /* 0x3be2 */
    KANJI,        /* 0x3be3 */
    KANJI,        /* 0x3be4 */
    KANJI,        /* 0x3be5 */
    KANJI,        /* 0x3be6 */
    KANJI,        /* 0x3be7 */
    KANJI,        /* 0x3be8 */
    KANJI,        /* 0x3be9 */
    KANJI,        /* 0x3bea */
    KANJI,        /* 0x3beb */
    KANJI,        /* 0x3bec */
    KANJI,        /* 0x3bed */
    KANJI,        /* 0x3bee */
    KANJI,        /* 0x3bef */
    KANJI,        /* 0x3bf0 */
    KANJI,        /* 0x3bf1 */
    KANJI,        /* 0x3bf2 */
    KANJI,        /* 0x3bf3 */
    KANJI,        /* 0x3bf4 */
    KANJI,        /* 0x3bf5 */
    KANJI,        /* 0x3bf6 */
    KANJI,        /* 0x3bf7 */
    KANJI,        /* 0x3bf8 */
    KANJI,        /* 0x3bf9 */
    KANJI,        /* 0x3bfa */
    KANJI,        /* 0x3bfb */
    KANJI,        /* 0x3bfc */
    KANJI,        /* 0x3bfd */
    KANJI,        /* 0x3bfe */
    KANJI,        /* 0x3bff */
    KANJI,        /* 0x3c00 */
    KANJI,        /* 0x3c01 */
    KANJI,        /* 0x3c02 */
    KANJI,        /* 0x3c03 */
    KANJI,        /* 0x3c04 */
    KANJI,        /* 0x3c05 */
    KANJI,        /* 0x3c06 */
    KANJI,        /* 0x3c07 */
    KANJI,        /* 0x3c08 */
    KANJI,        /* 0x3c09 */
    KANJI,        /* 0x3c0a */
    KANJI,        /* 0x3c0b */
    KANJI,        /* 0x3c0c */
    KANJI,        /* 0x3c0d */
    KANJI,        /* 0x3c0e */
    KANJI,        /* 0x3c0f */
    KANJI,        /* 0x3c10 */
    KANJI,        /* 0x3c11 */
    KANJI,        /* 0x3c12 */
    KANJI,        /* 0x3c13 */
    KANJI,        /* 0x3c14 */
    KANJI,        /* 0x3c15 */
    KANJI,        /* 0x3c16 */
    KANJI,        /* 0x3c17 */
    KANJI,        /* 0x3c18 */
    KANJI,        /* 0x3c19 */
    KANJI,        /* 0x3c1a */
    KANJI,        /* 0x3c1b */
    KANJI,        /* 0x3c1c */
    KANJI,        /* 0x3c1d */
    KANJI,        /* 0x3c1e */
    KANJI,        /* 0x3c1f */
    KANJI,        /* 0x3c20 */
    KANJI,        /* 0x3c21 */
    KANJI,        /* 0x3c22 */
    KANJI,        /* 0x3c23 */
    KANJI,        /* 0x3c24 */
    KANJI,        /* 0x3c25 */
    KANJI,        /* 0x3c26 */
    KANJI,        /* 0x3c27 */
    KANJI,        /* 0x3c28 */
    KANJI,        /* 0x3c29 */
    KANJI,        /* 0x3c2a */
    KANJI,        /* 0x3c2b */
    KANJI,        /* 0x3c2c */
    KANJI,        /* 0x3c2d */
    KANJI,        /* 0x3c2e */
    KANJI,        /* 0x3c2f */
    KANJI,        /* 0x3c30 */
    KANJI,        /* 0x3c31 */
    KANJI,        /* 0x3c32 */
    KANJI,        /* 0x3c33 */
    KANJI,        /* 0x3c34 */
    KANJI,        /* 0x3c35 */
    KANJI,        /* 0x3c36 */
    KANJI,        /* 0x3c37 */
    KANJI,        /* 0x3c38 */
    KANJI,        /* 0x3c39 */
    KANJI,        /* 0x3c3a */
    KANJI,        /* 0x3c3b */
    KANJI,        /* 0x3c3c */
    KANJI,        /* 0x3c3d */
    KANJI,        /* 0x3c3e */
    KANJI,        /* 0x3c3f */
    KANJI,        /* 0x3c40 */
    KANJI,        /* 0x3c41 */
    KANJI,        /* 0x3c42 */
    KANJI,        /* 0x3c43 */
    KANJI,        /* 0x3c44 */
    KANJI,        /* 0x3c45 */
    KANJI,        /* 0x3c46 */
    KANJI,        /* 0x3c47 */
    KANJI,        /* 0x3c48 */
    KANJI,        /* 0x3c49 */
    KANJI,        /* 0x3c4a */
    KANJI,        /* 0x3c4b */
    KANJI,        /* 0x3c4c */
    KANJI,        /* 0x3c4d */
    KANJI,        /* 0x3c4e */
    KANJI,        /* 0x3c4f */
    KANJI,        /* 0x3c50 */
    KANJI,        /* 0x3c51 */
    KANJI,        /* 0x3c52 */
    KANJI,        /* 0x3c53 */
    KANJI,        /* 0x3c54 */
    KANJI,        /* 0x3c55 */
    KANJI,        /* 0x3c56 */
    KANJI,        /* 0x3c57 */
    KANJI,        /* 0x3c58 */
    KANJI,        /* 0x3c59 */
    KANJI,        /* 0x3c5a */
    KANJI,        /* 0x3c5b */
    KANJI,        /* 0x3c5c */
    KANJI,        /* 0x3c5d */
    KANJI,        /* 0x3c5e */
    KANJI,        /* 0x3c5f */
    KANJI,        /* 0x3c60 */
    KANJI,        /* 0x3c61 */
    KANJI,        /* 0x3c62 */
    KANJI,        /* 0x3c63 */
    KANJI,        /* 0x3c64 */
    KANJI,        /* 0x3c65 */
    KANJI,        /* 0x3c66 */
    KANJI,        /* 0x3c67 */
    KANJI,        /* 0x3c68 */
    KANJI,        /* 0x3c69 */
    KANJI,        /* 0x3c6a */
    KANJI,        /* 0x3c6b */
    KANJI,        /* 0x3c6c */
    KANJI,        /* 0x3c6d */
    KANJI,        /* 0x3c6e */
    KANJI,        /* 0x3c6f */
    KANJI,        /* 0x3c70 */
    KANJI,        /* 0x3c71 */
    KANJI,        /* 0x3c72 */
    KANJI,        /* 0x3c73 */
    KANJI,        /* 0x3c74 */
    KANJI,        /* 0x3c75 */
    KANJI,        /* 0x3c76 */
    KANJI,        /* 0x3c77 */
    KANJI,        /* 0x3c78 */
    KANJI,        /* 0x3c79 */
    KANJI,        /* 0x3c7a */
    KANJI,        /* 0x3c7b */
    KANJI,        /* 0x3c7c */
    KANJI,        /* 0x3c7d */
    KANJI,        /* 0x3c7e */
    KANJI,        /* 0x3c7f */
    KANJI,        /* 0x3c80 */
    KANJI,        /* 0x3c81 */
    KANJI,        /* 0x3c82 */
    KANJI,        /* 0x3c83 */
    KANJI,        /* 0x3c84 */
    KANJI,        /* 0x3c85 */
    KANJI,        /* 0x3c86 */
    KANJI,        /* 0x3c87 */
    KANJI,        /* 0x3c88 */
    KANJI,        /* 0x3c89 */
    KANJI,        /* 0x3c8a */
    KANJI,        /* 0x3c8b */
    KANJI,        /* 0x3c8c */
    KANJI,        /* 0x3c8d */
    KANJI,        /* 0x3c8e */
    KANJI,        /* 0x3c8f */
    KANJI,        /* 0x3c90 */
    KANJI,        /* 0x3c91 */
    KANJI,        /* 0x3c92 */
    KANJI,        /* 0x3c93 */
    KANJI,        /* 0x3c94 */
    KANJI,        /* 0x3c95 */
    KANJI,        /* 0x3c96 */
    KANJI,        /* 0x3c97 */
    KANJI,        /* 0x3c98 */
    KANJI,        /* 0x3c99 */
    KANJI,        /* 0x3c9a */
    KANJI,        /* 0x3c9b */
    KANJI,        /* 0x3c9c */
    KANJI,        /* 0x3c9d */
    KANJI,        /* 0x3c9e */
    KANJI,        /* 0x3c9f */
    KANJI,        /* 0x3ca0 */
    KANJI,        /* 0x3ca1 */
    KANJI,        /* 0x3ca2 */
    KANJI,        /* 0x3ca3 */
    KANJI,        /* 0x3ca4 */
    KANJI,        /* 0x3ca5 */
    KANJI,        /* 0x3ca6 */
    KANJI,        /* 0x3ca7 */
    KANJI,        /* 0x3ca8 */
    KANJI,        /* 0x3ca9 */
    KANJI,        /* 0x3caa */
    KANJI,        /* 0x3cab */
    KANJI,        /* 0x3cac */
    KANJI,        /* 0x3cad */
    KANJI,        /* 0x3cae */
    KANJI,        /* 0x3caf */
    KANJI,        /* 0x3cb0 */
    KANJI,        /* 0x3cb1 */
    KANJI,        /* 0x3cb2 */
    KANJI,        /* 0x3cb3 */
    KANJI,        /* 0x3cb4 */
    KANJI,        /* 0x3cb5 */
    KANJI,        /* 0x3cb6 */
    KANJI,        /* 0x3cb7 */
    KANJI,        /* 0x3cb8 */
    KANJI,        /* 0x3cb9 */
    KANJI,        /* 0x3cba */
    KANJI,        /* 0x3cbb */
    KANJI,        /* 0x3cbc */
    KANJI,        /* 0x3cbd */
    KANJI,        /* 0x3cbe */
    KANJI,        /* 0x3cbf */
    KANJI,        /* 0x3cc0 */
    KANJI,        /* 0x3cc1 */
    KANJI,        /* 0x3cc2 */
    KANJI,        /* 0x3cc3 */
    KANJI,        /* 0x3cc4 */
    KANJI,        /* 0x3cc5 */
    KANJI,        /* 0x3cc6 */
    KANJI,        /* 0x3cc7 */
    KANJI,        /* 0x3cc8 */
    KANJI,        /* 0x3cc9 */
    KANJI,        /* 0x3cca */
    KANJI,        /* 0x3ccb */
    KANJI,        /* 0x3ccc */
    KANJI,        /* 0x3ccd */
    KANJI,        /* 0x3cce */
    KANJI,        /* 0x3ccf */
    KANJI,        /* 0x3cd0 */
    KANJI,        /* 0x3cd1 */
    KANJI,        /* 0x3cd2 */
    KANJI,        /* 0x3cd3 */
    KANJI,        /* 0x3cd4 */
    KANJI,        /* 0x3cd5 */
    KANJI,        /* 0x3cd6 */
    KANJI,        /* 0x3cd7 */
    KANJI,        /* 0x3cd8 */
    KANJI,        /* 0x3cd9 */
    KANJI,        /* 0x3cda */
    KANJI,        /* 0x3cdb */
    KANJI,        /* 0x3cdc */
    KANJI,        /* 0x3cdd */
    KANJI,        /* 0x3cde */
    KANJI,        /* 0x3cdf */
    KANJI,        /* 0x3ce0 */
    KANJI,        /* 0x3ce1 */
    KANJI,        /* 0x3ce2 */
    KANJI,        /* 0x3ce3 */
    KANJI,        /* 0x3ce4 */
    KANJI,        /* 0x3ce5 */
    KANJI,        /* 0x3ce6 */
    KANJI,        /* 0x3ce7 */
    KANJI,        /* 0x3ce8 */
    KANJI,        /* 0x3ce9 */
    KANJI,        /* 0x3cea */
    KANJI,        /* 0x3ceb */
    KANJI,        /* 0x3cec */
    KANJI,        /* 0x3ced */
    KANJI,        /* 0x3cee */
    KANJI,        /* 0x3cef */
    KANJI,        /* 0x3cf0 */
    KANJI,        /* 0x3cf1 */
    KANJI,        /* 0x3cf2 */
    KANJI,        /* 0x3cf3 */
    KANJI,        /* 0x3cf4 */
    KANJI,        /* 0x3cf5 */
    KANJI,        /* 0x3cf6 */
    KANJI,        /* 0x3cf7 */
    KANJI,        /* 0x3cf8 */
    KANJI,        /* 0x3cf9 */
    KANJI,        /* 0x3cfa */
    KANJI,        /* 0x3cfb */
    KANJI,        /* 0x3cfc */
    KANJI,        /* 0x3cfd */
    KANJI,        /* 0x3cfe */
    KANJI,        /* 0x3cff */
    KANJI,        /* 0x3d00 */
    KANJI,        /* 0x3d01 */
    KANJI,        /* 0x3d02 */
    KANJI,        /* 0x3d03 */
    KANJI,        /* 0x3d04 */
    KANJI,        /* 0x3d05 */
    KANJI,        /* 0x3d06 */
    KANJI,        /* 0x3d07 */
    KANJI,        /* 0x3d08 */
    KANJI,        /* 0x3d09 */
    KANJI,        /* 0x3d0a */
    KANJI,        /* 0x3d0b */
    KANJI,        /* 0x3d0c */
    KANJI,        /* 0x3d0d */
    KANJI,        /* 0x3d0e */
    KANJI,        /* 0x3d0f */
    KANJI,        /* 0x3d10 */
    KANJI,        /* 0x3d11 */
    KANJI,        /* 0x3d12 */
    KANJI,        /* 0x3d13 */
    KANJI,        /* 0x3d14 */
    KANJI,        /* 0x3d15 */
    KANJI,        /* 0x3d16 */
    KANJI,        /* 0x3d17 */
    KANJI,        /* 0x3d18 */
    KANJI,        /* 0x3d19 */
    KANJI,        /* 0x3d1a */
    KANJI,        /* 0x3d1b */
    KANJI,        /* 0x3d1c */
    KANJI,        /* 0x3d1d */
    KANJI,        /* 0x3d1e */
    KANJI,        /* 0x3d1f */
    KANJI,        /* 0x3d20 */
    KANJI,        /* 0x3d21 */
    KANJI,        /* 0x3d22 */
    KANJI,        /* 0x3d23 */
    KANJI,        /* 0x3d24 */
    KANJI,        /* 0x3d25 */
    KANJI,        /* 0x3d26 */
    KANJI,        /* 0x3d27 */
    KANJI,        /* 0x3d28 */
    KANJI,        /* 0x3d29 */
    KANJI,        /* 0x3d2a */
    KANJI,        /* 0x3d2b */
    KANJI,        /* 0x3d2c */
    KANJI,        /* 0x3d2d */
    KANJI,        /* 0x3d2e */
    KANJI,        /* 0x3d2f */
    KANJI,        /* 0x3d30 */
    KANJI,        /* 0x3d31 */
    KANJI,        /* 0x3d32 */
    KANJI,        /* 0x3d33 */
    KANJI,        /* 0x3d34 */
    KANJI,        /* 0x3d35 */
    KANJI,        /* 0x3d36 */
    KANJI,        /* 0x3d37 */
    KANJI,        /* 0x3d38 */
    KANJI,        /* 0x3d39 */
    KANJI,        /* 0x3d3a */
    KANJI,        /* 0x3d3b */
    KANJI,        /* 0x3d3c */
    KANJI,        /* 0x3d3d */
    KANJI,        /* 0x3d3e */
    KANJI,        /* 0x3d3f */
    KANJI,        /* 0x3d40 */
    KANJI,        /* 0x3d41 */
    KANJI,        /* 0x3d42 */
    KANJI,        /* 0x3d43 */
    KANJI,        /* 0x3d44 */
    KANJI,        /* 0x3d45 */
    KANJI,        /* 0x3d46 */
    KANJI,        /* 0x3d47 */
    KANJI,        /* 0x3d48 */
    KANJI,        /* 0x3d49 */
    KANJI,        /* 0x3d4a */
    KANJI,        /* 0x3d4b */
    KANJI,        /* 0x3d4c */
    KANJI,        /* 0x3d4d */
    KANJI,        /* 0x3d4e */
    KANJI,        /* 0x3d4f */
    KANJI,        /* 0x3d50 */
    KANJI,        /* 0x3d51 */
    KANJI,        /* 0x3d52 */
    KANJI,        /* 0x3d53 */
    KANJI,        /* 0x3d54 */
    KANJI,        /* 0x3d55 */
    KANJI,        /* 0x3d56 */
    KANJI,        /* 0x3d57 */
    KANJI,        /* 0x3d58 */
    KANJI,        /* 0x3d59 */
    KANJI,        /* 0x3d5a */
    KANJI,        /* 0x3d5b */
    KANJI,        /* 0x3d5c */
    KANJI,        /* 0x3d5d */
    KANJI,        /* 0x3d5e */
    KANJI,        /* 0x3d5f */
    KANJI,        /* 0x3d60 */
    KANJI,        /* 0x3d61 */
    KANJI,        /* 0x3d62 */
    KANJI,        /* 0x3d63 */
    KANJI,        /* 0x3d64 */
    KANJI,        /* 0x3d65 */
    KANJI,        /* 0x3d66 */
    KANJI,        /* 0x3d67 */
    KANJI,        /* 0x3d68 */
    KANJI,        /* 0x3d69 */
    KANJI,        /* 0x3d6a */
    KANJI,        /* 0x3d6b */
    KANJI,        /* 0x3d6c */
    KANJI,        /* 0x3d6d */
    KANJI,        /* 0x3d6e */
    KANJI,        /* 0x3d6f */
    KANJI,        /* 0x3d70 */
    KANJI,        /* 0x3d71 */
    KANJI,        /* 0x3d72 */
    KANJI,        /* 0x3d73 */
    KANJI,        /* 0x3d74 */
    KANJI,        /* 0x3d75 */
    KANJI,        /* 0x3d76 */
    KANJI,        /* 0x3d77 */
    KANJI,        /* 0x3d78 */
    KANJI,        /* 0x3d79 */
    KANJI,        /* 0x3d7a */
    KANJI,        /* 0x3d7b */
    KANJI,        /* 0x3d7c */
    KANJI,        /* 0x3d7d */
    KANJI,        /* 0x3d7e */
    KANJI,        /* 0x3d7f */
    KANJI,        /* 0x3d80 */
    KANJI,        /* 0x3d81 */
    KANJI,        /* 0x3d82 */
    KANJI,        /* 0x3d83 */
    KANJI,        /* 0x3d84 */
    KANJI,        /* 0x3d85 */
    KANJI,        /* 0x3d86 */
    KANJI,        /* 0x3d87 */
    KANJI,        /* 0x3d88 */
    KANJI,        /* 0x3d89 */
    KANJI,        /* 0x3d8a */
    KANJI,        /* 0x3d8b */
    KANJI,        /* 0x3d8c */
    KANJI,        /* 0x3d8d */
    KANJI,        /* 0x3d8e */
    KANJI,        /* 0x3d8f */
    KANJI,        /* 0x3d90 */
    KANJI,        /* 0x3d91 */
    KANJI,        /* 0x3d92 */
    KANJI,        /* 0x3d93 */
    KANJI,        /* 0x3d94 */
    KANJI,        /* 0x3d95 */
    KANJI,        /* 0x3d96 */
    KANJI,        /* 0x3d97 */
    KANJI,        /* 0x3d98 */
    KANJI,        /* 0x3d99 */
    KANJI,        /* 0x3d9a */
    KANJI,        /* 0x3d9b */
    KANJI,        /* 0x3d9c */
    KANJI,        /* 0x3d9d */
    KANJI,        /* 0x3d9e */
    KANJI,        /* 0x3d9f */
    KANJI,        /* 0x3da0 */
    KANJI,        /* 0x3da1 */
    KANJI,        /* 0x3da2 */
    KANJI,        /* 0x3da3 */
    KANJI,        /* 0x3da4 */
    KANJI,        /* 0x3da5 */
    KANJI,        /* 0x3da6 */
    KANJI,        /* 0x3da7 */
    KANJI,        /* 0x3da8 */
    KANJI,        /* 0x3da9 */
    KANJI,        /* 0x3daa */
    KANJI,        /* 0x3dab */
    KANJI,        /* 0x3dac */
    KANJI,        /* 0x3dad */
    KANJI,        /* 0x3dae */
    KANJI,        /* 0x3daf */
    KANJI,        /* 0x3db0 */
    KANJI,        /* 0x3db1 */
    KANJI,        /* 0x3db2 */
    KANJI,        /* 0x3db3 */
    KANJI,        /* 0x3db4 */
    KANJI,        /* 0x3db5 */
    KANJI,        /* 0x3db6 */
    KANJI,        /* 0x3db7 */
    KANJI,        /* 0x3db8 */
    KANJI,        /* 0x3db9 */
    KANJI,        /* 0x3dba */
    KANJI,        /* 0x3dbb */
    KANJI,        /* 0x3dbc */
    KANJI,        /* 0x3dbd */
    KANJI,        /* 0x3dbe */
    KANJI,        /* 0x3dbf */
    KANJI,        /* 0x3dc0 */
    KANJI,        /* 0x3dc1 */
    KANJI,        /* 0x3dc2 */
    KANJI,        /* 0x3dc3 */
    KANJI,        /* 0x3dc4 */
    KANJI,        /* 0x3dc5 */
    KANJI,        /* 0x3dc6 */
    KANJI,        /* 0x3dc7 */
    KANJI,        /* 0x3dc8 */
    KANJI,        /* 0x3dc9 */
    KANJI,        /* 0x3dca */
    KANJI,        /* 0x3dcb */
    KANJI,        /* 0x3dcc */
    KANJI,        /* 0x3dcd */
    KANJI,        /* 0x3dce */
    KANJI,        /* 0x3dcf */
    KANJI,        /* 0x3dd0 */
    KANJI,        /* 0x3dd1 */
    KANJI,        /* 0x3dd2 */
    KANJI,        /* 0x3dd3 */
    KANJI,        /* 0x3dd4 */
    KANJI,        /* 0x3dd5 */
    KANJI,        /* 0x3dd6 */
    KANJI,        /* 0x3dd7 */
    KANJI,        /* 0x3dd8 */
    KANJI,        /* 0x3dd9 */
    KANJI,        /* 0x3dda */
    KANJI,        /* 0x3ddb */
    KANJI,        /* 0x3ddc */
    KANJI,        /* 0x3ddd */
    KANJI,        /* 0x3dde */
    KANJI,        /* 0x3ddf */
    KANJI,        /* 0x3de0 */
    KANJI,        /* 0x3de1 */
    KANJI,        /* 0x3de2 */
    KANJI,        /* 0x3de3 */
    KANJI,        /* 0x3de4 */
    KANJI,        /* 0x3de5 */
    KANJI,        /* 0x3de6 */
    KANJI,        /* 0x3de7 */
    KANJI,        /* 0x3de8 */
    KANJI,        /* 0x3de9 */
    KANJI,        /* 0x3dea */
    KANJI,        /* 0x3deb */
    KANJI,        /* 0x3dec */
    KANJI,        /* 0x3ded */
    KANJI,        /* 0x3dee */
    KANJI,        /* 0x3def */
    KANJI,        /* 0x3df0 */
    KANJI,        /* 0x3df1 */
    KANJI,        /* 0x3df2 */
    KANJI,        /* 0x3df3 */
    KANJI,        /* 0x3df4 */
    KANJI,        /* 0x3df5 */
    KANJI,        /* 0x3df6 */
    KANJI,        /* 0x3df7 */
    KANJI,        /* 0x3df8 */
    KANJI,        /* 0x3df9 */
    KANJI,        /* 0x3dfa */
    KANJI,        /* 0x3dfb */
    KANJI,        /* 0x3dfc */
    KANJI,        /* 0x3dfd */
    KANJI,        /* 0x3dfe */
    KANJI,        /* 0x3dff */
    KANJI,        /* 0x3e00 */
    KANJI,        /* 0x3e01 */
    KANJI,        /* 0x3e02 */
    KANJI,        /* 0x3e03 */
    KANJI,        /* 0x3e04 */
    KANJI,        /* 0x3e05 */
    KANJI,        /* 0x3e06 */
    KANJI,        /* 0x3e07 */
    KANJI,        /* 0x3e08 */
    KANJI,        /* 0x3e09 */
    KANJI,        /* 0x3e0a */
    KANJI,        /* 0x3e0b */
    KANJI,        /* 0x3e0c */
    KANJI,        /* 0x3e0d */
    KANJI,        /* 0x3e0e */
    KANJI,        /* 0x3e0f */
    KANJI,        /* 0x3e10 */
    KANJI,        /* 0x3e11 */
    KANJI,        /* 0x3e12 */
    KANJI,        /* 0x3e13 */
    KANJI,        /* 0x3e14 */
    KANJI,        /* 0x3e15 */
    KANJI,        /* 0x3e16 */
    KANJI,        /* 0x3e17 */
    KANJI,        /* 0x3e18 */
    KANJI,        /* 0x3e19 */
    KANJI,        /* 0x3e1a */
    KANJI,        /* 0x3e1b */
    KANJI,        /* 0x3e1c */
    KANJI,        /* 0x3e1d */
    KANJI,        /* 0x3e1e */
    KANJI,        /* 0x3e1f */
    KANJI,        /* 0x3e20 */
    KANJI,        /* 0x3e21 */
    KANJI,        /* 0x3e22 */
    KANJI,        /* 0x3e23 */
    KANJI,        /* 0x3e24 */
    KANJI,        /* 0x3e25 */
    KANJI,        /* 0x3e26 */
    KANJI,        /* 0x3e27 */
    KANJI,        /* 0x3e28 */
    KANJI,        /* 0x3e29 */
    KANJI,        /* 0x3e2a */
    KANJI,        /* 0x3e2b */
    KANJI,        /* 0x3e2c */
    KANJI,        /* 0x3e2d */
    KANJI,        /* 0x3e2e */
    KANJI,        /* 0x3e2f */
    KANJI,        /* 0x3e30 */
    KANJI,        /* 0x3e31 */
    KANJI,        /* 0x3e32 */
    KANJI,        /* 0x3e33 */
    KANJI,        /* 0x3e34 */
    KANJI,        /* 0x3e35 */
    KANJI,        /* 0x3e36 */
    KANJI,        /* 0x3e37 */
    KANJI,        /* 0x3e38 */
    KANJI,        /* 0x3e39 */
    KANJI,        /* 0x3e3a */
    KANJI,        /* 0x3e3b */
    KANJI,        /* 0x3e3c */
    KANJI,        /* 0x3e3d */
    KANJI,        /* 0x3e3e */
    KANJI,        /* 0x3e3f */
    KANJI,        /* 0x3e40 */
    KANJI,        /* 0x3e41 */
    KANJI,        /* 0x3e42 */
    KANJI,        /* 0x3e43 */
    KANJI,        /* 0x3e44 */
    KANJI,        /* 0x3e45 */
    KANJI,        /* 0x3e46 */
    KANJI,        /* 0x3e47 */
    KANJI,        /* 0x3e48 */
    KANJI,        /* 0x3e49 */
    KANJI,        /* 0x3e4a */
    KANJI,        /* 0x3e4b */
    KANJI,        /* 0x3e4c */
    KANJI,        /* 0x3e4d */
    KANJI,        /* 0x3e4e */
    KANJI,        /* 0x3e4f */
    KANJI,        /* 0x3e50 */
    KANJI,        /* 0x3e51 */
    KANJI,        /* 0x3e52 */
    KANJI,        /* 0x3e53 */
    KANJI,        /* 0x3e54 */
    KANJI,        /* 0x3e55 */
    KANJI,        /* 0x3e56 */
    KANJI,        /* 0x3e57 */
    KANJI,        /* 0x3e58 */
    KANJI,        /* 0x3e59 */
    KANJI,        /* 0x3e5a */
    KANJI,        /* 0x3e5b */
    KANJI,        /* 0x3e5c */
    KANJI,        /* 0x3e5d */
    KANJI,        /* 0x3e5e */
    KANJI,        /* 0x3e5f */
    KANJI,        /* 0x3e60 */
    KANJI,        /* 0x3e61 */
    KANJI,        /* 0x3e62 */
    KANJI,        /* 0x3e63 */
    KANJI,        /* 0x3e64 */
    KANJI,        /* 0x3e65 */
    KANJI,        /* 0x3e66 */
    KANJI,        /* 0x3e67 */
    KANJI,        /* 0x3e68 */
    KANJI,        /* 0x3e69 */
    KANJI,        /* 0x3e6a */
    KANJI,        /* 0x3e6b */
    KANJI,        /* 0x3e6c */
    KANJI,        /* 0x3e6d */
    KANJI,        /* 0x3e6e */
    KANJI,        /* 0x3e6f */
    KANJI,        /* 0x3e70 */
    KANJI,        /* 0x3e71 */
    KANJI,        /* 0x3e72 */
    KANJI,        /* 0x3e73 */
    KANJI,        /* 0x3e74 */
    KANJI,        /* 0x3e75 */
    KANJI,        /* 0x3e76 */
    KANJI,        /* 0x3e77 */
    KANJI,        /* 0x3e78 */
    KANJI,        /* 0x3e79 */
    KANJI,        /* 0x3e7a */
    KANJI,        /* 0x3e7b */
    KANJI,        /* 0x3e7c */
    KANJI,        /* 0x3e7d */
    KANJI,        /* 0x3e7e */
    KANJI,        /* 0x3e7f */
    KANJI,        /* 0x3e80 */
    KANJI,        /* 0x3e81 */
    KANJI,        /* 0x3e82 */
    KANJI,        /* 0x3e83 */
    KANJI,        /* 0x3e84 */
    KANJI,        /* 0x3e85 */
    KANJI,        /* 0x3e86 */
    KANJI,        /* 0x3e87 */
    KANJI,        /* 0x3e88 */
    KANJI,        /* 0x3e89 */
    KANJI,        /* 0x3e8a */
    KANJI,        /* 0x3e8b */
    KANJI,        /* 0x3e8c */
    KANJI,        /* 0x3e8d */
    KANJI,        /* 0x3e8e */
    KANJI,        /* 0x3e8f */
    KANJI,        /* 0x3e90 */
    KANJI,        /* 0x3e91 */
    KANJI,        /* 0x3e92 */
    KANJI,        /* 0x3e93 */
    KANJI,        /* 0x3e94 */
    KANJI,        /* 0x3e95 */
    KANJI,        /* 0x3e96 */
    KANJI,        /* 0x3e97 */
    KANJI,        /* 0x3e98 */
    KANJI,        /* 0x3e99 */
    KANJI,        /* 0x3e9a */
    KANJI,        /* 0x3e9b */
    KANJI,        /* 0x3e9c */
    KANJI,        /* 0x3e9d */
    KANJI,        /* 0x3e9e */
    KANJI,        /* 0x3e9f */
    KANJI,        /* 0x3ea0 */
    KANJI,        /* 0x3ea1 */
    KANJI,        /* 0x3ea2 */
    KANJI,        /* 0x3ea3 */
    KANJI,        /* 0x3ea4 */
    KANJI,        /* 0x3ea5 */
    KANJI,        /* 0x3ea6 */
    KANJI,        /* 0x3ea7 */
    KANJI,        /* 0x3ea8 */
    KANJI,        /* 0x3ea9 */
    KANJI,        /* 0x3eaa */
    KANJI,        /* 0x3eab */
    KANJI,        /* 0x3eac */
    KANJI,        /* 0x3ead */
    KANJI,        /* 0x3eae */
    KANJI,        /* 0x3eaf */
    KANJI,        /* 0x3eb0 */
    KANJI,        /* 0x3eb1 */
    KANJI,        /* 0x3eb2 */
    KANJI,        /* 0x3eb3 */
    KANJI,        /* 0x3eb4 */
    KANJI,        /* 0x3eb5 */
    KANJI,        /* 0x3eb6 */
    KANJI,        /* 0x3eb7 */
    KANJI,        /* 0x3eb8 */
    KANJI,        /* 0x3eb9 */
    KANJI,        /* 0x3eba */
    KANJI,        /* 0x3ebb */
    KANJI,        /* 0x3ebc */
    KANJI,        /* 0x3ebd */
    KANJI,        /* 0x3ebe */
    KANJI,        /* 0x3ebf */
    KANJI,        /* 0x3ec0 */
    KANJI,        /* 0x3ec1 */
    KANJI,        /* 0x3ec2 */
    KANJI,        /* 0x3ec3 */
    KANJI,        /* 0x3ec4 */
    KANJI,        /* 0x3ec5 */
    KANJI,        /* 0x3ec6 */
    KANJI,        /* 0x3ec7 */
    KANJI,        /* 0x3ec8 */
    KANJI,        /* 0x3ec9 */
    KANJI,        /* 0x3eca */
    KANJI,        /* 0x3ecb */
    KANJI,        /* 0x3ecc */
    KANJI,        /* 0x3ecd */
    KANJI,        /* 0x3ece */
    KANJI,        /* 0x3ecf */
    KANJI,        /* 0x3ed0 */
    KANJI,        /* 0x3ed1 */
    KANJI,        /* 0x3ed2 */
    KANJI,        /* 0x3ed3 */
    KANJI,        /* 0x3ed4 */
    KANJI,        /* 0x3ed5 */
    KANJI,        /* 0x3ed6 */
    KANJI,        /* 0x3ed7 */
    KANJI,        /* 0x3ed8 */
    KANJI,        /* 0x3ed9 */
    KANJI,        /* 0x3eda */
    KANJI,        /* 0x3edb */
    KANJI,        /* 0x3edc */
    KANJI,        /* 0x3edd */
    KANJI,        /* 0x3ede */
    KANJI,        /* 0x3edf */
    KANJI,        /* 0x3ee0 */
    KANJI,        /* 0x3ee1 */
    KANJI,        /* 0x3ee2 */
    KANJI,        /* 0x3ee3 */
    KANJI,        /* 0x3ee4 */
    KANJI,        /* 0x3ee5 */
    KANJI,        /* 0x3ee6 */
    KANJI,        /* 0x3ee7 */
    KANJI,        /* 0x3ee8 */
    KANJI,        /* 0x3ee9 */
    KANJI,        /* 0x3eea */
    KANJI,        /* 0x3eeb */
    KANJI,        /* 0x3eec */
    KANJI,        /* 0x3eed */
    KANJI,        /* 0x3eee */
    KANJI,        /* 0x3eef */
    KANJI,        /* 0x3ef0 */
    KANJI,        /* 0x3ef1 */
    KANJI,        /* 0x3ef2 */
    KANJI,        /* 0x3ef3 */
    KANJI,        /* 0x3ef4 */
    KANJI,        /* 0x3ef5 */
    KANJI,        /* 0x3ef6 */
    KANJI,        /* 0x3ef7 */
    KANJI,        /* 0x3ef8 */
    KANJI,        /* 0x3ef9 */
    KANJI,        /* 0x3efa */
    KANJI,        /* 0x3efb */
    KANJI,        /* 0x3efc */
    KANJI,        /* 0x3efd */
    KANJI,        /* 0x3efe */
    KANJI,        /* 0x3eff */
    KANJI,        /* 0x3f00 */
    KANJI,        /* 0x3f01 */
    KANJI,        /* 0x3f02 */
    KANJI,        /* 0x3f03 */
    KANJI,        /* 0x3f04 */
    KANJI,        /* 0x3f05 */
    KANJI,        /* 0x3f06 */
    KANJI,        /* 0x3f07 */
    KANJI,        /* 0x3f08 */
    KANJI,        /* 0x3f09 */
    KANJI,        /* 0x3f0a */
    KANJI,        /* 0x3f0b */
    KANJI,        /* 0x3f0c */
    KANJI,        /* 0x3f0d */
    KANJI,        /* 0x3f0e */
    KANJI,        /* 0x3f0f */
    KANJI,        /* 0x3f10 */
    KANJI,        /* 0x3f11 */
    KANJI,        /* 0x3f12 */
    KANJI,        /* 0x3f13 */
    KANJI,        /* 0x3f14 */
    KANJI,        /* 0x3f15 */
    KANJI,        /* 0x3f16 */
    KANJI,        /* 0x3f17 */
    KANJI,        /* 0x3f18 */
    KANJI,        /* 0x3f19 */
    KANJI,        /* 0x3f1a */
    KANJI,        /* 0x3f1b */
    KANJI,        /* 0x3f1c */
    KANJI,        /* 0x3f1d */
    KANJI,        /* 0x3f1e */
    KANJI,        /* 0x3f1f */
    KANJI,        /* 0x3f20 */
    KANJI,        /* 0x3f21 */
    KANJI,        /* 0x3f22 */
    KANJI,        /* 0x3f23 */
    KANJI,        /* 0x3f24 */
    KANJI,        /* 0x3f25 */
    KANJI,        /* 0x3f26 */
    KANJI,        /* 0x3f27 */
    KANJI,        /* 0x3f28 */
    KANJI,        /* 0x3f29 */
    KANJI,        /* 0x3f2a */
    KANJI,        /* 0x3f2b */
    KANJI,        /* 0x3f2c */
    KANJI,        /* 0x3f2d */
    KANJI,        /* 0x3f2e */
    KANJI,        /* 0x3f2f */
    KANJI,        /* 0x3f30 */
    KANJI,        /* 0x3f31 */
    KANJI,        /* 0x3f32 */
    KANJI,        /* 0x3f33 */
    KANJI,        /* 0x3f34 */
    KANJI,        /* 0x3f35 */
    KANJI,        /* 0x3f36 */
    KANJI,        /* 0x3f37 */
    KANJI,        /* 0x3f38 */
    KANJI,        /* 0x3f39 */
    KANJI,        /* 0x3f3a */
    KANJI,        /* 0x3f3b */
    KANJI,        /* 0x3f3c */
    KANJI,        /* 0x3f3d */
    KANJI,        /* 0x3f3e */
    KANJI,        /* 0x3f3f */
    KANJI,        /* 0x3f40 */
    KANJI,        /* 0x3f41 */
    KANJI,        /* 0x3f42 */
    KANJI,        /* 0x3f43 */
    KANJI,        /* 0x3f44 */
    KANJI,        /* 0x3f45 */
    KANJI,        /* 0x3f46 */
    KANJI,        /* 0x3f47 */
    KANJI,        /* 0x3f48 */
    KANJI,        /* 0x3f49 */
    KANJI,        /* 0x3f4a */
    KANJI,        /* 0x3f4b */
    KANJI,        /* 0x3f4c */
    KANJI,        /* 0x3f4d */
    KANJI,        /* 0x3f4e */
    KANJI,        /* 0x3f4f */
    KANJI,        /* 0x3f50 */
    KANJI,        /* 0x3f51 */
    KANJI,        /* 0x3f52 */
    KANJI,        /* 0x3f53 */
    KANJI,        /* 0x3f54 */
    KANJI,        /* 0x3f55 */
    KANJI,        /* 0x3f56 */
    KANJI,        /* 0x3f57 */
    KANJI,        /* 0x3f58 */
    KANJI,        /* 0x3f59 */
    KANJI,        /* 0x3f5a */
    KANJI,        /* 0x3f5b */
    KANJI,        /* 0x3f5c */
    KANJI,        /* 0x3f5d */
    KANJI,        /* 0x3f5e */
    KANJI,        /* 0x3f5f */
    KANJI,        /* 0x3f60 */
    KANJI,        /* 0x3f61 */
    KANJI,        /* 0x3f62 */
    KANJI,        /* 0x3f63 */
    KANJI,        /* 0x3f64 */
    KANJI,        /* 0x3f65 */
    KANJI,        /* 0x3f66 */
    KANJI,        /* 0x3f67 */
    KANJI,        /* 0x3f68 */
    KANJI,        /* 0x3f69 */
    KANJI,        /* 0x3f6a */
    KANJI,        /* 0x3f6b */
    KANJI,        /* 0x3f6c */
    KANJI,        /* 0x3f6d */
    KANJI,        /* 0x3f6e */
    KANJI,        /* 0x3f6f */
    KANJI,        /* 0x3f70 */
    KANJI,        /* 0x3f71 */
    KANJI,        /* 0x3f72 */
    KANJI,        /* 0x3f73 */
    KANJI,        /* 0x3f74 */
    KANJI,        /* 0x3f75 */
    KANJI,        /* 0x3f76 */
    KANJI,        /* 0x3f77 */
    KANJI,        /* 0x3f78 */
    KANJI,        /* 0x3f79 */
    KANJI,        /* 0x3f7a */
    KANJI,        /* 0x3f7b */
    KANJI,        /* 0x3f7c */
    KANJI,        /* 0x3f7d */
    KANJI,        /* 0x3f7e */
    KANJI,        /* 0x3f7f */
    KANJI,        /* 0x3f80 */
    KANJI,        /* 0x3f81 */
    KANJI,        /* 0x3f82 */
    KANJI,        /* 0x3f83 */
    KANJI,        /* 0x3f84 */
    KANJI,        /* 0x3f85 */
    KANJI,        /* 0x3f86 */
    KANJI,        /* 0x3f87 */
    KANJI,        /* 0x3f88 */
    KANJI,        /* 0x3f89 */
    KANJI,        /* 0x3f8a */
    KANJI,        /* 0x3f8b */
    KANJI,        /* 0x3f8c */
    KANJI,        /* 0x3f8d */
    KANJI,        /* 0x3f8e */
    KANJI,        /* 0x3f8f */
    KANJI,        /* 0x3f90 */
    KANJI,        /* 0x3f91 */
    KANJI,        /* 0x3f92 */
    KANJI,        /* 0x3f93 */
    KANJI,        /* 0x3f94 */
    KANJI,        /* 0x3f95 */
    KANJI,        /* 0x3f96 */
    KANJI,        /* 0x3f97 */
    KANJI,        /* 0x3f98 */
    KANJI,        /* 0x3f99 */
    KANJI,        /* 0x3f9a */
    KANJI,        /* 0x3f9b */
    KANJI,        /* 0x3f9c */
    KANJI,        /* 0x3f9d */
    KANJI,        /* 0x3f9e */
    KANJI,        /* 0x3f9f */
    KANJI,        /* 0x3fa0 */
    KANJI,        /* 0x3fa1 */
    KANJI,        /* 0x3fa2 */
    KANJI,        /* 0x3fa3 */
    KANJI,        /* 0x3fa4 */
    KANJI,        /* 0x3fa5 */
    KANJI,        /* 0x3fa6 */
    KANJI,        /* 0x3fa7 */
    KANJI,        /* 0x3fa8 */
    KANJI,        /* 0x3fa9 */
    KANJI,        /* 0x3faa */
    KANJI,        /* 0x3fab */
    KANJI,        /* 0x3fac */
    KANJI,        /* 0x3fad */
    KANJI,        /* 0x3fae */
    KANJI,        /* 0x3faf */
    KANJI,        /* 0x3fb0 */
    KANJI,        /* 0x3fb1 */
    KANJI,        /* 0x3fb2 */
    KANJI,        /* 0x3fb3 */
    KANJI,        /* 0x3fb4 */
    KANJI,        /* 0x3fb5 */
    KANJI,        /* 0x3fb6 */
    KANJI,        /* 0x3fb7 */
    KANJI,        /* 0x3fb8 */
    KANJI,        /* 0x3fb9 */
    KANJI,        /* 0x3fba */
    KANJI,        /* 0x3fbb */
    KANJI,        /* 0x3fbc */
    KANJI,        /* 0x3fbd */
    KANJI,        /* 0x3fbe */
    KANJI,        /* 0x3fbf */
    KANJI,        /* 0x3fc0 */
    KANJI,        /* 0x3fc1 */
    KANJI,        /* 0x3fc2 */
    KANJI,        /* 0x3fc3 */
    KANJI,        /* 0x3fc4 */
    KANJI,        /* 0x3fc5 */
    KANJI,        /* 0x3fc6 */
    KANJI,        /* 0x3fc7 */
    KANJI,        /* 0x3fc8 */
    KANJI,        /* 0x3fc9 */
    KANJI,        /* 0x3fca */
    KANJI,        /* 0x3fcb */
    KANJI,        /* 0x3fcc */
    KANJI,        /* 0x3fcd */
    KANJI,        /* 0x3fce */
    KANJI,        /* 0x3fcf */
    KANJI,        /* 0x3fd0 */
    KANJI,        /* 0x3fd1 */
    KANJI,        /* 0x3fd2 */
    KANJI,        /* 0x3fd3 */
    KANJI,        /* 0x3fd4 */
    KANJI,        /* 0x3fd5 */
    KANJI,        /* 0x3fd6 */
    KANJI,        /* 0x3fd7 */
    KANJI,        /* 0x3fd8 */
    KANJI,        /* 0x3fd9 */
    KANJI,        /* 0x3fda */
    KANJI,        /* 0x3fdb */
    KANJI,        /* 0x3fdc */
    KANJI,        /* 0x3fdd */
    KANJI,        /* 0x3fde */
    KANJI,        /* 0x3fdf */
    KANJI,        /* 0x3fe0 */
    KANJI,        /* 0x3fe1 */
    KANJI,        /* 0x3fe2 */
    KANJI,        /* 0x3fe3 */
    KANJI,        /* 0x3fe4 */
    KANJI,        /* 0x3fe5 */
    KANJI,        /* 0x3fe6 */
    KANJI,        /* 0x3fe7 */
    KANJI,        /* 0x3fe8 */
    KANJI,        /* 0x3fe9 */
    KANJI,        /* 0x3fea */
    KANJI,        /* 0x3feb */
    KANJI,        /* 0x3fec */
    KANJI,        /* 0x3fed */
    KANJI,        /* 0x3fee */
    KANJI,        /* 0x3fef */
    KANJI,        /* 0x3ff0 */
    KANJI,        /* 0x3ff1 */
    KANJI,        /* 0x3ff2 */
    KANJI,        /* 0x3ff3 */
    KANJI,        /* 0x3ff4 */
    KANJI,        /* 0x3ff5 */
    KANJI,        /* 0x3ff6 */
    KANJI,        /* 0x3ff7 */
    KANJI,        /* 0x3ff8 */
    KANJI,        /* 0x3ff9 */
    KANJI,        /* 0x3ffa */
    KANJI,        /* 0x3ffb */
    KANJI,        /* 0x3ffc */
    KANJI,        /* 0x3ffd */
    KANJI,        /* 0x3ffe */
    KANJI,        /* 0x3fff */
    KANJI,        /* 0x4000 */
    KANJI,        /* 0x4001 */
    KANJI,        /* 0x4002 */
    KANJI,        /* 0x4003 */
    KANJI,        /* 0x4004 */
    KANJI,        /* 0x4005 */
    KANJI,        /* 0x4006 */
    KANJI,        /* 0x4007 */
    KANJI,        /* 0x4008 */
    KANJI,        /* 0x4009 */
    KANJI,        /* 0x400a */
    KANJI,        /* 0x400b */
    KANJI,        /* 0x400c */
    KANJI,        /* 0x400d */
    KANJI,        /* 0x400e */
    KANJI,        /* 0x400f */
    KANJI,        /* 0x4010 */
    KANJI,        /* 0x4011 */
    KANJI,        /* 0x4012 */
    KANJI,        /* 0x4013 */
    KANJI,        /* 0x4014 */
    KANJI,        /* 0x4015 */
    KANJI,        /* 0x4016 */
    KANJI,        /* 0x4017 */
    KANJI,        /* 0x4018 */
    KANJI,        /* 0x4019 */
    KANJI,        /* 0x401a */
    KANJI,        /* 0x401b */
    KANJI,        /* 0x401c */
    KANJI,        /* 0x401d */
    KANJI,        /* 0x401e */
    KANJI,        /* 0x401f */
    KANJI,        /* 0x4020 */
    KANJI,        /* 0x4021 */
    KANJI,        /* 0x4022 */
    KANJI,        /* 0x4023 */
    KANJI,        /* 0x4024 */
    KANJI,        /* 0x4025 */
    KANJI,        /* 0x4026 */
    KANJI,        /* 0x4027 */
    KANJI,        /* 0x4028 */
    KANJI,        /* 0x4029 */
    KANJI,        /* 0x402a */
    KANJI,        /* 0x402b */
    KANJI,        /* 0x402c */
    KANJI,        /* 0x402d */
    KANJI,        /* 0x402e */
    KANJI,        /* 0x402f */
    KANJI,        /* 0x4030 */
    KANJI,        /* 0x4031 */
    KANJI,        /* 0x4032 */
    KANJI,        /* 0x4033 */
    KANJI,        /* 0x4034 */
    KANJI,        /* 0x4035 */
    KANJI,        /* 0x4036 */
    KANJI,        /* 0x4037 */
    KANJI,        /* 0x4038 */
    KANJI,        /* 0x4039 */
    KANJI,        /* 0x403a */
    KANJI,        /* 0x403b */
    KANJI,        /* 0x403c */
    KANJI,        /* 0x403d */
    KANJI,        /* 0x403e */
    KANJI,        /* 0x403f */
    KANJI,        /* 0x4040 */
    KANJI,        /* 0x4041 */
    KANJI,        /* 0x4042 */
    KANJI,        /* 0x4043 */
    KANJI,        /* 0x4044 */
    KANJI,        /* 0x4045 */
    KANJI,        /* 0x4046 */
    KANJI,        /* 0x4047 */
    KANJI,        /* 0x4048 */
    KANJI,        /* 0x4049 */
    KANJI,        /* 0x404a */
    KANJI,        /* 0x404b */
    KANJI,        /* 0x404c */
    KANJI,        /* 0x404d */
    KANJI,        /* 0x404e */
    KANJI,        /* 0x404f */
    KANJI,        /* 0x4050 */
    KANJI,        /* 0x4051 */
    KANJI,        /* 0x4052 */
    KANJI,        /* 0x4053 */
    KANJI,        /* 0x4054 */
    KANJI,        /* 0x4055 */
    KANJI,        /* 0x4056 */
    KANJI,        /* 0x4057 */
    KANJI,        /* 0x4058 */
    KANJI,        /* 0x4059 */
    KANJI,        /* 0x405a */
    KANJI,        /* 0x405b */
    KANJI,        /* 0x405c */
    KANJI,        /* 0x405d */
    KANJI,        /* 0x405e */
    KANJI,        /* 0x405f */
    KANJI,        /* 0x4060 */
    KANJI,        /* 0x4061 */
    KANJI,        /* 0x4062 */
    KANJI,        /* 0x4063 */
    KANJI,        /* 0x4064 */
    KANJI,        /* 0x4065 */
    KANJI,        /* 0x4066 */
    KANJI,        /* 0x4067 */
    KANJI,        /* 0x4068 */
    KANJI,        /* 0x4069 */
    KANJI,        /* 0x406a */
    KANJI,        /* 0x406b */
    KANJI,        /* 0x406c */
    KANJI,        /* 0x406d */
    KANJI,        /* 0x406e */
    KANJI,        /* 0x406f */
    KANJI,        /* 0x4070 */
    KANJI,        /* 0x4071 */
    KANJI,        /* 0x4072 */
    KANJI,        /* 0x4073 */
    KANJI,        /* 0x4074 */
    KANJI,        /* 0x4075 */
    KANJI,        /* 0x4076 */
    KANJI,        /* 0x4077 */
    KANJI,        /* 0x4078 */
    KANJI,        /* 0x4079 */
    KANJI,        /* 0x407a */
    KANJI,        /* 0x407b */
    KANJI,        /* 0x407c */
    KANJI,        /* 0x407d */
    KANJI,        /* 0x407e */
    KANJI,        /* 0x407f */
    KANJI,        /* 0x4080 */
    KANJI,        /* 0x4081 */
    KANJI,        /* 0x4082 */
    KANJI,        /* 0x4083 */
    KANJI,        /* 0x4084 */
    KANJI,        /* 0x4085 */
    KANJI,        /* 0x4086 */
    KANJI,        /* 0x4087 */
    KANJI,        /* 0x4088 */
    KANJI,        /* 0x4089 */
    KANJI,        /* 0x408a */
    KANJI,        /* 0x408b */
    KANJI,        /* 0x408c */
    KANJI,        /* 0x408d */
    KANJI,        /* 0x408e */
    KANJI,        /* 0x408f */
    KANJI,        /* 0x4090 */
    KANJI,        /* 0x4091 */
    KANJI,        /* 0x4092 */
    KANJI,        /* 0x4093 */
    KANJI,        /* 0x4094 */
    KANJI,        /* 0x4095 */
    KANJI,        /* 0x4096 */
    KANJI,        /* 0x4097 */
    KANJI,        /* 0x4098 */
    KANJI,        /* 0x4099 */
    KANJI,        /* 0x409a */
    KANJI,        /* 0x409b */
    KANJI,        /* 0x409c */
    KANJI,        /* 0x409d */
    KANJI,        /* 0x409e */
    KANJI,        /* 0x409f */
    KANJI,        /* 0x40a0 */
    KANJI,        /* 0x40a1 */
    KANJI,        /* 0x40a2 */
    KANJI,        /* 0x40a3 */
    KANJI,        /* 0x40a4 */
    KANJI,        /* 0x40a5 */
    KANJI,        /* 0x40a6 */
    KANJI,        /* 0x40a7 */
    KANJI,        /* 0x40a8 */
    KANJI,        /* 0x40a9 */
    KANJI,        /* 0x40aa */
    KANJI,        /* 0x40ab */
    KANJI,        /* 0x40ac */
    KANJI,        /* 0x40ad */
    KANJI,        /* 0x40ae */
    KANJI,        /* 0x40af */
    KANJI,        /* 0x40b0 */
    KANJI,        /* 0x40b1 */
    KANJI,        /* 0x40b2 */
    KANJI,        /* 0x40b3 */
    KANJI,        /* 0x40b4 */
    KANJI,        /* 0x40b5 */
    KANJI,        /* 0x40b6 */
    KANJI,        /* 0x40b7 */
    KANJI,        /* 0x40b8 */
    KANJI,        /* 0x40b9 */
    KANJI,        /* 0x40ba */
    KANJI,        /* 0x40bb */
    KANJI,        /* 0x40bc */
    KANJI,        /* 0x40bd */
    KANJI,        /* 0x40be */
    KANJI,        /* 0x40bf */
    KANJI,        /* 0x40c0 */
    KANJI,        /* 0x40c1 */
    KANJI,        /* 0x40c2 */
    KANJI,        /* 0x40c3 */
    KANJI,        /* 0x40c4 */
    KANJI,        /* 0x40c5 */
    KANJI,        /* 0x40c6 */
    KANJI,        /* 0x40c7 */
    KANJI,        /* 0x40c8 */
    KANJI,        /* 0x40c9 */
    KANJI,        /* 0x40ca */
    KANJI,        /* 0x40cb */
    KANJI,        /* 0x40cc */
    KANJI,        /* 0x40cd */
    KANJI,        /* 0x40ce */
    KANJI,        /* 0x40cf */
    KANJI,        /* 0x40d0 */
    KANJI,        /* 0x40d1 */
    KANJI,        /* 0x40d2 */
    KANJI,        /* 0x40d3 */
    KANJI,        /* 0x40d4 */
    KANJI,        /* 0x40d5 */
    KANJI,        /* 0x40d6 */
    KANJI,        /* 0x40d7 */
    KANJI,        /* 0x40d8 */
    KANJI,        /* 0x40d9 */
    KANJI,        /* 0x40da */
    KANJI,        /* 0x40db */
    KANJI,        /* 0x40dc */
    KANJI,        /* 0x40dd */
    KANJI,        /* 0x40de */
    KANJI,        /* 0x40df */
    KANJI,        /* 0x40e0 */
    KANJI,        /* 0x40e1 */
    KANJI,        /* 0x40e2 */
    KANJI,        /* 0x40e3 */
    KANJI,        /* 0x40e4 */
    KANJI,        /* 0x40e5 */
    KANJI,        /* 0x40e6 */
    KANJI,        /* 0x40e7 */
    KANJI,        /* 0x40e8 */
    KANJI,        /* 0x40e9 */
    KANJI,        /* 0x40ea */
    KANJI,        /* 0x40eb */
    KANJI,        /* 0x40ec */
    KANJI,        /* 0x40ed */
    KANJI,        /* 0x40ee */
    KANJI,        /* 0x40ef */
    KANJI,        /* 0x40f0 */
    KANJI,        /* 0x40f1 */
    KANJI,        /* 0x40f2 */
    KANJI,        /* 0x40f3 */
    KANJI,        /* 0x40f4 */
    KANJI,        /* 0x40f5 */
    KANJI,        /* 0x40f6 */
    KANJI,        /* 0x40f7 */
    KANJI,        /* 0x40f8 */
    KANJI,        /* 0x40f9 */
    KANJI,        /* 0x40fa */
    KANJI,        /* 0x40fb */
    KANJI,        /* 0x40fc */
    KANJI,        /* 0x40fd */
    KANJI,        /* 0x40fe */
    KANJI,        /* 0x40ff */
    KANJI,        /* 0x4100 */
    KANJI,        /* 0x4101 */
    KANJI,        /* 0x4102 */
    KANJI,        /* 0x4103 */
    KANJI,        /* 0x4104 */
    KANJI,        /* 0x4105 */
    KANJI,        /* 0x4106 */
    KANJI,        /* 0x4107 */
    KANJI,        /* 0x4108 */
    KANJI,        /* 0x4109 */
    KANJI,        /* 0x410a */
    KANJI,        /* 0x410b */
    KANJI,        /* 0x410c */
    KANJI,        /* 0x410d */
    KANJI,        /* 0x410e */
    KANJI,        /* 0x410f */
    KANJI,        /* 0x4110 */
    KANJI,        /* 0x4111 */
    KANJI,        /* 0x4112 */
    KANJI,        /* 0x4113 */
    KANJI,        /* 0x4114 */
    KANJI,        /* 0x4115 */
    KANJI,        /* 0x4116 */
    KANJI,        /* 0x4117 */
    KANJI,        /* 0x4118 */
    KANJI,        /* 0x4119 */
    KANJI,        /* 0x411a */
    KANJI,        /* 0x411b */
    KANJI,        /* 0x411c */
    KANJI,        /* 0x411d */
    KANJI,        /* 0x411e */
    KANJI,        /* 0x411f */
    KANJI,        /* 0x4120 */
    KANJI,        /* 0x4121 */
    KANJI,        /* 0x4122 */
    KANJI,        /* 0x4123 */
    KANJI,        /* 0x4124 */
    KANJI,        /* 0x4125 */
    KANJI,        /* 0x4126 */
    KANJI,        /* 0x4127 */
    KANJI,        /* 0x4128 */
    KANJI,        /* 0x4129 */
    KANJI,        /* 0x412a */
    KANJI,        /* 0x412b */
    KANJI,        /* 0x412c */
    KANJI,        /* 0x412d */
    KANJI,        /* 0x412e */
    KANJI,        /* 0x412f */
    KANJI,        /* 0x4130 */
    KANJI,        /* 0x4131 */
    KANJI,        /* 0x4132 */
    KANJI,        /* 0x4133 */
    KANJI,        /* 0x4134 */
    KANJI,        /* 0x4135 */
    KANJI,        /* 0x4136 */
    KANJI,        /* 0x4137 */
    KANJI,        /* 0x4138 */
    KANJI,        /* 0x4139 */
    KANJI,        /* 0x413a */
    KANJI,        /* 0x413b */
    KANJI,        /* 0x413c */
    KANJI,        /* 0x413d */
    KANJI,        /* 0x413e */
    KANJI,        /* 0x413f */
    KANJI,        /* 0x4140 */
    KANJI,        /* 0x4141 */
    KANJI,        /* 0x4142 */
    KANJI,        /* 0x4143 */
    KANJI,        /* 0x4144 */
    KANJI,        /* 0x4145 */
    KANJI,        /* 0x4146 */
    KANJI,        /* 0x4147 */
    KANJI,        /* 0x4148 */
    KANJI,        /* 0x4149 */
    KANJI,        /* 0x414a */
    KANJI,        /* 0x414b */
    KANJI,        /* 0x414c */
    KANJI,        /* 0x414d */
    KANJI,        /* 0x414e */
    KANJI,        /* 0x414f */
    KANJI,        /* 0x4150 */
    KANJI,        /* 0x4151 */
    KANJI,        /* 0x4152 */
    KANJI,        /* 0x4153 */
    KANJI,        /* 0x4154 */
    KANJI,        /* 0x4155 */
    KANJI,        /* 0x4156 */
    KANJI,        /* 0x4157 */
    KANJI,        /* 0x4158 */
    KANJI,        /* 0x4159 */
    KANJI,        /* 0x415a */
    KANJI,        /* 0x415b */
    KANJI,        /* 0x415c */
    KANJI,        /* 0x415d */
    KANJI,        /* 0x415e */
    KANJI,        /* 0x415f */
    KANJI,        /* 0x4160 */
    KANJI,        /* 0x4161 */
    KANJI,        /* 0x4162 */
    KANJI,        /* 0x4163 */
    KANJI,        /* 0x4164 */
    KANJI,        /* 0x4165 */
    KANJI,        /* 0x4166 */
    KANJI,        /* 0x4167 */
    KANJI,        /* 0x4168 */
    KANJI,        /* 0x4169 */
    KANJI,        /* 0x416a */
    KANJI,        /* 0x416b */
    KANJI,        /* 0x416c */
    KANJI,        /* 0x416d */
    KANJI,        /* 0x416e */
    KANJI,        /* 0x416f */
    KANJI,        /* 0x4170 */
    KANJI,        /* 0x4171 */
    KANJI,        /* 0x4172 */
    KANJI,        /* 0x4173 */
    KANJI,        /* 0x4174 */
    KANJI,        /* 0x4175 */
    KANJI,        /* 0x4176 */
    KANJI,        /* 0x4177 */
    KANJI,        /* 0x4178 */
    KANJI,        /* 0x4179 */
    KANJI,        /* 0x417a */
    KANJI,        /* 0x417b */
    KANJI,        /* 0x417c */
    KANJI,        /* 0x417d */
    KANJI,        /* 0x417e */
    KANJI,        /* 0x417f */
    KANJI,        /* 0x4180 */
    KANJI,        /* 0x4181 */
    KANJI,        /* 0x4182 */
    KANJI,        /* 0x4183 */
    KANJI,        /* 0x4184 */
    KANJI,        /* 0x4185 */
    KANJI,        /* 0x4186 */
    KANJI,        /* 0x4187 */
    KANJI,        /* 0x4188 */
    KANJI,        /* 0x4189 */
    KANJI,        /* 0x418a */
    KANJI,        /* 0x418b */
    KANJI,        /* 0x418c */
    KANJI,        /* 0x418d */
    KANJI,        /* 0x418e */
    KANJI,        /* 0x418f */
    KANJI,        /* 0x4190 */
    KANJI,        /* 0x4191 */
    KANJI,        /* 0x4192 */
    KANJI,        /* 0x4193 */
    KANJI,        /* 0x4194 */
    KANJI,        /* 0x4195 */
    KANJI,        /* 0x4196 */
    KANJI,        /* 0x4197 */
    KANJI,        /* 0x4198 */
    KANJI,        /* 0x4199 */
    KANJI,        /* 0x419a */
    KANJI,        /* 0x419b */
    KANJI,        /* 0x419c */
    KANJI,        /* 0x419d */
    KANJI,        /* 0x419e */
    KANJI,        /* 0x419f */
    KANJI,        /* 0x41a0 */
    KANJI,        /* 0x41a1 */
    KANJI,        /* 0x41a2 */
    KANJI,        /* 0x41a3 */
    KANJI,        /* 0x41a4 */
    KANJI,        /* 0x41a5 */
    KANJI,        /* 0x41a6 */
    KANJI,        /* 0x41a7 */
    KANJI,        /* 0x41a8 */
    KANJI,        /* 0x41a9 */
    KANJI,        /* 0x41aa */
    KANJI,        /* 0x41ab */
    KANJI,        /* 0x41ac */
    KANJI,        /* 0x41ad */
    KANJI,        /* 0x41ae */
    KANJI,        /* 0x41af */
    KANJI,        /* 0x41b0 */
    KANJI,        /* 0x41b1 */
    KANJI,        /* 0x41b2 */
    KANJI,        /* 0x41b3 */
    KANJI,        /* 0x41b4 */
    KANJI,        /* 0x41b5 */
    KANJI,        /* 0x41b6 */
    KANJI,        /* 0x41b7 */
    KANJI,        /* 0x41b8 */
    KANJI,        /* 0x41b9 */
    KANJI,        /* 0x41ba */
    KANJI,        /* 0x41bb */
    KANJI,        /* 0x41bc */
    KANJI,        /* 0x41bd */
    KANJI,        /* 0x41be */
    KANJI,        /* 0x41bf */
    KANJI,        /* 0x41c0 */
    KANJI,        /* 0x41c1 */
    KANJI,        /* 0x41c2 */
    KANJI,        /* 0x41c3 */
    KANJI,        /* 0x41c4 */
    KANJI,        /* 0x41c5 */
    KANJI,        /* 0x41c6 */
    KANJI,        /* 0x41c7 */
    KANJI,        /* 0x41c8 */
    KANJI,        /* 0x41c9 */
    KANJI,        /* 0x41ca */
    KANJI,        /* 0x41cb */
    KANJI,        /* 0x41cc */
    KANJI,        /* 0x41cd */
    KANJI,        /* 0x41ce */
    KANJI,        /* 0x41cf */
    KANJI,        /* 0x41d0 */
    KANJI,        /* 0x41d1 */
    KANJI,        /* 0x41d2 */
    KANJI,        /* 0x41d3 */
    KANJI,        /* 0x41d4 */
    KANJI,        /* 0x41d5 */
    KANJI,        /* 0x41d6 */
    KANJI,        /* 0x41d7 */
    KANJI,        /* 0x41d8 */
    KANJI,        /* 0x41d9 */
    KANJI,        /* 0x41da */
    KANJI,        /* 0x41db */
    KANJI,        /* 0x41dc */
    KANJI,        /* 0x41dd */
    KANJI,        /* 0x41de */
    KANJI,        /* 0x41df */
    KANJI,        /* 0x41e0 */
    KANJI,        /* 0x41e1 */
    KANJI,        /* 0x41e2 */
    KANJI,        /* 0x41e3 */
    KANJI,        /* 0x41e4 */
    KANJI,        /* 0x41e5 */
    KANJI,        /* 0x41e6 */
    KANJI,        /* 0x41e7 */
    KANJI,        /* 0x41e8 */
    KANJI,        /* 0x41e9 */
    KANJI,        /* 0x41ea */
    KANJI,        /* 0x41eb */
    KANJI,        /* 0x41ec */
    KANJI,        /* 0x41ed */
    KANJI,        /* 0x41ee */
    KANJI,        /* 0x41ef */
    KANJI,        /* 0x41f0 */
    KANJI,        /* 0x41f1 */
    KANJI,        /* 0x41f2 */
    KANJI,        /* 0x41f3 */
    KANJI,        /* 0x41f4 */
    KANJI,        /* 0x41f5 */
    KANJI,        /* 0x41f6 */
    KANJI,        /* 0x41f7 */
    KANJI,        /* 0x41f8 */
    KANJI,        /* 0x41f9 */
    KANJI,        /* 0x41fa */
    KANJI,        /* 0x41fb */
    KANJI,        /* 0x41fc */
    KANJI,        /* 0x41fd */
    KANJI,        /* 0x41fe */
    KANJI,        /* 0x41ff */
    KANJI,        /* 0x4200 */
    KANJI,        /* 0x4201 */
    KANJI,        /* 0x4202 */
    KANJI,        /* 0x4203 */
    KANJI,        /* 0x4204 */
    KANJI,        /* 0x4205 */
    KANJI,        /* 0x4206 */
    KANJI,        /* 0x4207 */
    KANJI,        /* 0x4208 */
    KANJI,        /* 0x4209 */
    KANJI,        /* 0x420a */
    KANJI,        /* 0x420b */
    KANJI,        /* 0x420c */
    KANJI,        /* 0x420d */
    KANJI,        /* 0x420e */
    KANJI,        /* 0x420f */
    KANJI,        /* 0x4210 */
    KANJI,        /* 0x4211 */
    KANJI,        /* 0x4212 */
    KANJI,        /* 0x4213 */
    KANJI,        /* 0x4214 */
    KANJI,        /* 0x4215 */
    KANJI,        /* 0x4216 */
    KANJI,        /* 0x4217 */
    KANJI,        /* 0x4218 */
    KANJI,        /* 0x4219 */
    KANJI,        /* 0x421a */
    KANJI,        /* 0x421b */
    KANJI,        /* 0x421c */
    KANJI,        /* 0x421d */
    KANJI,        /* 0x421e */
    KANJI,        /* 0x421f */
    KANJI,        /* 0x4220 */
    KANJI,        /* 0x4221 */
    KANJI,        /* 0x4222 */
    KANJI,        /* 0x4223 */
    KANJI,        /* 0x4224 */
    KANJI,        /* 0x4225 */
    KANJI,        /* 0x4226 */
    KANJI,        /* 0x4227 */
    KANJI,        /* 0x4228 */
    KANJI,        /* 0x4229 */
    KANJI,        /* 0x422a */
    KANJI,        /* 0x422b */
    KANJI,        /* 0x422c */
    KANJI,        /* 0x422d */
    KANJI,        /* 0x422e */
    KANJI,        /* 0x422f */
    KANJI,        /* 0x4230 */
    KANJI,        /* 0x4231 */
    KANJI,        /* 0x4232 */
    KANJI,        /* 0x4233 */
    KANJI,        /* 0x4234 */
    KANJI,        /* 0x4235 */
    KANJI,        /* 0x4236 */
    KANJI,        /* 0x4237 */
    KANJI,        /* 0x4238 */
    KANJI,        /* 0x4239 */
    KANJI,        /* 0x423a */
    KANJI,        /* 0x423b */
    KANJI,        /* 0x423c */
    KANJI,        /* 0x423d */
    KANJI,        /* 0x423e */
    KANJI,        /* 0x423f */
    KANJI,        /* 0x4240 */
    KANJI,        /* 0x4241 */
    KANJI,        /* 0x4242 */
    KANJI,        /* 0x4243 */
    KANJI,        /* 0x4244 */
    KANJI,        /* 0x4245 */
    KANJI,        /* 0x4246 */
    KANJI,        /* 0x4247 */
    KANJI,        /* 0x4248 */
    KANJI,        /* 0x4249 */
    KANJI,        /* 0x424a */
    KANJI,        /* 0x424b */
    KANJI,        /* 0x424c */
    KANJI,        /* 0x424d */
    KANJI,        /* 0x424e */
    KANJI,        /* 0x424f */
    KANJI,        /* 0x4250 */
    KANJI,        /* 0x4251 */
    KANJI,        /* 0x4252 */
    KANJI,        /* 0x4253 */
    KANJI,        /* 0x4254 */
    KANJI,        /* 0x4255 */
    KANJI,        /* 0x4256 */
    KANJI,        /* 0x4257 */
    KANJI,        /* 0x4258 */
    KANJI,        /* 0x4259 */
    KANJI,        /* 0x425a */
    KANJI,        /* 0x425b */
    KANJI,        /* 0x425c */
    KANJI,        /* 0x425d */
    KANJI,        /* 0x425e */
    KANJI,        /* 0x425f */
    KANJI,        /* 0x4260 */
    KANJI,        /* 0x4261 */
    KANJI,        /* 0x4262 */
    KANJI,        /* 0x4263 */
    KANJI,        /* 0x4264 */
    KANJI,        /* 0x4265 */
    KANJI,        /* 0x4266 */
    KANJI,        /* 0x4267 */
    KANJI,        /* 0x4268 */
    KANJI,        /* 0x4269 */
    KANJI,        /* 0x426a */
    KANJI,        /* 0x426b */
    KANJI,        /* 0x426c */
    KANJI,        /* 0x426d */
    KANJI,        /* 0x426e */
    KANJI,        /* 0x426f */
    KANJI,        /* 0x4270 */
    KANJI,        /* 0x4271 */
    KANJI,        /* 0x4272 */
    KANJI,        /* 0x4273 */
    KANJI,        /* 0x4274 */
    KANJI,        /* 0x4275 */
    KANJI,        /* 0x4276 */
    KANJI,        /* 0x4277 */
    KANJI,        /* 0x4278 */
    KANJI,        /* 0x4279 */
    KANJI,        /* 0x427a */
    KANJI,        /* 0x427b */
    KANJI,        /* 0x427c */
    KANJI,        /* 0x427d */
    KANJI,        /* 0x427e */
    KANJI,        /* 0x427f */
    KANJI,        /* 0x4280 */
    KANJI,        /* 0x4281 */
    KANJI,        /* 0x4282 */
    KANJI,        /* 0x4283 */
    KANJI,        /* 0x4284 */
    KANJI,        /* 0x4285 */
    KANJI,        /* 0x4286 */
    KANJI,        /* 0x4287 */
    KANJI,        /* 0x4288 */
    KANJI,        /* 0x4289 */
    KANJI,        /* 0x428a */
    KANJI,        /* 0x428b */
    KANJI,        /* 0x428c */
    KANJI,        /* 0x428d */
    KANJI,        /* 0x428e */
    KANJI,        /* 0x428f */
    KANJI,        /* 0x4290 */
    KANJI,        /* 0x4291 */
    KANJI,        /* 0x4292 */
    KANJI,        /* 0x4293 */
    KANJI,        /* 0x4294 */
    KANJI,        /* 0x4295 */
    KANJI,        /* 0x4296 */
    KANJI,        /* 0x4297 */
    KANJI,        /* 0x4298 */
    KANJI,        /* 0x4299 */
    KANJI,        /* 0x429a */
    KANJI,        /* 0x429b */
    KANJI,        /* 0x429c */
    KANJI,        /* 0x429d */
    KANJI,        /* 0x429e */
    KANJI,        /* 0x429f */
    KANJI,        /* 0x42a0 */
    KANJI,        /* 0x42a1 */
    KANJI,        /* 0x42a2 */
    KANJI,        /* 0x42a3 */
    KANJI,        /* 0x42a4 */
    KANJI,        /* 0x42a5 */
    KANJI,        /* 0x42a6 */
    KANJI,        /* 0x42a7 */
    KANJI,        /* 0x42a8 */
    KANJI,        /* 0x42a9 */
    KANJI,        /* 0x42aa */
    KANJI,        /* 0x42ab */
    KANJI,        /* 0x42ac */
    KANJI,        /* 0x42ad */
    KANJI,        /* 0x42ae */
    KANJI,        /* 0x42af */
    KANJI,        /* 0x42b0 */
    KANJI,        /* 0x42b1 */
    KANJI,        /* 0x42b2 */
    KANJI,        /* 0x42b3 */
    KANJI,        /* 0x42b4 */
    KANJI,        /* 0x42b5 */
    KANJI,        /* 0x42b6 */
    KANJI,        /* 0x42b7 */
    KANJI,        /* 0x42b8 */
    KANJI,        /* 0x42b9 */
    KANJI,        /* 0x42ba */
    KANJI,        /* 0x42bb */
    KANJI,        /* 0x42bc */
    KANJI,        /* 0x42bd */
    KANJI,        /* 0x42be */
    KANJI,        /* 0x42bf */
    KANJI,        /* 0x42c0 */
    KANJI,        /* 0x42c1 */
    KANJI,        /* 0x42c2 */
    KANJI,        /* 0x42c3 */
    KANJI,        /* 0x42c4 */
    KANJI,        /* 0x42c5 */
    KANJI,        /* 0x42c6 */
    KANJI,        /* 0x42c7 */
    KANJI,        /* 0x42c8 */
    KANJI,        /* 0x42c9 */
    KANJI,        /* 0x42ca */
    KANJI,        /* 0x42cb */
    KANJI,        /* 0x42cc */
    KANJI,        /* 0x42cd */
    KANJI,        /* 0x42ce */
    KANJI,        /* 0x42cf */
    KANJI,        /* 0x42d0 */
    KANJI,        /* 0x42d1 */
    KANJI,        /* 0x42d2 */
    KANJI,        /* 0x42d3 */
    KANJI,        /* 0x42d4 */
    KANJI,        /* 0x42d5 */
    KANJI,        /* 0x42d6 */
    KANJI,        /* 0x42d7 */
    KANJI,        /* 0x42d8 */
    KANJI,        /* 0x42d9 */
    KANJI,        /* 0x42da */
    KANJI,        /* 0x42db */
    KANJI,        /* 0x42dc */
    KANJI,        /* 0x42dd */
    KANJI,        /* 0x42de */
    KANJI,        /* 0x42df */
    KANJI,        /* 0x42e0 */
    KANJI,        /* 0x42e1 */
    KANJI,        /* 0x42e2 */
    KANJI,        /* 0x42e3 */
    KANJI,        /* 0x42e4 */
    KANJI,        /* 0x42e5 */
    KANJI,        /* 0x42e6 */
    KANJI,        /* 0x42e7 */
    KANJI,        /* 0x42e8 */
    KANJI,        /* 0x42e9 */
    KANJI,        /* 0x42ea */
    KANJI,        /* 0x42eb */
    KANJI,        /* 0x42ec */
    KANJI,        /* 0x42ed */
    KANJI,        /* 0x42ee */
    KANJI,        /* 0x42ef */
    KANJI,        /* 0x42f0 */
    KANJI,        /* 0x42f1 */
    KANJI,        /* 0x42f2 */
    KANJI,        /* 0x42f3 */
    KANJI,        /* 0x42f4 */
    KANJI,        /* 0x42f5 */
    KANJI,        /* 0x42f6 */
    KANJI,        /* 0x42f7 */
    KANJI,        /* 0x42f8 */
    KANJI,        /* 0x42f9 */
    KANJI,        /* 0x42fa */
    KANJI,        /* 0x42fb */
    KANJI,        /* 0x42fc */
    KANJI,        /* 0x42fd */
    KANJI,        /* 0x42fe */
    KANJI,        /* 0x42ff */
    KANJI,        /* 0x4300 */
    KANJI,        /* 0x4301 */
    KANJI,        /* 0x4302 */
    KANJI,        /* 0x4303 */
    KANJI,        /* 0x4304 */
    KANJI,        /* 0x4305 */
    KANJI,        /* 0x4306 */
    KANJI,        /* 0x4307 */
    KANJI,        /* 0x4308 */
    KANJI,        /* 0x4309 */
    KANJI,        /* 0x430a */
    KANJI,        /* 0x430b */
    KANJI,        /* 0x430c */
    KANJI,        /* 0x430d */
    KANJI,        /* 0x430e */
    KANJI,        /* 0x430f */
    KANJI,        /* 0x4310 */
    KANJI,        /* 0x4311 */
    KANJI,        /* 0x4312 */
    KANJI,        /* 0x4313 */
    KANJI,        /* 0x4314 */
    KANJI,        /* 0x4315 */
    KANJI,        /* 0x4316 */
    KANJI,        /* 0x4317 */
    KANJI,        /* 0x4318 */
    KANJI,        /* 0x4319 */
    KANJI,        /* 0x431a */
    KANJI,        /* 0x431b */
    KANJI,        /* 0x431c */
    KANJI,        /* 0x431d */
    KANJI,        /* 0x431e */
    KANJI,        /* 0x431f */
    KANJI,        /* 0x4320 */
    KANJI,        /* 0x4321 */
    KANJI,        /* 0x4322 */
    KANJI,        /* 0x4323 */
    KANJI,        /* 0x4324 */
    KANJI,        /* 0x4325 */
    KANJI,        /* 0x4326 */
    KANJI,        /* 0x4327 */
    KANJI,        /* 0x4328 */
    KANJI,        /* 0x4329 */
    KANJI,        /* 0x432a */
    KANJI,        /* 0x432b */
    KANJI,        /* 0x432c */
    KANJI,        /* 0x432d */
    KANJI,        /* 0x432e */
    KANJI,        /* 0x432f */
    KANJI,        /* 0x4330 */
    KANJI,        /* 0x4331 */
    KANJI,        /* 0x4332 */
    KANJI,        /* 0x4333 */
    KANJI,        /* 0x4334 */
    KANJI,        /* 0x4335 */
    KANJI,        /* 0x4336 */
    KANJI,        /* 0x4337 */
    KANJI,        /* 0x4338 */
    KANJI,        /* 0x4339 */
    KANJI,        /* 0x433a */
    KANJI,        /* 0x433b */
    KANJI,        /* 0x433c */
    KANJI,        /* 0x433d */
    KANJI,        /* 0x433e */
    KANJI,        /* 0x433f */
    KANJI,        /* 0x4340 */
    KANJI,        /* 0x4341 */
    KANJI,        /* 0x4342 */
    KANJI,        /* 0x4343 */
    KANJI,        /* 0x4344 */
    KANJI,        /* 0x4345 */
    KANJI,        /* 0x4346 */
    KANJI,        /* 0x4347 */
    KANJI,        /* 0x4348 */
    KANJI,        /* 0x4349 */
    KANJI,        /* 0x434a */
    KANJI,        /* 0x434b */
    KANJI,        /* 0x434c */
    KANJI,        /* 0x434d */
    KANJI,        /* 0x434e */
    KANJI,        /* 0x434f */
    KANJI,        /* 0x4350 */
    KANJI,        /* 0x4351 */
    KANJI,        /* 0x4352 */
    KANJI,        /* 0x4353 */
    KANJI,        /* 0x4354 */
    KANJI,        /* 0x4355 */
    KANJI,        /* 0x4356 */
    KANJI,        /* 0x4357 */
    KANJI,        /* 0x4358 */
    KANJI,        /* 0x4359 */
    KANJI,        /* 0x435a */
    KANJI,        /* 0x435b */
    KANJI,        /* 0x435c */
    KANJI,        /* 0x435d */
    KANJI,        /* 0x435e */
    KANJI,        /* 0x435f */
    KANJI,        /* 0x4360 */
    KANJI,        /* 0x4361 */
    KANJI,        /* 0x4362 */
    KANJI,        /* 0x4363 */
    KANJI,        /* 0x4364 */
    KANJI,        /* 0x4365 */
    KANJI,        /* 0x4366 */
    KANJI,        /* 0x4367 */
    KANJI,        /* 0x4368 */
    KANJI,        /* 0x4369 */
    KANJI,        /* 0x436a */
    KANJI,        /* 0x436b */
    KANJI,        /* 0x436c */
    KANJI,        /* 0x436d */
    KANJI,        /* 0x436e */
    KANJI,        /* 0x436f */
    KANJI,        /* 0x4370 */
    KANJI,        /* 0x4371 */
    KANJI,        /* 0x4372 */
    KANJI,        /* 0x4373 */
    KANJI,        /* 0x4374 */
    KANJI,        /* 0x4375 */
    KANJI,        /* 0x4376 */
    KANJI,        /* 0x4377 */
    KANJI,        /* 0x4378 */
    KANJI,        /* 0x4379 */
    KANJI,        /* 0x437a */
    KANJI,        /* 0x437b */
    KANJI,        /* 0x437c */
    KANJI,        /* 0x437d */
    KANJI,        /* 0x437e */
    KANJI,        /* 0x437f */
    KANJI,        /* 0x4380 */
    KANJI,        /* 0x4381 */
    KANJI,        /* 0x4382 */
    KANJI,        /* 0x4383 */
    KANJI,        /* 0x4384 */
    KANJI,        /* 0x4385 */
    KANJI,        /* 0x4386 */
    KANJI,        /* 0x4387 */
    KANJI,        /* 0x4388 */
    KANJI,        /* 0x4389 */
    KANJI,        /* 0x438a */
    KANJI,        /* 0x438b */
    KANJI,        /* 0x438c */
    KANJI,        /* 0x438d */
    KANJI,        /* 0x438e */
    KANJI,        /* 0x438f */
    KANJI,        /* 0x4390 */
    KANJI,        /* 0x4391 */
    KANJI,        /* 0x4392 */
    KANJI,        /* 0x4393 */
    KANJI,        /* 0x4394 */
    KANJI,        /* 0x4395 */
    KANJI,        /* 0x4396 */
    KANJI,        /* 0x4397 */
    KANJI,        /* 0x4398 */
    KANJI,        /* 0x4399 */
    KANJI,        /* 0x439a */
    KANJI,        /* 0x439b */
    KANJI,        /* 0x439c */
    KANJI,        /* 0x439d */
    KANJI,        /* 0x439e */
    KANJI,        /* 0x439f */
    KANJI,        /* 0x43a0 */
    KANJI,        /* 0x43a1 */
    KANJI,        /* 0x43a2 */
    KANJI,        /* 0x43a3 */
    KANJI,        /* 0x43a4 */
    KANJI,        /* 0x43a5 */
    KANJI,        /* 0x43a6 */
    KANJI,        /* 0x43a7 */
    KANJI,        /* 0x43a8 */
    KANJI,        /* 0x43a9 */
    KANJI,        /* 0x43aa */
    KANJI,        /* 0x43ab */
    KANJI,        /* 0x43ac */
    KANJI,        /* 0x43ad */
    KANJI,        /* 0x43ae */
    KANJI,        /* 0x43af */
    KANJI,        /* 0x43b0 */
    KANJI,        /* 0x43b1 */
    KANJI,        /* 0x43b2 */
    KANJI,        /* 0x43b3 */
    KANJI,        /* 0x43b4 */
    KANJI,        /* 0x43b5 */
    KANJI,        /* 0x43b6 */
    KANJI,        /* 0x43b7 */
    KANJI,        /* 0x43b8 */
    KANJI,        /* 0x43b9 */
    KANJI,        /* 0x43ba */
    KANJI,        /* 0x43bb */
    KANJI,        /* 0x43bc */
    KANJI,        /* 0x43bd */
    KANJI,        /* 0x43be */
    KANJI,        /* 0x43bf */
    KANJI,        /* 0x43c0 */
    KANJI,        /* 0x43c1 */
    KANJI,        /* 0x43c2 */
    KANJI,        /* 0x43c3 */
    KANJI,        /* 0x43c4 */
    KANJI,        /* 0x43c5 */
    KANJI,        /* 0x43c6 */
    KANJI,        /* 0x43c7 */
    KANJI,        /* 0x43c8 */
    KANJI,        /* 0x43c9 */
    KANJI,        /* 0x43ca */
    KANJI,        /* 0x43cb */
    KANJI,        /* 0x43cc */
    KANJI,        /* 0x43cd */
    KANJI,        /* 0x43ce */
    KANJI,        /* 0x43cf */
    KANJI,        /* 0x43d0 */
    KANJI,        /* 0x43d1 */
    KANJI,        /* 0x43d2 */
    KANJI,        /* 0x43d3 */
    KANJI,        /* 0x43d4 */
    KANJI,        /* 0x43d5 */
    KANJI,        /* 0x43d6 */
    KANJI,        /* 0x43d7 */
    KANJI,        /* 0x43d8 */
    KANJI,        /* 0x43d9 */
    KANJI,        /* 0x43da */
    KANJI,        /* 0x43db */
    KANJI,        /* 0x43dc */
    KANJI,        /* 0x43dd */
    KANJI,        /* 0x43de */
    KANJI,        /* 0x43df */
    KANJI,        /* 0x43e0 */
    KANJI,        /* 0x43e1 */
    KANJI,        /* 0x43e2 */
    KANJI,        /* 0x43e3 */
    KANJI,        /* 0x43e4 */
    KANJI,        /* 0x43e5 */
    KANJI,        /* 0x43e6 */
    KANJI,        /* 0x43e7 */
    KANJI,        /* 0x43e8 */
    KANJI,        /* 0x43e9 */
    KANJI,        /* 0x43ea */
    KANJI,        /* 0x43eb */
    KANJI,        /* 0x43ec */
    KANJI,        /* 0x43ed */
    KANJI,        /* 0x43ee */
    KANJI,        /* 0x43ef */
    KANJI,        /* 0x43f0 */
    KANJI,        /* 0x43f1 */
    KANJI,        /* 0x43f2 */
    KANJI,        /* 0x43f3 */
    KANJI,        /* 0x43f4 */
    KANJI,        /* 0x43f5 */
    KANJI,        /* 0x43f6 */
    KANJI,        /* 0x43f7 */
    KANJI,        /* 0x43f8 */
    KANJI,        /* 0x43f9 */
    KANJI,        /* 0x43fa */
    KANJI,        /* 0x43fb */
    KANJI,        /* 0x43fc */
    KANJI,        /* 0x43fd */
    KANJI,        /* 0x43fe */
    KANJI,        /* 0x43ff */
    KANJI,        /* 0x4400 */
    KANJI,        /* 0x4401 */
    KANJI,        /* 0x4402 */
    KANJI,        /* 0x4403 */
    KANJI,        /* 0x4404 */
    KANJI,        /* 0x4405 */
    KANJI,        /* 0x4406 */
    KANJI,        /* 0x4407 */
    KANJI,        /* 0x4408 */
    KANJI,        /* 0x4409 */
    KANJI,        /* 0x440a */
    KANJI,        /* 0x440b */
    KANJI,        /* 0x440c */
    KANJI,        /* 0x440d */
    KANJI,        /* 0x440e */
    KANJI,        /* 0x440f */
    KANJI,        /* 0x4410 */
    KANJI,        /* 0x4411 */
    KANJI,        /* 0x4412 */
    KANJI,        /* 0x4413 */
    KANJI,        /* 0x4414 */
    KANJI,        /* 0x4415 */
    KANJI,        /* 0x4416 */
    KANJI,        /* 0x4417 */
    KANJI,        /* 0x4418 */
    KANJI,        /* 0x4419 */
    KANJI,        /* 0x441a */
    KANJI,        /* 0x441b */
    KANJI,        /* 0x441c */
    KANJI,        /* 0x441d */
    KANJI,        /* 0x441e */
    KANJI,        /* 0x441f */
    KANJI,        /* 0x4420 */
    KANJI,        /* 0x4421 */
    KANJI,        /* 0x4422 */
    KANJI,        /* 0x4423 */
    KANJI,        /* 0x4424 */
    KANJI,        /* 0x4425 */
    KANJI,        /* 0x4426 */
    KANJI,        /* 0x4427 */
    KANJI,        /* 0x4428 */
    KANJI,        /* 0x4429 */
    KANJI,        /* 0x442a */
    KANJI,        /* 0x442b */
    KANJI,        /* 0x442c */
    KANJI,        /* 0x442d */
    KANJI,        /* 0x442e */
    KANJI,        /* 0x442f */
    KANJI,        /* 0x4430 */
    KANJI,        /* 0x4431 */
    KANJI,        /* 0x4432 */
    KANJI,        /* 0x4433 */
    KANJI,        /* 0x4434 */
    KANJI,        /* 0x4435 */
    KANJI,        /* 0x4436 */
    KANJI,        /* 0x4437 */
    KANJI,        /* 0x4438 */
    KANJI,        /* 0x4439 */
    KANJI,        /* 0x443a */
    KANJI,        /* 0x443b */
    KANJI,        /* 0x443c */
    KANJI,        /* 0x443d */
    KANJI,        /* 0x443e */
    KANJI,        /* 0x443f */
    KANJI,        /* 0x4440 */
    KANJI,        /* 0x4441 */
    KANJI,        /* 0x4442 */
    KANJI,        /* 0x4443 */
    KANJI,        /* 0x4444 */
    KANJI,        /* 0x4445 */
    KANJI,        /* 0x4446 */
    KANJI,        /* 0x4447 */
    KANJI,        /* 0x4448 */
    KANJI,        /* 0x4449 */
    KANJI,        /* 0x444a */
    KANJI,        /* 0x444b */
    KANJI,        /* 0x444c */
    KANJI,        /* 0x444d */
    KANJI,        /* 0x444e */
    KANJI,        /* 0x444f */
    KANJI,        /* 0x4450 */
    KANJI,        /* 0x4451 */
    KANJI,        /* 0x4452 */
    KANJI,        /* 0x4453 */
    KANJI,        /* 0x4454 */
    KANJI,        /* 0x4455 */
    KANJI,        /* 0x4456 */
    KANJI,        /* 0x4457 */
    KANJI,        /* 0x4458 */
    KANJI,        /* 0x4459 */
    KANJI,        /* 0x445a */
    KANJI,        /* 0x445b */
    KANJI,        /* 0x445c */
    KANJI,        /* 0x445d */
    KANJI,        /* 0x445e */
    KANJI,        /* 0x445f */
    KANJI,        /* 0x4460 */
    KANJI,        /* 0x4461 */
    KANJI,        /* 0x4462 */
    KANJI,        /* 0x4463 */
    KANJI,        /* 0x4464 */
    KANJI,        /* 0x4465 */
    KANJI,        /* 0x4466 */
    KANJI,        /* 0x4467 */
    KANJI,        /* 0x4468 */
    KANJI,        /* 0x4469 */
    KANJI,        /* 0x446a */
    KANJI,        /* 0x446b */
    KANJI,        /* 0x446c */
    KANJI,        /* 0x446d */
    KANJI,        /* 0x446e */
    KANJI,        /* 0x446f */
    KANJI,        /* 0x4470 */
    KANJI,        /* 0x4471 */
    KANJI,        /* 0x4472 */
    KANJI,        /* 0x4473 */
    KANJI,        /* 0x4474 */
    KANJI,        /* 0x4475 */
    KANJI,        /* 0x4476 */
    KANJI,        /* 0x4477 */
    KANJI,        /* 0x4478 */
    KANJI,        /* 0x4479 */
    KANJI,        /* 0x447a */
    KANJI,        /* 0x447b */
    KANJI,        /* 0x447c */
    KANJI,        /* 0x447d */
    KANJI,        /* 0x447e */
    KANJI,        /* 0x447f */
    KANJI,        /* 0x4480 */
    KANJI,        /* 0x4481 */
    KANJI,        /* 0x4482 */
    KANJI,        /* 0x4483 */
    KANJI,        /* 0x4484 */
    KANJI,        /* 0x4485 */
    KANJI,        /* 0x4486 */
    KANJI,        /* 0x4487 */
    KANJI,        /* 0x4488 */
    KANJI,        /* 0x4489 */
    KANJI,        /* 0x448a */
    KANJI,        /* 0x448b */
    KANJI,        /* 0x448c */
    KANJI,        /* 0x448d */
    KANJI,        /* 0x448e */
    KANJI,        /* 0x448f */
    KANJI,        /* 0x4490 */
    KANJI,        /* 0x4491 */
    KANJI,        /* 0x4492 */
    KANJI,        /* 0x4493 */
    KANJI,        /* 0x4494 */
    KANJI,        /* 0x4495 */
    KANJI,        /* 0x4496 */
    KANJI,        /* 0x4497 */
    KANJI,        /* 0x4498 */
    KANJI,        /* 0x4499 */
    KANJI,        /* 0x449a */
    KANJI,        /* 0x449b */
    KANJI,        /* 0x449c */
    KANJI,        /* 0x449d */
    KANJI,        /* 0x449e */
    KANJI,        /* 0x449f */
    KANJI,        /* 0x44a0 */
    KANJI,        /* 0x44a1 */
    KANJI,        /* 0x44a2 */
    KANJI,        /* 0x44a3 */
    KANJI,        /* 0x44a4 */
    KANJI,        /* 0x44a5 */
    KANJI,        /* 0x44a6 */
    KANJI,        /* 0x44a7 */
    KANJI,        /* 0x44a8 */
    KANJI,        /* 0x44a9 */
    KANJI,        /* 0x44aa */
    KANJI,        /* 0x44ab */
    KANJI,        /* 0x44ac */
    KANJI,        /* 0x44ad */
    KANJI,        /* 0x44ae */
    KANJI,        /* 0x44af */
    KANJI,        /* 0x44b0 */
    KANJI,        /* 0x44b1 */
    KANJI,        /* 0x44b2 */
    KANJI,        /* 0x44b3 */
    KANJI,        /* 0x44b4 */
    KANJI,        /* 0x44b5 */
    KANJI,        /* 0x44b6 */
    KANJI,        /* 0x44b7 */
    KANJI,        /* 0x44b8 */
    KANJI,        /* 0x44b9 */
    KANJI,        /* 0x44ba */
    KANJI,        /* 0x44bb */
    KANJI,        /* 0x44bc */
    KANJI,        /* 0x44bd */
    KANJI,        /* 0x44be */
    KANJI,        /* 0x44bf */
    KANJI,        /* 0x44c0 */
    KANJI,        /* 0x44c1 */
    KANJI,        /* 0x44c2 */
    KANJI,        /* 0x44c3 */
    KANJI,        /* 0x44c4 */
    KANJI,        /* 0x44c5 */
    KANJI,        /* 0x44c6 */
    KANJI,        /* 0x44c7 */
    KANJI,        /* 0x44c8 */
    KANJI,        /* 0x44c9 */
    KANJI,        /* 0x44ca */
    KANJI,        /* 0x44cb */
    KANJI,        /* 0x44cc */
    KANJI,        /* 0x44cd */
    KANJI,        /* 0x44ce */
    KANJI,        /* 0x44cf */
    KANJI,        /* 0x44d0 */
    KANJI,        /* 0x44d1 */
    KANJI,        /* 0x44d2 */
    KANJI,        /* 0x44d3 */
    KANJI,        /* 0x44d4 */
    KANJI,        /* 0x44d5 */
    KANJI,        /* 0x44d6 */
    KANJI,        /* 0x44d7 */
    KANJI,        /* 0x44d8 */
    KANJI,        /* 0x44d9 */
    KANJI,        /* 0x44da */
    KANJI,        /* 0x44db */
    KANJI,        /* 0x44dc */
    KANJI,        /* 0x44dd */
    KANJI,        /* 0x44de */
    KANJI,        /* 0x44df */
    KANJI,        /* 0x44e0 */
    KANJI,        /* 0x44e1 */
    KANJI,        /* 0x44e2 */
    KANJI,        /* 0x44e3 */
    KANJI,        /* 0x44e4 */
    KANJI,        /* 0x44e5 */
    KANJI,        /* 0x44e6 */
    KANJI,        /* 0x44e7 */
    KANJI,        /* 0x44e8 */
    KANJI,        /* 0x44e9 */
    KANJI,        /* 0x44ea */
    KANJI,        /* 0x44eb */
    KANJI,        /* 0x44ec */
    KANJI,        /* 0x44ed */
    KANJI,        /* 0x44ee */
    KANJI,        /* 0x44ef */
    KANJI,        /* 0x44f0 */
    KANJI,        /* 0x44f1 */
    KANJI,        /* 0x44f2 */
    KANJI,        /* 0x44f3 */
    KANJI,        /* 0x44f4 */
    KANJI,        /* 0x44f5 */
    KANJI,        /* 0x44f6 */
    KANJI,        /* 0x44f7 */
    KANJI,        /* 0x44f8 */
    KANJI,        /* 0x44f9 */
    KANJI,        /* 0x44fa */
    KANJI,        /* 0x44fb */
    KANJI,        /* 0x44fc */
    KANJI,        /* 0x44fd */
    KANJI,        /* 0x44fe */
    KANJI,        /* 0x44ff */
    KANJI,        /* 0x4500 */
    KANJI,        /* 0x4501 */
    KANJI,        /* 0x4502 */
    KANJI,        /* 0x4503 */
    KANJI,        /* 0x4504 */
    KANJI,        /* 0x4505 */
    KANJI,        /* 0x4506 */
    KANJI,        /* 0x4507 */
    KANJI,        /* 0x4508 */
    KANJI,        /* 0x4509 */
    KANJI,        /* 0x450a */
    KANJI,        /* 0x450b */
    KANJI,        /* 0x450c */
    KANJI,        /* 0x450d */
    KANJI,        /* 0x450e */
    KANJI,        /* 0x450f */
    KANJI,        /* 0x4510 */
    KANJI,        /* 0x4511 */
    KANJI,        /* 0x4512 */
    KANJI,        /* 0x4513 */
    KANJI,        /* 0x4514 */
    KANJI,        /* 0x4515 */
    KANJI,        /* 0x4516 */
    KANJI,        /* 0x4517 */
    KANJI,        /* 0x4518 */
    KANJI,        /* 0x4519 */
    KANJI,        /* 0x451a */
    KANJI,        /* 0x451b */
    KANJI,        /* 0x451c */
    KANJI,        /* 0x451d */
    KANJI,        /* 0x451e */
    KANJI,        /* 0x451f */
    KANJI,        /* 0x4520 */
    KANJI,        /* 0x4521 */
    KANJI,        /* 0x4522 */
    KANJI,        /* 0x4523 */
    KANJI,        /* 0x4524 */
    KANJI,        /* 0x4525 */
    KANJI,        /* 0x4526 */
    KANJI,        /* 0x4527 */
    KANJI,        /* 0x4528 */
    KANJI,        /* 0x4529 */
    KANJI,        /* 0x452a */
    KANJI,        /* 0x452b */
    KANJI,        /* 0x452c */
    KANJI,        /* 0x452d */
    KANJI,        /* 0x452e */
    KANJI,        /* 0x452f */
    KANJI,        /* 0x4530 */
    KANJI,        /* 0x4531 */
    KANJI,        /* 0x4532 */
    KANJI,        /* 0x4533 */
    KANJI,        /* 0x4534 */
    KANJI,        /* 0x4535 */
    KANJI,        /* 0x4536 */
    KANJI,        /* 0x4537 */
    KANJI,        /* 0x4538 */
    KANJI,        /* 0x4539 */
    KANJI,        /* 0x453a */
    KANJI,        /* 0x453b */
    KANJI,        /* 0x453c */
    KANJI,        /* 0x453d */
    KANJI,        /* 0x453e */
    KANJI,        /* 0x453f */
    KANJI,        /* 0x4540 */
    KANJI,        /* 0x4541 */
    KANJI,        /* 0x4542 */
    KANJI,        /* 0x4543 */
    KANJI,        /* 0x4544 */
    KANJI,        /* 0x4545 */
    KANJI,        /* 0x4546 */
    KANJI,        /* 0x4547 */
    KANJI,        /* 0x4548 */
    KANJI,        /* 0x4549 */
    KANJI,        /* 0x454a */
    KANJI,        /* 0x454b */
    KANJI,        /* 0x454c */
    KANJI,        /* 0x454d */
    KANJI,        /* 0x454e */
    KANJI,        /* 0x454f */
    KANJI,        /* 0x4550 */
    KANJI,        /* 0x4551 */
    KANJI,        /* 0x4552 */
    KANJI,        /* 0x4553 */
    KANJI,        /* 0x4554 */
    KANJI,        /* 0x4555 */
    KANJI,        /* 0x4556 */
    KANJI,        /* 0x4557 */
    KANJI,        /* 0x4558 */
    KANJI,        /* 0x4559 */
    KANJI,        /* 0x455a */
    KANJI,        /* 0x455b */
    KANJI,        /* 0x455c */
    KANJI,        /* 0x455d */
    KANJI,        /* 0x455e */
    KANJI,        /* 0x455f */
    KANJI,        /* 0x4560 */
    KANJI,        /* 0x4561 */
    KANJI,        /* 0x4562 */
    KANJI,        /* 0x4563 */
    KANJI,        /* 0x4564 */
    KANJI,        /* 0x4565 */
    KANJI,        /* 0x4566 */
    KANJI,        /* 0x4567 */
    KANJI,        /* 0x4568 */
    KANJI,        /* 0x4569 */
    KANJI,        /* 0x456a */
    KANJI,        /* 0x456b */
    KANJI,        /* 0x456c */
    KANJI,        /* 0x456d */
    KANJI,        /* 0x456e */
    KANJI,        /* 0x456f */
    KANJI,        /* 0x4570 */
    KANJI,        /* 0x4571 */
    KANJI,        /* 0x4572 */
    KANJI,        /* 0x4573 */
    KANJI,        /* 0x4574 */
    KANJI,        /* 0x4575 */
    KANJI,        /* 0x4576 */
    KANJI,        /* 0x4577 */
    KANJI,        /* 0x4578 */
    KANJI,        /* 0x4579 */
    KANJI,        /* 0x457a */
    KANJI,        /* 0x457b */
    KANJI,        /* 0x457c */
    KANJI,        /* 0x457d */
    KANJI,        /* 0x457e */
    KANJI,        /* 0x457f */
    KANJI,        /* 0x4580 */
    KANJI,        /* 0x4581 */
    KANJI,        /* 0x4582 */
    KANJI,        /* 0x4583 */
    KANJI,        /* 0x4584 */
    KANJI,        /* 0x4585 */
    KANJI,        /* 0x4586 */
    KANJI,        /* 0x4587 */
    KANJI,        /* 0x4588 */
    KANJI,        /* 0x4589 */
    KANJI,        /* 0x458a */
    KANJI,        /* 0x458b */
    KANJI,        /* 0x458c */
    KANJI,        /* 0x458d */
    KANJI,        /* 0x458e */
    KANJI,        /* 0x458f */
    KANJI,        /* 0x4590 */
    KANJI,        /* 0x4591 */
    KANJI,        /* 0x4592 */
    KANJI,        /* 0x4593 */
    KANJI,        /* 0x4594 */
    KANJI,        /* 0x4595 */
    KANJI,        /* 0x4596 */
    KANJI,        /* 0x4597 */
    KANJI,        /* 0x4598 */
    KANJI,        /* 0x4599 */
    KANJI,        /* 0x459a */
    KANJI,        /* 0x459b */
    KANJI,        /* 0x459c */
    KANJI,        /* 0x459d */
    KANJI,        /* 0x459e */
    KANJI,        /* 0x459f */
    KANJI,        /* 0x45a0 */
    KANJI,        /* 0x45a1 */
    KANJI,        /* 0x45a2 */
    KANJI,        /* 0x45a3 */
    KANJI,        /* 0x45a4 */
    KANJI,        /* 0x45a5 */
    KANJI,        /* 0x45a6 */
    KANJI,        /* 0x45a7 */
    KANJI,        /* 0x45a8 */
    KANJI,        /* 0x45a9 */
    KANJI,        /* 0x45aa */
    KANJI,        /* 0x45ab */
    KANJI,        /* 0x45ac */
    KANJI,        /* 0x45ad */
    KANJI,        /* 0x45ae */
    KANJI,        /* 0x45af */
    KANJI,        /* 0x45b0 */
    KANJI,        /* 0x45b1 */
    KANJI,        /* 0x45b2 */
    KANJI,        /* 0x45b3 */
    KANJI,        /* 0x45b4 */
    KANJI,        /* 0x45b5 */
    KANJI,        /* 0x45b6 */
    KANJI,        /* 0x45b7 */
    KANJI,        /* 0x45b8 */
    KANJI,        /* 0x45b9 */
    KANJI,        /* 0x45ba */
    KANJI,        /* 0x45bb */
    KANJI,        /* 0x45bc */
    KANJI,        /* 0x45bd */
    KANJI,        /* 0x45be */
    KANJI,        /* 0x45bf */
    KANJI,        /* 0x45c0 */
    KANJI,        /* 0x45c1 */
    KANJI,        /* 0x45c2 */
    KANJI,        /* 0x45c3 */
    KANJI,        /* 0x45c4 */
    KANJI,        /* 0x45c5 */
    KANJI,        /* 0x45c6 */
    KANJI,        /* 0x45c7 */
    KANJI,        /* 0x45c8 */
    KANJI,        /* 0x45c9 */
    KANJI,        /* 0x45ca */
    KANJI,        /* 0x45cb */
    KANJI,        /* 0x45cc */
    KANJI,        /* 0x45cd */
    KANJI,        /* 0x45ce */
    KANJI,        /* 0x45cf */
    KANJI,        /* 0x45d0 */
    KANJI,        /* 0x45d1 */
    KANJI,        /* 0x45d2 */
    KANJI,        /* 0x45d3 */
    KANJI,        /* 0x45d4 */
    KANJI,        /* 0x45d5 */
    KANJI,        /* 0x45d6 */
    KANJI,        /* 0x45d7 */
    KANJI,        /* 0x45d8 */
    KANJI,        /* 0x45d9 */
    KANJI,        /* 0x45da */
    KANJI,        /* 0x45db */
    KANJI,        /* 0x45dc */
    KANJI,        /* 0x45dd */
    KANJI,        /* 0x45de */
    KANJI,        /* 0x45df */
    KANJI,        /* 0x45e0 */
    KANJI,        /* 0x45e1 */
    KANJI,        /* 0x45e2 */
    KANJI,        /* 0x45e3 */
    KANJI,        /* 0x45e4 */
    KANJI,        /* 0x45e5 */
    KANJI,        /* 0x45e6 */
    KANJI,        /* 0x45e7 */
    KANJI,        /* 0x45e8 */
    KANJI,        /* 0x45e9 */
    KANJI,        /* 0x45ea */
    KANJI,        /* 0x45eb */
    KANJI,        /* 0x45ec */
    KANJI,        /* 0x45ed */
    KANJI,        /* 0x45ee */
    KANJI,        /* 0x45ef */
    KANJI,        /* 0x45f0 */
    KANJI,        /* 0x45f1 */
    KANJI,        /* 0x45f2 */
    KANJI,        /* 0x45f3 */
    KANJI,        /* 0x45f4 */
    KANJI,        /* 0x45f5 */
    KANJI,        /* 0x45f6 */
    KANJI,        /* 0x45f7 */
    KANJI,        /* 0x45f8 */
    KANJI,        /* 0x45f9 */
    KANJI,        /* 0x45fa */
    KANJI,        /* 0x45fb */
    KANJI,        /* 0x45fc */
    KANJI,        /* 0x45fd */
    KANJI,        /* 0x45fe */
    KANJI,        /* 0x45ff */
    KANJI,        /* 0x4600 */
    KANJI,        /* 0x4601 */
    KANJI,        /* 0x4602 */
    KANJI,        /* 0x4603 */
    KANJI,        /* 0x4604 */
    KANJI,        /* 0x4605 */
    KANJI,        /* 0x4606 */
    KANJI,        /* 0x4607 */
    KANJI,        /* 0x4608 */
    KANJI,        /* 0x4609 */
    KANJI,        /* 0x460a */
    KANJI,        /* 0x460b */
    KANJI,        /* 0x460c */
    KANJI,        /* 0x460d */
    KANJI,        /* 0x460e */
    KANJI,        /* 0x460f */
    KANJI,        /* 0x4610 */
    KANJI,        /* 0x4611 */
    KANJI,        /* 0x4612 */
    KANJI,        /* 0x4613 */
    KANJI,        /* 0x4614 */
    KANJI,        /* 0x4615 */
    KANJI,        /* 0x4616 */
    KANJI,        /* 0x4617 */
    KANJI,        /* 0x4618 */
    KANJI,        /* 0x4619 */
    KANJI,        /* 0x461a */
    KANJI,        /* 0x461b */
    KANJI,        /* 0x461c */
    KANJI,        /* 0x461d */
    KANJI,        /* 0x461e */
    KANJI,        /* 0x461f */
    KANJI,        /* 0x4620 */
    KANJI,        /* 0x4621 */
    KANJI,        /* 0x4622 */
    KANJI,        /* 0x4623 */
    KANJI,        /* 0x4624 */
    KANJI,        /* 0x4625 */
    KANJI,        /* 0x4626 */
    KANJI,        /* 0x4627 */
    KANJI,        /* 0x4628 */
    KANJI,        /* 0x4629 */
    KANJI,        /* 0x462a */
    KANJI,        /* 0x462b */
    KANJI,        /* 0x462c */
    KANJI,        /* 0x462d */
    KANJI,        /* 0x462e */
    KANJI,        /* 0x462f */
    KANJI,        /* 0x4630 */
    KANJI,        /* 0x4631 */
    KANJI,        /* 0x4632 */
    KANJI,        /* 0x4633 */
    KANJI,        /* 0x4634 */
    KANJI,        /* 0x4635 */
    KANJI,        /* 0x4636 */
    KANJI,        /* 0x4637 */
    KANJI,        /* 0x4638 */
    KANJI,        /* 0x4639 */
    KANJI,        /* 0x463a */
    KANJI,        /* 0x463b */
    KANJI,        /* 0x463c */
    KANJI,        /* 0x463d */
    KANJI,        /* 0x463e */
    KANJI,        /* 0x463f */
    KANJI,        /* 0x4640 */
    KANJI,        /* 0x4641 */
    KANJI,        /* 0x4642 */
    KANJI,        /* 0x4643 */
    KANJI,        /* 0x4644 */
    KANJI,        /* 0x4645 */
    KANJI,        /* 0x4646 */
    KANJI,        /* 0x4647 */
    KANJI,        /* 0x4648 */
    KANJI,        /* 0x4649 */
    KANJI,        /* 0x464a */
    KANJI,        /* 0x464b */
    KANJI,        /* 0x464c */
    KANJI,        /* 0x464d */
    KANJI,        /* 0x464e */
    KANJI,        /* 0x464f */
    KANJI,        /* 0x4650 */
    KANJI,        /* 0x4651 */
    KANJI,        /* 0x4652 */
    KANJI,        /* 0x4653 */
    KANJI,        /* 0x4654 */
    KANJI,        /* 0x4655 */
    KANJI,        /* 0x4656 */
    KANJI,        /* 0x4657 */
    KANJI,        /* 0x4658 */
    KANJI,        /* 0x4659 */
    KANJI,        /* 0x465a */
    KANJI,        /* 0x465b */
    KANJI,        /* 0x465c */
    KANJI,        /* 0x465d */
    KANJI,        /* 0x465e */
    KANJI,        /* 0x465f */
    KANJI,        /* 0x4660 */
    KANJI,        /* 0x4661 */
    KANJI,        /* 0x4662 */
    KANJI,        /* 0x4663 */
    KANJI,        /* 0x4664 */
    KANJI,        /* 0x4665 */
    KANJI,        /* 0x4666 */
    KANJI,        /* 0x4667 */
    KANJI,        /* 0x4668 */
    KANJI,        /* 0x4669 */
    KANJI,        /* 0x466a */
    KANJI,        /* 0x466b */
    KANJI,        /* 0x466c */
    KANJI,        /* 0x466d */
    KANJI,        /* 0x466e */
    KANJI,        /* 0x466f */
    KANJI,        /* 0x4670 */
    KANJI,        /* 0x4671 */
    KANJI,        /* 0x4672 */
    KANJI,        /* 0x4673 */
    KANJI,        /* 0x4674 */
    KANJI,        /* 0x4675 */
    KANJI,        /* 0x4676 */
    KANJI,        /* 0x4677 */
    KANJI,        /* 0x4678 */
    KANJI,        /* 0x4679 */
    KANJI,        /* 0x467a */
    KANJI,        /* 0x467b */
    KANJI,        /* 0x467c */
    KANJI,        /* 0x467d */
    KANJI,        /* 0x467e */
    KANJI,        /* 0x467f */
    KANJI,        /* 0x4680 */
    KANJI,        /* 0x4681 */
    KANJI,        /* 0x4682 */
    KANJI,        /* 0x4683 */
    KANJI,        /* 0x4684 */
    KANJI,        /* 0x4685 */
    KANJI,        /* 0x4686 */
    KANJI,        /* 0x4687 */
    KANJI,        /* 0x4688 */
    KANJI,        /* 0x4689 */
    KANJI,        /* 0x468a */
    KANJI,        /* 0x468b */
    KANJI,        /* 0x468c */
    KANJI,        /* 0x468d */
    KANJI,        /* 0x468e */
    KANJI,        /* 0x468f */
    KANJI,        /* 0x4690 */
    KANJI,        /* 0x4691 */
    KANJI,        /* 0x4692 */
    KANJI,        /* 0x4693 */
    KANJI,        /* 0x4694 */
    KANJI,        /* 0x4695 */
    KANJI,        /* 0x4696 */
    KANJI,        /* 0x4697 */
    KANJI,        /* 0x4698 */
    KANJI,        /* 0x4699 */
    KANJI,        /* 0x469a */
    KANJI,        /* 0x469b */
    KANJI,        /* 0x469c */
    KANJI,        /* 0x469d */
    KANJI,        /* 0x469e */
    KANJI,        /* 0x469f */
    KANJI,        /* 0x46a0 */
    KANJI,        /* 0x46a1 */
    KANJI,        /* 0x46a2 */
    KANJI,        /* 0x46a3 */
    KANJI,        /* 0x46a4 */
    KANJI,        /* 0x46a5 */
    KANJI,        /* 0x46a6 */
    KANJI,        /* 0x46a7 */
    KANJI,        /* 0x46a8 */
    KANJI,        /* 0x46a9 */
    KANJI,        /* 0x46aa */
    KANJI,        /* 0x46ab */
    KANJI,        /* 0x46ac */
    KANJI,        /* 0x46ad */
    KANJI,        /* 0x46ae */
    KANJI,        /* 0x46af */
    KANJI,        /* 0x46b0 */
    KANJI,        /* 0x46b1 */
    KANJI,        /* 0x46b2 */
    KANJI,        /* 0x46b3 */
    KANJI,        /* 0x46b4 */
    KANJI,        /* 0x46b5 */
    KANJI,        /* 0x46b6 */
    KANJI,        /* 0x46b7 */
    KANJI,        /* 0x46b8 */
    KANJI,        /* 0x46b9 */
    KANJI,        /* 0x46ba */
    KANJI,        /* 0x46bb */
    KANJI,        /* 0x46bc */
    KANJI,        /* 0x46bd */
    KANJI,        /* 0x46be */
    KANJI,        /* 0x46bf */
    KANJI,        /* 0x46c0 */
    KANJI,        /* 0x46c1 */
    KANJI,        /* 0x46c2 */
    KANJI,        /* 0x46c3 */
    KANJI,        /* 0x46c4 */
    KANJI,        /* 0x46c5 */
    KANJI,        /* 0x46c6 */
    KANJI,        /* 0x46c7 */
    KANJI,        /* 0x46c8 */
    KANJI,        /* 0x46c9 */
    KANJI,        /* 0x46ca */
    KANJI,        /* 0x46cb */
    KANJI,        /* 0x46cc */
    KANJI,        /* 0x46cd */
    KANJI,        /* 0x46ce */
    KANJI,        /* 0x46cf */
    KANJI,        /* 0x46d0 */
    KANJI,        /* 0x46d1 */
    KANJI,        /* 0x46d2 */
    KANJI,        /* 0x46d3 */
    KANJI,        /* 0x46d4 */
    KANJI,        /* 0x46d5 */
    KANJI,        /* 0x46d6 */
    KANJI,        /* 0x46d7 */
    KANJI,        /* 0x46d8 */
    KANJI,        /* 0x46d9 */
    KANJI,        /* 0x46da */
    KANJI,        /* 0x46db */
    KANJI,        /* 0x46dc */
    KANJI,        /* 0x46dd */
    KANJI,        /* 0x46de */
    KANJI,        /* 0x46df */
    KANJI,        /* 0x46e0 */
    KANJI,        /* 0x46e1 */
    KANJI,        /* 0x46e2 */
    KANJI,        /* 0x46e3 */
    KANJI,        /* 0x46e4 */
    KANJI,        /* 0x46e5 */
    KANJI,        /* 0x46e6 */
    KANJI,        /* 0x46e7 */
    KANJI,        /* 0x46e8 */
    KANJI,        /* 0x46e9 */
    KANJI,        /* 0x46ea */
    KANJI,        /* 0x46eb */
    KANJI,        /* 0x46ec */
    KANJI,        /* 0x46ed */
    KANJI,        /* 0x46ee */
    KANJI,        /* 0x46ef */
    KANJI,        /* 0x46f0 */
    KANJI,        /* 0x46f1 */
    KANJI,        /* 0x46f2 */
    KANJI,        /* 0x46f3 */
    KANJI,        /* 0x46f4 */
    KANJI,        /* 0x46f5 */
    KANJI,        /* 0x46f6 */
    KANJI,        /* 0x46f7 */
    KANJI,        /* 0x46f8 */
    KANJI,        /* 0x46f9 */
    KANJI,        /* 0x46fa */
    KANJI,        /* 0x46fb */
    KANJI,        /* 0x46fc */
    KANJI,        /* 0x46fd */
    KANJI,        /* 0x46fe */
    KANJI,        /* 0x46ff */
    KANJI,        /* 0x4700 */
    KANJI,        /* 0x4701 */
    KANJI,        /* 0x4702 */
    KANJI,        /* 0x4703 */
    KANJI,        /* 0x4704 */
    KANJI,        /* 0x4705 */
    KANJI,        /* 0x4706 */
    KANJI,        /* 0x4707 */
    KANJI,        /* 0x4708 */
    KANJI,        /* 0x4709 */
    KANJI,        /* 0x470a */
    KANJI,        /* 0x470b */
    KANJI,        /* 0x470c */
    KANJI,        /* 0x470d */
    KANJI,        /* 0x470e */
    KANJI,        /* 0x470f */
    KANJI,        /* 0x4710 */
    KANJI,        /* 0x4711 */
    KANJI,        /* 0x4712 */
    KANJI,        /* 0x4713 */
    KANJI,        /* 0x4714 */
    KANJI,        /* 0x4715 */
    KANJI,        /* 0x4716 */
    KANJI,        /* 0x4717 */
    KANJI,        /* 0x4718 */
    KANJI,        /* 0x4719 */
    KANJI,        /* 0x471a */
    KANJI,        /* 0x471b */
    KANJI,        /* 0x471c */
    KANJI,        /* 0x471d */
    KANJI,        /* 0x471e */
    KANJI,        /* 0x471f */
    KANJI,        /* 0x4720 */
    KANJI,        /* 0x4721 */
    KANJI,        /* 0x4722 */
    KANJI,        /* 0x4723 */
    KANJI,        /* 0x4724 */
    KANJI,        /* 0x4725 */
    KANJI,        /* 0x4726 */
    KANJI,        /* 0x4727 */
    KANJI,        /* 0x4728 */
    KANJI,        /* 0x4729 */
    KANJI,        /* 0x472a */
    KANJI,        /* 0x472b */
    KANJI,        /* 0x472c */
    KANJI,        /* 0x472d */
    KANJI,        /* 0x472e */
    KANJI,        /* 0x472f */
    KANJI,        /* 0x4730 */
    KANJI,        /* 0x4731 */
    KANJI,        /* 0x4732 */
    KANJI,        /* 0x4733 */
    KANJI,        /* 0x4734 */
    KANJI,        /* 0x4735 */
    KANJI,        /* 0x4736 */
    KANJI,        /* 0x4737 */
    KANJI,        /* 0x4738 */
    KANJI,        /* 0x4739 */
    KANJI,        /* 0x473a */
    KANJI,        /* 0x473b */
    KANJI,        /* 0x473c */
    KANJI,        /* 0x473d */
    KANJI,        /* 0x473e */
    KANJI,        /* 0x473f */
    KANJI,        /* 0x4740 */
    KANJI,        /* 0x4741 */
    KANJI,        /* 0x4742 */
    KANJI,        /* 0x4743 */
    KANJI,        /* 0x4744 */
    KANJI,        /* 0x4745 */
    KANJI,        /* 0x4746 */
    KANJI,        /* 0x4747 */
    KANJI,        /* 0x4748 */
    KANJI,        /* 0x4749 */
    KANJI,        /* 0x474a */
    KANJI,        /* 0x474b */
    KANJI,        /* 0x474c */
    KANJI,        /* 0x474d */
    KANJI,        /* 0x474e */
    KANJI,        /* 0x474f */
    KANJI,        /* 0x4750 */
    KANJI,        /* 0x4751 */
    KANJI,        /* 0x4752 */
    KANJI,        /* 0x4753 */
    KANJI,        /* 0x4754 */
    KANJI,        /* 0x4755 */
    KANJI,        /* 0x4756 */
    KANJI,        /* 0x4757 */
    KANJI,        /* 0x4758 */
    KANJI,        /* 0x4759 */
    KANJI,        /* 0x475a */
    KANJI,        /* 0x475b */
    KANJI,        /* 0x475c */
    KANJI,        /* 0x475d */
    KANJI,        /* 0x475e */
    KANJI,        /* 0x475f */
    KANJI,        /* 0x4760 */
    KANJI,        /* 0x4761 */
    KANJI,        /* 0x4762 */
    KANJI,        /* 0x4763 */
    KANJI,        /* 0x4764 */
    KANJI,        /* 0x4765 */
    KANJI,        /* 0x4766 */
    KANJI,        /* 0x4767 */
    KANJI,        /* 0x4768 */
    KANJI,        /* 0x4769 */
    KANJI,        /* 0x476a */
    KANJI,        /* 0x476b */
    KANJI,        /* 0x476c */
    KANJI,        /* 0x476d */
    KANJI,        /* 0x476e */
    KANJI,        /* 0x476f */
    KANJI,        /* 0x4770 */
    KANJI,        /* 0x4771 */
    KANJI,        /* 0x4772 */
    KANJI,        /* 0x4773 */
    KANJI,        /* 0x4774 */
    KANJI,        /* 0x4775 */
    KANJI,        /* 0x4776 */
    KANJI,        /* 0x4777 */
    KANJI,        /* 0x4778 */
    KANJI,        /* 0x4779 */
    KANJI,        /* 0x477a */
    KANJI,        /* 0x477b */
    KANJI,        /* 0x477c */
    KANJI,        /* 0x477d */
    KANJI,        /* 0x477e */
    KANJI,        /* 0x477f */
    KANJI,        /* 0x4780 */
    KANJI,        /* 0x4781 */
    KANJI,        /* 0x4782 */
    KANJI,        /* 0x4783 */
    KANJI,        /* 0x4784 */
    KANJI,        /* 0x4785 */
    KANJI,        /* 0x4786 */
    KANJI,        /* 0x4787 */
    KANJI,        /* 0x4788 */
    KANJI,        /* 0x4789 */
    KANJI,        /* 0x478a */
    KANJI,        /* 0x478b */
    KANJI,        /* 0x478c */
    KANJI,        /* 0x478d */
    KANJI,        /* 0x478e */
    KANJI,        /* 0x478f */
    KANJI,        /* 0x4790 */
    KANJI,        /* 0x4791 */
    KANJI,        /* 0x4792 */
    KANJI,        /* 0x4793 */
    KANJI,        /* 0x4794 */
    KANJI,        /* 0x4795 */
    KANJI,        /* 0x4796 */
    KANJI,        /* 0x4797 */
    KANJI,        /* 0x4798 */
    KANJI,        /* 0x4799 */
    KANJI,        /* 0x479a */
    KANJI,        /* 0x479b */
    KANJI,        /* 0x479c */
    KANJI,        /* 0x479d */
    KANJI,        /* 0x479e */
    KANJI,        /* 0x479f */
    KANJI,        /* 0x47a0 */
    KANJI,        /* 0x47a1 */
    KANJI,        /* 0x47a2 */
    KANJI,        /* 0x47a3 */
    KANJI,        /* 0x47a4 */
    KANJI,        /* 0x47a5 */
    KANJI,        /* 0x47a6 */
    KANJI,        /* 0x47a7 */
    KANJI,        /* 0x47a8 */
    KANJI,        /* 0x47a9 */
    KANJI,        /* 0x47aa */
    KANJI,        /* 0x47ab */
    KANJI,        /* 0x47ac */
    KANJI,        /* 0x47ad */
    KANJI,        /* 0x47ae */
    KANJI,        /* 0x47af */
    KANJI,        /* 0x47b0 */
    KANJI,        /* 0x47b1 */
    KANJI,        /* 0x47b2 */
    KANJI,        /* 0x47b3 */
    KANJI,        /* 0x47b4 */
    KANJI,        /* 0x47b5 */
    KANJI,        /* 0x47b6 */
    KANJI,        /* 0x47b7 */
    KANJI,        /* 0x47b8 */
    KANJI,        /* 0x47b9 */
    KANJI,        /* 0x47ba */
    KANJI,        /* 0x47bb */
    KANJI,        /* 0x47bc */
    KANJI,        /* 0x47bd */
    KANJI,        /* 0x47be */
    KANJI,        /* 0x47bf */
    KANJI,        /* 0x47c0 */
    KANJI,        /* 0x47c1 */
    KANJI,        /* 0x47c2 */
    KANJI,        /* 0x47c3 */
    KANJI,        /* 0x47c4 */
    KANJI,        /* 0x47c5 */
    KANJI,        /* 0x47c6 */
    KANJI,        /* 0x47c7 */
    KANJI,        /* 0x47c8 */
    KANJI,        /* 0x47c9 */
    KANJI,        /* 0x47ca */
    KANJI,        /* 0x47cb */
    KANJI,        /* 0x47cc */
    KANJI,        /* 0x47cd */
    KANJI,        /* 0x47ce */
    KANJI,        /* 0x47cf */
    KANJI,        /* 0x47d0 */
    KANJI,        /* 0x47d1 */
    KANJI,        /* 0x47d2 */
    KANJI,        /* 0x47d3 */
    KANJI,        /* 0x47d4 */
    KANJI,        /* 0x47d5 */
    KANJI,        /* 0x47d6 */
    KANJI,        /* 0x47d7 */
    KANJI,        /* 0x47d8 */
    KANJI,        /* 0x47d9 */
    KANJI,        /* 0x47da */
    KANJI,        /* 0x47db */
    KANJI,        /* 0x47dc */
    KANJI,        /* 0x47dd */
    KANJI,        /* 0x47de */
    KANJI,        /* 0x47df */
    KANJI,        /* 0x47e0 */
    KANJI,        /* 0x47e1 */
    KANJI,        /* 0x47e2 */
    KANJI,        /* 0x47e3 */
    KANJI,        /* 0x47e4 */
    KANJI,        /* 0x47e5 */
    KANJI,        /* 0x47e6 */
    KANJI,        /* 0x47e7 */
    KANJI,        /* 0x47e8 */
    KANJI,        /* 0x47e9 */
    KANJI,        /* 0x47ea */
    KANJI,        /* 0x47eb */
    KANJI,        /* 0x47ec */
    KANJI,        /* 0x47ed */
    KANJI,        /* 0x47ee */
    KANJI,        /* 0x47ef */
    KANJI,        /* 0x47f0 */
    KANJI,        /* 0x47f1 */
    KANJI,        /* 0x47f2 */
    KANJI,        /* 0x47f3 */
    KANJI,        /* 0x47f4 */
    KANJI,        /* 0x47f5 */
    KANJI,        /* 0x47f6 */
    KANJI,        /* 0x47f7 */
    KANJI,        /* 0x47f8 */
    KANJI,        /* 0x47f9 */
    KANJI,        /* 0x47fa */
    KANJI,        /* 0x47fb */
    KANJI,        /* 0x47fc */
    KANJI,        /* 0x47fd */
    KANJI,        /* 0x47fe */
    KANJI,        /* 0x47ff */
    KANJI,        /* 0x4800 */
    KANJI,        /* 0x4801 */
    KANJI,        /* 0x4802 */
    KANJI,        /* 0x4803 */
    KANJI,        /* 0x4804 */
    KANJI,        /* 0x4805 */
    KANJI,        /* 0x4806 */
    KANJI,        /* 0x4807 */
    KANJI,        /* 0x4808 */
    KANJI,        /* 0x4809 */
    KANJI,        /* 0x480a */
    KANJI,        /* 0x480b */
    KANJI,        /* 0x480c */
    KANJI,        /* 0x480d */
    KANJI,        /* 0x480e */
    KANJI,        /* 0x480f */
    KANJI,        /* 0x4810 */
    KANJI,        /* 0x4811 */
    KANJI,        /* 0x4812 */
    KANJI,        /* 0x4813 */
    KANJI,        /* 0x4814 */
    KANJI,        /* 0x4815 */
    KANJI,        /* 0x4816 */
    KANJI,        /* 0x4817 */
    KANJI,        /* 0x4818 */
    KANJI,        /* 0x4819 */
    KANJI,        /* 0x481a */
    KANJI,        /* 0x481b */
    KANJI,        /* 0x481c */
    KANJI,        /* 0x481d */
    KANJI,        /* 0x481e */
    KANJI,        /* 0x481f */
    KANJI,        /* 0x4820 */
    KANJI,        /* 0x4821 */
    KANJI,        /* 0x4822 */
    KANJI,        /* 0x4823 */
    KANJI,        /* 0x4824 */
    KANJI,        /* 0x4825 */
    KANJI,        /* 0x4826 */
    KANJI,        /* 0x4827 */
    KANJI,        /* 0x4828 */
    KANJI,        /* 0x4829 */
    KANJI,        /* 0x482a */
    KANJI,        /* 0x482b */
    KANJI,        /* 0x482c */
    KANJI,        /* 0x482d */
    KANJI,        /* 0x482e */
    KANJI,        /* 0x482f */
    KANJI,        /* 0x4830 */
    KANJI,        /* 0x4831 */
    KANJI,        /* 0x4832 */
    KANJI,        /* 0x4833 */
    KANJI,        /* 0x4834 */
    KANJI,        /* 0x4835 */
    KANJI,        /* 0x4836 */
    KANJI,        /* 0x4837 */
    KANJI,        /* 0x4838 */
    KANJI,        /* 0x4839 */
    KANJI,        /* 0x483a */
    KANJI,        /* 0x483b */
    KANJI,        /* 0x483c */
    KANJI,        /* 0x483d */
    KANJI,        /* 0x483e */
    KANJI,        /* 0x483f */
    KANJI,        /* 0x4840 */
    KANJI,        /* 0x4841 */
    KANJI,        /* 0x4842 */
    KANJI,        /* 0x4843 */
    KANJI,        /* 0x4844 */
    KANJI,        /* 0x4845 */
    KANJI,        /* 0x4846 */
    KANJI,        /* 0x4847 */
    KANJI,        /* 0x4848 */
    KANJI,        /* 0x4849 */
    KANJI,        /* 0x484a */
    KANJI,        /* 0x484b */
    KANJI,        /* 0x484c */
    KANJI,        /* 0x484d */
    KANJI,        /* 0x484e */
    KANJI,        /* 0x484f */
    KANJI,        /* 0x4850 */
    KANJI,        /* 0x4851 */
    KANJI,        /* 0x4852 */
    KANJI,        /* 0x4853 */
    KANJI,        /* 0x4854 */
    KANJI,        /* 0x4855 */
    KANJI,        /* 0x4856 */
    KANJI,        /* 0x4857 */
    KANJI,        /* 0x4858 */
    KANJI,        /* 0x4859 */
    KANJI,        /* 0x485a */
    KANJI,        /* 0x485b */
    KANJI,        /* 0x485c */
    KANJI,        /* 0x485d */
    KANJI,        /* 0x485e */
    KANJI,        /* 0x485f */
    KANJI,        /* 0x4860 */
    KANJI,        /* 0x4861 */
    KANJI,        /* 0x4862 */
    KANJI,        /* 0x4863 */
    KANJI,        /* 0x4864 */
    KANJI,        /* 0x4865 */
    KANJI,        /* 0x4866 */
    KANJI,        /* 0x4867 */
    KANJI,        /* 0x4868 */
    KANJI,        /* 0x4869 */
    KANJI,        /* 0x486a */
    KANJI,        /* 0x486b */
    KANJI,        /* 0x486c */
    KANJI,        /* 0x486d */
    KANJI,        /* 0x486e */
    KANJI,        /* 0x486f */
    KANJI,        /* 0x4870 */
    KANJI,        /* 0x4871 */
    KANJI,        /* 0x4872 */
    KANJI,        /* 0x4873 */
    KANJI,        /* 0x4874 */
    KANJI,        /* 0x4875 */
    KANJI,        /* 0x4876 */
    KANJI,        /* 0x4877 */
    KANJI,        /* 0x4878 */
    KANJI,        /* 0x4879 */
    KANJI,        /* 0x487a */
    KANJI,        /* 0x487b */
    KANJI,        /* 0x487c */
    KANJI,        /* 0x487d */
    KANJI,        /* 0x487e */
    KANJI,        /* 0x487f */
    KANJI,        /* 0x4880 */
    KANJI,        /* 0x4881 */
    KANJI,        /* 0x4882 */
    KANJI,        /* 0x4883 */
    KANJI,        /* 0x4884 */
    KANJI,        /* 0x4885 */
    KANJI,        /* 0x4886 */
    KANJI,        /* 0x4887 */
    KANJI,        /* 0x4888 */
    KANJI,        /* 0x4889 */
    KANJI,        /* 0x488a */
    KANJI,        /* 0x488b */
    KANJI,        /* 0x488c */
    KANJI,        /* 0x488d */
    KANJI,        /* 0x488e */
    KANJI,        /* 0x488f */
    KANJI,        /* 0x4890 */
    KANJI,        /* 0x4891 */
    KANJI,        /* 0x4892 */
    KANJI,        /* 0x4893 */
    KANJI,        /* 0x4894 */
    KANJI,        /* 0x4895 */
    KANJI,        /* 0x4896 */
    KANJI,        /* 0x4897 */
    KANJI,        /* 0x4898 */
    KANJI,        /* 0x4899 */
    KANJI,        /* 0x489a */
    KANJI,        /* 0x489b */
    KANJI,        /* 0x489c */
    KANJI,        /* 0x489d */
    KANJI,        /* 0x489e */
    KANJI,        /* 0x489f */
    KANJI,        /* 0x48a0 */
    KANJI,        /* 0x48a1 */
    KANJI,        /* 0x48a2 */
    KANJI,        /* 0x48a3 */
    KANJI,        /* 0x48a4 */
    KANJI,        /* 0x48a5 */
    KANJI,        /* 0x48a6 */
    KANJI,        /* 0x48a7 */
    KANJI,        /* 0x48a8 */
    KANJI,        /* 0x48a9 */
    KANJI,        /* 0x48aa */
    KANJI,        /* 0x48ab */
    KANJI,        /* 0x48ac */
    KANJI,        /* 0x48ad */
    KANJI,        /* 0x48ae */
    KANJI,        /* 0x48af */
    KANJI,        /* 0x48b0 */
    KANJI,        /* 0x48b1 */
    KANJI,        /* 0x48b2 */
    KANJI,        /* 0x48b3 */
    KANJI,        /* 0x48b4 */
    KANJI,        /* 0x48b5 */
    KANJI,        /* 0x48b6 */
    KANJI,        /* 0x48b7 */
    KANJI,        /* 0x48b8 */
    KANJI,        /* 0x48b9 */
    KANJI,        /* 0x48ba */
    KANJI,        /* 0x48bb */
    KANJI,        /* 0x48bc */
    KANJI,        /* 0x48bd */
    KANJI,        /* 0x48be */
    KANJI,        /* 0x48bf */
    KANJI,        /* 0x48c0 */
    KANJI,        /* 0x48c1 */
    KANJI,        /* 0x48c2 */
    KANJI,        /* 0x48c3 */
    KANJI,        /* 0x48c4 */
    KANJI,        /* 0x48c5 */
    KANJI,        /* 0x48c6 */
    KANJI,        /* 0x48c7 */
    KANJI,        /* 0x48c8 */
    KANJI,        /* 0x48c9 */
    KANJI,        /* 0x48ca */
    KANJI,        /* 0x48cb */
    KANJI,        /* 0x48cc */
    KANJI,        /* 0x48cd */
    KANJI,        /* 0x48ce */
    KANJI,        /* 0x48cf */
    KANJI,        /* 0x48d0 */
    KANJI,        /* 0x48d1 */
    KANJI,        /* 0x48d2 */
    KANJI,        /* 0x48d3 */
    KANJI,        /* 0x48d4 */
    KANJI,        /* 0x48d5 */
    KANJI,        /* 0x48d6 */
    KANJI,        /* 0x48d7 */
    KANJI,        /* 0x48d8 */
    KANJI,        /* 0x48d9 */
    KANJI,        /* 0x48da */
    KANJI,        /* 0x48db */
    KANJI,        /* 0x48dc */
    KANJI,        /* 0x48dd */
    KANJI,        /* 0x48de */
    KANJI,        /* 0x48df */
    KANJI,        /* 0x48e0 */
    KANJI,        /* 0x48e1 */
    KANJI,        /* 0x48e2 */
    KANJI,        /* 0x48e3 */
    KANJI,        /* 0x48e4 */
    KANJI,        /* 0x48e5 */
    KANJI,        /* 0x48e6 */
    KANJI,        /* 0x48e7 */
    KANJI,        /* 0x48e8 */
    KANJI,        /* 0x48e9 */
    KANJI,        /* 0x48ea */
    KANJI,        /* 0x48eb */
    KANJI,        /* 0x48ec */
    KANJI,        /* 0x48ed */
    KANJI,        /* 0x48ee */
    KANJI,        /* 0x48ef */
    KANJI,        /* 0x48f0 */
    KANJI,        /* 0x48f1 */
    KANJI,        /* 0x48f2 */
    KANJI,        /* 0x48f3 */
    KANJI,        /* 0x48f4 */
    KANJI,        /* 0x48f5 */
    KANJI,        /* 0x48f6 */
    KANJI,        /* 0x48f7 */
    KANJI,        /* 0x48f8 */
    KANJI,        /* 0x48f9 */
    KANJI,        /* 0x48fa */
    KANJI,        /* 0x48fb */
    KANJI,        /* 0x48fc */
    KANJI,        /* 0x48fd */
    KANJI,        /* 0x48fe */
    KANJI,        /* 0x48ff */
    KANJI,        /* 0x4900 */
    KANJI,        /* 0x4901 */
    KANJI,        /* 0x4902 */
    KANJI,        /* 0x4903 */
    KANJI,        /* 0x4904 */
    KANJI,        /* 0x4905 */
    KANJI,        /* 0x4906 */
    KANJI,        /* 0x4907 */
    KANJI,        /* 0x4908 */
    KANJI,        /* 0x4909 */
    KANJI,        /* 0x490a */
    KANJI,        /* 0x490b */
    KANJI,        /* 0x490c */
    KANJI,        /* 0x490d */
    KANJI,        /* 0x490e */
    KANJI,        /* 0x490f */
    KANJI,        /* 0x4910 */
    KANJI,        /* 0x4911 */
    KANJI,        /* 0x4912 */
    KANJI,        /* 0x4913 */
    KANJI,        /* 0x4914 */
    KANJI,        /* 0x4915 */
    KANJI,        /* 0x4916 */
    KANJI,        /* 0x4917 */
    KANJI,        /* 0x4918 */
    KANJI,        /* 0x4919 */
    KANJI,        /* 0x491a */
    KANJI,        /* 0x491b */
    KANJI,        /* 0x491c */
    KANJI,        /* 0x491d */
    KANJI,        /* 0x491e */
    KANJI,        /* 0x491f */
    KANJI,        /* 0x4920 */
    KANJI,        /* 0x4921 */
    KANJI,        /* 0x4922 */
    KANJI,        /* 0x4923 */
    KANJI,        /* 0x4924 */
    KANJI,        /* 0x4925 */
    KANJI,        /* 0x4926 */
    KANJI,        /* 0x4927 */
    KANJI,        /* 0x4928 */
    KANJI,        /* 0x4929 */
    KANJI,        /* 0x492a */
    KANJI,        /* 0x492b */
    KANJI,        /* 0x492c */
    KANJI,        /* 0x492d */
    KANJI,        /* 0x492e */
    KANJI,        /* 0x492f */
    KANJI,        /* 0x4930 */
    KANJI,        /* 0x4931 */
    KANJI,        /* 0x4932 */
    KANJI,        /* 0x4933 */
    KANJI,        /* 0x4934 */
    KANJI,        /* 0x4935 */
    KANJI,        /* 0x4936 */
    KANJI,        /* 0x4937 */
    KANJI,        /* 0x4938 */
    KANJI,        /* 0x4939 */
    KANJI,        /* 0x493a */
    KANJI,        /* 0x493b */
    KANJI,        /* 0x493c */
    KANJI,        /* 0x493d */
    KANJI,        /* 0x493e */
    KANJI,        /* 0x493f */
    KANJI,        /* 0x4940 */
    KANJI,        /* 0x4941 */
    KANJI,        /* 0x4942 */
    KANJI,        /* 0x4943 */
    KANJI,        /* 0x4944 */
    KANJI,        /* 0x4945 */
    KANJI,        /* 0x4946 */
    KANJI,        /* 0x4947 */
    KANJI,        /* 0x4948 */
    KANJI,        /* 0x4949 */
    KANJI,        /* 0x494a */
    KANJI,        /* 0x494b */
    KANJI,        /* 0x494c */
    KANJI,        /* 0x494d */
    KANJI,        /* 0x494e */
    KANJI,        /* 0x494f */
    KANJI,        /* 0x4950 */
    KANJI,        /* 0x4951 */
    KANJI,        /* 0x4952 */
    KANJI,        /* 0x4953 */
    KANJI,        /* 0x4954 */
    KANJI,        /* 0x4955 */
    KANJI,        /* 0x4956 */
    KANJI,        /* 0x4957 */
    KANJI,        /* 0x4958 */
    KANJI,        /* 0x4959 */
    KANJI,        /* 0x495a */
    KANJI,        /* 0x495b */
    KANJI,        /* 0x495c */
    KANJI,        /* 0x495d */
    KANJI,        /* 0x495e */
    KANJI,        /* 0x495f */
    KANJI,        /* 0x4960 */
    KANJI,        /* 0x4961 */
    KANJI,        /* 0x4962 */
    KANJI,        /* 0x4963 */
    KANJI,        /* 0x4964 */
    KANJI,        /* 0x4965 */
    KANJI,        /* 0x4966 */
    KANJI,        /* 0x4967 */
    KANJI,        /* 0x4968 */
    KANJI,        /* 0x4969 */
    KANJI,        /* 0x496a */
    KANJI,        /* 0x496b */
    KANJI,        /* 0x496c */
    KANJI,        /* 0x496d */
    KANJI,        /* 0x496e */
    KANJI,        /* 0x496f */
    KANJI,        /* 0x4970 */
    KANJI,        /* 0x4971 */
    KANJI,        /* 0x4972 */
    KANJI,        /* 0x4973 */
    KANJI,        /* 0x4974 */
    KANJI,        /* 0x4975 */
    KANJI,        /* 0x4976 */
    KANJI,        /* 0x4977 */
    KANJI,        /* 0x4978 */
    KANJI,        /* 0x4979 */
    KANJI,        /* 0x497a */
    KANJI,        /* 0x497b */
    KANJI,        /* 0x497c */
    KANJI,        /* 0x497d */
    KANJI,        /* 0x497e */
    KANJI,        /* 0x497f */
    KANJI,        /* 0x4980 */
    KANJI,        /* 0x4981 */
    KANJI,        /* 0x4982 */
    KANJI,        /* 0x4983 */
    KANJI,        /* 0x4984 */
    KANJI,        /* 0x4985 */
    KANJI,        /* 0x4986 */
    KANJI,        /* 0x4987 */
    KANJI,        /* 0x4988 */
    KANJI,        /* 0x4989 */
    KANJI,        /* 0x498a */
    KANJI,        /* 0x498b */
    KANJI,        /* 0x498c */
    KANJI,        /* 0x498d */
    KANJI,        /* 0x498e */
    KANJI,        /* 0x498f */
    KANJI,        /* 0x4990 */
    KANJI,        /* 0x4991 */
    KANJI,        /* 0x4992 */
    KANJI,        /* 0x4993 */
    KANJI,        /* 0x4994 */
    KANJI,        /* 0x4995 */
    KANJI,        /* 0x4996 */
    KANJI,        /* 0x4997 */
    KANJI,        /* 0x4998 */
    KANJI,        /* 0x4999 */
    KANJI,        /* 0x499a */
    KANJI,        /* 0x499b */
    KANJI,        /* 0x499c */
    KANJI,        /* 0x499d */
    KANJI,        /* 0x499e */
    KANJI,        /* 0x499f */
    KANJI,        /* 0x49a0 */
    KANJI,        /* 0x49a1 */
    KANJI,        /* 0x49a2 */
    KANJI,        /* 0x49a3 */
    KANJI,        /* 0x49a4 */
    KANJI,        /* 0x49a5 */
    KANJI,        /* 0x49a6 */
    KANJI,        /* 0x49a7 */
    KANJI,        /* 0x49a8 */
    KANJI,        /* 0x49a9 */
    KANJI,        /* 0x49aa */
    KANJI,        /* 0x49ab */
    KANJI,        /* 0x49ac */
    KANJI,        /* 0x49ad */
    KANJI,        /* 0x49ae */
    KANJI,        /* 0x49af */
    KANJI,        /* 0x49b0 */
    KANJI,        /* 0x49b1 */
    KANJI,        /* 0x49b2 */
    KANJI,        /* 0x49b3 */
    KANJI,        /* 0x49b4 */
    KANJI,        /* 0x49b5 */
    KANJI,        /* 0x49b6 */
    KANJI,        /* 0x49b7 */
    KANJI,        /* 0x49b8 */
    KANJI,        /* 0x49b9 */
    KANJI,        /* 0x49ba */
    KANJI,        /* 0x49bb */
    KANJI,        /* 0x49bc */
    KANJI,        /* 0x49bd */
    KANJI,        /* 0x49be */
    KANJI,        /* 0x49bf */
    KANJI,        /* 0x49c0 */
    KANJI,        /* 0x49c1 */
    KANJI,        /* 0x49c2 */
    KANJI,        /* 0x49c3 */
    KANJI,        /* 0x49c4 */
    KANJI,        /* 0x49c5 */
    KANJI,        /* 0x49c6 */
    KANJI,        /* 0x49c7 */
    KANJI,        /* 0x49c8 */
    KANJI,        /* 0x49c9 */
    KANJI,        /* 0x49ca */
    KANJI,        /* 0x49cb */
    KANJI,        /* 0x49cc */
    KANJI,        /* 0x49cd */
    KANJI,        /* 0x49ce */
    KANJI,        /* 0x49cf */
    KANJI,        /* 0x49d0 */
    KANJI,        /* 0x49d1 */
    KANJI,        /* 0x49d2 */
    KANJI,        /* 0x49d3 */
    KANJI,        /* 0x49d4 */
    KANJI,        /* 0x49d5 */
    KANJI,        /* 0x49d6 */
    KANJI,        /* 0x49d7 */
    KANJI,        /* 0x49d8 */
    KANJI,        /* 0x49d9 */
    KANJI,        /* 0x49da */
    KANJI,        /* 0x49db */
    KANJI,        /* 0x49dc */
    KANJI,        /* 0x49dd */
    KANJI,        /* 0x49de */
    KANJI,        /* 0x49df */
    KANJI,        /* 0x49e0 */
    KANJI,        /* 0x49e1 */
    KANJI,        /* 0x49e2 */
    KANJI,        /* 0x49e3 */
    KANJI,        /* 0x49e4 */
    KANJI,        /* 0x49e5 */
    KANJI,        /* 0x49e6 */
    KANJI,        /* 0x49e7 */
    KANJI,        /* 0x49e8 */
    KANJI,        /* 0x49e9 */
    KANJI,        /* 0x49ea */
    KANJI,        /* 0x49eb */
    KANJI,        /* 0x49ec */
    KANJI,        /* 0x49ed */
    KANJI,        /* 0x49ee */
    KANJI,        /* 0x49ef */
    KANJI,        /* 0x49f0 */
    KANJI,        /* 0x49f1 */
    KANJI,        /* 0x49f2 */
    KANJI,        /* 0x49f3 */
    KANJI,        /* 0x49f4 */
    KANJI,        /* 0x49f5 */
    KANJI,        /* 0x49f6 */
    KANJI,        /* 0x49f7 */
    KANJI,        /* 0x49f8 */
    KANJI,        /* 0x49f9 */
    KANJI,        /* 0x49fa */
    KANJI,        /* 0x49fb */
    KANJI,        /* 0x49fc */
    KANJI,        /* 0x49fd */
    KANJI,        /* 0x49fe */
    KANJI,        /* 0x49ff */
    KANJI,        /* 0x4a00 */
    KANJI,        /* 0x4a01 */
    KANJI,        /* 0x4a02 */
    KANJI,        /* 0x4a03 */
    KANJI,        /* 0x4a04 */
    KANJI,        /* 0x4a05 */
    KANJI,        /* 0x4a06 */
    KANJI,        /* 0x4a07 */
    KANJI,        /* 0x4a08 */
    KANJI,        /* 0x4a09 */
    KANJI,        /* 0x4a0a */
    KANJI,        /* 0x4a0b */
    KANJI,        /* 0x4a0c */
    KANJI,        /* 0x4a0d */
    KANJI,        /* 0x4a0e */
    KANJI,        /* 0x4a0f */
    KANJI,        /* 0x4a10 */
    KANJI,        /* 0x4a11 */
    KANJI,        /* 0x4a12 */
    KANJI,        /* 0x4a13 */
    KANJI,        /* 0x4a14 */
    KANJI,        /* 0x4a15 */
    KANJI,        /* 0x4a16 */
    KANJI,        /* 0x4a17 */
    KANJI,        /* 0x4a18 */
    KANJI,        /* 0x4a19 */
    KANJI,        /* 0x4a1a */
    KANJI,        /* 0x4a1b */
    KANJI,        /* 0x4a1c */
    KANJI,        /* 0x4a1d */
    KANJI,        /* 0x4a1e */
    KANJI,        /* 0x4a1f */
    KANJI,        /* 0x4a20 */
    KANJI,        /* 0x4a21 */
    KANJI,        /* 0x4a22 */
    KANJI,        /* 0x4a23 */
    KANJI,        /* 0x4a24 */
    KANJI,        /* 0x4a25 */
    KANJI,        /* 0x4a26 */
    KANJI,        /* 0x4a27 */
    KANJI,        /* 0x4a28 */
    KANJI,        /* 0x4a29 */
    KANJI,        /* 0x4a2a */
    KANJI,        /* 0x4a2b */
    KANJI,        /* 0x4a2c */
    KANJI,        /* 0x4a2d */
    KANJI,        /* 0x4a2e */
    KANJI,        /* 0x4a2f */
    KANJI,        /* 0x4a30 */
    KANJI,        /* 0x4a31 */
    KANJI,        /* 0x4a32 */
    KANJI,        /* 0x4a33 */
    KANJI,        /* 0x4a34 */
    KANJI,        /* 0x4a35 */
    KANJI,        /* 0x4a36 */
    KANJI,        /* 0x4a37 */
    KANJI,        /* 0x4a38 */
    KANJI,        /* 0x4a39 */
    KANJI,        /* 0x4a3a */
    KANJI,        /* 0x4a3b */
    KANJI,        /* 0x4a3c */
    KANJI,        /* 0x4a3d */
    KANJI,        /* 0x4a3e */
    KANJI,        /* 0x4a3f */
    KANJI,        /* 0x4a40 */
    KANJI,        /* 0x4a41 */
    KANJI,        /* 0x4a42 */
    KANJI,        /* 0x4a43 */
    KANJI,        /* 0x4a44 */
    KANJI,        /* 0x4a45 */
    KANJI,        /* 0x4a46 */
    KANJI,        /* 0x4a47 */
    KANJI,        /* 0x4a48 */
    KANJI,        /* 0x4a49 */
    KANJI,        /* 0x4a4a */
    KANJI,        /* 0x4a4b */
    KANJI,        /* 0x4a4c */
    KANJI,        /* 0x4a4d */
    KANJI,        /* 0x4a4e */
    KANJI,        /* 0x4a4f */
    KANJI,        /* 0x4a50 */
    KANJI,        /* 0x4a51 */
    KANJI,        /* 0x4a52 */
    KANJI,        /* 0x4a53 */
    KANJI,        /* 0x4a54 */
    KANJI,        /* 0x4a55 */
    KANJI,        /* 0x4a56 */
    KANJI,        /* 0x4a57 */
    KANJI,        /* 0x4a58 */
    KANJI,        /* 0x4a59 */
    KANJI,        /* 0x4a5a */
    KANJI,        /* 0x4a5b */
    KANJI,        /* 0x4a5c */
    KANJI,        /* 0x4a5d */
    KANJI,        /* 0x4a5e */
    KANJI,        /* 0x4a5f */
    KANJI,        /* 0x4a60 */
    KANJI,        /* 0x4a61 */
    KANJI,        /* 0x4a62 */
    KANJI,        /* 0x4a63 */
    KANJI,        /* 0x4a64 */
    KANJI,        /* 0x4a65 */
    KANJI,        /* 0x4a66 */
    KANJI,        /* 0x4a67 */
    KANJI,        /* 0x4a68 */
    KANJI,        /* 0x4a69 */
    KANJI,        /* 0x4a6a */
    KANJI,        /* 0x4a6b */
    KANJI,        /* 0x4a6c */
    KANJI,        /* 0x4a6d */
    KANJI,        /* 0x4a6e */
    KANJI,        /* 0x4a6f */
    KANJI,        /* 0x4a70 */
    KANJI,        /* 0x4a71 */
    KANJI,        /* 0x4a72 */
    KANJI,        /* 0x4a73 */
    KANJI,        /* 0x4a74 */
    KANJI,        /* 0x4a75 */
    KANJI,        /* 0x4a76 */
    KANJI,        /* 0x4a77 */
    KANJI,        /* 0x4a78 */
    KANJI,        /* 0x4a79 */
    KANJI,        /* 0x4a7a */
    KANJI,        /* 0x4a7b */
    KANJI,        /* 0x4a7c */
    KANJI,        /* 0x4a7d */
    KANJI,        /* 0x4a7e */
    KANJI,        /* 0x4a7f */
    KANJI,        /* 0x4a80 */
    KANJI,        /* 0x4a81 */
    KANJI,        /* 0x4a82 */
    KANJI,        /* 0x4a83 */
    KANJI,        /* 0x4a84 */
    KANJI,        /* 0x4a85 */
    KANJI,        /* 0x4a86 */
    KANJI,        /* 0x4a87 */
    KANJI,        /* 0x4a88 */
    KANJI,        /* 0x4a89 */
    KANJI,        /* 0x4a8a */
    KANJI,        /* 0x4a8b */
    KANJI,        /* 0x4a8c */
    KANJI,        /* 0x4a8d */
    KANJI,        /* 0x4a8e */
    KANJI,        /* 0x4a8f */
    KANJI,        /* 0x4a90 */
    KANJI,        /* 0x4a91 */
    KANJI,        /* 0x4a92 */
    KANJI,        /* 0x4a93 */
    KANJI,        /* 0x4a94 */
    KANJI,        /* 0x4a95 */
    KANJI,        /* 0x4a96 */
    KANJI,        /* 0x4a97 */
    KANJI,        /* 0x4a98 */
    KANJI,        /* 0x4a99 */
    KANJI,        /* 0x4a9a */
    KANJI,        /* 0x4a9b */
    KANJI,        /* 0x4a9c */
    KANJI,        /* 0x4a9d */
    KANJI,        /* 0x4a9e */
    KANJI,        /* 0x4a9f */
    KANJI,        /* 0x4aa0 */
    KANJI,        /* 0x4aa1 */
    KANJI,        /* 0x4aa2 */
    KANJI,        /* 0x4aa3 */
    KANJI,        /* 0x4aa4 */
    KANJI,        /* 0x4aa5 */
    KANJI,        /* 0x4aa6 */
    KANJI,        /* 0x4aa7 */
    KANJI,        /* 0x4aa8 */
    KANJI,        /* 0x4aa9 */
    KANJI,        /* 0x4aaa */
    KANJI,        /* 0x4aab */
    KANJI,        /* 0x4aac */
    KANJI,        /* 0x4aad */
    KANJI,        /* 0x4aae */
    KANJI,        /* 0x4aaf */
    KANJI,        /* 0x4ab0 */
    KANJI,        /* 0x4ab1 */
    KANJI,        /* 0x4ab2 */
    KANJI,        /* 0x4ab3 */
    KANJI,        /* 0x4ab4 */
    KANJI,        /* 0x4ab5 */
    KANJI,        /* 0x4ab6 */
    KANJI,        /* 0x4ab7 */
    KANJI,        /* 0x4ab8 */
    KANJI,        /* 0x4ab9 */
    KANJI,        /* 0x4aba */
    KANJI,        /* 0x4abb */
    KANJI,        /* 0x4abc */
    KANJI,        /* 0x4abd */
    KANJI,        /* 0x4abe */
    KANJI,        /* 0x4abf */
    KANJI,        /* 0x4ac0 */
    KANJI,        /* 0x4ac1 */
    KANJI,        /* 0x4ac2 */
    KANJI,        /* 0x4ac3 */
    KANJI,        /* 0x4ac4 */
    KANJI,        /* 0x4ac5 */
    KANJI,        /* 0x4ac6 */
    KANJI,        /* 0x4ac7 */
    KANJI,        /* 0x4ac8 */
    KANJI,        /* 0x4ac9 */
    KANJI,        /* 0x4aca */
    KANJI,        /* 0x4acb */
    KANJI,        /* 0x4acc */
    KANJI,        /* 0x4acd */
    KANJI,        /* 0x4ace */
    KANJI,        /* 0x4acf */
    KANJI,        /* 0x4ad0 */
    KANJI,        /* 0x4ad1 */
    KANJI,        /* 0x4ad2 */
    KANJI,        /* 0x4ad3 */
    KANJI,        /* 0x4ad4 */
    KANJI,        /* 0x4ad5 */
    KANJI,        /* 0x4ad6 */
    KANJI,        /* 0x4ad7 */
    KANJI,        /* 0x4ad8 */
    KANJI,        /* 0x4ad9 */
    KANJI,        /* 0x4ada */
    KANJI,        /* 0x4adb */
    KANJI,        /* 0x4adc */
    KANJI,        /* 0x4add */
    KANJI,        /* 0x4ade */
    KANJI,        /* 0x4adf */
    KANJI,        /* 0x4ae0 */
    KANJI,        /* 0x4ae1 */
    KANJI,        /* 0x4ae2 */
    KANJI,        /* 0x4ae3 */
    KANJI,        /* 0x4ae4 */
    KANJI,        /* 0x4ae5 */
    KANJI,        /* 0x4ae6 */
    KANJI,        /* 0x4ae7 */
    KANJI,        /* 0x4ae8 */
    KANJI,        /* 0x4ae9 */
    KANJI,        /* 0x4aea */
    KANJI,        /* 0x4aeb */
    KANJI,        /* 0x4aec */
    KANJI,        /* 0x4aed */
    KANJI,        /* 0x4aee */
    KANJI,        /* 0x4aef */
    KANJI,        /* 0x4af0 */
    KANJI,        /* 0x4af1 */
    KANJI,        /* 0x4af2 */
    KANJI,        /* 0x4af3 */
    KANJI,        /* 0x4af4 */
    KANJI,        /* 0x4af5 */
    KANJI,        /* 0x4af6 */
    KANJI,        /* 0x4af7 */
    KANJI,        /* 0x4af8 */
    KANJI,        /* 0x4af9 */
    KANJI,        /* 0x4afa */
    KANJI,        /* 0x4afb */
    KANJI,        /* 0x4afc */
    KANJI,        /* 0x4afd */
    KANJI,        /* 0x4afe */
    KANJI,        /* 0x4aff */
    KANJI,        /* 0x4b00 */
    KANJI,        /* 0x4b01 */
    KANJI,        /* 0x4b02 */
    KANJI,        /* 0x4b03 */
    KANJI,        /* 0x4b04 */
    KANJI,        /* 0x4b05 */
    KANJI,        /* 0x4b06 */
    KANJI,        /* 0x4b07 */
    KANJI,        /* 0x4b08 */
    KANJI,        /* 0x4b09 */
    KANJI,        /* 0x4b0a */
    KANJI,        /* 0x4b0b */
    KANJI,        /* 0x4b0c */
    KANJI,        /* 0x4b0d */
    KANJI,        /* 0x4b0e */
    KANJI,        /* 0x4b0f */
    KANJI,        /* 0x4b10 */
    KANJI,        /* 0x4b11 */
    KANJI,        /* 0x4b12 */
    KANJI,        /* 0x4b13 */
    KANJI,        /* 0x4b14 */
    KANJI,        /* 0x4b15 */
    KANJI,        /* 0x4b16 */
    KANJI,        /* 0x4b17 */
    KANJI,        /* 0x4b18 */
    KANJI,        /* 0x4b19 */
    KANJI,        /* 0x4b1a */
    KANJI,        /* 0x4b1b */
    KANJI,        /* 0x4b1c */
    KANJI,        /* 0x4b1d */
    KANJI,        /* 0x4b1e */
    KANJI,        /* 0x4b1f */
    KANJI,        /* 0x4b20 */
    KANJI,        /* 0x4b21 */
    KANJI,        /* 0x4b22 */
    KANJI,        /* 0x4b23 */
    KANJI,        /* 0x4b24 */
    KANJI,        /* 0x4b25 */
    KANJI,        /* 0x4b26 */
    KANJI,        /* 0x4b27 */
    KANJI,        /* 0x4b28 */
    KANJI,        /* 0x4b29 */
    KANJI,        /* 0x4b2a */
    KANJI,        /* 0x4b2b */
    KANJI,        /* 0x4b2c */
    KANJI,        /* 0x4b2d */
    KANJI,        /* 0x4b2e */
    KANJI,        /* 0x4b2f */
    KANJI,        /* 0x4b30 */
    KANJI,        /* 0x4b31 */
    KANJI,        /* 0x4b32 */
    KANJI,        /* 0x4b33 */
    KANJI,        /* 0x4b34 */
    KANJI,        /* 0x4b35 */
    KANJI,        /* 0x4b36 */
    KANJI,        /* 0x4b37 */
    KANJI,        /* 0x4b38 */
    KANJI,        /* 0x4b39 */
    KANJI,        /* 0x4b3a */
    KANJI,        /* 0x4b3b */
    KANJI,        /* 0x4b3c */
    KANJI,        /* 0x4b3d */
    KANJI,        /* 0x4b3e */
    KANJI,        /* 0x4b3f */
    KANJI,        /* 0x4b40 */
    KANJI,        /* 0x4b41 */
    KANJI,        /* 0x4b42 */
    KANJI,        /* 0x4b43 */
    KANJI,        /* 0x4b44 */
    KANJI,        /* 0x4b45 */
    KANJI,        /* 0x4b46 */
    KANJI,        /* 0x4b47 */
    KANJI,        /* 0x4b48 */
    KANJI,        /* 0x4b49 */
    KANJI,        /* 0x4b4a */
    KANJI,        /* 0x4b4b */
    KANJI,        /* 0x4b4c */
    KANJI,        /* 0x4b4d */
    KANJI,        /* 0x4b4e */
    KANJI,        /* 0x4b4f */
    KANJI,        /* 0x4b50 */
    KANJI,        /* 0x4b51 */
    KANJI,        /* 0x4b52 */
    KANJI,        /* 0x4b53 */
    KANJI,        /* 0x4b54 */
    KANJI,        /* 0x4b55 */
    KANJI,        /* 0x4b56 */
    KANJI,        /* 0x4b57 */
    KANJI,        /* 0x4b58 */
    KANJI,        /* 0x4b59 */
    KANJI,        /* 0x4b5a */
    KANJI,        /* 0x4b5b */
    KANJI,        /* 0x4b5c */
    KANJI,        /* 0x4b5d */
    KANJI,        /* 0x4b5e */
    KANJI,        /* 0x4b5f */
    KANJI,        /* 0x4b60 */
    KANJI,        /* 0x4b61 */
    KANJI,        /* 0x4b62 */
    KANJI,        /* 0x4b63 */
    KANJI,        /* 0x4b64 */
    KANJI,        /* 0x4b65 */
    KANJI,        /* 0x4b66 */
    KANJI,        /* 0x4b67 */
    KANJI,        /* 0x4b68 */
    KANJI,        /* 0x4b69 */
    KANJI,        /* 0x4b6a */
    KANJI,        /* 0x4b6b */
    KANJI,        /* 0x4b6c */
    KANJI,        /* 0x4b6d */
    KANJI,        /* 0x4b6e */
    KANJI,        /* 0x4b6f */
    KANJI,        /* 0x4b70 */
    KANJI,        /* 0x4b71 */
    KANJI,        /* 0x4b72 */
    KANJI,        /* 0x4b73 */
    KANJI,        /* 0x4b74 */
    KANJI,        /* 0x4b75 */
    KANJI,        /* 0x4b76 */
    KANJI,        /* 0x4b77 */
    KANJI,        /* 0x4b78 */
    KANJI,        /* 0x4b79 */
    KANJI,        /* 0x4b7a */
    KANJI,        /* 0x4b7b */
    KANJI,        /* 0x4b7c */
    KANJI,        /* 0x4b7d */
    KANJI,        /* 0x4b7e */
    KANJI,        /* 0x4b7f */
    KANJI,        /* 0x4b80 */
    KANJI,        /* 0x4b81 */
    KANJI,        /* 0x4b82 */
    KANJI,        /* 0x4b83 */
    KANJI,        /* 0x4b84 */
    KANJI,        /* 0x4b85 */
    KANJI,        /* 0x4b86 */
    KANJI,        /* 0x4b87 */
    KANJI,        /* 0x4b88 */
    KANJI,        /* 0x4b89 */
    KANJI,        /* 0x4b8a */
    KANJI,        /* 0x4b8b */
    KANJI,        /* 0x4b8c */
    KANJI,        /* 0x4b8d */
    KANJI,        /* 0x4b8e */
    KANJI,        /* 0x4b8f */
    KANJI,        /* 0x4b90 */
    KANJI,        /* 0x4b91 */
    KANJI,        /* 0x4b92 */
    KANJI,        /* 0x4b93 */
    KANJI,        /* 0x4b94 */
    KANJI,        /* 0x4b95 */
    KANJI,        /* 0x4b96 */
    KANJI,        /* 0x4b97 */
    KANJI,        /* 0x4b98 */
    KANJI,        /* 0x4b99 */
    KANJI,        /* 0x4b9a */
    KANJI,        /* 0x4b9b */
    KANJI,        /* 0x4b9c */
    KANJI,        /* 0x4b9d */
    KANJI,        /* 0x4b9e */
    KANJI,        /* 0x4b9f */
    KANJI,        /* 0x4ba0 */
    KANJI,        /* 0x4ba1 */
    KANJI,        /* 0x4ba2 */
    KANJI,        /* 0x4ba3 */
    KANJI,        /* 0x4ba4 */
    KANJI,        /* 0x4ba5 */
    KANJI,        /* 0x4ba6 */
    KANJI,        /* 0x4ba7 */
    KANJI,        /* 0x4ba8 */
    KANJI,        /* 0x4ba9 */
    KANJI,        /* 0x4baa */
    KANJI,        /* 0x4bab */
    KANJI,        /* 0x4bac */
    KANJI,        /* 0x4bad */
    KANJI,        /* 0x4bae */
    KANJI,        /* 0x4baf */
    KANJI,        /* 0x4bb0 */
    KANJI,        /* 0x4bb1 */
    KANJI,        /* 0x4bb2 */
    KANJI,        /* 0x4bb3 */
    KANJI,        /* 0x4bb4 */
    KANJI,        /* 0x4bb5 */
    KANJI,        /* 0x4bb6 */
    KANJI,        /* 0x4bb7 */
    KANJI,        /* 0x4bb8 */
    KANJI,        /* 0x4bb9 */
    KANJI,        /* 0x4bba */
    KANJI,        /* 0x4bbb */
    KANJI,        /* 0x4bbc */
    KANJI,        /* 0x4bbd */
    KANJI,        /* 0x4bbe */
    KANJI,        /* 0x4bbf */
    KANJI,        /* 0x4bc0 */
    KANJI,        /* 0x4bc1 */
    KANJI,        /* 0x4bc2 */
    KANJI,        /* 0x4bc3 */
    KANJI,        /* 0x4bc4 */
    KANJI,        /* 0x4bc5 */
    KANJI,        /* 0x4bc6 */
    KANJI,        /* 0x4bc7 */
    KANJI,        /* 0x4bc8 */
    KANJI,        /* 0x4bc9 */
    KANJI,        /* 0x4bca */
    KANJI,        /* 0x4bcb */
    KANJI,        /* 0x4bcc */
    KANJI,        /* 0x4bcd */
    KANJI,        /* 0x4bce */
    KANJI,        /* 0x4bcf */
    KANJI,        /* 0x4bd0 */
    KANJI,        /* 0x4bd1 */
    KANJI,        /* 0x4bd2 */
    KANJI,        /* 0x4bd3 */
    KANJI,        /* 0x4bd4 */
    KANJI,        /* 0x4bd5 */
    KANJI,        /* 0x4bd6 */
    KANJI,        /* 0x4bd7 */
    KANJI,        /* 0x4bd8 */
    KANJI,        /* 0x4bd9 */
    KANJI,        /* 0x4bda */
    KANJI,        /* 0x4bdb */
    KANJI,        /* 0x4bdc */
    KANJI,        /* 0x4bdd */
    KANJI,        /* 0x4bde */
    KANJI,        /* 0x4bdf */
    KANJI,        /* 0x4be0 */
    KANJI,        /* 0x4be1 */
    KANJI,        /* 0x4be2 */
    KANJI,        /* 0x4be3 */
    KANJI,        /* 0x4be4 */
    KANJI,        /* 0x4be5 */
    KANJI,        /* 0x4be6 */
    KANJI,        /* 0x4be7 */
    KANJI,        /* 0x4be8 */
    KANJI,        /* 0x4be9 */
    KANJI,        /* 0x4bea */
    KANJI,        /* 0x4beb */
    KANJI,        /* 0x4bec */
    KANJI,        /* 0x4bed */
    KANJI,        /* 0x4bee */
    KANJI,        /* 0x4bef */
    KANJI,        /* 0x4bf0 */
    KANJI,        /* 0x4bf1 */
    KANJI,        /* 0x4bf2 */
    KANJI,        /* 0x4bf3 */
    KANJI,        /* 0x4bf4 */
    KANJI,        /* 0x4bf5 */
    KANJI,        /* 0x4bf6 */
    KANJI,        /* 0x4bf7 */
    KANJI,        /* 0x4bf8 */
    KANJI,        /* 0x4bf9 */
    KANJI,        /* 0x4bfa */
    KANJI,        /* 0x4bfb */
    KANJI,        /* 0x4bfc */
    KANJI,        /* 0x4bfd */
    KANJI,        /* 0x4bfe */
    KANJI,        /* 0x4bff */
    KANJI,        /* 0x4c00 */
    KANJI,        /* 0x4c01 */
    KANJI,        /* 0x4c02 */
    KANJI,        /* 0x4c03 */
    KANJI,        /* 0x4c04 */
    KANJI,        /* 0x4c05 */
    KANJI,        /* 0x4c06 */
    KANJI,        /* 0x4c07 */
    KANJI,        /* 0x4c08 */
    KANJI,        /* 0x4c09 */
    KANJI,        /* 0x4c0a */
    KANJI,        /* 0x4c0b */
    KANJI,        /* 0x4c0c */
    KANJI,        /* 0x4c0d */
    KANJI,        /* 0x4c0e */
    KANJI,        /* 0x4c0f */
    KANJI,        /* 0x4c10 */
    KANJI,        /* 0x4c11 */
    KANJI,        /* 0x4c12 */
    KANJI,        /* 0x4c13 */
    KANJI,        /* 0x4c14 */
    KANJI,        /* 0x4c15 */
    KANJI,        /* 0x4c16 */
    KANJI,        /* 0x4c17 */
    KANJI,        /* 0x4c18 */
    KANJI,        /* 0x4c19 */
    KANJI,        /* 0x4c1a */
    KANJI,        /* 0x4c1b */
    KANJI,        /* 0x4c1c */
    KANJI,        /* 0x4c1d */
    KANJI,        /* 0x4c1e */
    KANJI,        /* 0x4c1f */
    KANJI,        /* 0x4c20 */
    KANJI,        /* 0x4c21 */
    KANJI,        /* 0x4c22 */
    KANJI,        /* 0x4c23 */
    KANJI,        /* 0x4c24 */
    KANJI,        /* 0x4c25 */
    KANJI,        /* 0x4c26 */
    KANJI,        /* 0x4c27 */
    KANJI,        /* 0x4c28 */
    KANJI,        /* 0x4c29 */
    KANJI,        /* 0x4c2a */
    KANJI,        /* 0x4c2b */
    KANJI,        /* 0x4c2c */
    KANJI,        /* 0x4c2d */
    KANJI,        /* 0x4c2e */
    KANJI,        /* 0x4c2f */
    KANJI,        /* 0x4c30 */
    KANJI,        /* 0x4c31 */
    KANJI,        /* 0x4c32 */
    KANJI,        /* 0x4c33 */
    KANJI,        /* 0x4c34 */
    KANJI,        /* 0x4c35 */
    KANJI,        /* 0x4c36 */
    KANJI,        /* 0x4c37 */
    KANJI,        /* 0x4c38 */
    KANJI,        /* 0x4c39 */
    KANJI,        /* 0x4c3a */
    KANJI,        /* 0x4c3b */
    KANJI,        /* 0x4c3c */
    KANJI,        /* 0x4c3d */
    KANJI,        /* 0x4c3e */
    KANJI,        /* 0x4c3f */
    KANJI,        /* 0x4c40 */
    KANJI,        /* 0x4c41 */
    KANJI,        /* 0x4c42 */
    KANJI,        /* 0x4c43 */
    KANJI,        /* 0x4c44 */
    KANJI,        /* 0x4c45 */
    KANJI,        /* 0x4c46 */
    KANJI,        /* 0x4c47 */
    KANJI,        /* 0x4c48 */
    KANJI,        /* 0x4c49 */
    KANJI,        /* 0x4c4a */
    KANJI,        /* 0x4c4b */
    KANJI,        /* 0x4c4c */
    KANJI,        /* 0x4c4d */
    KANJI,        /* 0x4c4e */
    KANJI,        /* 0x4c4f */
    KANJI,        /* 0x4c50 */
    KANJI,        /* 0x4c51 */
    KANJI,        /* 0x4c52 */
    KANJI,        /* 0x4c53 */
    KANJI,        /* 0x4c54 */
    KANJI,        /* 0x4c55 */
    KANJI,        /* 0x4c56 */
    KANJI,        /* 0x4c57 */
    KANJI,        /* 0x4c58 */
    KANJI,        /* 0x4c59 */
    KANJI,        /* 0x4c5a */
    KANJI,        /* 0x4c5b */
    KANJI,        /* 0x4c5c */
    KANJI,        /* 0x4c5d */
    KANJI,        /* 0x4c5e */
    KANJI,        /* 0x4c5f */
    KANJI,        /* 0x4c60 */
    KANJI,        /* 0x4c61 */
    KANJI,        /* 0x4c62 */
    KANJI,        /* 0x4c63 */
    KANJI,        /* 0x4c64 */
    KANJI,        /* 0x4c65 */
    KANJI,        /* 0x4c66 */
    KANJI,        /* 0x4c67 */
    KANJI,        /* 0x4c68 */
    KANJI,        /* 0x4c69 */
    KANJI,        /* 0x4c6a */
    KANJI,        /* 0x4c6b */
    KANJI,        /* 0x4c6c */
    KANJI,        /* 0x4c6d */
    KANJI,        /* 0x4c6e */
    KANJI,        /* 0x4c6f */
    KANJI,        /* 0x4c70 */
    KANJI,        /* 0x4c71 */
    KANJI,        /* 0x4c72 */
    KANJI,        /* 0x4c73 */
    KANJI,        /* 0x4c74 */
    KANJI,        /* 0x4c75 */
    KANJI,        /* 0x4c76 */
    KANJI,        /* 0x4c77 */
    KANJI,        /* 0x4c78 */
    KANJI,        /* 0x4c79 */
    KANJI,        /* 0x4c7a */
    KANJI,        /* 0x4c7b */
    KANJI,        /* 0x4c7c */
    KANJI,        /* 0x4c7d */
    KANJI,        /* 0x4c7e */
    KANJI,        /* 0x4c7f */
    KANJI,        /* 0x4c80 */
    KANJI,        /* 0x4c81 */
    KANJI,        /* 0x4c82 */
    KANJI,        /* 0x4c83 */
    KANJI,        /* 0x4c84 */
    KANJI,        /* 0x4c85 */
    KANJI,        /* 0x4c86 */
    KANJI,        /* 0x4c87 */
    KANJI,        /* 0x4c88 */
    KANJI,        /* 0x4c89 */
    KANJI,        /* 0x4c8a */
    KANJI,        /* 0x4c8b */
    KANJI,        /* 0x4c8c */
    KANJI,        /* 0x4c8d */
    KANJI,        /* 0x4c8e */
    KANJI,        /* 0x4c8f */
    KANJI,        /* 0x4c90 */
    KANJI,        /* 0x4c91 */
    KANJI,        /* 0x4c92 */
    KANJI,        /* 0x4c93 */
    KANJI,        /* 0x4c94 */
    KANJI,        /* 0x4c95 */
    KANJI,        /* 0x4c96 */
    KANJI,        /* 0x4c97 */
    KANJI,        /* 0x4c98 */
    KANJI,        /* 0x4c99 */
    KANJI,        /* 0x4c9a */
    KANJI,        /* 0x4c9b */
    KANJI,        /* 0x4c9c */
    KANJI,        /* 0x4c9d */
    KANJI,        /* 0x4c9e */
    KANJI,        /* 0x4c9f */
    KANJI,        /* 0x4ca0 */
    KANJI,        /* 0x4ca1 */
    KANJI,        /* 0x4ca2 */
    KANJI,        /* 0x4ca3 */
    KANJI,        /* 0x4ca4 */
    KANJI,        /* 0x4ca5 */
    KANJI,        /* 0x4ca6 */
    KANJI,        /* 0x4ca7 */
    KANJI,        /* 0x4ca8 */
    KANJI,        /* 0x4ca9 */
    KANJI,        /* 0x4caa */
    KANJI,        /* 0x4cab */
    KANJI,        /* 0x4cac */
    KANJI,        /* 0x4cad */
    KANJI,        /* 0x4cae */
    KANJI,        /* 0x4caf */
    KANJI,        /* 0x4cb0 */
    KANJI,        /* 0x4cb1 */
    KANJI,        /* 0x4cb2 */
    KANJI,        /* 0x4cb3 */
    KANJI,        /* 0x4cb4 */
    KANJI,        /* 0x4cb5 */
    KANJI,        /* 0x4cb6 */
    KANJI,        /* 0x4cb7 */
    KANJI,        /* 0x4cb8 */
    KANJI,        /* 0x4cb9 */
    KANJI,        /* 0x4cba */
    KANJI,        /* 0x4cbb */
    KANJI,        /* 0x4cbc */
    KANJI,        /* 0x4cbd */
    KANJI,        /* 0x4cbe */
    KANJI,        /* 0x4cbf */
    KANJI,        /* 0x4cc0 */
    KANJI,        /* 0x4cc1 */
    KANJI,        /* 0x4cc2 */
    KANJI,        /* 0x4cc3 */
    KANJI,        /* 0x4cc4 */
    KANJI,        /* 0x4cc5 */
    KANJI,        /* 0x4cc6 */
    KANJI,        /* 0x4cc7 */
    KANJI,        /* 0x4cc8 */
    KANJI,        /* 0x4cc9 */
    KANJI,        /* 0x4cca */
    KANJI,        /* 0x4ccb */
    KANJI,        /* 0x4ccc */
    KANJI,        /* 0x4ccd */
    KANJI,        /* 0x4cce */
    KANJI,        /* 0x4ccf */
    KANJI,        /* 0x4cd0 */
    KANJI,        /* 0x4cd1 */
    KANJI,        /* 0x4cd2 */
    KANJI,        /* 0x4cd3 */
    KANJI,        /* 0x4cd4 */
    KANJI,        /* 0x4cd5 */
    KANJI,        /* 0x4cd6 */
    KANJI,        /* 0x4cd7 */
    KANJI,        /* 0x4cd8 */
    KANJI,        /* 0x4cd9 */
    KANJI,        /* 0x4cda */
    KANJI,        /* 0x4cdb */
    KANJI,        /* 0x4cdc */
    KANJI,        /* 0x4cdd */
    KANJI,        /* 0x4cde */
    KANJI,        /* 0x4cdf */
    KANJI,        /* 0x4ce0 */
    KANJI,        /* 0x4ce1 */
    KANJI,        /* 0x4ce2 */
    KANJI,        /* 0x4ce3 */
    KANJI,        /* 0x4ce4 */
    KANJI,        /* 0x4ce5 */
    KANJI,        /* 0x4ce6 */
    KANJI,        /* 0x4ce7 */
    KANJI,        /* 0x4ce8 */
    KANJI,        /* 0x4ce9 */
    KANJI,        /* 0x4cea */
    KANJI,        /* 0x4ceb */
    KANJI,        /* 0x4cec */
    KANJI,        /* 0x4ced */
    KANJI,        /* 0x4cee */
    KANJI,        /* 0x4cef */
    KANJI,        /* 0x4cf0 */
    KANJI,        /* 0x4cf1 */
    KANJI,        /* 0x4cf2 */
    KANJI,        /* 0x4cf3 */
    KANJI,        /* 0x4cf4 */
    KANJI,        /* 0x4cf5 */
    KANJI,        /* 0x4cf6 */
    KANJI,        /* 0x4cf7 */
    KANJI,        /* 0x4cf8 */
    KANJI,        /* 0x4cf9 */
    KANJI,        /* 0x4cfa */
    KANJI,        /* 0x4cfb */
    KANJI,        /* 0x4cfc */
    KANJI,        /* 0x4cfd */
    KANJI,        /* 0x4cfe */
    KANJI,        /* 0x4cff */
    KANJI,        /* 0x4d00 */
    KANJI,        /* 0x4d01 */
    KANJI,        /* 0x4d02 */
    KANJI,        /* 0x4d03 */
    KANJI,        /* 0x4d04 */
    KANJI,        /* 0x4d05 */
    KANJI,        /* 0x4d06 */
    KANJI,        /* 0x4d07 */
    KANJI,        /* 0x4d08 */
    KANJI,        /* 0x4d09 */
    KANJI,        /* 0x4d0a */
    KANJI,        /* 0x4d0b */
    KANJI,        /* 0x4d0c */
    KANJI,        /* 0x4d0d */
    KANJI,        /* 0x4d0e */
    KANJI,        /* 0x4d0f */
    KANJI,        /* 0x4d10 */
    KANJI,        /* 0x4d11 */
    KANJI,        /* 0x4d12 */
    KANJI,        /* 0x4d13 */
    KANJI,        /* 0x4d14 */
    KANJI,        /* 0x4d15 */
    KANJI,        /* 0x4d16 */
    KANJI,        /* 0x4d17 */
    KANJI,        /* 0x4d18 */
    KANJI,        /* 0x4d19 */
    KANJI,        /* 0x4d1a */
    KANJI,        /* 0x4d1b */
    KANJI,        /* 0x4d1c */
    KANJI,        /* 0x4d1d */
    KANJI,        /* 0x4d1e */
    KANJI,        /* 0x4d1f */
    KANJI,        /* 0x4d20 */
    KANJI,        /* 0x4d21 */
    KANJI,        /* 0x4d22 */
    KANJI,        /* 0x4d23 */
    KANJI,        /* 0x4d24 */
    KANJI,        /* 0x4d25 */
    KANJI,        /* 0x4d26 */
    KANJI,        /* 0x4d27 */
    KANJI,        /* 0x4d28 */
    KANJI,        /* 0x4d29 */
    KANJI,        /* 0x4d2a */
    KANJI,        /* 0x4d2b */
    KANJI,        /* 0x4d2c */
    KANJI,        /* 0x4d2d */
    KANJI,        /* 0x4d2e */
    KANJI,        /* 0x4d2f */
    KANJI,        /* 0x4d30 */
    KANJI,        /* 0x4d31 */
    KANJI,        /* 0x4d32 */
    KANJI,        /* 0x4d33 */
    KANJI,        /* 0x4d34 */
    KANJI,        /* 0x4d35 */
    KANJI,        /* 0x4d36 */
    KANJI,        /* 0x4d37 */
    KANJI,        /* 0x4d38 */
    KANJI,        /* 0x4d39 */
    KANJI,        /* 0x4d3a */
    KANJI,        /* 0x4d3b */
    KANJI,        /* 0x4d3c */
    KANJI,        /* 0x4d3d */
    KANJI,        /* 0x4d3e */
    KANJI,        /* 0x4d3f */
    KANJI,        /* 0x4d40 */
    KANJI,        /* 0x4d41 */
    KANJI,        /* 0x4d42 */
    KANJI,        /* 0x4d43 */
    KANJI,        /* 0x4d44 */
    KANJI,        /* 0x4d45 */
    KANJI,        /* 0x4d46 */
    KANJI,        /* 0x4d47 */
    KANJI,        /* 0x4d48 */
    KANJI,        /* 0x4d49 */
    KANJI,        /* 0x4d4a */
    KANJI,        /* 0x4d4b */
    KANJI,        /* 0x4d4c */
    KANJI,        /* 0x4d4d */
    KANJI,        /* 0x4d4e */
    KANJI,        /* 0x4d4f */
    KANJI,        /* 0x4d50 */
    KANJI,        /* 0x4d51 */
    KANJI,        /* 0x4d52 */
    KANJI,        /* 0x4d53 */
    KANJI,        /* 0x4d54 */
    KANJI,        /* 0x4d55 */
    KANJI,        /* 0x4d56 */
    KANJI,        /* 0x4d57 */
    KANJI,        /* 0x4d58 */
    KANJI,        /* 0x4d59 */
    KANJI,        /* 0x4d5a */
    KANJI,        /* 0x4d5b */
    KANJI,        /* 0x4d5c */
    KANJI,        /* 0x4d5d */
    KANJI,        /* 0x4d5e */
    KANJI,        /* 0x4d5f */
    KANJI,        /* 0x4d60 */
    KANJI,        /* 0x4d61 */
    KANJI,        /* 0x4d62 */
    KANJI,        /* 0x4d63 */
    KANJI,        /* 0x4d64 */
    KANJI,        /* 0x4d65 */
    KANJI,        /* 0x4d66 */
    KANJI,        /* 0x4d67 */
    KANJI,        /* 0x4d68 */
    KANJI,        /* 0x4d69 */
    KANJI,        /* 0x4d6a */
    KANJI,        /* 0x4d6b */
    KANJI,        /* 0x4d6c */
    KANJI,        /* 0x4d6d */
    KANJI,        /* 0x4d6e */
    KANJI,        /* 0x4d6f */
    KANJI,        /* 0x4d70 */
    KANJI,        /* 0x4d71 */
    KANJI,        /* 0x4d72 */
    KANJI,        /* 0x4d73 */
    KANJI,        /* 0x4d74 */
    KANJI,        /* 0x4d75 */
    KANJI,        /* 0x4d76 */
    KANJI,        /* 0x4d77 */
    KANJI,        /* 0x4d78 */
    KANJI,        /* 0x4d79 */
    KANJI,        /* 0x4d7a */
    KANJI,        /* 0x4d7b */
    KANJI,        /* 0x4d7c */
    KANJI,        /* 0x4d7d */
    KANJI,        /* 0x4d7e */
    KANJI,        /* 0x4d7f */
    KANJI,        /* 0x4d80 */
    KANJI,        /* 0x4d81 */
    KANJI,        /* 0x4d82 */
    KANJI,        /* 0x4d83 */
    KANJI,        /* 0x4d84 */
    KANJI,        /* 0x4d85 */
    KANJI,        /* 0x4d86 */
    KANJI,        /* 0x4d87 */
    KANJI,        /* 0x4d88 */
    KANJI,        /* 0x4d89 */
    KANJI,        /* 0x4d8a */
    KANJI,        /* 0x4d8b */
    KANJI,        /* 0x4d8c */
    KANJI,        /* 0x4d8d */
    KANJI,        /* 0x4d8e */
    KANJI,        /* 0x4d8f */
    KANJI,        /* 0x4d90 */
    KANJI,        /* 0x4d91 */
    KANJI,        /* 0x4d92 */
    KANJI,        /* 0x4d93 */
    KANJI,        /* 0x4d94 */
    KANJI,        /* 0x4d95 */
    KANJI,        /* 0x4d96 */
    KANJI,        /* 0x4d97 */
    KANJI,        /* 0x4d98 */
    KANJI,        /* 0x4d99 */
    KANJI,        /* 0x4d9a */
    KANJI,        /* 0x4d9b */
    KANJI,        /* 0x4d9c */
    KANJI,        /* 0x4d9d */
    KANJI,        /* 0x4d9e */
    KANJI,        /* 0x4d9f */
    KANJI,        /* 0x4da0 */
    KANJI,        /* 0x4da1 */
    KANJI,        /* 0x4da2 */
    KANJI,        /* 0x4da3 */
    KANJI,        /* 0x4da4 */
    KANJI,        /* 0x4da5 */
    KANJI,        /* 0x4da6 */
    KANJI,        /* 0x4da7 */
    KANJI,        /* 0x4da8 */
    KANJI,        /* 0x4da9 */
    KANJI,        /* 0x4daa */
    KANJI,        /* 0x4dab */
    KANJI,        /* 0x4dac */
    KANJI,        /* 0x4dad */
    KANJI,        /* 0x4dae */
    KANJI,        /* 0x4daf */
    KANJI,        /* 0x4db0 */
    KANJI,        /* 0x4db1 */
    KANJI,        /* 0x4db2 */
    KANJI,        /* 0x4db3 */
    KANJI,        /* 0x4db4 */
    KANJI,        /* 0x4db5 */
    OTHER,        /* 0x4db6 */
    OTHER,        /* 0x4db7 */
    OTHER,        /* 0x4db8 */
    OTHER,        /* 0x4db9 */
    OTHER,        /* 0x4dba */
    OTHER,        /* 0x4dbb */
    OTHER,        /* 0x4dbc */
    OTHER,        /* 0x4dbd */
    OTHER,        /* 0x4dbe */
    OTHER,        /* 0x4dbf */
    OTHER,        /* 0x4dc0 */
    OTHER,        /* 0x4dc1 */
    OTHER,        /* 0x4dc2 */
    OTHER,        /* 0x4dc3 */
    OTHER,        /* 0x4dc4 */
    OTHER,        /* 0x4dc5 */
    OTHER,        /* 0x4dc6 */
    OTHER,        /* 0x4dc7 */
    OTHER,        /* 0x4dc8 */
    OTHER,        /* 0x4dc9 */
    OTHER,        /* 0x4dca */
    OTHER,        /* 0x4dcb */
    OTHER,        /* 0x4dcc */
    OTHER,        /* 0x4dcd */
    OTHER,        /* 0x4dce */
    OTHER,        /* 0x4dcf */
    OTHER,        /* 0x4dd0 */
    OTHER,        /* 0x4dd1 */
    OTHER,        /* 0x4dd2 */
    OTHER,        /* 0x4dd3 */
    OTHER,        /* 0x4dd4 */
    OTHER,        /* 0x4dd5 */
    OTHER,        /* 0x4dd6 */
    OTHER,        /* 0x4dd7 */
    OTHER,        /* 0x4dd8 */
    OTHER,        /* 0x4dd9 */
    OTHER,        /* 0x4dda */
    OTHER,        /* 0x4ddb */
    OTHER,        /* 0x4ddc */
    OTHER,        /* 0x4ddd */
    OTHER,        /* 0x4dde */
    OTHER,        /* 0x4ddf */
    OTHER,        /* 0x4de0 */
    OTHER,        /* 0x4de1 */
    OTHER,        /* 0x4de2 */
    OTHER,        /* 0x4de3 */
    OTHER,        /* 0x4de4 */
    OTHER,        /* 0x4de5 */
    OTHER,        /* 0x4de6 */
    OTHER,        /* 0x4de7 */
    OTHER,        /* 0x4de8 */
    OTHER,        /* 0x4de9 */
    OTHER,        /* 0x4dea */
    OTHER,        /* 0x4deb */
    OTHER,        /* 0x4dec */
    OTHER,        /* 0x4ded */
    OTHER,        /* 0x4dee */
    OTHER,        /* 0x4def */
    OTHER,        /* 0x4df0 */
    OTHER,        /* 0x4df1 */
    OTHER,        /* 0x4df2 */
    OTHER,        /* 0x4df3 */
    OTHER,        /* 0x4df4 */
    OTHER,        /* 0x4df5 */
    OTHER,        /* 0x4df6 */
    OTHER,        /* 0x4df7 */
    OTHER,        /* 0x4df8 */
    OTHER,        /* 0x4df9 */
    OTHER,        /* 0x4dfa */
    OTHER,        /* 0x4dfb */
    OTHER,        /* 0x4dfc */
    OTHER,        /* 0x4dfd */
    OTHER,        /* 0x4dfe */
    OTHER,        /* 0x4dff */
    KANJINUMERIC,        /* 0x4e00 */
    KANJI,        /* 0x4e01 */
    KANJI,        /* 0x4e02 */
    KANJINUMERIC,        /* 0x4e03 */
    KANJI,        /* 0x4e04 */
    KANJI,        /* 0x4e05 */
    KANJI,        /* 0x4e06 */
    KANJINUMERIC,        /* 0x4e07 */
    KANJI,        /* 0x4e08 */
    KANJINUMERIC,        /* 0x4e09 */
    KANJI,        /* 0x4e0a */
    KANJI,        /* 0x4e0b */
    KANJI,        /* 0x4e0c */
    KANJI,        /* 0x4e0d */
    KANJI,        /* 0x4e0e */
    KANJI,        /* 0x4e0f */
    KANJI,        /* 0x4e10 */
    KANJI,        /* 0x4e11 */
    KANJI,        /* 0x4e12 */
    KANJI,        /* 0x4e13 */
    KANJI,        /* 0x4e14 */
    KANJI,        /* 0x4e15 */
    KANJI,        /* 0x4e16 */
    KANJI,        /* 0x4e17 */
    KANJI,        /* 0x4e18 */
    KANJI,        /* 0x4e19 */
    KANJI,        /* 0x4e1a */
    KANJI,        /* 0x4e1b */
    KANJI,        /* 0x4e1c */
    KANJI,        /* 0x4e1d */
    KANJI,        /* 0x4e1e */
    KANJI,        /* 0x4e1f */
    KANJI,        /* 0x4e20 */
    KANJI,        /* 0x4e21 */
    KANJI,        /* 0x4e22 */
    KANJI,        /* 0x4e23 */
    KANJI,        /* 0x4e24 */
    KANJI,        /* 0x4e25 */
    KANJI,        /* 0x4e26 */
    KANJI,        /* 0x4e27 */
    KANJI,        /* 0x4e28 */
    KANJI,        /* 0x4e29 */
    KANJI,        /* 0x4e2a */
    KANJI,        /* 0x4e2b */
    KANJI,        /* 0x4e2c */
    KANJI,        /* 0x4e2d */
    KANJI,        /* 0x4e2e */
    KANJI,        /* 0x4e2f */
    KANJI,        /* 0x4e30 */
    KANJI,        /* 0x4e31 */
    KANJI,        /* 0x4e32 */
    KANJI,        /* 0x4e33 */
    KANJI,        /* 0x4e34 */
    KANJI,        /* 0x4e35 */
    KANJI,        /* 0x4e36 */
    KANJI,        /* 0x4e37 */
    KANJI,        /* 0x4e38 */
    KANJI,        /* 0x4e39 */
    KANJI,        /* 0x4e3a */
    KANJI,        /* 0x4e3b */
    KANJI,        /* 0x4e3c */
    KANJI,        /* 0x4e3d */
    KANJI,        /* 0x4e3e */
    KANJI,        /* 0x4e3f */
    KANJI,        /* 0x4e40 */
    KANJI,        /* 0x4e41 */
    KANJI,        /* 0x4e42 */
    KANJI,        /* 0x4e43 */
    KANJI,        /* 0x4e44 */
    KANJI,        /* 0x4e45 */
    KANJI,        /* 0x4e46 */
    KANJI,        /* 0x4e47 */
    KANJI,        /* 0x4e48 */
    KANJI,        /* 0x4e49 */
    KANJI,        /* 0x4e4a */
    KANJI,        /* 0x4e4b */
    KANJI,        /* 0x4e4c */
    KANJI,        /* 0x4e4d */
    KANJI,        /* 0x4e4e */
    KANJI,        /* 0x4e4f */
    KANJI,        /* 0x4e50 */
    KANJI,        /* 0x4e51 */
    KANJI,        /* 0x4e52 */
    KANJI,        /* 0x4e53 */
    KANJI,        /* 0x4e54 */
    KANJI,        /* 0x4e55 */
    KANJI,        /* 0x4e56 */
    KANJI,        /* 0x4e57 */
    KANJI,        /* 0x4e58 */
    KANJI,        /* 0x4e59 */
    KANJI,        /* 0x4e5a */
    KANJI,        /* 0x4e5b */
    KANJI,        /* 0x4e5c */
    KANJINUMERIC,        /* 0x4e5d */
    KANJI,        /* 0x4e5e */
    KANJI,        /* 0x4e5f */
    KANJI,        /* 0x4e60 */
    KANJI,        /* 0x4e61 */
    KANJI,        /* 0x4e62 */
    KANJI,        /* 0x4e63 */
    KANJI,        /* 0x4e64 */
    KANJI,        /* 0x4e65 */
    KANJI,        /* 0x4e66 */
    KANJI,        /* 0x4e67 */
    KANJI,        /* 0x4e68 */
    KANJI,        /* 0x4e69 */
    KANJI,        /* 0x4e6a */
    KANJI,        /* 0x4e6b */
    KANJI,        /* 0x4e6c */
    KANJI,        /* 0x4e6d */
    KANJI,        /* 0x4e6e */
    KANJI,        /* 0x4e6f */
    KANJI,        /* 0x4e70 */
    KANJI,        /* 0x4e71 */
    KANJI,        /* 0x4e72 */
    KANJI,        /* 0x4e73 */
    KANJI,        /* 0x4e74 */
    KANJI,        /* 0x4e75 */
    KANJI,        /* 0x4e76 */
    KANJI,        /* 0x4e77 */
    KANJI,        /* 0x4e78 */
    KANJI,        /* 0x4e79 */
    KANJI,        /* 0x4e7a */
    KANJI,        /* 0x4e7b */
    KANJI,        /* 0x4e7c */
    KANJI,        /* 0x4e7d */
    KANJI,        /* 0x4e7e */
    KANJI,        /* 0x4e7f */
    KANJI,        /* 0x4e80 */
    KANJI,        /* 0x4e81 */
    KANJI,        /* 0x4e82 */
    KANJI,        /* 0x4e83 */
    KANJI,        /* 0x4e84 */
    KANJI,        /* 0x4e85 */
    KANJI,        /* 0x4e86 */
    KANJI,        /* 0x4e87 */
    KANJI,        /* 0x4e88 */
    KANJI,        /* 0x4e89 */
    KANJI,        /* 0x4e8a */
    KANJI,        /* 0x4e8b */
    KANJINUMERIC,        /* 0x4e8c */
    KANJI,        /* 0x4e8d */
    KANJI,        /* 0x4e8e */
    KANJI,        /* 0x4e8f */
    KANJI,        /* 0x4e90 */
    KANJI,        /* 0x4e91 */
    KANJI,        /* 0x4e92 */
    KANJI,        /* 0x4e93 */
    KANJINUMERIC,        /* 0x4e94 */
    KANJI,        /* 0x4e95 */
    KANJI,        /* 0x4e96 */
    KANJI,        /* 0x4e97 */
    KANJI,        /* 0x4e98 */
    KANJI,        /* 0x4e99 */
    KANJI,        /* 0x4e9a */
    KANJI,        /* 0x4e9b */
    KANJI,        /* 0x4e9c */
    KANJI,        /* 0x4e9d */
    KANJI,        /* 0x4e9e */
    KANJI,        /* 0x4e9f */
    KANJI,        /* 0x4ea0 */
    KANJI,        /* 0x4ea1 */
    KANJI,        /* 0x4ea2 */
    KANJI,        /* 0x4ea3 */
    KANJI,        /* 0x4ea4 */
    KANJI,        /* 0x4ea5 */
    KANJI,        /* 0x4ea6 */
    KANJI,        /* 0x4ea7 */
    KANJI,        /* 0x4ea8 */
    KANJI,        /* 0x4ea9 */
    KANJI,        /* 0x4eaa */
    KANJI,        /* 0x4eab */
    KANJI,        /* 0x4eac */
    KANJI,        /* 0x4ead */
    KANJI,        /* 0x4eae */
    KANJI,        /* 0x4eaf */
    KANJI,        /* 0x4eb0 */
    KANJI,        /* 0x4eb1 */
    KANJI,        /* 0x4eb2 */
    KANJI,        /* 0x4eb3 */
    KANJI,        /* 0x4eb4 */
    KANJI,        /* 0x4eb5 */
    KANJI,        /* 0x4eb6 */
    KANJI,        /* 0x4eb7 */
    KANJI,        /* 0x4eb8 */
    KANJI,        /* 0x4eb9 */
    KANJI,        /* 0x4eba */
    KANJI,        /* 0x4ebb */
    KANJI,        /* 0x4ebc */
    KANJI,        /* 0x4ebd */
    KANJI,        /* 0x4ebe */
    KANJI,        /* 0x4ebf */
    KANJI,        /* 0x4ec0 */
    KANJI,        /* 0x4ec1 */
    KANJI,        /* 0x4ec2 */
    KANJI,        /* 0x4ec3 */
    KANJI,        /* 0x4ec4 */
    KANJI,        /* 0x4ec5 */
    KANJI,        /* 0x4ec6 */
    KANJI,        /* 0x4ec7 */
    KANJI,        /* 0x4ec8 */
    KANJI,        /* 0x4ec9 */
    KANJI,        /* 0x4eca */
    KANJI,        /* 0x4ecb */
    KANJI,        /* 0x4ecc */
    KANJI,        /* 0x4ecd */
    KANJI,        /* 0x4ece */
    KANJI,        /* 0x4ecf */
    KANJI,        /* 0x4ed0 */
    KANJI,        /* 0x4ed1 */
    KANJI,        /* 0x4ed2 */
    KANJI,        /* 0x4ed3 */
    KANJI,        /* 0x4ed4 */
    KANJI,        /* 0x4ed5 */
    KANJI,        /* 0x4ed6 */
    KANJI,        /* 0x4ed7 */
    KANJI,        /* 0x4ed8 */
    KANJI,        /* 0x4ed9 */
    KANJI,        /* 0x4eda */
    KANJI,        /* 0x4edb */
    KANJI,        /* 0x4edc */
    KANJI,        /* 0x4edd */
    KANJI,        /* 0x4ede */
    KANJI,        /* 0x4edf */
    KANJI,        /* 0x4ee0 */
    KANJI,        /* 0x4ee1 */
    KANJI,        /* 0x4ee2 */
    KANJI,        /* 0x4ee3 */
    KANJI,        /* 0x4ee4 */
    KANJI,        /* 0x4ee5 */
    KANJI,        /* 0x4ee6 */
    KANJI,        /* 0x4ee7 */
    KANJI,        /* 0x4ee8 */
    KANJI,        /* 0x4ee9 */
    KANJI,        /* 0x4eea */
    KANJI,        /* 0x4eeb */
    KANJI,        /* 0x4eec */
    KANJI,        /* 0x4eed */
    KANJI,        /* 0x4eee */
    KANJI,        /* 0x4eef */
    KANJI,        /* 0x4ef0 */
    KANJI,        /* 0x4ef1 */
    KANJI,        /* 0x4ef2 */
    KANJI,        /* 0x4ef3 */
    KANJI,        /* 0x4ef4 */
    KANJI,        /* 0x4ef5 */
    KANJI,        /* 0x4ef6 */
    KANJI,        /* 0x4ef7 */
    KANJI,        /* 0x4ef8 */
    KANJI,        /* 0x4ef9 */
    KANJI,        /* 0x4efa */
    KANJI,        /* 0x4efb */
    KANJI,        /* 0x4efc */
    KANJI,        /* 0x4efd */
    KANJI,        /* 0x4efe */
    KANJI,        /* 0x4eff */
    KANJI,        /* 0x4f00 */
    KANJI,        /* 0x4f01 */
    KANJI,        /* 0x4f02 */
    KANJI,        /* 0x4f03 */
    KANJI,        /* 0x4f04 */
    KANJI,        /* 0x4f05 */
    KANJI,        /* 0x4f06 */
    KANJI,        /* 0x4f07 */
    KANJI,        /* 0x4f08 */
    KANJI,        /* 0x4f09 */
    KANJI,        /* 0x4f0a */
    KANJI,        /* 0x4f0b */
    KANJI,        /* 0x4f0c */
    KANJI,        /* 0x4f0d */
    KANJI,        /* 0x4f0e */
    KANJI,        /* 0x4f0f */
    KANJI,        /* 0x4f10 */
    KANJI,        /* 0x4f11 */
    KANJI,        /* 0x4f12 */
    KANJI,        /* 0x4f13 */
    KANJI,        /* 0x4f14 */
    KANJI,        /* 0x4f15 */
    KANJI,        /* 0x4f16 */
    KANJI,        /* 0x4f17 */
    KANJI,        /* 0x4f18 */
    KANJI,        /* 0x4f19 */
    KANJI,        /* 0x4f1a */
    KANJI,        /* 0x4f1b */
    KANJI,        /* 0x4f1c */
    KANJI,        /* 0x4f1d */
    KANJI,        /* 0x4f1e */
    KANJI,        /* 0x4f1f */
    KANJI,        /* 0x4f20 */
    KANJI,        /* 0x4f21 */
    KANJI,        /* 0x4f22 */
    KANJI,        /* 0x4f23 */
    KANJI,        /* 0x4f24 */
    KANJI,        /* 0x4f25 */
    KANJI,        /* 0x4f26 */
    KANJI,        /* 0x4f27 */
    KANJI,        /* 0x4f28 */
    KANJI,        /* 0x4f29 */
    KANJI,        /* 0x4f2a */
    KANJI,        /* 0x4f2b */
    KANJI,        /* 0x4f2c */
    KANJI,        /* 0x4f2d */
    KANJI,        /* 0x4f2e */
    KANJI,        /* 0x4f2f */
    KANJI,        /* 0x4f30 */
    KANJI,        /* 0x4f31 */
    KANJI,        /* 0x4f32 */
    KANJI,        /* 0x4f33 */
    KANJI,        /* 0x4f34 */
    KANJI,        /* 0x4f35 */
    KANJI,        /* 0x4f36 */
    KANJI,        /* 0x4f37 */
    KANJI,        /* 0x4f38 */
    KANJI,        /* 0x4f39 */
    KANJI,        /* 0x4f3a */
    KANJI,        /* 0x4f3b */
    KANJI,        /* 0x4f3c */
    KANJI,        /* 0x4f3d */
    KANJI,        /* 0x4f3e */
    KANJI,        /* 0x4f3f */
    KANJI,        /* 0x4f40 */
    KANJI,        /* 0x4f41 */
    KANJI,        /* 0x4f42 */
    KANJI,        /* 0x4f43 */
    KANJI,        /* 0x4f44 */
    KANJI,        /* 0x4f45 */
    KANJI,        /* 0x4f46 */
    KANJI,        /* 0x4f47 */
    KANJI,        /* 0x4f48 */
    KANJI,        /* 0x4f49 */
    KANJI,        /* 0x4f4a */
    KANJI,        /* 0x4f4b */
    KANJI,        /* 0x4f4c */
    KANJI,        /* 0x4f4d */
    KANJI,        /* 0x4f4e */
    KANJI,        /* 0x4f4f */
    KANJI,        /* 0x4f50 */
    KANJI,        /* 0x4f51 */
    KANJI,        /* 0x4f52 */
    KANJI,        /* 0x4f53 */
    KANJI,        /* 0x4f54 */
    KANJI,        /* 0x4f55 */
    KANJI,        /* 0x4f56 */
    KANJI,        /* 0x4f57 */
    KANJI,        /* 0x4f58 */
    KANJI,        /* 0x4f59 */
    KANJI,        /* 0x4f5a */
    KANJI,        /* 0x4f5b */
    KANJI,        /* 0x4f5c */
    KANJI,        /* 0x4f5d */
    KANJI,        /* 0x4f5e */
    KANJI,        /* 0x4f5f */
    KANJI,        /* 0x4f60 */
    KANJI,        /* 0x4f61 */
    KANJI,        /* 0x4f62 */
    KANJI,        /* 0x4f63 */
    KANJI,        /* 0x4f64 */
    KANJI,        /* 0x4f65 */
    KANJI,        /* 0x4f66 */
    KANJI,        /* 0x4f67 */
    KANJI,        /* 0x4f68 */
    KANJI,        /* 0x4f69 */
    KANJI,        /* 0x4f6a */
    KANJI,        /* 0x4f6b */
    KANJI,        /* 0x4f6c */
    KANJI,        /* 0x4f6d */
    KANJI,        /* 0x4f6e */
    KANJI,        /* 0x4f6f */
    KANJI,        /* 0x4f70 */
    KANJI,        /* 0x4f71 */
    KANJI,        /* 0x4f72 */
    KANJI,        /* 0x4f73 */
    KANJI,        /* 0x4f74 */
    KANJI,        /* 0x4f75 */
    KANJI,        /* 0x4f76 */
    KANJI,        /* 0x4f77 */
    KANJI,        /* 0x4f78 */
    KANJI,        /* 0x4f79 */
    KANJI,        /* 0x4f7a */
    KANJI,        /* 0x4f7b */
    KANJI,        /* 0x4f7c */
    KANJI,        /* 0x4f7d */
    KANJI,        /* 0x4f7e */
    KANJI,        /* 0x4f7f */
    KANJI,        /* 0x4f80 */
    KANJI,        /* 0x4f81 */
    KANJI,        /* 0x4f82 */
    KANJI,        /* 0x4f83 */
    KANJI,        /* 0x4f84 */
    KANJI,        /* 0x4f85 */
    KANJI,        /* 0x4f86 */
    KANJI,        /* 0x4f87 */
    KANJI,        /* 0x4f88 */
    KANJI,        /* 0x4f89 */
    KANJI,        /* 0x4f8a */
    KANJI,        /* 0x4f8b */
    KANJI,        /* 0x4f8c */
    KANJI,        /* 0x4f8d */
    KANJI,        /* 0x4f8e */
    KANJI,        /* 0x4f8f */
    KANJI,        /* 0x4f90 */
    KANJI,        /* 0x4f91 */
    KANJI,        /* 0x4f92 */
    KANJI,        /* 0x4f93 */
    KANJI,        /* 0x4f94 */
    KANJI,        /* 0x4f95 */
    KANJI,        /* 0x4f96 */
    KANJI,        /* 0x4f97 */
    KANJI,        /* 0x4f98 */
    KANJI,        /* 0x4f99 */
    KANJI,        /* 0x4f9a */
    KANJI,        /* 0x4f9b */
    KANJI,        /* 0x4f9c */
    KANJI,        /* 0x4f9d */
    KANJI,        /* 0x4f9e */
    KANJI,        /* 0x4f9f */
    KANJI,        /* 0x4fa0 */
    KANJI,        /* 0x4fa1 */
    KANJI,        /* 0x4fa2 */
    KANJI,        /* 0x4fa3 */
    KANJI,        /* 0x4fa4 */
    KANJI,        /* 0x4fa5 */
    KANJI,        /* 0x4fa6 */
    KANJI,        /* 0x4fa7 */
    KANJI,        /* 0x4fa8 */
    KANJI,        /* 0x4fa9 */
    KANJI,        /* 0x4faa */
    KANJI,        /* 0x4fab */
    KANJI,        /* 0x4fac */
    KANJI,        /* 0x4fad */
    KANJI,        /* 0x4fae */
    KANJI,        /* 0x4faf */
    KANJI,        /* 0x4fb0 */
    KANJI,        /* 0x4fb1 */
    KANJI,        /* 0x4fb2 */
    KANJI,        /* 0x4fb3 */
    KANJI,        /* 0x4fb4 */
    KANJI,        /* 0x4fb5 */
    KANJI,        /* 0x4fb6 */
    KANJI,        /* 0x4fb7 */
    KANJI,        /* 0x4fb8 */
    KANJI,        /* 0x4fb9 */
    KANJI,        /* 0x4fba */
    KANJI,        /* 0x4fbb */
    KANJI,        /* 0x4fbc */
    KANJI,        /* 0x4fbd */
    KANJI,        /* 0x4fbe */
    KANJI,        /* 0x4fbf */
    KANJI,        /* 0x4fc0 */
    KANJI,        /* 0x4fc1 */
    KANJI,        /* 0x4fc2 */
    KANJI,        /* 0x4fc3 */
    KANJI,        /* 0x4fc4 */
    KANJI,        /* 0x4fc5 */
    KANJI,        /* 0x4fc6 */
    KANJI,        /* 0x4fc7 */
    KANJI,        /* 0x4fc8 */
    KANJI,        /* 0x4fc9 */
    KANJI,        /* 0x4fca */
    KANJI,        /* 0x4fcb */
    KANJI,        /* 0x4fcc */
    KANJI,        /* 0x4fcd */
    KANJI,        /* 0x4fce */
    KANJI,        /* 0x4fcf */
    KANJI,        /* 0x4fd0 */
    KANJI,        /* 0x4fd1 */
    KANJI,        /* 0x4fd2 */
    KANJI,        /* 0x4fd3 */
    KANJI,        /* 0x4fd4 */
    KANJI,        /* 0x4fd5 */
    KANJI,        /* 0x4fd6 */
    KANJI,        /* 0x4fd7 */
    KANJI,        /* 0x4fd8 */
    KANJI,        /* 0x4fd9 */
    KANJI,        /* 0x4fda */
    KANJI,        /* 0x4fdb */
    KANJI,        /* 0x4fdc */
    KANJI,        /* 0x4fdd */
    KANJI,        /* 0x4fde */
    KANJI,        /* 0x4fdf */
    KANJI,        /* 0x4fe0 */
    KANJI,        /* 0x4fe1 */
    KANJI,        /* 0x4fe2 */
    KANJI,        /* 0x4fe3 */
    KANJI,        /* 0x4fe4 */
    KANJI,        /* 0x4fe5 */
    KANJI,        /* 0x4fe6 */
    KANJI,        /* 0x4fe7 */
    KANJI,        /* 0x4fe8 */
    KANJI,        /* 0x4fe9 */
    KANJI,        /* 0x4fea */
    KANJI,        /* 0x4feb */
    KANJI,        /* 0x4fec */
    KANJI,        /* 0x4fed */
    KANJI,        /* 0x4fee */
    KANJI,        /* 0x4fef */
    KANJI,        /* 0x4ff0 */
    KANJI,        /* 0x4ff1 */
    KANJI,        /* 0x4ff2 */
    KANJI,        /* 0x4ff3 */
    KANJI,        /* 0x4ff4 */
    KANJI,        /* 0x4ff5 */
    KANJI,        /* 0x4ff6 */
    KANJI,        /* 0x4ff7 */
    KANJI,        /* 0x4ff8 */
    KANJI,        /* 0x4ff9 */
    KANJI,        /* 0x4ffa */
    KANJI,        /* 0x4ffb */
    KANJI,        /* 0x4ffc */
    KANJI,        /* 0x4ffd */
    KANJI,        /* 0x4ffe */
    KANJI,        /* 0x4fff */
    KANJI,        /* 0x5000 */
    KANJI,        /* 0x5001 */
    KANJI,        /* 0x5002 */
    KANJI,        /* 0x5003 */
    KANJI,        /* 0x5004 */
    KANJI,        /* 0x5005 */
    KANJI,        /* 0x5006 */
    KANJI,        /* 0x5007 */
    KANJI,        /* 0x5008 */
    KANJI,        /* 0x5009 */
    KANJI,        /* 0x500a */
    KANJI,        /* 0x500b */
    KANJI,        /* 0x500c */
    KANJI,        /* 0x500d */
    KANJI,        /* 0x500e */
    KANJI,        /* 0x500f */
    KANJI,        /* 0x5010 */
    KANJI,        /* 0x5011 */
    KANJI,        /* 0x5012 */
    KANJI,        /* 0x5013 */
    KANJI,        /* 0x5014 */
    KANJI,        /* 0x5015 */
    KANJI,        /* 0x5016 */
    KANJI,        /* 0x5017 */
    KANJI,        /* 0x5018 */
    KANJI,        /* 0x5019 */
    KANJI,        /* 0x501a */
    KANJI,        /* 0x501b */
    KANJI,        /* 0x501c */
    KANJI,        /* 0x501d */
    KANJI,        /* 0x501e */
    KANJI,        /* 0x501f */
    KANJI,        /* 0x5020 */
    KANJI,        /* 0x5021 */
    KANJI,        /* 0x5022 */
    KANJI,        /* 0x5023 */
    KANJI,        /* 0x5024 */
    KANJI,        /* 0x5025 */
    KANJI,        /* 0x5026 */
    KANJI,        /* 0x5027 */
    KANJI,        /* 0x5028 */
    KANJI,        /* 0x5029 */
    KANJI,        /* 0x502a */
    KANJI,        /* 0x502b */
    KANJI,        /* 0x502c */
    KANJI,        /* 0x502d */
    KANJI,        /* 0x502e */
    KANJI,        /* 0x502f */
    KANJI,        /* 0x5030 */
    KANJI,        /* 0x5031 */
    KANJI,        /* 0x5032 */
    KANJI,        /* 0x5033 */
    KANJI,        /* 0x5034 */
    KANJI,        /* 0x5035 */
    KANJI,        /* 0x5036 */
    KANJI,        /* 0x5037 */
    KANJI,        /* 0x5038 */
    KANJI,        /* 0x5039 */
    KANJI,        /* 0x503a */
    KANJI,        /* 0x503b */
    KANJI,        /* 0x503c */
    KANJI,        /* 0x503d */
    KANJI,        /* 0x503e */
    KANJI,        /* 0x503f */
    KANJI,        /* 0x5040 */
    KANJI,        /* 0x5041 */
    KANJI,        /* 0x5042 */
    KANJI,        /* 0x5043 */
    KANJI,        /* 0x5044 */
    KANJI,        /* 0x5045 */
    KANJI,        /* 0x5046 */
    KANJI,        /* 0x5047 */
    KANJI,        /* 0x5048 */
    KANJI,        /* 0x5049 */
    KANJI,        /* 0x504a */
    KANJI,        /* 0x504b */
    KANJI,        /* 0x504c */
    KANJI,        /* 0x504d */
    KANJI,        /* 0x504e */
    KANJI,        /* 0x504f */
    KANJI,        /* 0x5050 */
    KANJI,        /* 0x5051 */
    KANJI,        /* 0x5052 */
    KANJI,        /* 0x5053 */
    KANJI,        /* 0x5054 */
    KANJI,        /* 0x5055 */
    KANJI,        /* 0x5056 */
    KANJI,        /* 0x5057 */
    KANJI,        /* 0x5058 */
    KANJI,        /* 0x5059 */
    KANJI,        /* 0x505a */
    KANJI,        /* 0x505b */
    KANJI,        /* 0x505c */
    KANJI,        /* 0x505d */
    KANJI,        /* 0x505e */
    KANJI,        /* 0x505f */
    KANJI,        /* 0x5060 */
    KANJI,        /* 0x5061 */
    KANJI,        /* 0x5062 */
    KANJI,        /* 0x5063 */
    KANJI,        /* 0x5064 */
    KANJI,        /* 0x5065 */
    KANJI,        /* 0x5066 */
    KANJI,        /* 0x5067 */
    KANJI,        /* 0x5068 */
    KANJI,        /* 0x5069 */
    KANJI,        /* 0x506a */
    KANJI,        /* 0x506b */
    KANJI,        /* 0x506c */
    KANJI,        /* 0x506d */
    KANJI,        /* 0x506e */
    KANJI,        /* 0x506f */
    KANJI,        /* 0x5070 */
    KANJI,        /* 0x5071 */
    KANJI,        /* 0x5072 */
    KANJI,        /* 0x5073 */
    KANJI,        /* 0x5074 */
    KANJI,        /* 0x5075 */
    KANJI,        /* 0x5076 */
    KANJI,        /* 0x5077 */
    KANJI,        /* 0x5078 */
    KANJI,        /* 0x5079 */
    KANJI,        /* 0x507a */
    KANJI,        /* 0x507b */
    KANJI,        /* 0x507c */
    KANJI,        /* 0x507d */
    KANJI,        /* 0x507e */
    KANJI,        /* 0x507f */
    KANJI,        /* 0x5080 */
    KANJI,        /* 0x5081 */
    KANJI,        /* 0x5082 */
    KANJI,        /* 0x5083 */
    KANJI,        /* 0x5084 */
    KANJI,        /* 0x5085 */
    KANJI,        /* 0x5086 */
    KANJI,        /* 0x5087 */
    KANJI,        /* 0x5088 */
    KANJI,        /* 0x5089 */
    KANJI,        /* 0x508a */
    KANJI,        /* 0x508b */
    KANJI,        /* 0x508c */
    KANJI,        /* 0x508d */
    KANJI,        /* 0x508e */
    KANJI,        /* 0x508f */
    KANJI,        /* 0x5090 */
    KANJI,        /* 0x5091 */
    KANJI,        /* 0x5092 */
    KANJI,        /* 0x5093 */
    KANJI,        /* 0x5094 */
    KANJI,        /* 0x5095 */
    KANJI,        /* 0x5096 */
    KANJI,        /* 0x5097 */
    KANJI,        /* 0x5098 */
    KANJI,        /* 0x5099 */
    KANJI,        /* 0x509a */
    KANJI,        /* 0x509b */
    KANJI,        /* 0x509c */
    KANJI,        /* 0x509d */
    KANJI,        /* 0x509e */
    KANJI,        /* 0x509f */
    KANJI,        /* 0x50a0 */
    KANJI,        /* 0x50a1 */
    KANJI,        /* 0x50a2 */
    KANJI,        /* 0x50a3 */
    KANJI,        /* 0x50a4 */
    KANJI,        /* 0x50a5 */
    KANJI,        /* 0x50a6 */
    KANJI,        /* 0x50a7 */
    KANJI,        /* 0x50a8 */
    KANJI,        /* 0x50a9 */
    KANJI,        /* 0x50aa */
    KANJI,        /* 0x50ab */
    KANJI,        /* 0x50ac */
    KANJI,        /* 0x50ad */
    KANJI,        /* 0x50ae */
    KANJI,        /* 0x50af */
    KANJI,        /* 0x50b0 */
    KANJI,        /* 0x50b1 */
    KANJI,        /* 0x50b2 */
    KANJI,        /* 0x50b3 */
    KANJI,        /* 0x50b4 */
    KANJI,        /* 0x50b5 */
    KANJI,        /* 0x50b6 */
    KANJI,        /* 0x50b7 */
    KANJI,        /* 0x50b8 */
    KANJI,        /* 0x50b9 */
    KANJI,        /* 0x50ba */
    KANJI,        /* 0x50bb */
    KANJI,        /* 0x50bc */
    KANJI,        /* 0x50bd */
    KANJI,        /* 0x50be */
    KANJI,        /* 0x50bf */
    KANJI,        /* 0x50c0 */
    KANJI,        /* 0x50c1 */
    KANJI,        /* 0x50c2 */
    KANJI,        /* 0x50c3 */
    KANJI,        /* 0x50c4 */
    KANJI,        /* 0x50c5 */
    KANJI,        /* 0x50c6 */
    KANJI,        /* 0x50c7 */
    KANJI,        /* 0x50c8 */
    KANJI,        /* 0x50c9 */
    KANJI,        /* 0x50ca */
    KANJI,        /* 0x50cb */
    KANJI,        /* 0x50cc */
    KANJI,        /* 0x50cd */
    KANJI,        /* 0x50ce */
    KANJI,        /* 0x50cf */
    KANJI,        /* 0x50d0 */
    KANJI,        /* 0x50d1 */
    KANJI,        /* 0x50d2 */
    KANJI,        /* 0x50d3 */
    KANJI,        /* 0x50d4 */
    KANJI,        /* 0x50d5 */
    KANJI,        /* 0x50d6 */
    KANJI,        /* 0x50d7 */
    KANJI,        /* 0x50d8 */
    KANJI,        /* 0x50d9 */
    KANJI,        /* 0x50da */
    KANJI,        /* 0x50db */
    KANJI,        /* 0x50dc */
    KANJI,        /* 0x50dd */
    KANJI,        /* 0x50de */
    KANJI,        /* 0x50df */
    KANJI,        /* 0x50e0 */
    KANJI,        /* 0x50e1 */
    KANJI,        /* 0x50e2 */
    KANJI,        /* 0x50e3 */
    KANJI,        /* 0x50e4 */
    KANJI,        /* 0x50e5 */
    KANJI,        /* 0x50e6 */
    KANJI,        /* 0x50e7 */
    KANJI,        /* 0x50e8 */
    KANJI,        /* 0x50e9 */
    KANJI,        /* 0x50ea */
    KANJI,        /* 0x50eb */
    KANJI,        /* 0x50ec */
    KANJI,        /* 0x50ed */
    KANJI,        /* 0x50ee */
    KANJI,        /* 0x50ef */
    KANJI,        /* 0x50f0 */
    KANJI,        /* 0x50f1 */
    KANJI,        /* 0x50f2 */
    KANJI,        /* 0x50f3 */
    KANJI,        /* 0x50f4 */
    KANJI,        /* 0x50f5 */
    KANJI,        /* 0x50f6 */
    KANJI,        /* 0x50f7 */
    KANJI,        /* 0x50f8 */
    KANJI,        /* 0x50f9 */
    KANJI,        /* 0x50fa */
    KANJI,        /* 0x50fb */
    KANJI,        /* 0x50fc */
    KANJI,        /* 0x50fd */
    KANJI,        /* 0x50fe */
    KANJI,        /* 0x50ff */
    KANJI,        /* 0x5100 */
    KANJI,        /* 0x5101 */
    KANJI,        /* 0x5102 */
    KANJI,        /* 0x5103 */
    KANJINUMERIC,        /* 0x5104 */
    KANJI,        /* 0x5105 */
    KANJI,        /* 0x5106 */
    KANJI,        /* 0x5107 */
    KANJI,        /* 0x5108 */
    KANJI,        /* 0x5109 */
    KANJI,        /* 0x510a */
    KANJI,        /* 0x510b */
    KANJI,        /* 0x510c */
    KANJI,        /* 0x510d */
    KANJI,        /* 0x510e */
    KANJI,        /* 0x510f */
    KANJI,        /* 0x5110 */
    KANJI,        /* 0x5111 */
    KANJI,        /* 0x5112 */
    KANJI,        /* 0x5113 */
    KANJI,        /* 0x5114 */
    KANJI,        /* 0x5115 */
    KANJI,        /* 0x5116 */
    KANJI,        /* 0x5117 */
    KANJI,        /* 0x5118 */
    KANJI,        /* 0x5119 */
    KANJI,        /* 0x511a */
    KANJI,        /* 0x511b */
    KANJI,        /* 0x511c */
    KANJI,        /* 0x511d */
    KANJI,        /* 0x511e */
    KANJI,        /* 0x511f */
    KANJI,        /* 0x5120 */
    KANJI,        /* 0x5121 */
    KANJI,        /* 0x5122 */
    KANJI,        /* 0x5123 */
    KANJI,        /* 0x5124 */
    KANJI,        /* 0x5125 */
    KANJI,        /* 0x5126 */
    KANJI,        /* 0x5127 */
    KANJI,        /* 0x5128 */
    KANJI,        /* 0x5129 */
    KANJI,        /* 0x512a */
    KANJI,        /* 0x512b */
    KANJI,        /* 0x512c */
    KANJI,        /* 0x512d */
    KANJI,        /* 0x512e */
    KANJI,        /* 0x512f */
    KANJI,        /* 0x5130 */
    KANJI,        /* 0x5131 */
    KANJI,        /* 0x5132 */
    KANJI,        /* 0x5133 */
    KANJI,        /* 0x5134 */
    KANJI,        /* 0x5135 */
    KANJI,        /* 0x5136 */
    KANJI,        /* 0x5137 */
    KANJI,        /* 0x5138 */
    KANJI,        /* 0x5139 */
    KANJI,        /* 0x513a */
    KANJI,        /* 0x513b */
    KANJI,        /* 0x513c */
    KANJI,        /* 0x513d */
    KANJI,        /* 0x513e */
    KANJI,        /* 0x513f */
    KANJI,        /* 0x5140 */
    KANJI,        /* 0x5141 */
    KANJI,        /* 0x5142 */
    KANJI,        /* 0x5143 */
    KANJI,        /* 0x5144 */
    KANJI,        /* 0x5145 */
    KANJINUMERIC,        /* 0x5146 */
    KANJI,        /* 0x5147 */
    KANJI,        /* 0x5148 */
    KANJI,        /* 0x5149 */
    KANJI,        /* 0x514a */
    KANJI,        /* 0x514b */
    KANJI,        /* 0x514c */
    KANJI,        /* 0x514d */
    KANJI,        /* 0x514e */
    KANJI,        /* 0x514f */
    KANJI,        /* 0x5150 */
    KANJI,        /* 0x5151 */
    KANJI,        /* 0x5152 */
    KANJI,        /* 0x5153 */
    KANJI,        /* 0x5154 */
    KANJI,        /* 0x5155 */
    KANJI,        /* 0x5156 */
    KANJI,        /* 0x5157 */
    KANJI,        /* 0x5158 */
    KANJI,        /* 0x5159 */
    KANJI,        /* 0x515a */
    KANJI,        /* 0x515b */
    KANJI,        /* 0x515c */
    KANJI,        /* 0x515d */
    KANJI,        /* 0x515e */
    KANJI,        /* 0x515f */
    KANJI,        /* 0x5160 */
    KANJI,        /* 0x5161 */
    KANJI,        /* 0x5162 */
    KANJI,        /* 0x5163 */
    KANJI,        /* 0x5164 */
    KANJI,        /* 0x5165 */
    KANJI,        /* 0x5166 */
    KANJI,        /* 0x5167 */
    KANJI,        /* 0x5168 */
    KANJI,        /* 0x5169 */
    KANJI,        /* 0x516a */
    KANJINUMERIC,        /* 0x516b */
    KANJI,        /* 0x516c */
    KANJINUMERIC,        /* 0x516d */
    KANJI,        /* 0x516e */
    KANJI,        /* 0x516f */
    KANJI,        /* 0x5170 */
    KANJI,        /* 0x5171 */
    KANJI,        /* 0x5172 */
    KANJI,        /* 0x5173 */
    KANJI,        /* 0x5174 */
    KANJI,        /* 0x5175 */
    KANJI,        /* 0x5176 */
    KANJI,        /* 0x5177 */
    KANJI,        /* 0x5178 */
    KANJI,        /* 0x5179 */
    KANJI,        /* 0x517a */
    KANJI,        /* 0x517b */
    KANJI,        /* 0x517c */
    KANJI,        /* 0x517d */
    KANJI,        /* 0x517e */
    KANJI,        /* 0x517f */
    KANJI,        /* 0x5180 */
    KANJI,        /* 0x5181 */
    KANJI,        /* 0x5182 */
    KANJI,        /* 0x5183 */
    KANJI,        /* 0x5184 */
    KANJI,        /* 0x5185 */
    KANJI,        /* 0x5186 */
    KANJI,        /* 0x5187 */
    KANJI,        /* 0x5188 */
    KANJI,        /* 0x5189 */
    KANJI,        /* 0x518a */
    KANJI,        /* 0x518b */
    KANJI,        /* 0x518c */
    KANJI,        /* 0x518d */
    KANJI,        /* 0x518e */
    KANJI,        /* 0x518f */
    KANJI,        /* 0x5190 */
    KANJI,        /* 0x5191 */
    KANJI,        /* 0x5192 */
    KANJI,        /* 0x5193 */
    KANJI,        /* 0x5194 */
    KANJI,        /* 0x5195 */
    KANJI,        /* 0x5196 */
    KANJI,        /* 0x5197 */
    KANJI,        /* 0x5198 */
    KANJI,        /* 0x5199 */
    KANJI,        /* 0x519a */
    KANJI,        /* 0x519b */
    KANJI,        /* 0x519c */
    KANJI,        /* 0x519d */
    KANJI,        /* 0x519e */
    KANJI,        /* 0x519f */
    KANJI,        /* 0x51a0 */
    KANJI,        /* 0x51a1 */
    KANJI,        /* 0x51a2 */
    KANJI,        /* 0x51a3 */
    KANJI,        /* 0x51a4 */
    KANJI,        /* 0x51a5 */
    KANJI,        /* 0x51a6 */
    KANJI,        /* 0x51a7 */
    KANJI,        /* 0x51a8 */
    KANJI,        /* 0x51a9 */
    KANJI,        /* 0x51aa */
    KANJI,        /* 0x51ab */
    KANJI,        /* 0x51ac */
    KANJI,        /* 0x51ad */
    KANJI,        /* 0x51ae */
    KANJI,        /* 0x51af */
    KANJI,        /* 0x51b0 */
    KANJI,        /* 0x51b1 */
    KANJI,        /* 0x51b2 */
    KANJI,        /* 0x51b3 */
    KANJI,        /* 0x51b4 */
    KANJI,        /* 0x51b5 */
    KANJI,        /* 0x51b6 */
    KANJI,        /* 0x51b7 */
    KANJI,        /* 0x51b8 */
    KANJI,        /* 0x51b9 */
    KANJI,        /* 0x51ba */
    KANJI,        /* 0x51bb */
    KANJI,        /* 0x51bc */
    KANJI,        /* 0x51bd */
    KANJI,        /* 0x51be */
    KANJI,        /* 0x51bf */
    KANJI,        /* 0x51c0 */
    KANJI,        /* 0x51c1 */
    KANJI,        /* 0x51c2 */
    KANJI,        /* 0x51c3 */
    KANJI,        /* 0x51c4 */
    KANJI,        /* 0x51c5 */
    KANJI,        /* 0x51c6 */
    KANJI,        /* 0x51c7 */
    KANJI,        /* 0x51c8 */
    KANJI,        /* 0x51c9 */
    KANJI,        /* 0x51ca */
    KANJI,        /* 0x51cb */
    KANJI,        /* 0x51cc */
    KANJI,        /* 0x51cd */
    KANJI,        /* 0x51ce */
    KANJI,        /* 0x51cf */
    KANJI,        /* 0x51d0 */
    KANJI,        /* 0x51d1 */
    KANJI,        /* 0x51d2 */
    KANJI,        /* 0x51d3 */
    KANJI,        /* 0x51d4 */
    KANJI,        /* 0x51d5 */
    KANJI,        /* 0x51d6 */
    KANJI,        /* 0x51d7 */
    KANJI,        /* 0x51d8 */
    KANJI,        /* 0x51d9 */
    KANJI,        /* 0x51da */
    KANJI,        /* 0x51db */
    KANJI,        /* 0x51dc */
    KANJI,        /* 0x51dd */
    KANJI,        /* 0x51de */
    KANJI,        /* 0x51df */
    KANJI,        /* 0x51e0 */
    KANJI,        /* 0x51e1 */
    KANJI,        /* 0x51e2 */
    KANJI,        /* 0x51e3 */
    KANJI,        /* 0x51e4 */
    KANJI,        /* 0x51e5 */
    KANJI,        /* 0x51e6 */
    KANJI,        /* 0x51e7 */
    KANJI,        /* 0x51e8 */
    KANJI,        /* 0x51e9 */
    KANJI,        /* 0x51ea */
    KANJI,        /* 0x51eb */
    KANJI,        /* 0x51ec */
    KANJI,        /* 0x51ed */
    KANJI,        /* 0x51ee */
    KANJI,        /* 0x51ef */
    KANJI,        /* 0x51f0 */
    KANJI,        /* 0x51f1 */
    KANJI,        /* 0x51f2 */
    KANJI,        /* 0x51f3 */
    KANJI,        /* 0x51f4 */
    KANJI,        /* 0x51f5 */
    KANJI,        /* 0x51f6 */
    KANJI,        /* 0x51f7 */
    KANJI,        /* 0x51f8 */
    KANJI,        /* 0x51f9 */
    KANJI,        /* 0x51fa */
    KANJI,        /* 0x51fb */
    KANJI,        /* 0x51fc */
    KANJI,        /* 0x51fd */
    KANJI,        /* 0x51fe */
    KANJI,        /* 0x51ff */
    KANJI,        /* 0x5200 */
    KANJI,        /* 0x5201 */
    KANJI,        /* 0x5202 */
    KANJI,        /* 0x5203 */
    KANJI,        /* 0x5204 */
    KANJI,        /* 0x5205 */
    KANJI,        /* 0x5206 */
    KANJI,        /* 0x5207 */
    KANJI,        /* 0x5208 */
    KANJI,        /* 0x5209 */
    KANJI,        /* 0x520a */
    KANJI,        /* 0x520b */
    KANJI,        /* 0x520c */
    KANJI,        /* 0x520d */
    KANJI,        /* 0x520e */
    KANJI,        /* 0x520f */
    KANJI,        /* 0x5210 */
    KANJI,        /* 0x5211 */
    KANJI,        /* 0x5212 */
    KANJI,        /* 0x5213 */
    KANJI,        /* 0x5214 */
    KANJI,        /* 0x5215 */
    KANJI,        /* 0x5216 */
    KANJI,        /* 0x5217 */
    KANJI,        /* 0x5218 */
    KANJI,        /* 0x5219 */
    KANJI,        /* 0x521a */
    KANJI,        /* 0x521b */
    KANJI,        /* 0x521c */
    KANJI,        /* 0x521d */
    KANJI,        /* 0x521e */
    KANJI,        /* 0x521f */
    KANJI,        /* 0x5220 */
    KANJI,        /* 0x5221 */
    KANJI,        /* 0x5222 */
    KANJI,        /* 0x5223 */
    KANJI,        /* 0x5224 */
    KANJI,        /* 0x5225 */
    KANJI,        /* 0x5226 */
    KANJI,        /* 0x5227 */
    KANJI,        /* 0x5228 */
    KANJI,        /* 0x5229 */
    KANJI,        /* 0x522a */
    KANJI,        /* 0x522b */
    KANJI,        /* 0x522c */
    KANJI,        /* 0x522d */
    KANJI,        /* 0x522e */
    KANJI,        /* 0x522f */
    KANJI,        /* 0x5230 */
    KANJI,        /* 0x5231 */
    KANJI,        /* 0x5232 */
    KANJI,        /* 0x5233 */
    KANJI,        /* 0x5234 */
    KANJI,        /* 0x5235 */
    KANJI,        /* 0x5236 */
    KANJI,        /* 0x5237 */
    KANJI,        /* 0x5238 */
    KANJI,        /* 0x5239 */
    KANJI,        /* 0x523a */
    KANJI,        /* 0x523b */
    KANJI,        /* 0x523c */
    KANJI,        /* 0x523d */
    KANJI,        /* 0x523e */
    KANJI,        /* 0x523f */
    KANJI,        /* 0x5240 */
    KANJI,        /* 0x5241 */
    KANJI,        /* 0x5242 */
    KANJI,        /* 0x5243 */
    KANJI,        /* 0x5244 */
    KANJI,        /* 0x5245 */
    KANJI,        /* 0x5246 */
    KANJI,        /* 0x5247 */
    KANJI,        /* 0x5248 */
    KANJI,        /* 0x5249 */
    KANJI,        /* 0x524a */
    KANJI,        /* 0x524b */
    KANJI,        /* 0x524c */
    KANJI,        /* 0x524d */
    KANJI,        /* 0x524e */
    KANJI,        /* 0x524f */
    KANJI,        /* 0x5250 */
    KANJI,        /* 0x5251 */
    KANJI,        /* 0x5252 */
    KANJI,        /* 0x5253 */
    KANJI,        /* 0x5254 */
    KANJI,        /* 0x5255 */
    KANJI,        /* 0x5256 */
    KANJI,        /* 0x5257 */
    KANJI,        /* 0x5258 */
    KANJI,        /* 0x5259 */
    KANJI,        /* 0x525a */
    KANJI,        /* 0x525b */
    KANJI,        /* 0x525c */
    KANJI,        /* 0x525d */
    KANJI,        /* 0x525e */
    KANJI,        /* 0x525f */
    KANJI,        /* 0x5260 */
    KANJI,        /* 0x5261 */
    KANJI,        /* 0x5262 */
    KANJI,        /* 0x5263 */
    KANJI,        /* 0x5264 */
    KANJI,        /* 0x5265 */
    KANJI,        /* 0x5266 */
    KANJI,        /* 0x5267 */
    KANJI,        /* 0x5268 */
    KANJI,        /* 0x5269 */
    KANJI,        /* 0x526a */
    KANJI,        /* 0x526b */
    KANJI,        /* 0x526c */
    KANJI,        /* 0x526d */
    KANJI,        /* 0x526e */
    KANJI,        /* 0x526f */
    KANJI,        /* 0x5270 */
    KANJI,        /* 0x5271 */
    KANJI,        /* 0x5272 */
    KANJI,        /* 0x5273 */
    KANJI,        /* 0x5274 */
    KANJI,        /* 0x5275 */
    KANJI,        /* 0x5276 */
    KANJI,        /* 0x5277 */
    KANJI,        /* 0x5278 */
    KANJI,        /* 0x5279 */
    KANJI,        /* 0x527a */
    KANJI,        /* 0x527b */
    KANJI,        /* 0x527c */
    KANJI,        /* 0x527d */
    KANJI,        /* 0x527e */
    KANJI,        /* 0x527f */
    KANJI,        /* 0x5280 */
    KANJI,        /* 0x5281 */
    KANJI,        /* 0x5282 */
    KANJI,        /* 0x5283 */
    KANJI,        /* 0x5284 */
    KANJI,        /* 0x5285 */
    KANJI,        /* 0x5286 */
    KANJI,        /* 0x5287 */
    KANJI,        /* 0x5288 */
    KANJI,        /* 0x5289 */
    KANJI,        /* 0x528a */
    KANJI,        /* 0x528b */
    KANJI,        /* 0x528c */
    KANJI,        /* 0x528d */
    KANJI,        /* 0x528e */
    KANJI,        /* 0x528f */
    KANJI,        /* 0x5290 */
    KANJI,        /* 0x5291 */
    KANJI,        /* 0x5292 */
    KANJI,        /* 0x5293 */
    KANJI,        /* 0x5294 */
    KANJI,        /* 0x5295 */
    KANJI,        /* 0x5296 */
    KANJI,        /* 0x5297 */
    KANJI,        /* 0x5298 */
    KANJI,        /* 0x5299 */
    KANJI,        /* 0x529a */
    KANJI,        /* 0x529b */
    KANJI,        /* 0x529c */
    KANJI,        /* 0x529d */
    KANJI,        /* 0x529e */
    KANJI,        /* 0x529f */
    KANJI,        /* 0x52a0 */
    KANJI,        /* 0x52a1 */
    KANJI,        /* 0x52a2 */
    KANJI,        /* 0x52a3 */
    KANJI,        /* 0x52a4 */
    KANJI,        /* 0x52a5 */
    KANJI,        /* 0x52a6 */
    KANJI,        /* 0x52a7 */
    KANJI,        /* 0x52a8 */
    KANJI,        /* 0x52a9 */
    KANJI,        /* 0x52aa */
    KANJI,        /* 0x52ab */
    KANJI,        /* 0x52ac */
    KANJI,        /* 0x52ad */
    KANJI,        /* 0x52ae */
    KANJI,        /* 0x52af */
    KANJI,        /* 0x52b0 */
    KANJI,        /* 0x52b1 */
    KANJI,        /* 0x52b2 */
    KANJI,        /* 0x52b3 */
    KANJI,        /* 0x52b4 */
    KANJI,        /* 0x52b5 */
    KANJI,        /* 0x52b6 */
    KANJI,        /* 0x52b7 */
    KANJI,        /* 0x52b8 */
    KANJI,        /* 0x52b9 */
    KANJI,        /* 0x52ba */
    KANJI,        /* 0x52bb */
    KANJI,        /* 0x52bc */
    KANJI,        /* 0x52bd */
    KANJI,        /* 0x52be */
    KANJI,        /* 0x52bf */
    KANJI,        /* 0x52c0 */
    KANJI,        /* 0x52c1 */
    KANJI,        /* 0x52c2 */
    KANJI,        /* 0x52c3 */
    KANJI,        /* 0x52c4 */
    KANJI,        /* 0x52c5 */
    KANJI,        /* 0x52c6 */
    KANJI,        /* 0x52c7 */
    KANJI,        /* 0x52c8 */
    KANJI,        /* 0x52c9 */
    KANJI,        /* 0x52ca */
    KANJI,        /* 0x52cb */
    KANJI,        /* 0x52cc */
    KANJI,        /* 0x52cd */
    KANJI,        /* 0x52ce */
    KANJI,        /* 0x52cf */
    KANJI,        /* 0x52d0 */
    KANJI,        /* 0x52d1 */
    KANJI,        /* 0x52d2 */
    KANJI,        /* 0x52d3 */
    KANJI,        /* 0x52d4 */
    KANJI,        /* 0x52d5 */
    KANJI,        /* 0x52d6 */
    KANJI,        /* 0x52d7 */
    KANJI,        /* 0x52d8 */
    KANJI,        /* 0x52d9 */
    KANJI,        /* 0x52da */
    KANJI,        /* 0x52db */
    KANJI,        /* 0x52dc */
    KANJI,        /* 0x52dd */
    KANJI,        /* 0x52de */
    KANJI,        /* 0x52df */
    KANJI,        /* 0x52e0 */
    KANJI,        /* 0x52e1 */
    KANJI,        /* 0x52e2 */
    KANJI,        /* 0x52e3 */
    KANJI,        /* 0x52e4 */
    KANJI,        /* 0x52e5 */
    KANJI,        /* 0x52e6 */
    KANJI,        /* 0x52e7 */
    KANJI,        /* 0x52e8 */
    KANJI,        /* 0x52e9 */
    KANJI,        /* 0x52ea */
    KANJI,        /* 0x52eb */
    KANJI,        /* 0x52ec */
    KANJI,        /* 0x52ed */
    KANJI,        /* 0x52ee */
    KANJI,        /* 0x52ef */
    KANJI,        /* 0x52f0 */
    KANJI,        /* 0x52f1 */
    KANJI,        /* 0x52f2 */
    KANJI,        /* 0x52f3 */
    KANJI,        /* 0x52f4 */
    KANJI,        /* 0x52f5 */
    KANJI,        /* 0x52f6 */
    KANJI,        /* 0x52f7 */
    KANJI,        /* 0x52f8 */
    KANJI,        /* 0x52f9 */
    KANJI,        /* 0x52fa */
    KANJI,        /* 0x52fb */
    KANJI,        /* 0x52fc */
    KANJI,        /* 0x52fd */
    KANJI,        /* 0x52fe */
    KANJI,        /* 0x52ff */
    KANJI,        /* 0x5300 */
    KANJI,        /* 0x5301 */
    KANJI,        /* 0x5302 */
    KANJI,        /* 0x5303 */
    KANJI,        /* 0x5304 */
    KANJI,        /* 0x5305 */
    KANJI,        /* 0x5306 */
    KANJI,        /* 0x5307 */
    KANJI,        /* 0x5308 */
    KANJI,        /* 0x5309 */
    KANJI,        /* 0x530a */
    KANJI,        /* 0x530b */
    KANJI,        /* 0x530c */
    KANJI,        /* 0x530d */
    KANJI,        /* 0x530e */
    KANJI,        /* 0x530f */
    KANJI,        /* 0x5310 */
    KANJI,        /* 0x5311 */
    KANJI,        /* 0x5312 */
    KANJI,        /* 0x5313 */
    KANJI,        /* 0x5314 */
    KANJI,        /* 0x5315 */
    KANJI,        /* 0x5316 */
    KANJI,        /* 0x5317 */
    KANJI,        /* 0x5318 */
    KANJI,        /* 0x5319 */
    KANJI,        /* 0x531a */
    KANJI,        /* 0x531b */
    KANJI,        /* 0x531c */
    KANJI,        /* 0x531d */
    KANJI,        /* 0x531e */
    KANJI,        /* 0x531f */
    KANJI,        /* 0x5320 */
    KANJI,        /* 0x5321 */
    KANJI,        /* 0x5322 */
    KANJI,        /* 0x5323 */
    KANJI,        /* 0x5324 */
    KANJI,        /* 0x5325 */
    KANJI,        /* 0x5326 */
    KANJI,        /* 0x5327 */
    KANJI,        /* 0x5328 */
    KANJI,        /* 0x5329 */
    KANJI,        /* 0x532a */
    KANJI,        /* 0x532b */
    KANJI,        /* 0x532c */
    KANJI,        /* 0x532d */
    KANJI,        /* 0x532e */
    KANJI,        /* 0x532f */
    KANJI,        /* 0x5330 */
    KANJI,        /* 0x5331 */
    KANJI,        /* 0x5332 */
    KANJI,        /* 0x5333 */
    KANJI,        /* 0x5334 */
    KANJI,        /* 0x5335 */
    KANJI,        /* 0x5336 */
    KANJI,        /* 0x5337 */
    KANJI,        /* 0x5338 */
    KANJI,        /* 0x5339 */
    KANJI,        /* 0x533a */
    KANJI,        /* 0x533b */
    KANJI,        /* 0x533c */
    KANJI,        /* 0x533d */
    KANJI,        /* 0x533e */
    KANJI,        /* 0x533f */
    KANJI,        /* 0x5340 */
    KANJINUMERIC,        /* 0x5341 */
    KANJI,        /* 0x5342 */
    KANJINUMERIC,        /* 0x5343 */
    KANJI,        /* 0x5344 */
    KANJI,        /* 0x5345 */
    KANJI,        /* 0x5346 */
    KANJI,        /* 0x5347 */
    KANJI,        /* 0x5348 */
    KANJI,        /* 0x5349 */
    KANJI,        /* 0x534a */
    KANJI,        /* 0x534b */
    KANJI,        /* 0x534c */
    KANJI,        /* 0x534d */
    KANJI,        /* 0x534e */
    KANJI,        /* 0x534f */
    KANJI,        /* 0x5350 */
    KANJI,        /* 0x5351 */
    KANJI,        /* 0x5352 */
    KANJI,        /* 0x5353 */
    KANJI,        /* 0x5354 */
    KANJI,        /* 0x5355 */
    KANJI,        /* 0x5356 */
    KANJI,        /* 0x5357 */
    KANJI,        /* 0x5358 */
    KANJI,        /* 0x5359 */
    KANJI,        /* 0x535a */
    KANJI,        /* 0x535b */
    KANJI,        /* 0x535c */
    KANJI,        /* 0x535d */
    KANJI,        /* 0x535e */
    KANJI,        /* 0x535f */
    KANJI,        /* 0x5360 */
    KANJI,        /* 0x5361 */
    KANJI,        /* 0x5362 */
    KANJI,        /* 0x5363 */
    KANJI,        /* 0x5364 */
    KANJI,        /* 0x5365 */
    KANJI,        /* 0x5366 */
    KANJI,        /* 0x5367 */
    KANJI,        /* 0x5368 */
    KANJI,        /* 0x5369 */
    KANJI,        /* 0x536a */
    KANJI,        /* 0x536b */
    KANJI,        /* 0x536c */
    KANJI,        /* 0x536d */
    KANJI,        /* 0x536e */
    KANJI,        /* 0x536f */
    KANJI,        /* 0x5370 */
    KANJI,        /* 0x5371 */
    KANJI,        /* 0x5372 */
    KANJI,        /* 0x5373 */
    KANJI,        /* 0x5374 */
    KANJI,        /* 0x5375 */
    KANJI,        /* 0x5376 */
    KANJI,        /* 0x5377 */
    KANJI,        /* 0x5378 */
    KANJI,        /* 0x5379 */
    KANJI,        /* 0x537a */
    KANJI,        /* 0x537b */
    KANJI,        /* 0x537c */
    KANJI,        /* 0x537d */
    KANJI,        /* 0x537e */
    KANJI,        /* 0x537f */
    KANJI,        /* 0x5380 */
    KANJI,        /* 0x5381 */
    KANJI,        /* 0x5382 */
    KANJI,        /* 0x5383 */
    KANJI,        /* 0x5384 */
    KANJI,        /* 0x5385 */
    KANJI,        /* 0x5386 */
    KANJI,        /* 0x5387 */
    KANJI,        /* 0x5388 */
    KANJI,        /* 0x5389 */
    KANJI,        /* 0x538a */
    KANJI,        /* 0x538b */
    KANJI,        /* 0x538c */
    KANJI,        /* 0x538d */
    KANJI,        /* 0x538e */
    KANJI,        /* 0x538f */
    KANJI,        /* 0x5390 */
    KANJI,        /* 0x5391 */
    KANJI,        /* 0x5392 */
    KANJI,        /* 0x5393 */
    KANJI,        /* 0x5394 */
    KANJI,        /* 0x5395 */
    KANJI,        /* 0x5396 */
    KANJI,        /* 0x5397 */
    KANJI,        /* 0x5398 */
    KANJI,        /* 0x5399 */
    KANJI,        /* 0x539a */
    KANJI,        /* 0x539b */
    KANJI,        /* 0x539c */
    KANJI,        /* 0x539d */
    KANJI,        /* 0x539e */
    KANJI,        /* 0x539f */
    KANJI,        /* 0x53a0 */
    KANJI,        /* 0x53a1 */
    KANJI,        /* 0x53a2 */
    KANJI,        /* 0x53a3 */
    KANJI,        /* 0x53a4 */
    KANJI,        /* 0x53a5 */
    KANJI,        /* 0x53a6 */
    KANJI,        /* 0x53a7 */
    KANJI,        /* 0x53a8 */
    KANJI,        /* 0x53a9 */
    KANJI,        /* 0x53aa */
    KANJI,        /* 0x53ab */
    KANJI,        /* 0x53ac */
    KANJI,        /* 0x53ad */
    KANJI,        /* 0x53ae */
    KANJI,        /* 0x53af */
    KANJI,        /* 0x53b0 */
    KANJI,        /* 0x53b1 */
    KANJI,        /* 0x53b2 */
    KANJI,        /* 0x53b3 */
    KANJI,        /* 0x53b4 */
    KANJI,        /* 0x53b5 */
    KANJI,        /* 0x53b6 */
    KANJI,        /* 0x53b7 */
    KANJI,        /* 0x53b8 */
    KANJI,        /* 0x53b9 */
    KANJI,        /* 0x53ba */
    KANJI,        /* 0x53bb */
    KANJI,        /* 0x53bc */
    KANJI,        /* 0x53bd */
    KANJI,        /* 0x53be */
    KANJI,        /* 0x53bf */
    KANJI,        /* 0x53c0 */
    KANJI,        /* 0x53c1 */
    KANJI,        /* 0x53c2 */
    KANJI,        /* 0x53c3 */
    KANJI,        /* 0x53c4 */
    KANJI,        /* 0x53c5 */
    KANJI,        /* 0x53c6 */
    KANJI,        /* 0x53c7 */
    KANJI,        /* 0x53c8 */
    KANJI,        /* 0x53c9 */
    KANJI,        /* 0x53ca */
    KANJI,        /* 0x53cb */
    KANJI,        /* 0x53cc */
    KANJI,        /* 0x53cd */
    KANJI,        /* 0x53ce */
    KANJI,        /* 0x53cf */
    KANJI,        /* 0x53d0 */
    KANJI,        /* 0x53d1 */
    KANJI,        /* 0x53d2 */
    KANJI,        /* 0x53d3 */
    KANJI,        /* 0x53d4 */
    KANJI,        /* 0x53d5 */
    KANJI,        /* 0x53d6 */
    KANJI,        /* 0x53d7 */
    KANJI,        /* 0x53d8 */
    KANJI,        /* 0x53d9 */
    KANJI,        /* 0x53da */
    KANJI,        /* 0x53db */
    KANJI,        /* 0x53dc */
    KANJI,        /* 0x53dd */
    KANJI,        /* 0x53de */
    KANJI,        /* 0x53df */
    KANJI,        /* 0x53e0 */
    KANJI,        /* 0x53e1 */
    KANJI,        /* 0x53e2 */
    KANJI,        /* 0x53e3 */
    KANJI,        /* 0x53e4 */
    KANJI,        /* 0x53e5 */
    KANJI,        /* 0x53e6 */
    KANJI,        /* 0x53e7 */
    KANJI,        /* 0x53e8 */
    KANJI,        /* 0x53e9 */
    KANJI,        /* 0x53ea */
    KANJI,        /* 0x53eb */
    KANJI,        /* 0x53ec */
    KANJI,        /* 0x53ed */
    KANJI,        /* 0x53ee */
    KANJI,        /* 0x53ef */
    KANJI,        /* 0x53f0 */
    KANJI,        /* 0x53f1 */
    KANJI,        /* 0x53f2 */
    KANJI,        /* 0x53f3 */
    KANJI,        /* 0x53f4 */
    KANJI,        /* 0x53f5 */
    KANJI,        /* 0x53f6 */
    KANJI,        /* 0x53f7 */
    KANJI,        /* 0x53f8 */
    KANJI,        /* 0x53f9 */
    KANJI,        /* 0x53fa */
    KANJI,        /* 0x53fb */
    KANJI,        /* 0x53fc */
    KANJI,        /* 0x53fd */
    KANJI,        /* 0x53fe */
    KANJI,        /* 0x53ff */
    KANJI,        /* 0x5400 */
    KANJI,        /* 0x5401 */
    KANJI,        /* 0x5402 */
    KANJI,        /* 0x5403 */
    KANJI,        /* 0x5404 */
    KANJI,        /* 0x5405 */
    KANJI,        /* 0x5406 */
    KANJI,        /* 0x5407 */
    KANJI,        /* 0x5408 */
    KANJI,        /* 0x5409 */
    KANJI,        /* 0x540a */
    KANJI,        /* 0x540b */
    KANJI,        /* 0x540c */
    KANJI,        /* 0x540d */
    KANJI,        /* 0x540e */
    KANJI,        /* 0x540f */
    KANJI,        /* 0x5410 */
    KANJI,        /* 0x5411 */
    KANJI,        /* 0x5412 */
    KANJI,        /* 0x5413 */
    KANJI,        /* 0x5414 */
    KANJI,        /* 0x5415 */
    KANJI,        /* 0x5416 */
    KANJI,        /* 0x5417 */
    KANJI,        /* 0x5418 */
    KANJI,        /* 0x5419 */
    KANJI,        /* 0x541a */
    KANJI,        /* 0x541b */
    KANJI,        /* 0x541c */
    KANJI,        /* 0x541d */
    KANJI,        /* 0x541e */
    KANJI,        /* 0x541f */
    KANJI,        /* 0x5420 */
    KANJI,        /* 0x5421 */
    KANJI,        /* 0x5422 */
    KANJI,        /* 0x5423 */
    KANJI,        /* 0x5424 */
    KANJI,        /* 0x5425 */
    KANJI,        /* 0x5426 */
    KANJI,        /* 0x5427 */
    KANJI,        /* 0x5428 */
    KANJI,        /* 0x5429 */
    KANJI,        /* 0x542a */
    KANJI,        /* 0x542b */
    KANJI,        /* 0x542c */
    KANJI,        /* 0x542d */
    KANJI,        /* 0x542e */
    KANJI,        /* 0x542f */
    KANJI,        /* 0x5430 */
    KANJI,        /* 0x5431 */
    KANJI,        /* 0x5432 */
    KANJI,        /* 0x5433 */
    KANJI,        /* 0x5434 */
    KANJI,        /* 0x5435 */
    KANJI,        /* 0x5436 */
    KANJI,        /* 0x5437 */
    KANJI,        /* 0x5438 */
    KANJI,        /* 0x5439 */
    KANJI,        /* 0x543a */
    KANJI,        /* 0x543b */
    KANJI,        /* 0x543c */
    KANJI,        /* 0x543d */
    KANJI,        /* 0x543e */
    KANJI,        /* 0x543f */
    KANJI,        /* 0x5440 */
    KANJI,        /* 0x5441 */
    KANJI,        /* 0x5442 */
    KANJI,        /* 0x5443 */
    KANJI,        /* 0x5444 */
    KANJI,        /* 0x5445 */
    KANJI,        /* 0x5446 */
    KANJI,        /* 0x5447 */
    KANJI,        /* 0x5448 */
    KANJI,        /* 0x5449 */
    KANJI,        /* 0x544a */
    KANJI,        /* 0x544b */
    KANJI,        /* 0x544c */
    KANJI,        /* 0x544d */
    KANJI,        /* 0x544e */
    KANJI,        /* 0x544f */
    KANJI,        /* 0x5450 */
    KANJI,        /* 0x5451 */
    KANJI,        /* 0x5452 */
    KANJI,        /* 0x5453 */
    KANJI,        /* 0x5454 */
    KANJI,        /* 0x5455 */
    KANJI,        /* 0x5456 */
    KANJI,        /* 0x5457 */
    KANJI,        /* 0x5458 */
    KANJI,        /* 0x5459 */
    KANJI,        /* 0x545a */
    KANJI,        /* 0x545b */
    KANJI,        /* 0x545c */
    KANJI,        /* 0x545d */
    KANJI,        /* 0x545e */
    KANJI,        /* 0x545f */
    KANJI,        /* 0x5460 */
    KANJI,        /* 0x5461 */
    KANJI,        /* 0x5462 */
    KANJI,        /* 0x5463 */
    KANJI,        /* 0x5464 */
    KANJI,        /* 0x5465 */
    KANJI,        /* 0x5466 */
    KANJI,        /* 0x5467 */
    KANJI,        /* 0x5468 */
    KANJI,        /* 0x5469 */
    KANJI,        /* 0x546a */
    KANJI,        /* 0x546b */
    KANJI,        /* 0x546c */
    KANJI,        /* 0x546d */
    KANJI,        /* 0x546e */
    KANJI,        /* 0x546f */
    KANJI,        /* 0x5470 */
    KANJI,        /* 0x5471 */
    KANJI,        /* 0x5472 */
    KANJI,        /* 0x5473 */
    KANJI,        /* 0x5474 */
    KANJI,        /* 0x5475 */
    KANJI,        /* 0x5476 */
    KANJI,        /* 0x5477 */
    KANJI,        /* 0x5478 */
    KANJI,        /* 0x5479 */
    KANJI,        /* 0x547a */
    KANJI,        /* 0x547b */
    KANJI,        /* 0x547c */
    KANJI,        /* 0x547d */
    KANJI,        /* 0x547e */
    KANJI,        /* 0x547f */
    KANJI,        /* 0x5480 */
    KANJI,        /* 0x5481 */
    KANJI,        /* 0x5482 */
    KANJI,        /* 0x5483 */
    KANJI,        /* 0x5484 */
    KANJI,        /* 0x5485 */
    KANJI,        /* 0x5486 */
    KANJI,        /* 0x5487 */
    KANJI,        /* 0x5488 */
    KANJI,        /* 0x5489 */
    KANJI,        /* 0x548a */
    KANJI,        /* 0x548b */
    KANJI,        /* 0x548c */
    KANJI,        /* 0x548d */
    KANJI,        /* 0x548e */
    KANJI,        /* 0x548f */
    KANJI,        /* 0x5490 */
    KANJI,        /* 0x5491 */
    KANJI,        /* 0x5492 */
    KANJI,        /* 0x5493 */
    KANJI,        /* 0x5494 */
    KANJI,        /* 0x5495 */
    KANJI,        /* 0x5496 */
    KANJI,        /* 0x5497 */
    KANJI,        /* 0x5498 */
    KANJI,        /* 0x5499 */
    KANJI,        /* 0x549a */
    KANJI,        /* 0x549b */
    KANJI,        /* 0x549c */
    KANJI,        /* 0x549d */
    KANJI,        /* 0x549e */
    KANJI,        /* 0x549f */
    KANJI,        /* 0x54a0 */
    KANJI,        /* 0x54a1 */
    KANJI,        /* 0x54a2 */
    KANJI,        /* 0x54a3 */
    KANJI,        /* 0x54a4 */
    KANJI,        /* 0x54a5 */
    KANJI,        /* 0x54a6 */
    KANJI,        /* 0x54a7 */
    KANJI,        /* 0x54a8 */
    KANJI,        /* 0x54a9 */
    KANJI,        /* 0x54aa */
    KANJI,        /* 0x54ab */
    KANJI,        /* 0x54ac */
    KANJI,        /* 0x54ad */
    KANJI,        /* 0x54ae */
    KANJI,        /* 0x54af */
    KANJI,        /* 0x54b0 */
    KANJI,        /* 0x54b1 */
    KANJI,        /* 0x54b2 */
    KANJI,        /* 0x54b3 */
    KANJI,        /* 0x54b4 */
    KANJI,        /* 0x54b5 */
    KANJI,        /* 0x54b6 */
    KANJI,        /* 0x54b7 */
    KANJI,        /* 0x54b8 */
    KANJI,        /* 0x54b9 */
    KANJI,        /* 0x54ba */
    KANJI,        /* 0x54bb */
    KANJI,        /* 0x54bc */
    KANJI,        /* 0x54bd */
    KANJI,        /* 0x54be */
    KANJI,        /* 0x54bf */
    KANJI,        /* 0x54c0 */
    KANJI,        /* 0x54c1 */
    KANJI,        /* 0x54c2 */
    KANJI,        /* 0x54c3 */
    KANJI,        /* 0x54c4 */
    KANJI,        /* 0x54c5 */
    KANJI,        /* 0x54c6 */
    KANJI,        /* 0x54c7 */
    KANJI,        /* 0x54c8 */
    KANJI,        /* 0x54c9 */
    KANJI,        /* 0x54ca */
    KANJI,        /* 0x54cb */
    KANJI,        /* 0x54cc */
    KANJI,        /* 0x54cd */
    KANJI,        /* 0x54ce */
    KANJI,        /* 0x54cf */
    KANJI,        /* 0x54d0 */
    KANJI,        /* 0x54d1 */
    KANJI,        /* 0x54d2 */
    KANJI,        /* 0x54d3 */
    KANJI,        /* 0x54d4 */
    KANJI,        /* 0x54d5 */
    KANJI,        /* 0x54d6 */
    KANJI,        /* 0x54d7 */
    KANJI,        /* 0x54d8 */
    KANJI,        /* 0x54d9 */
    KANJI,        /* 0x54da */
    KANJI,        /* 0x54db */
    KANJI,        /* 0x54dc */
    KANJI,        /* 0x54dd */
    KANJI,        /* 0x54de */
    KANJI,        /* 0x54df */
    KANJI,        /* 0x54e0 */
    KANJI,        /* 0x54e1 */
    KANJI,        /* 0x54e2 */
    KANJI,        /* 0x54e3 */
    KANJI,        /* 0x54e4 */
    KANJI,        /* 0x54e5 */
    KANJI,        /* 0x54e6 */
    KANJI,        /* 0x54e7 */
    KANJI,        /* 0x54e8 */
    KANJI,        /* 0x54e9 */
    KANJI,        /* 0x54ea */
    KANJI,        /* 0x54eb */
    KANJI,        /* 0x54ec */
    KANJI,        /* 0x54ed */
    KANJI,        /* 0x54ee */
    KANJI,        /* 0x54ef */
    KANJI,        /* 0x54f0 */
    KANJI,        /* 0x54f1 */
    KANJI,        /* 0x54f2 */
    KANJI,        /* 0x54f3 */
    KANJI,        /* 0x54f4 */
    KANJI,        /* 0x54f5 */
    KANJI,        /* 0x54f6 */
    KANJI,        /* 0x54f7 */
    KANJI,        /* 0x54f8 */
    KANJI,        /* 0x54f9 */
    KANJI,        /* 0x54fa */
    KANJI,        /* 0x54fb */
    KANJI,        /* 0x54fc */
    KANJI,        /* 0x54fd */
    KANJI,        /* 0x54fe */
    KANJI,        /* 0x54ff */
    KANJI,        /* 0x5500 */
    KANJI,        /* 0x5501 */
    KANJI,        /* 0x5502 */
    KANJI,        /* 0x5503 */
    KANJI,        /* 0x5504 */
    KANJI,        /* 0x5505 */
    KANJI,        /* 0x5506 */
    KANJI,        /* 0x5507 */
    KANJI,        /* 0x5508 */
    KANJI,        /* 0x5509 */
    KANJI,        /* 0x550a */
    KANJI,        /* 0x550b */
    KANJI,        /* 0x550c */
    KANJI,        /* 0x550d */
    KANJI,        /* 0x550e */
    KANJI,        /* 0x550f */
    KANJI,        /* 0x5510 */
    KANJI,        /* 0x5511 */
    KANJI,        /* 0x5512 */
    KANJI,        /* 0x5513 */
    KANJI,        /* 0x5514 */
    KANJI,        /* 0x5515 */
    KANJI,        /* 0x5516 */
    KANJI,        /* 0x5517 */
    KANJI,        /* 0x5518 */
    KANJI,        /* 0x5519 */
    KANJI,        /* 0x551a */
    KANJI,        /* 0x551b */
    KANJI,        /* 0x551c */
    KANJI,        /* 0x551d */
    KANJI,        /* 0x551e */
    KANJI,        /* 0x551f */
    KANJI,        /* 0x5520 */
    KANJI,        /* 0x5521 */
    KANJI,        /* 0x5522 */
    KANJI,        /* 0x5523 */
    KANJI,        /* 0x5524 */
    KANJI,        /* 0x5525 */
    KANJI,        /* 0x5526 */
    KANJI,        /* 0x5527 */
    KANJI,        /* 0x5528 */
    KANJI,        /* 0x5529 */
    KANJI,        /* 0x552a */
    KANJI,        /* 0x552b */
    KANJI,        /* 0x552c */
    KANJI,        /* 0x552d */
    KANJI,        /* 0x552e */
    KANJI,        /* 0x552f */
    KANJI,        /* 0x5530 */
    KANJI,        /* 0x5531 */
    KANJI,        /* 0x5532 */
    KANJI,        /* 0x5533 */
    KANJI,        /* 0x5534 */
    KANJI,        /* 0x5535 */
    KANJI,        /* 0x5536 */
    KANJI,        /* 0x5537 */
    KANJI,        /* 0x5538 */
    KANJI,        /* 0x5539 */
    KANJI,        /* 0x553a */
    KANJI,        /* 0x553b */
    KANJI,        /* 0x553c */
    KANJI,        /* 0x553d */
    KANJI,        /* 0x553e */
    KANJI,        /* 0x553f */
    KANJI,        /* 0x5540 */
    KANJI,        /* 0x5541 */
    KANJI,        /* 0x5542 */
    KANJI,        /* 0x5543 */
    KANJI,        /* 0x5544 */
    KANJI,        /* 0x5545 */
    KANJI,        /* 0x5546 */
    KANJI,        /* 0x5547 */
    KANJI,        /* 0x5548 */
    KANJI,        /* 0x5549 */
    KANJI,        /* 0x554a */
    KANJI,        /* 0x554b */
    KANJI,        /* 0x554c */
    KANJI,        /* 0x554d */
    KANJI,        /* 0x554e */
    KANJI,        /* 0x554f */
    KANJI,        /* 0x5550 */
    KANJI,        /* 0x5551 */
    KANJI,        /* 0x5552 */
    KANJI,        /* 0x5553 */
    KANJI,        /* 0x5554 */
    KANJI,        /* 0x5555 */
    KANJI,        /* 0x5556 */
    KANJI,        /* 0x5557 */
    KANJI,        /* 0x5558 */
    KANJI,        /* 0x5559 */
    KANJI,        /* 0x555a */
    KANJI,        /* 0x555b */
    KANJI,        /* 0x555c */
    KANJI,        /* 0x555d */
    KANJI,        /* 0x555e */
    KANJI,        /* 0x555f */
    KANJI,        /* 0x5560 */
    KANJI,        /* 0x5561 */
    KANJI,        /* 0x5562 */
    KANJI,        /* 0x5563 */
    KANJI,        /* 0x5564 */
    KANJI,        /* 0x5565 */
    KANJI,        /* 0x5566 */
    KANJI,        /* 0x5567 */
    KANJI,        /* 0x5568 */
    KANJI,        /* 0x5569 */
    KANJI,        /* 0x556a */
    KANJI,        /* 0x556b */
    KANJI,        /* 0x556c */
    KANJI,        /* 0x556d */
    KANJI,        /* 0x556e */
    KANJI,        /* 0x556f */
    KANJI,        /* 0x5570 */
    KANJI,        /* 0x5571 */
    KANJI,        /* 0x5572 */
    KANJI,        /* 0x5573 */
    KANJI,        /* 0x5574 */
    KANJI,        /* 0x5575 */
    KANJI,        /* 0x5576 */
    KANJI,        /* 0x5577 */
    KANJI,        /* 0x5578 */
    KANJI,        /* 0x5579 */
    KANJI,        /* 0x557a */
    KANJI,        /* 0x557b */
    KANJI,        /* 0x557c */
    KANJI,        /* 0x557d */
    KANJI,        /* 0x557e */
    KANJI,        /* 0x557f */
    KANJI,        /* 0x5580 */
    KANJI,        /* 0x5581 */
    KANJI,        /* 0x5582 */
    KANJI,        /* 0x5583 */
    KANJI,        /* 0x5584 */
    KANJI,        /* 0x5585 */
    KANJI,        /* 0x5586 */
    KANJI,        /* 0x5587 */
    KANJI,        /* 0x5588 */
    KANJI,        /* 0x5589 */
    KANJI,        /* 0x558a */
    KANJI,        /* 0x558b */
    KANJI,        /* 0x558c */
    KANJI,        /* 0x558d */
    KANJI,        /* 0x558e */
    KANJI,        /* 0x558f */
    KANJI,        /* 0x5590 */
    KANJI,        /* 0x5591 */
    KANJI,        /* 0x5592 */
    KANJI,        /* 0x5593 */
    KANJI,        /* 0x5594 */
    KANJI,        /* 0x5595 */
    KANJI,        /* 0x5596 */
    KANJI,        /* 0x5597 */
    KANJI,        /* 0x5598 */
    KANJI,        /* 0x5599 */
    KANJI,        /* 0x559a */
    KANJI,        /* 0x559b */
    KANJI,        /* 0x559c */
    KANJI,        /* 0x559d */
    KANJI,        /* 0x559e */
    KANJI,        /* 0x559f */
    KANJI,        /* 0x55a0 */
    KANJI,        /* 0x55a1 */
    KANJI,        /* 0x55a2 */
    KANJI,        /* 0x55a3 */
    KANJI,        /* 0x55a4 */
    KANJI,        /* 0x55a5 */
    KANJI,        /* 0x55a6 */
    KANJI,        /* 0x55a7 */
    KANJI,        /* 0x55a8 */
    KANJI,        /* 0x55a9 */
    KANJI,        /* 0x55aa */
    KANJI,        /* 0x55ab */
    KANJI,        /* 0x55ac */
    KANJI,        /* 0x55ad */
    KANJI,        /* 0x55ae */
    KANJI,        /* 0x55af */
    KANJI,        /* 0x55b0 */
    KANJI,        /* 0x55b1 */
    KANJI,        /* 0x55b2 */
    KANJI,        /* 0x55b3 */
    KANJI,        /* 0x55b4 */
    KANJI,        /* 0x55b5 */
    KANJI,        /* 0x55b6 */
    KANJI,        /* 0x55b7 */
    KANJI,        /* 0x55b8 */
    KANJI,        /* 0x55b9 */
    KANJI,        /* 0x55ba */
    KANJI,        /* 0x55bb */
    KANJI,        /* 0x55bc */
    KANJI,        /* 0x55bd */
    KANJI,        /* 0x55be */
    KANJI,        /* 0x55bf */
    KANJI,        /* 0x55c0 */
    KANJI,        /* 0x55c1 */
    KANJI,        /* 0x55c2 */
    KANJI,        /* 0x55c3 */
    KANJI,        /* 0x55c4 */
    KANJI,        /* 0x55c5 */
    KANJI,        /* 0x55c6 */
    KANJI,        /* 0x55c7 */
    KANJI,        /* 0x55c8 */
    KANJI,        /* 0x55c9 */
    KANJI,        /* 0x55ca */
    KANJI,        /* 0x55cb */
    KANJI,        /* 0x55cc */
    KANJI,        /* 0x55cd */
    KANJI,        /* 0x55ce */
    KANJI,        /* 0x55cf */
    KANJI,        /* 0x55d0 */
    KANJI,        /* 0x55d1 */
    KANJI,        /* 0x55d2 */
    KANJI,        /* 0x55d3 */
    KANJI,        /* 0x55d4 */
    KANJI,        /* 0x55d5 */
    KANJI,        /* 0x55d6 */
    KANJI,        /* 0x55d7 */
    KANJI,        /* 0x55d8 */
    KANJI,        /* 0x55d9 */
    KANJI,        /* 0x55da */
    KANJI,        /* 0x55db */
    KANJI,        /* 0x55dc */
    KANJI,        /* 0x55dd */
    KANJI,        /* 0x55de */
    KANJI,        /* 0x55df */
    KANJI,        /* 0x55e0 */
    KANJI,        /* 0x55e1 */
    KANJI,        /* 0x55e2 */
    KANJI,        /* 0x55e3 */
    KANJI,        /* 0x55e4 */
    KANJI,        /* 0x55e5 */
    KANJI,        /* 0x55e6 */
    KANJI,        /* 0x55e7 */
    KANJI,        /* 0x55e8 */
    KANJI,        /* 0x55e9 */
    KANJI,        /* 0x55ea */
    KANJI,        /* 0x55eb */
    KANJI,        /* 0x55ec */
    KANJI,        /* 0x55ed */
    KANJI,        /* 0x55ee */
    KANJI,        /* 0x55ef */
    KANJI,        /* 0x55f0 */
    KANJI,        /* 0x55f1 */
    KANJI,        /* 0x55f2 */
    KANJI,        /* 0x55f3 */
    KANJI,        /* 0x55f4 */
    KANJI,        /* 0x55f5 */
    KANJI,        /* 0x55f6 */
    KANJI,        /* 0x55f7 */
    KANJI,        /* 0x55f8 */
    KANJI,        /* 0x55f9 */
    KANJI,        /* 0x55fa */
    KANJI,        /* 0x55fb */
    KANJI,        /* 0x55fc */
    KANJI,        /* 0x55fd */
    KANJI,        /* 0x55fe */
    KANJI,        /* 0x55ff */
    KANJI,        /* 0x5600 */
    KANJI,        /* 0x5601 */
    KANJI,        /* 0x5602 */
    KANJI,        /* 0x5603 */
    KANJI,        /* 0x5604 */
    KANJI,        /* 0x5605 */
    KANJI,        /* 0x5606 */
    KANJI,        /* 0x5607 */
    KANJI,        /* 0x5608 */
    KANJI,        /* 0x5609 */
    KANJI,        /* 0x560a */
    KANJI,        /* 0x560b */
    KANJI,        /* 0x560c */
    KANJI,        /* 0x560d */
    KANJI,        /* 0x560e */
    KANJI,        /* 0x560f */
    KANJI,        /* 0x5610 */
    KANJI,        /* 0x5611 */
    KANJI,        /* 0x5612 */
    KANJI,        /* 0x5613 */
    KANJI,        /* 0x5614 */
    KANJI,        /* 0x5615 */
    KANJI,        /* 0x5616 */
    KANJI,        /* 0x5617 */
    KANJI,        /* 0x5618 */
    KANJI,        /* 0x5619 */
    KANJI,        /* 0x561a */
    KANJI,        /* 0x561b */
    KANJI,        /* 0x561c */
    KANJI,        /* 0x561d */
    KANJI,        /* 0x561e */
    KANJI,        /* 0x561f */
    KANJI,        /* 0x5620 */
    KANJI,        /* 0x5621 */
    KANJI,        /* 0x5622 */
    KANJI,        /* 0x5623 */
    KANJI,        /* 0x5624 */
    KANJI,        /* 0x5625 */
    KANJI,        /* 0x5626 */
    KANJI,        /* 0x5627 */
    KANJI,        /* 0x5628 */
    KANJI,        /* 0x5629 */
    KANJI,        /* 0x562a */
    KANJI,        /* 0x562b */
    KANJI,        /* 0x562c */
    KANJI,        /* 0x562d */
    KANJI,        /* 0x562e */
    KANJI,        /* 0x562f */
    KANJI,        /* 0x5630 */
    KANJI,        /* 0x5631 */
    KANJI,        /* 0x5632 */
    KANJI,        /* 0x5633 */
    KANJI,        /* 0x5634 */
    KANJI,        /* 0x5635 */
    KANJI,        /* 0x5636 */
    KANJI,        /* 0x5637 */
    KANJI,        /* 0x5638 */
    KANJI,        /* 0x5639 */
    KANJI,        /* 0x563a */
    KANJI,        /* 0x563b */
    KANJI,        /* 0x563c */
    KANJI,        /* 0x563d */
    KANJI,        /* 0x563e */
    KANJI,        /* 0x563f */
    KANJI,        /* 0x5640 */
    KANJI,        /* 0x5641 */
    KANJI,        /* 0x5642 */
    KANJI,        /* 0x5643 */
    KANJI,        /* 0x5644 */
    KANJI,        /* 0x5645 */
    KANJI,        /* 0x5646 */
    KANJI,        /* 0x5647 */
    KANJI,        /* 0x5648 */
    KANJI,        /* 0x5649 */
    KANJI,        /* 0x564a */
    KANJI,        /* 0x564b */
    KANJI,        /* 0x564c */
    KANJI,        /* 0x564d */
    KANJI,        /* 0x564e */
    KANJI,        /* 0x564f */
    KANJI,        /* 0x5650 */
    KANJI,        /* 0x5651 */
    KANJI,        /* 0x5652 */
    KANJI,        /* 0x5653 */
    KANJI,        /* 0x5654 */
    KANJI,        /* 0x5655 */
    KANJI,        /* 0x5656 */
    KANJI,        /* 0x5657 */
    KANJI,        /* 0x5658 */
    KANJI,        /* 0x5659 */
    KANJI,        /* 0x565a */
    KANJI,        /* 0x565b */
    KANJI,        /* 0x565c */
    KANJI,        /* 0x565d */
    KANJI,        /* 0x565e */
    KANJI,        /* 0x565f */
    KANJI,        /* 0x5660 */
    KANJI,        /* 0x5661 */
    KANJI,        /* 0x5662 */
    KANJI,        /* 0x5663 */
    KANJI,        /* 0x5664 */
    KANJI,        /* 0x5665 */
    KANJI,        /* 0x5666 */
    KANJI,        /* 0x5667 */
    KANJI,        /* 0x5668 */
    KANJI,        /* 0x5669 */
    KANJI,        /* 0x566a */
    KANJI,        /* 0x566b */
    KANJI,        /* 0x566c */
    KANJI,        /* 0x566d */
    KANJI,        /* 0x566e */
    KANJI,        /* 0x566f */
    KANJI,        /* 0x5670 */
    KANJI,        /* 0x5671 */
    KANJI,        /* 0x5672 */
    KANJI,        /* 0x5673 */
    KANJI,        /* 0x5674 */
    KANJI,        /* 0x5675 */
    KANJI,        /* 0x5676 */
    KANJI,        /* 0x5677 */
    KANJI,        /* 0x5678 */
    KANJI,        /* 0x5679 */
    KANJI,        /* 0x567a */
    KANJI,        /* 0x567b */
    KANJI,        /* 0x567c */
    KANJI,        /* 0x567d */
    KANJI,        /* 0x567e */
    KANJI,        /* 0x567f */
    KANJI,        /* 0x5680 */
    KANJI,        /* 0x5681 */
    KANJI,        /* 0x5682 */
    KANJI,        /* 0x5683 */
    KANJI,        /* 0x5684 */
    KANJI,        /* 0x5685 */
    KANJI,        /* 0x5686 */
    KANJI,        /* 0x5687 */
    KANJI,        /* 0x5688 */
    KANJI,        /* 0x5689 */
    KANJI,        /* 0x568a */
    KANJI,        /* 0x568b */
    KANJI,        /* 0x568c */
    KANJI,        /* 0x568d */
    KANJI,        /* 0x568e */
    KANJI,        /* 0x568f */
    KANJI,        /* 0x5690 */
    KANJI,        /* 0x5691 */
    KANJI,        /* 0x5692 */
    KANJI,        /* 0x5693 */
    KANJI,        /* 0x5694 */
    KANJI,        /* 0x5695 */
    KANJI,        /* 0x5696 */
    KANJI,        /* 0x5697 */
    KANJI,        /* 0x5698 */
    KANJI,        /* 0x5699 */
    KANJI,        /* 0x569a */
    KANJI,        /* 0x569b */
    KANJI,        /* 0x569c */
    KANJI,        /* 0x569d */
    KANJI,        /* 0x569e */
    KANJI,        /* 0x569f */
    KANJI,        /* 0x56a0 */
    KANJI,        /* 0x56a1 */
    KANJI,        /* 0x56a2 */
    KANJI,        /* 0x56a3 */
    KANJI,        /* 0x56a4 */
    KANJI,        /* 0x56a5 */
    KANJI,        /* 0x56a6 */
    KANJI,        /* 0x56a7 */
    KANJI,        /* 0x56a8 */
    KANJI,        /* 0x56a9 */
    KANJI,        /* 0x56aa */
    KANJI,        /* 0x56ab */
    KANJI,        /* 0x56ac */
    KANJI,        /* 0x56ad */
    KANJI,        /* 0x56ae */
    KANJI,        /* 0x56af */
    KANJI,        /* 0x56b0 */
    KANJI,        /* 0x56b1 */
    KANJI,        /* 0x56b2 */
    KANJI,        /* 0x56b3 */
    KANJI,        /* 0x56b4 */
    KANJI,        /* 0x56b5 */
    KANJI,        /* 0x56b6 */
    KANJI,        /* 0x56b7 */
    KANJI,        /* 0x56b8 */
    KANJI,        /* 0x56b9 */
    KANJI,        /* 0x56ba */
    KANJI,        /* 0x56bb */
    KANJI,        /* 0x56bc */
    KANJI,        /* 0x56bd */
    KANJI,        /* 0x56be */
    KANJI,        /* 0x56bf */
    KANJI,        /* 0x56c0 */
    KANJI,        /* 0x56c1 */
    KANJI,        /* 0x56c2 */
    KANJI,        /* 0x56c3 */
    KANJI,        /* 0x56c4 */
    KANJI,        /* 0x56c5 */
    KANJI,        /* 0x56c6 */
    KANJI,        /* 0x56c7 */
    KANJI,        /* 0x56c8 */
    KANJI,        /* 0x56c9 */
    KANJI,        /* 0x56ca */
    KANJI,        /* 0x56cb */
    KANJI,        /* 0x56cc */
    KANJI,        /* 0x56cd */
    KANJI,        /* 0x56ce */
    KANJI,        /* 0x56cf */
    KANJI,        /* 0x56d0 */
    KANJI,        /* 0x56d1 */
    KANJI,        /* 0x56d2 */
    KANJI,        /* 0x56d3 */
    KANJI,        /* 0x56d4 */
    KANJI,        /* 0x56d5 */
    KANJI,        /* 0x56d6 */
    KANJI,        /* 0x56d7 */
    KANJI,        /* 0x56d8 */
    KANJI,        /* 0x56d9 */
    KANJI,        /* 0x56da */
    KANJINUMERIC,        /* 0x56db */
    KANJI,        /* 0x56dc */
    KANJI,        /* 0x56dd */
    KANJI,        /* 0x56de */
    KANJI,        /* 0x56df */
    KANJI,        /* 0x56e0 */
    KANJI,        /* 0x56e1 */
    KANJI,        /* 0x56e2 */
    KANJI,        /* 0x56e3 */
    KANJI,        /* 0x56e4 */
    KANJI,        /* 0x56e5 */
    KANJI,        /* 0x56e6 */
    KANJI,        /* 0x56e7 */
    KANJI,        /* 0x56e8 */
    KANJI,        /* 0x56e9 */
    KANJI,        /* 0x56ea */
    KANJI,        /* 0x56eb */
    KANJI,        /* 0x56ec */
    KANJI,        /* 0x56ed */
    KANJI,        /* 0x56ee */
    KANJI,        /* 0x56ef */
    KANJI,        /* 0x56f0 */
    KANJI,        /* 0x56f1 */
    KANJI,        /* 0x56f2 */
    KANJI,        /* 0x56f3 */
    KANJI,        /* 0x56f4 */
    KANJI,        /* 0x56f5 */
    KANJI,        /* 0x56f6 */
    KANJI,        /* 0x56f7 */
    KANJI,        /* 0x56f8 */
    KANJI,        /* 0x56f9 */
    KANJI,        /* 0x56fa */
    KANJI,        /* 0x56fb */
    KANJI,        /* 0x56fc */
    KANJI,        /* 0x56fd */
    KANJI,        /* 0x56fe */
    KANJI,        /* 0x56ff */
    KANJI,        /* 0x5700 */
    KANJI,        /* 0x5701 */
    KANJI,        /* 0x5702 */
    KANJI,        /* 0x5703 */
    KANJI,        /* 0x5704 */
    KANJI,        /* 0x5705 */
    KANJI,        /* 0x5706 */
    KANJI,        /* 0x5707 */
    KANJI,        /* 0x5708 */
    KANJI,        /* 0x5709 */
    KANJI,        /* 0x570a */
    KANJI,        /* 0x570b */
    KANJI,        /* 0x570c */
    KANJI,        /* 0x570d */
    KANJI,        /* 0x570e */
    KANJI,        /* 0x570f */
    KANJI,        /* 0x5710 */
    KANJI,        /* 0x5711 */
    KANJI,        /* 0x5712 */
    KANJI,        /* 0x5713 */
    KANJI,        /* 0x5714 */
    KANJI,        /* 0x5715 */
    KANJI,        /* 0x5716 */
    KANJI,        /* 0x5717 */
    KANJI,        /* 0x5718 */
    KANJI,        /* 0x5719 */
    KANJI,        /* 0x571a */
    KANJI,        /* 0x571b */
    KANJI,        /* 0x571c */
    KANJI,        /* 0x571d */
    KANJI,        /* 0x571e */
    KANJI,        /* 0x571f */
    KANJI,        /* 0x5720 */
    KANJI,        /* 0x5721 */
    KANJI,        /* 0x5722 */
    KANJI,        /* 0x5723 */
    KANJI,        /* 0x5724 */
    KANJI,        /* 0x5725 */
    KANJI,        /* 0x5726 */
    KANJI,        /* 0x5727 */
    KANJI,        /* 0x5728 */
    KANJI,        /* 0x5729 */
    KANJI,        /* 0x572a */
    KANJI,        /* 0x572b */
    KANJI,        /* 0x572c */
    KANJI,        /* 0x572d */
    KANJI,        /* 0x572e */
    KANJI,        /* 0x572f */
    KANJI,        /* 0x5730 */
    KANJI,        /* 0x5731 */
    KANJI,        /* 0x5732 */
    KANJI,        /* 0x5733 */
    KANJI,        /* 0x5734 */
    KANJI,        /* 0x5735 */
    KANJI,        /* 0x5736 */
    KANJI,        /* 0x5737 */
    KANJI,        /* 0x5738 */
    KANJI,        /* 0x5739 */
    KANJI,        /* 0x573a */
    KANJI,        /* 0x573b */
    KANJI,        /* 0x573c */
    KANJI,        /* 0x573d */
    KANJI,        /* 0x573e */
    KANJI,        /* 0x573f */
    KANJI,        /* 0x5740 */
    KANJI,        /* 0x5741 */
    KANJI,        /* 0x5742 */
    KANJI,        /* 0x5743 */
    KANJI,        /* 0x5744 */
    KANJI,        /* 0x5745 */
    KANJI,        /* 0x5746 */
    KANJI,        /* 0x5747 */
    KANJI,        /* 0x5748 */
    KANJI,        /* 0x5749 */
    KANJI,        /* 0x574a */
    KANJI,        /* 0x574b */
    KANJI,        /* 0x574c */
    KANJI,        /* 0x574d */
    KANJI,        /* 0x574e */
    KANJI,        /* 0x574f */
    KANJI,        /* 0x5750 */
    KANJI,        /* 0x5751 */
    KANJI,        /* 0x5752 */
    KANJI,        /* 0x5753 */
    KANJI,        /* 0x5754 */
    KANJI,        /* 0x5755 */
    KANJI,        /* 0x5756 */
    KANJI,        /* 0x5757 */
    KANJI,        /* 0x5758 */
    KANJI,        /* 0x5759 */
    KANJI,        /* 0x575a */
    KANJI,        /* 0x575b */
    KANJI,        /* 0x575c */
    KANJI,        /* 0x575d */
    KANJI,        /* 0x575e */
    KANJI,        /* 0x575f */
    KANJI,        /* 0x5760 */
    KANJI,        /* 0x5761 */
    KANJI,        /* 0x5762 */
    KANJI,        /* 0x5763 */
    KANJI,        /* 0x5764 */
    KANJI,        /* 0x5765 */
    KANJI,        /* 0x5766 */
    KANJI,        /* 0x5767 */
    KANJI,        /* 0x5768 */
    KANJI,        /* 0x5769 */
    KANJI,        /* 0x576a */
    KANJI,        /* 0x576b */
    KANJI,        /* 0x576c */
    KANJI,        /* 0x576d */
    KANJI,        /* 0x576e */
    KANJI,        /* 0x576f */
    KANJI,        /* 0x5770 */
    KANJI,        /* 0x5771 */
    KANJI,        /* 0x5772 */
    KANJI,        /* 0x5773 */
    KANJI,        /* 0x5774 */
    KANJI,        /* 0x5775 */
    KANJI,        /* 0x5776 */
    KANJI,        /* 0x5777 */
    KANJI,        /* 0x5778 */
    KANJI,        /* 0x5779 */
    KANJI,        /* 0x577a */
    KANJI,        /* 0x577b */
    KANJI,        /* 0x577c */
    KANJI,        /* 0x577d */
    KANJI,        /* 0x577e */
    KANJI,        /* 0x577f */
    KANJI,        /* 0x5780 */
    KANJI,        /* 0x5781 */
    KANJI,        /* 0x5782 */
    KANJI,        /* 0x5783 */
    KANJI,        /* 0x5784 */
    KANJI,        /* 0x5785 */
    KANJI,        /* 0x5786 */
    KANJI,        /* 0x5787 */
    KANJI,        /* 0x5788 */
    KANJI,        /* 0x5789 */
    KANJI,        /* 0x578a */
    KANJI,        /* 0x578b */
    KANJI,        /* 0x578c */
    KANJI,        /* 0x578d */
    KANJI,        /* 0x578e */
    KANJI,        /* 0x578f */
    KANJI,        /* 0x5790 */
    KANJI,        /* 0x5791 */
    KANJI,        /* 0x5792 */
    KANJI,        /* 0x5793 */
    KANJI,        /* 0x5794 */
    KANJI,        /* 0x5795 */
    KANJI,        /* 0x5796 */
    KANJI,        /* 0x5797 */
    KANJI,        /* 0x5798 */
    KANJI,        /* 0x5799 */
    KANJI,        /* 0x579a */
    KANJI,        /* 0x579b */
    KANJI,        /* 0x579c */
    KANJI,        /* 0x579d */
    KANJI,        /* 0x579e */
    KANJI,        /* 0x579f */
    KANJI,        /* 0x57a0 */
    KANJI,        /* 0x57a1 */
    KANJI,        /* 0x57a2 */
    KANJI,        /* 0x57a3 */
    KANJI,        /* 0x57a4 */
    KANJI,        /* 0x57a5 */
    KANJI,        /* 0x57a6 */
    KANJI,        /* 0x57a7 */
    KANJI,        /* 0x57a8 */
    KANJI,        /* 0x57a9 */
    KANJI,        /* 0x57aa */
    KANJI,        /* 0x57ab */
    KANJI,        /* 0x57ac */
    KANJI,        /* 0x57ad */
    KANJI,        /* 0x57ae */
    KANJI,        /* 0x57af */
    KANJI,        /* 0x57b0 */
    KANJI,        /* 0x57b1 */
    KANJI,        /* 0x57b2 */
    KANJI,        /* 0x57b3 */
    KANJI,        /* 0x57b4 */
    KANJI,        /* 0x57b5 */
    KANJI,        /* 0x57b6 */
    KANJI,        /* 0x57b7 */
    KANJI,        /* 0x57b8 */
    KANJI,        /* 0x57b9 */
    KANJI,        /* 0x57ba */
    KANJI,        /* 0x57bb */
    KANJI,        /* 0x57bc */
    KANJI,        /* 0x57bd */
    KANJI,        /* 0x57be */
    KANJI,        /* 0x57bf */
    KANJI,        /* 0x57c0 */
    KANJI,        /* 0x57c1 */
    KANJI,        /* 0x57c2 */
    KANJI,        /* 0x57c3 */
    KANJI,        /* 0x57c4 */
    KANJI,        /* 0x57c5 */
    KANJI,        /* 0x57c6 */
    KANJI,        /* 0x57c7 */
    KANJI,        /* 0x57c8 */
    KANJI,        /* 0x57c9 */
    KANJI,        /* 0x57ca */
    KANJI,        /* 0x57cb */
    KANJI,        /* 0x57cc */
    KANJI,        /* 0x57cd */
    KANJI,        /* 0x57ce */
    KANJI,        /* 0x57cf */
    KANJI,        /* 0x57d0 */
    KANJI,        /* 0x57d1 */
    KANJI,        /* 0x57d2 */
    KANJI,        /* 0x57d3 */
    KANJI,        /* 0x57d4 */
    KANJI,        /* 0x57d5 */
    KANJI,        /* 0x57d6 */
    KANJI,        /* 0x57d7 */
    KANJI,        /* 0x57d8 */
    KANJI,        /* 0x57d9 */
    KANJI,        /* 0x57da */
    KANJI,        /* 0x57db */
    KANJI,        /* 0x57dc */
    KANJI,        /* 0x57dd */
    KANJI,        /* 0x57de */
    KANJI,        /* 0x57df */
    KANJI,        /* 0x57e0 */
    KANJI,        /* 0x57e1 */
    KANJI,        /* 0x57e2 */
    KANJI,        /* 0x57e3 */
    KANJI,        /* 0x57e4 */
    KANJI,        /* 0x57e5 */
    KANJI,        /* 0x57e6 */
    KANJI,        /* 0x57e7 */
    KANJI,        /* 0x57e8 */
    KANJI,        /* 0x57e9 */
    KANJI,        /* 0x57ea */
    KANJI,        /* 0x57eb */
    KANJI,        /* 0x57ec */
    KANJI,        /* 0x57ed */
    KANJI,        /* 0x57ee */
    KANJI,        /* 0x57ef */
    KANJI,        /* 0x57f0 */
    KANJI,        /* 0x57f1 */
    KANJI,        /* 0x57f2 */
    KANJI,        /* 0x57f3 */
    KANJI,        /* 0x57f4 */
    KANJI,        /* 0x57f5 */
    KANJI,        /* 0x57f6 */
    KANJI,        /* 0x57f7 */
    KANJI,        /* 0x57f8 */
    KANJI,        /* 0x57f9 */
    KANJI,        /* 0x57fa */
    KANJI,        /* 0x57fb */
    KANJI,        /* 0x57fc */
    KANJI,        /* 0x57fd */
    KANJI,        /* 0x57fe */
    KANJI,        /* 0x57ff */
    KANJI,        /* 0x5800 */
    KANJI,        /* 0x5801 */
    KANJI,        /* 0x5802 */
    KANJI,        /* 0x5803 */
    KANJI,        /* 0x5804 */
    KANJI,        /* 0x5805 */
    KANJI,        /* 0x5806 */
    KANJI,        /* 0x5807 */
    KANJI,        /* 0x5808 */
    KANJI,        /* 0x5809 */
    KANJI,        /* 0x580a */
    KANJI,        /* 0x580b */
    KANJI,        /* 0x580c */
    KANJI,        /* 0x580d */
    KANJI,        /* 0x580e */
    KANJI,        /* 0x580f */
    KANJI,        /* 0x5810 */
    KANJI,        /* 0x5811 */
    KANJI,        /* 0x5812 */
    KANJI,        /* 0x5813 */
    KANJI,        /* 0x5814 */
    KANJI,        /* 0x5815 */
    KANJI,        /* 0x5816 */
    KANJI,        /* 0x5817 */
    KANJI,        /* 0x5818 */
    KANJI,        /* 0x5819 */
    KANJI,        /* 0x581a */
    KANJI,        /* 0x581b */
    KANJI,        /* 0x581c */
    KANJI,        /* 0x581d */
    KANJI,        /* 0x581e */
    KANJI,        /* 0x581f */
    KANJI,        /* 0x5820 */
    KANJI,        /* 0x5821 */
    KANJI,        /* 0x5822 */
    KANJI,        /* 0x5823 */
    KANJI,        /* 0x5824 */
    KANJI,        /* 0x5825 */
    KANJI,        /* 0x5826 */
    KANJI,        /* 0x5827 */
    KANJI,        /* 0x5828 */
    KANJI,        /* 0x5829 */
    KANJI,        /* 0x582a */
    KANJI,        /* 0x582b */
    KANJI,        /* 0x582c */
    KANJI,        /* 0x582d */
    KANJI,        /* 0x582e */
    KANJI,        /* 0x582f */
    KANJI,        /* 0x5830 */
    KANJI,        /* 0x5831 */
    KANJI,        /* 0x5832 */
    KANJI,        /* 0x5833 */
    KANJI,        /* 0x5834 */
    KANJI,        /* 0x5835 */
    KANJI,        /* 0x5836 */
    KANJI,        /* 0x5837 */
    KANJI,        /* 0x5838 */
    KANJI,        /* 0x5839 */
    KANJI,        /* 0x583a */
    KANJI,        /* 0x583b */
    KANJI,        /* 0x583c */
    KANJI,        /* 0x583d */
    KANJI,        /* 0x583e */
    KANJI,        /* 0x583f */
    KANJI,        /* 0x5840 */
    KANJI,        /* 0x5841 */
    KANJI,        /* 0x5842 */
    KANJI,        /* 0x5843 */
    KANJI,        /* 0x5844 */
    KANJI,        /* 0x5845 */
    KANJI,        /* 0x5846 */
    KANJI,        /* 0x5847 */
    KANJI,        /* 0x5848 */
    KANJI,        /* 0x5849 */
    KANJI,        /* 0x584a */
    KANJI,        /* 0x584b */
    KANJI,        /* 0x584c */
    KANJI,        /* 0x584d */
    KANJI,        /* 0x584e */
    KANJI,        /* 0x584f */
    KANJI,        /* 0x5850 */
    KANJI,        /* 0x5851 */
    KANJI,        /* 0x5852 */
    KANJI,        /* 0x5853 */
    KANJI,        /* 0x5854 */
    KANJI,        /* 0x5855 */
    KANJI,        /* 0x5856 */
    KANJI,        /* 0x5857 */
    KANJI,        /* 0x5858 */
    KANJI,        /* 0x5859 */
    KANJI,        /* 0x585a */
    KANJI,        /* 0x585b */
    KANJI,        /* 0x585c */
    KANJI,        /* 0x585d */
    KANJI,        /* 0x585e */
    KANJI,        /* 0x585f */
    KANJI,        /* 0x5860 */
    KANJI,        /* 0x5861 */
    KANJI,        /* 0x5862 */
    KANJI,        /* 0x5863 */
    KANJI,        /* 0x5864 */
    KANJI,        /* 0x5865 */
    KANJI,        /* 0x5866 */
    KANJI,        /* 0x5867 */
    KANJI,        /* 0x5868 */
    KANJI,        /* 0x5869 */
    KANJI,        /* 0x586a */
    KANJI,        /* 0x586b */
    KANJI,        /* 0x586c */
    KANJI,        /* 0x586d */
    KANJI,        /* 0x586e */
    KANJI,        /* 0x586f */
    KANJI,        /* 0x5870 */
    KANJI,        /* 0x5871 */
    KANJI,        /* 0x5872 */
    KANJI,        /* 0x5873 */
    KANJI,        /* 0x5874 */
    KANJI,        /* 0x5875 */
    KANJI,        /* 0x5876 */
    KANJI,        /* 0x5877 */
    KANJI,        /* 0x5878 */
    KANJI,        /* 0x5879 */
    KANJI,        /* 0x587a */
    KANJI,        /* 0x587b */
    KANJI,        /* 0x587c */
    KANJI,        /* 0x587d */
    KANJI,        /* 0x587e */
    KANJI,        /* 0x587f */
    KANJI,        /* 0x5880 */
    KANJI,        /* 0x5881 */
    KANJI,        /* 0x5882 */
    KANJI,        /* 0x5883 */
    KANJI,        /* 0x5884 */
    KANJI,        /* 0x5885 */
    KANJI,        /* 0x5886 */
    KANJI,        /* 0x5887 */
    KANJI,        /* 0x5888 */
    KANJI,        /* 0x5889 */
    KANJI,        /* 0x588a */
    KANJI,        /* 0x588b */
    KANJI,        /* 0x588c */
    KANJI,        /* 0x588d */
    KANJI,        /* 0x588e */
    KANJI,        /* 0x588f */
    KANJI,        /* 0x5890 */
    KANJI,        /* 0x5891 */
    KANJI,        /* 0x5892 */
    KANJI,        /* 0x5893 */
    KANJI,        /* 0x5894 */
    KANJI,        /* 0x5895 */
    KANJI,        /* 0x5896 */
    KANJI,        /* 0x5897 */
    KANJI,        /* 0x5898 */
    KANJI,        /* 0x5899 */
    KANJI,        /* 0x589a */
    KANJI,        /* 0x589b */
    KANJI,        /* 0x589c */
    KANJI,        /* 0x589d */
    KANJI,        /* 0x589e */
    KANJI,        /* 0x589f */
    KANJI,        /* 0x58a0 */
    KANJI,        /* 0x58a1 */
    KANJI,        /* 0x58a2 */
    KANJI,        /* 0x58a3 */
    KANJI,        /* 0x58a4 */
    KANJI,        /* 0x58a5 */
    KANJI,        /* 0x58a6 */
    KANJI,        /* 0x58a7 */
    KANJI,        /* 0x58a8 */
    KANJI,        /* 0x58a9 */
    KANJI,        /* 0x58aa */
    KANJI,        /* 0x58ab */
    KANJI,        /* 0x58ac */
    KANJI,        /* 0x58ad */
    KANJI,        /* 0x58ae */
    KANJI,        /* 0x58af */
    KANJI,        /* 0x58b0 */
    KANJI,        /* 0x58b1 */
    KANJI,        /* 0x58b2 */
    KANJI,        /* 0x58b3 */
    KANJI,        /* 0x58b4 */
    KANJI,        /* 0x58b5 */
    KANJI,        /* 0x58b6 */
    KANJI,        /* 0x58b7 */
    KANJI,        /* 0x58b8 */
    KANJI,        /* 0x58b9 */
    KANJI,        /* 0x58ba */
    KANJI,        /* 0x58bb */
    KANJI,        /* 0x58bc */
    KANJI,        /* 0x58bd */
    KANJI,        /* 0x58be */
    KANJI,        /* 0x58bf */
    KANJI,        /* 0x58c0 */
    KANJI,        /* 0x58c1 */
    KANJI,        /* 0x58c2 */
    KANJI,        /* 0x58c3 */
    KANJI,        /* 0x58c4 */
    KANJI,        /* 0x58c5 */
    KANJI,        /* 0x58c6 */
    KANJI,        /* 0x58c7 */
    KANJI,        /* 0x58c8 */
    KANJI,        /* 0x58c9 */
    KANJI,        /* 0x58ca */
    KANJI,        /* 0x58cb */
    KANJI,        /* 0x58cc */
    KANJI,        /* 0x58cd */
    KANJI,        /* 0x58ce */
    KANJI,        /* 0x58cf */
    KANJI,        /* 0x58d0 */
    KANJI,        /* 0x58d1 */
    KANJI,        /* 0x58d2 */
    KANJI,        /* 0x58d3 */
    KANJI,        /* 0x58d4 */
    KANJI,        /* 0x58d5 */
    KANJI,        /* 0x58d6 */
    KANJI,        /* 0x58d7 */
    KANJI,        /* 0x58d8 */
    KANJI,        /* 0x58d9 */
    KANJI,        /* 0x58da */
    KANJI,        /* 0x58db */
    KANJI,        /* 0x58dc */
    KANJI,        /* 0x58dd */
    KANJI,        /* 0x58de */
    KANJI,        /* 0x58df */
    KANJI,        /* 0x58e0 */
    KANJI,        /* 0x58e1 */
    KANJI,        /* 0x58e2 */
    KANJI,        /* 0x58e3 */
    KANJI,        /* 0x58e4 */
    KANJI,        /* 0x58e5 */
    KANJI,        /* 0x58e6 */
    KANJI,        /* 0x58e7 */
    KANJI,        /* 0x58e8 */
    KANJI,        /* 0x58e9 */
    KANJI,        /* 0x58ea */
    KANJI,        /* 0x58eb */
    KANJI,        /* 0x58ec */
    KANJI,        /* 0x58ed */
    KANJI,        /* 0x58ee */
    KANJI,        /* 0x58ef */
    KANJI,        /* 0x58f0 */
    KANJI,        /* 0x58f1 */
    KANJI,        /* 0x58f2 */
    KANJI,        /* 0x58f3 */
    KANJI,        /* 0x58f4 */
    KANJI,        /* 0x58f5 */
    KANJI,        /* 0x58f6 */
    KANJI,        /* 0x58f7 */
    KANJI,        /* 0x58f8 */
    KANJI,        /* 0x58f9 */
    KANJI,        /* 0x58fa */
    KANJI,        /* 0x58fb */
    KANJI,        /* 0x58fc */
    KANJI,        /* 0x58fd */
    KANJI,        /* 0x58fe */
    KANJI,        /* 0x58ff */
    KANJI,        /* 0x5900 */
    KANJI,        /* 0x5901 */
    KANJI,        /* 0x5902 */
    KANJI,        /* 0x5903 */
    KANJI,        /* 0x5904 */
    KANJI,        /* 0x5905 */
    KANJI,        /* 0x5906 */
    KANJI,        /* 0x5907 */
    KANJI,        /* 0x5908 */
    KANJI,        /* 0x5909 */
    KANJI,        /* 0x590a */
    KANJI,        /* 0x590b */
    KANJI,        /* 0x590c */
    KANJI,        /* 0x590d */
    KANJI,        /* 0x590e */
    KANJI,        /* 0x590f */
    KANJI,        /* 0x5910 */
    KANJI,        /* 0x5911 */
    KANJI,        /* 0x5912 */
    KANJI,        /* 0x5913 */
    KANJI,        /* 0x5914 */
    KANJI,        /* 0x5915 */
    KANJI,        /* 0x5916 */
    KANJI,        /* 0x5917 */
    KANJI,        /* 0x5918 */
    KANJI,        /* 0x5919 */
    KANJI,        /* 0x591a */
    KANJI,        /* 0x591b */
    KANJI,        /* 0x591c */
    KANJI,        /* 0x591d */
    KANJI,        /* 0x591e */
    KANJI,        /* 0x591f */
    KANJI,        /* 0x5920 */
    KANJI,        /* 0x5921 */
    KANJI,        /* 0x5922 */
    KANJI,        /* 0x5923 */
    KANJI,        /* 0x5924 */
    KANJI,        /* 0x5925 */
    KANJI,        /* 0x5926 */
    KANJI,        /* 0x5927 */
    KANJI,        /* 0x5928 */
    KANJI,        /* 0x5929 */
    KANJI,        /* 0x592a */
    KANJI,        /* 0x592b */
    KANJI,        /* 0x592c */
    KANJI,        /* 0x592d */
    KANJI,        /* 0x592e */
    KANJI,        /* 0x592f */
    KANJI,        /* 0x5930 */
    KANJI,        /* 0x5931 */
    KANJI,        /* 0x5932 */
    KANJI,        /* 0x5933 */
    KANJI,        /* 0x5934 */
    KANJI,        /* 0x5935 */
    KANJI,        /* 0x5936 */
    KANJI,        /* 0x5937 */
    KANJI,        /* 0x5938 */
    KANJI,        /* 0x5939 */
    KANJI,        /* 0x593a */
    KANJI,        /* 0x593b */
    KANJI,        /* 0x593c */
    KANJI,        /* 0x593d */
    KANJI,        /* 0x593e */
    KANJI,        /* 0x593f */
    KANJI,        /* 0x5940 */
    KANJI,        /* 0x5941 */
    KANJI,        /* 0x5942 */
    KANJI,        /* 0x5943 */
    KANJI,        /* 0x5944 */
    KANJI,        /* 0x5945 */
    KANJI,        /* 0x5946 */
    KANJI,        /* 0x5947 */
    KANJI,        /* 0x5948 */
    KANJI,        /* 0x5949 */
    KANJI,        /* 0x594a */
    KANJI,        /* 0x594b */
    KANJI,        /* 0x594c */
    KANJI,        /* 0x594d */
    KANJI,        /* 0x594e */
    KANJI,        /* 0x594f */
    KANJI,        /* 0x5950 */
    KANJI,        /* 0x5951 */
    KANJI,        /* 0x5952 */
    KANJI,        /* 0x5953 */
    KANJI,        /* 0x5954 */
    KANJI,        /* 0x5955 */
    KANJI,        /* 0x5956 */
    KANJI,        /* 0x5957 */
    KANJI,        /* 0x5958 */
    KANJI,        /* 0x5959 */
    KANJI,        /* 0x595a */
    KANJI,        /* 0x595b */
    KANJI,        /* 0x595c */
    KANJI,        /* 0x595d */
    KANJI,        /* 0x595e */
    KANJI,        /* 0x595f */
    KANJI,        /* 0x5960 */
    KANJI,        /* 0x5961 */
    KANJI,        /* 0x5962 */
    KANJI,        /* 0x5963 */
    KANJI,        /* 0x5964 */
    KANJI,        /* 0x5965 */
    KANJI,        /* 0x5966 */
    KANJI,        /* 0x5967 */
    KANJI,        /* 0x5968 */
    KANJI,        /* 0x5969 */
    KANJI,        /* 0x596a */
    KANJI,        /* 0x596b */
    KANJI,        /* 0x596c */
    KANJI,        /* 0x596d */
    KANJI,        /* 0x596e */
    KANJI,        /* 0x596f */
    KANJI,        /* 0x5970 */
    KANJI,        /* 0x5971 */
    KANJI,        /* 0x5972 */
    KANJI,        /* 0x5973 */
    KANJI,        /* 0x5974 */
    KANJI,        /* 0x5975 */
    KANJI,        /* 0x5976 */
    KANJI,        /* 0x5977 */
    KANJI,        /* 0x5978 */
    KANJI,        /* 0x5979 */
    KANJI,        /* 0x597a */
    KANJI,        /* 0x597b */
    KANJI,        /* 0x597c */
    KANJI,        /* 0x597d */
    KANJI,        /* 0x597e */
    KANJI,        /* 0x597f */
    KANJI,        /* 0x5980 */
    KANJI,        /* 0x5981 */
    KANJI,        /* 0x5982 */
    KANJI,        /* 0x5983 */
    KANJI,        /* 0x5984 */
    KANJI,        /* 0x5985 */
    KANJI,        /* 0x5986 */
    KANJI,        /* 0x5987 */
    KANJI,        /* 0x5988 */
    KANJI,        /* 0x5989 */
    KANJI,        /* 0x598a */
    KANJI,        /* 0x598b */
    KANJI,        /* 0x598c */
    KANJI,        /* 0x598d */
    KANJI,        /* 0x598e */
    KANJI,        /* 0x598f */
    KANJI,        /* 0x5990 */
    KANJI,        /* 0x5991 */
    KANJI,        /* 0x5992 */
    KANJI,        /* 0x5993 */
    KANJI,        /* 0x5994 */
    KANJI,        /* 0x5995 */
    KANJI,        /* 0x5996 */
    KANJI,        /* 0x5997 */
    KANJI,        /* 0x5998 */
    KANJI,        /* 0x5999 */
    KANJI,        /* 0x599a */
    KANJI,        /* 0x599b */
    KANJI,        /* 0x599c */
    KANJI,        /* 0x599d */
    KANJI,        /* 0x599e */
    KANJI,        /* 0x599f */
    KANJI,        /* 0x59a0 */
    KANJI,        /* 0x59a1 */
    KANJI,        /* 0x59a2 */
    KANJI,        /* 0x59a3 */
    KANJI,        /* 0x59a4 */
    KANJI,        /* 0x59a5 */
    KANJI,        /* 0x59a6 */
    KANJI,        /* 0x59a7 */
    KANJI,        /* 0x59a8 */
    KANJI,        /* 0x59a9 */
    KANJI,        /* 0x59aa */
    KANJI,        /* 0x59ab */
    KANJI,        /* 0x59ac */
    KANJI,        /* 0x59ad */
    KANJI,        /* 0x59ae */
    KANJI,        /* 0x59af */
    KANJI,        /* 0x59b0 */
    KANJI,        /* 0x59b1 */
    KANJI,        /* 0x59b2 */
    KANJI,        /* 0x59b3 */
    KANJI,        /* 0x59b4 */
    KANJI,        /* 0x59b5 */
    KANJI,        /* 0x59b6 */
    KANJI,        /* 0x59b7 */
    KANJI,        /* 0x59b8 */
    KANJI,        /* 0x59b9 */
    KANJI,        /* 0x59ba */
    KANJI,        /* 0x59bb */
    KANJI,        /* 0x59bc */
    KANJI,        /* 0x59bd */
    KANJI,        /* 0x59be */
    KANJI,        /* 0x59bf */
    KANJI,        /* 0x59c0 */
    KANJI,        /* 0x59c1 */
    KANJI,        /* 0x59c2 */
    KANJI,        /* 0x59c3 */
    KANJI,        /* 0x59c4 */
    KANJI,        /* 0x59c5 */
    KANJI,        /* 0x59c6 */
    KANJI,        /* 0x59c7 */
    KANJI,        /* 0x59c8 */
    KANJI,        /* 0x59c9 */
    KANJI,        /* 0x59ca */
    KANJI,        /* 0x59cb */
    KANJI,        /* 0x59cc */
    KANJI,        /* 0x59cd */
    KANJI,        /* 0x59ce */
    KANJI,        /* 0x59cf */
    KANJI,        /* 0x59d0 */
    KANJI,        /* 0x59d1 */
    KANJI,        /* 0x59d2 */
    KANJI,        /* 0x59d3 */
    KANJI,        /* 0x59d4 */
    KANJI,        /* 0x59d5 */
    KANJI,        /* 0x59d6 */
    KANJI,        /* 0x59d7 */
    KANJI,        /* 0x59d8 */
    KANJI,        /* 0x59d9 */
    KANJI,        /* 0x59da */
    KANJI,        /* 0x59db */
    KANJI,        /* 0x59dc */
    KANJI,        /* 0x59dd */
    KANJI,        /* 0x59de */
    KANJI,        /* 0x59df */
    KANJI,        /* 0x59e0 */
    KANJI,        /* 0x59e1 */
    KANJI,        /* 0x59e2 */
    KANJI,        /* 0x59e3 */
    KANJI,        /* 0x59e4 */
    KANJI,        /* 0x59e5 */
    KANJI,        /* 0x59e6 */
    KANJI,        /* 0x59e7 */
    KANJI,        /* 0x59e8 */
    KANJI,        /* 0x59e9 */
    KANJI,        /* 0x59ea */
    KANJI,        /* 0x59eb */
    KANJI,        /* 0x59ec */
    KANJI,        /* 0x59ed */
    KANJI,        /* 0x59ee */
    KANJI,        /* 0x59ef */
    KANJI,        /* 0x59f0 */
    KANJI,        /* 0x59f1 */
    KANJI,        /* 0x59f2 */
    KANJI,        /* 0x59f3 */
    KANJI,        /* 0x59f4 */
    KANJI,        /* 0x59f5 */
    KANJI,        /* 0x59f6 */
    KANJI,        /* 0x59f7 */
    KANJI,        /* 0x59f8 */
    KANJI,        /* 0x59f9 */
    KANJI,        /* 0x59fa */
    KANJI,        /* 0x59fb */
    KANJI,        /* 0x59fc */
    KANJI,        /* 0x59fd */
    KANJI,        /* 0x59fe */
    KANJI,        /* 0x59ff */
    KANJI,        /* 0x5a00 */
    KANJI,        /* 0x5a01 */
    KANJI,        /* 0x5a02 */
    KANJI,        /* 0x5a03 */
    KANJI,        /* 0x5a04 */
    KANJI,        /* 0x5a05 */
    KANJI,        /* 0x5a06 */
    KANJI,        /* 0x5a07 */
    KANJI,        /* 0x5a08 */
    KANJI,        /* 0x5a09 */
    KANJI,        /* 0x5a0a */
    KANJI,        /* 0x5a0b */
    KANJI,        /* 0x5a0c */
    KANJI,        /* 0x5a0d */
    KANJI,        /* 0x5a0e */
    KANJI,        /* 0x5a0f */
    KANJI,        /* 0x5a10 */
    KANJI,        /* 0x5a11 */
    KANJI,        /* 0x5a12 */
    KANJI,        /* 0x5a13 */
    KANJI,        /* 0x5a14 */
    KANJI,        /* 0x5a15 */
    KANJI,        /* 0x5a16 */
    KANJI,        /* 0x5a17 */
    KANJI,        /* 0x5a18 */
    KANJI,        /* 0x5a19 */
    KANJI,        /* 0x5a1a */
    KANJI,        /* 0x5a1b */
    KANJI,        /* 0x5a1c */
    KANJI,        /* 0x5a1d */
    KANJI,        /* 0x5a1e */
    KANJI,        /* 0x5a1f */
    KANJI,        /* 0x5a20 */
    KANJI,        /* 0x5a21 */
    KANJI,        /* 0x5a22 */
    KANJI,        /* 0x5a23 */
    KANJI,        /* 0x5a24 */
    KANJI,        /* 0x5a25 */
    KANJI,        /* 0x5a26 */
    KANJI,        /* 0x5a27 */
    KANJI,        /* 0x5a28 */
    KANJI,        /* 0x5a29 */
    KANJI,        /* 0x5a2a */
    KANJI,        /* 0x5a2b */
    KANJI,        /* 0x5a2c */
    KANJI,        /* 0x5a2d */
    KANJI,        /* 0x5a2e */
    KANJI,        /* 0x5a2f */
    KANJI,        /* 0x5a30 */
    KANJI,        /* 0x5a31 */
    KANJI,        /* 0x5a32 */
    KANJI,        /* 0x5a33 */
    KANJI,        /* 0x5a34 */
    KANJI,        /* 0x5a35 */
    KANJI,        /* 0x5a36 */
    KANJI,        /* 0x5a37 */
    KANJI,        /* 0x5a38 */
    KANJI,        /* 0x5a39 */
    KANJI,        /* 0x5a3a */
    KANJI,        /* 0x5a3b */
    KANJI,        /* 0x5a3c */
    KANJI,        /* 0x5a3d */
    KANJI,        /* 0x5a3e */
    KANJI,        /* 0x5a3f */
    KANJI,        /* 0x5a40 */
    KANJI,        /* 0x5a41 */
    KANJI,        /* 0x5a42 */
    KANJI,        /* 0x5a43 */
    KANJI,        /* 0x5a44 */
    KANJI,        /* 0x5a45 */
    KANJI,        /* 0x5a46 */
    KANJI,        /* 0x5a47 */
    KANJI,        /* 0x5a48 */
    KANJI,        /* 0x5a49 */
    KANJI,        /* 0x5a4a */
    KANJI,        /* 0x5a4b */
    KANJI,        /* 0x5a4c */
    KANJI,        /* 0x5a4d */
    KANJI,        /* 0x5a4e */
    KANJI,        /* 0x5a4f */
    KANJI,        /* 0x5a50 */
    KANJI,        /* 0x5a51 */
    KANJI,        /* 0x5a52 */
    KANJI,        /* 0x5a53 */
    KANJI,        /* 0x5a54 */
    KANJI,        /* 0x5a55 */
    KANJI,        /* 0x5a56 */
    KANJI,        /* 0x5a57 */
    KANJI,        /* 0x5a58 */
    KANJI,        /* 0x5a59 */
    KANJI,        /* 0x5a5a */
    KANJI,        /* 0x5a5b */
    KANJI,        /* 0x5a5c */
    KANJI,        /* 0x5a5d */
    KANJI,        /* 0x5a5e */
    KANJI,        /* 0x5a5f */
    KANJI,        /* 0x5a60 */
    KANJI,        /* 0x5a61 */
    KANJI,        /* 0x5a62 */
    KANJI,        /* 0x5a63 */
    KANJI,        /* 0x5a64 */
    KANJI,        /* 0x5a65 */
    KANJI,        /* 0x5a66 */
    KANJI,        /* 0x5a67 */
    KANJI,        /* 0x5a68 */
    KANJI,        /* 0x5a69 */
    KANJI,        /* 0x5a6a */
    KANJI,        /* 0x5a6b */
    KANJI,        /* 0x5a6c */
    KANJI,        /* 0x5a6d */
    KANJI,        /* 0x5a6e */
    KANJI,        /* 0x5a6f */
    KANJI,        /* 0x5a70 */
    KANJI,        /* 0x5a71 */
    KANJI,        /* 0x5a72 */
    KANJI,        /* 0x5a73 */
    KANJI,        /* 0x5a74 */
    KANJI,        /* 0x5a75 */
    KANJI,        /* 0x5a76 */
    KANJI,        /* 0x5a77 */
    KANJI,        /* 0x5a78 */
    KANJI,        /* 0x5a79 */
    KANJI,        /* 0x5a7a */
    KANJI,        /* 0x5a7b */
    KANJI,        /* 0x5a7c */
    KANJI,        /* 0x5a7d */
    KANJI,        /* 0x5a7e */
    KANJI,        /* 0x5a7f */
    KANJI,        /* 0x5a80 */
    KANJI,        /* 0x5a81 */
    KANJI,        /* 0x5a82 */
    KANJI,        /* 0x5a83 */
    KANJI,        /* 0x5a84 */
    KANJI,        /* 0x5a85 */
    KANJI,        /* 0x5a86 */
    KANJI,        /* 0x5a87 */
    KANJI,        /* 0x5a88 */
    KANJI,        /* 0x5a89 */
    KANJI,        /* 0x5a8a */
    KANJI,        /* 0x5a8b */
    KANJI,        /* 0x5a8c */
    KANJI,        /* 0x5a8d */
    KANJI,        /* 0x5a8e */
    KANJI,        /* 0x5a8f */
    KANJI,        /* 0x5a90 */
    KANJI,        /* 0x5a91 */
    KANJI,        /* 0x5a92 */
    KANJI,        /* 0x5a93 */
    KANJI,        /* 0x5a94 */
    KANJI,        /* 0x5a95 */
    KANJI,        /* 0x5a96 */
    KANJI,        /* 0x5a97 */
    KANJI,        /* 0x5a98 */
    KANJI,        /* 0x5a99 */
    KANJI,        /* 0x5a9a */
    KANJI,        /* 0x5a9b */
    KANJI,        /* 0x5a9c */
    KANJI,        /* 0x5a9d */
    KANJI,        /* 0x5a9e */
    KANJI,        /* 0x5a9f */
    KANJI,        /* 0x5aa0 */
    KANJI,        /* 0x5aa1 */
    KANJI,        /* 0x5aa2 */
    KANJI,        /* 0x5aa3 */
    KANJI,        /* 0x5aa4 */
    KANJI,        /* 0x5aa5 */
    KANJI,        /* 0x5aa6 */
    KANJI,        /* 0x5aa7 */
    KANJI,        /* 0x5aa8 */
    KANJI,        /* 0x5aa9 */
    KANJI,        /* 0x5aaa */
    KANJI,        /* 0x5aab */
    KANJI,        /* 0x5aac */
    KANJI,        /* 0x5aad */
    KANJI,        /* 0x5aae */
    KANJI,        /* 0x5aaf */
    KANJI,        /* 0x5ab0 */
    KANJI,        /* 0x5ab1 */
    KANJI,        /* 0x5ab2 */
    KANJI,        /* 0x5ab3 */
    KANJI,        /* 0x5ab4 */
    KANJI,        /* 0x5ab5 */
    KANJI,        /* 0x5ab6 */
    KANJI,        /* 0x5ab7 */
    KANJI,        /* 0x5ab8 */
    KANJI,        /* 0x5ab9 */
    KANJI,        /* 0x5aba */
    KANJI,        /* 0x5abb */
    KANJI,        /* 0x5abc */
    KANJI,        /* 0x5abd */
    KANJI,        /* 0x5abe */
    KANJI,        /* 0x5abf */
    KANJI,        /* 0x5ac0 */
    KANJI,        /* 0x5ac1 */
    KANJI,        /* 0x5ac2 */
    KANJI,        /* 0x5ac3 */
    KANJI,        /* 0x5ac4 */
    KANJI,        /* 0x5ac5 */
    KANJI,        /* 0x5ac6 */
    KANJI,        /* 0x5ac7 */
    KANJI,        /* 0x5ac8 */
    KANJI,        /* 0x5ac9 */
    KANJI,        /* 0x5aca */
    KANJI,        /* 0x5acb */
    KANJI,        /* 0x5acc */
    KANJI,        /* 0x5acd */
    KANJI,        /* 0x5ace */
    KANJI,        /* 0x5acf */
    KANJI,        /* 0x5ad0 */
    KANJI,        /* 0x5ad1 */
    KANJI,        /* 0x5ad2 */
    KANJI,        /* 0x5ad3 */
    KANJI,        /* 0x5ad4 */
    KANJI,        /* 0x5ad5 */
    KANJI,        /* 0x5ad6 */
    KANJI,        /* 0x5ad7 */
    KANJI,        /* 0x5ad8 */
    KANJI,        /* 0x5ad9 */
    KANJI,        /* 0x5ada */
    KANJI,        /* 0x5adb */
    KANJI,        /* 0x5adc */
    KANJI,        /* 0x5add */
    KANJI,        /* 0x5ade */
    KANJI,        /* 0x5adf */
    KANJI,        /* 0x5ae0 */
    KANJI,        /* 0x5ae1 */
    KANJI,        /* 0x5ae2 */
    KANJI,        /* 0x5ae3 */
    KANJI,        /* 0x5ae4 */
    KANJI,        /* 0x5ae5 */
    KANJI,        /* 0x5ae6 */
    KANJI,        /* 0x5ae7 */
    KANJI,        /* 0x5ae8 */
    KANJI,        /* 0x5ae9 */
    KANJI,        /* 0x5aea */
    KANJI,        /* 0x5aeb */
    KANJI,        /* 0x5aec */
    KANJI,        /* 0x5aed */
    KANJI,        /* 0x5aee */
    KANJI,        /* 0x5aef */
    KANJI,        /* 0x5af0 */
    KANJI,        /* 0x5af1 */
    KANJI,        /* 0x5af2 */
    KANJI,        /* 0x5af3 */
    KANJI,        /* 0x5af4 */
    KANJI,        /* 0x5af5 */
    KANJI,        /* 0x5af6 */
    KANJI,        /* 0x5af7 */
    KANJI,        /* 0x5af8 */
    KANJI,        /* 0x5af9 */
    KANJI,        /* 0x5afa */
    KANJI,        /* 0x5afb */
    KANJI,        /* 0x5afc */
    KANJI,        /* 0x5afd */
    KANJI,        /* 0x5afe */
    KANJI,        /* 0x5aff */
    KANJI,        /* 0x5b00 */
    KANJI,        /* 0x5b01 */
    KANJI,        /* 0x5b02 */
    KANJI,        /* 0x5b03 */
    KANJI,        /* 0x5b04 */
    KANJI,        /* 0x5b05 */
    KANJI,        /* 0x5b06 */
    KANJI,        /* 0x5b07 */
    KANJI,        /* 0x5b08 */
    KANJI,        /* 0x5b09 */
    KANJI,        /* 0x5b0a */
    KANJI,        /* 0x5b0b */
    KANJI,        /* 0x5b0c */
    KANJI,        /* 0x5b0d */
    KANJI,        /* 0x5b0e */
    KANJI,        /* 0x5b0f */
    KANJI,        /* 0x5b10 */
    KANJI,        /* 0x5b11 */
    KANJI,        /* 0x5b12 */
    KANJI,        /* 0x5b13 */
    KANJI,        /* 0x5b14 */
    KANJI,        /* 0x5b15 */
    KANJI,        /* 0x5b16 */
    KANJI,        /* 0x5b17 */
    KANJI,        /* 0x5b18 */
    KANJI,        /* 0x5b19 */
    KANJI,        /* 0x5b1a */
    KANJI,        /* 0x5b1b */
    KANJI,        /* 0x5b1c */
    KANJI,        /* 0x5b1d */
    KANJI,        /* 0x5b1e */
    KANJI,        /* 0x5b1f */
    KANJI,        /* 0x5b20 */
    KANJI,        /* 0x5b21 */
    KANJI,        /* 0x5b22 */
    KANJI,        /* 0x5b23 */
    KANJI,        /* 0x5b24 */
    KANJI,        /* 0x5b25 */
    KANJI,        /* 0x5b26 */
    KANJI,        /* 0x5b27 */
    KANJI,        /* 0x5b28 */
    KANJI,        /* 0x5b29 */
    KANJI,        /* 0x5b2a */
    KANJI,        /* 0x5b2b */
    KANJI,        /* 0x5b2c */
    KANJI,        /* 0x5b2d */
    KANJI,        /* 0x5b2e */
    KANJI,        /* 0x5b2f */
    KANJI,        /* 0x5b30 */
    KANJI,        /* 0x5b31 */
    KANJI,        /* 0x5b32 */
    KANJI,        /* 0x5b33 */
    KANJI,        /* 0x5b34 */
    KANJI,        /* 0x5b35 */
    KANJI,        /* 0x5b36 */
    KANJI,        /* 0x5b37 */
    KANJI,        /* 0x5b38 */
    KANJI,        /* 0x5b39 */
    KANJI,        /* 0x5b3a */
    KANJI,        /* 0x5b3b */
    KANJI,        /* 0x5b3c */
    KANJI,        /* 0x5b3d */
    KANJI,        /* 0x5b3e */
    KANJI,        /* 0x5b3f */
    KANJI,        /* 0x5b40 */
    KANJI,        /* 0x5b41 */
    KANJI,        /* 0x5b42 */
    KANJI,        /* 0x5b43 */
    KANJI,        /* 0x5b44 */
    KANJI,        /* 0x5b45 */
    KANJI,        /* 0x5b46 */
    KANJI,        /* 0x5b47 */
    KANJI,        /* 0x5b48 */
    KANJI,        /* 0x5b49 */
    KANJI,        /* 0x5b4a */
    KANJI,        /* 0x5b4b */
    KANJI,        /* 0x5b4c */
    KANJI,        /* 0x5b4d */
    KANJI,        /* 0x5b4e */
    KANJI,        /* 0x5b4f */
    KANJI,        /* 0x5b50 */
    KANJI,        /* 0x5b51 */
    KANJI,        /* 0x5b52 */
    KANJI,        /* 0x5b53 */
    KANJI,        /* 0x5b54 */
    KANJI,        /* 0x5b55 */
    KANJI,        /* 0x5b56 */
    KANJI,        /* 0x5b57 */
    KANJI,        /* 0x5b58 */
    KANJI,        /* 0x5b59 */
    KANJI,        /* 0x5b5a */
    KANJI,        /* 0x5b5b */
    KANJI,        /* 0x5b5c */
    KANJI,        /* 0x5b5d */
    KANJI,        /* 0x5b5e */
    KANJI,        /* 0x5b5f */
    KANJI,        /* 0x5b60 */
    KANJI,        /* 0x5b61 */
    KANJI,        /* 0x5b62 */
    KANJI,        /* 0x5b63 */
    KANJI,        /* 0x5b64 */
    KANJI,        /* 0x5b65 */
    KANJI,        /* 0x5b66 */
    KANJI,        /* 0x5b67 */
    KANJI,        /* 0x5b68 */
    KANJI,        /* 0x5b69 */
    KANJI,        /* 0x5b6a */
    KANJI,        /* 0x5b6b */
    KANJI,        /* 0x5b6c */
    KANJI,        /* 0x5b6d */
    KANJI,        /* 0x5b6e */
    KANJI,        /* 0x5b6f */
    KANJI,        /* 0x5b70 */
    KANJI,        /* 0x5b71 */
    KANJI,        /* 0x5b72 */
    KANJI,        /* 0x5b73 */
    KANJI,        /* 0x5b74 */
    KANJI,        /* 0x5b75 */
    KANJI,        /* 0x5b76 */
    KANJI,        /* 0x5b77 */
    KANJI,        /* 0x5b78 */
    KANJI,        /* 0x5b79 */
    KANJI,        /* 0x5b7a */
    KANJI,        /* 0x5b7b */
    KANJI,        /* 0x5b7c */
    KANJI,        /* 0x5b7d */
    KANJI,        /* 0x5b7e */
    KANJI,        /* 0x5b7f */
    KANJI,        /* 0x5b80 */
    KANJI,        /* 0x5b81 */
    KANJI,        /* 0x5b82 */
    KANJI,        /* 0x5b83 */
    KANJI,        /* 0x5b84 */
    KANJI,        /* 0x5b85 */
    KANJI,        /* 0x5b86 */
    KANJI,        /* 0x5b87 */
    KANJI,        /* 0x5b88 */
    KANJI,        /* 0x5b89 */
    KANJI,        /* 0x5b8a */
    KANJI,        /* 0x5b8b */
    KANJI,        /* 0x5b8c */
    KANJI,        /* 0x5b8d */
    KANJI,        /* 0x5b8e */
    KANJI,        /* 0x5b8f */
    KANJI,        /* 0x5b90 */
    KANJI,        /* 0x5b91 */
    KANJI,        /* 0x5b92 */
    KANJI,        /* 0x5b93 */
    KANJI,        /* 0x5b94 */
    KANJI,        /* 0x5b95 */
    KANJI,        /* 0x5b96 */
    KANJI,        /* 0x5b97 */
    KANJI,        /* 0x5b98 */
    KANJI,        /* 0x5b99 */
    KANJI,        /* 0x5b9a */
    KANJI,        /* 0x5b9b */
    KANJI,        /* 0x5b9c */
    KANJI,        /* 0x5b9d */
    KANJI,        /* 0x5b9e */
    KANJI,        /* 0x5b9f */
    KANJI,        /* 0x5ba0 */
    KANJI,        /* 0x5ba1 */
    KANJI,        /* 0x5ba2 */
    KANJI,        /* 0x5ba3 */
    KANJI,        /* 0x5ba4 */
    KANJI,        /* 0x5ba5 */
    KANJI,        /* 0x5ba6 */
    KANJI,        /* 0x5ba7 */
    KANJI,        /* 0x5ba8 */
    KANJI,        /* 0x5ba9 */
    KANJI,        /* 0x5baa */
    KANJI,        /* 0x5bab */
    KANJI,        /* 0x5bac */
    KANJI,        /* 0x5bad */
    KANJI,        /* 0x5bae */
    KANJI,        /* 0x5baf */
    KANJI,        /* 0x5bb0 */
    KANJI,        /* 0x5bb1 */
    KANJI,        /* 0x5bb2 */
    KANJI,        /* 0x5bb3 */
    KANJI,        /* 0x5bb4 */
    KANJI,        /* 0x5bb5 */
    KANJI,        /* 0x5bb6 */
    KANJI,        /* 0x5bb7 */
    KANJI,        /* 0x5bb8 */
    KANJI,        /* 0x5bb9 */
    KANJI,        /* 0x5bba */
    KANJI,        /* 0x5bbb */
    KANJI,        /* 0x5bbc */
    KANJI,        /* 0x5bbd */
    KANJI,        /* 0x5bbe */
    KANJI,        /* 0x5bbf */
    KANJI,        /* 0x5bc0 */
    KANJI,        /* 0x5bc1 */
    KANJI,        /* 0x5bc2 */
    KANJI,        /* 0x5bc3 */
    KANJI,        /* 0x5bc4 */
    KANJI,        /* 0x5bc5 */
    KANJI,        /* 0x5bc6 */
    KANJI,        /* 0x5bc7 */
    KANJI,        /* 0x5bc8 */
    KANJI,        /* 0x5bc9 */
    KANJI,        /* 0x5bca */
    KANJI,        /* 0x5bcb */
    KANJI,        /* 0x5bcc */
    KANJI,        /* 0x5bcd */
    KANJI,        /* 0x5bce */
    KANJI,        /* 0x5bcf */
    KANJI,        /* 0x5bd0 */
    KANJI,        /* 0x5bd1 */
    KANJI,        /* 0x5bd2 */
    KANJI,        /* 0x5bd3 */
    KANJI,        /* 0x5bd4 */
    KANJI,        /* 0x5bd5 */
    KANJI,        /* 0x5bd6 */
    KANJI,        /* 0x5bd7 */
    KANJI,        /* 0x5bd8 */
    KANJI,        /* 0x5bd9 */
    KANJI,        /* 0x5bda */
    KANJI,        /* 0x5bdb */
    KANJI,        /* 0x5bdc */
    KANJI,        /* 0x5bdd */
    KANJI,        /* 0x5bde */
    KANJI,        /* 0x5bdf */
    KANJI,        /* 0x5be0 */
    KANJI,        /* 0x5be1 */
    KANJI,        /* 0x5be2 */
    KANJI,        /* 0x5be3 */
    KANJI,        /* 0x5be4 */
    KANJI,        /* 0x5be5 */
    KANJI,        /* 0x5be6 */
    KANJI,        /* 0x5be7 */
    KANJI,        /* 0x5be8 */
    KANJI,        /* 0x5be9 */
    KANJI,        /* 0x5bea */
    KANJI,        /* 0x5beb */
    KANJI,        /* 0x5bec */
    KANJI,        /* 0x5bed */
    KANJI,        /* 0x5bee */
    KANJI,        /* 0x5bef */
    KANJI,        /* 0x5bf0 */
    KANJI,        /* 0x5bf1 */
    KANJI,        /* 0x5bf2 */
    KANJI,        /* 0x5bf3 */
    KANJI,        /* 0x5bf4 */
    KANJI,        /* 0x5bf5 */
    KANJI,        /* 0x5bf6 */
    KANJI,        /* 0x5bf7 */
    KANJI,        /* 0x5bf8 */
    KANJI,        /* 0x5bf9 */
    KANJI,        /* 0x5bfa */
    KANJI,        /* 0x5bfb */
    KANJI,        /* 0x5bfc */
    KANJI,        /* 0x5bfd */
    KANJI,        /* 0x5bfe */
    KANJI,        /* 0x5bff */
    KANJI,        /* 0x5c00 */
    KANJI,        /* 0x5c01 */
    KANJI,        /* 0x5c02 */
    KANJI,        /* 0x5c03 */
    KANJI,        /* 0x5c04 */
    KANJI,        /* 0x5c05 */
    KANJI,        /* 0x5c06 */
    KANJI,        /* 0x5c07 */
    KANJI,        /* 0x5c08 */
    KANJI,        /* 0x5c09 */
    KANJI,        /* 0x5c0a */
    KANJI,        /* 0x5c0b */
    KANJI,        /* 0x5c0c */
    KANJI,        /* 0x5c0d */
    KANJI,        /* 0x5c0e */
    KANJI,        /* 0x5c0f */
    KANJI,        /* 0x5c10 */
    KANJI,        /* 0x5c11 */
    KANJI,        /* 0x5c12 */
    KANJI,        /* 0x5c13 */
    KANJI,        /* 0x5c14 */
    KANJI,        /* 0x5c15 */
    KANJI,        /* 0x5c16 */
    KANJI,        /* 0x5c17 */
    KANJI,        /* 0x5c18 */
    KANJI,        /* 0x5c19 */
    KANJI,        /* 0x5c1a */
    KANJI,        /* 0x5c1b */
    KANJI,        /* 0x5c1c */
    KANJI,        /* 0x5c1d */
    KANJI,        /* 0x5c1e */
    KANJI,        /* 0x5c1f */
    KANJI,        /* 0x5c20 */
    KANJI,        /* 0x5c21 */
    KANJI,        /* 0x5c22 */
    KANJI,        /* 0x5c23 */
    KANJI,        /* 0x5c24 */
    KANJI,        /* 0x5c25 */
    KANJI,        /* 0x5c26 */
    KANJI,        /* 0x5c27 */
    KANJI,        /* 0x5c28 */
    KANJI,        /* 0x5c29 */
    KANJI,        /* 0x5c2a */
    KANJI,        /* 0x5c2b */
    KANJI,        /* 0x5c2c */
    KANJI,        /* 0x5c2d */
    KANJI,        /* 0x5c2e */
    KANJI,        /* 0x5c2f */
    KANJI,        /* 0x5c30 */
    KANJI,        /* 0x5c31 */
    KANJI,        /* 0x5c32 */
    KANJI,        /* 0x5c33 */
    KANJI,        /* 0x5c34 */
    KANJI,        /* 0x5c35 */
    KANJI,        /* 0x5c36 */
    KANJI,        /* 0x5c37 */
    KANJI,        /* 0x5c38 */
    KANJI,        /* 0x5c39 */
    KANJI,        /* 0x5c3a */
    KANJI,        /* 0x5c3b */
    KANJI,        /* 0x5c3c */
    KANJI,        /* 0x5c3d */
    KANJI,        /* 0x5c3e */
    KANJI,        /* 0x5c3f */
    KANJI,        /* 0x5c40 */
    KANJI,        /* 0x5c41 */
    KANJI,        /* 0x5c42 */
    KANJI,        /* 0x5c43 */
    KANJI,        /* 0x5c44 */
    KANJI,        /* 0x5c45 */
    KANJI,        /* 0x5c46 */
    KANJI,        /* 0x5c47 */
    KANJI,        /* 0x5c48 */
    KANJI,        /* 0x5c49 */
    KANJI,        /* 0x5c4a */
    KANJI,        /* 0x5c4b */
    KANJI,        /* 0x5c4c */
    KANJI,        /* 0x5c4d */
    KANJI,        /* 0x5c4e */
    KANJI,        /* 0x5c4f */
    KANJI,        /* 0x5c50 */
    KANJI,        /* 0x5c51 */
    KANJI,        /* 0x5c52 */
    KANJI,        /* 0x5c53 */
    KANJI,        /* 0x5c54 */
    KANJI,        /* 0x5c55 */
    KANJI,        /* 0x5c56 */
    KANJI,        /* 0x5c57 */
    KANJI,        /* 0x5c58 */
    KANJI,        /* 0x5c59 */
    KANJI,        /* 0x5c5a */
    KANJI,        /* 0x5c5b */
    KANJI,        /* 0x5c5c */
    KANJI,        /* 0x5c5d */
    KANJI,        /* 0x5c5e */
    KANJI,        /* 0x5c5f */
    KANJI,        /* 0x5c60 */
    KANJI,        /* 0x5c61 */
    KANJI,        /* 0x5c62 */
    KANJI,        /* 0x5c63 */
    KANJI,        /* 0x5c64 */
    KANJI,        /* 0x5c65 */
    KANJI,        /* 0x5c66 */
    KANJI,        /* 0x5c67 */
    KANJI,        /* 0x5c68 */
    KANJI,        /* 0x5c69 */
    KANJI,        /* 0x5c6a */
    KANJI,        /* 0x5c6b */
    KANJI,        /* 0x5c6c */
    KANJI,        /* 0x5c6d */
    KANJI,        /* 0x5c6e */
    KANJI,        /* 0x5c6f */
    KANJI,        /* 0x5c70 */
    KANJI,        /* 0x5c71 */
    KANJI,        /* 0x5c72 */
    KANJI,        /* 0x5c73 */
    KANJI,        /* 0x5c74 */
    KANJI,        /* 0x5c75 */
    KANJI,        /* 0x5c76 */
    KANJI,        /* 0x5c77 */
    KANJI,        /* 0x5c78 */
    KANJI,        /* 0x5c79 */
    KANJI,        /* 0x5c7a */
    KANJI,        /* 0x5c7b */
    KANJI,        /* 0x5c7c */
    KANJI,        /* 0x5c7d */
    KANJI,        /* 0x5c7e */
    KANJI,        /* 0x5c7f */
    KANJI,        /* 0x5c80 */
    KANJI,        /* 0x5c81 */
    KANJI,        /* 0x5c82 */
    KANJI,        /* 0x5c83 */
    KANJI,        /* 0x5c84 */
    KANJI,        /* 0x5c85 */
    KANJI,        /* 0x5c86 */
    KANJI,        /* 0x5c87 */
    KANJI,        /* 0x5c88 */
    KANJI,        /* 0x5c89 */
    KANJI,        /* 0x5c8a */
    KANJI,        /* 0x5c8b */
    KANJI,        /* 0x5c8c */
    KANJI,        /* 0x5c8d */
    KANJI,        /* 0x5c8e */
    KANJI,        /* 0x5c8f */
    KANJI,        /* 0x5c90 */
    KANJI,        /* 0x5c91 */
    KANJI,        /* 0x5c92 */
    KANJI,        /* 0x5c93 */
    KANJI,        /* 0x5c94 */
    KANJI,        /* 0x5c95 */
    KANJI,        /* 0x5c96 */
    KANJI,        /* 0x5c97 */
    KANJI,        /* 0x5c98 */
    KANJI,        /* 0x5c99 */
    KANJI,        /* 0x5c9a */
    KANJI,        /* 0x5c9b */
    KANJI,        /* 0x5c9c */
    KANJI,        /* 0x5c9d */
    KANJI,        /* 0x5c9e */
    KANJI,        /* 0x5c9f */
    KANJI,        /* 0x5ca0 */
    KANJI,        /* 0x5ca1 */
    KANJI,        /* 0x5ca2 */
    KANJI,        /* 0x5ca3 */
    KANJI,        /* 0x5ca4 */
    KANJI,        /* 0x5ca5 */
    KANJI,        /* 0x5ca6 */
    KANJI,        /* 0x5ca7 */
    KANJI,        /* 0x5ca8 */
    KANJI,        /* 0x5ca9 */
    KANJI,        /* 0x5caa */
    KANJI,        /* 0x5cab */
    KANJI,        /* 0x5cac */
    KANJI,        /* 0x5cad */
    KANJI,        /* 0x5cae */
    KANJI,        /* 0x5caf */
    KANJI,        /* 0x5cb0 */
    KANJI,        /* 0x5cb1 */
    KANJI,        /* 0x5cb2 */
    KANJI,        /* 0x5cb3 */
    KANJI,        /* 0x5cb4 */
    KANJI,        /* 0x5cb5 */
    KANJI,        /* 0x5cb6 */
    KANJI,        /* 0x5cb7 */
    KANJI,        /* 0x5cb8 */
    KANJI,        /* 0x5cb9 */
    KANJI,        /* 0x5cba */
    KANJI,        /* 0x5cbb */
    KANJI,        /* 0x5cbc */
    KANJI,        /* 0x5cbd */
    KANJI,        /* 0x5cbe */
    KANJI,        /* 0x5cbf */
    KANJI,        /* 0x5cc0 */
    KANJI,        /* 0x5cc1 */
    KANJI,        /* 0x5cc2 */
    KANJI,        /* 0x5cc3 */
    KANJI,        /* 0x5cc4 */
    KANJI,        /* 0x5cc5 */
    KANJI,        /* 0x5cc6 */
    KANJI,        /* 0x5cc7 */
    KANJI,        /* 0x5cc8 */
    KANJI,        /* 0x5cc9 */
    KANJI,        /* 0x5cca */
    KANJI,        /* 0x5ccb */
    KANJI,        /* 0x5ccc */
    KANJI,        /* 0x5ccd */
    KANJI,        /* 0x5cce */
    KANJI,        /* 0x5ccf */
    KANJI,        /* 0x5cd0 */
    KANJI,        /* 0x5cd1 */
    KANJI,        /* 0x5cd2 */
    KANJI,        /* 0x5cd3 */
    KANJI,        /* 0x5cd4 */
    KANJI,        /* 0x5cd5 */
    KANJI,        /* 0x5cd6 */
    KANJI,        /* 0x5cd7 */
    KANJI,        /* 0x5cd8 */
    KANJI,        /* 0x5cd9 */
    KANJI,        /* 0x5cda */
    KANJI,        /* 0x5cdb */
    KANJI,        /* 0x5cdc */
    KANJI,        /* 0x5cdd */
    KANJI,        /* 0x5cde */
    KANJI,        /* 0x5cdf */
    KANJI,        /* 0x5ce0 */
    KANJI,        /* 0x5ce1 */
    KANJI,        /* 0x5ce2 */
    KANJI,        /* 0x5ce3 */
    KANJI,        /* 0x5ce4 */
    KANJI,        /* 0x5ce5 */
    KANJI,        /* 0x5ce6 */
    KANJI,        /* 0x5ce7 */
    KANJI,        /* 0x5ce8 */
    KANJI,        /* 0x5ce9 */
    KANJI,        /* 0x5cea */
    KANJI,        /* 0x5ceb */
    KANJI,        /* 0x5cec */
    KANJI,        /* 0x5ced */
    KANJI,        /* 0x5cee */
    KANJI,        /* 0x5cef */
    KANJI,        /* 0x5cf0 */
    KANJI,        /* 0x5cf1 */
    KANJI,        /* 0x5cf2 */
    KANJI,        /* 0x5cf3 */
    KANJI,        /* 0x5cf4 */
    KANJI,        /* 0x5cf5 */
    KANJI,        /* 0x5cf6 */
    KANJI,        /* 0x5cf7 */
    KANJI,        /* 0x5cf8 */
    KANJI,        /* 0x5cf9 */
    KANJI,        /* 0x5cfa */
    KANJI,        /* 0x5cfb */
    KANJI,        /* 0x5cfc */
    KANJI,        /* 0x5cfd */
    KANJI,        /* 0x5cfe */
    KANJI,        /* 0x5cff */
    KANJI,        /* 0x5d00 */
    KANJI,        /* 0x5d01 */
    KANJI,        /* 0x5d02 */
    KANJI,        /* 0x5d03 */
    KANJI,        /* 0x5d04 */
    KANJI,        /* 0x5d05 */
    KANJI,        /* 0x5d06 */
    KANJI,        /* 0x5d07 */
    KANJI,        /* 0x5d08 */
    KANJI,        /* 0x5d09 */
    KANJI,        /* 0x5d0a */
    KANJI,        /* 0x5d0b */
    KANJI,        /* 0x5d0c */
    KANJI,        /* 0x5d0d */
    KANJI,        /* 0x5d0e */
    KANJI,        /* 0x5d0f */
    KANJI,        /* 0x5d10 */
    KANJI,        /* 0x5d11 */
    KANJI,        /* 0x5d12 */
    KANJI,        /* 0x5d13 */
    KANJI,        /* 0x5d14 */
    KANJI,        /* 0x5d15 */
    KANJI,        /* 0x5d16 */
    KANJI,        /* 0x5d17 */
    KANJI,        /* 0x5d18 */
    KANJI,        /* 0x5d19 */
    KANJI,        /* 0x5d1a */
    KANJI,        /* 0x5d1b */
    KANJI,        /* 0x5d1c */
    KANJI,        /* 0x5d1d */
    KANJI,        /* 0x5d1e */
    KANJI,        /* 0x5d1f */
    KANJI,        /* 0x5d20 */
    KANJI,        /* 0x5d21 */
    KANJI,        /* 0x5d22 */
    KANJI,        /* 0x5d23 */
    KANJI,        /* 0x5d24 */
    KANJI,        /* 0x5d25 */
    KANJI,        /* 0x5d26 */
    KANJI,        /* 0x5d27 */
    KANJI,        /* 0x5d28 */
    KANJI,        /* 0x5d29 */
    KANJI,        /* 0x5d2a */
    KANJI,        /* 0x5d2b */
    KANJI,        /* 0x5d2c */
    KANJI,        /* 0x5d2d */
    KANJI,        /* 0x5d2e */
    KANJI,        /* 0x5d2f */
    KANJI,        /* 0x5d30 */
    KANJI,        /* 0x5d31 */
    KANJI,        /* 0x5d32 */
    KANJI,        /* 0x5d33 */
    KANJI,        /* 0x5d34 */
    KANJI,        /* 0x5d35 */
    KANJI,        /* 0x5d36 */
    KANJI,        /* 0x5d37 */
    KANJI,        /* 0x5d38 */
    KANJI,        /* 0x5d39 */
    KANJI,        /* 0x5d3a */
    KANJI,        /* 0x5d3b */
    KANJI,        /* 0x5d3c */
    KANJI,        /* 0x5d3d */
    KANJI,        /* 0x5d3e */
    KANJI,        /* 0x5d3f */
    KANJI,        /* 0x5d40 */
    KANJI,        /* 0x5d41 */
    KANJI,        /* 0x5d42 */
    KANJI,        /* 0x5d43 */
    KANJI,        /* 0x5d44 */
    KANJI,        /* 0x5d45 */
    KANJI,        /* 0x5d46 */
    KANJI,        /* 0x5d47 */
    KANJI,        /* 0x5d48 */
    KANJI,        /* 0x5d49 */
    KANJI,        /* 0x5d4a */
    KANJI,        /* 0x5d4b */
    KANJI,        /* 0x5d4c */
    KANJI,        /* 0x5d4d */
    KANJI,        /* 0x5d4e */
    KANJI,        /* 0x5d4f */
    KANJI,        /* 0x5d50 */
    KANJI,        /* 0x5d51 */
    KANJI,        /* 0x5d52 */
    KANJI,        /* 0x5d53 */
    KANJI,        /* 0x5d54 */
    KANJI,        /* 0x5d55 */
    KANJI,        /* 0x5d56 */
    KANJI,        /* 0x5d57 */
    KANJI,        /* 0x5d58 */
    KANJI,        /* 0x5d59 */
    KANJI,        /* 0x5d5a */
    KANJI,        /* 0x5d5b */
    KANJI,        /* 0x5d5c */
    KANJI,        /* 0x5d5d */
    KANJI,        /* 0x5d5e */
    KANJI,        /* 0x5d5f */
    KANJI,        /* 0x5d60 */
    KANJI,        /* 0x5d61 */
    KANJI,        /* 0x5d62 */
    KANJI,        /* 0x5d63 */
    KANJI,        /* 0x5d64 */
    KANJI,        /* 0x5d65 */
    KANJI,        /* 0x5d66 */
    KANJI,        /* 0x5d67 */
    KANJI,        /* 0x5d68 */
    KANJI,        /* 0x5d69 */
    KANJI,        /* 0x5d6a */
    KANJI,        /* 0x5d6b */
    KANJI,        /* 0x5d6c */
    KANJI,        /* 0x5d6d */
    KANJI,        /* 0x5d6e */
    KANJI,        /* 0x5d6f */
    KANJI,        /* 0x5d70 */
    KANJI,        /* 0x5d71 */
    KANJI,        /* 0x5d72 */
    KANJI,        /* 0x5d73 */
    KANJI,        /* 0x5d74 */
    KANJI,        /* 0x5d75 */
    KANJI,        /* 0x5d76 */
    KANJI,        /* 0x5d77 */
    KANJI,        /* 0x5d78 */
    KANJI,        /* 0x5d79 */
    KANJI,        /* 0x5d7a */
    KANJI,        /* 0x5d7b */
    KANJI,        /* 0x5d7c */
    KANJI,        /* 0x5d7d */
    KANJI,        /* 0x5d7e */
    KANJI,        /* 0x5d7f */
    KANJI,        /* 0x5d80 */
    KANJI,        /* 0x5d81 */
    KANJI,        /* 0x5d82 */
    KANJI,        /* 0x5d83 */
    KANJI,        /* 0x5d84 */
    KANJI,        /* 0x5d85 */
    KANJI,        /* 0x5d86 */
    KANJI,        /* 0x5d87 */
    KANJI,        /* 0x5d88 */
    KANJI,        /* 0x5d89 */
    KANJI,        /* 0x5d8a */
    KANJI,        /* 0x5d8b */
    KANJI,        /* 0x5d8c */
    KANJI,        /* 0x5d8d */
    KANJI,        /* 0x5d8e */
    KANJI,        /* 0x5d8f */
    KANJI,        /* 0x5d90 */
    KANJI,        /* 0x5d91 */
    KANJI,        /* 0x5d92 */
    KANJI,        /* 0x5d93 */
    KANJI,        /* 0x5d94 */
    KANJI,        /* 0x5d95 */
    KANJI,        /* 0x5d96 */
    KANJI,        /* 0x5d97 */
    KANJI,        /* 0x5d98 */
    KANJI,        /* 0x5d99 */
    KANJI,        /* 0x5d9a */
    KANJI,        /* 0x5d9b */
    KANJI,        /* 0x5d9c */
    KANJI,        /* 0x5d9d */
    KANJI,        /* 0x5d9e */
    KANJI,        /* 0x5d9f */
    KANJI,        /* 0x5da0 */
    KANJI,        /* 0x5da1 */
    KANJI,        /* 0x5da2 */
    KANJI,        /* 0x5da3 */
    KANJI,        /* 0x5da4 */
    KANJI,        /* 0x5da5 */
    KANJI,        /* 0x5da6 */
    KANJI,        /* 0x5da7 */
    KANJI,        /* 0x5da8 */
    KANJI,        /* 0x5da9 */
    KANJI,        /* 0x5daa */
    KANJI,        /* 0x5dab */
    KANJI,        /* 0x5dac */
    KANJI,        /* 0x5dad */
    KANJI,        /* 0x5dae */
    KANJI,        /* 0x5daf */
    KANJI,        /* 0x5db0 */
    KANJI,        /* 0x5db1 */
    KANJI,        /* 0x5db2 */
    KANJI,        /* 0x5db3 */
    KANJI,        /* 0x5db4 */
    KANJI,        /* 0x5db5 */
    KANJI,        /* 0x5db6 */
    KANJI,        /* 0x5db7 */
    KANJI,        /* 0x5db8 */
    KANJI,        /* 0x5db9 */
    KANJI,        /* 0x5dba */
    KANJI,        /* 0x5dbb */
    KANJI,        /* 0x5dbc */
    KANJI,        /* 0x5dbd */
    KANJI,        /* 0x5dbe */
    KANJI,        /* 0x5dbf */
    KANJI,        /* 0x5dc0 */
    KANJI,        /* 0x5dc1 */
    KANJI,        /* 0x5dc2 */
    KANJI,        /* 0x5dc3 */
    KANJI,        /* 0x5dc4 */
    KANJI,        /* 0x5dc5 */
    KANJI,        /* 0x5dc6 */
    KANJI,        /* 0x5dc7 */
    KANJI,        /* 0x5dc8 */
    KANJI,        /* 0x5dc9 */
    KANJI,        /* 0x5dca */
    KANJI,        /* 0x5dcb */
    KANJI,        /* 0x5dcc */
    KANJI,        /* 0x5dcd */
    KANJI,        /* 0x5dce */
    KANJI,        /* 0x5dcf */
    KANJI,        /* 0x5dd0 */
    KANJI,        /* 0x5dd1 */
    KANJI,        /* 0x5dd2 */
    KANJI,        /* 0x5dd3 */
    KANJI,        /* 0x5dd4 */
    KANJI,        /* 0x5dd5 */
    KANJI,        /* 0x5dd6 */
    KANJI,        /* 0x5dd7 */
    KANJI,        /* 0x5dd8 */
    KANJI,        /* 0x5dd9 */
    KANJI,        /* 0x5dda */
    KANJI,        /* 0x5ddb */
    KANJI,        /* 0x5ddc */
    KANJI,        /* 0x5ddd */
    KANJI,        /* 0x5dde */
    KANJI,        /* 0x5ddf */
    KANJI,        /* 0x5de0 */
    KANJI,        /* 0x5de1 */
    KANJI,        /* 0x5de2 */
    KANJI,        /* 0x5de3 */
    KANJI,        /* 0x5de4 */
    KANJI,        /* 0x5de5 */
    KANJI,        /* 0x5de6 */
    KANJI,        /* 0x5de7 */
    KANJI,        /* 0x5de8 */
    KANJI,        /* 0x5de9 */
    KANJI,        /* 0x5dea */
    KANJI,        /* 0x5deb */
    KANJI,        /* 0x5dec */
    KANJI,        /* 0x5ded */
    KANJI,        /* 0x5dee */
    KANJI,        /* 0x5def */
    KANJI,        /* 0x5df0 */
    KANJI,        /* 0x5df1 */
    KANJI,        /* 0x5df2 */
    KANJI,        /* 0x5df3 */
    KANJI,        /* 0x5df4 */
    KANJI,        /* 0x5df5 */
    KANJI,        /* 0x5df6 */
    KANJI,        /* 0x5df7 */
    KANJI,        /* 0x5df8 */
    KANJI,        /* 0x5df9 */
    KANJI,        /* 0x5dfa */
    KANJI,        /* 0x5dfb */
    KANJI,        /* 0x5dfc */
    KANJI,        /* 0x5dfd */
    KANJI,        /* 0x5dfe */
    KANJI,        /* 0x5dff */
    KANJI,        /* 0x5e00 */
    KANJI,        /* 0x5e01 */
    KANJI,        /* 0x5e02 */
    KANJI,        /* 0x5e03 */
    KANJI,        /* 0x5e04 */
    KANJI,        /* 0x5e05 */
    KANJI,        /* 0x5e06 */
    KANJI,        /* 0x5e07 */
    KANJI,        /* 0x5e08 */
    KANJI,        /* 0x5e09 */
    KANJI,        /* 0x5e0a */
    KANJI,        /* 0x5e0b */
    KANJI,        /* 0x5e0c */
    KANJI,        /* 0x5e0d */
    KANJI,        /* 0x5e0e */
    KANJI,        /* 0x5e0f */
    KANJI,        /* 0x5e10 */
    KANJI,        /* 0x5e11 */
    KANJI,        /* 0x5e12 */
    KANJI,        /* 0x5e13 */
    KANJI,        /* 0x5e14 */
    KANJI,        /* 0x5e15 */
    KANJI,        /* 0x5e16 */
    KANJI,        /* 0x5e17 */
    KANJI,        /* 0x5e18 */
    KANJI,        /* 0x5e19 */
    KANJI,        /* 0x5e1a */
    KANJI,        /* 0x5e1b */
    KANJI,        /* 0x5e1c */
    KANJI,        /* 0x5e1d */
    KANJI,        /* 0x5e1e */
    KANJI,        /* 0x5e1f */
    KANJI,        /* 0x5e20 */
    KANJI,        /* 0x5e21 */
    KANJI,        /* 0x5e22 */
    KANJI,        /* 0x5e23 */
    KANJI,        /* 0x5e24 */
    KANJI,        /* 0x5e25 */
    KANJI,        /* 0x5e26 */
    KANJI,        /* 0x5e27 */
    KANJI,        /* 0x5e28 */
    KANJI,        /* 0x5e29 */
    KANJI,        /* 0x5e2a */
    KANJI,        /* 0x5e2b */
    KANJI,        /* 0x5e2c */
    KANJI,        /* 0x5e2d */
    KANJI,        /* 0x5e2e */
    KANJI,        /* 0x5e2f */
    KANJI,        /* 0x5e30 */
    KANJI,        /* 0x5e31 */
    KANJI,        /* 0x5e32 */
    KANJI,        /* 0x5e33 */
    KANJI,        /* 0x5e34 */
    KANJI,        /* 0x5e35 */
    KANJI,        /* 0x5e36 */
    KANJI,        /* 0x5e37 */
    KANJI,        /* 0x5e38 */
    KANJI,        /* 0x5e39 */
    KANJI,        /* 0x5e3a */
    KANJI,        /* 0x5e3b */
    KANJI,        /* 0x5e3c */
    KANJI,        /* 0x5e3d */
    KANJI,        /* 0x5e3e */
    KANJI,        /* 0x5e3f */
    KANJI,        /* 0x5e40 */
    KANJI,        /* 0x5e41 */
    KANJI,        /* 0x5e42 */
    KANJI,        /* 0x5e43 */
    KANJI,        /* 0x5e44 */
    KANJI,        /* 0x5e45 */
    KANJI,        /* 0x5e46 */
    KANJI,        /* 0x5e47 */
    KANJI,        /* 0x5e48 */
    KANJI,        /* 0x5e49 */
    KANJI,        /* 0x5e4a */
    KANJI,        /* 0x5e4b */
    KANJI,        /* 0x5e4c */
    KANJI,        /* 0x5e4d */
    KANJI,        /* 0x5e4e */
    KANJI,        /* 0x5e4f */
    KANJI,        /* 0x5e50 */
    KANJI,        /* 0x5e51 */
    KANJI,        /* 0x5e52 */
    KANJI,        /* 0x5e53 */
    KANJI,        /* 0x5e54 */
    KANJI,        /* 0x5e55 */
    KANJI,        /* 0x5e56 */
    KANJI,        /* 0x5e57 */
    KANJI,        /* 0x5e58 */
    KANJI,        /* 0x5e59 */
    KANJI,        /* 0x5e5a */
    KANJI,        /* 0x5e5b */
    KANJI,        /* 0x5e5c */
    KANJI,        /* 0x5e5d */
    KANJI,        /* 0x5e5e */
    KANJI,        /* 0x5e5f */
    KANJI,        /* 0x5e60 */
    KANJI,        /* 0x5e61 */
    KANJI,        /* 0x5e62 */
    KANJI,        /* 0x5e63 */
    KANJI,        /* 0x5e64 */
    KANJI,        /* 0x5e65 */
    KANJI,        /* 0x5e66 */
    KANJI,        /* 0x5e67 */
    KANJI,        /* 0x5e68 */
    KANJI,        /* 0x5e69 */
    KANJI,        /* 0x5e6a */
    KANJI,        /* 0x5e6b */
    KANJI,        /* 0x5e6c */
    KANJI,        /* 0x5e6d */
    KANJI,        /* 0x5e6e */
    KANJI,        /* 0x5e6f */
    KANJI,        /* 0x5e70 */
    KANJI,        /* 0x5e71 */
    KANJI,        /* 0x5e72 */
    KANJI,        /* 0x5e73 */
    KANJI,        /* 0x5e74 */
    KANJI,        /* 0x5e75 */
    KANJI,        /* 0x5e76 */
    KANJI,        /* 0x5e77 */
    KANJI,        /* 0x5e78 */
    KANJI,        /* 0x5e79 */
    KANJI,        /* 0x5e7a */
    KANJI,        /* 0x5e7b */
    KANJI,        /* 0x5e7c */
    KANJI,        /* 0x5e7d */
    KANJI,        /* 0x5e7e */
    KANJI,        /* 0x5e7f */
    KANJI,        /* 0x5e80 */
    KANJI,        /* 0x5e81 */
    KANJI,        /* 0x5e82 */
    KANJI,        /* 0x5e83 */
    KANJI,        /* 0x5e84 */
    KANJI,        /* 0x5e85 */
    KANJI,        /* 0x5e86 */
    KANJI,        /* 0x5e87 */
    KANJI,        /* 0x5e88 */
    KANJI,        /* 0x5e89 */
    KANJI,        /* 0x5e8a */
    KANJI,        /* 0x5e8b */
    KANJI,        /* 0x5e8c */
    KANJI,        /* 0x5e8d */
    KANJI,        /* 0x5e8e */
    KANJI,        /* 0x5e8f */
    KANJI,        /* 0x5e90 */
    KANJI,        /* 0x5e91 */
    KANJI,        /* 0x5e92 */
    KANJI,        /* 0x5e93 */
    KANJI,        /* 0x5e94 */
    KANJI,        /* 0x5e95 */
    KANJI,        /* 0x5e96 */
    KANJI,        /* 0x5e97 */
    KANJI,        /* 0x5e98 */
    KANJI,        /* 0x5e99 */
    KANJI,        /* 0x5e9a */
    KANJI,        /* 0x5e9b */
    KANJI,        /* 0x5e9c */
    KANJI,        /* 0x5e9d */
    KANJI,        /* 0x5e9e */
    KANJI,        /* 0x5e9f */
    KANJI,        /* 0x5ea0 */
    KANJI,        /* 0x5ea1 */
    KANJI,        /* 0x5ea2 */
    KANJI,        /* 0x5ea3 */
    KANJI,        /* 0x5ea4 */
    KANJI,        /* 0x5ea5 */
    KANJI,        /* 0x5ea6 */
    KANJI,        /* 0x5ea7 */
    KANJI,        /* 0x5ea8 */
    KANJI,        /* 0x5ea9 */
    KANJI,        /* 0x5eaa */
    KANJI,        /* 0x5eab */
    KANJI,        /* 0x5eac */
    KANJI,        /* 0x5ead */
    KANJI,        /* 0x5eae */
    KANJI,        /* 0x5eaf */
    KANJI,        /* 0x5eb0 */
    KANJI,        /* 0x5eb1 */
    KANJI,        /* 0x5eb2 */
    KANJI,        /* 0x5eb3 */
    KANJI,        /* 0x5eb4 */
    KANJI,        /* 0x5eb5 */
    KANJI,        /* 0x5eb6 */
    KANJI,        /* 0x5eb7 */
    KANJI,        /* 0x5eb8 */
    KANJI,        /* 0x5eb9 */
    KANJI,        /* 0x5eba */
    KANJI,        /* 0x5ebb */
    KANJI,        /* 0x5ebc */
    KANJI,        /* 0x5ebd */
    KANJI,        /* 0x5ebe */
    KANJI,        /* 0x5ebf */
    KANJI,        /* 0x5ec0 */
    KANJI,        /* 0x5ec1 */
    KANJI,        /* 0x5ec2 */
    KANJI,        /* 0x5ec3 */
    KANJI,        /* 0x5ec4 */
    KANJI,        /* 0x5ec5 */
    KANJI,        /* 0x5ec6 */
    KANJI,        /* 0x5ec7 */
    KANJI,        /* 0x5ec8 */
    KANJI,        /* 0x5ec9 */
    KANJI,        /* 0x5eca */
    KANJI,        /* 0x5ecb */
    KANJI,        /* 0x5ecc */
    KANJI,        /* 0x5ecd */
    KANJI,        /* 0x5ece */
    KANJI,        /* 0x5ecf */
    KANJI,        /* 0x5ed0 */
    KANJI,        /* 0x5ed1 */
    KANJI,        /* 0x5ed2 */
    KANJI,        /* 0x5ed3 */
    KANJI,        /* 0x5ed4 */
    KANJI,        /* 0x5ed5 */
    KANJI,        /* 0x5ed6 */
    KANJI,        /* 0x5ed7 */
    KANJI,        /* 0x5ed8 */
    KANJI,        /* 0x5ed9 */
    KANJI,        /* 0x5eda */
    KANJI,        /* 0x5edb */
    KANJI,        /* 0x5edc */
    KANJI,        /* 0x5edd */
    KANJI,        /* 0x5ede */
    KANJI,        /* 0x5edf */
    KANJI,        /* 0x5ee0 */
    KANJI,        /* 0x5ee1 */
    KANJI,        /* 0x5ee2 */
    KANJI,        /* 0x5ee3 */
    KANJI,        /* 0x5ee4 */
    KANJI,        /* 0x5ee5 */
    KANJI,        /* 0x5ee6 */
    KANJI,        /* 0x5ee7 */
    KANJI,        /* 0x5ee8 */
    KANJI,        /* 0x5ee9 */
    KANJI,        /* 0x5eea */
    KANJI,        /* 0x5eeb */
    KANJI,        /* 0x5eec */
    KANJI,        /* 0x5eed */
    KANJI,        /* 0x5eee */
    KANJI,        /* 0x5eef */
    KANJI,        /* 0x5ef0 */
    KANJI,        /* 0x5ef1 */
    KANJI,        /* 0x5ef2 */
    KANJI,        /* 0x5ef3 */
    KANJI,        /* 0x5ef4 */
    KANJI,        /* 0x5ef5 */
    KANJI,        /* 0x5ef6 */
    KANJI,        /* 0x5ef7 */
    KANJI,        /* 0x5ef8 */
    KANJI,        /* 0x5ef9 */
    KANJI,        /* 0x5efa */
    KANJI,        /* 0x5efb */
    KANJI,        /* 0x5efc */
    KANJI,        /* 0x5efd */
    KANJI,        /* 0x5efe */
    KANJI,        /* 0x5eff */
    KANJI,        /* 0x5f00 */
    KANJI,        /* 0x5f01 */
    KANJI,        /* 0x5f02 */
    KANJI,        /* 0x5f03 */
    KANJI,        /* 0x5f04 */
    KANJI,        /* 0x5f05 */
    KANJI,        /* 0x5f06 */
    KANJI,        /* 0x5f07 */
    KANJI,        /* 0x5f08 */
    KANJI,        /* 0x5f09 */
    KANJI,        /* 0x5f0a */
    KANJI,        /* 0x5f0b */
    KANJI,        /* 0x5f0c */
    KANJI,        /* 0x5f0d */
    KANJI,        /* 0x5f0e */
    KANJI,        /* 0x5f0f */
    KANJI,        /* 0x5f10 */
    KANJI,        /* 0x5f11 */
    KANJI,        /* 0x5f12 */
    KANJI,        /* 0x5f13 */
    KANJI,        /* 0x5f14 */
    KANJI,        /* 0x5f15 */
    KANJI,        /* 0x5f16 */
    KANJI,        /* 0x5f17 */
    KANJI,        /* 0x5f18 */
    KANJI,        /* 0x5f19 */
    KANJI,        /* 0x5f1a */
    KANJI,        /* 0x5f1b */
    KANJI,        /* 0x5f1c */
    KANJI,        /* 0x5f1d */
    KANJI,        /* 0x5f1e */
    KANJI,        /* 0x5f1f */
    KANJI,        /* 0x5f20 */
    KANJI,        /* 0x5f21 */
    KANJI,        /* 0x5f22 */
    KANJI,        /* 0x5f23 */
    KANJI,        /* 0x5f24 */
    KANJI,        /* 0x5f25 */
    KANJI,        /* 0x5f26 */
    KANJI,        /* 0x5f27 */
    KANJI,        /* 0x5f28 */
    KANJI,        /* 0x5f29 */
    KANJI,        /* 0x5f2a */
    KANJI,        /* 0x5f2b */
    KANJI,        /* 0x5f2c */
    KANJI,        /* 0x5f2d */
    KANJI,        /* 0x5f2e */
    KANJI,        /* 0x5f2f */
    KANJI,        /* 0x5f30 */
    KANJI,        /* 0x5f31 */
    KANJI,        /* 0x5f32 */
    KANJI,        /* 0x5f33 */
    KANJI,        /* 0x5f34 */
    KANJI,        /* 0x5f35 */
    KANJI,        /* 0x5f36 */
    KANJI,        /* 0x5f37 */
    KANJI,        /* 0x5f38 */
    KANJI,        /* 0x5f39 */
    KANJI,        /* 0x5f3a */
    KANJI,        /* 0x5f3b */
    KANJI,        /* 0x5f3c */
    KANJI,        /* 0x5f3d */
    KANJI,        /* 0x5f3e */
    KANJI,        /* 0x5f3f */
    KANJI,        /* 0x5f40 */
    KANJI,        /* 0x5f41 */
    KANJI,        /* 0x5f42 */
    KANJI,        /* 0x5f43 */
    KANJI,        /* 0x5f44 */
    KANJI,        /* 0x5f45 */
    KANJI,        /* 0x5f46 */
    KANJI,        /* 0x5f47 */
    KANJI,        /* 0x5f48 */
    KANJI,        /* 0x5f49 */
    KANJI,        /* 0x5f4a */
    KANJI,        /* 0x5f4b */
    KANJI,        /* 0x5f4c */
    KANJI,        /* 0x5f4d */
    KANJI,        /* 0x5f4e */
    KANJI,        /* 0x5f4f */
    KANJI,        /* 0x5f50 */
    KANJI,        /* 0x5f51 */
    KANJI,        /* 0x5f52 */
    KANJI,        /* 0x5f53 */
    KANJI,        /* 0x5f54 */
    KANJI,        /* 0x5f55 */
    KANJI,        /* 0x5f56 */
    KANJI,        /* 0x5f57 */
    KANJI,        /* 0x5f58 */
    KANJI,        /* 0x5f59 */
    KANJI,        /* 0x5f5a */
    KANJI,        /* 0x5f5b */
    KANJI,        /* 0x5f5c */
    KANJI,        /* 0x5f5d */
    KANJI,        /* 0x5f5e */
    KANJI,        /* 0x5f5f */
    KANJI,        /* 0x5f60 */
    KANJI,        /* 0x5f61 */
    KANJI,        /* 0x5f62 */
    KANJI,        /* 0x5f63 */
    KANJI,        /* 0x5f64 */
    KANJI,        /* 0x5f65 */
    KANJI,        /* 0x5f66 */
    KANJI,        /* 0x5f67 */
    KANJI,        /* 0x5f68 */
    KANJI,        /* 0x5f69 */
    KANJI,        /* 0x5f6a */
    KANJI,        /* 0x5f6b */
    KANJI,        /* 0x5f6c */
    KANJI,        /* 0x5f6d */
    KANJI,        /* 0x5f6e */
    KANJI,        /* 0x5f6f */
    KANJI,        /* 0x5f70 */
    KANJI,        /* 0x5f71 */
    KANJI,        /* 0x5f72 */
    KANJI,        /* 0x5f73 */
    KANJI,        /* 0x5f74 */
    KANJI,        /* 0x5f75 */
    KANJI,        /* 0x5f76 */
    KANJI,        /* 0x5f77 */
    KANJI,        /* 0x5f78 */
    KANJI,        /* 0x5f79 */
    KANJI,        /* 0x5f7a */
    KANJI,        /* 0x5f7b */
    KANJI,        /* 0x5f7c */
    KANJI,        /* 0x5f7d */
    KANJI,        /* 0x5f7e */
    KANJI,        /* 0x5f7f */
    KANJI,        /* 0x5f80 */
    KANJI,        /* 0x5f81 */
    KANJI,        /* 0x5f82 */
    KANJI,        /* 0x5f83 */
    KANJI,        /* 0x5f84 */
    KANJI,        /* 0x5f85 */
    KANJI,        /* 0x5f86 */
    KANJI,        /* 0x5f87 */
    KANJI,        /* 0x5f88 */
    KANJI,        /* 0x5f89 */
    KANJI,        /* 0x5f8a */
    KANJI,        /* 0x5f8b */
    KANJI,        /* 0x5f8c */
    KANJI,        /* 0x5f8d */
    KANJI,        /* 0x5f8e */
    KANJI,        /* 0x5f8f */
    KANJI,        /* 0x5f90 */
    KANJI,        /* 0x5f91 */
    KANJI,        /* 0x5f92 */
    KANJI,        /* 0x5f93 */
    KANJI,        /* 0x5f94 */
    KANJI,        /* 0x5f95 */
    KANJI,        /* 0x5f96 */
    KANJI,        /* 0x5f97 */
    KANJI,        /* 0x5f98 */
    KANJI,        /* 0x5f99 */
    KANJI,        /* 0x5f9a */
    KANJI,        /* 0x5f9b */
    KANJI,        /* 0x5f9c */
    KANJI,        /* 0x5f9d */
    KANJI,        /* 0x5f9e */
    KANJI,        /* 0x5f9f */
    KANJI,        /* 0x5fa0 */
    KANJI,        /* 0x5fa1 */
    KANJI,        /* 0x5fa2 */
    KANJI,        /* 0x5fa3 */
    KANJI,        /* 0x5fa4 */
    KANJI,        /* 0x5fa5 */
    KANJI,        /* 0x5fa6 */
    KANJI,        /* 0x5fa7 */
    KANJI,        /* 0x5fa8 */
    KANJI,        /* 0x5fa9 */
    KANJI,        /* 0x5faa */
    KANJI,        /* 0x5fab */
    KANJI,        /* 0x5fac */
    KANJI,        /* 0x5fad */
    KANJI,        /* 0x5fae */
    KANJI,        /* 0x5faf */
    KANJI,        /* 0x5fb0 */
    KANJI,        /* 0x5fb1 */
    KANJI,        /* 0x5fb2 */
    KANJI,        /* 0x5fb3 */
    KANJI,        /* 0x5fb4 */
    KANJI,        /* 0x5fb5 */
    KANJI,        /* 0x5fb6 */
    KANJI,        /* 0x5fb7 */
    KANJI,        /* 0x5fb8 */
    KANJI,        /* 0x5fb9 */
    KANJI,        /* 0x5fba */
    KANJI,        /* 0x5fbb */
    KANJI,        /* 0x5fbc */
    KANJI,        /* 0x5fbd */
    KANJI,        /* 0x5fbe */
    KANJI,        /* 0x5fbf */
    KANJI,        /* 0x5fc0 */
    KANJI,        /* 0x5fc1 */
    KANJI,        /* 0x5fc2 */
    KANJI,        /* 0x5fc3 */
    KANJI,        /* 0x5fc4 */
    KANJI,        /* 0x5fc5 */
    KANJI,        /* 0x5fc6 */
    KANJI,        /* 0x5fc7 */
    KANJI,        /* 0x5fc8 */
    KANJI,        /* 0x5fc9 */
    KANJI,        /* 0x5fca */
    KANJI,        /* 0x5fcb */
    KANJI,        /* 0x5fcc */
    KANJI,        /* 0x5fcd */
    KANJI,        /* 0x5fce */
    KANJI,        /* 0x5fcf */
    KANJI,        /* 0x5fd0 */
    KANJI,        /* 0x5fd1 */
    KANJI,        /* 0x5fd2 */
    KANJI,        /* 0x5fd3 */
    KANJI,        /* 0x5fd4 */
    KANJI,        /* 0x5fd5 */
    KANJI,        /* 0x5fd6 */
    KANJI,        /* 0x5fd7 */
    KANJI,        /* 0x5fd8 */
    KANJI,        /* 0x5fd9 */
    KANJI,        /* 0x5fda */
    KANJI,        /* 0x5fdb */
    KANJI,        /* 0x5fdc */
    KANJI,        /* 0x5fdd */
    KANJI,        /* 0x5fde */
    KANJI,        /* 0x5fdf */
    KANJI,        /* 0x5fe0 */
    KANJI,        /* 0x5fe1 */
    KANJI,        /* 0x5fe2 */
    KANJI,        /* 0x5fe3 */
    KANJI,        /* 0x5fe4 */
    KANJI,        /* 0x5fe5 */
    KANJI,        /* 0x5fe6 */
    KANJI,        /* 0x5fe7 */
    KANJI,        /* 0x5fe8 */
    KANJI,        /* 0x5fe9 */
    KANJI,        /* 0x5fea */
    KANJI,        /* 0x5feb */
    KANJI,        /* 0x5fec */
    KANJI,        /* 0x5fed */
    KANJI,        /* 0x5fee */
    KANJI,        /* 0x5fef */
    KANJI,        /* 0x5ff0 */
    KANJI,        /* 0x5ff1 */
    KANJI,        /* 0x5ff2 */
    KANJI,        /* 0x5ff3 */
    KANJI,        /* 0x5ff4 */
    KANJI,        /* 0x5ff5 */
    KANJI,        /* 0x5ff6 */
    KANJI,        /* 0x5ff7 */
    KANJI,        /* 0x5ff8 */
    KANJI,        /* 0x5ff9 */
    KANJI,        /* 0x5ffa */
    KANJI,        /* 0x5ffb */
    KANJI,        /* 0x5ffc */
    KANJI,        /* 0x5ffd */
    KANJI,        /* 0x5ffe */
    KANJI,        /* 0x5fff */
    KANJI,        /* 0x6000 */
    KANJI,        /* 0x6001 */
    KANJI,        /* 0x6002 */
    KANJI,        /* 0x6003 */
    KANJI,        /* 0x6004 */
    KANJI,        /* 0x6005 */
    KANJI,        /* 0x6006 */
    KANJI,        /* 0x6007 */
    KANJI,        /* 0x6008 */
    KANJI,        /* 0x6009 */
    KANJI,        /* 0x600a */
    KANJI,        /* 0x600b */
    KANJI,        /* 0x600c */
    KANJI,        /* 0x600d */
    KANJI,        /* 0x600e */
    KANJI,        /* 0x600f */
    KANJI,        /* 0x6010 */
    KANJI,        /* 0x6011 */
    KANJI,        /* 0x6012 */
    KANJI,        /* 0x6013 */
    KANJI,        /* 0x6014 */
    KANJI,        /* 0x6015 */
    KANJI,        /* 0x6016 */
    KANJI,        /* 0x6017 */
    KANJI,        /* 0x6018 */
    KANJI,        /* 0x6019 */
    KANJI,        /* 0x601a */
    KANJI,        /* 0x601b */
    KANJI,        /* 0x601c */
    KANJI,        /* 0x601d */
    KANJI,        /* 0x601e */
    KANJI,        /* 0x601f */
    KANJI,        /* 0x6020 */
    KANJI,        /* 0x6021 */
    KANJI,        /* 0x6022 */
    KANJI,        /* 0x6023 */
    KANJI,        /* 0x6024 */
    KANJI,        /* 0x6025 */
    KANJI,        /* 0x6026 */
    KANJI,        /* 0x6027 */
    KANJI,        /* 0x6028 */
    KANJI,        /* 0x6029 */
    KANJI,        /* 0x602a */
    KANJI,        /* 0x602b */
    KANJI,        /* 0x602c */
    KANJI,        /* 0x602d */
    KANJI,        /* 0x602e */
    KANJI,        /* 0x602f */
    KANJI,        /* 0x6030 */
    KANJI,        /* 0x6031 */
    KANJI,        /* 0x6032 */
    KANJI,        /* 0x6033 */
    KANJI,        /* 0x6034 */
    KANJI,        /* 0x6035 */
    KANJI,        /* 0x6036 */
    KANJI,        /* 0x6037 */
    KANJI,        /* 0x6038 */
    KANJI,        /* 0x6039 */
    KANJI,        /* 0x603a */
    KANJI,        /* 0x603b */
    KANJI,        /* 0x603c */
    KANJI,        /* 0x603d */
    KANJI,        /* 0x603e */
    KANJI,        /* 0x603f */
    KANJI,        /* 0x6040 */
    KANJI,        /* 0x6041 */
    KANJI,        /* 0x6042 */
    KANJI,        /* 0x6043 */
    KANJI,        /* 0x6044 */
    KANJI,        /* 0x6045 */
    KANJI,        /* 0x6046 */
    KANJI,        /* 0x6047 */
    KANJI,        /* 0x6048 */
    KANJI,        /* 0x6049 */
    KANJI,        /* 0x604a */
    KANJI,        /* 0x604b */
    KANJI,        /* 0x604c */
    KANJI,        /* 0x604d */
    KANJI,        /* 0x604e */
    KANJI,        /* 0x604f */
    KANJI,        /* 0x6050 */
    KANJI,        /* 0x6051 */
    KANJI,        /* 0x6052 */
    KANJI,        /* 0x6053 */
    KANJI,        /* 0x6054 */
    KANJI,        /* 0x6055 */
    KANJI,        /* 0x6056 */
    KANJI,        /* 0x6057 */
    KANJI,        /* 0x6058 */
    KANJI,        /* 0x6059 */
    KANJI,        /* 0x605a */
    KANJI,        /* 0x605b */
    KANJI,        /* 0x605c */
    KANJI,        /* 0x605d */
    KANJI,        /* 0x605e */
    KANJI,        /* 0x605f */
    KANJI,        /* 0x6060 */
    KANJI,        /* 0x6061 */
    KANJI,        /* 0x6062 */
    KANJI,        /* 0x6063 */
    KANJI,        /* 0x6064 */
    KANJI,        /* 0x6065 */
    KANJI,        /* 0x6066 */
    KANJI,        /* 0x6067 */
    KANJI,        /* 0x6068 */
    KANJI,        /* 0x6069 */
    KANJI,        /* 0x606a */
    KANJI,        /* 0x606b */
    KANJI,        /* 0x606c */
    KANJI,        /* 0x606d */
    KANJI,        /* 0x606e */
    KANJI,        /* 0x606f */
    KANJI,        /* 0x6070 */
    KANJI,        /* 0x6071 */
    KANJI,        /* 0x6072 */
    KANJI,        /* 0x6073 */
    KANJI,        /* 0x6074 */
    KANJI,        /* 0x6075 */
    KANJI,        /* 0x6076 */
    KANJI,        /* 0x6077 */
    KANJI,        /* 0x6078 */
    KANJI,        /* 0x6079 */
    KANJI,        /* 0x607a */
    KANJI,        /* 0x607b */
    KANJI,        /* 0x607c */
    KANJI,        /* 0x607d */
    KANJI,        /* 0x607e */
    KANJI,        /* 0x607f */
    KANJI,        /* 0x6080 */
    KANJI,        /* 0x6081 */
    KANJI,        /* 0x6082 */
    KANJI,        /* 0x6083 */
    KANJI,        /* 0x6084 */
    KANJI,        /* 0x6085 */
    KANJI,        /* 0x6086 */
    KANJI,        /* 0x6087 */
    KANJI,        /* 0x6088 */
    KANJI,        /* 0x6089 */
    KANJI,        /* 0x608a */
    KANJI,        /* 0x608b */
    KANJI,        /* 0x608c */
    KANJI,        /* 0x608d */
    KANJI,        /* 0x608e */
    KANJI,        /* 0x608f */
    KANJI,        /* 0x6090 */
    KANJI,        /* 0x6091 */
    KANJI,        /* 0x6092 */
    KANJI,        /* 0x6093 */
    KANJI,        /* 0x6094 */
    KANJI,        /* 0x6095 */
    KANJI,        /* 0x6096 */
    KANJI,        /* 0x6097 */
    KANJI,        /* 0x6098 */
    KANJI,        /* 0x6099 */
    KANJI,        /* 0x609a */
    KANJI,        /* 0x609b */
    KANJI,        /* 0x609c */
    KANJI,        /* 0x609d */
    KANJI,        /* 0x609e */
    KANJI,        /* 0x609f */
    KANJI,        /* 0x60a0 */
    KANJI,        /* 0x60a1 */
    KANJI,        /* 0x60a2 */
    KANJI,        /* 0x60a3 */
    KANJI,        /* 0x60a4 */
    KANJI,        /* 0x60a5 */
    KANJI,        /* 0x60a6 */
    KANJI,        /* 0x60a7 */
    KANJI,        /* 0x60a8 */
    KANJI,        /* 0x60a9 */
    KANJI,        /* 0x60aa */
    KANJI,        /* 0x60ab */
    KANJI,        /* 0x60ac */
    KANJI,        /* 0x60ad */
    KANJI,        /* 0x60ae */
    KANJI,        /* 0x60af */
    KANJI,        /* 0x60b0 */
    KANJI,        /* 0x60b1 */
    KANJI,        /* 0x60b2 */
    KANJI,        /* 0x60b3 */
    KANJI,        /* 0x60b4 */
    KANJI,        /* 0x60b5 */
    KANJI,        /* 0x60b6 */
    KANJI,        /* 0x60b7 */
    KANJI,        /* 0x60b8 */
    KANJI,        /* 0x60b9 */
    KANJI,        /* 0x60ba */
    KANJI,        /* 0x60bb */
    KANJI,        /* 0x60bc */
    KANJI,        /* 0x60bd */
    KANJI,        /* 0x60be */
    KANJI,        /* 0x60bf */
    KANJI,        /* 0x60c0 */
    KANJI,        /* 0x60c1 */
    KANJI,        /* 0x60c2 */
    KANJI,        /* 0x60c3 */
    KANJI,        /* 0x60c4 */
    KANJI,        /* 0x60c5 */
    KANJI,        /* 0x60c6 */
    KANJI,        /* 0x60c7 */
    KANJI,        /* 0x60c8 */
    KANJI,        /* 0x60c9 */
    KANJI,        /* 0x60ca */
    KANJI,        /* 0x60cb */
    KANJI,        /* 0x60cc */
    KANJI,        /* 0x60cd */
    KANJI,        /* 0x60ce */
    KANJI,        /* 0x60cf */
    KANJI,        /* 0x60d0 */
    KANJI,        /* 0x60d1 */
    KANJI,        /* 0x60d2 */
    KANJI,        /* 0x60d3 */
    KANJI,        /* 0x60d4 */
    KANJI,        /* 0x60d5 */
    KANJI,        /* 0x60d6 */
    KANJI,        /* 0x60d7 */
    KANJI,        /* 0x60d8 */
    KANJI,        /* 0x60d9 */
    KANJI,        /* 0x60da */
    KANJI,        /* 0x60db */
    KANJI,        /* 0x60dc */
    KANJI,        /* 0x60dd */
    KANJI,        /* 0x60de */
    KANJI,        /* 0x60df */
    KANJI,        /* 0x60e0 */
    KANJI,        /* 0x60e1 */
    KANJI,        /* 0x60e2 */
    KANJI,        /* 0x60e3 */
    KANJI,        /* 0x60e4 */
    KANJI,        /* 0x60e5 */
    KANJI,        /* 0x60e6 */
    KANJI,        /* 0x60e7 */
    KANJI,        /* 0x60e8 */
    KANJI,        /* 0x60e9 */
    KANJI,        /* 0x60ea */
    KANJI,        /* 0x60eb */
    KANJI,        /* 0x60ec */
    KANJI,        /* 0x60ed */
    KANJI,        /* 0x60ee */
    KANJI,        /* 0x60ef */
    KANJI,        /* 0x60f0 */
    KANJI,        /* 0x60f1 */
    KANJI,        /* 0x60f2 */
    KANJI,        /* 0x60f3 */
    KANJI,        /* 0x60f4 */
    KANJI,        /* 0x60f5 */
    KANJI,        /* 0x60f6 */
    KANJI,        /* 0x60f7 */
    KANJI,        /* 0x60f8 */
    KANJI,        /* 0x60f9 */
    KANJI,        /* 0x60fa */
    KANJI,        /* 0x60fb */
    KANJI,        /* 0x60fc */
    KANJI,        /* 0x60fd */
    KANJI,        /* 0x60fe */
    KANJI,        /* 0x60ff */
    KANJI,        /* 0x6100 */
    KANJI,        /* 0x6101 */
    KANJI,        /* 0x6102 */
    KANJI,        /* 0x6103 */
    KANJI,        /* 0x6104 */
    KANJI,        /* 0x6105 */
    KANJI,        /* 0x6106 */
    KANJI,        /* 0x6107 */
    KANJI,        /* 0x6108 */
    KANJI,        /* 0x6109 */
    KANJI,        /* 0x610a */
    KANJI,        /* 0x610b */
    KANJI,        /* 0x610c */
    KANJI,        /* 0x610d */
    KANJI,        /* 0x610e */
    KANJI,        /* 0x610f */
    KANJI,        /* 0x6110 */
    KANJI,        /* 0x6111 */
    KANJI,        /* 0x6112 */
    KANJI,        /* 0x6113 */
    KANJI,        /* 0x6114 */
    KANJI,        /* 0x6115 */
    KANJI,        /* 0x6116 */
    KANJI,        /* 0x6117 */
    KANJI,        /* 0x6118 */
    KANJI,        /* 0x6119 */
    KANJI,        /* 0x611a */
    KANJI,        /* 0x611b */
    KANJI,        /* 0x611c */
    KANJI,        /* 0x611d */
    KANJI,        /* 0x611e */
    KANJI,        /* 0x611f */
    KANJI,        /* 0x6120 */
    KANJI,        /* 0x6121 */
    KANJI,        /* 0x6122 */
    KANJI,        /* 0x6123 */
    KANJI,        /* 0x6124 */
    KANJI,        /* 0x6125 */
    KANJI,        /* 0x6126 */
    KANJI,        /* 0x6127 */
    KANJI,        /* 0x6128 */
    KANJI,        /* 0x6129 */
    KANJI,        /* 0x612a */
    KANJI,        /* 0x612b */
    KANJI,        /* 0x612c */
    KANJI,        /* 0x612d */
    KANJI,        /* 0x612e */
    KANJI,        /* 0x612f */
    KANJI,        /* 0x6130 */
    KANJI,        /* 0x6131 */
    KANJI,        /* 0x6132 */
    KANJI,        /* 0x6133 */
    KANJI,        /* 0x6134 */
    KANJI,        /* 0x6135 */
    KANJI,        /* 0x6136 */
    KANJI,        /* 0x6137 */
    KANJI,        /* 0x6138 */
    KANJI,        /* 0x6139 */
    KANJI,        /* 0x613a */
    KANJI,        /* 0x613b */
    KANJI,        /* 0x613c */
    KANJI,        /* 0x613d */
    KANJI,        /* 0x613e */
    KANJI,        /* 0x613f */
    KANJI,        /* 0x6140 */
    KANJI,        /* 0x6141 */
    KANJI,        /* 0x6142 */
    KANJI,        /* 0x6143 */
    KANJI,        /* 0x6144 */
    KANJI,        /* 0x6145 */
    KANJI,        /* 0x6146 */
    KANJI,        /* 0x6147 */
    KANJI,        /* 0x6148 */
    KANJI,        /* 0x6149 */
    KANJI,        /* 0x614a */
    KANJI,        /* 0x614b */
    KANJI,        /* 0x614c */
    KANJI,        /* 0x614d */
    KANJI,        /* 0x614e */
    KANJI,        /* 0x614f */
    KANJI,        /* 0x6150 */
    KANJI,        /* 0x6151 */
    KANJI,        /* 0x6152 */
    KANJI,        /* 0x6153 */
    KANJI,        /* 0x6154 */
    KANJI,        /* 0x6155 */
    KANJI,        /* 0x6156 */
    KANJI,        /* 0x6157 */
    KANJI,        /* 0x6158 */
    KANJI,        /* 0x6159 */
    KANJI,        /* 0x615a */
    KANJI,        /* 0x615b */
    KANJI,        /* 0x615c */
    KANJI,        /* 0x615d */
    KANJI,        /* 0x615e */
    KANJI,        /* 0x615f */
    KANJI,        /* 0x6160 */
    KANJI,        /* 0x6161 */
    KANJI,        /* 0x6162 */
    KANJI,        /* 0x6163 */
    KANJI,        /* 0x6164 */
    KANJI,        /* 0x6165 */
    KANJI,        /* 0x6166 */
    KANJI,        /* 0x6167 */
    KANJI,        /* 0x6168 */
    KANJI,        /* 0x6169 */
    KANJI,        /* 0x616a */
    KANJI,        /* 0x616b */
    KANJI,        /* 0x616c */
    KANJI,        /* 0x616d */
    KANJI,        /* 0x616e */
    KANJI,        /* 0x616f */
    KANJI,        /* 0x6170 */
    KANJI,        /* 0x6171 */
    KANJI,        /* 0x6172 */
    KANJI,        /* 0x6173 */
    KANJI,        /* 0x6174 */
    KANJI,        /* 0x6175 */
    KANJI,        /* 0x6176 */
    KANJI,        /* 0x6177 */
    KANJI,        /* 0x6178 */
    KANJI,        /* 0x6179 */
    KANJI,        /* 0x617a */
    KANJI,        /* 0x617b */
    KANJI,        /* 0x617c */
    KANJI,        /* 0x617d */
    KANJI,        /* 0x617e */
    KANJI,        /* 0x617f */
    KANJI,        /* 0x6180 */
    KANJI,        /* 0x6181 */
    KANJI,        /* 0x6182 */
    KANJI,        /* 0x6183 */
    KANJI,        /* 0x6184 */
    KANJI,        /* 0x6185 */
    KANJI,        /* 0x6186 */
    KANJI,        /* 0x6187 */
    KANJI,        /* 0x6188 */
    KANJI,        /* 0x6189 */
    KANJI,        /* 0x618a */
    KANJI,        /* 0x618b */
    KANJI,        /* 0x618c */
    KANJI,        /* 0x618d */
    KANJI,        /* 0x618e */
    KANJI,        /* 0x618f */
    KANJI,        /* 0x6190 */
    KANJI,        /* 0x6191 */
    KANJI,        /* 0x6192 */
    KANJI,        /* 0x6193 */
    KANJI,        /* 0x6194 */
    KANJI,        /* 0x6195 */
    KANJI,        /* 0x6196 */
    KANJI,        /* 0x6197 */
    KANJI,        /* 0x6198 */
    KANJI,        /* 0x6199 */
    KANJI,        /* 0x619a */
    KANJI,        /* 0x619b */
    KANJI,        /* 0x619c */
    KANJI,        /* 0x619d */
    KANJI,        /* 0x619e */
    KANJI,        /* 0x619f */
    KANJI,        /* 0x61a0 */
    KANJI,        /* 0x61a1 */
    KANJI,        /* 0x61a2 */
    KANJI,        /* 0x61a3 */
    KANJI,        /* 0x61a4 */
    KANJI,        /* 0x61a5 */
    KANJI,        /* 0x61a6 */
    KANJI,        /* 0x61a7 */
    KANJI,        /* 0x61a8 */
    KANJI,        /* 0x61a9 */
    KANJI,        /* 0x61aa */
    KANJI,        /* 0x61ab */
    KANJI,        /* 0x61ac */
    KANJI,        /* 0x61ad */
    KANJI,        /* 0x61ae */
    KANJI,        /* 0x61af */
    KANJI,        /* 0x61b0 */
    KANJI,        /* 0x61b1 */
    KANJI,        /* 0x61b2 */
    KANJI,        /* 0x61b3 */
    KANJI,        /* 0x61b4 */
    KANJI,        /* 0x61b5 */
    KANJI,        /* 0x61b6 */
    KANJI,        /* 0x61b7 */
    KANJI,        /* 0x61b8 */
    KANJI,        /* 0x61b9 */
    KANJI,        /* 0x61ba */
    KANJI,        /* 0x61bb */
    KANJI,        /* 0x61bc */
    KANJI,        /* 0x61bd */
    KANJI,        /* 0x61be */
    KANJI,        /* 0x61bf */
    KANJI,        /* 0x61c0 */
    KANJI,        /* 0x61c1 */
    KANJI,        /* 0x61c2 */
    KANJI,        /* 0x61c3 */
    KANJI,        /* 0x61c4 */
    KANJI,        /* 0x61c5 */
    KANJI,        /* 0x61c6 */
    KANJI,        /* 0x61c7 */
    KANJI,        /* 0x61c8 */
    KANJI,        /* 0x61c9 */
    KANJI,        /* 0x61ca */
    KANJI,        /* 0x61cb */
    KANJI,        /* 0x61cc */
    KANJI,        /* 0x61cd */
    KANJI,        /* 0x61ce */
    KANJI,        /* 0x61cf */
    KANJI,        /* 0x61d0 */
    KANJI,        /* 0x61d1 */
    KANJI,        /* 0x61d2 */
    KANJI,        /* 0x61d3 */
    KANJI,        /* 0x61d4 */
    KANJI,        /* 0x61d5 */
    KANJI,        /* 0x61d6 */
    KANJI,        /* 0x61d7 */
    KANJI,        /* 0x61d8 */
    KANJI,        /* 0x61d9 */
    KANJI,        /* 0x61da */
    KANJI,        /* 0x61db */
    KANJI,        /* 0x61dc */
    KANJI,        /* 0x61dd */
    KANJI,        /* 0x61de */
    KANJI,        /* 0x61df */
    KANJI,        /* 0x61e0 */
    KANJI,        /* 0x61e1 */
    KANJI,        /* 0x61e2 */
    KANJI,        /* 0x61e3 */
    KANJI,        /* 0x61e4 */
    KANJI,        /* 0x61e5 */
    KANJI,        /* 0x61e6 */
    KANJI,        /* 0x61e7 */
    KANJI,        /* 0x61e8 */
    KANJI,        /* 0x61e9 */
    KANJI,        /* 0x61ea */
    KANJI,        /* 0x61eb */
    KANJI,        /* 0x61ec */
    KANJI,        /* 0x61ed */
    KANJI,        /* 0x61ee */
    KANJI,        /* 0x61ef */
    KANJI,        /* 0x61f0 */
    KANJI,        /* 0x61f1 */
    KANJI,        /* 0x61f2 */
    KANJI,        /* 0x61f3 */
    KANJI,        /* 0x61f4 */
    KANJI,        /* 0x61f5 */
    KANJI,        /* 0x61f6 */
    KANJI,        /* 0x61f7 */
    KANJI,        /* 0x61f8 */
    KANJI,        /* 0x61f9 */
    KANJI,        /* 0x61fa */
    KANJI,        /* 0x61fb */
    KANJI,        /* 0x61fc */
    KANJI,        /* 0x61fd */
    KANJI,        /* 0x61fe */
    KANJI,        /* 0x61ff */
    KANJI,        /* 0x6200 */
    KANJI,        /* 0x6201 */
    KANJI,        /* 0x6202 */
    KANJI,        /* 0x6203 */
    KANJI,        /* 0x6204 */
    KANJI,        /* 0x6205 */
    KANJI,        /* 0x6206 */
    KANJI,        /* 0x6207 */
    KANJI,        /* 0x6208 */
    KANJI,        /* 0x6209 */
    KANJI,        /* 0x620a */
    KANJI,        /* 0x620b */
    KANJI,        /* 0x620c */
    KANJI,        /* 0x620d */
    KANJI,        /* 0x620e */
    KANJI,        /* 0x620f */
    KANJI,        /* 0x6210 */
    KANJI,        /* 0x6211 */
    KANJI,        /* 0x6212 */
    KANJI,        /* 0x6213 */
    KANJI,        /* 0x6214 */
    KANJI,        /* 0x6215 */
    KANJI,        /* 0x6216 */
    KANJI,        /* 0x6217 */
    KANJI,        /* 0x6218 */
    KANJI,        /* 0x6219 */
    KANJI,        /* 0x621a */
    KANJI,        /* 0x621b */
    KANJI,        /* 0x621c */
    KANJI,        /* 0x621d */
    KANJI,        /* 0x621e */
    KANJI,        /* 0x621f */
    KANJI,        /* 0x6220 */
    KANJI,        /* 0x6221 */
    KANJI,        /* 0x6222 */
    KANJI,        /* 0x6223 */
    KANJI,        /* 0x6224 */
    KANJI,        /* 0x6225 */
    KANJI,        /* 0x6226 */
    KANJI,        /* 0x6227 */
    KANJI,        /* 0x6228 */
    KANJI,        /* 0x6229 */
    KANJI,        /* 0x622a */
    KANJI,        /* 0x622b */
    KANJI,        /* 0x622c */
    KANJI,        /* 0x622d */
    KANJI,        /* 0x622e */
    KANJI,        /* 0x622f */
    KANJI,        /* 0x6230 */
    KANJI,        /* 0x6231 */
    KANJI,        /* 0x6232 */
    KANJI,        /* 0x6233 */
    KANJI,        /* 0x6234 */
    KANJI,        /* 0x6235 */
    KANJI,        /* 0x6236 */
    KANJI,        /* 0x6237 */
    KANJI,        /* 0x6238 */
    KANJI,        /* 0x6239 */
    KANJI,        /* 0x623a */
    KANJI,        /* 0x623b */
    KANJI,        /* 0x623c */
    KANJI,        /* 0x623d */
    KANJI,        /* 0x623e */
    KANJI,        /* 0x623f */
    KANJI,        /* 0x6240 */
    KANJI,        /* 0x6241 */
    KANJI,        /* 0x6242 */
    KANJI,        /* 0x6243 */
    KANJI,        /* 0x6244 */
    KANJI,        /* 0x6245 */
    KANJI,        /* 0x6246 */
    KANJI,        /* 0x6247 */
    KANJI,        /* 0x6248 */
    KANJI,        /* 0x6249 */
    KANJI,        /* 0x624a */
    KANJI,        /* 0x624b */
    KANJI,        /* 0x624c */
    KANJI,        /* 0x624d */
    KANJI,        /* 0x624e */
    KANJI,        /* 0x624f */
    KANJI,        /* 0x6250 */
    KANJI,        /* 0x6251 */
    KANJI,        /* 0x6252 */
    KANJI,        /* 0x6253 */
    KANJI,        /* 0x6254 */
    KANJI,        /* 0x6255 */
    KANJI,        /* 0x6256 */
    KANJI,        /* 0x6257 */
    KANJI,        /* 0x6258 */
    KANJI,        /* 0x6259 */
    KANJI,        /* 0x625a */
    KANJI,        /* 0x625b */
    KANJI,        /* 0x625c */
    KANJI,        /* 0x625d */
    KANJI,        /* 0x625e */
    KANJI,        /* 0x625f */
    KANJI,        /* 0x6260 */
    KANJI,        /* 0x6261 */
    KANJI,        /* 0x6262 */
    KANJI,        /* 0x6263 */
    KANJI,        /* 0x6264 */
    KANJI,        /* 0x6265 */
    KANJI,        /* 0x6266 */
    KANJI,        /* 0x6267 */
    KANJI,        /* 0x6268 */
    KANJI,        /* 0x6269 */
    KANJI,        /* 0x626a */
    KANJI,        /* 0x626b */
    KANJI,        /* 0x626c */
    KANJI,        /* 0x626d */
    KANJI,        /* 0x626e */
    KANJI,        /* 0x626f */
    KANJI,        /* 0x6270 */
    KANJI,        /* 0x6271 */
    KANJI,        /* 0x6272 */
    KANJI,        /* 0x6273 */
    KANJI,        /* 0x6274 */
    KANJI,        /* 0x6275 */
    KANJI,        /* 0x6276 */
    KANJI,        /* 0x6277 */
    KANJI,        /* 0x6278 */
    KANJI,        /* 0x6279 */
    KANJI,        /* 0x627a */
    KANJI,        /* 0x627b */
    KANJI,        /* 0x627c */
    KANJI,        /* 0x627d */
    KANJI,        /* 0x627e */
    KANJI,        /* 0x627f */
    KANJI,        /* 0x6280 */
    KANJI,        /* 0x6281 */
    KANJI,        /* 0x6282 */
    KANJI,        /* 0x6283 */
    KANJI,        /* 0x6284 */
    KANJI,        /* 0x6285 */
    KANJI,        /* 0x6286 */
    KANJI,        /* 0x6287 */
    KANJI,        /* 0x6288 */
    KANJI,        /* 0x6289 */
    KANJI,        /* 0x628a */
    KANJI,        /* 0x628b */
    KANJI,        /* 0x628c */
    KANJI,        /* 0x628d */
    KANJI,        /* 0x628e */
    KANJI,        /* 0x628f */
    KANJI,        /* 0x6290 */
    KANJI,        /* 0x6291 */
    KANJI,        /* 0x6292 */
    KANJI,        /* 0x6293 */
    KANJI,        /* 0x6294 */
    KANJI,        /* 0x6295 */
    KANJI,        /* 0x6296 */
    KANJI,        /* 0x6297 */
    KANJI,        /* 0x6298 */
    KANJI,        /* 0x6299 */
    KANJI,        /* 0x629a */
    KANJI,        /* 0x629b */
    KANJI,        /* 0x629c */
    KANJI,        /* 0x629d */
    KANJI,        /* 0x629e */
    KANJI,        /* 0x629f */
    KANJI,        /* 0x62a0 */
    KANJI,        /* 0x62a1 */
    KANJI,        /* 0x62a2 */
    KANJI,        /* 0x62a3 */
    KANJI,        /* 0x62a4 */
    KANJI,        /* 0x62a5 */
    KANJI,        /* 0x62a6 */
    KANJI,        /* 0x62a7 */
    KANJI,        /* 0x62a8 */
    KANJI,        /* 0x62a9 */
    KANJI,        /* 0x62aa */
    KANJI,        /* 0x62ab */
    KANJI,        /* 0x62ac */
    KANJI,        /* 0x62ad */
    KANJI,        /* 0x62ae */
    KANJI,        /* 0x62af */
    KANJI,        /* 0x62b0 */
    KANJI,        /* 0x62b1 */
    KANJI,        /* 0x62b2 */
    KANJI,        /* 0x62b3 */
    KANJI,        /* 0x62b4 */
    KANJI,        /* 0x62b5 */
    KANJI,        /* 0x62b6 */
    KANJI,        /* 0x62b7 */
    KANJI,        /* 0x62b8 */
    KANJI,        /* 0x62b9 */
    KANJI,        /* 0x62ba */
    KANJI,        /* 0x62bb */
    KANJI,        /* 0x62bc */
    KANJI,        /* 0x62bd */
    KANJI,        /* 0x62be */
    KANJI,        /* 0x62bf */
    KANJI,        /* 0x62c0 */
    KANJI,        /* 0x62c1 */
    KANJI,        /* 0x62c2 */
    KANJI,        /* 0x62c3 */
    KANJI,        /* 0x62c4 */
    KANJI,        /* 0x62c5 */
    KANJI,        /* 0x62c6 */
    KANJI,        /* 0x62c7 */
    KANJI,        /* 0x62c8 */
    KANJI,        /* 0x62c9 */
    KANJI,        /* 0x62ca */
    KANJI,        /* 0x62cb */
    KANJI,        /* 0x62cc */
    KANJI,        /* 0x62cd */
    KANJI,        /* 0x62ce */
    KANJI,        /* 0x62cf */
    KANJI,        /* 0x62d0 */
    KANJI,        /* 0x62d1 */
    KANJI,        /* 0x62d2 */
    KANJI,        /* 0x62d3 */
    KANJI,        /* 0x62d4 */
    KANJI,        /* 0x62d5 */
    KANJI,        /* 0x62d6 */
    KANJI,        /* 0x62d7 */
    KANJI,        /* 0x62d8 */
    KANJI,        /* 0x62d9 */
    KANJI,        /* 0x62da */
    KANJI,        /* 0x62db */
    KANJI,        /* 0x62dc */
    KANJI,        /* 0x62dd */
    KANJI,        /* 0x62de */
    KANJI,        /* 0x62df */
    KANJI,        /* 0x62e0 */
    KANJI,        /* 0x62e1 */
    KANJI,        /* 0x62e2 */
    KANJI,        /* 0x62e3 */
    KANJI,        /* 0x62e4 */
    KANJI,        /* 0x62e5 */
    KANJI,        /* 0x62e6 */
    KANJI,        /* 0x62e7 */
    KANJI,        /* 0x62e8 */
    KANJI,        /* 0x62e9 */
    KANJI,        /* 0x62ea */
    KANJI,        /* 0x62eb */
    KANJI,        /* 0x62ec */
    KANJI,        /* 0x62ed */
    KANJI,        /* 0x62ee */
    KANJI,        /* 0x62ef */
    KANJI,        /* 0x62f0 */
    KANJI,        /* 0x62f1 */
    KANJI,        /* 0x62f2 */
    KANJI,        /* 0x62f3 */
    KANJI,        /* 0x62f4 */
    KANJI,        /* 0x62f5 */
    KANJI,        /* 0x62f6 */
    KANJI,        /* 0x62f7 */
    KANJI,        /* 0x62f8 */
    KANJI,        /* 0x62f9 */
    KANJI,        /* 0x62fa */
    KANJI,        /* 0x62fb */
    KANJI,        /* 0x62fc */
    KANJI,        /* 0x62fd */
    KANJI,        /* 0x62fe */
    KANJI,        /* 0x62ff */
    KANJI,        /* 0x6300 */
    KANJI,        /* 0x6301 */
    KANJI,        /* 0x6302 */
    KANJI,        /* 0x6303 */
    KANJI,        /* 0x6304 */
    KANJI,        /* 0x6305 */
    KANJI,        /* 0x6306 */
    KANJI,        /* 0x6307 */
    KANJI,        /* 0x6308 */
    KANJI,        /* 0x6309 */
    KANJI,        /* 0x630a */
    KANJI,        /* 0x630b */
    KANJI,        /* 0x630c */
    KANJI,        /* 0x630d */
    KANJI,        /* 0x630e */
    KANJI,        /* 0x630f */
    KANJI,        /* 0x6310 */
    KANJI,        /* 0x6311 */
    KANJI,        /* 0x6312 */
    KANJI,        /* 0x6313 */
    KANJI,        /* 0x6314 */
    KANJI,        /* 0x6315 */
    KANJI,        /* 0x6316 */
    KANJI,        /* 0x6317 */
    KANJI,        /* 0x6318 */
    KANJI,        /* 0x6319 */
    KANJI,        /* 0x631a */
    KANJI,        /* 0x631b */
    KANJI,        /* 0x631c */
    KANJI,        /* 0x631d */
    KANJI,        /* 0x631e */
    KANJI,        /* 0x631f */
    KANJI,        /* 0x6320 */
    KANJI,        /* 0x6321 */
    KANJI,        /* 0x6322 */
    KANJI,        /* 0x6323 */
    KANJI,        /* 0x6324 */
    KANJI,        /* 0x6325 */
    KANJI,        /* 0x6326 */
    KANJI,        /* 0x6327 */
    KANJI,        /* 0x6328 */
    KANJI,        /* 0x6329 */
    KANJI,        /* 0x632a */
    KANJI,        /* 0x632b */
    KANJI,        /* 0x632c */
    KANJI,        /* 0x632d */
    KANJI,        /* 0x632e */
    KANJI,        /* 0x632f */
    KANJI,        /* 0x6330 */
    KANJI,        /* 0x6331 */
    KANJI,        /* 0x6332 */
    KANJI,        /* 0x6333 */
    KANJI,        /* 0x6334 */
    KANJI,        /* 0x6335 */
    KANJI,        /* 0x6336 */
    KANJI,        /* 0x6337 */
    KANJI,        /* 0x6338 */
    KANJI,        /* 0x6339 */
    KANJI,        /* 0x633a */
    KANJI,        /* 0x633b */
    KANJI,        /* 0x633c */
    KANJI,        /* 0x633d */
    KANJI,        /* 0x633e */
    KANJI,        /* 0x633f */
    KANJI,        /* 0x6340 */
    KANJI,        /* 0x6341 */
    KANJI,        /* 0x6342 */
    KANJI,        /* 0x6343 */
    KANJI,        /* 0x6344 */
    KANJI,        /* 0x6345 */
    KANJI,        /* 0x6346 */
    KANJI,        /* 0x6347 */
    KANJI,        /* 0x6348 */
    KANJI,        /* 0x6349 */
    KANJI,        /* 0x634a */
    KANJI,        /* 0x634b */
    KANJI,        /* 0x634c */
    KANJI,        /* 0x634d */
    KANJI,        /* 0x634e */
    KANJI,        /* 0x634f */
    KANJI,        /* 0x6350 */
    KANJI,        /* 0x6351 */
    KANJI,        /* 0x6352 */
    KANJI,        /* 0x6353 */
    KANJI,        /* 0x6354 */
    KANJI,        /* 0x6355 */
    KANJI,        /* 0x6356 */
    KANJI,        /* 0x6357 */
    KANJI,        /* 0x6358 */
    KANJI,        /* 0x6359 */
    KANJI,        /* 0x635a */
    KANJI,        /* 0x635b */
    KANJI,        /* 0x635c */
    KANJI,        /* 0x635d */
    KANJI,        /* 0x635e */
    KANJI,        /* 0x635f */
    KANJI,        /* 0x6360 */
    KANJI,        /* 0x6361 */
    KANJI,        /* 0x6362 */
    KANJI,        /* 0x6363 */
    KANJI,        /* 0x6364 */
    KANJI,        /* 0x6365 */
    KANJI,        /* 0x6366 */
    KANJI,        /* 0x6367 */
    KANJI,        /* 0x6368 */
    KANJI,        /* 0x6369 */
    KANJI,        /* 0x636a */
    KANJI,        /* 0x636b */
    KANJI,        /* 0x636c */
    KANJI,        /* 0x636d */
    KANJI,        /* 0x636e */
    KANJI,        /* 0x636f */
    KANJI,        /* 0x6370 */
    KANJI,        /* 0x6371 */
    KANJI,        /* 0x6372 */
    KANJI,        /* 0x6373 */
    KANJI,        /* 0x6374 */
    KANJI,        /* 0x6375 */
    KANJI,        /* 0x6376 */
    KANJI,        /* 0x6377 */
    KANJI,        /* 0x6378 */
    KANJI,        /* 0x6379 */
    KANJI,        /* 0x637a */
    KANJI,        /* 0x637b */
    KANJI,        /* 0x637c */
    KANJI,        /* 0x637d */
    KANJI,        /* 0x637e */
    KANJI,        /* 0x637f */
    KANJI,        /* 0x6380 */
    KANJI,        /* 0x6381 */
    KANJI,        /* 0x6382 */
    KANJI,        /* 0x6383 */
    KANJI,        /* 0x6384 */
    KANJI,        /* 0x6385 */
    KANJI,        /* 0x6386 */
    KANJI,        /* 0x6387 */
    KANJI,        /* 0x6388 */
    KANJI,        /* 0x6389 */
    KANJI,        /* 0x638a */
    KANJI,        /* 0x638b */
    KANJI,        /* 0x638c */
    KANJI,        /* 0x638d */
    KANJI,        /* 0x638e */
    KANJI,        /* 0x638f */
    KANJI,        /* 0x6390 */
    KANJI,        /* 0x6391 */
    KANJI,        /* 0x6392 */
    KANJI,        /* 0x6393 */
    KANJI,        /* 0x6394 */
    KANJI,        /* 0x6395 */
    KANJI,        /* 0x6396 */
    KANJI,        /* 0x6397 */
    KANJI,        /* 0x6398 */
    KANJI,        /* 0x6399 */
    KANJI,        /* 0x639a */
    KANJI,        /* 0x639b */
    KANJI,        /* 0x639c */
    KANJI,        /* 0x639d */
    KANJI,        /* 0x639e */
    KANJI,        /* 0x639f */
    KANJI,        /* 0x63a0 */
    KANJI,        /* 0x63a1 */
    KANJI,        /* 0x63a2 */
    KANJI,        /* 0x63a3 */
    KANJI,        /* 0x63a4 */
    KANJI,        /* 0x63a5 */
    KANJI,        /* 0x63a6 */
    KANJI,        /* 0x63a7 */
    KANJI,        /* 0x63a8 */
    KANJI,        /* 0x63a9 */
    KANJI,        /* 0x63aa */
    KANJI,        /* 0x63ab */
    KANJI,        /* 0x63ac */
    KANJI,        /* 0x63ad */
    KANJI,        /* 0x63ae */
    KANJI,        /* 0x63af */
    KANJI,        /* 0x63b0 */
    KANJI,        /* 0x63b1 */
    KANJI,        /* 0x63b2 */
    KANJI,        /* 0x63b3 */
    KANJI,        /* 0x63b4 */
    KANJI,        /* 0x63b5 */
    KANJI,        /* 0x63b6 */
    KANJI,        /* 0x63b7 */
    KANJI,        /* 0x63b8 */
    KANJI,        /* 0x63b9 */
    KANJI,        /* 0x63ba */
    KANJI,        /* 0x63bb */
    KANJI,        /* 0x63bc */
    KANJI,        /* 0x63bd */
    KANJI,        /* 0x63be */
    KANJI,        /* 0x63bf */
    KANJI,        /* 0x63c0 */
    KANJI,        /* 0x63c1 */
    KANJI,        /* 0x63c2 */
    KANJI,        /* 0x63c3 */
    KANJI,        /* 0x63c4 */
    KANJI,        /* 0x63c5 */
    KANJI,        /* 0x63c6 */
    KANJI,        /* 0x63c7 */
    KANJI,        /* 0x63c8 */
    KANJI,        /* 0x63c9 */
    KANJI,        /* 0x63ca */
    KANJI,        /* 0x63cb */
    KANJI,        /* 0x63cc */
    KANJI,        /* 0x63cd */
    KANJI,        /* 0x63ce */
    KANJI,        /* 0x63cf */
    KANJI,        /* 0x63d0 */
    KANJI,        /* 0x63d1 */
    KANJI,        /* 0x63d2 */
    KANJI,        /* 0x63d3 */
    KANJI,        /* 0x63d4 */
    KANJI,        /* 0x63d5 */
    KANJI,        /* 0x63d6 */
    KANJI,        /* 0x63d7 */
    KANJI,        /* 0x63d8 */
    KANJI,        /* 0x63d9 */
    KANJI,        /* 0x63da */
    KANJI,        /* 0x63db */
    KANJI,        /* 0x63dc */
    KANJI,        /* 0x63dd */
    KANJI,        /* 0x63de */
    KANJI,        /* 0x63df */
    KANJI,        /* 0x63e0 */
    KANJI,        /* 0x63e1 */
    KANJI,        /* 0x63e2 */
    KANJI,        /* 0x63e3 */
    KANJI,        /* 0x63e4 */
    KANJI,        /* 0x63e5 */
    KANJI,        /* 0x63e6 */
    KANJI,        /* 0x63e7 */
    KANJI,        /* 0x63e8 */
    KANJI,        /* 0x63e9 */
    KANJI,        /* 0x63ea */
    KANJI,        /* 0x63eb */
    KANJI,        /* 0x63ec */
    KANJI,        /* 0x63ed */
    KANJI,        /* 0x63ee */
    KANJI,        /* 0x63ef */
    KANJI,        /* 0x63f0 */
    KANJI,        /* 0x63f1 */
    KANJI,        /* 0x63f2 */
    KANJI,        /* 0x63f3 */
    KANJI,        /* 0x63f4 */
    KANJI,        /* 0x63f5 */
    KANJI,        /* 0x63f6 */
    KANJI,        /* 0x63f7 */
    KANJI,        /* 0x63f8 */
    KANJI,        /* 0x63f9 */
    KANJI,        /* 0x63fa */
    KANJI,        /* 0x63fb */
    KANJI,        /* 0x63fc */
    KANJI,        /* 0x63fd */
    KANJI,        /* 0x63fe */
    KANJI,        /* 0x63ff */
    KANJI,        /* 0x6400 */
    KANJI,        /* 0x6401 */
    KANJI,        /* 0x6402 */
    KANJI,        /* 0x6403 */
    KANJI,        /* 0x6404 */
    KANJI,        /* 0x6405 */
    KANJI,        /* 0x6406 */
    KANJI,        /* 0x6407 */
    KANJI,        /* 0x6408 */
    KANJI,        /* 0x6409 */
    KANJI,        /* 0x640a */
    KANJI,        /* 0x640b */
    KANJI,        /* 0x640c */
    KANJI,        /* 0x640d */
    KANJI,        /* 0x640e */
    KANJI,        /* 0x640f */
    KANJI,        /* 0x6410 */
    KANJI,        /* 0x6411 */
    KANJI,        /* 0x6412 */
    KANJI,        /* 0x6413 */
    KANJI,        /* 0x6414 */
    KANJI,        /* 0x6415 */
    KANJI,        /* 0x6416 */
    KANJI,        /* 0x6417 */
    KANJI,        /* 0x6418 */
    KANJI,        /* 0x6419 */
    KANJI,        /* 0x641a */
    KANJI,        /* 0x641b */
    KANJI,        /* 0x641c */
    KANJI,        /* 0x641d */
    KANJI,        /* 0x641e */
    KANJI,        /* 0x641f */
    KANJI,        /* 0x6420 */
    KANJI,        /* 0x6421 */
    KANJI,        /* 0x6422 */
    KANJI,        /* 0x6423 */
    KANJI,        /* 0x6424 */
    KANJI,        /* 0x6425 */
    KANJI,        /* 0x6426 */
    KANJI,        /* 0x6427 */
    KANJI,        /* 0x6428 */
    KANJI,        /* 0x6429 */
    KANJI,        /* 0x642a */
    KANJI,        /* 0x642b */
    KANJI,        /* 0x642c */
    KANJI,        /* 0x642d */
    KANJI,        /* 0x642e */
    KANJI,        /* 0x642f */
    KANJI,        /* 0x6430 */
    KANJI,        /* 0x6431 */
    KANJI,        /* 0x6432 */
    KANJI,        /* 0x6433 */
    KANJI,        /* 0x6434 */
    KANJI,        /* 0x6435 */
    KANJI,        /* 0x6436 */
    KANJI,        /* 0x6437 */
    KANJI,        /* 0x6438 */
    KANJI,        /* 0x6439 */
    KANJI,        /* 0x643a */
    KANJI,        /* 0x643b */
    KANJI,        /* 0x643c */
    KANJI,        /* 0x643d */
    KANJI,        /* 0x643e */
    KANJI,        /* 0x643f */
    KANJI,        /* 0x6440 */
    KANJI,        /* 0x6441 */
    KANJI,        /* 0x6442 */
    KANJI,        /* 0x6443 */
    KANJI,        /* 0x6444 */
    KANJI,        /* 0x6445 */
    KANJI,        /* 0x6446 */
    KANJI,        /* 0x6447 */
    KANJI,        /* 0x6448 */
    KANJI,        /* 0x6449 */
    KANJI,        /* 0x644a */
    KANJI,        /* 0x644b */
    KANJI,        /* 0x644c */
    KANJI,        /* 0x644d */
    KANJI,        /* 0x644e */
    KANJI,        /* 0x644f */
    KANJI,        /* 0x6450 */
    KANJI,        /* 0x6451 */
    KANJI,        /* 0x6452 */
    KANJI,        /* 0x6453 */
    KANJI,        /* 0x6454 */
    KANJI,        /* 0x6455 */
    KANJI,        /* 0x6456 */
    KANJI,        /* 0x6457 */
    KANJI,        /* 0x6458 */
    KANJI,        /* 0x6459 */
    KANJI,        /* 0x645a */
    KANJI,        /* 0x645b */
    KANJI,        /* 0x645c */
    KANJI,        /* 0x645d */
    KANJI,        /* 0x645e */
    KANJI,        /* 0x645f */
    KANJI,        /* 0x6460 */
    KANJI,        /* 0x6461 */
    KANJI,        /* 0x6462 */
    KANJI,        /* 0x6463 */
    KANJI,        /* 0x6464 */
    KANJI,        /* 0x6465 */
    KANJI,        /* 0x6466 */
    KANJI,        /* 0x6467 */
    KANJI,        /* 0x6468 */
    KANJI,        /* 0x6469 */
    KANJI,        /* 0x646a */
    KANJI,        /* 0x646b */
    KANJI,        /* 0x646c */
    KANJI,        /* 0x646d */
    KANJI,        /* 0x646e */
    KANJI,        /* 0x646f */
    KANJI,        /* 0x6470 */
    KANJI,        /* 0x6471 */
    KANJI,        /* 0x6472 */
    KANJI,        /* 0x6473 */
    KANJI,        /* 0x6474 */
    KANJI,        /* 0x6475 */
    KANJI,        /* 0x6476 */
    KANJI,        /* 0x6477 */
    KANJI,        /* 0x6478 */
    KANJI,        /* 0x6479 */
    KANJI,        /* 0x647a */
    KANJI,        /* 0x647b */
    KANJI,        /* 0x647c */
    KANJI,        /* 0x647d */
    KANJI,        /* 0x647e */
    KANJI,        /* 0x647f */
    KANJI,        /* 0x6480 */
    KANJI,        /* 0x6481 */
    KANJI,        /* 0x6482 */
    KANJI,        /* 0x6483 */
    KANJI,        /* 0x6484 */
    KANJI,        /* 0x6485 */
    KANJI,        /* 0x6486 */
    KANJI,        /* 0x6487 */
    KANJI,        /* 0x6488 */
    KANJI,        /* 0x6489 */
    KANJI,        /* 0x648a */
    KANJI,        /* 0x648b */
    KANJI,        /* 0x648c */
    KANJI,        /* 0x648d */
    KANJI,        /* 0x648e */
    KANJI,        /* 0x648f */
    KANJI,        /* 0x6490 */
    KANJI,        /* 0x6491 */
    KANJI,        /* 0x6492 */
    KANJI,        /* 0x6493 */
    KANJI,        /* 0x6494 */
    KANJI,        /* 0x6495 */
    KANJI,        /* 0x6496 */
    KANJI,        /* 0x6497 */
    KANJI,        /* 0x6498 */
    KANJI,        /* 0x6499 */
    KANJI,        /* 0x649a */
    KANJI,        /* 0x649b */
    KANJI,        /* 0x649c */
    KANJI,        /* 0x649d */
    KANJI,        /* 0x649e */
    KANJI,        /* 0x649f */
    KANJI,        /* 0x64a0 */
    KANJI,        /* 0x64a1 */
    KANJI,        /* 0x64a2 */
    KANJI,        /* 0x64a3 */
    KANJI,        /* 0x64a4 */
    KANJI,        /* 0x64a5 */
    KANJI,        /* 0x64a6 */
    KANJI,        /* 0x64a7 */
    KANJI,        /* 0x64a8 */
    KANJI,        /* 0x64a9 */
    KANJI,        /* 0x64aa */
    KANJI,        /* 0x64ab */
    KANJI,        /* 0x64ac */
    KANJI,        /* 0x64ad */
    KANJI,        /* 0x64ae */
    KANJI,        /* 0x64af */
    KANJI,        /* 0x64b0 */
    KANJI,        /* 0x64b1 */
    KANJI,        /* 0x64b2 */
    KANJI,        /* 0x64b3 */
    KANJI,        /* 0x64b4 */
    KANJI,        /* 0x64b5 */
    KANJI,        /* 0x64b6 */
    KANJI,        /* 0x64b7 */
    KANJI,        /* 0x64b8 */
    KANJI,        /* 0x64b9 */
    KANJI,        /* 0x64ba */
    KANJI,        /* 0x64bb */
    KANJI,        /* 0x64bc */
    KANJI,        /* 0x64bd */
    KANJI,        /* 0x64be */
    KANJI,        /* 0x64bf */
    KANJI,        /* 0x64c0 */
    KANJI,        /* 0x64c1 */
    KANJI,        /* 0x64c2 */
    KANJI,        /* 0x64c3 */
    KANJI,        /* 0x64c4 */
    KANJI,        /* 0x64c5 */
    KANJI,        /* 0x64c6 */
    KANJI,        /* 0x64c7 */
    KANJI,        /* 0x64c8 */
    KANJI,        /* 0x64c9 */
    KANJI,        /* 0x64ca */
    KANJI,        /* 0x64cb */
    KANJI,        /* 0x64cc */
    KANJI,        /* 0x64cd */
    KANJI,        /* 0x64ce */
    KANJI,        /* 0x64cf */
    KANJI,        /* 0x64d0 */
    KANJI,        /* 0x64d1 */
    KANJI,        /* 0x64d2 */
    KANJI,        /* 0x64d3 */
    KANJI,        /* 0x64d4 */
    KANJI,        /* 0x64d5 */
    KANJI,        /* 0x64d6 */
    KANJI,        /* 0x64d7 */
    KANJI,        /* 0x64d8 */
    KANJI,        /* 0x64d9 */
    KANJI,        /* 0x64da */
    KANJI,        /* 0x64db */
    KANJI,        /* 0x64dc */
    KANJI,        /* 0x64dd */
    KANJI,        /* 0x64de */
    KANJI,        /* 0x64df */
    KANJI,        /* 0x64e0 */
    KANJI,        /* 0x64e1 */
    KANJI,        /* 0x64e2 */
    KANJI,        /* 0x64e3 */
    KANJI,        /* 0x64e4 */
    KANJI,        /* 0x64e5 */
    KANJI,        /* 0x64e6 */
    KANJI,        /* 0x64e7 */
    KANJI,        /* 0x64e8 */
    KANJI,        /* 0x64e9 */
    KANJI,        /* 0x64ea */
    KANJI,        /* 0x64eb */
    KANJI,        /* 0x64ec */
    KANJI,        /* 0x64ed */
    KANJI,        /* 0x64ee */
    KANJI,        /* 0x64ef */
    KANJI,        /* 0x64f0 */
    KANJI,        /* 0x64f1 */
    KANJI,        /* 0x64f2 */
    KANJI,        /* 0x64f3 */
    KANJI,        /* 0x64f4 */
    KANJI,        /* 0x64f5 */
    KANJI,        /* 0x64f6 */
    KANJI,        /* 0x64f7 */
    KANJI,        /* 0x64f8 */
    KANJI,        /* 0x64f9 */
    KANJI,        /* 0x64fa */
    KANJI,        /* 0x64fb */
    KANJI,        /* 0x64fc */
    KANJI,        /* 0x64fd */
    KANJI,        /* 0x64fe */
    KANJI,        /* 0x64ff */
    KANJI,        /* 0x6500 */
    KANJI,        /* 0x6501 */
    KANJI,        /* 0x6502 */
    KANJI,        /* 0x6503 */
    KANJI,        /* 0x6504 */
    KANJI,        /* 0x6505 */
    KANJI,        /* 0x6506 */
    KANJI,        /* 0x6507 */
    KANJI,        /* 0x6508 */
    KANJI,        /* 0x6509 */
    KANJI,        /* 0x650a */
    KANJI,        /* 0x650b */
    KANJI,        /* 0x650c */
    KANJI,        /* 0x650d */
    KANJI,        /* 0x650e */
    KANJI,        /* 0x650f */
    KANJI,        /* 0x6510 */
    KANJI,        /* 0x6511 */
    KANJI,        /* 0x6512 */
    KANJI,        /* 0x6513 */
    KANJI,        /* 0x6514 */
    KANJI,        /* 0x6515 */
    KANJI,        /* 0x6516 */
    KANJI,        /* 0x6517 */
    KANJI,        /* 0x6518 */
    KANJI,        /* 0x6519 */
    KANJI,        /* 0x651a */
    KANJI,        /* 0x651b */
    KANJI,        /* 0x651c */
    KANJI,        /* 0x651d */
    KANJI,        /* 0x651e */
    KANJI,        /* 0x651f */
    KANJI,        /* 0x6520 */
    KANJI,        /* 0x6521 */
    KANJI,        /* 0x6522 */
    KANJI,        /* 0x6523 */
    KANJI,        /* 0x6524 */
    KANJI,        /* 0x6525 */
    KANJI,        /* 0x6526 */
    KANJI,        /* 0x6527 */
    KANJI,        /* 0x6528 */
    KANJI,        /* 0x6529 */
    KANJI,        /* 0x652a */
    KANJI,        /* 0x652b */
    KANJI,        /* 0x652c */
    KANJI,        /* 0x652d */
    KANJI,        /* 0x652e */
    KANJI,        /* 0x652f */
    KANJI,        /* 0x6530 */
    KANJI,        /* 0x6531 */
    KANJI,        /* 0x6532 */
    KANJI,        /* 0x6533 */
    KANJI,        /* 0x6534 */
    KANJI,        /* 0x6535 */
    KANJI,        /* 0x6536 */
    KANJI,        /* 0x6537 */
    KANJI,        /* 0x6538 */
    KANJI,        /* 0x6539 */
    KANJI,        /* 0x653a */
    KANJI,        /* 0x653b */
    KANJI,        /* 0x653c */
    KANJI,        /* 0x653d */
    KANJI,        /* 0x653e */
    KANJI,        /* 0x653f */
    KANJI,        /* 0x6540 */
    KANJI,        /* 0x6541 */
    KANJI,        /* 0x6542 */
    KANJI,        /* 0x6543 */
    KANJI,        /* 0x6544 */
    KANJI,        /* 0x6545 */
    KANJI,        /* 0x6546 */
    KANJI,        /* 0x6547 */
    KANJI,        /* 0x6548 */
    KANJI,        /* 0x6549 */
    KANJI,        /* 0x654a */
    KANJI,        /* 0x654b */
    KANJI,        /* 0x654c */
    KANJI,        /* 0x654d */
    KANJI,        /* 0x654e */
    KANJI,        /* 0x654f */
    KANJI,        /* 0x6550 */
    KANJI,        /* 0x6551 */
    KANJI,        /* 0x6552 */
    KANJI,        /* 0x6553 */
    KANJI,        /* 0x6554 */
    KANJI,        /* 0x6555 */
    KANJI,        /* 0x6556 */
    KANJI,        /* 0x6557 */
    KANJI,        /* 0x6558 */
    KANJI,        /* 0x6559 */
    KANJI,        /* 0x655a */
    KANJI,        /* 0x655b */
    KANJI,        /* 0x655c */
    KANJI,        /* 0x655d */
    KANJI,        /* 0x655e */
    KANJI,        /* 0x655f */
    KANJI,        /* 0x6560 */
    KANJI,        /* 0x6561 */
    KANJI,        /* 0x6562 */
    KANJI,        /* 0x6563 */
    KANJI,        /* 0x6564 */
    KANJI,        /* 0x6565 */
    KANJI,        /* 0x6566 */
    KANJI,        /* 0x6567 */
    KANJI,        /* 0x6568 */
    KANJI,        /* 0x6569 */
    KANJI,        /* 0x656a */
    KANJI,        /* 0x656b */
    KANJI,        /* 0x656c */
    KANJI,        /* 0x656d */
    KANJI,        /* 0x656e */
    KANJI,        /* 0x656f */
    KANJI,        /* 0x6570 */
    KANJI,        /* 0x6571 */
    KANJI,        /* 0x6572 */
    KANJI,        /* 0x6573 */
    KANJI,        /* 0x6574 */
    KANJI,        /* 0x6575 */
    KANJI,        /* 0x6576 */
    KANJI,        /* 0x6577 */
    KANJI,        /* 0x6578 */
    KANJI,        /* 0x6579 */
    KANJI,        /* 0x657a */
    KANJI,        /* 0x657b */
    KANJI,        /* 0x657c */
    KANJI,        /* 0x657d */
    KANJI,        /* 0x657e */
    KANJI,        /* 0x657f */
    KANJI,        /* 0x6580 */
    KANJI,        /* 0x6581 */
    KANJI,        /* 0x6582 */
    KANJI,        /* 0x6583 */
    KANJI,        /* 0x6584 */
    KANJI,        /* 0x6585 */
    KANJI,        /* 0x6586 */
    KANJI,        /* 0x6587 */
    KANJI,        /* 0x6588 */
    KANJI,        /* 0x6589 */
    KANJI,        /* 0x658a */
    KANJI,        /* 0x658b */
    KANJI,        /* 0x658c */
    KANJI,        /* 0x658d */
    KANJI,        /* 0x658e */
    KANJI,        /* 0x658f */
    KANJI,        /* 0x6590 */
    KANJI,        /* 0x6591 */
    KANJI,        /* 0x6592 */
    KANJI,        /* 0x6593 */
    KANJI,        /* 0x6594 */
    KANJI,        /* 0x6595 */
    KANJI,        /* 0x6596 */
    KANJI,        /* 0x6597 */
    KANJI,        /* 0x6598 */
    KANJI,        /* 0x6599 */
    KANJI,        /* 0x659a */
    KANJI,        /* 0x659b */
    KANJI,        /* 0x659c */
    KANJI,        /* 0x659d */
    KANJI,        /* 0x659e */
    KANJI,        /* 0x659f */
    KANJI,        /* 0x65a0 */
    KANJI,        /* 0x65a1 */
    KANJI,        /* 0x65a2 */
    KANJI,        /* 0x65a3 */
    KANJI,        /* 0x65a4 */
    KANJI,        /* 0x65a5 */
    KANJI,        /* 0x65a6 */
    KANJI,        /* 0x65a7 */
    KANJI,        /* 0x65a8 */
    KANJI,        /* 0x65a9 */
    KANJI,        /* 0x65aa */
    KANJI,        /* 0x65ab */
    KANJI,        /* 0x65ac */
    KANJI,        /* 0x65ad */
    KANJI,        /* 0x65ae */
    KANJI,        /* 0x65af */
    KANJI,        /* 0x65b0 */
    KANJI,        /* 0x65b1 */
    KANJI,        /* 0x65b2 */
    KANJI,        /* 0x65b3 */
    KANJI,        /* 0x65b4 */
    KANJI,        /* 0x65b5 */
    KANJI,        /* 0x65b6 */
    KANJI,        /* 0x65b7 */
    KANJI,        /* 0x65b8 */
    KANJI,        /* 0x65b9 */
    KANJI,        /* 0x65ba */
    KANJI,        /* 0x65bb */
    KANJI,        /* 0x65bc */
    KANJI,        /* 0x65bd */
    KANJI,        /* 0x65be */
    KANJI,        /* 0x65bf */
    KANJI,        /* 0x65c0 */
    KANJI,        /* 0x65c1 */
    KANJI,        /* 0x65c2 */
    KANJI,        /* 0x65c3 */
    KANJI,        /* 0x65c4 */
    KANJI,        /* 0x65c5 */
    KANJI,        /* 0x65c6 */
    KANJI,        /* 0x65c7 */
    KANJI,        /* 0x65c8 */
    KANJI,        /* 0x65c9 */
    KANJI,        /* 0x65ca */
    KANJI,        /* 0x65cb */
    KANJI,        /* 0x65cc */
    KANJI,        /* 0x65cd */
    KANJI,        /* 0x65ce */
    KANJI,        /* 0x65cf */
    KANJI,        /* 0x65d0 */
    KANJI,        /* 0x65d1 */
    KANJI,        /* 0x65d2 */
    KANJI,        /* 0x65d3 */
    KANJI,        /* 0x65d4 */
    KANJI,        /* 0x65d5 */
    KANJI,        /* 0x65d6 */
    KANJI,        /* 0x65d7 */
    KANJI,        /* 0x65d8 */
    KANJI,        /* 0x65d9 */
    KANJI,        /* 0x65da */
    KANJI,        /* 0x65db */
    KANJI,        /* 0x65dc */
    KANJI,        /* 0x65dd */
    KANJI,        /* 0x65de */
    KANJI,        /* 0x65df */
    KANJI,        /* 0x65e0 */
    KANJI,        /* 0x65e1 */
    KANJI,        /* 0x65e2 */
    KANJI,        /* 0x65e3 */
    KANJI,        /* 0x65e4 */
    KANJI,        /* 0x65e5 */
    KANJI,        /* 0x65e6 */
    KANJI,        /* 0x65e7 */
    KANJI,        /* 0x65e8 */
    KANJI,        /* 0x65e9 */
    KANJI,        /* 0x65ea */
    KANJI,        /* 0x65eb */
    KANJI,        /* 0x65ec */
    KANJI,        /* 0x65ed */
    KANJI,        /* 0x65ee */
    KANJI,        /* 0x65ef */
    KANJI,        /* 0x65f0 */
    KANJI,        /* 0x65f1 */
    KANJI,        /* 0x65f2 */
    KANJI,        /* 0x65f3 */
    KANJI,        /* 0x65f4 */
    KANJI,        /* 0x65f5 */
    KANJI,        /* 0x65f6 */
    KANJI,        /* 0x65f7 */
    KANJI,        /* 0x65f8 */
    KANJI,        /* 0x65f9 */
    KANJI,        /* 0x65fa */
    KANJI,        /* 0x65fb */
    KANJI,        /* 0x65fc */
    KANJI,        /* 0x65fd */
    KANJI,        /* 0x65fe */
    KANJI,        /* 0x65ff */
    KANJI,        /* 0x6600 */
    KANJI,        /* 0x6601 */
    KANJI,        /* 0x6602 */
    KANJI,        /* 0x6603 */
    KANJI,        /* 0x6604 */
    KANJI,        /* 0x6605 */
    KANJI,        /* 0x6606 */
    KANJI,        /* 0x6607 */
    KANJI,        /* 0x6608 */
    KANJI,        /* 0x6609 */
    KANJI,        /* 0x660a */
    KANJI,        /* 0x660b */
    KANJI,        /* 0x660c */
    KANJI,        /* 0x660d */
    KANJI,        /* 0x660e */
    KANJI,        /* 0x660f */
    KANJI,        /* 0x6610 */
    KANJI,        /* 0x6611 */
    KANJI,        /* 0x6612 */
    KANJI,        /* 0x6613 */
    KANJI,        /* 0x6614 */
    KANJI,        /* 0x6615 */
    KANJI,        /* 0x6616 */
    KANJI,        /* 0x6617 */
    KANJI,        /* 0x6618 */
    KANJI,        /* 0x6619 */
    KANJI,        /* 0x661a */
    KANJI,        /* 0x661b */
    KANJI,        /* 0x661c */
    KANJI,        /* 0x661d */
    KANJI,        /* 0x661e */
    KANJI,        /* 0x661f */
    KANJI,        /* 0x6620 */
    KANJI,        /* 0x6621 */
    KANJI,        /* 0x6622 */
    KANJI,        /* 0x6623 */
    KANJI,        /* 0x6624 */
    KANJI,        /* 0x6625 */
    KANJI,        /* 0x6626 */
    KANJI,        /* 0x6627 */
    KANJI,        /* 0x6628 */
    KANJI,        /* 0x6629 */
    KANJI,        /* 0x662a */
    KANJI,        /* 0x662b */
    KANJI,        /* 0x662c */
    KANJI,        /* 0x662d */
    KANJI,        /* 0x662e */
    KANJI,        /* 0x662f */
    KANJI,        /* 0x6630 */
    KANJI,        /* 0x6631 */
    KANJI,        /* 0x6632 */
    KANJI,        /* 0x6633 */
    KANJI,        /* 0x6634 */
    KANJI,        /* 0x6635 */
    KANJI,        /* 0x6636 */
    KANJI,        /* 0x6637 */
    KANJI,        /* 0x6638 */
    KANJI,        /* 0x6639 */
    KANJI,        /* 0x663a */
    KANJI,        /* 0x663b */
    KANJI,        /* 0x663c */
    KANJI,        /* 0x663d */
    KANJI,        /* 0x663e */
    KANJI,        /* 0x663f */
    KANJI,        /* 0x6640 */
    KANJI,        /* 0x6641 */
    KANJI,        /* 0x6642 */
    KANJI,        /* 0x6643 */
    KANJI,        /* 0x6644 */
    KANJI,        /* 0x6645 */
    KANJI,        /* 0x6646 */
    KANJI,        /* 0x6647 */
    KANJI,        /* 0x6648 */
    KANJI,        /* 0x6649 */
    KANJI,        /* 0x664a */
    KANJI,        /* 0x664b */
    KANJI,        /* 0x664c */
    KANJI,        /* 0x664d */
    KANJI,        /* 0x664e */
    KANJI,        /* 0x664f */
    KANJI,        /* 0x6650 */
    KANJI,        /* 0x6651 */
    KANJI,        /* 0x6652 */
    KANJI,        /* 0x6653 */
    KANJI,        /* 0x6654 */
    KANJI,        /* 0x6655 */
    KANJI,        /* 0x6656 */
    KANJI,        /* 0x6657 */
    KANJI,        /* 0x6658 */
    KANJI,        /* 0x6659 */
    KANJI,        /* 0x665a */
    KANJI,        /* 0x665b */
    KANJI,        /* 0x665c */
    KANJI,        /* 0x665d */
    KANJI,        /* 0x665e */
    KANJI,        /* 0x665f */
    KANJI,        /* 0x6660 */
    KANJI,        /* 0x6661 */
    KANJI,        /* 0x6662 */
    KANJI,        /* 0x6663 */
    KANJI,        /* 0x6664 */
    KANJI,        /* 0x6665 */
    KANJI,        /* 0x6666 */
    KANJI,        /* 0x6667 */
    KANJI,        /* 0x6668 */
    KANJI,        /* 0x6669 */
    KANJI,        /* 0x666a */
    KANJI,        /* 0x666b */
    KANJI,        /* 0x666c */
    KANJI,        /* 0x666d */
    KANJI,        /* 0x666e */
    KANJI,        /* 0x666f */
    KANJI,        /* 0x6670 */
    KANJI,        /* 0x6671 */
    KANJI,        /* 0x6672 */
    KANJI,        /* 0x6673 */
    KANJI,        /* 0x6674 */
    KANJI,        /* 0x6675 */
    KANJI,        /* 0x6676 */
    KANJI,        /* 0x6677 */
    KANJI,        /* 0x6678 */
    KANJI,        /* 0x6679 */
    KANJI,        /* 0x667a */
    KANJI,        /* 0x667b */
    KANJI,        /* 0x667c */
    KANJI,        /* 0x667d */
    KANJI,        /* 0x667e */
    KANJI,        /* 0x667f */
    KANJI,        /* 0x6680 */
    KANJI,        /* 0x6681 */
    KANJI,        /* 0x6682 */
    KANJI,        /* 0x6683 */
    KANJI,        /* 0x6684 */
    KANJI,        /* 0x6685 */
    KANJI,        /* 0x6686 */
    KANJI,        /* 0x6687 */
    KANJI,        /* 0x6688 */
    KANJI,        /* 0x6689 */
    KANJI,        /* 0x668a */
    KANJI,        /* 0x668b */
    KANJI,        /* 0x668c */
    KANJI,        /* 0x668d */
    KANJI,        /* 0x668e */
    KANJI,        /* 0x668f */
    KANJI,        /* 0x6690 */
    KANJI,        /* 0x6691 */
    KANJI,        /* 0x6692 */
    KANJI,        /* 0x6693 */
    KANJI,        /* 0x6694 */
    KANJI,        /* 0x6695 */
    KANJI,        /* 0x6696 */
    KANJI,        /* 0x6697 */
    KANJI,        /* 0x6698 */
    KANJI,        /* 0x6699 */
    KANJI,        /* 0x669a */
    KANJI,        /* 0x669b */
    KANJI,        /* 0x669c */
    KANJI,        /* 0x669d */
    KANJI,        /* 0x669e */
    KANJI,        /* 0x669f */
    KANJI,        /* 0x66a0 */
    KANJI,        /* 0x66a1 */
    KANJI,        /* 0x66a2 */
    KANJI,        /* 0x66a3 */
    KANJI,        /* 0x66a4 */
    KANJI,        /* 0x66a5 */
    KANJI,        /* 0x66a6 */
    KANJI,        /* 0x66a7 */
    KANJI,        /* 0x66a8 */
    KANJI,        /* 0x66a9 */
    KANJI,        /* 0x66aa */
    KANJI,        /* 0x66ab */
    KANJI,        /* 0x66ac */
    KANJI,        /* 0x66ad */
    KANJI,        /* 0x66ae */
    KANJI,        /* 0x66af */
    KANJI,        /* 0x66b0 */
    KANJI,        /* 0x66b1 */
    KANJI,        /* 0x66b2 */
    KANJI,        /* 0x66b3 */
    KANJI,        /* 0x66b4 */
    KANJI,        /* 0x66b5 */
    KANJI,        /* 0x66b6 */
    KANJI,        /* 0x66b7 */
    KANJI,        /* 0x66b8 */
    KANJI,        /* 0x66b9 */
    KANJI,        /* 0x66ba */
    KANJI,        /* 0x66bb */
    KANJI,        /* 0x66bc */
    KANJI,        /* 0x66bd */
    KANJI,        /* 0x66be */
    KANJI,        /* 0x66bf */
    KANJI,        /* 0x66c0 */
    KANJI,        /* 0x66c1 */
    KANJI,        /* 0x66c2 */
    KANJI,        /* 0x66c3 */
    KANJI,        /* 0x66c4 */
    KANJI,        /* 0x66c5 */
    KANJI,        /* 0x66c6 */
    KANJI,        /* 0x66c7 */
    KANJI,        /* 0x66c8 */
    KANJI,        /* 0x66c9 */
    KANJI,        /* 0x66ca */
    KANJI,        /* 0x66cb */
    KANJI,        /* 0x66cc */
    KANJI,        /* 0x66cd */
    KANJI,        /* 0x66ce */
    KANJI,        /* 0x66cf */
    KANJI,        /* 0x66d0 */
    KANJI,        /* 0x66d1 */
    KANJI,        /* 0x66d2 */
    KANJI,        /* 0x66d3 */
    KANJI,        /* 0x66d4 */
    KANJI,        /* 0x66d5 */
    KANJI,        /* 0x66d6 */
    KANJI,        /* 0x66d7 */
    KANJI,        /* 0x66d8 */
    KANJI,        /* 0x66d9 */
    KANJI,        /* 0x66da */
    KANJI,        /* 0x66db */
    KANJI,        /* 0x66dc */
    KANJI,        /* 0x66dd */
    KANJI,        /* 0x66de */
    KANJI,        /* 0x66df */
    KANJI,        /* 0x66e0 */
    KANJI,        /* 0x66e1 */
    KANJI,        /* 0x66e2 */
    KANJI,        /* 0x66e3 */
    KANJI,        /* 0x66e4 */
    KANJI,        /* 0x66e5 */
    KANJI,        /* 0x66e6 */
    KANJI,        /* 0x66e7 */
    KANJI,        /* 0x66e8 */
    KANJI,        /* 0x66e9 */
    KANJI,        /* 0x66ea */
    KANJI,        /* 0x66eb */
    KANJI,        /* 0x66ec */
    KANJI,        /* 0x66ed */
    KANJI,        /* 0x66ee */
    KANJI,        /* 0x66ef */
    KANJI,        /* 0x66f0 */
    KANJI,        /* 0x66f1 */
    KANJI,        /* 0x66f2 */
    KANJI,        /* 0x66f3 */
    KANJI,        /* 0x66f4 */
    KANJI,        /* 0x66f5 */
    KANJI,        /* 0x66f6 */
    KANJI,        /* 0x66f7 */
    KANJI,        /* 0x66f8 */
    KANJI,        /* 0x66f9 */
    KANJI,        /* 0x66fa */
    KANJI,        /* 0x66fb */
    KANJI,        /* 0x66fc */
    KANJI,        /* 0x66fd */
    KANJI,        /* 0x66fe */
    KANJI,        /* 0x66ff */
    KANJI,        /* 0x6700 */
    KANJI,        /* 0x6701 */
    KANJI,        /* 0x6702 */
    KANJI,        /* 0x6703 */
    KANJI,        /* 0x6704 */
    KANJI,        /* 0x6705 */
    KANJI,        /* 0x6706 */
    KANJI,        /* 0x6707 */
    KANJI,        /* 0x6708 */
    KANJI,        /* 0x6709 */
    KANJI,        /* 0x670a */
    KANJI,        /* 0x670b */
    KANJI,        /* 0x670c */
    KANJI,        /* 0x670d */
    KANJI,        /* 0x670e */
    KANJI,        /* 0x670f */
    KANJI,        /* 0x6710 */
    KANJI,        /* 0x6711 */
    KANJI,        /* 0x6712 */
    KANJI,        /* 0x6713 */
    KANJI,        /* 0x6714 */
    KANJI,        /* 0x6715 */
    KANJI,        /* 0x6716 */
    KANJI,        /* 0x6717 */
    KANJI,        /* 0x6718 */
    KANJI,        /* 0x6719 */
    KANJI,        /* 0x671a */
    KANJI,        /* 0x671b */
    KANJI,        /* 0x671c */
    KANJI,        /* 0x671d */
    KANJI,        /* 0x671e */
    KANJI,        /* 0x671f */
    KANJI,        /* 0x6720 */
    KANJI,        /* 0x6721 */
    KANJI,        /* 0x6722 */
    KANJI,        /* 0x6723 */
    KANJI,        /* 0x6724 */
    KANJI,        /* 0x6725 */
    KANJI,        /* 0x6726 */
    KANJI,        /* 0x6727 */
    KANJI,        /* 0x6728 */
    KANJI,        /* 0x6729 */
    KANJI,        /* 0x672a */
    KANJI,        /* 0x672b */
    KANJI,        /* 0x672c */
    KANJI,        /* 0x672d */
    KANJI,        /* 0x672e */
    KANJI,        /* 0x672f */
    KANJI,        /* 0x6730 */
    KANJI,        /* 0x6731 */
    KANJI,        /* 0x6732 */
    KANJI,        /* 0x6733 */
    KANJI,        /* 0x6734 */
    KANJI,        /* 0x6735 */
    KANJI,        /* 0x6736 */
    KANJI,        /* 0x6737 */
    KANJI,        /* 0x6738 */
    KANJI,        /* 0x6739 */
    KANJI,        /* 0x673a */
    KANJI,        /* 0x673b */
    KANJI,        /* 0x673c */
    KANJI,        /* 0x673d */
    KANJI,        /* 0x673e */
    KANJI,        /* 0x673f */
    KANJI,        /* 0x6740 */
    KANJI,        /* 0x6741 */
    KANJI,        /* 0x6742 */
    KANJI,        /* 0x6743 */
    KANJI,        /* 0x6744 */
    KANJI,        /* 0x6745 */
    KANJI,        /* 0x6746 */
    KANJI,        /* 0x6747 */
    KANJI,        /* 0x6748 */
    KANJI,        /* 0x6749 */
    KANJI,        /* 0x674a */
    KANJI,        /* 0x674b */
    KANJI,        /* 0x674c */
    KANJI,        /* 0x674d */
    KANJI,        /* 0x674e */
    KANJI,        /* 0x674f */
    KANJI,        /* 0x6750 */
    KANJI,        /* 0x6751 */
    KANJI,        /* 0x6752 */
    KANJI,        /* 0x6753 */
    KANJI,        /* 0x6754 */
    KANJI,        /* 0x6755 */
    KANJI,        /* 0x6756 */
    KANJI,        /* 0x6757 */
    KANJI,        /* 0x6758 */
    KANJI,        /* 0x6759 */
    KANJI,        /* 0x675a */
    KANJI,        /* 0x675b */
    KANJI,        /* 0x675c */
    KANJI,        /* 0x675d */
    KANJI,        /* 0x675e */
    KANJI,        /* 0x675f */
    KANJI,        /* 0x6760 */
    KANJI,        /* 0x6761 */
    KANJI,        /* 0x6762 */
    KANJI,        /* 0x6763 */
    KANJI,        /* 0x6764 */
    KANJI,        /* 0x6765 */
    KANJI,        /* 0x6766 */
    KANJI,        /* 0x6767 */
    KANJI,        /* 0x6768 */
    KANJI,        /* 0x6769 */
    KANJI,        /* 0x676a */
    KANJI,        /* 0x676b */
    KANJI,        /* 0x676c */
    KANJI,        /* 0x676d */
    KANJI,        /* 0x676e */
    KANJI,        /* 0x676f */
    KANJI,        /* 0x6770 */
    KANJI,        /* 0x6771 */
    KANJI,        /* 0x6772 */
    KANJI,        /* 0x6773 */
    KANJI,        /* 0x6774 */
    KANJI,        /* 0x6775 */
    KANJI,        /* 0x6776 */
    KANJI,        /* 0x6777 */
    KANJI,        /* 0x6778 */
    KANJI,        /* 0x6779 */
    KANJI,        /* 0x677a */
    KANJI,        /* 0x677b */
    KANJI,        /* 0x677c */
    KANJI,        /* 0x677d */
    KANJI,        /* 0x677e */
    KANJI,        /* 0x677f */
    KANJI,        /* 0x6780 */
    KANJI,        /* 0x6781 */
    KANJI,        /* 0x6782 */
    KANJI,        /* 0x6783 */
    KANJI,        /* 0x6784 */
    KANJI,        /* 0x6785 */
    KANJI,        /* 0x6786 */
    KANJI,        /* 0x6787 */
    KANJI,        /* 0x6788 */
    KANJI,        /* 0x6789 */
    KANJI,        /* 0x678a */
    KANJI,        /* 0x678b */
    KANJI,        /* 0x678c */
    KANJI,        /* 0x678d */
    KANJI,        /* 0x678e */
    KANJI,        /* 0x678f */
    KANJI,        /* 0x6790 */
    KANJI,        /* 0x6791 */
    KANJI,        /* 0x6792 */
    KANJI,        /* 0x6793 */
    KANJI,        /* 0x6794 */
    KANJI,        /* 0x6795 */
    KANJI,        /* 0x6796 */
    KANJI,        /* 0x6797 */
    KANJI,        /* 0x6798 */
    KANJI,        /* 0x6799 */
    KANJI,        /* 0x679a */
    KANJI,        /* 0x679b */
    KANJI,        /* 0x679c */
    KANJI,        /* 0x679d */
    KANJI,        /* 0x679e */
    KANJI,        /* 0x679f */
    KANJI,        /* 0x67a0 */
    KANJI,        /* 0x67a1 */
    KANJI,        /* 0x67a2 */
    KANJI,        /* 0x67a3 */
    KANJI,        /* 0x67a4 */
    KANJI,        /* 0x67a5 */
    KANJI,        /* 0x67a6 */
    KANJI,        /* 0x67a7 */
    KANJI,        /* 0x67a8 */
    KANJI,        /* 0x67a9 */
    KANJI,        /* 0x67aa */
    KANJI,        /* 0x67ab */
    KANJI,        /* 0x67ac */
    KANJI,        /* 0x67ad */
    KANJI,        /* 0x67ae */
    KANJI,        /* 0x67af */
    KANJI,        /* 0x67b0 */
    KANJI,        /* 0x67b1 */
    KANJI,        /* 0x67b2 */
    KANJI,        /* 0x67b3 */
    KANJI,        /* 0x67b4 */
    KANJI,        /* 0x67b5 */
    KANJI,        /* 0x67b6 */
    KANJI,        /* 0x67b7 */
    KANJI,        /* 0x67b8 */
    KANJI,        /* 0x67b9 */
    KANJI,        /* 0x67ba */
    KANJI,        /* 0x67bb */
    KANJI,        /* 0x67bc */
    KANJI,        /* 0x67bd */
    KANJI,        /* 0x67be */
    KANJI,        /* 0x67bf */
    KANJI,        /* 0x67c0 */
    KANJI,        /* 0x67c1 */
    KANJI,        /* 0x67c2 */
    KANJI,        /* 0x67c3 */
    KANJI,        /* 0x67c4 */
    KANJI,        /* 0x67c5 */
    KANJI,        /* 0x67c6 */
    KANJI,        /* 0x67c7 */
    KANJI,        /* 0x67c8 */
    KANJI,        /* 0x67c9 */
    KANJI,        /* 0x67ca */
    KANJI,        /* 0x67cb */
    KANJI,        /* 0x67cc */
    KANJI,        /* 0x67cd */
    KANJI,        /* 0x67ce */
    KANJI,        /* 0x67cf */
    KANJI,        /* 0x67d0 */
    KANJI,        /* 0x67d1 */
    KANJI,        /* 0x67d2 */
    KANJI,        /* 0x67d3 */
    KANJI,        /* 0x67d4 */
    KANJI,        /* 0x67d5 */
    KANJI,        /* 0x67d6 */
    KANJI,        /* 0x67d7 */
    KANJI,        /* 0x67d8 */
    KANJI,        /* 0x67d9 */
    KANJI,        /* 0x67da */
    KANJI,        /* 0x67db */
    KANJI,        /* 0x67dc */
    KANJI,        /* 0x67dd */
    KANJI,        /* 0x67de */
    KANJI,        /* 0x67df */
    KANJI,        /* 0x67e0 */
    KANJI,        /* 0x67e1 */
    KANJI,        /* 0x67e2 */
    KANJI,        /* 0x67e3 */
    KANJI,        /* 0x67e4 */
    KANJI,        /* 0x67e5 */
    KANJI,        /* 0x67e6 */
    KANJI,        /* 0x67e7 */
    KANJI,        /* 0x67e8 */
    KANJI,        /* 0x67e9 */
    KANJI,        /* 0x67ea */
    KANJI,        /* 0x67eb */
    KANJI,        /* 0x67ec */
    KANJI,        /* 0x67ed */
    KANJI,        /* 0x67ee */
    KANJI,        /* 0x67ef */
    KANJI,        /* 0x67f0 */
    KANJI,        /* 0x67f1 */
    KANJI,        /* 0x67f2 */
    KANJI,        /* 0x67f3 */
    KANJI,        /* 0x67f4 */
    KANJI,        /* 0x67f5 */
    KANJI,        /* 0x67f6 */
    KANJI,        /* 0x67f7 */
    KANJI,        /* 0x67f8 */
    KANJI,        /* 0x67f9 */
    KANJI,        /* 0x67fa */
    KANJI,        /* 0x67fb */
    KANJI,        /* 0x67fc */
    KANJI,        /* 0x67fd */
    KANJI,        /* 0x67fe */
    KANJI,        /* 0x67ff */
    KANJI,        /* 0x6800 */
    KANJI,        /* 0x6801 */
    KANJI,        /* 0x6802 */
    KANJI,        /* 0x6803 */
    KANJI,        /* 0x6804 */
    KANJI,        /* 0x6805 */
    KANJI,        /* 0x6806 */
    KANJI,        /* 0x6807 */
    KANJI,        /* 0x6808 */
    KANJI,        /* 0x6809 */
    KANJI,        /* 0x680a */
    KANJI,        /* 0x680b */
    KANJI,        /* 0x680c */
    KANJI,        /* 0x680d */
    KANJI,        /* 0x680e */
    KANJI,        /* 0x680f */
    KANJI,        /* 0x6810 */
    KANJI,        /* 0x6811 */
    KANJI,        /* 0x6812 */
    KANJI,        /* 0x6813 */
    KANJI,        /* 0x6814 */
    KANJI,        /* 0x6815 */
    KANJI,        /* 0x6816 */
    KANJI,        /* 0x6817 */
    KANJI,        /* 0x6818 */
    KANJI,        /* 0x6819 */
    KANJI,        /* 0x681a */
    KANJI,        /* 0x681b */
    KANJI,        /* 0x681c */
    KANJI,        /* 0x681d */
    KANJI,        /* 0x681e */
    KANJI,        /* 0x681f */
    KANJI,        /* 0x6820 */
    KANJI,        /* 0x6821 */
    KANJI,        /* 0x6822 */
    KANJI,        /* 0x6823 */
    KANJI,        /* 0x6824 */
    KANJI,        /* 0x6825 */
    KANJI,        /* 0x6826 */
    KANJI,        /* 0x6827 */
    KANJI,        /* 0x6828 */
    KANJI,        /* 0x6829 */
    KANJI,        /* 0x682a */
    KANJI,        /* 0x682b */
    KANJI,        /* 0x682c */
    KANJI,        /* 0x682d */
    KANJI,        /* 0x682e */
    KANJI,        /* 0x682f */
    KANJI,        /* 0x6830 */
    KANJI,        /* 0x6831 */
    KANJI,        /* 0x6832 */
    KANJI,        /* 0x6833 */
    KANJI,        /* 0x6834 */
    KANJI,        /* 0x6835 */
    KANJI,        /* 0x6836 */
    KANJI,        /* 0x6837 */
    KANJI,        /* 0x6838 */
    KANJI,        /* 0x6839 */
    KANJI,        /* 0x683a */
    KANJI,        /* 0x683b */
    KANJI,        /* 0x683c */
    KANJI,        /* 0x683d */
    KANJI,        /* 0x683e */
    KANJI,        /* 0x683f */
    KANJI,        /* 0x6840 */
    KANJI,        /* 0x6841 */
    KANJI,        /* 0x6842 */
    KANJI,        /* 0x6843 */
    KANJI,        /* 0x6844 */
    KANJI,        /* 0x6845 */
    KANJI,        /* 0x6846 */
    KANJI,        /* 0x6847 */
    KANJI,        /* 0x6848 */
    KANJI,        /* 0x6849 */
    KANJI,        /* 0x684a */
    KANJI,        /* 0x684b */
    KANJI,        /* 0x684c */
    KANJI,        /* 0x684d */
    KANJI,        /* 0x684e */
    KANJI,        /* 0x684f */
    KANJI,        /* 0x6850 */
    KANJI,        /* 0x6851 */
    KANJI,        /* 0x6852 */
    KANJI,        /* 0x6853 */
    KANJI,        /* 0x6854 */
    KANJI,        /* 0x6855 */
    KANJI,        /* 0x6856 */
    KANJI,        /* 0x6857 */
    KANJI,        /* 0x6858 */
    KANJI,        /* 0x6859 */
    KANJI,        /* 0x685a */
    KANJI,        /* 0x685b */
    KANJI,        /* 0x685c */
    KANJI,        /* 0x685d */
    KANJI,        /* 0x685e */
    KANJI,        /* 0x685f */
    KANJI,        /* 0x6860 */
    KANJI,        /* 0x6861 */
    KANJI,        /* 0x6862 */
    KANJI,        /* 0x6863 */
    KANJI,        /* 0x6864 */
    KANJI,        /* 0x6865 */
    KANJI,        /* 0x6866 */
    KANJI,        /* 0x6867 */
    KANJI,        /* 0x6868 */
    KANJI,        /* 0x6869 */
    KANJI,        /* 0x686a */
    KANJI,        /* 0x686b */
    KANJI,        /* 0x686c */
    KANJI,        /* 0x686d */
    KANJI,        /* 0x686e */
    KANJI,        /* 0x686f */
    KANJI,        /* 0x6870 */
    KANJI,        /* 0x6871 */
    KANJI,        /* 0x6872 */
    KANJI,        /* 0x6873 */
    KANJI,        /* 0x6874 */
    KANJI,        /* 0x6875 */
    KANJI,        /* 0x6876 */
    KANJI,        /* 0x6877 */
    KANJI,        /* 0x6878 */
    KANJI,        /* 0x6879 */
    KANJI,        /* 0x687a */
    KANJI,        /* 0x687b */
    KANJI,        /* 0x687c */
    KANJI,        /* 0x687d */
    KANJI,        /* 0x687e */
    KANJI,        /* 0x687f */
    KANJI,        /* 0x6880 */
    KANJI,        /* 0x6881 */
    KANJI,        /* 0x6882 */
    KANJI,        /* 0x6883 */
    KANJI,        /* 0x6884 */
    KANJI,        /* 0x6885 */
    KANJI,        /* 0x6886 */
    KANJI,        /* 0x6887 */
    KANJI,        /* 0x6888 */
    KANJI,        /* 0x6889 */
    KANJI,        /* 0x688a */
    KANJI,        /* 0x688b */
    KANJI,        /* 0x688c */
    KANJI,        /* 0x688d */
    KANJI,        /* 0x688e */
    KANJI,        /* 0x688f */
    KANJI,        /* 0x6890 */
    KANJI,        /* 0x6891 */
    KANJI,        /* 0x6892 */
    KANJI,        /* 0x6893 */
    KANJI,        /* 0x6894 */
    KANJI,        /* 0x6895 */
    KANJI,        /* 0x6896 */
    KANJI,        /* 0x6897 */
    KANJI,        /* 0x6898 */
    KANJI,        /* 0x6899 */
    KANJI,        /* 0x689a */
    KANJI,        /* 0x689b */
    KANJI,        /* 0x689c */
    KANJI,        /* 0x689d */
    KANJI,        /* 0x689e */
    KANJI,        /* 0x689f */
    KANJI,        /* 0x68a0 */
    KANJI,        /* 0x68a1 */
    KANJI,        /* 0x68a2 */
    KANJI,        /* 0x68a3 */
    KANJI,        /* 0x68a4 */
    KANJI,        /* 0x68a5 */
    KANJI,        /* 0x68a6 */
    KANJI,        /* 0x68a7 */
    KANJI,        /* 0x68a8 */
    KANJI,        /* 0x68a9 */
    KANJI,        /* 0x68aa */
    KANJI,        /* 0x68ab */
    KANJI,        /* 0x68ac */
    KANJI,        /* 0x68ad */
    KANJI,        /* 0x68ae */
    KANJI,        /* 0x68af */
    KANJI,        /* 0x68b0 */
    KANJI,        /* 0x68b1 */
    KANJI,        /* 0x68b2 */
    KANJI,        /* 0x68b3 */
    KANJI,        /* 0x68b4 */
    KANJI,        /* 0x68b5 */
    KANJI,        /* 0x68b6 */
    KANJI,        /* 0x68b7 */
    KANJI,        /* 0x68b8 */
    KANJI,        /* 0x68b9 */
    KANJI,        /* 0x68ba */
    KANJI,        /* 0x68bb */
    KANJI,        /* 0x68bc */
    KANJI,        /* 0x68bd */
    KANJI,        /* 0x68be */
    KANJI,        /* 0x68bf */
    KANJI,        /* 0x68c0 */
    KANJI,        /* 0x68c1 */
    KANJI,        /* 0x68c2 */
    KANJI,        /* 0x68c3 */
    KANJI,        /* 0x68c4 */
    KANJI,        /* 0x68c5 */
    KANJI,        /* 0x68c6 */
    KANJI,        /* 0x68c7 */
    KANJI,        /* 0x68c8 */
    KANJI,        /* 0x68c9 */
    KANJI,        /* 0x68ca */
    KANJI,        /* 0x68cb */
    KANJI,        /* 0x68cc */
    KANJI,        /* 0x68cd */
    KANJI,        /* 0x68ce */
    KANJI,        /* 0x68cf */
    KANJI,        /* 0x68d0 */
    KANJI,        /* 0x68d1 */
    KANJI,        /* 0x68d2 */
    KANJI,        /* 0x68d3 */
    KANJI,        /* 0x68d4 */
    KANJI,        /* 0x68d5 */
    KANJI,        /* 0x68d6 */
    KANJI,        /* 0x68d7 */
    KANJI,        /* 0x68d8 */
    KANJI,        /* 0x68d9 */
    KANJI,        /* 0x68da */
    KANJI,        /* 0x68db */
    KANJI,        /* 0x68dc */
    KANJI,        /* 0x68dd */
    KANJI,        /* 0x68de */
    KANJI,        /* 0x68df */
    KANJI,        /* 0x68e0 */
    KANJI,        /* 0x68e1 */
    KANJI,        /* 0x68e2 */
    KANJI,        /* 0x68e3 */
    KANJI,        /* 0x68e4 */
    KANJI,        /* 0x68e5 */
    KANJI,        /* 0x68e6 */
    KANJI,        /* 0x68e7 */
    KANJI,        /* 0x68e8 */
    KANJI,        /* 0x68e9 */
    KANJI,        /* 0x68ea */
    KANJI,        /* 0x68eb */
    KANJI,        /* 0x68ec */
    KANJI,        /* 0x68ed */
    KANJI,        /* 0x68ee */
    KANJI,        /* 0x68ef */
    KANJI,        /* 0x68f0 */
    KANJI,        /* 0x68f1 */
    KANJI,        /* 0x68f2 */
    KANJI,        /* 0x68f3 */
    KANJI,        /* 0x68f4 */
    KANJI,        /* 0x68f5 */
    KANJI,        /* 0x68f6 */
    KANJI,        /* 0x68f7 */
    KANJI,        /* 0x68f8 */
    KANJI,        /* 0x68f9 */
    KANJI,        /* 0x68fa */
    KANJI,        /* 0x68fb */
    KANJI,        /* 0x68fc */
    KANJI,        /* 0x68fd */
    KANJI,        /* 0x68fe */
    KANJI,        /* 0x68ff */
    KANJI,        /* 0x6900 */
    KANJI,        /* 0x6901 */
    KANJI,        /* 0x6902 */
    KANJI,        /* 0x6903 */
    KANJI,        /* 0x6904 */
    KANJI,        /* 0x6905 */
    KANJI,        /* 0x6906 */
    KANJI,        /* 0x6907 */
    KANJI,        /* 0x6908 */
    KANJI,        /* 0x6909 */
    KANJI,        /* 0x690a */
    KANJI,        /* 0x690b */
    KANJI,        /* 0x690c */
    KANJI,        /* 0x690d */
    KANJI,        /* 0x690e */
    KANJI,        /* 0x690f */
    KANJI,        /* 0x6910 */
    KANJI,        /* 0x6911 */
    KANJI,        /* 0x6912 */
    KANJI,        /* 0x6913 */
    KANJI,        /* 0x6914 */
    KANJI,        /* 0x6915 */
    KANJI,        /* 0x6916 */
    KANJI,        /* 0x6917 */
    KANJI,        /* 0x6918 */
    KANJI,        /* 0x6919 */
    KANJI,        /* 0x691a */
    KANJI,        /* 0x691b */
    KANJI,        /* 0x691c */
    KANJI,        /* 0x691d */
    KANJI,        /* 0x691e */
    KANJI,        /* 0x691f */
    KANJI,        /* 0x6920 */
    KANJI,        /* 0x6921 */
    KANJI,        /* 0x6922 */
    KANJI,        /* 0x6923 */
    KANJI,        /* 0x6924 */
    KANJI,        /* 0x6925 */
    KANJI,        /* 0x6926 */
    KANJI,        /* 0x6927 */
    KANJI,        /* 0x6928 */
    KANJI,        /* 0x6929 */
    KANJI,        /* 0x692a */
    KANJI,        /* 0x692b */
    KANJI,        /* 0x692c */
    KANJI,        /* 0x692d */
    KANJI,        /* 0x692e */
    KANJI,        /* 0x692f */
    KANJI,        /* 0x6930 */
    KANJI,        /* 0x6931 */
    KANJI,        /* 0x6932 */
    KANJI,        /* 0x6933 */
    KANJI,        /* 0x6934 */
    KANJI,        /* 0x6935 */
    KANJI,        /* 0x6936 */
    KANJI,        /* 0x6937 */
    KANJI,        /* 0x6938 */
    KANJI,        /* 0x6939 */
    KANJI,        /* 0x693a */
    KANJI,        /* 0x693b */
    KANJI,        /* 0x693c */
    KANJI,        /* 0x693d */
    KANJI,        /* 0x693e */
    KANJI,        /* 0x693f */
    KANJI,        /* 0x6940 */
    KANJI,        /* 0x6941 */
    KANJI,        /* 0x6942 */
    KANJI,        /* 0x6943 */
    KANJI,        /* 0x6944 */
    KANJI,        /* 0x6945 */
    KANJI,        /* 0x6946 */
    KANJI,        /* 0x6947 */
    KANJI,        /* 0x6948 */
    KANJI,        /* 0x6949 */
    KANJI,        /* 0x694a */
    KANJI,        /* 0x694b */
    KANJI,        /* 0x694c */
    KANJI,        /* 0x694d */
    KANJI,        /* 0x694e */
    KANJI,        /* 0x694f */
    KANJI,        /* 0x6950 */
    KANJI,        /* 0x6951 */
    KANJI,        /* 0x6952 */
    KANJI,        /* 0x6953 */
    KANJI,        /* 0x6954 */
    KANJI,        /* 0x6955 */
    KANJI,        /* 0x6956 */
    KANJI,        /* 0x6957 */
    KANJI,        /* 0x6958 */
    KANJI,        /* 0x6959 */
    KANJI,        /* 0x695a */
    KANJI,        /* 0x695b */
    KANJI,        /* 0x695c */
    KANJI,        /* 0x695d */
    KANJI,        /* 0x695e */
    KANJI,        /* 0x695f */
    KANJI,        /* 0x6960 */
    KANJI,        /* 0x6961 */
    KANJI,        /* 0x6962 */
    KANJI,        /* 0x6963 */
    KANJI,        /* 0x6964 */
    KANJI,        /* 0x6965 */
    KANJI,        /* 0x6966 */
    KANJI,        /* 0x6967 */
    KANJI,        /* 0x6968 */
    KANJI,        /* 0x6969 */
    KANJI,        /* 0x696a */
    KANJI,        /* 0x696b */
    KANJI,        /* 0x696c */
    KANJI,        /* 0x696d */
    KANJI,        /* 0x696e */
    KANJI,        /* 0x696f */
    KANJI,        /* 0x6970 */
    KANJI,        /* 0x6971 */
    KANJI,        /* 0x6972 */
    KANJI,        /* 0x6973 */
    KANJI,        /* 0x6974 */
    KANJI,        /* 0x6975 */
    KANJI,        /* 0x6976 */
    KANJI,        /* 0x6977 */
    KANJI,        /* 0x6978 */
    KANJI,        /* 0x6979 */
    KANJI,        /* 0x697a */
    KANJI,        /* 0x697b */
    KANJI,        /* 0x697c */
    KANJI,        /* 0x697d */
    KANJI,        /* 0x697e */
    KANJI,        /* 0x697f */
    KANJI,        /* 0x6980 */
    KANJI,        /* 0x6981 */
    KANJI,        /* 0x6982 */
    KANJI,        /* 0x6983 */
    KANJI,        /* 0x6984 */
    KANJI,        /* 0x6985 */
    KANJI,        /* 0x6986 */
    KANJI,        /* 0x6987 */
    KANJI,        /* 0x6988 */
    KANJI,        /* 0x6989 */
    KANJI,        /* 0x698a */
    KANJI,        /* 0x698b */
    KANJI,        /* 0x698c */
    KANJI,        /* 0x698d */
    KANJI,        /* 0x698e */
    KANJI,        /* 0x698f */
    KANJI,        /* 0x6990 */
    KANJI,        /* 0x6991 */
    KANJI,        /* 0x6992 */
    KANJI,        /* 0x6993 */
    KANJI,        /* 0x6994 */
    KANJI,        /* 0x6995 */
    KANJI,        /* 0x6996 */
    KANJI,        /* 0x6997 */
    KANJI,        /* 0x6998 */
    KANJI,        /* 0x6999 */
    KANJI,        /* 0x699a */
    KANJI,        /* 0x699b */
    KANJI,        /* 0x699c */
    KANJI,        /* 0x699d */
    KANJI,        /* 0x699e */
    KANJI,        /* 0x699f */
    KANJI,        /* 0x69a0 */
    KANJI,        /* 0x69a1 */
    KANJI,        /* 0x69a2 */
    KANJI,        /* 0x69a3 */
    KANJI,        /* 0x69a4 */
    KANJI,        /* 0x69a5 */
    KANJI,        /* 0x69a6 */
    KANJI,        /* 0x69a7 */
    KANJI,        /* 0x69a8 */
    KANJI,        /* 0x69a9 */
    KANJI,        /* 0x69aa */
    KANJI,        /* 0x69ab */
    KANJI,        /* 0x69ac */
    KANJI,        /* 0x69ad */
    KANJI,        /* 0x69ae */
    KANJI,        /* 0x69af */
    KANJI,        /* 0x69b0 */
    KANJI,        /* 0x69b1 */
    KANJI,        /* 0x69b2 */
    KANJI,        /* 0x69b3 */
    KANJI,        /* 0x69b4 */
    KANJI,        /* 0x69b5 */
    KANJI,        /* 0x69b6 */
    KANJI,        /* 0x69b7 */
    KANJI,        /* 0x69b8 */
    KANJI,        /* 0x69b9 */
    KANJI,        /* 0x69ba */
    KANJI,        /* 0x69bb */
    KANJI,        /* 0x69bc */
    KANJI,        /* 0x69bd */
    KANJI,        /* 0x69be */
    KANJI,        /* 0x69bf */
    KANJI,        /* 0x69c0 */
    KANJI,        /* 0x69c1 */
    KANJI,        /* 0x69c2 */
    KANJI,        /* 0x69c3 */
    KANJI,        /* 0x69c4 */
    KANJI,        /* 0x69c5 */
    KANJI,        /* 0x69c6 */
    KANJI,        /* 0x69c7 */
    KANJI,        /* 0x69c8 */
    KANJI,        /* 0x69c9 */
    KANJI,        /* 0x69ca */
    KANJI,        /* 0x69cb */
    KANJI,        /* 0x69cc */
    KANJI,        /* 0x69cd */
    KANJI,        /* 0x69ce */
    KANJI,        /* 0x69cf */
    KANJI,        /* 0x69d0 */
    KANJI,        /* 0x69d1 */
    KANJI,        /* 0x69d2 */
    KANJI,        /* 0x69d3 */
    KANJI,        /* 0x69d4 */
    KANJI,        /* 0x69d5 */
    KANJI,        /* 0x69d6 */
    KANJI,        /* 0x69d7 */
    KANJI,        /* 0x69d8 */
    KANJI,        /* 0x69d9 */
    KANJI,        /* 0x69da */
    KANJI,        /* 0x69db */
    KANJI,        /* 0x69dc */
    KANJI,        /* 0x69dd */
    KANJI,        /* 0x69de */
    KANJI,        /* 0x69df */
    KANJI,        /* 0x69e0 */
    KANJI,        /* 0x69e1 */
    KANJI,        /* 0x69e2 */
    KANJI,        /* 0x69e3 */
    KANJI,        /* 0x69e4 */
    KANJI,        /* 0x69e5 */
    KANJI,        /* 0x69e6 */
    KANJI,        /* 0x69e7 */
    KANJI,        /* 0x69e8 */
    KANJI,        /* 0x69e9 */
    KANJI,        /* 0x69ea */
    KANJI,        /* 0x69eb */
    KANJI,        /* 0x69ec */
    KANJI,        /* 0x69ed */
    KANJI,        /* 0x69ee */
    KANJI,        /* 0x69ef */
    KANJI,        /* 0x69f0 */
    KANJI,        /* 0x69f1 */
    KANJI,        /* 0x69f2 */
    KANJI,        /* 0x69f3 */
    KANJI,        /* 0x69f4 */
    KANJI,        /* 0x69f5 */
    KANJI,        /* 0x69f6 */
    KANJI,        /* 0x69f7 */
    KANJI,        /* 0x69f8 */
    KANJI,        /* 0x69f9 */
    KANJI,        /* 0x69fa */
    KANJI,        /* 0x69fb */
    KANJI,        /* 0x69fc */
    KANJI,        /* 0x69fd */
    KANJI,        /* 0x69fe */
    KANJI,        /* 0x69ff */
    KANJI,        /* 0x6a00 */
    KANJI,        /* 0x6a01 */
    KANJI,        /* 0x6a02 */
    KANJI,        /* 0x6a03 */
    KANJI,        /* 0x6a04 */
    KANJI,        /* 0x6a05 */
    KANJI,        /* 0x6a06 */
    KANJI,        /* 0x6a07 */
    KANJI,        /* 0x6a08 */
    KANJI,        /* 0x6a09 */
    KANJI,        /* 0x6a0a */
    KANJI,        /* 0x6a0b */
    KANJI,        /* 0x6a0c */
    KANJI,        /* 0x6a0d */
    KANJI,        /* 0x6a0e */
    KANJI,        /* 0x6a0f */
    KANJI,        /* 0x6a10 */
    KANJI,        /* 0x6a11 */
    KANJI,        /* 0x6a12 */
    KANJI,        /* 0x6a13 */
    KANJI,        /* 0x6a14 */
    KANJI,        /* 0x6a15 */
    KANJI,        /* 0x6a16 */
    KANJI,        /* 0x6a17 */
    KANJI,        /* 0x6a18 */
    KANJI,        /* 0x6a19 */
    KANJI,        /* 0x6a1a */
    KANJI,        /* 0x6a1b */
    KANJI,        /* 0x6a1c */
    KANJI,        /* 0x6a1d */
    KANJI,        /* 0x6a1e */
    KANJI,        /* 0x6a1f */
    KANJI,        /* 0x6a20 */
    KANJI,        /* 0x6a21 */
    KANJI,        /* 0x6a22 */
    KANJI,        /* 0x6a23 */
    KANJI,        /* 0x6a24 */
    KANJI,        /* 0x6a25 */
    KANJI,        /* 0x6a26 */
    KANJI,        /* 0x6a27 */
    KANJI,        /* 0x6a28 */
    KANJI,        /* 0x6a29 */
    KANJI,        /* 0x6a2a */
    KANJI,        /* 0x6a2b */
    KANJI,        /* 0x6a2c */
    KANJI,        /* 0x6a2d */
    KANJI,        /* 0x6a2e */
    KANJI,        /* 0x6a2f */
    KANJI,        /* 0x6a30 */
    KANJI,        /* 0x6a31 */
    KANJI,        /* 0x6a32 */
    KANJI,        /* 0x6a33 */
    KANJI,        /* 0x6a34 */
    KANJI,        /* 0x6a35 */
    KANJI,        /* 0x6a36 */
    KANJI,        /* 0x6a37 */
    KANJI,        /* 0x6a38 */
    KANJI,        /* 0x6a39 */
    KANJI,        /* 0x6a3a */
    KANJI,        /* 0x6a3b */
    KANJI,        /* 0x6a3c */
    KANJI,        /* 0x6a3d */
    KANJI,        /* 0x6a3e */
    KANJI,        /* 0x6a3f */
    KANJI,        /* 0x6a40 */
    KANJI,        /* 0x6a41 */
    KANJI,        /* 0x6a42 */
    KANJI,        /* 0x6a43 */
    KANJI,        /* 0x6a44 */
    KANJI,        /* 0x6a45 */
    KANJI,        /* 0x6a46 */
    KANJI,        /* 0x6a47 */
    KANJI,        /* 0x6a48 */
    KANJI,        /* 0x6a49 */
    KANJI,        /* 0x6a4a */
    KANJI,        /* 0x6a4b */
    KANJI,        /* 0x6a4c */
    KANJI,        /* 0x6a4d */
    KANJI,        /* 0x6a4e */
    KANJI,        /* 0x6a4f */
    KANJI,        /* 0x6a50 */
    KANJI,        /* 0x6a51 */
    KANJI,        /* 0x6a52 */
    KANJI,        /* 0x6a53 */
    KANJI,        /* 0x6a54 */
    KANJI,        /* 0x6a55 */
    KANJI,        /* 0x6a56 */
    KANJI,        /* 0x6a57 */
    KANJI,        /* 0x6a58 */
    KANJI,        /* 0x6a59 */
    KANJI,        /* 0x6a5a */
    KANJI,        /* 0x6a5b */
    KANJI,        /* 0x6a5c */
    KANJI,        /* 0x6a5d */
    KANJI,        /* 0x6a5e */
    KANJI,        /* 0x6a5f */
    KANJI,        /* 0x6a60 */
    KANJI,        /* 0x6a61 */
    KANJI,        /* 0x6a62 */
    KANJI,        /* 0x6a63 */
    KANJI,        /* 0x6a64 */
    KANJI,        /* 0x6a65 */
    KANJI,        /* 0x6a66 */
    KANJI,        /* 0x6a67 */
    KANJI,        /* 0x6a68 */
    KANJI,        /* 0x6a69 */
    KANJI,        /* 0x6a6a */
    KANJI,        /* 0x6a6b */
    KANJI,        /* 0x6a6c */
    KANJI,        /* 0x6a6d */
    KANJI,        /* 0x6a6e */
    KANJI,        /* 0x6a6f */
    KANJI,        /* 0x6a70 */
    KANJI,        /* 0x6a71 */
    KANJI,        /* 0x6a72 */
    KANJI,        /* 0x6a73 */
    KANJI,        /* 0x6a74 */
    KANJI,        /* 0x6a75 */
    KANJI,        /* 0x6a76 */
    KANJI,        /* 0x6a77 */
    KANJI,        /* 0x6a78 */
    KANJI,        /* 0x6a79 */
    KANJI,        /* 0x6a7a */
    KANJI,        /* 0x6a7b */
    KANJI,        /* 0x6a7c */
    KANJI,        /* 0x6a7d */
    KANJI,        /* 0x6a7e */
    KANJI,        /* 0x6a7f */
    KANJI,        /* 0x6a80 */
    KANJI,        /* 0x6a81 */
    KANJI,        /* 0x6a82 */
    KANJI,        /* 0x6a83 */
    KANJI,        /* 0x6a84 */
    KANJI,        /* 0x6a85 */
    KANJI,        /* 0x6a86 */
    KANJI,        /* 0x6a87 */
    KANJI,        /* 0x6a88 */
    KANJI,        /* 0x6a89 */
    KANJI,        /* 0x6a8a */
    KANJI,        /* 0x6a8b */
    KANJI,        /* 0x6a8c */
    KANJI,        /* 0x6a8d */
    KANJI,        /* 0x6a8e */
    KANJI,        /* 0x6a8f */
    KANJI,        /* 0x6a90 */
    KANJI,        /* 0x6a91 */
    KANJI,        /* 0x6a92 */
    KANJI,        /* 0x6a93 */
    KANJI,        /* 0x6a94 */
    KANJI,        /* 0x6a95 */
    KANJI,        /* 0x6a96 */
    KANJI,        /* 0x6a97 */
    KANJI,        /* 0x6a98 */
    KANJI,        /* 0x6a99 */
    KANJI,        /* 0x6a9a */
    KANJI,        /* 0x6a9b */
    KANJI,        /* 0x6a9c */
    KANJI,        /* 0x6a9d */
    KANJI,        /* 0x6a9e */
    KANJI,        /* 0x6a9f */
    KANJI,        /* 0x6aa0 */
    KANJI,        /* 0x6aa1 */
    KANJI,        /* 0x6aa2 */
    KANJI,        /* 0x6aa3 */
    KANJI,        /* 0x6aa4 */
    KANJI,        /* 0x6aa5 */
    KANJI,        /* 0x6aa6 */
    KANJI,        /* 0x6aa7 */
    KANJI,        /* 0x6aa8 */
    KANJI,        /* 0x6aa9 */
    KANJI,        /* 0x6aaa */
    KANJI,        /* 0x6aab */
    KANJI,        /* 0x6aac */
    KANJI,        /* 0x6aad */
    KANJI,        /* 0x6aae */
    KANJI,        /* 0x6aaf */
    KANJI,        /* 0x6ab0 */
    KANJI,        /* 0x6ab1 */
    KANJI,        /* 0x6ab2 */
    KANJI,        /* 0x6ab3 */
    KANJI,        /* 0x6ab4 */
    KANJI,        /* 0x6ab5 */
    KANJI,        /* 0x6ab6 */
    KANJI,        /* 0x6ab7 */
    KANJI,        /* 0x6ab8 */
    KANJI,        /* 0x6ab9 */
    KANJI,        /* 0x6aba */
    KANJI,        /* 0x6abb */
    KANJI,        /* 0x6abc */
    KANJI,        /* 0x6abd */
    KANJI,        /* 0x6abe */
    KANJI,        /* 0x6abf */
    KANJI,        /* 0x6ac0 */
    KANJI,        /* 0x6ac1 */
    KANJI,        /* 0x6ac2 */
    KANJI,        /* 0x6ac3 */
    KANJI,        /* 0x6ac4 */
    KANJI,        /* 0x6ac5 */
    KANJI,        /* 0x6ac6 */
    KANJI,        /* 0x6ac7 */
    KANJI,        /* 0x6ac8 */
    KANJI,        /* 0x6ac9 */
    KANJI,        /* 0x6aca */
    KANJI,        /* 0x6acb */
    KANJI,        /* 0x6acc */
    KANJI,        /* 0x6acd */
    KANJI,        /* 0x6ace */
    KANJI,        /* 0x6acf */
    KANJI,        /* 0x6ad0 */
    KANJI,        /* 0x6ad1 */
    KANJI,        /* 0x6ad2 */
    KANJI,        /* 0x6ad3 */
    KANJI,        /* 0x6ad4 */
    KANJI,        /* 0x6ad5 */
    KANJI,        /* 0x6ad6 */
    KANJI,        /* 0x6ad7 */
    KANJI,        /* 0x6ad8 */
    KANJI,        /* 0x6ad9 */
    KANJI,        /* 0x6ada */
    KANJI,        /* 0x6adb */
    KANJI,        /* 0x6adc */
    KANJI,        /* 0x6add */
    KANJI,        /* 0x6ade */
    KANJI,        /* 0x6adf */
    KANJI,        /* 0x6ae0 */
    KANJI,        /* 0x6ae1 */
    KANJI,        /* 0x6ae2 */
    KANJI,        /* 0x6ae3 */
    KANJI,        /* 0x6ae4 */
    KANJI,        /* 0x6ae5 */
    KANJI,        /* 0x6ae6 */
    KANJI,        /* 0x6ae7 */
    KANJI,        /* 0x6ae8 */
    KANJI,        /* 0x6ae9 */
    KANJI,        /* 0x6aea */
    KANJI,        /* 0x6aeb */
    KANJI,        /* 0x6aec */
    KANJI,        /* 0x6aed */
    KANJI,        /* 0x6aee */
    KANJI,        /* 0x6aef */
    KANJI,        /* 0x6af0 */
    KANJI,        /* 0x6af1 */
    KANJI,        /* 0x6af2 */
    KANJI,        /* 0x6af3 */
    KANJI,        /* 0x6af4 */
    KANJI,        /* 0x6af5 */
    KANJI,        /* 0x6af6 */
    KANJI,        /* 0x6af7 */
    KANJI,        /* 0x6af8 */
    KANJI,        /* 0x6af9 */
    KANJI,        /* 0x6afa */
    KANJI,        /* 0x6afb */
    KANJI,        /* 0x6afc */
    KANJI,        /* 0x6afd */
    KANJI,        /* 0x6afe */
    KANJI,        /* 0x6aff */
    KANJI,        /* 0x6b00 */
    KANJI,        /* 0x6b01 */
    KANJI,        /* 0x6b02 */
    KANJI,        /* 0x6b03 */
    KANJI,        /* 0x6b04 */
    KANJI,        /* 0x6b05 */
    KANJI,        /* 0x6b06 */
    KANJI,        /* 0x6b07 */
    KANJI,        /* 0x6b08 */
    KANJI,        /* 0x6b09 */
    KANJI,        /* 0x6b0a */
    KANJI,        /* 0x6b0b */
    KANJI,        /* 0x6b0c */
    KANJI,        /* 0x6b0d */
    KANJI,        /* 0x6b0e */
    KANJI,        /* 0x6b0f */
    KANJI,        /* 0x6b10 */
    KANJI,        /* 0x6b11 */
    KANJI,        /* 0x6b12 */
    KANJI,        /* 0x6b13 */
    KANJI,        /* 0x6b14 */
    KANJI,        /* 0x6b15 */
    KANJI,        /* 0x6b16 */
    KANJI,        /* 0x6b17 */
    KANJI,        /* 0x6b18 */
    KANJI,        /* 0x6b19 */
    KANJI,        /* 0x6b1a */
    KANJI,        /* 0x6b1b */
    KANJI,        /* 0x6b1c */
    KANJI,        /* 0x6b1d */
    KANJI,        /* 0x6b1e */
    KANJI,        /* 0x6b1f */
    KANJI,        /* 0x6b20 */
    KANJI,        /* 0x6b21 */
    KANJI,        /* 0x6b22 */
    KANJI,        /* 0x6b23 */
    KANJI,        /* 0x6b24 */
    KANJI,        /* 0x6b25 */
    KANJI,        /* 0x6b26 */
    KANJI,        /* 0x6b27 */
    KANJI,        /* 0x6b28 */
    KANJI,        /* 0x6b29 */
    KANJI,        /* 0x6b2a */
    KANJI,        /* 0x6b2b */
    KANJI,        /* 0x6b2c */
    KANJI,        /* 0x6b2d */
    KANJI,        /* 0x6b2e */
    KANJI,        /* 0x6b2f */
    KANJI,        /* 0x6b30 */
    KANJI,        /* 0x6b31 */
    KANJI,        /* 0x6b32 */
    KANJI,        /* 0x6b33 */
    KANJI,        /* 0x6b34 */
    KANJI,        /* 0x6b35 */
    KANJI,        /* 0x6b36 */
    KANJI,        /* 0x6b37 */
    KANJI,        /* 0x6b38 */
    KANJI,        /* 0x6b39 */
    KANJI,        /* 0x6b3a */
    KANJI,        /* 0x6b3b */
    KANJI,        /* 0x6b3c */
    KANJI,        /* 0x6b3d */
    KANJI,        /* 0x6b3e */
    KANJI,        /* 0x6b3f */
    KANJI,        /* 0x6b40 */
    KANJI,        /* 0x6b41 */
    KANJI,        /* 0x6b42 */
    KANJI,        /* 0x6b43 */
    KANJI,        /* 0x6b44 */
    KANJI,        /* 0x6b45 */
    KANJI,        /* 0x6b46 */
    KANJI,        /* 0x6b47 */
    KANJI,        /* 0x6b48 */
    KANJI,        /* 0x6b49 */
    KANJI,        /* 0x6b4a */
    KANJI,        /* 0x6b4b */
    KANJI,        /* 0x6b4c */
    KANJI,        /* 0x6b4d */
    KANJI,        /* 0x6b4e */
    KANJI,        /* 0x6b4f */
    KANJI,        /* 0x6b50 */
    KANJI,        /* 0x6b51 */
    KANJI,        /* 0x6b52 */
    KANJI,        /* 0x6b53 */
    KANJI,        /* 0x6b54 */
    KANJI,        /* 0x6b55 */
    KANJI,        /* 0x6b56 */
    KANJI,        /* 0x6b57 */
    KANJI,        /* 0x6b58 */
    KANJI,        /* 0x6b59 */
    KANJI,        /* 0x6b5a */
    KANJI,        /* 0x6b5b */
    KANJI,        /* 0x6b5c */
    KANJI,        /* 0x6b5d */
    KANJI,        /* 0x6b5e */
    KANJI,        /* 0x6b5f */
    KANJI,        /* 0x6b60 */
    KANJI,        /* 0x6b61 */
    KANJI,        /* 0x6b62 */
    KANJI,        /* 0x6b63 */
    KANJI,        /* 0x6b64 */
    KANJI,        /* 0x6b65 */
    KANJI,        /* 0x6b66 */
    KANJI,        /* 0x6b67 */
    KANJI,        /* 0x6b68 */
    KANJI,        /* 0x6b69 */
    KANJI,        /* 0x6b6a */
    KANJI,        /* 0x6b6b */
    KANJI,        /* 0x6b6c */
    KANJI,        /* 0x6b6d */
    KANJI,        /* 0x6b6e */
    KANJI,        /* 0x6b6f */
    KANJI,        /* 0x6b70 */
    KANJI,        /* 0x6b71 */
    KANJI,        /* 0x6b72 */
    KANJI,        /* 0x6b73 */
    KANJI,        /* 0x6b74 */
    KANJI,        /* 0x6b75 */
    KANJI,        /* 0x6b76 */
    KANJI,        /* 0x6b77 */
    KANJI,        /* 0x6b78 */
    KANJI,        /* 0x6b79 */
    KANJI,        /* 0x6b7a */
    KANJI,        /* 0x6b7b */
    KANJI,        /* 0x6b7c */
    KANJI,        /* 0x6b7d */
    KANJI,        /* 0x6b7e */
    KANJI,        /* 0x6b7f */
    KANJI,        /* 0x6b80 */
    KANJI,        /* 0x6b81 */
    KANJI,        /* 0x6b82 */
    KANJI,        /* 0x6b83 */
    KANJI,        /* 0x6b84 */
    KANJI,        /* 0x6b85 */
    KANJI,        /* 0x6b86 */
    KANJI,        /* 0x6b87 */
    KANJI,        /* 0x6b88 */
    KANJI,        /* 0x6b89 */
    KANJI,        /* 0x6b8a */
    KANJI,        /* 0x6b8b */
    KANJI,        /* 0x6b8c */
    KANJI,        /* 0x6b8d */
    KANJI,        /* 0x6b8e */
    KANJI,        /* 0x6b8f */
    KANJI,        /* 0x6b90 */
    KANJI,        /* 0x6b91 */
    KANJI,        /* 0x6b92 */
    KANJI,        /* 0x6b93 */
    KANJI,        /* 0x6b94 */
    KANJI,        /* 0x6b95 */
    KANJI,        /* 0x6b96 */
    KANJI,        /* 0x6b97 */
    KANJI,        /* 0x6b98 */
    KANJI,        /* 0x6b99 */
    KANJI,        /* 0x6b9a */
    KANJI,        /* 0x6b9b */
    KANJI,        /* 0x6b9c */
    KANJI,        /* 0x6b9d */
    KANJI,        /* 0x6b9e */
    KANJI,        /* 0x6b9f */
    KANJI,        /* 0x6ba0 */
    KANJI,        /* 0x6ba1 */
    KANJI,        /* 0x6ba2 */
    KANJI,        /* 0x6ba3 */
    KANJI,        /* 0x6ba4 */
    KANJI,        /* 0x6ba5 */
    KANJI,        /* 0x6ba6 */
    KANJI,        /* 0x6ba7 */
    KANJI,        /* 0x6ba8 */
    KANJI,        /* 0x6ba9 */
    KANJI,        /* 0x6baa */
    KANJI,        /* 0x6bab */
    KANJI,        /* 0x6bac */
    KANJI,        /* 0x6bad */
    KANJI,        /* 0x6bae */
    KANJI,        /* 0x6baf */
    KANJI,        /* 0x6bb0 */
    KANJI,        /* 0x6bb1 */
    KANJI,        /* 0x6bb2 */
    KANJI,        /* 0x6bb3 */
    KANJI,        /* 0x6bb4 */
    KANJI,        /* 0x6bb5 */
    KANJI,        /* 0x6bb6 */
    KANJI,        /* 0x6bb7 */
    KANJI,        /* 0x6bb8 */
    KANJI,        /* 0x6bb9 */
    KANJI,        /* 0x6bba */
    KANJI,        /* 0x6bbb */
    KANJI,        /* 0x6bbc */
    KANJI,        /* 0x6bbd */
    KANJI,        /* 0x6bbe */
    KANJI,        /* 0x6bbf */
    KANJI,        /* 0x6bc0 */
    KANJI,        /* 0x6bc1 */
    KANJI,        /* 0x6bc2 */
    KANJI,        /* 0x6bc3 */
    KANJI,        /* 0x6bc4 */
    KANJI,        /* 0x6bc5 */
    KANJI,        /* 0x6bc6 */
    KANJI,        /* 0x6bc7 */
    KANJI,        /* 0x6bc8 */
    KANJI,        /* 0x6bc9 */
    KANJI,        /* 0x6bca */
    KANJI,        /* 0x6bcb */
    KANJI,        /* 0x6bcc */
    KANJI,        /* 0x6bcd */
    KANJI,        /* 0x6bce */
    KANJI,        /* 0x6bcf */
    KANJI,        /* 0x6bd0 */
    KANJI,        /* 0x6bd1 */
    KANJI,        /* 0x6bd2 */
    KANJI,        /* 0x6bd3 */
    KANJI,        /* 0x6bd4 */
    KANJI,        /* 0x6bd5 */
    KANJI,        /* 0x6bd6 */
    KANJI,        /* 0x6bd7 */
    KANJI,        /* 0x6bd8 */
    KANJI,        /* 0x6bd9 */
    KANJI,        /* 0x6bda */
    KANJI,        /* 0x6bdb */
    KANJI,        /* 0x6bdc */
    KANJI,        /* 0x6bdd */
    KANJI,        /* 0x6bde */
    KANJI,        /* 0x6bdf */
    KANJI,        /* 0x6be0 */
    KANJI,        /* 0x6be1 */
    KANJI,        /* 0x6be2 */
    KANJI,        /* 0x6be3 */
    KANJI,        /* 0x6be4 */
    KANJI,        /* 0x6be5 */
    KANJI,        /* 0x6be6 */
    KANJI,        /* 0x6be7 */
    KANJI,        /* 0x6be8 */
    KANJI,        /* 0x6be9 */
    KANJI,        /* 0x6bea */
    KANJI,        /* 0x6beb */
    KANJI,        /* 0x6bec */
    KANJI,        /* 0x6bed */
    KANJI,        /* 0x6bee */
    KANJI,        /* 0x6bef */
    KANJI,        /* 0x6bf0 */
    KANJI,        /* 0x6bf1 */
    KANJI,        /* 0x6bf2 */
    KANJI,        /* 0x6bf3 */
    KANJI,        /* 0x6bf4 */
    KANJI,        /* 0x6bf5 */
    KANJI,        /* 0x6bf6 */
    KANJI,        /* 0x6bf7 */
    KANJI,        /* 0x6bf8 */
    KANJI,        /* 0x6bf9 */
    KANJI,        /* 0x6bfa */
    KANJI,        /* 0x6bfb */
    KANJI,        /* 0x6bfc */
    KANJI,        /* 0x6bfd */
    KANJI,        /* 0x6bfe */
    KANJI,        /* 0x6bff */
    KANJI,        /* 0x6c00 */
    KANJI,        /* 0x6c01 */
    KANJI,        /* 0x6c02 */
    KANJI,        /* 0x6c03 */
    KANJI,        /* 0x6c04 */
    KANJI,        /* 0x6c05 */
    KANJI,        /* 0x6c06 */
    KANJI,        /* 0x6c07 */
    KANJI,        /* 0x6c08 */
    KANJI,        /* 0x6c09 */
    KANJI,        /* 0x6c0a */
    KANJI,        /* 0x6c0b */
    KANJI,        /* 0x6c0c */
    KANJI,        /* 0x6c0d */
    KANJI,        /* 0x6c0e */
    KANJI,        /* 0x6c0f */
    KANJI,        /* 0x6c10 */
    KANJI,        /* 0x6c11 */
    KANJI,        /* 0x6c12 */
    KANJI,        /* 0x6c13 */
    KANJI,        /* 0x6c14 */
    KANJI,        /* 0x6c15 */
    KANJI,        /* 0x6c16 */
    KANJI,        /* 0x6c17 */
    KANJI,        /* 0x6c18 */
    KANJI,        /* 0x6c19 */
    KANJI,        /* 0x6c1a */
    KANJI,        /* 0x6c1b */
    KANJI,        /* 0x6c1c */
    KANJI,        /* 0x6c1d */
    KANJI,        /* 0x6c1e */
    KANJI,        /* 0x6c1f */
    KANJI,        /* 0x6c20 */
    KANJI,        /* 0x6c21 */
    KANJI,        /* 0x6c22 */
    KANJI,        /* 0x6c23 */
    KANJI,        /* 0x6c24 */
    KANJI,        /* 0x6c25 */
    KANJI,        /* 0x6c26 */
    KANJI,        /* 0x6c27 */
    KANJI,        /* 0x6c28 */
    KANJI,        /* 0x6c29 */
    KANJI,        /* 0x6c2a */
    KANJI,        /* 0x6c2b */
    KANJI,        /* 0x6c2c */
    KANJI,        /* 0x6c2d */
    KANJI,        /* 0x6c2e */
    KANJI,        /* 0x6c2f */
    KANJI,        /* 0x6c30 */
    KANJI,        /* 0x6c31 */
    KANJI,        /* 0x6c32 */
    KANJI,        /* 0x6c33 */
    KANJI,        /* 0x6c34 */
    KANJI,        /* 0x6c35 */
    KANJI,        /* 0x6c36 */
    KANJI,        /* 0x6c37 */
    KANJI,        /* 0x6c38 */
    KANJI,        /* 0x6c39 */
    KANJI,        /* 0x6c3a */
    KANJI,        /* 0x6c3b */
    KANJI,        /* 0x6c3c */
    KANJI,        /* 0x6c3d */
    KANJI,        /* 0x6c3e */
    KANJI,        /* 0x6c3f */
    KANJI,        /* 0x6c40 */
    KANJI,        /* 0x6c41 */
    KANJI,        /* 0x6c42 */
    KANJI,        /* 0x6c43 */
    KANJI,        /* 0x6c44 */
    KANJI,        /* 0x6c45 */
    KANJI,        /* 0x6c46 */
    KANJI,        /* 0x6c47 */
    KANJI,        /* 0x6c48 */
    KANJI,        /* 0x6c49 */
    KANJI,        /* 0x6c4a */
    KANJI,        /* 0x6c4b */
    KANJI,        /* 0x6c4c */
    KANJI,        /* 0x6c4d */
    KANJI,        /* 0x6c4e */
    KANJI,        /* 0x6c4f */
    KANJI,        /* 0x6c50 */
    KANJI,        /* 0x6c51 */
    KANJI,        /* 0x6c52 */
    KANJI,        /* 0x6c53 */
    KANJI,        /* 0x6c54 */
    KANJI,        /* 0x6c55 */
    KANJI,        /* 0x6c56 */
    KANJI,        /* 0x6c57 */
    KANJI,        /* 0x6c58 */
    KANJI,        /* 0x6c59 */
    KANJI,        /* 0x6c5a */
    KANJI,        /* 0x6c5b */
    KANJI,        /* 0x6c5c */
    KANJI,        /* 0x6c5d */
    KANJI,        /* 0x6c5e */
    KANJI,        /* 0x6c5f */
    KANJI,        /* 0x6c60 */
    KANJI,        /* 0x6c61 */
    KANJI,        /* 0x6c62 */
    KANJI,        /* 0x6c63 */
    KANJI,        /* 0x6c64 */
    KANJI,        /* 0x6c65 */
    KANJI,        /* 0x6c66 */
    KANJI,        /* 0x6c67 */
    KANJI,        /* 0x6c68 */
    KANJI,        /* 0x6c69 */
    KANJI,        /* 0x6c6a */
    KANJI,        /* 0x6c6b */
    KANJI,        /* 0x6c6c */
    KANJI,        /* 0x6c6d */
    KANJI,        /* 0x6c6e */
    KANJI,        /* 0x6c6f */
    KANJI,        /* 0x6c70 */
    KANJI,        /* 0x6c71 */
    KANJI,        /* 0x6c72 */
    KANJI,        /* 0x6c73 */
    KANJI,        /* 0x6c74 */
    KANJI,        /* 0x6c75 */
    KANJI,        /* 0x6c76 */
    KANJI,        /* 0x6c77 */
    KANJI,        /* 0x6c78 */
    KANJI,        /* 0x6c79 */
    KANJI,        /* 0x6c7a */
    KANJI,        /* 0x6c7b */
    KANJI,        /* 0x6c7c */
    KANJI,        /* 0x6c7d */
    KANJI,        /* 0x6c7e */
    KANJI,        /* 0x6c7f */
    KANJI,        /* 0x6c80 */
    KANJI,        /* 0x6c81 */
    KANJI,        /* 0x6c82 */
    KANJI,        /* 0x6c83 */
    KANJI,        /* 0x6c84 */
    KANJI,        /* 0x6c85 */
    KANJI,        /* 0x6c86 */
    KANJI,        /* 0x6c87 */
    KANJI,        /* 0x6c88 */
    KANJI,        /* 0x6c89 */
    KANJI,        /* 0x6c8a */
    KANJI,        /* 0x6c8b */
    KANJI,        /* 0x6c8c */
    KANJI,        /* 0x6c8d */
    KANJI,        /* 0x6c8e */
    KANJI,        /* 0x6c8f */
    KANJI,        /* 0x6c90 */
    KANJI,        /* 0x6c91 */
    KANJI,        /* 0x6c92 */
    KANJI,        /* 0x6c93 */
    KANJI,        /* 0x6c94 */
    KANJI,        /* 0x6c95 */
    KANJI,        /* 0x6c96 */
    KANJI,        /* 0x6c97 */
    KANJI,        /* 0x6c98 */
    KANJI,        /* 0x6c99 */
    KANJI,        /* 0x6c9a */
    KANJI,        /* 0x6c9b */
    KANJI,        /* 0x6c9c */
    KANJI,        /* 0x6c9d */
    KANJI,        /* 0x6c9e */
    KANJI,        /* 0x6c9f */
    KANJI,        /* 0x6ca0 */
    KANJI,        /* 0x6ca1 */
    KANJI,        /* 0x6ca2 */
    KANJI,        /* 0x6ca3 */
    KANJI,        /* 0x6ca4 */
    KANJI,        /* 0x6ca5 */
    KANJI,        /* 0x6ca6 */
    KANJI,        /* 0x6ca7 */
    KANJI,        /* 0x6ca8 */
    KANJI,        /* 0x6ca9 */
    KANJI,        /* 0x6caa */
    KANJI,        /* 0x6cab */
    KANJI,        /* 0x6cac */
    KANJI,        /* 0x6cad */
    KANJI,        /* 0x6cae */
    KANJI,        /* 0x6caf */
    KANJI,        /* 0x6cb0 */
    KANJI,        /* 0x6cb1 */
    KANJI,        /* 0x6cb2 */
    KANJI,        /* 0x6cb3 */
    KANJI,        /* 0x6cb4 */
    KANJI,        /* 0x6cb5 */
    KANJI,        /* 0x6cb6 */
    KANJI,        /* 0x6cb7 */
    KANJI,        /* 0x6cb8 */
    KANJI,        /* 0x6cb9 */
    KANJI,        /* 0x6cba */
    KANJI,        /* 0x6cbb */
    KANJI,        /* 0x6cbc */
    KANJI,        /* 0x6cbd */
    KANJI,        /* 0x6cbe */
    KANJI,        /* 0x6cbf */
    KANJI,        /* 0x6cc0 */
    KANJI,        /* 0x6cc1 */
    KANJI,        /* 0x6cc2 */
    KANJI,        /* 0x6cc3 */
    KANJI,        /* 0x6cc4 */
    KANJI,        /* 0x6cc5 */
    KANJI,        /* 0x6cc6 */
    KANJI,        /* 0x6cc7 */
    KANJI,        /* 0x6cc8 */
    KANJI,        /* 0x6cc9 */
    KANJI,        /* 0x6cca */
    KANJI,        /* 0x6ccb */
    KANJI,        /* 0x6ccc */
    KANJI,        /* 0x6ccd */
    KANJI,        /* 0x6cce */
    KANJI,        /* 0x6ccf */
    KANJI,        /* 0x6cd0 */
    KANJI,        /* 0x6cd1 */
    KANJI,        /* 0x6cd2 */
    KANJI,        /* 0x6cd3 */
    KANJI,        /* 0x6cd4 */
    KANJI,        /* 0x6cd5 */
    KANJI,        /* 0x6cd6 */
    KANJI,        /* 0x6cd7 */
    KANJI,        /* 0x6cd8 */
    KANJI,        /* 0x6cd9 */
    KANJI,        /* 0x6cda */
    KANJI,        /* 0x6cdb */
    KANJI,        /* 0x6cdc */
    KANJI,        /* 0x6cdd */
    KANJI,        /* 0x6cde */
    KANJI,        /* 0x6cdf */
    KANJI,        /* 0x6ce0 */
    KANJI,        /* 0x6ce1 */
    KANJI,        /* 0x6ce2 */
    KANJI,        /* 0x6ce3 */
    KANJI,        /* 0x6ce4 */
    KANJI,        /* 0x6ce5 */
    KANJI,        /* 0x6ce6 */
    KANJI,        /* 0x6ce7 */
    KANJI,        /* 0x6ce8 */
    KANJI,        /* 0x6ce9 */
    KANJI,        /* 0x6cea */
    KANJI,        /* 0x6ceb */
    KANJI,        /* 0x6cec */
    KANJI,        /* 0x6ced */
    KANJI,        /* 0x6cee */
    KANJI,        /* 0x6cef */
    KANJI,        /* 0x6cf0 */
    KANJI,        /* 0x6cf1 */
    KANJI,        /* 0x6cf2 */
    KANJI,        /* 0x6cf3 */
    KANJI,        /* 0x6cf4 */
    KANJI,        /* 0x6cf5 */
    KANJI,        /* 0x6cf6 */
    KANJI,        /* 0x6cf7 */
    KANJI,        /* 0x6cf8 */
    KANJI,        /* 0x6cf9 */
    KANJI,        /* 0x6cfa */
    KANJI,        /* 0x6cfb */
    KANJI,        /* 0x6cfc */
    KANJI,        /* 0x6cfd */
    KANJI,        /* 0x6cfe */
    KANJI,        /* 0x6cff */
    KANJI,        /* 0x6d00 */
    KANJI,        /* 0x6d01 */
    KANJI,        /* 0x6d02 */
    KANJI,        /* 0x6d03 */
    KANJI,        /* 0x6d04 */
    KANJI,        /* 0x6d05 */
    KANJI,        /* 0x6d06 */
    KANJI,        /* 0x6d07 */
    KANJI,        /* 0x6d08 */
    KANJI,        /* 0x6d09 */
    KANJI,        /* 0x6d0a */
    KANJI,        /* 0x6d0b */
    KANJI,        /* 0x6d0c */
    KANJI,        /* 0x6d0d */
    KANJI,        /* 0x6d0e */
    KANJI,        /* 0x6d0f */
    KANJI,        /* 0x6d10 */
    KANJI,        /* 0x6d11 */
    KANJI,        /* 0x6d12 */
    KANJI,        /* 0x6d13 */
    KANJI,        /* 0x6d14 */
    KANJI,        /* 0x6d15 */
    KANJI,        /* 0x6d16 */
    KANJI,        /* 0x6d17 */
    KANJI,        /* 0x6d18 */
    KANJI,        /* 0x6d19 */
    KANJI,        /* 0x6d1a */
    KANJI,        /* 0x6d1b */
    KANJI,        /* 0x6d1c */
    KANJI,        /* 0x6d1d */
    KANJI,        /* 0x6d1e */
    KANJI,        /* 0x6d1f */
    KANJI,        /* 0x6d20 */
    KANJI,        /* 0x6d21 */
    KANJI,        /* 0x6d22 */
    KANJI,        /* 0x6d23 */
    KANJI,        /* 0x6d24 */
    KANJI,        /* 0x6d25 */
    KANJI,        /* 0x6d26 */
    KANJI,        /* 0x6d27 */
    KANJI,        /* 0x6d28 */
    KANJI,        /* 0x6d29 */
    KANJI,        /* 0x6d2a */
    KANJI,        /* 0x6d2b */
    KANJI,        /* 0x6d2c */
    KANJI,        /* 0x6d2d */
    KANJI,        /* 0x6d2e */
    KANJI,        /* 0x6d2f */
    KANJI,        /* 0x6d30 */
    KANJI,        /* 0x6d31 */
    KANJI,        /* 0x6d32 */
    KANJI,        /* 0x6d33 */
    KANJI,        /* 0x6d34 */
    KANJI,        /* 0x6d35 */
    KANJI,        /* 0x6d36 */
    KANJI,        /* 0x6d37 */
    KANJI,        /* 0x6d38 */
    KANJI,        /* 0x6d39 */
    KANJI,        /* 0x6d3a */
    KANJI,        /* 0x6d3b */
    KANJI,        /* 0x6d3c */
    KANJI,        /* 0x6d3d */
    KANJI,        /* 0x6d3e */
    KANJI,        /* 0x6d3f */
    KANJI,        /* 0x6d40 */
    KANJI,        /* 0x6d41 */
    KANJI,        /* 0x6d42 */
    KANJI,        /* 0x6d43 */
    KANJI,        /* 0x6d44 */
    KANJI,        /* 0x6d45 */
    KANJI,        /* 0x6d46 */
    KANJI,        /* 0x6d47 */
    KANJI,        /* 0x6d48 */
    KANJI,        /* 0x6d49 */
    KANJI,        /* 0x6d4a */
    KANJI,        /* 0x6d4b */
    KANJI,        /* 0x6d4c */
    KANJI,        /* 0x6d4d */
    KANJI,        /* 0x6d4e */
    KANJI,        /* 0x6d4f */
    KANJI,        /* 0x6d50 */
    KANJI,        /* 0x6d51 */
    KANJI,        /* 0x6d52 */
    KANJI,        /* 0x6d53 */
    KANJI,        /* 0x6d54 */
    KANJI,        /* 0x6d55 */
    KANJI,        /* 0x6d56 */
    KANJI,        /* 0x6d57 */
    KANJI,        /* 0x6d58 */
    KANJI,        /* 0x6d59 */
    KANJI,        /* 0x6d5a */
    KANJI,        /* 0x6d5b */
    KANJI,        /* 0x6d5c */
    KANJI,        /* 0x6d5d */
    KANJI,        /* 0x6d5e */
    KANJI,        /* 0x6d5f */
    KANJI,        /* 0x6d60 */
    KANJI,        /* 0x6d61 */
    KANJI,        /* 0x6d62 */
    KANJI,        /* 0x6d63 */
    KANJI,        /* 0x6d64 */
    KANJI,        /* 0x6d65 */
    KANJI,        /* 0x6d66 */
    KANJI,        /* 0x6d67 */
    KANJI,        /* 0x6d68 */
    KANJI,        /* 0x6d69 */
    KANJI,        /* 0x6d6a */
    KANJI,        /* 0x6d6b */
    KANJI,        /* 0x6d6c */
    KANJI,        /* 0x6d6d */
    KANJI,        /* 0x6d6e */
    KANJI,        /* 0x6d6f */
    KANJI,        /* 0x6d70 */
    KANJI,        /* 0x6d71 */
    KANJI,        /* 0x6d72 */
    KANJI,        /* 0x6d73 */
    KANJI,        /* 0x6d74 */
    KANJI,        /* 0x6d75 */
    KANJI,        /* 0x6d76 */
    KANJI,        /* 0x6d77 */
    KANJI,        /* 0x6d78 */
    KANJI,        /* 0x6d79 */
    KANJI,        /* 0x6d7a */
    KANJI,        /* 0x6d7b */
    KANJI,        /* 0x6d7c */
    KANJI,        /* 0x6d7d */
    KANJI,        /* 0x6d7e */
    KANJI,        /* 0x6d7f */
    KANJI,        /* 0x6d80 */
    KANJI,        /* 0x6d81 */
    KANJI,        /* 0x6d82 */
    KANJI,        /* 0x6d83 */
    KANJI,        /* 0x6d84 */
    KANJI,        /* 0x6d85 */
    KANJI,        /* 0x6d86 */
    KANJI,        /* 0x6d87 */
    KANJI,        /* 0x6d88 */
    KANJI,        /* 0x6d89 */
    KANJI,        /* 0x6d8a */
    KANJI,        /* 0x6d8b */
    KANJI,        /* 0x6d8c */
    KANJI,        /* 0x6d8d */
    KANJI,        /* 0x6d8e */
    KANJI,        /* 0x6d8f */
    KANJI,        /* 0x6d90 */
    KANJI,        /* 0x6d91 */
    KANJI,        /* 0x6d92 */
    KANJI,        /* 0x6d93 */
    KANJI,        /* 0x6d94 */
    KANJI,        /* 0x6d95 */
    KANJI,        /* 0x6d96 */
    KANJI,        /* 0x6d97 */
    KANJI,        /* 0x6d98 */
    KANJI,        /* 0x6d99 */
    KANJI,        /* 0x6d9a */
    KANJI,        /* 0x6d9b */
    KANJI,        /* 0x6d9c */
    KANJI,        /* 0x6d9d */
    KANJI,        /* 0x6d9e */
    KANJI,        /* 0x6d9f */
    KANJI,        /* 0x6da0 */
    KANJI,        /* 0x6da1 */
    KANJI,        /* 0x6da2 */
    KANJI,        /* 0x6da3 */
    KANJI,        /* 0x6da4 */
    KANJI,        /* 0x6da5 */
    KANJI,        /* 0x6da6 */
    KANJI,        /* 0x6da7 */
    KANJI,        /* 0x6da8 */
    KANJI,        /* 0x6da9 */
    KANJI,        /* 0x6daa */
    KANJI,        /* 0x6dab */
    KANJI,        /* 0x6dac */
    KANJI,        /* 0x6dad */
    KANJI,        /* 0x6dae */
    KANJI,        /* 0x6daf */
    KANJI,        /* 0x6db0 */
    KANJI,        /* 0x6db1 */
    KANJI,        /* 0x6db2 */
    KANJI,        /* 0x6db3 */
    KANJI,        /* 0x6db4 */
    KANJI,        /* 0x6db5 */
    KANJI,        /* 0x6db6 */
    KANJI,        /* 0x6db7 */
    KANJI,        /* 0x6db8 */
    KANJI,        /* 0x6db9 */
    KANJI,        /* 0x6dba */
    KANJI,        /* 0x6dbb */
    KANJI,        /* 0x6dbc */
    KANJI,        /* 0x6dbd */
    KANJI,        /* 0x6dbe */
    KANJI,        /* 0x6dbf */
    KANJI,        /* 0x6dc0 */
    KANJI,        /* 0x6dc1 */
    KANJI,        /* 0x6dc2 */
    KANJI,        /* 0x6dc3 */
    KANJI,        /* 0x6dc4 */
    KANJI,        /* 0x6dc5 */
    KANJI,        /* 0x6dc6 */
    KANJI,        /* 0x6dc7 */
    KANJI,        /* 0x6dc8 */
    KANJI,        /* 0x6dc9 */
    KANJI,        /* 0x6dca */
    KANJI,        /* 0x6dcb */
    KANJI,        /* 0x6dcc */
    KANJI,        /* 0x6dcd */
    KANJI,        /* 0x6dce */
    KANJI,        /* 0x6dcf */
    KANJI,        /* 0x6dd0 */
    KANJI,        /* 0x6dd1 */
    KANJI,        /* 0x6dd2 */
    KANJI,        /* 0x6dd3 */
    KANJI,        /* 0x6dd4 */
    KANJI,        /* 0x6dd5 */
    KANJI,        /* 0x6dd6 */
    KANJI,        /* 0x6dd7 */
    KANJI,        /* 0x6dd8 */
    KANJI,        /* 0x6dd9 */
    KANJI,        /* 0x6dda */
    KANJI,        /* 0x6ddb */
    KANJI,        /* 0x6ddc */
    KANJI,        /* 0x6ddd */
    KANJI,        /* 0x6dde */
    KANJI,        /* 0x6ddf */
    KANJI,        /* 0x6de0 */
    KANJI,        /* 0x6de1 */
    KANJI,        /* 0x6de2 */
    KANJI,        /* 0x6de3 */
    KANJI,        /* 0x6de4 */
    KANJI,        /* 0x6de5 */
    KANJI,        /* 0x6de6 */
    KANJI,        /* 0x6de7 */
    KANJI,        /* 0x6de8 */
    KANJI,        /* 0x6de9 */
    KANJI,        /* 0x6dea */
    KANJI,        /* 0x6deb */
    KANJI,        /* 0x6dec */
    KANJI,        /* 0x6ded */
    KANJI,        /* 0x6dee */
    KANJI,        /* 0x6def */
    KANJI,        /* 0x6df0 */
    KANJI,        /* 0x6df1 */
    KANJI,        /* 0x6df2 */
    KANJI,        /* 0x6df3 */
    KANJI,        /* 0x6df4 */
    KANJI,        /* 0x6df5 */
    KANJI,        /* 0x6df6 */
    KANJI,        /* 0x6df7 */
    KANJI,        /* 0x6df8 */
    KANJI,        /* 0x6df9 */
    KANJI,        /* 0x6dfa */
    KANJI,        /* 0x6dfb */
    KANJI,        /* 0x6dfc */
    KANJI,        /* 0x6dfd */
    KANJI,        /* 0x6dfe */
    KANJI,        /* 0x6dff */
    KANJI,        /* 0x6e00 */
    KANJI,        /* 0x6e01 */
    KANJI,        /* 0x6e02 */
    KANJI,        /* 0x6e03 */
    KANJI,        /* 0x6e04 */
    KANJI,        /* 0x6e05 */
    KANJI,        /* 0x6e06 */
    KANJI,        /* 0x6e07 */
    KANJI,        /* 0x6e08 */
    KANJI,        /* 0x6e09 */
    KANJI,        /* 0x6e0a */
    KANJI,        /* 0x6e0b */
    KANJI,        /* 0x6e0c */
    KANJI,        /* 0x6e0d */
    KANJI,        /* 0x6e0e */
    KANJI,        /* 0x6e0f */
    KANJI,        /* 0x6e10 */
    KANJI,        /* 0x6e11 */
    KANJI,        /* 0x6e12 */
    KANJI,        /* 0x6e13 */
    KANJI,        /* 0x6e14 */
    KANJI,        /* 0x6e15 */
    KANJI,        /* 0x6e16 */
    KANJI,        /* 0x6e17 */
    KANJI,        /* 0x6e18 */
    KANJI,        /* 0x6e19 */
    KANJI,        /* 0x6e1a */
    KANJI,        /* 0x6e1b */
    KANJI,        /* 0x6e1c */
    KANJI,        /* 0x6e1d */
    KANJI,        /* 0x6e1e */
    KANJI,        /* 0x6e1f */
    KANJI,        /* 0x6e20 */
    KANJI,        /* 0x6e21 */
    KANJI,        /* 0x6e22 */
    KANJI,        /* 0x6e23 */
    KANJI,        /* 0x6e24 */
    KANJI,        /* 0x6e25 */
    KANJI,        /* 0x6e26 */
    KANJI,        /* 0x6e27 */
    KANJI,        /* 0x6e28 */
    KANJI,        /* 0x6e29 */
    KANJI,        /* 0x6e2a */
    KANJI,        /* 0x6e2b */
    KANJI,        /* 0x6e2c */
    KANJI,        /* 0x6e2d */
    KANJI,        /* 0x6e2e */
    KANJI,        /* 0x6e2f */
    KANJI,        /* 0x6e30 */
    KANJI,        /* 0x6e31 */
    KANJI,        /* 0x6e32 */
    KANJI,        /* 0x6e33 */
    KANJI,        /* 0x6e34 */
    KANJI,        /* 0x6e35 */
    KANJI,        /* 0x6e36 */
    KANJI,        /* 0x6e37 */
    KANJI,        /* 0x6e38 */
    KANJI,        /* 0x6e39 */
    KANJI,        /* 0x6e3a */
    KANJI,        /* 0x6e3b */
    KANJI,        /* 0x6e3c */
    KANJI,        /* 0x6e3d */
    KANJI,        /* 0x6e3e */
    KANJI,        /* 0x6e3f */
    KANJI,        /* 0x6e40 */
    KANJI,        /* 0x6e41 */
    KANJI,        /* 0x6e42 */
    KANJI,        /* 0x6e43 */
    KANJI,        /* 0x6e44 */
    KANJI,        /* 0x6e45 */
    KANJI,        /* 0x6e46 */
    KANJI,        /* 0x6e47 */
    KANJI,        /* 0x6e48 */
    KANJI,        /* 0x6e49 */
    KANJI,        /* 0x6e4a */
    KANJI,        /* 0x6e4b */
    KANJI,        /* 0x6e4c */
    KANJI,        /* 0x6e4d */
    KANJI,        /* 0x6e4e */
    KANJI,        /* 0x6e4f */
    KANJI,        /* 0x6e50 */
    KANJI,        /* 0x6e51 */
    KANJI,        /* 0x6e52 */
    KANJI,        /* 0x6e53 */
    KANJI,        /* 0x6e54 */
    KANJI,        /* 0x6e55 */
    KANJI,        /* 0x6e56 */
    KANJI,        /* 0x6e57 */
    KANJI,        /* 0x6e58 */
    KANJI,        /* 0x6e59 */
    KANJI,        /* 0x6e5a */
    KANJI,        /* 0x6e5b */
    KANJI,        /* 0x6e5c */
    KANJI,        /* 0x6e5d */
    KANJI,        /* 0x6e5e */
    KANJI,        /* 0x6e5f */
    KANJI,        /* 0x6e60 */
    KANJI,        /* 0x6e61 */
    KANJI,        /* 0x6e62 */
    KANJI,        /* 0x6e63 */
    KANJI,        /* 0x6e64 */
    KANJI,        /* 0x6e65 */
    KANJI,        /* 0x6e66 */
    KANJI,        /* 0x6e67 */
    KANJI,        /* 0x6e68 */
    KANJI,        /* 0x6e69 */
    KANJI,        /* 0x6e6a */
    KANJI,        /* 0x6e6b */
    KANJI,        /* 0x6e6c */
    KANJI,        /* 0x6e6d */
    KANJI,        /* 0x6e6e */
    KANJI,        /* 0x6e6f */
    KANJI,        /* 0x6e70 */
    KANJI,        /* 0x6e71 */
    KANJI,        /* 0x6e72 */
    KANJI,        /* 0x6e73 */
    KANJI,        /* 0x6e74 */
    KANJI,        /* 0x6e75 */
    KANJI,        /* 0x6e76 */
    KANJI,        /* 0x6e77 */
    KANJI,        /* 0x6e78 */
    KANJI,        /* 0x6e79 */
    KANJI,        /* 0x6e7a */
    KANJI,        /* 0x6e7b */
    KANJI,        /* 0x6e7c */
    KANJI,        /* 0x6e7d */
    KANJI,        /* 0x6e7e */
    KANJI,        /* 0x6e7f */
    KANJI,        /* 0x6e80 */
    KANJI,        /* 0x6e81 */
    KANJI,        /* 0x6e82 */
    KANJI,        /* 0x6e83 */
    KANJI,        /* 0x6e84 */
    KANJI,        /* 0x6e85 */
    KANJI,        /* 0x6e86 */
    KANJI,        /* 0x6e87 */
    KANJI,        /* 0x6e88 */
    KANJI,        /* 0x6e89 */
    KANJI,        /* 0x6e8a */
    KANJI,        /* 0x6e8b */
    KANJI,        /* 0x6e8c */
    KANJI,        /* 0x6e8d */
    KANJI,        /* 0x6e8e */
    KANJI,        /* 0x6e8f */
    KANJI,        /* 0x6e90 */
    KANJI,        /* 0x6e91 */
    KANJI,        /* 0x6e92 */
    KANJI,        /* 0x6e93 */
    KANJI,        /* 0x6e94 */
    KANJI,        /* 0x6e95 */
    KANJI,        /* 0x6e96 */
    KANJI,        /* 0x6e97 */
    KANJI,        /* 0x6e98 */
    KANJI,        /* 0x6e99 */
    KANJI,        /* 0x6e9a */
    KANJI,        /* 0x6e9b */
    KANJI,        /* 0x6e9c */
    KANJI,        /* 0x6e9d */
    KANJI,        /* 0x6e9e */
    KANJI,        /* 0x6e9f */
    KANJI,        /* 0x6ea0 */
    KANJI,        /* 0x6ea1 */
    KANJI,        /* 0x6ea2 */
    KANJI,        /* 0x6ea3 */
    KANJI,        /* 0x6ea4 */
    KANJI,        /* 0x6ea5 */
    KANJI,        /* 0x6ea6 */
    KANJI,        /* 0x6ea7 */
    KANJI,        /* 0x6ea8 */
    KANJI,        /* 0x6ea9 */
    KANJI,        /* 0x6eaa */
    KANJI,        /* 0x6eab */
    KANJI,        /* 0x6eac */
    KANJI,        /* 0x6ead */
    KANJI,        /* 0x6eae */
    KANJI,        /* 0x6eaf */
    KANJI,        /* 0x6eb0 */
    KANJI,        /* 0x6eb1 */
    KANJI,        /* 0x6eb2 */
    KANJI,        /* 0x6eb3 */
    KANJI,        /* 0x6eb4 */
    KANJI,        /* 0x6eb5 */
    KANJI,        /* 0x6eb6 */
    KANJI,        /* 0x6eb7 */
    KANJI,        /* 0x6eb8 */
    KANJI,        /* 0x6eb9 */
    KANJI,        /* 0x6eba */
    KANJI,        /* 0x6ebb */
    KANJI,        /* 0x6ebc */
    KANJI,        /* 0x6ebd */
    KANJI,        /* 0x6ebe */
    KANJI,        /* 0x6ebf */
    KANJI,        /* 0x6ec0 */
    KANJI,        /* 0x6ec1 */
    KANJI,        /* 0x6ec2 */
    KANJI,        /* 0x6ec3 */
    KANJI,        /* 0x6ec4 */
    KANJI,        /* 0x6ec5 */
    KANJI,        /* 0x6ec6 */
    KANJI,        /* 0x6ec7 */
    KANJI,        /* 0x6ec8 */
    KANJI,        /* 0x6ec9 */
    KANJI,        /* 0x6eca */
    KANJI,        /* 0x6ecb */
    KANJI,        /* 0x6ecc */
    KANJI,        /* 0x6ecd */
    KANJI,        /* 0x6ece */
    KANJI,        /* 0x6ecf */
    KANJI,        /* 0x6ed0 */
    KANJI,        /* 0x6ed1 */
    KANJI,        /* 0x6ed2 */
    KANJI,        /* 0x6ed3 */
    KANJI,        /* 0x6ed4 */
    KANJI,        /* 0x6ed5 */
    KANJI,        /* 0x6ed6 */
    KANJI,        /* 0x6ed7 */
    KANJI,        /* 0x6ed8 */
    KANJI,        /* 0x6ed9 */
    KANJI,        /* 0x6eda */
    KANJI,        /* 0x6edb */
    KANJI,        /* 0x6edc */
    KANJI,        /* 0x6edd */
    KANJI,        /* 0x6ede */
    KANJI,        /* 0x6edf */
    KANJI,        /* 0x6ee0 */
    KANJI,        /* 0x6ee1 */
    KANJI,        /* 0x6ee2 */
    KANJI,        /* 0x6ee3 */
    KANJI,        /* 0x6ee4 */
    KANJI,        /* 0x6ee5 */
    KANJI,        /* 0x6ee6 */
    KANJI,        /* 0x6ee7 */
    KANJI,        /* 0x6ee8 */
    KANJI,        /* 0x6ee9 */
    KANJI,        /* 0x6eea */
    KANJI,        /* 0x6eeb */
    KANJI,        /* 0x6eec */
    KANJI,        /* 0x6eed */
    KANJI,        /* 0x6eee */
    KANJI,        /* 0x6eef */
    KANJI,        /* 0x6ef0 */
    KANJI,        /* 0x6ef1 */
    KANJI,        /* 0x6ef2 */
    KANJI,        /* 0x6ef3 */
    KANJI,        /* 0x6ef4 */
    KANJI,        /* 0x6ef5 */
    KANJI,        /* 0x6ef6 */
    KANJI,        /* 0x6ef7 */
    KANJI,        /* 0x6ef8 */
    KANJI,        /* 0x6ef9 */
    KANJI,        /* 0x6efa */
    KANJI,        /* 0x6efb */
    KANJI,        /* 0x6efc */
    KANJI,        /* 0x6efd */
    KANJI,        /* 0x6efe */
    KANJI,        /* 0x6eff */
    KANJI,        /* 0x6f00 */
    KANJI,        /* 0x6f01 */
    KANJI,        /* 0x6f02 */
    KANJI,        /* 0x6f03 */
    KANJI,        /* 0x6f04 */
    KANJI,        /* 0x6f05 */
    KANJI,        /* 0x6f06 */
    KANJI,        /* 0x6f07 */
    KANJI,        /* 0x6f08 */
    KANJI,        /* 0x6f09 */
    KANJI,        /* 0x6f0a */
    KANJI,        /* 0x6f0b */
    KANJI,        /* 0x6f0c */
    KANJI,        /* 0x6f0d */
    KANJI,        /* 0x6f0e */
    KANJI,        /* 0x6f0f */
    KANJI,        /* 0x6f10 */
    KANJI,        /* 0x6f11 */
    KANJI,        /* 0x6f12 */
    KANJI,        /* 0x6f13 */
    KANJI,        /* 0x6f14 */
    KANJI,        /* 0x6f15 */
    KANJI,        /* 0x6f16 */
    KANJI,        /* 0x6f17 */
    KANJI,        /* 0x6f18 */
    KANJI,        /* 0x6f19 */
    KANJI,        /* 0x6f1a */
    KANJI,        /* 0x6f1b */
    KANJI,        /* 0x6f1c */
    KANJI,        /* 0x6f1d */
    KANJI,        /* 0x6f1e */
    KANJI,        /* 0x6f1f */
    KANJI,        /* 0x6f20 */
    KANJI,        /* 0x6f21 */
    KANJI,        /* 0x6f22 */
    KANJI,        /* 0x6f23 */
    KANJI,        /* 0x6f24 */
    KANJI,        /* 0x6f25 */
    KANJI,        /* 0x6f26 */
    KANJI,        /* 0x6f27 */
    KANJI,        /* 0x6f28 */
    KANJI,        /* 0x6f29 */
    KANJI,        /* 0x6f2a */
    KANJI,        /* 0x6f2b */
    KANJI,        /* 0x6f2c */
    KANJI,        /* 0x6f2d */
    KANJI,        /* 0x6f2e */
    KANJI,        /* 0x6f2f */
    KANJI,        /* 0x6f30 */
    KANJI,        /* 0x6f31 */
    KANJI,        /* 0x6f32 */
    KANJI,        /* 0x6f33 */
    KANJI,        /* 0x6f34 */
    KANJI,        /* 0x6f35 */
    KANJI,        /* 0x6f36 */
    KANJI,        /* 0x6f37 */
    KANJI,        /* 0x6f38 */
    KANJI,        /* 0x6f39 */
    KANJI,        /* 0x6f3a */
    KANJI,        /* 0x6f3b */
    KANJI,        /* 0x6f3c */
    KANJI,        /* 0x6f3d */
    KANJI,        /* 0x6f3e */
    KANJI,        /* 0x6f3f */
    KANJI,        /* 0x6f40 */
    KANJI,        /* 0x6f41 */
    KANJI,        /* 0x6f42 */
    KANJI,        /* 0x6f43 */
    KANJI,        /* 0x6f44 */
    KANJI,        /* 0x6f45 */
    KANJI,        /* 0x6f46 */
    KANJI,        /* 0x6f47 */
    KANJI,        /* 0x6f48 */
    KANJI,        /* 0x6f49 */
    KANJI,        /* 0x6f4a */
    KANJI,        /* 0x6f4b */
    KANJI,        /* 0x6f4c */
    KANJI,        /* 0x6f4d */
    KANJI,        /* 0x6f4e */
    KANJI,        /* 0x6f4f */
    KANJI,        /* 0x6f50 */
    KANJI,        /* 0x6f51 */
    KANJI,        /* 0x6f52 */
    KANJI,        /* 0x6f53 */
    KANJI,        /* 0x6f54 */
    KANJI,        /* 0x6f55 */
    KANJI,        /* 0x6f56 */
    KANJI,        /* 0x6f57 */
    KANJI,        /* 0x6f58 */
    KANJI,        /* 0x6f59 */
    KANJI,        /* 0x6f5a */
    KANJI,        /* 0x6f5b */
    KANJI,        /* 0x6f5c */
    KANJI,        /* 0x6f5d */
    KANJI,        /* 0x6f5e */
    KANJI,        /* 0x6f5f */
    KANJI,        /* 0x6f60 */
    KANJI,        /* 0x6f61 */
    KANJI,        /* 0x6f62 */
    KANJI,        /* 0x6f63 */
    KANJI,        /* 0x6f64 */
    KANJI,        /* 0x6f65 */
    KANJI,        /* 0x6f66 */
    KANJI,        /* 0x6f67 */
    KANJI,        /* 0x6f68 */
    KANJI,        /* 0x6f69 */
    KANJI,        /* 0x6f6a */
    KANJI,        /* 0x6f6b */
    KANJI,        /* 0x6f6c */
    KANJI,        /* 0x6f6d */
    KANJI,        /* 0x6f6e */
    KANJI,        /* 0x6f6f */
    KANJI,        /* 0x6f70 */
    KANJI,        /* 0x6f71 */
    KANJI,        /* 0x6f72 */
    KANJI,        /* 0x6f73 */
    KANJI,        /* 0x6f74 */
    KANJI,        /* 0x6f75 */
    KANJI,        /* 0x6f76 */
    KANJI,        /* 0x6f77 */
    KANJI,        /* 0x6f78 */
    KANJI,        /* 0x6f79 */
    KANJI,        /* 0x6f7a */
    KANJI,        /* 0x6f7b */
    KANJI,        /* 0x6f7c */
    KANJI,        /* 0x6f7d */
    KANJI,        /* 0x6f7e */
    KANJI,        /* 0x6f7f */
    KANJI,        /* 0x6f80 */
    KANJI,        /* 0x6f81 */
    KANJI,        /* 0x6f82 */
    KANJI,        /* 0x6f83 */
    KANJI,        /* 0x6f84 */
    KANJI,        /* 0x6f85 */
    KANJI,        /* 0x6f86 */
    KANJI,        /* 0x6f87 */
    KANJI,        /* 0x6f88 */
    KANJI,        /* 0x6f89 */
    KANJI,        /* 0x6f8a */
    KANJI,        /* 0x6f8b */
    KANJI,        /* 0x6f8c */
    KANJI,        /* 0x6f8d */
    KANJI,        /* 0x6f8e */
    KANJI,        /* 0x6f8f */
    KANJI,        /* 0x6f90 */
    KANJI,        /* 0x6f91 */
    KANJI,        /* 0x6f92 */
    KANJI,        /* 0x6f93 */
    KANJI,        /* 0x6f94 */
    KANJI,        /* 0x6f95 */
    KANJI,        /* 0x6f96 */
    KANJI,        /* 0x6f97 */
    KANJI,        /* 0x6f98 */
    KANJI,        /* 0x6f99 */
    KANJI,        /* 0x6f9a */
    KANJI,        /* 0x6f9b */
    KANJI,        /* 0x6f9c */
    KANJI,        /* 0x6f9d */
    KANJI,        /* 0x6f9e */
    KANJI,        /* 0x6f9f */
    KANJI,        /* 0x6fa0 */
    KANJI,        /* 0x6fa1 */
    KANJI,        /* 0x6fa2 */
    KANJI,        /* 0x6fa3 */
    KANJI,        /* 0x6fa4 */
    KANJI,        /* 0x6fa5 */
    KANJI,        /* 0x6fa6 */
    KANJI,        /* 0x6fa7 */
    KANJI,        /* 0x6fa8 */
    KANJI,        /* 0x6fa9 */
    KANJI,        /* 0x6faa */
    KANJI,        /* 0x6fab */
    KANJI,        /* 0x6fac */
    KANJI,        /* 0x6fad */
    KANJI,        /* 0x6fae */
    KANJI,        /* 0x6faf */
    KANJI,        /* 0x6fb0 */
    KANJI,        /* 0x6fb1 */
    KANJI,        /* 0x6fb2 */
    KANJI,        /* 0x6fb3 */
    KANJI,        /* 0x6fb4 */
    KANJI,        /* 0x6fb5 */
    KANJI,        /* 0x6fb6 */
    KANJI,        /* 0x6fb7 */
    KANJI,        /* 0x6fb8 */
    KANJI,        /* 0x6fb9 */
    KANJI,        /* 0x6fba */
    KANJI,        /* 0x6fbb */
    KANJI,        /* 0x6fbc */
    KANJI,        /* 0x6fbd */
    KANJI,        /* 0x6fbe */
    KANJI,        /* 0x6fbf */
    KANJI,        /* 0x6fc0 */
    KANJI,        /* 0x6fc1 */
    KANJI,        /* 0x6fc2 */
    KANJI,        /* 0x6fc3 */
    KANJI,        /* 0x6fc4 */
    KANJI,        /* 0x6fc5 */
    KANJI,        /* 0x6fc6 */
    KANJI,        /* 0x6fc7 */
    KANJI,        /* 0x6fc8 */
    KANJI,        /* 0x6fc9 */
    KANJI,        /* 0x6fca */
    KANJI,        /* 0x6fcb */
    KANJI,        /* 0x6fcc */
    KANJI,        /* 0x6fcd */
    KANJI,        /* 0x6fce */
    KANJI,        /* 0x6fcf */
    KANJI,        /* 0x6fd0 */
    KANJI,        /* 0x6fd1 */
    KANJI,        /* 0x6fd2 */
    KANJI,        /* 0x6fd3 */
    KANJI,        /* 0x6fd4 */
    KANJI,        /* 0x6fd5 */
    KANJI,        /* 0x6fd6 */
    KANJI,        /* 0x6fd7 */
    KANJI,        /* 0x6fd8 */
    KANJI,        /* 0x6fd9 */
    KANJI,        /* 0x6fda */
    KANJI,        /* 0x6fdb */
    KANJI,        /* 0x6fdc */
    KANJI,        /* 0x6fdd */
    KANJI,        /* 0x6fde */
    KANJI,        /* 0x6fdf */
    KANJI,        /* 0x6fe0 */
    KANJI,        /* 0x6fe1 */
    KANJI,        /* 0x6fe2 */
    KANJI,        /* 0x6fe3 */
    KANJI,        /* 0x6fe4 */
    KANJI,        /* 0x6fe5 */
    KANJI,        /* 0x6fe6 */
    KANJI,        /* 0x6fe7 */
    KANJI,        /* 0x6fe8 */
    KANJI,        /* 0x6fe9 */
    KANJI,        /* 0x6fea */
    KANJI,        /* 0x6feb */
    KANJI,        /* 0x6fec */
    KANJI,        /* 0x6fed */
    KANJI,        /* 0x6fee */
    KANJI,        /* 0x6fef */
    KANJI,        /* 0x6ff0 */
    KANJI,        /* 0x6ff1 */
    KANJI,        /* 0x6ff2 */
    KANJI,        /* 0x6ff3 */
    KANJI,        /* 0x6ff4 */
    KANJI,        /* 0x6ff5 */
    KANJI,        /* 0x6ff6 */
    KANJI,        /* 0x6ff7 */
    KANJI,        /* 0x6ff8 */
    KANJI,        /* 0x6ff9 */
    KANJI,        /* 0x6ffa */
    KANJI,        /* 0x6ffb */
    KANJI,        /* 0x6ffc */
    KANJI,        /* 0x6ffd */
    KANJI,        /* 0x6ffe */
    KANJI,        /* 0x6fff */
    KANJI,        /* 0x7000 */
    KANJI,        /* 0x7001 */
    KANJI,        /* 0x7002 */
    KANJI,        /* 0x7003 */
    KANJI,        /* 0x7004 */
    KANJI,        /* 0x7005 */
    KANJI,        /* 0x7006 */
    KANJI,        /* 0x7007 */
    KANJI,        /* 0x7008 */
    KANJI,        /* 0x7009 */
    KANJI,        /* 0x700a */
    KANJI,        /* 0x700b */
    KANJI,        /* 0x700c */
    KANJI,        /* 0x700d */
    KANJI,        /* 0x700e */
    KANJI,        /* 0x700f */
    KANJI,        /* 0x7010 */
    KANJI,        /* 0x7011 */
    KANJI,        /* 0x7012 */
    KANJI,        /* 0x7013 */
    KANJI,        /* 0x7014 */
    KANJI,        /* 0x7015 */
    KANJI,        /* 0x7016 */
    KANJI,        /* 0x7017 */
    KANJI,        /* 0x7018 */
    KANJI,        /* 0x7019 */
    KANJI,        /* 0x701a */
    KANJI,        /* 0x701b */
    KANJI,        /* 0x701c */
    KANJI,        /* 0x701d */
    KANJI,        /* 0x701e */
    KANJI,        /* 0x701f */
    KANJI,        /* 0x7020 */
    KANJI,        /* 0x7021 */
    KANJI,        /* 0x7022 */
    KANJI,        /* 0x7023 */
    KANJI,        /* 0x7024 */
    KANJI,        /* 0x7025 */
    KANJI,        /* 0x7026 */
    KANJI,        /* 0x7027 */
    KANJI,        /* 0x7028 */
    KANJI,        /* 0x7029 */
    KANJI,        /* 0x702a */
    KANJI,        /* 0x702b */
    KANJI,        /* 0x702c */
    KANJI,        /* 0x702d */
    KANJI,        /* 0x702e */
    KANJI,        /* 0x702f */
    KANJI,        /* 0x7030 */
    KANJI,        /* 0x7031 */
    KANJI,        /* 0x7032 */
    KANJI,        /* 0x7033 */
    KANJI,        /* 0x7034 */
    KANJI,        /* 0x7035 */
    KANJI,        /* 0x7036 */
    KANJI,        /* 0x7037 */
    KANJI,        /* 0x7038 */
    KANJI,        /* 0x7039 */
    KANJI,        /* 0x703a */
    KANJI,        /* 0x703b */
    KANJI,        /* 0x703c */
    KANJI,        /* 0x703d */
    KANJI,        /* 0x703e */
    KANJI,        /* 0x703f */
    KANJI,        /* 0x7040 */
    KANJI,        /* 0x7041 */
    KANJI,        /* 0x7042 */
    KANJI,        /* 0x7043 */
    KANJI,        /* 0x7044 */
    KANJI,        /* 0x7045 */
    KANJI,        /* 0x7046 */
    KANJI,        /* 0x7047 */
    KANJI,        /* 0x7048 */
    KANJI,        /* 0x7049 */
    KANJI,        /* 0x704a */
    KANJI,        /* 0x704b */
    KANJI,        /* 0x704c */
    KANJI,        /* 0x704d */
    KANJI,        /* 0x704e */
    KANJI,        /* 0x704f */
    KANJI,        /* 0x7050 */
    KANJI,        /* 0x7051 */
    KANJI,        /* 0x7052 */
    KANJI,        /* 0x7053 */
    KANJI,        /* 0x7054 */
    KANJI,        /* 0x7055 */
    KANJI,        /* 0x7056 */
    KANJI,        /* 0x7057 */
    KANJI,        /* 0x7058 */
    KANJI,        /* 0x7059 */
    KANJI,        /* 0x705a */
    KANJI,        /* 0x705b */
    KANJI,        /* 0x705c */
    KANJI,        /* 0x705d */
    KANJI,        /* 0x705e */
    KANJI,        /* 0x705f */
    KANJI,        /* 0x7060 */
    KANJI,        /* 0x7061 */
    KANJI,        /* 0x7062 */
    KANJI,        /* 0x7063 */
    KANJI,        /* 0x7064 */
    KANJI,        /* 0x7065 */
    KANJI,        /* 0x7066 */
    KANJI,        /* 0x7067 */
    KANJI,        /* 0x7068 */
    KANJI,        /* 0x7069 */
    KANJI,        /* 0x706a */
    KANJI,        /* 0x706b */
    KANJI,        /* 0x706c */
    KANJI,        /* 0x706d */
    KANJI,        /* 0x706e */
    KANJI,        /* 0x706f */
    KANJI,        /* 0x7070 */
    KANJI,        /* 0x7071 */
    KANJI,        /* 0x7072 */
    KANJI,        /* 0x7073 */
    KANJI,        /* 0x7074 */
    KANJI,        /* 0x7075 */
    KANJI,        /* 0x7076 */
    KANJI,        /* 0x7077 */
    KANJI,        /* 0x7078 */
    KANJI,        /* 0x7079 */
    KANJI,        /* 0x707a */
    KANJI,        /* 0x707b */
    KANJI,        /* 0x707c */
    KANJI,        /* 0x707d */
    KANJI,        /* 0x707e */
    KANJI,        /* 0x707f */
    KANJI,        /* 0x7080 */
    KANJI,        /* 0x7081 */
    KANJI,        /* 0x7082 */
    KANJI,        /* 0x7083 */
    KANJI,        /* 0x7084 */
    KANJI,        /* 0x7085 */
    KANJI,        /* 0x7086 */
    KANJI,        /* 0x7087 */
    KANJI,        /* 0x7088 */
    KANJI,        /* 0x7089 */
    KANJI,        /* 0x708a */
    KANJI,        /* 0x708b */
    KANJI,        /* 0x708c */
    KANJI,        /* 0x708d */
    KANJI,        /* 0x708e */
    KANJI,        /* 0x708f */
    KANJI,        /* 0x7090 */
    KANJI,        /* 0x7091 */
    KANJI,        /* 0x7092 */
    KANJI,        /* 0x7093 */
    KANJI,        /* 0x7094 */
    KANJI,        /* 0x7095 */
    KANJI,        /* 0x7096 */
    KANJI,        /* 0x7097 */
    KANJI,        /* 0x7098 */
    KANJI,        /* 0x7099 */
    KANJI,        /* 0x709a */
    KANJI,        /* 0x709b */
    KANJI,        /* 0x709c */
    KANJI,        /* 0x709d */
    KANJI,        /* 0x709e */
    KANJI,        /* 0x709f */
    KANJI,        /* 0x70a0 */
    KANJI,        /* 0x70a1 */
    KANJI,        /* 0x70a2 */
    KANJI,        /* 0x70a3 */
    KANJI,        /* 0x70a4 */
    KANJI,        /* 0x70a5 */
    KANJI,        /* 0x70a6 */
    KANJI,        /* 0x70a7 */
    KANJI,        /* 0x70a8 */
    KANJI,        /* 0x70a9 */
    KANJI,        /* 0x70aa */
    KANJI,        /* 0x70ab */
    KANJI,        /* 0x70ac */
    KANJI,        /* 0x70ad */
    KANJI,        /* 0x70ae */
    KANJI,        /* 0x70af */
    KANJI,        /* 0x70b0 */
    KANJI,        /* 0x70b1 */
    KANJI,        /* 0x70b2 */
    KANJI,        /* 0x70b3 */
    KANJI,        /* 0x70b4 */
    KANJI,        /* 0x70b5 */
    KANJI,        /* 0x70b6 */
    KANJI,        /* 0x70b7 */
    KANJI,        /* 0x70b8 */
    KANJI,        /* 0x70b9 */
    KANJI,        /* 0x70ba */
    KANJI,        /* 0x70bb */
    KANJI,        /* 0x70bc */
    KANJI,        /* 0x70bd */
    KANJI,        /* 0x70be */
    KANJI,        /* 0x70bf */
    KANJI,        /* 0x70c0 */
    KANJI,        /* 0x70c1 */
    KANJI,        /* 0x70c2 */
    KANJI,        /* 0x70c3 */
    KANJI,        /* 0x70c4 */
    KANJI,        /* 0x70c5 */
    KANJI,        /* 0x70c6 */
    KANJI,        /* 0x70c7 */
    KANJI,        /* 0x70c8 */
    KANJI,        /* 0x70c9 */
    KANJI,        /* 0x70ca */
    KANJI,        /* 0x70cb */
    KANJI,        /* 0x70cc */
    KANJI,        /* 0x70cd */
    KANJI,        /* 0x70ce */
    KANJI,        /* 0x70cf */
    KANJI,        /* 0x70d0 */
    KANJI,        /* 0x70d1 */
    KANJI,        /* 0x70d2 */
    KANJI,        /* 0x70d3 */
    KANJI,        /* 0x70d4 */
    KANJI,        /* 0x70d5 */
    KANJI,        /* 0x70d6 */
    KANJI,        /* 0x70d7 */
    KANJI,        /* 0x70d8 */
    KANJI,        /* 0x70d9 */
    KANJI,        /* 0x70da */
    KANJI,        /* 0x70db */
    KANJI,        /* 0x70dc */
    KANJI,        /* 0x70dd */
    KANJI,        /* 0x70de */
    KANJI,        /* 0x70df */
    KANJI,        /* 0x70e0 */
    KANJI,        /* 0x70e1 */
    KANJI,        /* 0x70e2 */
    KANJI,        /* 0x70e3 */
    KANJI,        /* 0x70e4 */
    KANJI,        /* 0x70e5 */
    KANJI,        /* 0x70e6 */
    KANJI,        /* 0x70e7 */
    KANJI,        /* 0x70e8 */
    KANJI,        /* 0x70e9 */
    KANJI,        /* 0x70ea */
    KANJI,        /* 0x70eb */
    KANJI,        /* 0x70ec */
    KANJI,        /* 0x70ed */
    KANJI,        /* 0x70ee */
    KANJI,        /* 0x70ef */
    KANJI,        /* 0x70f0 */
    KANJI,        /* 0x70f1 */
    KANJI,        /* 0x70f2 */
    KANJI,        /* 0x70f3 */
    KANJI,        /* 0x70f4 */
    KANJI,        /* 0x70f5 */
    KANJI,        /* 0x70f6 */
    KANJI,        /* 0x70f7 */
    KANJI,        /* 0x70f8 */
    KANJI,        /* 0x70f9 */
    KANJI,        /* 0x70fa */
    KANJI,        /* 0x70fb */
    KANJI,        /* 0x70fc */
    KANJI,        /* 0x70fd */
    KANJI,        /* 0x70fe */
    KANJI,        /* 0x70ff */
    KANJI,        /* 0x7100 */
    KANJI,        /* 0x7101 */
    KANJI,        /* 0x7102 */
    KANJI,        /* 0x7103 */
    KANJI,        /* 0x7104 */
    KANJI,        /* 0x7105 */
    KANJI,        /* 0x7106 */
    KANJI,        /* 0x7107 */
    KANJI,        /* 0x7108 */
    KANJI,        /* 0x7109 */
    KANJI,        /* 0x710a */
    KANJI,        /* 0x710b */
    KANJI,        /* 0x710c */
    KANJI,        /* 0x710d */
    KANJI,        /* 0x710e */
    KANJI,        /* 0x710f */
    KANJI,        /* 0x7110 */
    KANJI,        /* 0x7111 */
    KANJI,        /* 0x7112 */
    KANJI,        /* 0x7113 */
    KANJI,        /* 0x7114 */
    KANJI,        /* 0x7115 */
    KANJI,        /* 0x7116 */
    KANJI,        /* 0x7117 */
    KANJI,        /* 0x7118 */
    KANJI,        /* 0x7119 */
    KANJI,        /* 0x711a */
    KANJI,        /* 0x711b */
    KANJI,        /* 0x711c */
    KANJI,        /* 0x711d */
    KANJI,        /* 0x711e */
    KANJI,        /* 0x711f */
    KANJI,        /* 0x7120 */
    KANJI,        /* 0x7121 */
    KANJI,        /* 0x7122 */
    KANJI,        /* 0x7123 */
    KANJI,        /* 0x7124 */
    KANJI,        /* 0x7125 */
    KANJI,        /* 0x7126 */
    KANJI,        /* 0x7127 */
    KANJI,        /* 0x7128 */
    KANJI,        /* 0x7129 */
    KANJI,        /* 0x712a */
    KANJI,        /* 0x712b */
    KANJI,        /* 0x712c */
    KANJI,        /* 0x712d */
    KANJI,        /* 0x712e */
    KANJI,        /* 0x712f */
    KANJI,        /* 0x7130 */
    KANJI,        /* 0x7131 */
    KANJI,        /* 0x7132 */
    KANJI,        /* 0x7133 */
    KANJI,        /* 0x7134 */
    KANJI,        /* 0x7135 */
    KANJI,        /* 0x7136 */
    KANJI,        /* 0x7137 */
    KANJI,        /* 0x7138 */
    KANJI,        /* 0x7139 */
    KANJI,        /* 0x713a */
    KANJI,        /* 0x713b */
    KANJI,        /* 0x713c */
    KANJI,        /* 0x713d */
    KANJI,        /* 0x713e */
    KANJI,        /* 0x713f */
    KANJI,        /* 0x7140 */
    KANJI,        /* 0x7141 */
    KANJI,        /* 0x7142 */
    KANJI,        /* 0x7143 */
    KANJI,        /* 0x7144 */
    KANJI,        /* 0x7145 */
    KANJI,        /* 0x7146 */
    KANJI,        /* 0x7147 */
    KANJI,        /* 0x7148 */
    KANJI,        /* 0x7149 */
    KANJI,        /* 0x714a */
    KANJI,        /* 0x714b */
    KANJI,        /* 0x714c */
    KANJI,        /* 0x714d */
    KANJI,        /* 0x714e */
    KANJI,        /* 0x714f */
    KANJI,        /* 0x7150 */
    KANJI,        /* 0x7151 */
    KANJI,        /* 0x7152 */
    KANJI,        /* 0x7153 */
    KANJI,        /* 0x7154 */
    KANJI,        /* 0x7155 */
    KANJI,        /* 0x7156 */
    KANJI,        /* 0x7157 */
    KANJI,        /* 0x7158 */
    KANJI,        /* 0x7159 */
    KANJI,        /* 0x715a */
    KANJI,        /* 0x715b */
    KANJI,        /* 0x715c */
    KANJI,        /* 0x715d */
    KANJI,        /* 0x715e */
    KANJI,        /* 0x715f */
    KANJI,        /* 0x7160 */
    KANJI,        /* 0x7161 */
    KANJI,        /* 0x7162 */
    KANJI,        /* 0x7163 */
    KANJI,        /* 0x7164 */
    KANJI,        /* 0x7165 */
    KANJI,        /* 0x7166 */
    KANJI,        /* 0x7167 */
    KANJI,        /* 0x7168 */
    KANJI,        /* 0x7169 */
    KANJI,        /* 0x716a */
    KANJI,        /* 0x716b */
    KANJI,        /* 0x716c */
    KANJI,        /* 0x716d */
    KANJI,        /* 0x716e */
    KANJI,        /* 0x716f */
    KANJI,        /* 0x7170 */
    KANJI,        /* 0x7171 */
    KANJI,        /* 0x7172 */
    KANJI,        /* 0x7173 */
    KANJI,        /* 0x7174 */
    KANJI,        /* 0x7175 */
    KANJI,        /* 0x7176 */
    KANJI,        /* 0x7177 */
    KANJI,        /* 0x7178 */
    KANJI,        /* 0x7179 */
    KANJI,        /* 0x717a */
    KANJI,        /* 0x717b */
    KANJI,        /* 0x717c */
    KANJI,        /* 0x717d */
    KANJI,        /* 0x717e */
    KANJI,        /* 0x717f */
    KANJI,        /* 0x7180 */
    KANJI,        /* 0x7181 */
    KANJI,        /* 0x7182 */
    KANJI,        /* 0x7183 */
    KANJI,        /* 0x7184 */
    KANJI,        /* 0x7185 */
    KANJI,        /* 0x7186 */
    KANJI,        /* 0x7187 */
    KANJI,        /* 0x7188 */
    KANJI,        /* 0x7189 */
    KANJI,        /* 0x718a */
    KANJI,        /* 0x718b */
    KANJI,        /* 0x718c */
    KANJI,        /* 0x718d */
    KANJI,        /* 0x718e */
    KANJI,        /* 0x718f */
    KANJI,        /* 0x7190 */
    KANJI,        /* 0x7191 */
    KANJI,        /* 0x7192 */
    KANJI,        /* 0x7193 */
    KANJI,        /* 0x7194 */
    KANJI,        /* 0x7195 */
    KANJI,        /* 0x7196 */
    KANJI,        /* 0x7197 */
    KANJI,        /* 0x7198 */
    KANJI,        /* 0x7199 */
    KANJI,        /* 0x719a */
    KANJI,        /* 0x719b */
    KANJI,        /* 0x719c */
    KANJI,        /* 0x719d */
    KANJI,        /* 0x719e */
    KANJI,        /* 0x719f */
    KANJI,        /* 0x71a0 */
    KANJI,        /* 0x71a1 */
    KANJI,        /* 0x71a2 */
    KANJI,        /* 0x71a3 */
    KANJI,        /* 0x71a4 */
    KANJI,        /* 0x71a5 */
    KANJI,        /* 0x71a6 */
    KANJI,        /* 0x71a7 */
    KANJI,        /* 0x71a8 */
    KANJI,        /* 0x71a9 */
    KANJI,        /* 0x71aa */
    KANJI,        /* 0x71ab */
    KANJI,        /* 0x71ac */
    KANJI,        /* 0x71ad */
    KANJI,        /* 0x71ae */
    KANJI,        /* 0x71af */
    KANJI,        /* 0x71b0 */
    KANJI,        /* 0x71b1 */
    KANJI,        /* 0x71b2 */
    KANJI,        /* 0x71b3 */
    KANJI,        /* 0x71b4 */
    KANJI,        /* 0x71b5 */
    KANJI,        /* 0x71b6 */
    KANJI,        /* 0x71b7 */
    KANJI,        /* 0x71b8 */
    KANJI,        /* 0x71b9 */
    KANJI,        /* 0x71ba */
    KANJI,        /* 0x71bb */
    KANJI,        /* 0x71bc */
    KANJI,        /* 0x71bd */
    KANJI,        /* 0x71be */
    KANJI,        /* 0x71bf */
    KANJI,        /* 0x71c0 */
    KANJI,        /* 0x71c1 */
    KANJI,        /* 0x71c2 */
    KANJI,        /* 0x71c3 */
    KANJI,        /* 0x71c4 */
    KANJI,        /* 0x71c5 */
    KANJI,        /* 0x71c6 */
    KANJI,        /* 0x71c7 */
    KANJI,        /* 0x71c8 */
    KANJI,        /* 0x71c9 */
    KANJI,        /* 0x71ca */
    KANJI,        /* 0x71cb */
    KANJI,        /* 0x71cc */
    KANJI,        /* 0x71cd */
    KANJI,        /* 0x71ce */
    KANJI,        /* 0x71cf */
    KANJI,        /* 0x71d0 */
    KANJI,        /* 0x71d1 */
    KANJI,        /* 0x71d2 */
    KANJI,        /* 0x71d3 */
    KANJI,        /* 0x71d4 */
    KANJI,        /* 0x71d5 */
    KANJI,        /* 0x71d6 */
    KANJI,        /* 0x71d7 */
    KANJI,        /* 0x71d8 */
    KANJI,        /* 0x71d9 */
    KANJI,        /* 0x71da */
    KANJI,        /* 0x71db */
    KANJI,        /* 0x71dc */
    KANJI,        /* 0x71dd */
    KANJI,        /* 0x71de */
    KANJI,        /* 0x71df */
    KANJI,        /* 0x71e0 */
    KANJI,        /* 0x71e1 */
    KANJI,        /* 0x71e2 */
    KANJI,        /* 0x71e3 */
    KANJI,        /* 0x71e4 */
    KANJI,        /* 0x71e5 */
    KANJI,        /* 0x71e6 */
    KANJI,        /* 0x71e7 */
    KANJI,        /* 0x71e8 */
    KANJI,        /* 0x71e9 */
    KANJI,        /* 0x71ea */
    KANJI,        /* 0x71eb */
    KANJI,        /* 0x71ec */
    KANJI,        /* 0x71ed */
    KANJI,        /* 0x71ee */
    KANJI,        /* 0x71ef */
    KANJI,        /* 0x71f0 */
    KANJI,        /* 0x71f1 */
    KANJI,        /* 0x71f2 */
    KANJI,        /* 0x71f3 */
    KANJI,        /* 0x71f4 */
    KANJI,        /* 0x71f5 */
    KANJI,        /* 0x71f6 */
    KANJI,        /* 0x71f7 */
    KANJI,        /* 0x71f8 */
    KANJI,        /* 0x71f9 */
    KANJI,        /* 0x71fa */
    KANJI,        /* 0x71fb */
    KANJI,        /* 0x71fc */
    KANJI,        /* 0x71fd */
    KANJI,        /* 0x71fe */
    KANJI,        /* 0x71ff */
    KANJI,        /* 0x7200 */
    KANJI,        /* 0x7201 */
    KANJI,        /* 0x7202 */
    KANJI,        /* 0x7203 */
    KANJI,        /* 0x7204 */
    KANJI,        /* 0x7205 */
    KANJI,        /* 0x7206 */
    KANJI,        /* 0x7207 */
    KANJI,        /* 0x7208 */
    KANJI,        /* 0x7209 */
    KANJI,        /* 0x720a */
    KANJI,        /* 0x720b */
    KANJI,        /* 0x720c */
    KANJI,        /* 0x720d */
    KANJI,        /* 0x720e */
    KANJI,        /* 0x720f */
    KANJI,        /* 0x7210 */
    KANJI,        /* 0x7211 */
    KANJI,        /* 0x7212 */
    KANJI,        /* 0x7213 */
    KANJI,        /* 0x7214 */
    KANJI,        /* 0x7215 */
    KANJI,        /* 0x7216 */
    KANJI,        /* 0x7217 */
    KANJI,        /* 0x7218 */
    KANJI,        /* 0x7219 */
    KANJI,        /* 0x721a */
    KANJI,        /* 0x721b */
    KANJI,        /* 0x721c */
    KANJI,        /* 0x721d */
    KANJI,        /* 0x721e */
    KANJI,        /* 0x721f */
    KANJI,        /* 0x7220 */
    KANJI,        /* 0x7221 */
    KANJI,        /* 0x7222 */
    KANJI,        /* 0x7223 */
    KANJI,        /* 0x7224 */
    KANJI,        /* 0x7225 */
    KANJI,        /* 0x7226 */
    KANJI,        /* 0x7227 */
    KANJI,        /* 0x7228 */
    KANJI,        /* 0x7229 */
    KANJI,        /* 0x722a */
    KANJI,        /* 0x722b */
    KANJI,        /* 0x722c */
    KANJI,        /* 0x722d */
    KANJI,        /* 0x722e */
    KANJI,        /* 0x722f */
    KANJI,        /* 0x7230 */
    KANJI,        /* 0x7231 */
    KANJI,        /* 0x7232 */
    KANJI,        /* 0x7233 */
    KANJI,        /* 0x7234 */
    KANJI,        /* 0x7235 */
    KANJI,        /* 0x7236 */
    KANJI,        /* 0x7237 */
    KANJI,        /* 0x7238 */
    KANJI,        /* 0x7239 */
    KANJI,        /* 0x723a */
    KANJI,        /* 0x723b */
    KANJI,        /* 0x723c */
    KANJI,        /* 0x723d */
    KANJI,        /* 0x723e */
    KANJI,        /* 0x723f */
    KANJI,        /* 0x7240 */
    KANJI,        /* 0x7241 */
    KANJI,        /* 0x7242 */
    KANJI,        /* 0x7243 */
    KANJI,        /* 0x7244 */
    KANJI,        /* 0x7245 */
    KANJI,        /* 0x7246 */
    KANJI,        /* 0x7247 */
    KANJI,        /* 0x7248 */
    KANJI,        /* 0x7249 */
    KANJI,        /* 0x724a */
    KANJI,        /* 0x724b */
    KANJI,        /* 0x724c */
    KANJI,        /* 0x724d */
    KANJI,        /* 0x724e */
    KANJI,        /* 0x724f */
    KANJI,        /* 0x7250 */
    KANJI,        /* 0x7251 */
    KANJI,        /* 0x7252 */
    KANJI,        /* 0x7253 */
    KANJI,        /* 0x7254 */
    KANJI,        /* 0x7255 */
    KANJI,        /* 0x7256 */
    KANJI,        /* 0x7257 */
    KANJI,        /* 0x7258 */
    KANJI,        /* 0x7259 */
    KANJI,        /* 0x725a */
    KANJI,        /* 0x725b */
    KANJI,        /* 0x725c */
    KANJI,        /* 0x725d */
    KANJI,        /* 0x725e */
    KANJI,        /* 0x725f */
    KANJI,        /* 0x7260 */
    KANJI,        /* 0x7261 */
    KANJI,        /* 0x7262 */
    KANJI,        /* 0x7263 */
    KANJI,        /* 0x7264 */
    KANJI,        /* 0x7265 */
    KANJI,        /* 0x7266 */
    KANJI,        /* 0x7267 */
    KANJI,        /* 0x7268 */
    KANJI,        /* 0x7269 */
    KANJI,        /* 0x726a */
    KANJI,        /* 0x726b */
    KANJI,        /* 0x726c */
    KANJI,        /* 0x726d */
    KANJI,        /* 0x726e */
    KANJI,        /* 0x726f */
    KANJI,        /* 0x7270 */
    KANJI,        /* 0x7271 */
    KANJI,        /* 0x7272 */
    KANJI,        /* 0x7273 */
    KANJI,        /* 0x7274 */
    KANJI,        /* 0x7275 */
    KANJI,        /* 0x7276 */
    KANJI,        /* 0x7277 */
    KANJI,        /* 0x7278 */
    KANJI,        /* 0x7279 */
    KANJI,        /* 0x727a */
    KANJI,        /* 0x727b */
    KANJI,        /* 0x727c */
    KANJI,        /* 0x727d */
    KANJI,        /* 0x727e */
    KANJI,        /* 0x727f */
    KANJI,        /* 0x7280 */
    KANJI,        /* 0x7281 */
    KANJI,        /* 0x7282 */
    KANJI,        /* 0x7283 */
    KANJI,        /* 0x7284 */
    KANJI,        /* 0x7285 */
    KANJI,        /* 0x7286 */
    KANJI,        /* 0x7287 */
    KANJI,        /* 0x7288 */
    KANJI,        /* 0x7289 */
    KANJI,        /* 0x728a */
    KANJI,        /* 0x728b */
    KANJI,        /* 0x728c */
    KANJI,        /* 0x728d */
    KANJI,        /* 0x728e */
    KANJI,        /* 0x728f */
    KANJI,        /* 0x7290 */
    KANJI,        /* 0x7291 */
    KANJI,        /* 0x7292 */
    KANJI,        /* 0x7293 */
    KANJI,        /* 0x7294 */
    KANJI,        /* 0x7295 */
    KANJI,        /* 0x7296 */
    KANJI,        /* 0x7297 */
    KANJI,        /* 0x7298 */
    KANJI,        /* 0x7299 */
    KANJI,        /* 0x729a */
    KANJI,        /* 0x729b */
    KANJI,        /* 0x729c */
    KANJI,        /* 0x729d */
    KANJI,        /* 0x729e */
    KANJI,        /* 0x729f */
    KANJI,        /* 0x72a0 */
    KANJI,        /* 0x72a1 */
    KANJI,        /* 0x72a2 */
    KANJI,        /* 0x72a3 */
    KANJI,        /* 0x72a4 */
    KANJI,        /* 0x72a5 */
    KANJI,        /* 0x72a6 */
    KANJI,        /* 0x72a7 */
    KANJI,        /* 0x72a8 */
    KANJI,        /* 0x72a9 */
    KANJI,        /* 0x72aa */
    KANJI,        /* 0x72ab */
    KANJI,        /* 0x72ac */
    KANJI,        /* 0x72ad */
    KANJI,        /* 0x72ae */
    KANJI,        /* 0x72af */
    KANJI,        /* 0x72b0 */
    KANJI,        /* 0x72b1 */
    KANJI,        /* 0x72b2 */
    KANJI,        /* 0x72b3 */
    KANJI,        /* 0x72b4 */
    KANJI,        /* 0x72b5 */
    KANJI,        /* 0x72b6 */
    KANJI,        /* 0x72b7 */
    KANJI,        /* 0x72b8 */
    KANJI,        /* 0x72b9 */
    KANJI,        /* 0x72ba */
    KANJI,        /* 0x72bb */
    KANJI,        /* 0x72bc */
    KANJI,        /* 0x72bd */
    KANJI,        /* 0x72be */
    KANJI,        /* 0x72bf */
    KANJI,        /* 0x72c0 */
    KANJI,        /* 0x72c1 */
    KANJI,        /* 0x72c2 */
    KANJI,        /* 0x72c3 */
    KANJI,        /* 0x72c4 */
    KANJI,        /* 0x72c5 */
    KANJI,        /* 0x72c6 */
    KANJI,        /* 0x72c7 */
    KANJI,        /* 0x72c8 */
    KANJI,        /* 0x72c9 */
    KANJI,        /* 0x72ca */
    KANJI,        /* 0x72cb */
    KANJI,        /* 0x72cc */
    KANJI,        /* 0x72cd */
    KANJI,        /* 0x72ce */
    KANJI,        /* 0x72cf */
    KANJI,        /* 0x72d0 */
    KANJI,        /* 0x72d1 */
    KANJI,        /* 0x72d2 */
    KANJI,        /* 0x72d3 */
    KANJI,        /* 0x72d4 */
    KANJI,        /* 0x72d5 */
    KANJI,        /* 0x72d6 */
    KANJI,        /* 0x72d7 */
    KANJI,        /* 0x72d8 */
    KANJI,        /* 0x72d9 */
    KANJI,        /* 0x72da */
    KANJI,        /* 0x72db */
    KANJI,        /* 0x72dc */
    KANJI,        /* 0x72dd */
    KANJI,        /* 0x72de */
    KANJI,        /* 0x72df */
    KANJI,        /* 0x72e0 */
    KANJI,        /* 0x72e1 */
    KANJI,        /* 0x72e2 */
    KANJI,        /* 0x72e3 */
    KANJI,        /* 0x72e4 */
    KANJI,        /* 0x72e5 */
    KANJI,        /* 0x72e6 */
    KANJI,        /* 0x72e7 */
    KANJI,        /* 0x72e8 */
    KANJI,        /* 0x72e9 */
    KANJI,        /* 0x72ea */
    KANJI,        /* 0x72eb */
    KANJI,        /* 0x72ec */
    KANJI,        /* 0x72ed */
    KANJI,        /* 0x72ee */
    KANJI,        /* 0x72ef */
    KANJI,        /* 0x72f0 */
    KANJI,        /* 0x72f1 */
    KANJI,        /* 0x72f2 */
    KANJI,        /* 0x72f3 */
    KANJI,        /* 0x72f4 */
    KANJI,        /* 0x72f5 */
    KANJI,        /* 0x72f6 */
    KANJI,        /* 0x72f7 */
    KANJI,        /* 0x72f8 */
    KANJI,        /* 0x72f9 */
    KANJI,        /* 0x72fa */
    KANJI,        /* 0x72fb */
    KANJI,        /* 0x72fc */
    KANJI,        /* 0x72fd */
    KANJI,        /* 0x72fe */
    KANJI,        /* 0x72ff */
    KANJI,        /* 0x7300 */
    KANJI,        /* 0x7301 */
    KANJI,        /* 0x7302 */
    KANJI,        /* 0x7303 */
    KANJI,        /* 0x7304 */
    KANJI,        /* 0x7305 */
    KANJI,        /* 0x7306 */
    KANJI,        /* 0x7307 */
    KANJI,        /* 0x7308 */
    KANJI,        /* 0x7309 */
    KANJI,        /* 0x730a */
    KANJI,        /* 0x730b */
    KANJI,        /* 0x730c */
    KANJI,        /* 0x730d */
    KANJI,        /* 0x730e */
    KANJI,        /* 0x730f */
    KANJI,        /* 0x7310 */
    KANJI,        /* 0x7311 */
    KANJI,        /* 0x7312 */
    KANJI,        /* 0x7313 */
    KANJI,        /* 0x7314 */
    KANJI,        /* 0x7315 */
    KANJI,        /* 0x7316 */
    KANJI,        /* 0x7317 */
    KANJI,        /* 0x7318 */
    KANJI,        /* 0x7319 */
    KANJI,        /* 0x731a */
    KANJI,        /* 0x731b */
    KANJI,        /* 0x731c */
    KANJI,        /* 0x731d */
    KANJI,        /* 0x731e */
    KANJI,        /* 0x731f */
    KANJI,        /* 0x7320 */
    KANJI,        /* 0x7321 */
    KANJI,        /* 0x7322 */
    KANJI,        /* 0x7323 */
    KANJI,        /* 0x7324 */
    KANJI,        /* 0x7325 */
    KANJI,        /* 0x7326 */
    KANJI,        /* 0x7327 */
    KANJI,        /* 0x7328 */
    KANJI,        /* 0x7329 */
    KANJI,        /* 0x732a */
    KANJI,        /* 0x732b */
    KANJI,        /* 0x732c */
    KANJI,        /* 0x732d */
    KANJI,        /* 0x732e */
    KANJI,        /* 0x732f */
    KANJI,        /* 0x7330 */
    KANJI,        /* 0x7331 */
    KANJI,        /* 0x7332 */
    KANJI,        /* 0x7333 */
    KANJI,        /* 0x7334 */
    KANJI,        /* 0x7335 */
    KANJI,        /* 0x7336 */
    KANJI,        /* 0x7337 */
    KANJI,        /* 0x7338 */
    KANJI,        /* 0x7339 */
    KANJI,        /* 0x733a */
    KANJI,        /* 0x733b */
    KANJI,        /* 0x733c */
    KANJI,        /* 0x733d */
    KANJI,        /* 0x733e */
    KANJI,        /* 0x733f */
    KANJI,        /* 0x7340 */
    KANJI,        /* 0x7341 */
    KANJI,        /* 0x7342 */
    KANJI,        /* 0x7343 */
    KANJI,        /* 0x7344 */
    KANJI,        /* 0x7345 */
    KANJI,        /* 0x7346 */
    KANJI,        /* 0x7347 */
    KANJI,        /* 0x7348 */
    KANJI,        /* 0x7349 */
    KANJI,        /* 0x734a */
    KANJI,        /* 0x734b */
    KANJI,        /* 0x734c */
    KANJI,        /* 0x734d */
    KANJI,        /* 0x734e */
    KANJI,        /* 0x734f */
    KANJI,        /* 0x7350 */
    KANJI,        /* 0x7351 */
    KANJI,        /* 0x7352 */
    KANJI,        /* 0x7353 */
    KANJI,        /* 0x7354 */
    KANJI,        /* 0x7355 */
    KANJI,        /* 0x7356 */
    KANJI,        /* 0x7357 */
    KANJI,        /* 0x7358 */
    KANJI,        /* 0x7359 */
    KANJI,        /* 0x735a */
    KANJI,        /* 0x735b */
    KANJI,        /* 0x735c */
    KANJI,        /* 0x735d */
    KANJI,        /* 0x735e */
    KANJI,        /* 0x735f */
    KANJI,        /* 0x7360 */
    KANJI,        /* 0x7361 */
    KANJI,        /* 0x7362 */
    KANJI,        /* 0x7363 */
    KANJI,        /* 0x7364 */
    KANJI,        /* 0x7365 */
    KANJI,        /* 0x7366 */
    KANJI,        /* 0x7367 */
    KANJI,        /* 0x7368 */
    KANJI,        /* 0x7369 */
    KANJI,        /* 0x736a */
    KANJI,        /* 0x736b */
    KANJI,        /* 0x736c */
    KANJI,        /* 0x736d */
    KANJI,        /* 0x736e */
    KANJI,        /* 0x736f */
    KANJI,        /* 0x7370 */
    KANJI,        /* 0x7371 */
    KANJI,        /* 0x7372 */
    KANJI,        /* 0x7373 */
    KANJI,        /* 0x7374 */
    KANJI,        /* 0x7375 */
    KANJI,        /* 0x7376 */
    KANJI,        /* 0x7377 */
    KANJI,        /* 0x7378 */
    KANJI,        /* 0x7379 */
    KANJI,        /* 0x737a */
    KANJI,        /* 0x737b */
    KANJI,        /* 0x737c */
    KANJI,        /* 0x737d */
    KANJI,        /* 0x737e */
    KANJI,        /* 0x737f */
    KANJI,        /* 0x7380 */
    KANJI,        /* 0x7381 */
    KANJI,        /* 0x7382 */
    KANJI,        /* 0x7383 */
    KANJI,        /* 0x7384 */
    KANJI,        /* 0x7385 */
    KANJI,        /* 0x7386 */
    KANJI,        /* 0x7387 */
    KANJI,        /* 0x7388 */
    KANJI,        /* 0x7389 */
    KANJI,        /* 0x738a */
    KANJI,        /* 0x738b */
    KANJI,        /* 0x738c */
    KANJI,        /* 0x738d */
    KANJI,        /* 0x738e */
    KANJI,        /* 0x738f */
    KANJI,        /* 0x7390 */
    KANJI,        /* 0x7391 */
    KANJI,        /* 0x7392 */
    KANJI,        /* 0x7393 */
    KANJI,        /* 0x7394 */
    KANJI,        /* 0x7395 */
    KANJI,        /* 0x7396 */
    KANJI,        /* 0x7397 */
    KANJI,        /* 0x7398 */
    KANJI,        /* 0x7399 */
    KANJI,        /* 0x739a */
    KANJI,        /* 0x739b */
    KANJI,        /* 0x739c */
    KANJI,        /* 0x739d */
    KANJI,        /* 0x739e */
    KANJI,        /* 0x739f */
    KANJI,        /* 0x73a0 */
    KANJI,        /* 0x73a1 */
    KANJI,        /* 0x73a2 */
    KANJI,        /* 0x73a3 */
    KANJI,        /* 0x73a4 */
    KANJI,        /* 0x73a5 */
    KANJI,        /* 0x73a6 */
    KANJI,        /* 0x73a7 */
    KANJI,        /* 0x73a8 */
    KANJI,        /* 0x73a9 */
    KANJI,        /* 0x73aa */
    KANJI,        /* 0x73ab */
    KANJI,        /* 0x73ac */
    KANJI,        /* 0x73ad */
    KANJI,        /* 0x73ae */
    KANJI,        /* 0x73af */
    KANJI,        /* 0x73b0 */
    KANJI,        /* 0x73b1 */
    KANJI,        /* 0x73b2 */
    KANJI,        /* 0x73b3 */
    KANJI,        /* 0x73b4 */
    KANJI,        /* 0x73b5 */
    KANJI,        /* 0x73b6 */
    KANJI,        /* 0x73b7 */
    KANJI,        /* 0x73b8 */
    KANJI,        /* 0x73b9 */
    KANJI,        /* 0x73ba */
    KANJI,        /* 0x73bb */
    KANJI,        /* 0x73bc */
    KANJI,        /* 0x73bd */
    KANJI,        /* 0x73be */
    KANJI,        /* 0x73bf */
    KANJI,        /* 0x73c0 */
    KANJI,        /* 0x73c1 */
    KANJI,        /* 0x73c2 */
    KANJI,        /* 0x73c3 */
    KANJI,        /* 0x73c4 */
    KANJI,        /* 0x73c5 */
    KANJI,        /* 0x73c6 */
    KANJI,        /* 0x73c7 */
    KANJI,        /* 0x73c8 */
    KANJI,        /* 0x73c9 */
    KANJI,        /* 0x73ca */
    KANJI,        /* 0x73cb */
    KANJI,        /* 0x73cc */
    KANJI,        /* 0x73cd */
    KANJI,        /* 0x73ce */
    KANJI,        /* 0x73cf */
    KANJI,        /* 0x73d0 */
    KANJI,        /* 0x73d1 */
    KANJI,        /* 0x73d2 */
    KANJI,        /* 0x73d3 */
    KANJI,        /* 0x73d4 */
    KANJI,        /* 0x73d5 */
    KANJI,        /* 0x73d6 */
    KANJI,        /* 0x73d7 */
    KANJI,        /* 0x73d8 */
    KANJI,        /* 0x73d9 */
    KANJI,        /* 0x73da */
    KANJI,        /* 0x73db */
    KANJI,        /* 0x73dc */
    KANJI,        /* 0x73dd */
    KANJI,        /* 0x73de */
    KANJI,        /* 0x73df */
    KANJI,        /* 0x73e0 */
    KANJI,        /* 0x73e1 */
    KANJI,        /* 0x73e2 */
    KANJI,        /* 0x73e3 */
    KANJI,        /* 0x73e4 */
    KANJI,        /* 0x73e5 */
    KANJI,        /* 0x73e6 */
    KANJI,        /* 0x73e7 */
    KANJI,        /* 0x73e8 */
    KANJI,        /* 0x73e9 */
    KANJI,        /* 0x73ea */
    KANJI,        /* 0x73eb */
    KANJI,        /* 0x73ec */
    KANJI,        /* 0x73ed */
    KANJI,        /* 0x73ee */
    KANJI,        /* 0x73ef */
    KANJI,        /* 0x73f0 */
    KANJI,        /* 0x73f1 */
    KANJI,        /* 0x73f2 */
    KANJI,        /* 0x73f3 */
    KANJI,        /* 0x73f4 */
    KANJI,        /* 0x73f5 */
    KANJI,        /* 0x73f6 */
    KANJI,        /* 0x73f7 */
    KANJI,        /* 0x73f8 */
    KANJI,        /* 0x73f9 */
    KANJI,        /* 0x73fa */
    KANJI,        /* 0x73fb */
    KANJI,        /* 0x73fc */
    KANJI,        /* 0x73fd */
    KANJI,        /* 0x73fe */
    KANJI,        /* 0x73ff */
    KANJI,        /* 0x7400 */
    KANJI,        /* 0x7401 */
    KANJI,        /* 0x7402 */
    KANJI,        /* 0x7403 */
    KANJI,        /* 0x7404 */
    KANJI,        /* 0x7405 */
    KANJI,        /* 0x7406 */
    KANJI,        /* 0x7407 */
    KANJI,        /* 0x7408 */
    KANJI,        /* 0x7409 */
    KANJI,        /* 0x740a */
    KANJI,        /* 0x740b */
    KANJI,        /* 0x740c */
    KANJI,        /* 0x740d */
    KANJI,        /* 0x740e */
    KANJI,        /* 0x740f */
    KANJI,        /* 0x7410 */
    KANJI,        /* 0x7411 */
    KANJI,        /* 0x7412 */
    KANJI,        /* 0x7413 */
    KANJI,        /* 0x7414 */
    KANJI,        /* 0x7415 */
    KANJI,        /* 0x7416 */
    KANJI,        /* 0x7417 */
    KANJI,        /* 0x7418 */
    KANJI,        /* 0x7419 */
    KANJI,        /* 0x741a */
    KANJI,        /* 0x741b */
    KANJI,        /* 0x741c */
    KANJI,        /* 0x741d */
    KANJI,        /* 0x741e */
    KANJI,        /* 0x741f */
    KANJI,        /* 0x7420 */
    KANJI,        /* 0x7421 */
    KANJI,        /* 0x7422 */
    KANJI,        /* 0x7423 */
    KANJI,        /* 0x7424 */
    KANJI,        /* 0x7425 */
    KANJI,        /* 0x7426 */
    KANJI,        /* 0x7427 */
    KANJI,        /* 0x7428 */
    KANJI,        /* 0x7429 */
    KANJI,        /* 0x742a */
    KANJI,        /* 0x742b */
    KANJI,        /* 0x742c */
    KANJI,        /* 0x742d */
    KANJI,        /* 0x742e */
    KANJI,        /* 0x742f */
    KANJI,        /* 0x7430 */
    KANJI,        /* 0x7431 */
    KANJI,        /* 0x7432 */
    KANJI,        /* 0x7433 */
    KANJI,        /* 0x7434 */
    KANJI,        /* 0x7435 */
    KANJI,        /* 0x7436 */
    KANJI,        /* 0x7437 */
    KANJI,        /* 0x7438 */
    KANJI,        /* 0x7439 */
    KANJI,        /* 0x743a */
    KANJI,        /* 0x743b */
    KANJI,        /* 0x743c */
    KANJI,        /* 0x743d */
    KANJI,        /* 0x743e */
    KANJI,        /* 0x743f */
    KANJI,        /* 0x7440 */
    KANJI,        /* 0x7441 */
    KANJI,        /* 0x7442 */
    KANJI,        /* 0x7443 */
    KANJI,        /* 0x7444 */
    KANJI,        /* 0x7445 */
    KANJI,        /* 0x7446 */
    KANJI,        /* 0x7447 */
    KANJI,        /* 0x7448 */
    KANJI,        /* 0x7449 */
    KANJI,        /* 0x744a */
    KANJI,        /* 0x744b */
    KANJI,        /* 0x744c */
    KANJI,        /* 0x744d */
    KANJI,        /* 0x744e */
    KANJI,        /* 0x744f */
    KANJI,        /* 0x7450 */
    KANJI,        /* 0x7451 */
    KANJI,        /* 0x7452 */
    KANJI,        /* 0x7453 */
    KANJI,        /* 0x7454 */
    KANJI,        /* 0x7455 */
    KANJI,        /* 0x7456 */
    KANJI,        /* 0x7457 */
    KANJI,        /* 0x7458 */
    KANJI,        /* 0x7459 */
    KANJI,        /* 0x745a */
    KANJI,        /* 0x745b */
    KANJI,        /* 0x745c */
    KANJI,        /* 0x745d */
    KANJI,        /* 0x745e */
    KANJI,        /* 0x745f */
    KANJI,        /* 0x7460 */
    KANJI,        /* 0x7461 */
    KANJI,        /* 0x7462 */
    KANJI,        /* 0x7463 */
    KANJI,        /* 0x7464 */
    KANJI,        /* 0x7465 */
    KANJI,        /* 0x7466 */
    KANJI,        /* 0x7467 */
    KANJI,        /* 0x7468 */
    KANJI,        /* 0x7469 */
    KANJI,        /* 0x746a */
    KANJI,        /* 0x746b */
    KANJI,        /* 0x746c */
    KANJI,        /* 0x746d */
    KANJI,        /* 0x746e */
    KANJI,        /* 0x746f */
    KANJI,        /* 0x7470 */
    KANJI,        /* 0x7471 */
    KANJI,        /* 0x7472 */
    KANJI,        /* 0x7473 */
    KANJI,        /* 0x7474 */
    KANJI,        /* 0x7475 */
    KANJI,        /* 0x7476 */
    KANJI,        /* 0x7477 */
    KANJI,        /* 0x7478 */
    KANJI,        /* 0x7479 */
    KANJI,        /* 0x747a */
    KANJI,        /* 0x747b */
    KANJI,        /* 0x747c */
    KANJI,        /* 0x747d */
    KANJI,        /* 0x747e */
    KANJI,        /* 0x747f */
    KANJI,        /* 0x7480 */
    KANJI,        /* 0x7481 */
    KANJI,        /* 0x7482 */
    KANJI,        /* 0x7483 */
    KANJI,        /* 0x7484 */
    KANJI,        /* 0x7485 */
    KANJI,        /* 0x7486 */
    KANJI,        /* 0x7487 */
    KANJI,        /* 0x7488 */
    KANJI,        /* 0x7489 */
    KANJI,        /* 0x748a */
    KANJI,        /* 0x748b */
    KANJI,        /* 0x748c */
    KANJI,        /* 0x748d */
    KANJI,        /* 0x748e */
    KANJI,        /* 0x748f */
    KANJI,        /* 0x7490 */
    KANJI,        /* 0x7491 */
    KANJI,        /* 0x7492 */
    KANJI,        /* 0x7493 */
    KANJI,        /* 0x7494 */
    KANJI,        /* 0x7495 */
    KANJI,        /* 0x7496 */
    KANJI,        /* 0x7497 */
    KANJI,        /* 0x7498 */
    KANJI,        /* 0x7499 */
    KANJI,        /* 0x749a */
    KANJI,        /* 0x749b */
    KANJI,        /* 0x749c */
    KANJI,        /* 0x749d */
    KANJI,        /* 0x749e */
    KANJI,        /* 0x749f */
    KANJI,        /* 0x74a0 */
    KANJI,        /* 0x74a1 */
    KANJI,        /* 0x74a2 */
    KANJI,        /* 0x74a3 */
    KANJI,        /* 0x74a4 */
    KANJI,        /* 0x74a5 */
    KANJI,        /* 0x74a6 */
    KANJI,        /* 0x74a7 */
    KANJI,        /* 0x74a8 */
    KANJI,        /* 0x74a9 */
    KANJI,        /* 0x74aa */
    KANJI,        /* 0x74ab */
    KANJI,        /* 0x74ac */
    KANJI,        /* 0x74ad */
    KANJI,        /* 0x74ae */
    KANJI,        /* 0x74af */
    KANJI,        /* 0x74b0 */
    KANJI,        /* 0x74b1 */
    KANJI,        /* 0x74b2 */
    KANJI,        /* 0x74b3 */
    KANJI,        /* 0x74b4 */
    KANJI,        /* 0x74b5 */
    KANJI,        /* 0x74b6 */
    KANJI,        /* 0x74b7 */
    KANJI,        /* 0x74b8 */
    KANJI,        /* 0x74b9 */
    KANJI,        /* 0x74ba */
    KANJI,        /* 0x74bb */
    KANJI,        /* 0x74bc */
    KANJI,        /* 0x74bd */
    KANJI,        /* 0x74be */
    KANJI,        /* 0x74bf */
    KANJI,        /* 0x74c0 */
    KANJI,        /* 0x74c1 */
    KANJI,        /* 0x74c2 */
    KANJI,        /* 0x74c3 */
    KANJI,        /* 0x74c4 */
    KANJI,        /* 0x74c5 */
    KANJI,        /* 0x74c6 */
    KANJI,        /* 0x74c7 */
    KANJI,        /* 0x74c8 */
    KANJI,        /* 0x74c9 */
    KANJI,        /* 0x74ca */
    KANJI,        /* 0x74cb */
    KANJI,        /* 0x74cc */
    KANJI,        /* 0x74cd */
    KANJI,        /* 0x74ce */
    KANJI,        /* 0x74cf */
    KANJI,        /* 0x74d0 */
    KANJI,        /* 0x74d1 */
    KANJI,        /* 0x74d2 */
    KANJI,        /* 0x74d3 */
    KANJI,        /* 0x74d4 */
    KANJI,        /* 0x74d5 */
    KANJI,        /* 0x74d6 */
    KANJI,        /* 0x74d7 */
    KANJI,        /* 0x74d8 */
    KANJI,        /* 0x74d9 */
    KANJI,        /* 0x74da */
    KANJI,        /* 0x74db */
    KANJI,        /* 0x74dc */
    KANJI,        /* 0x74dd */
    KANJI,        /* 0x74de */
    KANJI,        /* 0x74df */
    KANJI,        /* 0x74e0 */
    KANJI,        /* 0x74e1 */
    KANJI,        /* 0x74e2 */
    KANJI,        /* 0x74e3 */
    KANJI,        /* 0x74e4 */
    KANJI,        /* 0x74e5 */
    KANJI,        /* 0x74e6 */
    KANJI,        /* 0x74e7 */
    KANJI,        /* 0x74e8 */
    KANJI,        /* 0x74e9 */
    KANJI,        /* 0x74ea */
    KANJI,        /* 0x74eb */
    KANJI,        /* 0x74ec */
    KANJI,        /* 0x74ed */
    KANJI,        /* 0x74ee */
    KANJI,        /* 0x74ef */
    KANJI,        /* 0x74f0 */
    KANJI,        /* 0x74f1 */
    KANJI,        /* 0x74f2 */
    KANJI,        /* 0x74f3 */
    KANJI,        /* 0x74f4 */
    KANJI,        /* 0x74f5 */
    KANJI,        /* 0x74f6 */
    KANJI,        /* 0x74f7 */
    KANJI,        /* 0x74f8 */
    KANJI,        /* 0x74f9 */
    KANJI,        /* 0x74fa */
    KANJI,        /* 0x74fb */
    KANJI,        /* 0x74fc */
    KANJI,        /* 0x74fd */
    KANJI,        /* 0x74fe */
    KANJI,        /* 0x74ff */
    KANJI,        /* 0x7500 */
    KANJI,        /* 0x7501 */
    KANJI,        /* 0x7502 */
    KANJI,        /* 0x7503 */
    KANJI,        /* 0x7504 */
    KANJI,        /* 0x7505 */
    KANJI,        /* 0x7506 */
    KANJI,        /* 0x7507 */
    KANJI,        /* 0x7508 */
    KANJI,        /* 0x7509 */
    KANJI,        /* 0x750a */
    KANJI,        /* 0x750b */
    KANJI,        /* 0x750c */
    KANJI,        /* 0x750d */
    KANJI,        /* 0x750e */
    KANJI,        /* 0x750f */
    KANJI,        /* 0x7510 */
    KANJI,        /* 0x7511 */
    KANJI,        /* 0x7512 */
    KANJI,        /* 0x7513 */
    KANJI,        /* 0x7514 */
    KANJI,        /* 0x7515 */
    KANJI,        /* 0x7516 */
    KANJI,        /* 0x7517 */
    KANJI,        /* 0x7518 */
    KANJI,        /* 0x7519 */
    KANJI,        /* 0x751a */
    KANJI,        /* 0x751b */
    KANJI,        /* 0x751c */
    KANJI,        /* 0x751d */
    KANJI,        /* 0x751e */
    KANJI,        /* 0x751f */
    KANJI,        /* 0x7520 */
    KANJI,        /* 0x7521 */
    KANJI,        /* 0x7522 */
    KANJI,        /* 0x7523 */
    KANJI,        /* 0x7524 */
    KANJI,        /* 0x7525 */
    KANJI,        /* 0x7526 */
    KANJI,        /* 0x7527 */
    KANJI,        /* 0x7528 */
    KANJI,        /* 0x7529 */
    KANJI,        /* 0x752a */
    KANJI,        /* 0x752b */
    KANJI,        /* 0x752c */
    KANJI,        /* 0x752d */
    KANJI,        /* 0x752e */
    KANJI,        /* 0x752f */
    KANJI,        /* 0x7530 */
    KANJI,        /* 0x7531 */
    KANJI,        /* 0x7532 */
    KANJI,        /* 0x7533 */
    KANJI,        /* 0x7534 */
    KANJI,        /* 0x7535 */
    KANJI,        /* 0x7536 */
    KANJI,        /* 0x7537 */
    KANJI,        /* 0x7538 */
    KANJI,        /* 0x7539 */
    KANJI,        /* 0x753a */
    KANJI,        /* 0x753b */
    KANJI,        /* 0x753c */
    KANJI,        /* 0x753d */
    KANJI,        /* 0x753e */
    KANJI,        /* 0x753f */
    KANJI,        /* 0x7540 */
    KANJI,        /* 0x7541 */
    KANJI,        /* 0x7542 */
    KANJI,        /* 0x7543 */
    KANJI,        /* 0x7544 */
    KANJI,        /* 0x7545 */
    KANJI,        /* 0x7546 */
    KANJI,        /* 0x7547 */
    KANJI,        /* 0x7548 */
    KANJI,        /* 0x7549 */
    KANJI,        /* 0x754a */
    KANJI,        /* 0x754b */
    KANJI,        /* 0x754c */
    KANJI,        /* 0x754d */
    KANJI,        /* 0x754e */
    KANJI,        /* 0x754f */
    KANJI,        /* 0x7550 */
    KANJI,        /* 0x7551 */
    KANJI,        /* 0x7552 */
    KANJI,        /* 0x7553 */
    KANJI,        /* 0x7554 */
    KANJI,        /* 0x7555 */
    KANJI,        /* 0x7556 */
    KANJI,        /* 0x7557 */
    KANJI,        /* 0x7558 */
    KANJI,        /* 0x7559 */
    KANJI,        /* 0x755a */
    KANJI,        /* 0x755b */
    KANJI,        /* 0x755c */
    KANJI,        /* 0x755d */
    KANJI,        /* 0x755e */
    KANJI,        /* 0x755f */
    KANJI,        /* 0x7560 */
    KANJI,        /* 0x7561 */
    KANJI,        /* 0x7562 */
    KANJI,        /* 0x7563 */
    KANJI,        /* 0x7564 */
    KANJI,        /* 0x7565 */
    KANJI,        /* 0x7566 */
    KANJI,        /* 0x7567 */
    KANJI,        /* 0x7568 */
    KANJI,        /* 0x7569 */
    KANJI,        /* 0x756a */
    KANJI,        /* 0x756b */
    KANJI,        /* 0x756c */
    KANJI,        /* 0x756d */
    KANJI,        /* 0x756e */
    KANJI,        /* 0x756f */
    KANJI,        /* 0x7570 */
    KANJI,        /* 0x7571 */
    KANJI,        /* 0x7572 */
    KANJI,        /* 0x7573 */
    KANJI,        /* 0x7574 */
    KANJI,        /* 0x7575 */
    KANJI,        /* 0x7576 */
    KANJI,        /* 0x7577 */
    KANJI,        /* 0x7578 */
    KANJI,        /* 0x7579 */
    KANJI,        /* 0x757a */
    KANJI,        /* 0x757b */
    KANJI,        /* 0x757c */
    KANJI,        /* 0x757d */
    KANJI,        /* 0x757e */
    KANJI,        /* 0x757f */
    KANJI,        /* 0x7580 */
    KANJI,        /* 0x7581 */
    KANJI,        /* 0x7582 */
    KANJI,        /* 0x7583 */
    KANJI,        /* 0x7584 */
    KANJI,        /* 0x7585 */
    KANJI,        /* 0x7586 */
    KANJI,        /* 0x7587 */
    KANJI,        /* 0x7588 */
    KANJI,        /* 0x7589 */
    KANJI,        /* 0x758a */
    KANJI,        /* 0x758b */
    KANJI,        /* 0x758c */
    KANJI,        /* 0x758d */
    KANJI,        /* 0x758e */
    KANJI,        /* 0x758f */
    KANJI,        /* 0x7590 */
    KANJI,        /* 0x7591 */
    KANJI,        /* 0x7592 */
    KANJI,        /* 0x7593 */
    KANJI,        /* 0x7594 */
    KANJI,        /* 0x7595 */
    KANJI,        /* 0x7596 */
    KANJI,        /* 0x7597 */
    KANJI,        /* 0x7598 */
    KANJI,        /* 0x7599 */
    KANJI,        /* 0x759a */
    KANJI,        /* 0x759b */
    KANJI,        /* 0x759c */
    KANJI,        /* 0x759d */
    KANJI,        /* 0x759e */
    KANJI,        /* 0x759f */
    KANJI,        /* 0x75a0 */
    KANJI,        /* 0x75a1 */
    KANJI,        /* 0x75a2 */
    KANJI,        /* 0x75a3 */
    KANJI,        /* 0x75a4 */
    KANJI,        /* 0x75a5 */
    KANJI,        /* 0x75a6 */
    KANJI,        /* 0x75a7 */
    KANJI,        /* 0x75a8 */
    KANJI,        /* 0x75a9 */
    KANJI,        /* 0x75aa */
    KANJI,        /* 0x75ab */
    KANJI,        /* 0x75ac */
    KANJI,        /* 0x75ad */
    KANJI,        /* 0x75ae */
    KANJI,        /* 0x75af */
    KANJI,        /* 0x75b0 */
    KANJI,        /* 0x75b1 */
    KANJI,        /* 0x75b2 */
    KANJI,        /* 0x75b3 */
    KANJI,        /* 0x75b4 */
    KANJI,        /* 0x75b5 */
    KANJI,        /* 0x75b6 */
    KANJI,        /* 0x75b7 */
    KANJI,        /* 0x75b8 */
    KANJI,        /* 0x75b9 */
    KANJI,        /* 0x75ba */
    KANJI,        /* 0x75bb */
    KANJI,        /* 0x75bc */
    KANJI,        /* 0x75bd */
    KANJI,        /* 0x75be */
    KANJI,        /* 0x75bf */
    KANJI,        /* 0x75c0 */
    KANJI,        /* 0x75c1 */
    KANJI,        /* 0x75c2 */
    KANJI,        /* 0x75c3 */
    KANJI,        /* 0x75c4 */
    KANJI,        /* 0x75c5 */
    KANJI,        /* 0x75c6 */
    KANJI,        /* 0x75c7 */
    KANJI,        /* 0x75c8 */
    KANJI,        /* 0x75c9 */
    KANJI,        /* 0x75ca */
    KANJI,        /* 0x75cb */
    KANJI,        /* 0x75cc */
    KANJI,        /* 0x75cd */
    KANJI,        /* 0x75ce */
    KANJI,        /* 0x75cf */
    KANJI,        /* 0x75d0 */
    KANJI,        /* 0x75d1 */
    KANJI,        /* 0x75d2 */
    KANJI,        /* 0x75d3 */
    KANJI,        /* 0x75d4 */
    KANJI,        /* 0x75d5 */
    KANJI,        /* 0x75d6 */
    KANJI,        /* 0x75d7 */
    KANJI,        /* 0x75d8 */
    KANJI,        /* 0x75d9 */
    KANJI,        /* 0x75da */
    KANJI,        /* 0x75db */
    KANJI,        /* 0x75dc */
    KANJI,        /* 0x75dd */
    KANJI,        /* 0x75de */
    KANJI,        /* 0x75df */
    KANJI,        /* 0x75e0 */
    KANJI,        /* 0x75e1 */
    KANJI,        /* 0x75e2 */
    KANJI,        /* 0x75e3 */
    KANJI,        /* 0x75e4 */
    KANJI,        /* 0x75e5 */
    KANJI,        /* 0x75e6 */
    KANJI,        /* 0x75e7 */
    KANJI,        /* 0x75e8 */
    KANJI,        /* 0x75e9 */
    KANJI,        /* 0x75ea */
    KANJI,        /* 0x75eb */
    KANJI,        /* 0x75ec */
    KANJI,        /* 0x75ed */
    KANJI,        /* 0x75ee */
    KANJI,        /* 0x75ef */
    KANJI,        /* 0x75f0 */
    KANJI,        /* 0x75f1 */
    KANJI,        /* 0x75f2 */
    KANJI,        /* 0x75f3 */
    KANJI,        /* 0x75f4 */
    KANJI,        /* 0x75f5 */
    KANJI,        /* 0x75f6 */
    KANJI,        /* 0x75f7 */
    KANJI,        /* 0x75f8 */
    KANJI,        /* 0x75f9 */
    KANJI,        /* 0x75fa */
    KANJI,        /* 0x75fb */
    KANJI,        /* 0x75fc */
    KANJI,        /* 0x75fd */
    KANJI,        /* 0x75fe */
    KANJI,        /* 0x75ff */
    KANJI,        /* 0x7600 */
    KANJI,        /* 0x7601 */
    KANJI,        /* 0x7602 */
    KANJI,        /* 0x7603 */
    KANJI,        /* 0x7604 */
    KANJI,        /* 0x7605 */
    KANJI,        /* 0x7606 */
    KANJI,        /* 0x7607 */
    KANJI,        /* 0x7608 */
    KANJI,        /* 0x7609 */
    KANJI,        /* 0x760a */
    KANJI,        /* 0x760b */
    KANJI,        /* 0x760c */
    KANJI,        /* 0x760d */
    KANJI,        /* 0x760e */
    KANJI,        /* 0x760f */
    KANJI,        /* 0x7610 */
    KANJI,        /* 0x7611 */
    KANJI,        /* 0x7612 */
    KANJI,        /* 0x7613 */
    KANJI,        /* 0x7614 */
    KANJI,        /* 0x7615 */
    KANJI,        /* 0x7616 */
    KANJI,        /* 0x7617 */
    KANJI,        /* 0x7618 */
    KANJI,        /* 0x7619 */
    KANJI,        /* 0x761a */
    KANJI,        /* 0x761b */
    KANJI,        /* 0x761c */
    KANJI,        /* 0x761d */
    KANJI,        /* 0x761e */
    KANJI,        /* 0x761f */
    KANJI,        /* 0x7620 */
    KANJI,        /* 0x7621 */
    KANJI,        /* 0x7622 */
    KANJI,        /* 0x7623 */
    KANJI,        /* 0x7624 */
    KANJI,        /* 0x7625 */
    KANJI,        /* 0x7626 */
    KANJI,        /* 0x7627 */
    KANJI,        /* 0x7628 */
    KANJI,        /* 0x7629 */
    KANJI,        /* 0x762a */
    KANJI,        /* 0x762b */
    KANJI,        /* 0x762c */
    KANJI,        /* 0x762d */
    KANJI,        /* 0x762e */
    KANJI,        /* 0x762f */
    KANJI,        /* 0x7630 */
    KANJI,        /* 0x7631 */
    KANJI,        /* 0x7632 */
    KANJI,        /* 0x7633 */
    KANJI,        /* 0x7634 */
    KANJI,        /* 0x7635 */
    KANJI,        /* 0x7636 */
    KANJI,        /* 0x7637 */
    KANJI,        /* 0x7638 */
    KANJI,        /* 0x7639 */
    KANJI,        /* 0x763a */
    KANJI,        /* 0x763b */
    KANJI,        /* 0x763c */
    KANJI,        /* 0x763d */
    KANJI,        /* 0x763e */
    KANJI,        /* 0x763f */
    KANJI,        /* 0x7640 */
    KANJI,        /* 0x7641 */
    KANJI,        /* 0x7642 */
    KANJI,        /* 0x7643 */
    KANJI,        /* 0x7644 */
    KANJI,        /* 0x7645 */
    KANJI,        /* 0x7646 */
    KANJI,        /* 0x7647 */
    KANJI,        /* 0x7648 */
    KANJI,        /* 0x7649 */
    KANJI,        /* 0x764a */
    KANJI,        /* 0x764b */
    KANJI,        /* 0x764c */
    KANJI,        /* 0x764d */
    KANJI,        /* 0x764e */
    KANJI,        /* 0x764f */
    KANJI,        /* 0x7650 */
    KANJI,        /* 0x7651 */
    KANJI,        /* 0x7652 */
    KANJI,        /* 0x7653 */
    KANJI,        /* 0x7654 */
    KANJI,        /* 0x7655 */
    KANJI,        /* 0x7656 */
    KANJI,        /* 0x7657 */
    KANJI,        /* 0x7658 */
    KANJI,        /* 0x7659 */
    KANJI,        /* 0x765a */
    KANJI,        /* 0x765b */
    KANJI,        /* 0x765c */
    KANJI,        /* 0x765d */
    KANJI,        /* 0x765e */
    KANJI,        /* 0x765f */
    KANJI,        /* 0x7660 */
    KANJI,        /* 0x7661 */
    KANJI,        /* 0x7662 */
    KANJI,        /* 0x7663 */
    KANJI,        /* 0x7664 */
    KANJI,        /* 0x7665 */
    KANJI,        /* 0x7666 */
    KANJI,        /* 0x7667 */
    KANJI,        /* 0x7668 */
    KANJI,        /* 0x7669 */
    KANJI,        /* 0x766a */
    KANJI,        /* 0x766b */
    KANJI,        /* 0x766c */
    KANJI,        /* 0x766d */
    KANJI,        /* 0x766e */
    KANJI,        /* 0x766f */
    KANJI,        /* 0x7670 */
    KANJI,        /* 0x7671 */
    KANJI,        /* 0x7672 */
    KANJI,        /* 0x7673 */
    KANJI,        /* 0x7674 */
    KANJI,        /* 0x7675 */
    KANJI,        /* 0x7676 */
    KANJI,        /* 0x7677 */
    KANJI,        /* 0x7678 */
    KANJI,        /* 0x7679 */
    KANJI,        /* 0x767a */
    KANJI,        /* 0x767b */
    KANJI,        /* 0x767c */
    KANJI,        /* 0x767d */
    KANJINUMERIC,        /* 0x767e */
    KANJI,        /* 0x767f */
    KANJI,        /* 0x7680 */
    KANJI,        /* 0x7681 */
    KANJI,        /* 0x7682 */
    KANJI,        /* 0x7683 */
    KANJI,        /* 0x7684 */
    KANJI,        /* 0x7685 */
    KANJI,        /* 0x7686 */
    KANJI,        /* 0x7687 */
    KANJI,        /* 0x7688 */
    KANJI,        /* 0x7689 */
    KANJI,        /* 0x768a */
    KANJI,        /* 0x768b */
    KANJI,        /* 0x768c */
    KANJI,        /* 0x768d */
    KANJI,        /* 0x768e */
    KANJI,        /* 0x768f */
    KANJI,        /* 0x7690 */
    KANJI,        /* 0x7691 */
    KANJI,        /* 0x7692 */
    KANJI,        /* 0x7693 */
    KANJI,        /* 0x7694 */
    KANJI,        /* 0x7695 */
    KANJI,        /* 0x7696 */
    KANJI,        /* 0x7697 */
    KANJI,        /* 0x7698 */
    KANJI,        /* 0x7699 */
    KANJI,        /* 0x769a */
    KANJI,        /* 0x769b */
    KANJI,        /* 0x769c */
    KANJI,        /* 0x769d */
    KANJI,        /* 0x769e */
    KANJI,        /* 0x769f */
    KANJI,        /* 0x76a0 */
    KANJI,        /* 0x76a1 */
    KANJI,        /* 0x76a2 */
    KANJI,        /* 0x76a3 */
    KANJI,        /* 0x76a4 */
    KANJI,        /* 0x76a5 */
    KANJI,        /* 0x76a6 */
    KANJI,        /* 0x76a7 */
    KANJI,        /* 0x76a8 */
    KANJI,        /* 0x76a9 */
    KANJI,        /* 0x76aa */
    KANJI,        /* 0x76ab */
    KANJI,        /* 0x76ac */
    KANJI,        /* 0x76ad */
    KANJI,        /* 0x76ae */
    KANJI,        /* 0x76af */
    KANJI,        /* 0x76b0 */
    KANJI,        /* 0x76b1 */
    KANJI,        /* 0x76b2 */
    KANJI,        /* 0x76b3 */
    KANJI,        /* 0x76b4 */
    KANJI,        /* 0x76b5 */
    KANJI,        /* 0x76b6 */
    KANJI,        /* 0x76b7 */
    KANJI,        /* 0x76b8 */
    KANJI,        /* 0x76b9 */
    KANJI,        /* 0x76ba */
    KANJI,        /* 0x76bb */
    KANJI,        /* 0x76bc */
    KANJI,        /* 0x76bd */
    KANJI,        /* 0x76be */
    KANJI,        /* 0x76bf */
    KANJI,        /* 0x76c0 */
    KANJI,        /* 0x76c1 */
    KANJI,        /* 0x76c2 */
    KANJI,        /* 0x76c3 */
    KANJI,        /* 0x76c4 */
    KANJI,        /* 0x76c5 */
    KANJI,        /* 0x76c6 */
    KANJI,        /* 0x76c7 */
    KANJI,        /* 0x76c8 */
    KANJI,        /* 0x76c9 */
    KANJI,        /* 0x76ca */
    KANJI,        /* 0x76cb */
    KANJI,        /* 0x76cc */
    KANJI,        /* 0x76cd */
    KANJI,        /* 0x76ce */
    KANJI,        /* 0x76cf */
    KANJI,        /* 0x76d0 */
    KANJI,        /* 0x76d1 */
    KANJI,        /* 0x76d2 */
    KANJI,        /* 0x76d3 */
    KANJI,        /* 0x76d4 */
    KANJI,        /* 0x76d5 */
    KANJI,        /* 0x76d6 */
    KANJI,        /* 0x76d7 */
    KANJI,        /* 0x76d8 */
    KANJI,        /* 0x76d9 */
    KANJI,        /* 0x76da */
    KANJI,        /* 0x76db */
    KANJI,        /* 0x76dc */
    KANJI,        /* 0x76dd */
    KANJI,        /* 0x76de */
    KANJI,        /* 0x76df */
    KANJI,        /* 0x76e0 */
    KANJI,        /* 0x76e1 */
    KANJI,        /* 0x76e2 */
    KANJI,        /* 0x76e3 */
    KANJI,        /* 0x76e4 */
    KANJI,        /* 0x76e5 */
    KANJI,        /* 0x76e6 */
    KANJI,        /* 0x76e7 */
    KANJI,        /* 0x76e8 */
    KANJI,        /* 0x76e9 */
    KANJI,        /* 0x76ea */
    KANJI,        /* 0x76eb */
    KANJI,        /* 0x76ec */
    KANJI,        /* 0x76ed */
    KANJI,        /* 0x76ee */
    KANJI,        /* 0x76ef */
    KANJI,        /* 0x76f0 */
    KANJI,        /* 0x76f1 */
    KANJI,        /* 0x76f2 */
    KANJI,        /* 0x76f3 */
    KANJI,        /* 0x76f4 */
    KANJI,        /* 0x76f5 */
    KANJI,        /* 0x76f6 */
    KANJI,        /* 0x76f7 */
    KANJI,        /* 0x76f8 */
    KANJI,        /* 0x76f9 */
    KANJI,        /* 0x76fa */
    KANJI,        /* 0x76fb */
    KANJI,        /* 0x76fc */
    KANJI,        /* 0x76fd */
    KANJI,        /* 0x76fe */
    KANJI,        /* 0x76ff */
    KANJI,        /* 0x7700 */
    KANJI,        /* 0x7701 */
    KANJI,        /* 0x7702 */
    KANJI,        /* 0x7703 */
    KANJI,        /* 0x7704 */
    KANJI,        /* 0x7705 */
    KANJI,        /* 0x7706 */
    KANJI,        /* 0x7707 */
    KANJI,        /* 0x7708 */
    KANJI,        /* 0x7709 */
    KANJI,        /* 0x770a */
    KANJI,        /* 0x770b */
    KANJI,        /* 0x770c */
    KANJI,        /* 0x770d */
    KANJI,        /* 0x770e */
    KANJI,        /* 0x770f */
    KANJI,        /* 0x7710 */
    KANJI,        /* 0x7711 */
    KANJI,        /* 0x7712 */
    KANJI,        /* 0x7713 */
    KANJI,        /* 0x7714 */
    KANJI,        /* 0x7715 */
    KANJI,        /* 0x7716 */
    KANJI,        /* 0x7717 */
    KANJI,        /* 0x7718 */
    KANJI,        /* 0x7719 */
    KANJI,        /* 0x771a */
    KANJI,        /* 0x771b */
    KANJI,        /* 0x771c */
    KANJI,        /* 0x771d */
    KANJI,        /* 0x771e */
    KANJI,        /* 0x771f */
    KANJI,        /* 0x7720 */
    KANJI,        /* 0x7721 */
    KANJI,        /* 0x7722 */
    KANJI,        /* 0x7723 */
    KANJI,        /* 0x7724 */
    KANJI,        /* 0x7725 */
    KANJI,        /* 0x7726 */
    KANJI,        /* 0x7727 */
    KANJI,        /* 0x7728 */
    KANJI,        /* 0x7729 */
    KANJI,        /* 0x772a */
    KANJI,        /* 0x772b */
    KANJI,        /* 0x772c */
    KANJI,        /* 0x772d */
    KANJI,        /* 0x772e */
    KANJI,        /* 0x772f */
    KANJI,        /* 0x7730 */
    KANJI,        /* 0x7731 */
    KANJI,        /* 0x7732 */
    KANJI,        /* 0x7733 */
    KANJI,        /* 0x7734 */
    KANJI,        /* 0x7735 */
    KANJI,        /* 0x7736 */
    KANJI,        /* 0x7737 */
    KANJI,        /* 0x7738 */
    KANJI,        /* 0x7739 */
    KANJI,        /* 0x773a */
    KANJI,        /* 0x773b */
    KANJI,        /* 0x773c */
    KANJI,        /* 0x773d */
    KANJI,        /* 0x773e */
    KANJI,        /* 0x773f */
    KANJI,        /* 0x7740 */
    KANJI,        /* 0x7741 */
    KANJI,        /* 0x7742 */
    KANJI,        /* 0x7743 */
    KANJI,        /* 0x7744 */
    KANJI,        /* 0x7745 */
    KANJI,        /* 0x7746 */
    KANJI,        /* 0x7747 */
    KANJI,        /* 0x7748 */
    KANJI,        /* 0x7749 */
    KANJI,        /* 0x774a */
    KANJI,        /* 0x774b */
    KANJI,        /* 0x774c */
    KANJI,        /* 0x774d */
    KANJI,        /* 0x774e */
    KANJI,        /* 0x774f */
    KANJI,        /* 0x7750 */
    KANJI,        /* 0x7751 */
    KANJI,        /* 0x7752 */
    KANJI,        /* 0x7753 */
    KANJI,        /* 0x7754 */
    KANJI,        /* 0x7755 */
    KANJI,        /* 0x7756 */
    KANJI,        /* 0x7757 */
    KANJI,        /* 0x7758 */
    KANJI,        /* 0x7759 */
    KANJI,        /* 0x775a */
    KANJI,        /* 0x775b */
    KANJI,        /* 0x775c */
    KANJI,        /* 0x775d */
    KANJI,        /* 0x775e */
    KANJI,        /* 0x775f */
    KANJI,        /* 0x7760 */
    KANJI,        /* 0x7761 */
    KANJI,        /* 0x7762 */
    KANJI,        /* 0x7763 */
    KANJI,        /* 0x7764 */
    KANJI,        /* 0x7765 */
    KANJI,        /* 0x7766 */
    KANJI,        /* 0x7767 */
    KANJI,        /* 0x7768 */
    KANJI,        /* 0x7769 */
    KANJI,        /* 0x776a */
    KANJI,        /* 0x776b */
    KANJI,        /* 0x776c */
    KANJI,        /* 0x776d */
    KANJI,        /* 0x776e */
    KANJI,        /* 0x776f */
    KANJI,        /* 0x7770 */
    KANJI,        /* 0x7771 */
    KANJI,        /* 0x7772 */
    KANJI,        /* 0x7773 */
    KANJI,        /* 0x7774 */
    KANJI,        /* 0x7775 */
    KANJI,        /* 0x7776 */
    KANJI,        /* 0x7777 */
    KANJI,        /* 0x7778 */
    KANJI,        /* 0x7779 */
    KANJI,        /* 0x777a */
    KANJI,        /* 0x777b */
    KANJI,        /* 0x777c */
    KANJI,        /* 0x777d */
    KANJI,        /* 0x777e */
    KANJI,        /* 0x777f */
    KANJI,        /* 0x7780 */
    KANJI,        /* 0x7781 */
    KANJI,        /* 0x7782 */
    KANJI,        /* 0x7783 */
    KANJI,        /* 0x7784 */
    KANJI,        /* 0x7785 */
    KANJI,        /* 0x7786 */
    KANJI,        /* 0x7787 */
    KANJI,        /* 0x7788 */
    KANJI,        /* 0x7789 */
    KANJI,        /* 0x778a */
    KANJI,        /* 0x778b */
    KANJI,        /* 0x778c */
    KANJI,        /* 0x778d */
    KANJI,        /* 0x778e */
    KANJI,        /* 0x778f */
    KANJI,        /* 0x7790 */
    KANJI,        /* 0x7791 */
    KANJI,        /* 0x7792 */
    KANJI,        /* 0x7793 */
    KANJI,        /* 0x7794 */
    KANJI,        /* 0x7795 */
    KANJI,        /* 0x7796 */
    KANJI,        /* 0x7797 */
    KANJI,        /* 0x7798 */
    KANJI,        /* 0x7799 */
    KANJI,        /* 0x779a */
    KANJI,        /* 0x779b */
    KANJI,        /* 0x779c */
    KANJI,        /* 0x779d */
    KANJI,        /* 0x779e */
    KANJI,        /* 0x779f */
    KANJI,        /* 0x77a0 */
    KANJI,        /* 0x77a1 */
    KANJI,        /* 0x77a2 */
    KANJI,        /* 0x77a3 */
    KANJI,        /* 0x77a4 */
    KANJI,        /* 0x77a5 */
    KANJI,        /* 0x77a6 */
    KANJI,        /* 0x77a7 */
    KANJI,        /* 0x77a8 */
    KANJI,        /* 0x77a9 */
    KANJI,        /* 0x77aa */
    KANJI,        /* 0x77ab */
    KANJI,        /* 0x77ac */
    KANJI,        /* 0x77ad */
    KANJI,        /* 0x77ae */
    KANJI,        /* 0x77af */
    KANJI,        /* 0x77b0 */
    KANJI,        /* 0x77b1 */
    KANJI,        /* 0x77b2 */
    KANJI,        /* 0x77b3 */
    KANJI,        /* 0x77b4 */
    KANJI,        /* 0x77b5 */
    KANJI,        /* 0x77b6 */
    KANJI,        /* 0x77b7 */
    KANJI,        /* 0x77b8 */
    KANJI,        /* 0x77b9 */
    KANJI,        /* 0x77ba */
    KANJI,        /* 0x77bb */
    KANJI,        /* 0x77bc */
    KANJI,        /* 0x77bd */
    KANJI,        /* 0x77be */
    KANJI,        /* 0x77bf */
    KANJI,        /* 0x77c0 */
    KANJI,        /* 0x77c1 */
    KANJI,        /* 0x77c2 */
    KANJI,        /* 0x77c3 */
    KANJI,        /* 0x77c4 */
    KANJI,        /* 0x77c5 */
    KANJI,        /* 0x77c6 */
    KANJI,        /* 0x77c7 */
    KANJI,        /* 0x77c8 */
    KANJI,        /* 0x77c9 */
    KANJI,        /* 0x77ca */
    KANJI,        /* 0x77cb */
    KANJI,        /* 0x77cc */
    KANJI,        /* 0x77cd */
    KANJI,        /* 0x77ce */
    KANJI,        /* 0x77cf */
    KANJI,        /* 0x77d0 */
    KANJI,        /* 0x77d1 */
    KANJI,        /* 0x77d2 */
    KANJI,        /* 0x77d3 */
    KANJI,        /* 0x77d4 */
    KANJI,        /* 0x77d5 */
    KANJI,        /* 0x77d6 */
    KANJI,        /* 0x77d7 */
    KANJI,        /* 0x77d8 */
    KANJI,        /* 0x77d9 */
    KANJI,        /* 0x77da */
    KANJI,        /* 0x77db */
    KANJI,        /* 0x77dc */
    KANJI,        /* 0x77dd */
    KANJI,        /* 0x77de */
    KANJI,        /* 0x77df */
    KANJI,        /* 0x77e0 */
    KANJI,        /* 0x77e1 */
    KANJI,        /* 0x77e2 */
    KANJI,        /* 0x77e3 */
    KANJI,        /* 0x77e4 */
    KANJI,        /* 0x77e5 */
    KANJI,        /* 0x77e6 */
    KANJI,        /* 0x77e7 */
    KANJI,        /* 0x77e8 */
    KANJI,        /* 0x77e9 */
    KANJI,        /* 0x77ea */
    KANJI,        /* 0x77eb */
    KANJI,        /* 0x77ec */
    KANJI,        /* 0x77ed */
    KANJI,        /* 0x77ee */
    KANJI,        /* 0x77ef */
    KANJI,        /* 0x77f0 */
    KANJI,        /* 0x77f1 */
    KANJI,        /* 0x77f2 */
    KANJI,        /* 0x77f3 */
    KANJI,        /* 0x77f4 */
    KANJI,        /* 0x77f5 */
    KANJI,        /* 0x77f6 */
    KANJI,        /* 0x77f7 */
    KANJI,        /* 0x77f8 */
    KANJI,        /* 0x77f9 */
    KANJI,        /* 0x77fa */
    KANJI,        /* 0x77fb */
    KANJI,        /* 0x77fc */
    KANJI,        /* 0x77fd */
    KANJI,        /* 0x77fe */
    KANJI,        /* 0x77ff */
    KANJI,        /* 0x7800 */
    KANJI,        /* 0x7801 */
    KANJI,        /* 0x7802 */
    KANJI,        /* 0x7803 */
    KANJI,        /* 0x7804 */
    KANJI,        /* 0x7805 */
    KANJI,        /* 0x7806 */
    KANJI,        /* 0x7807 */
    KANJI,        /* 0x7808 */
    KANJI,        /* 0x7809 */
    KANJI,        /* 0x780a */
    KANJI,        /* 0x780b */
    KANJI,        /* 0x780c */
    KANJI,        /* 0x780d */
    KANJI,        /* 0x780e */
    KANJI,        /* 0x780f */
    KANJI,        /* 0x7810 */
    KANJI,        /* 0x7811 */
    KANJI,        /* 0x7812 */
    KANJI,        /* 0x7813 */
    KANJI,        /* 0x7814 */
    KANJI,        /* 0x7815 */
    KANJI,        /* 0x7816 */
    KANJI,        /* 0x7817 */
    KANJI,        /* 0x7818 */
    KANJI,        /* 0x7819 */
    KANJI,        /* 0x781a */
    KANJI,        /* 0x781b */
    KANJI,        /* 0x781c */
    KANJI,        /* 0x781d */
    KANJI,        /* 0x781e */
    KANJI,        /* 0x781f */
    KANJI,        /* 0x7820 */
    KANJI,        /* 0x7821 */
    KANJI,        /* 0x7822 */
    KANJI,        /* 0x7823 */
    KANJI,        /* 0x7824 */
    KANJI,        /* 0x7825 */
    KANJI,        /* 0x7826 */
    KANJI,        /* 0x7827 */
    KANJI,        /* 0x7828 */
    KANJI,        /* 0x7829 */
    KANJI,        /* 0x782a */
    KANJI,        /* 0x782b */
    KANJI,        /* 0x782c */
    KANJI,        /* 0x782d */
    KANJI,        /* 0x782e */
    KANJI,        /* 0x782f */
    KANJI,        /* 0x7830 */
    KANJI,        /* 0x7831 */
    KANJI,        /* 0x7832 */
    KANJI,        /* 0x7833 */
    KANJI,        /* 0x7834 */
    KANJI,        /* 0x7835 */
    KANJI,        /* 0x7836 */
    KANJI,        /* 0x7837 */
    KANJI,        /* 0x7838 */
    KANJI,        /* 0x7839 */
    KANJI,        /* 0x783a */
    KANJI,        /* 0x783b */
    KANJI,        /* 0x783c */
    KANJI,        /* 0x783d */
    KANJI,        /* 0x783e */
    KANJI,        /* 0x783f */
    KANJI,        /* 0x7840 */
    KANJI,        /* 0x7841 */
    KANJI,        /* 0x7842 */
    KANJI,        /* 0x7843 */
    KANJI,        /* 0x7844 */
    KANJI,        /* 0x7845 */
    KANJI,        /* 0x7846 */
    KANJI,        /* 0x7847 */
    KANJI,        /* 0x7848 */
    KANJI,        /* 0x7849 */
    KANJI,        /* 0x784a */
    KANJI,        /* 0x784b */
    KANJI,        /* 0x784c */
    KANJI,        /* 0x784d */
    KANJI,        /* 0x784e */
    KANJI,        /* 0x784f */
    KANJI,        /* 0x7850 */
    KANJI,        /* 0x7851 */
    KANJI,        /* 0x7852 */
    KANJI,        /* 0x7853 */
    KANJI,        /* 0x7854 */
    KANJI,        /* 0x7855 */
    KANJI,        /* 0x7856 */
    KANJI,        /* 0x7857 */
    KANJI,        /* 0x7858 */
    KANJI,        /* 0x7859 */
    KANJI,        /* 0x785a */
    KANJI,        /* 0x785b */
    KANJI,        /* 0x785c */
    KANJI,        /* 0x785d */
    KANJI,        /* 0x785e */
    KANJI,        /* 0x785f */
    KANJI,        /* 0x7860 */
    KANJI,        /* 0x7861 */
    KANJI,        /* 0x7862 */
    KANJI,        /* 0x7863 */
    KANJI,        /* 0x7864 */
    KANJI,        /* 0x7865 */
    KANJI,        /* 0x7866 */
    KANJI,        /* 0x7867 */
    KANJI,        /* 0x7868 */
    KANJI,        /* 0x7869 */
    KANJI,        /* 0x786a */
    KANJI,        /* 0x786b */
    KANJI,        /* 0x786c */
    KANJI,        /* 0x786d */
    KANJI,        /* 0x786e */
    KANJI,        /* 0x786f */
    KANJI,        /* 0x7870 */
    KANJI,        /* 0x7871 */
    KANJI,        /* 0x7872 */
    KANJI,        /* 0x7873 */
    KANJI,        /* 0x7874 */
    KANJI,        /* 0x7875 */
    KANJI,        /* 0x7876 */
    KANJI,        /* 0x7877 */
    KANJI,        /* 0x7878 */
    KANJI,        /* 0x7879 */
    KANJI,        /* 0x787a */
    KANJI,        /* 0x787b */
    KANJI,        /* 0x787c */
    KANJI,        /* 0x787d */
    KANJI,        /* 0x787e */
    KANJI,        /* 0x787f */
    KANJI,        /* 0x7880 */
    KANJI,        /* 0x7881 */
    KANJI,        /* 0x7882 */
    KANJI,        /* 0x7883 */
    KANJI,        /* 0x7884 */
    KANJI,        /* 0x7885 */
    KANJI,        /* 0x7886 */
    KANJI,        /* 0x7887 */
    KANJI,        /* 0x7888 */
    KANJI,        /* 0x7889 */
    KANJI,        /* 0x788a */
    KANJI,        /* 0x788b */
    KANJI,        /* 0x788c */
    KANJI,        /* 0x788d */
    KANJI,        /* 0x788e */
    KANJI,        /* 0x788f */
    KANJI,        /* 0x7890 */
    KANJI,        /* 0x7891 */
    KANJI,        /* 0x7892 */
    KANJI,        /* 0x7893 */
    KANJI,        /* 0x7894 */
    KANJI,        /* 0x7895 */
    KANJI,        /* 0x7896 */
    KANJI,        /* 0x7897 */
    KANJI,        /* 0x7898 */
    KANJI,        /* 0x7899 */
    KANJI,        /* 0x789a */
    KANJI,        /* 0x789b */
    KANJI,        /* 0x789c */
    KANJI,        /* 0x789d */
    KANJI,        /* 0x789e */
    KANJI,        /* 0x789f */
    KANJI,        /* 0x78a0 */
    KANJI,        /* 0x78a1 */
    KANJI,        /* 0x78a2 */
    KANJI,        /* 0x78a3 */
    KANJI,        /* 0x78a4 */
    KANJI,        /* 0x78a5 */
    KANJI,        /* 0x78a6 */
    KANJI,        /* 0x78a7 */
    KANJI,        /* 0x78a8 */
    KANJI,        /* 0x78a9 */
    KANJI,        /* 0x78aa */
    KANJI,        /* 0x78ab */
    KANJI,        /* 0x78ac */
    KANJI,        /* 0x78ad */
    KANJI,        /* 0x78ae */
    KANJI,        /* 0x78af */
    KANJI,        /* 0x78b0 */
    KANJI,        /* 0x78b1 */
    KANJI,        /* 0x78b2 */
    KANJI,        /* 0x78b3 */
    KANJI,        /* 0x78b4 */
    KANJI,        /* 0x78b5 */
    KANJI,        /* 0x78b6 */
    KANJI,        /* 0x78b7 */
    KANJI,        /* 0x78b8 */
    KANJI,        /* 0x78b9 */
    KANJI,        /* 0x78ba */
    KANJI,        /* 0x78bb */
    KANJI,        /* 0x78bc */
    KANJI,        /* 0x78bd */
    KANJI,        /* 0x78be */
    KANJI,        /* 0x78bf */
    KANJI,        /* 0x78c0 */
    KANJI,        /* 0x78c1 */
    KANJI,        /* 0x78c2 */
    KANJI,        /* 0x78c3 */
    KANJI,        /* 0x78c4 */
    KANJI,        /* 0x78c5 */
    KANJI,        /* 0x78c6 */
    KANJI,        /* 0x78c7 */
    KANJI,        /* 0x78c8 */
    KANJI,        /* 0x78c9 */
    KANJI,        /* 0x78ca */
    KANJI,        /* 0x78cb */
    KANJI,        /* 0x78cc */
    KANJI,        /* 0x78cd */
    KANJI,        /* 0x78ce */
    KANJI,        /* 0x78cf */
    KANJI,        /* 0x78d0 */
    KANJI,        /* 0x78d1 */
    KANJI,        /* 0x78d2 */
    KANJI,        /* 0x78d3 */
    KANJI,        /* 0x78d4 */
    KANJI,        /* 0x78d5 */
    KANJI,        /* 0x78d6 */
    KANJI,        /* 0x78d7 */
    KANJI,        /* 0x78d8 */
    KANJI,        /* 0x78d9 */
    KANJI,        /* 0x78da */
    KANJI,        /* 0x78db */
    KANJI,        /* 0x78dc */
    KANJI,        /* 0x78dd */
    KANJI,        /* 0x78de */
    KANJI,        /* 0x78df */
    KANJI,        /* 0x78e0 */
    KANJI,        /* 0x78e1 */
    KANJI,        /* 0x78e2 */
    KANJI,        /* 0x78e3 */
    KANJI,        /* 0x78e4 */
    KANJI,        /* 0x78e5 */
    KANJI,        /* 0x78e6 */
    KANJI,        /* 0x78e7 */
    KANJI,        /* 0x78e8 */
    KANJI,        /* 0x78e9 */
    KANJI,        /* 0x78ea */
    KANJI,        /* 0x78eb */
    KANJI,        /* 0x78ec */
    KANJI,        /* 0x78ed */
    KANJI,        /* 0x78ee */
    KANJI,        /* 0x78ef */
    KANJI,        /* 0x78f0 */
    KANJI,        /* 0x78f1 */
    KANJI,        /* 0x78f2 */
    KANJI,        /* 0x78f3 */
    KANJI,        /* 0x78f4 */
    KANJI,        /* 0x78f5 */
    KANJI,        /* 0x78f6 */
    KANJI,        /* 0x78f7 */
    KANJI,        /* 0x78f8 */
    KANJI,        /* 0x78f9 */
    KANJI,        /* 0x78fa */
    KANJI,        /* 0x78fb */
    KANJI,        /* 0x78fc */
    KANJI,        /* 0x78fd */
    KANJI,        /* 0x78fe */
    KANJI,        /* 0x78ff */
    KANJI,        /* 0x7900 */
    KANJI,        /* 0x7901 */
    KANJI,        /* 0x7902 */
    KANJI,        /* 0x7903 */
    KANJI,        /* 0x7904 */
    KANJI,        /* 0x7905 */
    KANJI,        /* 0x7906 */
    KANJI,        /* 0x7907 */
    KANJI,        /* 0x7908 */
    KANJI,        /* 0x7909 */
    KANJI,        /* 0x790a */
    KANJI,        /* 0x790b */
    KANJI,        /* 0x790c */
    KANJI,        /* 0x790d */
    KANJI,        /* 0x790e */
    KANJI,        /* 0x790f */
    KANJI,        /* 0x7910 */
    KANJI,        /* 0x7911 */
    KANJI,        /* 0x7912 */
    KANJI,        /* 0x7913 */
    KANJI,        /* 0x7914 */
    KANJI,        /* 0x7915 */
    KANJI,        /* 0x7916 */
    KANJI,        /* 0x7917 */
    KANJI,        /* 0x7918 */
    KANJI,        /* 0x7919 */
    KANJI,        /* 0x791a */
    KANJI,        /* 0x791b */
    KANJI,        /* 0x791c */
    KANJI,        /* 0x791d */
    KANJI,        /* 0x791e */
    KANJI,        /* 0x791f */
    KANJI,        /* 0x7920 */
    KANJI,        /* 0x7921 */
    KANJI,        /* 0x7922 */
    KANJI,        /* 0x7923 */
    KANJI,        /* 0x7924 */
    KANJI,        /* 0x7925 */
    KANJI,        /* 0x7926 */
    KANJI,        /* 0x7927 */
    KANJI,        /* 0x7928 */
    KANJI,        /* 0x7929 */
    KANJI,        /* 0x792a */
    KANJI,        /* 0x792b */
    KANJI,        /* 0x792c */
    KANJI,        /* 0x792d */
    KANJI,        /* 0x792e */
    KANJI,        /* 0x792f */
    KANJI,        /* 0x7930 */
    KANJI,        /* 0x7931 */
    KANJI,        /* 0x7932 */
    KANJI,        /* 0x7933 */
    KANJI,        /* 0x7934 */
    KANJI,        /* 0x7935 */
    KANJI,        /* 0x7936 */
    KANJI,        /* 0x7937 */
    KANJI,        /* 0x7938 */
    KANJI,        /* 0x7939 */
    KANJI,        /* 0x793a */
    KANJI,        /* 0x793b */
    KANJI,        /* 0x793c */
    KANJI,        /* 0x793d */
    KANJI,        /* 0x793e */
    KANJI,        /* 0x793f */
    KANJI,        /* 0x7940 */
    KANJI,        /* 0x7941 */
    KANJI,        /* 0x7942 */
    KANJI,        /* 0x7943 */
    KANJI,        /* 0x7944 */
    KANJI,        /* 0x7945 */
    KANJI,        /* 0x7946 */
    KANJI,        /* 0x7947 */
    KANJI,        /* 0x7948 */
    KANJI,        /* 0x7949 */
    KANJI,        /* 0x794a */
    KANJI,        /* 0x794b */
    KANJI,        /* 0x794c */
    KANJI,        /* 0x794d */
    KANJI,        /* 0x794e */
    KANJI,        /* 0x794f */
    KANJI,        /* 0x7950 */
    KANJI,        /* 0x7951 */
    KANJI,        /* 0x7952 */
    KANJI,        /* 0x7953 */
    KANJI,        /* 0x7954 */
    KANJI,        /* 0x7955 */
    KANJI,        /* 0x7956 */
    KANJI,        /* 0x7957 */
    KANJI,        /* 0x7958 */
    KANJI,        /* 0x7959 */
    KANJI,        /* 0x795a */
    KANJI,        /* 0x795b */
    KANJI,        /* 0x795c */
    KANJI,        /* 0x795d */
    KANJI,        /* 0x795e */
    KANJI,        /* 0x795f */
    KANJI,        /* 0x7960 */
    KANJI,        /* 0x7961 */
    KANJI,        /* 0x7962 */
    KANJI,        /* 0x7963 */
    KANJI,        /* 0x7964 */
    KANJI,        /* 0x7965 */
    KANJI,        /* 0x7966 */
    KANJI,        /* 0x7967 */
    KANJI,        /* 0x7968 */
    KANJI,        /* 0x7969 */
    KANJI,        /* 0x796a */
    KANJI,        /* 0x796b */
    KANJI,        /* 0x796c */
    KANJI,        /* 0x796d */
    KANJI,        /* 0x796e */
    KANJI,        /* 0x796f */
    KANJI,        /* 0x7970 */
    KANJI,        /* 0x7971 */
    KANJI,        /* 0x7972 */
    KANJI,        /* 0x7973 */
    KANJI,        /* 0x7974 */
    KANJI,        /* 0x7975 */
    KANJI,        /* 0x7976 */
    KANJI,        /* 0x7977 */
    KANJI,        /* 0x7978 */
    KANJI,        /* 0x7979 */
    KANJI,        /* 0x797a */
    KANJI,        /* 0x797b */
    KANJI,        /* 0x797c */
    KANJI,        /* 0x797d */
    KANJI,        /* 0x797e */
    KANJI,        /* 0x797f */
    KANJI,        /* 0x7980 */
    KANJI,        /* 0x7981 */
    KANJI,        /* 0x7982 */
    KANJI,        /* 0x7983 */
    KANJI,        /* 0x7984 */
    KANJI,        /* 0x7985 */
    KANJI,        /* 0x7986 */
    KANJI,        /* 0x7987 */
    KANJI,        /* 0x7988 */
    KANJI,        /* 0x7989 */
    KANJI,        /* 0x798a */
    KANJI,        /* 0x798b */
    KANJI,        /* 0x798c */
    KANJI,        /* 0x798d */
    KANJI,        /* 0x798e */
    KANJI,        /* 0x798f */
    KANJI,        /* 0x7990 */
    KANJI,        /* 0x7991 */
    KANJI,        /* 0x7992 */
    KANJI,        /* 0x7993 */
    KANJI,        /* 0x7994 */
    KANJI,        /* 0x7995 */
    KANJI,        /* 0x7996 */
    KANJI,        /* 0x7997 */
    KANJI,        /* 0x7998 */
    KANJI,        /* 0x7999 */
    KANJI,        /* 0x799a */
    KANJI,        /* 0x799b */
    KANJI,        /* 0x799c */
    KANJI,        /* 0x799d */
    KANJI,        /* 0x799e */
    KANJI,        /* 0x799f */
    KANJI,        /* 0x79a0 */
    KANJI,        /* 0x79a1 */
    KANJI,        /* 0x79a2 */
    KANJI,        /* 0x79a3 */
    KANJI,        /* 0x79a4 */
    KANJI,        /* 0x79a5 */
    KANJI,        /* 0x79a6 */
    KANJI,        /* 0x79a7 */
    KANJI,        /* 0x79a8 */
    KANJI,        /* 0x79a9 */
    KANJI,        /* 0x79aa */
    KANJI,        /* 0x79ab */
    KANJI,        /* 0x79ac */
    KANJI,        /* 0x79ad */
    KANJI,        /* 0x79ae */
    KANJI,        /* 0x79af */
    KANJI,        /* 0x79b0 */
    KANJI,        /* 0x79b1 */
    KANJI,        /* 0x79b2 */
    KANJI,        /* 0x79b3 */
    KANJI,        /* 0x79b4 */
    KANJI,        /* 0x79b5 */
    KANJI,        /* 0x79b6 */
    KANJI,        /* 0x79b7 */
    KANJI,        /* 0x79b8 */
    KANJI,        /* 0x79b9 */
    KANJI,        /* 0x79ba */
    KANJI,        /* 0x79bb */
    KANJI,        /* 0x79bc */
    KANJI,        /* 0x79bd */
    KANJI,        /* 0x79be */
    KANJI,        /* 0x79bf */
    KANJI,        /* 0x79c0 */
    KANJI,        /* 0x79c1 */
    KANJI,        /* 0x79c2 */
    KANJI,        /* 0x79c3 */
    KANJI,        /* 0x79c4 */
    KANJI,        /* 0x79c5 */
    KANJI,        /* 0x79c6 */
    KANJI,        /* 0x79c7 */
    KANJI,        /* 0x79c8 */
    KANJI,        /* 0x79c9 */
    KANJI,        /* 0x79ca */
    KANJI,        /* 0x79cb */
    KANJI,        /* 0x79cc */
    KANJI,        /* 0x79cd */
    KANJI,        /* 0x79ce */
    KANJI,        /* 0x79cf */
    KANJI,        /* 0x79d0 */
    KANJI,        /* 0x79d1 */
    KANJI,        /* 0x79d2 */
    KANJI,        /* 0x79d3 */
    KANJI,        /* 0x79d4 */
    KANJI,        /* 0x79d5 */
    KANJI,        /* 0x79d6 */
    KANJI,        /* 0x79d7 */
    KANJI,        /* 0x79d8 */
    KANJI,        /* 0x79d9 */
    KANJI,        /* 0x79da */
    KANJI,        /* 0x79db */
    KANJI,        /* 0x79dc */
    KANJI,        /* 0x79dd */
    KANJI,        /* 0x79de */
    KANJI,        /* 0x79df */
    KANJI,        /* 0x79e0 */
    KANJI,        /* 0x79e1 */
    KANJI,        /* 0x79e2 */
    KANJI,        /* 0x79e3 */
    KANJI,        /* 0x79e4 */
    KANJI,        /* 0x79e5 */
    KANJI,        /* 0x79e6 */
    KANJI,        /* 0x79e7 */
    KANJI,        /* 0x79e8 */
    KANJI,        /* 0x79e9 */
    KANJI,        /* 0x79ea */
    KANJI,        /* 0x79eb */
    KANJI,        /* 0x79ec */
    KANJI,        /* 0x79ed */
    KANJI,        /* 0x79ee */
    KANJI,        /* 0x79ef */
    KANJI,        /* 0x79f0 */
    KANJI,        /* 0x79f1 */
    KANJI,        /* 0x79f2 */
    KANJI,        /* 0x79f3 */
    KANJI,        /* 0x79f4 */
    KANJI,        /* 0x79f5 */
    KANJI,        /* 0x79f6 */
    KANJI,        /* 0x79f7 */
    KANJI,        /* 0x79f8 */
    KANJI,        /* 0x79f9 */
    KANJI,        /* 0x79fa */
    KANJI,        /* 0x79fb */
    KANJI,        /* 0x79fc */
    KANJI,        /* 0x79fd */
    KANJI,        /* 0x79fe */
    KANJI,        /* 0x79ff */
    KANJI,        /* 0x7a00 */
    KANJI,        /* 0x7a01 */
    KANJI,        /* 0x7a02 */
    KANJI,        /* 0x7a03 */
    KANJI,        /* 0x7a04 */
    KANJI,        /* 0x7a05 */
    KANJI,        /* 0x7a06 */
    KANJI,        /* 0x7a07 */
    KANJI,        /* 0x7a08 */
    KANJI,        /* 0x7a09 */
    KANJI,        /* 0x7a0a */
    KANJI,        /* 0x7a0b */
    KANJI,        /* 0x7a0c */
    KANJI,        /* 0x7a0d */
    KANJI,        /* 0x7a0e */
    KANJI,        /* 0x7a0f */
    KANJI,        /* 0x7a10 */
    KANJI,        /* 0x7a11 */
    KANJI,        /* 0x7a12 */
    KANJI,        /* 0x7a13 */
    KANJI,        /* 0x7a14 */
    KANJI,        /* 0x7a15 */
    KANJI,        /* 0x7a16 */
    KANJI,        /* 0x7a17 */
    KANJI,        /* 0x7a18 */
    KANJI,        /* 0x7a19 */
    KANJI,        /* 0x7a1a */
    KANJI,        /* 0x7a1b */
    KANJI,        /* 0x7a1c */
    KANJI,        /* 0x7a1d */
    KANJI,        /* 0x7a1e */
    KANJI,        /* 0x7a1f */
    KANJI,        /* 0x7a20 */
    KANJI,        /* 0x7a21 */
    KANJI,        /* 0x7a22 */
    KANJI,        /* 0x7a23 */
    KANJI,        /* 0x7a24 */
    KANJI,        /* 0x7a25 */
    KANJI,        /* 0x7a26 */
    KANJI,        /* 0x7a27 */
    KANJI,        /* 0x7a28 */
    KANJI,        /* 0x7a29 */
    KANJI,        /* 0x7a2a */
    KANJI,        /* 0x7a2b */
    KANJI,        /* 0x7a2c */
    KANJI,        /* 0x7a2d */
    KANJI,        /* 0x7a2e */
    KANJI,        /* 0x7a2f */
    KANJI,        /* 0x7a30 */
    KANJI,        /* 0x7a31 */
    KANJI,        /* 0x7a32 */
    KANJI,        /* 0x7a33 */
    KANJI,        /* 0x7a34 */
    KANJI,        /* 0x7a35 */
    KANJI,        /* 0x7a36 */
    KANJI,        /* 0x7a37 */
    KANJI,        /* 0x7a38 */
    KANJI,        /* 0x7a39 */
    KANJI,        /* 0x7a3a */
    KANJI,        /* 0x7a3b */
    KANJI,        /* 0x7a3c */
    KANJI,        /* 0x7a3d */
    KANJI,        /* 0x7a3e */
    KANJI,        /* 0x7a3f */
    KANJI,        /* 0x7a40 */
    KANJI,        /* 0x7a41 */
    KANJI,        /* 0x7a42 */
    KANJI,        /* 0x7a43 */
    KANJI,        /* 0x7a44 */
    KANJI,        /* 0x7a45 */
    KANJI,        /* 0x7a46 */
    KANJI,        /* 0x7a47 */
    KANJI,        /* 0x7a48 */
    KANJI,        /* 0x7a49 */
    KANJI,        /* 0x7a4a */
    KANJI,        /* 0x7a4b */
    KANJI,        /* 0x7a4c */
    KANJI,        /* 0x7a4d */
    KANJI,        /* 0x7a4e */
    KANJI,        /* 0x7a4f */
    KANJI,        /* 0x7a50 */
    KANJI,        /* 0x7a51 */
    KANJI,        /* 0x7a52 */
    KANJI,        /* 0x7a53 */
    KANJI,        /* 0x7a54 */
    KANJI,        /* 0x7a55 */
    KANJI,        /* 0x7a56 */
    KANJI,        /* 0x7a57 */
    KANJI,        /* 0x7a58 */
    KANJI,        /* 0x7a59 */
    KANJI,        /* 0x7a5a */
    KANJI,        /* 0x7a5b */
    KANJI,        /* 0x7a5c */
    KANJI,        /* 0x7a5d */
    KANJI,        /* 0x7a5e */
    KANJI,        /* 0x7a5f */
    KANJI,        /* 0x7a60 */
    KANJI,        /* 0x7a61 */
    KANJI,        /* 0x7a62 */
    KANJI,        /* 0x7a63 */
    KANJI,        /* 0x7a64 */
    KANJI,        /* 0x7a65 */
    KANJI,        /* 0x7a66 */
    KANJI,        /* 0x7a67 */
    KANJI,        /* 0x7a68 */
    KANJI,        /* 0x7a69 */
    KANJI,        /* 0x7a6a */
    KANJI,        /* 0x7a6b */
    KANJI,        /* 0x7a6c */
    KANJI,        /* 0x7a6d */
    KANJI,        /* 0x7a6e */
    KANJI,        /* 0x7a6f */
    KANJI,        /* 0x7a70 */
    KANJI,        /* 0x7a71 */
    KANJI,        /* 0x7a72 */
    KANJI,        /* 0x7a73 */
    KANJI,        /* 0x7a74 */
    KANJI,        /* 0x7a75 */
    KANJI,        /* 0x7a76 */
    KANJI,        /* 0x7a77 */
    KANJI,        /* 0x7a78 */
    KANJI,        /* 0x7a79 */
    KANJI,        /* 0x7a7a */
    KANJI,        /* 0x7a7b */
    KANJI,        /* 0x7a7c */
    KANJI,        /* 0x7a7d */
    KANJI,        /* 0x7a7e */
    KANJI,        /* 0x7a7f */
    KANJI,        /* 0x7a80 */
    KANJI,        /* 0x7a81 */
    KANJI,        /* 0x7a82 */
    KANJI,        /* 0x7a83 */
    KANJI,        /* 0x7a84 */
    KANJI,        /* 0x7a85 */
    KANJI,        /* 0x7a86 */
    KANJI,        /* 0x7a87 */
    KANJI,        /* 0x7a88 */
    KANJI,        /* 0x7a89 */
    KANJI,        /* 0x7a8a */
    KANJI,        /* 0x7a8b */
    KANJI,        /* 0x7a8c */
    KANJI,        /* 0x7a8d */
    KANJI,        /* 0x7a8e */
    KANJI,        /* 0x7a8f */
    KANJI,        /* 0x7a90 */
    KANJI,        /* 0x7a91 */
    KANJI,        /* 0x7a92 */
    KANJI,        /* 0x7a93 */
    KANJI,        /* 0x7a94 */
    KANJI,        /* 0x7a95 */
    KANJI,        /* 0x7a96 */
    KANJI,        /* 0x7a97 */
    KANJI,        /* 0x7a98 */
    KANJI,        /* 0x7a99 */
    KANJI,        /* 0x7a9a */
    KANJI,        /* 0x7a9b */
    KANJI,        /* 0x7a9c */
    KANJI,        /* 0x7a9d */
    KANJI,        /* 0x7a9e */
    KANJI,        /* 0x7a9f */
    KANJI,        /* 0x7aa0 */
    KANJI,        /* 0x7aa1 */
    KANJI,        /* 0x7aa2 */
    KANJI,        /* 0x7aa3 */
    KANJI,        /* 0x7aa4 */
    KANJI,        /* 0x7aa5 */
    KANJI,        /* 0x7aa6 */
    KANJI,        /* 0x7aa7 */
    KANJI,        /* 0x7aa8 */
    KANJI,        /* 0x7aa9 */
    KANJI,        /* 0x7aaa */
    KANJI,        /* 0x7aab */
    KANJI,        /* 0x7aac */
    KANJI,        /* 0x7aad */
    KANJI,        /* 0x7aae */
    KANJI,        /* 0x7aaf */
    KANJI,        /* 0x7ab0 */
    KANJI,        /* 0x7ab1 */
    KANJI,        /* 0x7ab2 */
    KANJI,        /* 0x7ab3 */
    KANJI,        /* 0x7ab4 */
    KANJI,        /* 0x7ab5 */
    KANJI,        /* 0x7ab6 */
    KANJI,        /* 0x7ab7 */
    KANJI,        /* 0x7ab8 */
    KANJI,        /* 0x7ab9 */
    KANJI,        /* 0x7aba */
    KANJI,        /* 0x7abb */
    KANJI,        /* 0x7abc */
    KANJI,        /* 0x7abd */
    KANJI,        /* 0x7abe */
    KANJI,        /* 0x7abf */
    KANJI,        /* 0x7ac0 */
    KANJI,        /* 0x7ac1 */
    KANJI,        /* 0x7ac2 */
    KANJI,        /* 0x7ac3 */
    KANJI,        /* 0x7ac4 */
    KANJI,        /* 0x7ac5 */
    KANJI,        /* 0x7ac6 */
    KANJI,        /* 0x7ac7 */
    KANJI,        /* 0x7ac8 */
    KANJI,        /* 0x7ac9 */
    KANJI,        /* 0x7aca */
    KANJI,        /* 0x7acb */
    KANJI,        /* 0x7acc */
    KANJI,        /* 0x7acd */
    KANJI,        /* 0x7ace */
    KANJI,        /* 0x7acf */
    KANJI,        /* 0x7ad0 */
    KANJI,        /* 0x7ad1 */
    KANJI,        /* 0x7ad2 */
    KANJI,        /* 0x7ad3 */
    KANJI,        /* 0x7ad4 */
    KANJI,        /* 0x7ad5 */
    KANJI,        /* 0x7ad6 */
    KANJI,        /* 0x7ad7 */
    KANJI,        /* 0x7ad8 */
    KANJI,        /* 0x7ad9 */
    KANJI,        /* 0x7ada */
    KANJI,        /* 0x7adb */
    KANJI,        /* 0x7adc */
    KANJI,        /* 0x7add */
    KANJI,        /* 0x7ade */
    KANJI,        /* 0x7adf */
    KANJI,        /* 0x7ae0 */
    KANJI,        /* 0x7ae1 */
    KANJI,        /* 0x7ae2 */
    KANJI,        /* 0x7ae3 */
    KANJI,        /* 0x7ae4 */
    KANJI,        /* 0x7ae5 */
    KANJI,        /* 0x7ae6 */
    KANJI,        /* 0x7ae7 */
    KANJI,        /* 0x7ae8 */
    KANJI,        /* 0x7ae9 */
    KANJI,        /* 0x7aea */
    KANJI,        /* 0x7aeb */
    KANJI,        /* 0x7aec */
    KANJI,        /* 0x7aed */
    KANJI,        /* 0x7aee */
    KANJI,        /* 0x7aef */
    KANJI,        /* 0x7af0 */
    KANJI,        /* 0x7af1 */
    KANJI,        /* 0x7af2 */
    KANJI,        /* 0x7af3 */
    KANJI,        /* 0x7af4 */
    KANJI,        /* 0x7af5 */
    KANJI,        /* 0x7af6 */
    KANJI,        /* 0x7af7 */
    KANJI,        /* 0x7af8 */
    KANJI,        /* 0x7af9 */
    KANJI,        /* 0x7afa */
    KANJI,        /* 0x7afb */
    KANJI,        /* 0x7afc */
    KANJI,        /* 0x7afd */
    KANJI,        /* 0x7afe */
    KANJI,        /* 0x7aff */
    KANJI,        /* 0x7b00 */
    KANJI,        /* 0x7b01 */
    KANJI,        /* 0x7b02 */
    KANJI,        /* 0x7b03 */
    KANJI,        /* 0x7b04 */
    KANJI,        /* 0x7b05 */
    KANJI,        /* 0x7b06 */
    KANJI,        /* 0x7b07 */
    KANJI,        /* 0x7b08 */
    KANJI,        /* 0x7b09 */
    KANJI,        /* 0x7b0a */
    KANJI,        /* 0x7b0b */
    KANJI,        /* 0x7b0c */
    KANJI,        /* 0x7b0d */
    KANJI,        /* 0x7b0e */
    KANJI,        /* 0x7b0f */
    KANJI,        /* 0x7b10 */
    KANJI,        /* 0x7b11 */
    KANJI,        /* 0x7b12 */
    KANJI,        /* 0x7b13 */
    KANJI,        /* 0x7b14 */
    KANJI,        /* 0x7b15 */
    KANJI,        /* 0x7b16 */
    KANJI,        /* 0x7b17 */
    KANJI,        /* 0x7b18 */
    KANJI,        /* 0x7b19 */
    KANJI,        /* 0x7b1a */
    KANJI,        /* 0x7b1b */
    KANJI,        /* 0x7b1c */
    KANJI,        /* 0x7b1d */
    KANJI,        /* 0x7b1e */
    KANJI,        /* 0x7b1f */
    KANJI,        /* 0x7b20 */
    KANJI,        /* 0x7b21 */
    KANJI,        /* 0x7b22 */
    KANJI,        /* 0x7b23 */
    KANJI,        /* 0x7b24 */
    KANJI,        /* 0x7b25 */
    KANJI,        /* 0x7b26 */
    KANJI,        /* 0x7b27 */
    KANJI,        /* 0x7b28 */
    KANJI,        /* 0x7b29 */
    KANJI,        /* 0x7b2a */
    KANJI,        /* 0x7b2b */
    KANJI,        /* 0x7b2c */
    KANJI,        /* 0x7b2d */
    KANJI,        /* 0x7b2e */
    KANJI,        /* 0x7b2f */
    KANJI,        /* 0x7b30 */
    KANJI,        /* 0x7b31 */
    KANJI,        /* 0x7b32 */
    KANJI,        /* 0x7b33 */
    KANJI,        /* 0x7b34 */
    KANJI,        /* 0x7b35 */
    KANJI,        /* 0x7b36 */
    KANJI,        /* 0x7b37 */
    KANJI,        /* 0x7b38 */
    KANJI,        /* 0x7b39 */
    KANJI,        /* 0x7b3a */
    KANJI,        /* 0x7b3b */
    KANJI,        /* 0x7b3c */
    KANJI,        /* 0x7b3d */
    KANJI,        /* 0x7b3e */
    KANJI,        /* 0x7b3f */
    KANJI,        /* 0x7b40 */
    KANJI,        /* 0x7b41 */
    KANJI,        /* 0x7b42 */
    KANJI,        /* 0x7b43 */
    KANJI,        /* 0x7b44 */
    KANJI,        /* 0x7b45 */
    KANJI,        /* 0x7b46 */
    KANJI,        /* 0x7b47 */
    KANJI,        /* 0x7b48 */
    KANJI,        /* 0x7b49 */
    KANJI,        /* 0x7b4a */
    KANJI,        /* 0x7b4b */
    KANJI,        /* 0x7b4c */
    KANJI,        /* 0x7b4d */
    KANJI,        /* 0x7b4e */
    KANJI,        /* 0x7b4f */
    KANJI,        /* 0x7b50 */
    KANJI,        /* 0x7b51 */
    KANJI,        /* 0x7b52 */
    KANJI,        /* 0x7b53 */
    KANJI,        /* 0x7b54 */
    KANJI,        /* 0x7b55 */
    KANJI,        /* 0x7b56 */
    KANJI,        /* 0x7b57 */
    KANJI,        /* 0x7b58 */
    KANJI,        /* 0x7b59 */
    KANJI,        /* 0x7b5a */
    KANJI,        /* 0x7b5b */
    KANJI,        /* 0x7b5c */
    KANJI,        /* 0x7b5d */
    KANJI,        /* 0x7b5e */
    KANJI,        /* 0x7b5f */
    KANJI,        /* 0x7b60 */
    KANJI,        /* 0x7b61 */
    KANJI,        /* 0x7b62 */
    KANJI,        /* 0x7b63 */
    KANJI,        /* 0x7b64 */
    KANJI,        /* 0x7b65 */
    KANJI,        /* 0x7b66 */
    KANJI,        /* 0x7b67 */
    KANJI,        /* 0x7b68 */
    KANJI,        /* 0x7b69 */
    KANJI,        /* 0x7b6a */
    KANJI,        /* 0x7b6b */
    KANJI,        /* 0x7b6c */
    KANJI,        /* 0x7b6d */
    KANJI,        /* 0x7b6e */
    KANJI,        /* 0x7b6f */
    KANJI,        /* 0x7b70 */
    KANJI,        /* 0x7b71 */
    KANJI,        /* 0x7b72 */
    KANJI,        /* 0x7b73 */
    KANJI,        /* 0x7b74 */
    KANJI,        /* 0x7b75 */
    KANJI,        /* 0x7b76 */
    KANJI,        /* 0x7b77 */
    KANJI,        /* 0x7b78 */
    KANJI,        /* 0x7b79 */
    KANJI,        /* 0x7b7a */
    KANJI,        /* 0x7b7b */
    KANJI,        /* 0x7b7c */
    KANJI,        /* 0x7b7d */
    KANJI,        /* 0x7b7e */
    KANJI,        /* 0x7b7f */
    KANJI,        /* 0x7b80 */
    KANJI,        /* 0x7b81 */
    KANJI,        /* 0x7b82 */
    KANJI,        /* 0x7b83 */
    KANJI,        /* 0x7b84 */
    KANJI,        /* 0x7b85 */
    KANJI,        /* 0x7b86 */
    KANJI,        /* 0x7b87 */
    KANJI,        /* 0x7b88 */
    KANJI,        /* 0x7b89 */
    KANJI,        /* 0x7b8a */
    KANJI,        /* 0x7b8b */
    KANJI,        /* 0x7b8c */
    KANJI,        /* 0x7b8d */
    KANJI,        /* 0x7b8e */
    KANJI,        /* 0x7b8f */
    KANJI,        /* 0x7b90 */
    KANJI,        /* 0x7b91 */
    KANJI,        /* 0x7b92 */
    KANJI,        /* 0x7b93 */
    KANJI,        /* 0x7b94 */
    KANJI,        /* 0x7b95 */
    KANJI,        /* 0x7b96 */
    KANJI,        /* 0x7b97 */
    KANJI,        /* 0x7b98 */
    KANJI,        /* 0x7b99 */
    KANJI,        /* 0x7b9a */
    KANJI,        /* 0x7b9b */
    KANJI,        /* 0x7b9c */
    KANJI,        /* 0x7b9d */
    KANJI,        /* 0x7b9e */
    KANJI,        /* 0x7b9f */
    KANJI,        /* 0x7ba0 */
    KANJI,        /* 0x7ba1 */
    KANJI,        /* 0x7ba2 */
    KANJI,        /* 0x7ba3 */
    KANJI,        /* 0x7ba4 */
    KANJI,        /* 0x7ba5 */
    KANJI,        /* 0x7ba6 */
    KANJI,        /* 0x7ba7 */
    KANJI,        /* 0x7ba8 */
    KANJI,        /* 0x7ba9 */
    KANJI,        /* 0x7baa */
    KANJI,        /* 0x7bab */
    KANJI,        /* 0x7bac */
    KANJI,        /* 0x7bad */
    KANJI,        /* 0x7bae */
    KANJI,        /* 0x7baf */
    KANJI,        /* 0x7bb0 */
    KANJI,        /* 0x7bb1 */
    KANJI,        /* 0x7bb2 */
    KANJI,        /* 0x7bb3 */
    KANJI,        /* 0x7bb4 */
    KANJI,        /* 0x7bb5 */
    KANJI,        /* 0x7bb6 */
    KANJI,        /* 0x7bb7 */
    KANJI,        /* 0x7bb8 */
    KANJI,        /* 0x7bb9 */
    KANJI,        /* 0x7bba */
    KANJI,        /* 0x7bbb */
    KANJI,        /* 0x7bbc */
    KANJI,        /* 0x7bbd */
    KANJI,        /* 0x7bbe */
    KANJI,        /* 0x7bbf */
    KANJI,        /* 0x7bc0 */
    KANJI,        /* 0x7bc1 */
    KANJI,        /* 0x7bc2 */
    KANJI,        /* 0x7bc3 */
    KANJI,        /* 0x7bc4 */
    KANJI,        /* 0x7bc5 */
    KANJI,        /* 0x7bc6 */
    KANJI,        /* 0x7bc7 */
    KANJI,        /* 0x7bc8 */
    KANJI,        /* 0x7bc9 */
    KANJI,        /* 0x7bca */
    KANJI,        /* 0x7bcb */
    KANJI,        /* 0x7bcc */
    KANJI,        /* 0x7bcd */
    KANJI,        /* 0x7bce */
    KANJI,        /* 0x7bcf */
    KANJI,        /* 0x7bd0 */
    KANJI,        /* 0x7bd1 */
    KANJI,        /* 0x7bd2 */
    KANJI,        /* 0x7bd3 */
    KANJI,        /* 0x7bd4 */
    KANJI,        /* 0x7bd5 */
    KANJI,        /* 0x7bd6 */
    KANJI,        /* 0x7bd7 */
    KANJI,        /* 0x7bd8 */
    KANJI,        /* 0x7bd9 */
    KANJI,        /* 0x7bda */
    KANJI,        /* 0x7bdb */
    KANJI,        /* 0x7bdc */
    KANJI,        /* 0x7bdd */
    KANJI,        /* 0x7bde */
    KANJI,        /* 0x7bdf */
    KANJI,        /* 0x7be0 */
    KANJI,        /* 0x7be1 */
    KANJI,        /* 0x7be2 */
    KANJI,        /* 0x7be3 */
    KANJI,        /* 0x7be4 */
    KANJI,        /* 0x7be5 */
    KANJI,        /* 0x7be6 */
    KANJI,        /* 0x7be7 */
    KANJI,        /* 0x7be8 */
    KANJI,        /* 0x7be9 */
    KANJI,        /* 0x7bea */
    KANJI,        /* 0x7beb */
    KANJI,        /* 0x7bec */
    KANJI,        /* 0x7bed */
    KANJI,        /* 0x7bee */
    KANJI,        /* 0x7bef */
    KANJI,        /* 0x7bf0 */
    KANJI,        /* 0x7bf1 */
    KANJI,        /* 0x7bf2 */
    KANJI,        /* 0x7bf3 */
    KANJI,        /* 0x7bf4 */
    KANJI,        /* 0x7bf5 */
    KANJI,        /* 0x7bf6 */
    KANJI,        /* 0x7bf7 */
    KANJI,        /* 0x7bf8 */
    KANJI,        /* 0x7bf9 */
    KANJI,        /* 0x7bfa */
    KANJI,        /* 0x7bfb */
    KANJI,        /* 0x7bfc */
    KANJI,        /* 0x7bfd */
    KANJI,        /* 0x7bfe */
    KANJI,        /* 0x7bff */
    KANJI,        /* 0x7c00 */
    KANJI,        /* 0x7c01 */
    KANJI,        /* 0x7c02 */
    KANJI,        /* 0x7c03 */
    KANJI,        /* 0x7c04 */
    KANJI,        /* 0x7c05 */
    KANJI,        /* 0x7c06 */
    KANJI,        /* 0x7c07 */
    KANJI,        /* 0x7c08 */
    KANJI,        /* 0x7c09 */
    KANJI,        /* 0x7c0a */
    KANJI,        /* 0x7c0b */
    KANJI,        /* 0x7c0c */
    KANJI,        /* 0x7c0d */
    KANJI,        /* 0x7c0e */
    KANJI,        /* 0x7c0f */
    KANJI,        /* 0x7c10 */
    KANJI,        /* 0x7c11 */
    KANJI,        /* 0x7c12 */
    KANJI,        /* 0x7c13 */
    KANJI,        /* 0x7c14 */
    KANJI,        /* 0x7c15 */
    KANJI,        /* 0x7c16 */
    KANJI,        /* 0x7c17 */
    KANJI,        /* 0x7c18 */
    KANJI,        /* 0x7c19 */
    KANJI,        /* 0x7c1a */
    KANJI,        /* 0x7c1b */
    KANJI,        /* 0x7c1c */
    KANJI,        /* 0x7c1d */
    KANJI,        /* 0x7c1e */
    KANJI,        /* 0x7c1f */
    KANJI,        /* 0x7c20 */
    KANJI,        /* 0x7c21 */
    KANJI,        /* 0x7c22 */
    KANJI,        /* 0x7c23 */
    KANJI,        /* 0x7c24 */
    KANJI,        /* 0x7c25 */
    KANJI,        /* 0x7c26 */
    KANJI,        /* 0x7c27 */
    KANJI,        /* 0x7c28 */
    KANJI,        /* 0x7c29 */
    KANJI,        /* 0x7c2a */
    KANJI,        /* 0x7c2b */
    KANJI,        /* 0x7c2c */
    KANJI,        /* 0x7c2d */
    KANJI,        /* 0x7c2e */
    KANJI,        /* 0x7c2f */
    KANJI,        /* 0x7c30 */
    KANJI,        /* 0x7c31 */
    KANJI,        /* 0x7c32 */
    KANJI,        /* 0x7c33 */
    KANJI,        /* 0x7c34 */
    KANJI,        /* 0x7c35 */
    KANJI,        /* 0x7c36 */
    KANJI,        /* 0x7c37 */
    KANJI,        /* 0x7c38 */
    KANJI,        /* 0x7c39 */
    KANJI,        /* 0x7c3a */
    KANJI,        /* 0x7c3b */
    KANJI,        /* 0x7c3c */
    KANJI,        /* 0x7c3d */
    KANJI,        /* 0x7c3e */
    KANJI,        /* 0x7c3f */
    KANJI,        /* 0x7c40 */
    KANJI,        /* 0x7c41 */
    KANJI,        /* 0x7c42 */
    KANJI,        /* 0x7c43 */
    KANJI,        /* 0x7c44 */
    KANJI,        /* 0x7c45 */
    KANJI,        /* 0x7c46 */
    KANJI,        /* 0x7c47 */
    KANJI,        /* 0x7c48 */
    KANJI,        /* 0x7c49 */
    KANJI,        /* 0x7c4a */
    KANJI,        /* 0x7c4b */
    KANJI,        /* 0x7c4c */
    KANJI,        /* 0x7c4d */
    KANJI,        /* 0x7c4e */
    KANJI,        /* 0x7c4f */
    KANJI,        /* 0x7c50 */
    KANJI,        /* 0x7c51 */
    KANJI,        /* 0x7c52 */
    KANJI,        /* 0x7c53 */
    KANJI,        /* 0x7c54 */
    KANJI,        /* 0x7c55 */
    KANJI,        /* 0x7c56 */
    KANJI,        /* 0x7c57 */
    KANJI,        /* 0x7c58 */
    KANJI,        /* 0x7c59 */
    KANJI,        /* 0x7c5a */
    KANJI,        /* 0x7c5b */
    KANJI,        /* 0x7c5c */
    KANJI,        /* 0x7c5d */
    KANJI,        /* 0x7c5e */
    KANJI,        /* 0x7c5f */
    KANJI,        /* 0x7c60 */
    KANJI,        /* 0x7c61 */
    KANJI,        /* 0x7c62 */
    KANJI,        /* 0x7c63 */
    KANJI,        /* 0x7c64 */
    KANJI,        /* 0x7c65 */
    KANJI,        /* 0x7c66 */
    KANJI,        /* 0x7c67 */
    KANJI,        /* 0x7c68 */
    KANJI,        /* 0x7c69 */
    KANJI,        /* 0x7c6a */
    KANJI,        /* 0x7c6b */
    KANJI,        /* 0x7c6c */
    KANJI,        /* 0x7c6d */
    KANJI,        /* 0x7c6e */
    KANJI,        /* 0x7c6f */
    KANJI,        /* 0x7c70 */
    KANJI,        /* 0x7c71 */
    KANJI,        /* 0x7c72 */
    KANJI,        /* 0x7c73 */
    KANJI,        /* 0x7c74 */
    KANJI,        /* 0x7c75 */
    KANJI,        /* 0x7c76 */
    KANJI,        /* 0x7c77 */
    KANJI,        /* 0x7c78 */
    KANJI,        /* 0x7c79 */
    KANJI,        /* 0x7c7a */
    KANJI,        /* 0x7c7b */
    KANJI,        /* 0x7c7c */
    KANJI,        /* 0x7c7d */
    KANJI,        /* 0x7c7e */
    KANJI,        /* 0x7c7f */
    KANJI,        /* 0x7c80 */
    KANJI,        /* 0x7c81 */
    KANJI,        /* 0x7c82 */
    KANJI,        /* 0x7c83 */
    KANJI,        /* 0x7c84 */
    KANJI,        /* 0x7c85 */
    KANJI,        /* 0x7c86 */
    KANJI,        /* 0x7c87 */
    KANJI,        /* 0x7c88 */
    KANJI,        /* 0x7c89 */
    KANJI,        /* 0x7c8a */
    KANJI,        /* 0x7c8b */
    KANJI,        /* 0x7c8c */
    KANJI,        /* 0x7c8d */
    KANJI,        /* 0x7c8e */
    KANJI,        /* 0x7c8f */
    KANJI,        /* 0x7c90 */
    KANJI,        /* 0x7c91 */
    KANJI,        /* 0x7c92 */
    KANJI,        /* 0x7c93 */
    KANJI,        /* 0x7c94 */
    KANJI,        /* 0x7c95 */
    KANJI,        /* 0x7c96 */
    KANJI,        /* 0x7c97 */
    KANJI,        /* 0x7c98 */
    KANJI,        /* 0x7c99 */
    KANJI,        /* 0x7c9a */
    KANJI,        /* 0x7c9b */
    KANJI,        /* 0x7c9c */
    KANJI,        /* 0x7c9d */
    KANJI,        /* 0x7c9e */
    KANJI,        /* 0x7c9f */
    KANJI,        /* 0x7ca0 */
    KANJI,        /* 0x7ca1 */
    KANJI,        /* 0x7ca2 */
    KANJI,        /* 0x7ca3 */
    KANJI,        /* 0x7ca4 */
    KANJI,        /* 0x7ca5 */
    KANJI,        /* 0x7ca6 */
    KANJI,        /* 0x7ca7 */
    KANJI,        /* 0x7ca8 */
    KANJI,        /* 0x7ca9 */
    KANJI,        /* 0x7caa */
    KANJI,        /* 0x7cab */
    KANJI,        /* 0x7cac */
    KANJI,        /* 0x7cad */
    KANJI,        /* 0x7cae */
    KANJI,        /* 0x7caf */
    KANJI,        /* 0x7cb0 */
    KANJI,        /* 0x7cb1 */
    KANJI,        /* 0x7cb2 */
    KANJI,        /* 0x7cb3 */
    KANJI,        /* 0x7cb4 */
    KANJI,        /* 0x7cb5 */
    KANJI,        /* 0x7cb6 */
    KANJI,        /* 0x7cb7 */
    KANJI,        /* 0x7cb8 */
    KANJI,        /* 0x7cb9 */
    KANJI,        /* 0x7cba */
    KANJI,        /* 0x7cbb */
    KANJI,        /* 0x7cbc */
    KANJI,        /* 0x7cbd */
    KANJI,        /* 0x7cbe */
    KANJI,        /* 0x7cbf */
    KANJI,        /* 0x7cc0 */
    KANJI,        /* 0x7cc1 */
    KANJI,        /* 0x7cc2 */
    KANJI,        /* 0x7cc3 */
    KANJI,        /* 0x7cc4 */
    KANJI,        /* 0x7cc5 */
    KANJI,        /* 0x7cc6 */
    KANJI,        /* 0x7cc7 */
    KANJI,        /* 0x7cc8 */
    KANJI,        /* 0x7cc9 */
    KANJI,        /* 0x7cca */
    KANJI,        /* 0x7ccb */
    KANJI,        /* 0x7ccc */
    KANJI,        /* 0x7ccd */
    KANJI,        /* 0x7cce */
    KANJI,        /* 0x7ccf */
    KANJI,        /* 0x7cd0 */
    KANJI,        /* 0x7cd1 */
    KANJI,        /* 0x7cd2 */
    KANJI,        /* 0x7cd3 */
    KANJI,        /* 0x7cd4 */
    KANJI,        /* 0x7cd5 */
    KANJI,        /* 0x7cd6 */
    KANJI,        /* 0x7cd7 */
    KANJI,        /* 0x7cd8 */
    KANJI,        /* 0x7cd9 */
    KANJI,        /* 0x7cda */
    KANJI,        /* 0x7cdb */
    KANJI,        /* 0x7cdc */
    KANJI,        /* 0x7cdd */
    KANJI,        /* 0x7cde */
    KANJI,        /* 0x7cdf */
    KANJI,        /* 0x7ce0 */
    KANJI,        /* 0x7ce1 */
    KANJI,        /* 0x7ce2 */
    KANJI,        /* 0x7ce3 */
    KANJI,        /* 0x7ce4 */
    KANJI,        /* 0x7ce5 */
    KANJI,        /* 0x7ce6 */
    KANJI,        /* 0x7ce7 */
    KANJI,        /* 0x7ce8 */
    KANJI,        /* 0x7ce9 */
    KANJI,        /* 0x7cea */
    KANJI,        /* 0x7ceb */
    KANJI,        /* 0x7cec */
    KANJI,        /* 0x7ced */
    KANJI,        /* 0x7cee */
    KANJI,        /* 0x7cef */
    KANJI,        /* 0x7cf0 */
    KANJI,        /* 0x7cf1 */
    KANJI,        /* 0x7cf2 */
    KANJI,        /* 0x7cf3 */
    KANJI,        /* 0x7cf4 */
    KANJI,        /* 0x7cf5 */
    KANJI,        /* 0x7cf6 */
    KANJI,        /* 0x7cf7 */
    KANJI,        /* 0x7cf8 */
    KANJI,        /* 0x7cf9 */
    KANJI,        /* 0x7cfa */
    KANJI,        /* 0x7cfb */
    KANJI,        /* 0x7cfc */
    KANJI,        /* 0x7cfd */
    KANJI,        /* 0x7cfe */
    KANJI,        /* 0x7cff */
    KANJI,        /* 0x7d00 */
    KANJI,        /* 0x7d01 */
    KANJI,        /* 0x7d02 */
    KANJI,        /* 0x7d03 */
    KANJI,        /* 0x7d04 */
    KANJI,        /* 0x7d05 */
    KANJI,        /* 0x7d06 */
    KANJI,        /* 0x7d07 */
    KANJI,        /* 0x7d08 */
    KANJI,        /* 0x7d09 */
    KANJI,        /* 0x7d0a */
    KANJI,        /* 0x7d0b */
    KANJI,        /* 0x7d0c */
    KANJI,        /* 0x7d0d */
    KANJI,        /* 0x7d0e */
    KANJI,        /* 0x7d0f */
    KANJI,        /* 0x7d10 */
    KANJI,        /* 0x7d11 */
    KANJI,        /* 0x7d12 */
    KANJI,        /* 0x7d13 */
    KANJI,        /* 0x7d14 */
    KANJI,        /* 0x7d15 */
    KANJI,        /* 0x7d16 */
    KANJI,        /* 0x7d17 */
    KANJI,        /* 0x7d18 */
    KANJI,        /* 0x7d19 */
    KANJI,        /* 0x7d1a */
    KANJI,        /* 0x7d1b */
    KANJI,        /* 0x7d1c */
    KANJI,        /* 0x7d1d */
    KANJI,        /* 0x7d1e */
    KANJI,        /* 0x7d1f */
    KANJI,        /* 0x7d20 */
    KANJI,        /* 0x7d21 */
    KANJI,        /* 0x7d22 */
    KANJI,        /* 0x7d23 */
    KANJI,        /* 0x7d24 */
    KANJI,        /* 0x7d25 */
    KANJI,        /* 0x7d26 */
    KANJI,        /* 0x7d27 */
    KANJI,        /* 0x7d28 */
    KANJI,        /* 0x7d29 */
    KANJI,        /* 0x7d2a */
    KANJI,        /* 0x7d2b */
    KANJI,        /* 0x7d2c */
    KANJI,        /* 0x7d2d */
    KANJI,        /* 0x7d2e */
    KANJI,        /* 0x7d2f */
    KANJI,        /* 0x7d30 */
    KANJI,        /* 0x7d31 */
    KANJI,        /* 0x7d32 */
    KANJI,        /* 0x7d33 */
    KANJI,        /* 0x7d34 */
    KANJI,        /* 0x7d35 */
    KANJI,        /* 0x7d36 */
    KANJI,        /* 0x7d37 */
    KANJI,        /* 0x7d38 */
    KANJI,        /* 0x7d39 */
    KANJI,        /* 0x7d3a */
    KANJI,        /* 0x7d3b */
    KANJI,        /* 0x7d3c */
    KANJI,        /* 0x7d3d */
    KANJI,        /* 0x7d3e */
    KANJI,        /* 0x7d3f */
    KANJI,        /* 0x7d40 */
    KANJI,        /* 0x7d41 */
    KANJI,        /* 0x7d42 */
    KANJI,        /* 0x7d43 */
    KANJI,        /* 0x7d44 */
    KANJI,        /* 0x7d45 */
    KANJI,        /* 0x7d46 */
    KANJI,        /* 0x7d47 */
    KANJI,        /* 0x7d48 */
    KANJI,        /* 0x7d49 */
    KANJI,        /* 0x7d4a */
    KANJI,        /* 0x7d4b */
    KANJI,        /* 0x7d4c */
    KANJI,        /* 0x7d4d */
    KANJI,        /* 0x7d4e */
    KANJI,        /* 0x7d4f */
    KANJI,        /* 0x7d50 */
    KANJI,        /* 0x7d51 */
    KANJI,        /* 0x7d52 */
    KANJI,        /* 0x7d53 */
    KANJI,        /* 0x7d54 */
    KANJI,        /* 0x7d55 */
    KANJI,        /* 0x7d56 */
    KANJI,        /* 0x7d57 */
    KANJI,        /* 0x7d58 */
    KANJI,        /* 0x7d59 */
    KANJI,        /* 0x7d5a */
    KANJI,        /* 0x7d5b */
    KANJI,        /* 0x7d5c */
    KANJI,        /* 0x7d5d */
    KANJI,        /* 0x7d5e */
    KANJI,        /* 0x7d5f */
    KANJI,        /* 0x7d60 */
    KANJI,        /* 0x7d61 */
    KANJI,        /* 0x7d62 */
    KANJI,        /* 0x7d63 */
    KANJI,        /* 0x7d64 */
    KANJI,        /* 0x7d65 */
    KANJI,        /* 0x7d66 */
    KANJI,        /* 0x7d67 */
    KANJI,        /* 0x7d68 */
    KANJI,        /* 0x7d69 */
    KANJI,        /* 0x7d6a */
    KANJI,        /* 0x7d6b */
    KANJI,        /* 0x7d6c */
    KANJI,        /* 0x7d6d */
    KANJI,        /* 0x7d6e */
    KANJI,        /* 0x7d6f */
    KANJI,        /* 0x7d70 */
    KANJI,        /* 0x7d71 */
    KANJI,        /* 0x7d72 */
    KANJI,        /* 0x7d73 */
    KANJI,        /* 0x7d74 */
    KANJI,        /* 0x7d75 */
    KANJI,        /* 0x7d76 */
    KANJI,        /* 0x7d77 */
    KANJI,        /* 0x7d78 */
    KANJI,        /* 0x7d79 */
    KANJI,        /* 0x7d7a */
    KANJI,        /* 0x7d7b */
    KANJI,        /* 0x7d7c */
    KANJI,        /* 0x7d7d */
    KANJI,        /* 0x7d7e */
    KANJI,        /* 0x7d7f */
    KANJI,        /* 0x7d80 */
    KANJI,        /* 0x7d81 */
    KANJI,        /* 0x7d82 */
    KANJI,        /* 0x7d83 */
    KANJI,        /* 0x7d84 */
    KANJI,        /* 0x7d85 */
    KANJI,        /* 0x7d86 */
    KANJI,        /* 0x7d87 */
    KANJI,        /* 0x7d88 */
    KANJI,        /* 0x7d89 */
    KANJI,        /* 0x7d8a */
    KANJI,        /* 0x7d8b */
    KANJI,        /* 0x7d8c */
    KANJI,        /* 0x7d8d */
    KANJI,        /* 0x7d8e */
    KANJI,        /* 0x7d8f */
    KANJI,        /* 0x7d90 */
    KANJI,        /* 0x7d91 */
    KANJI,        /* 0x7d92 */
    KANJI,        /* 0x7d93 */
    KANJI,        /* 0x7d94 */
    KANJI,        /* 0x7d95 */
    KANJI,        /* 0x7d96 */
    KANJI,        /* 0x7d97 */
    KANJI,        /* 0x7d98 */
    KANJI,        /* 0x7d99 */
    KANJI,        /* 0x7d9a */
    KANJI,        /* 0x7d9b */
    KANJI,        /* 0x7d9c */
    KANJI,        /* 0x7d9d */
    KANJI,        /* 0x7d9e */
    KANJI,        /* 0x7d9f */
    KANJI,        /* 0x7da0 */
    KANJI,        /* 0x7da1 */
    KANJI,        /* 0x7da2 */
    KANJI,        /* 0x7da3 */
    KANJI,        /* 0x7da4 */
    KANJI,        /* 0x7da5 */
    KANJI,        /* 0x7da6 */
    KANJI,        /* 0x7da7 */
    KANJI,        /* 0x7da8 */
    KANJI,        /* 0x7da9 */
    KANJI,        /* 0x7daa */
    KANJI,        /* 0x7dab */
    KANJI,        /* 0x7dac */
    KANJI,        /* 0x7dad */
    KANJI,        /* 0x7dae */
    KANJI,        /* 0x7daf */
    KANJI,        /* 0x7db0 */
    KANJI,        /* 0x7db1 */
    KANJI,        /* 0x7db2 */
    KANJI,        /* 0x7db3 */
    KANJI,        /* 0x7db4 */
    KANJI,        /* 0x7db5 */
    KANJI,        /* 0x7db6 */
    KANJI,        /* 0x7db7 */
    KANJI,        /* 0x7db8 */
    KANJI,        /* 0x7db9 */
    KANJI,        /* 0x7dba */
    KANJI,        /* 0x7dbb */
    KANJI,        /* 0x7dbc */
    KANJI,        /* 0x7dbd */
    KANJI,        /* 0x7dbe */
    KANJI,        /* 0x7dbf */
    KANJI,        /* 0x7dc0 */
    KANJI,        /* 0x7dc1 */
    KANJI,        /* 0x7dc2 */
    KANJI,        /* 0x7dc3 */
    KANJI,        /* 0x7dc4 */
    KANJI,        /* 0x7dc5 */
    KANJI,        /* 0x7dc6 */
    KANJI,        /* 0x7dc7 */
    KANJI,        /* 0x7dc8 */
    KANJI,        /* 0x7dc9 */
    KANJI,        /* 0x7dca */
    KANJI,        /* 0x7dcb */
    KANJI,        /* 0x7dcc */
    KANJI,        /* 0x7dcd */
    KANJI,        /* 0x7dce */
    KANJI,        /* 0x7dcf */
    KANJI,        /* 0x7dd0 */
    KANJI,        /* 0x7dd1 */
    KANJI,        /* 0x7dd2 */
    KANJI,        /* 0x7dd3 */
    KANJI,        /* 0x7dd4 */
    KANJI,        /* 0x7dd5 */
    KANJI,        /* 0x7dd6 */
    KANJI,        /* 0x7dd7 */
    KANJI,        /* 0x7dd8 */
    KANJI,        /* 0x7dd9 */
    KANJI,        /* 0x7dda */
    KANJI,        /* 0x7ddb */
    KANJI,        /* 0x7ddc */
    KANJI,        /* 0x7ddd */
    KANJI,        /* 0x7dde */
    KANJI,        /* 0x7ddf */
    KANJI,        /* 0x7de0 */
    KANJI,        /* 0x7de1 */
    KANJI,        /* 0x7de2 */
    KANJI,        /* 0x7de3 */
    KANJI,        /* 0x7de4 */
    KANJI,        /* 0x7de5 */
    KANJI,        /* 0x7de6 */
    KANJI,        /* 0x7de7 */
    KANJI,        /* 0x7de8 */
    KANJI,        /* 0x7de9 */
    KANJI,        /* 0x7dea */
    KANJI,        /* 0x7deb */
    KANJI,        /* 0x7dec */
    KANJI,        /* 0x7ded */
    KANJI,        /* 0x7dee */
    KANJI,        /* 0x7def */
    KANJI,        /* 0x7df0 */
    KANJI,        /* 0x7df1 */
    KANJI,        /* 0x7df2 */
    KANJI,        /* 0x7df3 */
    KANJI,        /* 0x7df4 */
    KANJI,        /* 0x7df5 */
    KANJI,        /* 0x7df6 */
    KANJI,        /* 0x7df7 */
    KANJI,        /* 0x7df8 */
    KANJI,        /* 0x7df9 */
    KANJI,        /* 0x7dfa */
    KANJI,        /* 0x7dfb */
    KANJI,        /* 0x7dfc */
    KANJI,        /* 0x7dfd */
    KANJI,        /* 0x7dfe */
    KANJI,        /* 0x7dff */
    KANJI,        /* 0x7e00 */
    KANJI,        /* 0x7e01 */
    KANJI,        /* 0x7e02 */
    KANJI,        /* 0x7e03 */
    KANJI,        /* 0x7e04 */
    KANJI,        /* 0x7e05 */
    KANJI,        /* 0x7e06 */
    KANJI,        /* 0x7e07 */
    KANJI,        /* 0x7e08 */
    KANJI,        /* 0x7e09 */
    KANJI,        /* 0x7e0a */
    KANJI,        /* 0x7e0b */
    KANJI,        /* 0x7e0c */
    KANJI,        /* 0x7e0d */
    KANJI,        /* 0x7e0e */
    KANJI,        /* 0x7e0f */
    KANJI,        /* 0x7e10 */
    KANJI,        /* 0x7e11 */
    KANJI,        /* 0x7e12 */
    KANJI,        /* 0x7e13 */
    KANJI,        /* 0x7e14 */
    KANJI,        /* 0x7e15 */
    KANJI,        /* 0x7e16 */
    KANJI,        /* 0x7e17 */
    KANJI,        /* 0x7e18 */
    KANJI,        /* 0x7e19 */
    KANJI,        /* 0x7e1a */
    KANJI,        /* 0x7e1b */
    KANJI,        /* 0x7e1c */
    KANJI,        /* 0x7e1d */
    KANJI,        /* 0x7e1e */
    KANJI,        /* 0x7e1f */
    KANJI,        /* 0x7e20 */
    KANJI,        /* 0x7e21 */
    KANJI,        /* 0x7e22 */
    KANJI,        /* 0x7e23 */
    KANJI,        /* 0x7e24 */
    KANJI,        /* 0x7e25 */
    KANJI,        /* 0x7e26 */
    KANJI,        /* 0x7e27 */
    KANJI,        /* 0x7e28 */
    KANJI,        /* 0x7e29 */
    KANJI,        /* 0x7e2a */
    KANJI,        /* 0x7e2b */
    KANJI,        /* 0x7e2c */
    KANJI,        /* 0x7e2d */
    KANJI,        /* 0x7e2e */
    KANJI,        /* 0x7e2f */
    KANJI,        /* 0x7e30 */
    KANJI,        /* 0x7e31 */
    KANJI,        /* 0x7e32 */
    KANJI,        /* 0x7e33 */
    KANJI,        /* 0x7e34 */
    KANJI,        /* 0x7e35 */
    KANJI,        /* 0x7e36 */
    KANJI,        /* 0x7e37 */
    KANJI,        /* 0x7e38 */
    KANJI,        /* 0x7e39 */
    KANJI,        /* 0x7e3a */
    KANJI,        /* 0x7e3b */
    KANJI,        /* 0x7e3c */
    KANJI,        /* 0x7e3d */
    KANJI,        /* 0x7e3e */
    KANJI,        /* 0x7e3f */
    KANJI,        /* 0x7e40 */
    KANJI,        /* 0x7e41 */
    KANJI,        /* 0x7e42 */
    KANJI,        /* 0x7e43 */
    KANJI,        /* 0x7e44 */
    KANJI,        /* 0x7e45 */
    KANJI,        /* 0x7e46 */
    KANJI,        /* 0x7e47 */
    KANJI,        /* 0x7e48 */
    KANJI,        /* 0x7e49 */
    KANJI,        /* 0x7e4a */
    KANJI,        /* 0x7e4b */
    KANJI,        /* 0x7e4c */
    KANJI,        /* 0x7e4d */
    KANJI,        /* 0x7e4e */
    KANJI,        /* 0x7e4f */
    KANJI,        /* 0x7e50 */
    KANJI,        /* 0x7e51 */
    KANJI,        /* 0x7e52 */
    KANJI,        /* 0x7e53 */
    KANJI,        /* 0x7e54 */
    KANJI,        /* 0x7e55 */
    KANJI,        /* 0x7e56 */
    KANJI,        /* 0x7e57 */
    KANJI,        /* 0x7e58 */
    KANJI,        /* 0x7e59 */
    KANJI,        /* 0x7e5a */
    KANJI,        /* 0x7e5b */
    KANJI,        /* 0x7e5c */
    KANJI,        /* 0x7e5d */
    KANJI,        /* 0x7e5e */
    KANJI,        /* 0x7e5f */
    KANJI,        /* 0x7e60 */
    KANJI,        /* 0x7e61 */
    KANJI,        /* 0x7e62 */
    KANJI,        /* 0x7e63 */
    KANJI,        /* 0x7e64 */
    KANJI,        /* 0x7e65 */
    KANJI,        /* 0x7e66 */
    KANJI,        /* 0x7e67 */
    KANJI,        /* 0x7e68 */
    KANJI,        /* 0x7e69 */
    KANJI,        /* 0x7e6a */
    KANJI,        /* 0x7e6b */
    KANJI,        /* 0x7e6c */
    KANJI,        /* 0x7e6d */
    KANJI,        /* 0x7e6e */
    KANJI,        /* 0x7e6f */
    KANJI,        /* 0x7e70 */
    KANJI,        /* 0x7e71 */
    KANJI,        /* 0x7e72 */
    KANJI,        /* 0x7e73 */
    KANJI,        /* 0x7e74 */
    KANJI,        /* 0x7e75 */
    KANJI,        /* 0x7e76 */
    KANJI,        /* 0x7e77 */
    KANJI,        /* 0x7e78 */
    KANJI,        /* 0x7e79 */
    KANJI,        /* 0x7e7a */
    KANJI,        /* 0x7e7b */
    KANJI,        /* 0x7e7c */
    KANJI,        /* 0x7e7d */
    KANJI,        /* 0x7e7e */
    KANJI,        /* 0x7e7f */
    KANJI,        /* 0x7e80 */
    KANJI,        /* 0x7e81 */
    KANJI,        /* 0x7e82 */
    KANJI,        /* 0x7e83 */
    KANJI,        /* 0x7e84 */
    KANJI,        /* 0x7e85 */
    KANJI,        /* 0x7e86 */
    KANJI,        /* 0x7e87 */
    KANJI,        /* 0x7e88 */
    KANJI,        /* 0x7e89 */
    KANJI,        /* 0x7e8a */
    KANJI,        /* 0x7e8b */
    KANJI,        /* 0x7e8c */
    KANJI,        /* 0x7e8d */
    KANJI,        /* 0x7e8e */
    KANJI,        /* 0x7e8f */
    KANJI,        /* 0x7e90 */
    KANJI,        /* 0x7e91 */
    KANJI,        /* 0x7e92 */
    KANJI,        /* 0x7e93 */
    KANJI,        /* 0x7e94 */
    KANJI,        /* 0x7e95 */
    KANJI,        /* 0x7e96 */
    KANJI,        /* 0x7e97 */
    KANJI,        /* 0x7e98 */
    KANJI,        /* 0x7e99 */
    KANJI,        /* 0x7e9a */
    KANJI,        /* 0x7e9b */
    KANJI,        /* 0x7e9c */
    KANJI,        /* 0x7e9d */
    KANJI,        /* 0x7e9e */
    KANJI,        /* 0x7e9f */
    KANJI,        /* 0x7ea0 */
    KANJI,        /* 0x7ea1 */
    KANJI,        /* 0x7ea2 */
    KANJI,        /* 0x7ea3 */
    KANJI,        /* 0x7ea4 */
    KANJI,        /* 0x7ea5 */
    KANJI,        /* 0x7ea6 */
    KANJI,        /* 0x7ea7 */
    KANJI,        /* 0x7ea8 */
    KANJI,        /* 0x7ea9 */
    KANJI,        /* 0x7eaa */
    KANJI,        /* 0x7eab */
    KANJI,        /* 0x7eac */
    KANJI,        /* 0x7ead */
    KANJI,        /* 0x7eae */
    KANJI,        /* 0x7eaf */
    KANJI,        /* 0x7eb0 */
    KANJI,        /* 0x7eb1 */
    KANJI,        /* 0x7eb2 */
    KANJI,        /* 0x7eb3 */
    KANJI,        /* 0x7eb4 */
    KANJI,        /* 0x7eb5 */
    KANJI,        /* 0x7eb6 */
    KANJI,        /* 0x7eb7 */
    KANJI,        /* 0x7eb8 */
    KANJI,        /* 0x7eb9 */
    KANJI,        /* 0x7eba */
    KANJI,        /* 0x7ebb */
    KANJI,        /* 0x7ebc */
    KANJI,        /* 0x7ebd */
    KANJI,        /* 0x7ebe */
    KANJI,        /* 0x7ebf */
    KANJI,        /* 0x7ec0 */
    KANJI,        /* 0x7ec1 */
    KANJI,        /* 0x7ec2 */
    KANJI,        /* 0x7ec3 */
    KANJI,        /* 0x7ec4 */
    KANJI,        /* 0x7ec5 */
    KANJI,        /* 0x7ec6 */
    KANJI,        /* 0x7ec7 */
    KANJI,        /* 0x7ec8 */
    KANJI,        /* 0x7ec9 */
    KANJI,        /* 0x7eca */
    KANJI,        /* 0x7ecb */
    KANJI,        /* 0x7ecc */
    KANJI,        /* 0x7ecd */
    KANJI,        /* 0x7ece */
    KANJI,        /* 0x7ecf */
    KANJI,        /* 0x7ed0 */
    KANJI,        /* 0x7ed1 */
    KANJI,        /* 0x7ed2 */
    KANJI,        /* 0x7ed3 */
    KANJI,        /* 0x7ed4 */
    KANJI,        /* 0x7ed5 */
    KANJI,        /* 0x7ed6 */
    KANJI,        /* 0x7ed7 */
    KANJI,        /* 0x7ed8 */
    KANJI,        /* 0x7ed9 */
    KANJI,        /* 0x7eda */
    KANJI,        /* 0x7edb */
    KANJI,        /* 0x7edc */
    KANJI,        /* 0x7edd */
    KANJI,        /* 0x7ede */
    KANJI,        /* 0x7edf */
    KANJI,        /* 0x7ee0 */
    KANJI,        /* 0x7ee1 */
    KANJI,        /* 0x7ee2 */
    KANJI,        /* 0x7ee3 */
    KANJI,        /* 0x7ee4 */
    KANJI,        /* 0x7ee5 */
    KANJI,        /* 0x7ee6 */
    KANJI,        /* 0x7ee7 */
    KANJI,        /* 0x7ee8 */
    KANJI,        /* 0x7ee9 */
    KANJI,        /* 0x7eea */
    KANJI,        /* 0x7eeb */
    KANJI,        /* 0x7eec */
    KANJI,        /* 0x7eed */
    KANJI,        /* 0x7eee */
    KANJI,        /* 0x7eef */
    KANJI,        /* 0x7ef0 */
    KANJI,        /* 0x7ef1 */
    KANJI,        /* 0x7ef2 */
    KANJI,        /* 0x7ef3 */
    KANJI,        /* 0x7ef4 */
    KANJI,        /* 0x7ef5 */
    KANJI,        /* 0x7ef6 */
    KANJI,        /* 0x7ef7 */
    KANJI,        /* 0x7ef8 */
    KANJI,        /* 0x7ef9 */
    KANJI,        /* 0x7efa */
    KANJI,        /* 0x7efb */
    KANJI,        /* 0x7efc */
    KANJI,        /* 0x7efd */
    KANJI,        /* 0x7efe */
    KANJI,        /* 0x7eff */
    KANJI,        /* 0x7f00 */
    KANJI,        /* 0x7f01 */
    KANJI,        /* 0x7f02 */
    KANJI,        /* 0x7f03 */
    KANJI,        /* 0x7f04 */
    KANJI,        /* 0x7f05 */
    KANJI,        /* 0x7f06 */
    KANJI,        /* 0x7f07 */
    KANJI,        /* 0x7f08 */
    KANJI,        /* 0x7f09 */
    KANJI,        /* 0x7f0a */
    KANJI,        /* 0x7f0b */
    KANJI,        /* 0x7f0c */
    KANJI,        /* 0x7f0d */
    KANJI,        /* 0x7f0e */
    KANJI,        /* 0x7f0f */
    KANJI,        /* 0x7f10 */
    KANJI,        /* 0x7f11 */
    KANJI,        /* 0x7f12 */
    KANJI,        /* 0x7f13 */
    KANJI,        /* 0x7f14 */
    KANJI,        /* 0x7f15 */
    KANJI,        /* 0x7f16 */
    KANJI,        /* 0x7f17 */
    KANJI,        /* 0x7f18 */
    KANJI,        /* 0x7f19 */
    KANJI,        /* 0x7f1a */
    KANJI,        /* 0x7f1b */
    KANJI,        /* 0x7f1c */
    KANJI,        /* 0x7f1d */
    KANJI,        /* 0x7f1e */
    KANJI,        /* 0x7f1f */
    KANJI,        /* 0x7f20 */
    KANJI,        /* 0x7f21 */
    KANJI,        /* 0x7f22 */
    KANJI,        /* 0x7f23 */
    KANJI,        /* 0x7f24 */
    KANJI,        /* 0x7f25 */
    KANJI,        /* 0x7f26 */
    KANJI,        /* 0x7f27 */
    KANJI,        /* 0x7f28 */
    KANJI,        /* 0x7f29 */
    KANJI,        /* 0x7f2a */
    KANJI,        /* 0x7f2b */
    KANJI,        /* 0x7f2c */
    KANJI,        /* 0x7f2d */
    KANJI,        /* 0x7f2e */
    KANJI,        /* 0x7f2f */
    KANJI,        /* 0x7f30 */
    KANJI,        /* 0x7f31 */
    KANJI,        /* 0x7f32 */
    KANJI,        /* 0x7f33 */
    KANJI,        /* 0x7f34 */
    KANJI,        /* 0x7f35 */
    KANJI,        /* 0x7f36 */
    KANJI,        /* 0x7f37 */
    KANJI,        /* 0x7f38 */
    KANJI,        /* 0x7f39 */
    KANJI,        /* 0x7f3a */
    KANJI,        /* 0x7f3b */
    KANJI,        /* 0x7f3c */
    KANJI,        /* 0x7f3d */
    KANJI,        /* 0x7f3e */
    KANJI,        /* 0x7f3f */
    KANJI,        /* 0x7f40 */
    KANJI,        /* 0x7f41 */
    KANJI,        /* 0x7f42 */
    KANJI,        /* 0x7f43 */
    KANJI,        /* 0x7f44 */
    KANJI,        /* 0x7f45 */
    KANJI,        /* 0x7f46 */
    KANJI,        /* 0x7f47 */
    KANJI,        /* 0x7f48 */
    KANJI,        /* 0x7f49 */
    KANJI,        /* 0x7f4a */
    KANJI,        /* 0x7f4b */
    KANJI,        /* 0x7f4c */
    KANJI,        /* 0x7f4d */
    KANJI,        /* 0x7f4e */
    KANJI,        /* 0x7f4f */
    KANJI,        /* 0x7f50 */
    KANJI,        /* 0x7f51 */
    KANJI,        /* 0x7f52 */
    KANJI,        /* 0x7f53 */
    KANJI,        /* 0x7f54 */
    KANJI,        /* 0x7f55 */
    KANJI,        /* 0x7f56 */
    KANJI,        /* 0x7f57 */
    KANJI,        /* 0x7f58 */
    KANJI,        /* 0x7f59 */
    KANJI,        /* 0x7f5a */
    KANJI,        /* 0x7f5b */
    KANJI,        /* 0x7f5c */
    KANJI,        /* 0x7f5d */
    KANJI,        /* 0x7f5e */
    KANJI,        /* 0x7f5f */
    KANJI,        /* 0x7f60 */
    KANJI,        /* 0x7f61 */
    KANJI,        /* 0x7f62 */
    KANJI,        /* 0x7f63 */
    KANJI,        /* 0x7f64 */
    KANJI,        /* 0x7f65 */
    KANJI,        /* 0x7f66 */
    KANJI,        /* 0x7f67 */
    KANJI,        /* 0x7f68 */
    KANJI,        /* 0x7f69 */
    KANJI,        /* 0x7f6a */
    KANJI,        /* 0x7f6b */
    KANJI,        /* 0x7f6c */
    KANJI,        /* 0x7f6d */
    KANJI,        /* 0x7f6e */
    KANJI,        /* 0x7f6f */
    KANJI,        /* 0x7f70 */
    KANJI,        /* 0x7f71 */
    KANJI,        /* 0x7f72 */
    KANJI,        /* 0x7f73 */
    KANJI,        /* 0x7f74 */
    KANJI,        /* 0x7f75 */
    KANJI,        /* 0x7f76 */
    KANJI,        /* 0x7f77 */
    KANJI,        /* 0x7f78 */
    KANJI,        /* 0x7f79 */
    KANJI,        /* 0x7f7a */
    KANJI,        /* 0x7f7b */
    KANJI,        /* 0x7f7c */
    KANJI,        /* 0x7f7d */
    KANJI,        /* 0x7f7e */
    KANJI,        /* 0x7f7f */
    KANJI,        /* 0x7f80 */
    KANJI,        /* 0x7f81 */
    KANJI,        /* 0x7f82 */
    KANJI,        /* 0x7f83 */
    KANJI,        /* 0x7f84 */
    KANJI,        /* 0x7f85 */
    KANJI,        /* 0x7f86 */
    KANJI,        /* 0x7f87 */
    KANJI,        /* 0x7f88 */
    KANJI,        /* 0x7f89 */
    KANJI,        /* 0x7f8a */
    KANJI,        /* 0x7f8b */
    KANJI,        /* 0x7f8c */
    KANJI,        /* 0x7f8d */
    KANJI,        /* 0x7f8e */
    KANJI,        /* 0x7f8f */
    KANJI,        /* 0x7f90 */
    KANJI,        /* 0x7f91 */
    KANJI,        /* 0x7f92 */
    KANJI,        /* 0x7f93 */
    KANJI,        /* 0x7f94 */
    KANJI,        /* 0x7f95 */
    KANJI,        /* 0x7f96 */
    KANJI,        /* 0x7f97 */
    KANJI,        /* 0x7f98 */
    KANJI,        /* 0x7f99 */
    KANJI,        /* 0x7f9a */
    KANJI,        /* 0x7f9b */
    KANJI,        /* 0x7f9c */
    KANJI,        /* 0x7f9d */
    KANJI,        /* 0x7f9e */
    KANJI,        /* 0x7f9f */
    KANJI,        /* 0x7fa0 */
    KANJI,        /* 0x7fa1 */
    KANJI,        /* 0x7fa2 */
    KANJI,        /* 0x7fa3 */
    KANJI,        /* 0x7fa4 */
    KANJI,        /* 0x7fa5 */
    KANJI,        /* 0x7fa6 */
    KANJI,        /* 0x7fa7 */
    KANJI,        /* 0x7fa8 */
    KANJI,        /* 0x7fa9 */
    KANJI,        /* 0x7faa */
    KANJI,        /* 0x7fab */
    KANJI,        /* 0x7fac */
    KANJI,        /* 0x7fad */
    KANJI,        /* 0x7fae */
    KANJI,        /* 0x7faf */
    KANJI,        /* 0x7fb0 */
    KANJI,        /* 0x7fb1 */
    KANJI,        /* 0x7fb2 */
    KANJI,        /* 0x7fb3 */
    KANJI,        /* 0x7fb4 */
    KANJI,        /* 0x7fb5 */
    KANJI,        /* 0x7fb6 */
    KANJI,        /* 0x7fb7 */
    KANJI,        /* 0x7fb8 */
    KANJI,        /* 0x7fb9 */
    KANJI,        /* 0x7fba */
    KANJI,        /* 0x7fbb */
    KANJI,        /* 0x7fbc */
    KANJI,        /* 0x7fbd */
    KANJI,        /* 0x7fbe */
    KANJI,        /* 0x7fbf */
    KANJI,        /* 0x7fc0 */
    KANJI,        /* 0x7fc1 */
    KANJI,        /* 0x7fc2 */
    KANJI,        /* 0x7fc3 */
    KANJI,        /* 0x7fc4 */
    KANJI,        /* 0x7fc5 */
    KANJI,        /* 0x7fc6 */
    KANJI,        /* 0x7fc7 */
    KANJI,        /* 0x7fc8 */
    KANJI,        /* 0x7fc9 */
    KANJI,        /* 0x7fca */
    KANJI,        /* 0x7fcb */
    KANJI,        /* 0x7fcc */
    KANJI,        /* 0x7fcd */
    KANJI,        /* 0x7fce */
    KANJI,        /* 0x7fcf */
    KANJI,        /* 0x7fd0 */
    KANJI,        /* 0x7fd1 */
    KANJI,        /* 0x7fd2 */
    KANJI,        /* 0x7fd3 */
    KANJI,        /* 0x7fd4 */
    KANJI,        /* 0x7fd5 */
    KANJI,        /* 0x7fd6 */
    KANJI,        /* 0x7fd7 */
    KANJI,        /* 0x7fd8 */
    KANJI,        /* 0x7fd9 */
    KANJI,        /* 0x7fda */
    KANJI,        /* 0x7fdb */
    KANJI,        /* 0x7fdc */
    KANJI,        /* 0x7fdd */
    KANJI,        /* 0x7fde */
    KANJI,        /* 0x7fdf */
    KANJI,        /* 0x7fe0 */
    KANJI,        /* 0x7fe1 */
    KANJI,        /* 0x7fe2 */
    KANJI,        /* 0x7fe3 */
    KANJI,        /* 0x7fe4 */
    KANJI,        /* 0x7fe5 */
    KANJI,        /* 0x7fe6 */
    KANJI,        /* 0x7fe7 */
    KANJI,        /* 0x7fe8 */
    KANJI,        /* 0x7fe9 */
    KANJI,        /* 0x7fea */
    KANJI,        /* 0x7feb */
    KANJI,        /* 0x7fec */
    KANJI,        /* 0x7fed */
    KANJI,        /* 0x7fee */
    KANJI,        /* 0x7fef */
    KANJI,        /* 0x7ff0 */
    KANJI,        /* 0x7ff1 */
    KANJI,        /* 0x7ff2 */
    KANJI,        /* 0x7ff3 */
    KANJI,        /* 0x7ff4 */
    KANJI,        /* 0x7ff5 */
    KANJI,        /* 0x7ff6 */
    KANJI,        /* 0x7ff7 */
    KANJI,        /* 0x7ff8 */
    KANJI,        /* 0x7ff9 */
    KANJI,        /* 0x7ffa */
    KANJI,        /* 0x7ffb */
    KANJI,        /* 0x7ffc */
    KANJI,        /* 0x7ffd */
    KANJI,        /* 0x7ffe */
    KANJI,        /* 0x7fff */
    KANJI,        /* 0x8000 */
    KANJI,        /* 0x8001 */
    KANJI,        /* 0x8002 */
    KANJI,        /* 0x8003 */
    KANJI,        /* 0x8004 */
    KANJI,        /* 0x8005 */
    KANJI,        /* 0x8006 */
    KANJI,        /* 0x8007 */
    KANJI,        /* 0x8008 */
    KANJI,        /* 0x8009 */
    KANJI,        /* 0x800a */
    KANJI,        /* 0x800b */
    KANJI,        /* 0x800c */
    KANJI,        /* 0x800d */
    KANJI,        /* 0x800e */
    KANJI,        /* 0x800f */
    KANJI,        /* 0x8010 */
    KANJI,        /* 0x8011 */
    KANJI,        /* 0x8012 */
    KANJI,        /* 0x8013 */
    KANJI,        /* 0x8014 */
    KANJI,        /* 0x8015 */
    KANJI,        /* 0x8016 */
    KANJI,        /* 0x8017 */
    KANJI,        /* 0x8018 */
    KANJI,        /* 0x8019 */
    KANJI,        /* 0x801a */
    KANJI,        /* 0x801b */
    KANJI,        /* 0x801c */
    KANJI,        /* 0x801d */
    KANJI,        /* 0x801e */
    KANJI,        /* 0x801f */
    KANJI,        /* 0x8020 */
    KANJI,        /* 0x8021 */
    KANJI,        /* 0x8022 */
    KANJI,        /* 0x8023 */
    KANJI,        /* 0x8024 */
    KANJI,        /* 0x8025 */
    KANJI,        /* 0x8026 */
    KANJI,        /* 0x8027 */
    KANJI,        /* 0x8028 */
    KANJI,        /* 0x8029 */
    KANJI,        /* 0x802a */
    KANJI,        /* 0x802b */
    KANJI,        /* 0x802c */
    KANJI,        /* 0x802d */
    KANJI,        /* 0x802e */
    KANJI,        /* 0x802f */
    KANJI,        /* 0x8030 */
    KANJI,        /* 0x8031 */
    KANJI,        /* 0x8032 */
    KANJI,        /* 0x8033 */
    KANJI,        /* 0x8034 */
    KANJI,        /* 0x8035 */
    KANJI,        /* 0x8036 */
    KANJI,        /* 0x8037 */
    KANJI,        /* 0x8038 */
    KANJI,        /* 0x8039 */
    KANJI,        /* 0x803a */
    KANJI,        /* 0x803b */
    KANJI,        /* 0x803c */
    KANJI,        /* 0x803d */
    KANJI,        /* 0x803e */
    KANJI,        /* 0x803f */
    KANJI,        /* 0x8040 */
    KANJI,        /* 0x8041 */
    KANJI,        /* 0x8042 */
    KANJI,        /* 0x8043 */
    KANJI,        /* 0x8044 */
    KANJI,        /* 0x8045 */
    KANJI,        /* 0x8046 */
    KANJI,        /* 0x8047 */
    KANJI,        /* 0x8048 */
    KANJI,        /* 0x8049 */
    KANJI,        /* 0x804a */
    KANJI,        /* 0x804b */
    KANJI,        /* 0x804c */
    KANJI,        /* 0x804d */
    KANJI,        /* 0x804e */
    KANJI,        /* 0x804f */
    KANJI,        /* 0x8050 */
    KANJI,        /* 0x8051 */
    KANJI,        /* 0x8052 */
    KANJI,        /* 0x8053 */
    KANJI,        /* 0x8054 */
    KANJI,        /* 0x8055 */
    KANJI,        /* 0x8056 */
    KANJI,        /* 0x8057 */
    KANJI,        /* 0x8058 */
    KANJI,        /* 0x8059 */
    KANJI,        /* 0x805a */
    KANJI,        /* 0x805b */
    KANJI,        /* 0x805c */
    KANJI,        /* 0x805d */
    KANJI,        /* 0x805e */
    KANJI,        /* 0x805f */
    KANJI,        /* 0x8060 */
    KANJI,        /* 0x8061 */
    KANJI,        /* 0x8062 */
    KANJI,        /* 0x8063 */
    KANJI,        /* 0x8064 */
    KANJI,        /* 0x8065 */
    KANJI,        /* 0x8066 */
    KANJI,        /* 0x8067 */
    KANJI,        /* 0x8068 */
    KANJI,        /* 0x8069 */
    KANJI,        /* 0x806a */
    KANJI,        /* 0x806b */
    KANJI,        /* 0x806c */
    KANJI,        /* 0x806d */
    KANJI,        /* 0x806e */
    KANJI,        /* 0x806f */
    KANJI,        /* 0x8070 */
    KANJI,        /* 0x8071 */
    KANJI,        /* 0x8072 */
    KANJI,        /* 0x8073 */
    KANJI,        /* 0x8074 */
    KANJI,        /* 0x8075 */
    KANJI,        /* 0x8076 */
    KANJI,        /* 0x8077 */
    KANJI,        /* 0x8078 */
    KANJI,        /* 0x8079 */
    KANJI,        /* 0x807a */
    KANJI,        /* 0x807b */
    KANJI,        /* 0x807c */
    KANJI,        /* 0x807d */
    KANJI,        /* 0x807e */
    KANJI,        /* 0x807f */
    KANJI,        /* 0x8080 */
    KANJI,        /* 0x8081 */
    KANJI,        /* 0x8082 */
    KANJI,        /* 0x8083 */
    KANJI,        /* 0x8084 */
    KANJI,        /* 0x8085 */
    KANJI,        /* 0x8086 */
    KANJI,        /* 0x8087 */
    KANJI,        /* 0x8088 */
    KANJI,        /* 0x8089 */
    KANJI,        /* 0x808a */
    KANJI,        /* 0x808b */
    KANJI,        /* 0x808c */
    KANJI,        /* 0x808d */
    KANJI,        /* 0x808e */
    KANJI,        /* 0x808f */
    KANJI,        /* 0x8090 */
    KANJI,        /* 0x8091 */
    KANJI,        /* 0x8092 */
    KANJI,        /* 0x8093 */
    KANJI,        /* 0x8094 */
    KANJI,        /* 0x8095 */
    KANJI,        /* 0x8096 */
    KANJI,        /* 0x8097 */
    KANJI,        /* 0x8098 */
    KANJI,        /* 0x8099 */
    KANJI,        /* 0x809a */
    KANJI,        /* 0x809b */
    KANJI,        /* 0x809c */
    KANJI,        /* 0x809d */
    KANJI,        /* 0x809e */
    KANJI,        /* 0x809f */
    KANJI,        /* 0x80a0 */
    KANJI,        /* 0x80a1 */
    KANJI,        /* 0x80a2 */
    KANJI,        /* 0x80a3 */
    KANJI,        /* 0x80a4 */
    KANJI,        /* 0x80a5 */
    KANJI,        /* 0x80a6 */
    KANJI,        /* 0x80a7 */
    KANJI,        /* 0x80a8 */
    KANJI,        /* 0x80a9 */
    KANJI,        /* 0x80aa */
    KANJI,        /* 0x80ab */
    KANJI,        /* 0x80ac */
    KANJI,        /* 0x80ad */
    KANJI,        /* 0x80ae */
    KANJI,        /* 0x80af */
    KANJI,        /* 0x80b0 */
    KANJI,        /* 0x80b1 */
    KANJI,        /* 0x80b2 */
    KANJI,        /* 0x80b3 */
    KANJI,        /* 0x80b4 */
    KANJI,        /* 0x80b5 */
    KANJI,        /* 0x80b6 */
    KANJI,        /* 0x80b7 */
    KANJI,        /* 0x80b8 */
    KANJI,        /* 0x80b9 */
    KANJI,        /* 0x80ba */
    KANJI,        /* 0x80bb */
    KANJI,        /* 0x80bc */
    KANJI,        /* 0x80bd */
    KANJI,        /* 0x80be */
    KANJI,        /* 0x80bf */
    KANJI,        /* 0x80c0 */
    KANJI,        /* 0x80c1 */
    KANJI,        /* 0x80c2 */
    KANJI,        /* 0x80c3 */
    KANJI,        /* 0x80c4 */
    KANJI,        /* 0x80c5 */
    KANJI,        /* 0x80c6 */
    KANJI,        /* 0x80c7 */
    KANJI,        /* 0x80c8 */
    KANJI,        /* 0x80c9 */
    KANJI,        /* 0x80ca */
    KANJI,        /* 0x80cb */
    KANJI,        /* 0x80cc */
    KANJI,        /* 0x80cd */
    KANJI,        /* 0x80ce */
    KANJI,        /* 0x80cf */
    KANJI,        /* 0x80d0 */
    KANJI,        /* 0x80d1 */
    KANJI,        /* 0x80d2 */
    KANJI,        /* 0x80d3 */
    KANJI,        /* 0x80d4 */
    KANJI,        /* 0x80d5 */
    KANJI,        /* 0x80d6 */
    KANJI,        /* 0x80d7 */
    KANJI,        /* 0x80d8 */
    KANJI,        /* 0x80d9 */
    KANJI,        /* 0x80da */
    KANJI,        /* 0x80db */
    KANJI,        /* 0x80dc */
    KANJI,        /* 0x80dd */
    KANJI,        /* 0x80de */
    KANJI,        /* 0x80df */
    KANJI,        /* 0x80e0 */
    KANJI,        /* 0x80e1 */
    KANJI,        /* 0x80e2 */
    KANJI,        /* 0x80e3 */
    KANJI,        /* 0x80e4 */
    KANJI,        /* 0x80e5 */
    KANJI,        /* 0x80e6 */
    KANJI,        /* 0x80e7 */
    KANJI,        /* 0x80e8 */
    KANJI,        /* 0x80e9 */
    KANJI,        /* 0x80ea */
    KANJI,        /* 0x80eb */
    KANJI,        /* 0x80ec */
    KANJI,        /* 0x80ed */
    KANJI,        /* 0x80ee */
    KANJI,        /* 0x80ef */
    KANJI,        /* 0x80f0 */
    KANJI,        /* 0x80f1 */
    KANJI,        /* 0x80f2 */
    KANJI,        /* 0x80f3 */
    KANJI,        /* 0x80f4 */
    KANJI,        /* 0x80f5 */
    KANJI,        /* 0x80f6 */
    KANJI,        /* 0x80f7 */
    KANJI,        /* 0x80f8 */
    KANJI,        /* 0x80f9 */
    KANJI,        /* 0x80fa */
    KANJI,        /* 0x80fb */
    KANJI,        /* 0x80fc */
    KANJI,        /* 0x80fd */
    KANJI,        /* 0x80fe */
    KANJI,        /* 0x80ff */
    KANJI,        /* 0x8100 */
    KANJI,        /* 0x8101 */
    KANJI,        /* 0x8102 */
    KANJI,        /* 0x8103 */
    KANJI,        /* 0x8104 */
    KANJI,        /* 0x8105 */
    KANJI,        /* 0x8106 */
    KANJI,        /* 0x8107 */
    KANJI,        /* 0x8108 */
    KANJI,        /* 0x8109 */
    KANJI,        /* 0x810a */
    KANJI,        /* 0x810b */
    KANJI,        /* 0x810c */
    KANJI,        /* 0x810d */
    KANJI,        /* 0x810e */
    KANJI,        /* 0x810f */
    KANJI,        /* 0x8110 */
    KANJI,        /* 0x8111 */
    KANJI,        /* 0x8112 */
    KANJI,        /* 0x8113 */
    KANJI,        /* 0x8114 */
    KANJI,        /* 0x8115 */
    KANJI,        /* 0x8116 */
    KANJI,        /* 0x8117 */
    KANJI,        /* 0x8118 */
    KANJI,        /* 0x8119 */
    KANJI,        /* 0x811a */
    KANJI,        /* 0x811b */
    KANJI,        /* 0x811c */
    KANJI,        /* 0x811d */
    KANJI,        /* 0x811e */
    KANJI,        /* 0x811f */
    KANJI,        /* 0x8120 */
    KANJI,        /* 0x8121 */
    KANJI,        /* 0x8122 */
    KANJI,        /* 0x8123 */
    KANJI,        /* 0x8124 */
    KANJI,        /* 0x8125 */
    KANJI,        /* 0x8126 */
    KANJI,        /* 0x8127 */
    KANJI,        /* 0x8128 */
    KANJI,        /* 0x8129 */
    KANJI,        /* 0x812a */
    KANJI,        /* 0x812b */
    KANJI,        /* 0x812c */
    KANJI,        /* 0x812d */
    KANJI,        /* 0x812e */
    KANJI,        /* 0x812f */
    KANJI,        /* 0x8130 */
    KANJI,        /* 0x8131 */
    KANJI,        /* 0x8132 */
    KANJI,        /* 0x8133 */
    KANJI,        /* 0x8134 */
    KANJI,        /* 0x8135 */
    KANJI,        /* 0x8136 */
    KANJI,        /* 0x8137 */
    KANJI,        /* 0x8138 */
    KANJI,        /* 0x8139 */
    KANJI,        /* 0x813a */
    KANJI,        /* 0x813b */
    KANJI,        /* 0x813c */
    KANJI,        /* 0x813d */
    KANJI,        /* 0x813e */
    KANJI,        /* 0x813f */
    KANJI,        /* 0x8140 */
    KANJI,        /* 0x8141 */
    KANJI,        /* 0x8142 */
    KANJI,        /* 0x8143 */
    KANJI,        /* 0x8144 */
    KANJI,        /* 0x8145 */
    KANJI,        /* 0x8146 */
    KANJI,        /* 0x8147 */
    KANJI,        /* 0x8148 */
    KANJI,        /* 0x8149 */
    KANJI,        /* 0x814a */
    KANJI,        /* 0x814b */
    KANJI,        /* 0x814c */
    KANJI,        /* 0x814d */
    KANJI,        /* 0x814e */
    KANJI,        /* 0x814f */
    KANJI,        /* 0x8150 */
    KANJI,        /* 0x8151 */
    KANJI,        /* 0x8152 */
    KANJI,        /* 0x8153 */
    KANJI,        /* 0x8154 */
    KANJI,        /* 0x8155 */
    KANJI,        /* 0x8156 */
    KANJI,        /* 0x8157 */
    KANJI,        /* 0x8158 */
    KANJI,        /* 0x8159 */
    KANJI,        /* 0x815a */
    KANJI,        /* 0x815b */
    KANJI,        /* 0x815c */
    KANJI,        /* 0x815d */
    KANJI,        /* 0x815e */
    KANJI,        /* 0x815f */
    KANJI,        /* 0x8160 */
    KANJI,        /* 0x8161 */
    KANJI,        /* 0x8162 */
    KANJI,        /* 0x8163 */
    KANJI,        /* 0x8164 */
    KANJI,        /* 0x8165 */
    KANJI,        /* 0x8166 */
    KANJI,        /* 0x8167 */
    KANJI,        /* 0x8168 */
    KANJI,        /* 0x8169 */
    KANJI,        /* 0x816a */
    KANJI,        /* 0x816b */
    KANJI,        /* 0x816c */
    KANJI,        /* 0x816d */
    KANJI,        /* 0x816e */
    KANJI,        /* 0x816f */
    KANJI,        /* 0x8170 */
    KANJI,        /* 0x8171 */
    KANJI,        /* 0x8172 */
    KANJI,        /* 0x8173 */
    KANJI,        /* 0x8174 */
    KANJI,        /* 0x8175 */
    KANJI,        /* 0x8176 */
    KANJI,        /* 0x8177 */
    KANJI,        /* 0x8178 */
    KANJI,        /* 0x8179 */
    KANJI,        /* 0x817a */
    KANJI,        /* 0x817b */
    KANJI,        /* 0x817c */
    KANJI,        /* 0x817d */
    KANJI,        /* 0x817e */
    KANJI,        /* 0x817f */
    KANJI,        /* 0x8180 */
    KANJI,        /* 0x8181 */
    KANJI,        /* 0x8182 */
    KANJI,        /* 0x8183 */
    KANJI,        /* 0x8184 */
    KANJI,        /* 0x8185 */
    KANJI,        /* 0x8186 */
    KANJI,        /* 0x8187 */
    KANJI,        /* 0x8188 */
    KANJI,        /* 0x8189 */
    KANJI,        /* 0x818a */
    KANJI,        /* 0x818b */
    KANJI,        /* 0x818c */
    KANJI,        /* 0x818d */
    KANJI,        /* 0x818e */
    KANJI,        /* 0x818f */
    KANJI,        /* 0x8190 */
    KANJI,        /* 0x8191 */
    KANJI,        /* 0x8192 */
    KANJI,        /* 0x8193 */
    KANJI,        /* 0x8194 */
    KANJI,        /* 0x8195 */
    KANJI,        /* 0x8196 */
    KANJI,        /* 0x8197 */
    KANJI,        /* 0x8198 */
    KANJI,        /* 0x8199 */
    KANJI,        /* 0x819a */
    KANJI,        /* 0x819b */
    KANJI,        /* 0x819c */
    KANJI,        /* 0x819d */
    KANJI,        /* 0x819e */
    KANJI,        /* 0x819f */
    KANJI,        /* 0x81a0 */
    KANJI,        /* 0x81a1 */
    KANJI,        /* 0x81a2 */
    KANJI,        /* 0x81a3 */
    KANJI,        /* 0x81a4 */
    KANJI,        /* 0x81a5 */
    KANJI,        /* 0x81a6 */
    KANJI,        /* 0x81a7 */
    KANJI,        /* 0x81a8 */
    KANJI,        /* 0x81a9 */
    KANJI,        /* 0x81aa */
    KANJI,        /* 0x81ab */
    KANJI,        /* 0x81ac */
    KANJI,        /* 0x81ad */
    KANJI,        /* 0x81ae */
    KANJI,        /* 0x81af */
    KANJI,        /* 0x81b0 */
    KANJI,        /* 0x81b1 */
    KANJI,        /* 0x81b2 */
    KANJI,        /* 0x81b3 */
    KANJI,        /* 0x81b4 */
    KANJI,        /* 0x81b5 */
    KANJI,        /* 0x81b6 */
    KANJI,        /* 0x81b7 */
    KANJI,        /* 0x81b8 */
    KANJI,        /* 0x81b9 */
    KANJI,        /* 0x81ba */
    KANJI,        /* 0x81bb */
    KANJI,        /* 0x81bc */
    KANJI,        /* 0x81bd */
    KANJI,        /* 0x81be */
    KANJI,        /* 0x81bf */
    KANJI,        /* 0x81c0 */
    KANJI,        /* 0x81c1 */
    KANJI,        /* 0x81c2 */
    KANJI,        /* 0x81c3 */
    KANJI,        /* 0x81c4 */
    KANJI,        /* 0x81c5 */
    KANJI,        /* 0x81c6 */
    KANJI,        /* 0x81c7 */
    KANJI,        /* 0x81c8 */
    KANJI,        /* 0x81c9 */
    KANJI,        /* 0x81ca */
    KANJI,        /* 0x81cb */
    KANJI,        /* 0x81cc */
    KANJI,        /* 0x81cd */
    KANJI,        /* 0x81ce */
    KANJI,        /* 0x81cf */
    KANJI,        /* 0x81d0 */
    KANJI,        /* 0x81d1 */
    KANJI,        /* 0x81d2 */
    KANJI,        /* 0x81d3 */
    KANJI,        /* 0x81d4 */
    KANJI,        /* 0x81d5 */
    KANJI,        /* 0x81d6 */
    KANJI,        /* 0x81d7 */
    KANJI,        /* 0x81d8 */
    KANJI,        /* 0x81d9 */
    KANJI,        /* 0x81da */
    KANJI,        /* 0x81db */
    KANJI,        /* 0x81dc */
    KANJI,        /* 0x81dd */
    KANJI,        /* 0x81de */
    KANJI,        /* 0x81df */
    KANJI,        /* 0x81e0 */
    KANJI,        /* 0x81e1 */
    KANJI,        /* 0x81e2 */
    KANJI,        /* 0x81e3 */
    KANJI,        /* 0x81e4 */
    KANJI,        /* 0x81e5 */
    KANJI,        /* 0x81e6 */
    KANJI,        /* 0x81e7 */
    KANJI,        /* 0x81e8 */
    KANJI,        /* 0x81e9 */
    KANJI,        /* 0x81ea */
    KANJI,        /* 0x81eb */
    KANJI,        /* 0x81ec */
    KANJI,        /* 0x81ed */
    KANJI,        /* 0x81ee */
    KANJI,        /* 0x81ef */
    KANJI,        /* 0x81f0 */
    KANJI,        /* 0x81f1 */
    KANJI,        /* 0x81f2 */
    KANJI,        /* 0x81f3 */
    KANJI,        /* 0x81f4 */
    KANJI,        /* 0x81f5 */
    KANJI,        /* 0x81f6 */
    KANJI,        /* 0x81f7 */
    KANJI,        /* 0x81f8 */
    KANJI,        /* 0x81f9 */
    KANJI,        /* 0x81fa */
    KANJI,        /* 0x81fb */
    KANJI,        /* 0x81fc */
    KANJI,        /* 0x81fd */
    KANJI,        /* 0x81fe */
    KANJI,        /* 0x81ff */
    KANJI,        /* 0x8200 */
    KANJI,        /* 0x8201 */
    KANJI,        /* 0x8202 */
    KANJI,        /* 0x8203 */
    KANJI,        /* 0x8204 */
    KANJI,        /* 0x8205 */
    KANJI,        /* 0x8206 */
    KANJI,        /* 0x8207 */
    KANJI,        /* 0x8208 */
    KANJI,        /* 0x8209 */
    KANJI,        /* 0x820a */
    KANJI,        /* 0x820b */
    KANJI,        /* 0x820c */
    KANJI,        /* 0x820d */
    KANJI,        /* 0x820e */
    KANJI,        /* 0x820f */
    KANJI,        /* 0x8210 */
    KANJI,        /* 0x8211 */
    KANJI,        /* 0x8212 */
    KANJI,        /* 0x8213 */
    KANJI,        /* 0x8214 */
    KANJI,        /* 0x8215 */
    KANJI,        /* 0x8216 */
    KANJI,        /* 0x8217 */
    KANJI,        /* 0x8218 */
    KANJI,        /* 0x8219 */
    KANJI,        /* 0x821a */
    KANJI,        /* 0x821b */
    KANJI,        /* 0x821c */
    KANJI,        /* 0x821d */
    KANJI,        /* 0x821e */
    KANJI,        /* 0x821f */
    KANJI,        /* 0x8220 */
    KANJI,        /* 0x8221 */
    KANJI,        /* 0x8222 */
    KANJI,        /* 0x8223 */
    KANJI,        /* 0x8224 */
    KANJI,        /* 0x8225 */
    KANJI,        /* 0x8226 */
    KANJI,        /* 0x8227 */
    KANJI,        /* 0x8228 */
    KANJI,        /* 0x8229 */
    KANJI,        /* 0x822a */
    KANJI,        /* 0x822b */
    KANJI,        /* 0x822c */
    KANJI,        /* 0x822d */
    KANJI,        /* 0x822e */
    KANJI,        /* 0x822f */
    KANJI,        /* 0x8230 */
    KANJI,        /* 0x8231 */
    KANJI,        /* 0x8232 */
    KANJI,        /* 0x8233 */
    KANJI,        /* 0x8234 */
    KANJI,        /* 0x8235 */
    KANJI,        /* 0x8236 */
    KANJI,        /* 0x8237 */
    KANJI,        /* 0x8238 */
    KANJI,        /* 0x8239 */
    KANJI,        /* 0x823a */
    KANJI,        /* 0x823b */
    KANJI,        /* 0x823c */
    KANJI,        /* 0x823d */
    KANJI,        /* 0x823e */
    KANJI,        /* 0x823f */
    KANJI,        /* 0x8240 */
    KANJI,        /* 0x8241 */
    KANJI,        /* 0x8242 */
    KANJI,        /* 0x8243 */
    KANJI,        /* 0x8244 */
    KANJI,        /* 0x8245 */
    KANJI,        /* 0x8246 */
    KANJI,        /* 0x8247 */
    KANJI,        /* 0x8248 */
    KANJI,        /* 0x8249 */
    KANJI,        /* 0x824a */
    KANJI,        /* 0x824b */
    KANJI,        /* 0x824c */
    KANJI,        /* 0x824d */
    KANJI,        /* 0x824e */
    KANJI,        /* 0x824f */
    KANJI,        /* 0x8250 */
    KANJI,        /* 0x8251 */
    KANJI,        /* 0x8252 */
    KANJI,        /* 0x8253 */
    KANJI,        /* 0x8254 */
    KANJI,        /* 0x8255 */
    KANJI,        /* 0x8256 */
    KANJI,        /* 0x8257 */
    KANJI,        /* 0x8258 */
    KANJI,        /* 0x8259 */
    KANJI,        /* 0x825a */
    KANJI,        /* 0x825b */
    KANJI,        /* 0x825c */
    KANJI,        /* 0x825d */
    KANJI,        /* 0x825e */
    KANJI,        /* 0x825f */
    KANJI,        /* 0x8260 */
    KANJI,        /* 0x8261 */
    KANJI,        /* 0x8262 */
    KANJI,        /* 0x8263 */
    KANJI,        /* 0x8264 */
    KANJI,        /* 0x8265 */
    KANJI,        /* 0x8266 */
    KANJI,        /* 0x8267 */
    KANJI,        /* 0x8268 */
    KANJI,        /* 0x8269 */
    KANJI,        /* 0x826a */
    KANJI,        /* 0x826b */
    KANJI,        /* 0x826c */
    KANJI,        /* 0x826d */
    KANJI,        /* 0x826e */
    KANJI,        /* 0x826f */
    KANJI,        /* 0x8270 */
    KANJI,        /* 0x8271 */
    KANJI,        /* 0x8272 */
    KANJI,        /* 0x8273 */
    KANJI,        /* 0x8274 */
    KANJI,        /* 0x8275 */
    KANJI,        /* 0x8276 */
    KANJI,        /* 0x8277 */
    KANJI,        /* 0x8278 */
    KANJI,        /* 0x8279 */
    KANJI,        /* 0x827a */
    KANJI,        /* 0x827b */
    KANJI,        /* 0x827c */
    KANJI,        /* 0x827d */
    KANJI,        /* 0x827e */
    KANJI,        /* 0x827f */
    KANJI,        /* 0x8280 */
    KANJI,        /* 0x8281 */
    KANJI,        /* 0x8282 */
    KANJI,        /* 0x8283 */
    KANJI,        /* 0x8284 */
    KANJI,        /* 0x8285 */
    KANJI,        /* 0x8286 */
    KANJI,        /* 0x8287 */
    KANJI,        /* 0x8288 */
    KANJI,        /* 0x8289 */
    KANJI,        /* 0x828a */
    KANJI,        /* 0x828b */
    KANJI,        /* 0x828c */
    KANJI,        /* 0x828d */
    KANJI,        /* 0x828e */
    KANJI,        /* 0x828f */
    KANJI,        /* 0x8290 */
    KANJI,        /* 0x8291 */
    KANJI,        /* 0x8292 */
    KANJI,        /* 0x8293 */
    KANJI,        /* 0x8294 */
    KANJI,        /* 0x8295 */
    KANJI,        /* 0x8296 */
    KANJI,        /* 0x8297 */
    KANJI,        /* 0x8298 */
    KANJI,        /* 0x8299 */
    KANJI,        /* 0x829a */
    KANJI,        /* 0x829b */
    KANJI,        /* 0x829c */
    KANJI,        /* 0x829d */
    KANJI,        /* 0x829e */
    KANJI,        /* 0x829f */
    KANJI,        /* 0x82a0 */
    KANJI,        /* 0x82a1 */
    KANJI,        /* 0x82a2 */
    KANJI,        /* 0x82a3 */
    KANJI,        /* 0x82a4 */
    KANJI,        /* 0x82a5 */
    KANJI,        /* 0x82a6 */
    KANJI,        /* 0x82a7 */
    KANJI,        /* 0x82a8 */
    KANJI,        /* 0x82a9 */
    KANJI,        /* 0x82aa */
    KANJI,        /* 0x82ab */
    KANJI,        /* 0x82ac */
    KANJI,        /* 0x82ad */
    KANJI,        /* 0x82ae */
    KANJI,        /* 0x82af */
    KANJI,        /* 0x82b0 */
    KANJI,        /* 0x82b1 */
    KANJI,        /* 0x82b2 */
    KANJI,        /* 0x82b3 */
    KANJI,        /* 0x82b4 */
    KANJI,        /* 0x82b5 */
    KANJI,        /* 0x82b6 */
    KANJI,        /* 0x82b7 */
    KANJI,        /* 0x82b8 */
    KANJI,        /* 0x82b9 */
    KANJI,        /* 0x82ba */
    KANJI,        /* 0x82bb */
    KANJI,        /* 0x82bc */
    KANJI,        /* 0x82bd */
    KANJI,        /* 0x82be */
    KANJI,        /* 0x82bf */
    KANJI,        /* 0x82c0 */
    KANJI,        /* 0x82c1 */
    KANJI,        /* 0x82c2 */
    KANJI,        /* 0x82c3 */
    KANJI,        /* 0x82c4 */
    KANJI,        /* 0x82c5 */
    KANJI,        /* 0x82c6 */
    KANJI,        /* 0x82c7 */
    KANJI,        /* 0x82c8 */
    KANJI,        /* 0x82c9 */
    KANJI,        /* 0x82ca */
    KANJI,        /* 0x82cb */
    KANJI,        /* 0x82cc */
    KANJI,        /* 0x82cd */
    KANJI,        /* 0x82ce */
    KANJI,        /* 0x82cf */
    KANJI,        /* 0x82d0 */
    KANJI,        /* 0x82d1 */
    KANJI,        /* 0x82d2 */
    KANJI,        /* 0x82d3 */
    KANJI,        /* 0x82d4 */
    KANJI,        /* 0x82d5 */
    KANJI,        /* 0x82d6 */
    KANJI,        /* 0x82d7 */
    KANJI,        /* 0x82d8 */
    KANJI,        /* 0x82d9 */
    KANJI,        /* 0x82da */
    KANJI,        /* 0x82db */
    KANJI,        /* 0x82dc */
    KANJI,        /* 0x82dd */
    KANJI,        /* 0x82de */
    KANJI,        /* 0x82df */
    KANJI,        /* 0x82e0 */
    KANJI,        /* 0x82e1 */
    KANJI,        /* 0x82e2 */
    KANJI,        /* 0x82e3 */
    KANJI,        /* 0x82e4 */
    KANJI,        /* 0x82e5 */
    KANJI,        /* 0x82e6 */
    KANJI,        /* 0x82e7 */
    KANJI,        /* 0x82e8 */
    KANJI,        /* 0x82e9 */
    KANJI,        /* 0x82ea */
    KANJI,        /* 0x82eb */
    KANJI,        /* 0x82ec */
    KANJI,        /* 0x82ed */
    KANJI,        /* 0x82ee */
    KANJI,        /* 0x82ef */
    KANJI,        /* 0x82f0 */
    KANJI,        /* 0x82f1 */
    KANJI,        /* 0x82f2 */
    KANJI,        /* 0x82f3 */
    KANJI,        /* 0x82f4 */
    KANJI,        /* 0x82f5 */
    KANJI,        /* 0x82f6 */
    KANJI,        /* 0x82f7 */
    KANJI,        /* 0x82f8 */
    KANJI,        /* 0x82f9 */
    KANJI,        /* 0x82fa */
    KANJI,        /* 0x82fb */
    KANJI,        /* 0x82fc */
    KANJI,        /* 0x82fd */
    KANJI,        /* 0x82fe */
    KANJI,        /* 0x82ff */
    KANJI,        /* 0x8300 */
    KANJI,        /* 0x8301 */
    KANJI,        /* 0x8302 */
    KANJI,        /* 0x8303 */
    KANJI,        /* 0x8304 */
    KANJI,        /* 0x8305 */
    KANJI,        /* 0x8306 */
    KANJI,        /* 0x8307 */
    KANJI,        /* 0x8308 */
    KANJI,        /* 0x8309 */
    KANJI,        /* 0x830a */
    KANJI,        /* 0x830b */
    KANJI,        /* 0x830c */
    KANJI,        /* 0x830d */
    KANJI,        /* 0x830e */
    KANJI,        /* 0x830f */
    KANJI,        /* 0x8310 */
    KANJI,        /* 0x8311 */
    KANJI,        /* 0x8312 */
    KANJI,        /* 0x8313 */
    KANJI,        /* 0x8314 */
    KANJI,        /* 0x8315 */
    KANJI,        /* 0x8316 */
    KANJI,        /* 0x8317 */
    KANJI,        /* 0x8318 */
    KANJI,        /* 0x8319 */
    KANJI,        /* 0x831a */
    KANJI,        /* 0x831b */
    KANJI,        /* 0x831c */
    KANJI,        /* 0x831d */
    KANJI,        /* 0x831e */
    KANJI,        /* 0x831f */
    KANJI,        /* 0x8320 */
    KANJI,        /* 0x8321 */
    KANJI,        /* 0x8322 */
    KANJI,        /* 0x8323 */
    KANJI,        /* 0x8324 */
    KANJI,        /* 0x8325 */
    KANJI,        /* 0x8326 */
    KANJI,        /* 0x8327 */
    KANJI,        /* 0x8328 */
    KANJI,        /* 0x8329 */
    KANJI,        /* 0x832a */
    KANJI,        /* 0x832b */
    KANJI,        /* 0x832c */
    KANJI,        /* 0x832d */
    KANJI,        /* 0x832e */
    KANJI,        /* 0x832f */
    KANJI,        /* 0x8330 */
    KANJI,        /* 0x8331 */
    KANJI,        /* 0x8332 */
    KANJI,        /* 0x8333 */
    KANJI,        /* 0x8334 */
    KANJI,        /* 0x8335 */
    KANJI,        /* 0x8336 */
    KANJI,        /* 0x8337 */
    KANJI,        /* 0x8338 */
    KANJI,        /* 0x8339 */
    KANJI,        /* 0x833a */
    KANJI,        /* 0x833b */
    KANJI,        /* 0x833c */
    KANJI,        /* 0x833d */
    KANJI,        /* 0x833e */
    KANJI,        /* 0x833f */
    KANJI,        /* 0x8340 */
    KANJI,        /* 0x8341 */
    KANJI,        /* 0x8342 */
    KANJI,        /* 0x8343 */
    KANJI,        /* 0x8344 */
    KANJI,        /* 0x8345 */
    KANJI,        /* 0x8346 */
    KANJI,        /* 0x8347 */
    KANJI,        /* 0x8348 */
    KANJI,        /* 0x8349 */
    KANJI,        /* 0x834a */
    KANJI,        /* 0x834b */
    KANJI,        /* 0x834c */
    KANJI,        /* 0x834d */
    KANJI,        /* 0x834e */
    KANJI,        /* 0x834f */
    KANJI,        /* 0x8350 */
    KANJI,        /* 0x8351 */
    KANJI,        /* 0x8352 */
    KANJI,        /* 0x8353 */
    KANJI,        /* 0x8354 */
    KANJI,        /* 0x8355 */
    KANJI,        /* 0x8356 */
    KANJI,        /* 0x8357 */
    KANJI,        /* 0x8358 */
    KANJI,        /* 0x8359 */
    KANJI,        /* 0x835a */
    KANJI,        /* 0x835b */
    KANJI,        /* 0x835c */
    KANJI,        /* 0x835d */
    KANJI,        /* 0x835e */
    KANJI,        /* 0x835f */
    KANJI,        /* 0x8360 */
    KANJI,        /* 0x8361 */
    KANJI,        /* 0x8362 */
    KANJI,        /* 0x8363 */
    KANJI,        /* 0x8364 */
    KANJI,        /* 0x8365 */
    KANJI,        /* 0x8366 */
    KANJI,        /* 0x8367 */
    KANJI,        /* 0x8368 */
    KANJI,        /* 0x8369 */
    KANJI,        /* 0x836a */
    KANJI,        /* 0x836b */
    KANJI,        /* 0x836c */
    KANJI,        /* 0x836d */
    KANJI,        /* 0x836e */
    KANJI,        /* 0x836f */
    KANJI,        /* 0x8370 */
    KANJI,        /* 0x8371 */
    KANJI,        /* 0x8372 */
    KANJI,        /* 0x8373 */
    KANJI,        /* 0x8374 */
    KANJI,        /* 0x8375 */
    KANJI,        /* 0x8376 */
    KANJI,        /* 0x8377 */
    KANJI,        /* 0x8378 */
    KANJI,        /* 0x8379 */
    KANJI,        /* 0x837a */
    KANJI,        /* 0x837b */
    KANJI,        /* 0x837c */
    KANJI,        /* 0x837d */
    KANJI,        /* 0x837e */
    KANJI,        /* 0x837f */
    KANJI,        /* 0x8380 */
    KANJI,        /* 0x8381 */
    KANJI,        /* 0x8382 */
    KANJI,        /* 0x8383 */
    KANJI,        /* 0x8384 */
    KANJI,        /* 0x8385 */
    KANJI,        /* 0x8386 */
    KANJI,        /* 0x8387 */
    KANJI,        /* 0x8388 */
    KANJI,        /* 0x8389 */
    KANJI,        /* 0x838a */
    KANJI,        /* 0x838b */
    KANJI,        /* 0x838c */
    KANJI,        /* 0x838d */
    KANJI,        /* 0x838e */
    KANJI,        /* 0x838f */
    KANJI,        /* 0x8390 */
    KANJI,        /* 0x8391 */
    KANJI,        /* 0x8392 */
    KANJI,        /* 0x8393 */
    KANJI,        /* 0x8394 */
    KANJI,        /* 0x8395 */
    KANJI,        /* 0x8396 */
    KANJI,        /* 0x8397 */
    KANJI,        /* 0x8398 */
    KANJI,        /* 0x8399 */
    KANJI,        /* 0x839a */
    KANJI,        /* 0x839b */
    KANJI,        /* 0x839c */
    KANJI,        /* 0x839d */
    KANJI,        /* 0x839e */
    KANJI,        /* 0x839f */
    KANJI,        /* 0x83a0 */
    KANJI,        /* 0x83a1 */
    KANJI,        /* 0x83a2 */
    KANJI,        /* 0x83a3 */
    KANJI,        /* 0x83a4 */
    KANJI,        /* 0x83a5 */
    KANJI,        /* 0x83a6 */
    KANJI,        /* 0x83a7 */
    KANJI,        /* 0x83a8 */
    KANJI,        /* 0x83a9 */
    KANJI,        /* 0x83aa */
    KANJI,        /* 0x83ab */
    KANJI,        /* 0x83ac */
    KANJI,        /* 0x83ad */
    KANJI,        /* 0x83ae */
    KANJI,        /* 0x83af */
    KANJI,        /* 0x83b0 */
    KANJI,        /* 0x83b1 */
    KANJI,        /* 0x83b2 */
    KANJI,        /* 0x83b3 */
    KANJI,        /* 0x83b4 */
    KANJI,        /* 0x83b5 */
    KANJI,        /* 0x83b6 */
    KANJI,        /* 0x83b7 */
    KANJI,        /* 0x83b8 */
    KANJI,        /* 0x83b9 */
    KANJI,        /* 0x83ba */
    KANJI,        /* 0x83bb */
    KANJI,        /* 0x83bc */
    KANJI,        /* 0x83bd */
    KANJI,        /* 0x83be */
    KANJI,        /* 0x83bf */
    KANJI,        /* 0x83c0 */
    KANJI,        /* 0x83c1 */
    KANJI,        /* 0x83c2 */
    KANJI,        /* 0x83c3 */
    KANJI,        /* 0x83c4 */
    KANJI,        /* 0x83c5 */
    KANJI,        /* 0x83c6 */
    KANJI,        /* 0x83c7 */
    KANJI,        /* 0x83c8 */
    KANJI,        /* 0x83c9 */
    KANJI,        /* 0x83ca */
    KANJI,        /* 0x83cb */
    KANJI,        /* 0x83cc */
    KANJI,        /* 0x83cd */
    KANJI,        /* 0x83ce */
    KANJI,        /* 0x83cf */
    KANJI,        /* 0x83d0 */
    KANJI,        /* 0x83d1 */
    KANJI,        /* 0x83d2 */
    KANJI,        /* 0x83d3 */
    KANJI,        /* 0x83d4 */
    KANJI,        /* 0x83d5 */
    KANJI,        /* 0x83d6 */
    KANJI,        /* 0x83d7 */
    KANJI,        /* 0x83d8 */
    KANJI,        /* 0x83d9 */
    KANJI,        /* 0x83da */
    KANJI,        /* 0x83db */
    KANJI,        /* 0x83dc */
    KANJI,        /* 0x83dd */
    KANJI,        /* 0x83de */
    KANJI,        /* 0x83df */
    KANJI,        /* 0x83e0 */
    KANJI,        /* 0x83e1 */
    KANJI,        /* 0x83e2 */
    KANJI,        /* 0x83e3 */
    KANJI,        /* 0x83e4 */
    KANJI,        /* 0x83e5 */
    KANJI,        /* 0x83e6 */
    KANJI,        /* 0x83e7 */
    KANJI,        /* 0x83e8 */
    KANJI,        /* 0x83e9 */
    KANJI,        /* 0x83ea */
    KANJI,        /* 0x83eb */
    KANJI,        /* 0x83ec */
    KANJI,        /* 0x83ed */
    KANJI,        /* 0x83ee */
    KANJI,        /* 0x83ef */
    KANJI,        /* 0x83f0 */
    KANJI,        /* 0x83f1 */
    KANJI,        /* 0x83f2 */
    KANJI,        /* 0x83f3 */
    KANJI,        /* 0x83f4 */
    KANJI,        /* 0x83f5 */
    KANJI,        /* 0x83f6 */
    KANJI,        /* 0x83f7 */
    KANJI,        /* 0x83f8 */
    KANJI,        /* 0x83f9 */
    KANJI,        /* 0x83fa */
    KANJI,        /* 0x83fb */
    KANJI,        /* 0x83fc */
    KANJI,        /* 0x83fd */
    KANJI,        /* 0x83fe */
    KANJI,        /* 0x83ff */
    KANJI,        /* 0x8400 */
    KANJI,        /* 0x8401 */
    KANJI,        /* 0x8402 */
    KANJI,        /* 0x8403 */
    KANJI,        /* 0x8404 */
    KANJI,        /* 0x8405 */
    KANJI,        /* 0x8406 */
    KANJI,        /* 0x8407 */
    KANJI,        /* 0x8408 */
    KANJI,        /* 0x8409 */
    KANJI,        /* 0x840a */
    KANJI,        /* 0x840b */
    KANJI,        /* 0x840c */
    KANJI,        /* 0x840d */
    KANJI,        /* 0x840e */
    KANJI,        /* 0x840f */
    KANJI,        /* 0x8410 */
    KANJI,        /* 0x8411 */
    KANJI,        /* 0x8412 */
    KANJI,        /* 0x8413 */
    KANJI,        /* 0x8414 */
    KANJI,        /* 0x8415 */
    KANJI,        /* 0x8416 */
    KANJI,        /* 0x8417 */
    KANJI,        /* 0x8418 */
    KANJI,        /* 0x8419 */
    KANJI,        /* 0x841a */
    KANJI,        /* 0x841b */
    KANJI,        /* 0x841c */
    KANJI,        /* 0x841d */
    KANJI,        /* 0x841e */
    KANJI,        /* 0x841f */
    KANJI,        /* 0x8420 */
    KANJI,        /* 0x8421 */
    KANJI,        /* 0x8422 */
    KANJI,        /* 0x8423 */
    KANJI,        /* 0x8424 */
    KANJI,        /* 0x8425 */
    KANJI,        /* 0x8426 */
    KANJI,        /* 0x8427 */
    KANJI,        /* 0x8428 */
    KANJI,        /* 0x8429 */
    KANJI,        /* 0x842a */
    KANJI,        /* 0x842b */
    KANJI,        /* 0x842c */
    KANJI,        /* 0x842d */
    KANJI,        /* 0x842e */
    KANJI,        /* 0x842f */
    KANJI,        /* 0x8430 */
    KANJI,        /* 0x8431 */
    KANJI,        /* 0x8432 */
    KANJI,        /* 0x8433 */
    KANJI,        /* 0x8434 */
    KANJI,        /* 0x8435 */
    KANJI,        /* 0x8436 */
    KANJI,        /* 0x8437 */
    KANJI,        /* 0x8438 */
    KANJI,        /* 0x8439 */
    KANJI,        /* 0x843a */
    KANJI,        /* 0x843b */
    KANJI,        /* 0x843c */
    KANJI,        /* 0x843d */
    KANJI,        /* 0x843e */
    KANJI,        /* 0x843f */
    KANJI,        /* 0x8440 */
    KANJI,        /* 0x8441 */
    KANJI,        /* 0x8442 */
    KANJI,        /* 0x8443 */
    KANJI,        /* 0x8444 */
    KANJI,        /* 0x8445 */
    KANJI,        /* 0x8446 */
    KANJI,        /* 0x8447 */
    KANJI,        /* 0x8448 */
    KANJI,        /* 0x8449 */
    KANJI,        /* 0x844a */
    KANJI,        /* 0x844b */
    KANJI,        /* 0x844c */
    KANJI,        /* 0x844d */
    KANJI,        /* 0x844e */
    KANJI,        /* 0x844f */
    KANJI,        /* 0x8450 */
    KANJI,        /* 0x8451 */
    KANJI,        /* 0x8452 */
    KANJI,        /* 0x8453 */
    KANJI,        /* 0x8454 */
    KANJI,        /* 0x8455 */
    KANJI,        /* 0x8456 */
    KANJI,        /* 0x8457 */
    KANJI,        /* 0x8458 */
    KANJI,        /* 0x8459 */
    KANJI,        /* 0x845a */
    KANJI,        /* 0x845b */
    KANJI,        /* 0x845c */
    KANJI,        /* 0x845d */
    KANJI,        /* 0x845e */
    KANJI,        /* 0x845f */
    KANJI,        /* 0x8460 */
    KANJI,        /* 0x8461 */
    KANJI,        /* 0x8462 */
    KANJI,        /* 0x8463 */
    KANJI,        /* 0x8464 */
    KANJI,        /* 0x8465 */
    KANJI,        /* 0x8466 */
    KANJI,        /* 0x8467 */
    KANJI,        /* 0x8468 */
    KANJI,        /* 0x8469 */
    KANJI,        /* 0x846a */
    KANJI,        /* 0x846b */
    KANJI,        /* 0x846c */
    KANJI,        /* 0x846d */
    KANJI,        /* 0x846e */
    KANJI,        /* 0x846f */
    KANJI,        /* 0x8470 */
    KANJI,        /* 0x8471 */
    KANJI,        /* 0x8472 */
    KANJI,        /* 0x8473 */
    KANJI,        /* 0x8474 */
    KANJI,        /* 0x8475 */
    KANJI,        /* 0x8476 */
    KANJI,        /* 0x8477 */
    KANJI,        /* 0x8478 */
    KANJI,        /* 0x8479 */
    KANJI,        /* 0x847a */
    KANJI,        /* 0x847b */
    KANJI,        /* 0x847c */
    KANJI,        /* 0x847d */
    KANJI,        /* 0x847e */
    KANJI,        /* 0x847f */
    KANJI,        /* 0x8480 */
    KANJI,        /* 0x8481 */
    KANJI,        /* 0x8482 */
    KANJI,        /* 0x8483 */
    KANJI,        /* 0x8484 */
    KANJI,        /* 0x8485 */
    KANJI,        /* 0x8486 */
    KANJI,        /* 0x8487 */
    KANJI,        /* 0x8488 */
    KANJI,        /* 0x8489 */
    KANJI,        /* 0x848a */
    KANJI,        /* 0x848b */
    KANJI,        /* 0x848c */
    KANJI,        /* 0x848d */
    KANJI,        /* 0x848e */
    KANJI,        /* 0x848f */
    KANJI,        /* 0x8490 */
    KANJI,        /* 0x8491 */
    KANJI,        /* 0x8492 */
    KANJI,        /* 0x8493 */
    KANJI,        /* 0x8494 */
    KANJI,        /* 0x8495 */
    KANJI,        /* 0x8496 */
    KANJI,        /* 0x8497 */
    KANJI,        /* 0x8498 */
    KANJI,        /* 0x8499 */
    KANJI,        /* 0x849a */
    KANJI,        /* 0x849b */
    KANJI,        /* 0x849c */
    KANJI,        /* 0x849d */
    KANJI,        /* 0x849e */
    KANJI,        /* 0x849f */
    KANJI,        /* 0x84a0 */
    KANJI,        /* 0x84a1 */
    KANJI,        /* 0x84a2 */
    KANJI,        /* 0x84a3 */
    KANJI,        /* 0x84a4 */
    KANJI,        /* 0x84a5 */
    KANJI,        /* 0x84a6 */
    KANJI,        /* 0x84a7 */
    KANJI,        /* 0x84a8 */
    KANJI,        /* 0x84a9 */
    KANJI,        /* 0x84aa */
    KANJI,        /* 0x84ab */
    KANJI,        /* 0x84ac */
    KANJI,        /* 0x84ad */
    KANJI,        /* 0x84ae */
    KANJI,        /* 0x84af */
    KANJI,        /* 0x84b0 */
    KANJI,        /* 0x84b1 */
    KANJI,        /* 0x84b2 */
    KANJI,        /* 0x84b3 */
    KANJI,        /* 0x84b4 */
    KANJI,        /* 0x84b5 */
    KANJI,        /* 0x84b6 */
    KANJI,        /* 0x84b7 */
    KANJI,        /* 0x84b8 */
    KANJI,        /* 0x84b9 */
    KANJI,        /* 0x84ba */
    KANJI,        /* 0x84bb */
    KANJI,        /* 0x84bc */
    KANJI,        /* 0x84bd */
    KANJI,        /* 0x84be */
    KANJI,        /* 0x84bf */
    KANJI,        /* 0x84c0 */
    KANJI,        /* 0x84c1 */
    KANJI,        /* 0x84c2 */
    KANJI,        /* 0x84c3 */
    KANJI,        /* 0x84c4 */
    KANJI,        /* 0x84c5 */
    KANJI,        /* 0x84c6 */
    KANJI,        /* 0x84c7 */
    KANJI,        /* 0x84c8 */
    KANJI,        /* 0x84c9 */
    KANJI,        /* 0x84ca */
    KANJI,        /* 0x84cb */
    KANJI,        /* 0x84cc */
    KANJI,        /* 0x84cd */
    KANJI,        /* 0x84ce */
    KANJI,        /* 0x84cf */
    KANJI,        /* 0x84d0 */
    KANJI,        /* 0x84d1 */
    KANJI,        /* 0x84d2 */
    KANJI,        /* 0x84d3 */
    KANJI,        /* 0x84d4 */
    KANJI,        /* 0x84d5 */
    KANJI,        /* 0x84d6 */
    KANJI,        /* 0x84d7 */
    KANJI,        /* 0x84d8 */
    KANJI,        /* 0x84d9 */
    KANJI,        /* 0x84da */
    KANJI,        /* 0x84db */
    KANJI,        /* 0x84dc */
    KANJI,        /* 0x84dd */
    KANJI,        /* 0x84de */
    KANJI,        /* 0x84df */
    KANJI,        /* 0x84e0 */
    KANJI,        /* 0x84e1 */
    KANJI,        /* 0x84e2 */
    KANJI,        /* 0x84e3 */
    KANJI,        /* 0x84e4 */
    KANJI,        /* 0x84e5 */
    KANJI,        /* 0x84e6 */
    KANJI,        /* 0x84e7 */
    KANJI,        /* 0x84e8 */
    KANJI,        /* 0x84e9 */
    KANJI,        /* 0x84ea */
    KANJI,        /* 0x84eb */
    KANJI,        /* 0x84ec */
    KANJI,        /* 0x84ed */
    KANJI,        /* 0x84ee */
    KANJI,        /* 0x84ef */
    KANJI,        /* 0x84f0 */
    KANJI,        /* 0x84f1 */
    KANJI,        /* 0x84f2 */
    KANJI,        /* 0x84f3 */
    KANJI,        /* 0x84f4 */
    KANJI,        /* 0x84f5 */
    KANJI,        /* 0x84f6 */
    KANJI,        /* 0x84f7 */
    KANJI,        /* 0x84f8 */
    KANJI,        /* 0x84f9 */
    KANJI,        /* 0x84fa */
    KANJI,        /* 0x84fb */
    KANJI,        /* 0x84fc */
    KANJI,        /* 0x84fd */
    KANJI,        /* 0x84fe */
    KANJI,        /* 0x84ff */
    KANJI,        /* 0x8500 */
    KANJI,        /* 0x8501 */
    KANJI,        /* 0x8502 */
    KANJI,        /* 0x8503 */
    KANJI,        /* 0x8504 */
    KANJI,        /* 0x8505 */
    KANJI,        /* 0x8506 */
    KANJI,        /* 0x8507 */
    KANJI,        /* 0x8508 */
    KANJI,        /* 0x8509 */
    KANJI,        /* 0x850a */
    KANJI,        /* 0x850b */
    KANJI,        /* 0x850c */
    KANJI,        /* 0x850d */
    KANJI,        /* 0x850e */
    KANJI,        /* 0x850f */
    KANJI,        /* 0x8510 */
    KANJI,        /* 0x8511 */
    KANJI,        /* 0x8512 */
    KANJI,        /* 0x8513 */
    KANJI,        /* 0x8514 */
    KANJI,        /* 0x8515 */
    KANJI,        /* 0x8516 */
    KANJI,        /* 0x8517 */
    KANJI,        /* 0x8518 */
    KANJI,        /* 0x8519 */
    KANJI,        /* 0x851a */
    KANJI,        /* 0x851b */
    KANJI,        /* 0x851c */
    KANJI,        /* 0x851d */
    KANJI,        /* 0x851e */
    KANJI,        /* 0x851f */
    KANJI,        /* 0x8520 */
    KANJI,        /* 0x8521 */
    KANJI,        /* 0x8522 */
    KANJI,        /* 0x8523 */
    KANJI,        /* 0x8524 */
    KANJI,        /* 0x8525 */
    KANJI,        /* 0x8526 */
    KANJI,        /* 0x8527 */
    KANJI,        /* 0x8528 */
    KANJI,        /* 0x8529 */
    KANJI,        /* 0x852a */
    KANJI,        /* 0x852b */
    KANJI,        /* 0x852c */
    KANJI,        /* 0x852d */
    KANJI,        /* 0x852e */
    KANJI,        /* 0x852f */
    KANJI,        /* 0x8530 */
    KANJI,        /* 0x8531 */
    KANJI,        /* 0x8532 */
    KANJI,        /* 0x8533 */
    KANJI,        /* 0x8534 */
    KANJI,        /* 0x8535 */
    KANJI,        /* 0x8536 */
    KANJI,        /* 0x8537 */
    KANJI,        /* 0x8538 */
    KANJI,        /* 0x8539 */
    KANJI,        /* 0x853a */
    KANJI,        /* 0x853b */
    KANJI,        /* 0x853c */
    KANJI,        /* 0x853d */
    KANJI,        /* 0x853e */
    KANJI,        /* 0x853f */
    KANJI,        /* 0x8540 */
    KANJI,        /* 0x8541 */
    KANJI,        /* 0x8542 */
    KANJI,        /* 0x8543 */
    KANJI,        /* 0x8544 */
    KANJI,        /* 0x8545 */
    KANJI,        /* 0x8546 */
    KANJI,        /* 0x8547 */
    KANJI,        /* 0x8548 */
    KANJI,        /* 0x8549 */
    KANJI,        /* 0x854a */
    KANJI,        /* 0x854b */
    KANJI,        /* 0x854c */
    KANJI,        /* 0x854d */
    KANJI,        /* 0x854e */
    KANJI,        /* 0x854f */
    KANJI,        /* 0x8550 */
    KANJI,        /* 0x8551 */
    KANJI,        /* 0x8552 */
    KANJI,        /* 0x8553 */
    KANJI,        /* 0x8554 */
    KANJI,        /* 0x8555 */
    KANJI,        /* 0x8556 */
    KANJI,        /* 0x8557 */
    KANJI,        /* 0x8558 */
    KANJI,        /* 0x8559 */
    KANJI,        /* 0x855a */
    KANJI,        /* 0x855b */
    KANJI,        /* 0x855c */
    KANJI,        /* 0x855d */
    KANJI,        /* 0x855e */
    KANJI,        /* 0x855f */
    KANJI,        /* 0x8560 */
    KANJI,        /* 0x8561 */
    KANJI,        /* 0x8562 */
    KANJI,        /* 0x8563 */
    KANJI,        /* 0x8564 */
    KANJI,        /* 0x8565 */
    KANJI,        /* 0x8566 */
    KANJI,        /* 0x8567 */
    KANJI,        /* 0x8568 */
    KANJI,        /* 0x8569 */
    KANJI,        /* 0x856a */
    KANJI,        /* 0x856b */
    KANJI,        /* 0x856c */
    KANJI,        /* 0x856d */
    KANJI,        /* 0x856e */
    KANJI,        /* 0x856f */
    KANJI,        /* 0x8570 */
    KANJI,        /* 0x8571 */
    KANJI,        /* 0x8572 */
    KANJI,        /* 0x8573 */
    KANJI,        /* 0x8574 */
    KANJI,        /* 0x8575 */
    KANJI,        /* 0x8576 */
    KANJI,        /* 0x8577 */
    KANJI,        /* 0x8578 */
    KANJI,        /* 0x8579 */
    KANJI,        /* 0x857a */
    KANJI,        /* 0x857b */
    KANJI,        /* 0x857c */
    KANJI,        /* 0x857d */
    KANJI,        /* 0x857e */
    KANJI,        /* 0x857f */
    KANJI,        /* 0x8580 */
    KANJI,        /* 0x8581 */
    KANJI,        /* 0x8582 */
    KANJI,        /* 0x8583 */
    KANJI,        /* 0x8584 */
    KANJI,        /* 0x8585 */
    KANJI,        /* 0x8586 */
    KANJI,        /* 0x8587 */
    KANJI,        /* 0x8588 */
    KANJI,        /* 0x8589 */
    KANJI,        /* 0x858a */
    KANJI,        /* 0x858b */
    KANJI,        /* 0x858c */
    KANJI,        /* 0x858d */
    KANJI,        /* 0x858e */
    KANJI,        /* 0x858f */
    KANJI,        /* 0x8590 */
    KANJI,        /* 0x8591 */
    KANJI,        /* 0x8592 */
    KANJI,        /* 0x8593 */
    KANJI,        /* 0x8594 */
    KANJI,        /* 0x8595 */
    KANJI,        /* 0x8596 */
    KANJI,        /* 0x8597 */
    KANJI,        /* 0x8598 */
    KANJI,        /* 0x8599 */
    KANJI,        /* 0x859a */
    KANJI,        /* 0x859b */
    KANJI,        /* 0x859c */
    KANJI,        /* 0x859d */
    KANJI,        /* 0x859e */
    KANJI,        /* 0x859f */
    KANJI,        /* 0x85a0 */
    KANJI,        /* 0x85a1 */
    KANJI,        /* 0x85a2 */
    KANJI,        /* 0x85a3 */
    KANJI,        /* 0x85a4 */
    KANJI,        /* 0x85a5 */
    KANJI,        /* 0x85a6 */
    KANJI,        /* 0x85a7 */
    KANJI,        /* 0x85a8 */
    KANJI,        /* 0x85a9 */
    KANJI,        /* 0x85aa */
    KANJI,        /* 0x85ab */
    KANJI,        /* 0x85ac */
    KANJI,        /* 0x85ad */
    KANJI,        /* 0x85ae */
    KANJI,        /* 0x85af */
    KANJI,        /* 0x85b0 */
    KANJI,        /* 0x85b1 */
    KANJI,        /* 0x85b2 */
    KANJI,        /* 0x85b3 */
    KANJI,        /* 0x85b4 */
    KANJI,        /* 0x85b5 */
    KANJI,        /* 0x85b6 */
    KANJI,        /* 0x85b7 */
    KANJI,        /* 0x85b8 */
    KANJI,        /* 0x85b9 */
    KANJI,        /* 0x85ba */
    KANJI,        /* 0x85bb */
    KANJI,        /* 0x85bc */
    KANJI,        /* 0x85bd */
    KANJI,        /* 0x85be */
    KANJI,        /* 0x85bf */
    KANJI,        /* 0x85c0 */
    KANJI,        /* 0x85c1 */
    KANJI,        /* 0x85c2 */
    KANJI,        /* 0x85c3 */
    KANJI,        /* 0x85c4 */
    KANJI,        /* 0x85c5 */
    KANJI,        /* 0x85c6 */
    KANJI,        /* 0x85c7 */
    KANJI,        /* 0x85c8 */
    KANJI,        /* 0x85c9 */
    KANJI,        /* 0x85ca */
    KANJI,        /* 0x85cb */
    KANJI,        /* 0x85cc */
    KANJI,        /* 0x85cd */
    KANJI,        /* 0x85ce */
    KANJI,        /* 0x85cf */
    KANJI,        /* 0x85d0 */
    KANJI,        /* 0x85d1 */
    KANJI,        /* 0x85d2 */
    KANJI,        /* 0x85d3 */
    KANJI,        /* 0x85d4 */
    KANJI,        /* 0x85d5 */
    KANJI,        /* 0x85d6 */
    KANJI,        /* 0x85d7 */
    KANJI,        /* 0x85d8 */
    KANJI,        /* 0x85d9 */
    KANJI,        /* 0x85da */
    KANJI,        /* 0x85db */
    KANJI,        /* 0x85dc */
    KANJI,        /* 0x85dd */
    KANJI,        /* 0x85de */
    KANJI,        /* 0x85df */
    KANJI,        /* 0x85e0 */
    KANJI,        /* 0x85e1 */
    KANJI,        /* 0x85e2 */
    KANJI,        /* 0x85e3 */
    KANJI,        /* 0x85e4 */
    KANJI,        /* 0x85e5 */
    KANJI,        /* 0x85e6 */
    KANJI,        /* 0x85e7 */
    KANJI,        /* 0x85e8 */
    KANJI,        /* 0x85e9 */
    KANJI,        /* 0x85ea */
    KANJI,        /* 0x85eb */
    KANJI,        /* 0x85ec */
    KANJI,        /* 0x85ed */
    KANJI,        /* 0x85ee */
    KANJI,        /* 0x85ef */
    KANJI,        /* 0x85f0 */
    KANJI,        /* 0x85f1 */
    KANJI,        /* 0x85f2 */
    KANJI,        /* 0x85f3 */
    KANJI,        /* 0x85f4 */
    KANJI,        /* 0x85f5 */
    KANJI,        /* 0x85f6 */
    KANJI,        /* 0x85f7 */
    KANJI,        /* 0x85f8 */
    KANJI,        /* 0x85f9 */
    KANJI,        /* 0x85fa */
    KANJI,        /* 0x85fb */
    KANJI,        /* 0x85fc */
    KANJI,        /* 0x85fd */
    KANJI,        /* 0x85fe */
    KANJI,        /* 0x85ff */
    KANJI,        /* 0x8600 */
    KANJI,        /* 0x8601 */
    KANJI,        /* 0x8602 */
    KANJI,        /* 0x8603 */
    KANJI,        /* 0x8604 */
    KANJI,        /* 0x8605 */
    KANJI,        /* 0x8606 */
    KANJI,        /* 0x8607 */
    KANJI,        /* 0x8608 */
    KANJI,        /* 0x8609 */
    KANJI,        /* 0x860a */
    KANJI,        /* 0x860b */
    KANJI,        /* 0x860c */
    KANJI,        /* 0x860d */
    KANJI,        /* 0x860e */
    KANJI,        /* 0x860f */
    KANJI,        /* 0x8610 */
    KANJI,        /* 0x8611 */
    KANJI,        /* 0x8612 */
    KANJI,        /* 0x8613 */
    KANJI,        /* 0x8614 */
    KANJI,        /* 0x8615 */
    KANJI,        /* 0x8616 */
    KANJI,        /* 0x8617 */
    KANJI,        /* 0x8618 */
    KANJI,        /* 0x8619 */
    KANJI,        /* 0x861a */
    KANJI,        /* 0x861b */
    KANJI,        /* 0x861c */
    KANJI,        /* 0x861d */
    KANJI,        /* 0x861e */
    KANJI,        /* 0x861f */
    KANJI,        /* 0x8620 */
    KANJI,        /* 0x8621 */
    KANJI,        /* 0x8622 */
    KANJI,        /* 0x8623 */
    KANJI,        /* 0x8624 */
    KANJI,        /* 0x8625 */
    KANJI,        /* 0x8626 */
    KANJI,        /* 0x8627 */
    KANJI,        /* 0x8628 */
    KANJI,        /* 0x8629 */
    KANJI,        /* 0x862a */
    KANJI,        /* 0x862b */
    KANJI,        /* 0x862c */
    KANJI,        /* 0x862d */
    KANJI,        /* 0x862e */
    KANJI,        /* 0x862f */
    KANJI,        /* 0x8630 */
    KANJI,        /* 0x8631 */
    KANJI,        /* 0x8632 */
    KANJI,        /* 0x8633 */
    KANJI,        /* 0x8634 */
    KANJI,        /* 0x8635 */
    KANJI,        /* 0x8636 */
    KANJI,        /* 0x8637 */
    KANJI,        /* 0x8638 */
    KANJI,        /* 0x8639 */
    KANJI,        /* 0x863a */
    KANJI,        /* 0x863b */
    KANJI,        /* 0x863c */
    KANJI,        /* 0x863d */
    KANJI,        /* 0x863e */
    KANJI,        /* 0x863f */
    KANJI,        /* 0x8640 */
    KANJI,        /* 0x8641 */
    KANJI,        /* 0x8642 */
    KANJI,        /* 0x8643 */
    KANJI,        /* 0x8644 */
    KANJI,        /* 0x8645 */
    KANJI,        /* 0x8646 */
    KANJI,        /* 0x8647 */
    KANJI,        /* 0x8648 */
    KANJI,        /* 0x8649 */
    KANJI,        /* 0x864a */
    KANJI,        /* 0x864b */
    KANJI,        /* 0x864c */
    KANJI,        /* 0x864d */
    KANJI,        /* 0x864e */
    KANJI,        /* 0x864f */
    KANJI,        /* 0x8650 */
    KANJI,        /* 0x8651 */
    KANJI,        /* 0x8652 */
    KANJI,        /* 0x8653 */
    KANJI,        /* 0x8654 */
    KANJI,        /* 0x8655 */
    KANJI,        /* 0x8656 */
    KANJI,        /* 0x8657 */
    KANJI,        /* 0x8658 */
    KANJI,        /* 0x8659 */
    KANJI,        /* 0x865a */
    KANJI,        /* 0x865b */
    KANJI,        /* 0x865c */
    KANJI,        /* 0x865d */
    KANJI,        /* 0x865e */
    KANJI,        /* 0x865f */
    KANJI,        /* 0x8660 */
    KANJI,        /* 0x8661 */
    KANJI,        /* 0x8662 */
    KANJI,        /* 0x8663 */
    KANJI,        /* 0x8664 */
    KANJI,        /* 0x8665 */
    KANJI,        /* 0x8666 */
    KANJI,        /* 0x8667 */
    KANJI,        /* 0x8668 */
    KANJI,        /* 0x8669 */
    KANJI,        /* 0x866a */
    KANJI,        /* 0x866b */
    KANJI,        /* 0x866c */
    KANJI,        /* 0x866d */
    KANJI,        /* 0x866e */
    KANJI,        /* 0x866f */
    KANJI,        /* 0x8670 */
    KANJI,        /* 0x8671 */
    KANJI,        /* 0x8672 */
    KANJI,        /* 0x8673 */
    KANJI,        /* 0x8674 */
    KANJI,        /* 0x8675 */
    KANJI,        /* 0x8676 */
    KANJI,        /* 0x8677 */
    KANJI,        /* 0x8678 */
    KANJI,        /* 0x8679 */
    KANJI,        /* 0x867a */
    KANJI,        /* 0x867b */
    KANJI,        /* 0x867c */
    KANJI,        /* 0x867d */
    KANJI,        /* 0x867e */
    KANJI,        /* 0x867f */
    KANJI,        /* 0x8680 */
    KANJI,        /* 0x8681 */
    KANJI,        /* 0x8682 */
    KANJI,        /* 0x8683 */
    KANJI,        /* 0x8684 */
    KANJI,        /* 0x8685 */
    KANJI,        /* 0x8686 */
    KANJI,        /* 0x8687 */
    KANJI,        /* 0x8688 */
    KANJI,        /* 0x8689 */
    KANJI,        /* 0x868a */
    KANJI,        /* 0x868b */
    KANJI,        /* 0x868c */
    KANJI,        /* 0x868d */
    KANJI,        /* 0x868e */
    KANJI,        /* 0x868f */
    KANJI,        /* 0x8690 */
    KANJI,        /* 0x8691 */
    KANJI,        /* 0x8692 */
    KANJI,        /* 0x8693 */
    KANJI,        /* 0x8694 */
    KANJI,        /* 0x8695 */
    KANJI,        /* 0x8696 */
    KANJI,        /* 0x8697 */
    KANJI,        /* 0x8698 */
    KANJI,        /* 0x8699 */
    KANJI,        /* 0x869a */
    KANJI,        /* 0x869b */
    KANJI,        /* 0x869c */
    KANJI,        /* 0x869d */
    KANJI,        /* 0x869e */
    KANJI,        /* 0x869f */
    KANJI,        /* 0x86a0 */
    KANJI,        /* 0x86a1 */
    KANJI,        /* 0x86a2 */
    KANJI,        /* 0x86a3 */
    KANJI,        /* 0x86a4 */
    KANJI,        /* 0x86a5 */
    KANJI,        /* 0x86a6 */
    KANJI,        /* 0x86a7 */
    KANJI,        /* 0x86a8 */
    KANJI,        /* 0x86a9 */
    KANJI,        /* 0x86aa */
    KANJI,        /* 0x86ab */
    KANJI,        /* 0x86ac */
    KANJI,        /* 0x86ad */
    KANJI,        /* 0x86ae */
    KANJI,        /* 0x86af */
    KANJI,        /* 0x86b0 */
    KANJI,        /* 0x86b1 */
    KANJI,        /* 0x86b2 */
    KANJI,        /* 0x86b3 */
    KANJI,        /* 0x86b4 */
    KANJI,        /* 0x86b5 */
    KANJI,        /* 0x86b6 */
    KANJI,        /* 0x86b7 */
    KANJI,        /* 0x86b8 */
    KANJI,        /* 0x86b9 */
    KANJI,        /* 0x86ba */
    KANJI,        /* 0x86bb */
    KANJI,        /* 0x86bc */
    KANJI,        /* 0x86bd */
    KANJI,        /* 0x86be */
    KANJI,        /* 0x86bf */
    KANJI,        /* 0x86c0 */
    KANJI,        /* 0x86c1 */
    KANJI,        /* 0x86c2 */
    KANJI,        /* 0x86c3 */
    KANJI,        /* 0x86c4 */
    KANJI,        /* 0x86c5 */
    KANJI,        /* 0x86c6 */
    KANJI,        /* 0x86c7 */
    KANJI,        /* 0x86c8 */
    KANJI,        /* 0x86c9 */
    KANJI,        /* 0x86ca */
    KANJI,        /* 0x86cb */
    KANJI,        /* 0x86cc */
    KANJI,        /* 0x86cd */
    KANJI,        /* 0x86ce */
    KANJI,        /* 0x86cf */
    KANJI,        /* 0x86d0 */
    KANJI,        /* 0x86d1 */
    KANJI,        /* 0x86d2 */
    KANJI,        /* 0x86d3 */
    KANJI,        /* 0x86d4 */
    KANJI,        /* 0x86d5 */
    KANJI,        /* 0x86d6 */
    KANJI,        /* 0x86d7 */
    KANJI,        /* 0x86d8 */
    KANJI,        /* 0x86d9 */
    KANJI,        /* 0x86da */
    KANJI,        /* 0x86db */
    KANJI,        /* 0x86dc */
    KANJI,        /* 0x86dd */
    KANJI,        /* 0x86de */
    KANJI,        /* 0x86df */
    KANJI,        /* 0x86e0 */
    KANJI,        /* 0x86e1 */
    KANJI,        /* 0x86e2 */
    KANJI,        /* 0x86e3 */
    KANJI,        /* 0x86e4 */
    KANJI,        /* 0x86e5 */
    KANJI,        /* 0x86e6 */
    KANJI,        /* 0x86e7 */
    KANJI,        /* 0x86e8 */
    KANJI,        /* 0x86e9 */
    KANJI,        /* 0x86ea */
    KANJI,        /* 0x86eb */
    KANJI,        /* 0x86ec */
    KANJI,        /* 0x86ed */
    KANJI,        /* 0x86ee */
    KANJI,        /* 0x86ef */
    KANJI,        /* 0x86f0 */
    KANJI,        /* 0x86f1 */
    KANJI,        /* 0x86f2 */
    KANJI,        /* 0x86f3 */
    KANJI,        /* 0x86f4 */
    KANJI,        /* 0x86f5 */
    KANJI,        /* 0x86f6 */
    KANJI,        /* 0x86f7 */
    KANJI,        /* 0x86f8 */
    KANJI,        /* 0x86f9 */
    KANJI,        /* 0x86fa */
    KANJI,        /* 0x86fb */
    KANJI,        /* 0x86fc */
    KANJI,        /* 0x86fd */
    KANJI,        /* 0x86fe */
    KANJI,        /* 0x86ff */
    KANJI,        /* 0x8700 */
    KANJI,        /* 0x8701 */
    KANJI,        /* 0x8702 */
    KANJI,        /* 0x8703 */
    KANJI,        /* 0x8704 */
    KANJI,        /* 0x8705 */
    KANJI,        /* 0x8706 */
    KANJI,        /* 0x8707 */
    KANJI,        /* 0x8708 */
    KANJI,        /* 0x8709 */
    KANJI,        /* 0x870a */
    KANJI,        /* 0x870b */
    KANJI,        /* 0x870c */
    KANJI,        /* 0x870d */
    KANJI,        /* 0x870e */
    KANJI,        /* 0x870f */
    KANJI,        /* 0x8710 */
    KANJI,        /* 0x8711 */
    KANJI,        /* 0x8712 */
    KANJI,        /* 0x8713 */
    KANJI,        /* 0x8714 */
    KANJI,        /* 0x8715 */
    KANJI,        /* 0x8716 */
    KANJI,        /* 0x8717 */
    KANJI,        /* 0x8718 */
    KANJI,        /* 0x8719 */
    KANJI,        /* 0x871a */
    KANJI,        /* 0x871b */
    KANJI,        /* 0x871c */
    KANJI,        /* 0x871d */
    KANJI,        /* 0x871e */
    KANJI,        /* 0x871f */
    KANJI,        /* 0x8720 */
    KANJI,        /* 0x8721 */
    KANJI,        /* 0x8722 */
    KANJI,        /* 0x8723 */
    KANJI,        /* 0x8724 */
    KANJI,        /* 0x8725 */
    KANJI,        /* 0x8726 */
    KANJI,        /* 0x8727 */
    KANJI,        /* 0x8728 */
    KANJI,        /* 0x8729 */
    KANJI,        /* 0x872a */
    KANJI,        /* 0x872b */
    KANJI,        /* 0x872c */
    KANJI,        /* 0x872d */
    KANJI,        /* 0x872e */
    KANJI,        /* 0x872f */
    KANJI,        /* 0x8730 */
    KANJI,        /* 0x8731 */
    KANJI,        /* 0x8732 */
    KANJI,        /* 0x8733 */
    KANJI,        /* 0x8734 */
    KANJI,        /* 0x8735 */
    KANJI,        /* 0x8736 */
    KANJI,        /* 0x8737 */
    KANJI,        /* 0x8738 */
    KANJI,        /* 0x8739 */
    KANJI,        /* 0x873a */
    KANJI,        /* 0x873b */
    KANJI,        /* 0x873c */
    KANJI,        /* 0x873d */
    KANJI,        /* 0x873e */
    KANJI,        /* 0x873f */
    KANJI,        /* 0x8740 */
    KANJI,        /* 0x8741 */
    KANJI,        /* 0x8742 */
    KANJI,        /* 0x8743 */
    KANJI,        /* 0x8744 */
    KANJI,        /* 0x8745 */
    KANJI,        /* 0x8746 */
    KANJI,        /* 0x8747 */
    KANJI,        /* 0x8748 */
    KANJI,        /* 0x8749 */
    KANJI,        /* 0x874a */
    KANJI,        /* 0x874b */
    KANJI,        /* 0x874c */
    KANJI,        /* 0x874d */
    KANJI,        /* 0x874e */
    KANJI,        /* 0x874f */
    KANJI,        /* 0x8750 */
    KANJI,        /* 0x8751 */
    KANJI,        /* 0x8752 */
    KANJI,        /* 0x8753 */
    KANJI,        /* 0x8754 */
    KANJI,        /* 0x8755 */
    KANJI,        /* 0x8756 */
    KANJI,        /* 0x8757 */
    KANJI,        /* 0x8758 */
    KANJI,        /* 0x8759 */
    KANJI,        /* 0x875a */
    KANJI,        /* 0x875b */
    KANJI,        /* 0x875c */
    KANJI,        /* 0x875d */
    KANJI,        /* 0x875e */
    KANJI,        /* 0x875f */
    KANJI,        /* 0x8760 */
    KANJI,        /* 0x8761 */
    KANJI,        /* 0x8762 */
    KANJI,        /* 0x8763 */
    KANJI,        /* 0x8764 */
    KANJI,        /* 0x8765 */
    KANJI,        /* 0x8766 */
    KANJI,        /* 0x8767 */
    KANJI,        /* 0x8768 */
    KANJI,        /* 0x8769 */
    KANJI,        /* 0x876a */
    KANJI,        /* 0x876b */
    KANJI,        /* 0x876c */
    KANJI,        /* 0x876d */
    KANJI,        /* 0x876e */
    KANJI,        /* 0x876f */
    KANJI,        /* 0x8770 */
    KANJI,        /* 0x8771 */
    KANJI,        /* 0x8772 */
    KANJI,        /* 0x8773 */
    KANJI,        /* 0x8774 */
    KANJI,        /* 0x8775 */
    KANJI,        /* 0x8776 */
    KANJI,        /* 0x8777 */
    KANJI,        /* 0x8778 */
    KANJI,        /* 0x8779 */
    KANJI,        /* 0x877a */
    KANJI,        /* 0x877b */
    KANJI,        /* 0x877c */
    KANJI,        /* 0x877d */
    KANJI,        /* 0x877e */
    KANJI,        /* 0x877f */
    KANJI,        /* 0x8780 */
    KANJI,        /* 0x8781 */
    KANJI,        /* 0x8782 */
    KANJI,        /* 0x8783 */
    KANJI,        /* 0x8784 */
    KANJI,        /* 0x8785 */
    KANJI,        /* 0x8786 */
    KANJI,        /* 0x8787 */
    KANJI,        /* 0x8788 */
    KANJI,        /* 0x8789 */
    KANJI,        /* 0x878a */
    KANJI,        /* 0x878b */
    KANJI,        /* 0x878c */
    KANJI,        /* 0x878d */
    KANJI,        /* 0x878e */
    KANJI,        /* 0x878f */
    KANJI,        /* 0x8790 */
    KANJI,        /* 0x8791 */
    KANJI,        /* 0x8792 */
    KANJI,        /* 0x8793 */
    KANJI,        /* 0x8794 */
    KANJI,        /* 0x8795 */
    KANJI,        /* 0x8796 */
    KANJI,        /* 0x8797 */
    KANJI,        /* 0x8798 */
    KANJI,        /* 0x8799 */
    KANJI,        /* 0x879a */
    KANJI,        /* 0x879b */
    KANJI,        /* 0x879c */
    KANJI,        /* 0x879d */
    KANJI,        /* 0x879e */
    KANJI,        /* 0x879f */
    KANJI,        /* 0x87a0 */
    KANJI,        /* 0x87a1 */
    KANJI,        /* 0x87a2 */
    KANJI,        /* 0x87a3 */
    KANJI,        /* 0x87a4 */
    KANJI,        /* 0x87a5 */
    KANJI,        /* 0x87a6 */
    KANJI,        /* 0x87a7 */
    KANJI,        /* 0x87a8 */
    KANJI,        /* 0x87a9 */
    KANJI,        /* 0x87aa */
    KANJI,        /* 0x87ab */
    KANJI,        /* 0x87ac */
    KANJI,        /* 0x87ad */
    KANJI,        /* 0x87ae */
    KANJI,        /* 0x87af */
    KANJI,        /* 0x87b0 */
    KANJI,        /* 0x87b1 */
    KANJI,        /* 0x87b2 */
    KANJI,        /* 0x87b3 */
    KANJI,        /* 0x87b4 */
    KANJI,        /* 0x87b5 */
    KANJI,        /* 0x87b6 */
    KANJI,        /* 0x87b7 */
    KANJI,        /* 0x87b8 */
    KANJI,        /* 0x87b9 */
    KANJI,        /* 0x87ba */
    KANJI,        /* 0x87bb */
    KANJI,        /* 0x87bc */
    KANJI,        /* 0x87bd */
    KANJI,        /* 0x87be */
    KANJI,        /* 0x87bf */
    KANJI,        /* 0x87c0 */
    KANJI,        /* 0x87c1 */
    KANJI,        /* 0x87c2 */
    KANJI,        /* 0x87c3 */
    KANJI,        /* 0x87c4 */
    KANJI,        /* 0x87c5 */
    KANJI,        /* 0x87c6 */
    KANJI,        /* 0x87c7 */
    KANJI,        /* 0x87c8 */
    KANJI,        /* 0x87c9 */
    KANJI,        /* 0x87ca */
    KANJI,        /* 0x87cb */
    KANJI,        /* 0x87cc */
    KANJI,        /* 0x87cd */
    KANJI,        /* 0x87ce */
    KANJI,        /* 0x87cf */
    KANJI,        /* 0x87d0 */
    KANJI,        /* 0x87d1 */
    KANJI,        /* 0x87d2 */
    KANJI,        /* 0x87d3 */
    KANJI,        /* 0x87d4 */
    KANJI,        /* 0x87d5 */
    KANJI,        /* 0x87d6 */
    KANJI,        /* 0x87d7 */
    KANJI,        /* 0x87d8 */
    KANJI,        /* 0x87d9 */
    KANJI,        /* 0x87da */
    KANJI,        /* 0x87db */
    KANJI,        /* 0x87dc */
    KANJI,        /* 0x87dd */
    KANJI,        /* 0x87de */
    KANJI,        /* 0x87df */
    KANJI,        /* 0x87e0 */
    KANJI,        /* 0x87e1 */
    KANJI,        /* 0x87e2 */
    KANJI,        /* 0x87e3 */
    KANJI,        /* 0x87e4 */
    KANJI,        /* 0x87e5 */
    KANJI,        /* 0x87e6 */
    KANJI,        /* 0x87e7 */
    KANJI,        /* 0x87e8 */
    KANJI,        /* 0x87e9 */
    KANJI,        /* 0x87ea */
    KANJI,        /* 0x87eb */
    KANJI,        /* 0x87ec */
    KANJI,        /* 0x87ed */
    KANJI,        /* 0x87ee */
    KANJI,        /* 0x87ef */
    KANJI,        /* 0x87f0 */
    KANJI,        /* 0x87f1 */
    KANJI,        /* 0x87f2 */
    KANJI,        /* 0x87f3 */
    KANJI,        /* 0x87f4 */
    KANJI,        /* 0x87f5 */
    KANJI,        /* 0x87f6 */
    KANJI,        /* 0x87f7 */
    KANJI,        /* 0x87f8 */
    KANJI,        /* 0x87f9 */
    KANJI,        /* 0x87fa */
    KANJI,        /* 0x87fb */
    KANJI,        /* 0x87fc */
    KANJI,        /* 0x87fd */
    KANJI,        /* 0x87fe */
    KANJI,        /* 0x87ff */
    KANJI,        /* 0x8800 */
    KANJI,        /* 0x8801 */
    KANJI,        /* 0x8802 */
    KANJI,        /* 0x8803 */
    KANJI,        /* 0x8804 */
    KANJI,        /* 0x8805 */
    KANJI,        /* 0x8806 */
    KANJI,        /* 0x8807 */
    KANJI,        /* 0x8808 */
    KANJI,        /* 0x8809 */
    KANJI,        /* 0x880a */
    KANJI,        /* 0x880b */
    KANJI,        /* 0x880c */
    KANJI,        /* 0x880d */
    KANJI,        /* 0x880e */
    KANJI,        /* 0x880f */
    KANJI,        /* 0x8810 */
    KANJI,        /* 0x8811 */
    KANJI,        /* 0x8812 */
    KANJI,        /* 0x8813 */
    KANJI,        /* 0x8814 */
    KANJI,        /* 0x8815 */
    KANJI,        /* 0x8816 */
    KANJI,        /* 0x8817 */
    KANJI,        /* 0x8818 */
    KANJI,        /* 0x8819 */
    KANJI,        /* 0x881a */
    KANJI,        /* 0x881b */
    KANJI,        /* 0x881c */
    KANJI,        /* 0x881d */
    KANJI,        /* 0x881e */
    KANJI,        /* 0x881f */
    KANJI,        /* 0x8820 */
    KANJI,        /* 0x8821 */
    KANJI,        /* 0x8822 */
    KANJI,        /* 0x8823 */
    KANJI,        /* 0x8824 */
    KANJI,        /* 0x8825 */
    KANJI,        /* 0x8826 */
    KANJI,        /* 0x8827 */
    KANJI,        /* 0x8828 */
    KANJI,        /* 0x8829 */
    KANJI,        /* 0x882a */
    KANJI,        /* 0x882b */
    KANJI,        /* 0x882c */
    KANJI,        /* 0x882d */
    KANJI,        /* 0x882e */
    KANJI,        /* 0x882f */
    KANJI,        /* 0x8830 */
    KANJI,        /* 0x8831 */
    KANJI,        /* 0x8832 */
    KANJI,        /* 0x8833 */
    KANJI,        /* 0x8834 */
    KANJI,        /* 0x8835 */
    KANJI,        /* 0x8836 */
    KANJI,        /* 0x8837 */
    KANJI,        /* 0x8838 */
    KANJI,        /* 0x8839 */
    KANJI,        /* 0x883a */
    KANJI,        /* 0x883b */
    KANJI,        /* 0x883c */
    KANJI,        /* 0x883d */
    KANJI,        /* 0x883e */
    KANJI,        /* 0x883f */
    KANJI,        /* 0x8840 */
    KANJI,        /* 0x8841 */
    KANJI,        /* 0x8842 */
    KANJI,        /* 0x8843 */
    KANJI,        /* 0x8844 */
    KANJI,        /* 0x8845 */
    KANJI,        /* 0x8846 */
    KANJI,        /* 0x8847 */
    KANJI,        /* 0x8848 */
    KANJI,        /* 0x8849 */
    KANJI,        /* 0x884a */
    KANJI,        /* 0x884b */
    KANJI,        /* 0x884c */
    KANJI,        /* 0x884d */
    KANJI,        /* 0x884e */
    KANJI,        /* 0x884f */
    KANJI,        /* 0x8850 */
    KANJI,        /* 0x8851 */
    KANJI,        /* 0x8852 */
    KANJI,        /* 0x8853 */
    KANJI,        /* 0x8854 */
    KANJI,        /* 0x8855 */
    KANJI,        /* 0x8856 */
    KANJI,        /* 0x8857 */
    KANJI,        /* 0x8858 */
    KANJI,        /* 0x8859 */
    KANJI,        /* 0x885a */
    KANJI,        /* 0x885b */
    KANJI,        /* 0x885c */
    KANJI,        /* 0x885d */
    KANJI,        /* 0x885e */
    KANJI,        /* 0x885f */
    KANJI,        /* 0x8860 */
    KANJI,        /* 0x8861 */
    KANJI,        /* 0x8862 */
    KANJI,        /* 0x8863 */
    KANJI,        /* 0x8864 */
    KANJI,        /* 0x8865 */
    KANJI,        /* 0x8866 */
    KANJI,        /* 0x8867 */
    KANJI,        /* 0x8868 */
    KANJI,        /* 0x8869 */
    KANJI,        /* 0x886a */
    KANJI,        /* 0x886b */
    KANJI,        /* 0x886c */
    KANJI,        /* 0x886d */
    KANJI,        /* 0x886e */
    KANJI,        /* 0x886f */
    KANJI,        /* 0x8870 */
    KANJI,        /* 0x8871 */
    KANJI,        /* 0x8872 */
    KANJI,        /* 0x8873 */
    KANJI,        /* 0x8874 */
    KANJI,        /* 0x8875 */
    KANJI,        /* 0x8876 */
    KANJI,        /* 0x8877 */
    KANJI,        /* 0x8878 */
    KANJI,        /* 0x8879 */
    KANJI,        /* 0x887a */
    KANJI,        /* 0x887b */
    KANJI,        /* 0x887c */
    KANJI,        /* 0x887d */
    KANJI,        /* 0x887e */
    KANJI,        /* 0x887f */
    KANJI,        /* 0x8880 */
    KANJI,        /* 0x8881 */
    KANJI,        /* 0x8882 */
    KANJI,        /* 0x8883 */
    KANJI,        /* 0x8884 */
    KANJI,        /* 0x8885 */
    KANJI,        /* 0x8886 */
    KANJI,        /* 0x8887 */
    KANJI,        /* 0x8888 */
    KANJI,        /* 0x8889 */
    KANJI,        /* 0x888a */
    KANJI,        /* 0x888b */
    KANJI,        /* 0x888c */
    KANJI,        /* 0x888d */
    KANJI,        /* 0x888e */
    KANJI,        /* 0x888f */
    KANJI,        /* 0x8890 */
    KANJI,        /* 0x8891 */
    KANJI,        /* 0x8892 */
    KANJI,        /* 0x8893 */
    KANJI,        /* 0x8894 */
    KANJI,        /* 0x8895 */
    KANJI,        /* 0x8896 */
    KANJI,        /* 0x8897 */
    KANJI,        /* 0x8898 */
    KANJI,        /* 0x8899 */
    KANJI,        /* 0x889a */
    KANJI,        /* 0x889b */
    KANJI,        /* 0x889c */
    KANJI,        /* 0x889d */
    KANJI,        /* 0x889e */
    KANJI,        /* 0x889f */
    KANJI,        /* 0x88a0 */
    KANJI,        /* 0x88a1 */
    KANJI,        /* 0x88a2 */
    KANJI,        /* 0x88a3 */
    KANJI,        /* 0x88a4 */
    KANJI,        /* 0x88a5 */
    KANJI,        /* 0x88a6 */
    KANJI,        /* 0x88a7 */
    KANJI,        /* 0x88a8 */
    KANJI,        /* 0x88a9 */
    KANJI,        /* 0x88aa */
    KANJI,        /* 0x88ab */
    KANJI,        /* 0x88ac */
    KANJI,        /* 0x88ad */
    KANJI,        /* 0x88ae */
    KANJI,        /* 0x88af */
    KANJI,        /* 0x88b0 */
    KANJI,        /* 0x88b1 */
    KANJI,        /* 0x88b2 */
    KANJI,        /* 0x88b3 */
    KANJI,        /* 0x88b4 */
    KANJI,        /* 0x88b5 */
    KANJI,        /* 0x88b6 */
    KANJI,        /* 0x88b7 */
    KANJI,        /* 0x88b8 */
    KANJI,        /* 0x88b9 */
    KANJI,        /* 0x88ba */
    KANJI,        /* 0x88bb */
    KANJI,        /* 0x88bc */
    KANJI,        /* 0x88bd */
    KANJI,        /* 0x88be */
    KANJI,        /* 0x88bf */
    KANJI,        /* 0x88c0 */
    KANJI,        /* 0x88c1 */
    KANJI,        /* 0x88c2 */
    KANJI,        /* 0x88c3 */
    KANJI,        /* 0x88c4 */
    KANJI,        /* 0x88c5 */
    KANJI,        /* 0x88c6 */
    KANJI,        /* 0x88c7 */
    KANJI,        /* 0x88c8 */
    KANJI,        /* 0x88c9 */
    KANJI,        /* 0x88ca */
    KANJI,        /* 0x88cb */
    KANJI,        /* 0x88cc */
    KANJI,        /* 0x88cd */
    KANJI,        /* 0x88ce */
    KANJI,        /* 0x88cf */
    KANJI,        /* 0x88d0 */
    KANJI,        /* 0x88d1 */
    KANJI,        /* 0x88d2 */
    KANJI,        /* 0x88d3 */
    KANJI,        /* 0x88d4 */
    KANJI,        /* 0x88d5 */
    KANJI,        /* 0x88d6 */
    KANJI,        /* 0x88d7 */
    KANJI,        /* 0x88d8 */
    KANJI,        /* 0x88d9 */
    KANJI,        /* 0x88da */
    KANJI,        /* 0x88db */
    KANJI,        /* 0x88dc */
    KANJI,        /* 0x88dd */
    KANJI,        /* 0x88de */
    KANJI,        /* 0x88df */
    KANJI,        /* 0x88e0 */
    KANJI,        /* 0x88e1 */
    KANJI,        /* 0x88e2 */
    KANJI,        /* 0x88e3 */
    KANJI,        /* 0x88e4 */
    KANJI,        /* 0x88e5 */
    KANJI,        /* 0x88e6 */
    KANJI,        /* 0x88e7 */
    KANJI,        /* 0x88e8 */
    KANJI,        /* 0x88e9 */
    KANJI,        /* 0x88ea */
    KANJI,        /* 0x88eb */
    KANJI,        /* 0x88ec */
    KANJI,        /* 0x88ed */
    KANJI,        /* 0x88ee */
    KANJI,        /* 0x88ef */
    KANJI,        /* 0x88f0 */
    KANJI,        /* 0x88f1 */
    KANJI,        /* 0x88f2 */
    KANJI,        /* 0x88f3 */
    KANJI,        /* 0x88f4 */
    KANJI,        /* 0x88f5 */
    KANJI,        /* 0x88f6 */
    KANJI,        /* 0x88f7 */
    KANJI,        /* 0x88f8 */
    KANJI,        /* 0x88f9 */
    KANJI,        /* 0x88fa */
    KANJI,        /* 0x88fb */
    KANJI,        /* 0x88fc */
    KANJI,        /* 0x88fd */
    KANJI,        /* 0x88fe */
    KANJI,        /* 0x88ff */
    KANJI,        /* 0x8900 */
    KANJI,        /* 0x8901 */
    KANJI,        /* 0x8902 */
    KANJI,        /* 0x8903 */
    KANJI,        /* 0x8904 */
    KANJI,        /* 0x8905 */
    KANJI,        /* 0x8906 */
    KANJI,        /* 0x8907 */
    KANJI,        /* 0x8908 */
    KANJI,        /* 0x8909 */
    KANJI,        /* 0x890a */
    KANJI,        /* 0x890b */
    KANJI,        /* 0x890c */
    KANJI,        /* 0x890d */
    KANJI,        /* 0x890e */
    KANJI,        /* 0x890f */
    KANJI,        /* 0x8910 */
    KANJI,        /* 0x8911 */
    KANJI,        /* 0x8912 */
    KANJI,        /* 0x8913 */
    KANJI,        /* 0x8914 */
    KANJI,        /* 0x8915 */
    KANJI,        /* 0x8916 */
    KANJI,        /* 0x8917 */
    KANJI,        /* 0x8918 */
    KANJI,        /* 0x8919 */
    KANJI,        /* 0x891a */
    KANJI,        /* 0x891b */
    KANJI,        /* 0x891c */
    KANJI,        /* 0x891d */
    KANJI,        /* 0x891e */
    KANJI,        /* 0x891f */
    KANJI,        /* 0x8920 */
    KANJI,        /* 0x8921 */
    KANJI,        /* 0x8922 */
    KANJI,        /* 0x8923 */
    KANJI,        /* 0x8924 */
    KANJI,        /* 0x8925 */
    KANJI,        /* 0x8926 */
    KANJI,        /* 0x8927 */
    KANJI,        /* 0x8928 */
    KANJI,        /* 0x8929 */
    KANJI,        /* 0x892a */
    KANJI,        /* 0x892b */
    KANJI,        /* 0x892c */
    KANJI,        /* 0x892d */
    KANJI,        /* 0x892e */
    KANJI,        /* 0x892f */
    KANJI,        /* 0x8930 */
    KANJI,        /* 0x8931 */
    KANJI,        /* 0x8932 */
    KANJI,        /* 0x8933 */
    KANJI,        /* 0x8934 */
    KANJI,        /* 0x8935 */
    KANJI,        /* 0x8936 */
    KANJI,        /* 0x8937 */
    KANJI,        /* 0x8938 */
    KANJI,        /* 0x8939 */
    KANJI,        /* 0x893a */
    KANJI,        /* 0x893b */
    KANJI,        /* 0x893c */
    KANJI,        /* 0x893d */
    KANJI,        /* 0x893e */
    KANJI,        /* 0x893f */
    KANJI,        /* 0x8940 */
    KANJI,        /* 0x8941 */
    KANJI,        /* 0x8942 */
    KANJI,        /* 0x8943 */
    KANJI,        /* 0x8944 */
    KANJI,        /* 0x8945 */
    KANJI,        /* 0x8946 */
    KANJI,        /* 0x8947 */
    KANJI,        /* 0x8948 */
    KANJI,        /* 0x8949 */
    KANJI,        /* 0x894a */
    KANJI,        /* 0x894b */
    KANJI,        /* 0x894c */
    KANJI,        /* 0x894d */
    KANJI,        /* 0x894e */
    KANJI,        /* 0x894f */
    KANJI,        /* 0x8950 */
    KANJI,        /* 0x8951 */
    KANJI,        /* 0x8952 */
    KANJI,        /* 0x8953 */
    KANJI,        /* 0x8954 */
    KANJI,        /* 0x8955 */
    KANJI,        /* 0x8956 */
    KANJI,        /* 0x8957 */
    KANJI,        /* 0x8958 */
    KANJI,        /* 0x8959 */
    KANJI,        /* 0x895a */
    KANJI,        /* 0x895b */
    KANJI,        /* 0x895c */
    KANJI,        /* 0x895d */
    KANJI,        /* 0x895e */
    KANJI,        /* 0x895f */
    KANJI,        /* 0x8960 */
    KANJI,        /* 0x8961 */
    KANJI,        /* 0x8962 */
    KANJI,        /* 0x8963 */
    KANJI,        /* 0x8964 */
    KANJI,        /* 0x8965 */
    KANJI,        /* 0x8966 */
    KANJI,        /* 0x8967 */
    KANJI,        /* 0x8968 */
    KANJI,        /* 0x8969 */
    KANJI,        /* 0x896a */
    KANJI,        /* 0x896b */
    KANJI,        /* 0x896c */
    KANJI,        /* 0x896d */
    KANJI,        /* 0x896e */
    KANJI,        /* 0x896f */
    KANJI,        /* 0x8970 */
    KANJI,        /* 0x8971 */
    KANJI,        /* 0x8972 */
    KANJI,        /* 0x8973 */
    KANJI,        /* 0x8974 */
    KANJI,        /* 0x8975 */
    KANJI,        /* 0x8976 */
    KANJI,        /* 0x8977 */
    KANJI,        /* 0x8978 */
    KANJI,        /* 0x8979 */
    KANJI,        /* 0x897a */
    KANJI,        /* 0x897b */
    KANJI,        /* 0x897c */
    KANJI,        /* 0x897d */
    KANJI,        /* 0x897e */
    KANJI,        /* 0x897f */
    KANJI,        /* 0x8980 */
    KANJI,        /* 0x8981 */
    KANJI,        /* 0x8982 */
    KANJI,        /* 0x8983 */
    KANJI,        /* 0x8984 */
    KANJI,        /* 0x8985 */
    KANJI,        /* 0x8986 */
    KANJI,        /* 0x8987 */
    KANJI,        /* 0x8988 */
    KANJI,        /* 0x8989 */
    KANJI,        /* 0x898a */
    KANJI,        /* 0x898b */
    KANJI,        /* 0x898c */
    KANJI,        /* 0x898d */
    KANJI,        /* 0x898e */
    KANJI,        /* 0x898f */
    KANJI,        /* 0x8990 */
    KANJI,        /* 0x8991 */
    KANJI,        /* 0x8992 */
    KANJI,        /* 0x8993 */
    KANJI,        /* 0x8994 */
    KANJI,        /* 0x8995 */
    KANJI,        /* 0x8996 */
    KANJI,        /* 0x8997 */
    KANJI,        /* 0x8998 */
    KANJI,        /* 0x8999 */
    KANJI,        /* 0x899a */
    KANJI,        /* 0x899b */
    KANJI,        /* 0x899c */
    KANJI,        /* 0x899d */
    KANJI,        /* 0x899e */
    KANJI,        /* 0x899f */
    KANJI,        /* 0x89a0 */
    KANJI,        /* 0x89a1 */
    KANJI,        /* 0x89a2 */
    KANJI,        /* 0x89a3 */
    KANJI,        /* 0x89a4 */
    KANJI,        /* 0x89a5 */
    KANJI,        /* 0x89a6 */
    KANJI,        /* 0x89a7 */
    KANJI,        /* 0x89a8 */
    KANJI,        /* 0x89a9 */
    KANJI,        /* 0x89aa */
    KANJI,        /* 0x89ab */
    KANJI,        /* 0x89ac */
    KANJI,        /* 0x89ad */
    KANJI,        /* 0x89ae */
    KANJI,        /* 0x89af */
    KANJI,        /* 0x89b0 */
    KANJI,        /* 0x89b1 */
    KANJI,        /* 0x89b2 */
    KANJI,        /* 0x89b3 */
    KANJI,        /* 0x89b4 */
    KANJI,        /* 0x89b5 */
    KANJI,        /* 0x89b6 */
    KANJI,        /* 0x89b7 */
    KANJI,        /* 0x89b8 */
    KANJI,        /* 0x89b9 */
    KANJI,        /* 0x89ba */
    KANJI,        /* 0x89bb */
    KANJI,        /* 0x89bc */
    KANJI,        /* 0x89bd */
    KANJI,        /* 0x89be */
    KANJI,        /* 0x89bf */
    KANJI,        /* 0x89c0 */
    KANJI,        /* 0x89c1 */
    KANJI,        /* 0x89c2 */
    KANJI,        /* 0x89c3 */
    KANJI,        /* 0x89c4 */
    KANJI,        /* 0x89c5 */
    KANJI,        /* 0x89c6 */
    KANJI,        /* 0x89c7 */
    KANJI,        /* 0x89c8 */
    KANJI,        /* 0x89c9 */
    KANJI,        /* 0x89ca */
    KANJI,        /* 0x89cb */
    KANJI,        /* 0x89cc */
    KANJI,        /* 0x89cd */
    KANJI,        /* 0x89ce */
    KANJI,        /* 0x89cf */
    KANJI,        /* 0x89d0 */
    KANJI,        /* 0x89d1 */
    KANJI,        /* 0x89d2 */
    KANJI,        /* 0x89d3 */
    KANJI,        /* 0x89d4 */
    KANJI,        /* 0x89d5 */
    KANJI,        /* 0x89d6 */
    KANJI,        /* 0x89d7 */
    KANJI,        /* 0x89d8 */
    KANJI,        /* 0x89d9 */
    KANJI,        /* 0x89da */
    KANJI,        /* 0x89db */
    KANJI,        /* 0x89dc */
    KANJI,        /* 0x89dd */
    KANJI,        /* 0x89de */
    KANJI,        /* 0x89df */
    KANJI,        /* 0x89e0 */
    KANJI,        /* 0x89e1 */
    KANJI,        /* 0x89e2 */
    KANJI,        /* 0x89e3 */
    KANJI,        /* 0x89e4 */
    KANJI,        /* 0x89e5 */
    KANJI,        /* 0x89e6 */
    KANJI,        /* 0x89e7 */
    KANJI,        /* 0x89e8 */
    KANJI,        /* 0x89e9 */
    KANJI,        /* 0x89ea */
    KANJI,        /* 0x89eb */
    KANJI,        /* 0x89ec */
    KANJI,        /* 0x89ed */
    KANJI,        /* 0x89ee */
    KANJI,        /* 0x89ef */
    KANJI,        /* 0x89f0 */
    KANJI,        /* 0x89f1 */
    KANJI,        /* 0x89f2 */
    KANJI,        /* 0x89f3 */
    KANJI,        /* 0x89f4 */
    KANJI,        /* 0x89f5 */
    KANJI,        /* 0x89f6 */
    KANJI,        /* 0x89f7 */
    KANJI,        /* 0x89f8 */
    KANJI,        /* 0x89f9 */
    KANJI,        /* 0x89fa */
    KANJI,        /* 0x89fb */
    KANJI,        /* 0x89fc */
    KANJI,        /* 0x89fd */
    KANJI,        /* 0x89fe */
    KANJI,        /* 0x89ff */
    KANJI,        /* 0x8a00 */
    KANJI,        /* 0x8a01 */
    KANJI,        /* 0x8a02 */
    KANJI,        /* 0x8a03 */
    KANJI,        /* 0x8a04 */
    KANJI,        /* 0x8a05 */
    KANJI,        /* 0x8a06 */
    KANJI,        /* 0x8a07 */
    KANJI,        /* 0x8a08 */
    KANJI,        /* 0x8a09 */
    KANJI,        /* 0x8a0a */
    KANJI,        /* 0x8a0b */
    KANJI,        /* 0x8a0c */
    KANJI,        /* 0x8a0d */
    KANJI,        /* 0x8a0e */
    KANJI,        /* 0x8a0f */
    KANJI,        /* 0x8a10 */
    KANJI,        /* 0x8a11 */
    KANJI,        /* 0x8a12 */
    KANJI,        /* 0x8a13 */
    KANJI,        /* 0x8a14 */
    KANJI,        /* 0x8a15 */
    KANJI,        /* 0x8a16 */
    KANJI,        /* 0x8a17 */
    KANJI,        /* 0x8a18 */
    KANJI,        /* 0x8a19 */
    KANJI,        /* 0x8a1a */
    KANJI,        /* 0x8a1b */
    KANJI,        /* 0x8a1c */
    KANJI,        /* 0x8a1d */
    KANJI,        /* 0x8a1e */
    KANJI,        /* 0x8a1f */
    KANJI,        /* 0x8a20 */
    KANJI,        /* 0x8a21 */
    KANJI,        /* 0x8a22 */
    KANJI,        /* 0x8a23 */
    KANJI,        /* 0x8a24 */
    KANJI,        /* 0x8a25 */
    KANJI,        /* 0x8a26 */
    KANJI,        /* 0x8a27 */
    KANJI,        /* 0x8a28 */
    KANJI,        /* 0x8a29 */
    KANJI,        /* 0x8a2a */
    KANJI,        /* 0x8a2b */
    KANJI,        /* 0x8a2c */
    KANJI,        /* 0x8a2d */
    KANJI,        /* 0x8a2e */
    KANJI,        /* 0x8a2f */
    KANJI,        /* 0x8a30 */
    KANJI,        /* 0x8a31 */
    KANJI,        /* 0x8a32 */
    KANJI,        /* 0x8a33 */
    KANJI,        /* 0x8a34 */
    KANJI,        /* 0x8a35 */
    KANJI,        /* 0x8a36 */
    KANJI,        /* 0x8a37 */
    KANJI,        /* 0x8a38 */
    KANJI,        /* 0x8a39 */
    KANJI,        /* 0x8a3a */
    KANJI,        /* 0x8a3b */
    KANJI,        /* 0x8a3c */
    KANJI,        /* 0x8a3d */
    KANJI,        /* 0x8a3e */
    KANJI,        /* 0x8a3f */
    KANJI,        /* 0x8a40 */
    KANJI,        /* 0x8a41 */
    KANJI,        /* 0x8a42 */
    KANJI,        /* 0x8a43 */
    KANJI,        /* 0x8a44 */
    KANJI,        /* 0x8a45 */
    KANJI,        /* 0x8a46 */
    KANJI,        /* 0x8a47 */
    KANJI,        /* 0x8a48 */
    KANJI,        /* 0x8a49 */
    KANJI,        /* 0x8a4a */
    KANJI,        /* 0x8a4b */
    KANJI,        /* 0x8a4c */
    KANJI,        /* 0x8a4d */
    KANJI,        /* 0x8a4e */
    KANJI,        /* 0x8a4f */
    KANJI,        /* 0x8a50 */
    KANJI,        /* 0x8a51 */
    KANJI,        /* 0x8a52 */
    KANJI,        /* 0x8a53 */
    KANJI,        /* 0x8a54 */
    KANJI,        /* 0x8a55 */
    KANJI,        /* 0x8a56 */
    KANJI,        /* 0x8a57 */
    KANJI,        /* 0x8a58 */
    KANJI,        /* 0x8a59 */
    KANJI,        /* 0x8a5a */
    KANJI,        /* 0x8a5b */
    KANJI,        /* 0x8a5c */
    KANJI,        /* 0x8a5d */
    KANJI,        /* 0x8a5e */
    KANJI,        /* 0x8a5f */
    KANJI,        /* 0x8a60 */
    KANJI,        /* 0x8a61 */
    KANJI,        /* 0x8a62 */
    KANJI,        /* 0x8a63 */
    KANJI,        /* 0x8a64 */
    KANJI,        /* 0x8a65 */
    KANJI,        /* 0x8a66 */
    KANJI,        /* 0x8a67 */
    KANJI,        /* 0x8a68 */
    KANJI,        /* 0x8a69 */
    KANJI,        /* 0x8a6a */
    KANJI,        /* 0x8a6b */
    KANJI,        /* 0x8a6c */
    KANJI,        /* 0x8a6d */
    KANJI,        /* 0x8a6e */
    KANJI,        /* 0x8a6f */
    KANJI,        /* 0x8a70 */
    KANJI,        /* 0x8a71 */
    KANJI,        /* 0x8a72 */
    KANJI,        /* 0x8a73 */
    KANJI,        /* 0x8a74 */
    KANJI,        /* 0x8a75 */
    KANJI,        /* 0x8a76 */
    KANJI,        /* 0x8a77 */
    KANJI,        /* 0x8a78 */
    KANJI,        /* 0x8a79 */
    KANJI,        /* 0x8a7a */
    KANJI,        /* 0x8a7b */
    KANJI,        /* 0x8a7c */
    KANJI,        /* 0x8a7d */
    KANJI,        /* 0x8a7e */
    KANJI,        /* 0x8a7f */
    KANJI,        /* 0x8a80 */
    KANJI,        /* 0x8a81 */
    KANJI,        /* 0x8a82 */
    KANJI,        /* 0x8a83 */
    KANJI,        /* 0x8a84 */
    KANJI,        /* 0x8a85 */
    KANJI,        /* 0x8a86 */
    KANJI,        /* 0x8a87 */
    KANJI,        /* 0x8a88 */
    KANJI,        /* 0x8a89 */
    KANJI,        /* 0x8a8a */
    KANJI,        /* 0x8a8b */
    KANJI,        /* 0x8a8c */
    KANJI,        /* 0x8a8d */
    KANJI,        /* 0x8a8e */
    KANJI,        /* 0x8a8f */
    KANJI,        /* 0x8a90 */
    KANJI,        /* 0x8a91 */
    KANJI,        /* 0x8a92 */
    KANJI,        /* 0x8a93 */
    KANJI,        /* 0x8a94 */
    KANJI,        /* 0x8a95 */
    KANJI,        /* 0x8a96 */
    KANJI,        /* 0x8a97 */
    KANJI,        /* 0x8a98 */
    KANJI,        /* 0x8a99 */
    KANJI,        /* 0x8a9a */
    KANJI,        /* 0x8a9b */
    KANJI,        /* 0x8a9c */
    KANJI,        /* 0x8a9d */
    KANJI,        /* 0x8a9e */
    KANJI,        /* 0x8a9f */
    KANJI,        /* 0x8aa0 */
    KANJI,        /* 0x8aa1 */
    KANJI,        /* 0x8aa2 */
    KANJI,        /* 0x8aa3 */
    KANJI,        /* 0x8aa4 */
    KANJI,        /* 0x8aa5 */
    KANJI,        /* 0x8aa6 */
    KANJI,        /* 0x8aa7 */
    KANJI,        /* 0x8aa8 */
    KANJI,        /* 0x8aa9 */
    KANJI,        /* 0x8aaa */
    KANJI,        /* 0x8aab */
    KANJI,        /* 0x8aac */
    KANJI,        /* 0x8aad */
    KANJI,        /* 0x8aae */
    KANJI,        /* 0x8aaf */
    KANJI,        /* 0x8ab0 */
    KANJI,        /* 0x8ab1 */
    KANJI,        /* 0x8ab2 */
    KANJI,        /* 0x8ab3 */
    KANJI,        /* 0x8ab4 */
    KANJI,        /* 0x8ab5 */
    KANJI,        /* 0x8ab6 */
    KANJI,        /* 0x8ab7 */
    KANJI,        /* 0x8ab8 */
    KANJI,        /* 0x8ab9 */
    KANJI,        /* 0x8aba */
    KANJI,        /* 0x8abb */
    KANJI,        /* 0x8abc */
    KANJI,        /* 0x8abd */
    KANJI,        /* 0x8abe */
    KANJI,        /* 0x8abf */
    KANJI,        /* 0x8ac0 */
    KANJI,        /* 0x8ac1 */
    KANJI,        /* 0x8ac2 */
    KANJI,        /* 0x8ac3 */
    KANJI,        /* 0x8ac4 */
    KANJI,        /* 0x8ac5 */
    KANJI,        /* 0x8ac6 */
    KANJI,        /* 0x8ac7 */
    KANJI,        /* 0x8ac8 */
    KANJI,        /* 0x8ac9 */
    KANJI,        /* 0x8aca */
    KANJI,        /* 0x8acb */
    KANJI,        /* 0x8acc */
    KANJI,        /* 0x8acd */
    KANJI,        /* 0x8ace */
    KANJI,        /* 0x8acf */
    KANJI,        /* 0x8ad0 */
    KANJI,        /* 0x8ad1 */
    KANJI,        /* 0x8ad2 */
    KANJI,        /* 0x8ad3 */
    KANJI,        /* 0x8ad4 */
    KANJI,        /* 0x8ad5 */
    KANJI,        /* 0x8ad6 */
    KANJI,        /* 0x8ad7 */
    KANJI,        /* 0x8ad8 */
    KANJI,        /* 0x8ad9 */
    KANJI,        /* 0x8ada */
    KANJI,        /* 0x8adb */
    KANJI,        /* 0x8adc */
    KANJI,        /* 0x8add */
    KANJI,        /* 0x8ade */
    KANJI,        /* 0x8adf */
    KANJI,        /* 0x8ae0 */
    KANJI,        /* 0x8ae1 */
    KANJI,        /* 0x8ae2 */
    KANJI,        /* 0x8ae3 */
    KANJI,        /* 0x8ae4 */
    KANJI,        /* 0x8ae5 */
    KANJI,        /* 0x8ae6 */
    KANJI,        /* 0x8ae7 */
    KANJI,        /* 0x8ae8 */
    KANJI,        /* 0x8ae9 */
    KANJI,        /* 0x8aea */
    KANJI,        /* 0x8aeb */
    KANJI,        /* 0x8aec */
    KANJI,        /* 0x8aed */
    KANJI,        /* 0x8aee */
    KANJI,        /* 0x8aef */
    KANJI,        /* 0x8af0 */
    KANJI,        /* 0x8af1 */
    KANJI,        /* 0x8af2 */
    KANJI,        /* 0x8af3 */
    KANJI,        /* 0x8af4 */
    KANJI,        /* 0x8af5 */
    KANJI,        /* 0x8af6 */
    KANJI,        /* 0x8af7 */
    KANJI,        /* 0x8af8 */
    KANJI,        /* 0x8af9 */
    KANJI,        /* 0x8afa */
    KANJI,        /* 0x8afb */
    KANJI,        /* 0x8afc */
    KANJI,        /* 0x8afd */
    KANJI,        /* 0x8afe */
    KANJI,        /* 0x8aff */
    KANJI,        /* 0x8b00 */
    KANJI,        /* 0x8b01 */
    KANJI,        /* 0x8b02 */
    KANJI,        /* 0x8b03 */
    KANJI,        /* 0x8b04 */
    KANJI,        /* 0x8b05 */
    KANJI,        /* 0x8b06 */
    KANJI,        /* 0x8b07 */
    KANJI,        /* 0x8b08 */
    KANJI,        /* 0x8b09 */
    KANJI,        /* 0x8b0a */
    KANJI,        /* 0x8b0b */
    KANJI,        /* 0x8b0c */
    KANJI,        /* 0x8b0d */
    KANJI,        /* 0x8b0e */
    KANJI,        /* 0x8b0f */
    KANJI,        /* 0x8b10 */
    KANJI,        /* 0x8b11 */
    KANJI,        /* 0x8b12 */
    KANJI,        /* 0x8b13 */
    KANJI,        /* 0x8b14 */
    KANJI,        /* 0x8b15 */
    KANJI,        /* 0x8b16 */
    KANJI,        /* 0x8b17 */
    KANJI,        /* 0x8b18 */
    KANJI,        /* 0x8b19 */
    KANJI,        /* 0x8b1a */
    KANJI,        /* 0x8b1b */
    KANJI,        /* 0x8b1c */
    KANJI,        /* 0x8b1d */
    KANJI,        /* 0x8b1e */
    KANJI,        /* 0x8b1f */
    KANJI,        /* 0x8b20 */
    KANJI,        /* 0x8b21 */
    KANJI,        /* 0x8b22 */
    KANJI,        /* 0x8b23 */
    KANJI,        /* 0x8b24 */
    KANJI,        /* 0x8b25 */
    KANJI,        /* 0x8b26 */
    KANJI,        /* 0x8b27 */
    KANJI,        /* 0x8b28 */
    KANJI,        /* 0x8b29 */
    KANJI,        /* 0x8b2a */
    KANJI,        /* 0x8b2b */
    KANJI,        /* 0x8b2c */
    KANJI,        /* 0x8b2d */
    KANJI,        /* 0x8b2e */
    KANJI,        /* 0x8b2f */
    KANJI,        /* 0x8b30 */
    KANJI,        /* 0x8b31 */
    KANJI,        /* 0x8b32 */
    KANJI,        /* 0x8b33 */
    KANJI,        /* 0x8b34 */
    KANJI,        /* 0x8b35 */
    KANJI,        /* 0x8b36 */
    KANJI,        /* 0x8b37 */
    KANJI,        /* 0x8b38 */
    KANJI,        /* 0x8b39 */
    KANJI,        /* 0x8b3a */
    KANJI,        /* 0x8b3b */
    KANJI,        /* 0x8b3c */
    KANJI,        /* 0x8b3d */
    KANJI,        /* 0x8b3e */
    KANJI,        /* 0x8b3f */
    KANJI,        /* 0x8b40 */
    KANJI,        /* 0x8b41 */
    KANJI,        /* 0x8b42 */
    KANJI,        /* 0x8b43 */
    KANJI,        /* 0x8b44 */
    KANJI,        /* 0x8b45 */
    KANJI,        /* 0x8b46 */
    KANJI,        /* 0x8b47 */
    KANJI,        /* 0x8b48 */
    KANJI,        /* 0x8b49 */
    KANJI,        /* 0x8b4a */
    KANJI,        /* 0x8b4b */
    KANJI,        /* 0x8b4c */
    KANJI,        /* 0x8b4d */
    KANJI,        /* 0x8b4e */
    KANJI,        /* 0x8b4f */
    KANJI,        /* 0x8b50 */
    KANJI,        /* 0x8b51 */
    KANJI,        /* 0x8b52 */
    KANJI,        /* 0x8b53 */
    KANJI,        /* 0x8b54 */
    KANJI,        /* 0x8b55 */
    KANJI,        /* 0x8b56 */
    KANJI,        /* 0x8b57 */
    KANJI,        /* 0x8b58 */
    KANJI,        /* 0x8b59 */
    KANJI,        /* 0x8b5a */
    KANJI,        /* 0x8b5b */
    KANJI,        /* 0x8b5c */
    KANJI,        /* 0x8b5d */
    KANJI,        /* 0x8b5e */
    KANJI,        /* 0x8b5f */
    KANJI,        /* 0x8b60 */
    KANJI,        /* 0x8b61 */
    KANJI,        /* 0x8b62 */
    KANJI,        /* 0x8b63 */
    KANJI,        /* 0x8b64 */
    KANJI,        /* 0x8b65 */
    KANJI,        /* 0x8b66 */
    KANJI,        /* 0x8b67 */
    KANJI,        /* 0x8b68 */
    KANJI,        /* 0x8b69 */
    KANJI,        /* 0x8b6a */
    KANJI,        /* 0x8b6b */
    KANJI,        /* 0x8b6c */
    KANJI,        /* 0x8b6d */
    KANJI,        /* 0x8b6e */
    KANJI,        /* 0x8b6f */
    KANJI,        /* 0x8b70 */
    KANJI,        /* 0x8b71 */
    KANJI,        /* 0x8b72 */
    KANJI,        /* 0x8b73 */
    KANJI,        /* 0x8b74 */
    KANJI,        /* 0x8b75 */
    KANJI,        /* 0x8b76 */
    KANJI,        /* 0x8b77 */
    KANJI,        /* 0x8b78 */
    KANJI,        /* 0x8b79 */
    KANJI,        /* 0x8b7a */
    KANJI,        /* 0x8b7b */
    KANJI,        /* 0x8b7c */
    KANJI,        /* 0x8b7d */
    KANJI,        /* 0x8b7e */
    KANJI,        /* 0x8b7f */
    KANJI,        /* 0x8b80 */
    KANJI,        /* 0x8b81 */
    KANJI,        /* 0x8b82 */
    KANJI,        /* 0x8b83 */
    KANJI,        /* 0x8b84 */
    KANJI,        /* 0x8b85 */
    KANJI,        /* 0x8b86 */
    KANJI,        /* 0x8b87 */
    KANJI,        /* 0x8b88 */
    KANJI,        /* 0x8b89 */
    KANJI,        /* 0x8b8a */
    KANJI,        /* 0x8b8b */
    KANJI,        /* 0x8b8c */
    KANJI,        /* 0x8b8d */
    KANJI,        /* 0x8b8e */
    KANJI,        /* 0x8b8f */
    KANJI,        /* 0x8b90 */
    KANJI,        /* 0x8b91 */
    KANJI,        /* 0x8b92 */
    KANJI,        /* 0x8b93 */
    KANJI,        /* 0x8b94 */
    KANJI,        /* 0x8b95 */
    KANJI,        /* 0x8b96 */
    KANJI,        /* 0x8b97 */
    KANJI,        /* 0x8b98 */
    KANJI,        /* 0x8b99 */
    KANJI,        /* 0x8b9a */
    KANJI,        /* 0x8b9b */
    KANJI,        /* 0x8b9c */
    KANJI,        /* 0x8b9d */
    KANJI,        /* 0x8b9e */
    KANJI,        /* 0x8b9f */
    KANJI,        /* 0x8ba0 */
    KANJI,        /* 0x8ba1 */
    KANJI,        /* 0x8ba2 */
    KANJI,        /* 0x8ba3 */
    KANJI,        /* 0x8ba4 */
    KANJI,        /* 0x8ba5 */
    KANJI,        /* 0x8ba6 */
    KANJI,        /* 0x8ba7 */
    KANJI,        /* 0x8ba8 */
    KANJI,        /* 0x8ba9 */
    KANJI,        /* 0x8baa */
    KANJI,        /* 0x8bab */
    KANJI,        /* 0x8bac */
    KANJI,        /* 0x8bad */
    KANJI,        /* 0x8bae */
    KANJI,        /* 0x8baf */
    KANJI,        /* 0x8bb0 */
    KANJI,        /* 0x8bb1 */
    KANJI,        /* 0x8bb2 */
    KANJI,        /* 0x8bb3 */
    KANJI,        /* 0x8bb4 */
    KANJI,        /* 0x8bb5 */
    KANJI,        /* 0x8bb6 */
    KANJI,        /* 0x8bb7 */
    KANJI,        /* 0x8bb8 */
    KANJI,        /* 0x8bb9 */
    KANJI,        /* 0x8bba */
    KANJI,        /* 0x8bbb */
    KANJI,        /* 0x8bbc */
    KANJI,        /* 0x8bbd */
    KANJI,        /* 0x8bbe */
    KANJI,        /* 0x8bbf */
    KANJI,        /* 0x8bc0 */
    KANJI,        /* 0x8bc1 */
    KANJI,        /* 0x8bc2 */
    KANJI,        /* 0x8bc3 */
    KANJI,        /* 0x8bc4 */
    KANJI,        /* 0x8bc5 */
    KANJI,        /* 0x8bc6 */
    KANJI,        /* 0x8bc7 */
    KANJI,        /* 0x8bc8 */
    KANJI,        /* 0x8bc9 */
    KANJI,        /* 0x8bca */
    KANJI,        /* 0x8bcb */
    KANJI,        /* 0x8bcc */
    KANJI,        /* 0x8bcd */
    KANJI,        /* 0x8bce */
    KANJI,        /* 0x8bcf */
    KANJI,        /* 0x8bd0 */
    KANJI,        /* 0x8bd1 */
    KANJI,        /* 0x8bd2 */
    KANJI,        /* 0x8bd3 */
    KANJI,        /* 0x8bd4 */
    KANJI,        /* 0x8bd5 */
    KANJI,        /* 0x8bd6 */
    KANJI,        /* 0x8bd7 */
    KANJI,        /* 0x8bd8 */
    KANJI,        /* 0x8bd9 */
    KANJI,        /* 0x8bda */
    KANJI,        /* 0x8bdb */
    KANJI,        /* 0x8bdc */
    KANJI,        /* 0x8bdd */
    KANJI,        /* 0x8bde */
    KANJI,        /* 0x8bdf */
    KANJI,        /* 0x8be0 */
    KANJI,        /* 0x8be1 */
    KANJI,        /* 0x8be2 */
    KANJI,        /* 0x8be3 */
    KANJI,        /* 0x8be4 */
    KANJI,        /* 0x8be5 */
    KANJI,        /* 0x8be6 */
    KANJI,        /* 0x8be7 */
    KANJI,        /* 0x8be8 */
    KANJI,        /* 0x8be9 */
    KANJI,        /* 0x8bea */
    KANJI,        /* 0x8beb */
    KANJI,        /* 0x8bec */
    KANJI,        /* 0x8bed */
    KANJI,        /* 0x8bee */
    KANJI,        /* 0x8bef */
    KANJI,        /* 0x8bf0 */
    KANJI,        /* 0x8bf1 */
    KANJI,        /* 0x8bf2 */
    KANJI,        /* 0x8bf3 */
    KANJI,        /* 0x8bf4 */
    KANJI,        /* 0x8bf5 */
    KANJI,        /* 0x8bf6 */
    KANJI,        /* 0x8bf7 */
    KANJI,        /* 0x8bf8 */
    KANJI,        /* 0x8bf9 */
    KANJI,        /* 0x8bfa */
    KANJI,        /* 0x8bfb */
    KANJI,        /* 0x8bfc */
    KANJI,        /* 0x8bfd */
    KANJI,        /* 0x8bfe */
    KANJI,        /* 0x8bff */
    KANJI,        /* 0x8c00 */
    KANJI,        /* 0x8c01 */
    KANJI,        /* 0x8c02 */
    KANJI,        /* 0x8c03 */
    KANJI,        /* 0x8c04 */
    KANJI,        /* 0x8c05 */
    KANJI,        /* 0x8c06 */
    KANJI,        /* 0x8c07 */
    KANJI,        /* 0x8c08 */
    KANJI,        /* 0x8c09 */
    KANJI,        /* 0x8c0a */
    KANJI,        /* 0x8c0b */
    KANJI,        /* 0x8c0c */
    KANJI,        /* 0x8c0d */
    KANJI,        /* 0x8c0e */
    KANJI,        /* 0x8c0f */
    KANJI,        /* 0x8c10 */
    KANJI,        /* 0x8c11 */
    KANJI,        /* 0x8c12 */
    KANJI,        /* 0x8c13 */
    KANJI,        /* 0x8c14 */
    KANJI,        /* 0x8c15 */
    KANJI,        /* 0x8c16 */
    KANJI,        /* 0x8c17 */
    KANJI,        /* 0x8c18 */
    KANJI,        /* 0x8c19 */
    KANJI,        /* 0x8c1a */
    KANJI,        /* 0x8c1b */
    KANJI,        /* 0x8c1c */
    KANJI,        /* 0x8c1d */
    KANJI,        /* 0x8c1e */
    KANJI,        /* 0x8c1f */
    KANJI,        /* 0x8c20 */
    KANJI,        /* 0x8c21 */
    KANJI,        /* 0x8c22 */
    KANJI,        /* 0x8c23 */
    KANJI,        /* 0x8c24 */
    KANJI,        /* 0x8c25 */
    KANJI,        /* 0x8c26 */
    KANJI,        /* 0x8c27 */
    KANJI,        /* 0x8c28 */
    KANJI,        /* 0x8c29 */
    KANJI,        /* 0x8c2a */
    KANJI,        /* 0x8c2b */
    KANJI,        /* 0x8c2c */
    KANJI,        /* 0x8c2d */
    KANJI,        /* 0x8c2e */
    KANJI,        /* 0x8c2f */
    KANJI,        /* 0x8c30 */
    KANJI,        /* 0x8c31 */
    KANJI,        /* 0x8c32 */
    KANJI,        /* 0x8c33 */
    KANJI,        /* 0x8c34 */
    KANJI,        /* 0x8c35 */
    KANJI,        /* 0x8c36 */
    KANJI,        /* 0x8c37 */
    KANJI,        /* 0x8c38 */
    KANJI,        /* 0x8c39 */
    KANJI,        /* 0x8c3a */
    KANJI,        /* 0x8c3b */
    KANJI,        /* 0x8c3c */
    KANJI,        /* 0x8c3d */
    KANJI,        /* 0x8c3e */
    KANJI,        /* 0x8c3f */
    KANJI,        /* 0x8c40 */
    KANJI,        /* 0x8c41 */
    KANJI,        /* 0x8c42 */
    KANJI,        /* 0x8c43 */
    KANJI,        /* 0x8c44 */
    KANJI,        /* 0x8c45 */
    KANJI,        /* 0x8c46 */
    KANJI,        /* 0x8c47 */
    KANJI,        /* 0x8c48 */
    KANJI,        /* 0x8c49 */
    KANJI,        /* 0x8c4a */
    KANJI,        /* 0x8c4b */
    KANJI,        /* 0x8c4c */
    KANJI,        /* 0x8c4d */
    KANJI,        /* 0x8c4e */
    KANJI,        /* 0x8c4f */
    KANJI,        /* 0x8c50 */
    KANJI,        /* 0x8c51 */
    KANJI,        /* 0x8c52 */
    KANJI,        /* 0x8c53 */
    KANJI,        /* 0x8c54 */
    KANJI,        /* 0x8c55 */
    KANJI,        /* 0x8c56 */
    KANJI,        /* 0x8c57 */
    KANJI,        /* 0x8c58 */
    KANJI,        /* 0x8c59 */
    KANJI,        /* 0x8c5a */
    KANJI,        /* 0x8c5b */
    KANJI,        /* 0x8c5c */
    KANJI,        /* 0x8c5d */
    KANJI,        /* 0x8c5e */
    KANJI,        /* 0x8c5f */
    KANJI,        /* 0x8c60 */
    KANJI,        /* 0x8c61 */
    KANJI,        /* 0x8c62 */
    KANJI,        /* 0x8c63 */
    KANJI,        /* 0x8c64 */
    KANJI,        /* 0x8c65 */
    KANJI,        /* 0x8c66 */
    KANJI,        /* 0x8c67 */
    KANJI,        /* 0x8c68 */
    KANJI,        /* 0x8c69 */
    KANJI,        /* 0x8c6a */
    KANJI,        /* 0x8c6b */
    KANJI,        /* 0x8c6c */
    KANJI,        /* 0x8c6d */
    KANJI,        /* 0x8c6e */
    KANJI,        /* 0x8c6f */
    KANJI,        /* 0x8c70 */
    KANJI,        /* 0x8c71 */
    KANJI,        /* 0x8c72 */
    KANJI,        /* 0x8c73 */
    KANJI,        /* 0x8c74 */
    KANJI,        /* 0x8c75 */
    KANJI,        /* 0x8c76 */
    KANJI,        /* 0x8c77 */
    KANJI,        /* 0x8c78 */
    KANJI,        /* 0x8c79 */
    KANJI,        /* 0x8c7a */
    KANJI,        /* 0x8c7b */
    KANJI,        /* 0x8c7c */
    KANJI,        /* 0x8c7d */
    KANJI,        /* 0x8c7e */
    KANJI,        /* 0x8c7f */
    KANJI,        /* 0x8c80 */
    KANJI,        /* 0x8c81 */
    KANJI,        /* 0x8c82 */
    KANJI,        /* 0x8c83 */
    KANJI,        /* 0x8c84 */
    KANJI,        /* 0x8c85 */
    KANJI,        /* 0x8c86 */
    KANJI,        /* 0x8c87 */
    KANJI,        /* 0x8c88 */
    KANJI,        /* 0x8c89 */
    KANJI,        /* 0x8c8a */
    KANJI,        /* 0x8c8b */
    KANJI,        /* 0x8c8c */
    KANJI,        /* 0x8c8d */
    KANJI,        /* 0x8c8e */
    KANJI,        /* 0x8c8f */
    KANJI,        /* 0x8c90 */
    KANJI,        /* 0x8c91 */
    KANJI,        /* 0x8c92 */
    KANJI,        /* 0x8c93 */
    KANJI,        /* 0x8c94 */
    KANJI,        /* 0x8c95 */
    KANJI,        /* 0x8c96 */
    KANJI,        /* 0x8c97 */
    KANJI,        /* 0x8c98 */
    KANJI,        /* 0x8c99 */
    KANJI,        /* 0x8c9a */
    KANJI,        /* 0x8c9b */
    KANJI,        /* 0x8c9c */
    KANJI,        /* 0x8c9d */
    KANJI,        /* 0x8c9e */
    KANJI,        /* 0x8c9f */
    KANJI,        /* 0x8ca0 */
    KANJI,        /* 0x8ca1 */
    KANJI,        /* 0x8ca2 */
    KANJI,        /* 0x8ca3 */
    KANJI,        /* 0x8ca4 */
    KANJI,        /* 0x8ca5 */
    KANJI,        /* 0x8ca6 */
    KANJI,        /* 0x8ca7 */
    KANJI,        /* 0x8ca8 */
    KANJI,        /* 0x8ca9 */
    KANJI,        /* 0x8caa */
    KANJI,        /* 0x8cab */
    KANJI,        /* 0x8cac */
    KANJI,        /* 0x8cad */
    KANJI,        /* 0x8cae */
    KANJI,        /* 0x8caf */
    KANJI,        /* 0x8cb0 */
    KANJI,        /* 0x8cb1 */
    KANJI,        /* 0x8cb2 */
    KANJI,        /* 0x8cb3 */
    KANJI,        /* 0x8cb4 */
    KANJI,        /* 0x8cb5 */
    KANJI,        /* 0x8cb6 */
    KANJI,        /* 0x8cb7 */
    KANJI,        /* 0x8cb8 */
    KANJI,        /* 0x8cb9 */
    KANJI,        /* 0x8cba */
    KANJI,        /* 0x8cbb */
    KANJI,        /* 0x8cbc */
    KANJI,        /* 0x8cbd */
    KANJI,        /* 0x8cbe */
    KANJI,        /* 0x8cbf */
    KANJI,        /* 0x8cc0 */
    KANJI,        /* 0x8cc1 */
    KANJI,        /* 0x8cc2 */
    KANJI,        /* 0x8cc3 */
    KANJI,        /* 0x8cc4 */
    KANJI,        /* 0x8cc5 */
    KANJI,        /* 0x8cc6 */
    KANJI,        /* 0x8cc7 */
    KANJI,        /* 0x8cc8 */
    KANJI,        /* 0x8cc9 */
    KANJI,        /* 0x8cca */
    KANJI,        /* 0x8ccb */
    KANJI,        /* 0x8ccc */
    KANJI,        /* 0x8ccd */
    KANJI,        /* 0x8cce */
    KANJI,        /* 0x8ccf */
    KANJI,        /* 0x8cd0 */
    KANJI,        /* 0x8cd1 */
    KANJI,        /* 0x8cd2 */
    KANJI,        /* 0x8cd3 */
    KANJI,        /* 0x8cd4 */
    KANJI,        /* 0x8cd5 */
    KANJI,        /* 0x8cd6 */
    KANJI,        /* 0x8cd7 */
    KANJI,        /* 0x8cd8 */
    KANJI,        /* 0x8cd9 */
    KANJI,        /* 0x8cda */
    KANJI,        /* 0x8cdb */
    KANJI,        /* 0x8cdc */
    KANJI,        /* 0x8cdd */
    KANJI,        /* 0x8cde */
    KANJI,        /* 0x8cdf */
    KANJI,        /* 0x8ce0 */
    KANJI,        /* 0x8ce1 */
    KANJI,        /* 0x8ce2 */
    KANJI,        /* 0x8ce3 */
    KANJI,        /* 0x8ce4 */
    KANJI,        /* 0x8ce5 */
    KANJI,        /* 0x8ce6 */
    KANJI,        /* 0x8ce7 */
    KANJI,        /* 0x8ce8 */
    KANJI,        /* 0x8ce9 */
    KANJI,        /* 0x8cea */
    KANJI,        /* 0x8ceb */
    KANJI,        /* 0x8cec */
    KANJI,        /* 0x8ced */
    KANJI,        /* 0x8cee */
    KANJI,        /* 0x8cef */
    KANJI,        /* 0x8cf0 */
    KANJI,        /* 0x8cf1 */
    KANJI,        /* 0x8cf2 */
    KANJI,        /* 0x8cf3 */
    KANJI,        /* 0x8cf4 */
    KANJI,        /* 0x8cf5 */
    KANJI,        /* 0x8cf6 */
    KANJI,        /* 0x8cf7 */
    KANJI,        /* 0x8cf8 */
    KANJI,        /* 0x8cf9 */
    KANJI,        /* 0x8cfa */
    KANJI,        /* 0x8cfb */
    KANJI,        /* 0x8cfc */
    KANJI,        /* 0x8cfd */
    KANJI,        /* 0x8cfe */
    KANJI,        /* 0x8cff */
    KANJI,        /* 0x8d00 */
    KANJI,        /* 0x8d01 */
    KANJI,        /* 0x8d02 */
    KANJI,        /* 0x8d03 */
    KANJI,        /* 0x8d04 */
    KANJI,        /* 0x8d05 */
    KANJI,        /* 0x8d06 */
    KANJI,        /* 0x8d07 */
    KANJI,        /* 0x8d08 */
    KANJI,        /* 0x8d09 */
    KANJI,        /* 0x8d0a */
    KANJI,        /* 0x8d0b */
    KANJI,        /* 0x8d0c */
    KANJI,        /* 0x8d0d */
    KANJI,        /* 0x8d0e */
    KANJI,        /* 0x8d0f */
    KANJI,        /* 0x8d10 */
    KANJI,        /* 0x8d11 */
    KANJI,        /* 0x8d12 */
    KANJI,        /* 0x8d13 */
    KANJI,        /* 0x8d14 */
    KANJI,        /* 0x8d15 */
    KANJI,        /* 0x8d16 */
    KANJI,        /* 0x8d17 */
    KANJI,        /* 0x8d18 */
    KANJI,        /* 0x8d19 */
    KANJI,        /* 0x8d1a */
    KANJI,        /* 0x8d1b */
    KANJI,        /* 0x8d1c */
    KANJI,        /* 0x8d1d */
    KANJI,        /* 0x8d1e */
    KANJI,        /* 0x8d1f */
    KANJI,        /* 0x8d20 */
    KANJI,        /* 0x8d21 */
    KANJI,        /* 0x8d22 */
    KANJI,        /* 0x8d23 */
    KANJI,        /* 0x8d24 */
    KANJI,        /* 0x8d25 */
    KANJI,        /* 0x8d26 */
    KANJI,        /* 0x8d27 */
    KANJI,        /* 0x8d28 */
    KANJI,        /* 0x8d29 */
    KANJI,        /* 0x8d2a */
    KANJI,        /* 0x8d2b */
    KANJI,        /* 0x8d2c */
    KANJI,        /* 0x8d2d */
    KANJI,        /* 0x8d2e */
    KANJI,        /* 0x8d2f */
    KANJI,        /* 0x8d30 */
    KANJI,        /* 0x8d31 */
    KANJI,        /* 0x8d32 */
    KANJI,        /* 0x8d33 */
    KANJI,        /* 0x8d34 */
    KANJI,        /* 0x8d35 */
    KANJI,        /* 0x8d36 */
    KANJI,        /* 0x8d37 */
    KANJI,        /* 0x8d38 */
    KANJI,        /* 0x8d39 */
    KANJI,        /* 0x8d3a */
    KANJI,        /* 0x8d3b */
    KANJI,        /* 0x8d3c */
    KANJI,        /* 0x8d3d */
    KANJI,        /* 0x8d3e */
    KANJI,        /* 0x8d3f */
    KANJI,        /* 0x8d40 */
    KANJI,        /* 0x8d41 */
    KANJI,        /* 0x8d42 */
    KANJI,        /* 0x8d43 */
    KANJI,        /* 0x8d44 */
    KANJI,        /* 0x8d45 */
    KANJI,        /* 0x8d46 */
    KANJI,        /* 0x8d47 */
    KANJI,        /* 0x8d48 */
    KANJI,        /* 0x8d49 */
    KANJI,        /* 0x8d4a */
    KANJI,        /* 0x8d4b */
    KANJI,        /* 0x8d4c */
    KANJI,        /* 0x8d4d */
    KANJI,        /* 0x8d4e */
    KANJI,        /* 0x8d4f */
    KANJI,        /* 0x8d50 */
    KANJI,        /* 0x8d51 */
    KANJI,        /* 0x8d52 */
    KANJI,        /* 0x8d53 */
    KANJI,        /* 0x8d54 */
    KANJI,        /* 0x8d55 */
    KANJI,        /* 0x8d56 */
    KANJI,        /* 0x8d57 */
    KANJI,        /* 0x8d58 */
    KANJI,        /* 0x8d59 */
    KANJI,        /* 0x8d5a */
    KANJI,        /* 0x8d5b */
    KANJI,        /* 0x8d5c */
    KANJI,        /* 0x8d5d */
    KANJI,        /* 0x8d5e */
    KANJI,        /* 0x8d5f */
    KANJI,        /* 0x8d60 */
    KANJI,        /* 0x8d61 */
    KANJI,        /* 0x8d62 */
    KANJI,        /* 0x8d63 */
    KANJI,        /* 0x8d64 */
    KANJI,        /* 0x8d65 */
    KANJI,        /* 0x8d66 */
    KANJI,        /* 0x8d67 */
    KANJI,        /* 0x8d68 */
    KANJI,        /* 0x8d69 */
    KANJI,        /* 0x8d6a */
    KANJI,        /* 0x8d6b */
    KANJI,        /* 0x8d6c */
    KANJI,        /* 0x8d6d */
    KANJI,        /* 0x8d6e */
    KANJI,        /* 0x8d6f */
    KANJI,        /* 0x8d70 */
    KANJI,        /* 0x8d71 */
    KANJI,        /* 0x8d72 */
    KANJI,        /* 0x8d73 */
    KANJI,        /* 0x8d74 */
    KANJI,        /* 0x8d75 */
    KANJI,        /* 0x8d76 */
    KANJI,        /* 0x8d77 */
    KANJI,        /* 0x8d78 */
    KANJI,        /* 0x8d79 */
    KANJI,        /* 0x8d7a */
    KANJI,        /* 0x8d7b */
    KANJI,        /* 0x8d7c */
    KANJI,        /* 0x8d7d */
    KANJI,        /* 0x8d7e */
    KANJI,        /* 0x8d7f */
    KANJI,        /* 0x8d80 */
    KANJI,        /* 0x8d81 */
    KANJI,        /* 0x8d82 */
    KANJI,        /* 0x8d83 */
    KANJI,        /* 0x8d84 */
    KANJI,        /* 0x8d85 */
    KANJI,        /* 0x8d86 */
    KANJI,        /* 0x8d87 */
    KANJI,        /* 0x8d88 */
    KANJI,        /* 0x8d89 */
    KANJI,        /* 0x8d8a */
    KANJI,        /* 0x8d8b */
    KANJI,        /* 0x8d8c */
    KANJI,        /* 0x8d8d */
    KANJI,        /* 0x8d8e */
    KANJI,        /* 0x8d8f */
    KANJI,        /* 0x8d90 */
    KANJI,        /* 0x8d91 */
    KANJI,        /* 0x8d92 */
    KANJI,        /* 0x8d93 */
    KANJI,        /* 0x8d94 */
    KANJI,        /* 0x8d95 */
    KANJI,        /* 0x8d96 */
    KANJI,        /* 0x8d97 */
    KANJI,        /* 0x8d98 */
    KANJI,        /* 0x8d99 */
    KANJI,        /* 0x8d9a */
    KANJI,        /* 0x8d9b */
    KANJI,        /* 0x8d9c */
    KANJI,        /* 0x8d9d */
    KANJI,        /* 0x8d9e */
    KANJI,        /* 0x8d9f */
    KANJI,        /* 0x8da0 */
    KANJI,        /* 0x8da1 */
    KANJI,        /* 0x8da2 */
    KANJI,        /* 0x8da3 */
    KANJI,        /* 0x8da4 */
    KANJI,        /* 0x8da5 */
    KANJI,        /* 0x8da6 */
    KANJI,        /* 0x8da7 */
    KANJI,        /* 0x8da8 */
    KANJI,        /* 0x8da9 */
    KANJI,        /* 0x8daa */
    KANJI,        /* 0x8dab */
    KANJI,        /* 0x8dac */
    KANJI,        /* 0x8dad */
    KANJI,        /* 0x8dae */
    KANJI,        /* 0x8daf */
    KANJI,        /* 0x8db0 */
    KANJI,        /* 0x8db1 */
    KANJI,        /* 0x8db2 */
    KANJI,        /* 0x8db3 */
    KANJI,        /* 0x8db4 */
    KANJI,        /* 0x8db5 */
    KANJI,        /* 0x8db6 */
    KANJI,        /* 0x8db7 */
    KANJI,        /* 0x8db8 */
    KANJI,        /* 0x8db9 */
    KANJI,        /* 0x8dba */
    KANJI,        /* 0x8dbb */
    KANJI,        /* 0x8dbc */
    KANJI,        /* 0x8dbd */
    KANJI,        /* 0x8dbe */
    KANJI,        /* 0x8dbf */
    KANJI,        /* 0x8dc0 */
    KANJI,        /* 0x8dc1 */
    KANJI,        /* 0x8dc2 */
    KANJI,        /* 0x8dc3 */
    KANJI,        /* 0x8dc4 */
    KANJI,        /* 0x8dc5 */
    KANJI,        /* 0x8dc6 */
    KANJI,        /* 0x8dc7 */
    KANJI,        /* 0x8dc8 */
    KANJI,        /* 0x8dc9 */
    KANJI,        /* 0x8dca */
    KANJI,        /* 0x8dcb */
    KANJI,        /* 0x8dcc */
    KANJI,        /* 0x8dcd */
    KANJI,        /* 0x8dce */
    KANJI,        /* 0x8dcf */
    KANJI,        /* 0x8dd0 */
    KANJI,        /* 0x8dd1 */
    KANJI,        /* 0x8dd2 */
    KANJI,        /* 0x8dd3 */
    KANJI,        /* 0x8dd4 */
    KANJI,        /* 0x8dd5 */
    KANJI,        /* 0x8dd6 */
    KANJI,        /* 0x8dd7 */
    KANJI,        /* 0x8dd8 */
    KANJI,        /* 0x8dd9 */
    KANJI,        /* 0x8dda */
    KANJI,        /* 0x8ddb */
    KANJI,        /* 0x8ddc */
    KANJI,        /* 0x8ddd */
    KANJI,        /* 0x8dde */
    KANJI,        /* 0x8ddf */
    KANJI,        /* 0x8de0 */
    KANJI,        /* 0x8de1 */
    KANJI,        /* 0x8de2 */
    KANJI,        /* 0x8de3 */
    KANJI,        /* 0x8de4 */
    KANJI,        /* 0x8de5 */
    KANJI,        /* 0x8de6 */
    KANJI,        /* 0x8de7 */
    KANJI,        /* 0x8de8 */
    KANJI,        /* 0x8de9 */
    KANJI,        /* 0x8dea */
    KANJI,        /* 0x8deb */
    KANJI,        /* 0x8dec */
    KANJI,        /* 0x8ded */
    KANJI,        /* 0x8dee */
    KANJI,        /* 0x8def */
    KANJI,        /* 0x8df0 */
    KANJI,        /* 0x8df1 */
    KANJI,        /* 0x8df2 */
    KANJI,        /* 0x8df3 */
    KANJI,        /* 0x8df4 */
    KANJI,        /* 0x8df5 */
    KANJI,        /* 0x8df6 */
    KANJI,        /* 0x8df7 */
    KANJI,        /* 0x8df8 */
    KANJI,        /* 0x8df9 */
    KANJI,        /* 0x8dfa */
    KANJI,        /* 0x8dfb */
    KANJI,        /* 0x8dfc */
    KANJI,        /* 0x8dfd */
    KANJI,        /* 0x8dfe */
    KANJI,        /* 0x8dff */
    KANJI,        /* 0x8e00 */
    KANJI,        /* 0x8e01 */
    KANJI,        /* 0x8e02 */
    KANJI,        /* 0x8e03 */
    KANJI,        /* 0x8e04 */
    KANJI,        /* 0x8e05 */
    KANJI,        /* 0x8e06 */
    KANJI,        /* 0x8e07 */
    KANJI,        /* 0x8e08 */
    KANJI,        /* 0x8e09 */
    KANJI,        /* 0x8e0a */
    KANJI,        /* 0x8e0b */
    KANJI,        /* 0x8e0c */
    KANJI,        /* 0x8e0d */
    KANJI,        /* 0x8e0e */
    KANJI,        /* 0x8e0f */
    KANJI,        /* 0x8e10 */
    KANJI,        /* 0x8e11 */
    KANJI,        /* 0x8e12 */
    KANJI,        /* 0x8e13 */
    KANJI,        /* 0x8e14 */
    KANJI,        /* 0x8e15 */
    KANJI,        /* 0x8e16 */
    KANJI,        /* 0x8e17 */
    KANJI,        /* 0x8e18 */
    KANJI,        /* 0x8e19 */
    KANJI,        /* 0x8e1a */
    KANJI,        /* 0x8e1b */
    KANJI,        /* 0x8e1c */
    KANJI,        /* 0x8e1d */
    KANJI,        /* 0x8e1e */
    KANJI,        /* 0x8e1f */
    KANJI,        /* 0x8e20 */
    KANJI,        /* 0x8e21 */
    KANJI,        /* 0x8e22 */
    KANJI,        /* 0x8e23 */
    KANJI,        /* 0x8e24 */
    KANJI,        /* 0x8e25 */
    KANJI,        /* 0x8e26 */
    KANJI,        /* 0x8e27 */
    KANJI,        /* 0x8e28 */
    KANJI,        /* 0x8e29 */
    KANJI,        /* 0x8e2a */
    KANJI,        /* 0x8e2b */
    KANJI,        /* 0x8e2c */
    KANJI,        /* 0x8e2d */
    KANJI,        /* 0x8e2e */
    KANJI,        /* 0x8e2f */
    KANJI,        /* 0x8e30 */
    KANJI,        /* 0x8e31 */
    KANJI,        /* 0x8e32 */
    KANJI,        /* 0x8e33 */
    KANJI,        /* 0x8e34 */
    KANJI,        /* 0x8e35 */
    KANJI,        /* 0x8e36 */
    KANJI,        /* 0x8e37 */
    KANJI,        /* 0x8e38 */
    KANJI,        /* 0x8e39 */
    KANJI,        /* 0x8e3a */
    KANJI,        /* 0x8e3b */
    KANJI,        /* 0x8e3c */
    KANJI,        /* 0x8e3d */
    KANJI,        /* 0x8e3e */
    KANJI,        /* 0x8e3f */
    KANJI,        /* 0x8e40 */
    KANJI,        /* 0x8e41 */
    KANJI,        /* 0x8e42 */
    KANJI,        /* 0x8e43 */
    KANJI,        /* 0x8e44 */
    KANJI,        /* 0x8e45 */
    KANJI,        /* 0x8e46 */
    KANJI,        /* 0x8e47 */
    KANJI,        /* 0x8e48 */
    KANJI,        /* 0x8e49 */
    KANJI,        /* 0x8e4a */
    KANJI,        /* 0x8e4b */
    KANJI,        /* 0x8e4c */
    KANJI,        /* 0x8e4d */
    KANJI,        /* 0x8e4e */
    KANJI,        /* 0x8e4f */
    KANJI,        /* 0x8e50 */
    KANJI,        /* 0x8e51 */
    KANJI,        /* 0x8e52 */
    KANJI,        /* 0x8e53 */
    KANJI,        /* 0x8e54 */
    KANJI,        /* 0x8e55 */
    KANJI,        /* 0x8e56 */
    KANJI,        /* 0x8e57 */
    KANJI,        /* 0x8e58 */
    KANJI,        /* 0x8e59 */
    KANJI,        /* 0x8e5a */
    KANJI,        /* 0x8e5b */
    KANJI,        /* 0x8e5c */
    KANJI,        /* 0x8e5d */
    KANJI,        /* 0x8e5e */
    KANJI,        /* 0x8e5f */
    KANJI,        /* 0x8e60 */
    KANJI,        /* 0x8e61 */
    KANJI,        /* 0x8e62 */
    KANJI,        /* 0x8e63 */
    KANJI,        /* 0x8e64 */
    KANJI,        /* 0x8e65 */
    KANJI,        /* 0x8e66 */
    KANJI,        /* 0x8e67 */
    KANJI,        /* 0x8e68 */
    KANJI,        /* 0x8e69 */
    KANJI,        /* 0x8e6a */
    KANJI,        /* 0x8e6b */
    KANJI,        /* 0x8e6c */
    KANJI,        /* 0x8e6d */
    KANJI,        /* 0x8e6e */
    KANJI,        /* 0x8e6f */
    KANJI,        /* 0x8e70 */
    KANJI,        /* 0x8e71 */
    KANJI,        /* 0x8e72 */
    KANJI,        /* 0x8e73 */
    KANJI,        /* 0x8e74 */
    KANJI,        /* 0x8e75 */
    KANJI,        /* 0x8e76 */
    KANJI,        /* 0x8e77 */
    KANJI,        /* 0x8e78 */
    KANJI,        /* 0x8e79 */
    KANJI,        /* 0x8e7a */
    KANJI,        /* 0x8e7b */
    KANJI,        /* 0x8e7c */
    KANJI,        /* 0x8e7d */
    KANJI,        /* 0x8e7e */
    KANJI,        /* 0x8e7f */
    KANJI,        /* 0x8e80 */
    KANJI,        /* 0x8e81 */
    KANJI,        /* 0x8e82 */
    KANJI,        /* 0x8e83 */
    KANJI,        /* 0x8e84 */
    KANJI,        /* 0x8e85 */
    KANJI,        /* 0x8e86 */
    KANJI,        /* 0x8e87 */
    KANJI,        /* 0x8e88 */
    KANJI,        /* 0x8e89 */
    KANJI,        /* 0x8e8a */
    KANJI,        /* 0x8e8b */
    KANJI,        /* 0x8e8c */
    KANJI,        /* 0x8e8d */
    KANJI,        /* 0x8e8e */
    KANJI,        /* 0x8e8f */
    KANJI,        /* 0x8e90 */
    KANJI,        /* 0x8e91 */
    KANJI,        /* 0x8e92 */
    KANJI,        /* 0x8e93 */
    KANJI,        /* 0x8e94 */
    KANJI,        /* 0x8e95 */
    KANJI,        /* 0x8e96 */
    KANJI,        /* 0x8e97 */
    KANJI,        /* 0x8e98 */
    KANJI,        /* 0x8e99 */
    KANJI,        /* 0x8e9a */
    KANJI,        /* 0x8e9b */
    KANJI,        /* 0x8e9c */
    KANJI,        /* 0x8e9d */
    KANJI,        /* 0x8e9e */
    KANJI,        /* 0x8e9f */
    KANJI,        /* 0x8ea0 */
    KANJI,        /* 0x8ea1 */
    KANJI,        /* 0x8ea2 */
    KANJI,        /* 0x8ea3 */
    KANJI,        /* 0x8ea4 */
    KANJI,        /* 0x8ea5 */
    KANJI,        /* 0x8ea6 */
    KANJI,        /* 0x8ea7 */
    KANJI,        /* 0x8ea8 */
    KANJI,        /* 0x8ea9 */
    KANJI,        /* 0x8eaa */
    KANJI,        /* 0x8eab */
    KANJI,        /* 0x8eac */
    KANJI,        /* 0x8ead */
    KANJI,        /* 0x8eae */
    KANJI,        /* 0x8eaf */
    KANJI,        /* 0x8eb0 */
    KANJI,        /* 0x8eb1 */
    KANJI,        /* 0x8eb2 */
    KANJI,        /* 0x8eb3 */
    KANJI,        /* 0x8eb4 */
    KANJI,        /* 0x8eb5 */
    KANJI,        /* 0x8eb6 */
    KANJI,        /* 0x8eb7 */
    KANJI,        /* 0x8eb8 */
    KANJI,        /* 0x8eb9 */
    KANJI,        /* 0x8eba */
    KANJI,        /* 0x8ebb */
    KANJI,        /* 0x8ebc */
    KANJI,        /* 0x8ebd */
    KANJI,        /* 0x8ebe */
    KANJI,        /* 0x8ebf */
    KANJI,        /* 0x8ec0 */
    KANJI,        /* 0x8ec1 */
    KANJI,        /* 0x8ec2 */
    KANJI,        /* 0x8ec3 */
    KANJI,        /* 0x8ec4 */
    KANJI,        /* 0x8ec5 */
    KANJI,        /* 0x8ec6 */
    KANJI,        /* 0x8ec7 */
    KANJI,        /* 0x8ec8 */
    KANJI,        /* 0x8ec9 */
    KANJI,        /* 0x8eca */
    KANJI,        /* 0x8ecb */
    KANJI,        /* 0x8ecc */
    KANJI,        /* 0x8ecd */
    KANJI,        /* 0x8ece */
    KANJI,        /* 0x8ecf */
    KANJI,        /* 0x8ed0 */
    KANJI,        /* 0x8ed1 */
    KANJI,        /* 0x8ed2 */
    KANJI,        /* 0x8ed3 */
    KANJI,        /* 0x8ed4 */
    KANJI,        /* 0x8ed5 */
    KANJI,        /* 0x8ed6 */
    KANJI,        /* 0x8ed7 */
    KANJI,        /* 0x8ed8 */
    KANJI,        /* 0x8ed9 */
    KANJI,        /* 0x8eda */
    KANJI,        /* 0x8edb */
    KANJI,        /* 0x8edc */
    KANJI,        /* 0x8edd */
    KANJI,        /* 0x8ede */
    KANJI,        /* 0x8edf */
    KANJI,        /* 0x8ee0 */
    KANJI,        /* 0x8ee1 */
    KANJI,        /* 0x8ee2 */
    KANJI,        /* 0x8ee3 */
    KANJI,        /* 0x8ee4 */
    KANJI,        /* 0x8ee5 */
    KANJI,        /* 0x8ee6 */
    KANJI,        /* 0x8ee7 */
    KANJI,        /* 0x8ee8 */
    KANJI,        /* 0x8ee9 */
    KANJI,        /* 0x8eea */
    KANJI,        /* 0x8eeb */
    KANJI,        /* 0x8eec */
    KANJI,        /* 0x8eed */
    KANJI,        /* 0x8eee */
    KANJI,        /* 0x8eef */
    KANJI,        /* 0x8ef0 */
    KANJI,        /* 0x8ef1 */
    KANJI,        /* 0x8ef2 */
    KANJI,        /* 0x8ef3 */
    KANJI,        /* 0x8ef4 */
    KANJI,        /* 0x8ef5 */
    KANJI,        /* 0x8ef6 */
    KANJI,        /* 0x8ef7 */
    KANJI,        /* 0x8ef8 */
    KANJI,        /* 0x8ef9 */
    KANJI,        /* 0x8efa */
    KANJI,        /* 0x8efb */
    KANJI,        /* 0x8efc */
    KANJI,        /* 0x8efd */
    KANJI,        /* 0x8efe */
    KANJI,        /* 0x8eff */
    KANJI,        /* 0x8f00 */
    KANJI,        /* 0x8f01 */
    KANJI,        /* 0x8f02 */
    KANJI,        /* 0x8f03 */
    KANJI,        /* 0x8f04 */
    KANJI,        /* 0x8f05 */
    KANJI,        /* 0x8f06 */
    KANJI,        /* 0x8f07 */
    KANJI,        /* 0x8f08 */
    KANJI,        /* 0x8f09 */
    KANJI,        /* 0x8f0a */
    KANJI,        /* 0x8f0b */
    KANJI,        /* 0x8f0c */
    KANJI,        /* 0x8f0d */
    KANJI,        /* 0x8f0e */
    KANJI,        /* 0x8f0f */
    KANJI,        /* 0x8f10 */
    KANJI,        /* 0x8f11 */
    KANJI,        /* 0x8f12 */
    KANJI,        /* 0x8f13 */
    KANJI,        /* 0x8f14 */
    KANJI,        /* 0x8f15 */
    KANJI,        /* 0x8f16 */
    KANJI,        /* 0x8f17 */
    KANJI,        /* 0x8f18 */
    KANJI,        /* 0x8f19 */
    KANJI,        /* 0x8f1a */
    KANJI,        /* 0x8f1b */
    KANJI,        /* 0x8f1c */
    KANJI,        /* 0x8f1d */
    KANJI,        /* 0x8f1e */
    KANJI,        /* 0x8f1f */
    KANJI,        /* 0x8f20 */
    KANJI,        /* 0x8f21 */
    KANJI,        /* 0x8f22 */
    KANJI,        /* 0x8f23 */
    KANJI,        /* 0x8f24 */
    KANJI,        /* 0x8f25 */
    KANJI,        /* 0x8f26 */
    KANJI,        /* 0x8f27 */
    KANJI,        /* 0x8f28 */
    KANJI,        /* 0x8f29 */
    KANJI,        /* 0x8f2a */
    KANJI,        /* 0x8f2b */
    KANJI,        /* 0x8f2c */
    KANJI,        /* 0x8f2d */
    KANJI,        /* 0x8f2e */
    KANJI,        /* 0x8f2f */
    KANJI,        /* 0x8f30 */
    KANJI,        /* 0x8f31 */
    KANJI,        /* 0x8f32 */
    KANJI,        /* 0x8f33 */
    KANJI,        /* 0x8f34 */
    KANJI,        /* 0x8f35 */
    KANJI,        /* 0x8f36 */
    KANJI,        /* 0x8f37 */
    KANJI,        /* 0x8f38 */
    KANJI,        /* 0x8f39 */
    KANJI,        /* 0x8f3a */
    KANJI,        /* 0x8f3b */
    KANJI,        /* 0x8f3c */
    KANJI,        /* 0x8f3d */
    KANJI,        /* 0x8f3e */
    KANJI,        /* 0x8f3f */
    KANJI,        /* 0x8f40 */
    KANJI,        /* 0x8f41 */
    KANJI,        /* 0x8f42 */
    KANJI,        /* 0x8f43 */
    KANJI,        /* 0x8f44 */
    KANJI,        /* 0x8f45 */
    KANJI,        /* 0x8f46 */
    KANJI,        /* 0x8f47 */
    KANJI,        /* 0x8f48 */
    KANJI,        /* 0x8f49 */
    KANJI,        /* 0x8f4a */
    KANJI,        /* 0x8f4b */
    KANJI,        /* 0x8f4c */
    KANJI,        /* 0x8f4d */
    KANJI,        /* 0x8f4e */
    KANJI,        /* 0x8f4f */
    KANJI,        /* 0x8f50 */
    KANJI,        /* 0x8f51 */
    KANJI,        /* 0x8f52 */
    KANJI,        /* 0x8f53 */
    KANJI,        /* 0x8f54 */
    KANJI,        /* 0x8f55 */
    KANJI,        /* 0x8f56 */
    KANJI,        /* 0x8f57 */
    KANJI,        /* 0x8f58 */
    KANJI,        /* 0x8f59 */
    KANJI,        /* 0x8f5a */
    KANJI,        /* 0x8f5b */
    KANJI,        /* 0x8f5c */
    KANJI,        /* 0x8f5d */
    KANJI,        /* 0x8f5e */
    KANJI,        /* 0x8f5f */
    KANJI,        /* 0x8f60 */
    KANJI,        /* 0x8f61 */
    KANJI,        /* 0x8f62 */
    KANJI,        /* 0x8f63 */
    KANJI,        /* 0x8f64 */
    KANJI,        /* 0x8f65 */
    KANJI,        /* 0x8f66 */
    KANJI,        /* 0x8f67 */
    KANJI,        /* 0x8f68 */
    KANJI,        /* 0x8f69 */
    KANJI,        /* 0x8f6a */
    KANJI,        /* 0x8f6b */
    KANJI,        /* 0x8f6c */
    KANJI,        /* 0x8f6d */
    KANJI,        /* 0x8f6e */
    KANJI,        /* 0x8f6f */
    KANJI,        /* 0x8f70 */
    KANJI,        /* 0x8f71 */
    KANJI,        /* 0x8f72 */
    KANJI,        /* 0x8f73 */
    KANJI,        /* 0x8f74 */
    KANJI,        /* 0x8f75 */
    KANJI,        /* 0x8f76 */
    KANJI,        /* 0x8f77 */
    KANJI,        /* 0x8f78 */
    KANJI,        /* 0x8f79 */
    KANJI,        /* 0x8f7a */
    KANJI,        /* 0x8f7b */
    KANJI,        /* 0x8f7c */
    KANJI,        /* 0x8f7d */
    KANJI,        /* 0x8f7e */
    KANJI,        /* 0x8f7f */
    KANJI,        /* 0x8f80 */
    KANJI,        /* 0x8f81 */
    KANJI,        /* 0x8f82 */
    KANJI,        /* 0x8f83 */
    KANJI,        /* 0x8f84 */
    KANJI,        /* 0x8f85 */
    KANJI,        /* 0x8f86 */
    KANJI,        /* 0x8f87 */
    KANJI,        /* 0x8f88 */
    KANJI,        /* 0x8f89 */
    KANJI,        /* 0x8f8a */
    KANJI,        /* 0x8f8b */
    KANJI,        /* 0x8f8c */
    KANJI,        /* 0x8f8d */
    KANJI,        /* 0x8f8e */
    KANJI,        /* 0x8f8f */
    KANJI,        /* 0x8f90 */
    KANJI,        /* 0x8f91 */
    KANJI,        /* 0x8f92 */
    KANJI,        /* 0x8f93 */
    KANJI,        /* 0x8f94 */
    KANJI,        /* 0x8f95 */
    KANJI,        /* 0x8f96 */
    KANJI,        /* 0x8f97 */
    KANJI,        /* 0x8f98 */
    KANJI,        /* 0x8f99 */
    KANJI,        /* 0x8f9a */
    KANJI,        /* 0x8f9b */
    KANJI,        /* 0x8f9c */
    KANJI,        /* 0x8f9d */
    KANJI,        /* 0x8f9e */
    KANJI,        /* 0x8f9f */
    KANJI,        /* 0x8fa0 */
    KANJI,        /* 0x8fa1 */
    KANJI,        /* 0x8fa2 */
    KANJI,        /* 0x8fa3 */
    KANJI,        /* 0x8fa4 */
    KANJI,        /* 0x8fa5 */
    KANJI,        /* 0x8fa6 */
    KANJI,        /* 0x8fa7 */
    KANJI,        /* 0x8fa8 */
    KANJI,        /* 0x8fa9 */
    KANJI,        /* 0x8faa */
    KANJI,        /* 0x8fab */
    KANJI,        /* 0x8fac */
    KANJI,        /* 0x8fad */
    KANJI,        /* 0x8fae */
    KANJI,        /* 0x8faf */
    KANJI,        /* 0x8fb0 */
    KANJI,        /* 0x8fb1 */
    KANJI,        /* 0x8fb2 */
    KANJI,        /* 0x8fb3 */
    KANJI,        /* 0x8fb4 */
    KANJI,        /* 0x8fb5 */
    KANJI,        /* 0x8fb6 */
    KANJI,        /* 0x8fb7 */
    KANJI,        /* 0x8fb8 */
    KANJI,        /* 0x8fb9 */
    KANJI,        /* 0x8fba */
    KANJI,        /* 0x8fbb */
    KANJI,        /* 0x8fbc */
    KANJI,        /* 0x8fbd */
    KANJI,        /* 0x8fbe */
    KANJI,        /* 0x8fbf */
    KANJI,        /* 0x8fc0 */
    KANJI,        /* 0x8fc1 */
    KANJI,        /* 0x8fc2 */
    KANJI,        /* 0x8fc3 */
    KANJI,        /* 0x8fc4 */
    KANJI,        /* 0x8fc5 */
    KANJI,        /* 0x8fc6 */
    KANJI,        /* 0x8fc7 */
    KANJI,        /* 0x8fc8 */
    KANJI,        /* 0x8fc9 */
    KANJI,        /* 0x8fca */
    KANJI,        /* 0x8fcb */
    KANJI,        /* 0x8fcc */
    KANJI,        /* 0x8fcd */
    KANJI,        /* 0x8fce */
    KANJI,        /* 0x8fcf */
    KANJI,        /* 0x8fd0 */
    KANJI,        /* 0x8fd1 */
    KANJI,        /* 0x8fd2 */
    KANJI,        /* 0x8fd3 */
    KANJI,        /* 0x8fd4 */
    KANJI,        /* 0x8fd5 */
    KANJI,        /* 0x8fd6 */
    KANJI,        /* 0x8fd7 */
    KANJI,        /* 0x8fd8 */
    KANJI,        /* 0x8fd9 */
    KANJI,        /* 0x8fda */
    KANJI,        /* 0x8fdb */
    KANJI,        /* 0x8fdc */
    KANJI,        /* 0x8fdd */
    KANJI,        /* 0x8fde */
    KANJI,        /* 0x8fdf */
    KANJI,        /* 0x8fe0 */
    KANJI,        /* 0x8fe1 */
    KANJI,        /* 0x8fe2 */
    KANJI,        /* 0x8fe3 */
    KANJI,        /* 0x8fe4 */
    KANJI,        /* 0x8fe5 */
    KANJI,        /* 0x8fe6 */
    KANJI,        /* 0x8fe7 */
    KANJI,        /* 0x8fe8 */
    KANJI,        /* 0x8fe9 */
    KANJI,        /* 0x8fea */
    KANJI,        /* 0x8feb */
    KANJI,        /* 0x8fec */
    KANJI,        /* 0x8fed */
    KANJI,        /* 0x8fee */
    KANJI,        /* 0x8fef */
    KANJI,        /* 0x8ff0 */
    KANJI,        /* 0x8ff1 */
    KANJI,        /* 0x8ff2 */
    KANJI,        /* 0x8ff3 */
    KANJI,        /* 0x8ff4 */
    KANJI,        /* 0x8ff5 */
    KANJI,        /* 0x8ff6 */
    KANJI,        /* 0x8ff7 */
    KANJI,        /* 0x8ff8 */
    KANJI,        /* 0x8ff9 */
    KANJI,        /* 0x8ffa */
    KANJI,        /* 0x8ffb */
    KANJI,        /* 0x8ffc */
    KANJI,        /* 0x8ffd */
    KANJI,        /* 0x8ffe */
    KANJI,        /* 0x8fff */
    KANJI,        /* 0x9000 */
    KANJI,        /* 0x9001 */
    KANJI,        /* 0x9002 */
    KANJI,        /* 0x9003 */
    KANJI,        /* 0x9004 */
    KANJI,        /* 0x9005 */
    KANJI,        /* 0x9006 */
    KANJI,        /* 0x9007 */
    KANJI,        /* 0x9008 */
    KANJI,        /* 0x9009 */
    KANJI,        /* 0x900a */
    KANJI,        /* 0x900b */
    KANJI,        /* 0x900c */
    KANJI,        /* 0x900d */
    KANJI,        /* 0x900e */
    KANJI,        /* 0x900f */
    KANJI,        /* 0x9010 */
    KANJI,        /* 0x9011 */
    KANJI,        /* 0x9012 */
    KANJI,        /* 0x9013 */
    KANJI,        /* 0x9014 */
    KANJI,        /* 0x9015 */
    KANJI,        /* 0x9016 */
    KANJI,        /* 0x9017 */
    KANJI,        /* 0x9018 */
    KANJI,        /* 0x9019 */
    KANJI,        /* 0x901a */
    KANJI,        /* 0x901b */
    KANJI,        /* 0x901c */
    KANJI,        /* 0x901d */
    KANJI,        /* 0x901e */
    KANJI,        /* 0x901f */
    KANJI,        /* 0x9020 */
    KANJI,        /* 0x9021 */
    KANJI,        /* 0x9022 */
    KANJI,        /* 0x9023 */
    KANJI,        /* 0x9024 */
    KANJI,        /* 0x9025 */
    KANJI,        /* 0x9026 */
    KANJI,        /* 0x9027 */
    KANJI,        /* 0x9028 */
    KANJI,        /* 0x9029 */
    KANJI,        /* 0x902a */
    KANJI,        /* 0x902b */
    KANJI,        /* 0x902c */
    KANJI,        /* 0x902d */
    KANJI,        /* 0x902e */
    KANJI,        /* 0x902f */
    KANJI,        /* 0x9030 */
    KANJI,        /* 0x9031 */
    KANJI,        /* 0x9032 */
    KANJI,        /* 0x9033 */
    KANJI,        /* 0x9034 */
    KANJI,        /* 0x9035 */
    KANJI,        /* 0x9036 */
    KANJI,        /* 0x9037 */
    KANJI,        /* 0x9038 */
    KANJI,        /* 0x9039 */
    KANJI,        /* 0x903a */
    KANJI,        /* 0x903b */
    KANJI,        /* 0x903c */
    KANJI,        /* 0x903d */
    KANJI,        /* 0x903e */
    KANJI,        /* 0x903f */
    KANJI,        /* 0x9040 */
    KANJI,        /* 0x9041 */
    KANJI,        /* 0x9042 */
    KANJI,        /* 0x9043 */
    KANJI,        /* 0x9044 */
    KANJI,        /* 0x9045 */
    KANJI,        /* 0x9046 */
    KANJI,        /* 0x9047 */
    KANJI,        /* 0x9048 */
    KANJI,        /* 0x9049 */
    KANJI,        /* 0x904a */
    KANJI,        /* 0x904b */
    KANJI,        /* 0x904c */
    KANJI,        /* 0x904d */
    KANJI,        /* 0x904e */
    KANJI,        /* 0x904f */
    KANJI,        /* 0x9050 */
    KANJI,        /* 0x9051 */
    KANJI,        /* 0x9052 */
    KANJI,        /* 0x9053 */
    KANJI,        /* 0x9054 */
    KANJI,        /* 0x9055 */
    KANJI,        /* 0x9056 */
    KANJI,        /* 0x9057 */
    KANJI,        /* 0x9058 */
    KANJI,        /* 0x9059 */
    KANJI,        /* 0x905a */
    KANJI,        /* 0x905b */
    KANJI,        /* 0x905c */
    KANJI,        /* 0x905d */
    KANJI,        /* 0x905e */
    KANJI,        /* 0x905f */
    KANJI,        /* 0x9060 */
    KANJI,        /* 0x9061 */
    KANJI,        /* 0x9062 */
    KANJI,        /* 0x9063 */
    KANJI,        /* 0x9064 */
    KANJI,        /* 0x9065 */
    KANJI,        /* 0x9066 */
    KANJI,        /* 0x9067 */
    KANJI,        /* 0x9068 */
    KANJI,        /* 0x9069 */
    KANJI,        /* 0x906a */
    KANJI,        /* 0x906b */
    KANJI,        /* 0x906c */
    KANJI,        /* 0x906d */
    KANJI,        /* 0x906e */
    KANJI,        /* 0x906f */
    KANJI,        /* 0x9070 */
    KANJI,        /* 0x9071 */
    KANJI,        /* 0x9072 */
    KANJI,        /* 0x9073 */
    KANJI,        /* 0x9074 */
    KANJI,        /* 0x9075 */
    KANJI,        /* 0x9076 */
    KANJI,        /* 0x9077 */
    KANJI,        /* 0x9078 */
    KANJI,        /* 0x9079 */
    KANJI,        /* 0x907a */
    KANJI,        /* 0x907b */
    KANJI,        /* 0x907c */
    KANJI,        /* 0x907d */
    KANJI,        /* 0x907e */
    KANJI,        /* 0x907f */
    KANJI,        /* 0x9080 */
    KANJI,        /* 0x9081 */
    KANJI,        /* 0x9082 */
    KANJI,        /* 0x9083 */
    KANJI,        /* 0x9084 */
    KANJI,        /* 0x9085 */
    KANJI,        /* 0x9086 */
    KANJI,        /* 0x9087 */
    KANJI,        /* 0x9088 */
    KANJI,        /* 0x9089 */
    KANJI,        /* 0x908a */
    KANJI,        /* 0x908b */
    KANJI,        /* 0x908c */
    KANJI,        /* 0x908d */
    KANJI,        /* 0x908e */
    KANJI,        /* 0x908f */
    KANJI,        /* 0x9090 */
    KANJI,        /* 0x9091 */
    KANJI,        /* 0x9092 */
    KANJI,        /* 0x9093 */
    KANJI,        /* 0x9094 */
    KANJI,        /* 0x9095 */
    KANJI,        /* 0x9096 */
    KANJI,        /* 0x9097 */
    KANJI,        /* 0x9098 */
    KANJI,        /* 0x9099 */
    KANJI,        /* 0x909a */
    KANJI,        /* 0x909b */
    KANJI,        /* 0x909c */
    KANJI,        /* 0x909d */
    KANJI,        /* 0x909e */
    KANJI,        /* 0x909f */
    KANJI,        /* 0x90a0 */
    KANJI,        /* 0x90a1 */
    KANJI,        /* 0x90a2 */
    KANJI,        /* 0x90a3 */
    KANJI,        /* 0x90a4 */
    KANJI,        /* 0x90a5 */
    KANJI,        /* 0x90a6 */
    KANJI,        /* 0x90a7 */
    KANJI,        /* 0x90a8 */
    KANJI,        /* 0x90a9 */
    KANJI,        /* 0x90aa */
    KANJI,        /* 0x90ab */
    KANJI,        /* 0x90ac */
    KANJI,        /* 0x90ad */
    KANJI,        /* 0x90ae */
    KANJI,        /* 0x90af */
    KANJI,        /* 0x90b0 */
    KANJI,        /* 0x90b1 */
    KANJI,        /* 0x90b2 */
    KANJI,        /* 0x90b3 */
    KANJI,        /* 0x90b4 */
    KANJI,        /* 0x90b5 */
    KANJI,        /* 0x90b6 */
    KANJI,        /* 0x90b7 */
    KANJI,        /* 0x90b8 */
    KANJI,        /* 0x90b9 */
    KANJI,        /* 0x90ba */
    KANJI,        /* 0x90bb */
    KANJI,        /* 0x90bc */
    KANJI,        /* 0x90bd */
    KANJI,        /* 0x90be */
    KANJI,        /* 0x90bf */
    KANJI,        /* 0x90c0 */
    KANJI,        /* 0x90c1 */
    KANJI,        /* 0x90c2 */
    KANJI,        /* 0x90c3 */
    KANJI,        /* 0x90c4 */
    KANJI,        /* 0x90c5 */
    KANJI,        /* 0x90c6 */
    KANJI,        /* 0x90c7 */
    KANJI,        /* 0x90c8 */
    KANJI,        /* 0x90c9 */
    KANJI,        /* 0x90ca */
    KANJI,        /* 0x90cb */
    KANJI,        /* 0x90cc */
    KANJI,        /* 0x90cd */
    KANJI,        /* 0x90ce */
    KANJI,        /* 0x90cf */
    KANJI,        /* 0x90d0 */
    KANJI,        /* 0x90d1 */
    KANJI,        /* 0x90d2 */
    KANJI,        /* 0x90d3 */
    KANJI,        /* 0x90d4 */
    KANJI,        /* 0x90d5 */
    KANJI,        /* 0x90d6 */
    KANJI,        /* 0x90d7 */
    KANJI,        /* 0x90d8 */
    KANJI,        /* 0x90d9 */
    KANJI,        /* 0x90da */
    KANJI,        /* 0x90db */
    KANJI,        /* 0x90dc */
    KANJI,        /* 0x90dd */
    KANJI,        /* 0x90de */
    KANJI,        /* 0x90df */
    KANJI,        /* 0x90e0 */
    KANJI,        /* 0x90e1 */
    KANJI,        /* 0x90e2 */
    KANJI,        /* 0x90e3 */
    KANJI,        /* 0x90e4 */
    KANJI,        /* 0x90e5 */
    KANJI,        /* 0x90e6 */
    KANJI,        /* 0x90e7 */
    KANJI,        /* 0x90e8 */
    KANJI,        /* 0x90e9 */
    KANJI,        /* 0x90ea */
    KANJI,        /* 0x90eb */
    KANJI,        /* 0x90ec */
    KANJI,        /* 0x90ed */
    KANJI,        /* 0x90ee */
    KANJI,        /* 0x90ef */
    KANJI,        /* 0x90f0 */
    KANJI,        /* 0x90f1 */
    KANJI,        /* 0x90f2 */
    KANJI,        /* 0x90f3 */
    KANJI,        /* 0x90f4 */
    KANJI,        /* 0x90f5 */
    KANJI,        /* 0x90f6 */
    KANJI,        /* 0x90f7 */
    KANJI,        /* 0x90f8 */
    KANJI,        /* 0x90f9 */
    KANJI,        /* 0x90fa */
    KANJI,        /* 0x90fb */
    KANJI,        /* 0x90fc */
    KANJI,        /* 0x90fd */
    KANJI,        /* 0x90fe */
    KANJI,        /* 0x90ff */
    KANJI,        /* 0x9100 */
    KANJI,        /* 0x9101 */
    KANJI,        /* 0x9102 */
    KANJI,        /* 0x9103 */
    KANJI,        /* 0x9104 */
    KANJI,        /* 0x9105 */
    KANJI,        /* 0x9106 */
    KANJI,        /* 0x9107 */
    KANJI,        /* 0x9108 */
    KANJI,        /* 0x9109 */
    KANJI,        /* 0x910a */
    KANJI,        /* 0x910b */
    KANJI,        /* 0x910c */
    KANJI,        /* 0x910d */
    KANJI,        /* 0x910e */
    KANJI,        /* 0x910f */
    KANJI,        /* 0x9110 */
    KANJI,        /* 0x9111 */
    KANJI,        /* 0x9112 */
    KANJI,        /* 0x9113 */
    KANJI,        /* 0x9114 */
    KANJI,        /* 0x9115 */
    KANJI,        /* 0x9116 */
    KANJI,        /* 0x9117 */
    KANJI,        /* 0x9118 */
    KANJI,        /* 0x9119 */
    KANJI,        /* 0x911a */
    KANJI,        /* 0x911b */
    KANJI,        /* 0x911c */
    KANJI,        /* 0x911d */
    KANJI,        /* 0x911e */
    KANJI,        /* 0x911f */
    KANJI,        /* 0x9120 */
    KANJI,        /* 0x9121 */
    KANJI,        /* 0x9122 */
    KANJI,        /* 0x9123 */
    KANJI,        /* 0x9124 */
    KANJI,        /* 0x9125 */
    KANJI,        /* 0x9126 */
    KANJI,        /* 0x9127 */
    KANJI,        /* 0x9128 */
    KANJI,        /* 0x9129 */
    KANJI,        /* 0x912a */
    KANJI,        /* 0x912b */
    KANJI,        /* 0x912c */
    KANJI,        /* 0x912d */
    KANJI,        /* 0x912e */
    KANJI,        /* 0x912f */
    KANJI,        /* 0x9130 */
    KANJI,        /* 0x9131 */
    KANJI,        /* 0x9132 */
    KANJI,        /* 0x9133 */
    KANJI,        /* 0x9134 */
    KANJI,        /* 0x9135 */
    KANJI,        /* 0x9136 */
    KANJI,        /* 0x9137 */
    KANJI,        /* 0x9138 */
    KANJI,        /* 0x9139 */
    KANJI,        /* 0x913a */
    KANJI,        /* 0x913b */
    KANJI,        /* 0x913c */
    KANJI,        /* 0x913d */
    KANJI,        /* 0x913e */
    KANJI,        /* 0x913f */
    KANJI,        /* 0x9140 */
    KANJI,        /* 0x9141 */
    KANJI,        /* 0x9142 */
    KANJI,        /* 0x9143 */
    KANJI,        /* 0x9144 */
    KANJI,        /* 0x9145 */
    KANJI,        /* 0x9146 */
    KANJI,        /* 0x9147 */
    KANJI,        /* 0x9148 */
    KANJI,        /* 0x9149 */
    KANJI,        /* 0x914a */
    KANJI,        /* 0x914b */
    KANJI,        /* 0x914c */
    KANJI,        /* 0x914d */
    KANJI,        /* 0x914e */
    KANJI,        /* 0x914f */
    KANJI,        /* 0x9150 */
    KANJI,        /* 0x9151 */
    KANJI,        /* 0x9152 */
    KANJI,        /* 0x9153 */
    KANJI,        /* 0x9154 */
    KANJI,        /* 0x9155 */
    KANJI,        /* 0x9156 */
    KANJI,        /* 0x9157 */
    KANJI,        /* 0x9158 */
    KANJI,        /* 0x9159 */
    KANJI,        /* 0x915a */
    KANJI,        /* 0x915b */
    KANJI,        /* 0x915c */
    KANJI,        /* 0x915d */
    KANJI,        /* 0x915e */
    KANJI,        /* 0x915f */
    KANJI,        /* 0x9160 */
    KANJI,        /* 0x9161 */
    KANJI,        /* 0x9162 */
    KANJI,        /* 0x9163 */
    KANJI,        /* 0x9164 */
    KANJI,        /* 0x9165 */
    KANJI,        /* 0x9166 */
    KANJI,        /* 0x9167 */
    KANJI,        /* 0x9168 */
    KANJI,        /* 0x9169 */
    KANJI,        /* 0x916a */
    KANJI,        /* 0x916b */
    KANJI,        /* 0x916c */
    KANJI,        /* 0x916d */
    KANJI,        /* 0x916e */
    KANJI,        /* 0x916f */
    KANJI,        /* 0x9170 */
    KANJI,        /* 0x9171 */
    KANJI,        /* 0x9172 */
    KANJI,        /* 0x9173 */
    KANJI,        /* 0x9174 */
    KANJI,        /* 0x9175 */
    KANJI,        /* 0x9176 */
    KANJI,        /* 0x9177 */
    KANJI,        /* 0x9178 */
    KANJI,        /* 0x9179 */
    KANJI,        /* 0x917a */
    KANJI,        /* 0x917b */
    KANJI,        /* 0x917c */
    KANJI,        /* 0x917d */
    KANJI,        /* 0x917e */
    KANJI,        /* 0x917f */
    KANJI,        /* 0x9180 */
    KANJI,        /* 0x9181 */
    KANJI,        /* 0x9182 */
    KANJI,        /* 0x9183 */
    KANJI,        /* 0x9184 */
    KANJI,        /* 0x9185 */
    KANJI,        /* 0x9186 */
    KANJI,        /* 0x9187 */
    KANJI,        /* 0x9188 */
    KANJI,        /* 0x9189 */
    KANJI,        /* 0x918a */
    KANJI,        /* 0x918b */
    KANJI,        /* 0x918c */
    KANJI,        /* 0x918d */
    KANJI,        /* 0x918e */
    KANJI,        /* 0x918f */
    KANJI,        /* 0x9190 */
    KANJI,        /* 0x9191 */
    KANJI,        /* 0x9192 */
    KANJI,        /* 0x9193 */
    KANJI,        /* 0x9194 */
    KANJI,        /* 0x9195 */
    KANJI,        /* 0x9196 */
    KANJI,        /* 0x9197 */
    KANJI,        /* 0x9198 */
    KANJI,        /* 0x9199 */
    KANJI,        /* 0x919a */
    KANJI,        /* 0x919b */
    KANJI,        /* 0x919c */
    KANJI,        /* 0x919d */
    KANJI,        /* 0x919e */
    KANJI,        /* 0x919f */
    KANJI,        /* 0x91a0 */
    KANJI,        /* 0x91a1 */
    KANJI,        /* 0x91a2 */
    KANJI,        /* 0x91a3 */
    KANJI,        /* 0x91a4 */
    KANJI,        /* 0x91a5 */
    KANJI,        /* 0x91a6 */
    KANJI,        /* 0x91a7 */
    KANJI,        /* 0x91a8 */
    KANJI,        /* 0x91a9 */
    KANJI,        /* 0x91aa */
    KANJI,        /* 0x91ab */
    KANJI,        /* 0x91ac */
    KANJI,        /* 0x91ad */
    KANJI,        /* 0x91ae */
    KANJI,        /* 0x91af */
    KANJI,        /* 0x91b0 */
    KANJI,        /* 0x91b1 */
    KANJI,        /* 0x91b2 */
    KANJI,        /* 0x91b3 */
    KANJI,        /* 0x91b4 */
    KANJI,        /* 0x91b5 */
    KANJI,        /* 0x91b6 */
    KANJI,        /* 0x91b7 */
    KANJI,        /* 0x91b8 */
    KANJI,        /* 0x91b9 */
    KANJI,        /* 0x91ba */
    KANJI,        /* 0x91bb */
    KANJI,        /* 0x91bc */
    KANJI,        /* 0x91bd */
    KANJI,        /* 0x91be */
    KANJI,        /* 0x91bf */
    KANJI,        /* 0x91c0 */
    KANJI,        /* 0x91c1 */
    KANJI,        /* 0x91c2 */
    KANJI,        /* 0x91c3 */
    KANJI,        /* 0x91c4 */
    KANJI,        /* 0x91c5 */
    KANJI,        /* 0x91c6 */
    KANJI,        /* 0x91c7 */
    KANJI,        /* 0x91c8 */
    KANJI,        /* 0x91c9 */
    KANJI,        /* 0x91ca */
    KANJI,        /* 0x91cb */
    KANJI,        /* 0x91cc */
    KANJI,        /* 0x91cd */
    KANJI,        /* 0x91ce */
    KANJI,        /* 0x91cf */
    KANJI,        /* 0x91d0 */
    KANJI,        /* 0x91d1 */
    KANJI,        /* 0x91d2 */
    KANJI,        /* 0x91d3 */
    KANJI,        /* 0x91d4 */
    KANJI,        /* 0x91d5 */
    KANJI,        /* 0x91d6 */
    KANJI,        /* 0x91d7 */
    KANJI,        /* 0x91d8 */
    KANJI,        /* 0x91d9 */
    KANJI,        /* 0x91da */
    KANJI,        /* 0x91db */
    KANJI,        /* 0x91dc */
    KANJI,        /* 0x91dd */
    KANJI,        /* 0x91de */
    KANJI,        /* 0x91df */
    KANJI,        /* 0x91e0 */
    KANJI,        /* 0x91e1 */
    KANJI,        /* 0x91e2 */
    KANJI,        /* 0x91e3 */
    KANJI,        /* 0x91e4 */
    KANJI,        /* 0x91e5 */
    KANJI,        /* 0x91e6 */
    KANJI,        /* 0x91e7 */
    KANJI,        /* 0x91e8 */
    KANJI,        /* 0x91e9 */
    KANJI,        /* 0x91ea */
    KANJI,        /* 0x91eb */
    KANJI,        /* 0x91ec */
    KANJI,        /* 0x91ed */
    KANJI,        /* 0x91ee */
    KANJI,        /* 0x91ef */
    KANJI,        /* 0x91f0 */
    KANJI,        /* 0x91f1 */
    KANJI,        /* 0x91f2 */
    KANJI,        /* 0x91f3 */
    KANJI,        /* 0x91f4 */
    KANJI,        /* 0x91f5 */
    KANJI,        /* 0x91f6 */
    KANJI,        /* 0x91f7 */
    KANJI,        /* 0x91f8 */
    KANJI,        /* 0x91f9 */
    KANJI,        /* 0x91fa */
    KANJI,        /* 0x91fb */
    KANJI,        /* 0x91fc */
    KANJI,        /* 0x91fd */
    KANJI,        /* 0x91fe */
    KANJI,        /* 0x91ff */
    KANJI,        /* 0x9200 */
    KANJI,        /* 0x9201 */
    KANJI,        /* 0x9202 */
    KANJI,        /* 0x9203 */
    KANJI,        /* 0x9204 */
    KANJI,        /* 0x9205 */
    KANJI,        /* 0x9206 */
    KANJI,        /* 0x9207 */
    KANJI,        /* 0x9208 */
    KANJI,        /* 0x9209 */
    KANJI,        /* 0x920a */
    KANJI,        /* 0x920b */
    KANJI,        /* 0x920c */
    KANJI,        /* 0x920d */
    KANJI,        /* 0x920e */
    KANJI,        /* 0x920f */
    KANJI,        /* 0x9210 */
    KANJI,        /* 0x9211 */
    KANJI,        /* 0x9212 */
    KANJI,        /* 0x9213 */
    KANJI,        /* 0x9214 */
    KANJI,        /* 0x9215 */
    KANJI,        /* 0x9216 */
    KANJI,        /* 0x9217 */
    KANJI,        /* 0x9218 */
    KANJI,        /* 0x9219 */
    KANJI,        /* 0x921a */
    KANJI,        /* 0x921b */
    KANJI,        /* 0x921c */
    KANJI,        /* 0x921d */
    KANJI,        /* 0x921e */
    KANJI,        /* 0x921f */
    KANJI,        /* 0x9220 */
    KANJI,        /* 0x9221 */
    KANJI,        /* 0x9222 */
    KANJI,        /* 0x9223 */
    KANJI,        /* 0x9224 */
    KANJI,        /* 0x9225 */
    KANJI,        /* 0x9226 */
    KANJI,        /* 0x9227 */
    KANJI,        /* 0x9228 */
    KANJI,        /* 0x9229 */
    KANJI,        /* 0x922a */
    KANJI,        /* 0x922b */
    KANJI,        /* 0x922c */
    KANJI,        /* 0x922d */
    KANJI,        /* 0x922e */
    KANJI,        /* 0x922f */
    KANJI,        /* 0x9230 */
    KANJI,        /* 0x9231 */
    KANJI,        /* 0x9232 */
    KANJI,        /* 0x9233 */
    KANJI,        /* 0x9234 */
    KANJI,        /* 0x9235 */
    KANJI,        /* 0x9236 */
    KANJI,        /* 0x9237 */
    KANJI,        /* 0x9238 */
    KANJI,        /* 0x9239 */
    KANJI,        /* 0x923a */
    KANJI,        /* 0x923b */
    KANJI,        /* 0x923c */
    KANJI,        /* 0x923d */
    KANJI,        /* 0x923e */
    KANJI,        /* 0x923f */
    KANJI,        /* 0x9240 */
    KANJI,        /* 0x9241 */
    KANJI,        /* 0x9242 */
    KANJI,        /* 0x9243 */
    KANJI,        /* 0x9244 */
    KANJI,        /* 0x9245 */
    KANJI,        /* 0x9246 */
    KANJI,        /* 0x9247 */
    KANJI,        /* 0x9248 */
    KANJI,        /* 0x9249 */
    KANJI,        /* 0x924a */
    KANJI,        /* 0x924b */
    KANJI,        /* 0x924c */
    KANJI,        /* 0x924d */
    KANJI,        /* 0x924e */
    KANJI,        /* 0x924f */
    KANJI,        /* 0x9250 */
    KANJI,        /* 0x9251 */
    KANJI,        /* 0x9252 */
    KANJI,        /* 0x9253 */
    KANJI,        /* 0x9254 */
    KANJI,        /* 0x9255 */
    KANJI,        /* 0x9256 */
    KANJI,        /* 0x9257 */
    KANJI,        /* 0x9258 */
    KANJI,        /* 0x9259 */
    KANJI,        /* 0x925a */
    KANJI,        /* 0x925b */
    KANJI,        /* 0x925c */
    KANJI,        /* 0x925d */
    KANJI,        /* 0x925e */
    KANJI,        /* 0x925f */
    KANJI,        /* 0x9260 */
    KANJI,        /* 0x9261 */
    KANJI,        /* 0x9262 */
    KANJI,        /* 0x9263 */
    KANJI,        /* 0x9264 */
    KANJI,        /* 0x9265 */
    KANJI,        /* 0x9266 */
    KANJI,        /* 0x9267 */
    KANJI,        /* 0x9268 */
    KANJI,        /* 0x9269 */
    KANJI,        /* 0x926a */
    KANJI,        /* 0x926b */
    KANJI,        /* 0x926c */
    KANJI,        /* 0x926d */
    KANJI,        /* 0x926e */
    KANJI,        /* 0x926f */
    KANJI,        /* 0x9270 */
    KANJI,        /* 0x9271 */
    KANJI,        /* 0x9272 */
    KANJI,        /* 0x9273 */
    KANJI,        /* 0x9274 */
    KANJI,        /* 0x9275 */
    KANJI,        /* 0x9276 */
    KANJI,        /* 0x9277 */
    KANJI,        /* 0x9278 */
    KANJI,        /* 0x9279 */
    KANJI,        /* 0x927a */
    KANJI,        /* 0x927b */
    KANJI,        /* 0x927c */
    KANJI,        /* 0x927d */
    KANJI,        /* 0x927e */
    KANJI,        /* 0x927f */
    KANJI,        /* 0x9280 */
    KANJI,        /* 0x9281 */
    KANJI,        /* 0x9282 */
    KANJI,        /* 0x9283 */
    KANJI,        /* 0x9284 */
    KANJI,        /* 0x9285 */
    KANJI,        /* 0x9286 */
    KANJI,        /* 0x9287 */
    KANJI,        /* 0x9288 */
    KANJI,        /* 0x9289 */
    KANJI,        /* 0x928a */
    KANJI,        /* 0x928b */
    KANJI,        /* 0x928c */
    KANJI,        /* 0x928d */
    KANJI,        /* 0x928e */
    KANJI,        /* 0x928f */
    KANJI,        /* 0x9290 */
    KANJI,        /* 0x9291 */
    KANJI,        /* 0x9292 */
    KANJI,        /* 0x9293 */
    KANJI,        /* 0x9294 */
    KANJI,        /* 0x9295 */
    KANJI,        /* 0x9296 */
    KANJI,        /* 0x9297 */
    KANJI,        /* 0x9298 */
    KANJI,        /* 0x9299 */
    KANJI,        /* 0x929a */
    KANJI,        /* 0x929b */
    KANJI,        /* 0x929c */
    KANJI,        /* 0x929d */
    KANJI,        /* 0x929e */
    KANJI,        /* 0x929f */
    KANJI,        /* 0x92a0 */
    KANJI,        /* 0x92a1 */
    KANJI,        /* 0x92a2 */
    KANJI,        /* 0x92a3 */
    KANJI,        /* 0x92a4 */
    KANJI,        /* 0x92a5 */
    KANJI,        /* 0x92a6 */
    KANJI,        /* 0x92a7 */
    KANJI,        /* 0x92a8 */
    KANJI,        /* 0x92a9 */
    KANJI,        /* 0x92aa */
    KANJI,        /* 0x92ab */
    KANJI,        /* 0x92ac */
    KANJI,        /* 0x92ad */
    KANJI,        /* 0x92ae */
    KANJI,        /* 0x92af */
    KANJI,        /* 0x92b0 */
    KANJI,        /* 0x92b1 */
    KANJI,        /* 0x92b2 */
    KANJI,        /* 0x92b3 */
    KANJI,        /* 0x92b4 */
    KANJI,        /* 0x92b5 */
    KANJI,        /* 0x92b6 */
    KANJI,        /* 0x92b7 */
    KANJI,        /* 0x92b8 */
    KANJI,        /* 0x92b9 */
    KANJI,        /* 0x92ba */
    KANJI,        /* 0x92bb */
    KANJI,        /* 0x92bc */
    KANJI,        /* 0x92bd */
    KANJI,        /* 0x92be */
    KANJI,        /* 0x92bf */
    KANJI,        /* 0x92c0 */
    KANJI,        /* 0x92c1 */
    KANJI,        /* 0x92c2 */
    KANJI,        /* 0x92c3 */
    KANJI,        /* 0x92c4 */
    KANJI,        /* 0x92c5 */
    KANJI,        /* 0x92c6 */
    KANJI,        /* 0x92c7 */
    KANJI,        /* 0x92c8 */
    KANJI,        /* 0x92c9 */
    KANJI,        /* 0x92ca */
    KANJI,        /* 0x92cb */
    KANJI,        /* 0x92cc */
    KANJI,        /* 0x92cd */
    KANJI,        /* 0x92ce */
    KANJI,        /* 0x92cf */
    KANJI,        /* 0x92d0 */
    KANJI,        /* 0x92d1 */
    KANJI,        /* 0x92d2 */
    KANJI,        /* 0x92d3 */
    KANJI,        /* 0x92d4 */
    KANJI,        /* 0x92d5 */
    KANJI,        /* 0x92d6 */
    KANJI,        /* 0x92d7 */
    KANJI,        /* 0x92d8 */
    KANJI,        /* 0x92d9 */
    KANJI,        /* 0x92da */
    KANJI,        /* 0x92db */
    KANJI,        /* 0x92dc */
    KANJI,        /* 0x92dd */
    KANJI,        /* 0x92de */
    KANJI,        /* 0x92df */
    KANJI,        /* 0x92e0 */
    KANJI,        /* 0x92e1 */
    KANJI,        /* 0x92e2 */
    KANJI,        /* 0x92e3 */
    KANJI,        /* 0x92e4 */
    KANJI,        /* 0x92e5 */
    KANJI,        /* 0x92e6 */
    KANJI,        /* 0x92e7 */
    KANJI,        /* 0x92e8 */
    KANJI,        /* 0x92e9 */
    KANJI,        /* 0x92ea */
    KANJI,        /* 0x92eb */
    KANJI,        /* 0x92ec */
    KANJI,        /* 0x92ed */
    KANJI,        /* 0x92ee */
    KANJI,        /* 0x92ef */
    KANJI,        /* 0x92f0 */
    KANJI,        /* 0x92f1 */
    KANJI,        /* 0x92f2 */
    KANJI,        /* 0x92f3 */
    KANJI,        /* 0x92f4 */
    KANJI,        /* 0x92f5 */
    KANJI,        /* 0x92f6 */
    KANJI,        /* 0x92f7 */
    KANJI,        /* 0x92f8 */
    KANJI,        /* 0x92f9 */
    KANJI,        /* 0x92fa */
    KANJI,        /* 0x92fb */
    KANJI,        /* 0x92fc */
    KANJI,        /* 0x92fd */
    KANJI,        /* 0x92fe */
    KANJI,        /* 0x92ff */
    KANJI,        /* 0x9300 */
    KANJI,        /* 0x9301 */
    KANJI,        /* 0x9302 */
    KANJI,        /* 0x9303 */
    KANJI,        /* 0x9304 */
    KANJI,        /* 0x9305 */
    KANJI,        /* 0x9306 */
    KANJI,        /* 0x9307 */
    KANJI,        /* 0x9308 */
    KANJI,        /* 0x9309 */
    KANJI,        /* 0x930a */
    KANJI,        /* 0x930b */
    KANJI,        /* 0x930c */
    KANJI,        /* 0x930d */
    KANJI,        /* 0x930e */
    KANJI,        /* 0x930f */
    KANJI,        /* 0x9310 */
    KANJI,        /* 0x9311 */
    KANJI,        /* 0x9312 */
    KANJI,        /* 0x9313 */
    KANJI,        /* 0x9314 */
    KANJI,        /* 0x9315 */
    KANJI,        /* 0x9316 */
    KANJI,        /* 0x9317 */
    KANJI,        /* 0x9318 */
    KANJI,        /* 0x9319 */
    KANJI,        /* 0x931a */
    KANJI,        /* 0x931b */
    KANJI,        /* 0x931c */
    KANJI,        /* 0x931d */
    KANJI,        /* 0x931e */
    KANJI,        /* 0x931f */
    KANJI,        /* 0x9320 */
    KANJI,        /* 0x9321 */
    KANJI,        /* 0x9322 */
    KANJI,        /* 0x9323 */
    KANJI,        /* 0x9324 */
    KANJI,        /* 0x9325 */
    KANJI,        /* 0x9326 */
    KANJI,        /* 0x9327 */
    KANJI,        /* 0x9328 */
    KANJI,        /* 0x9329 */
    KANJI,        /* 0x932a */
    KANJI,        /* 0x932b */
    KANJI,        /* 0x932c */
    KANJI,        /* 0x932d */
    KANJI,        /* 0x932e */
    KANJI,        /* 0x932f */
    KANJI,        /* 0x9330 */
    KANJI,        /* 0x9331 */
    KANJI,        /* 0x9332 */
    KANJI,        /* 0x9333 */
    KANJI,        /* 0x9334 */
    KANJI,        /* 0x9335 */
    KANJI,        /* 0x9336 */
    KANJI,        /* 0x9337 */
    KANJI,        /* 0x9338 */
    KANJI,        /* 0x9339 */
    KANJI,        /* 0x933a */
    KANJI,        /* 0x933b */
    KANJI,        /* 0x933c */
    KANJI,        /* 0x933d */
    KANJI,        /* 0x933e */
    KANJI,        /* 0x933f */
    KANJI,        /* 0x9340 */
    KANJI,        /* 0x9341 */
    KANJI,        /* 0x9342 */
    KANJI,        /* 0x9343 */
    KANJI,        /* 0x9344 */
    KANJI,        /* 0x9345 */
    KANJI,        /* 0x9346 */
    KANJI,        /* 0x9347 */
    KANJI,        /* 0x9348 */
    KANJI,        /* 0x9349 */
    KANJI,        /* 0x934a */
    KANJI,        /* 0x934b */
    KANJI,        /* 0x934c */
    KANJI,        /* 0x934d */
    KANJI,        /* 0x934e */
    KANJI,        /* 0x934f */
    KANJI,        /* 0x9350 */
    KANJI,        /* 0x9351 */
    KANJI,        /* 0x9352 */
    KANJI,        /* 0x9353 */
    KANJI,        /* 0x9354 */
    KANJI,        /* 0x9355 */
    KANJI,        /* 0x9356 */
    KANJI,        /* 0x9357 */
    KANJI,        /* 0x9358 */
    KANJI,        /* 0x9359 */
    KANJI,        /* 0x935a */
    KANJI,        /* 0x935b */
    KANJI,        /* 0x935c */
    KANJI,        /* 0x935d */
    KANJI,        /* 0x935e */
    KANJI,        /* 0x935f */
    KANJI,        /* 0x9360 */
    KANJI,        /* 0x9361 */
    KANJI,        /* 0x9362 */
    KANJI,        /* 0x9363 */
    KANJI,        /* 0x9364 */
    KANJI,        /* 0x9365 */
    KANJI,        /* 0x9366 */
    KANJI,        /* 0x9367 */
    KANJI,        /* 0x9368 */
    KANJI,        /* 0x9369 */
    KANJI,        /* 0x936a */
    KANJI,        /* 0x936b */
    KANJI,        /* 0x936c */
    KANJI,        /* 0x936d */
    KANJI,        /* 0x936e */
    KANJI,        /* 0x936f */
    KANJI,        /* 0x9370 */
    KANJI,        /* 0x9371 */
    KANJI,        /* 0x9372 */
    KANJI,        /* 0x9373 */
    KANJI,        /* 0x9374 */
    KANJI,        /* 0x9375 */
    KANJI,        /* 0x9376 */
    KANJI,        /* 0x9377 */
    KANJI,        /* 0x9378 */
    KANJI,        /* 0x9379 */
    KANJI,        /* 0x937a */
    KANJI,        /* 0x937b */
    KANJI,        /* 0x937c */
    KANJI,        /* 0x937d */
    KANJI,        /* 0x937e */
    KANJI,        /* 0x937f */
    KANJI,        /* 0x9380 */
    KANJI,        /* 0x9381 */
    KANJI,        /* 0x9382 */
    KANJI,        /* 0x9383 */
    KANJI,        /* 0x9384 */
    KANJI,        /* 0x9385 */
    KANJI,        /* 0x9386 */
    KANJI,        /* 0x9387 */
    KANJI,        /* 0x9388 */
    KANJI,        /* 0x9389 */
    KANJI,        /* 0x938a */
    KANJI,        /* 0x938b */
    KANJI,        /* 0x938c */
    KANJI,        /* 0x938d */
    KANJI,        /* 0x938e */
    KANJI,        /* 0x938f */
    KANJI,        /* 0x9390 */
    KANJI,        /* 0x9391 */
    KANJI,        /* 0x9392 */
    KANJI,        /* 0x9393 */
    KANJI,        /* 0x9394 */
    KANJI,        /* 0x9395 */
    KANJI,        /* 0x9396 */
    KANJI,        /* 0x9397 */
    KANJI,        /* 0x9398 */
    KANJI,        /* 0x9399 */
    KANJI,        /* 0x939a */
    KANJI,        /* 0x939b */
    KANJI,        /* 0x939c */
    KANJI,        /* 0x939d */
    KANJI,        /* 0x939e */
    KANJI,        /* 0x939f */
    KANJI,        /* 0x93a0 */
    KANJI,        /* 0x93a1 */
    KANJI,        /* 0x93a2 */
    KANJI,        /* 0x93a3 */
    KANJI,        /* 0x93a4 */
    KANJI,        /* 0x93a5 */
    KANJI,        /* 0x93a6 */
    KANJI,        /* 0x93a7 */
    KANJI,        /* 0x93a8 */
    KANJI,        /* 0x93a9 */
    KANJI,        /* 0x93aa */
    KANJI,        /* 0x93ab */
    KANJI,        /* 0x93ac */
    KANJI,        /* 0x93ad */
    KANJI,        /* 0x93ae */
    KANJI,        /* 0x93af */
    KANJI,        /* 0x93b0 */
    KANJI,        /* 0x93b1 */
    KANJI,        /* 0x93b2 */
    KANJI,        /* 0x93b3 */
    KANJI,        /* 0x93b4 */
    KANJI,        /* 0x93b5 */
    KANJI,        /* 0x93b6 */
    KANJI,        /* 0x93b7 */
    KANJI,        /* 0x93b8 */
    KANJI,        /* 0x93b9 */
    KANJI,        /* 0x93ba */
    KANJI,        /* 0x93bb */
    KANJI,        /* 0x93bc */
    KANJI,        /* 0x93bd */
    KANJI,        /* 0x93be */
    KANJI,        /* 0x93bf */
    KANJI,        /* 0x93c0 */
    KANJI,        /* 0x93c1 */
    KANJI,        /* 0x93c2 */
    KANJI,        /* 0x93c3 */
    KANJI,        /* 0x93c4 */
    KANJI,        /* 0x93c5 */
    KANJI,        /* 0x93c6 */
    KANJI,        /* 0x93c7 */
    KANJI,        /* 0x93c8 */
    KANJI,        /* 0x93c9 */
    KANJI,        /* 0x93ca */
    KANJI,        /* 0x93cb */
    KANJI,        /* 0x93cc */
    KANJI,        /* 0x93cd */
    KANJI,        /* 0x93ce */
    KANJI,        /* 0x93cf */
    KANJI,        /* 0x93d0 */
    KANJI,        /* 0x93d1 */
    KANJI,        /* 0x93d2 */
    KANJI,        /* 0x93d3 */
    KANJI,        /* 0x93d4 */
    KANJI,        /* 0x93d5 */
    KANJI,        /* 0x93d6 */
    KANJI,        /* 0x93d7 */
    KANJI,        /* 0x93d8 */
    KANJI,        /* 0x93d9 */
    KANJI,        /* 0x93da */
    KANJI,        /* 0x93db */
    KANJI,        /* 0x93dc */
    KANJI,        /* 0x93dd */
    KANJI,        /* 0x93de */
    KANJI,        /* 0x93df */
    KANJI,        /* 0x93e0 */
    KANJI,        /* 0x93e1 */
    KANJI,        /* 0x93e2 */
    KANJI,        /* 0x93e3 */
    KANJI,        /* 0x93e4 */
    KANJI,        /* 0x93e5 */
    KANJI,        /* 0x93e6 */
    KANJI,        /* 0x93e7 */
    KANJI,        /* 0x93e8 */
    KANJI,        /* 0x93e9 */
    KANJI,        /* 0x93ea */
    KANJI,        /* 0x93eb */
    KANJI,        /* 0x93ec */
    KANJI,        /* 0x93ed */
    KANJI,        /* 0x93ee */
    KANJI,        /* 0x93ef */
    KANJI,        /* 0x93f0 */
    KANJI,        /* 0x93f1 */
    KANJI,        /* 0x93f2 */
    KANJI,        /* 0x93f3 */
    KANJI,        /* 0x93f4 */
    KANJI,        /* 0x93f5 */
    KANJI,        /* 0x93f6 */
    KANJI,        /* 0x93f7 */
    KANJI,        /* 0x93f8 */
    KANJI,        /* 0x93f9 */
    KANJI,        /* 0x93fa */
    KANJI,        /* 0x93fb */
    KANJI,        /* 0x93fc */
    KANJI,        /* 0x93fd */
    KANJI,        /* 0x93fe */
    KANJI,        /* 0x93ff */
    KANJI,        /* 0x9400 */
    KANJI,        /* 0x9401 */
    KANJI,        /* 0x9402 */
    KANJI,        /* 0x9403 */
    KANJI,        /* 0x9404 */
    KANJI,        /* 0x9405 */
    KANJI,        /* 0x9406 */
    KANJI,        /* 0x9407 */
    KANJI,        /* 0x9408 */
    KANJI,        /* 0x9409 */
    KANJI,        /* 0x940a */
    KANJI,        /* 0x940b */
    KANJI,        /* 0x940c */
    KANJI,        /* 0x940d */
    KANJI,        /* 0x940e */
    KANJI,        /* 0x940f */
    KANJI,        /* 0x9410 */
    KANJI,        /* 0x9411 */
    KANJI,        /* 0x9412 */
    KANJI,        /* 0x9413 */
    KANJI,        /* 0x9414 */
    KANJI,        /* 0x9415 */
    KANJI,        /* 0x9416 */
    KANJI,        /* 0x9417 */
    KANJI,        /* 0x9418 */
    KANJI,        /* 0x9419 */
    KANJI,        /* 0x941a */
    KANJI,        /* 0x941b */
    KANJI,        /* 0x941c */
    KANJI,        /* 0x941d */
    KANJI,        /* 0x941e */
    KANJI,        /* 0x941f */
    KANJI,        /* 0x9420 */
    KANJI,        /* 0x9421 */
    KANJI,        /* 0x9422 */
    KANJI,        /* 0x9423 */
    KANJI,        /* 0x9424 */
    KANJI,        /* 0x9425 */
    KANJI,        /* 0x9426 */
    KANJI,        /* 0x9427 */
    KANJI,        /* 0x9428 */
    KANJI,        /* 0x9429 */
    KANJI,        /* 0x942a */
    KANJI,        /* 0x942b */
    KANJI,        /* 0x942c */
    KANJI,        /* 0x942d */
    KANJI,        /* 0x942e */
    KANJI,        /* 0x942f */
    KANJI,        /* 0x9430 */
    KANJI,        /* 0x9431 */
    KANJI,        /* 0x9432 */
    KANJI,        /* 0x9433 */
    KANJI,        /* 0x9434 */
    KANJI,        /* 0x9435 */
    KANJI,        /* 0x9436 */
    KANJI,        /* 0x9437 */
    KANJI,        /* 0x9438 */
    KANJI,        /* 0x9439 */
    KANJI,        /* 0x943a */
    KANJI,        /* 0x943b */
    KANJI,        /* 0x943c */
    KANJI,        /* 0x943d */
    KANJI,        /* 0x943e */
    KANJI,        /* 0x943f */
    KANJI,        /* 0x9440 */
    KANJI,        /* 0x9441 */
    KANJI,        /* 0x9442 */
    KANJI,        /* 0x9443 */
    KANJI,        /* 0x9444 */
    KANJI,        /* 0x9445 */
    KANJI,        /* 0x9446 */
    KANJI,        /* 0x9447 */
    KANJI,        /* 0x9448 */
    KANJI,        /* 0x9449 */
    KANJI,        /* 0x944a */
    KANJI,        /* 0x944b */
    KANJI,        /* 0x944c */
    KANJI,        /* 0x944d */
    KANJI,        /* 0x944e */
    KANJI,        /* 0x944f */
    KANJI,        /* 0x9450 */
    KANJI,        /* 0x9451 */
    KANJI,        /* 0x9452 */
    KANJI,        /* 0x9453 */
    KANJI,        /* 0x9454 */
    KANJI,        /* 0x9455 */
    KANJI,        /* 0x9456 */
    KANJI,        /* 0x9457 */
    KANJI,        /* 0x9458 */
    KANJI,        /* 0x9459 */
    KANJI,        /* 0x945a */
    KANJI,        /* 0x945b */
    KANJI,        /* 0x945c */
    KANJI,        /* 0x945d */
    KANJI,        /* 0x945e */
    KANJI,        /* 0x945f */
    KANJI,        /* 0x9460 */
    KANJI,        /* 0x9461 */
    KANJI,        /* 0x9462 */
    KANJI,        /* 0x9463 */
    KANJI,        /* 0x9464 */
    KANJI,        /* 0x9465 */
    KANJI,        /* 0x9466 */
    KANJI,        /* 0x9467 */
    KANJI,        /* 0x9468 */
    KANJI,        /* 0x9469 */
    KANJI,        /* 0x946a */
    KANJI,        /* 0x946b */
    KANJI,        /* 0x946c */
    KANJI,        /* 0x946d */
    KANJI,        /* 0x946e */
    KANJI,        /* 0x946f */
    KANJI,        /* 0x9470 */
    KANJI,        /* 0x9471 */
    KANJI,        /* 0x9472 */
    KANJI,        /* 0x9473 */
    KANJI,        /* 0x9474 */
    KANJI,        /* 0x9475 */
    KANJI,        /* 0x9476 */
    KANJI,        /* 0x9477 */
    KANJI,        /* 0x9478 */
    KANJI,        /* 0x9479 */
    KANJI,        /* 0x947a */
    KANJI,        /* 0x947b */
    KANJI,        /* 0x947c */
    KANJI,        /* 0x947d */
    KANJI,        /* 0x947e */
    KANJI,        /* 0x947f */
    KANJI,        /* 0x9480 */
    KANJI,        /* 0x9481 */
    KANJI,        /* 0x9482 */
    KANJI,        /* 0x9483 */
    KANJI,        /* 0x9484 */
    KANJI,        /* 0x9485 */
    KANJI,        /* 0x9486 */
    KANJI,        /* 0x9487 */
    KANJI,        /* 0x9488 */
    KANJI,        /* 0x9489 */
    KANJI,        /* 0x948a */
    KANJI,        /* 0x948b */
    KANJI,        /* 0x948c */
    KANJI,        /* 0x948d */
    KANJI,        /* 0x948e */
    KANJI,        /* 0x948f */
    KANJI,        /* 0x9490 */
    KANJI,        /* 0x9491 */
    KANJI,        /* 0x9492 */
    KANJI,        /* 0x9493 */
    KANJI,        /* 0x9494 */
    KANJI,        /* 0x9495 */
    KANJI,        /* 0x9496 */
    KANJI,        /* 0x9497 */
    KANJI,        /* 0x9498 */
    KANJI,        /* 0x9499 */
    KANJI,        /* 0x949a */
    KANJI,        /* 0x949b */
    KANJI,        /* 0x949c */
    KANJI,        /* 0x949d */
    KANJI,        /* 0x949e */
    KANJI,        /* 0x949f */
    KANJI,        /* 0x94a0 */
    KANJI,        /* 0x94a1 */
    KANJI,        /* 0x94a2 */
    KANJI,        /* 0x94a3 */
    KANJI,        /* 0x94a4 */
    KANJI,        /* 0x94a5 */
    KANJI,        /* 0x94a6 */
    KANJI,        /* 0x94a7 */
    KANJI,        /* 0x94a8 */
    KANJI,        /* 0x94a9 */
    KANJI,        /* 0x94aa */
    KANJI,        /* 0x94ab */
    KANJI,        /* 0x94ac */
    KANJI,        /* 0x94ad */
    KANJI,        /* 0x94ae */
    KANJI,        /* 0x94af */
    KANJI,        /* 0x94b0 */
    KANJI,        /* 0x94b1 */
    KANJI,        /* 0x94b2 */
    KANJI,        /* 0x94b3 */
    KANJI,        /* 0x94b4 */
    KANJI,        /* 0x94b5 */
    KANJI,        /* 0x94b6 */
    KANJI,        /* 0x94b7 */
    KANJI,        /* 0x94b8 */
    KANJI,        /* 0x94b9 */
    KANJI,        /* 0x94ba */
    KANJI,        /* 0x94bb */
    KANJI,        /* 0x94bc */
    KANJI,        /* 0x94bd */
    KANJI,        /* 0x94be */
    KANJI,        /* 0x94bf */
    KANJI,        /* 0x94c0 */
    KANJI,        /* 0x94c1 */
    KANJI,        /* 0x94c2 */
    KANJI,        /* 0x94c3 */
    KANJI,        /* 0x94c4 */
    KANJI,        /* 0x94c5 */
    KANJI,        /* 0x94c6 */
    KANJI,        /* 0x94c7 */
    KANJI,        /* 0x94c8 */
    KANJI,        /* 0x94c9 */
    KANJI,        /* 0x94ca */
    KANJI,        /* 0x94cb */
    KANJI,        /* 0x94cc */
    KANJI,        /* 0x94cd */
    KANJI,        /* 0x94ce */
    KANJI,        /* 0x94cf */
    KANJI,        /* 0x94d0 */
    KANJI,        /* 0x94d1 */
    KANJI,        /* 0x94d2 */
    KANJI,        /* 0x94d3 */
    KANJI,        /* 0x94d4 */
    KANJI,        /* 0x94d5 */
    KANJI,        /* 0x94d6 */
    KANJI,        /* 0x94d7 */
    KANJI,        /* 0x94d8 */
    KANJI,        /* 0x94d9 */
    KANJI,        /* 0x94da */
    KANJI,        /* 0x94db */
    KANJI,        /* 0x94dc */
    KANJI,        /* 0x94dd */
    KANJI,        /* 0x94de */
    KANJI,        /* 0x94df */
    KANJI,        /* 0x94e0 */
    KANJI,        /* 0x94e1 */
    KANJI,        /* 0x94e2 */
    KANJI,        /* 0x94e3 */
    KANJI,        /* 0x94e4 */
    KANJI,        /* 0x94e5 */
    KANJI,        /* 0x94e6 */
    KANJI,        /* 0x94e7 */
    KANJI,        /* 0x94e8 */
    KANJI,        /* 0x94e9 */
    KANJI,        /* 0x94ea */
    KANJI,        /* 0x94eb */
    KANJI,        /* 0x94ec */
    KANJI,        /* 0x94ed */
    KANJI,        /* 0x94ee */
    KANJI,        /* 0x94ef */
    KANJI,        /* 0x94f0 */
    KANJI,        /* 0x94f1 */
    KANJI,        /* 0x94f2 */
    KANJI,        /* 0x94f3 */
    KANJI,        /* 0x94f4 */
    KANJI,        /* 0x94f5 */
    KANJI,        /* 0x94f6 */
    KANJI,        /* 0x94f7 */
    KANJI,        /* 0x94f8 */
    KANJI,        /* 0x94f9 */
    KANJI,        /* 0x94fa */
    KANJI,        /* 0x94fb */
    KANJI,        /* 0x94fc */
    KANJI,        /* 0x94fd */
    KANJI,        /* 0x94fe */
    KANJI,        /* 0x94ff */
    KANJI,        /* 0x9500 */
    KANJI,        /* 0x9501 */
    KANJI,        /* 0x9502 */
    KANJI,        /* 0x9503 */
    KANJI,        /* 0x9504 */
    KANJI,        /* 0x9505 */
    KANJI,        /* 0x9506 */
    KANJI,        /* 0x9507 */
    KANJI,        /* 0x9508 */
    KANJI,        /* 0x9509 */
    KANJI,        /* 0x950a */
    KANJI,        /* 0x950b */
    KANJI,        /* 0x950c */
    KANJI,        /* 0x950d */
    KANJI,        /* 0x950e */
    KANJI,        /* 0x950f */
    KANJI,        /* 0x9510 */
    KANJI,        /* 0x9511 */
    KANJI,        /* 0x9512 */
    KANJI,        /* 0x9513 */
    KANJI,        /* 0x9514 */
    KANJI,        /* 0x9515 */
    KANJI,        /* 0x9516 */
    KANJI,        /* 0x9517 */
    KANJI,        /* 0x9518 */
    KANJI,        /* 0x9519 */
    KANJI,        /* 0x951a */
    KANJI,        /* 0x951b */
    KANJI,        /* 0x951c */
    KANJI,        /* 0x951d */
    KANJI,        /* 0x951e */
    KANJI,        /* 0x951f */
    KANJI,        /* 0x9520 */
    KANJI,        /* 0x9521 */
    KANJI,        /* 0x9522 */
    KANJI,        /* 0x9523 */
    KANJI,        /* 0x9524 */
    KANJI,        /* 0x9525 */
    KANJI,        /* 0x9526 */
    KANJI,        /* 0x9527 */
    KANJI,        /* 0x9528 */
    KANJI,        /* 0x9529 */
    KANJI,        /* 0x952a */
    KANJI,        /* 0x952b */
    KANJI,        /* 0x952c */
    KANJI,        /* 0x952d */
    KANJI,        /* 0x952e */
    KANJI,        /* 0x952f */
    KANJI,        /* 0x9530 */
    KANJI,        /* 0x9531 */
    KANJI,        /* 0x9532 */
    KANJI,        /* 0x9533 */
    KANJI,        /* 0x9534 */
    KANJI,        /* 0x9535 */
    KANJI,        /* 0x9536 */
    KANJI,        /* 0x9537 */
    KANJI,        /* 0x9538 */
    KANJI,        /* 0x9539 */
    KANJI,        /* 0x953a */
    KANJI,        /* 0x953b */
    KANJI,        /* 0x953c */
    KANJI,        /* 0x953d */
    KANJI,        /* 0x953e */
    KANJI,        /* 0x953f */
    KANJI,        /* 0x9540 */
    KANJI,        /* 0x9541 */
    KANJI,        /* 0x9542 */
    KANJI,        /* 0x9543 */
    KANJI,        /* 0x9544 */
    KANJI,        /* 0x9545 */
    KANJI,        /* 0x9546 */
    KANJI,        /* 0x9547 */
    KANJI,        /* 0x9548 */
    KANJI,        /* 0x9549 */
    KANJI,        /* 0x954a */
    KANJI,        /* 0x954b */
    KANJI,        /* 0x954c */
    KANJI,        /* 0x954d */
    KANJI,        /* 0x954e */
    KANJI,        /* 0x954f */
    KANJI,        /* 0x9550 */
    KANJI,        /* 0x9551 */
    KANJI,        /* 0x9552 */
    KANJI,        /* 0x9553 */
    KANJI,        /* 0x9554 */
    KANJI,        /* 0x9555 */
    KANJI,        /* 0x9556 */
    KANJI,        /* 0x9557 */
    KANJI,        /* 0x9558 */
    KANJI,        /* 0x9559 */
    KANJI,        /* 0x955a */
    KANJI,        /* 0x955b */
    KANJI,        /* 0x955c */
    KANJI,        /* 0x955d */
    KANJI,        /* 0x955e */
    KANJI,        /* 0x955f */
    KANJI,        /* 0x9560 */
    KANJI,        /* 0x9561 */
    KANJI,        /* 0x9562 */
    KANJI,        /* 0x9563 */
    KANJI,        /* 0x9564 */
    KANJI,        /* 0x9565 */
    KANJI,        /* 0x9566 */
    KANJI,        /* 0x9567 */
    KANJI,        /* 0x9568 */
    KANJI,        /* 0x9569 */
    KANJI,        /* 0x956a */
    KANJI,        /* 0x956b */
    KANJI,        /* 0x956c */
    KANJI,        /* 0x956d */
    KANJI,        /* 0x956e */
    KANJI,        /* 0x956f */
    KANJI,        /* 0x9570 */
    KANJI,        /* 0x9571 */
    KANJI,        /* 0x9572 */
    KANJI,        /* 0x9573 */
    KANJI,        /* 0x9574 */
    KANJI,        /* 0x9575 */
    KANJI,        /* 0x9576 */
    KANJI,        /* 0x9577 */
    KANJI,        /* 0x9578 */
    KANJI,        /* 0x9579 */
    KANJI,        /* 0x957a */
    KANJI,        /* 0x957b */
    KANJI,        /* 0x957c */
    KANJI,        /* 0x957d */
    KANJI,        /* 0x957e */
    KANJI,        /* 0x957f */
    KANJI,        /* 0x9580 */
    KANJI,        /* 0x9581 */
    KANJI,        /* 0x9582 */
    KANJI,        /* 0x9583 */
    KANJI,        /* 0x9584 */
    KANJI,        /* 0x9585 */
    KANJI,        /* 0x9586 */
    KANJI,        /* 0x9587 */
    KANJI,        /* 0x9588 */
    KANJI,        /* 0x9589 */
    KANJI,        /* 0x958a */
    KANJI,        /* 0x958b */
    KANJI,        /* 0x958c */
    KANJI,        /* 0x958d */
    KANJI,        /* 0x958e */
    KANJI,        /* 0x958f */
    KANJI,        /* 0x9590 */
    KANJI,        /* 0x9591 */
    KANJI,        /* 0x9592 */
    KANJI,        /* 0x9593 */
    KANJI,        /* 0x9594 */
    KANJI,        /* 0x9595 */
    KANJI,        /* 0x9596 */
    KANJI,        /* 0x9597 */
    KANJI,        /* 0x9598 */
    KANJI,        /* 0x9599 */
    KANJI,        /* 0x959a */
    KANJI,        /* 0x959b */
    KANJI,        /* 0x959c */
    KANJI,        /* 0x959d */
    KANJI,        /* 0x959e */
    KANJI,        /* 0x959f */
    KANJI,        /* 0x95a0 */
    KANJI,        /* 0x95a1 */
    KANJI,        /* 0x95a2 */
    KANJI,        /* 0x95a3 */
    KANJI,        /* 0x95a4 */
    KANJI,        /* 0x95a5 */
    KANJI,        /* 0x95a6 */
    KANJI,        /* 0x95a7 */
    KANJI,        /* 0x95a8 */
    KANJI,        /* 0x95a9 */
    KANJI,        /* 0x95aa */
    KANJI,        /* 0x95ab */
    KANJI,        /* 0x95ac */
    KANJI,        /* 0x95ad */
    KANJI,        /* 0x95ae */
    KANJI,        /* 0x95af */
    KANJI,        /* 0x95b0 */
    KANJI,        /* 0x95b1 */
    KANJI,        /* 0x95b2 */
    KANJI,        /* 0x95b3 */
    KANJI,        /* 0x95b4 */
    KANJI,        /* 0x95b5 */
    KANJI,        /* 0x95b6 */
    KANJI,        /* 0x95b7 */
    KANJI,        /* 0x95b8 */
    KANJI,        /* 0x95b9 */
    KANJI,        /* 0x95ba */
    KANJI,        /* 0x95bb */
    KANJI,        /* 0x95bc */
    KANJI,        /* 0x95bd */
    KANJI,        /* 0x95be */
    KANJI,        /* 0x95bf */
    KANJI,        /* 0x95c0 */
    KANJI,        /* 0x95c1 */
    KANJI,        /* 0x95c2 */
    KANJI,        /* 0x95c3 */
    KANJI,        /* 0x95c4 */
    KANJI,        /* 0x95c5 */
    KANJI,        /* 0x95c6 */
    KANJI,        /* 0x95c7 */
    KANJI,        /* 0x95c8 */
    KANJI,        /* 0x95c9 */
    KANJI,        /* 0x95ca */
    KANJI,        /* 0x95cb */
    KANJI,        /* 0x95cc */
    KANJI,        /* 0x95cd */
    KANJI,        /* 0x95ce */
    KANJI,        /* 0x95cf */
    KANJI,        /* 0x95d0 */
    KANJI,        /* 0x95d1 */
    KANJI,        /* 0x95d2 */
    KANJI,        /* 0x95d3 */
    KANJI,        /* 0x95d4 */
    KANJI,        /* 0x95d5 */
    KANJI,        /* 0x95d6 */
    KANJI,        /* 0x95d7 */
    KANJI,        /* 0x95d8 */
    KANJI,        /* 0x95d9 */
    KANJI,        /* 0x95da */
    KANJI,        /* 0x95db */
    KANJI,        /* 0x95dc */
    KANJI,        /* 0x95dd */
    KANJI,        /* 0x95de */
    KANJI,        /* 0x95df */
    KANJI,        /* 0x95e0 */
    KANJI,        /* 0x95e1 */
    KANJI,        /* 0x95e2 */
    KANJI,        /* 0x95e3 */
    KANJI,        /* 0x95e4 */
    KANJI,        /* 0x95e5 */
    KANJI,        /* 0x95e6 */
    KANJI,        /* 0x95e7 */
    KANJI,        /* 0x95e8 */
    KANJI,        /* 0x95e9 */
    KANJI,        /* 0x95ea */
    KANJI,        /* 0x95eb */
    KANJI,        /* 0x95ec */
    KANJI,        /* 0x95ed */
    KANJI,        /* 0x95ee */
    KANJI,        /* 0x95ef */
    KANJI,        /* 0x95f0 */
    KANJI,        /* 0x95f1 */
    KANJI,        /* 0x95f2 */
    KANJI,        /* 0x95f3 */
    KANJI,        /* 0x95f4 */
    KANJI,        /* 0x95f5 */
    KANJI,        /* 0x95f6 */
    KANJI,        /* 0x95f7 */
    KANJI,        /* 0x95f8 */
    KANJI,        /* 0x95f9 */
    KANJI,        /* 0x95fa */
    KANJI,        /* 0x95fb */
    KANJI,        /* 0x95fc */
    KANJI,        /* 0x95fd */
    KANJI,        /* 0x95fe */
    KANJI,        /* 0x95ff */
    KANJI,        /* 0x9600 */
    KANJI,        /* 0x9601 */
    KANJI,        /* 0x9602 */
    KANJI,        /* 0x9603 */
    KANJI,        /* 0x9604 */
    KANJI,        /* 0x9605 */
    KANJI,        /* 0x9606 */
    KANJI,        /* 0x9607 */
    KANJI,        /* 0x9608 */
    KANJI,        /* 0x9609 */
    KANJI,        /* 0x960a */
    KANJI,        /* 0x960b */
    KANJI,        /* 0x960c */
    KANJI,        /* 0x960d */
    KANJI,        /* 0x960e */
    KANJI,        /* 0x960f */
    KANJI,        /* 0x9610 */
    KANJI,        /* 0x9611 */
    KANJI,        /* 0x9612 */
    KANJI,        /* 0x9613 */
    KANJI,        /* 0x9614 */
    KANJI,        /* 0x9615 */
    KANJI,        /* 0x9616 */
    KANJI,        /* 0x9617 */
    KANJI,        /* 0x9618 */
    KANJI,        /* 0x9619 */
    KANJI,        /* 0x961a */
    KANJI,        /* 0x961b */
    KANJI,        /* 0x961c */
    KANJI,        /* 0x961d */
    KANJI,        /* 0x961e */
    KANJI,        /* 0x961f */
    KANJI,        /* 0x9620 */
    KANJI,        /* 0x9621 */
    KANJI,        /* 0x9622 */
    KANJI,        /* 0x9623 */
    KANJI,        /* 0x9624 */
    KANJI,        /* 0x9625 */
    KANJI,        /* 0x9626 */
    KANJI,        /* 0x9627 */
    KANJI,        /* 0x9628 */
    KANJI,        /* 0x9629 */
    KANJI,        /* 0x962a */
    KANJI,        /* 0x962b */
    KANJI,        /* 0x962c */
    KANJI,        /* 0x962d */
    KANJI,        /* 0x962e */
    KANJI,        /* 0x962f */
    KANJI,        /* 0x9630 */
    KANJI,        /* 0x9631 */
    KANJI,        /* 0x9632 */
    KANJI,        /* 0x9633 */
    KANJI,        /* 0x9634 */
    KANJI,        /* 0x9635 */
    KANJI,        /* 0x9636 */
    KANJI,        /* 0x9637 */
    KANJI,        /* 0x9638 */
    KANJI,        /* 0x9639 */
    KANJI,        /* 0x963a */
    KANJI,        /* 0x963b */
    KANJI,        /* 0x963c */
    KANJI,        /* 0x963d */
    KANJI,        /* 0x963e */
    KANJI,        /* 0x963f */
    KANJI,        /* 0x9640 */
    KANJI,        /* 0x9641 */
    KANJI,        /* 0x9642 */
    KANJI,        /* 0x9643 */
    KANJI,        /* 0x9644 */
    KANJI,        /* 0x9645 */
    KANJI,        /* 0x9646 */
    KANJI,        /* 0x9647 */
    KANJI,        /* 0x9648 */
    KANJI,        /* 0x9649 */
    KANJI,        /* 0x964a */
    KANJI,        /* 0x964b */
    KANJI,        /* 0x964c */
    KANJI,        /* 0x964d */
    KANJI,        /* 0x964e */
    KANJI,        /* 0x964f */
    KANJI,        /* 0x9650 */
    KANJI,        /* 0x9651 */
    KANJI,        /* 0x9652 */
    KANJI,        /* 0x9653 */
    KANJI,        /* 0x9654 */
    KANJI,        /* 0x9655 */
    KANJI,        /* 0x9656 */
    KANJI,        /* 0x9657 */
    KANJI,        /* 0x9658 */
    KANJI,        /* 0x9659 */
    KANJI,        /* 0x965a */
    KANJI,        /* 0x965b */
    KANJI,        /* 0x965c */
    KANJI,        /* 0x965d */
    KANJI,        /* 0x965e */
    KANJI,        /* 0x965f */
    KANJI,        /* 0x9660 */
    KANJI,        /* 0x9661 */
    KANJI,        /* 0x9662 */
    KANJI,        /* 0x9663 */
    KANJI,        /* 0x9664 */
    KANJI,        /* 0x9665 */
    KANJI,        /* 0x9666 */
    KANJI,        /* 0x9667 */
    KANJI,        /* 0x9668 */
    KANJI,        /* 0x9669 */
    KANJI,        /* 0x966a */
    KANJI,        /* 0x966b */
    KANJI,        /* 0x966c */
    KANJI,        /* 0x966d */
    KANJI,        /* 0x966e */
    KANJI,        /* 0x966f */
    KANJI,        /* 0x9670 */
    KANJI,        /* 0x9671 */
    KANJI,        /* 0x9672 */
    KANJI,        /* 0x9673 */
    KANJI,        /* 0x9674 */
    KANJI,        /* 0x9675 */
    KANJI,        /* 0x9676 */
    KANJI,        /* 0x9677 */
    KANJI,        /* 0x9678 */
    KANJI,        /* 0x9679 */
    KANJI,        /* 0x967a */
    KANJI,        /* 0x967b */
    KANJI,        /* 0x967c */
    KANJI,        /* 0x967d */
    KANJI,        /* 0x967e */
    KANJI,        /* 0x967f */
    KANJI,        /* 0x9680 */
    KANJI,        /* 0x9681 */
    KANJI,        /* 0x9682 */
    KANJI,        /* 0x9683 */
    KANJI,        /* 0x9684 */
    KANJI,        /* 0x9685 */
    KANJI,        /* 0x9686 */
    KANJI,        /* 0x9687 */
    KANJI,        /* 0x9688 */
    KANJI,        /* 0x9689 */
    KANJI,        /* 0x968a */
    KANJI,        /* 0x968b */
    KANJI,        /* 0x968c */
    KANJI,        /* 0x968d */
    KANJI,        /* 0x968e */
    KANJI,        /* 0x968f */
    KANJI,        /* 0x9690 */
    KANJI,        /* 0x9691 */
    KANJI,        /* 0x9692 */
    KANJI,        /* 0x9693 */
    KANJI,        /* 0x9694 */
    KANJI,        /* 0x9695 */
    KANJI,        /* 0x9696 */
    KANJI,        /* 0x9697 */
    KANJI,        /* 0x9698 */
    KANJI,        /* 0x9699 */
    KANJI,        /* 0x969a */
    KANJI,        /* 0x969b */
    KANJI,        /* 0x969c */
    KANJI,        /* 0x969d */
    KANJI,        /* 0x969e */
    KANJI,        /* 0x969f */
    KANJI,        /* 0x96a0 */
    KANJI,        /* 0x96a1 */
    KANJI,        /* 0x96a2 */
    KANJI,        /* 0x96a3 */
    KANJI,        /* 0x96a4 */
    KANJI,        /* 0x96a5 */
    KANJI,        /* 0x96a6 */
    KANJI,        /* 0x96a7 */
    KANJI,        /* 0x96a8 */
    KANJI,        /* 0x96a9 */
    KANJI,        /* 0x96aa */
    KANJI,        /* 0x96ab */
    KANJI,        /* 0x96ac */
    KANJI,        /* 0x96ad */
    KANJI,        /* 0x96ae */
    KANJI,        /* 0x96af */
    KANJI,        /* 0x96b0 */
    KANJI,        /* 0x96b1 */
    KANJI,        /* 0x96b2 */
    KANJI,        /* 0x96b3 */
    KANJI,        /* 0x96b4 */
    KANJI,        /* 0x96b5 */
    KANJI,        /* 0x96b6 */
    KANJI,        /* 0x96b7 */
    KANJI,        /* 0x96b8 */
    KANJI,        /* 0x96b9 */
    KANJI,        /* 0x96ba */
    KANJI,        /* 0x96bb */
    KANJI,        /* 0x96bc */
    KANJI,        /* 0x96bd */
    KANJI,        /* 0x96be */
    KANJI,        /* 0x96bf */
    KANJI,        /* 0x96c0 */
    KANJI,        /* 0x96c1 */
    KANJI,        /* 0x96c2 */
    KANJI,        /* 0x96c3 */
    KANJI,        /* 0x96c4 */
    KANJI,        /* 0x96c5 */
    KANJI,        /* 0x96c6 */
    KANJI,        /* 0x96c7 */
    KANJI,        /* 0x96c8 */
    KANJI,        /* 0x96c9 */
    KANJI,        /* 0x96ca */
    KANJI,        /* 0x96cb */
    KANJI,        /* 0x96cc */
    KANJI,        /* 0x96cd */
    KANJI,        /* 0x96ce */
    KANJI,        /* 0x96cf */
    KANJI,        /* 0x96d0 */
    KANJI,        /* 0x96d1 */
    KANJI,        /* 0x96d2 */
    KANJI,        /* 0x96d3 */
    KANJI,        /* 0x96d4 */
    KANJI,        /* 0x96d5 */
    KANJI,        /* 0x96d6 */
    KANJI,        /* 0x96d7 */
    KANJI,        /* 0x96d8 */
    KANJI,        /* 0x96d9 */
    KANJI,        /* 0x96da */
    KANJI,        /* 0x96db */
    KANJI,        /* 0x96dc */
    KANJI,        /* 0x96dd */
    KANJI,        /* 0x96de */
    KANJI,        /* 0x96df */
    KANJI,        /* 0x96e0 */
    KANJI,        /* 0x96e1 */
    KANJI,        /* 0x96e2 */
    KANJI,        /* 0x96e3 */
    KANJI,        /* 0x96e4 */
    KANJI,        /* 0x96e5 */
    KANJI,        /* 0x96e6 */
    KANJI,        /* 0x96e7 */
    KANJI,        /* 0x96e8 */
    KANJI,        /* 0x96e9 */
    KANJI,        /* 0x96ea */
    KANJI,        /* 0x96eb */
    KANJI,        /* 0x96ec */
    KANJI,        /* 0x96ed */
    KANJI,        /* 0x96ee */
    KANJI,        /* 0x96ef */
    KANJI,        /* 0x96f0 */
    KANJI,        /* 0x96f1 */
    KANJI,        /* 0x96f2 */
    KANJI,        /* 0x96f3 */
    KANJI,        /* 0x96f4 */
    KANJI,        /* 0x96f5 */
    KANJI,        /* 0x96f6 */
    KANJI,        /* 0x96f7 */
    KANJI,        /* 0x96f8 */
    KANJI,        /* 0x96f9 */
    KANJI,        /* 0x96fa */
    KANJI,        /* 0x96fb */
    KANJI,        /* 0x96fc */
    KANJI,        /* 0x96fd */
    KANJI,        /* 0x96fe */
    KANJI,        /* 0x96ff */
    KANJI,        /* 0x9700 */
    KANJI,        /* 0x9701 */
    KANJI,        /* 0x9702 */
    KANJI,        /* 0x9703 */
    KANJI,        /* 0x9704 */
    KANJI,        /* 0x9705 */
    KANJI,        /* 0x9706 */
    KANJI,        /* 0x9707 */
    KANJI,        /* 0x9708 */
    KANJI,        /* 0x9709 */
    KANJI,        /* 0x970a */
    KANJI,        /* 0x970b */
    KANJI,        /* 0x970c */
    KANJI,        /* 0x970d */
    KANJI,        /* 0x970e */
    KANJI,        /* 0x970f */
    KANJI,        /* 0x9710 */
    KANJI,        /* 0x9711 */
    KANJI,        /* 0x9712 */
    KANJI,        /* 0x9713 */
    KANJI,        /* 0x9714 */
    KANJI,        /* 0x9715 */
    KANJI,        /* 0x9716 */
    KANJI,        /* 0x9717 */
    KANJI,        /* 0x9718 */
    KANJI,        /* 0x9719 */
    KANJI,        /* 0x971a */
    KANJI,        /* 0x971b */
    KANJI,        /* 0x971c */
    KANJI,        /* 0x971d */
    KANJI,        /* 0x971e */
    KANJI,        /* 0x971f */
    KANJI,        /* 0x9720 */
    KANJI,        /* 0x9721 */
    KANJI,        /* 0x9722 */
    KANJI,        /* 0x9723 */
    KANJI,        /* 0x9724 */
    KANJI,        /* 0x9725 */
    KANJI,        /* 0x9726 */
    KANJI,        /* 0x9727 */
    KANJI,        /* 0x9728 */
    KANJI,        /* 0x9729 */
    KANJI,        /* 0x972a */
    KANJI,        /* 0x972b */
    KANJI,        /* 0x972c */
    KANJI,        /* 0x972d */
    KANJI,        /* 0x972e */
    KANJI,        /* 0x972f */
    KANJI,        /* 0x9730 */
    KANJI,        /* 0x9731 */
    KANJI,        /* 0x9732 */
    KANJI,        /* 0x9733 */
    KANJI,        /* 0x9734 */
    KANJI,        /* 0x9735 */
    KANJI,        /* 0x9736 */
    KANJI,        /* 0x9737 */
    KANJI,        /* 0x9738 */
    KANJI,        /* 0x9739 */
    KANJI,        /* 0x973a */
    KANJI,        /* 0x973b */
    KANJI,        /* 0x973c */
    KANJI,        /* 0x973d */
    KANJI,        /* 0x973e */
    KANJI,        /* 0x973f */
    KANJI,        /* 0x9740 */
    KANJI,        /* 0x9741 */
    KANJI,        /* 0x9742 */
    KANJI,        /* 0x9743 */
    KANJI,        /* 0x9744 */
    KANJI,        /* 0x9745 */
    KANJI,        /* 0x9746 */
    KANJI,        /* 0x9747 */
    KANJI,        /* 0x9748 */
    KANJI,        /* 0x9749 */
    KANJI,        /* 0x974a */
    KANJI,        /* 0x974b */
    KANJI,        /* 0x974c */
    KANJI,        /* 0x974d */
    KANJI,        /* 0x974e */
    KANJI,        /* 0x974f */
    KANJI,        /* 0x9750 */
    KANJI,        /* 0x9751 */
    KANJI,        /* 0x9752 */
    KANJI,        /* 0x9753 */
    KANJI,        /* 0x9754 */
    KANJI,        /* 0x9755 */
    KANJI,        /* 0x9756 */
    KANJI,        /* 0x9757 */
    KANJI,        /* 0x9758 */
    KANJI,        /* 0x9759 */
    KANJI,        /* 0x975a */
    KANJI,        /* 0x975b */
    KANJI,        /* 0x975c */
    KANJI,        /* 0x975d */
    KANJI,        /* 0x975e */
    KANJI,        /* 0x975f */
    KANJI,        /* 0x9760 */
    KANJI,        /* 0x9761 */
    KANJI,        /* 0x9762 */
    KANJI,        /* 0x9763 */
    KANJI,        /* 0x9764 */
    KANJI,        /* 0x9765 */
    KANJI,        /* 0x9766 */
    KANJI,        /* 0x9767 */
    KANJI,        /* 0x9768 */
    KANJI,        /* 0x9769 */
    KANJI,        /* 0x976a */
    KANJI,        /* 0x976b */
    KANJI,        /* 0x976c */
    KANJI,        /* 0x976d */
    KANJI,        /* 0x976e */
    KANJI,        /* 0x976f */
    KANJI,        /* 0x9770 */
    KANJI,        /* 0x9771 */
    KANJI,        /* 0x9772 */
    KANJI,        /* 0x9773 */
    KANJI,        /* 0x9774 */
    KANJI,        /* 0x9775 */
    KANJI,        /* 0x9776 */
    KANJI,        /* 0x9777 */
    KANJI,        /* 0x9778 */
    KANJI,        /* 0x9779 */
    KANJI,        /* 0x977a */
    KANJI,        /* 0x977b */
    KANJI,        /* 0x977c */
    KANJI,        /* 0x977d */
    KANJI,        /* 0x977e */
    KANJI,        /* 0x977f */
    KANJI,        /* 0x9780 */
    KANJI,        /* 0x9781 */
    KANJI,        /* 0x9782 */
    KANJI,        /* 0x9783 */
    KANJI,        /* 0x9784 */
    KANJI,        /* 0x9785 */
    KANJI,        /* 0x9786 */
    KANJI,        /* 0x9787 */
    KANJI,        /* 0x9788 */
    KANJI,        /* 0x9789 */
    KANJI,        /* 0x978a */
    KANJI,        /* 0x978b */
    KANJI,        /* 0x978c */
    KANJI,        /* 0x978d */
    KANJI,        /* 0x978e */
    KANJI,        /* 0x978f */
    KANJI,        /* 0x9790 */
    KANJI,        /* 0x9791 */
    KANJI,        /* 0x9792 */
    KANJI,        /* 0x9793 */
    KANJI,        /* 0x9794 */
    KANJI,        /* 0x9795 */
    KANJI,        /* 0x9796 */
    KANJI,        /* 0x9797 */
    KANJI,        /* 0x9798 */
    KANJI,        /* 0x9799 */
    KANJI,        /* 0x979a */
    KANJI,        /* 0x979b */
    KANJI,        /* 0x979c */
    KANJI,        /* 0x979d */
    KANJI,        /* 0x979e */
    KANJI,        /* 0x979f */
    KANJI,        /* 0x97a0 */
    KANJI,        /* 0x97a1 */
    KANJI,        /* 0x97a2 */
    KANJI,        /* 0x97a3 */
    KANJI,        /* 0x97a4 */
    KANJI,        /* 0x97a5 */
    KANJI,        /* 0x97a6 */
    KANJI,        /* 0x97a7 */
    KANJI,        /* 0x97a8 */
    KANJI,        /* 0x97a9 */
    KANJI,        /* 0x97aa */
    KANJI,        /* 0x97ab */
    KANJI,        /* 0x97ac */
    KANJI,        /* 0x97ad */
    KANJI,        /* 0x97ae */
    KANJI,        /* 0x97af */
    KANJI,        /* 0x97b0 */
    KANJI,        /* 0x97b1 */
    KANJI,        /* 0x97b2 */
    KANJI,        /* 0x97b3 */
    KANJI,        /* 0x97b4 */
    KANJI,        /* 0x97b5 */
    KANJI,        /* 0x97b6 */
    KANJI,        /* 0x97b7 */
    KANJI,        /* 0x97b8 */
    KANJI,        /* 0x97b9 */
    KANJI,        /* 0x97ba */
    KANJI,        /* 0x97bb */
    KANJI,        /* 0x97bc */
    KANJI,        /* 0x97bd */
    KANJI,        /* 0x97be */
    KANJI,        /* 0x97bf */
    KANJI,        /* 0x97c0 */
    KANJI,        /* 0x97c1 */
    KANJI,        /* 0x97c2 */
    KANJI,        /* 0x97c3 */
    KANJI,        /* 0x97c4 */
    KANJI,        /* 0x97c5 */
    KANJI,        /* 0x97c6 */
    KANJI,        /* 0x97c7 */
    KANJI,        /* 0x97c8 */
    KANJI,        /* 0x97c9 */
    KANJI,        /* 0x97ca */
    KANJI,        /* 0x97cb */
    KANJI,        /* 0x97cc */
    KANJI,        /* 0x97cd */
    KANJI,        /* 0x97ce */
    KANJI,        /* 0x97cf */
    KANJI,        /* 0x97d0 */
    KANJI,        /* 0x97d1 */
    KANJI,        /* 0x97d2 */
    KANJI,        /* 0x97d3 */
    KANJI,        /* 0x97d4 */
    KANJI,        /* 0x97d5 */
    KANJI,        /* 0x97d6 */
    KANJI,        /* 0x97d7 */
    KANJI,        /* 0x97d8 */
    KANJI,        /* 0x97d9 */
    KANJI,        /* 0x97da */
    KANJI,        /* 0x97db */
    KANJI,        /* 0x97dc */
    KANJI,        /* 0x97dd */
    KANJI,        /* 0x97de */
    KANJI,        /* 0x97df */
    KANJI,        /* 0x97e0 */
    KANJI,        /* 0x97e1 */
    KANJI,        /* 0x97e2 */
    KANJI,        /* 0x97e3 */
    KANJI,        /* 0x97e4 */
    KANJI,        /* 0x97e5 */
    KANJI,        /* 0x97e6 */
    KANJI,        /* 0x97e7 */
    KANJI,        /* 0x97e8 */
    KANJI,        /* 0x97e9 */
    KANJI,        /* 0x97ea */
    KANJI,        /* 0x97eb */
    KANJI,        /* 0x97ec */
    KANJI,        /* 0x97ed */
    KANJI,        /* 0x97ee */
    KANJI,        /* 0x97ef */
    KANJI,        /* 0x97f0 */
    KANJI,        /* 0x97f1 */
    KANJI,        /* 0x97f2 */
    KANJI,        /* 0x97f3 */
    KANJI,        /* 0x97f4 */
    KANJI,        /* 0x97f5 */
    KANJI,        /* 0x97f6 */
    KANJI,        /* 0x97f7 */
    KANJI,        /* 0x97f8 */
    KANJI,        /* 0x97f9 */
    KANJI,        /* 0x97fa */
    KANJI,        /* 0x97fb */
    KANJI,        /* 0x97fc */
    KANJI,        /* 0x97fd */
    KANJI,        /* 0x97fe */
    KANJI,        /* 0x97ff */
    KANJI,        /* 0x9800 */
    KANJI,        /* 0x9801 */
    KANJI,        /* 0x9802 */
    KANJI,        /* 0x9803 */
    KANJI,        /* 0x9804 */
    KANJI,        /* 0x9805 */
    KANJI,        /* 0x9806 */
    KANJI,        /* 0x9807 */
    KANJI,        /* 0x9808 */
    KANJI,        /* 0x9809 */
    KANJI,        /* 0x980a */
    KANJI,        /* 0x980b */
    KANJI,        /* 0x980c */
    KANJI,        /* 0x980d */
    KANJI,        /* 0x980e */
    KANJI,        /* 0x980f */
    KANJI,        /* 0x9810 */
    KANJI,        /* 0x9811 */
    KANJI,        /* 0x9812 */
    KANJI,        /* 0x9813 */
    KANJI,        /* 0x9814 */
    KANJI,        /* 0x9815 */
    KANJI,        /* 0x9816 */
    KANJI,        /* 0x9817 */
    KANJI,        /* 0x9818 */
    KANJI,        /* 0x9819 */
    KANJI,        /* 0x981a */
    KANJI,        /* 0x981b */
    KANJI,        /* 0x981c */
    KANJI,        /* 0x981d */
    KANJI,        /* 0x981e */
    KANJI,        /* 0x981f */
    KANJI,        /* 0x9820 */
    KANJI,        /* 0x9821 */
    KANJI,        /* 0x9822 */
    KANJI,        /* 0x9823 */
    KANJI,        /* 0x9824 */
    KANJI,        /* 0x9825 */
    KANJI,        /* 0x9826 */
    KANJI,        /* 0x9827 */
    KANJI,        /* 0x9828 */
    KANJI,        /* 0x9829 */
    KANJI,        /* 0x982a */
    KANJI,        /* 0x982b */
    KANJI,        /* 0x982c */
    KANJI,        /* 0x982d */
    KANJI,        /* 0x982e */
    KANJI,        /* 0x982f */
    KANJI,        /* 0x9830 */
    KANJI,        /* 0x9831 */
    KANJI,        /* 0x9832 */
    KANJI,        /* 0x9833 */
    KANJI,        /* 0x9834 */
    KANJI,        /* 0x9835 */
    KANJI,        /* 0x9836 */
    KANJI,        /* 0x9837 */
    KANJI,        /* 0x9838 */
    KANJI,        /* 0x9839 */
    KANJI,        /* 0x983a */
    KANJI,        /* 0x983b */
    KANJI,        /* 0x983c */
    KANJI,        /* 0x983d */
    KANJI,        /* 0x983e */
    KANJI,        /* 0x983f */
    KANJI,        /* 0x9840 */
    KANJI,        /* 0x9841 */
    KANJI,        /* 0x9842 */
    KANJI,        /* 0x9843 */
    KANJI,        /* 0x9844 */
    KANJI,        /* 0x9845 */
    KANJI,        /* 0x9846 */
    KANJI,        /* 0x9847 */
    KANJI,        /* 0x9848 */
    KANJI,        /* 0x9849 */
    KANJI,        /* 0x984a */
    KANJI,        /* 0x984b */
    KANJI,        /* 0x984c */
    KANJI,        /* 0x984d */
    KANJI,        /* 0x984e */
    KANJI,        /* 0x984f */
    KANJI,        /* 0x9850 */
    KANJI,        /* 0x9851 */
    KANJI,        /* 0x9852 */
    KANJI,        /* 0x9853 */
    KANJI,        /* 0x9854 */
    KANJI,        /* 0x9855 */
    KANJI,        /* 0x9856 */
    KANJI,        /* 0x9857 */
    KANJI,        /* 0x9858 */
    KANJI,        /* 0x9859 */
    KANJI,        /* 0x985a */
    KANJI,        /* 0x985b */
    KANJI,        /* 0x985c */
    KANJI,        /* 0x985d */
    KANJI,        /* 0x985e */
    KANJI,        /* 0x985f */
    KANJI,        /* 0x9860 */
    KANJI,        /* 0x9861 */
    KANJI,        /* 0x9862 */
    KANJI,        /* 0x9863 */
    KANJI,        /* 0x9864 */
    KANJI,        /* 0x9865 */
    KANJI,        /* 0x9866 */
    KANJI,        /* 0x9867 */
    KANJI,        /* 0x9868 */
    KANJI,        /* 0x9869 */
    KANJI,        /* 0x986a */
    KANJI,        /* 0x986b */
    KANJI,        /* 0x986c */
    KANJI,        /* 0x986d */
    KANJI,        /* 0x986e */
    KANJI,        /* 0x986f */
    KANJI,        /* 0x9870 */
    KANJI,        /* 0x9871 */
    KANJI,        /* 0x9872 */
    KANJI,        /* 0x9873 */
    KANJI,        /* 0x9874 */
    KANJI,        /* 0x9875 */
    KANJI,        /* 0x9876 */
    KANJI,        /* 0x9877 */
    KANJI,        /* 0x9878 */
    KANJI,        /* 0x9879 */
    KANJI,        /* 0x987a */
    KANJI,        /* 0x987b */
    KANJI,        /* 0x987c */
    KANJI,        /* 0x987d */
    KANJI,        /* 0x987e */
    KANJI,        /* 0x987f */
    KANJI,        /* 0x9880 */
    KANJI,        /* 0x9881 */
    KANJI,        /* 0x9882 */
    KANJI,        /* 0x9883 */
    KANJI,        /* 0x9884 */
    KANJI,        /* 0x9885 */
    KANJI,        /* 0x9886 */
    KANJI,        /* 0x9887 */
    KANJI,        /* 0x9888 */
    KANJI,        /* 0x9889 */
    KANJI,        /* 0x988a */
    KANJI,        /* 0x988b */
    KANJI,        /* 0x988c */
    KANJI,        /* 0x988d */
    KANJI,        /* 0x988e */
    KANJI,        /* 0x988f */
    KANJI,        /* 0x9890 */
    KANJI,        /* 0x9891 */
    KANJI,        /* 0x9892 */
    KANJI,        /* 0x9893 */
    KANJI,        /* 0x9894 */
    KANJI,        /* 0x9895 */
    KANJI,        /* 0x9896 */
    KANJI,        /* 0x9897 */
    KANJI,        /* 0x9898 */
    KANJI,        /* 0x9899 */
    KANJI,        /* 0x989a */
    KANJI,        /* 0x989b */
    KANJI,        /* 0x989c */
    KANJI,        /* 0x989d */
    KANJI,        /* 0x989e */
    KANJI,        /* 0x989f */
    KANJI,        /* 0x98a0 */
    KANJI,        /* 0x98a1 */
    KANJI,        /* 0x98a2 */
    KANJI,        /* 0x98a3 */
    KANJI,        /* 0x98a4 */
    KANJI,        /* 0x98a5 */
    KANJI,        /* 0x98a6 */
    KANJI,        /* 0x98a7 */
    KANJI,        /* 0x98a8 */
    KANJI,        /* 0x98a9 */
    KANJI,        /* 0x98aa */
    KANJI,        /* 0x98ab */
    KANJI,        /* 0x98ac */
    KANJI,        /* 0x98ad */
    KANJI,        /* 0x98ae */
    KANJI,        /* 0x98af */
    KANJI,        /* 0x98b0 */
    KANJI,        /* 0x98b1 */
    KANJI,        /* 0x98b2 */
    KANJI,        /* 0x98b3 */
    KANJI,        /* 0x98b4 */
    KANJI,        /* 0x98b5 */
    KANJI,        /* 0x98b6 */
    KANJI,        /* 0x98b7 */
    KANJI,        /* 0x98b8 */
    KANJI,        /* 0x98b9 */
    KANJI,        /* 0x98ba */
    KANJI,        /* 0x98bb */
    KANJI,        /* 0x98bc */
    KANJI,        /* 0x98bd */
    KANJI,        /* 0x98be */
    KANJI,        /* 0x98bf */
    KANJI,        /* 0x98c0 */
    KANJI,        /* 0x98c1 */
    KANJI,        /* 0x98c2 */
    KANJI,        /* 0x98c3 */
    KANJI,        /* 0x98c4 */
    KANJI,        /* 0x98c5 */
    KANJI,        /* 0x98c6 */
    KANJI,        /* 0x98c7 */
    KANJI,        /* 0x98c8 */
    KANJI,        /* 0x98c9 */
    KANJI,        /* 0x98ca */
    KANJI,        /* 0x98cb */
    KANJI,        /* 0x98cc */
    KANJI,        /* 0x98cd */
    KANJI,        /* 0x98ce */
    KANJI,        /* 0x98cf */
    KANJI,        /* 0x98d0 */
    KANJI,        /* 0x98d1 */
    KANJI,        /* 0x98d2 */
    KANJI,        /* 0x98d3 */
    KANJI,        /* 0x98d4 */
    KANJI,        /* 0x98d5 */
    KANJI,        /* 0x98d6 */
    KANJI,        /* 0x98d7 */
    KANJI,        /* 0x98d8 */
    KANJI,        /* 0x98d9 */
    KANJI,        /* 0x98da */
    KANJI,        /* 0x98db */
    KANJI,        /* 0x98dc */
    KANJI,        /* 0x98dd */
    KANJI,        /* 0x98de */
    KANJI,        /* 0x98df */
    KANJI,        /* 0x98e0 */
    KANJI,        /* 0x98e1 */
    KANJI,        /* 0x98e2 */
    KANJI,        /* 0x98e3 */
    KANJI,        /* 0x98e4 */
    KANJI,        /* 0x98e5 */
    KANJI,        /* 0x98e6 */
    KANJI,        /* 0x98e7 */
    KANJI,        /* 0x98e8 */
    KANJI,        /* 0x98e9 */
    KANJI,        /* 0x98ea */
    KANJI,        /* 0x98eb */
    KANJI,        /* 0x98ec */
    KANJI,        /* 0x98ed */
    KANJI,        /* 0x98ee */
    KANJI,        /* 0x98ef */
    KANJI,        /* 0x98f0 */
    KANJI,        /* 0x98f1 */
    KANJI,        /* 0x98f2 */
    KANJI,        /* 0x98f3 */
    KANJI,        /* 0x98f4 */
    KANJI,        /* 0x98f5 */
    KANJI,        /* 0x98f6 */
    KANJI,        /* 0x98f7 */
    KANJI,        /* 0x98f8 */
    KANJI,        /* 0x98f9 */
    KANJI,        /* 0x98fa */
    KANJI,        /* 0x98fb */
    KANJI,        /* 0x98fc */
    KANJI,        /* 0x98fd */
    KANJI,        /* 0x98fe */
    KANJI,        /* 0x98ff */
    KANJI,        /* 0x9900 */
    KANJI,        /* 0x9901 */
    KANJI,        /* 0x9902 */
    KANJI,        /* 0x9903 */
    KANJI,        /* 0x9904 */
    KANJI,        /* 0x9905 */
    KANJI,        /* 0x9906 */
    KANJI,        /* 0x9907 */
    KANJI,        /* 0x9908 */
    KANJI,        /* 0x9909 */
    KANJI,        /* 0x990a */
    KANJI,        /* 0x990b */
    KANJI,        /* 0x990c */
    KANJI,        /* 0x990d */
    KANJI,        /* 0x990e */
    KANJI,        /* 0x990f */
    KANJI,        /* 0x9910 */
    KANJI,        /* 0x9911 */
    KANJI,        /* 0x9912 */
    KANJI,        /* 0x9913 */
    KANJI,        /* 0x9914 */
    KANJI,        /* 0x9915 */
    KANJI,        /* 0x9916 */
    KANJI,        /* 0x9917 */
    KANJI,        /* 0x9918 */
    KANJI,        /* 0x9919 */
    KANJI,        /* 0x991a */
    KANJI,        /* 0x991b */
    KANJI,        /* 0x991c */
    KANJI,        /* 0x991d */
    KANJI,        /* 0x991e */
    KANJI,        /* 0x991f */
    KANJI,        /* 0x9920 */
    KANJI,        /* 0x9921 */
    KANJI,        /* 0x9922 */
    KANJI,        /* 0x9923 */
    KANJI,        /* 0x9924 */
    KANJI,        /* 0x9925 */
    KANJI,        /* 0x9926 */
    KANJI,        /* 0x9927 */
    KANJI,        /* 0x9928 */
    KANJI,        /* 0x9929 */
    KANJI,        /* 0x992a */
    KANJI,        /* 0x992b */
    KANJI,        /* 0x992c */
    KANJI,        /* 0x992d */
    KANJI,        /* 0x992e */
    KANJI,        /* 0x992f */
    KANJI,        /* 0x9930 */
    KANJI,        /* 0x9931 */
    KANJI,        /* 0x9932 */
    KANJI,        /* 0x9933 */
    KANJI,        /* 0x9934 */
    KANJI,        /* 0x9935 */
    KANJI,        /* 0x9936 */
    KANJI,        /* 0x9937 */
    KANJI,        /* 0x9938 */
    KANJI,        /* 0x9939 */
    KANJI,        /* 0x993a */
    KANJI,        /* 0x993b */
    KANJI,        /* 0x993c */
    KANJI,        /* 0x993d */
    KANJI,        /* 0x993e */
    KANJI,        /* 0x993f */
    KANJI,        /* 0x9940 */
    KANJI,        /* 0x9941 */
    KANJI,        /* 0x9942 */
    KANJI,        /* 0x9943 */
    KANJI,        /* 0x9944 */
    KANJI,        /* 0x9945 */
    KANJI,        /* 0x9946 */
    KANJI,        /* 0x9947 */
    KANJI,        /* 0x9948 */
    KANJI,        /* 0x9949 */
    KANJI,        /* 0x994a */
    KANJI,        /* 0x994b */
    KANJI,        /* 0x994c */
    KANJI,        /* 0x994d */
    KANJI,        /* 0x994e */
    KANJI,        /* 0x994f */
    KANJI,        /* 0x9950 */
    KANJI,        /* 0x9951 */
    KANJI,        /* 0x9952 */
    KANJI,        /* 0x9953 */
    KANJI,        /* 0x9954 */
    KANJI,        /* 0x9955 */
    KANJI,        /* 0x9956 */
    KANJI,        /* 0x9957 */
    KANJI,        /* 0x9958 */
    KANJI,        /* 0x9959 */
    KANJI,        /* 0x995a */
    KANJI,        /* 0x995b */
    KANJI,        /* 0x995c */
    KANJI,        /* 0x995d */
    KANJI,        /* 0x995e */
    KANJI,        /* 0x995f */
    KANJI,        /* 0x9960 */
    KANJI,        /* 0x9961 */
    KANJI,        /* 0x9962 */
    KANJI,        /* 0x9963 */
    KANJI,        /* 0x9964 */
    KANJI,        /* 0x9965 */
    KANJI,        /* 0x9966 */
    KANJI,        /* 0x9967 */
    KANJI,        /* 0x9968 */
    KANJI,        /* 0x9969 */
    KANJI,        /* 0x996a */
    KANJI,        /* 0x996b */
    KANJI,        /* 0x996c */
    KANJI,        /* 0x996d */
    KANJI,        /* 0x996e */
    KANJI,        /* 0x996f */
    KANJI,        /* 0x9970 */
    KANJI,        /* 0x9971 */
    KANJI,        /* 0x9972 */
    KANJI,        /* 0x9973 */
    KANJI,        /* 0x9974 */
    KANJI,        /* 0x9975 */
    KANJI,        /* 0x9976 */
    KANJI,        /* 0x9977 */
    KANJI,        /* 0x9978 */
    KANJI,        /* 0x9979 */
    KANJI,        /* 0x997a */
    KANJI,        /* 0x997b */
    KANJI,        /* 0x997c */
    KANJI,        /* 0x997d */
    KANJI,        /* 0x997e */
    KANJI,        /* 0x997f */
    KANJI,        /* 0x9980 */
    KANJI,        /* 0x9981 */
    KANJI,        /* 0x9982 */
    KANJI,        /* 0x9983 */
    KANJI,        /* 0x9984 */
    KANJI,        /* 0x9985 */
    KANJI,        /* 0x9986 */
    KANJI,        /* 0x9987 */
    KANJI,        /* 0x9988 */
    KANJI,        /* 0x9989 */
    KANJI,        /* 0x998a */
    KANJI,        /* 0x998b */
    KANJI,        /* 0x998c */
    KANJI,        /* 0x998d */
    KANJI,        /* 0x998e */
    KANJI,        /* 0x998f */
    KANJI,        /* 0x9990 */
    KANJI,        /* 0x9991 */
    KANJI,        /* 0x9992 */
    KANJI,        /* 0x9993 */
    KANJI,        /* 0x9994 */
    KANJI,        /* 0x9995 */
    KANJI,        /* 0x9996 */
    KANJI,        /* 0x9997 */
    KANJI,        /* 0x9998 */
    KANJI,        /* 0x9999 */
    KANJI,        /* 0x999a */
    KANJI,        /* 0x999b */
    KANJI,        /* 0x999c */
    KANJI,        /* 0x999d */
    KANJI,        /* 0x999e */
    KANJI,        /* 0x999f */
    KANJI,        /* 0x99a0 */
    KANJI,        /* 0x99a1 */
    KANJI,        /* 0x99a2 */
    KANJI,        /* 0x99a3 */
    KANJI,        /* 0x99a4 */
    KANJI,        /* 0x99a5 */
    KANJI,        /* 0x99a6 */
    KANJI,        /* 0x99a7 */
    KANJI,        /* 0x99a8 */
    KANJI,        /* 0x99a9 */
    KANJI,        /* 0x99aa */
    KANJI,        /* 0x99ab */
    KANJI,        /* 0x99ac */
    KANJI,        /* 0x99ad */
    KANJI,        /* 0x99ae */
    KANJI,        /* 0x99af */
    KANJI,        /* 0x99b0 */
    KANJI,        /* 0x99b1 */
    KANJI,        /* 0x99b2 */
    KANJI,        /* 0x99b3 */
    KANJI,        /* 0x99b4 */
    KANJI,        /* 0x99b5 */
    KANJI,        /* 0x99b6 */
    KANJI,        /* 0x99b7 */
    KANJI,        /* 0x99b8 */
    KANJI,        /* 0x99b9 */
    KANJI,        /* 0x99ba */
    KANJI,        /* 0x99bb */
    KANJI,        /* 0x99bc */
    KANJI,        /* 0x99bd */
    KANJI,        /* 0x99be */
    KANJI,        /* 0x99bf */
    KANJI,        /* 0x99c0 */
    KANJI,        /* 0x99c1 */
    KANJI,        /* 0x99c2 */
    KANJI,        /* 0x99c3 */
    KANJI,        /* 0x99c4 */
    KANJI,        /* 0x99c5 */
    KANJI,        /* 0x99c6 */
    KANJI,        /* 0x99c7 */
    KANJI,        /* 0x99c8 */
    KANJI,        /* 0x99c9 */
    KANJI,        /* 0x99ca */
    KANJI,        /* 0x99cb */
    KANJI,        /* 0x99cc */
    KANJI,        /* 0x99cd */
    KANJI,        /* 0x99ce */
    KANJI,        /* 0x99cf */
    KANJI,        /* 0x99d0 */
    KANJI,        /* 0x99d1 */
    KANJI,        /* 0x99d2 */
    KANJI,        /* 0x99d3 */
    KANJI,        /* 0x99d4 */
    KANJI,        /* 0x99d5 */
    KANJI,        /* 0x99d6 */
    KANJI,        /* 0x99d7 */
    KANJI,        /* 0x99d8 */
    KANJI,        /* 0x99d9 */
    KANJI,        /* 0x99da */
    KANJI,        /* 0x99db */
    KANJI,        /* 0x99dc */
    KANJI,        /* 0x99dd */
    KANJI,        /* 0x99de */
    KANJI,        /* 0x99df */
    KANJI,        /* 0x99e0 */
    KANJI,        /* 0x99e1 */
    KANJI,        /* 0x99e2 */
    KANJI,        /* 0x99e3 */
    KANJI,        /* 0x99e4 */
    KANJI,        /* 0x99e5 */
    KANJI,        /* 0x99e6 */
    KANJI,        /* 0x99e7 */
    KANJI,        /* 0x99e8 */
    KANJI,        /* 0x99e9 */
    KANJI,        /* 0x99ea */
    KANJI,        /* 0x99eb */
    KANJI,        /* 0x99ec */
    KANJI,        /* 0x99ed */
    KANJI,        /* 0x99ee */
    KANJI,        /* 0x99ef */
    KANJI,        /* 0x99f0 */
    KANJI,        /* 0x99f1 */
    KANJI,        /* 0x99f2 */
    KANJI,        /* 0x99f3 */
    KANJI,        /* 0x99f4 */
    KANJI,        /* 0x99f5 */
    KANJI,        /* 0x99f6 */
    KANJI,        /* 0x99f7 */
    KANJI,        /* 0x99f8 */
    KANJI,        /* 0x99f9 */
    KANJI,        /* 0x99fa */
    KANJI,        /* 0x99fb */
    KANJI,        /* 0x99fc */
    KANJI,        /* 0x99fd */
    KANJI,        /* 0x99fe */
    KANJI,        /* 0x99ff */
    KANJI,        /* 0x9a00 */
    KANJI,        /* 0x9a01 */
    KANJI,        /* 0x9a02 */
    KANJI,        /* 0x9a03 */
    KANJI,        /* 0x9a04 */
    KANJI,        /* 0x9a05 */
    KANJI,        /* 0x9a06 */
    KANJI,        /* 0x9a07 */
    KANJI,        /* 0x9a08 */
    KANJI,        /* 0x9a09 */
    KANJI,        /* 0x9a0a */
    KANJI,        /* 0x9a0b */
    KANJI,        /* 0x9a0c */
    KANJI,        /* 0x9a0d */
    KANJI,        /* 0x9a0e */
    KANJI,        /* 0x9a0f */
    KANJI,        /* 0x9a10 */
    KANJI,        /* 0x9a11 */
    KANJI,        /* 0x9a12 */
    KANJI,        /* 0x9a13 */
    KANJI,        /* 0x9a14 */
    KANJI,        /* 0x9a15 */
    KANJI,        /* 0x9a16 */
    KANJI,        /* 0x9a17 */
    KANJI,        /* 0x9a18 */
    KANJI,        /* 0x9a19 */
    KANJI,        /* 0x9a1a */
    KANJI,        /* 0x9a1b */
    KANJI,        /* 0x9a1c */
    KANJI,        /* 0x9a1d */
    KANJI,        /* 0x9a1e */
    KANJI,        /* 0x9a1f */
    KANJI,        /* 0x9a20 */
    KANJI,        /* 0x9a21 */
    KANJI,        /* 0x9a22 */
    KANJI,        /* 0x9a23 */
    KANJI,        /* 0x9a24 */
    KANJI,        /* 0x9a25 */
    KANJI,        /* 0x9a26 */
    KANJI,        /* 0x9a27 */
    KANJI,        /* 0x9a28 */
    KANJI,        /* 0x9a29 */
    KANJI,        /* 0x9a2a */
    KANJI,        /* 0x9a2b */
    KANJI,        /* 0x9a2c */
    KANJI,        /* 0x9a2d */
    KANJI,        /* 0x9a2e */
    KANJI,        /* 0x9a2f */
    KANJI,        /* 0x9a30 */
    KANJI,        /* 0x9a31 */
    KANJI,        /* 0x9a32 */
    KANJI,        /* 0x9a33 */
    KANJI,        /* 0x9a34 */
    KANJI,        /* 0x9a35 */
    KANJI,        /* 0x9a36 */
    KANJI,        /* 0x9a37 */
    KANJI,        /* 0x9a38 */
    KANJI,        /* 0x9a39 */
    KANJI,        /* 0x9a3a */
    KANJI,        /* 0x9a3b */
    KANJI,        /* 0x9a3c */
    KANJI,        /* 0x9a3d */
    KANJI,        /* 0x9a3e */
    KANJI,        /* 0x9a3f */
    KANJI,        /* 0x9a40 */
    KANJI,        /* 0x9a41 */
    KANJI,        /* 0x9a42 */
    KANJI,        /* 0x9a43 */
    KANJI,        /* 0x9a44 */
    KANJI,        /* 0x9a45 */
    KANJI,        /* 0x9a46 */
    KANJI,        /* 0x9a47 */
    KANJI,        /* 0x9a48 */
    KANJI,        /* 0x9a49 */
    KANJI,        /* 0x9a4a */
    KANJI,        /* 0x9a4b */
    KANJI,        /* 0x9a4c */
    KANJI,        /* 0x9a4d */
    KANJI,        /* 0x9a4e */
    KANJI,        /* 0x9a4f */
    KANJI,        /* 0x9a50 */
    KANJI,        /* 0x9a51 */
    KANJI,        /* 0x9a52 */
    KANJI,        /* 0x9a53 */
    KANJI,        /* 0x9a54 */
    KANJI,        /* 0x9a55 */
    KANJI,        /* 0x9a56 */
    KANJI,        /* 0x9a57 */
    KANJI,        /* 0x9a58 */
    KANJI,        /* 0x9a59 */
    KANJI,        /* 0x9a5a */
    KANJI,        /* 0x9a5b */
    KANJI,        /* 0x9a5c */
    KANJI,        /* 0x9a5d */
    KANJI,        /* 0x9a5e */
    KANJI,        /* 0x9a5f */
    KANJI,        /* 0x9a60 */
    KANJI,        /* 0x9a61 */
    KANJI,        /* 0x9a62 */
    KANJI,        /* 0x9a63 */
    KANJI,        /* 0x9a64 */
    KANJI,        /* 0x9a65 */
    KANJI,        /* 0x9a66 */
    KANJI,        /* 0x9a67 */
    KANJI,        /* 0x9a68 */
    KANJI,        /* 0x9a69 */
    KANJI,        /* 0x9a6a */
    KANJI,        /* 0x9a6b */
    KANJI,        /* 0x9a6c */
    KANJI,        /* 0x9a6d */
    KANJI,        /* 0x9a6e */
    KANJI,        /* 0x9a6f */
    KANJI,        /* 0x9a70 */
    KANJI,        /* 0x9a71 */
    KANJI,        /* 0x9a72 */
    KANJI,        /* 0x9a73 */
    KANJI,        /* 0x9a74 */
    KANJI,        /* 0x9a75 */
    KANJI,        /* 0x9a76 */
    KANJI,        /* 0x9a77 */
    KANJI,        /* 0x9a78 */
    KANJI,        /* 0x9a79 */
    KANJI,        /* 0x9a7a */
    KANJI,        /* 0x9a7b */
    KANJI,        /* 0x9a7c */
    KANJI,        /* 0x9a7d */
    KANJI,        /* 0x9a7e */
    KANJI,        /* 0x9a7f */
    KANJI,        /* 0x9a80 */
    KANJI,        /* 0x9a81 */
    KANJI,        /* 0x9a82 */
    KANJI,        /* 0x9a83 */
    KANJI,        /* 0x9a84 */
    KANJI,        /* 0x9a85 */
    KANJI,        /* 0x9a86 */
    KANJI,        /* 0x9a87 */
    KANJI,        /* 0x9a88 */
    KANJI,        /* 0x9a89 */
    KANJI,        /* 0x9a8a */
    KANJI,        /* 0x9a8b */
    KANJI,        /* 0x9a8c */
    KANJI,        /* 0x9a8d */
    KANJI,        /* 0x9a8e */
    KANJI,        /* 0x9a8f */
    KANJI,        /* 0x9a90 */
    KANJI,        /* 0x9a91 */
    KANJI,        /* 0x9a92 */
    KANJI,        /* 0x9a93 */
    KANJI,        /* 0x9a94 */
    KANJI,        /* 0x9a95 */
    KANJI,        /* 0x9a96 */
    KANJI,        /* 0x9a97 */
    KANJI,        /* 0x9a98 */
    KANJI,        /* 0x9a99 */
    KANJI,        /* 0x9a9a */
    KANJI,        /* 0x9a9b */
    KANJI,        /* 0x9a9c */
    KANJI,        /* 0x9a9d */
    KANJI,        /* 0x9a9e */
    KANJI,        /* 0x9a9f */
    KANJI,        /* 0x9aa0 */
    KANJI,        /* 0x9aa1 */
    KANJI,        /* 0x9aa2 */
    KANJI,        /* 0x9aa3 */
    KANJI,        /* 0x9aa4 */
    KANJI,        /* 0x9aa5 */
    KANJI,        /* 0x9aa6 */
    KANJI,        /* 0x9aa7 */
    KANJI,        /* 0x9aa8 */
    KANJI,        /* 0x9aa9 */
    KANJI,        /* 0x9aaa */
    KANJI,        /* 0x9aab */
    KANJI,        /* 0x9aac */
    KANJI,        /* 0x9aad */
    KANJI,        /* 0x9aae */
    KANJI,        /* 0x9aaf */
    KANJI,        /* 0x9ab0 */
    KANJI,        /* 0x9ab1 */
    KANJI,        /* 0x9ab2 */
    KANJI,        /* 0x9ab3 */
    KANJI,        /* 0x9ab4 */
    KANJI,        /* 0x9ab5 */
    KANJI,        /* 0x9ab6 */
    KANJI,        /* 0x9ab7 */
    KANJI,        /* 0x9ab8 */
    KANJI,        /* 0x9ab9 */
    KANJI,        /* 0x9aba */
    KANJI,        /* 0x9abb */
    KANJI,        /* 0x9abc */
    KANJI,        /* 0x9abd */
    KANJI,        /* 0x9abe */
    KANJI,        /* 0x9abf */
    KANJI,        /* 0x9ac0 */
    KANJI,        /* 0x9ac1 */
    KANJI,        /* 0x9ac2 */
    KANJI,        /* 0x9ac3 */
    KANJI,        /* 0x9ac4 */
    KANJI,        /* 0x9ac5 */
    KANJI,        /* 0x9ac6 */
    KANJI,        /* 0x9ac7 */
    KANJI,        /* 0x9ac8 */
    KANJI,        /* 0x9ac9 */
    KANJI,        /* 0x9aca */
    KANJI,        /* 0x9acb */
    KANJI,        /* 0x9acc */
    KANJI,        /* 0x9acd */
    KANJI,        /* 0x9ace */
    KANJI,        /* 0x9acf */
    KANJI,        /* 0x9ad0 */
    KANJI,        /* 0x9ad1 */
    KANJI,        /* 0x9ad2 */
    KANJI,        /* 0x9ad3 */
    KANJI,        /* 0x9ad4 */
    KANJI,        /* 0x9ad5 */
    KANJI,        /* 0x9ad6 */
    KANJI,        /* 0x9ad7 */
    KANJI,        /* 0x9ad8 */
    KANJI,        /* 0x9ad9 */
    KANJI,        /* 0x9ada */
    KANJI,        /* 0x9adb */
    KANJI,        /* 0x9adc */
    KANJI,        /* 0x9add */
    KANJI,        /* 0x9ade */
    KANJI,        /* 0x9adf */
    KANJI,        /* 0x9ae0 */
    KANJI,        /* 0x9ae1 */
    KANJI,        /* 0x9ae2 */
    KANJI,        /* 0x9ae3 */
    KANJI,        /* 0x9ae4 */
    KANJI,        /* 0x9ae5 */
    KANJI,        /* 0x9ae6 */
    KANJI,        /* 0x9ae7 */
    KANJI,        /* 0x9ae8 */
    KANJI,        /* 0x9ae9 */
    KANJI,        /* 0x9aea */
    KANJI,        /* 0x9aeb */
    KANJI,        /* 0x9aec */
    KANJI,        /* 0x9aed */
    KANJI,        /* 0x9aee */
    KANJI,        /* 0x9aef */
    KANJI,        /* 0x9af0 */
    KANJI,        /* 0x9af1 */
    KANJI,        /* 0x9af2 */
    KANJI,        /* 0x9af3 */
    KANJI,        /* 0x9af4 */
    KANJI,        /* 0x9af5 */
    KANJI,        /* 0x9af6 */
    KANJI,        /* 0x9af7 */
    KANJI,        /* 0x9af8 */
    KANJI,        /* 0x9af9 */
    KANJI,        /* 0x9afa */
    KANJI,        /* 0x9afb */
    KANJI,        /* 0x9afc */
    KANJI,        /* 0x9afd */
    KANJI,        /* 0x9afe */
    KANJI,        /* 0x9aff */
    KANJI,        /* 0x9b00 */
    KANJI,        /* 0x9b01 */
    KANJI,        /* 0x9b02 */
    KANJI,        /* 0x9b03 */
    KANJI,        /* 0x9b04 */
    KANJI,        /* 0x9b05 */
    KANJI,        /* 0x9b06 */
    KANJI,        /* 0x9b07 */
    KANJI,        /* 0x9b08 */
    KANJI,        /* 0x9b09 */
    KANJI,        /* 0x9b0a */
    KANJI,        /* 0x9b0b */
    KANJI,        /* 0x9b0c */
    KANJI,        /* 0x9b0d */
    KANJI,        /* 0x9b0e */
    KANJI,        /* 0x9b0f */
    KANJI,        /* 0x9b10 */
    KANJI,        /* 0x9b11 */
    KANJI,        /* 0x9b12 */
    KANJI,        /* 0x9b13 */
    KANJI,        /* 0x9b14 */
    KANJI,        /* 0x9b15 */
    KANJI,        /* 0x9b16 */
    KANJI,        /* 0x9b17 */
    KANJI,        /* 0x9b18 */
    KANJI,        /* 0x9b19 */
    KANJI,        /* 0x9b1a */
    KANJI,        /* 0x9b1b */
    KANJI,        /* 0x9b1c */
    KANJI,        /* 0x9b1d */
    KANJI,        /* 0x9b1e */
    KANJI,        /* 0x9b1f */
    KANJI,        /* 0x9b20 */
    KANJI,        /* 0x9b21 */
    KANJI,        /* 0x9b22 */
    KANJI,        /* 0x9b23 */
    KANJI,        /* 0x9b24 */
    KANJI,        /* 0x9b25 */
    KANJI,        /* 0x9b26 */
    KANJI,        /* 0x9b27 */
    KANJI,        /* 0x9b28 */
    KANJI,        /* 0x9b29 */
    KANJI,        /* 0x9b2a */
    KANJI,        /* 0x9b2b */
    KANJI,        /* 0x9b2c */
    KANJI,        /* 0x9b2d */
    KANJI,        /* 0x9b2e */
    KANJI,        /* 0x9b2f */
    KANJI,        /* 0x9b30 */
    KANJI,        /* 0x9b31 */
    KANJI,        /* 0x9b32 */
    KANJI,        /* 0x9b33 */
    KANJI,        /* 0x9b34 */
    KANJI,        /* 0x9b35 */
    KANJI,        /* 0x9b36 */
    KANJI,        /* 0x9b37 */
    KANJI,        /* 0x9b38 */
    KANJI,        /* 0x9b39 */
    KANJI,        /* 0x9b3a */
    KANJI,        /* 0x9b3b */
    KANJI,        /* 0x9b3c */
    KANJI,        /* 0x9b3d */
    KANJI,        /* 0x9b3e */
    KANJI,        /* 0x9b3f */
    KANJI,        /* 0x9b40 */
    KANJI,        /* 0x9b41 */
    KANJI,        /* 0x9b42 */
    KANJI,        /* 0x9b43 */
    KANJI,        /* 0x9b44 */
    KANJI,        /* 0x9b45 */
    KANJI,        /* 0x9b46 */
    KANJI,        /* 0x9b47 */
    KANJI,        /* 0x9b48 */
    KANJI,        /* 0x9b49 */
    KANJI,        /* 0x9b4a */
    KANJI,        /* 0x9b4b */
    KANJI,        /* 0x9b4c */
    KANJI,        /* 0x9b4d */
    KANJI,        /* 0x9b4e */
    KANJI,        /* 0x9b4f */
    KANJI,        /* 0x9b50 */
    KANJI,        /* 0x9b51 */
    KANJI,        /* 0x9b52 */
    KANJI,        /* 0x9b53 */
    KANJI,        /* 0x9b54 */
    KANJI,        /* 0x9b55 */
    KANJI,        /* 0x9b56 */
    KANJI,        /* 0x9b57 */
    KANJI,        /* 0x9b58 */
    KANJI,        /* 0x9b59 */
    KANJI,        /* 0x9b5a */
    KANJI,        /* 0x9b5b */
    KANJI,        /* 0x9b5c */
    KANJI,        /* 0x9b5d */
    KANJI,        /* 0x9b5e */
    KANJI,        /* 0x9b5f */
    KANJI,        /* 0x9b60 */
    KANJI,        /* 0x9b61 */
    KANJI,        /* 0x9b62 */
    KANJI,        /* 0x9b63 */
    KANJI,        /* 0x9b64 */
    KANJI,        /* 0x9b65 */
    KANJI,        /* 0x9b66 */
    KANJI,        /* 0x9b67 */
    KANJI,        /* 0x9b68 */
    KANJI,        /* 0x9b69 */
    KANJI,        /* 0x9b6a */
    KANJI,        /* 0x9b6b */
    KANJI,        /* 0x9b6c */
    KANJI,        /* 0x9b6d */
    KANJI,        /* 0x9b6e */
    KANJI,        /* 0x9b6f */
    KANJI,        /* 0x9b70 */
    KANJI,        /* 0x9b71 */
    KANJI,        /* 0x9b72 */
    KANJI,        /* 0x9b73 */
    KANJI,        /* 0x9b74 */
    KANJI,        /* 0x9b75 */
    KANJI,        /* 0x9b76 */
    KANJI,        /* 0x9b77 */
    KANJI,        /* 0x9b78 */
    KANJI,        /* 0x9b79 */
    KANJI,        /* 0x9b7a */
    KANJI,        /* 0x9b7b */
    KANJI,        /* 0x9b7c */
    KANJI,        /* 0x9b7d */
    KANJI,        /* 0x9b7e */
    KANJI,        /* 0x9b7f */
    KANJI,        /* 0x9b80 */
    KANJI,        /* 0x9b81 */
    KANJI,        /* 0x9b82 */
    KANJI,        /* 0x9b83 */
    KANJI,        /* 0x9b84 */
    KANJI,        /* 0x9b85 */
    KANJI,        /* 0x9b86 */
    KANJI,        /* 0x9b87 */
    KANJI,        /* 0x9b88 */
    KANJI,        /* 0x9b89 */
    KANJI,        /* 0x9b8a */
    KANJI,        /* 0x9b8b */
    KANJI,        /* 0x9b8c */
    KANJI,        /* 0x9b8d */
    KANJI,        /* 0x9b8e */
    KANJI,        /* 0x9b8f */
    KANJI,        /* 0x9b90 */
    KANJI,        /* 0x9b91 */
    KANJI,        /* 0x9b92 */
    KANJI,        /* 0x9b93 */
    KANJI,        /* 0x9b94 */
    KANJI,        /* 0x9b95 */
    KANJI,        /* 0x9b96 */
    KANJI,        /* 0x9b97 */
    KANJI,        /* 0x9b98 */
    KANJI,        /* 0x9b99 */
    KANJI,        /* 0x9b9a */
    KANJI,        /* 0x9b9b */
    KANJI,        /* 0x9b9c */
    KANJI,        /* 0x9b9d */
    KANJI,        /* 0x9b9e */
    KANJI,        /* 0x9b9f */
    KANJI,        /* 0x9ba0 */
    KANJI,        /* 0x9ba1 */
    KANJI,        /* 0x9ba2 */
    KANJI,        /* 0x9ba3 */
    KANJI,        /* 0x9ba4 */
    KANJI,        /* 0x9ba5 */
    KANJI,        /* 0x9ba6 */
    KANJI,        /* 0x9ba7 */
    KANJI,        /* 0x9ba8 */
    KANJI,        /* 0x9ba9 */
    KANJI,        /* 0x9baa */
    KANJI,        /* 0x9bab */
    KANJI,        /* 0x9bac */
    KANJI,        /* 0x9bad */
    KANJI,        /* 0x9bae */
    KANJI,        /* 0x9baf */
    KANJI,        /* 0x9bb0 */
    KANJI,        /* 0x9bb1 */
    KANJI,        /* 0x9bb2 */
    KANJI,        /* 0x9bb3 */
    KANJI,        /* 0x9bb4 */
    KANJI,        /* 0x9bb5 */
    KANJI,        /* 0x9bb6 */
    KANJI,        /* 0x9bb7 */
    KANJI,        /* 0x9bb8 */
    KANJI,        /* 0x9bb9 */
    KANJI,        /* 0x9bba */
    KANJI,        /* 0x9bbb */
    KANJI,        /* 0x9bbc */
    KANJI,        /* 0x9bbd */
    KANJI,        /* 0x9bbe */
    KANJI,        /* 0x9bbf */
    KANJI,        /* 0x9bc0 */
    KANJI,        /* 0x9bc1 */
    KANJI,        /* 0x9bc2 */
    KANJI,        /* 0x9bc3 */
    KANJI,        /* 0x9bc4 */
    KANJI,        /* 0x9bc5 */
    KANJI,        /* 0x9bc6 */
    KANJI,        /* 0x9bc7 */
    KANJI,        /* 0x9bc8 */
    KANJI,        /* 0x9bc9 */
    KANJI,        /* 0x9bca */
    KANJI,        /* 0x9bcb */
    KANJI,        /* 0x9bcc */
    KANJI,        /* 0x9bcd */
    KANJI,        /* 0x9bce */
    KANJI,        /* 0x9bcf */
    KANJI,        /* 0x9bd0 */
    KANJI,        /* 0x9bd1 */
    KANJI,        /* 0x9bd2 */
    KANJI,        /* 0x9bd3 */
    KANJI,        /* 0x9bd4 */
    KANJI,        /* 0x9bd5 */
    KANJI,        /* 0x9bd6 */
    KANJI,        /* 0x9bd7 */
    KANJI,        /* 0x9bd8 */
    KANJI,        /* 0x9bd9 */
    KANJI,        /* 0x9bda */
    KANJI,        /* 0x9bdb */
    KANJI,        /* 0x9bdc */
    KANJI,        /* 0x9bdd */
    KANJI,        /* 0x9bde */
    KANJI,        /* 0x9bdf */
    KANJI,        /* 0x9be0 */
    KANJI,        /* 0x9be1 */
    KANJI,        /* 0x9be2 */
    KANJI,        /* 0x9be3 */
    KANJI,        /* 0x9be4 */
    KANJI,        /* 0x9be5 */
    KANJI,        /* 0x9be6 */
    KANJI,        /* 0x9be7 */
    KANJI,        /* 0x9be8 */
    KANJI,        /* 0x9be9 */
    KANJI,        /* 0x9bea */
    KANJI,        /* 0x9beb */
    KANJI,        /* 0x9bec */
    KANJI,        /* 0x9bed */
    KANJI,        /* 0x9bee */
    KANJI,        /* 0x9bef */
    KANJI,        /* 0x9bf0 */
    KANJI,        /* 0x9bf1 */
    KANJI,        /* 0x9bf2 */
    KANJI,        /* 0x9bf3 */
    KANJI,        /* 0x9bf4 */
    KANJI,        /* 0x9bf5 */
    KANJI,        /* 0x9bf6 */
    KANJI,        /* 0x9bf7 */
    KANJI,        /* 0x9bf8 */
    KANJI,        /* 0x9bf9 */
    KANJI,        /* 0x9bfa */
    KANJI,        /* 0x9bfb */
    KANJI,        /* 0x9bfc */
    KANJI,        /* 0x9bfd */
    KANJI,        /* 0x9bfe */
    KANJI,        /* 0x9bff */
    KANJI,        /* 0x9c00 */
    KANJI,        /* 0x9c01 */
    KANJI,        /* 0x9c02 */
    KANJI,        /* 0x9c03 */
    KANJI,        /* 0x9c04 */
    KANJI,        /* 0x9c05 */
    KANJI,        /* 0x9c06 */
    KANJI,        /* 0x9c07 */
    KANJI,        /* 0x9c08 */
    KANJI,        /* 0x9c09 */
    KANJI,        /* 0x9c0a */
    KANJI,        /* 0x9c0b */
    KANJI,        /* 0x9c0c */
    KANJI,        /* 0x9c0d */
    KANJI,        /* 0x9c0e */
    KANJI,        /* 0x9c0f */
    KANJI,        /* 0x9c10 */
    KANJI,        /* 0x9c11 */
    KANJI,        /* 0x9c12 */
    KANJI,        /* 0x9c13 */
    KANJI,        /* 0x9c14 */
    KANJI,        /* 0x9c15 */
    KANJI,        /* 0x9c16 */
    KANJI,        /* 0x9c17 */
    KANJI,        /* 0x9c18 */
    KANJI,        /* 0x9c19 */
    KANJI,        /* 0x9c1a */
    KANJI,        /* 0x9c1b */
    KANJI,        /* 0x9c1c */
    KANJI,        /* 0x9c1d */
    KANJI,        /* 0x9c1e */
    KANJI,        /* 0x9c1f */
    KANJI,        /* 0x9c20 */
    KANJI,        /* 0x9c21 */
    KANJI,        /* 0x9c22 */
    KANJI,        /* 0x9c23 */
    KANJI,        /* 0x9c24 */
    KANJI,        /* 0x9c25 */
    KANJI,        /* 0x9c26 */
    KANJI,        /* 0x9c27 */
    KANJI,        /* 0x9c28 */
    KANJI,        /* 0x9c29 */
    KANJI,        /* 0x9c2a */
    KANJI,        /* 0x9c2b */
    KANJI,        /* 0x9c2c */
    KANJI,        /* 0x9c2d */
    KANJI,        /* 0x9c2e */
    KANJI,        /* 0x9c2f */
    KANJI,        /* 0x9c30 */
    KANJI,        /* 0x9c31 */
    KANJI,        /* 0x9c32 */
    KANJI,        /* 0x9c33 */
    KANJI,        /* 0x9c34 */
    KANJI,        /* 0x9c35 */
    KANJI,        /* 0x9c36 */
    KANJI,        /* 0x9c37 */
    KANJI,        /* 0x9c38 */
    KANJI,        /* 0x9c39 */
    KANJI,        /* 0x9c3a */
    KANJI,        /* 0x9c3b */
    KANJI,        /* 0x9c3c */
    KANJI,        /* 0x9c3d */
    KANJI,        /* 0x9c3e */
    KANJI,        /* 0x9c3f */
    KANJI,        /* 0x9c40 */
    KANJI,        /* 0x9c41 */
    KANJI,        /* 0x9c42 */
    KANJI,        /* 0x9c43 */
    KANJI,        /* 0x9c44 */
    KANJI,        /* 0x9c45 */
    KANJI,        /* 0x9c46 */
    KANJI,        /* 0x9c47 */
    KANJI,        /* 0x9c48 */
    KANJI,        /* 0x9c49 */
    KANJI,        /* 0x9c4a */
    KANJI,        /* 0x9c4b */
    KANJI,        /* 0x9c4c */
    KANJI,        /* 0x9c4d */
    KANJI,        /* 0x9c4e */
    KANJI,        /* 0x9c4f */
    KANJI,        /* 0x9c50 */
    KANJI,        /* 0x9c51 */
    KANJI,        /* 0x9c52 */
    KANJI,        /* 0x9c53 */
    KANJI,        /* 0x9c54 */
    KANJI,        /* 0x9c55 */
    KANJI,        /* 0x9c56 */
    KANJI,        /* 0x9c57 */
    KANJI,        /* 0x9c58 */
    KANJI,        /* 0x9c59 */
    KANJI,        /* 0x9c5a */
    KANJI,        /* 0x9c5b */
    KANJI,        /* 0x9c5c */
    KANJI,        /* 0x9c5d */
    KANJI,        /* 0x9c5e */
    KANJI,        /* 0x9c5f */
    KANJI,        /* 0x9c60 */
    KANJI,        /* 0x9c61 */
    KANJI,        /* 0x9c62 */
    KANJI,        /* 0x9c63 */
    KANJI,        /* 0x9c64 */
    KANJI,        /* 0x9c65 */
    KANJI,        /* 0x9c66 */
    KANJI,        /* 0x9c67 */
    KANJI,        /* 0x9c68 */
    KANJI,        /* 0x9c69 */
    KANJI,        /* 0x9c6a */
    KANJI,        /* 0x9c6b */
    KANJI,        /* 0x9c6c */
    KANJI,        /* 0x9c6d */
    KANJI,        /* 0x9c6e */
    KANJI,        /* 0x9c6f */
    KANJI,        /* 0x9c70 */
    KANJI,        /* 0x9c71 */
    KANJI,        /* 0x9c72 */
    KANJI,        /* 0x9c73 */
    KANJI,        /* 0x9c74 */
    KANJI,        /* 0x9c75 */
    KANJI,        /* 0x9c76 */
    KANJI,        /* 0x9c77 */
    KANJI,        /* 0x9c78 */
    KANJI,        /* 0x9c79 */
    KANJI,        /* 0x9c7a */
    KANJI,        /* 0x9c7b */
    KANJI,        /* 0x9c7c */
    KANJI,        /* 0x9c7d */
    KANJI,        /* 0x9c7e */
    KANJI,        /* 0x9c7f */
    KANJI,        /* 0x9c80 */
    KANJI,        /* 0x9c81 */
    KANJI,        /* 0x9c82 */
    KANJI,        /* 0x9c83 */
    KANJI,        /* 0x9c84 */
    KANJI,        /* 0x9c85 */
    KANJI,        /* 0x9c86 */
    KANJI,        /* 0x9c87 */
    KANJI,        /* 0x9c88 */
    KANJI,        /* 0x9c89 */
    KANJI,        /* 0x9c8a */
    KANJI,        /* 0x9c8b */
    KANJI,        /* 0x9c8c */
    KANJI,        /* 0x9c8d */
    KANJI,        /* 0x9c8e */
    KANJI,        /* 0x9c8f */
    KANJI,        /* 0x9c90 */
    KANJI,        /* 0x9c91 */
    KANJI,        /* 0x9c92 */
    KANJI,        /* 0x9c93 */
    KANJI,        /* 0x9c94 */
    KANJI,        /* 0x9c95 */
    KANJI,        /* 0x9c96 */
    KANJI,        /* 0x9c97 */
    KANJI,        /* 0x9c98 */
    KANJI,        /* 0x9c99 */
    KANJI,        /* 0x9c9a */
    KANJI,        /* 0x9c9b */
    KANJI,        /* 0x9c9c */
    KANJI,        /* 0x9c9d */
    KANJI,        /* 0x9c9e */
    KANJI,        /* 0x9c9f */
    KANJI,        /* 0x9ca0 */
    KANJI,        /* 0x9ca1 */
    KANJI,        /* 0x9ca2 */
    KANJI,        /* 0x9ca3 */
    KANJI,        /* 0x9ca4 */
    KANJI,        /* 0x9ca5 */
    KANJI,        /* 0x9ca6 */
    KANJI,        /* 0x9ca7 */
    KANJI,        /* 0x9ca8 */
    KANJI,        /* 0x9ca9 */
    KANJI,        /* 0x9caa */
    KANJI,        /* 0x9cab */
    KANJI,        /* 0x9cac */
    KANJI,        /* 0x9cad */
    KANJI,        /* 0x9cae */
    KANJI,        /* 0x9caf */
    KANJI,        /* 0x9cb0 */
    KANJI,        /* 0x9cb1 */
    KANJI,        /* 0x9cb2 */
    KANJI,        /* 0x9cb3 */
    KANJI,        /* 0x9cb4 */
    KANJI,        /* 0x9cb5 */
    KANJI,        /* 0x9cb6 */
    KANJI,        /* 0x9cb7 */
    KANJI,        /* 0x9cb8 */
    KANJI,        /* 0x9cb9 */
    KANJI,        /* 0x9cba */
    KANJI,        /* 0x9cbb */
    KANJI,        /* 0x9cbc */
    KANJI,        /* 0x9cbd */
    KANJI,        /* 0x9cbe */
    KANJI,        /* 0x9cbf */
    KANJI,        /* 0x9cc0 */
    KANJI,        /* 0x9cc1 */
    KANJI,        /* 0x9cc2 */
    KANJI,        /* 0x9cc3 */
    KANJI,        /* 0x9cc4 */
    KANJI,        /* 0x9cc5 */
    KANJI,        /* 0x9cc6 */
    KANJI,        /* 0x9cc7 */
    KANJI,        /* 0x9cc8 */
    KANJI,        /* 0x9cc9 */
    KANJI,        /* 0x9cca */
    KANJI,        /* 0x9ccb */
    KANJI,        /* 0x9ccc */
    KANJI,        /* 0x9ccd */
    KANJI,        /* 0x9cce */
    KANJI,        /* 0x9ccf */
    KANJI,        /* 0x9cd0 */
    KANJI,        /* 0x9cd1 */
    KANJI,        /* 0x9cd2 */
    KANJI,        /* 0x9cd3 */
    KANJI,        /* 0x9cd4 */
    KANJI,        /* 0x9cd5 */
    KANJI,        /* 0x9cd6 */
    KANJI,        /* 0x9cd7 */
    KANJI,        /* 0x9cd8 */
    KANJI,        /* 0x9cd9 */
    KANJI,        /* 0x9cda */
    KANJI,        /* 0x9cdb */
    KANJI,        /* 0x9cdc */
    KANJI,        /* 0x9cdd */
    KANJI,        /* 0x9cde */
    KANJI,        /* 0x9cdf */
    KANJI,        /* 0x9ce0 */
    KANJI,        /* 0x9ce1 */
    KANJI,        /* 0x9ce2 */
    KANJI,        /* 0x9ce3 */
    KANJI,        /* 0x9ce4 */
    KANJI,        /* 0x9ce5 */
    KANJI,        /* 0x9ce6 */
    KANJI,        /* 0x9ce7 */
    KANJI,        /* 0x9ce8 */
    KANJI,        /* 0x9ce9 */
    KANJI,        /* 0x9cea */
    KANJI,        /* 0x9ceb */
    KANJI,        /* 0x9cec */
    KANJI,        /* 0x9ced */
    KANJI,        /* 0x9cee */
    KANJI,        /* 0x9cef */
    KANJI,        /* 0x9cf0 */
    KANJI,        /* 0x9cf1 */
    KANJI,        /* 0x9cf2 */
    KANJI,        /* 0x9cf3 */
    KANJI,        /* 0x9cf4 */
    KANJI,        /* 0x9cf5 */
    KANJI,        /* 0x9cf6 */
    KANJI,        /* 0x9cf7 */
    KANJI,        /* 0x9cf8 */
    KANJI,        /* 0x9cf9 */
    KANJI,        /* 0x9cfa */
    KANJI,        /* 0x9cfb */
    KANJI,        /* 0x9cfc */
    KANJI,        /* 0x9cfd */
    KANJI,        /* 0x9cfe */
    KANJI,        /* 0x9cff */
    KANJI,        /* 0x9d00 */
    KANJI,        /* 0x9d01 */
    KANJI,        /* 0x9d02 */
    KANJI,        /* 0x9d03 */
    KANJI,        /* 0x9d04 */
    KANJI,        /* 0x9d05 */
    KANJI,        /* 0x9d06 */
    KANJI,        /* 0x9d07 */
    KANJI,        /* 0x9d08 */
    KANJI,        /* 0x9d09 */
    KANJI,        /* 0x9d0a */
    KANJI,        /* 0x9d0b */
    KANJI,        /* 0x9d0c */
    KANJI,        /* 0x9d0d */
    KANJI,        /* 0x9d0e */
    KANJI,        /* 0x9d0f */
    KANJI,        /* 0x9d10 */
    KANJI,        /* 0x9d11 */
    KANJI,        /* 0x9d12 */
    KANJI,        /* 0x9d13 */
    KANJI,        /* 0x9d14 */
    KANJI,        /* 0x9d15 */
    KANJI,        /* 0x9d16 */
    KANJI,        /* 0x9d17 */
    KANJI,        /* 0x9d18 */
    KANJI,        /* 0x9d19 */
    KANJI,        /* 0x9d1a */
    KANJI,        /* 0x9d1b */
    KANJI,        /* 0x9d1c */
    KANJI,        /* 0x9d1d */
    KANJI,        /* 0x9d1e */
    KANJI,        /* 0x9d1f */
    KANJI,        /* 0x9d20 */
    KANJI,        /* 0x9d21 */
    KANJI,        /* 0x9d22 */
    KANJI,        /* 0x9d23 */
    KANJI,        /* 0x9d24 */
    KANJI,        /* 0x9d25 */
    KANJI,        /* 0x9d26 */
    KANJI,        /* 0x9d27 */
    KANJI,        /* 0x9d28 */
    KANJI,        /* 0x9d29 */
    KANJI,        /* 0x9d2a */
    KANJI,        /* 0x9d2b */
    KANJI,        /* 0x9d2c */
    KANJI,        /* 0x9d2d */
    KANJI,        /* 0x9d2e */
    KANJI,        /* 0x9d2f */
    KANJI,        /* 0x9d30 */
    KANJI,        /* 0x9d31 */
    KANJI,        /* 0x9d32 */
    KANJI,        /* 0x9d33 */
    KANJI,        /* 0x9d34 */
    KANJI,        /* 0x9d35 */
    KANJI,        /* 0x9d36 */
    KANJI,        /* 0x9d37 */
    KANJI,        /* 0x9d38 */
    KANJI,        /* 0x9d39 */
    KANJI,        /* 0x9d3a */
    KANJI,        /* 0x9d3b */
    KANJI,        /* 0x9d3c */
    KANJI,        /* 0x9d3d */
    KANJI,        /* 0x9d3e */
    KANJI,        /* 0x9d3f */
    KANJI,        /* 0x9d40 */
    KANJI,        /* 0x9d41 */
    KANJI,        /* 0x9d42 */
    KANJI,        /* 0x9d43 */
    KANJI,        /* 0x9d44 */
    KANJI,        /* 0x9d45 */
    KANJI,        /* 0x9d46 */
    KANJI,        /* 0x9d47 */
    KANJI,        /* 0x9d48 */
    KANJI,        /* 0x9d49 */
    KANJI,        /* 0x9d4a */
    KANJI,        /* 0x9d4b */
    KANJI,        /* 0x9d4c */
    KANJI,        /* 0x9d4d */
    KANJI,        /* 0x9d4e */
    KANJI,        /* 0x9d4f */
    KANJI,        /* 0x9d50 */
    KANJI,        /* 0x9d51 */
    KANJI,        /* 0x9d52 */
    KANJI,        /* 0x9d53 */
    KANJI,        /* 0x9d54 */
    KANJI,        /* 0x9d55 */
    KANJI,        /* 0x9d56 */
    KANJI,        /* 0x9d57 */
    KANJI,        /* 0x9d58 */
    KANJI,        /* 0x9d59 */
    KANJI,        /* 0x9d5a */
    KANJI,        /* 0x9d5b */
    KANJI,        /* 0x9d5c */
    KANJI,        /* 0x9d5d */
    KANJI,        /* 0x9d5e */
    KANJI,        /* 0x9d5f */
    KANJI,        /* 0x9d60 */
    KANJI,        /* 0x9d61 */
    KANJI,        /* 0x9d62 */
    KANJI,        /* 0x9d63 */
    KANJI,        /* 0x9d64 */
    KANJI,        /* 0x9d65 */
    KANJI,        /* 0x9d66 */
    KANJI,        /* 0x9d67 */
    KANJI,        /* 0x9d68 */
    KANJI,        /* 0x9d69 */
    KANJI,        /* 0x9d6a */
    KANJI,        /* 0x9d6b */
    KANJI,        /* 0x9d6c */
    KANJI,        /* 0x9d6d */
    KANJI,        /* 0x9d6e */
    KANJI,        /* 0x9d6f */
    KANJI,        /* 0x9d70 */
    KANJI,        /* 0x9d71 */
    KANJI,        /* 0x9d72 */
    KANJI,        /* 0x9d73 */
    KANJI,        /* 0x9d74 */
    KANJI,        /* 0x9d75 */
    KANJI,        /* 0x9d76 */
    KANJI,        /* 0x9d77 */
    KANJI,        /* 0x9d78 */
    KANJI,        /* 0x9d79 */
    KANJI,        /* 0x9d7a */
    KANJI,        /* 0x9d7b */
    KANJI,        /* 0x9d7c */
    KANJI,        /* 0x9d7d */
    KANJI,        /* 0x9d7e */
    KANJI,        /* 0x9d7f */
    KANJI,        /* 0x9d80 */
    KANJI,        /* 0x9d81 */
    KANJI,        /* 0x9d82 */
    KANJI,        /* 0x9d83 */
    KANJI,        /* 0x9d84 */
    KANJI,        /* 0x9d85 */
    KANJI,        /* 0x9d86 */
    KANJI,        /* 0x9d87 */
    KANJI,        /* 0x9d88 */
    KANJI,        /* 0x9d89 */
    KANJI,        /* 0x9d8a */
    KANJI,        /* 0x9d8b */
    KANJI,        /* 0x9d8c */
    KANJI,        /* 0x9d8d */
    KANJI,        /* 0x9d8e */
    KANJI,        /* 0x9d8f */
    KANJI,        /* 0x9d90 */
    KANJI,        /* 0x9d91 */
    KANJI,        /* 0x9d92 */
    KANJI,        /* 0x9d93 */
    KANJI,        /* 0x9d94 */
    KANJI,        /* 0x9d95 */
    KANJI,        /* 0x9d96 */
    KANJI,        /* 0x9d97 */
    KANJI,        /* 0x9d98 */
    KANJI,        /* 0x9d99 */
    KANJI,        /* 0x9d9a */
    KANJI,        /* 0x9d9b */
    KANJI,        /* 0x9d9c */
    KANJI,        /* 0x9d9d */
    KANJI,        /* 0x9d9e */
    KANJI,        /* 0x9d9f */
    KANJI,        /* 0x9da0 */
    KANJI,        /* 0x9da1 */
    KANJI,        /* 0x9da2 */
    KANJI,        /* 0x9da3 */
    KANJI,        /* 0x9da4 */
    KANJI,        /* 0x9da5 */
    KANJI,        /* 0x9da6 */
    KANJI,        /* 0x9da7 */
    KANJI,        /* 0x9da8 */
    KANJI,        /* 0x9da9 */
    KANJI,        /* 0x9daa */
    KANJI,        /* 0x9dab */
    KANJI,        /* 0x9dac */
    KANJI,        /* 0x9dad */
    KANJI,        /* 0x9dae */
    KANJI,        /* 0x9daf */
    KANJI,        /* 0x9db0 */
    KANJI,        /* 0x9db1 */
    KANJI,        /* 0x9db2 */
    KANJI,        /* 0x9db3 */
    KANJI,        /* 0x9db4 */
    KANJI,        /* 0x9db5 */
    KANJI,        /* 0x9db6 */
    KANJI,        /* 0x9db7 */
    KANJI,        /* 0x9db8 */
    KANJI,        /* 0x9db9 */
    KANJI,        /* 0x9dba */
    KANJI,        /* 0x9dbb */
    KANJI,        /* 0x9dbc */
    KANJI,        /* 0x9dbd */
    KANJI,        /* 0x9dbe */
    KANJI,        /* 0x9dbf */
    KANJI,        /* 0x9dc0 */
    KANJI,        /* 0x9dc1 */
    KANJI,        /* 0x9dc2 */
    KANJI,        /* 0x9dc3 */
    KANJI,        /* 0x9dc4 */
    KANJI,        /* 0x9dc5 */
    KANJI,        /* 0x9dc6 */
    KANJI,        /* 0x9dc7 */
    KANJI,        /* 0x9dc8 */
    KANJI,        /* 0x9dc9 */
    KANJI,        /* 0x9dca */
    KANJI,        /* 0x9dcb */
    KANJI,        /* 0x9dcc */
    KANJI,        /* 0x9dcd */
    KANJI,        /* 0x9dce */
    KANJI,        /* 0x9dcf */
    KANJI,        /* 0x9dd0 */
    KANJI,        /* 0x9dd1 */
    KANJI,        /* 0x9dd2 */
    KANJI,        /* 0x9dd3 */
    KANJI,        /* 0x9dd4 */
    KANJI,        /* 0x9dd5 */
    KANJI,        /* 0x9dd6 */
    KANJI,        /* 0x9dd7 */
    KANJI,        /* 0x9dd8 */
    KANJI,        /* 0x9dd9 */
    KANJI,        /* 0x9dda */
    KANJI,        /* 0x9ddb */
    KANJI,        /* 0x9ddc */
    KANJI,        /* 0x9ddd */
    KANJI,        /* 0x9dde */
    KANJI,        /* 0x9ddf */
    KANJI,        /* 0x9de0 */
    KANJI,        /* 0x9de1 */
    KANJI,        /* 0x9de2 */
    KANJI,        /* 0x9de3 */
    KANJI,        /* 0x9de4 */
    KANJI,        /* 0x9de5 */
    KANJI,        /* 0x9de6 */
    KANJI,        /* 0x9de7 */
    KANJI,        /* 0x9de8 */
    KANJI,        /* 0x9de9 */
    KANJI,        /* 0x9dea */
    KANJI,        /* 0x9deb */
    KANJI,        /* 0x9dec */
    KANJI,        /* 0x9ded */
    KANJI,        /* 0x9dee */
    KANJI,        /* 0x9def */
    KANJI,        /* 0x9df0 */
    KANJI,        /* 0x9df1 */
    KANJI,        /* 0x9df2 */
    KANJI,        /* 0x9df3 */
    KANJI,        /* 0x9df4 */
    KANJI,        /* 0x9df5 */
    KANJI,        /* 0x9df6 */
    KANJI,        /* 0x9df7 */
    KANJI,        /* 0x9df8 */
    KANJI,        /* 0x9df9 */
    KANJI,        /* 0x9dfa */
    KANJI,        /* 0x9dfb */
    KANJI,        /* 0x9dfc */
    KANJI,        /* 0x9dfd */
    KANJI,        /* 0x9dfe */
    KANJI,        /* 0x9dff */
    KANJI,        /* 0x9e00 */
    KANJI,        /* 0x9e01 */
    KANJI,        /* 0x9e02 */
    KANJI,        /* 0x9e03 */
    KANJI,        /* 0x9e04 */
    KANJI,        /* 0x9e05 */
    KANJI,        /* 0x9e06 */
    KANJI,        /* 0x9e07 */
    KANJI,        /* 0x9e08 */
    KANJI,        /* 0x9e09 */
    KANJI,        /* 0x9e0a */
    KANJI,        /* 0x9e0b */
    KANJI,        /* 0x9e0c */
    KANJI,        /* 0x9e0d */
    KANJI,        /* 0x9e0e */
    KANJI,        /* 0x9e0f */
    KANJI,        /* 0x9e10 */
    KANJI,        /* 0x9e11 */
    KANJI,        /* 0x9e12 */
    KANJI,        /* 0x9e13 */
    KANJI,        /* 0x9e14 */
    KANJI,        /* 0x9e15 */
    KANJI,        /* 0x9e16 */
    KANJI,        /* 0x9e17 */
    KANJI,        /* 0x9e18 */
    KANJI,        /* 0x9e19 */
    KANJI,        /* 0x9e1a */
    KANJI,        /* 0x9e1b */
    KANJI,        /* 0x9e1c */
    KANJI,        /* 0x9e1d */
    KANJI,        /* 0x9e1e */
    KANJI,        /* 0x9e1f */
    KANJI,        /* 0x9e20 */
    KANJI,        /* 0x9e21 */
    KANJI,        /* 0x9e22 */
    KANJI,        /* 0x9e23 */
    KANJI,        /* 0x9e24 */
    KANJI,        /* 0x9e25 */
    KANJI,        /* 0x9e26 */
    KANJI,        /* 0x9e27 */
    KANJI,        /* 0x9e28 */
    KANJI,        /* 0x9e29 */
    KANJI,        /* 0x9e2a */
    KANJI,        /* 0x9e2b */
    KANJI,        /* 0x9e2c */
    KANJI,        /* 0x9e2d */
    KANJI,        /* 0x9e2e */
    KANJI,        /* 0x9e2f */
    KANJI,        /* 0x9e30 */
    KANJI,        /* 0x9e31 */
    KANJI,        /* 0x9e32 */
    KANJI,        /* 0x9e33 */
    KANJI,        /* 0x9e34 */
    KANJI,        /* 0x9e35 */
    KANJI,        /* 0x9e36 */
    KANJI,        /* 0x9e37 */
    KANJI,        /* 0x9e38 */
    KANJI,        /* 0x9e39 */
    KANJI,        /* 0x9e3a */
    KANJI,        /* 0x9e3b */
    KANJI,        /* 0x9e3c */
    KANJI,        /* 0x9e3d */
    KANJI,        /* 0x9e3e */
    KANJI,        /* 0x9e3f */
    KANJI,        /* 0x9e40 */
    KANJI,        /* 0x9e41 */
    KANJI,        /* 0x9e42 */
    KANJI,        /* 0x9e43 */
    KANJI,        /* 0x9e44 */
    KANJI,        /* 0x9e45 */
    KANJI,        /* 0x9e46 */
    KANJI,        /* 0x9e47 */
    KANJI,        /* 0x9e48 */
    KANJI,        /* 0x9e49 */
    KANJI,        /* 0x9e4a */
    KANJI,        /* 0x9e4b */
    KANJI,        /* 0x9e4c */
    KANJI,        /* 0x9e4d */
    KANJI,        /* 0x9e4e */
    KANJI,        /* 0x9e4f */
    KANJI,        /* 0x9e50 */
    KANJI,        /* 0x9e51 */
    KANJI,        /* 0x9e52 */
    KANJI,        /* 0x9e53 */
    KANJI,        /* 0x9e54 */
    KANJI,        /* 0x9e55 */
    KANJI,        /* 0x9e56 */
    KANJI,        /* 0x9e57 */
    KANJI,        /* 0x9e58 */
    KANJI,        /* 0x9e59 */
    KANJI,        /* 0x9e5a */
    KANJI,        /* 0x9e5b */
    KANJI,        /* 0x9e5c */
    KANJI,        /* 0x9e5d */
    KANJI,        /* 0x9e5e */
    KANJI,        /* 0x9e5f */
    KANJI,        /* 0x9e60 */
    KANJI,        /* 0x9e61 */
    KANJI,        /* 0x9e62 */
    KANJI,        /* 0x9e63 */
    KANJI,        /* 0x9e64 */
    KANJI,        /* 0x9e65 */
    KANJI,        /* 0x9e66 */
    KANJI,        /* 0x9e67 */
    KANJI,        /* 0x9e68 */
    KANJI,        /* 0x9e69 */
    KANJI,        /* 0x9e6a */
    KANJI,        /* 0x9e6b */
    KANJI,        /* 0x9e6c */
    KANJI,        /* 0x9e6d */
    KANJI,        /* 0x9e6e */
    KANJI,        /* 0x9e6f */
    KANJI,        /* 0x9e70 */
    KANJI,        /* 0x9e71 */
    KANJI,        /* 0x9e72 */
    KANJI,        /* 0x9e73 */
    KANJI,        /* 0x9e74 */
    KANJI,        /* 0x9e75 */
    KANJI,        /* 0x9e76 */
    KANJI,        /* 0x9e77 */
    KANJI,        /* 0x9e78 */
    KANJI,        /* 0x9e79 */
    KANJI,        /* 0x9e7a */
    KANJI,        /* 0x9e7b */
    KANJI,        /* 0x9e7c */
    KANJI,        /* 0x9e7d */
    KANJI,        /* 0x9e7e */
    KANJI,        /* 0x9e7f */
    KANJI,        /* 0x9e80 */
    KANJI,        /* 0x9e81 */
    KANJI,        /* 0x9e82 */
    KANJI,        /* 0x9e83 */
    KANJI,        /* 0x9e84 */
    KANJI,        /* 0x9e85 */
    KANJI,        /* 0x9e86 */
    KANJI,        /* 0x9e87 */
    KANJI,        /* 0x9e88 */
    KANJI,        /* 0x9e89 */
    KANJI,        /* 0x9e8a */
    KANJI,        /* 0x9e8b */
    KANJI,        /* 0x9e8c */
    KANJI,        /* 0x9e8d */
    KANJI,        /* 0x9e8e */
    KANJI,        /* 0x9e8f */
    KANJI,        /* 0x9e90 */
    KANJI,        /* 0x9e91 */
    KANJI,        /* 0x9e92 */
    KANJI,        /* 0x9e93 */
    KANJI,        /* 0x9e94 */
    KANJI,        /* 0x9e95 */
    KANJI,        /* 0x9e96 */
    KANJI,        /* 0x9e97 */
    KANJI,        /* 0x9e98 */
    KANJI,        /* 0x9e99 */
    KANJI,        /* 0x9e9a */
    KANJI,        /* 0x9e9b */
    KANJI,        /* 0x9e9c */
    KANJI,        /* 0x9e9d */
    KANJI,        /* 0x9e9e */
    KANJI,        /* 0x9e9f */
    KANJI,        /* 0x9ea0 */
    KANJI,        /* 0x9ea1 */
    KANJI,        /* 0x9ea2 */
    KANJI,        /* 0x9ea3 */
    KANJI,        /* 0x9ea4 */
    KANJI,        /* 0x9ea5 */
    KANJI,        /* 0x9ea6 */
    KANJI,        /* 0x9ea7 */
    KANJI,        /* 0x9ea8 */
    KANJI,        /* 0x9ea9 */
    KANJI,        /* 0x9eaa */
    KANJI,        /* 0x9eab */
    KANJI,        /* 0x9eac */
    KANJI,        /* 0x9ead */
    KANJI,        /* 0x9eae */
    KANJI,        /* 0x9eaf */
    KANJI,        /* 0x9eb0 */
    KANJI,        /* 0x9eb1 */
    KANJI,        /* 0x9eb2 */
    KANJI,        /* 0x9eb3 */
    KANJI,        /* 0x9eb4 */
    KANJI,        /* 0x9eb5 */
    KANJI,        /* 0x9eb6 */
    KANJI,        /* 0x9eb7 */
    KANJI,        /* 0x9eb8 */
    KANJI,        /* 0x9eb9 */
    KANJI,        /* 0x9eba */
    KANJI,        /* 0x9ebb */
    KANJI,        /* 0x9ebc */
    KANJI,        /* 0x9ebd */
    KANJI,        /* 0x9ebe */
    KANJI,        /* 0x9ebf */
    KANJI,        /* 0x9ec0 */
    KANJI,        /* 0x9ec1 */
    KANJI,        /* 0x9ec2 */
    KANJI,        /* 0x9ec3 */
    KANJI,        /* 0x9ec4 */
    KANJI,        /* 0x9ec5 */
    KANJI,        /* 0x9ec6 */
    KANJI,        /* 0x9ec7 */
    KANJI,        /* 0x9ec8 */
    KANJI,        /* 0x9ec9 */
    KANJI,        /* 0x9eca */
    KANJI,        /* 0x9ecb */
    KANJI,        /* 0x9ecc */
    KANJI,        /* 0x9ecd */
    KANJI,        /* 0x9ece */
    KANJI,        /* 0x9ecf */
    KANJI,        /* 0x9ed0 */
    KANJI,        /* 0x9ed1 */
    KANJI,        /* 0x9ed2 */
    KANJI,        /* 0x9ed3 */
    KANJI,        /* 0x9ed4 */
    KANJI,        /* 0x9ed5 */
    KANJI,        /* 0x9ed6 */
    KANJI,        /* 0x9ed7 */
    KANJI,        /* 0x9ed8 */
    KANJI,        /* 0x9ed9 */
    KANJI,        /* 0x9eda */
    KANJI,        /* 0x9edb */
    KANJI,        /* 0x9edc */
    KANJI,        /* 0x9edd */
    KANJI,        /* 0x9ede */
    KANJI,        /* 0x9edf */
    KANJI,        /* 0x9ee0 */
    KANJI,        /* 0x9ee1 */
    KANJI,        /* 0x9ee2 */
    KANJI,        /* 0x9ee3 */
    KANJI,        /* 0x9ee4 */
    KANJI,        /* 0x9ee5 */
    KANJI,        /* 0x9ee6 */
    KANJI,        /* 0x9ee7 */
    KANJI,        /* 0x9ee8 */
    KANJI,        /* 0x9ee9 */
    KANJI,        /* 0x9eea */
    KANJI,        /* 0x9eeb */
    KANJI,        /* 0x9eec */
    KANJI,        /* 0x9eed */
    KANJI,        /* 0x9eee */
    KANJI,        /* 0x9eef */
    KANJI,        /* 0x9ef0 */
    KANJI,        /* 0x9ef1 */
    KANJI,        /* 0x9ef2 */
    KANJI,        /* 0x9ef3 */
    KANJI,        /* 0x9ef4 */
    KANJI,        /* 0x9ef5 */
    KANJI,        /* 0x9ef6 */
    KANJI,        /* 0x9ef7 */
    KANJI,        /* 0x9ef8 */
    KANJI,        /* 0x9ef9 */
    KANJI,        /* 0x9efa */
    KANJI,        /* 0x9efb */
    KANJI,        /* 0x9efc */
    KANJI,        /* 0x9efd */
    KANJI,        /* 0x9efe */
    KANJI,        /* 0x9eff */
    KANJI,        /* 0x9f00 */
    KANJI,        /* 0x9f01 */
    KANJI,        /* 0x9f02 */
    KANJI,        /* 0x9f03 */
    KANJI,        /* 0x9f04 */
    KANJI,        /* 0x9f05 */
    KANJI,        /* 0x9f06 */
    KANJI,        /* 0x9f07 */
    KANJI,        /* 0x9f08 */
    KANJI,        /* 0x9f09 */
    KANJI,        /* 0x9f0a */
    KANJI,        /* 0x9f0b */
    KANJI,        /* 0x9f0c */
    KANJI,        /* 0x9f0d */
    KANJI,        /* 0x9f0e */
    KANJI,        /* 0x9f0f */
    KANJI,        /* 0x9f10 */
    KANJI,        /* 0x9f11 */
    KANJI,        /* 0x9f12 */
    KANJI,        /* 0x9f13 */
    KANJI,        /* 0x9f14 */
    KANJI,        /* 0x9f15 */
    KANJI,        /* 0x9f16 */
    KANJI,        /* 0x9f17 */
    KANJI,        /* 0x9f18 */
    KANJI,        /* 0x9f19 */
    KANJI,        /* 0x9f1a */
    KANJI,        /* 0x9f1b */
    KANJI,        /* 0x9f1c */
    KANJI,        /* 0x9f1d */
    KANJI,        /* 0x9f1e */
    KANJI,        /* 0x9f1f */
    KANJI,        /* 0x9f20 */
    KANJI,        /* 0x9f21 */
    KANJI,        /* 0x9f22 */
    KANJI,        /* 0x9f23 */
    KANJI,        /* 0x9f24 */
    KANJI,        /* 0x9f25 */
    KANJI,        /* 0x9f26 */
    KANJI,        /* 0x9f27 */
    KANJI,        /* 0x9f28 */
    KANJI,        /* 0x9f29 */
    KANJI,        /* 0x9f2a */
    KANJI,        /* 0x9f2b */
    KANJI,        /* 0x9f2c */
    KANJI,        /* 0x9f2d */
    KANJI,        /* 0x9f2e */
    KANJI,        /* 0x9f2f */
    KANJI,        /* 0x9f30 */
    KANJI,        /* 0x9f31 */
    KANJI,        /* 0x9f32 */
    KANJI,        /* 0x9f33 */
    KANJI,        /* 0x9f34 */
    KANJI,        /* 0x9f35 */
    KANJI,        /* 0x9f36 */
    KANJI,        /* 0x9f37 */
    KANJI,        /* 0x9f38 */
    KANJI,        /* 0x9f39 */
    KANJI,        /* 0x9f3a */
    KANJI,        /* 0x9f3b */
    KANJI,        /* 0x9f3c */
    KANJI,        /* 0x9f3d */
    KANJI,        /* 0x9f3e */
    KANJI,        /* 0x9f3f */
    KANJI,        /* 0x9f40 */
    KANJI,        /* 0x9f41 */
    KANJI,        /* 0x9f42 */
    KANJI,        /* 0x9f43 */
    KANJI,        /* 0x9f44 */
    KANJI,        /* 0x9f45 */
    KANJI,        /* 0x9f46 */
    KANJI,        /* 0x9f47 */
    KANJI,        /* 0x9f48 */
    KANJI,        /* 0x9f49 */
    KANJI,        /* 0x9f4a */
    KANJI,        /* 0x9f4b */
    KANJI,        /* 0x9f4c */
    KANJI,        /* 0x9f4d */
    KANJI,        /* 0x9f4e */
    KANJI,        /* 0x9f4f */
    KANJI,        /* 0x9f50 */
    KANJI,        /* 0x9f51 */
    KANJI,        /* 0x9f52 */
    KANJI,        /* 0x9f53 */
    KANJI,        /* 0x9f54 */
    KANJI,        /* 0x9f55 */
    KANJI,        /* 0x9f56 */
    KANJI,        /* 0x9f57 */
    KANJI,        /* 0x9f58 */
    KANJI,        /* 0x9f59 */
    KANJI,        /* 0x9f5a */
    KANJI,        /* 0x9f5b */
    KANJI,        /* 0x9f5c */
    KANJI,        /* 0x9f5d */
    KANJI,        /* 0x9f5e */
    KANJI,        /* 0x9f5f */
    KANJI,        /* 0x9f60 */
    KANJI,        /* 0x9f61 */
    KANJI,        /* 0x9f62 */
    KANJI,        /* 0x9f63 */
    KANJI,        /* 0x9f64 */
    KANJI,        /* 0x9f65 */
    KANJI,        /* 0x9f66 */
    KANJI,        /* 0x9f67 */
    KANJI,        /* 0x9f68 */
    KANJI,        /* 0x9f69 */
    KANJI,        /* 0x9f6a */
    KANJI,        /* 0x9f6b */
    KANJI,        /* 0x9f6c */
    KANJI,        /* 0x9f6d */
    KANJI,        /* 0x9f6e */
    KANJI,        /* 0x9f6f */
    KANJI,        /* 0x9f70 */
    KANJI,        /* 0x9f71 */
    KANJI,        /* 0x9f72 */
    KANJI,        /* 0x9f73 */
    KANJI,        /* 0x9f74 */
    KANJI,        /* 0x9f75 */
    KANJI,        /* 0x9f76 */
    KANJI,        /* 0x9f77 */
    KANJI,        /* 0x9f78 */
    KANJI,        /* 0x9f79 */
    KANJI,        /* 0x9f7a */
    KANJI,        /* 0x9f7b */
    KANJI,        /* 0x9f7c */
    KANJI,        /* 0x9f7d */
    KANJI,        /* 0x9f7e */
    KANJI,        /* 0x9f7f */
    KANJI,        /* 0x9f80 */
    KANJI,        /* 0x9f81 */
    KANJI,        /* 0x9f82 */
    KANJI,        /* 0x9f83 */
    KANJI,        /* 0x9f84 */
    KANJI,        /* 0x9f85 */
    KANJI,        /* 0x9f86 */
    KANJI,        /* 0x9f87 */
    KANJI,        /* 0x9f88 */
    KANJI,        /* 0x9f89 */
    KANJI,        /* 0x9f8a */
    KANJI,        /* 0x9f8b */
    KANJI,        /* 0x9f8c */
    KANJI,        /* 0x9f8d */
    KANJI,        /* 0x9f8e */
    KANJI,        /* 0x9f8f */
    KANJI,        /* 0x9f90 */
    KANJI,        /* 0x9f91 */
    KANJI,        /* 0x9f92 */
    KANJI,        /* 0x9f93 */
    KANJI,        /* 0x9f94 */
    KANJI,        /* 0x9f95 */
    KANJI,        /* 0x9f96 */
    KANJI,        /* 0x9f97 */
    KANJI,        /* 0x9f98 */
    KANJI,        /* 0x9f99 */
    KANJI,        /* 0x9f9a */
    KANJI,        /* 0x9f9b */
    KANJI,        /* 0x9f9c */
    KANJI,        /* 0x9f9d */
    KANJI,        /* 0x9f9e */
    KANJI,        /* 0x9f9f */
    KANJI,        /* 0x9fa0 */
    KANJI,        /* 0x9fa1 */
    KANJI,        /* 0x9fa2 */
    KANJI,        /* 0x9fa3 */
    KANJI,        /* 0x9fa4 */
    KANJI,        /* 0x9fa5 */
    OTHER,        /* 0x9fa6 */
    OTHER,        /* 0x9fa7 */
    OTHER,        /* 0x9fa8 */
    OTHER,        /* 0x9fa9 */
    OTHER,        /* 0x9faa */
    OTHER,        /* 0x9fab */
    OTHER,        /* 0x9fac */
    OTHER,        /* 0x9fad */
    OTHER,        /* 0x9fae */
    OTHER,        /* 0x9faf */
    OTHER,        /* 0x9fb0 */
    OTHER,        /* 0x9fb1 */
    OTHER,        /* 0x9fb2 */
    OTHER,        /* 0x9fb3 */
    OTHER,        /* 0x9fb4 */
    OTHER,        /* 0x9fb5 */
    OTHER,        /* 0x9fb6 */
    OTHER,        /* 0x9fb7 */
    OTHER,        /* 0x9fb8 */
    OTHER,        /* 0x9fb9 */
    OTHER,        /* 0x9fba */
    OTHER,        /* 0x9fbb */
    OTHER,        /* 0x9fbc */
    OTHER,        /* 0x9fbd */
    OTHER,        /* 0x9fbe */
    OTHER,        /* 0x9fbf */
    OTHER,        /* 0x9fc0 */
    OTHER,        /* 0x9fc1 */
    OTHER,        /* 0x9fc2 */
    OTHER,        /* 0x9fc3 */
    OTHER,        /* 0x9fc4 */
    OTHER,        /* 0x9fc5 */
    OTHER,        /* 0x9fc6 */
    OTHER,        /* 0x9fc7 */
    OTHER,        /* 0x9fc8 */
    OTHER,        /* 0x9fc9 */
    OTHER,        /* 0x9fca */
    OTHER,        /* 0x9fcb */
    OTHER,        /* 0x9fcc */
    OTHER,        /* 0x9fcd */
    OTHER,        /* 0x9fce */
    OTHER,        /* 0x9fcf */
    OTHER,        /* 0x9fd0 */
    OTHER,        /* 0x9fd1 */
    OTHER,        /* 0x9fd2 */
    OTHER,        /* 0x9fd3 */
    OTHER,        /* 0x9fd4 */
    OTHER,        /* 0x9fd5 */
    OTHER,        /* 0x9fd6 */
    OTHER,        /* 0x9fd7 */
    OTHER,        /* 0x9fd8 */
    OTHER,        /* 0x9fd9 */
    OTHER,        /* 0x9fda */
    OTHER,        /* 0x9fdb */
    OTHER,        /* 0x9fdc */
    OTHER,        /* 0x9fdd */
    OTHER,        /* 0x9fde */
    OTHER,        /* 0x9fdf */
    OTHER,        /* 0x9fe0 */
    OTHER,        /* 0x9fe1 */
    OTHER,        /* 0x9fe2 */
    OTHER,        /* 0x9fe3 */
    OTHER,        /* 0x9fe4 */
    OTHER,        /* 0x9fe5 */
    OTHER,        /* 0x9fe6 */
    OTHER,        /* 0x9fe7 */
    OTHER,        /* 0x9fe8 */
    OTHER,        /* 0x9fe9 */
    OTHER,        /* 0x9fea */
    OTHER,        /* 0x9feb */
    OTHER,        /* 0x9fec */
    OTHER,        /* 0x9fed */
    OTHER,        /* 0x9fee */
    OTHER,        /* 0x9fef */
    OTHER,        /* 0x9ff0 */
    OTHER,        /* 0x9ff1 */
    OTHER,        /* 0x9ff2 */
    OTHER,        /* 0x9ff3 */
    OTHER,        /* 0x9ff4 */
    OTHER,        /* 0x9ff5 */
    OTHER,        /* 0x9ff6 */
    OTHER,        /* 0x9ff7 */
    OTHER,        /* 0x9ff8 */
    OTHER,        /* 0x9ff9 */
    OTHER,        /* 0x9ffa */
    OTHER,        /* 0x9ffb */
    OTHER,        /* 0x9ffc */
    OTHER,        /* 0x9ffd */
    OTHER,        /* 0x9ffe */
    OTHER,        /* 0x9fff */
    OTHER,        /* 0xa000 */
    OTHER,        /* 0xa001 */
    OTHER,        /* 0xa002 */
    OTHER,        /* 0xa003 */
    OTHER,        /* 0xa004 */
    OTHER,        /* 0xa005 */
    OTHER,        /* 0xa006 */
    OTHER,        /* 0xa007 */
    OTHER,        /* 0xa008 */
    OTHER,        /* 0xa009 */
    OTHER,        /* 0xa00a */
    OTHER,        /* 0xa00b */
    OTHER,        /* 0xa00c */
    OTHER,        /* 0xa00d */
    OTHER,        /* 0xa00e */
    OTHER,        /* 0xa00f */
    OTHER,        /* 0xa010 */
    OTHER,        /* 0xa011 */
    OTHER,        /* 0xa012 */
    OTHER,        /* 0xa013 */
    OTHER,        /* 0xa014 */
    OTHER,        /* 0xa015 */
    OTHER,        /* 0xa016 */
    OTHER,        /* 0xa017 */
    OTHER,        /* 0xa018 */
    OTHER,        /* 0xa019 */
    OTHER,        /* 0xa01a */
    OTHER,        /* 0xa01b */
    OTHER,        /* 0xa01c */
    OTHER,        /* 0xa01d */
    OTHER,        /* 0xa01e */
    OTHER,        /* 0xa01f */
    OTHER,        /* 0xa020 */
    OTHER,        /* 0xa021 */
    OTHER,        /* 0xa022 */
    OTHER,        /* 0xa023 */
    OTHER,        /* 0xa024 */
    OTHER,        /* 0xa025 */
    OTHER,        /* 0xa026 */
    OTHER,        /* 0xa027 */
    OTHER,        /* 0xa028 */
    OTHER,        /* 0xa029 */
    OTHER,        /* 0xa02a */
    OTHER,        /* 0xa02b */
    OTHER,        /* 0xa02c */
    OTHER,        /* 0xa02d */
    OTHER,        /* 0xa02e */
    OTHER,        /* 0xa02f */
    OTHER,        /* 0xa030 */
    OTHER,        /* 0xa031 */
    OTHER,        /* 0xa032 */
    OTHER,        /* 0xa033 */
    OTHER,        /* 0xa034 */
    OTHER,        /* 0xa035 */
    OTHER,        /* 0xa036 */
    OTHER,        /* 0xa037 */
    OTHER,        /* 0xa038 */
    OTHER,        /* 0xa039 */
    OTHER,        /* 0xa03a */
    OTHER,        /* 0xa03b */
    OTHER,        /* 0xa03c */
    OTHER,        /* 0xa03d */
    OTHER,        /* 0xa03e */
    OTHER,        /* 0xa03f */
    OTHER,        /* 0xa040 */
    OTHER,        /* 0xa041 */
    OTHER,        /* 0xa042 */
    OTHER,        /* 0xa043 */
    OTHER,        /* 0xa044 */
    OTHER,        /* 0xa045 */
    OTHER,        /* 0xa046 */
    OTHER,        /* 0xa047 */
    OTHER,        /* 0xa048 */
    OTHER,        /* 0xa049 */
    OTHER,        /* 0xa04a */
    OTHER,        /* 0xa04b */
    OTHER,        /* 0xa04c */
    OTHER,        /* 0xa04d */
    OTHER,        /* 0xa04e */
    OTHER,        /* 0xa04f */
    OTHER,        /* 0xa050 */
    OTHER,        /* 0xa051 */
    OTHER,        /* 0xa052 */
    OTHER,        /* 0xa053 */
    OTHER,        /* 0xa054 */
    OTHER,        /* 0xa055 */
    OTHER,        /* 0xa056 */
    OTHER,        /* 0xa057 */
    OTHER,        /* 0xa058 */
    OTHER,        /* 0xa059 */
    OTHER,        /* 0xa05a */
    OTHER,        /* 0xa05b */
    OTHER,        /* 0xa05c */
    OTHER,        /* 0xa05d */
    OTHER,        /* 0xa05e */
    OTHER,        /* 0xa05f */
    OTHER,        /* 0xa060 */
    OTHER,        /* 0xa061 */
    OTHER,        /* 0xa062 */
    OTHER,        /* 0xa063 */
    OTHER,        /* 0xa064 */
    OTHER,        /* 0xa065 */
    OTHER,        /* 0xa066 */
    OTHER,        /* 0xa067 */
    OTHER,        /* 0xa068 */
    OTHER,        /* 0xa069 */
    OTHER,        /* 0xa06a */
    OTHER,        /* 0xa06b */
    OTHER,        /* 0xa06c */
    OTHER,        /* 0xa06d */
    OTHER,        /* 0xa06e */
    OTHER,        /* 0xa06f */
    OTHER,        /* 0xa070 */
    OTHER,        /* 0xa071 */
    OTHER,        /* 0xa072 */
    OTHER,        /* 0xa073 */
    OTHER,        /* 0xa074 */
    OTHER,        /* 0xa075 */
    OTHER,        /* 0xa076 */
    OTHER,        /* 0xa077 */
    OTHER,        /* 0xa078 */
    OTHER,        /* 0xa079 */
    OTHER,        /* 0xa07a */
    OTHER,        /* 0xa07b */
    OTHER,        /* 0xa07c */
    OTHER,        /* 0xa07d */
    OTHER,        /* 0xa07e */
    OTHER,        /* 0xa07f */
    OTHER,        /* 0xa080 */
    OTHER,        /* 0xa081 */
    OTHER,        /* 0xa082 */
    OTHER,        /* 0xa083 */
    OTHER,        /* 0xa084 */
    OTHER,        /* 0xa085 */
    OTHER,        /* 0xa086 */
    OTHER,        /* 0xa087 */
    OTHER,        /* 0xa088 */
    OTHER,        /* 0xa089 */
    OTHER,        /* 0xa08a */
    OTHER,        /* 0xa08b */
    OTHER,        /* 0xa08c */
    OTHER,        /* 0xa08d */
    OTHER,        /* 0xa08e */
    OTHER,        /* 0xa08f */
    OTHER,        /* 0xa090 */
    OTHER,        /* 0xa091 */
    OTHER,        /* 0xa092 */
    OTHER,        /* 0xa093 */
    OTHER,        /* 0xa094 */
    OTHER,        /* 0xa095 */
    OTHER,        /* 0xa096 */
    OTHER,        /* 0xa097 */
    OTHER,        /* 0xa098 */
    OTHER,        /* 0xa099 */
    OTHER,        /* 0xa09a */
    OTHER,        /* 0xa09b */
    OTHER,        /* 0xa09c */
    OTHER,        /* 0xa09d */
    OTHER,        /* 0xa09e */
    OTHER,        /* 0xa09f */
    OTHER,        /* 0xa0a0 */
    OTHER,        /* 0xa0a1 */
    OTHER,        /* 0xa0a2 */
    OTHER,        /* 0xa0a3 */
    OTHER,        /* 0xa0a4 */
    OTHER,        /* 0xa0a5 */
    OTHER,        /* 0xa0a6 */
    OTHER,        /* 0xa0a7 */
    OTHER,        /* 0xa0a8 */
    OTHER,        /* 0xa0a9 */
    OTHER,        /* 0xa0aa */
    OTHER,        /* 0xa0ab */
    OTHER,        /* 0xa0ac */
    OTHER,        /* 0xa0ad */
    OTHER,        /* 0xa0ae */
    OTHER,        /* 0xa0af */
    OTHER,        /* 0xa0b0 */
    OTHER,        /* 0xa0b1 */
    OTHER,        /* 0xa0b2 */
    OTHER,        /* 0xa0b3 */
    OTHER,        /* 0xa0b4 */
    OTHER,        /* 0xa0b5 */
    OTHER,        /* 0xa0b6 */
    OTHER,        /* 0xa0b7 */
    OTHER,        /* 0xa0b8 */
    OTHER,        /* 0xa0b9 */
    OTHER,        /* 0xa0ba */
    OTHER,        /* 0xa0bb */
    OTHER,        /* 0xa0bc */
    OTHER,        /* 0xa0bd */
    OTHER,        /* 0xa0be */
    OTHER,        /* 0xa0bf */
    OTHER,        /* 0xa0c0 */
    OTHER,        /* 0xa0c1 */
    OTHER,        /* 0xa0c2 */
    OTHER,        /* 0xa0c3 */
    OTHER,        /* 0xa0c4 */
    OTHER,        /* 0xa0c5 */
    OTHER,        /* 0xa0c6 */
    OTHER,        /* 0xa0c7 */
    OTHER,        /* 0xa0c8 */
    OTHER,        /* 0xa0c9 */
    OTHER,        /* 0xa0ca */
    OTHER,        /* 0xa0cb */
    OTHER,        /* 0xa0cc */
    OTHER,        /* 0xa0cd */
    OTHER,        /* 0xa0ce */
    OTHER,        /* 0xa0cf */
    OTHER,        /* 0xa0d0 */
    OTHER,        /* 0xa0d1 */
    OTHER,        /* 0xa0d2 */
    OTHER,        /* 0xa0d3 */
    OTHER,        /* 0xa0d4 */
    OTHER,        /* 0xa0d5 */
    OTHER,        /* 0xa0d6 */
    OTHER,        /* 0xa0d7 */
    OTHER,        /* 0xa0d8 */
    OTHER,        /* 0xa0d9 */
    OTHER,        /* 0xa0da */
    OTHER,        /* 0xa0db */
    OTHER,        /* 0xa0dc */
    OTHER,        /* 0xa0dd */
    OTHER,        /* 0xa0de */
    OTHER,        /* 0xa0df */
    OTHER,        /* 0xa0e0 */
    OTHER,        /* 0xa0e1 */
    OTHER,        /* 0xa0e2 */
    OTHER,        /* 0xa0e3 */
    OTHER,        /* 0xa0e4 */
    OTHER,        /* 0xa0e5 */
    OTHER,        /* 0xa0e6 */
    OTHER,        /* 0xa0e7 */
    OTHER,        /* 0xa0e8 */
    OTHER,        /* 0xa0e9 */
    OTHER,        /* 0xa0ea */
    OTHER,        /* 0xa0eb */
    OTHER,        /* 0xa0ec */
    OTHER,        /* 0xa0ed */
    OTHER,        /* 0xa0ee */
    OTHER,        /* 0xa0ef */
    OTHER,        /* 0xa0f0 */
    OTHER,        /* 0xa0f1 */
    OTHER,        /* 0xa0f2 */
    OTHER,        /* 0xa0f3 */
    OTHER,        /* 0xa0f4 */
    OTHER,        /* 0xa0f5 */
    OTHER,        /* 0xa0f6 */
    OTHER,        /* 0xa0f7 */
    OTHER,        /* 0xa0f8 */
    OTHER,        /* 0xa0f9 */
    OTHER,        /* 0xa0fa */
    OTHER,        /* 0xa0fb */
    OTHER,        /* 0xa0fc */
    OTHER,        /* 0xa0fd */
    OTHER,        /* 0xa0fe */
    OTHER,        /* 0xa0ff */
    OTHER,        /* 0xa100 */
    OTHER,        /* 0xa101 */
    OTHER,        /* 0xa102 */
    OTHER,        /* 0xa103 */
    OTHER,        /* 0xa104 */
    OTHER,        /* 0xa105 */
    OTHER,        /* 0xa106 */
    OTHER,        /* 0xa107 */
    OTHER,        /* 0xa108 */
    OTHER,        /* 0xa109 */
    OTHER,        /* 0xa10a */
    OTHER,        /* 0xa10b */
    OTHER,        /* 0xa10c */
    OTHER,        /* 0xa10d */
    OTHER,        /* 0xa10e */
    OTHER,        /* 0xa10f */
    OTHER,        /* 0xa110 */
    OTHER,        /* 0xa111 */
    OTHER,        /* 0xa112 */
    OTHER,        /* 0xa113 */
    OTHER,        /* 0xa114 */
    OTHER,        /* 0xa115 */
    OTHER,        /* 0xa116 */
    OTHER,        /* 0xa117 */
    OTHER,        /* 0xa118 */
    OTHER,        /* 0xa119 */
    OTHER,        /* 0xa11a */
    OTHER,        /* 0xa11b */
    OTHER,        /* 0xa11c */
    OTHER,        /* 0xa11d */
    OTHER,        /* 0xa11e */
    OTHER,        /* 0xa11f */
    OTHER,        /* 0xa120 */
    OTHER,        /* 0xa121 */
    OTHER,        /* 0xa122 */
    OTHER,        /* 0xa123 */
    OTHER,        /* 0xa124 */
    OTHER,        /* 0xa125 */
    OTHER,        /* 0xa126 */
    OTHER,        /* 0xa127 */
    OTHER,        /* 0xa128 */
    OTHER,        /* 0xa129 */
    OTHER,        /* 0xa12a */
    OTHER,        /* 0xa12b */
    OTHER,        /* 0xa12c */
    OTHER,        /* 0xa12d */
    OTHER,        /* 0xa12e */
    OTHER,        /* 0xa12f */
    OTHER,        /* 0xa130 */
    OTHER,        /* 0xa131 */
    OTHER,        /* 0xa132 */
    OTHER,        /* 0xa133 */
    OTHER,        /* 0xa134 */
    OTHER,        /* 0xa135 */
    OTHER,        /* 0xa136 */
    OTHER,        /* 0xa137 */
    OTHER,        /* 0xa138 */
    OTHER,        /* 0xa139 */
    OTHER,        /* 0xa13a */
    OTHER,        /* 0xa13b */
    OTHER,        /* 0xa13c */
    OTHER,        /* 0xa13d */
    OTHER,        /* 0xa13e */
    OTHER,        /* 0xa13f */
    OTHER,        /* 0xa140 */
    OTHER,        /* 0xa141 */
    OTHER,        /* 0xa142 */
    OTHER,        /* 0xa143 */
    OTHER,        /* 0xa144 */
    OTHER,        /* 0xa145 */
    OTHER,        /* 0xa146 */
    OTHER,        /* 0xa147 */
    OTHER,        /* 0xa148 */
    OTHER,        /* 0xa149 */
    OTHER,        /* 0xa14a */
    OTHER,        /* 0xa14b */
    OTHER,        /* 0xa14c */
    OTHER,        /* 0xa14d */
    OTHER,        /* 0xa14e */
    OTHER,        /* 0xa14f */
    OTHER,        /* 0xa150 */
    OTHER,        /* 0xa151 */
    OTHER,        /* 0xa152 */
    OTHER,        /* 0xa153 */
    OTHER,        /* 0xa154 */
    OTHER,        /* 0xa155 */
    OTHER,        /* 0xa156 */
    OTHER,        /* 0xa157 */
    OTHER,        /* 0xa158 */
    OTHER,        /* 0xa159 */
    OTHER,        /* 0xa15a */
    OTHER,        /* 0xa15b */
    OTHER,        /* 0xa15c */
    OTHER,        /* 0xa15d */
    OTHER,        /* 0xa15e */
    OTHER,        /* 0xa15f */
    OTHER,        /* 0xa160 */
    OTHER,        /* 0xa161 */
    OTHER,        /* 0xa162 */
    OTHER,        /* 0xa163 */
    OTHER,        /* 0xa164 */
    OTHER,        /* 0xa165 */
    OTHER,        /* 0xa166 */
    OTHER,        /* 0xa167 */
    OTHER,        /* 0xa168 */
    OTHER,        /* 0xa169 */
    OTHER,        /* 0xa16a */
    OTHER,        /* 0xa16b */
    OTHER,        /* 0xa16c */
    OTHER,        /* 0xa16d */
    OTHER,        /* 0xa16e */
    OTHER,        /* 0xa16f */
    OTHER,        /* 0xa170 */
    OTHER,        /* 0xa171 */
    OTHER,        /* 0xa172 */
    OTHER,        /* 0xa173 */
    OTHER,        /* 0xa174 */
    OTHER,        /* 0xa175 */
    OTHER,        /* 0xa176 */
    OTHER,        /* 0xa177 */
    OTHER,        /* 0xa178 */
    OTHER,        /* 0xa179 */
    OTHER,        /* 0xa17a */
    OTHER,        /* 0xa17b */
    OTHER,        /* 0xa17c */
    OTHER,        /* 0xa17d */
    OTHER,        /* 0xa17e */
    OTHER,        /* 0xa17f */
    OTHER,        /* 0xa180 */
    OTHER,        /* 0xa181 */
    OTHER,        /* 0xa182 */
    OTHER,        /* 0xa183 */
    OTHER,        /* 0xa184 */
    OTHER,        /* 0xa185 */
    OTHER,        /* 0xa186 */
    OTHER,        /* 0xa187 */
    OTHER,        /* 0xa188 */
    OTHER,        /* 0xa189 */
    OTHER,        /* 0xa18a */
    OTHER,        /* 0xa18b */
    OTHER,        /* 0xa18c */
    OTHER,        /* 0xa18d */
    OTHER,        /* 0xa18e */
    OTHER,        /* 0xa18f */
    OTHER,        /* 0xa190 */
    OTHER,        /* 0xa191 */
    OTHER,        /* 0xa192 */
    OTHER,        /* 0xa193 */
    OTHER,        /* 0xa194 */
    OTHER,        /* 0xa195 */
    OTHER,        /* 0xa196 */
    OTHER,        /* 0xa197 */
    OTHER,        /* 0xa198 */
    OTHER,        /* 0xa199 */
    OTHER,        /* 0xa19a */
    OTHER,        /* 0xa19b */
    OTHER,        /* 0xa19c */
    OTHER,        /* 0xa19d */
    OTHER,        /* 0xa19e */
    OTHER,        /* 0xa19f */
    OTHER,        /* 0xa1a0 */
    OTHER,        /* 0xa1a1 */
    OTHER,        /* 0xa1a2 */
    OTHER,        /* 0xa1a3 */
    OTHER,        /* 0xa1a4 */
    OTHER,        /* 0xa1a5 */
    OTHER,        /* 0xa1a6 */
    OTHER,        /* 0xa1a7 */
    OTHER,        /* 0xa1a8 */
    OTHER,        /* 0xa1a9 */
    OTHER,        /* 0xa1aa */
    OTHER,        /* 0xa1ab */
    OTHER,        /* 0xa1ac */
    OTHER,        /* 0xa1ad */
    OTHER,        /* 0xa1ae */
    OTHER,        /* 0xa1af */
    OTHER,        /* 0xa1b0 */
    OTHER,        /* 0xa1b1 */
    OTHER,        /* 0xa1b2 */
    OTHER,        /* 0xa1b3 */
    OTHER,        /* 0xa1b4 */
    OTHER,        /* 0xa1b5 */
    OTHER,        /* 0xa1b6 */
    OTHER,        /* 0xa1b7 */
    OTHER,        /* 0xa1b8 */
    OTHER,        /* 0xa1b9 */
    OTHER,        /* 0xa1ba */
    OTHER,        /* 0xa1bb */
    OTHER,        /* 0xa1bc */
    OTHER,        /* 0xa1bd */
    OTHER,        /* 0xa1be */
    OTHER,        /* 0xa1bf */
    OTHER,        /* 0xa1c0 */
    OTHER,        /* 0xa1c1 */
    OTHER,        /* 0xa1c2 */
    OTHER,        /* 0xa1c3 */
    OTHER,        /* 0xa1c4 */
    OTHER,        /* 0xa1c5 */
    OTHER,        /* 0xa1c6 */
    OTHER,        /* 0xa1c7 */
    OTHER,        /* 0xa1c8 */
    OTHER,        /* 0xa1c9 */
    OTHER,        /* 0xa1ca */
    OTHER,        /* 0xa1cb */
    OTHER,        /* 0xa1cc */
    OTHER,        /* 0xa1cd */
    OTHER,        /* 0xa1ce */
    OTHER,        /* 0xa1cf */
    OTHER,        /* 0xa1d0 */
    OTHER,        /* 0xa1d1 */
    OTHER,        /* 0xa1d2 */
    OTHER,        /* 0xa1d3 */
    OTHER,        /* 0xa1d4 */
    OTHER,        /* 0xa1d5 */
    OTHER,        /* 0xa1d6 */
    OTHER,        /* 0xa1d7 */
    OTHER,        /* 0xa1d8 */
    OTHER,        /* 0xa1d9 */
    OTHER,        /* 0xa1da */
    OTHER,        /* 0xa1db */
    OTHER,        /* 0xa1dc */
    OTHER,        /* 0xa1dd */
    OTHER,        /* 0xa1de */
    OTHER,        /* 0xa1df */
    OTHER,        /* 0xa1e0 */
    OTHER,        /* 0xa1e1 */
    OTHER,        /* 0xa1e2 */
    OTHER,        /* 0xa1e3 */
    OTHER,        /* 0xa1e4 */
    OTHER,        /* 0xa1e5 */
    OTHER,        /* 0xa1e6 */
    OTHER,        /* 0xa1e7 */
    OTHER,        /* 0xa1e8 */
    OTHER,        /* 0xa1e9 */
    OTHER,        /* 0xa1ea */
    OTHER,        /* 0xa1eb */
    OTHER,        /* 0xa1ec */
    OTHER,        /* 0xa1ed */
    OTHER,        /* 0xa1ee */
    OTHER,        /* 0xa1ef */
    OTHER,        /* 0xa1f0 */
    OTHER,        /* 0xa1f1 */
    OTHER,        /* 0xa1f2 */
    OTHER,        /* 0xa1f3 */
    OTHER,        /* 0xa1f4 */
    OTHER,        /* 0xa1f5 */
    OTHER,        /* 0xa1f6 */
    OTHER,        /* 0xa1f7 */
    OTHER,        /* 0xa1f8 */
    OTHER,        /* 0xa1f9 */
    OTHER,        /* 0xa1fa */
    OTHER,        /* 0xa1fb */
    OTHER,        /* 0xa1fc */
    OTHER,        /* 0xa1fd */
    OTHER,        /* 0xa1fe */
    OTHER,        /* 0xa1ff */
    OTHER,        /* 0xa200 */
    OTHER,        /* 0xa201 */
    OTHER,        /* 0xa202 */
    OTHER,        /* 0xa203 */
    OTHER,        /* 0xa204 */
    OTHER,        /* 0xa205 */
    OTHER,        /* 0xa206 */
    OTHER,        /* 0xa207 */
    OTHER,        /* 0xa208 */
    OTHER,        /* 0xa209 */
    OTHER,        /* 0xa20a */
    OTHER,        /* 0xa20b */
    OTHER,        /* 0xa20c */
    OTHER,        /* 0xa20d */
    OTHER,        /* 0xa20e */
    OTHER,        /* 0xa20f */
    OTHER,        /* 0xa210 */
    OTHER,        /* 0xa211 */
    OTHER,        /* 0xa212 */
    OTHER,        /* 0xa213 */
    OTHER,        /* 0xa214 */
    OTHER,        /* 0xa215 */
    OTHER,        /* 0xa216 */
    OTHER,        /* 0xa217 */
    OTHER,        /* 0xa218 */
    OTHER,        /* 0xa219 */
    OTHER,        /* 0xa21a */
    OTHER,        /* 0xa21b */
    OTHER,        /* 0xa21c */
    OTHER,        /* 0xa21d */
    OTHER,        /* 0xa21e */
    OTHER,        /* 0xa21f */
    OTHER,        /* 0xa220 */
    OTHER,        /* 0xa221 */
    OTHER,        /* 0xa222 */
    OTHER,        /* 0xa223 */
    OTHER,        /* 0xa224 */
    OTHER,        /* 0xa225 */
    OTHER,        /* 0xa226 */
    OTHER,        /* 0xa227 */
    OTHER,        /* 0xa228 */
    OTHER,        /* 0xa229 */
    OTHER,        /* 0xa22a */
    OTHER,        /* 0xa22b */
    OTHER,        /* 0xa22c */
    OTHER,        /* 0xa22d */
    OTHER,        /* 0xa22e */
    OTHER,        /* 0xa22f */
    OTHER,        /* 0xa230 */
    OTHER,        /* 0xa231 */
    OTHER,        /* 0xa232 */
    OTHER,        /* 0xa233 */
    OTHER,        /* 0xa234 */
    OTHER,        /* 0xa235 */
    OTHER,        /* 0xa236 */
    OTHER,        /* 0xa237 */
    OTHER,        /* 0xa238 */
    OTHER,        /* 0xa239 */
    OTHER,        /* 0xa23a */
    OTHER,        /* 0xa23b */
    OTHER,        /* 0xa23c */
    OTHER,        /* 0xa23d */
    OTHER,        /* 0xa23e */
    OTHER,        /* 0xa23f */
    OTHER,        /* 0xa240 */
    OTHER,        /* 0xa241 */
    OTHER,        /* 0xa242 */
    OTHER,        /* 0xa243 */
    OTHER,        /* 0xa244 */
    OTHER,        /* 0xa245 */
    OTHER,        /* 0xa246 */
    OTHER,        /* 0xa247 */
    OTHER,        /* 0xa248 */
    OTHER,        /* 0xa249 */
    OTHER,        /* 0xa24a */
    OTHER,        /* 0xa24b */
    OTHER,        /* 0xa24c */
    OTHER,        /* 0xa24d */
    OTHER,        /* 0xa24e */
    OTHER,        /* 0xa24f */
    OTHER,        /* 0xa250 */
    OTHER,        /* 0xa251 */
    OTHER,        /* 0xa252 */
    OTHER,        /* 0xa253 */
    OTHER,        /* 0xa254 */
    OTHER,        /* 0xa255 */
    OTHER,        /* 0xa256 */
    OTHER,        /* 0xa257 */
    OTHER,        /* 0xa258 */
    OTHER,        /* 0xa259 */
    OTHER,        /* 0xa25a */
    OTHER,        /* 0xa25b */
    OTHER,        /* 0xa25c */
    OTHER,        /* 0xa25d */
    OTHER,        /* 0xa25e */
    OTHER,        /* 0xa25f */
    OTHER,        /* 0xa260 */
    OTHER,        /* 0xa261 */
    OTHER,        /* 0xa262 */
    OTHER,        /* 0xa263 */
    OTHER,        /* 0xa264 */
    OTHER,        /* 0xa265 */
    OTHER,        /* 0xa266 */
    OTHER,        /* 0xa267 */
    OTHER,        /* 0xa268 */
    OTHER,        /* 0xa269 */
    OTHER,        /* 0xa26a */
    OTHER,        /* 0xa26b */
    OTHER,        /* 0xa26c */
    OTHER,        /* 0xa26d */
    OTHER,        /* 0xa26e */
    OTHER,        /* 0xa26f */
    OTHER,        /* 0xa270 */
    OTHER,        /* 0xa271 */
    OTHER,        /* 0xa272 */
    OTHER,        /* 0xa273 */
    OTHER,        /* 0xa274 */
    OTHER,        /* 0xa275 */
    OTHER,        /* 0xa276 */
    OTHER,        /* 0xa277 */
    OTHER,        /* 0xa278 */
    OTHER,        /* 0xa279 */
    OTHER,        /* 0xa27a */
    OTHER,        /* 0xa27b */
    OTHER,        /* 0xa27c */
    OTHER,        /* 0xa27d */
    OTHER,        /* 0xa27e */
    OTHER,        /* 0xa27f */
    OTHER,        /* 0xa280 */
    OTHER,        /* 0xa281 */
    OTHER,        /* 0xa282 */
    OTHER,        /* 0xa283 */
    OTHER,        /* 0xa284 */
    OTHER,        /* 0xa285 */
    OTHER,        /* 0xa286 */
    OTHER,        /* 0xa287 */
    OTHER,        /* 0xa288 */
    OTHER,        /* 0xa289 */
    OTHER,        /* 0xa28a */
    OTHER,        /* 0xa28b */
    OTHER,        /* 0xa28c */
    OTHER,        /* 0xa28d */
    OTHER,        /* 0xa28e */
    OTHER,        /* 0xa28f */
    OTHER,        /* 0xa290 */
    OTHER,        /* 0xa291 */
    OTHER,        /* 0xa292 */
    OTHER,        /* 0xa293 */
    OTHER,        /* 0xa294 */
    OTHER,        /* 0xa295 */
    OTHER,        /* 0xa296 */
    OTHER,        /* 0xa297 */
    OTHER,        /* 0xa298 */
    OTHER,        /* 0xa299 */
    OTHER,        /* 0xa29a */
    OTHER,        /* 0xa29b */
    OTHER,        /* 0xa29c */
    OTHER,        /* 0xa29d */
    OTHER,        /* 0xa29e */
    OTHER,        /* 0xa29f */
    OTHER,        /* 0xa2a0 */
    OTHER,        /* 0xa2a1 */
    OTHER,        /* 0xa2a2 */
    OTHER,        /* 0xa2a3 */
    OTHER,        /* 0xa2a4 */
    OTHER,        /* 0xa2a5 */
    OTHER,        /* 0xa2a6 */
    OTHER,        /* 0xa2a7 */
    OTHER,        /* 0xa2a8 */
    OTHER,        /* 0xa2a9 */
    OTHER,        /* 0xa2aa */
    OTHER,        /* 0xa2ab */
    OTHER,        /* 0xa2ac */
    OTHER,        /* 0xa2ad */
    OTHER,        /* 0xa2ae */
    OTHER,        /* 0xa2af */
    OTHER,        /* 0xa2b0 */
    OTHER,        /* 0xa2b1 */
    OTHER,        /* 0xa2b2 */
    OTHER,        /* 0xa2b3 */
    OTHER,        /* 0xa2b4 */
    OTHER,        /* 0xa2b5 */
    OTHER,        /* 0xa2b6 */
    OTHER,        /* 0xa2b7 */
    OTHER,        /* 0xa2b8 */
    OTHER,        /* 0xa2b9 */
    OTHER,        /* 0xa2ba */
    OTHER,        /* 0xa2bb */
    OTHER,        /* 0xa2bc */
    OTHER,        /* 0xa2bd */
    OTHER,        /* 0xa2be */
    OTHER,        /* 0xa2bf */
    OTHER,        /* 0xa2c0 */
    OTHER,        /* 0xa2c1 */
    OTHER,        /* 0xa2c2 */
    OTHER,        /* 0xa2c3 */
    OTHER,        /* 0xa2c4 */
    OTHER,        /* 0xa2c5 */
    OTHER,        /* 0xa2c6 */
    OTHER,        /* 0xa2c7 */
    OTHER,        /* 0xa2c8 */
    OTHER,        /* 0xa2c9 */
    OTHER,        /* 0xa2ca */
    OTHER,        /* 0xa2cb */
    OTHER,        /* 0xa2cc */
    OTHER,        /* 0xa2cd */
    OTHER,        /* 0xa2ce */
    OTHER,        /* 0xa2cf */
    OTHER,        /* 0xa2d0 */
    OTHER,        /* 0xa2d1 */
    OTHER,        /* 0xa2d2 */
    OTHER,        /* 0xa2d3 */
    OTHER,        /* 0xa2d4 */
    OTHER,        /* 0xa2d5 */
    OTHER,        /* 0xa2d6 */
    OTHER,        /* 0xa2d7 */
    OTHER,        /* 0xa2d8 */
    OTHER,        /* 0xa2d9 */
    OTHER,        /* 0xa2da */
    OTHER,        /* 0xa2db */
    OTHER,        /* 0xa2dc */
    OTHER,        /* 0xa2dd */
    OTHER,        /* 0xa2de */
    OTHER,        /* 0xa2df */
    OTHER,        /* 0xa2e0 */
    OTHER,        /* 0xa2e1 */
    OTHER,        /* 0xa2e2 */
    OTHER,        /* 0xa2e3 */
    OTHER,        /* 0xa2e4 */
    OTHER,        /* 0xa2e5 */
    OTHER,        /* 0xa2e6 */
    OTHER,        /* 0xa2e7 */
    OTHER,        /* 0xa2e8 */
    OTHER,        /* 0xa2e9 */
    OTHER,        /* 0xa2ea */
    OTHER,        /* 0xa2eb */
    OTHER,        /* 0xa2ec */
    OTHER,        /* 0xa2ed */
    OTHER,        /* 0xa2ee */
    OTHER,        /* 0xa2ef */
    OTHER,        /* 0xa2f0 */
    OTHER,        /* 0xa2f1 */
    OTHER,        /* 0xa2f2 */
    OTHER,        /* 0xa2f3 */
    OTHER,        /* 0xa2f4 */
    OTHER,        /* 0xa2f5 */
    OTHER,        /* 0xa2f6 */
    OTHER,        /* 0xa2f7 */
    OTHER,        /* 0xa2f8 */
    OTHER,        /* 0xa2f9 */
    OTHER,        /* 0xa2fa */
    OTHER,        /* 0xa2fb */
    OTHER,        /* 0xa2fc */
    OTHER,        /* 0xa2fd */
    OTHER,        /* 0xa2fe */
    OTHER,        /* 0xa2ff */
    OTHER,        /* 0xa300 */
    OTHER,        /* 0xa301 */
    OTHER,        /* 0xa302 */
    OTHER,        /* 0xa303 */
    OTHER,        /* 0xa304 */
    OTHER,        /* 0xa305 */
    OTHER,        /* 0xa306 */
    OTHER,        /* 0xa307 */
    OTHER,        /* 0xa308 */
    OTHER,        /* 0xa309 */
    OTHER,        /* 0xa30a */
    OTHER,        /* 0xa30b */
    OTHER,        /* 0xa30c */
    OTHER,        /* 0xa30d */
    OTHER,        /* 0xa30e */
    OTHER,        /* 0xa30f */
    OTHER,        /* 0xa310 */
    OTHER,        /* 0xa311 */
    OTHER,        /* 0xa312 */
    OTHER,        /* 0xa313 */
    OTHER,        /* 0xa314 */
    OTHER,        /* 0xa315 */
    OTHER,        /* 0xa316 */
    OTHER,        /* 0xa317 */
    OTHER,        /* 0xa318 */
    OTHER,        /* 0xa319 */
    OTHER,        /* 0xa31a */
    OTHER,        /* 0xa31b */
    OTHER,        /* 0xa31c */
    OTHER,        /* 0xa31d */
    OTHER,        /* 0xa31e */
    OTHER,        /* 0xa31f */
    OTHER,        /* 0xa320 */
    OTHER,        /* 0xa321 */
    OTHER,        /* 0xa322 */
    OTHER,        /* 0xa323 */
    OTHER,        /* 0xa324 */
    OTHER,        /* 0xa325 */
    OTHER,        /* 0xa326 */
    OTHER,        /* 0xa327 */
    OTHER,        /* 0xa328 */
    OTHER,        /* 0xa329 */
    OTHER,        /* 0xa32a */
    OTHER,        /* 0xa32b */
    OTHER,        /* 0xa32c */
    OTHER,        /* 0xa32d */
    OTHER,        /* 0xa32e */
    OTHER,        /* 0xa32f */
    OTHER,        /* 0xa330 */
    OTHER,        /* 0xa331 */
    OTHER,        /* 0xa332 */
    OTHER,        /* 0xa333 */
    OTHER,        /* 0xa334 */
    OTHER,        /* 0xa335 */
    OTHER,        /* 0xa336 */
    OTHER,        /* 0xa337 */
    OTHER,        /* 0xa338 */
    OTHER,        /* 0xa339 */
    OTHER,        /* 0xa33a */
    OTHER,        /* 0xa33b */
    OTHER,        /* 0xa33c */
    OTHER,        /* 0xa33d */
    OTHER,        /* 0xa33e */
    OTHER,        /* 0xa33f */
    OTHER,        /* 0xa340 */
    OTHER,        /* 0xa341 */
    OTHER,        /* 0xa342 */
    OTHER,        /* 0xa343 */
    OTHER,        /* 0xa344 */
    OTHER,        /* 0xa345 */
    OTHER,        /* 0xa346 */
    OTHER,        /* 0xa347 */
    OTHER,        /* 0xa348 */
    OTHER,        /* 0xa349 */
    OTHER,        /* 0xa34a */
    OTHER,        /* 0xa34b */
    OTHER,        /* 0xa34c */
    OTHER,        /* 0xa34d */
    OTHER,        /* 0xa34e */
    OTHER,        /* 0xa34f */
    OTHER,        /* 0xa350 */
    OTHER,        /* 0xa351 */
    OTHER,        /* 0xa352 */
    OTHER,        /* 0xa353 */
    OTHER,        /* 0xa354 */
    OTHER,        /* 0xa355 */
    OTHER,        /* 0xa356 */
    OTHER,        /* 0xa357 */
    OTHER,        /* 0xa358 */
    OTHER,        /* 0xa359 */
    OTHER,        /* 0xa35a */
    OTHER,        /* 0xa35b */
    OTHER,        /* 0xa35c */
    OTHER,        /* 0xa35d */
    OTHER,        /* 0xa35e */
    OTHER,        /* 0xa35f */
    OTHER,        /* 0xa360 */
    OTHER,        /* 0xa361 */
    OTHER,        /* 0xa362 */
    OTHER,        /* 0xa363 */
    OTHER,        /* 0xa364 */
    OTHER,        /* 0xa365 */
    OTHER,        /* 0xa366 */
    OTHER,        /* 0xa367 */
    OTHER,        /* 0xa368 */
    OTHER,        /* 0xa369 */
    OTHER,        /* 0xa36a */
    OTHER,        /* 0xa36b */
    OTHER,        /* 0xa36c */
    OTHER,        /* 0xa36d */
    OTHER,        /* 0xa36e */
    OTHER,        /* 0xa36f */
    OTHER,        /* 0xa370 */
    OTHER,        /* 0xa371 */
    OTHER,        /* 0xa372 */
    OTHER,        /* 0xa373 */
    OTHER,        /* 0xa374 */
    OTHER,        /* 0xa375 */
    OTHER,        /* 0xa376 */
    OTHER,        /* 0xa377 */
    OTHER,        /* 0xa378 */
    OTHER,        /* 0xa379 */
    OTHER,        /* 0xa37a */
    OTHER,        /* 0xa37b */
    OTHER,        /* 0xa37c */
    OTHER,        /* 0xa37d */
    OTHER,        /* 0xa37e */
    OTHER,        /* 0xa37f */
    OTHER,        /* 0xa380 */
    OTHER,        /* 0xa381 */
    OTHER,        /* 0xa382 */
    OTHER,        /* 0xa383 */
    OTHER,        /* 0xa384 */
    OTHER,        /* 0xa385 */
    OTHER,        /* 0xa386 */
    OTHER,        /* 0xa387 */
    OTHER,        /* 0xa388 */
    OTHER,        /* 0xa389 */
    OTHER,        /* 0xa38a */
    OTHER,        /* 0xa38b */
    OTHER,        /* 0xa38c */
    OTHER,        /* 0xa38d */
    OTHER,        /* 0xa38e */
    OTHER,        /* 0xa38f */
    OTHER,        /* 0xa390 */
    OTHER,        /* 0xa391 */
    OTHER,        /* 0xa392 */
    OTHER,        /* 0xa393 */
    OTHER,        /* 0xa394 */
    OTHER,        /* 0xa395 */
    OTHER,        /* 0xa396 */
    OTHER,        /* 0xa397 */
    OTHER,        /* 0xa398 */
    OTHER,        /* 0xa399 */
    OTHER,        /* 0xa39a */
    OTHER,        /* 0xa39b */
    OTHER,        /* 0xa39c */
    OTHER,        /* 0xa39d */
    OTHER,        /* 0xa39e */
    OTHER,        /* 0xa39f */
    OTHER,        /* 0xa3a0 */
    OTHER,        /* 0xa3a1 */
    OTHER,        /* 0xa3a2 */
    OTHER,        /* 0xa3a3 */
    OTHER,        /* 0xa3a4 */
    OTHER,        /* 0xa3a5 */
    OTHER,        /* 0xa3a6 */
    OTHER,        /* 0xa3a7 */
    OTHER,        /* 0xa3a8 */
    OTHER,        /* 0xa3a9 */
    OTHER,        /* 0xa3aa */
    OTHER,        /* 0xa3ab */
    OTHER,        /* 0xa3ac */
    OTHER,        /* 0xa3ad */
    OTHER,        /* 0xa3ae */
    OTHER,        /* 0xa3af */
    OTHER,        /* 0xa3b0 */
    OTHER,        /* 0xa3b1 */
    OTHER,        /* 0xa3b2 */
    OTHER,        /* 0xa3b3 */
    OTHER,        /* 0xa3b4 */
    OTHER,        /* 0xa3b5 */
    OTHER,        /* 0xa3b6 */
    OTHER,        /* 0xa3b7 */
    OTHER,        /* 0xa3b8 */
    OTHER,        /* 0xa3b9 */
    OTHER,        /* 0xa3ba */
    OTHER,        /* 0xa3bb */
    OTHER,        /* 0xa3bc */
    OTHER,        /* 0xa3bd */
    OTHER,        /* 0xa3be */
    OTHER,        /* 0xa3bf */
    OTHER,        /* 0xa3c0 */
    OTHER,        /* 0xa3c1 */
    OTHER,        /* 0xa3c2 */
    OTHER,        /* 0xa3c3 */
    OTHER,        /* 0xa3c4 */
    OTHER,        /* 0xa3c5 */
    OTHER,        /* 0xa3c6 */
    OTHER,        /* 0xa3c7 */
    OTHER,        /* 0xa3c8 */
    OTHER,        /* 0xa3c9 */
    OTHER,        /* 0xa3ca */
    OTHER,        /* 0xa3cb */
    OTHER,        /* 0xa3cc */
    OTHER,        /* 0xa3cd */
    OTHER,        /* 0xa3ce */
    OTHER,        /* 0xa3cf */
    OTHER,        /* 0xa3d0 */
    OTHER,        /* 0xa3d1 */
    OTHER,        /* 0xa3d2 */
    OTHER,        /* 0xa3d3 */
    OTHER,        /* 0xa3d4 */
    OTHER,        /* 0xa3d5 */
    OTHER,        /* 0xa3d6 */
    OTHER,        /* 0xa3d7 */
    OTHER,        /* 0xa3d8 */
    OTHER,        /* 0xa3d9 */
    OTHER,        /* 0xa3da */
    OTHER,        /* 0xa3db */
    OTHER,        /* 0xa3dc */
    OTHER,        /* 0xa3dd */
    OTHER,        /* 0xa3de */
    OTHER,        /* 0xa3df */
    OTHER,        /* 0xa3e0 */
    OTHER,        /* 0xa3e1 */
    OTHER,        /* 0xa3e2 */
    OTHER,        /* 0xa3e3 */
    OTHER,        /* 0xa3e4 */
    OTHER,        /* 0xa3e5 */
    OTHER,        /* 0xa3e6 */
    OTHER,        /* 0xa3e7 */
    OTHER,        /* 0xa3e8 */
    OTHER,        /* 0xa3e9 */
    OTHER,        /* 0xa3ea */
    OTHER,        /* 0xa3eb */
    OTHER,        /* 0xa3ec */
    OTHER,        /* 0xa3ed */
    OTHER,        /* 0xa3ee */
    OTHER,        /* 0xa3ef */
    OTHER,        /* 0xa3f0 */
    OTHER,        /* 0xa3f1 */
    OTHER,        /* 0xa3f2 */
    OTHER,        /* 0xa3f3 */
    OTHER,        /* 0xa3f4 */
    OTHER,        /* 0xa3f5 */
    OTHER,        /* 0xa3f6 */
    OTHER,        /* 0xa3f7 */
    OTHER,        /* 0xa3f8 */
    OTHER,        /* 0xa3f9 */
    OTHER,        /* 0xa3fa */
    OTHER,        /* 0xa3fb */
    OTHER,        /* 0xa3fc */
    OTHER,        /* 0xa3fd */
    OTHER,        /* 0xa3fe */
    OTHER,        /* 0xa3ff */
    OTHER,        /* 0xa400 */
    OTHER,        /* 0xa401 */
    OTHER,        /* 0xa402 */
    OTHER,        /* 0xa403 */
    OTHER,        /* 0xa404 */
    OTHER,        /* 0xa405 */
    OTHER,        /* 0xa406 */
    OTHER,        /* 0xa407 */
    OTHER,        /* 0xa408 */
    OTHER,        /* 0xa409 */
    OTHER,        /* 0xa40a */
    OTHER,        /* 0xa40b */
    OTHER,        /* 0xa40c */
    OTHER,        /* 0xa40d */
    OTHER,        /* 0xa40e */
    OTHER,        /* 0xa40f */
    OTHER,        /* 0xa410 */
    OTHER,        /* 0xa411 */
    OTHER,        /* 0xa412 */
    OTHER,        /* 0xa413 */
    OTHER,        /* 0xa414 */
    OTHER,        /* 0xa415 */
    OTHER,        /* 0xa416 */
    OTHER,        /* 0xa417 */
    OTHER,        /* 0xa418 */
    OTHER,        /* 0xa419 */
    OTHER,        /* 0xa41a */
    OTHER,        /* 0xa41b */
    OTHER,        /* 0xa41c */
    OTHER,        /* 0xa41d */
    OTHER,        /* 0xa41e */
    OTHER,        /* 0xa41f */
    OTHER,        /* 0xa420 */
    OTHER,        /* 0xa421 */
    OTHER,        /* 0xa422 */
    OTHER,        /* 0xa423 */
    OTHER,        /* 0xa424 */
    OTHER,        /* 0xa425 */
    OTHER,        /* 0xa426 */
    OTHER,        /* 0xa427 */
    OTHER,        /* 0xa428 */
    OTHER,        /* 0xa429 */
    OTHER,        /* 0xa42a */
    OTHER,        /* 0xa42b */
    OTHER,        /* 0xa42c */
    OTHER,        /* 0xa42d */
    OTHER,        /* 0xa42e */
    OTHER,        /* 0xa42f */
    OTHER,        /* 0xa430 */
    OTHER,        /* 0xa431 */
    OTHER,        /* 0xa432 */
    OTHER,        /* 0xa433 */
    OTHER,        /* 0xa434 */
    OTHER,        /* 0xa435 */
    OTHER,        /* 0xa436 */
    OTHER,        /* 0xa437 */
    OTHER,        /* 0xa438 */
    OTHER,        /* 0xa439 */
    OTHER,        /* 0xa43a */
    OTHER,        /* 0xa43b */
    OTHER,        /* 0xa43c */
    OTHER,        /* 0xa43d */
    OTHER,        /* 0xa43e */
    OTHER,        /* 0xa43f */
    OTHER,        /* 0xa440 */
    OTHER,        /* 0xa441 */
    OTHER,        /* 0xa442 */
    OTHER,        /* 0xa443 */
    OTHER,        /* 0xa444 */
    OTHER,        /* 0xa445 */
    OTHER,        /* 0xa446 */
    OTHER,        /* 0xa447 */
    OTHER,        /* 0xa448 */
    OTHER,        /* 0xa449 */
    OTHER,        /* 0xa44a */
    OTHER,        /* 0xa44b */
    OTHER,        /* 0xa44c */
    OTHER,        /* 0xa44d */
    OTHER,        /* 0xa44e */
    OTHER,        /* 0xa44f */
    OTHER,        /* 0xa450 */
    OTHER,        /* 0xa451 */
    OTHER,        /* 0xa452 */
    OTHER,        /* 0xa453 */
    OTHER,        /* 0xa454 */
    OTHER,        /* 0xa455 */
    OTHER,        /* 0xa456 */
    OTHER,        /* 0xa457 */
    OTHER,        /* 0xa458 */
    OTHER,        /* 0xa459 */
    OTHER,        /* 0xa45a */
    OTHER,        /* 0xa45b */
    OTHER,        /* 0xa45c */
    OTHER,        /* 0xa45d */
    OTHER,        /* 0xa45e */
    OTHER,        /* 0xa45f */
    OTHER,        /* 0xa460 */
    OTHER,        /* 0xa461 */
    OTHER,        /* 0xa462 */
    OTHER,        /* 0xa463 */
    OTHER,        /* 0xa464 */
    OTHER,        /* 0xa465 */
    OTHER,        /* 0xa466 */
    OTHER,        /* 0xa467 */
    OTHER,        /* 0xa468 */
    OTHER,        /* 0xa469 */
    OTHER,        /* 0xa46a */
    OTHER,        /* 0xa46b */
    OTHER,        /* 0xa46c */
    OTHER,        /* 0xa46d */
    OTHER,        /* 0xa46e */
    OTHER,        /* 0xa46f */
    OTHER,        /* 0xa470 */
    OTHER,        /* 0xa471 */
    OTHER,        /* 0xa472 */
    OTHER,        /* 0xa473 */
    OTHER,        /* 0xa474 */
    OTHER,        /* 0xa475 */
    OTHER,        /* 0xa476 */
    OTHER,        /* 0xa477 */
    OTHER,        /* 0xa478 */
    OTHER,        /* 0xa479 */
    OTHER,        /* 0xa47a */
    OTHER,        /* 0xa47b */
    OTHER,        /* 0xa47c */
    OTHER,        /* 0xa47d */
    OTHER,        /* 0xa47e */
    OTHER,        /* 0xa47f */
    OTHER,        /* 0xa480 */
    OTHER,        /* 0xa481 */
    OTHER,        /* 0xa482 */
    OTHER,        /* 0xa483 */
    OTHER,        /* 0xa484 */
    OTHER,        /* 0xa485 */
    OTHER,        /* 0xa486 */
    OTHER,        /* 0xa487 */
    OTHER,        /* 0xa488 */
    OTHER,        /* 0xa489 */
    OTHER,        /* 0xa48a */
    OTHER,        /* 0xa48b */
    OTHER,        /* 0xa48c */
    OTHER,        /* 0xa48d */
    OTHER,        /* 0xa48e */
    OTHER,        /* 0xa48f */
    OTHER,        /* 0xa490 */
    OTHER,        /* 0xa491 */
    OTHER,        /* 0xa492 */
    OTHER,        /* 0xa493 */
    OTHER,        /* 0xa494 */
    OTHER,        /* 0xa495 */
    OTHER,        /* 0xa496 */
    OTHER,        /* 0xa497 */
    OTHER,        /* 0xa498 */
    OTHER,        /* 0xa499 */
    OTHER,        /* 0xa49a */
    OTHER,        /* 0xa49b */
    OTHER,        /* 0xa49c */
    OTHER,        /* 0xa49d */
    OTHER,        /* 0xa49e */
    OTHER,        /* 0xa49f */
    OTHER,        /* 0xa4a0 */
    OTHER,        /* 0xa4a1 */
    OTHER,        /* 0xa4a2 */
    OTHER,        /* 0xa4a3 */
    OTHER,        /* 0xa4a4 */
    OTHER,        /* 0xa4a5 */
    OTHER,        /* 0xa4a6 */
    OTHER,        /* 0xa4a7 */
    OTHER,        /* 0xa4a8 */
    OTHER,        /* 0xa4a9 */
    OTHER,        /* 0xa4aa */
    OTHER,        /* 0xa4ab */
    OTHER,        /* 0xa4ac */
    OTHER,        /* 0xa4ad */
    OTHER,        /* 0xa4ae */
    OTHER,        /* 0xa4af */
    OTHER,        /* 0xa4b0 */
    OTHER,        /* 0xa4b1 */
    OTHER,        /* 0xa4b2 */
    OTHER,        /* 0xa4b3 */
    OTHER,        /* 0xa4b4 */
    OTHER,        /* 0xa4b5 */
    OTHER,        /* 0xa4b6 */
    OTHER,        /* 0xa4b7 */
    OTHER,        /* 0xa4b8 */
    OTHER,        /* 0xa4b9 */
    OTHER,        /* 0xa4ba */
    OTHER,        /* 0xa4bb */
    OTHER,        /* 0xa4bc */
    OTHER,        /* 0xa4bd */
    OTHER,        /* 0xa4be */
    OTHER,        /* 0xa4bf */
    OTHER,        /* 0xa4c0 */
    OTHER,        /* 0xa4c1 */
    OTHER,        /* 0xa4c2 */
    OTHER,        /* 0xa4c3 */
    OTHER,        /* 0xa4c4 */
    OTHER,        /* 0xa4c5 */
    OTHER,        /* 0xa4c6 */
    OTHER,        /* 0xa4c7 */
    OTHER,        /* 0xa4c8 */
    OTHER,        /* 0xa4c9 */
    OTHER,        /* 0xa4ca */
    OTHER,        /* 0xa4cb */
    OTHER,        /* 0xa4cc */
    OTHER,        /* 0xa4cd */
    OTHER,        /* 0xa4ce */
    OTHER,        /* 0xa4cf */
    OTHER,        /* 0xa4d0 */
    OTHER,        /* 0xa4d1 */
    OTHER,        /* 0xa4d2 */
    OTHER,        /* 0xa4d3 */
    OTHER,        /* 0xa4d4 */
    OTHER,        /* 0xa4d5 */
    OTHER,        /* 0xa4d6 */
    OTHER,        /* 0xa4d7 */
    OTHER,        /* 0xa4d8 */
    OTHER,        /* 0xa4d9 */
    OTHER,        /* 0xa4da */
    OTHER,        /* 0xa4db */
    OTHER,        /* 0xa4dc */
    OTHER,        /* 0xa4dd */
    OTHER,        /* 0xa4de */
    OTHER,        /* 0xa4df */
    OTHER,        /* 0xa4e0 */
    OTHER,        /* 0xa4e1 */
    OTHER,        /* 0xa4e2 */
    OTHER,        /* 0xa4e3 */
    OTHER,        /* 0xa4e4 */
    OTHER,        /* 0xa4e5 */
    OTHER,        /* 0xa4e6 */
    OTHER,        /* 0xa4e7 */
    OTHER,        /* 0xa4e8 */
    OTHER,        /* 0xa4e9 */
    OTHER,        /* 0xa4ea */
    OTHER,        /* 0xa4eb */
    OTHER,        /* 0xa4ec */
    OTHER,        /* 0xa4ed */
    OTHER,        /* 0xa4ee */
    OTHER,        /* 0xa4ef */
    OTHER,        /* 0xa4f0 */
    OTHER,        /* 0xa4f1 */
    OTHER,        /* 0xa4f2 */
    OTHER,        /* 0xa4f3 */
    OTHER,        /* 0xa4f4 */
    OTHER,        /* 0xa4f5 */
    OTHER,        /* 0xa4f6 */
    OTHER,        /* 0xa4f7 */
    OTHER,        /* 0xa4f8 */
    OTHER,        /* 0xa4f9 */
    OTHER,        /* 0xa4fa */
    OTHER,        /* 0xa4fb */
    OTHER,        /* 0xa4fc */
    OTHER,        /* 0xa4fd */
    OTHER,        /* 0xa4fe */
    OTHER,        /* 0xa4ff */
    OTHER,        /* 0xa500 */
    OTHER,        /* 0xa501 */
    OTHER,        /* 0xa502 */
    OTHER,        /* 0xa503 */
    OTHER,        /* 0xa504 */
    OTHER,        /* 0xa505 */
    OTHER,        /* 0xa506 */
    OTHER,        /* 0xa507 */
    OTHER,        /* 0xa508 */
    OTHER,        /* 0xa509 */
    OTHER,        /* 0xa50a */
    OTHER,        /* 0xa50b */
    OTHER,        /* 0xa50c */
    OTHER,        /* 0xa50d */
    OTHER,        /* 0xa50e */
    OTHER,        /* 0xa50f */
    OTHER,        /* 0xa510 */
    OTHER,        /* 0xa511 */
    OTHER,        /* 0xa512 */
    OTHER,        /* 0xa513 */
    OTHER,        /* 0xa514 */
    OTHER,        /* 0xa515 */
    OTHER,        /* 0xa516 */
    OTHER,        /* 0xa517 */
    OTHER,        /* 0xa518 */
    OTHER,        /* 0xa519 */
    OTHER,        /* 0xa51a */
    OTHER,        /* 0xa51b */
    OTHER,        /* 0xa51c */
    OTHER,        /* 0xa51d */
    OTHER,        /* 0xa51e */
    OTHER,        /* 0xa51f */
    OTHER,        /* 0xa520 */
    OTHER,        /* 0xa521 */
    OTHER,        /* 0xa522 */
    OTHER,        /* 0xa523 */
    OTHER,        /* 0xa524 */
    OTHER,        /* 0xa525 */
    OTHER,        /* 0xa526 */
    OTHER,        /* 0xa527 */
    OTHER,        /* 0xa528 */
    OTHER,        /* 0xa529 */
    OTHER,        /* 0xa52a */
    OTHER,        /* 0xa52b */
    OTHER,        /* 0xa52c */
    OTHER,        /* 0xa52d */
    OTHER,        /* 0xa52e */
    OTHER,        /* 0xa52f */
    OTHER,        /* 0xa530 */
    OTHER,        /* 0xa531 */
    OTHER,        /* 0xa532 */
    OTHER,        /* 0xa533 */
    OTHER,        /* 0xa534 */
    OTHER,        /* 0xa535 */
    OTHER,        /* 0xa536 */
    OTHER,        /* 0xa537 */
    OTHER,        /* 0xa538 */
    OTHER,        /* 0xa539 */
    OTHER,        /* 0xa53a */
    OTHER,        /* 0xa53b */
    OTHER,        /* 0xa53c */
    OTHER,        /* 0xa53d */
    OTHER,        /* 0xa53e */
    OTHER,        /* 0xa53f */
    OTHER,        /* 0xa540 */
    OTHER,        /* 0xa541 */
    OTHER,        /* 0xa542 */
    OTHER,        /* 0xa543 */
    OTHER,        /* 0xa544 */
    OTHER,        /* 0xa545 */
    OTHER,        /* 0xa546 */
    OTHER,        /* 0xa547 */
    OTHER,        /* 0xa548 */
    OTHER,        /* 0xa549 */
    OTHER,        /* 0xa54a */
    OTHER,        /* 0xa54b */
    OTHER,        /* 0xa54c */
    OTHER,        /* 0xa54d */
    OTHER,        /* 0xa54e */
    OTHER,        /* 0xa54f */
    OTHER,        /* 0xa550 */
    OTHER,        /* 0xa551 */
    OTHER,        /* 0xa552 */
    OTHER,        /* 0xa553 */
    OTHER,        /* 0xa554 */
    OTHER,        /* 0xa555 */
    OTHER,        /* 0xa556 */
    OTHER,        /* 0xa557 */
    OTHER,        /* 0xa558 */
    OTHER,        /* 0xa559 */
    OTHER,        /* 0xa55a */
    OTHER,        /* 0xa55b */
    OTHER,        /* 0xa55c */
    OTHER,        /* 0xa55d */
    OTHER,        /* 0xa55e */
    OTHER,        /* 0xa55f */
    OTHER,        /* 0xa560 */
    OTHER,        /* 0xa561 */
    OTHER,        /* 0xa562 */
    OTHER,        /* 0xa563 */
    OTHER,        /* 0xa564 */
    OTHER,        /* 0xa565 */
    OTHER,        /* 0xa566 */
    OTHER,        /* 0xa567 */
    OTHER,        /* 0xa568 */
    OTHER,        /* 0xa569 */
    OTHER,        /* 0xa56a */
    OTHER,        /* 0xa56b */
    OTHER,        /* 0xa56c */
    OTHER,        /* 0xa56d */
    OTHER,        /* 0xa56e */
    OTHER,        /* 0xa56f */
    OTHER,        /* 0xa570 */
    OTHER,        /* 0xa571 */
    OTHER,        /* 0xa572 */
    OTHER,        /* 0xa573 */
    OTHER,        /* 0xa574 */
    OTHER,        /* 0xa575 */
    OTHER,        /* 0xa576 */
    OTHER,        /* 0xa577 */
    OTHER,        /* 0xa578 */
    OTHER,        /* 0xa579 */
    OTHER,        /* 0xa57a */
    OTHER,        /* 0xa57b */
    OTHER,        /* 0xa57c */
    OTHER,        /* 0xa57d */
    OTHER,        /* 0xa57e */
    OTHER,        /* 0xa57f */
    OTHER,        /* 0xa580 */
    OTHER,        /* 0xa581 */
    OTHER,        /* 0xa582 */
    OTHER,        /* 0xa583 */
    OTHER,        /* 0xa584 */
    OTHER,        /* 0xa585 */
    OTHER,        /* 0xa586 */
    OTHER,        /* 0xa587 */
    OTHER,        /* 0xa588 */
    OTHER,        /* 0xa589 */
    OTHER,        /* 0xa58a */
    OTHER,        /* 0xa58b */
    OTHER,        /* 0xa58c */
    OTHER,        /* 0xa58d */
    OTHER,        /* 0xa58e */
    OTHER,        /* 0xa58f */
    OTHER,        /* 0xa590 */
    OTHER,        /* 0xa591 */
    OTHER,        /* 0xa592 */
    OTHER,        /* 0xa593 */
    OTHER,        /* 0xa594 */
    OTHER,        /* 0xa595 */
    OTHER,        /* 0xa596 */
    OTHER,        /* 0xa597 */
    OTHER,        /* 0xa598 */
    OTHER,        /* 0xa599 */
    OTHER,        /* 0xa59a */
    OTHER,        /* 0xa59b */
    OTHER,        /* 0xa59c */
    OTHER,        /* 0xa59d */
    OTHER,        /* 0xa59e */
    OTHER,        /* 0xa59f */
    OTHER,        /* 0xa5a0 */
    OTHER,        /* 0xa5a1 */
    OTHER,        /* 0xa5a2 */
    OTHER,        /* 0xa5a3 */
    OTHER,        /* 0xa5a4 */
    OTHER,        /* 0xa5a5 */
    OTHER,        /* 0xa5a6 */
    OTHER,        /* 0xa5a7 */
    OTHER,        /* 0xa5a8 */
    OTHER,        /* 0xa5a9 */
    OTHER,        /* 0xa5aa */
    OTHER,        /* 0xa5ab */
    OTHER,        /* 0xa5ac */
    OTHER,        /* 0xa5ad */
    OTHER,        /* 0xa5ae */
    OTHER,        /* 0xa5af */
    OTHER,        /* 0xa5b0 */
    OTHER,        /* 0xa5b1 */
    OTHER,        /* 0xa5b2 */
    OTHER,        /* 0xa5b3 */
    OTHER,        /* 0xa5b4 */
    OTHER,        /* 0xa5b5 */
    OTHER,        /* 0xa5b6 */
    OTHER,        /* 0xa5b7 */
    OTHER,        /* 0xa5b8 */
    OTHER,        /* 0xa5b9 */
    OTHER,        /* 0xa5ba */
    OTHER,        /* 0xa5bb */
    OTHER,        /* 0xa5bc */
    OTHER,        /* 0xa5bd */
    OTHER,        /* 0xa5be */
    OTHER,        /* 0xa5bf */
    OTHER,        /* 0xa5c0 */
    OTHER,        /* 0xa5c1 */
    OTHER,        /* 0xa5c2 */
    OTHER,        /* 0xa5c3 */
    OTHER,        /* 0xa5c4 */
    OTHER,        /* 0xa5c5 */
    OTHER,        /* 0xa5c6 */
    OTHER,        /* 0xa5c7 */
    OTHER,        /* 0xa5c8 */
    OTHER,        /* 0xa5c9 */
    OTHER,        /* 0xa5ca */
    OTHER,        /* 0xa5cb */
    OTHER,        /* 0xa5cc */
    OTHER,        /* 0xa5cd */
    OTHER,        /* 0xa5ce */
    OTHER,        /* 0xa5cf */
    OTHER,        /* 0xa5d0 */
    OTHER,        /* 0xa5d1 */
    OTHER,        /* 0xa5d2 */
    OTHER,        /* 0xa5d3 */
    OTHER,        /* 0xa5d4 */
    OTHER,        /* 0xa5d5 */
    OTHER,        /* 0xa5d6 */
    OTHER,        /* 0xa5d7 */
    OTHER,        /* 0xa5d8 */
    OTHER,        /* 0xa5d9 */
    OTHER,        /* 0xa5da */
    OTHER,        /* 0xa5db */
    OTHER,        /* 0xa5dc */
    OTHER,        /* 0xa5dd */
    OTHER,        /* 0xa5de */
    OTHER,        /* 0xa5df */
    OTHER,        /* 0xa5e0 */
    OTHER,        /* 0xa5e1 */
    OTHER,        /* 0xa5e2 */
    OTHER,        /* 0xa5e3 */
    OTHER,        /* 0xa5e4 */
    OTHER,        /* 0xa5e5 */
    OTHER,        /* 0xa5e6 */
    OTHER,        /* 0xa5e7 */
    OTHER,        /* 0xa5e8 */
    OTHER,        /* 0xa5e9 */
    OTHER,        /* 0xa5ea */
    OTHER,        /* 0xa5eb */
    OTHER,        /* 0xa5ec */
    OTHER,        /* 0xa5ed */
    OTHER,        /* 0xa5ee */
    OTHER,        /* 0xa5ef */
    OTHER,        /* 0xa5f0 */
    OTHER,        /* 0xa5f1 */
    OTHER,        /* 0xa5f2 */
    OTHER,        /* 0xa5f3 */
    OTHER,        /* 0xa5f4 */
    OTHER,        /* 0xa5f5 */
    OTHER,        /* 0xa5f6 */
    OTHER,        /* 0xa5f7 */
    OTHER,        /* 0xa5f8 */
    OTHER,        /* 0xa5f9 */
    OTHER,        /* 0xa5fa */
    OTHER,        /* 0xa5fb */
    OTHER,        /* 0xa5fc */
    OTHER,        /* 0xa5fd */
    OTHER,        /* 0xa5fe */
    OTHER,        /* 0xa5ff */
    OTHER,        /* 0xa600 */
    OTHER,        /* 0xa601 */
    OTHER,        /* 0xa602 */
    OTHER,        /* 0xa603 */
    OTHER,        /* 0xa604 */
    OTHER,        /* 0xa605 */
    OTHER,        /* 0xa606 */
    OTHER,        /* 0xa607 */
    OTHER,        /* 0xa608 */
    OTHER,        /* 0xa609 */
    OTHER,        /* 0xa60a */
    OTHER,        /* 0xa60b */
    OTHER,        /* 0xa60c */
    OTHER,        /* 0xa60d */
    OTHER,        /* 0xa60e */
    OTHER,        /* 0xa60f */
    OTHER,        /* 0xa610 */
    OTHER,        /* 0xa611 */
    OTHER,        /* 0xa612 */
    OTHER,        /* 0xa613 */
    OTHER,        /* 0xa614 */
    OTHER,        /* 0xa615 */
    OTHER,        /* 0xa616 */
    OTHER,        /* 0xa617 */
    OTHER,        /* 0xa618 */
    OTHER,        /* 0xa619 */
    OTHER,        /* 0xa61a */
    OTHER,        /* 0xa61b */
    OTHER,        /* 0xa61c */
    OTHER,        /* 0xa61d */
    OTHER,        /* 0xa61e */
    OTHER,        /* 0xa61f */
    OTHER,        /* 0xa620 */
    OTHER,        /* 0xa621 */
    OTHER,        /* 0xa622 */
    OTHER,        /* 0xa623 */
    OTHER,        /* 0xa624 */
    OTHER,        /* 0xa625 */
    OTHER,        /* 0xa626 */
    OTHER,        /* 0xa627 */
    OTHER,        /* 0xa628 */
    OTHER,        /* 0xa629 */
    OTHER,        /* 0xa62a */
    OTHER,        /* 0xa62b */
    OTHER,        /* 0xa62c */
    OTHER,        /* 0xa62d */
    OTHER,        /* 0xa62e */
    OTHER,        /* 0xa62f */
    OTHER,        /* 0xa630 */
    OTHER,        /* 0xa631 */
    OTHER,        /* 0xa632 */
    OTHER,        /* 0xa633 */
    OTHER,        /* 0xa634 */
    OTHER,        /* 0xa635 */
    OTHER,        /* 0xa636 */
    OTHER,        /* 0xa637 */
    OTHER,        /* 0xa638 */
    OTHER,        /* 0xa639 */
    OTHER,        /* 0xa63a */
    OTHER,        /* 0xa63b */
    OTHER,        /* 0xa63c */
    OTHER,        /* 0xa63d */
    OTHER,        /* 0xa63e */
    OTHER,        /* 0xa63f */
    OTHER,        /* 0xa640 */
    OTHER,        /* 0xa641 */
    OTHER,        /* 0xa642 */
    OTHER,        /* 0xa643 */
    OTHER,        /* 0xa644 */
    OTHER,        /* 0xa645 */
    OTHER,        /* 0xa646 */
    OTHER,        /* 0xa647 */
    OTHER,        /* 0xa648 */
    OTHER,        /* 0xa649 */
    OTHER,        /* 0xa64a */
    OTHER,        /* 0xa64b */
    OTHER,        /* 0xa64c */
    OTHER,        /* 0xa64d */
    OTHER,        /* 0xa64e */
    OTHER,        /* 0xa64f */
    OTHER,        /* 0xa650 */
    OTHER,        /* 0xa651 */
    OTHER,        /* 0xa652 */
    OTHER,        /* 0xa653 */
    OTHER,        /* 0xa654 */
    OTHER,        /* 0xa655 */
    OTHER,        /* 0xa656 */
    OTHER,        /* 0xa657 */
    OTHER,        /* 0xa658 */
    OTHER,        /* 0xa659 */
    OTHER,        /* 0xa65a */
    OTHER,        /* 0xa65b */
    OTHER,        /* 0xa65c */
    OTHER,        /* 0xa65d */
    OTHER,        /* 0xa65e */
    OTHER,        /* 0xa65f */
    OTHER,        /* 0xa660 */
    OTHER,        /* 0xa661 */
    OTHER,        /* 0xa662 */
    OTHER,        /* 0xa663 */
    OTHER,        /* 0xa664 */
    OTHER,        /* 0xa665 */
    OTHER,        /* 0xa666 */
    OTHER,        /* 0xa667 */
    OTHER,        /* 0xa668 */
    OTHER,        /* 0xa669 */
    OTHER,        /* 0xa66a */
    OTHER,        /* 0xa66b */
    OTHER,        /* 0xa66c */
    OTHER,        /* 0xa66d */
    OTHER,        /* 0xa66e */
    OTHER,        /* 0xa66f */
    OTHER,        /* 0xa670 */
    OTHER,        /* 0xa671 */
    OTHER,        /* 0xa672 */
    OTHER,        /* 0xa673 */
    OTHER,        /* 0xa674 */
    OTHER,        /* 0xa675 */
    OTHER,        /* 0xa676 */
    OTHER,        /* 0xa677 */
    OTHER,        /* 0xa678 */
    OTHER,        /* 0xa679 */
    OTHER,        /* 0xa67a */
    OTHER,        /* 0xa67b */
    OTHER,        /* 0xa67c */
    OTHER,        /* 0xa67d */
    OTHER,        /* 0xa67e */
    OTHER,        /* 0xa67f */
    OTHER,        /* 0xa680 */
    OTHER,        /* 0xa681 */
    OTHER,        /* 0xa682 */
    OTHER,        /* 0xa683 */
    OTHER,        /* 0xa684 */
    OTHER,        /* 0xa685 */
    OTHER,        /* 0xa686 */
    OTHER,        /* 0xa687 */
    OTHER,        /* 0xa688 */
    OTHER,        /* 0xa689 */
    OTHER,        /* 0xa68a */
    OTHER,        /* 0xa68b */
    OTHER,        /* 0xa68c */
    OTHER,        /* 0xa68d */
    OTHER,        /* 0xa68e */
    OTHER,        /* 0xa68f */
    OTHER,        /* 0xa690 */
    OTHER,        /* 0xa691 */
    OTHER,        /* 0xa692 */
    OTHER,        /* 0xa693 */
    OTHER,        /* 0xa694 */
    OTHER,        /* 0xa695 */
    OTHER,        /* 0xa696 */
    OTHER,        /* 0xa697 */
    OTHER,        /* 0xa698 */
    OTHER,        /* 0xa699 */
    OTHER,        /* 0xa69a */
    OTHER,        /* 0xa69b */
    OTHER,        /* 0xa69c */
    OTHER,        /* 0xa69d */
    OTHER,        /* 0xa69e */
    OTHER,        /* 0xa69f */
    OTHER,        /* 0xa6a0 */
    OTHER,        /* 0xa6a1 */
    OTHER,        /* 0xa6a2 */
    OTHER,        /* 0xa6a3 */
    OTHER,        /* 0xa6a4 */
    OTHER,        /* 0xa6a5 */
    OTHER,        /* 0xa6a6 */
    OTHER,        /* 0xa6a7 */
    OTHER,        /* 0xa6a8 */
    OTHER,        /* 0xa6a9 */
    OTHER,        /* 0xa6aa */
    OTHER,        /* 0xa6ab */
    OTHER,        /* 0xa6ac */
    OTHER,        /* 0xa6ad */
    OTHER,        /* 0xa6ae */
    OTHER,        /* 0xa6af */
    OTHER,        /* 0xa6b0 */
    OTHER,        /* 0xa6b1 */
    OTHER,        /* 0xa6b2 */
    OTHER,        /* 0xa6b3 */
    OTHER,        /* 0xa6b4 */
    OTHER,        /* 0xa6b5 */
    OTHER,        /* 0xa6b6 */
    OTHER,        /* 0xa6b7 */
    OTHER,        /* 0xa6b8 */
    OTHER,        /* 0xa6b9 */
    OTHER,        /* 0xa6ba */
    OTHER,        /* 0xa6bb */
    OTHER,        /* 0xa6bc */
    OTHER,        /* 0xa6bd */
    OTHER,        /* 0xa6be */
    OTHER,        /* 0xa6bf */
    OTHER,        /* 0xa6c0 */
    OTHER,        /* 0xa6c1 */
    OTHER,        /* 0xa6c2 */
    OTHER,        /* 0xa6c3 */
    OTHER,        /* 0xa6c4 */
    OTHER,        /* 0xa6c5 */
    OTHER,        /* 0xa6c6 */
    OTHER,        /* 0xa6c7 */
    OTHER,        /* 0xa6c8 */
    OTHER,        /* 0xa6c9 */
    OTHER,        /* 0xa6ca */
    OTHER,        /* 0xa6cb */
    OTHER,        /* 0xa6cc */
    OTHER,        /* 0xa6cd */
    OTHER,        /* 0xa6ce */
    OTHER,        /* 0xa6cf */
    OTHER,        /* 0xa6d0 */
    OTHER,        /* 0xa6d1 */
    OTHER,        /* 0xa6d2 */
    OTHER,        /* 0xa6d3 */
    OTHER,        /* 0xa6d4 */
    OTHER,        /* 0xa6d5 */
    OTHER,        /* 0xa6d6 */
    OTHER,        /* 0xa6d7 */
    OTHER,        /* 0xa6d8 */
    OTHER,        /* 0xa6d9 */
    OTHER,        /* 0xa6da */
    OTHER,        /* 0xa6db */
    OTHER,        /* 0xa6dc */
    OTHER,        /* 0xa6dd */
    OTHER,        /* 0xa6de */
    OTHER,        /* 0xa6df */
    OTHER,        /* 0xa6e0 */
    OTHER,        /* 0xa6e1 */
    OTHER,        /* 0xa6e2 */
    OTHER,        /* 0xa6e3 */
    OTHER,        /* 0xa6e4 */
    OTHER,        /* 0xa6e5 */
    OTHER,        /* 0xa6e6 */
    OTHER,        /* 0xa6e7 */
    OTHER,        /* 0xa6e8 */
    OTHER,        /* 0xa6e9 */
    OTHER,        /* 0xa6ea */
    OTHER,        /* 0xa6eb */
    OTHER,        /* 0xa6ec */
    OTHER,        /* 0xa6ed */
    OTHER,        /* 0xa6ee */
    OTHER,        /* 0xa6ef */
    OTHER,        /* 0xa6f0 */
    OTHER,        /* 0xa6f1 */
    OTHER,        /* 0xa6f2 */
    OTHER,        /* 0xa6f3 */
    OTHER,        /* 0xa6f4 */
    OTHER,        /* 0xa6f5 */
    OTHER,        /* 0xa6f6 */
    OTHER,        /* 0xa6f7 */
    OTHER,        /* 0xa6f8 */
    OTHER,        /* 0xa6f9 */
    OTHER,        /* 0xa6fa */
    OTHER,        /* 0xa6fb */
    OTHER,        /* 0xa6fc */
    OTHER,        /* 0xa6fd */
    OTHER,        /* 0xa6fe */
    OTHER,        /* 0xa6ff */
    OTHER,        /* 0xa700 */
    OTHER,        /* 0xa701 */
    OTHER,        /* 0xa702 */
    OTHER,        /* 0xa703 */
    OTHER,        /* 0xa704 */
    OTHER,        /* 0xa705 */
    OTHER,        /* 0xa706 */
    OTHER,        /* 0xa707 */
    OTHER,        /* 0xa708 */
    OTHER,        /* 0xa709 */
    OTHER,        /* 0xa70a */
    OTHER,        /* 0xa70b */
    OTHER,        /* 0xa70c */
    OTHER,        /* 0xa70d */
    OTHER,        /* 0xa70e */
    OTHER,        /* 0xa70f */
    OTHER,        /* 0xa710 */
    OTHER,        /* 0xa711 */
    OTHER,        /* 0xa712 */
    OTHER,        /* 0xa713 */
    OTHER,        /* 0xa714 */
    OTHER,        /* 0xa715 */
    OTHER,        /* 0xa716 */
    OTHER,        /* 0xa717 */
    OTHER,        /* 0xa718 */
    OTHER,        /* 0xa719 */
    OTHER,        /* 0xa71a */
    OTHER,        /* 0xa71b */
    OTHER,        /* 0xa71c */
    OTHER,        /* 0xa71d */
    OTHER,        /* 0xa71e */
    OTHER,        /* 0xa71f */
    OTHER,        /* 0xa720 */
    OTHER,        /* 0xa721 */
    OTHER,        /* 0xa722 */
    OTHER,        /* 0xa723 */
    OTHER,        /* 0xa724 */
    OTHER,        /* 0xa725 */
    OTHER,        /* 0xa726 */
    OTHER,        /* 0xa727 */
    OTHER,        /* 0xa728 */
    OTHER,        /* 0xa729 */
    OTHER,        /* 0xa72a */
    OTHER,        /* 0xa72b */
    OTHER,        /* 0xa72c */
    OTHER,        /* 0xa72d */
    OTHER,        /* 0xa72e */
    OTHER,        /* 0xa72f */
    OTHER,        /* 0xa730 */
    OTHER,        /* 0xa731 */
    OTHER,        /* 0xa732 */
    OTHER,        /* 0xa733 */
    OTHER,        /* 0xa734 */
    OTHER,        /* 0xa735 */
    OTHER,        /* 0xa736 */
    OTHER,        /* 0xa737 */
    OTHER,        /* 0xa738 */
    OTHER,        /* 0xa739 */
    OTHER,        /* 0xa73a */
    OTHER,        /* 0xa73b */
    OTHER,        /* 0xa73c */
    OTHER,        /* 0xa73d */
    OTHER,        /* 0xa73e */
    OTHER,        /* 0xa73f */
    OTHER,        /* 0xa740 */
    OTHER,        /* 0xa741 */
    OTHER,        /* 0xa742 */
    OTHER,        /* 0xa743 */
    OTHER,        /* 0xa744 */
    OTHER,        /* 0xa745 */
    OTHER,        /* 0xa746 */
    OTHER,        /* 0xa747 */
    OTHER,        /* 0xa748 */
    OTHER,        /* 0xa749 */
    OTHER,        /* 0xa74a */
    OTHER,        /* 0xa74b */
    OTHER,        /* 0xa74c */
    OTHER,        /* 0xa74d */
    OTHER,        /* 0xa74e */
    OTHER,        /* 0xa74f */
    OTHER,        /* 0xa750 */
    OTHER,        /* 0xa751 */
    OTHER,        /* 0xa752 */
    OTHER,        /* 0xa753 */
    OTHER,        /* 0xa754 */
    OTHER,        /* 0xa755 */
    OTHER,        /* 0xa756 */
    OTHER,        /* 0xa757 */
    OTHER,        /* 0xa758 */
    OTHER,        /* 0xa759 */
    OTHER,        /* 0xa75a */
    OTHER,        /* 0xa75b */
    OTHER,        /* 0xa75c */
    OTHER,        /* 0xa75d */
    OTHER,        /* 0xa75e */
    OTHER,        /* 0xa75f */
    OTHER,        /* 0xa760 */
    OTHER,        /* 0xa761 */
    OTHER,        /* 0xa762 */
    OTHER,        /* 0xa763 */
    OTHER,        /* 0xa764 */
    OTHER,        /* 0xa765 */
    OTHER,        /* 0xa766 */
    OTHER,        /* 0xa767 */
    OTHER,        /* 0xa768 */
    OTHER,        /* 0xa769 */
    OTHER,        /* 0xa76a */
    OTHER,        /* 0xa76b */
    OTHER,        /* 0xa76c */
    OTHER,        /* 0xa76d */
    OTHER,        /* 0xa76e */
    OTHER,        /* 0xa76f */
    OTHER,        /* 0xa770 */
    OTHER,        /* 0xa771 */
    OTHER,        /* 0xa772 */
    OTHER,        /* 0xa773 */
    OTHER,        /* 0xa774 */
    OTHER,        /* 0xa775 */
    OTHER,        /* 0xa776 */
    OTHER,        /* 0xa777 */
    OTHER,        /* 0xa778 */
    OTHER,        /* 0xa779 */
    OTHER,        /* 0xa77a */
    OTHER,        /* 0xa77b */
    OTHER,        /* 0xa77c */
    OTHER,        /* 0xa77d */
    OTHER,        /* 0xa77e */
    OTHER,        /* 0xa77f */
    OTHER,        /* 0xa780 */
    OTHER,        /* 0xa781 */
    OTHER,        /* 0xa782 */
    OTHER,        /* 0xa783 */
    OTHER,        /* 0xa784 */
    OTHER,        /* 0xa785 */
    OTHER,        /* 0xa786 */
    OTHER,        /* 0xa787 */
    OTHER,        /* 0xa788 */
    OTHER,        /* 0xa789 */
    OTHER,        /* 0xa78a */
    OTHER,        /* 0xa78b */
    OTHER,        /* 0xa78c */
    OTHER,        /* 0xa78d */
    OTHER,        /* 0xa78e */
    OTHER,        /* 0xa78f */
    OTHER,        /* 0xa790 */
    OTHER,        /* 0xa791 */
    OTHER,        /* 0xa792 */
    OTHER,        /* 0xa793 */
    OTHER,        /* 0xa794 */
    OTHER,        /* 0xa795 */
    OTHER,        /* 0xa796 */
    OTHER,        /* 0xa797 */
    OTHER,        /* 0xa798 */
    OTHER,        /* 0xa799 */
    OTHER,        /* 0xa79a */
    OTHER,        /* 0xa79b */
    OTHER,        /* 0xa79c */
    OTHER,        /* 0xa79d */
    OTHER,        /* 0xa79e */
    OTHER,        /* 0xa79f */
    OTHER,        /* 0xa7a0 */
    OTHER,        /* 0xa7a1 */
    OTHER,        /* 0xa7a2 */
    OTHER,        /* 0xa7a3 */
    OTHER,        /* 0xa7a4 */
    OTHER,        /* 0xa7a5 */
    OTHER,        /* 0xa7a6 */
    OTHER,        /* 0xa7a7 */
    OTHER,        /* 0xa7a8 */
    OTHER,        /* 0xa7a9 */
    OTHER,        /* 0xa7aa */
    OTHER,        /* 0xa7ab */
    OTHER,        /* 0xa7ac */
    OTHER,        /* 0xa7ad */
    OTHER,        /* 0xa7ae */
    OTHER,        /* 0xa7af */
    OTHER,        /* 0xa7b0 */
    OTHER,        /* 0xa7b1 */
    OTHER,        /* 0xa7b2 */
    OTHER,        /* 0xa7b3 */
    OTHER,        /* 0xa7b4 */
    OTHER,        /* 0xa7b5 */
    OTHER,        /* 0xa7b6 */
    OTHER,        /* 0xa7b7 */
    OTHER,        /* 0xa7b8 */
    OTHER,        /* 0xa7b9 */
    OTHER,        /* 0xa7ba */
    OTHER,        /* 0xa7bb */
    OTHER,        /* 0xa7bc */
    OTHER,        /* 0xa7bd */
    OTHER,        /* 0xa7be */
    OTHER,        /* 0xa7bf */
    OTHER,        /* 0xa7c0 */
    OTHER,        /* 0xa7c1 */
    OTHER,        /* 0xa7c2 */
    OTHER,        /* 0xa7c3 */
    OTHER,        /* 0xa7c4 */
    OTHER,        /* 0xa7c5 */
    OTHER,        /* 0xa7c6 */
    OTHER,        /* 0xa7c7 */
    OTHER,        /* 0xa7c8 */
    OTHER,        /* 0xa7c9 */
    OTHER,        /* 0xa7ca */
    OTHER,        /* 0xa7cb */
    OTHER,        /* 0xa7cc */
    OTHER,        /* 0xa7cd */
    OTHER,        /* 0xa7ce */
    OTHER,        /* 0xa7cf */
    OTHER,        /* 0xa7d0 */
    OTHER,        /* 0xa7d1 */
    OTHER,        /* 0xa7d2 */
    OTHER,        /* 0xa7d3 */
    OTHER,        /* 0xa7d4 */
    OTHER,        /* 0xa7d5 */
    OTHER,        /* 0xa7d6 */
    OTHER,        /* 0xa7d7 */
    OTHER,        /* 0xa7d8 */
    OTHER,        /* 0xa7d9 */
    OTHER,        /* 0xa7da */
    OTHER,        /* 0xa7db */
    OTHER,        /* 0xa7dc */
    OTHER,        /* 0xa7dd */
    OTHER,        /* 0xa7de */
    OTHER,        /* 0xa7df */
    OTHER,        /* 0xa7e0 */
    OTHER,        /* 0xa7e1 */
    OTHER,        /* 0xa7e2 */
    OTHER,        /* 0xa7e3 */
    OTHER,        /* 0xa7e4 */
    OTHER,        /* 0xa7e5 */
    OTHER,        /* 0xa7e6 */
    OTHER,        /* 0xa7e7 */
    OTHER,        /* 0xa7e8 */
    OTHER,        /* 0xa7e9 */
    OTHER,        /* 0xa7ea */
    OTHER,        /* 0xa7eb */
    OTHER,        /* 0xa7ec */
    OTHER,        /* 0xa7ed */
    OTHER,        /* 0xa7ee */
    OTHER,        /* 0xa7ef */
    OTHER,        /* 0xa7f0 */
    OTHER,        /* 0xa7f1 */
    OTHER,        /* 0xa7f2 */
    OTHER,        /* 0xa7f3 */
    OTHER,        /* 0xa7f4 */
    OTHER,        /* 0xa7f5 */
    OTHER,        /* 0xa7f6 */
    OTHER,        /* 0xa7f7 */
    OTHER,        /* 0xa7f8 */
    OTHER,        /* 0xa7f9 */
    OTHER,        /* 0xa7fa */
    OTHER,        /* 0xa7fb */
    OTHER,        /* 0xa7fc */
    OTHER,        /* 0xa7fd */
    OTHER,        /* 0xa7fe */
    OTHER,        /* 0xa7ff */
    OTHER,        /* 0xa800 */
    OTHER,        /* 0xa801 */
    OTHER,        /* 0xa802 */
    OTHER,        /* 0xa803 */
    OTHER,        /* 0xa804 */
    OTHER,        /* 0xa805 */
    OTHER,        /* 0xa806 */
    OTHER,        /* 0xa807 */
    OTHER,        /* 0xa808 */
    OTHER,        /* 0xa809 */
    OTHER,        /* 0xa80a */
    OTHER,        /* 0xa80b */
    OTHER,        /* 0xa80c */
    OTHER,        /* 0xa80d */
    OTHER,        /* 0xa80e */
    OTHER,        /* 0xa80f */
    OTHER,        /* 0xa810 */
    OTHER,        /* 0xa811 */
    OTHER,        /* 0xa812 */
    OTHER,        /* 0xa813 */
    OTHER,        /* 0xa814 */
    OTHER,        /* 0xa815 */
    OTHER,        /* 0xa816 */
    OTHER,        /* 0xa817 */
    OTHER,        /* 0xa818 */
    OTHER,        /* 0xa819 */
    OTHER,        /* 0xa81a */
    OTHER,        /* 0xa81b */
    OTHER,        /* 0xa81c */
    OTHER,        /* 0xa81d */
    OTHER,        /* 0xa81e */
    OTHER,        /* 0xa81f */
    OTHER,        /* 0xa820 */
    OTHER,        /* 0xa821 */
    OTHER,        /* 0xa822 */
    OTHER,        /* 0xa823 */
    OTHER,        /* 0xa824 */
    OTHER,        /* 0xa825 */
    OTHER,        /* 0xa826 */
    OTHER,        /* 0xa827 */
    OTHER,        /* 0xa828 */
    OTHER,        /* 0xa829 */
    OTHER,        /* 0xa82a */
    OTHER,        /* 0xa82b */
    OTHER,        /* 0xa82c */
    OTHER,        /* 0xa82d */
    OTHER,        /* 0xa82e */
    OTHER,        /* 0xa82f */
    OTHER,        /* 0xa830 */
    OTHER,        /* 0xa831 */
    OTHER,        /* 0xa832 */
    OTHER,        /* 0xa833 */
    OTHER,        /* 0xa834 */
    OTHER,        /* 0xa835 */
    OTHER,        /* 0xa836 */
    OTHER,        /* 0xa837 */
    OTHER,        /* 0xa838 */
    OTHER,        /* 0xa839 */
    OTHER,        /* 0xa83a */
    OTHER,        /* 0xa83b */
    OTHER,        /* 0xa83c */
    OTHER,        /* 0xa83d */
    OTHER,        /* 0xa83e */
    OTHER,        /* 0xa83f */
    OTHER,        /* 0xa840 */
    OTHER,        /* 0xa841 */
    OTHER,        /* 0xa842 */
    OTHER,        /* 0xa843 */
    OTHER,        /* 0xa844 */
    OTHER,        /* 0xa845 */
    OTHER,        /* 0xa846 */
    OTHER,        /* 0xa847 */
    OTHER,        /* 0xa848 */
    OTHER,        /* 0xa849 */
    OTHER,        /* 0xa84a */
    OTHER,        /* 0xa84b */
    OTHER,        /* 0xa84c */
    OTHER,        /* 0xa84d */
    OTHER,        /* 0xa84e */
    OTHER,        /* 0xa84f */
    OTHER,        /* 0xa850 */
    OTHER,        /* 0xa851 */
    OTHER,        /* 0xa852 */
    OTHER,        /* 0xa853 */
    OTHER,        /* 0xa854 */
    OTHER,        /* 0xa855 */
    OTHER,        /* 0xa856 */
    OTHER,        /* 0xa857 */
    OTHER,        /* 0xa858 */
    OTHER,        /* 0xa859 */
    OTHER,        /* 0xa85a */
    OTHER,        /* 0xa85b */
    OTHER,        /* 0xa85c */
    OTHER,        /* 0xa85d */
    OTHER,        /* 0xa85e */
    OTHER,        /* 0xa85f */
    OTHER,        /* 0xa860 */
    OTHER,        /* 0xa861 */
    OTHER,        /* 0xa862 */
    OTHER,        /* 0xa863 */
    OTHER,        /* 0xa864 */
    OTHER,        /* 0xa865 */
    OTHER,        /* 0xa866 */
    OTHER,        /* 0xa867 */
    OTHER,        /* 0xa868 */
    OTHER,        /* 0xa869 */
    OTHER,        /* 0xa86a */
    OTHER,        /* 0xa86b */
    OTHER,        /* 0xa86c */
    OTHER,        /* 0xa86d */
    OTHER,        /* 0xa86e */
    OTHER,        /* 0xa86f */
    OTHER,        /* 0xa870 */
    OTHER,        /* 0xa871 */
    OTHER,        /* 0xa872 */
    OTHER,        /* 0xa873 */
    OTHER,        /* 0xa874 */
    OTHER,        /* 0xa875 */
    OTHER,        /* 0xa876 */
    OTHER,        /* 0xa877 */
    OTHER,        /* 0xa878 */
    OTHER,        /* 0xa879 */
    OTHER,        /* 0xa87a */
    OTHER,        /* 0xa87b */
    OTHER,        /* 0xa87c */
    OTHER,        /* 0xa87d */
    OTHER,        /* 0xa87e */
    OTHER,        /* 0xa87f */
    OTHER,        /* 0xa880 */
    OTHER,        /* 0xa881 */
    OTHER,        /* 0xa882 */
    OTHER,        /* 0xa883 */
    OTHER,        /* 0xa884 */
    OTHER,        /* 0xa885 */
    OTHER,        /* 0xa886 */
    OTHER,        /* 0xa887 */
    OTHER,        /* 0xa888 */
    OTHER,        /* 0xa889 */
    OTHER,        /* 0xa88a */
    OTHER,        /* 0xa88b */
    OTHER,        /* 0xa88c */
    OTHER,        /* 0xa88d */
    OTHER,        /* 0xa88e */
    OTHER,        /* 0xa88f */
    OTHER,        /* 0xa890 */
    OTHER,        /* 0xa891 */
    OTHER,        /* 0xa892 */
    OTHER,        /* 0xa893 */
    OTHER,        /* 0xa894 */
    OTHER,        /* 0xa895 */
    OTHER,        /* 0xa896 */
    OTHER,        /* 0xa897 */
    OTHER,        /* 0xa898 */
    OTHER,        /* 0xa899 */
    OTHER,        /* 0xa89a */
    OTHER,        /* 0xa89b */
    OTHER,        /* 0xa89c */
    OTHER,        /* 0xa89d */
    OTHER,        /* 0xa89e */
    OTHER,        /* 0xa89f */
    OTHER,        /* 0xa8a0 */
    OTHER,        /* 0xa8a1 */
    OTHER,        /* 0xa8a2 */
    OTHER,        /* 0xa8a3 */
    OTHER,        /* 0xa8a4 */
    OTHER,        /* 0xa8a5 */
    OTHER,        /* 0xa8a6 */
    OTHER,        /* 0xa8a7 */
    OTHER,        /* 0xa8a8 */
    OTHER,        /* 0xa8a9 */
    OTHER,        /* 0xa8aa */
    OTHER,        /* 0xa8ab */
    OTHER,        /* 0xa8ac */
    OTHER,        /* 0xa8ad */
    OTHER,        /* 0xa8ae */
    OTHER,        /* 0xa8af */
    OTHER,        /* 0xa8b0 */
    OTHER,        /* 0xa8b1 */
    OTHER,        /* 0xa8b2 */
    OTHER,        /* 0xa8b3 */
    OTHER,        /* 0xa8b4 */
    OTHER,        /* 0xa8b5 */
    OTHER,        /* 0xa8b6 */
    OTHER,        /* 0xa8b7 */
    OTHER,        /* 0xa8b8 */
    OTHER,        /* 0xa8b9 */
    OTHER,        /* 0xa8ba */
    OTHER,        /* 0xa8bb */
    OTHER,        /* 0xa8bc */
    OTHER,        /* 0xa8bd */
    OTHER,        /* 0xa8be */
    OTHER,        /* 0xa8bf */
    OTHER,        /* 0xa8c0 */
    OTHER,        /* 0xa8c1 */
    OTHER,        /* 0xa8c2 */
    OTHER,        /* 0xa8c3 */
    OTHER,        /* 0xa8c4 */
    OTHER,        /* 0xa8c5 */
    OTHER,        /* 0xa8c6 */
    OTHER,        /* 0xa8c7 */
    OTHER,        /* 0xa8c8 */
    OTHER,        /* 0xa8c9 */
    OTHER,        /* 0xa8ca */
    OTHER,        /* 0xa8cb */
    OTHER,        /* 0xa8cc */
    OTHER,        /* 0xa8cd */
    OTHER,        /* 0xa8ce */
    OTHER,        /* 0xa8cf */
    OTHER,        /* 0xa8d0 */
    OTHER,        /* 0xa8d1 */
    OTHER,        /* 0xa8d2 */
    OTHER,        /* 0xa8d3 */
    OTHER,        /* 0xa8d4 */
    OTHER,        /* 0xa8d5 */
    OTHER,        /* 0xa8d6 */
    OTHER,        /* 0xa8d7 */
    OTHER,        /* 0xa8d8 */
    OTHER,        /* 0xa8d9 */
    OTHER,        /* 0xa8da */
    OTHER,        /* 0xa8db */
    OTHER,        /* 0xa8dc */
    OTHER,        /* 0xa8dd */
    OTHER,        /* 0xa8de */
    OTHER,        /* 0xa8df */
    OTHER,        /* 0xa8e0 */
    OTHER,        /* 0xa8e1 */
    OTHER,        /* 0xa8e2 */
    OTHER,        /* 0xa8e3 */
    OTHER,        /* 0xa8e4 */
    OTHER,        /* 0xa8e5 */
    OTHER,        /* 0xa8e6 */
    OTHER,        /* 0xa8e7 */
    OTHER,        /* 0xa8e8 */
    OTHER,        /* 0xa8e9 */
    OTHER,        /* 0xa8ea */
    OTHER,        /* 0xa8eb */
    OTHER,        /* 0xa8ec */
    OTHER,        /* 0xa8ed */
    OTHER,        /* 0xa8ee */
    OTHER,        /* 0xa8ef */
    OTHER,        /* 0xa8f0 */
    OTHER,        /* 0xa8f1 */
    OTHER,        /* 0xa8f2 */
    OTHER,        /* 0xa8f3 */
    OTHER,        /* 0xa8f4 */
    OTHER,        /* 0xa8f5 */
    OTHER,        /* 0xa8f6 */
    OTHER,        /* 0xa8f7 */
    OTHER,        /* 0xa8f8 */
    OTHER,        /* 0xa8f9 */
    OTHER,        /* 0xa8fa */
    OTHER,        /* 0xa8fb */
    OTHER,        /* 0xa8fc */
    OTHER,        /* 0xa8fd */
    OTHER,        /* 0xa8fe */
    OTHER,        /* 0xa8ff */
    OTHER,        /* 0xa900 */
    OTHER,        /* 0xa901 */
    OTHER,        /* 0xa902 */
    OTHER,        /* 0xa903 */
    OTHER,        /* 0xa904 */
    OTHER,        /* 0xa905 */
    OTHER,        /* 0xa906 */
    OTHER,        /* 0xa907 */
    OTHER,        /* 0xa908 */
    OTHER,        /* 0xa909 */
    OTHER,        /* 0xa90a */
    OTHER,        /* 0xa90b */
    OTHER,        /* 0xa90c */
    OTHER,        /* 0xa90d */
    OTHER,        /* 0xa90e */
    OTHER,        /* 0xa90f */
    OTHER,        /* 0xa910 */
    OTHER,        /* 0xa911 */
    OTHER,        /* 0xa912 */
    OTHER,        /* 0xa913 */
    OTHER,        /* 0xa914 */
    OTHER,        /* 0xa915 */
    OTHER,        /* 0xa916 */
    OTHER,        /* 0xa917 */
    OTHER,        /* 0xa918 */
    OTHER,        /* 0xa919 */
    OTHER,        /* 0xa91a */
    OTHER,        /* 0xa91b */
    OTHER,        /* 0xa91c */
    OTHER,        /* 0xa91d */
    OTHER,        /* 0xa91e */
    OTHER,        /* 0xa91f */
    OTHER,        /* 0xa920 */
    OTHER,        /* 0xa921 */
    OTHER,        /* 0xa922 */
    OTHER,        /* 0xa923 */
    OTHER,        /* 0xa924 */
    OTHER,        /* 0xa925 */
    OTHER,        /* 0xa926 */
    OTHER,        /* 0xa927 */
    OTHER,        /* 0xa928 */
    OTHER,        /* 0xa929 */
    OTHER,        /* 0xa92a */
    OTHER,        /* 0xa92b */
    OTHER,        /* 0xa92c */
    OTHER,        /* 0xa92d */
    OTHER,        /* 0xa92e */
    OTHER,        /* 0xa92f */
    OTHER,        /* 0xa930 */
    OTHER,        /* 0xa931 */
    OTHER,        /* 0xa932 */
    OTHER,        /* 0xa933 */
    OTHER,        /* 0xa934 */
    OTHER,        /* 0xa935 */
    OTHER,        /* 0xa936 */
    OTHER,        /* 0xa937 */
    OTHER,        /* 0xa938 */
    OTHER,        /* 0xa939 */
    OTHER,        /* 0xa93a */
    OTHER,        /* 0xa93b */
    OTHER,        /* 0xa93c */
    OTHER,        /* 0xa93d */
    OTHER,        /* 0xa93e */
    OTHER,        /* 0xa93f */
    OTHER,        /* 0xa940 */
    OTHER,        /* 0xa941 */
    OTHER,        /* 0xa942 */
    OTHER,        /* 0xa943 */
    OTHER,        /* 0xa944 */
    OTHER,        /* 0xa945 */
    OTHER,        /* 0xa946 */
    OTHER,        /* 0xa947 */
    OTHER,        /* 0xa948 */
    OTHER,        /* 0xa949 */
    OTHER,        /* 0xa94a */
    OTHER,        /* 0xa94b */
    OTHER,        /* 0xa94c */
    OTHER,        /* 0xa94d */
    OTHER,        /* 0xa94e */
    OTHER,        /* 0xa94f */
    OTHER,        /* 0xa950 */
    OTHER,        /* 0xa951 */
    OTHER,        /* 0xa952 */
    OTHER,        /* 0xa953 */
    OTHER,        /* 0xa954 */
    OTHER,        /* 0xa955 */
    OTHER,        /* 0xa956 */
    OTHER,        /* 0xa957 */
    OTHER,        /* 0xa958 */
    OTHER,        /* 0xa959 */
    OTHER,        /* 0xa95a */
    OTHER,        /* 0xa95b */
    OTHER,        /* 0xa95c */
    OTHER,        /* 0xa95d */
    OTHER,        /* 0xa95e */
    OTHER,        /* 0xa95f */
    OTHER,        /* 0xa960 */
    OTHER,        /* 0xa961 */
    OTHER,        /* 0xa962 */
    OTHER,        /* 0xa963 */
    OTHER,        /* 0xa964 */
    OTHER,        /* 0xa965 */
    OTHER,        /* 0xa966 */
    OTHER,        /* 0xa967 */
    OTHER,        /* 0xa968 */
    OTHER,        /* 0xa969 */
    OTHER,        /* 0xa96a */
    OTHER,        /* 0xa96b */
    OTHER,        /* 0xa96c */
    OTHER,        /* 0xa96d */
    OTHER,        /* 0xa96e */
    OTHER,        /* 0xa96f */
    OTHER,        /* 0xa970 */
    OTHER,        /* 0xa971 */
    OTHER,        /* 0xa972 */
    OTHER,        /* 0xa973 */
    OTHER,        /* 0xa974 */
    OTHER,        /* 0xa975 */
    OTHER,        /* 0xa976 */
    OTHER,        /* 0xa977 */
    OTHER,        /* 0xa978 */
    OTHER,        /* 0xa979 */
    OTHER,        /* 0xa97a */
    OTHER,        /* 0xa97b */
    OTHER,        /* 0xa97c */
    OTHER,        /* 0xa97d */
    OTHER,        /* 0xa97e */
    OTHER,        /* 0xa97f */
    OTHER,        /* 0xa980 */
    OTHER,        /* 0xa981 */
    OTHER,        /* 0xa982 */
    OTHER,        /* 0xa983 */
    OTHER,        /* 0xa984 */
    OTHER,        /* 0xa985 */
    OTHER,        /* 0xa986 */
    OTHER,        /* 0xa987 */
    OTHER,        /* 0xa988 */
    OTHER,        /* 0xa989 */
    OTHER,        /* 0xa98a */
    OTHER,        /* 0xa98b */
    OTHER,        /* 0xa98c */
    OTHER,        /* 0xa98d */
    OTHER,        /* 0xa98e */
    OTHER,        /* 0xa98f */
    OTHER,        /* 0xa990 */
    OTHER,        /* 0xa991 */
    OTHER,        /* 0xa992 */
    OTHER,        /* 0xa993 */
    OTHER,        /* 0xa994 */
    OTHER,        /* 0xa995 */
    OTHER,        /* 0xa996 */
    OTHER,        /* 0xa997 */
    OTHER,        /* 0xa998 */
    OTHER,        /* 0xa999 */
    OTHER,        /* 0xa99a */
    OTHER,        /* 0xa99b */
    OTHER,        /* 0xa99c */
    OTHER,        /* 0xa99d */
    OTHER,        /* 0xa99e */
    OTHER,        /* 0xa99f */
    OTHER,        /* 0xa9a0 */
    OTHER,        /* 0xa9a1 */
    OTHER,        /* 0xa9a2 */
    OTHER,        /* 0xa9a3 */
    OTHER,        /* 0xa9a4 */
    OTHER,        /* 0xa9a5 */
    OTHER,        /* 0xa9a6 */
    OTHER,        /* 0xa9a7 */
    OTHER,        /* 0xa9a8 */
    OTHER,        /* 0xa9a9 */
    OTHER,        /* 0xa9aa */
    OTHER,        /* 0xa9ab */
    OTHER,        /* 0xa9ac */
    OTHER,        /* 0xa9ad */
    OTHER,        /* 0xa9ae */
    OTHER,        /* 0xa9af */
    OTHER,        /* 0xa9b0 */
    OTHER,        /* 0xa9b1 */
    OTHER,        /* 0xa9b2 */
    OTHER,        /* 0xa9b3 */
    OTHER,        /* 0xa9b4 */
    OTHER,        /* 0xa9b5 */
    OTHER,        /* 0xa9b6 */
    OTHER,        /* 0xa9b7 */
    OTHER,        /* 0xa9b8 */
    OTHER,        /* 0xa9b9 */
    OTHER,        /* 0xa9ba */
    OTHER,        /* 0xa9bb */
    OTHER,        /* 0xa9bc */
    OTHER,        /* 0xa9bd */
    OTHER,        /* 0xa9be */
    OTHER,        /* 0xa9bf */
    OTHER,        /* 0xa9c0 */
    OTHER,        /* 0xa9c1 */
    OTHER,        /* 0xa9c2 */
    OTHER,        /* 0xa9c3 */
    OTHER,        /* 0xa9c4 */
    OTHER,        /* 0xa9c5 */
    OTHER,        /* 0xa9c6 */
    OTHER,        /* 0xa9c7 */
    OTHER,        /* 0xa9c8 */
    OTHER,        /* 0xa9c9 */
    OTHER,        /* 0xa9ca */
    OTHER,        /* 0xa9cb */
    OTHER,        /* 0xa9cc */
    OTHER,        /* 0xa9cd */
    OTHER,        /* 0xa9ce */
    OTHER,        /* 0xa9cf */
    OTHER,        /* 0xa9d0 */
    OTHER,        /* 0xa9d1 */
    OTHER,        /* 0xa9d2 */
    OTHER,        /* 0xa9d3 */
    OTHER,        /* 0xa9d4 */
    OTHER,        /* 0xa9d5 */
    OTHER,        /* 0xa9d6 */
    OTHER,        /* 0xa9d7 */
    OTHER,        /* 0xa9d8 */
    OTHER,        /* 0xa9d9 */
    OTHER,        /* 0xa9da */
    OTHER,        /* 0xa9db */
    OTHER,        /* 0xa9dc */
    OTHER,        /* 0xa9dd */
    OTHER,        /* 0xa9de */
    OTHER,        /* 0xa9df */
    OTHER,        /* 0xa9e0 */
    OTHER,        /* 0xa9e1 */
    OTHER,        /* 0xa9e2 */
    OTHER,        /* 0xa9e3 */
    OTHER,        /* 0xa9e4 */
    OTHER,        /* 0xa9e5 */
    OTHER,        /* 0xa9e6 */
    OTHER,        /* 0xa9e7 */
    OTHER,        /* 0xa9e8 */
    OTHER,        /* 0xa9e9 */
    OTHER,        /* 0xa9ea */
    OTHER,        /* 0xa9eb */
    OTHER,        /* 0xa9ec */
    OTHER,        /* 0xa9ed */
    OTHER,        /* 0xa9ee */
    OTHER,        /* 0xa9ef */
    OTHER,        /* 0xa9f0 */
    OTHER,        /* 0xa9f1 */
    OTHER,        /* 0xa9f2 */
    OTHER,        /* 0xa9f3 */
    OTHER,        /* 0xa9f4 */
    OTHER,        /* 0xa9f5 */
    OTHER,        /* 0xa9f6 */
    OTHER,        /* 0xa9f7 */
    OTHER,        /* 0xa9f8 */
    OTHER,        /* 0xa9f9 */
    OTHER,        /* 0xa9fa */
    OTHER,        /* 0xa9fb */
    OTHER,        /* 0xa9fc */
    OTHER,        /* 0xa9fd */
    OTHER,        /* 0xa9fe */
    OTHER,        /* 0xa9ff */
    OTHER,        /* 0xaa00 */
    OTHER,        /* 0xaa01 */
    OTHER,        /* 0xaa02 */
    OTHER,        /* 0xaa03 */
    OTHER,        /* 0xaa04 */
    OTHER,        /* 0xaa05 */
    OTHER,        /* 0xaa06 */
    OTHER,        /* 0xaa07 */
    OTHER,        /* 0xaa08 */
    OTHER,        /* 0xaa09 */
    OTHER,        /* 0xaa0a */
    OTHER,        /* 0xaa0b */
    OTHER,        /* 0xaa0c */
    OTHER,        /* 0xaa0d */
    OTHER,        /* 0xaa0e */
    OTHER,        /* 0xaa0f */
    OTHER,        /* 0xaa10 */
    OTHER,        /* 0xaa11 */
    OTHER,        /* 0xaa12 */
    OTHER,        /* 0xaa13 */
    OTHER,        /* 0xaa14 */
    OTHER,        /* 0xaa15 */
    OTHER,        /* 0xaa16 */
    OTHER,        /* 0xaa17 */
    OTHER,        /* 0xaa18 */
    OTHER,        /* 0xaa19 */
    OTHER,        /* 0xaa1a */
    OTHER,        /* 0xaa1b */
    OTHER,        /* 0xaa1c */
    OTHER,        /* 0xaa1d */
    OTHER,        /* 0xaa1e */
    OTHER,        /* 0xaa1f */
    OTHER,        /* 0xaa20 */
    OTHER,        /* 0xaa21 */
    OTHER,        /* 0xaa22 */
    OTHER,        /* 0xaa23 */
    OTHER,        /* 0xaa24 */
    OTHER,        /* 0xaa25 */
    OTHER,        /* 0xaa26 */
    OTHER,        /* 0xaa27 */
    OTHER,        /* 0xaa28 */
    OTHER,        /* 0xaa29 */
    OTHER,        /* 0xaa2a */
    OTHER,        /* 0xaa2b */
    OTHER,        /* 0xaa2c */
    OTHER,        /* 0xaa2d */
    OTHER,        /* 0xaa2e */
    OTHER,        /* 0xaa2f */
    OTHER,        /* 0xaa30 */
    OTHER,        /* 0xaa31 */
    OTHER,        /* 0xaa32 */
    OTHER,        /* 0xaa33 */
    OTHER,        /* 0xaa34 */
    OTHER,        /* 0xaa35 */
    OTHER,        /* 0xaa36 */
    OTHER,        /* 0xaa37 */
    OTHER,        /* 0xaa38 */
    OTHER,        /* 0xaa39 */
    OTHER,        /* 0xaa3a */
    OTHER,        /* 0xaa3b */
    OTHER,        /* 0xaa3c */
    OTHER,        /* 0xaa3d */
    OTHER,        /* 0xaa3e */
    OTHER,        /* 0xaa3f */
    OTHER,        /* 0xaa40 */
    OTHER,        /* 0xaa41 */
    OTHER,        /* 0xaa42 */
    OTHER,        /* 0xaa43 */
    OTHER,        /* 0xaa44 */
    OTHER,        /* 0xaa45 */
    OTHER,        /* 0xaa46 */
    OTHER,        /* 0xaa47 */
    OTHER,        /* 0xaa48 */
    OTHER,        /* 0xaa49 */
    OTHER,        /* 0xaa4a */
    OTHER,        /* 0xaa4b */
    OTHER,        /* 0xaa4c */
    OTHER,        /* 0xaa4d */
    OTHER,        /* 0xaa4e */
    OTHER,        /* 0xaa4f */
    OTHER,        /* 0xaa50 */
    OTHER,        /* 0xaa51 */
    OTHER,        /* 0xaa52 */
    OTHER,        /* 0xaa53 */
    OTHER,        /* 0xaa54 */
    OTHER,        /* 0xaa55 */
    OTHER,        /* 0xaa56 */
    OTHER,        /* 0xaa57 */
    OTHER,        /* 0xaa58 */
    OTHER,        /* 0xaa59 */
    OTHER,        /* 0xaa5a */
    OTHER,        /* 0xaa5b */
    OTHER,        /* 0xaa5c */
    OTHER,        /* 0xaa5d */
    OTHER,        /* 0xaa5e */
    OTHER,        /* 0xaa5f */
    OTHER,        /* 0xaa60 */
    OTHER,        /* 0xaa61 */
    OTHER,        /* 0xaa62 */
    OTHER,        /* 0xaa63 */
    OTHER,        /* 0xaa64 */
    OTHER,        /* 0xaa65 */
    OTHER,        /* 0xaa66 */
    OTHER,        /* 0xaa67 */
    OTHER,        /* 0xaa68 */
    OTHER,        /* 0xaa69 */
    OTHER,        /* 0xaa6a */
    OTHER,        /* 0xaa6b */
    OTHER,        /* 0xaa6c */
    OTHER,        /* 0xaa6d */
    OTHER,        /* 0xaa6e */
    OTHER,        /* 0xaa6f */
    OTHER,        /* 0xaa70 */
    OTHER,        /* 0xaa71 */
    OTHER,        /* 0xaa72 */
    OTHER,        /* 0xaa73 */
    OTHER,        /* 0xaa74 */
    OTHER,        /* 0xaa75 */
    OTHER,        /* 0xaa76 */
    OTHER,        /* 0xaa77 */
    OTHER,        /* 0xaa78 */
    OTHER,        /* 0xaa79 */
    OTHER,        /* 0xaa7a */
    OTHER,        /* 0xaa7b */
    OTHER,        /* 0xaa7c */
    OTHER,        /* 0xaa7d */
    OTHER,        /* 0xaa7e */
    OTHER,        /* 0xaa7f */
    OTHER,        /* 0xaa80 */
    OTHER,        /* 0xaa81 */
    OTHER,        /* 0xaa82 */
    OTHER,        /* 0xaa83 */
    OTHER,        /* 0xaa84 */
    OTHER,        /* 0xaa85 */
    OTHER,        /* 0xaa86 */
    OTHER,        /* 0xaa87 */
    OTHER,        /* 0xaa88 */
    OTHER,        /* 0xaa89 */
    OTHER,        /* 0xaa8a */
    OTHER,        /* 0xaa8b */
    OTHER,        /* 0xaa8c */
    OTHER,        /* 0xaa8d */
    OTHER,        /* 0xaa8e */
    OTHER,        /* 0xaa8f */
    OTHER,        /* 0xaa90 */
    OTHER,        /* 0xaa91 */
    OTHER,        /* 0xaa92 */
    OTHER,        /* 0xaa93 */
    OTHER,        /* 0xaa94 */
    OTHER,        /* 0xaa95 */
    OTHER,        /* 0xaa96 */
    OTHER,        /* 0xaa97 */
    OTHER,        /* 0xaa98 */
    OTHER,        /* 0xaa99 */
    OTHER,        /* 0xaa9a */
    OTHER,        /* 0xaa9b */
    OTHER,        /* 0xaa9c */
    OTHER,        /* 0xaa9d */
    OTHER,        /* 0xaa9e */
    OTHER,        /* 0xaa9f */
    OTHER,        /* 0xaaa0 */
    OTHER,        /* 0xaaa1 */
    OTHER,        /* 0xaaa2 */
    OTHER,        /* 0xaaa3 */
    OTHER,        /* 0xaaa4 */
    OTHER,        /* 0xaaa5 */
    OTHER,        /* 0xaaa6 */
    OTHER,        /* 0xaaa7 */
    OTHER,        /* 0xaaa8 */
    OTHER,        /* 0xaaa9 */
    OTHER,        /* 0xaaaa */
    OTHER,        /* 0xaaab */
    OTHER,        /* 0xaaac */
    OTHER,        /* 0xaaad */
    OTHER,        /* 0xaaae */
    OTHER,        /* 0xaaaf */
    OTHER,        /* 0xaab0 */
    OTHER,        /* 0xaab1 */
    OTHER,        /* 0xaab2 */
    OTHER,        /* 0xaab3 */
    OTHER,        /* 0xaab4 */
    OTHER,        /* 0xaab5 */
    OTHER,        /* 0xaab6 */
    OTHER,        /* 0xaab7 */
    OTHER,        /* 0xaab8 */
    OTHER,        /* 0xaab9 */
    OTHER,        /* 0xaaba */
    OTHER,        /* 0xaabb */
    OTHER,        /* 0xaabc */
    OTHER,        /* 0xaabd */
    OTHER,        /* 0xaabe */
    OTHER,        /* 0xaabf */
    OTHER,        /* 0xaac0 */
    OTHER,        /* 0xaac1 */
    OTHER,        /* 0xaac2 */
    OTHER,        /* 0xaac3 */
    OTHER,        /* 0xaac4 */
    OTHER,        /* 0xaac5 */
    OTHER,        /* 0xaac6 */
    OTHER,        /* 0xaac7 */
    OTHER,        /* 0xaac8 */
    OTHER,        /* 0xaac9 */
    OTHER,        /* 0xaaca */
    OTHER,        /* 0xaacb */
    OTHER,        /* 0xaacc */
    OTHER,        /* 0xaacd */
    OTHER,        /* 0xaace */
    OTHER,        /* 0xaacf */
    OTHER,        /* 0xaad0 */
    OTHER,        /* 0xaad1 */
    OTHER,        /* 0xaad2 */
    OTHER,        /* 0xaad3 */
    OTHER,        /* 0xaad4 */
    OTHER,        /* 0xaad5 */
    OTHER,        /* 0xaad6 */
    OTHER,        /* 0xaad7 */
    OTHER,        /* 0xaad8 */
    OTHER,        /* 0xaad9 */
    OTHER,        /* 0xaada */
    OTHER,        /* 0xaadb */
    OTHER,        /* 0xaadc */
    OTHER,        /* 0xaadd */
    OTHER,        /* 0xaade */
    OTHER,        /* 0xaadf */
    OTHER,        /* 0xaae0 */
    OTHER,        /* 0xaae1 */
    OTHER,        /* 0xaae2 */
    OTHER,        /* 0xaae3 */
    OTHER,        /* 0xaae4 */
    OTHER,        /* 0xaae5 */
    OTHER,        /* 0xaae6 */
    OTHER,        /* 0xaae7 */
    OTHER,        /* 0xaae8 */
    OTHER,        /* 0xaae9 */
    OTHER,        /* 0xaaea */
    OTHER,        /* 0xaaeb */
    OTHER,        /* 0xaaec */
    OTHER,        /* 0xaaed */
    OTHER,        /* 0xaaee */
    OTHER,        /* 0xaaef */
    OTHER,        /* 0xaaf0 */
    OTHER,        /* 0xaaf1 */
    OTHER,        /* 0xaaf2 */
    OTHER,        /* 0xaaf3 */
    OTHER,        /* 0xaaf4 */
    OTHER,        /* 0xaaf5 */
    OTHER,        /* 0xaaf6 */
    OTHER,        /* 0xaaf7 */
    OTHER,        /* 0xaaf8 */
    OTHER,        /* 0xaaf9 */
    OTHER,        /* 0xaafa */
    OTHER,        /* 0xaafb */
    OTHER,        /* 0xaafc */
    OTHER,        /* 0xaafd */
    OTHER,        /* 0xaafe */
    OTHER,        /* 0xaaff */
    OTHER,        /* 0xab00 */
    OTHER,        /* 0xab01 */
    OTHER,        /* 0xab02 */
    OTHER,        /* 0xab03 */
    OTHER,        /* 0xab04 */
    OTHER,        /* 0xab05 */
    OTHER,        /* 0xab06 */
    OTHER,        /* 0xab07 */
    OTHER,        /* 0xab08 */
    OTHER,        /* 0xab09 */
    OTHER,        /* 0xab0a */
    OTHER,        /* 0xab0b */
    OTHER,        /* 0xab0c */
    OTHER,        /* 0xab0d */
    OTHER,        /* 0xab0e */
    OTHER,        /* 0xab0f */
    OTHER,        /* 0xab10 */
    OTHER,        /* 0xab11 */
    OTHER,        /* 0xab12 */
    OTHER,        /* 0xab13 */
    OTHER,        /* 0xab14 */
    OTHER,        /* 0xab15 */
    OTHER,        /* 0xab16 */
    OTHER,        /* 0xab17 */
    OTHER,        /* 0xab18 */
    OTHER,        /* 0xab19 */
    OTHER,        /* 0xab1a */
    OTHER,        /* 0xab1b */
    OTHER,        /* 0xab1c */
    OTHER,        /* 0xab1d */
    OTHER,        /* 0xab1e */
    OTHER,        /* 0xab1f */
    OTHER,        /* 0xab20 */
    OTHER,        /* 0xab21 */
    OTHER,        /* 0xab22 */
    OTHER,        /* 0xab23 */
    OTHER,        /* 0xab24 */
    OTHER,        /* 0xab25 */
    OTHER,        /* 0xab26 */
    OTHER,        /* 0xab27 */
    OTHER,        /* 0xab28 */
    OTHER,        /* 0xab29 */
    OTHER,        /* 0xab2a */
    OTHER,        /* 0xab2b */
    OTHER,        /* 0xab2c */
    OTHER,        /* 0xab2d */
    OTHER,        /* 0xab2e */
    OTHER,        /* 0xab2f */
    OTHER,        /* 0xab30 */
    OTHER,        /* 0xab31 */
    OTHER,        /* 0xab32 */
    OTHER,        /* 0xab33 */
    OTHER,        /* 0xab34 */
    OTHER,        /* 0xab35 */
    OTHER,        /* 0xab36 */
    OTHER,        /* 0xab37 */
    OTHER,        /* 0xab38 */
    OTHER,        /* 0xab39 */
    OTHER,        /* 0xab3a */
    OTHER,        /* 0xab3b */
    OTHER,        /* 0xab3c */
    OTHER,        /* 0xab3d */
    OTHER,        /* 0xab3e */
    OTHER,        /* 0xab3f */
    OTHER,        /* 0xab40 */
    OTHER,        /* 0xab41 */
    OTHER,        /* 0xab42 */
    OTHER,        /* 0xab43 */
    OTHER,        /* 0xab44 */
    OTHER,        /* 0xab45 */
    OTHER,        /* 0xab46 */
    OTHER,        /* 0xab47 */
    OTHER,        /* 0xab48 */
    OTHER,        /* 0xab49 */
    OTHER,        /* 0xab4a */
    OTHER,        /* 0xab4b */
    OTHER,        /* 0xab4c */
    OTHER,        /* 0xab4d */
    OTHER,        /* 0xab4e */
    OTHER,        /* 0xab4f */
    OTHER,        /* 0xab50 */
    OTHER,        /* 0xab51 */
    OTHER,        /* 0xab52 */
    OTHER,        /* 0xab53 */
    OTHER,        /* 0xab54 */
    OTHER,        /* 0xab55 */
    OTHER,        /* 0xab56 */
    OTHER,        /* 0xab57 */
    OTHER,        /* 0xab58 */
    OTHER,        /* 0xab59 */
    OTHER,        /* 0xab5a */
    OTHER,        /* 0xab5b */
    OTHER,        /* 0xab5c */
    OTHER,        /* 0xab5d */
    OTHER,        /* 0xab5e */
    OTHER,        /* 0xab5f */
    OTHER,        /* 0xab60 */
    OTHER,        /* 0xab61 */
    OTHER,        /* 0xab62 */
    OTHER,        /* 0xab63 */
    OTHER,        /* 0xab64 */
    OTHER,        /* 0xab65 */
    OTHER,        /* 0xab66 */
    OTHER,        /* 0xab67 */
    OTHER,        /* 0xab68 */
    OTHER,        /* 0xab69 */
    OTHER,        /* 0xab6a */
    OTHER,        /* 0xab6b */
    OTHER,        /* 0xab6c */
    OTHER,        /* 0xab6d */
    OTHER,        /* 0xab6e */
    OTHER,        /* 0xab6f */
    OTHER,        /* 0xab70 */
    OTHER,        /* 0xab71 */
    OTHER,        /* 0xab72 */
    OTHER,        /* 0xab73 */
    OTHER,        /* 0xab74 */
    OTHER,        /* 0xab75 */
    OTHER,        /* 0xab76 */
    OTHER,        /* 0xab77 */
    OTHER,        /* 0xab78 */
    OTHER,        /* 0xab79 */
    OTHER,        /* 0xab7a */
    OTHER,        /* 0xab7b */
    OTHER,        /* 0xab7c */
    OTHER,        /* 0xab7d */
    OTHER,        /* 0xab7e */
    OTHER,        /* 0xab7f */
    OTHER,        /* 0xab80 */
    OTHER,        /* 0xab81 */
    OTHER,        /* 0xab82 */
    OTHER,        /* 0xab83 */
    OTHER,        /* 0xab84 */
    OTHER,        /* 0xab85 */
    OTHER,        /* 0xab86 */
    OTHER,        /* 0xab87 */
    OTHER,        /* 0xab88 */
    OTHER,        /* 0xab89 */
    OTHER,        /* 0xab8a */
    OTHER,        /* 0xab8b */
    OTHER,        /* 0xab8c */
    OTHER,        /* 0xab8d */
    OTHER,        /* 0xab8e */
    OTHER,        /* 0xab8f */
    OTHER,        /* 0xab90 */
    OTHER,        /* 0xab91 */
    OTHER,        /* 0xab92 */
    OTHER,        /* 0xab93 */
    OTHER,        /* 0xab94 */
    OTHER,        /* 0xab95 */
    OTHER,        /* 0xab96 */
    OTHER,        /* 0xab97 */
    OTHER,        /* 0xab98 */
    OTHER,        /* 0xab99 */
    OTHER,        /* 0xab9a */
    OTHER,        /* 0xab9b */
    OTHER,        /* 0xab9c */
    OTHER,        /* 0xab9d */
    OTHER,        /* 0xab9e */
    OTHER,        /* 0xab9f */
    OTHER,        /* 0xaba0 */
    OTHER,        /* 0xaba1 */
    OTHER,        /* 0xaba2 */
    OTHER,        /* 0xaba3 */
    OTHER,        /* 0xaba4 */
    OTHER,        /* 0xaba5 */
    OTHER,        /* 0xaba6 */
    OTHER,        /* 0xaba7 */
    OTHER,        /* 0xaba8 */
    OTHER,        /* 0xaba9 */
    OTHER,        /* 0xabaa */
    OTHER,        /* 0xabab */
    OTHER,        /* 0xabac */
    OTHER,        /* 0xabad */
    OTHER,        /* 0xabae */
    OTHER,        /* 0xabaf */
    OTHER,        /* 0xabb0 */
    OTHER,        /* 0xabb1 */
    OTHER,        /* 0xabb2 */
    OTHER,        /* 0xabb3 */
    OTHER,        /* 0xabb4 */
    OTHER,        /* 0xabb5 */
    OTHER,        /* 0xabb6 */
    OTHER,        /* 0xabb7 */
    OTHER,        /* 0xabb8 */
    OTHER,        /* 0xabb9 */
    OTHER,        /* 0xabba */
    OTHER,        /* 0xabbb */
    OTHER,        /* 0xabbc */
    OTHER,        /* 0xabbd */
    OTHER,        /* 0xabbe */
    OTHER,        /* 0xabbf */
    OTHER,        /* 0xabc0 */
    OTHER,        /* 0xabc1 */
    OTHER,        /* 0xabc2 */
    OTHER,        /* 0xabc3 */
    OTHER,        /* 0xabc4 */
    OTHER,        /* 0xabc5 */
    OTHER,        /* 0xabc6 */
    OTHER,        /* 0xabc7 */
    OTHER,        /* 0xabc8 */
    OTHER,        /* 0xabc9 */
    OTHER,        /* 0xabca */
    OTHER,        /* 0xabcb */
    OTHER,        /* 0xabcc */
    OTHER,        /* 0xabcd */
    OTHER,        /* 0xabce */
    OTHER,        /* 0xabcf */
    OTHER,        /* 0xabd0 */
    OTHER,        /* 0xabd1 */
    OTHER,        /* 0xabd2 */
    OTHER,        /* 0xabd3 */
    OTHER,        /* 0xabd4 */
    OTHER,        /* 0xabd5 */
    OTHER,        /* 0xabd6 */
    OTHER,        /* 0xabd7 */
    OTHER,        /* 0xabd8 */
    OTHER,        /* 0xabd9 */
    OTHER,        /* 0xabda */
    OTHER,        /* 0xabdb */
    OTHER,        /* 0xabdc */
    OTHER,        /* 0xabdd */
    OTHER,        /* 0xabde */
    OTHER,        /* 0xabdf */
    OTHER,        /* 0xabe0 */
    OTHER,        /* 0xabe1 */
    OTHER,        /* 0xabe2 */
    OTHER,        /* 0xabe3 */
    OTHER,        /* 0xabe4 */
    OTHER,        /* 0xabe5 */
    OTHER,        /* 0xabe6 */
    OTHER,        /* 0xabe7 */
    OTHER,        /* 0xabe8 */
    OTHER,        /* 0xabe9 */
    OTHER,        /* 0xabea */
    OTHER,        /* 0xabeb */
    OTHER,        /* 0xabec */
    OTHER,        /* 0xabed */
    OTHER,        /* 0xabee */
    OTHER,        /* 0xabef */
    OTHER,        /* 0xabf0 */
    OTHER,        /* 0xabf1 */
    OTHER,        /* 0xabf2 */
    OTHER,        /* 0xabf3 */
    OTHER,        /* 0xabf4 */
    OTHER,        /* 0xabf5 */
    OTHER,        /* 0xabf6 */
    OTHER,        /* 0xabf7 */
    OTHER,        /* 0xabf8 */
    OTHER,        /* 0xabf9 */
    OTHER,        /* 0xabfa */
    OTHER,        /* 0xabfb */
    OTHER,        /* 0xabfc */
    OTHER,        /* 0xabfd */
    OTHER,        /* 0xabfe */
    OTHER,        /* 0xabff */
    OTHER,        /* 0xac00 */
    OTHER,        /* 0xac01 */
    OTHER,        /* 0xac02 */
    OTHER,        /* 0xac03 */
    OTHER,        /* 0xac04 */
    OTHER,        /* 0xac05 */
    OTHER,        /* 0xac06 */
    OTHER,        /* 0xac07 */
    OTHER,        /* 0xac08 */
    OTHER,        /* 0xac09 */
    OTHER,        /* 0xac0a */
    OTHER,        /* 0xac0b */
    OTHER,        /* 0xac0c */
    OTHER,        /* 0xac0d */
    OTHER,        /* 0xac0e */
    OTHER,        /* 0xac0f */
    OTHER,        /* 0xac10 */
    OTHER,        /* 0xac11 */
    OTHER,        /* 0xac12 */
    OTHER,        /* 0xac13 */
    OTHER,        /* 0xac14 */
    OTHER,        /* 0xac15 */
    OTHER,        /* 0xac16 */
    OTHER,        /* 0xac17 */
    OTHER,        /* 0xac18 */
    OTHER,        /* 0xac19 */
    OTHER,        /* 0xac1a */
    OTHER,        /* 0xac1b */
    OTHER,        /* 0xac1c */
    OTHER,        /* 0xac1d */
    OTHER,        /* 0xac1e */
    OTHER,        /* 0xac1f */
    OTHER,        /* 0xac20 */
    OTHER,        /* 0xac21 */
    OTHER,        /* 0xac22 */
    OTHER,        /* 0xac23 */
    OTHER,        /* 0xac24 */
    OTHER,        /* 0xac25 */
    OTHER,        /* 0xac26 */
    OTHER,        /* 0xac27 */
    OTHER,        /* 0xac28 */
    OTHER,        /* 0xac29 */
    OTHER,        /* 0xac2a */
    OTHER,        /* 0xac2b */
    OTHER,        /* 0xac2c */
    OTHER,        /* 0xac2d */
    OTHER,        /* 0xac2e */
    OTHER,        /* 0xac2f */
    OTHER,        /* 0xac30 */
    OTHER,        /* 0xac31 */
    OTHER,        /* 0xac32 */
    OTHER,        /* 0xac33 */
    OTHER,        /* 0xac34 */
    OTHER,        /* 0xac35 */
    OTHER,        /* 0xac36 */
    OTHER,        /* 0xac37 */
    OTHER,        /* 0xac38 */
    OTHER,        /* 0xac39 */
    OTHER,        /* 0xac3a */
    OTHER,        /* 0xac3b */
    OTHER,        /* 0xac3c */
    OTHER,        /* 0xac3d */
    OTHER,        /* 0xac3e */
    OTHER,        /* 0xac3f */
    OTHER,        /* 0xac40 */
    OTHER,        /* 0xac41 */
    OTHER,        /* 0xac42 */
    OTHER,        /* 0xac43 */
    OTHER,        /* 0xac44 */
    OTHER,        /* 0xac45 */
    OTHER,        /* 0xac46 */
    OTHER,        /* 0xac47 */
    OTHER,        /* 0xac48 */
    OTHER,        /* 0xac49 */
    OTHER,        /* 0xac4a */
    OTHER,        /* 0xac4b */
    OTHER,        /* 0xac4c */
    OTHER,        /* 0xac4d */
    OTHER,        /* 0xac4e */
    OTHER,        /* 0xac4f */
    OTHER,        /* 0xac50 */
    OTHER,        /* 0xac51 */
    OTHER,        /* 0xac52 */
    OTHER,        /* 0xac53 */
    OTHER,        /* 0xac54 */
    OTHER,        /* 0xac55 */
    OTHER,        /* 0xac56 */
    OTHER,        /* 0xac57 */
    OTHER,        /* 0xac58 */
    OTHER,        /* 0xac59 */
    OTHER,        /* 0xac5a */
    OTHER,        /* 0xac5b */
    OTHER,        /* 0xac5c */
    OTHER,        /* 0xac5d */
    OTHER,        /* 0xac5e */
    OTHER,        /* 0xac5f */
    OTHER,        /* 0xac60 */
    OTHER,        /* 0xac61 */
    OTHER,        /* 0xac62 */
    OTHER,        /* 0xac63 */
    OTHER,        /* 0xac64 */
    OTHER,        /* 0xac65 */
    OTHER,        /* 0xac66 */
    OTHER,        /* 0xac67 */
    OTHER,        /* 0xac68 */
    OTHER,        /* 0xac69 */
    OTHER,        /* 0xac6a */
    OTHER,        /* 0xac6b */
    OTHER,        /* 0xac6c */
    OTHER,        /* 0xac6d */
    OTHER,        /* 0xac6e */
    OTHER,        /* 0xac6f */
    OTHER,        /* 0xac70 */
    OTHER,        /* 0xac71 */
    OTHER,        /* 0xac72 */
    OTHER,        /* 0xac73 */
    OTHER,        /* 0xac74 */
    OTHER,        /* 0xac75 */
    OTHER,        /* 0xac76 */
    OTHER,        /* 0xac77 */
    OTHER,        /* 0xac78 */
    OTHER,        /* 0xac79 */
    OTHER,        /* 0xac7a */
    OTHER,        /* 0xac7b */
    OTHER,        /* 0xac7c */
    OTHER,        /* 0xac7d */
    OTHER,        /* 0xac7e */
    OTHER,        /* 0xac7f */
    OTHER,        /* 0xac80 */
    OTHER,        /* 0xac81 */
    OTHER,        /* 0xac82 */
    OTHER,        /* 0xac83 */
    OTHER,        /* 0xac84 */
    OTHER,        /* 0xac85 */
    OTHER,        /* 0xac86 */
    OTHER,        /* 0xac87 */
    OTHER,        /* 0xac88 */
    OTHER,        /* 0xac89 */
    OTHER,        /* 0xac8a */
    OTHER,        /* 0xac8b */
    OTHER,        /* 0xac8c */
    OTHER,        /* 0xac8d */
    OTHER,        /* 0xac8e */
    OTHER,        /* 0xac8f */
    OTHER,        /* 0xac90 */
    OTHER,        /* 0xac91 */
    OTHER,        /* 0xac92 */
    OTHER,        /* 0xac93 */
    OTHER,        /* 0xac94 */
    OTHER,        /* 0xac95 */
    OTHER,        /* 0xac96 */
    OTHER,        /* 0xac97 */
    OTHER,        /* 0xac98 */
    OTHER,        /* 0xac99 */
    OTHER,        /* 0xac9a */
    OTHER,        /* 0xac9b */
    OTHER,        /* 0xac9c */
    OTHER,        /* 0xac9d */
    OTHER,        /* 0xac9e */
    OTHER,        /* 0xac9f */
    OTHER,        /* 0xaca0 */
    OTHER,        /* 0xaca1 */
    OTHER,        /* 0xaca2 */
    OTHER,        /* 0xaca3 */
    OTHER,        /* 0xaca4 */
    OTHER,        /* 0xaca5 */
    OTHER,        /* 0xaca6 */
    OTHER,        /* 0xaca7 */
    OTHER,        /* 0xaca8 */
    OTHER,        /* 0xaca9 */
    OTHER,        /* 0xacaa */
    OTHER,        /* 0xacab */
    OTHER,        /* 0xacac */
    OTHER,        /* 0xacad */
    OTHER,        /* 0xacae */
    OTHER,        /* 0xacaf */
    OTHER,        /* 0xacb0 */
    OTHER,        /* 0xacb1 */
    OTHER,        /* 0xacb2 */
    OTHER,        /* 0xacb3 */
    OTHER,        /* 0xacb4 */
    OTHER,        /* 0xacb5 */
    OTHER,        /* 0xacb6 */
    OTHER,        /* 0xacb7 */
    OTHER,        /* 0xacb8 */
    OTHER,        /* 0xacb9 */
    OTHER,        /* 0xacba */
    OTHER,        /* 0xacbb */
    OTHER,        /* 0xacbc */
    OTHER,        /* 0xacbd */
    OTHER,        /* 0xacbe */
    OTHER,        /* 0xacbf */
    OTHER,        /* 0xacc0 */
    OTHER,        /* 0xacc1 */
    OTHER,        /* 0xacc2 */
    OTHER,        /* 0xacc3 */
    OTHER,        /* 0xacc4 */
    OTHER,        /* 0xacc5 */
    OTHER,        /* 0xacc6 */
    OTHER,        /* 0xacc7 */
    OTHER,        /* 0xacc8 */
    OTHER,        /* 0xacc9 */
    OTHER,        /* 0xacca */
    OTHER,        /* 0xaccb */
    OTHER,        /* 0xaccc */
    OTHER,        /* 0xaccd */
    OTHER,        /* 0xacce */
    OTHER,        /* 0xaccf */
    OTHER,        /* 0xacd0 */
    OTHER,        /* 0xacd1 */
    OTHER,        /* 0xacd2 */
    OTHER,        /* 0xacd3 */
    OTHER,        /* 0xacd4 */
    OTHER,        /* 0xacd5 */
    OTHER,        /* 0xacd6 */
    OTHER,        /* 0xacd7 */
    OTHER,        /* 0xacd8 */
    OTHER,        /* 0xacd9 */
    OTHER,        /* 0xacda */
    OTHER,        /* 0xacdb */
    OTHER,        /* 0xacdc */
    OTHER,        /* 0xacdd */
    OTHER,        /* 0xacde */
    OTHER,        /* 0xacdf */
    OTHER,        /* 0xace0 */
    OTHER,        /* 0xace1 */
    OTHER,        /* 0xace2 */
    OTHER,        /* 0xace3 */
    OTHER,        /* 0xace4 */
    OTHER,        /* 0xace5 */
    OTHER,        /* 0xace6 */
    OTHER,        /* 0xace7 */
    OTHER,        /* 0xace8 */
    OTHER,        /* 0xace9 */
    OTHER,        /* 0xacea */
    OTHER,        /* 0xaceb */
    OTHER,        /* 0xacec */
    OTHER,        /* 0xaced */
    OTHER,        /* 0xacee */
    OTHER,        /* 0xacef */
    OTHER,        /* 0xacf0 */
    OTHER,        /* 0xacf1 */
    OTHER,        /* 0xacf2 */
    OTHER,        /* 0xacf3 */
    OTHER,        /* 0xacf4 */
    OTHER,        /* 0xacf5 */
    OTHER,        /* 0xacf6 */
    OTHER,        /* 0xacf7 */
    OTHER,        /* 0xacf8 */
    OTHER,        /* 0xacf9 */
    OTHER,        /* 0xacfa */
    OTHER,        /* 0xacfb */
    OTHER,        /* 0xacfc */
    OTHER,        /* 0xacfd */
    OTHER,        /* 0xacfe */
    OTHER,        /* 0xacff */
    OTHER,        /* 0xad00 */
    OTHER,        /* 0xad01 */
    OTHER,        /* 0xad02 */
    OTHER,        /* 0xad03 */
    OTHER,        /* 0xad04 */
    OTHER,        /* 0xad05 */
    OTHER,        /* 0xad06 */
    OTHER,        /* 0xad07 */
    OTHER,        /* 0xad08 */
    OTHER,        /* 0xad09 */
    OTHER,        /* 0xad0a */
    OTHER,        /* 0xad0b */
    OTHER,        /* 0xad0c */
    OTHER,        /* 0xad0d */
    OTHER,        /* 0xad0e */
    OTHER,        /* 0xad0f */
    OTHER,        /* 0xad10 */
    OTHER,        /* 0xad11 */
    OTHER,        /* 0xad12 */
    OTHER,        /* 0xad13 */
    OTHER,        /* 0xad14 */
    OTHER,        /* 0xad15 */
    OTHER,        /* 0xad16 */
    OTHER,        /* 0xad17 */
    OTHER,        /* 0xad18 */
    OTHER,        /* 0xad19 */
    OTHER,        /* 0xad1a */
    OTHER,        /* 0xad1b */
    OTHER,        /* 0xad1c */
    OTHER,        /* 0xad1d */
    OTHER,        /* 0xad1e */
    OTHER,        /* 0xad1f */
    OTHER,        /* 0xad20 */
    OTHER,        /* 0xad21 */
    OTHER,        /* 0xad22 */
    OTHER,        /* 0xad23 */
    OTHER,        /* 0xad24 */
    OTHER,        /* 0xad25 */
    OTHER,        /* 0xad26 */
    OTHER,        /* 0xad27 */
    OTHER,        /* 0xad28 */
    OTHER,        /* 0xad29 */
    OTHER,        /* 0xad2a */
    OTHER,        /* 0xad2b */
    OTHER,        /* 0xad2c */
    OTHER,        /* 0xad2d */
    OTHER,        /* 0xad2e */
    OTHER,        /* 0xad2f */
    OTHER,        /* 0xad30 */
    OTHER,        /* 0xad31 */
    OTHER,        /* 0xad32 */
    OTHER,        /* 0xad33 */
    OTHER,        /* 0xad34 */
    OTHER,        /* 0xad35 */
    OTHER,        /* 0xad36 */
    OTHER,        /* 0xad37 */
    OTHER,        /* 0xad38 */
    OTHER,        /* 0xad39 */
    OTHER,        /* 0xad3a */
    OTHER,        /* 0xad3b */
    OTHER,        /* 0xad3c */
    OTHER,        /* 0xad3d */
    OTHER,        /* 0xad3e */
    OTHER,        /* 0xad3f */
    OTHER,        /* 0xad40 */
    OTHER,        /* 0xad41 */
    OTHER,        /* 0xad42 */
    OTHER,        /* 0xad43 */
    OTHER,        /* 0xad44 */
    OTHER,        /* 0xad45 */
    OTHER,        /* 0xad46 */
    OTHER,        /* 0xad47 */
    OTHER,        /* 0xad48 */
    OTHER,        /* 0xad49 */
    OTHER,        /* 0xad4a */
    OTHER,        /* 0xad4b */
    OTHER,        /* 0xad4c */
    OTHER,        /* 0xad4d */
    OTHER,        /* 0xad4e */
    OTHER,        /* 0xad4f */
    OTHER,        /* 0xad50 */
    OTHER,        /* 0xad51 */
    OTHER,        /* 0xad52 */
    OTHER,        /* 0xad53 */
    OTHER,        /* 0xad54 */
    OTHER,        /* 0xad55 */
    OTHER,        /* 0xad56 */
    OTHER,        /* 0xad57 */
    OTHER,        /* 0xad58 */
    OTHER,        /* 0xad59 */
    OTHER,        /* 0xad5a */
    OTHER,        /* 0xad5b */
    OTHER,        /* 0xad5c */
    OTHER,        /* 0xad5d */
    OTHER,        /* 0xad5e */
    OTHER,        /* 0xad5f */
    OTHER,        /* 0xad60 */
    OTHER,        /* 0xad61 */
    OTHER,        /* 0xad62 */
    OTHER,        /* 0xad63 */
    OTHER,        /* 0xad64 */
    OTHER,        /* 0xad65 */
    OTHER,        /* 0xad66 */
    OTHER,        /* 0xad67 */
    OTHER,        /* 0xad68 */
    OTHER,        /* 0xad69 */
    OTHER,        /* 0xad6a */
    OTHER,        /* 0xad6b */
    OTHER,        /* 0xad6c */
    OTHER,        /* 0xad6d */
    OTHER,        /* 0xad6e */
    OTHER,        /* 0xad6f */
    OTHER,        /* 0xad70 */
    OTHER,        /* 0xad71 */
    OTHER,        /* 0xad72 */
    OTHER,        /* 0xad73 */
    OTHER,        /* 0xad74 */
    OTHER,        /* 0xad75 */
    OTHER,        /* 0xad76 */
    OTHER,        /* 0xad77 */
    OTHER,        /* 0xad78 */
    OTHER,        /* 0xad79 */
    OTHER,        /* 0xad7a */
    OTHER,        /* 0xad7b */
    OTHER,        /* 0xad7c */
    OTHER,        /* 0xad7d */
    OTHER,        /* 0xad7e */
    OTHER,        /* 0xad7f */
    OTHER,        /* 0xad80 */
    OTHER,        /* 0xad81 */
    OTHER,        /* 0xad82 */
    OTHER,        /* 0xad83 */
    OTHER,        /* 0xad84 */
    OTHER,        /* 0xad85 */
    OTHER,        /* 0xad86 */
    OTHER,        /* 0xad87 */
    OTHER,        /* 0xad88 */
    OTHER,        /* 0xad89 */
    OTHER,        /* 0xad8a */
    OTHER,        /* 0xad8b */
    OTHER,        /* 0xad8c */
    OTHER,        /* 0xad8d */
    OTHER,        /* 0xad8e */
    OTHER,        /* 0xad8f */
    OTHER,        /* 0xad90 */
    OTHER,        /* 0xad91 */
    OTHER,        /* 0xad92 */
    OTHER,        /* 0xad93 */
    OTHER,        /* 0xad94 */
    OTHER,        /* 0xad95 */
    OTHER,        /* 0xad96 */
    OTHER,        /* 0xad97 */
    OTHER,        /* 0xad98 */
    OTHER,        /* 0xad99 */
    OTHER,        /* 0xad9a */
    OTHER,        /* 0xad9b */
    OTHER,        /* 0xad9c */
    OTHER,        /* 0xad9d */
    OTHER,        /* 0xad9e */
    OTHER,        /* 0xad9f */
    OTHER,        /* 0xada0 */
    OTHER,        /* 0xada1 */
    OTHER,        /* 0xada2 */
    OTHER,        /* 0xada3 */
    OTHER,        /* 0xada4 */
    OTHER,        /* 0xada5 */
    OTHER,        /* 0xada6 */
    OTHER,        /* 0xada7 */
    OTHER,        /* 0xada8 */
    OTHER,        /* 0xada9 */
    OTHER,        /* 0xadaa */
    OTHER,        /* 0xadab */
    OTHER,        /* 0xadac */
    OTHER,        /* 0xadad */
    OTHER,        /* 0xadae */
    OTHER,        /* 0xadaf */
    OTHER,        /* 0xadb0 */
    OTHER,        /* 0xadb1 */
    OTHER,        /* 0xadb2 */
    OTHER,        /* 0xadb3 */
    OTHER,        /* 0xadb4 */
    OTHER,        /* 0xadb5 */
    OTHER,        /* 0xadb6 */
    OTHER,        /* 0xadb7 */
    OTHER,        /* 0xadb8 */
    OTHER,        /* 0xadb9 */
    OTHER,        /* 0xadba */
    OTHER,        /* 0xadbb */
    OTHER,        /* 0xadbc */
    OTHER,        /* 0xadbd */
    OTHER,        /* 0xadbe */
    OTHER,        /* 0xadbf */
    OTHER,        /* 0xadc0 */
    OTHER,        /* 0xadc1 */
    OTHER,        /* 0xadc2 */
    OTHER,        /* 0xadc3 */
    OTHER,        /* 0xadc4 */
    OTHER,        /* 0xadc5 */
    OTHER,        /* 0xadc6 */
    OTHER,        /* 0xadc7 */
    OTHER,        /* 0xadc8 */
    OTHER,        /* 0xadc9 */
    OTHER,        /* 0xadca */
    OTHER,        /* 0xadcb */
    OTHER,        /* 0xadcc */
    OTHER,        /* 0xadcd */
    OTHER,        /* 0xadce */
    OTHER,        /* 0xadcf */
    OTHER,        /* 0xadd0 */
    OTHER,        /* 0xadd1 */
    OTHER,        /* 0xadd2 */
    OTHER,        /* 0xadd3 */
    OTHER,        /* 0xadd4 */
    OTHER,        /* 0xadd5 */
    OTHER,        /* 0xadd6 */
    OTHER,        /* 0xadd7 */
    OTHER,        /* 0xadd8 */
    OTHER,        /* 0xadd9 */
    OTHER,        /* 0xadda */
    OTHER,        /* 0xaddb */
    OTHER,        /* 0xaddc */
    OTHER,        /* 0xaddd */
    OTHER,        /* 0xadde */
    OTHER,        /* 0xaddf */
    OTHER,        /* 0xade0 */
    OTHER,        /* 0xade1 */
    OTHER,        /* 0xade2 */
    OTHER,        /* 0xade3 */
    OTHER,        /* 0xade4 */
    OTHER,        /* 0xade5 */
    OTHER,        /* 0xade6 */
    OTHER,        /* 0xade7 */
    OTHER,        /* 0xade8 */
    OTHER,        /* 0xade9 */
    OTHER,        /* 0xadea */
    OTHER,        /* 0xadeb */
    OTHER,        /* 0xadec */
    OTHER,        /* 0xaded */
    OTHER,        /* 0xadee */
    OTHER,        /* 0xadef */
    OTHER,        /* 0xadf0 */
    OTHER,        /* 0xadf1 */
    OTHER,        /* 0xadf2 */
    OTHER,        /* 0xadf3 */
    OTHER,        /* 0xadf4 */
    OTHER,        /* 0xadf5 */
    OTHER,        /* 0xadf6 */
    OTHER,        /* 0xadf7 */
    OTHER,        /* 0xadf8 */
    OTHER,        /* 0xadf9 */
    OTHER,        /* 0xadfa */
    OTHER,        /* 0xadfb */
    OTHER,        /* 0xadfc */
    OTHER,        /* 0xadfd */
    OTHER,        /* 0xadfe */
    OTHER,        /* 0xadff */
    OTHER,        /* 0xae00 */
    OTHER,        /* 0xae01 */
    OTHER,        /* 0xae02 */
    OTHER,        /* 0xae03 */
    OTHER,        /* 0xae04 */
    OTHER,        /* 0xae05 */
    OTHER,        /* 0xae06 */
    OTHER,        /* 0xae07 */
    OTHER,        /* 0xae08 */
    OTHER,        /* 0xae09 */
    OTHER,        /* 0xae0a */
    OTHER,        /* 0xae0b */
    OTHER,        /* 0xae0c */
    OTHER,        /* 0xae0d */
    OTHER,        /* 0xae0e */
    OTHER,        /* 0xae0f */
    OTHER,        /* 0xae10 */
    OTHER,        /* 0xae11 */
    OTHER,        /* 0xae12 */
    OTHER,        /* 0xae13 */
    OTHER,        /* 0xae14 */
    OTHER,        /* 0xae15 */
    OTHER,        /* 0xae16 */
    OTHER,        /* 0xae17 */
    OTHER,        /* 0xae18 */
    OTHER,        /* 0xae19 */
    OTHER,        /* 0xae1a */
    OTHER,        /* 0xae1b */
    OTHER,        /* 0xae1c */
    OTHER,        /* 0xae1d */
    OTHER,        /* 0xae1e */
    OTHER,        /* 0xae1f */
    OTHER,        /* 0xae20 */
    OTHER,        /* 0xae21 */
    OTHER,        /* 0xae22 */
    OTHER,        /* 0xae23 */
    OTHER,        /* 0xae24 */
    OTHER,        /* 0xae25 */
    OTHER,        /* 0xae26 */
    OTHER,        /* 0xae27 */
    OTHER,        /* 0xae28 */
    OTHER,        /* 0xae29 */
    OTHER,        /* 0xae2a */
    OTHER,        /* 0xae2b */
    OTHER,        /* 0xae2c */
    OTHER,        /* 0xae2d */
    OTHER,        /* 0xae2e */
    OTHER,        /* 0xae2f */
    OTHER,        /* 0xae30 */
    OTHER,        /* 0xae31 */
    OTHER,        /* 0xae32 */
    OTHER,        /* 0xae33 */
    OTHER,        /* 0xae34 */
    OTHER,        /* 0xae35 */
    OTHER,        /* 0xae36 */
    OTHER,        /* 0xae37 */
    OTHER,        /* 0xae38 */
    OTHER,        /* 0xae39 */
    OTHER,        /* 0xae3a */
    OTHER,        /* 0xae3b */
    OTHER,        /* 0xae3c */
    OTHER,        /* 0xae3d */
    OTHER,        /* 0xae3e */
    OTHER,        /* 0xae3f */
    OTHER,        /* 0xae40 */
    OTHER,        /* 0xae41 */
    OTHER,        /* 0xae42 */
    OTHER,        /* 0xae43 */
    OTHER,        /* 0xae44 */
    OTHER,        /* 0xae45 */
    OTHER,        /* 0xae46 */
    OTHER,        /* 0xae47 */
    OTHER,        /* 0xae48 */
    OTHER,        /* 0xae49 */
    OTHER,        /* 0xae4a */
    OTHER,        /* 0xae4b */
    OTHER,        /* 0xae4c */
    OTHER,        /* 0xae4d */
    OTHER,        /* 0xae4e */
    OTHER,        /* 0xae4f */
    OTHER,        /* 0xae50 */
    OTHER,        /* 0xae51 */
    OTHER,        /* 0xae52 */
    OTHER,        /* 0xae53 */
    OTHER,        /* 0xae54 */
    OTHER,        /* 0xae55 */
    OTHER,        /* 0xae56 */
    OTHER,        /* 0xae57 */
    OTHER,        /* 0xae58 */
    OTHER,        /* 0xae59 */
    OTHER,        /* 0xae5a */
    OTHER,        /* 0xae5b */
    OTHER,        /* 0xae5c */
    OTHER,        /* 0xae5d */
    OTHER,        /* 0xae5e */
    OTHER,        /* 0xae5f */
    OTHER,        /* 0xae60 */
    OTHER,        /* 0xae61 */
    OTHER,        /* 0xae62 */
    OTHER,        /* 0xae63 */
    OTHER,        /* 0xae64 */
    OTHER,        /* 0xae65 */
    OTHER,        /* 0xae66 */
    OTHER,        /* 0xae67 */
    OTHER,        /* 0xae68 */
    OTHER,        /* 0xae69 */
    OTHER,        /* 0xae6a */
    OTHER,        /* 0xae6b */
    OTHER,        /* 0xae6c */
    OTHER,        /* 0xae6d */
    OTHER,        /* 0xae6e */
    OTHER,        /* 0xae6f */
    OTHER,        /* 0xae70 */
    OTHER,        /* 0xae71 */
    OTHER,        /* 0xae72 */
    OTHER,        /* 0xae73 */
    OTHER,        /* 0xae74 */
    OTHER,        /* 0xae75 */
    OTHER,        /* 0xae76 */
    OTHER,        /* 0xae77 */
    OTHER,        /* 0xae78 */
    OTHER,        /* 0xae79 */
    OTHER,        /* 0xae7a */
    OTHER,        /* 0xae7b */
    OTHER,        /* 0xae7c */
    OTHER,        /* 0xae7d */
    OTHER,        /* 0xae7e */
    OTHER,        /* 0xae7f */
    OTHER,        /* 0xae80 */
    OTHER,        /* 0xae81 */
    OTHER,        /* 0xae82 */
    OTHER,        /* 0xae83 */
    OTHER,        /* 0xae84 */
    OTHER,        /* 0xae85 */
    OTHER,        /* 0xae86 */
    OTHER,        /* 0xae87 */
    OTHER,        /* 0xae88 */
    OTHER,        /* 0xae89 */
    OTHER,        /* 0xae8a */
    OTHER,        /* 0xae8b */
    OTHER,        /* 0xae8c */
    OTHER,        /* 0xae8d */
    OTHER,        /* 0xae8e */
    OTHER,        /* 0xae8f */
    OTHER,        /* 0xae90 */
    OTHER,        /* 0xae91 */
    OTHER,        /* 0xae92 */
    OTHER,        /* 0xae93 */
    OTHER,        /* 0xae94 */
    OTHER,        /* 0xae95 */
    OTHER,        /* 0xae96 */
    OTHER,        /* 0xae97 */
    OTHER,        /* 0xae98 */
    OTHER,        /* 0xae99 */
    OTHER,        /* 0xae9a */
    OTHER,        /* 0xae9b */
    OTHER,        /* 0xae9c */
    OTHER,        /* 0xae9d */
    OTHER,        /* 0xae9e */
    OTHER,        /* 0xae9f */
    OTHER,        /* 0xaea0 */
    OTHER,        /* 0xaea1 */
    OTHER,        /* 0xaea2 */
    OTHER,        /* 0xaea3 */
    OTHER,        /* 0xaea4 */
    OTHER,        /* 0xaea5 */
    OTHER,        /* 0xaea6 */
    OTHER,        /* 0xaea7 */
    OTHER,        /* 0xaea8 */
    OTHER,        /* 0xaea9 */
    OTHER,        /* 0xaeaa */
    OTHER,        /* 0xaeab */
    OTHER,        /* 0xaeac */
    OTHER,        /* 0xaead */
    OTHER,        /* 0xaeae */
    OTHER,        /* 0xaeaf */
    OTHER,        /* 0xaeb0 */
    OTHER,        /* 0xaeb1 */
    OTHER,        /* 0xaeb2 */
    OTHER,        /* 0xaeb3 */
    OTHER,        /* 0xaeb4 */
    OTHER,        /* 0xaeb5 */
    OTHER,        /* 0xaeb6 */
    OTHER,        /* 0xaeb7 */
    OTHER,        /* 0xaeb8 */
    OTHER,        /* 0xaeb9 */
    OTHER,        /* 0xaeba */
    OTHER,        /* 0xaebb */
    OTHER,        /* 0xaebc */
    OTHER,        /* 0xaebd */
    OTHER,        /* 0xaebe */
    OTHER,        /* 0xaebf */
    OTHER,        /* 0xaec0 */
    OTHER,        /* 0xaec1 */
    OTHER,        /* 0xaec2 */
    OTHER,        /* 0xaec3 */
    OTHER,        /* 0xaec4 */
    OTHER,        /* 0xaec5 */
    OTHER,        /* 0xaec6 */
    OTHER,        /* 0xaec7 */
    OTHER,        /* 0xaec8 */
    OTHER,        /* 0xaec9 */
    OTHER,        /* 0xaeca */
    OTHER,        /* 0xaecb */
    OTHER,        /* 0xaecc */
    OTHER,        /* 0xaecd */
    OTHER,        /* 0xaece */
    OTHER,        /* 0xaecf */
    OTHER,        /* 0xaed0 */
    OTHER,        /* 0xaed1 */
    OTHER,        /* 0xaed2 */
    OTHER,        /* 0xaed3 */
    OTHER,        /* 0xaed4 */
    OTHER,        /* 0xaed5 */
    OTHER,        /* 0xaed6 */
    OTHER,        /* 0xaed7 */
    OTHER,        /* 0xaed8 */
    OTHER,        /* 0xaed9 */
    OTHER,        /* 0xaeda */
    OTHER,        /* 0xaedb */
    OTHER,        /* 0xaedc */
    OTHER,        /* 0xaedd */
    OTHER,        /* 0xaede */
    OTHER,        /* 0xaedf */
    OTHER,        /* 0xaee0 */
    OTHER,        /* 0xaee1 */
    OTHER,        /* 0xaee2 */
    OTHER,        /* 0xaee3 */
    OTHER,        /* 0xaee4 */
    OTHER,        /* 0xaee5 */
    OTHER,        /* 0xaee6 */
    OTHER,        /* 0xaee7 */
    OTHER,        /* 0xaee8 */
    OTHER,        /* 0xaee9 */
    OTHER,        /* 0xaeea */
    OTHER,        /* 0xaeeb */
    OTHER,        /* 0xaeec */
    OTHER,        /* 0xaeed */
    OTHER,        /* 0xaeee */
    OTHER,        /* 0xaeef */
    OTHER,        /* 0xaef0 */
    OTHER,        /* 0xaef1 */
    OTHER,        /* 0xaef2 */
    OTHER,        /* 0xaef3 */
    OTHER,        /* 0xaef4 */
    OTHER,        /* 0xaef5 */
    OTHER,        /* 0xaef6 */
    OTHER,        /* 0xaef7 */
    OTHER,        /* 0xaef8 */
    OTHER,        /* 0xaef9 */
    OTHER,        /* 0xaefa */
    OTHER,        /* 0xaefb */
    OTHER,        /* 0xaefc */
    OTHER,        /* 0xaefd */
    OTHER,        /* 0xaefe */
    OTHER,        /* 0xaeff */
    OTHER,        /* 0xaf00 */
    OTHER,        /* 0xaf01 */
    OTHER,        /* 0xaf02 */
    OTHER,        /* 0xaf03 */
    OTHER,        /* 0xaf04 */
    OTHER,        /* 0xaf05 */
    OTHER,        /* 0xaf06 */
    OTHER,        /* 0xaf07 */
    OTHER,        /* 0xaf08 */
    OTHER,        /* 0xaf09 */
    OTHER,        /* 0xaf0a */
    OTHER,        /* 0xaf0b */
    OTHER,        /* 0xaf0c */
    OTHER,        /* 0xaf0d */
    OTHER,        /* 0xaf0e */
    OTHER,        /* 0xaf0f */
    OTHER,        /* 0xaf10 */
    OTHER,        /* 0xaf11 */
    OTHER,        /* 0xaf12 */
    OTHER,        /* 0xaf13 */
    OTHER,        /* 0xaf14 */
    OTHER,        /* 0xaf15 */
    OTHER,        /* 0xaf16 */
    OTHER,        /* 0xaf17 */
    OTHER,        /* 0xaf18 */
    OTHER,        /* 0xaf19 */
    OTHER,        /* 0xaf1a */
    OTHER,        /* 0xaf1b */
    OTHER,        /* 0xaf1c */
    OTHER,        /* 0xaf1d */
    OTHER,        /* 0xaf1e */
    OTHER,        /* 0xaf1f */
    OTHER,        /* 0xaf20 */
    OTHER,        /* 0xaf21 */
    OTHER,        /* 0xaf22 */
    OTHER,        /* 0xaf23 */
    OTHER,        /* 0xaf24 */
    OTHER,        /* 0xaf25 */
    OTHER,        /* 0xaf26 */
    OTHER,        /* 0xaf27 */
    OTHER,        /* 0xaf28 */
    OTHER,        /* 0xaf29 */
    OTHER,        /* 0xaf2a */
    OTHER,        /* 0xaf2b */
    OTHER,        /* 0xaf2c */
    OTHER,        /* 0xaf2d */
    OTHER,        /* 0xaf2e */
    OTHER,        /* 0xaf2f */
    OTHER,        /* 0xaf30 */
    OTHER,        /* 0xaf31 */
    OTHER,        /* 0xaf32 */
    OTHER,        /* 0xaf33 */
    OTHER,        /* 0xaf34 */
    OTHER,        /* 0xaf35 */
    OTHER,        /* 0xaf36 */
    OTHER,        /* 0xaf37 */
    OTHER,        /* 0xaf38 */
    OTHER,        /* 0xaf39 */
    OTHER,        /* 0xaf3a */
    OTHER,        /* 0xaf3b */
    OTHER,        /* 0xaf3c */
    OTHER,        /* 0xaf3d */
    OTHER,        /* 0xaf3e */
    OTHER,        /* 0xaf3f */
    OTHER,        /* 0xaf40 */
    OTHER,        /* 0xaf41 */
    OTHER,        /* 0xaf42 */
    OTHER,        /* 0xaf43 */
    OTHER,        /* 0xaf44 */
    OTHER,        /* 0xaf45 */
    OTHER,        /* 0xaf46 */
    OTHER,        /* 0xaf47 */
    OTHER,        /* 0xaf48 */
    OTHER,        /* 0xaf49 */
    OTHER,        /* 0xaf4a */
    OTHER,        /* 0xaf4b */
    OTHER,        /* 0xaf4c */
    OTHER,        /* 0xaf4d */
    OTHER,        /* 0xaf4e */
    OTHER,        /* 0xaf4f */
    OTHER,        /* 0xaf50 */
    OTHER,        /* 0xaf51 */
    OTHER,        /* 0xaf52 */
    OTHER,        /* 0xaf53 */
    OTHER,        /* 0xaf54 */
    OTHER,        /* 0xaf55 */
    OTHER,        /* 0xaf56 */
    OTHER,        /* 0xaf57 */
    OTHER,        /* 0xaf58 */
    OTHER,        /* 0xaf59 */
    OTHER,        /* 0xaf5a */
    OTHER,        /* 0xaf5b */
    OTHER,        /* 0xaf5c */
    OTHER,        /* 0xaf5d */
    OTHER,        /* 0xaf5e */
    OTHER,        /* 0xaf5f */
    OTHER,        /* 0xaf60 */
    OTHER,        /* 0xaf61 */
    OTHER,        /* 0xaf62 */
    OTHER,        /* 0xaf63 */
    OTHER,        /* 0xaf64 */
    OTHER,        /* 0xaf65 */
    OTHER,        /* 0xaf66 */
    OTHER,        /* 0xaf67 */
    OTHER,        /* 0xaf68 */
    OTHER,        /* 0xaf69 */
    OTHER,        /* 0xaf6a */
    OTHER,        /* 0xaf6b */
    OTHER,        /* 0xaf6c */
    OTHER,        /* 0xaf6d */
    OTHER,        /* 0xaf6e */
    OTHER,        /* 0xaf6f */
    OTHER,        /* 0xaf70 */
    OTHER,        /* 0xaf71 */
    OTHER,        /* 0xaf72 */
    OTHER,        /* 0xaf73 */
    OTHER,        /* 0xaf74 */
    OTHER,        /* 0xaf75 */
    OTHER,        /* 0xaf76 */
    OTHER,        /* 0xaf77 */
    OTHER,        /* 0xaf78 */
    OTHER,        /* 0xaf79 */
    OTHER,        /* 0xaf7a */
    OTHER,        /* 0xaf7b */
    OTHER,        /* 0xaf7c */
    OTHER,        /* 0xaf7d */
    OTHER,        /* 0xaf7e */
    OTHER,        /* 0xaf7f */
    OTHER,        /* 0xaf80 */
    OTHER,        /* 0xaf81 */
    OTHER,        /* 0xaf82 */
    OTHER,        /* 0xaf83 */
    OTHER,        /* 0xaf84 */
    OTHER,        /* 0xaf85 */
    OTHER,        /* 0xaf86 */
    OTHER,        /* 0xaf87 */
    OTHER,        /* 0xaf88 */
    OTHER,        /* 0xaf89 */
    OTHER,        /* 0xaf8a */
    OTHER,        /* 0xaf8b */
    OTHER,        /* 0xaf8c */
    OTHER,        /* 0xaf8d */
    OTHER,        /* 0xaf8e */
    OTHER,        /* 0xaf8f */
    OTHER,        /* 0xaf90 */
    OTHER,        /* 0xaf91 */
    OTHER,        /* 0xaf92 */
    OTHER,        /* 0xaf93 */
    OTHER,        /* 0xaf94 */
    OTHER,        /* 0xaf95 */
    OTHER,        /* 0xaf96 */
    OTHER,        /* 0xaf97 */
    OTHER,        /* 0xaf98 */
    OTHER,        /* 0xaf99 */
    OTHER,        /* 0xaf9a */
    OTHER,        /* 0xaf9b */
    OTHER,        /* 0xaf9c */
    OTHER,        /* 0xaf9d */
    OTHER,        /* 0xaf9e */
    OTHER,        /* 0xaf9f */
    OTHER,        /* 0xafa0 */
    OTHER,        /* 0xafa1 */
    OTHER,        /* 0xafa2 */
    OTHER,        /* 0xafa3 */
    OTHER,        /* 0xafa4 */
    OTHER,        /* 0xafa5 */
    OTHER,        /* 0xafa6 */
    OTHER,        /* 0xafa7 */
    OTHER,        /* 0xafa8 */
    OTHER,        /* 0xafa9 */
    OTHER,        /* 0xafaa */
    OTHER,        /* 0xafab */
    OTHER,        /* 0xafac */
    OTHER,        /* 0xafad */
    OTHER,        /* 0xafae */
    OTHER,        /* 0xafaf */
    OTHER,        /* 0xafb0 */
    OTHER,        /* 0xafb1 */
    OTHER,        /* 0xafb2 */
    OTHER,        /* 0xafb3 */
    OTHER,        /* 0xafb4 */
    OTHER,        /* 0xafb5 */
    OTHER,        /* 0xafb6 */
    OTHER,        /* 0xafb7 */
    OTHER,        /* 0xafb8 */
    OTHER,        /* 0xafb9 */
    OTHER,        /* 0xafba */
    OTHER,        /* 0xafbb */
    OTHER,        /* 0xafbc */
    OTHER,        /* 0xafbd */
    OTHER,        /* 0xafbe */
    OTHER,        /* 0xafbf */
    OTHER,        /* 0xafc0 */
    OTHER,        /* 0xafc1 */
    OTHER,        /* 0xafc2 */
    OTHER,        /* 0xafc3 */
    OTHER,        /* 0xafc4 */
    OTHER,        /* 0xafc5 */
    OTHER,        /* 0xafc6 */
    OTHER,        /* 0xafc7 */
    OTHER,        /* 0xafc8 */
    OTHER,        /* 0xafc9 */
    OTHER,        /* 0xafca */
    OTHER,        /* 0xafcb */
    OTHER,        /* 0xafcc */
    OTHER,        /* 0xafcd */
    OTHER,        /* 0xafce */
    OTHER,        /* 0xafcf */
    OTHER,        /* 0xafd0 */
    OTHER,        /* 0xafd1 */
    OTHER,        /* 0xafd2 */
    OTHER,        /* 0xafd3 */
    OTHER,        /* 0xafd4 */
    OTHER,        /* 0xafd5 */
    OTHER,        /* 0xafd6 */
    OTHER,        /* 0xafd7 */
    OTHER,        /* 0xafd8 */
    OTHER,        /* 0xafd9 */
    OTHER,        /* 0xafda */
    OTHER,        /* 0xafdb */
    OTHER,        /* 0xafdc */
    OTHER,        /* 0xafdd */
    OTHER,        /* 0xafde */
    OTHER,        /* 0xafdf */
    OTHER,        /* 0xafe0 */
    OTHER,        /* 0xafe1 */
    OTHER,        /* 0xafe2 */
    OTHER,        /* 0xafe3 */
    OTHER,        /* 0xafe4 */
    OTHER,        /* 0xafe5 */
    OTHER,        /* 0xafe6 */
    OTHER,        /* 0xafe7 */
    OTHER,        /* 0xafe8 */
    OTHER,        /* 0xafe9 */
    OTHER,        /* 0xafea */
    OTHER,        /* 0xafeb */
    OTHER,        /* 0xafec */
    OTHER,        /* 0xafed */
    OTHER,        /* 0xafee */
    OTHER,        /* 0xafef */
    OTHER,        /* 0xaff0 */
    OTHER,        /* 0xaff1 */
    OTHER,        /* 0xaff2 */
    OTHER,        /* 0xaff3 */
    OTHER,        /* 0xaff4 */
    OTHER,        /* 0xaff5 */
    OTHER,        /* 0xaff6 */
    OTHER,        /* 0xaff7 */
    OTHER,        /* 0xaff8 */
    OTHER,        /* 0xaff9 */
    OTHER,        /* 0xaffa */
    OTHER,        /* 0xaffb */
    OTHER,        /* 0xaffc */
    OTHER,        /* 0xaffd */
    OTHER,        /* 0xaffe */
    OTHER,        /* 0xafff */
    OTHER,        /* 0xb000 */
    OTHER,        /* 0xb001 */
    OTHER,        /* 0xb002 */
    OTHER,        /* 0xb003 */
    OTHER,        /* 0xb004 */
    OTHER,        /* 0xb005 */
    OTHER,        /* 0xb006 */
    OTHER,        /* 0xb007 */
    OTHER,        /* 0xb008 */
    OTHER,        /* 0xb009 */
    OTHER,        /* 0xb00a */
    OTHER,        /* 0xb00b */
    OTHER,        /* 0xb00c */
    OTHER,        /* 0xb00d */
    OTHER,        /* 0xb00e */
    OTHER,        /* 0xb00f */
    OTHER,        /* 0xb010 */
    OTHER,        /* 0xb011 */
    OTHER,        /* 0xb012 */
    OTHER,        /* 0xb013 */
    OTHER,        /* 0xb014 */
    OTHER,        /* 0xb015 */
    OTHER,        /* 0xb016 */
    OTHER,        /* 0xb017 */
    OTHER,        /* 0xb018 */
    OTHER,        /* 0xb019 */
    OTHER,        /* 0xb01a */
    OTHER,        /* 0xb01b */
    OTHER,        /* 0xb01c */
    OTHER,        /* 0xb01d */
    OTHER,        /* 0xb01e */
    OTHER,        /* 0xb01f */
    OTHER,        /* 0xb020 */
    OTHER,        /* 0xb021 */
    OTHER,        /* 0xb022 */
    OTHER,        /* 0xb023 */
    OTHER,        /* 0xb024 */
    OTHER,        /* 0xb025 */
    OTHER,        /* 0xb026 */
    OTHER,        /* 0xb027 */
    OTHER,        /* 0xb028 */
    OTHER,        /* 0xb029 */
    OTHER,        /* 0xb02a */
    OTHER,        /* 0xb02b */
    OTHER,        /* 0xb02c */
    OTHER,        /* 0xb02d */
    OTHER,        /* 0xb02e */
    OTHER,        /* 0xb02f */
    OTHER,        /* 0xb030 */
    OTHER,        /* 0xb031 */
    OTHER,        /* 0xb032 */
    OTHER,        /* 0xb033 */
    OTHER,        /* 0xb034 */
    OTHER,        /* 0xb035 */
    OTHER,        /* 0xb036 */
    OTHER,        /* 0xb037 */
    OTHER,        /* 0xb038 */
    OTHER,        /* 0xb039 */
    OTHER,        /* 0xb03a */
    OTHER,        /* 0xb03b */
    OTHER,        /* 0xb03c */
    OTHER,        /* 0xb03d */
    OTHER,        /* 0xb03e */
    OTHER,        /* 0xb03f */
    OTHER,        /* 0xb040 */
    OTHER,        /* 0xb041 */
    OTHER,        /* 0xb042 */
    OTHER,        /* 0xb043 */
    OTHER,        /* 0xb044 */
    OTHER,        /* 0xb045 */
    OTHER,        /* 0xb046 */
    OTHER,        /* 0xb047 */
    OTHER,        /* 0xb048 */
    OTHER,        /* 0xb049 */
    OTHER,        /* 0xb04a */
    OTHER,        /* 0xb04b */
    OTHER,        /* 0xb04c */
    OTHER,        /* 0xb04d */
    OTHER,        /* 0xb04e */
    OTHER,        /* 0xb04f */
    OTHER,        /* 0xb050 */
    OTHER,        /* 0xb051 */
    OTHER,        /* 0xb052 */
    OTHER,        /* 0xb053 */
    OTHER,        /* 0xb054 */
    OTHER,        /* 0xb055 */
    OTHER,        /* 0xb056 */
    OTHER,        /* 0xb057 */
    OTHER,        /* 0xb058 */
    OTHER,        /* 0xb059 */
    OTHER,        /* 0xb05a */
    OTHER,        /* 0xb05b */
    OTHER,        /* 0xb05c */
    OTHER,        /* 0xb05d */
    OTHER,        /* 0xb05e */
    OTHER,        /* 0xb05f */
    OTHER,        /* 0xb060 */
    OTHER,        /* 0xb061 */
    OTHER,        /* 0xb062 */
    OTHER,        /* 0xb063 */
    OTHER,        /* 0xb064 */
    OTHER,        /* 0xb065 */
    OTHER,        /* 0xb066 */
    OTHER,        /* 0xb067 */
    OTHER,        /* 0xb068 */
    OTHER,        /* 0xb069 */
    OTHER,        /* 0xb06a */
    OTHER,        /* 0xb06b */
    OTHER,        /* 0xb06c */
    OTHER,        /* 0xb06d */
    OTHER,        /* 0xb06e */
    OTHER,        /* 0xb06f */
    OTHER,        /* 0xb070 */
    OTHER,        /* 0xb071 */
    OTHER,        /* 0xb072 */
    OTHER,        /* 0xb073 */
    OTHER,        /* 0xb074 */
    OTHER,        /* 0xb075 */
    OTHER,        /* 0xb076 */
    OTHER,        /* 0xb077 */
    OTHER,        /* 0xb078 */
    OTHER,        /* 0xb079 */
    OTHER,        /* 0xb07a */
    OTHER,        /* 0xb07b */
    OTHER,        /* 0xb07c */
    OTHER,        /* 0xb07d */
    OTHER,        /* 0xb07e */
    OTHER,        /* 0xb07f */
    OTHER,        /* 0xb080 */
    OTHER,        /* 0xb081 */
    OTHER,        /* 0xb082 */
    OTHER,        /* 0xb083 */
    OTHER,        /* 0xb084 */
    OTHER,        /* 0xb085 */
    OTHER,        /* 0xb086 */
    OTHER,        /* 0xb087 */
    OTHER,        /* 0xb088 */
    OTHER,        /* 0xb089 */
    OTHER,        /* 0xb08a */
    OTHER,        /* 0xb08b */
    OTHER,        /* 0xb08c */
    OTHER,        /* 0xb08d */
    OTHER,        /* 0xb08e */
    OTHER,        /* 0xb08f */
    OTHER,        /* 0xb090 */
    OTHER,        /* 0xb091 */
    OTHER,        /* 0xb092 */
    OTHER,        /* 0xb093 */
    OTHER,        /* 0xb094 */
    OTHER,        /* 0xb095 */
    OTHER,        /* 0xb096 */
    OTHER,        /* 0xb097 */
    OTHER,        /* 0xb098 */
    OTHER,        /* 0xb099 */
    OTHER,        /* 0xb09a */
    OTHER,        /* 0xb09b */
    OTHER,        /* 0xb09c */
    OTHER,        /* 0xb09d */
    OTHER,        /* 0xb09e */
    OTHER,        /* 0xb09f */
    OTHER,        /* 0xb0a0 */
    OTHER,        /* 0xb0a1 */
    OTHER,        /* 0xb0a2 */
    OTHER,        /* 0xb0a3 */
    OTHER,        /* 0xb0a4 */
    OTHER,        /* 0xb0a5 */
    OTHER,        /* 0xb0a6 */
    OTHER,        /* 0xb0a7 */
    OTHER,        /* 0xb0a8 */
    OTHER,        /* 0xb0a9 */
    OTHER,        /* 0xb0aa */
    OTHER,        /* 0xb0ab */
    OTHER,        /* 0xb0ac */
    OTHER,        /* 0xb0ad */
    OTHER,        /* 0xb0ae */
    OTHER,        /* 0xb0af */
    OTHER,        /* 0xb0b0 */
    OTHER,        /* 0xb0b1 */
    OTHER,        /* 0xb0b2 */
    OTHER,        /* 0xb0b3 */
    OTHER,        /* 0xb0b4 */
    OTHER,        /* 0xb0b5 */
    OTHER,        /* 0xb0b6 */
    OTHER,        /* 0xb0b7 */
    OTHER,        /* 0xb0b8 */
    OTHER,        /* 0xb0b9 */
    OTHER,        /* 0xb0ba */
    OTHER,        /* 0xb0bb */
    OTHER,        /* 0xb0bc */
    OTHER,        /* 0xb0bd */
    OTHER,        /* 0xb0be */
    OTHER,        /* 0xb0bf */
    OTHER,        /* 0xb0c0 */
    OTHER,        /* 0xb0c1 */
    OTHER,        /* 0xb0c2 */
    OTHER,        /* 0xb0c3 */
    OTHER,        /* 0xb0c4 */
    OTHER,        /* 0xb0c5 */
    OTHER,        /* 0xb0c6 */
    OTHER,        /* 0xb0c7 */
    OTHER,        /* 0xb0c8 */
    OTHER,        /* 0xb0c9 */
    OTHER,        /* 0xb0ca */
    OTHER,        /* 0xb0cb */
    OTHER,        /* 0xb0cc */
    OTHER,        /* 0xb0cd */
    OTHER,        /* 0xb0ce */
    OTHER,        /* 0xb0cf */
    OTHER,        /* 0xb0d0 */
    OTHER,        /* 0xb0d1 */
    OTHER,        /* 0xb0d2 */
    OTHER,        /* 0xb0d3 */
    OTHER,        /* 0xb0d4 */
    OTHER,        /* 0xb0d5 */
    OTHER,        /* 0xb0d6 */
    OTHER,        /* 0xb0d7 */
    OTHER,        /* 0xb0d8 */
    OTHER,        /* 0xb0d9 */
    OTHER,        /* 0xb0da */
    OTHER,        /* 0xb0db */
    OTHER,        /* 0xb0dc */
    OTHER,        /* 0xb0dd */
    OTHER,        /* 0xb0de */
    OTHER,        /* 0xb0df */
    OTHER,        /* 0xb0e0 */
    OTHER,        /* 0xb0e1 */
    OTHER,        /* 0xb0e2 */
    OTHER,        /* 0xb0e3 */
    OTHER,        /* 0xb0e4 */
    OTHER,        /* 0xb0e5 */
    OTHER,        /* 0xb0e6 */
    OTHER,        /* 0xb0e7 */
    OTHER,        /* 0xb0e8 */
    OTHER,        /* 0xb0e9 */
    OTHER,        /* 0xb0ea */
    OTHER,        /* 0xb0eb */
    OTHER,        /* 0xb0ec */
    OTHER,        /* 0xb0ed */
    OTHER,        /* 0xb0ee */
    OTHER,        /* 0xb0ef */
    OTHER,        /* 0xb0f0 */
    OTHER,        /* 0xb0f1 */
    OTHER,        /* 0xb0f2 */
    OTHER,        /* 0xb0f3 */
    OTHER,        /* 0xb0f4 */
    OTHER,        /* 0xb0f5 */
    OTHER,        /* 0xb0f6 */
    OTHER,        /* 0xb0f7 */
    OTHER,        /* 0xb0f8 */
    OTHER,        /* 0xb0f9 */
    OTHER,        /* 0xb0fa */
    OTHER,        /* 0xb0fb */
    OTHER,        /* 0xb0fc */
    OTHER,        /* 0xb0fd */
    OTHER,        /* 0xb0fe */
    OTHER,        /* 0xb0ff */
    OTHER,        /* 0xb100 */
    OTHER,        /* 0xb101 */
    OTHER,        /* 0xb102 */
    OTHER,        /* 0xb103 */
    OTHER,        /* 0xb104 */
    OTHER,        /* 0xb105 */
    OTHER,        /* 0xb106 */
    OTHER,        /* 0xb107 */
    OTHER,        /* 0xb108 */
    OTHER,        /* 0xb109 */
    OTHER,        /* 0xb10a */
    OTHER,        /* 0xb10b */
    OTHER,        /* 0xb10c */
    OTHER,        /* 0xb10d */
    OTHER,        /* 0xb10e */
    OTHER,        /* 0xb10f */
    OTHER,        /* 0xb110 */
    OTHER,        /* 0xb111 */
    OTHER,        /* 0xb112 */
    OTHER,        /* 0xb113 */
    OTHER,        /* 0xb114 */
    OTHER,        /* 0xb115 */
    OTHER,        /* 0xb116 */
    OTHER,        /* 0xb117 */
    OTHER,        /* 0xb118 */
    OTHER,        /* 0xb119 */
    OTHER,        /* 0xb11a */
    OTHER,        /* 0xb11b */
    OTHER,        /* 0xb11c */
    OTHER,        /* 0xb11d */
    OTHER,        /* 0xb11e */
    OTHER,        /* 0xb11f */
    OTHER,        /* 0xb120 */
    OTHER,        /* 0xb121 */
    OTHER,        /* 0xb122 */
    OTHER,        /* 0xb123 */
    OTHER,        /* 0xb124 */
    OTHER,        /* 0xb125 */
    OTHER,        /* 0xb126 */
    OTHER,        /* 0xb127 */
    OTHER,        /* 0xb128 */
    OTHER,        /* 0xb129 */
    OTHER,        /* 0xb12a */
    OTHER,        /* 0xb12b */
    OTHER,        /* 0xb12c */
    OTHER,        /* 0xb12d */
    OTHER,        /* 0xb12e */
    OTHER,        /* 0xb12f */
    OTHER,        /* 0xb130 */
    OTHER,        /* 0xb131 */
    OTHER,        /* 0xb132 */
    OTHER,        /* 0xb133 */
    OTHER,        /* 0xb134 */
    OTHER,        /* 0xb135 */
    OTHER,        /* 0xb136 */
    OTHER,        /* 0xb137 */
    OTHER,        /* 0xb138 */
    OTHER,        /* 0xb139 */
    OTHER,        /* 0xb13a */
    OTHER,        /* 0xb13b */
    OTHER,        /* 0xb13c */
    OTHER,        /* 0xb13d */
    OTHER,        /* 0xb13e */
    OTHER,        /* 0xb13f */
    OTHER,        /* 0xb140 */
    OTHER,        /* 0xb141 */
    OTHER,        /* 0xb142 */
    OTHER,        /* 0xb143 */
    OTHER,        /* 0xb144 */
    OTHER,        /* 0xb145 */
    OTHER,        /* 0xb146 */
    OTHER,        /* 0xb147 */
    OTHER,        /* 0xb148 */
    OTHER,        /* 0xb149 */
    OTHER,        /* 0xb14a */
    OTHER,        /* 0xb14b */
    OTHER,        /* 0xb14c */
    OTHER,        /* 0xb14d */
    OTHER,        /* 0xb14e */
    OTHER,        /* 0xb14f */
    OTHER,        /* 0xb150 */
    OTHER,        /* 0xb151 */
    OTHER,        /* 0xb152 */
    OTHER,        /* 0xb153 */
    OTHER,        /* 0xb154 */
    OTHER,        /* 0xb155 */
    OTHER,        /* 0xb156 */
    OTHER,        /* 0xb157 */
    OTHER,        /* 0xb158 */
    OTHER,        /* 0xb159 */
    OTHER,        /* 0xb15a */
    OTHER,        /* 0xb15b */
    OTHER,        /* 0xb15c */
    OTHER,        /* 0xb15d */
    OTHER,        /* 0xb15e */
    OTHER,        /* 0xb15f */
    OTHER,        /* 0xb160 */
    OTHER,        /* 0xb161 */
    OTHER,        /* 0xb162 */
    OTHER,        /* 0xb163 */
    OTHER,        /* 0xb164 */
    OTHER,        /* 0xb165 */
    OTHER,        /* 0xb166 */
    OTHER,        /* 0xb167 */
    OTHER,        /* 0xb168 */
    OTHER,        /* 0xb169 */
    OTHER,        /* 0xb16a */
    OTHER,        /* 0xb16b */
    OTHER,        /* 0xb16c */
    OTHER,        /* 0xb16d */
    OTHER,        /* 0xb16e */
    OTHER,        /* 0xb16f */
    OTHER,        /* 0xb170 */
    OTHER,        /* 0xb171 */
    OTHER,        /* 0xb172 */
    OTHER,        /* 0xb173 */
    OTHER,        /* 0xb174 */
    OTHER,        /* 0xb175 */
    OTHER,        /* 0xb176 */
    OTHER,        /* 0xb177 */
    OTHER,        /* 0xb178 */
    OTHER,        /* 0xb179 */
    OTHER,        /* 0xb17a */
    OTHER,        /* 0xb17b */
    OTHER,        /* 0xb17c */
    OTHER,        /* 0xb17d */
    OTHER,        /* 0xb17e */
    OTHER,        /* 0xb17f */
    OTHER,        /* 0xb180 */
    OTHER,        /* 0xb181 */
    OTHER,        /* 0xb182 */
    OTHER,        /* 0xb183 */
    OTHER,        /* 0xb184 */
    OTHER,        /* 0xb185 */
    OTHER,        /* 0xb186 */
    OTHER,        /* 0xb187 */
    OTHER,        /* 0xb188 */
    OTHER,        /* 0xb189 */
    OTHER,        /* 0xb18a */
    OTHER,        /* 0xb18b */
    OTHER,        /* 0xb18c */
    OTHER,        /* 0xb18d */
    OTHER,        /* 0xb18e */
    OTHER,        /* 0xb18f */
    OTHER,        /* 0xb190 */
    OTHER,        /* 0xb191 */
    OTHER,        /* 0xb192 */
    OTHER,        /* 0xb193 */
    OTHER,        /* 0xb194 */
    OTHER,        /* 0xb195 */
    OTHER,        /* 0xb196 */
    OTHER,        /* 0xb197 */
    OTHER,        /* 0xb198 */
    OTHER,        /* 0xb199 */
    OTHER,        /* 0xb19a */
    OTHER,        /* 0xb19b */
    OTHER,        /* 0xb19c */
    OTHER,        /* 0xb19d */
    OTHER,        /* 0xb19e */
    OTHER,        /* 0xb19f */
    OTHER,        /* 0xb1a0 */
    OTHER,        /* 0xb1a1 */
    OTHER,        /* 0xb1a2 */
    OTHER,        /* 0xb1a3 */
    OTHER,        /* 0xb1a4 */
    OTHER,        /* 0xb1a5 */
    OTHER,        /* 0xb1a6 */
    OTHER,        /* 0xb1a7 */
    OTHER,        /* 0xb1a8 */
    OTHER,        /* 0xb1a9 */
    OTHER,        /* 0xb1aa */
    OTHER,        /* 0xb1ab */
    OTHER,        /* 0xb1ac */
    OTHER,        /* 0xb1ad */
    OTHER,        /* 0xb1ae */
    OTHER,        /* 0xb1af */
    OTHER,        /* 0xb1b0 */
    OTHER,        /* 0xb1b1 */
    OTHER,        /* 0xb1b2 */
    OTHER,        /* 0xb1b3 */
    OTHER,        /* 0xb1b4 */
    OTHER,        /* 0xb1b5 */
    OTHER,        /* 0xb1b6 */
    OTHER,        /* 0xb1b7 */
    OTHER,        /* 0xb1b8 */
    OTHER,        /* 0xb1b9 */
    OTHER,        /* 0xb1ba */
    OTHER,        /* 0xb1bb */
    OTHER,        /* 0xb1bc */
    OTHER,        /* 0xb1bd */
    OTHER,        /* 0xb1be */
    OTHER,        /* 0xb1bf */
    OTHER,        /* 0xb1c0 */
    OTHER,        /* 0xb1c1 */
    OTHER,        /* 0xb1c2 */
    OTHER,        /* 0xb1c3 */
    OTHER,        /* 0xb1c4 */
    OTHER,        /* 0xb1c5 */
    OTHER,        /* 0xb1c6 */
    OTHER,        /* 0xb1c7 */
    OTHER,        /* 0xb1c8 */
    OTHER,        /* 0xb1c9 */
    OTHER,        /* 0xb1ca */
    OTHER,        /* 0xb1cb */
    OTHER,        /* 0xb1cc */
    OTHER,        /* 0xb1cd */
    OTHER,        /* 0xb1ce */
    OTHER,        /* 0xb1cf */
    OTHER,        /* 0xb1d0 */
    OTHER,        /* 0xb1d1 */
    OTHER,        /* 0xb1d2 */
    OTHER,        /* 0xb1d3 */
    OTHER,        /* 0xb1d4 */
    OTHER,        /* 0xb1d5 */
    OTHER,        /* 0xb1d6 */
    OTHER,        /* 0xb1d7 */
    OTHER,        /* 0xb1d8 */
    OTHER,        /* 0xb1d9 */
    OTHER,        /* 0xb1da */
    OTHER,        /* 0xb1db */
    OTHER,        /* 0xb1dc */
    OTHER,        /* 0xb1dd */
    OTHER,        /* 0xb1de */
    OTHER,        /* 0xb1df */
    OTHER,        /* 0xb1e0 */
    OTHER,        /* 0xb1e1 */
    OTHER,        /* 0xb1e2 */
    OTHER,        /* 0xb1e3 */
    OTHER,        /* 0xb1e4 */
    OTHER,        /* 0xb1e5 */
    OTHER,        /* 0xb1e6 */
    OTHER,        /* 0xb1e7 */
    OTHER,        /* 0xb1e8 */
    OTHER,        /* 0xb1e9 */
    OTHER,        /* 0xb1ea */
    OTHER,        /* 0xb1eb */
    OTHER,        /* 0xb1ec */
    OTHER,        /* 0xb1ed */
    OTHER,        /* 0xb1ee */
    OTHER,        /* 0xb1ef */
    OTHER,        /* 0xb1f0 */
    OTHER,        /* 0xb1f1 */
    OTHER,        /* 0xb1f2 */
    OTHER,        /* 0xb1f3 */
    OTHER,        /* 0xb1f4 */
    OTHER,        /* 0xb1f5 */
    OTHER,        /* 0xb1f6 */
    OTHER,        /* 0xb1f7 */
    OTHER,        /* 0xb1f8 */
    OTHER,        /* 0xb1f9 */
    OTHER,        /* 0xb1fa */
    OTHER,        /* 0xb1fb */
    OTHER,        /* 0xb1fc */
    OTHER,        /* 0xb1fd */
    OTHER,        /* 0xb1fe */
    OTHER,        /* 0xb1ff */
    OTHER,        /* 0xb200 */
    OTHER,        /* 0xb201 */
    OTHER,        /* 0xb202 */
    OTHER,        /* 0xb203 */
    OTHER,        /* 0xb204 */
    OTHER,        /* 0xb205 */
    OTHER,        /* 0xb206 */
    OTHER,        /* 0xb207 */
    OTHER,        /* 0xb208 */
    OTHER,        /* 0xb209 */
    OTHER,        /* 0xb20a */
    OTHER,        /* 0xb20b */
    OTHER,        /* 0xb20c */
    OTHER,        /* 0xb20d */
    OTHER,        /* 0xb20e */
    OTHER,        /* 0xb20f */
    OTHER,        /* 0xb210 */
    OTHER,        /* 0xb211 */
    OTHER,        /* 0xb212 */
    OTHER,        /* 0xb213 */
    OTHER,        /* 0xb214 */
    OTHER,        /* 0xb215 */
    OTHER,        /* 0xb216 */
    OTHER,        /* 0xb217 */
    OTHER,        /* 0xb218 */
    OTHER,        /* 0xb219 */
    OTHER,        /* 0xb21a */
    OTHER,        /* 0xb21b */
    OTHER,        /* 0xb21c */
    OTHER,        /* 0xb21d */
    OTHER,        /* 0xb21e */
    OTHER,        /* 0xb21f */
    OTHER,        /* 0xb220 */
    OTHER,        /* 0xb221 */
    OTHER,        /* 0xb222 */
    OTHER,        /* 0xb223 */
    OTHER,        /* 0xb224 */
    OTHER,        /* 0xb225 */
    OTHER,        /* 0xb226 */
    OTHER,        /* 0xb227 */
    OTHER,        /* 0xb228 */
    OTHER,        /* 0xb229 */
    OTHER,        /* 0xb22a */
    OTHER,        /* 0xb22b */
    OTHER,        /* 0xb22c */
    OTHER,        /* 0xb22d */
    OTHER,        /* 0xb22e */
    OTHER,        /* 0xb22f */
    OTHER,        /* 0xb230 */
    OTHER,        /* 0xb231 */
    OTHER,        /* 0xb232 */
    OTHER,        /* 0xb233 */
    OTHER,        /* 0xb234 */
    OTHER,        /* 0xb235 */
    OTHER,        /* 0xb236 */
    OTHER,        /* 0xb237 */
    OTHER,        /* 0xb238 */
    OTHER,        /* 0xb239 */
    OTHER,        /* 0xb23a */
    OTHER,        /* 0xb23b */
    OTHER,        /* 0xb23c */
    OTHER,        /* 0xb23d */
    OTHER,        /* 0xb23e */
    OTHER,        /* 0xb23f */
    OTHER,        /* 0xb240 */
    OTHER,        /* 0xb241 */
    OTHER,        /* 0xb242 */
    OTHER,        /* 0xb243 */
    OTHER,        /* 0xb244 */
    OTHER,        /* 0xb245 */
    OTHER,        /* 0xb246 */
    OTHER,        /* 0xb247 */
    OTHER,        /* 0xb248 */
    OTHER,        /* 0xb249 */
    OTHER,        /* 0xb24a */
    OTHER,        /* 0xb24b */
    OTHER,        /* 0xb24c */
    OTHER,        /* 0xb24d */
    OTHER,        /* 0xb24e */
    OTHER,        /* 0xb24f */
    OTHER,        /* 0xb250 */
    OTHER,        /* 0xb251 */
    OTHER,        /* 0xb252 */
    OTHER,        /* 0xb253 */
    OTHER,        /* 0xb254 */
    OTHER,        /* 0xb255 */
    OTHER,        /* 0xb256 */
    OTHER,        /* 0xb257 */
    OTHER,        /* 0xb258 */
    OTHER,        /* 0xb259 */
    OTHER,        /* 0xb25a */
    OTHER,        /* 0xb25b */
    OTHER,        /* 0xb25c */
    OTHER,        /* 0xb25d */
    OTHER,        /* 0xb25e */
    OTHER,        /* 0xb25f */
    OTHER,        /* 0xb260 */
    OTHER,        /* 0xb261 */
    OTHER,        /* 0xb262 */
    OTHER,        /* 0xb263 */
    OTHER,        /* 0xb264 */
    OTHER,        /* 0xb265 */
    OTHER,        /* 0xb266 */
    OTHER,        /* 0xb267 */
    OTHER,        /* 0xb268 */
    OTHER,        /* 0xb269 */
    OTHER,        /* 0xb26a */
    OTHER,        /* 0xb26b */
    OTHER,        /* 0xb26c */
    OTHER,        /* 0xb26d */
    OTHER,        /* 0xb26e */
    OTHER,        /* 0xb26f */
    OTHER,        /* 0xb270 */
    OTHER,        /* 0xb271 */
    OTHER,        /* 0xb272 */
    OTHER,        /* 0xb273 */
    OTHER,        /* 0xb274 */
    OTHER,        /* 0xb275 */
    OTHER,        /* 0xb276 */
    OTHER,        /* 0xb277 */
    OTHER,        /* 0xb278 */
    OTHER,        /* 0xb279 */
    OTHER,        /* 0xb27a */
    OTHER,        /* 0xb27b */
    OTHER,        /* 0xb27c */
    OTHER,        /* 0xb27d */
    OTHER,        /* 0xb27e */
    OTHER,        /* 0xb27f */
    OTHER,        /* 0xb280 */
    OTHER,        /* 0xb281 */
    OTHER,        /* 0xb282 */
    OTHER,        /* 0xb283 */
    OTHER,        /* 0xb284 */
    OTHER,        /* 0xb285 */
    OTHER,        /* 0xb286 */
    OTHER,        /* 0xb287 */
    OTHER,        /* 0xb288 */
    OTHER,        /* 0xb289 */
    OTHER,        /* 0xb28a */
    OTHER,        /* 0xb28b */
    OTHER,        /* 0xb28c */
    OTHER,        /* 0xb28d */
    OTHER,        /* 0xb28e */
    OTHER,        /* 0xb28f */
    OTHER,        /* 0xb290 */
    OTHER,        /* 0xb291 */
    OTHER,        /* 0xb292 */
    OTHER,        /* 0xb293 */
    OTHER,        /* 0xb294 */
    OTHER,        /* 0xb295 */
    OTHER,        /* 0xb296 */
    OTHER,        /* 0xb297 */
    OTHER,        /* 0xb298 */
    OTHER,        /* 0xb299 */
    OTHER,        /* 0xb29a */
    OTHER,        /* 0xb29b */
    OTHER,        /* 0xb29c */
    OTHER,        /* 0xb29d */
    OTHER,        /* 0xb29e */
    OTHER,        /* 0xb29f */
    OTHER,        /* 0xb2a0 */
    OTHER,        /* 0xb2a1 */
    OTHER,        /* 0xb2a2 */
    OTHER,        /* 0xb2a3 */
    OTHER,        /* 0xb2a4 */
    OTHER,        /* 0xb2a5 */
    OTHER,        /* 0xb2a6 */
    OTHER,        /* 0xb2a7 */
    OTHER,        /* 0xb2a8 */
    OTHER,        /* 0xb2a9 */
    OTHER,        /* 0xb2aa */
    OTHER,        /* 0xb2ab */
    OTHER,        /* 0xb2ac */
    OTHER,        /* 0xb2ad */
    OTHER,        /* 0xb2ae */
    OTHER,        /* 0xb2af */
    OTHER,        /* 0xb2b0 */
    OTHER,        /* 0xb2b1 */
    OTHER,        /* 0xb2b2 */
    OTHER,        /* 0xb2b3 */
    OTHER,        /* 0xb2b4 */
    OTHER,        /* 0xb2b5 */
    OTHER,        /* 0xb2b6 */
    OTHER,        /* 0xb2b7 */
    OTHER,        /* 0xb2b8 */
    OTHER,        /* 0xb2b9 */
    OTHER,        /* 0xb2ba */
    OTHER,        /* 0xb2bb */
    OTHER,        /* 0xb2bc */
    OTHER,        /* 0xb2bd */
    OTHER,        /* 0xb2be */
    OTHER,        /* 0xb2bf */
    OTHER,        /* 0xb2c0 */
    OTHER,        /* 0xb2c1 */
    OTHER,        /* 0xb2c2 */
    OTHER,        /* 0xb2c3 */
    OTHER,        /* 0xb2c4 */
    OTHER,        /* 0xb2c5 */
    OTHER,        /* 0xb2c6 */
    OTHER,        /* 0xb2c7 */
    OTHER,        /* 0xb2c8 */
    OTHER,        /* 0xb2c9 */
    OTHER,        /* 0xb2ca */
    OTHER,        /* 0xb2cb */
    OTHER,        /* 0xb2cc */
    OTHER,        /* 0xb2cd */
    OTHER,        /* 0xb2ce */
    OTHER,        /* 0xb2cf */
    OTHER,        /* 0xb2d0 */
    OTHER,        /* 0xb2d1 */
    OTHER,        /* 0xb2d2 */
    OTHER,        /* 0xb2d3 */
    OTHER,        /* 0xb2d4 */
    OTHER,        /* 0xb2d5 */
    OTHER,        /* 0xb2d6 */
    OTHER,        /* 0xb2d7 */
    OTHER,        /* 0xb2d8 */
    OTHER,        /* 0xb2d9 */
    OTHER,        /* 0xb2da */
    OTHER,        /* 0xb2db */
    OTHER,        /* 0xb2dc */
    OTHER,        /* 0xb2dd */
    OTHER,        /* 0xb2de */
    OTHER,        /* 0xb2df */
    OTHER,        /* 0xb2e0 */
    OTHER,        /* 0xb2e1 */
    OTHER,        /* 0xb2e2 */
    OTHER,        /* 0xb2e3 */
    OTHER,        /* 0xb2e4 */
    OTHER,        /* 0xb2e5 */
    OTHER,        /* 0xb2e6 */
    OTHER,        /* 0xb2e7 */
    OTHER,        /* 0xb2e8 */
    OTHER,        /* 0xb2e9 */
    OTHER,        /* 0xb2ea */
    OTHER,        /* 0xb2eb */
    OTHER,        /* 0xb2ec */
    OTHER,        /* 0xb2ed */
    OTHER,        /* 0xb2ee */
    OTHER,        /* 0xb2ef */
    OTHER,        /* 0xb2f0 */
    OTHER,        /* 0xb2f1 */
    OTHER,        /* 0xb2f2 */
    OTHER,        /* 0xb2f3 */
    OTHER,        /* 0xb2f4 */
    OTHER,        /* 0xb2f5 */
    OTHER,        /* 0xb2f6 */
    OTHER,        /* 0xb2f7 */
    OTHER,        /* 0xb2f8 */
    OTHER,        /* 0xb2f9 */
    OTHER,        /* 0xb2fa */
    OTHER,        /* 0xb2fb */
    OTHER,        /* 0xb2fc */
    OTHER,        /* 0xb2fd */
    OTHER,        /* 0xb2fe */
    OTHER,        /* 0xb2ff */
    OTHER,        /* 0xb300 */
    OTHER,        /* 0xb301 */
    OTHER,        /* 0xb302 */
    OTHER,        /* 0xb303 */
    OTHER,        /* 0xb304 */
    OTHER,        /* 0xb305 */
    OTHER,        /* 0xb306 */
    OTHER,        /* 0xb307 */
    OTHER,        /* 0xb308 */
    OTHER,        /* 0xb309 */
    OTHER,        /* 0xb30a */
    OTHER,        /* 0xb30b */
    OTHER,        /* 0xb30c */
    OTHER,        /* 0xb30d */
    OTHER,        /* 0xb30e */
    OTHER,        /* 0xb30f */
    OTHER,        /* 0xb310 */
    OTHER,        /* 0xb311 */
    OTHER,        /* 0xb312 */
    OTHER,        /* 0xb313 */
    OTHER,        /* 0xb314 */
    OTHER,        /* 0xb315 */
    OTHER,        /* 0xb316 */
    OTHER,        /* 0xb317 */
    OTHER,        /* 0xb318 */
    OTHER,        /* 0xb319 */
    OTHER,        /* 0xb31a */
    OTHER,        /* 0xb31b */
    OTHER,        /* 0xb31c */
    OTHER,        /* 0xb31d */
    OTHER,        /* 0xb31e */
    OTHER,        /* 0xb31f */
    OTHER,        /* 0xb320 */
    OTHER,        /* 0xb321 */
    OTHER,        /* 0xb322 */
    OTHER,        /* 0xb323 */
    OTHER,        /* 0xb324 */
    OTHER,        /* 0xb325 */
    OTHER,        /* 0xb326 */
    OTHER,        /* 0xb327 */
    OTHER,        /* 0xb328 */
    OTHER,        /* 0xb329 */
    OTHER,        /* 0xb32a */
    OTHER,        /* 0xb32b */
    OTHER,        /* 0xb32c */
    OTHER,        /* 0xb32d */
    OTHER,        /* 0xb32e */
    OTHER,        /* 0xb32f */
    OTHER,        /* 0xb330 */
    OTHER,        /* 0xb331 */
    OTHER,        /* 0xb332 */
    OTHER,        /* 0xb333 */
    OTHER,        /* 0xb334 */
    OTHER,        /* 0xb335 */
    OTHER,        /* 0xb336 */
    OTHER,        /* 0xb337 */
    OTHER,        /* 0xb338 */
    OTHER,        /* 0xb339 */
    OTHER,        /* 0xb33a */
    OTHER,        /* 0xb33b */
    OTHER,        /* 0xb33c */
    OTHER,        /* 0xb33d */
    OTHER,        /* 0xb33e */
    OTHER,        /* 0xb33f */
    OTHER,        /* 0xb340 */
    OTHER,        /* 0xb341 */
    OTHER,        /* 0xb342 */
    OTHER,        /* 0xb343 */
    OTHER,        /* 0xb344 */
    OTHER,        /* 0xb345 */
    OTHER,        /* 0xb346 */
    OTHER,        /* 0xb347 */
    OTHER,        /* 0xb348 */
    OTHER,        /* 0xb349 */
    OTHER,        /* 0xb34a */
    OTHER,        /* 0xb34b */
    OTHER,        /* 0xb34c */
    OTHER,        /* 0xb34d */
    OTHER,        /* 0xb34e */
    OTHER,        /* 0xb34f */
    OTHER,        /* 0xb350 */
    OTHER,        /* 0xb351 */
    OTHER,        /* 0xb352 */
    OTHER,        /* 0xb353 */
    OTHER,        /* 0xb354 */
    OTHER,        /* 0xb355 */
    OTHER,        /* 0xb356 */
    OTHER,        /* 0xb357 */
    OTHER,        /* 0xb358 */
    OTHER,        /* 0xb359 */
    OTHER,        /* 0xb35a */
    OTHER,        /* 0xb35b */
    OTHER,        /* 0xb35c */
    OTHER,        /* 0xb35d */
    OTHER,        /* 0xb35e */
    OTHER,        /* 0xb35f */
    OTHER,        /* 0xb360 */
    OTHER,        /* 0xb361 */
    OTHER,        /* 0xb362 */
    OTHER,        /* 0xb363 */
    OTHER,        /* 0xb364 */
    OTHER,        /* 0xb365 */
    OTHER,        /* 0xb366 */
    OTHER,        /* 0xb367 */
    OTHER,        /* 0xb368 */
    OTHER,        /* 0xb369 */
    OTHER,        /* 0xb36a */
    OTHER,        /* 0xb36b */
    OTHER,        /* 0xb36c */
    OTHER,        /* 0xb36d */
    OTHER,        /* 0xb36e */
    OTHER,        /* 0xb36f */
    OTHER,        /* 0xb370 */
    OTHER,        /* 0xb371 */
    OTHER,        /* 0xb372 */
    OTHER,        /* 0xb373 */
    OTHER,        /* 0xb374 */
    OTHER,        /* 0xb375 */
    OTHER,        /* 0xb376 */
    OTHER,        /* 0xb377 */
    OTHER,        /* 0xb378 */
    OTHER,        /* 0xb379 */
    OTHER,        /* 0xb37a */
    OTHER,        /* 0xb37b */
    OTHER,        /* 0xb37c */
    OTHER,        /* 0xb37d */
    OTHER,        /* 0xb37e */
    OTHER,        /* 0xb37f */
    OTHER,        /* 0xb380 */
    OTHER,        /* 0xb381 */
    OTHER,        /* 0xb382 */
    OTHER,        /* 0xb383 */
    OTHER,        /* 0xb384 */
    OTHER,        /* 0xb385 */
    OTHER,        /* 0xb386 */
    OTHER,        /* 0xb387 */
    OTHER,        /* 0xb388 */
    OTHER,        /* 0xb389 */
    OTHER,        /* 0xb38a */
    OTHER,        /* 0xb38b */
    OTHER,        /* 0xb38c */
    OTHER,        /* 0xb38d */
    OTHER,        /* 0xb38e */
    OTHER,        /* 0xb38f */
    OTHER,        /* 0xb390 */
    OTHER,        /* 0xb391 */
    OTHER,        /* 0xb392 */
    OTHER,        /* 0xb393 */
    OTHER,        /* 0xb394 */
    OTHER,        /* 0xb395 */
    OTHER,        /* 0xb396 */
    OTHER,        /* 0xb397 */
    OTHER,        /* 0xb398 */
    OTHER,        /* 0xb399 */
    OTHER,        /* 0xb39a */
    OTHER,        /* 0xb39b */
    OTHER,        /* 0xb39c */
    OTHER,        /* 0xb39d */
    OTHER,        /* 0xb39e */
    OTHER,        /* 0xb39f */
    OTHER,        /* 0xb3a0 */
    OTHER,        /* 0xb3a1 */
    OTHER,        /* 0xb3a2 */
    OTHER,        /* 0xb3a3 */
    OTHER,        /* 0xb3a4 */
    OTHER,        /* 0xb3a5 */
    OTHER,        /* 0xb3a6 */
    OTHER,        /* 0xb3a7 */
    OTHER,        /* 0xb3a8 */
    OTHER,        /* 0xb3a9 */
    OTHER,        /* 0xb3aa */
    OTHER,        /* 0xb3ab */
    OTHER,        /* 0xb3ac */
    OTHER,        /* 0xb3ad */
    OTHER,        /* 0xb3ae */
    OTHER,        /* 0xb3af */
    OTHER,        /* 0xb3b0 */
    OTHER,        /* 0xb3b1 */
    OTHER,        /* 0xb3b2 */
    OTHER,        /* 0xb3b3 */
    OTHER,        /* 0xb3b4 */
    OTHER,        /* 0xb3b5 */
    OTHER,        /* 0xb3b6 */
    OTHER,        /* 0xb3b7 */
    OTHER,        /* 0xb3b8 */
    OTHER,        /* 0xb3b9 */
    OTHER,        /* 0xb3ba */
    OTHER,        /* 0xb3bb */
    OTHER,        /* 0xb3bc */
    OTHER,        /* 0xb3bd */
    OTHER,        /* 0xb3be */
    OTHER,        /* 0xb3bf */
    OTHER,        /* 0xb3c0 */
    OTHER,        /* 0xb3c1 */
    OTHER,        /* 0xb3c2 */
    OTHER,        /* 0xb3c3 */
    OTHER,        /* 0xb3c4 */
    OTHER,        /* 0xb3c5 */
    OTHER,        /* 0xb3c6 */
    OTHER,        /* 0xb3c7 */
    OTHER,        /* 0xb3c8 */
    OTHER,        /* 0xb3c9 */
    OTHER,        /* 0xb3ca */
    OTHER,        /* 0xb3cb */
    OTHER,        /* 0xb3cc */
    OTHER,        /* 0xb3cd */
    OTHER,        /* 0xb3ce */
    OTHER,        /* 0xb3cf */
    OTHER,        /* 0xb3d0 */
    OTHER,        /* 0xb3d1 */
    OTHER,        /* 0xb3d2 */
    OTHER,        /* 0xb3d3 */
    OTHER,        /* 0xb3d4 */
    OTHER,        /* 0xb3d5 */
    OTHER,        /* 0xb3d6 */
    OTHER,        /* 0xb3d7 */
    OTHER,        /* 0xb3d8 */
    OTHER,        /* 0xb3d9 */
    OTHER,        /* 0xb3da */
    OTHER,        /* 0xb3db */
    OTHER,        /* 0xb3dc */
    OTHER,        /* 0xb3dd */
    OTHER,        /* 0xb3de */
    OTHER,        /* 0xb3df */
    OTHER,        /* 0xb3e0 */
    OTHER,        /* 0xb3e1 */
    OTHER,        /* 0xb3e2 */
    OTHER,        /* 0xb3e3 */
    OTHER,        /* 0xb3e4 */
    OTHER,        /* 0xb3e5 */
    OTHER,        /* 0xb3e6 */
    OTHER,        /* 0xb3e7 */
    OTHER,        /* 0xb3e8 */
    OTHER,        /* 0xb3e9 */
    OTHER,        /* 0xb3ea */
    OTHER,        /* 0xb3eb */
    OTHER,        /* 0xb3ec */
    OTHER,        /* 0xb3ed */
    OTHER,        /* 0xb3ee */
    OTHER,        /* 0xb3ef */
    OTHER,        /* 0xb3f0 */
    OTHER,        /* 0xb3f1 */
    OTHER,        /* 0xb3f2 */
    OTHER,        /* 0xb3f3 */
    OTHER,        /* 0xb3f4 */
    OTHER,        /* 0xb3f5 */
    OTHER,        /* 0xb3f6 */
    OTHER,        /* 0xb3f7 */
    OTHER,        /* 0xb3f8 */
    OTHER,        /* 0xb3f9 */
    OTHER,        /* 0xb3fa */
    OTHER,        /* 0xb3fb */
    OTHER,        /* 0xb3fc */
    OTHER,        /* 0xb3fd */
    OTHER,        /* 0xb3fe */
    OTHER,        /* 0xb3ff */
    OTHER,        /* 0xb400 */
    OTHER,        /* 0xb401 */
    OTHER,        /* 0xb402 */
    OTHER,        /* 0xb403 */
    OTHER,        /* 0xb404 */
    OTHER,        /* 0xb405 */
    OTHER,        /* 0xb406 */
    OTHER,        /* 0xb407 */
    OTHER,        /* 0xb408 */
    OTHER,        /* 0xb409 */
    OTHER,        /* 0xb40a */
    OTHER,        /* 0xb40b */
    OTHER,        /* 0xb40c */
    OTHER,        /* 0xb40d */
    OTHER,        /* 0xb40e */
    OTHER,        /* 0xb40f */
    OTHER,        /* 0xb410 */
    OTHER,        /* 0xb411 */
    OTHER,        /* 0xb412 */
    OTHER,        /* 0xb413 */
    OTHER,        /* 0xb414 */
    OTHER,        /* 0xb415 */
    OTHER,        /* 0xb416 */
    OTHER,        /* 0xb417 */
    OTHER,        /* 0xb418 */
    OTHER,        /* 0xb419 */
    OTHER,        /* 0xb41a */
    OTHER,        /* 0xb41b */
    OTHER,        /* 0xb41c */
    OTHER,        /* 0xb41d */
    OTHER,        /* 0xb41e */
    OTHER,        /* 0xb41f */
    OTHER,        /* 0xb420 */
    OTHER,        /* 0xb421 */
    OTHER,        /* 0xb422 */
    OTHER,        /* 0xb423 */
    OTHER,        /* 0xb424 */
    OTHER,        /* 0xb425 */
    OTHER,        /* 0xb426 */
    OTHER,        /* 0xb427 */
    OTHER,        /* 0xb428 */
    OTHER,        /* 0xb429 */
    OTHER,        /* 0xb42a */
    OTHER,        /* 0xb42b */
    OTHER,        /* 0xb42c */
    OTHER,        /* 0xb42d */
    OTHER,        /* 0xb42e */
    OTHER,        /* 0xb42f */
    OTHER,        /* 0xb430 */
    OTHER,        /* 0xb431 */
    OTHER,        /* 0xb432 */
    OTHER,        /* 0xb433 */
    OTHER,        /* 0xb434 */
    OTHER,        /* 0xb435 */
    OTHER,        /* 0xb436 */
    OTHER,        /* 0xb437 */
    OTHER,        /* 0xb438 */
    OTHER,        /* 0xb439 */
    OTHER,        /* 0xb43a */
    OTHER,        /* 0xb43b */
    OTHER,        /* 0xb43c */
    OTHER,        /* 0xb43d */
    OTHER,        /* 0xb43e */
    OTHER,        /* 0xb43f */
    OTHER,        /* 0xb440 */
    OTHER,        /* 0xb441 */
    OTHER,        /* 0xb442 */
    OTHER,        /* 0xb443 */
    OTHER,        /* 0xb444 */
    OTHER,        /* 0xb445 */
    OTHER,        /* 0xb446 */
    OTHER,        /* 0xb447 */
    OTHER,        /* 0xb448 */
    OTHER,        /* 0xb449 */
    OTHER,        /* 0xb44a */
    OTHER,        /* 0xb44b */
    OTHER,        /* 0xb44c */
    OTHER,        /* 0xb44d */
    OTHER,        /* 0xb44e */
    OTHER,        /* 0xb44f */
    OTHER,        /* 0xb450 */
    OTHER,        /* 0xb451 */
    OTHER,        /* 0xb452 */
    OTHER,        /* 0xb453 */
    OTHER,        /* 0xb454 */
    OTHER,        /* 0xb455 */
    OTHER,        /* 0xb456 */
    OTHER,        /* 0xb457 */
    OTHER,        /* 0xb458 */
    OTHER,        /* 0xb459 */
    OTHER,        /* 0xb45a */
    OTHER,        /* 0xb45b */
    OTHER,        /* 0xb45c */
    OTHER,        /* 0xb45d */
    OTHER,        /* 0xb45e */
    OTHER,        /* 0xb45f */
    OTHER,        /* 0xb460 */
    OTHER,        /* 0xb461 */
    OTHER,        /* 0xb462 */
    OTHER,        /* 0xb463 */
    OTHER,        /* 0xb464 */
    OTHER,        /* 0xb465 */
    OTHER,        /* 0xb466 */
    OTHER,        /* 0xb467 */
    OTHER,        /* 0xb468 */
    OTHER,        /* 0xb469 */
    OTHER,        /* 0xb46a */
    OTHER,        /* 0xb46b */
    OTHER,        /* 0xb46c */
    OTHER,        /* 0xb46d */
    OTHER,        /* 0xb46e */
    OTHER,        /* 0xb46f */
    OTHER,        /* 0xb470 */
    OTHER,        /* 0xb471 */
    OTHER,        /* 0xb472 */
    OTHER,        /* 0xb473 */
    OTHER,        /* 0xb474 */
    OTHER,        /* 0xb475 */
    OTHER,        /* 0xb476 */
    OTHER,        /* 0xb477 */
    OTHER,        /* 0xb478 */
    OTHER,        /* 0xb479 */
    OTHER,        /* 0xb47a */
    OTHER,        /* 0xb47b */
    OTHER,        /* 0xb47c */
    OTHER,        /* 0xb47d */
    OTHER,        /* 0xb47e */
    OTHER,        /* 0xb47f */
    OTHER,        /* 0xb480 */
    OTHER,        /* 0xb481 */
    OTHER,        /* 0xb482 */
    OTHER,        /* 0xb483 */
    OTHER,        /* 0xb484 */
    OTHER,        /* 0xb485 */
    OTHER,        /* 0xb486 */
    OTHER,        /* 0xb487 */
    OTHER,        /* 0xb488 */
    OTHER,        /* 0xb489 */
    OTHER,        /* 0xb48a */
    OTHER,        /* 0xb48b */
    OTHER,        /* 0xb48c */
    OTHER,        /* 0xb48d */
    OTHER,        /* 0xb48e */
    OTHER,        /* 0xb48f */
    OTHER,        /* 0xb490 */
    OTHER,        /* 0xb491 */
    OTHER,        /* 0xb492 */
    OTHER,        /* 0xb493 */
    OTHER,        /* 0xb494 */
    OTHER,        /* 0xb495 */
    OTHER,        /* 0xb496 */
    OTHER,        /* 0xb497 */
    OTHER,        /* 0xb498 */
    OTHER,        /* 0xb499 */
    OTHER,        /* 0xb49a */
    OTHER,        /* 0xb49b */
    OTHER,        /* 0xb49c */
    OTHER,        /* 0xb49d */
    OTHER,        /* 0xb49e */
    OTHER,        /* 0xb49f */
    OTHER,        /* 0xb4a0 */
    OTHER,        /* 0xb4a1 */
    OTHER,        /* 0xb4a2 */
    OTHER,        /* 0xb4a3 */
    OTHER,        /* 0xb4a4 */
    OTHER,        /* 0xb4a5 */
    OTHER,        /* 0xb4a6 */
    OTHER,        /* 0xb4a7 */
    OTHER,        /* 0xb4a8 */
    OTHER,        /* 0xb4a9 */
    OTHER,        /* 0xb4aa */
    OTHER,        /* 0xb4ab */
    OTHER,        /* 0xb4ac */
    OTHER,        /* 0xb4ad */
    OTHER,        /* 0xb4ae */
    OTHER,        /* 0xb4af */
    OTHER,        /* 0xb4b0 */
    OTHER,        /* 0xb4b1 */
    OTHER,        /* 0xb4b2 */
    OTHER,        /* 0xb4b3 */
    OTHER,        /* 0xb4b4 */
    OTHER,        /* 0xb4b5 */
    OTHER,        /* 0xb4b6 */
    OTHER,        /* 0xb4b7 */
    OTHER,        /* 0xb4b8 */
    OTHER,        /* 0xb4b9 */
    OTHER,        /* 0xb4ba */
    OTHER,        /* 0xb4bb */
    OTHER,        /* 0xb4bc */
    OTHER,        /* 0xb4bd */
    OTHER,        /* 0xb4be */
    OTHER,        /* 0xb4bf */
    OTHER,        /* 0xb4c0 */
    OTHER,        /* 0xb4c1 */
    OTHER,        /* 0xb4c2 */
    OTHER,        /* 0xb4c3 */
    OTHER,        /* 0xb4c4 */
    OTHER,        /* 0xb4c5 */
    OTHER,        /* 0xb4c6 */
    OTHER,        /* 0xb4c7 */
    OTHER,        /* 0xb4c8 */
    OTHER,        /* 0xb4c9 */
    OTHER,        /* 0xb4ca */
    OTHER,        /* 0xb4cb */
    OTHER,        /* 0xb4cc */
    OTHER,        /* 0xb4cd */
    OTHER,        /* 0xb4ce */
    OTHER,        /* 0xb4cf */
    OTHER,        /* 0xb4d0 */
    OTHER,        /* 0xb4d1 */
    OTHER,        /* 0xb4d2 */
    OTHER,        /* 0xb4d3 */
    OTHER,        /* 0xb4d4 */
    OTHER,        /* 0xb4d5 */
    OTHER,        /* 0xb4d6 */
    OTHER,        /* 0xb4d7 */
    OTHER,        /* 0xb4d8 */
    OTHER,        /* 0xb4d9 */
    OTHER,        /* 0xb4da */
    OTHER,        /* 0xb4db */
    OTHER,        /* 0xb4dc */
    OTHER,        /* 0xb4dd */
    OTHER,        /* 0xb4de */
    OTHER,        /* 0xb4df */
    OTHER,        /* 0xb4e0 */
    OTHER,        /* 0xb4e1 */
    OTHER,        /* 0xb4e2 */
    OTHER,        /* 0xb4e3 */
    OTHER,        /* 0xb4e4 */
    OTHER,        /* 0xb4e5 */
    OTHER,        /* 0xb4e6 */
    OTHER,        /* 0xb4e7 */
    OTHER,        /* 0xb4e8 */
    OTHER,        /* 0xb4e9 */
    OTHER,        /* 0xb4ea */
    OTHER,        /* 0xb4eb */
    OTHER,        /* 0xb4ec */
    OTHER,        /* 0xb4ed */
    OTHER,        /* 0xb4ee */
    OTHER,        /* 0xb4ef */
    OTHER,        /* 0xb4f0 */
    OTHER,        /* 0xb4f1 */
    OTHER,        /* 0xb4f2 */
    OTHER,        /* 0xb4f3 */
    OTHER,        /* 0xb4f4 */
    OTHER,        /* 0xb4f5 */
    OTHER,        /* 0xb4f6 */
    OTHER,        /* 0xb4f7 */
    OTHER,        /* 0xb4f8 */
    OTHER,        /* 0xb4f9 */
    OTHER,        /* 0xb4fa */
    OTHER,        /* 0xb4fb */
    OTHER,        /* 0xb4fc */
    OTHER,        /* 0xb4fd */
    OTHER,        /* 0xb4fe */
    OTHER,        /* 0xb4ff */
    OTHER,        /* 0xb500 */
    OTHER,        /* 0xb501 */
    OTHER,        /* 0xb502 */
    OTHER,        /* 0xb503 */
    OTHER,        /* 0xb504 */
    OTHER,        /* 0xb505 */
    OTHER,        /* 0xb506 */
    OTHER,        /* 0xb507 */
    OTHER,        /* 0xb508 */
    OTHER,        /* 0xb509 */
    OTHER,        /* 0xb50a */
    OTHER,        /* 0xb50b */
    OTHER,        /* 0xb50c */
    OTHER,        /* 0xb50d */
    OTHER,        /* 0xb50e */
    OTHER,        /* 0xb50f */
    OTHER,        /* 0xb510 */
    OTHER,        /* 0xb511 */
    OTHER,        /* 0xb512 */
    OTHER,        /* 0xb513 */
    OTHER,        /* 0xb514 */
    OTHER,        /* 0xb515 */
    OTHER,        /* 0xb516 */
    OTHER,        /* 0xb517 */
    OTHER,        /* 0xb518 */
    OTHER,        /* 0xb519 */
    OTHER,        /* 0xb51a */
    OTHER,        /* 0xb51b */
    OTHER,        /* 0xb51c */
    OTHER,        /* 0xb51d */
    OTHER,        /* 0xb51e */
    OTHER,        /* 0xb51f */
    OTHER,        /* 0xb520 */
    OTHER,        /* 0xb521 */
    OTHER,        /* 0xb522 */
    OTHER,        /* 0xb523 */
    OTHER,        /* 0xb524 */
    OTHER,        /* 0xb525 */
    OTHER,        /* 0xb526 */
    OTHER,        /* 0xb527 */
    OTHER,        /* 0xb528 */
    OTHER,        /* 0xb529 */
    OTHER,        /* 0xb52a */
    OTHER,        /* 0xb52b */
    OTHER,        /* 0xb52c */
    OTHER,        /* 0xb52d */
    OTHER,        /* 0xb52e */
    OTHER,        /* 0xb52f */
    OTHER,        /* 0xb530 */
    OTHER,        /* 0xb531 */
    OTHER,        /* 0xb532 */
    OTHER,        /* 0xb533 */
    OTHER,        /* 0xb534 */
    OTHER,        /* 0xb535 */
    OTHER,        /* 0xb536 */
    OTHER,        /* 0xb537 */
    OTHER,        /* 0xb538 */
    OTHER,        /* 0xb539 */
    OTHER,        /* 0xb53a */
    OTHER,        /* 0xb53b */
    OTHER,        /* 0xb53c */
    OTHER,        /* 0xb53d */
    OTHER,        /* 0xb53e */
    OTHER,        /* 0xb53f */
    OTHER,        /* 0xb540 */
    OTHER,        /* 0xb541 */
    OTHER,        /* 0xb542 */
    OTHER,        /* 0xb543 */
    OTHER,        /* 0xb544 */
    OTHER,        /* 0xb545 */
    OTHER,        /* 0xb546 */
    OTHER,        /* 0xb547 */
    OTHER,        /* 0xb548 */
    OTHER,        /* 0xb549 */
    OTHER,        /* 0xb54a */
    OTHER,        /* 0xb54b */
    OTHER,        /* 0xb54c */
    OTHER,        /* 0xb54d */
    OTHER,        /* 0xb54e */
    OTHER,        /* 0xb54f */
    OTHER,        /* 0xb550 */
    OTHER,        /* 0xb551 */
    OTHER,        /* 0xb552 */
    OTHER,        /* 0xb553 */
    OTHER,        /* 0xb554 */
    OTHER,        /* 0xb555 */
    OTHER,        /* 0xb556 */
    OTHER,        /* 0xb557 */
    OTHER,        /* 0xb558 */
    OTHER,        /* 0xb559 */
    OTHER,        /* 0xb55a */
    OTHER,        /* 0xb55b */
    OTHER,        /* 0xb55c */
    OTHER,        /* 0xb55d */
    OTHER,        /* 0xb55e */
    OTHER,        /* 0xb55f */
    OTHER,        /* 0xb560 */
    OTHER,        /* 0xb561 */
    OTHER,        /* 0xb562 */
    OTHER,        /* 0xb563 */
    OTHER,        /* 0xb564 */
    OTHER,        /* 0xb565 */
    OTHER,        /* 0xb566 */
    OTHER,        /* 0xb567 */
    OTHER,        /* 0xb568 */
    OTHER,        /* 0xb569 */
    OTHER,        /* 0xb56a */
    OTHER,        /* 0xb56b */
    OTHER,        /* 0xb56c */
    OTHER,        /* 0xb56d */
    OTHER,        /* 0xb56e */
    OTHER,        /* 0xb56f */
    OTHER,        /* 0xb570 */
    OTHER,        /* 0xb571 */
    OTHER,        /* 0xb572 */
    OTHER,        /* 0xb573 */
    OTHER,        /* 0xb574 */
    OTHER,        /* 0xb575 */
    OTHER,        /* 0xb576 */
    OTHER,        /* 0xb577 */
    OTHER,        /* 0xb578 */
    OTHER,        /* 0xb579 */
    OTHER,        /* 0xb57a */
    OTHER,        /* 0xb57b */
    OTHER,        /* 0xb57c */
    OTHER,        /* 0xb57d */
    OTHER,        /* 0xb57e */
    OTHER,        /* 0xb57f */
    OTHER,        /* 0xb580 */
    OTHER,        /* 0xb581 */
    OTHER,        /* 0xb582 */
    OTHER,        /* 0xb583 */
    OTHER,        /* 0xb584 */
    OTHER,        /* 0xb585 */
    OTHER,        /* 0xb586 */
    OTHER,        /* 0xb587 */
    OTHER,        /* 0xb588 */
    OTHER,        /* 0xb589 */
    OTHER,        /* 0xb58a */
    OTHER,        /* 0xb58b */
    OTHER,        /* 0xb58c */
    OTHER,        /* 0xb58d */
    OTHER,        /* 0xb58e */
    OTHER,        /* 0xb58f */
    OTHER,        /* 0xb590 */
    OTHER,        /* 0xb591 */
    OTHER,        /* 0xb592 */
    OTHER,        /* 0xb593 */
    OTHER,        /* 0xb594 */
    OTHER,        /* 0xb595 */
    OTHER,        /* 0xb596 */
    OTHER,        /* 0xb597 */
    OTHER,        /* 0xb598 */
    OTHER,        /* 0xb599 */
    OTHER,        /* 0xb59a */
    OTHER,        /* 0xb59b */
    OTHER,        /* 0xb59c */
    OTHER,        /* 0xb59d */
    OTHER,        /* 0xb59e */
    OTHER,        /* 0xb59f */
    OTHER,        /* 0xb5a0 */
    OTHER,        /* 0xb5a1 */
    OTHER,        /* 0xb5a2 */
    OTHER,        /* 0xb5a3 */
    OTHER,        /* 0xb5a4 */
    OTHER,        /* 0xb5a5 */
    OTHER,        /* 0xb5a6 */
    OTHER,        /* 0xb5a7 */
    OTHER,        /* 0xb5a8 */
    OTHER,        /* 0xb5a9 */
    OTHER,        /* 0xb5aa */
    OTHER,        /* 0xb5ab */
    OTHER,        /* 0xb5ac */
    OTHER,        /* 0xb5ad */
    OTHER,        /* 0xb5ae */
    OTHER,        /* 0xb5af */
    OTHER,        /* 0xb5b0 */
    OTHER,        /* 0xb5b1 */
    OTHER,        /* 0xb5b2 */
    OTHER,        /* 0xb5b3 */
    OTHER,        /* 0xb5b4 */
    OTHER,        /* 0xb5b5 */
    OTHER,        /* 0xb5b6 */
    OTHER,        /* 0xb5b7 */
    OTHER,        /* 0xb5b8 */
    OTHER,        /* 0xb5b9 */
    OTHER,        /* 0xb5ba */
    OTHER,        /* 0xb5bb */
    OTHER,        /* 0xb5bc */
    OTHER,        /* 0xb5bd */
    OTHER,        /* 0xb5be */
    OTHER,        /* 0xb5bf */
    OTHER,        /* 0xb5c0 */
    OTHER,        /* 0xb5c1 */
    OTHER,        /* 0xb5c2 */
    OTHER,        /* 0xb5c3 */
    OTHER,        /* 0xb5c4 */
    OTHER,        /* 0xb5c5 */
    OTHER,        /* 0xb5c6 */
    OTHER,        /* 0xb5c7 */
    OTHER,        /* 0xb5c8 */
    OTHER,        /* 0xb5c9 */
    OTHER,        /* 0xb5ca */
    OTHER,        /* 0xb5cb */
    OTHER,        /* 0xb5cc */
    OTHER,        /* 0xb5cd */
    OTHER,        /* 0xb5ce */
    OTHER,        /* 0xb5cf */
    OTHER,        /* 0xb5d0 */
    OTHER,        /* 0xb5d1 */
    OTHER,        /* 0xb5d2 */
    OTHER,        /* 0xb5d3 */
    OTHER,        /* 0xb5d4 */
    OTHER,        /* 0xb5d5 */
    OTHER,        /* 0xb5d6 */
    OTHER,        /* 0xb5d7 */
    OTHER,        /* 0xb5d8 */
    OTHER,        /* 0xb5d9 */
    OTHER,        /* 0xb5da */
    OTHER,        /* 0xb5db */
    OTHER,        /* 0xb5dc */
    OTHER,        /* 0xb5dd */
    OTHER,        /* 0xb5de */
    OTHER,        /* 0xb5df */
    OTHER,        /* 0xb5e0 */
    OTHER,        /* 0xb5e1 */
    OTHER,        /* 0xb5e2 */
    OTHER,        /* 0xb5e3 */
    OTHER,        /* 0xb5e4 */
    OTHER,        /* 0xb5e5 */
    OTHER,        /* 0xb5e6 */
    OTHER,        /* 0xb5e7 */
    OTHER,        /* 0xb5e8 */
    OTHER,        /* 0xb5e9 */
    OTHER,        /* 0xb5ea */
    OTHER,        /* 0xb5eb */
    OTHER,        /* 0xb5ec */
    OTHER,        /* 0xb5ed */
    OTHER,        /* 0xb5ee */
    OTHER,        /* 0xb5ef */
    OTHER,        /* 0xb5f0 */
    OTHER,        /* 0xb5f1 */
    OTHER,        /* 0xb5f2 */
    OTHER,        /* 0xb5f3 */
    OTHER,        /* 0xb5f4 */
    OTHER,        /* 0xb5f5 */
    OTHER,        /* 0xb5f6 */
    OTHER,        /* 0xb5f7 */
    OTHER,        /* 0xb5f8 */
    OTHER,        /* 0xb5f9 */
    OTHER,        /* 0xb5fa */
    OTHER,        /* 0xb5fb */
    OTHER,        /* 0xb5fc */
    OTHER,        /* 0xb5fd */
    OTHER,        /* 0xb5fe */
    OTHER,        /* 0xb5ff */
    OTHER,        /* 0xb600 */
    OTHER,        /* 0xb601 */
    OTHER,        /* 0xb602 */
    OTHER,        /* 0xb603 */
    OTHER,        /* 0xb604 */
    OTHER,        /* 0xb605 */
    OTHER,        /* 0xb606 */
    OTHER,        /* 0xb607 */
    OTHER,        /* 0xb608 */
    OTHER,        /* 0xb609 */
    OTHER,        /* 0xb60a */
    OTHER,        /* 0xb60b */
    OTHER,        /* 0xb60c */
    OTHER,        /* 0xb60d */
    OTHER,        /* 0xb60e */
    OTHER,        /* 0xb60f */
    OTHER,        /* 0xb610 */
    OTHER,        /* 0xb611 */
    OTHER,        /* 0xb612 */
    OTHER,        /* 0xb613 */
    OTHER,        /* 0xb614 */
    OTHER,        /* 0xb615 */
    OTHER,        /* 0xb616 */
    OTHER,        /* 0xb617 */
    OTHER,        /* 0xb618 */
    OTHER,        /* 0xb619 */
    OTHER,        /* 0xb61a */
    OTHER,        /* 0xb61b */
    OTHER,        /* 0xb61c */
    OTHER,        /* 0xb61d */
    OTHER,        /* 0xb61e */
    OTHER,        /* 0xb61f */
    OTHER,        /* 0xb620 */
    OTHER,        /* 0xb621 */
    OTHER,        /* 0xb622 */
    OTHER,        /* 0xb623 */
    OTHER,        /* 0xb624 */
    OTHER,        /* 0xb625 */
    OTHER,        /* 0xb626 */
    OTHER,        /* 0xb627 */
    OTHER,        /* 0xb628 */
    OTHER,        /* 0xb629 */
    OTHER,        /* 0xb62a */
    OTHER,        /* 0xb62b */
    OTHER,        /* 0xb62c */
    OTHER,        /* 0xb62d */
    OTHER,        /* 0xb62e */
    OTHER,        /* 0xb62f */
    OTHER,        /* 0xb630 */
    OTHER,        /* 0xb631 */
    OTHER,        /* 0xb632 */
    OTHER,        /* 0xb633 */
    OTHER,        /* 0xb634 */
    OTHER,        /* 0xb635 */
    OTHER,        /* 0xb636 */
    OTHER,        /* 0xb637 */
    OTHER,        /* 0xb638 */
    OTHER,        /* 0xb639 */
    OTHER,        /* 0xb63a */
    OTHER,        /* 0xb63b */
    OTHER,        /* 0xb63c */
    OTHER,        /* 0xb63d */
    OTHER,        /* 0xb63e */
    OTHER,        /* 0xb63f */
    OTHER,        /* 0xb640 */
    OTHER,        /* 0xb641 */
    OTHER,        /* 0xb642 */
    OTHER,        /* 0xb643 */
    OTHER,        /* 0xb644 */
    OTHER,        /* 0xb645 */
    OTHER,        /* 0xb646 */
    OTHER,        /* 0xb647 */
    OTHER,        /* 0xb648 */
    OTHER,        /* 0xb649 */
    OTHER,        /* 0xb64a */
    OTHER,        /* 0xb64b */
    OTHER,        /* 0xb64c */
    OTHER,        /* 0xb64d */
    OTHER,        /* 0xb64e */
    OTHER,        /* 0xb64f */
    OTHER,        /* 0xb650 */
    OTHER,        /* 0xb651 */
    OTHER,        /* 0xb652 */
    OTHER,        /* 0xb653 */
    OTHER,        /* 0xb654 */
    OTHER,        /* 0xb655 */
    OTHER,        /* 0xb656 */
    OTHER,        /* 0xb657 */
    OTHER,        /* 0xb658 */
    OTHER,        /* 0xb659 */
    OTHER,        /* 0xb65a */
    OTHER,        /* 0xb65b */
    OTHER,        /* 0xb65c */
    OTHER,        /* 0xb65d */
    OTHER,        /* 0xb65e */
    OTHER,        /* 0xb65f */
    OTHER,        /* 0xb660 */
    OTHER,        /* 0xb661 */
    OTHER,        /* 0xb662 */
    OTHER,        /* 0xb663 */
    OTHER,        /* 0xb664 */
    OTHER,        /* 0xb665 */
    OTHER,        /* 0xb666 */
    OTHER,        /* 0xb667 */
    OTHER,        /* 0xb668 */
    OTHER,        /* 0xb669 */
    OTHER,        /* 0xb66a */
    OTHER,        /* 0xb66b */
    OTHER,        /* 0xb66c */
    OTHER,        /* 0xb66d */
    OTHER,        /* 0xb66e */
    OTHER,        /* 0xb66f */
    OTHER,        /* 0xb670 */
    OTHER,        /* 0xb671 */
    OTHER,        /* 0xb672 */
    OTHER,        /* 0xb673 */
    OTHER,        /* 0xb674 */
    OTHER,        /* 0xb675 */
    OTHER,        /* 0xb676 */
    OTHER,        /* 0xb677 */
    OTHER,        /* 0xb678 */
    OTHER,        /* 0xb679 */
    OTHER,        /* 0xb67a */
    OTHER,        /* 0xb67b */
    OTHER,        /* 0xb67c */
    OTHER,        /* 0xb67d */
    OTHER,        /* 0xb67e */
    OTHER,        /* 0xb67f */
    OTHER,        /* 0xb680 */
    OTHER,        /* 0xb681 */
    OTHER,        /* 0xb682 */
    OTHER,        /* 0xb683 */
    OTHER,        /* 0xb684 */
    OTHER,        /* 0xb685 */
    OTHER,        /* 0xb686 */
    OTHER,        /* 0xb687 */
    OTHER,        /* 0xb688 */
    OTHER,        /* 0xb689 */
    OTHER,        /* 0xb68a */
    OTHER,        /* 0xb68b */
    OTHER,        /* 0xb68c */
    OTHER,        /* 0xb68d */
    OTHER,        /* 0xb68e */
    OTHER,        /* 0xb68f */
    OTHER,        /* 0xb690 */
    OTHER,        /* 0xb691 */
    OTHER,        /* 0xb692 */
    OTHER,        /* 0xb693 */
    OTHER,        /* 0xb694 */
    OTHER,        /* 0xb695 */
    OTHER,        /* 0xb696 */
    OTHER,        /* 0xb697 */
    OTHER,        /* 0xb698 */
    OTHER,        /* 0xb699 */
    OTHER,        /* 0xb69a */
    OTHER,        /* 0xb69b */
    OTHER,        /* 0xb69c */
    OTHER,        /* 0xb69d */
    OTHER,        /* 0xb69e */
    OTHER,        /* 0xb69f */
    OTHER,        /* 0xb6a0 */
    OTHER,        /* 0xb6a1 */
    OTHER,        /* 0xb6a2 */
    OTHER,        /* 0xb6a3 */
    OTHER,        /* 0xb6a4 */
    OTHER,        /* 0xb6a5 */
    OTHER,        /* 0xb6a6 */
    OTHER,        /* 0xb6a7 */
    OTHER,        /* 0xb6a8 */
    OTHER,        /* 0xb6a9 */
    OTHER,        /* 0xb6aa */
    OTHER,        /* 0xb6ab */
    OTHER,        /* 0xb6ac */
    OTHER,        /* 0xb6ad */
    OTHER,        /* 0xb6ae */
    OTHER,        /* 0xb6af */
    OTHER,        /* 0xb6b0 */
    OTHER,        /* 0xb6b1 */
    OTHER,        /* 0xb6b2 */
    OTHER,        /* 0xb6b3 */
    OTHER,        /* 0xb6b4 */
    OTHER,        /* 0xb6b5 */
    OTHER,        /* 0xb6b6 */
    OTHER,        /* 0xb6b7 */
    OTHER,        /* 0xb6b8 */
    OTHER,        /* 0xb6b9 */
    OTHER,        /* 0xb6ba */
    OTHER,        /* 0xb6bb */
    OTHER,        /* 0xb6bc */
    OTHER,        /* 0xb6bd */
    OTHER,        /* 0xb6be */
    OTHER,        /* 0xb6bf */
    OTHER,        /* 0xb6c0 */
    OTHER,        /* 0xb6c1 */
    OTHER,        /* 0xb6c2 */
    OTHER,        /* 0xb6c3 */
    OTHER,        /* 0xb6c4 */
    OTHER,        /* 0xb6c5 */
    OTHER,        /* 0xb6c6 */
    OTHER,        /* 0xb6c7 */
    OTHER,        /* 0xb6c8 */
    OTHER,        /* 0xb6c9 */
    OTHER,        /* 0xb6ca */
    OTHER,        /* 0xb6cb */
    OTHER,        /* 0xb6cc */
    OTHER,        /* 0xb6cd */
    OTHER,        /* 0xb6ce */
    OTHER,        /* 0xb6cf */
    OTHER,        /* 0xb6d0 */
    OTHER,        /* 0xb6d1 */
    OTHER,        /* 0xb6d2 */
    OTHER,        /* 0xb6d3 */
    OTHER,        /* 0xb6d4 */
    OTHER,        /* 0xb6d5 */
    OTHER,        /* 0xb6d6 */
    OTHER,        /* 0xb6d7 */
    OTHER,        /* 0xb6d8 */
    OTHER,        /* 0xb6d9 */
    OTHER,        /* 0xb6da */
    OTHER,        /* 0xb6db */
    OTHER,        /* 0xb6dc */
    OTHER,        /* 0xb6dd */
    OTHER,        /* 0xb6de */
    OTHER,        /* 0xb6df */
    OTHER,        /* 0xb6e0 */
    OTHER,        /* 0xb6e1 */
    OTHER,        /* 0xb6e2 */
    OTHER,        /* 0xb6e3 */
    OTHER,        /* 0xb6e4 */
    OTHER,        /* 0xb6e5 */
    OTHER,        /* 0xb6e6 */
    OTHER,        /* 0xb6e7 */
    OTHER,        /* 0xb6e8 */
    OTHER,        /* 0xb6e9 */
    OTHER,        /* 0xb6ea */
    OTHER,        /* 0xb6eb */
    OTHER,        /* 0xb6ec */
    OTHER,        /* 0xb6ed */
    OTHER,        /* 0xb6ee */
    OTHER,        /* 0xb6ef */
    OTHER,        /* 0xb6f0 */
    OTHER,        /* 0xb6f1 */
    OTHER,        /* 0xb6f2 */
    OTHER,        /* 0xb6f3 */
    OTHER,        /* 0xb6f4 */
    OTHER,        /* 0xb6f5 */
    OTHER,        /* 0xb6f6 */
    OTHER,        /* 0xb6f7 */
    OTHER,        /* 0xb6f8 */
    OTHER,        /* 0xb6f9 */
    OTHER,        /* 0xb6fa */
    OTHER,        /* 0xb6fb */
    OTHER,        /* 0xb6fc */
    OTHER,        /* 0xb6fd */
    OTHER,        /* 0xb6fe */
    OTHER,        /* 0xb6ff */
    OTHER,        /* 0xb700 */
    OTHER,        /* 0xb701 */
    OTHER,        /* 0xb702 */
    OTHER,        /* 0xb703 */
    OTHER,        /* 0xb704 */
    OTHER,        /* 0xb705 */
    OTHER,        /* 0xb706 */
    OTHER,        /* 0xb707 */
    OTHER,        /* 0xb708 */
    OTHER,        /* 0xb709 */
    OTHER,        /* 0xb70a */
    OTHER,        /* 0xb70b */
    OTHER,        /* 0xb70c */
    OTHER,        /* 0xb70d */
    OTHER,        /* 0xb70e */
    OTHER,        /* 0xb70f */
    OTHER,        /* 0xb710 */
    OTHER,        /* 0xb711 */
    OTHER,        /* 0xb712 */
    OTHER,        /* 0xb713 */
    OTHER,        /* 0xb714 */
    OTHER,        /* 0xb715 */
    OTHER,        /* 0xb716 */
    OTHER,        /* 0xb717 */
    OTHER,        /* 0xb718 */
    OTHER,        /* 0xb719 */
    OTHER,        /* 0xb71a */
    OTHER,        /* 0xb71b */
    OTHER,        /* 0xb71c */
    OTHER,        /* 0xb71d */
    OTHER,        /* 0xb71e */
    OTHER,        /* 0xb71f */
    OTHER,        /* 0xb720 */
    OTHER,        /* 0xb721 */
    OTHER,        /* 0xb722 */
    OTHER,        /* 0xb723 */
    OTHER,        /* 0xb724 */
    OTHER,        /* 0xb725 */
    OTHER,        /* 0xb726 */
    OTHER,        /* 0xb727 */
    OTHER,        /* 0xb728 */
    OTHER,        /* 0xb729 */
    OTHER,        /* 0xb72a */
    OTHER,        /* 0xb72b */
    OTHER,        /* 0xb72c */
    OTHER,        /* 0xb72d */
    OTHER,        /* 0xb72e */
    OTHER,        /* 0xb72f */
    OTHER,        /* 0xb730 */
    OTHER,        /* 0xb731 */
    OTHER,        /* 0xb732 */
    OTHER,        /* 0xb733 */
    OTHER,        /* 0xb734 */
    OTHER,        /* 0xb735 */
    OTHER,        /* 0xb736 */
    OTHER,        /* 0xb737 */
    OTHER,        /* 0xb738 */
    OTHER,        /* 0xb739 */
    OTHER,        /* 0xb73a */
    OTHER,        /* 0xb73b */
    OTHER,        /* 0xb73c */
    OTHER,        /* 0xb73d */
    OTHER,        /* 0xb73e */
    OTHER,        /* 0xb73f */
    OTHER,        /* 0xb740 */
    OTHER,        /* 0xb741 */
    OTHER,        /* 0xb742 */
    OTHER,        /* 0xb743 */
    OTHER,        /* 0xb744 */
    OTHER,        /* 0xb745 */
    OTHER,        /* 0xb746 */
    OTHER,        /* 0xb747 */
    OTHER,        /* 0xb748 */
    OTHER,        /* 0xb749 */
    OTHER,        /* 0xb74a */
    OTHER,        /* 0xb74b */
    OTHER,        /* 0xb74c */
    OTHER,        /* 0xb74d */
    OTHER,        /* 0xb74e */
    OTHER,        /* 0xb74f */
    OTHER,        /* 0xb750 */
    OTHER,        /* 0xb751 */
    OTHER,        /* 0xb752 */
    OTHER,        /* 0xb753 */
    OTHER,        /* 0xb754 */
    OTHER,        /* 0xb755 */
    OTHER,        /* 0xb756 */
    OTHER,        /* 0xb757 */
    OTHER,        /* 0xb758 */
    OTHER,        /* 0xb759 */
    OTHER,        /* 0xb75a */
    OTHER,        /* 0xb75b */
    OTHER,        /* 0xb75c */
    OTHER,        /* 0xb75d */
    OTHER,        /* 0xb75e */
    OTHER,        /* 0xb75f */
    OTHER,        /* 0xb760 */
    OTHER,        /* 0xb761 */
    OTHER,        /* 0xb762 */
    OTHER,        /* 0xb763 */
    OTHER,        /* 0xb764 */
    OTHER,        /* 0xb765 */
    OTHER,        /* 0xb766 */
    OTHER,        /* 0xb767 */
    OTHER,        /* 0xb768 */
    OTHER,        /* 0xb769 */
    OTHER,        /* 0xb76a */
    OTHER,        /* 0xb76b */
    OTHER,        /* 0xb76c */
    OTHER,        /* 0xb76d */
    OTHER,        /* 0xb76e */
    OTHER,        /* 0xb76f */
    OTHER,        /* 0xb770 */
    OTHER,        /* 0xb771 */
    OTHER,        /* 0xb772 */
    OTHER,        /* 0xb773 */
    OTHER,        /* 0xb774 */
    OTHER,        /* 0xb775 */
    OTHER,        /* 0xb776 */
    OTHER,        /* 0xb777 */
    OTHER,        /* 0xb778 */
    OTHER,        /* 0xb779 */
    OTHER,        /* 0xb77a */
    OTHER,        /* 0xb77b */
    OTHER,        /* 0xb77c */
    OTHER,        /* 0xb77d */
    OTHER,        /* 0xb77e */
    OTHER,        /* 0xb77f */
    OTHER,        /* 0xb780 */
    OTHER,        /* 0xb781 */
    OTHER,        /* 0xb782 */
    OTHER,        /* 0xb783 */
    OTHER,        /* 0xb784 */
    OTHER,        /* 0xb785 */
    OTHER,        /* 0xb786 */
    OTHER,        /* 0xb787 */
    OTHER,        /* 0xb788 */
    OTHER,        /* 0xb789 */
    OTHER,        /* 0xb78a */
    OTHER,        /* 0xb78b */
    OTHER,        /* 0xb78c */
    OTHER,        /* 0xb78d */
    OTHER,        /* 0xb78e */
    OTHER,        /* 0xb78f */
    OTHER,        /* 0xb790 */
    OTHER,        /* 0xb791 */
    OTHER,        /* 0xb792 */
    OTHER,        /* 0xb793 */
    OTHER,        /* 0xb794 */
    OTHER,        /* 0xb795 */
    OTHER,        /* 0xb796 */
    OTHER,        /* 0xb797 */
    OTHER,        /* 0xb798 */
    OTHER,        /* 0xb799 */
    OTHER,        /* 0xb79a */
    OTHER,        /* 0xb79b */
    OTHER,        /* 0xb79c */
    OTHER,        /* 0xb79d */
    OTHER,        /* 0xb79e */
    OTHER,        /* 0xb79f */
    OTHER,        /* 0xb7a0 */
    OTHER,        /* 0xb7a1 */
    OTHER,        /* 0xb7a2 */
    OTHER,        /* 0xb7a3 */
    OTHER,        /* 0xb7a4 */
    OTHER,        /* 0xb7a5 */
    OTHER,        /* 0xb7a6 */
    OTHER,        /* 0xb7a7 */
    OTHER,        /* 0xb7a8 */
    OTHER,        /* 0xb7a9 */
    OTHER,        /* 0xb7aa */
    OTHER,        /* 0xb7ab */
    OTHER,        /* 0xb7ac */
    OTHER,        /* 0xb7ad */
    OTHER,        /* 0xb7ae */
    OTHER,        /* 0xb7af */
    OTHER,        /* 0xb7b0 */
    OTHER,        /* 0xb7b1 */
    OTHER,        /* 0xb7b2 */
    OTHER,        /* 0xb7b3 */
    OTHER,        /* 0xb7b4 */
    OTHER,        /* 0xb7b5 */
    OTHER,        /* 0xb7b6 */
    OTHER,        /* 0xb7b7 */
    OTHER,        /* 0xb7b8 */
    OTHER,        /* 0xb7b9 */
    OTHER,        /* 0xb7ba */
    OTHER,        /* 0xb7bb */
    OTHER,        /* 0xb7bc */
    OTHER,        /* 0xb7bd */
    OTHER,        /* 0xb7be */
    OTHER,        /* 0xb7bf */
    OTHER,        /* 0xb7c0 */
    OTHER,        /* 0xb7c1 */
    OTHER,        /* 0xb7c2 */
    OTHER,        /* 0xb7c3 */
    OTHER,        /* 0xb7c4 */
    OTHER,        /* 0xb7c5 */
    OTHER,        /* 0xb7c6 */
    OTHER,        /* 0xb7c7 */
    OTHER,        /* 0xb7c8 */
    OTHER,        /* 0xb7c9 */
    OTHER,        /* 0xb7ca */
    OTHER,        /* 0xb7cb */
    OTHER,        /* 0xb7cc */
    OTHER,        /* 0xb7cd */
    OTHER,        /* 0xb7ce */
    OTHER,        /* 0xb7cf */
    OTHER,        /* 0xb7d0 */
    OTHER,        /* 0xb7d1 */
    OTHER,        /* 0xb7d2 */
    OTHER,        /* 0xb7d3 */
    OTHER,        /* 0xb7d4 */
    OTHER,        /* 0xb7d5 */
    OTHER,        /* 0xb7d6 */
    OTHER,        /* 0xb7d7 */
    OTHER,        /* 0xb7d8 */
    OTHER,        /* 0xb7d9 */
    OTHER,        /* 0xb7da */
    OTHER,        /* 0xb7db */
    OTHER,        /* 0xb7dc */
    OTHER,        /* 0xb7dd */
    OTHER,        /* 0xb7de */
    OTHER,        /* 0xb7df */
    OTHER,        /* 0xb7e0 */
    OTHER,        /* 0xb7e1 */
    OTHER,        /* 0xb7e2 */
    OTHER,        /* 0xb7e3 */
    OTHER,        /* 0xb7e4 */
    OTHER,        /* 0xb7e5 */
    OTHER,        /* 0xb7e6 */
    OTHER,        /* 0xb7e7 */
    OTHER,        /* 0xb7e8 */
    OTHER,        /* 0xb7e9 */
    OTHER,        /* 0xb7ea */
    OTHER,        /* 0xb7eb */
    OTHER,        /* 0xb7ec */
    OTHER,        /* 0xb7ed */
    OTHER,        /* 0xb7ee */
    OTHER,        /* 0xb7ef */
    OTHER,        /* 0xb7f0 */
    OTHER,        /* 0xb7f1 */
    OTHER,        /* 0xb7f2 */
    OTHER,        /* 0xb7f3 */
    OTHER,        /* 0xb7f4 */
    OTHER,        /* 0xb7f5 */
    OTHER,        /* 0xb7f6 */
    OTHER,        /* 0xb7f7 */
    OTHER,        /* 0xb7f8 */
    OTHER,        /* 0xb7f9 */
    OTHER,        /* 0xb7fa */
    OTHER,        /* 0xb7fb */
    OTHER,        /* 0xb7fc */
    OTHER,        /* 0xb7fd */
    OTHER,        /* 0xb7fe */
    OTHER,        /* 0xb7ff */
    OTHER,        /* 0xb800 */
    OTHER,        /* 0xb801 */
    OTHER,        /* 0xb802 */
    OTHER,        /* 0xb803 */
    OTHER,        /* 0xb804 */
    OTHER,        /* 0xb805 */
    OTHER,        /* 0xb806 */
    OTHER,        /* 0xb807 */
    OTHER,        /* 0xb808 */
    OTHER,        /* 0xb809 */
    OTHER,        /* 0xb80a */
    OTHER,        /* 0xb80b */
    OTHER,        /* 0xb80c */
    OTHER,        /* 0xb80d */
    OTHER,        /* 0xb80e */
    OTHER,        /* 0xb80f */
    OTHER,        /* 0xb810 */
    OTHER,        /* 0xb811 */
    OTHER,        /* 0xb812 */
    OTHER,        /* 0xb813 */
    OTHER,        /* 0xb814 */
    OTHER,        /* 0xb815 */
    OTHER,        /* 0xb816 */
    OTHER,        /* 0xb817 */
    OTHER,        /* 0xb818 */
    OTHER,        /* 0xb819 */
    OTHER,        /* 0xb81a */
    OTHER,        /* 0xb81b */
    OTHER,        /* 0xb81c */
    OTHER,        /* 0xb81d */
    OTHER,        /* 0xb81e */
    OTHER,        /* 0xb81f */
    OTHER,        /* 0xb820 */
    OTHER,        /* 0xb821 */
    OTHER,        /* 0xb822 */
    OTHER,        /* 0xb823 */
    OTHER,        /* 0xb824 */
    OTHER,        /* 0xb825 */
    OTHER,        /* 0xb826 */
    OTHER,        /* 0xb827 */
    OTHER,        /* 0xb828 */
    OTHER,        /* 0xb829 */
    OTHER,        /* 0xb82a */
    OTHER,        /* 0xb82b */
    OTHER,        /* 0xb82c */
    OTHER,        /* 0xb82d */
    OTHER,        /* 0xb82e */
    OTHER,        /* 0xb82f */
    OTHER,        /* 0xb830 */
    OTHER,        /* 0xb831 */
    OTHER,        /* 0xb832 */
    OTHER,        /* 0xb833 */
    OTHER,        /* 0xb834 */
    OTHER,        /* 0xb835 */
    OTHER,        /* 0xb836 */
    OTHER,        /* 0xb837 */
    OTHER,        /* 0xb838 */
    OTHER,        /* 0xb839 */
    OTHER,        /* 0xb83a */
    OTHER,        /* 0xb83b */
    OTHER,        /* 0xb83c */
    OTHER,        /* 0xb83d */
    OTHER,        /* 0xb83e */
    OTHER,        /* 0xb83f */
    OTHER,        /* 0xb840 */
    OTHER,        /* 0xb841 */
    OTHER,        /* 0xb842 */
    OTHER,        /* 0xb843 */
    OTHER,        /* 0xb844 */
    OTHER,        /* 0xb845 */
    OTHER,        /* 0xb846 */
    OTHER,        /* 0xb847 */
    OTHER,        /* 0xb848 */
    OTHER,        /* 0xb849 */
    OTHER,        /* 0xb84a */
    OTHER,        /* 0xb84b */
    OTHER,        /* 0xb84c */
    OTHER,        /* 0xb84d */
    OTHER,        /* 0xb84e */
    OTHER,        /* 0xb84f */
    OTHER,        /* 0xb850 */
    OTHER,        /* 0xb851 */
    OTHER,        /* 0xb852 */
    OTHER,        /* 0xb853 */
    OTHER,        /* 0xb854 */
    OTHER,        /* 0xb855 */
    OTHER,        /* 0xb856 */
    OTHER,        /* 0xb857 */
    OTHER,        /* 0xb858 */
    OTHER,        /* 0xb859 */
    OTHER,        /* 0xb85a */
    OTHER,        /* 0xb85b */
    OTHER,        /* 0xb85c */
    OTHER,        /* 0xb85d */
    OTHER,        /* 0xb85e */
    OTHER,        /* 0xb85f */
    OTHER,        /* 0xb860 */
    OTHER,        /* 0xb861 */
    OTHER,        /* 0xb862 */
    OTHER,        /* 0xb863 */
    OTHER,        /* 0xb864 */
    OTHER,        /* 0xb865 */
    OTHER,        /* 0xb866 */
    OTHER,        /* 0xb867 */
    OTHER,        /* 0xb868 */
    OTHER,        /* 0xb869 */
    OTHER,        /* 0xb86a */
    OTHER,        /* 0xb86b */
    OTHER,        /* 0xb86c */
    OTHER,        /* 0xb86d */
    OTHER,        /* 0xb86e */
    OTHER,        /* 0xb86f */
    OTHER,        /* 0xb870 */
    OTHER,        /* 0xb871 */
    OTHER,        /* 0xb872 */
    OTHER,        /* 0xb873 */
    OTHER,        /* 0xb874 */
    OTHER,        /* 0xb875 */
    OTHER,        /* 0xb876 */
    OTHER,        /* 0xb877 */
    OTHER,        /* 0xb878 */
    OTHER,        /* 0xb879 */
    OTHER,        /* 0xb87a */
    OTHER,        /* 0xb87b */
    OTHER,        /* 0xb87c */
    OTHER,        /* 0xb87d */
    OTHER,        /* 0xb87e */
    OTHER,        /* 0xb87f */
    OTHER,        /* 0xb880 */
    OTHER,        /* 0xb881 */
    OTHER,        /* 0xb882 */
    OTHER,        /* 0xb883 */
    OTHER,        /* 0xb884 */
    OTHER,        /* 0xb885 */
    OTHER,        /* 0xb886 */
    OTHER,        /* 0xb887 */
    OTHER,        /* 0xb888 */
    OTHER,        /* 0xb889 */
    OTHER,        /* 0xb88a */
    OTHER,        /* 0xb88b */
    OTHER,        /* 0xb88c */
    OTHER,        /* 0xb88d */
    OTHER,        /* 0xb88e */
    OTHER,        /* 0xb88f */
    OTHER,        /* 0xb890 */
    OTHER,        /* 0xb891 */
    OTHER,        /* 0xb892 */
    OTHER,        /* 0xb893 */
    OTHER,        /* 0xb894 */
    OTHER,        /* 0xb895 */
    OTHER,        /* 0xb896 */
    OTHER,        /* 0xb897 */
    OTHER,        /* 0xb898 */
    OTHER,        /* 0xb899 */
    OTHER,        /* 0xb89a */
    OTHER,        /* 0xb89b */
    OTHER,        /* 0xb89c */
    OTHER,        /* 0xb89d */
    OTHER,        /* 0xb89e */
    OTHER,        /* 0xb89f */
    OTHER,        /* 0xb8a0 */
    OTHER,        /* 0xb8a1 */
    OTHER,        /* 0xb8a2 */
    OTHER,        /* 0xb8a3 */
    OTHER,        /* 0xb8a4 */
    OTHER,        /* 0xb8a5 */
    OTHER,        /* 0xb8a6 */
    OTHER,        /* 0xb8a7 */
    OTHER,        /* 0xb8a8 */
    OTHER,        /* 0xb8a9 */
    OTHER,        /* 0xb8aa */
    OTHER,        /* 0xb8ab */
    OTHER,        /* 0xb8ac */
    OTHER,        /* 0xb8ad */
    OTHER,        /* 0xb8ae */
    OTHER,        /* 0xb8af */
    OTHER,        /* 0xb8b0 */
    OTHER,        /* 0xb8b1 */
    OTHER,        /* 0xb8b2 */
    OTHER,        /* 0xb8b3 */
    OTHER,        /* 0xb8b4 */
    OTHER,        /* 0xb8b5 */
    OTHER,        /* 0xb8b6 */
    OTHER,        /* 0xb8b7 */
    OTHER,        /* 0xb8b8 */
    OTHER,        /* 0xb8b9 */
    OTHER,        /* 0xb8ba */
    OTHER,        /* 0xb8bb */
    OTHER,        /* 0xb8bc */
    OTHER,        /* 0xb8bd */
    OTHER,        /* 0xb8be */
    OTHER,        /* 0xb8bf */
    OTHER,        /* 0xb8c0 */
    OTHER,        /* 0xb8c1 */
    OTHER,        /* 0xb8c2 */
    OTHER,        /* 0xb8c3 */
    OTHER,        /* 0xb8c4 */
    OTHER,        /* 0xb8c5 */
    OTHER,        /* 0xb8c6 */
    OTHER,        /* 0xb8c7 */
    OTHER,        /* 0xb8c8 */
    OTHER,        /* 0xb8c9 */
    OTHER,        /* 0xb8ca */
    OTHER,        /* 0xb8cb */
    OTHER,        /* 0xb8cc */
    OTHER,        /* 0xb8cd */
    OTHER,        /* 0xb8ce */
    OTHER,        /* 0xb8cf */
    OTHER,        /* 0xb8d0 */
    OTHER,        /* 0xb8d1 */
    OTHER,        /* 0xb8d2 */
    OTHER,        /* 0xb8d3 */
    OTHER,        /* 0xb8d4 */
    OTHER,        /* 0xb8d5 */
    OTHER,        /* 0xb8d6 */
    OTHER,        /* 0xb8d7 */
    OTHER,        /* 0xb8d8 */
    OTHER,        /* 0xb8d9 */
    OTHER,        /* 0xb8da */
    OTHER,        /* 0xb8db */
    OTHER,        /* 0xb8dc */
    OTHER,        /* 0xb8dd */
    OTHER,        /* 0xb8de */
    OTHER,        /* 0xb8df */
    OTHER,        /* 0xb8e0 */
    OTHER,        /* 0xb8e1 */
    OTHER,        /* 0xb8e2 */
    OTHER,        /* 0xb8e3 */
    OTHER,        /* 0xb8e4 */
    OTHER,        /* 0xb8e5 */
    OTHER,        /* 0xb8e6 */
    OTHER,        /* 0xb8e7 */
    OTHER,        /* 0xb8e8 */
    OTHER,        /* 0xb8e9 */
    OTHER,        /* 0xb8ea */
    OTHER,        /* 0xb8eb */
    OTHER,        /* 0xb8ec */
    OTHER,        /* 0xb8ed */
    OTHER,        /* 0xb8ee */
    OTHER,        /* 0xb8ef */
    OTHER,        /* 0xb8f0 */
    OTHER,        /* 0xb8f1 */
    OTHER,        /* 0xb8f2 */
    OTHER,        /* 0xb8f3 */
    OTHER,        /* 0xb8f4 */
    OTHER,        /* 0xb8f5 */
    OTHER,        /* 0xb8f6 */
    OTHER,        /* 0xb8f7 */
    OTHER,        /* 0xb8f8 */
    OTHER,        /* 0xb8f9 */
    OTHER,        /* 0xb8fa */
    OTHER,        /* 0xb8fb */
    OTHER,        /* 0xb8fc */
    OTHER,        /* 0xb8fd */
    OTHER,        /* 0xb8fe */
    OTHER,        /* 0xb8ff */
    OTHER,        /* 0xb900 */
    OTHER,        /* 0xb901 */
    OTHER,        /* 0xb902 */
    OTHER,        /* 0xb903 */
    OTHER,        /* 0xb904 */
    OTHER,        /* 0xb905 */
    OTHER,        /* 0xb906 */
    OTHER,        /* 0xb907 */
    OTHER,        /* 0xb908 */
    OTHER,        /* 0xb909 */
    OTHER,        /* 0xb90a */
    OTHER,        /* 0xb90b */
    OTHER,        /* 0xb90c */
    OTHER,        /* 0xb90d */
    OTHER,        /* 0xb90e */
    OTHER,        /* 0xb90f */
    OTHER,        /* 0xb910 */
    OTHER,        /* 0xb911 */
    OTHER,        /* 0xb912 */
    OTHER,        /* 0xb913 */
    OTHER,        /* 0xb914 */
    OTHER,        /* 0xb915 */
    OTHER,        /* 0xb916 */
    OTHER,        /* 0xb917 */
    OTHER,        /* 0xb918 */
    OTHER,        /* 0xb919 */
    OTHER,        /* 0xb91a */
    OTHER,        /* 0xb91b */
    OTHER,        /* 0xb91c */
    OTHER,        /* 0xb91d */
    OTHER,        /* 0xb91e */
    OTHER,        /* 0xb91f */
    OTHER,        /* 0xb920 */
    OTHER,        /* 0xb921 */
    OTHER,        /* 0xb922 */
    OTHER,        /* 0xb923 */
    OTHER,        /* 0xb924 */
    OTHER,        /* 0xb925 */
    OTHER,        /* 0xb926 */
    OTHER,        /* 0xb927 */
    OTHER,        /* 0xb928 */
    OTHER,        /* 0xb929 */
    OTHER,        /* 0xb92a */
    OTHER,        /* 0xb92b */
    OTHER,        /* 0xb92c */
    OTHER,        /* 0xb92d */
    OTHER,        /* 0xb92e */
    OTHER,        /* 0xb92f */
    OTHER,        /* 0xb930 */
    OTHER,        /* 0xb931 */
    OTHER,        /* 0xb932 */
    OTHER,        /* 0xb933 */
    OTHER,        /* 0xb934 */
    OTHER,        /* 0xb935 */
    OTHER,        /* 0xb936 */
    OTHER,        /* 0xb937 */
    OTHER,        /* 0xb938 */
    OTHER,        /* 0xb939 */
    OTHER,        /* 0xb93a */
    OTHER,        /* 0xb93b */
    OTHER,        /* 0xb93c */
    OTHER,        /* 0xb93d */
    OTHER,        /* 0xb93e */
    OTHER,        /* 0xb93f */
    OTHER,        /* 0xb940 */
    OTHER,        /* 0xb941 */
    OTHER,        /* 0xb942 */
    OTHER,        /* 0xb943 */
    OTHER,        /* 0xb944 */
    OTHER,        /* 0xb945 */
    OTHER,        /* 0xb946 */
    OTHER,        /* 0xb947 */
    OTHER,        /* 0xb948 */
    OTHER,        /* 0xb949 */
    OTHER,        /* 0xb94a */
    OTHER,        /* 0xb94b */
    OTHER,        /* 0xb94c */
    OTHER,        /* 0xb94d */
    OTHER,        /* 0xb94e */
    OTHER,        /* 0xb94f */
    OTHER,        /* 0xb950 */
    OTHER,        /* 0xb951 */
    OTHER,        /* 0xb952 */
    OTHER,        /* 0xb953 */
    OTHER,        /* 0xb954 */
    OTHER,        /* 0xb955 */
    OTHER,        /* 0xb956 */
    OTHER,        /* 0xb957 */
    OTHER,        /* 0xb958 */
    OTHER,        /* 0xb959 */
    OTHER,        /* 0xb95a */
    OTHER,        /* 0xb95b */
    OTHER,        /* 0xb95c */
    OTHER,        /* 0xb95d */
    OTHER,        /* 0xb95e */
    OTHER,        /* 0xb95f */
    OTHER,        /* 0xb960 */
    OTHER,        /* 0xb961 */
    OTHER,        /* 0xb962 */
    OTHER,        /* 0xb963 */
    OTHER,        /* 0xb964 */
    OTHER,        /* 0xb965 */
    OTHER,        /* 0xb966 */
    OTHER,        /* 0xb967 */
    OTHER,        /* 0xb968 */
    OTHER,        /* 0xb969 */
    OTHER,        /* 0xb96a */
    OTHER,        /* 0xb96b */
    OTHER,        /* 0xb96c */
    OTHER,        /* 0xb96d */
    OTHER,        /* 0xb96e */
    OTHER,        /* 0xb96f */
    OTHER,        /* 0xb970 */
    OTHER,        /* 0xb971 */
    OTHER,        /* 0xb972 */
    OTHER,        /* 0xb973 */
    OTHER,        /* 0xb974 */
    OTHER,        /* 0xb975 */
    OTHER,        /* 0xb976 */
    OTHER,        /* 0xb977 */
    OTHER,        /* 0xb978 */
    OTHER,        /* 0xb979 */
    OTHER,        /* 0xb97a */
    OTHER,        /* 0xb97b */
    OTHER,        /* 0xb97c */
    OTHER,        /* 0xb97d */
    OTHER,        /* 0xb97e */
    OTHER,        /* 0xb97f */
    OTHER,        /* 0xb980 */
    OTHER,        /* 0xb981 */
    OTHER,        /* 0xb982 */
    OTHER,        /* 0xb983 */
    OTHER,        /* 0xb984 */
    OTHER,        /* 0xb985 */
    OTHER,        /* 0xb986 */
    OTHER,        /* 0xb987 */
    OTHER,        /* 0xb988 */
    OTHER,        /* 0xb989 */
    OTHER,        /* 0xb98a */
    OTHER,        /* 0xb98b */
    OTHER,        /* 0xb98c */
    OTHER,        /* 0xb98d */
    OTHER,        /* 0xb98e */
    OTHER,        /* 0xb98f */
    OTHER,        /* 0xb990 */
    OTHER,        /* 0xb991 */
    OTHER,        /* 0xb992 */
    OTHER,        /* 0xb993 */
    OTHER,        /* 0xb994 */
    OTHER,        /* 0xb995 */
    OTHER,        /* 0xb996 */
    OTHER,        /* 0xb997 */
    OTHER,        /* 0xb998 */
    OTHER,        /* 0xb999 */
    OTHER,        /* 0xb99a */
    OTHER,        /* 0xb99b */
    OTHER,        /* 0xb99c */
    OTHER,        /* 0xb99d */
    OTHER,        /* 0xb99e */
    OTHER,        /* 0xb99f */
    OTHER,        /* 0xb9a0 */
    OTHER,        /* 0xb9a1 */
    OTHER,        /* 0xb9a2 */
    OTHER,        /* 0xb9a3 */
    OTHER,        /* 0xb9a4 */
    OTHER,        /* 0xb9a5 */
    OTHER,        /* 0xb9a6 */
    OTHER,        /* 0xb9a7 */
    OTHER,        /* 0xb9a8 */
    OTHER,        /* 0xb9a9 */
    OTHER,        /* 0xb9aa */
    OTHER,        /* 0xb9ab */
    OTHER,        /* 0xb9ac */
    OTHER,        /* 0xb9ad */
    OTHER,        /* 0xb9ae */
    OTHER,        /* 0xb9af */
    OTHER,        /* 0xb9b0 */
    OTHER,        /* 0xb9b1 */
    OTHER,        /* 0xb9b2 */
    OTHER,        /* 0xb9b3 */
    OTHER,        /* 0xb9b4 */
    OTHER,        /* 0xb9b5 */
    OTHER,        /* 0xb9b6 */
    OTHER,        /* 0xb9b7 */
    OTHER,        /* 0xb9b8 */
    OTHER,        /* 0xb9b9 */
    OTHER,        /* 0xb9ba */
    OTHER,        /* 0xb9bb */
    OTHER,        /* 0xb9bc */
    OTHER,        /* 0xb9bd */
    OTHER,        /* 0xb9be */
    OTHER,        /* 0xb9bf */
    OTHER,        /* 0xb9c0 */
    OTHER,        /* 0xb9c1 */
    OTHER,        /* 0xb9c2 */
    OTHER,        /* 0xb9c3 */
    OTHER,        /* 0xb9c4 */
    OTHER,        /* 0xb9c5 */
    OTHER,        /* 0xb9c6 */
    OTHER,        /* 0xb9c7 */
    OTHER,        /* 0xb9c8 */
    OTHER,        /* 0xb9c9 */
    OTHER,        /* 0xb9ca */
    OTHER,        /* 0xb9cb */
    OTHER,        /* 0xb9cc */
    OTHER,        /* 0xb9cd */
    OTHER,        /* 0xb9ce */
    OTHER,        /* 0xb9cf */
    OTHER,        /* 0xb9d0 */
    OTHER,        /* 0xb9d1 */
    OTHER,        /* 0xb9d2 */
    OTHER,        /* 0xb9d3 */
    OTHER,        /* 0xb9d4 */
    OTHER,        /* 0xb9d5 */
    OTHER,        /* 0xb9d6 */
    OTHER,        /* 0xb9d7 */
    OTHER,        /* 0xb9d8 */
    OTHER,        /* 0xb9d9 */
    OTHER,        /* 0xb9da */
    OTHER,        /* 0xb9db */
    OTHER,        /* 0xb9dc */
    OTHER,        /* 0xb9dd */
    OTHER,        /* 0xb9de */
    OTHER,        /* 0xb9df */
    OTHER,        /* 0xb9e0 */
    OTHER,        /* 0xb9e1 */
    OTHER,        /* 0xb9e2 */
    OTHER,        /* 0xb9e3 */
    OTHER,        /* 0xb9e4 */
    OTHER,        /* 0xb9e5 */
    OTHER,        /* 0xb9e6 */
    OTHER,        /* 0xb9e7 */
    OTHER,        /* 0xb9e8 */
    OTHER,        /* 0xb9e9 */
    OTHER,        /* 0xb9ea */
    OTHER,        /* 0xb9eb */
    OTHER,        /* 0xb9ec */
    OTHER,        /* 0xb9ed */
    OTHER,        /* 0xb9ee */
    OTHER,        /* 0xb9ef */
    OTHER,        /* 0xb9f0 */
    OTHER,        /* 0xb9f1 */
    OTHER,        /* 0xb9f2 */
    OTHER,        /* 0xb9f3 */
    OTHER,        /* 0xb9f4 */
    OTHER,        /* 0xb9f5 */
    OTHER,        /* 0xb9f6 */
    OTHER,        /* 0xb9f7 */
    OTHER,        /* 0xb9f8 */
    OTHER,        /* 0xb9f9 */
    OTHER,        /* 0xb9fa */
    OTHER,        /* 0xb9fb */
    OTHER,        /* 0xb9fc */
    OTHER,        /* 0xb9fd */
    OTHER,        /* 0xb9fe */
    OTHER,        /* 0xb9ff */
    OTHER,        /* 0xba00 */
    OTHER,        /* 0xba01 */
    OTHER,        /* 0xba02 */
    OTHER,        /* 0xba03 */
    OTHER,        /* 0xba04 */
    OTHER,        /* 0xba05 */
    OTHER,        /* 0xba06 */
    OTHER,        /* 0xba07 */
    OTHER,        /* 0xba08 */
    OTHER,        /* 0xba09 */
    OTHER,        /* 0xba0a */
    OTHER,        /* 0xba0b */
    OTHER,        /* 0xba0c */
    OTHER,        /* 0xba0d */
    OTHER,        /* 0xba0e */
    OTHER,        /* 0xba0f */
    OTHER,        /* 0xba10 */
    OTHER,        /* 0xba11 */
    OTHER,        /* 0xba12 */
    OTHER,        /* 0xba13 */
    OTHER,        /* 0xba14 */
    OTHER,        /* 0xba15 */
    OTHER,        /* 0xba16 */
    OTHER,        /* 0xba17 */
    OTHER,        /* 0xba18 */
    OTHER,        /* 0xba19 */
    OTHER,        /* 0xba1a */
    OTHER,        /* 0xba1b */
    OTHER,        /* 0xba1c */
    OTHER,        /* 0xba1d */
    OTHER,        /* 0xba1e */
    OTHER,        /* 0xba1f */
    OTHER,        /* 0xba20 */
    OTHER,        /* 0xba21 */
    OTHER,        /* 0xba22 */
    OTHER,        /* 0xba23 */
    OTHER,        /* 0xba24 */
    OTHER,        /* 0xba25 */
    OTHER,        /* 0xba26 */
    OTHER,        /* 0xba27 */
    OTHER,        /* 0xba28 */
    OTHER,        /* 0xba29 */
    OTHER,        /* 0xba2a */
    OTHER,        /* 0xba2b */
    OTHER,        /* 0xba2c */
    OTHER,        /* 0xba2d */
    OTHER,        /* 0xba2e */
    OTHER,        /* 0xba2f */
    OTHER,        /* 0xba30 */
    OTHER,        /* 0xba31 */
    OTHER,        /* 0xba32 */
    OTHER,        /* 0xba33 */
    OTHER,        /* 0xba34 */
    OTHER,        /* 0xba35 */
    OTHER,        /* 0xba36 */
    OTHER,        /* 0xba37 */
    OTHER,        /* 0xba38 */
    OTHER,        /* 0xba39 */
    OTHER,        /* 0xba3a */
    OTHER,        /* 0xba3b */
    OTHER,        /* 0xba3c */
    OTHER,        /* 0xba3d */
    OTHER,        /* 0xba3e */
    OTHER,        /* 0xba3f */
    OTHER,        /* 0xba40 */
    OTHER,        /* 0xba41 */
    OTHER,        /* 0xba42 */
    OTHER,        /* 0xba43 */
    OTHER,        /* 0xba44 */
    OTHER,        /* 0xba45 */
    OTHER,        /* 0xba46 */
    OTHER,        /* 0xba47 */
    OTHER,        /* 0xba48 */
    OTHER,        /* 0xba49 */
    OTHER,        /* 0xba4a */
    OTHER,        /* 0xba4b */
    OTHER,        /* 0xba4c */
    OTHER,        /* 0xba4d */
    OTHER,        /* 0xba4e */
    OTHER,        /* 0xba4f */
    OTHER,        /* 0xba50 */
    OTHER,        /* 0xba51 */
    OTHER,        /* 0xba52 */
    OTHER,        /* 0xba53 */
    OTHER,        /* 0xba54 */
    OTHER,        /* 0xba55 */
    OTHER,        /* 0xba56 */
    OTHER,        /* 0xba57 */
    OTHER,        /* 0xba58 */
    OTHER,        /* 0xba59 */
    OTHER,        /* 0xba5a */
    OTHER,        /* 0xba5b */
    OTHER,        /* 0xba5c */
    OTHER,        /* 0xba5d */
    OTHER,        /* 0xba5e */
    OTHER,        /* 0xba5f */
    OTHER,        /* 0xba60 */
    OTHER,        /* 0xba61 */
    OTHER,        /* 0xba62 */
    OTHER,        /* 0xba63 */
    OTHER,        /* 0xba64 */
    OTHER,        /* 0xba65 */
    OTHER,        /* 0xba66 */
    OTHER,        /* 0xba67 */
    OTHER,        /* 0xba68 */
    OTHER,        /* 0xba69 */
    OTHER,        /* 0xba6a */
    OTHER,        /* 0xba6b */
    OTHER,        /* 0xba6c */
    OTHER,        /* 0xba6d */
    OTHER,        /* 0xba6e */
    OTHER,        /* 0xba6f */
    OTHER,        /* 0xba70 */
    OTHER,        /* 0xba71 */
    OTHER,        /* 0xba72 */
    OTHER,        /* 0xba73 */
    OTHER,        /* 0xba74 */
    OTHER,        /* 0xba75 */
    OTHER,        /* 0xba76 */
    OTHER,        /* 0xba77 */
    OTHER,        /* 0xba78 */
    OTHER,        /* 0xba79 */
    OTHER,        /* 0xba7a */
    OTHER,        /* 0xba7b */
    OTHER,        /* 0xba7c */
    OTHER,        /* 0xba7d */
    OTHER,        /* 0xba7e */
    OTHER,        /* 0xba7f */
    OTHER,        /* 0xba80 */
    OTHER,        /* 0xba81 */
    OTHER,        /* 0xba82 */
    OTHER,        /* 0xba83 */
    OTHER,        /* 0xba84 */
    OTHER,        /* 0xba85 */
    OTHER,        /* 0xba86 */
    OTHER,        /* 0xba87 */
    OTHER,        /* 0xba88 */
    OTHER,        /* 0xba89 */
    OTHER,        /* 0xba8a */
    OTHER,        /* 0xba8b */
    OTHER,        /* 0xba8c */
    OTHER,        /* 0xba8d */
    OTHER,        /* 0xba8e */
    OTHER,        /* 0xba8f */
    OTHER,        /* 0xba90 */
    OTHER,        /* 0xba91 */
    OTHER,        /* 0xba92 */
    OTHER,        /* 0xba93 */
    OTHER,        /* 0xba94 */
    OTHER,        /* 0xba95 */
    OTHER,        /* 0xba96 */
    OTHER,        /* 0xba97 */
    OTHER,        /* 0xba98 */
    OTHER,        /* 0xba99 */
    OTHER,        /* 0xba9a */
    OTHER,        /* 0xba9b */
    OTHER,        /* 0xba9c */
    OTHER,        /* 0xba9d */
    OTHER,        /* 0xba9e */
    OTHER,        /* 0xba9f */
    OTHER,        /* 0xbaa0 */
    OTHER,        /* 0xbaa1 */
    OTHER,        /* 0xbaa2 */
    OTHER,        /* 0xbaa3 */
    OTHER,        /* 0xbaa4 */
    OTHER,        /* 0xbaa5 */
    OTHER,        /* 0xbaa6 */
    OTHER,        /* 0xbaa7 */
    OTHER,        /* 0xbaa8 */
    OTHER,        /* 0xbaa9 */
    OTHER,        /* 0xbaaa */
    OTHER,        /* 0xbaab */
    OTHER,        /* 0xbaac */
    OTHER,        /* 0xbaad */
    OTHER,        /* 0xbaae */
    OTHER,        /* 0xbaaf */
    OTHER,        /* 0xbab0 */
    OTHER,        /* 0xbab1 */
    OTHER,        /* 0xbab2 */
    OTHER,        /* 0xbab3 */
    OTHER,        /* 0xbab4 */
    OTHER,        /* 0xbab5 */
    OTHER,        /* 0xbab6 */
    OTHER,        /* 0xbab7 */
    OTHER,        /* 0xbab8 */
    OTHER,        /* 0xbab9 */
    OTHER,        /* 0xbaba */
    OTHER,        /* 0xbabb */
    OTHER,        /* 0xbabc */
    OTHER,        /* 0xbabd */
    OTHER,        /* 0xbabe */
    OTHER,        /* 0xbabf */
    OTHER,        /* 0xbac0 */
    OTHER,        /* 0xbac1 */
    OTHER,        /* 0xbac2 */
    OTHER,        /* 0xbac3 */
    OTHER,        /* 0xbac4 */
    OTHER,        /* 0xbac5 */
    OTHER,        /* 0xbac6 */
    OTHER,        /* 0xbac7 */
    OTHER,        /* 0xbac8 */
    OTHER,        /* 0xbac9 */
    OTHER,        /* 0xbaca */
    OTHER,        /* 0xbacb */
    OTHER,        /* 0xbacc */
    OTHER,        /* 0xbacd */
    OTHER,        /* 0xbace */
    OTHER,        /* 0xbacf */
    OTHER,        /* 0xbad0 */
    OTHER,        /* 0xbad1 */
    OTHER,        /* 0xbad2 */
    OTHER,        /* 0xbad3 */
    OTHER,        /* 0xbad4 */
    OTHER,        /* 0xbad5 */
    OTHER,        /* 0xbad6 */
    OTHER,        /* 0xbad7 */
    OTHER,        /* 0xbad8 */
    OTHER,        /* 0xbad9 */
    OTHER,        /* 0xbada */
    OTHER,        /* 0xbadb */
    OTHER,        /* 0xbadc */
    OTHER,        /* 0xbadd */
    OTHER,        /* 0xbade */
    OTHER,        /* 0xbadf */
    OTHER,        /* 0xbae0 */
    OTHER,        /* 0xbae1 */
    OTHER,        /* 0xbae2 */
    OTHER,        /* 0xbae3 */
    OTHER,        /* 0xbae4 */
    OTHER,        /* 0xbae5 */
    OTHER,        /* 0xbae6 */
    OTHER,        /* 0xbae7 */
    OTHER,        /* 0xbae8 */
    OTHER,        /* 0xbae9 */
    OTHER,        /* 0xbaea */
    OTHER,        /* 0xbaeb */
    OTHER,        /* 0xbaec */
    OTHER,        /* 0xbaed */
    OTHER,        /* 0xbaee */
    OTHER,        /* 0xbaef */
    OTHER,        /* 0xbaf0 */
    OTHER,        /* 0xbaf1 */
    OTHER,        /* 0xbaf2 */
    OTHER,        /* 0xbaf3 */
    OTHER,        /* 0xbaf4 */
    OTHER,        /* 0xbaf5 */
    OTHER,        /* 0xbaf6 */
    OTHER,        /* 0xbaf7 */
    OTHER,        /* 0xbaf8 */
    OTHER,        /* 0xbaf9 */
    OTHER,        /* 0xbafa */
    OTHER,        /* 0xbafb */
    OTHER,        /* 0xbafc */
    OTHER,        /* 0xbafd */
    OTHER,        /* 0xbafe */
    OTHER,        /* 0xbaff */
    OTHER,        /* 0xbb00 */
    OTHER,        /* 0xbb01 */
    OTHER,        /* 0xbb02 */
    OTHER,        /* 0xbb03 */
    OTHER,        /* 0xbb04 */
    OTHER,        /* 0xbb05 */
    OTHER,        /* 0xbb06 */
    OTHER,        /* 0xbb07 */
    OTHER,        /* 0xbb08 */
    OTHER,        /* 0xbb09 */
    OTHER,        /* 0xbb0a */
    OTHER,        /* 0xbb0b */
    OTHER,        /* 0xbb0c */
    OTHER,        /* 0xbb0d */
    OTHER,        /* 0xbb0e */
    OTHER,        /* 0xbb0f */
    OTHER,        /* 0xbb10 */
    OTHER,        /* 0xbb11 */
    OTHER,        /* 0xbb12 */
    OTHER,        /* 0xbb13 */
    OTHER,        /* 0xbb14 */
    OTHER,        /* 0xbb15 */
    OTHER,        /* 0xbb16 */
    OTHER,        /* 0xbb17 */
    OTHER,        /* 0xbb18 */
    OTHER,        /* 0xbb19 */
    OTHER,        /* 0xbb1a */
    OTHER,        /* 0xbb1b */
    OTHER,        /* 0xbb1c */
    OTHER,        /* 0xbb1d */
    OTHER,        /* 0xbb1e */
    OTHER,        /* 0xbb1f */
    OTHER,        /* 0xbb20 */
    OTHER,        /* 0xbb21 */
    OTHER,        /* 0xbb22 */
    OTHER,        /* 0xbb23 */
    OTHER,        /* 0xbb24 */
    OTHER,        /* 0xbb25 */
    OTHER,        /* 0xbb26 */
    OTHER,        /* 0xbb27 */
    OTHER,        /* 0xbb28 */
    OTHER,        /* 0xbb29 */
    OTHER,        /* 0xbb2a */
    OTHER,        /* 0xbb2b */
    OTHER,        /* 0xbb2c */
    OTHER,        /* 0xbb2d */
    OTHER,        /* 0xbb2e */
    OTHER,        /* 0xbb2f */
    OTHER,        /* 0xbb30 */
    OTHER,        /* 0xbb31 */
    OTHER,        /* 0xbb32 */
    OTHER,        /* 0xbb33 */
    OTHER,        /* 0xbb34 */
    OTHER,        /* 0xbb35 */
    OTHER,        /* 0xbb36 */
    OTHER,        /* 0xbb37 */
    OTHER,        /* 0xbb38 */
    OTHER,        /* 0xbb39 */
    OTHER,        /* 0xbb3a */
    OTHER,        /* 0xbb3b */
    OTHER,        /* 0xbb3c */
    OTHER,        /* 0xbb3d */
    OTHER,        /* 0xbb3e */
    OTHER,        /* 0xbb3f */
    OTHER,        /* 0xbb40 */
    OTHER,        /* 0xbb41 */
    OTHER,        /* 0xbb42 */
    OTHER,        /* 0xbb43 */
    OTHER,        /* 0xbb44 */
    OTHER,        /* 0xbb45 */
    OTHER,        /* 0xbb46 */
    OTHER,        /* 0xbb47 */
    OTHER,        /* 0xbb48 */
    OTHER,        /* 0xbb49 */
    OTHER,        /* 0xbb4a */
    OTHER,        /* 0xbb4b */
    OTHER,        /* 0xbb4c */
    OTHER,        /* 0xbb4d */
    OTHER,        /* 0xbb4e */
    OTHER,        /* 0xbb4f */
    OTHER,        /* 0xbb50 */
    OTHER,        /* 0xbb51 */
    OTHER,        /* 0xbb52 */
    OTHER,        /* 0xbb53 */
    OTHER,        /* 0xbb54 */
    OTHER,        /* 0xbb55 */
    OTHER,        /* 0xbb56 */
    OTHER,        /* 0xbb57 */
    OTHER,        /* 0xbb58 */
    OTHER,        /* 0xbb59 */
    OTHER,        /* 0xbb5a */
    OTHER,        /* 0xbb5b */
    OTHER,        /* 0xbb5c */
    OTHER,        /* 0xbb5d */
    OTHER,        /* 0xbb5e */
    OTHER,        /* 0xbb5f */
    OTHER,        /* 0xbb60 */
    OTHER,        /* 0xbb61 */
    OTHER,        /* 0xbb62 */
    OTHER,        /* 0xbb63 */
    OTHER,        /* 0xbb64 */
    OTHER,        /* 0xbb65 */
    OTHER,        /* 0xbb66 */
    OTHER,        /* 0xbb67 */
    OTHER,        /* 0xbb68 */
    OTHER,        /* 0xbb69 */
    OTHER,        /* 0xbb6a */
    OTHER,        /* 0xbb6b */
    OTHER,        /* 0xbb6c */
    OTHER,        /* 0xbb6d */
    OTHER,        /* 0xbb6e */
    OTHER,        /* 0xbb6f */
    OTHER,        /* 0xbb70 */
    OTHER,        /* 0xbb71 */
    OTHER,        /* 0xbb72 */
    OTHER,        /* 0xbb73 */
    OTHER,        /* 0xbb74 */
    OTHER,        /* 0xbb75 */
    OTHER,        /* 0xbb76 */
    OTHER,        /* 0xbb77 */
    OTHER,        /* 0xbb78 */
    OTHER,        /* 0xbb79 */
    OTHER,        /* 0xbb7a */
    OTHER,        /* 0xbb7b */
    OTHER,        /* 0xbb7c */
    OTHER,        /* 0xbb7d */
    OTHER,        /* 0xbb7e */
    OTHER,        /* 0xbb7f */
    OTHER,        /* 0xbb80 */
    OTHER,        /* 0xbb81 */
    OTHER,        /* 0xbb82 */
    OTHER,        /* 0xbb83 */
    OTHER,        /* 0xbb84 */
    OTHER,        /* 0xbb85 */
    OTHER,        /* 0xbb86 */
    OTHER,        /* 0xbb87 */
    OTHER,        /* 0xbb88 */
    OTHER,        /* 0xbb89 */
    OTHER,        /* 0xbb8a */
    OTHER,        /* 0xbb8b */
    OTHER,        /* 0xbb8c */
    OTHER,        /* 0xbb8d */
    OTHER,        /* 0xbb8e */
    OTHER,        /* 0xbb8f */
    OTHER,        /* 0xbb90 */
    OTHER,        /* 0xbb91 */
    OTHER,        /* 0xbb92 */
    OTHER,        /* 0xbb93 */
    OTHER,        /* 0xbb94 */
    OTHER,        /* 0xbb95 */
    OTHER,        /* 0xbb96 */
    OTHER,        /* 0xbb97 */
    OTHER,        /* 0xbb98 */
    OTHER,        /* 0xbb99 */
    OTHER,        /* 0xbb9a */
    OTHER,        /* 0xbb9b */
    OTHER,        /* 0xbb9c */
    OTHER,        /* 0xbb9d */
    OTHER,        /* 0xbb9e */
    OTHER,        /* 0xbb9f */
    OTHER,        /* 0xbba0 */
    OTHER,        /* 0xbba1 */
    OTHER,        /* 0xbba2 */
    OTHER,        /* 0xbba3 */
    OTHER,        /* 0xbba4 */
    OTHER,        /* 0xbba5 */
    OTHER,        /* 0xbba6 */
    OTHER,        /* 0xbba7 */
    OTHER,        /* 0xbba8 */
    OTHER,        /* 0xbba9 */
    OTHER,        /* 0xbbaa */
    OTHER,        /* 0xbbab */
    OTHER,        /* 0xbbac */
    OTHER,        /* 0xbbad */
    OTHER,        /* 0xbbae */
    OTHER,        /* 0xbbaf */
    OTHER,        /* 0xbbb0 */
    OTHER,        /* 0xbbb1 */
    OTHER,        /* 0xbbb2 */
    OTHER,        /* 0xbbb3 */
    OTHER,        /* 0xbbb4 */
    OTHER,        /* 0xbbb5 */
    OTHER,        /* 0xbbb6 */
    OTHER,        /* 0xbbb7 */
    OTHER,        /* 0xbbb8 */
    OTHER,        /* 0xbbb9 */
    OTHER,        /* 0xbbba */
    OTHER,        /* 0xbbbb */
    OTHER,        /* 0xbbbc */
    OTHER,        /* 0xbbbd */
    OTHER,        /* 0xbbbe */
    OTHER,        /* 0xbbbf */
    OTHER,        /* 0xbbc0 */
    OTHER,        /* 0xbbc1 */
    OTHER,        /* 0xbbc2 */
    OTHER,        /* 0xbbc3 */
    OTHER,        /* 0xbbc4 */
    OTHER,        /* 0xbbc5 */
    OTHER,        /* 0xbbc6 */
    OTHER,        /* 0xbbc7 */
    OTHER,        /* 0xbbc8 */
    OTHER,        /* 0xbbc9 */
    OTHER,        /* 0xbbca */
    OTHER,        /* 0xbbcb */
    OTHER,        /* 0xbbcc */
    OTHER,        /* 0xbbcd */
    OTHER,        /* 0xbbce */
    OTHER,        /* 0xbbcf */
    OTHER,        /* 0xbbd0 */
    OTHER,        /* 0xbbd1 */
    OTHER,        /* 0xbbd2 */
    OTHER,        /* 0xbbd3 */
    OTHER,        /* 0xbbd4 */
    OTHER,        /* 0xbbd5 */
    OTHER,        /* 0xbbd6 */
    OTHER,        /* 0xbbd7 */
    OTHER,        /* 0xbbd8 */
    OTHER,        /* 0xbbd9 */
    OTHER,        /* 0xbbda */
    OTHER,        /* 0xbbdb */
    OTHER,        /* 0xbbdc */
    OTHER,        /* 0xbbdd */
    OTHER,        /* 0xbbde */
    OTHER,        /* 0xbbdf */
    OTHER,        /* 0xbbe0 */
    OTHER,        /* 0xbbe1 */
    OTHER,        /* 0xbbe2 */
    OTHER,        /* 0xbbe3 */
    OTHER,        /* 0xbbe4 */
    OTHER,        /* 0xbbe5 */
    OTHER,        /* 0xbbe6 */
    OTHER,        /* 0xbbe7 */
    OTHER,        /* 0xbbe8 */
    OTHER,        /* 0xbbe9 */
    OTHER,        /* 0xbbea */
    OTHER,        /* 0xbbeb */
    OTHER,        /* 0xbbec */
    OTHER,        /* 0xbbed */
    OTHER,        /* 0xbbee */
    OTHER,        /* 0xbbef */
    OTHER,        /* 0xbbf0 */
    OTHER,        /* 0xbbf1 */
    OTHER,        /* 0xbbf2 */
    OTHER,        /* 0xbbf3 */
    OTHER,        /* 0xbbf4 */
    OTHER,        /* 0xbbf5 */
    OTHER,        /* 0xbbf6 */
    OTHER,        /* 0xbbf7 */
    OTHER,        /* 0xbbf8 */
    OTHER,        /* 0xbbf9 */
    OTHER,        /* 0xbbfa */
    OTHER,        /* 0xbbfb */
    OTHER,        /* 0xbbfc */
    OTHER,        /* 0xbbfd */
    OTHER,        /* 0xbbfe */
    OTHER,        /* 0xbbff */
    OTHER,        /* 0xbc00 */
    OTHER,        /* 0xbc01 */
    OTHER,        /* 0xbc02 */
    OTHER,        /* 0xbc03 */
    OTHER,        /* 0xbc04 */
    OTHER,        /* 0xbc05 */
    OTHER,        /* 0xbc06 */
    OTHER,        /* 0xbc07 */
    OTHER,        /* 0xbc08 */
    OTHER,        /* 0xbc09 */
    OTHER,        /* 0xbc0a */
    OTHER,        /* 0xbc0b */
    OTHER,        /* 0xbc0c */
    OTHER,        /* 0xbc0d */
    OTHER,        /* 0xbc0e */
    OTHER,        /* 0xbc0f */
    OTHER,        /* 0xbc10 */
    OTHER,        /* 0xbc11 */
    OTHER,        /* 0xbc12 */
    OTHER,        /* 0xbc13 */
    OTHER,        /* 0xbc14 */
    OTHER,        /* 0xbc15 */
    OTHER,        /* 0xbc16 */
    OTHER,        /* 0xbc17 */
    OTHER,        /* 0xbc18 */
    OTHER,        /* 0xbc19 */
    OTHER,        /* 0xbc1a */
    OTHER,        /* 0xbc1b */
    OTHER,        /* 0xbc1c */
    OTHER,        /* 0xbc1d */
    OTHER,        /* 0xbc1e */
    OTHER,        /* 0xbc1f */
    OTHER,        /* 0xbc20 */
    OTHER,        /* 0xbc21 */
    OTHER,        /* 0xbc22 */
    OTHER,        /* 0xbc23 */
    OTHER,        /* 0xbc24 */
    OTHER,        /* 0xbc25 */
    OTHER,        /* 0xbc26 */
    OTHER,        /* 0xbc27 */
    OTHER,        /* 0xbc28 */
    OTHER,        /* 0xbc29 */
    OTHER,        /* 0xbc2a */
    OTHER,        /* 0xbc2b */
    OTHER,        /* 0xbc2c */
    OTHER,        /* 0xbc2d */
    OTHER,        /* 0xbc2e */
    OTHER,        /* 0xbc2f */
    OTHER,        /* 0xbc30 */
    OTHER,        /* 0xbc31 */
    OTHER,        /* 0xbc32 */
    OTHER,        /* 0xbc33 */
    OTHER,        /* 0xbc34 */
    OTHER,        /* 0xbc35 */
    OTHER,        /* 0xbc36 */
    OTHER,        /* 0xbc37 */
    OTHER,        /* 0xbc38 */
    OTHER,        /* 0xbc39 */
    OTHER,        /* 0xbc3a */
    OTHER,        /* 0xbc3b */
    OTHER,        /* 0xbc3c */
    OTHER,        /* 0xbc3d */
    OTHER,        /* 0xbc3e */
    OTHER,        /* 0xbc3f */
    OTHER,        /* 0xbc40 */
    OTHER,        /* 0xbc41 */
    OTHER,        /* 0xbc42 */
    OTHER,        /* 0xbc43 */
    OTHER,        /* 0xbc44 */
    OTHER,        /* 0xbc45 */
    OTHER,        /* 0xbc46 */
    OTHER,        /* 0xbc47 */
    OTHER,        /* 0xbc48 */
    OTHER,        /* 0xbc49 */
    OTHER,        /* 0xbc4a */
    OTHER,        /* 0xbc4b */
    OTHER,        /* 0xbc4c */
    OTHER,        /* 0xbc4d */
    OTHER,        /* 0xbc4e */
    OTHER,        /* 0xbc4f */
    OTHER,        /* 0xbc50 */
    OTHER,        /* 0xbc51 */
    OTHER,        /* 0xbc52 */
    OTHER,        /* 0xbc53 */
    OTHER,        /* 0xbc54 */
    OTHER,        /* 0xbc55 */
    OTHER,        /* 0xbc56 */
    OTHER,        /* 0xbc57 */
    OTHER,        /* 0xbc58 */
    OTHER,        /* 0xbc59 */
    OTHER,        /* 0xbc5a */
    OTHER,        /* 0xbc5b */
    OTHER,        /* 0xbc5c */
    OTHER,        /* 0xbc5d */
    OTHER,        /* 0xbc5e */
    OTHER,        /* 0xbc5f */
    OTHER,        /* 0xbc60 */
    OTHER,        /* 0xbc61 */
    OTHER,        /* 0xbc62 */
    OTHER,        /* 0xbc63 */
    OTHER,        /* 0xbc64 */
    OTHER,        /* 0xbc65 */
    OTHER,        /* 0xbc66 */
    OTHER,        /* 0xbc67 */
    OTHER,        /* 0xbc68 */
    OTHER,        /* 0xbc69 */
    OTHER,        /* 0xbc6a */
    OTHER,        /* 0xbc6b */
    OTHER,        /* 0xbc6c */
    OTHER,        /* 0xbc6d */
    OTHER,        /* 0xbc6e */
    OTHER,        /* 0xbc6f */
    OTHER,        /* 0xbc70 */
    OTHER,        /* 0xbc71 */
    OTHER,        /* 0xbc72 */
    OTHER,        /* 0xbc73 */
    OTHER,        /* 0xbc74 */
    OTHER,        /* 0xbc75 */
    OTHER,        /* 0xbc76 */
    OTHER,        /* 0xbc77 */
    OTHER,        /* 0xbc78 */
    OTHER,        /* 0xbc79 */
    OTHER,        /* 0xbc7a */
    OTHER,        /* 0xbc7b */
    OTHER,        /* 0xbc7c */
    OTHER,        /* 0xbc7d */
    OTHER,        /* 0xbc7e */
    OTHER,        /* 0xbc7f */
    OTHER,        /* 0xbc80 */
    OTHER,        /* 0xbc81 */
    OTHER,        /* 0xbc82 */
    OTHER,        /* 0xbc83 */
    OTHER,        /* 0xbc84 */
    OTHER,        /* 0xbc85 */
    OTHER,        /* 0xbc86 */
    OTHER,        /* 0xbc87 */
    OTHER,        /* 0xbc88 */
    OTHER,        /* 0xbc89 */
    OTHER,        /* 0xbc8a */
    OTHER,        /* 0xbc8b */
    OTHER,        /* 0xbc8c */
    OTHER,        /* 0xbc8d */
    OTHER,        /* 0xbc8e */
    OTHER,        /* 0xbc8f */
    OTHER,        /* 0xbc90 */
    OTHER,        /* 0xbc91 */
    OTHER,        /* 0xbc92 */
    OTHER,        /* 0xbc93 */
    OTHER,        /* 0xbc94 */
    OTHER,        /* 0xbc95 */
    OTHER,        /* 0xbc96 */
    OTHER,        /* 0xbc97 */
    OTHER,        /* 0xbc98 */
    OTHER,        /* 0xbc99 */
    OTHER,        /* 0xbc9a */
    OTHER,        /* 0xbc9b */
    OTHER,        /* 0xbc9c */
    OTHER,        /* 0xbc9d */
    OTHER,        /* 0xbc9e */
    OTHER,        /* 0xbc9f */
    OTHER,        /* 0xbca0 */
    OTHER,        /* 0xbca1 */
    OTHER,        /* 0xbca2 */
    OTHER,        /* 0xbca3 */
    OTHER,        /* 0xbca4 */
    OTHER,        /* 0xbca5 */
    OTHER,        /* 0xbca6 */
    OTHER,        /* 0xbca7 */
    OTHER,        /* 0xbca8 */
    OTHER,        /* 0xbca9 */
    OTHER,        /* 0xbcaa */
    OTHER,        /* 0xbcab */
    OTHER,        /* 0xbcac */
    OTHER,        /* 0xbcad */
    OTHER,        /* 0xbcae */
    OTHER,        /* 0xbcaf */
    OTHER,        /* 0xbcb0 */
    OTHER,        /* 0xbcb1 */
    OTHER,        /* 0xbcb2 */
    OTHER,        /* 0xbcb3 */
    OTHER,        /* 0xbcb4 */
    OTHER,        /* 0xbcb5 */
    OTHER,        /* 0xbcb6 */
    OTHER,        /* 0xbcb7 */
    OTHER,        /* 0xbcb8 */
    OTHER,        /* 0xbcb9 */
    OTHER,        /* 0xbcba */
    OTHER,        /* 0xbcbb */
    OTHER,        /* 0xbcbc */
    OTHER,        /* 0xbcbd */
    OTHER,        /* 0xbcbe */
    OTHER,        /* 0xbcbf */
    OTHER,        /* 0xbcc0 */
    OTHER,        /* 0xbcc1 */
    OTHER,        /* 0xbcc2 */
    OTHER,        /* 0xbcc3 */
    OTHER,        /* 0xbcc4 */
    OTHER,        /* 0xbcc5 */
    OTHER,        /* 0xbcc6 */
    OTHER,        /* 0xbcc7 */
    OTHER,        /* 0xbcc8 */
    OTHER,        /* 0xbcc9 */
    OTHER,        /* 0xbcca */
    OTHER,        /* 0xbccb */
    OTHER,        /* 0xbccc */
    OTHER,        /* 0xbccd */
    OTHER,        /* 0xbcce */
    OTHER,        /* 0xbccf */
    OTHER,        /* 0xbcd0 */
    OTHER,        /* 0xbcd1 */
    OTHER,        /* 0xbcd2 */
    OTHER,        /* 0xbcd3 */
    OTHER,        /* 0xbcd4 */
    OTHER,        /* 0xbcd5 */
    OTHER,        /* 0xbcd6 */
    OTHER,        /* 0xbcd7 */
    OTHER,        /* 0xbcd8 */
    OTHER,        /* 0xbcd9 */
    OTHER,        /* 0xbcda */
    OTHER,        /* 0xbcdb */
    OTHER,        /* 0xbcdc */
    OTHER,        /* 0xbcdd */
    OTHER,        /* 0xbcde */
    OTHER,        /* 0xbcdf */
    OTHER,        /* 0xbce0 */
    OTHER,        /* 0xbce1 */
    OTHER,        /* 0xbce2 */
    OTHER,        /* 0xbce3 */
    OTHER,        /* 0xbce4 */
    OTHER,        /* 0xbce5 */
    OTHER,        /* 0xbce6 */
    OTHER,        /* 0xbce7 */
    OTHER,        /* 0xbce8 */
    OTHER,        /* 0xbce9 */
    OTHER,        /* 0xbcea */
    OTHER,        /* 0xbceb */
    OTHER,        /* 0xbcec */
    OTHER,        /* 0xbced */
    OTHER,        /* 0xbcee */
    OTHER,        /* 0xbcef */
    OTHER,        /* 0xbcf0 */
    OTHER,        /* 0xbcf1 */
    OTHER,        /* 0xbcf2 */
    OTHER,        /* 0xbcf3 */
    OTHER,        /* 0xbcf4 */
    OTHER,        /* 0xbcf5 */
    OTHER,        /* 0xbcf6 */
    OTHER,        /* 0xbcf7 */
    OTHER,        /* 0xbcf8 */
    OTHER,        /* 0xbcf9 */
    OTHER,        /* 0xbcfa */
    OTHER,        /* 0xbcfb */
    OTHER,        /* 0xbcfc */
    OTHER,        /* 0xbcfd */
    OTHER,        /* 0xbcfe */
    OTHER,        /* 0xbcff */
    OTHER,        /* 0xbd00 */
    OTHER,        /* 0xbd01 */
    OTHER,        /* 0xbd02 */
    OTHER,        /* 0xbd03 */
    OTHER,        /* 0xbd04 */
    OTHER,        /* 0xbd05 */
    OTHER,        /* 0xbd06 */
    OTHER,        /* 0xbd07 */
    OTHER,        /* 0xbd08 */
    OTHER,        /* 0xbd09 */
    OTHER,        /* 0xbd0a */
    OTHER,        /* 0xbd0b */
    OTHER,        /* 0xbd0c */
    OTHER,        /* 0xbd0d */
    OTHER,        /* 0xbd0e */
    OTHER,        /* 0xbd0f */
    OTHER,        /* 0xbd10 */
    OTHER,        /* 0xbd11 */
    OTHER,        /* 0xbd12 */
    OTHER,        /* 0xbd13 */
    OTHER,        /* 0xbd14 */
    OTHER,        /* 0xbd15 */
    OTHER,        /* 0xbd16 */
    OTHER,        /* 0xbd17 */
    OTHER,        /* 0xbd18 */
    OTHER,        /* 0xbd19 */
    OTHER,        /* 0xbd1a */
    OTHER,        /* 0xbd1b */
    OTHER,        /* 0xbd1c */
    OTHER,        /* 0xbd1d */
    OTHER,        /* 0xbd1e */
    OTHER,        /* 0xbd1f */
    OTHER,        /* 0xbd20 */
    OTHER,        /* 0xbd21 */
    OTHER,        /* 0xbd22 */
    OTHER,        /* 0xbd23 */
    OTHER,        /* 0xbd24 */
    OTHER,        /* 0xbd25 */
    OTHER,        /* 0xbd26 */
    OTHER,        /* 0xbd27 */
    OTHER,        /* 0xbd28 */
    OTHER,        /* 0xbd29 */
    OTHER,        /* 0xbd2a */
    OTHER,        /* 0xbd2b */
    OTHER,        /* 0xbd2c */
    OTHER,        /* 0xbd2d */
    OTHER,        /* 0xbd2e */
    OTHER,        /* 0xbd2f */
    OTHER,        /* 0xbd30 */
    OTHER,        /* 0xbd31 */
    OTHER,        /* 0xbd32 */
    OTHER,        /* 0xbd33 */
    OTHER,        /* 0xbd34 */
    OTHER,        /* 0xbd35 */
    OTHER,        /* 0xbd36 */
    OTHER,        /* 0xbd37 */
    OTHER,        /* 0xbd38 */
    OTHER,        /* 0xbd39 */
    OTHER,        /* 0xbd3a */
    OTHER,        /* 0xbd3b */
    OTHER,        /* 0xbd3c */
    OTHER,        /* 0xbd3d */
    OTHER,        /* 0xbd3e */
    OTHER,        /* 0xbd3f */
    OTHER,        /* 0xbd40 */
    OTHER,        /* 0xbd41 */
    OTHER,        /* 0xbd42 */
    OTHER,        /* 0xbd43 */
    OTHER,        /* 0xbd44 */
    OTHER,        /* 0xbd45 */
    OTHER,        /* 0xbd46 */
    OTHER,        /* 0xbd47 */
    OTHER,        /* 0xbd48 */
    OTHER,        /* 0xbd49 */
    OTHER,        /* 0xbd4a */
    OTHER,        /* 0xbd4b */
    OTHER,        /* 0xbd4c */
    OTHER,        /* 0xbd4d */
    OTHER,        /* 0xbd4e */
    OTHER,        /* 0xbd4f */
    OTHER,        /* 0xbd50 */
    OTHER,        /* 0xbd51 */
    OTHER,        /* 0xbd52 */
    OTHER,        /* 0xbd53 */
    OTHER,        /* 0xbd54 */
    OTHER,        /* 0xbd55 */
    OTHER,        /* 0xbd56 */
    OTHER,        /* 0xbd57 */
    OTHER,        /* 0xbd58 */
    OTHER,        /* 0xbd59 */
    OTHER,        /* 0xbd5a */
    OTHER,        /* 0xbd5b */
    OTHER,        /* 0xbd5c */
    OTHER,        /* 0xbd5d */
    OTHER,        /* 0xbd5e */
    OTHER,        /* 0xbd5f */
    OTHER,        /* 0xbd60 */
    OTHER,        /* 0xbd61 */
    OTHER,        /* 0xbd62 */
    OTHER,        /* 0xbd63 */
    OTHER,        /* 0xbd64 */
    OTHER,        /* 0xbd65 */
    OTHER,        /* 0xbd66 */
    OTHER,        /* 0xbd67 */
    OTHER,        /* 0xbd68 */
    OTHER,        /* 0xbd69 */
    OTHER,        /* 0xbd6a */
    OTHER,        /* 0xbd6b */
    OTHER,        /* 0xbd6c */
    OTHER,        /* 0xbd6d */
    OTHER,        /* 0xbd6e */
    OTHER,        /* 0xbd6f */
    OTHER,        /* 0xbd70 */
    OTHER,        /* 0xbd71 */
    OTHER,        /* 0xbd72 */
    OTHER,        /* 0xbd73 */
    OTHER,        /* 0xbd74 */
    OTHER,        /* 0xbd75 */
    OTHER,        /* 0xbd76 */
    OTHER,        /* 0xbd77 */
    OTHER,        /* 0xbd78 */
    OTHER,        /* 0xbd79 */
    OTHER,        /* 0xbd7a */
    OTHER,        /* 0xbd7b */
    OTHER,        /* 0xbd7c */
    OTHER,        /* 0xbd7d */
    OTHER,        /* 0xbd7e */
    OTHER,        /* 0xbd7f */
    OTHER,        /* 0xbd80 */
    OTHER,        /* 0xbd81 */
    OTHER,        /* 0xbd82 */
    OTHER,        /* 0xbd83 */
    OTHER,        /* 0xbd84 */
    OTHER,        /* 0xbd85 */
    OTHER,        /* 0xbd86 */
    OTHER,        /* 0xbd87 */
    OTHER,        /* 0xbd88 */
    OTHER,        /* 0xbd89 */
    OTHER,        /* 0xbd8a */
    OTHER,        /* 0xbd8b */
    OTHER,        /* 0xbd8c */
    OTHER,        /* 0xbd8d */
    OTHER,        /* 0xbd8e */
    OTHER,        /* 0xbd8f */
    OTHER,        /* 0xbd90 */
    OTHER,        /* 0xbd91 */
    OTHER,        /* 0xbd92 */
    OTHER,        /* 0xbd93 */
    OTHER,        /* 0xbd94 */
    OTHER,        /* 0xbd95 */
    OTHER,        /* 0xbd96 */
    OTHER,        /* 0xbd97 */
    OTHER,        /* 0xbd98 */
    OTHER,        /* 0xbd99 */
    OTHER,        /* 0xbd9a */
    OTHER,        /* 0xbd9b */
    OTHER,        /* 0xbd9c */
    OTHER,        /* 0xbd9d */
    OTHER,        /* 0xbd9e */
    OTHER,        /* 0xbd9f */
    OTHER,        /* 0xbda0 */
    OTHER,        /* 0xbda1 */
    OTHER,        /* 0xbda2 */
    OTHER,        /* 0xbda3 */
    OTHER,        /* 0xbda4 */
    OTHER,        /* 0xbda5 */
    OTHER,        /* 0xbda6 */
    OTHER,        /* 0xbda7 */
    OTHER,        /* 0xbda8 */
    OTHER,        /* 0xbda9 */
    OTHER,        /* 0xbdaa */
    OTHER,        /* 0xbdab */
    OTHER,        /* 0xbdac */
    OTHER,        /* 0xbdad */
    OTHER,        /* 0xbdae */
    OTHER,        /* 0xbdaf */
    OTHER,        /* 0xbdb0 */
    OTHER,        /* 0xbdb1 */
    OTHER,        /* 0xbdb2 */
    OTHER,        /* 0xbdb3 */
    OTHER,        /* 0xbdb4 */
    OTHER,        /* 0xbdb5 */
    OTHER,        /* 0xbdb6 */
    OTHER,        /* 0xbdb7 */
    OTHER,        /* 0xbdb8 */
    OTHER,        /* 0xbdb9 */
    OTHER,        /* 0xbdba */
    OTHER,        /* 0xbdbb */
    OTHER,        /* 0xbdbc */
    OTHER,        /* 0xbdbd */
    OTHER,        /* 0xbdbe */
    OTHER,        /* 0xbdbf */
    OTHER,        /* 0xbdc0 */
    OTHER,        /* 0xbdc1 */
    OTHER,        /* 0xbdc2 */
    OTHER,        /* 0xbdc3 */
    OTHER,        /* 0xbdc4 */
    OTHER,        /* 0xbdc5 */
    OTHER,        /* 0xbdc6 */
    OTHER,        /* 0xbdc7 */
    OTHER,        /* 0xbdc8 */
    OTHER,        /* 0xbdc9 */
    OTHER,        /* 0xbdca */
    OTHER,        /* 0xbdcb */
    OTHER,        /* 0xbdcc */
    OTHER,        /* 0xbdcd */
    OTHER,        /* 0xbdce */
    OTHER,        /* 0xbdcf */
    OTHER,        /* 0xbdd0 */
    OTHER,        /* 0xbdd1 */
    OTHER,        /* 0xbdd2 */
    OTHER,        /* 0xbdd3 */
    OTHER,        /* 0xbdd4 */
    OTHER,        /* 0xbdd5 */
    OTHER,        /* 0xbdd6 */
    OTHER,        /* 0xbdd7 */
    OTHER,        /* 0xbdd8 */
    OTHER,        /* 0xbdd9 */
    OTHER,        /* 0xbdda */
    OTHER,        /* 0xbddb */
    OTHER,        /* 0xbddc */
    OTHER,        /* 0xbddd */
    OTHER,        /* 0xbdde */
    OTHER,        /* 0xbddf */
    OTHER,        /* 0xbde0 */
    OTHER,        /* 0xbde1 */
    OTHER,        /* 0xbde2 */
    OTHER,        /* 0xbde3 */
    OTHER,        /* 0xbde4 */
    OTHER,        /* 0xbde5 */
    OTHER,        /* 0xbde6 */
    OTHER,        /* 0xbde7 */
    OTHER,        /* 0xbde8 */
    OTHER,        /* 0xbde9 */
    OTHER,        /* 0xbdea */
    OTHER,        /* 0xbdeb */
    OTHER,        /* 0xbdec */
    OTHER,        /* 0xbded */
    OTHER,        /* 0xbdee */
    OTHER,        /* 0xbdef */
    OTHER,        /* 0xbdf0 */
    OTHER,        /* 0xbdf1 */
    OTHER,        /* 0xbdf2 */
    OTHER,        /* 0xbdf3 */
    OTHER,        /* 0xbdf4 */
    OTHER,        /* 0xbdf5 */
    OTHER,        /* 0xbdf6 */
    OTHER,        /* 0xbdf7 */
    OTHER,        /* 0xbdf8 */
    OTHER,        /* 0xbdf9 */
    OTHER,        /* 0xbdfa */
    OTHER,        /* 0xbdfb */
    OTHER,        /* 0xbdfc */
    OTHER,        /* 0xbdfd */
    OTHER,        /* 0xbdfe */
    OTHER,        /* 0xbdff */
    OTHER,        /* 0xbe00 */
    OTHER,        /* 0xbe01 */
    OTHER,        /* 0xbe02 */
    OTHER,        /* 0xbe03 */
    OTHER,        /* 0xbe04 */
    OTHER,        /* 0xbe05 */
    OTHER,        /* 0xbe06 */
    OTHER,        /* 0xbe07 */
    OTHER,        /* 0xbe08 */
    OTHER,        /* 0xbe09 */
    OTHER,        /* 0xbe0a */
    OTHER,        /* 0xbe0b */
    OTHER,        /* 0xbe0c */
    OTHER,        /* 0xbe0d */
    OTHER,        /* 0xbe0e */
    OTHER,        /* 0xbe0f */
    OTHER,        /* 0xbe10 */
    OTHER,        /* 0xbe11 */
    OTHER,        /* 0xbe12 */
    OTHER,        /* 0xbe13 */
    OTHER,        /* 0xbe14 */
    OTHER,        /* 0xbe15 */
    OTHER,        /* 0xbe16 */
    OTHER,        /* 0xbe17 */
    OTHER,        /* 0xbe18 */
    OTHER,        /* 0xbe19 */
    OTHER,        /* 0xbe1a */
    OTHER,        /* 0xbe1b */
    OTHER,        /* 0xbe1c */
    OTHER,        /* 0xbe1d */
    OTHER,        /* 0xbe1e */
    OTHER,        /* 0xbe1f */
    OTHER,        /* 0xbe20 */
    OTHER,        /* 0xbe21 */
    OTHER,        /* 0xbe22 */
    OTHER,        /* 0xbe23 */
    OTHER,        /* 0xbe24 */
    OTHER,        /* 0xbe25 */
    OTHER,        /* 0xbe26 */
    OTHER,        /* 0xbe27 */
    OTHER,        /* 0xbe28 */
    OTHER,        /* 0xbe29 */
    OTHER,        /* 0xbe2a */
    OTHER,        /* 0xbe2b */
    OTHER,        /* 0xbe2c */
    OTHER,        /* 0xbe2d */
    OTHER,        /* 0xbe2e */
    OTHER,        /* 0xbe2f */
    OTHER,        /* 0xbe30 */
    OTHER,        /* 0xbe31 */
    OTHER,        /* 0xbe32 */
    OTHER,        /* 0xbe33 */
    OTHER,        /* 0xbe34 */
    OTHER,        /* 0xbe35 */
    OTHER,        /* 0xbe36 */
    OTHER,        /* 0xbe37 */
    OTHER,        /* 0xbe38 */
    OTHER,        /* 0xbe39 */
    OTHER,        /* 0xbe3a */
    OTHER,        /* 0xbe3b */
    OTHER,        /* 0xbe3c */
    OTHER,        /* 0xbe3d */
    OTHER,        /* 0xbe3e */
    OTHER,        /* 0xbe3f */
    OTHER,        /* 0xbe40 */
    OTHER,        /* 0xbe41 */
    OTHER,        /* 0xbe42 */
    OTHER,        /* 0xbe43 */
    OTHER,        /* 0xbe44 */
    OTHER,        /* 0xbe45 */
    OTHER,        /* 0xbe46 */
    OTHER,        /* 0xbe47 */
    OTHER,        /* 0xbe48 */
    OTHER,        /* 0xbe49 */
    OTHER,        /* 0xbe4a */
    OTHER,        /* 0xbe4b */
    OTHER,        /* 0xbe4c */
    OTHER,        /* 0xbe4d */
    OTHER,        /* 0xbe4e */
    OTHER,        /* 0xbe4f */
    OTHER,        /* 0xbe50 */
    OTHER,        /* 0xbe51 */
    OTHER,        /* 0xbe52 */
    OTHER,        /* 0xbe53 */
    OTHER,        /* 0xbe54 */
    OTHER,        /* 0xbe55 */
    OTHER,        /* 0xbe56 */
    OTHER,        /* 0xbe57 */
    OTHER,        /* 0xbe58 */
    OTHER,        /* 0xbe59 */
    OTHER,        /* 0xbe5a */
    OTHER,        /* 0xbe5b */
    OTHER,        /* 0xbe5c */
    OTHER,        /* 0xbe5d */
    OTHER,        /* 0xbe5e */
    OTHER,        /* 0xbe5f */
    OTHER,        /* 0xbe60 */
    OTHER,        /* 0xbe61 */
    OTHER,        /* 0xbe62 */
    OTHER,        /* 0xbe63 */
    OTHER,        /* 0xbe64 */
    OTHER,        /* 0xbe65 */
    OTHER,        /* 0xbe66 */
    OTHER,        /* 0xbe67 */
    OTHER,        /* 0xbe68 */
    OTHER,        /* 0xbe69 */
    OTHER,        /* 0xbe6a */
    OTHER,        /* 0xbe6b */
    OTHER,        /* 0xbe6c */
    OTHER,        /* 0xbe6d */
    OTHER,        /* 0xbe6e */
    OTHER,        /* 0xbe6f */
    OTHER,        /* 0xbe70 */
    OTHER,        /* 0xbe71 */
    OTHER,        /* 0xbe72 */
    OTHER,        /* 0xbe73 */
    OTHER,        /* 0xbe74 */
    OTHER,        /* 0xbe75 */
    OTHER,        /* 0xbe76 */
    OTHER,        /* 0xbe77 */
    OTHER,        /* 0xbe78 */
    OTHER,        /* 0xbe79 */
    OTHER,        /* 0xbe7a */
    OTHER,        /* 0xbe7b */
    OTHER,        /* 0xbe7c */
    OTHER,        /* 0xbe7d */
    OTHER,        /* 0xbe7e */
    OTHER,        /* 0xbe7f */
    OTHER,        /* 0xbe80 */
    OTHER,        /* 0xbe81 */
    OTHER,        /* 0xbe82 */
    OTHER,        /* 0xbe83 */
    OTHER,        /* 0xbe84 */
    OTHER,        /* 0xbe85 */
    OTHER,        /* 0xbe86 */
    OTHER,        /* 0xbe87 */
    OTHER,        /* 0xbe88 */
    OTHER,        /* 0xbe89 */
    OTHER,        /* 0xbe8a */
    OTHER,        /* 0xbe8b */
    OTHER,        /* 0xbe8c */
    OTHER,        /* 0xbe8d */
    OTHER,        /* 0xbe8e */
    OTHER,        /* 0xbe8f */
    OTHER,        /* 0xbe90 */
    OTHER,        /* 0xbe91 */
    OTHER,        /* 0xbe92 */
    OTHER,        /* 0xbe93 */
    OTHER,        /* 0xbe94 */
    OTHER,        /* 0xbe95 */
    OTHER,        /* 0xbe96 */
    OTHER,        /* 0xbe97 */
    OTHER,        /* 0xbe98 */
    OTHER,        /* 0xbe99 */
    OTHER,        /* 0xbe9a */
    OTHER,        /* 0xbe9b */
    OTHER,        /* 0xbe9c */
    OTHER,        /* 0xbe9d */
    OTHER,        /* 0xbe9e */
    OTHER,        /* 0xbe9f */
    OTHER,        /* 0xbea0 */
    OTHER,        /* 0xbea1 */
    OTHER,        /* 0xbea2 */
    OTHER,        /* 0xbea3 */
    OTHER,        /* 0xbea4 */
    OTHER,        /* 0xbea5 */
    OTHER,        /* 0xbea6 */
    OTHER,        /* 0xbea7 */
    OTHER,        /* 0xbea8 */
    OTHER,        /* 0xbea9 */
    OTHER,        /* 0xbeaa */
    OTHER,        /* 0xbeab */
    OTHER,        /* 0xbeac */
    OTHER,        /* 0xbead */
    OTHER,        /* 0xbeae */
    OTHER,        /* 0xbeaf */
    OTHER,        /* 0xbeb0 */
    OTHER,        /* 0xbeb1 */
    OTHER,        /* 0xbeb2 */
    OTHER,        /* 0xbeb3 */
    OTHER,        /* 0xbeb4 */
    OTHER,        /* 0xbeb5 */
    OTHER,        /* 0xbeb6 */
    OTHER,        /* 0xbeb7 */
    OTHER,        /* 0xbeb8 */
    OTHER,        /* 0xbeb9 */
    OTHER,        /* 0xbeba */
    OTHER,        /* 0xbebb */
    OTHER,        /* 0xbebc */
    OTHER,        /* 0xbebd */
    OTHER,        /* 0xbebe */
    OTHER,        /* 0xbebf */
    OTHER,        /* 0xbec0 */
    OTHER,        /* 0xbec1 */
    OTHER,        /* 0xbec2 */
    OTHER,        /* 0xbec3 */
    OTHER,        /* 0xbec4 */
    OTHER,        /* 0xbec5 */
    OTHER,        /* 0xbec6 */
    OTHER,        /* 0xbec7 */
    OTHER,        /* 0xbec8 */
    OTHER,        /* 0xbec9 */
    OTHER,        /* 0xbeca */
    OTHER,        /* 0xbecb */
    OTHER,        /* 0xbecc */
    OTHER,        /* 0xbecd */
    OTHER,        /* 0xbece */
    OTHER,        /* 0xbecf */
    OTHER,        /* 0xbed0 */
    OTHER,        /* 0xbed1 */
    OTHER,        /* 0xbed2 */
    OTHER,        /* 0xbed3 */
    OTHER,        /* 0xbed4 */
    OTHER,        /* 0xbed5 */
    OTHER,        /* 0xbed6 */
    OTHER,        /* 0xbed7 */
    OTHER,        /* 0xbed8 */
    OTHER,        /* 0xbed9 */
    OTHER,        /* 0xbeda */
    OTHER,        /* 0xbedb */
    OTHER,        /* 0xbedc */
    OTHER,        /* 0xbedd */
    OTHER,        /* 0xbede */
    OTHER,        /* 0xbedf */
    OTHER,        /* 0xbee0 */
    OTHER,        /* 0xbee1 */
    OTHER,        /* 0xbee2 */
    OTHER,        /* 0xbee3 */
    OTHER,        /* 0xbee4 */
    OTHER,        /* 0xbee5 */
    OTHER,        /* 0xbee6 */
    OTHER,        /* 0xbee7 */
    OTHER,        /* 0xbee8 */
    OTHER,        /* 0xbee9 */
    OTHER,        /* 0xbeea */
    OTHER,        /* 0xbeeb */
    OTHER,        /* 0xbeec */
    OTHER,        /* 0xbeed */
    OTHER,        /* 0xbeee */
    OTHER,        /* 0xbeef */
    OTHER,        /* 0xbef0 */
    OTHER,        /* 0xbef1 */
    OTHER,        /* 0xbef2 */
    OTHER,        /* 0xbef3 */
    OTHER,        /* 0xbef4 */
    OTHER,        /* 0xbef5 */
    OTHER,        /* 0xbef6 */
    OTHER,        /* 0xbef7 */
    OTHER,        /* 0xbef8 */
    OTHER,        /* 0xbef9 */
    OTHER,        /* 0xbefa */
    OTHER,        /* 0xbefb */
    OTHER,        /* 0xbefc */
    OTHER,        /* 0xbefd */
    OTHER,        /* 0xbefe */
    OTHER,        /* 0xbeff */
    OTHER,        /* 0xbf00 */
    OTHER,        /* 0xbf01 */
    OTHER,        /* 0xbf02 */
    OTHER,        /* 0xbf03 */
    OTHER,        /* 0xbf04 */
    OTHER,        /* 0xbf05 */
    OTHER,        /* 0xbf06 */
    OTHER,        /* 0xbf07 */
    OTHER,        /* 0xbf08 */
    OTHER,        /* 0xbf09 */
    OTHER,        /* 0xbf0a */
    OTHER,        /* 0xbf0b */
    OTHER,        /* 0xbf0c */
    OTHER,        /* 0xbf0d */
    OTHER,        /* 0xbf0e */
    OTHER,        /* 0xbf0f */
    OTHER,        /* 0xbf10 */
    OTHER,        /* 0xbf11 */
    OTHER,        /* 0xbf12 */
    OTHER,        /* 0xbf13 */
    OTHER,        /* 0xbf14 */
    OTHER,        /* 0xbf15 */
    OTHER,        /* 0xbf16 */
    OTHER,        /* 0xbf17 */
    OTHER,        /* 0xbf18 */
    OTHER,        /* 0xbf19 */
    OTHER,        /* 0xbf1a */
    OTHER,        /* 0xbf1b */
    OTHER,        /* 0xbf1c */
    OTHER,        /* 0xbf1d */
    OTHER,        /* 0xbf1e */
    OTHER,        /* 0xbf1f */
    OTHER,        /* 0xbf20 */
    OTHER,        /* 0xbf21 */
    OTHER,        /* 0xbf22 */
    OTHER,        /* 0xbf23 */
    OTHER,        /* 0xbf24 */
    OTHER,        /* 0xbf25 */
    OTHER,        /* 0xbf26 */
    OTHER,        /* 0xbf27 */
    OTHER,        /* 0xbf28 */
    OTHER,        /* 0xbf29 */
    OTHER,        /* 0xbf2a */
    OTHER,        /* 0xbf2b */
    OTHER,        /* 0xbf2c */
    OTHER,        /* 0xbf2d */
    OTHER,        /* 0xbf2e */
    OTHER,        /* 0xbf2f */
    OTHER,        /* 0xbf30 */
    OTHER,        /* 0xbf31 */
    OTHER,        /* 0xbf32 */
    OTHER,        /* 0xbf33 */
    OTHER,        /* 0xbf34 */
    OTHER,        /* 0xbf35 */
    OTHER,        /* 0xbf36 */
    OTHER,        /* 0xbf37 */
    OTHER,        /* 0xbf38 */
    OTHER,        /* 0xbf39 */
    OTHER,        /* 0xbf3a */
    OTHER,        /* 0xbf3b */
    OTHER,        /* 0xbf3c */
    OTHER,        /* 0xbf3d */
    OTHER,        /* 0xbf3e */
    OTHER,        /* 0xbf3f */
    OTHER,        /* 0xbf40 */
    OTHER,        /* 0xbf41 */
    OTHER,        /* 0xbf42 */
    OTHER,        /* 0xbf43 */
    OTHER,        /* 0xbf44 */
    OTHER,        /* 0xbf45 */
    OTHER,        /* 0xbf46 */
    OTHER,        /* 0xbf47 */
    OTHER,        /* 0xbf48 */
    OTHER,        /* 0xbf49 */
    OTHER,        /* 0xbf4a */
    OTHER,        /* 0xbf4b */
    OTHER,        /* 0xbf4c */
    OTHER,        /* 0xbf4d */
    OTHER,        /* 0xbf4e */
    OTHER,        /* 0xbf4f */
    OTHER,        /* 0xbf50 */
    OTHER,        /* 0xbf51 */
    OTHER,        /* 0xbf52 */
    OTHER,        /* 0xbf53 */
    OTHER,        /* 0xbf54 */
    OTHER,        /* 0xbf55 */
    OTHER,        /* 0xbf56 */
    OTHER,        /* 0xbf57 */
    OTHER,        /* 0xbf58 */
    OTHER,        /* 0xbf59 */
    OTHER,        /* 0xbf5a */
    OTHER,        /* 0xbf5b */
    OTHER,        /* 0xbf5c */
    OTHER,        /* 0xbf5d */
    OTHER,        /* 0xbf5e */
    OTHER,        /* 0xbf5f */
    OTHER,        /* 0xbf60 */
    OTHER,        /* 0xbf61 */
    OTHER,        /* 0xbf62 */
    OTHER,        /* 0xbf63 */
    OTHER,        /* 0xbf64 */
    OTHER,        /* 0xbf65 */
    OTHER,        /* 0xbf66 */
    OTHER,        /* 0xbf67 */
    OTHER,        /* 0xbf68 */
    OTHER,        /* 0xbf69 */
    OTHER,        /* 0xbf6a */
    OTHER,        /* 0xbf6b */
    OTHER,        /* 0xbf6c */
    OTHER,        /* 0xbf6d */
    OTHER,        /* 0xbf6e */
    OTHER,        /* 0xbf6f */
    OTHER,        /* 0xbf70 */
    OTHER,        /* 0xbf71 */
    OTHER,        /* 0xbf72 */
    OTHER,        /* 0xbf73 */
    OTHER,        /* 0xbf74 */
    OTHER,        /* 0xbf75 */
    OTHER,        /* 0xbf76 */
    OTHER,        /* 0xbf77 */
    OTHER,        /* 0xbf78 */
    OTHER,        /* 0xbf79 */
    OTHER,        /* 0xbf7a */
    OTHER,        /* 0xbf7b */
    OTHER,        /* 0xbf7c */
    OTHER,        /* 0xbf7d */
    OTHER,        /* 0xbf7e */
    OTHER,        /* 0xbf7f */
    OTHER,        /* 0xbf80 */
    OTHER,        /* 0xbf81 */
    OTHER,        /* 0xbf82 */
    OTHER,        /* 0xbf83 */
    OTHER,        /* 0xbf84 */
    OTHER,        /* 0xbf85 */
    OTHER,        /* 0xbf86 */
    OTHER,        /* 0xbf87 */
    OTHER,        /* 0xbf88 */
    OTHER,        /* 0xbf89 */
    OTHER,        /* 0xbf8a */
    OTHER,        /* 0xbf8b */
    OTHER,        /* 0xbf8c */
    OTHER,        /* 0xbf8d */
    OTHER,        /* 0xbf8e */
    OTHER,        /* 0xbf8f */
    OTHER,        /* 0xbf90 */
    OTHER,        /* 0xbf91 */
    OTHER,        /* 0xbf92 */
    OTHER,        /* 0xbf93 */
    OTHER,        /* 0xbf94 */
    OTHER,        /* 0xbf95 */
    OTHER,        /* 0xbf96 */
    OTHER,        /* 0xbf97 */
    OTHER,        /* 0xbf98 */
    OTHER,        /* 0xbf99 */
    OTHER,        /* 0xbf9a */
    OTHER,        /* 0xbf9b */
    OTHER,        /* 0xbf9c */
    OTHER,        /* 0xbf9d */
    OTHER,        /* 0xbf9e */
    OTHER,        /* 0xbf9f */
    OTHER,        /* 0xbfa0 */
    OTHER,        /* 0xbfa1 */
    OTHER,        /* 0xbfa2 */
    OTHER,        /* 0xbfa3 */
    OTHER,        /* 0xbfa4 */
    OTHER,        /* 0xbfa5 */
    OTHER,        /* 0xbfa6 */
    OTHER,        /* 0xbfa7 */
    OTHER,        /* 0xbfa8 */
    OTHER,        /* 0xbfa9 */
    OTHER,        /* 0xbfaa */
    OTHER,        /* 0xbfab */
    OTHER,        /* 0xbfac */
    OTHER,        /* 0xbfad */
    OTHER,        /* 0xbfae */
    OTHER,        /* 0xbfaf */
    OTHER,        /* 0xbfb0 */
    OTHER,        /* 0xbfb1 */
    OTHER,        /* 0xbfb2 */
    OTHER,        /* 0xbfb3 */
    OTHER,        /* 0xbfb4 */
    OTHER,        /* 0xbfb5 */
    OTHER,        /* 0xbfb6 */
    OTHER,        /* 0xbfb7 */
    OTHER,        /* 0xbfb8 */
    OTHER,        /* 0xbfb9 */
    OTHER,        /* 0xbfba */
    OTHER,        /* 0xbfbb */
    OTHER,        /* 0xbfbc */
    OTHER,        /* 0xbfbd */
    OTHER,        /* 0xbfbe */
    OTHER,        /* 0xbfbf */
    OTHER,        /* 0xbfc0 */
    OTHER,        /* 0xbfc1 */
    OTHER,        /* 0xbfc2 */
    OTHER,        /* 0xbfc3 */
    OTHER,        /* 0xbfc4 */
    OTHER,        /* 0xbfc5 */
    OTHER,        /* 0xbfc6 */
    OTHER,        /* 0xbfc7 */
    OTHER,        /* 0xbfc8 */
    OTHER,        /* 0xbfc9 */
    OTHER,        /* 0xbfca */
    OTHER,        /* 0xbfcb */
    OTHER,        /* 0xbfcc */
    OTHER,        /* 0xbfcd */
    OTHER,        /* 0xbfce */
    OTHER,        /* 0xbfcf */
    OTHER,        /* 0xbfd0 */
    OTHER,        /* 0xbfd1 */
    OTHER,        /* 0xbfd2 */
    OTHER,        /* 0xbfd3 */
    OTHER,        /* 0xbfd4 */
    OTHER,        /* 0xbfd5 */
    OTHER,        /* 0xbfd6 */
    OTHER,        /* 0xbfd7 */
    OTHER,        /* 0xbfd8 */
    OTHER,        /* 0xbfd9 */
    OTHER,        /* 0xbfda */
    OTHER,        /* 0xbfdb */
    OTHER,        /* 0xbfdc */
    OTHER,        /* 0xbfdd */
    OTHER,        /* 0xbfde */
    OTHER,        /* 0xbfdf */
    OTHER,        /* 0xbfe0 */
    OTHER,        /* 0xbfe1 */
    OTHER,        /* 0xbfe2 */
    OTHER,        /* 0xbfe3 */
    OTHER,        /* 0xbfe4 */
    OTHER,        /* 0xbfe5 */
    OTHER,        /* 0xbfe6 */
    OTHER,        /* 0xbfe7 */
    OTHER,        /* 0xbfe8 */
    OTHER,        /* 0xbfe9 */
    OTHER,        /* 0xbfea */
    OTHER,        /* 0xbfeb */
    OTHER,        /* 0xbfec */
    OTHER,        /* 0xbfed */
    OTHER,        /* 0xbfee */
    OTHER,        /* 0xbfef */
    OTHER,        /* 0xbff0 */
    OTHER,        /* 0xbff1 */
    OTHER,        /* 0xbff2 */
    OTHER,        /* 0xbff3 */
    OTHER,        /* 0xbff4 */
    OTHER,        /* 0xbff5 */
    OTHER,        /* 0xbff6 */
    OTHER,        /* 0xbff7 */
    OTHER,        /* 0xbff8 */
    OTHER,        /* 0xbff9 */
    OTHER,        /* 0xbffa */
    OTHER,        /* 0xbffb */
    OTHER,        /* 0xbffc */
    OTHER,        /* 0xbffd */
    OTHER,        /* 0xbffe */
    OTHER,        /* 0xbfff */
    OTHER,        /* 0xc000 */
    OTHER,        /* 0xc001 */
    OTHER,        /* 0xc002 */
    OTHER,        /* 0xc003 */
    OTHER,        /* 0xc004 */
    OTHER,        /* 0xc005 */
    OTHER,        /* 0xc006 */
    OTHER,        /* 0xc007 */
    OTHER,        /* 0xc008 */
    OTHER,        /* 0xc009 */
    OTHER,        /* 0xc00a */
    OTHER,        /* 0xc00b */
    OTHER,        /* 0xc00c */
    OTHER,        /* 0xc00d */
    OTHER,        /* 0xc00e */
    OTHER,        /* 0xc00f */
    OTHER,        /* 0xc010 */
    OTHER,        /* 0xc011 */
    OTHER,        /* 0xc012 */
    OTHER,        /* 0xc013 */
    OTHER,        /* 0xc014 */
    OTHER,        /* 0xc015 */
    OTHER,        /* 0xc016 */
    OTHER,        /* 0xc017 */
    OTHER,        /* 0xc018 */
    OTHER,        /* 0xc019 */
    OTHER,        /* 0xc01a */
    OTHER,        /* 0xc01b */
    OTHER,        /* 0xc01c */
    OTHER,        /* 0xc01d */
    OTHER,        /* 0xc01e */
    OTHER,        /* 0xc01f */
    OTHER,        /* 0xc020 */
    OTHER,        /* 0xc021 */
    OTHER,        /* 0xc022 */
    OTHER,        /* 0xc023 */
    OTHER,        /* 0xc024 */
    OTHER,        /* 0xc025 */
    OTHER,        /* 0xc026 */
    OTHER,        /* 0xc027 */
    OTHER,        /* 0xc028 */
    OTHER,        /* 0xc029 */
    OTHER,        /* 0xc02a */
    OTHER,        /* 0xc02b */
    OTHER,        /* 0xc02c */
    OTHER,        /* 0xc02d */
    OTHER,        /* 0xc02e */
    OTHER,        /* 0xc02f */
    OTHER,        /* 0xc030 */
    OTHER,        /* 0xc031 */
    OTHER,        /* 0xc032 */
    OTHER,        /* 0xc033 */
    OTHER,        /* 0xc034 */
    OTHER,        /* 0xc035 */
    OTHER,        /* 0xc036 */
    OTHER,        /* 0xc037 */
    OTHER,        /* 0xc038 */
    OTHER,        /* 0xc039 */
    OTHER,        /* 0xc03a */
    OTHER,        /* 0xc03b */
    OTHER,        /* 0xc03c */
    OTHER,        /* 0xc03d */
    OTHER,        /* 0xc03e */
    OTHER,        /* 0xc03f */
    OTHER,        /* 0xc040 */
    OTHER,        /* 0xc041 */
    OTHER,        /* 0xc042 */
    OTHER,        /* 0xc043 */
    OTHER,        /* 0xc044 */
    OTHER,        /* 0xc045 */
    OTHER,        /* 0xc046 */
    OTHER,        /* 0xc047 */
    OTHER,        /* 0xc048 */
    OTHER,        /* 0xc049 */
    OTHER,        /* 0xc04a */
    OTHER,        /* 0xc04b */
    OTHER,        /* 0xc04c */
    OTHER,        /* 0xc04d */
    OTHER,        /* 0xc04e */
    OTHER,        /* 0xc04f */
    OTHER,        /* 0xc050 */
    OTHER,        /* 0xc051 */
    OTHER,        /* 0xc052 */
    OTHER,        /* 0xc053 */
    OTHER,        /* 0xc054 */
    OTHER,        /* 0xc055 */
    OTHER,        /* 0xc056 */
    OTHER,        /* 0xc057 */
    OTHER,        /* 0xc058 */
    OTHER,        /* 0xc059 */
    OTHER,        /* 0xc05a */
    OTHER,        /* 0xc05b */
    OTHER,        /* 0xc05c */
    OTHER,        /* 0xc05d */
    OTHER,        /* 0xc05e */
    OTHER,        /* 0xc05f */
    OTHER,        /* 0xc060 */
    OTHER,        /* 0xc061 */
    OTHER,        /* 0xc062 */
    OTHER,        /* 0xc063 */
    OTHER,        /* 0xc064 */
    OTHER,        /* 0xc065 */
    OTHER,        /* 0xc066 */
    OTHER,        /* 0xc067 */
    OTHER,        /* 0xc068 */
    OTHER,        /* 0xc069 */
    OTHER,        /* 0xc06a */
    OTHER,        /* 0xc06b */
    OTHER,        /* 0xc06c */
    OTHER,        /* 0xc06d */
    OTHER,        /* 0xc06e */
    OTHER,        /* 0xc06f */
    OTHER,        /* 0xc070 */
    OTHER,        /* 0xc071 */
    OTHER,        /* 0xc072 */
    OTHER,        /* 0xc073 */
    OTHER,        /* 0xc074 */
    OTHER,        /* 0xc075 */
    OTHER,        /* 0xc076 */
    OTHER,        /* 0xc077 */
    OTHER,        /* 0xc078 */
    OTHER,        /* 0xc079 */
    OTHER,        /* 0xc07a */
    OTHER,        /* 0xc07b */
    OTHER,        /* 0xc07c */
    OTHER,        /* 0xc07d */
    OTHER,        /* 0xc07e */
    OTHER,        /* 0xc07f */
    OTHER,        /* 0xc080 */
    OTHER,        /* 0xc081 */
    OTHER,        /* 0xc082 */
    OTHER,        /* 0xc083 */
    OTHER,        /* 0xc084 */
    OTHER,        /* 0xc085 */
    OTHER,        /* 0xc086 */
    OTHER,        /* 0xc087 */
    OTHER,        /* 0xc088 */
    OTHER,        /* 0xc089 */
    OTHER,        /* 0xc08a */
    OTHER,        /* 0xc08b */
    OTHER,        /* 0xc08c */
    OTHER,        /* 0xc08d */
    OTHER,        /* 0xc08e */
    OTHER,        /* 0xc08f */
    OTHER,        /* 0xc090 */
    OTHER,        /* 0xc091 */
    OTHER,        /* 0xc092 */
    OTHER,        /* 0xc093 */
    OTHER,        /* 0xc094 */
    OTHER,        /* 0xc095 */
    OTHER,        /* 0xc096 */
    OTHER,        /* 0xc097 */
    OTHER,        /* 0xc098 */
    OTHER,        /* 0xc099 */
    OTHER,        /* 0xc09a */
    OTHER,        /* 0xc09b */
    OTHER,        /* 0xc09c */
    OTHER,        /* 0xc09d */
    OTHER,        /* 0xc09e */
    OTHER,        /* 0xc09f */
    OTHER,        /* 0xc0a0 */
    OTHER,        /* 0xc0a1 */
    OTHER,        /* 0xc0a2 */
    OTHER,        /* 0xc0a3 */
    OTHER,        /* 0xc0a4 */
    OTHER,        /* 0xc0a5 */
    OTHER,        /* 0xc0a6 */
    OTHER,        /* 0xc0a7 */
    OTHER,        /* 0xc0a8 */
    OTHER,        /* 0xc0a9 */
    OTHER,        /* 0xc0aa */
    OTHER,        /* 0xc0ab */
    OTHER,        /* 0xc0ac */
    OTHER,        /* 0xc0ad */
    OTHER,        /* 0xc0ae */
    OTHER,        /* 0xc0af */
    OTHER,        /* 0xc0b0 */
    OTHER,        /* 0xc0b1 */
    OTHER,        /* 0xc0b2 */
    OTHER,        /* 0xc0b3 */
    OTHER,        /* 0xc0b4 */
    OTHER,        /* 0xc0b5 */
    OTHER,        /* 0xc0b6 */
    OTHER,        /* 0xc0b7 */
    OTHER,        /* 0xc0b8 */
    OTHER,        /* 0xc0b9 */
    OTHER,        /* 0xc0ba */
    OTHER,        /* 0xc0bb */
    OTHER,        /* 0xc0bc */
    OTHER,        /* 0xc0bd */
    OTHER,        /* 0xc0be */
    OTHER,        /* 0xc0bf */
    OTHER,        /* 0xc0c0 */
    OTHER,        /* 0xc0c1 */
    OTHER,        /* 0xc0c2 */
    OTHER,        /* 0xc0c3 */
    OTHER,        /* 0xc0c4 */
    OTHER,        /* 0xc0c5 */
    OTHER,        /* 0xc0c6 */
    OTHER,        /* 0xc0c7 */
    OTHER,        /* 0xc0c8 */
    OTHER,        /* 0xc0c9 */
    OTHER,        /* 0xc0ca */
    OTHER,        /* 0xc0cb */
    OTHER,        /* 0xc0cc */
    OTHER,        /* 0xc0cd */
    OTHER,        /* 0xc0ce */
    OTHER,        /* 0xc0cf */
    OTHER,        /* 0xc0d0 */
    OTHER,        /* 0xc0d1 */
    OTHER,        /* 0xc0d2 */
    OTHER,        /* 0xc0d3 */
    OTHER,        /* 0xc0d4 */
    OTHER,        /* 0xc0d5 */
    OTHER,        /* 0xc0d6 */
    OTHER,        /* 0xc0d7 */
    OTHER,        /* 0xc0d8 */
    OTHER,        /* 0xc0d9 */
    OTHER,        /* 0xc0da */
    OTHER,        /* 0xc0db */
    OTHER,        /* 0xc0dc */
    OTHER,        /* 0xc0dd */
    OTHER,        /* 0xc0de */
    OTHER,        /* 0xc0df */
    OTHER,        /* 0xc0e0 */
    OTHER,        /* 0xc0e1 */
    OTHER,        /* 0xc0e2 */
    OTHER,        /* 0xc0e3 */
    OTHER,        /* 0xc0e4 */
    OTHER,        /* 0xc0e5 */
    OTHER,        /* 0xc0e6 */
    OTHER,        /* 0xc0e7 */
    OTHER,        /* 0xc0e8 */
    OTHER,        /* 0xc0e9 */
    OTHER,        /* 0xc0ea */
    OTHER,        /* 0xc0eb */
    OTHER,        /* 0xc0ec */
    OTHER,        /* 0xc0ed */
    OTHER,        /* 0xc0ee */
    OTHER,        /* 0xc0ef */
    OTHER,        /* 0xc0f0 */
    OTHER,        /* 0xc0f1 */
    OTHER,        /* 0xc0f2 */
    OTHER,        /* 0xc0f3 */
    OTHER,        /* 0xc0f4 */
    OTHER,        /* 0xc0f5 */
    OTHER,        /* 0xc0f6 */
    OTHER,        /* 0xc0f7 */
    OTHER,        /* 0xc0f8 */
    OTHER,        /* 0xc0f9 */
    OTHER,        /* 0xc0fa */
    OTHER,        /* 0xc0fb */
    OTHER,        /* 0xc0fc */
    OTHER,        /* 0xc0fd */
    OTHER,        /* 0xc0fe */
    OTHER,        /* 0xc0ff */
    OTHER,        /* 0xc100 */
    OTHER,        /* 0xc101 */
    OTHER,        /* 0xc102 */
    OTHER,        /* 0xc103 */
    OTHER,        /* 0xc104 */
    OTHER,        /* 0xc105 */
    OTHER,        /* 0xc106 */
    OTHER,        /* 0xc107 */
    OTHER,        /* 0xc108 */
    OTHER,        /* 0xc109 */
    OTHER,        /* 0xc10a */
    OTHER,        /* 0xc10b */
    OTHER,        /* 0xc10c */
    OTHER,        /* 0xc10d */
    OTHER,        /* 0xc10e */
    OTHER,        /* 0xc10f */
    OTHER,        /* 0xc110 */
    OTHER,        /* 0xc111 */
    OTHER,        /* 0xc112 */
    OTHER,        /* 0xc113 */
    OTHER,        /* 0xc114 */
    OTHER,        /* 0xc115 */
    OTHER,        /* 0xc116 */
    OTHER,        /* 0xc117 */
    OTHER,        /* 0xc118 */
    OTHER,        /* 0xc119 */
    OTHER,        /* 0xc11a */
    OTHER,        /* 0xc11b */
    OTHER,        /* 0xc11c */
    OTHER,        /* 0xc11d */
    OTHER,        /* 0xc11e */
    OTHER,        /* 0xc11f */
    OTHER,        /* 0xc120 */
    OTHER,        /* 0xc121 */
    OTHER,        /* 0xc122 */
    OTHER,        /* 0xc123 */
    OTHER,        /* 0xc124 */
    OTHER,        /* 0xc125 */
    OTHER,        /* 0xc126 */
    OTHER,        /* 0xc127 */
    OTHER,        /* 0xc128 */
    OTHER,        /* 0xc129 */
    OTHER,        /* 0xc12a */
    OTHER,        /* 0xc12b */
    OTHER,        /* 0xc12c */
    OTHER,        /* 0xc12d */
    OTHER,        /* 0xc12e */
    OTHER,        /* 0xc12f */
    OTHER,        /* 0xc130 */
    OTHER,        /* 0xc131 */
    OTHER,        /* 0xc132 */
    OTHER,        /* 0xc133 */
    OTHER,        /* 0xc134 */
    OTHER,        /* 0xc135 */
    OTHER,        /* 0xc136 */
    OTHER,        /* 0xc137 */
    OTHER,        /* 0xc138 */
    OTHER,        /* 0xc139 */
    OTHER,        /* 0xc13a */
    OTHER,        /* 0xc13b */
    OTHER,        /* 0xc13c */
    OTHER,        /* 0xc13d */
    OTHER,        /* 0xc13e */
    OTHER,        /* 0xc13f */
    OTHER,        /* 0xc140 */
    OTHER,        /* 0xc141 */
    OTHER,        /* 0xc142 */
    OTHER,        /* 0xc143 */
    OTHER,        /* 0xc144 */
    OTHER,        /* 0xc145 */
    OTHER,        /* 0xc146 */
    OTHER,        /* 0xc147 */
    OTHER,        /* 0xc148 */
    OTHER,        /* 0xc149 */
    OTHER,        /* 0xc14a */
    OTHER,        /* 0xc14b */
    OTHER,        /* 0xc14c */
    OTHER,        /* 0xc14d */
    OTHER,        /* 0xc14e */
    OTHER,        /* 0xc14f */
    OTHER,        /* 0xc150 */
    OTHER,        /* 0xc151 */
    OTHER,        /* 0xc152 */
    OTHER,        /* 0xc153 */
    OTHER,        /* 0xc154 */
    OTHER,        /* 0xc155 */
    OTHER,        /* 0xc156 */
    OTHER,        /* 0xc157 */
    OTHER,        /* 0xc158 */
    OTHER,        /* 0xc159 */
    OTHER,        /* 0xc15a */
    OTHER,        /* 0xc15b */
    OTHER,        /* 0xc15c */
    OTHER,        /* 0xc15d */
    OTHER,        /* 0xc15e */
    OTHER,        /* 0xc15f */
    OTHER,        /* 0xc160 */
    OTHER,        /* 0xc161 */
    OTHER,        /* 0xc162 */
    OTHER,        /* 0xc163 */
    OTHER,        /* 0xc164 */
    OTHER,        /* 0xc165 */
    OTHER,        /* 0xc166 */
    OTHER,        /* 0xc167 */
    OTHER,        /* 0xc168 */
    OTHER,        /* 0xc169 */
    OTHER,        /* 0xc16a */
    OTHER,        /* 0xc16b */
    OTHER,        /* 0xc16c */
    OTHER,        /* 0xc16d */
    OTHER,        /* 0xc16e */
    OTHER,        /* 0xc16f */
    OTHER,        /* 0xc170 */
    OTHER,        /* 0xc171 */
    OTHER,        /* 0xc172 */
    OTHER,        /* 0xc173 */
    OTHER,        /* 0xc174 */
    OTHER,        /* 0xc175 */
    OTHER,        /* 0xc176 */
    OTHER,        /* 0xc177 */
    OTHER,        /* 0xc178 */
    OTHER,        /* 0xc179 */
    OTHER,        /* 0xc17a */
    OTHER,        /* 0xc17b */
    OTHER,        /* 0xc17c */
    OTHER,        /* 0xc17d */
    OTHER,        /* 0xc17e */
    OTHER,        /* 0xc17f */
    OTHER,        /* 0xc180 */
    OTHER,        /* 0xc181 */
    OTHER,        /* 0xc182 */
    OTHER,        /* 0xc183 */
    OTHER,        /* 0xc184 */
    OTHER,        /* 0xc185 */
    OTHER,        /* 0xc186 */
    OTHER,        /* 0xc187 */
    OTHER,        /* 0xc188 */
    OTHER,        /* 0xc189 */
    OTHER,        /* 0xc18a */
    OTHER,        /* 0xc18b */
    OTHER,        /* 0xc18c */
    OTHER,        /* 0xc18d */
    OTHER,        /* 0xc18e */
    OTHER,        /* 0xc18f */
    OTHER,        /* 0xc190 */
    OTHER,        /* 0xc191 */
    OTHER,        /* 0xc192 */
    OTHER,        /* 0xc193 */
    OTHER,        /* 0xc194 */
    OTHER,        /* 0xc195 */
    OTHER,        /* 0xc196 */
    OTHER,        /* 0xc197 */
    OTHER,        /* 0xc198 */
    OTHER,        /* 0xc199 */
    OTHER,        /* 0xc19a */
    OTHER,        /* 0xc19b */
    OTHER,        /* 0xc19c */
    OTHER,        /* 0xc19d */
    OTHER,        /* 0xc19e */
    OTHER,        /* 0xc19f */
    OTHER,        /* 0xc1a0 */
    OTHER,        /* 0xc1a1 */
    OTHER,        /* 0xc1a2 */
    OTHER,        /* 0xc1a3 */
    OTHER,        /* 0xc1a4 */
    OTHER,        /* 0xc1a5 */
    OTHER,        /* 0xc1a6 */
    OTHER,        /* 0xc1a7 */
    OTHER,        /* 0xc1a8 */
    OTHER,        /* 0xc1a9 */
    OTHER,        /* 0xc1aa */
    OTHER,        /* 0xc1ab */
    OTHER,        /* 0xc1ac */
    OTHER,        /* 0xc1ad */
    OTHER,        /* 0xc1ae */
    OTHER,        /* 0xc1af */
    OTHER,        /* 0xc1b0 */
    OTHER,        /* 0xc1b1 */
    OTHER,        /* 0xc1b2 */
    OTHER,        /* 0xc1b3 */
    OTHER,        /* 0xc1b4 */
    OTHER,        /* 0xc1b5 */
    OTHER,        /* 0xc1b6 */
    OTHER,        /* 0xc1b7 */
    OTHER,        /* 0xc1b8 */
    OTHER,        /* 0xc1b9 */
    OTHER,        /* 0xc1ba */
    OTHER,        /* 0xc1bb */
    OTHER,        /* 0xc1bc */
    OTHER,        /* 0xc1bd */
    OTHER,        /* 0xc1be */
    OTHER,        /* 0xc1bf */
    OTHER,        /* 0xc1c0 */
    OTHER,        /* 0xc1c1 */
    OTHER,        /* 0xc1c2 */
    OTHER,        /* 0xc1c3 */
    OTHER,        /* 0xc1c4 */
    OTHER,        /* 0xc1c5 */
    OTHER,        /* 0xc1c6 */
    OTHER,        /* 0xc1c7 */
    OTHER,        /* 0xc1c8 */
    OTHER,        /* 0xc1c9 */
    OTHER,        /* 0xc1ca */
    OTHER,        /* 0xc1cb */
    OTHER,        /* 0xc1cc */
    OTHER,        /* 0xc1cd */
    OTHER,        /* 0xc1ce */
    OTHER,        /* 0xc1cf */
    OTHER,        /* 0xc1d0 */
    OTHER,        /* 0xc1d1 */
    OTHER,        /* 0xc1d2 */
    OTHER,        /* 0xc1d3 */
    OTHER,        /* 0xc1d4 */
    OTHER,        /* 0xc1d5 */
    OTHER,        /* 0xc1d6 */
    OTHER,        /* 0xc1d7 */
    OTHER,        /* 0xc1d8 */
    OTHER,        /* 0xc1d9 */
    OTHER,        /* 0xc1da */
    OTHER,        /* 0xc1db */
    OTHER,        /* 0xc1dc */
    OTHER,        /* 0xc1dd */
    OTHER,        /* 0xc1de */
    OTHER,        /* 0xc1df */
    OTHER,        /* 0xc1e0 */
    OTHER,        /* 0xc1e1 */
    OTHER,        /* 0xc1e2 */
    OTHER,        /* 0xc1e3 */
    OTHER,        /* 0xc1e4 */
    OTHER,        /* 0xc1e5 */
    OTHER,        /* 0xc1e6 */
    OTHER,        /* 0xc1e7 */
    OTHER,        /* 0xc1e8 */
    OTHER,        /* 0xc1e9 */
    OTHER,        /* 0xc1ea */
    OTHER,        /* 0xc1eb */
    OTHER,        /* 0xc1ec */
    OTHER,        /* 0xc1ed */
    OTHER,        /* 0xc1ee */
    OTHER,        /* 0xc1ef */
    OTHER,        /* 0xc1f0 */
    OTHER,        /* 0xc1f1 */
    OTHER,        /* 0xc1f2 */
    OTHER,        /* 0xc1f3 */
    OTHER,        /* 0xc1f4 */
    OTHER,        /* 0xc1f5 */
    OTHER,        /* 0xc1f6 */
    OTHER,        /* 0xc1f7 */
    OTHER,        /* 0xc1f8 */
    OTHER,        /* 0xc1f9 */
    OTHER,        /* 0xc1fa */
    OTHER,        /* 0xc1fb */
    OTHER,        /* 0xc1fc */
    OTHER,        /* 0xc1fd */
    OTHER,        /* 0xc1fe */
    OTHER,        /* 0xc1ff */
    OTHER,        /* 0xc200 */
    OTHER,        /* 0xc201 */
    OTHER,        /* 0xc202 */
    OTHER,        /* 0xc203 */
    OTHER,        /* 0xc204 */
    OTHER,        /* 0xc205 */
    OTHER,        /* 0xc206 */
    OTHER,        /* 0xc207 */
    OTHER,        /* 0xc208 */
    OTHER,        /* 0xc209 */
    OTHER,        /* 0xc20a */
    OTHER,        /* 0xc20b */
    OTHER,        /* 0xc20c */
    OTHER,        /* 0xc20d */
    OTHER,        /* 0xc20e */
    OTHER,        /* 0xc20f */
    OTHER,        /* 0xc210 */
    OTHER,        /* 0xc211 */
    OTHER,        /* 0xc212 */
    OTHER,        /* 0xc213 */
    OTHER,        /* 0xc214 */
    OTHER,        /* 0xc215 */
    OTHER,        /* 0xc216 */
    OTHER,        /* 0xc217 */
    OTHER,        /* 0xc218 */
    OTHER,        /* 0xc219 */
    OTHER,        /* 0xc21a */
    OTHER,        /* 0xc21b */
    OTHER,        /* 0xc21c */
    OTHER,        /* 0xc21d */
    OTHER,        /* 0xc21e */
    OTHER,        /* 0xc21f */
    OTHER,        /* 0xc220 */
    OTHER,        /* 0xc221 */
    OTHER,        /* 0xc222 */
    OTHER,        /* 0xc223 */
    OTHER,        /* 0xc224 */
    OTHER,        /* 0xc225 */
    OTHER,        /* 0xc226 */
    OTHER,        /* 0xc227 */
    OTHER,        /* 0xc228 */
    OTHER,        /* 0xc229 */
    OTHER,        /* 0xc22a */
    OTHER,        /* 0xc22b */
    OTHER,        /* 0xc22c */
    OTHER,        /* 0xc22d */
    OTHER,        /* 0xc22e */
    OTHER,        /* 0xc22f */
    OTHER,        /* 0xc230 */
    OTHER,        /* 0xc231 */
    OTHER,        /* 0xc232 */
    OTHER,        /* 0xc233 */
    OTHER,        /* 0xc234 */
    OTHER,        /* 0xc235 */
    OTHER,        /* 0xc236 */
    OTHER,        /* 0xc237 */
    OTHER,        /* 0xc238 */
    OTHER,        /* 0xc239 */
    OTHER,        /* 0xc23a */
    OTHER,        /* 0xc23b */
    OTHER,        /* 0xc23c */
    OTHER,        /* 0xc23d */
    OTHER,        /* 0xc23e */
    OTHER,        /* 0xc23f */
    OTHER,        /* 0xc240 */
    OTHER,        /* 0xc241 */
    OTHER,        /* 0xc242 */
    OTHER,        /* 0xc243 */
    OTHER,        /* 0xc244 */
    OTHER,        /* 0xc245 */
    OTHER,        /* 0xc246 */
    OTHER,        /* 0xc247 */
    OTHER,        /* 0xc248 */
    OTHER,        /* 0xc249 */
    OTHER,        /* 0xc24a */
    OTHER,        /* 0xc24b */
    OTHER,        /* 0xc24c */
    OTHER,        /* 0xc24d */
    OTHER,        /* 0xc24e */
    OTHER,        /* 0xc24f */
    OTHER,        /* 0xc250 */
    OTHER,        /* 0xc251 */
    OTHER,        /* 0xc252 */
    OTHER,        /* 0xc253 */
    OTHER,        /* 0xc254 */
    OTHER,        /* 0xc255 */
    OTHER,        /* 0xc256 */
    OTHER,        /* 0xc257 */
    OTHER,        /* 0xc258 */
    OTHER,        /* 0xc259 */
    OTHER,        /* 0xc25a */
    OTHER,        /* 0xc25b */
    OTHER,        /* 0xc25c */
    OTHER,        /* 0xc25d */
    OTHER,        /* 0xc25e */
    OTHER,        /* 0xc25f */
    OTHER,        /* 0xc260 */
    OTHER,        /* 0xc261 */
    OTHER,        /* 0xc262 */
    OTHER,        /* 0xc263 */
    OTHER,        /* 0xc264 */
    OTHER,        /* 0xc265 */
    OTHER,        /* 0xc266 */
    OTHER,        /* 0xc267 */
    OTHER,        /* 0xc268 */
    OTHER,        /* 0xc269 */
    OTHER,        /* 0xc26a */
    OTHER,        /* 0xc26b */
    OTHER,        /* 0xc26c */
    OTHER,        /* 0xc26d */
    OTHER,        /* 0xc26e */
    OTHER,        /* 0xc26f */
    OTHER,        /* 0xc270 */
    OTHER,        /* 0xc271 */
    OTHER,        /* 0xc272 */
    OTHER,        /* 0xc273 */
    OTHER,        /* 0xc274 */
    OTHER,        /* 0xc275 */
    OTHER,        /* 0xc276 */
    OTHER,        /* 0xc277 */
    OTHER,        /* 0xc278 */
    OTHER,        /* 0xc279 */
    OTHER,        /* 0xc27a */
    OTHER,        /* 0xc27b */
    OTHER,        /* 0xc27c */
    OTHER,        /* 0xc27d */
    OTHER,        /* 0xc27e */
    OTHER,        /* 0xc27f */
    OTHER,        /* 0xc280 */
    OTHER,        /* 0xc281 */
    OTHER,        /* 0xc282 */
    OTHER,        /* 0xc283 */
    OTHER,        /* 0xc284 */
    OTHER,        /* 0xc285 */
    OTHER,        /* 0xc286 */
    OTHER,        /* 0xc287 */
    OTHER,        /* 0xc288 */
    OTHER,        /* 0xc289 */
    OTHER,        /* 0xc28a */
    OTHER,        /* 0xc28b */
    OTHER,        /* 0xc28c */
    OTHER,        /* 0xc28d */
    OTHER,        /* 0xc28e */
    OTHER,        /* 0xc28f */
    OTHER,        /* 0xc290 */
    OTHER,        /* 0xc291 */
    OTHER,        /* 0xc292 */
    OTHER,        /* 0xc293 */
    OTHER,        /* 0xc294 */
    OTHER,        /* 0xc295 */
    OTHER,        /* 0xc296 */
    OTHER,        /* 0xc297 */
    OTHER,        /* 0xc298 */
    OTHER,        /* 0xc299 */
    OTHER,        /* 0xc29a */
    OTHER,        /* 0xc29b */
    OTHER,        /* 0xc29c */
    OTHER,        /* 0xc29d */
    OTHER,        /* 0xc29e */
    OTHER,        /* 0xc29f */
    OTHER,        /* 0xc2a0 */
    OTHER,        /* 0xc2a1 */
    OTHER,        /* 0xc2a2 */
    OTHER,        /* 0xc2a3 */
    OTHER,        /* 0xc2a4 */
    OTHER,        /* 0xc2a5 */
    OTHER,        /* 0xc2a6 */
    OTHER,        /* 0xc2a7 */
    OTHER,        /* 0xc2a8 */
    OTHER,        /* 0xc2a9 */
    OTHER,        /* 0xc2aa */
    OTHER,        /* 0xc2ab */
    OTHER,        /* 0xc2ac */
    OTHER,        /* 0xc2ad */
    OTHER,        /* 0xc2ae */
    OTHER,        /* 0xc2af */
    OTHER,        /* 0xc2b0 */
    OTHER,        /* 0xc2b1 */
    OTHER,        /* 0xc2b2 */
    OTHER,        /* 0xc2b3 */
    OTHER,        /* 0xc2b4 */
    OTHER,        /* 0xc2b5 */
    OTHER,        /* 0xc2b6 */
    OTHER,        /* 0xc2b7 */
    OTHER,        /* 0xc2b8 */
    OTHER,        /* 0xc2b9 */
    OTHER,        /* 0xc2ba */
    OTHER,        /* 0xc2bb */
    OTHER,        /* 0xc2bc */
    OTHER,        /* 0xc2bd */
    OTHER,        /* 0xc2be */
    OTHER,        /* 0xc2bf */
    OTHER,        /* 0xc2c0 */
    OTHER,        /* 0xc2c1 */
    OTHER,        /* 0xc2c2 */
    OTHER,        /* 0xc2c3 */
    OTHER,        /* 0xc2c4 */
    OTHER,        /* 0xc2c5 */
    OTHER,        /* 0xc2c6 */
    OTHER,        /* 0xc2c7 */
    OTHER,        /* 0xc2c8 */
    OTHER,        /* 0xc2c9 */
    OTHER,        /* 0xc2ca */
    OTHER,        /* 0xc2cb */
    OTHER,        /* 0xc2cc */
    OTHER,        /* 0xc2cd */
    OTHER,        /* 0xc2ce */
    OTHER,        /* 0xc2cf */
    OTHER,        /* 0xc2d0 */
    OTHER,        /* 0xc2d1 */
    OTHER,        /* 0xc2d2 */
    OTHER,        /* 0xc2d3 */
    OTHER,        /* 0xc2d4 */
    OTHER,        /* 0xc2d5 */
    OTHER,        /* 0xc2d6 */
    OTHER,        /* 0xc2d7 */
    OTHER,        /* 0xc2d8 */
    OTHER,        /* 0xc2d9 */
    OTHER,        /* 0xc2da */
    OTHER,        /* 0xc2db */
    OTHER,        /* 0xc2dc */
    OTHER,        /* 0xc2dd */
    OTHER,        /* 0xc2de */
    OTHER,        /* 0xc2df */
    OTHER,        /* 0xc2e0 */
    OTHER,        /* 0xc2e1 */
    OTHER,        /* 0xc2e2 */
    OTHER,        /* 0xc2e3 */
    OTHER,        /* 0xc2e4 */
    OTHER,        /* 0xc2e5 */
    OTHER,        /* 0xc2e6 */
    OTHER,        /* 0xc2e7 */
    OTHER,        /* 0xc2e8 */
    OTHER,        /* 0xc2e9 */
    OTHER,        /* 0xc2ea */
    OTHER,        /* 0xc2eb */
    OTHER,        /* 0xc2ec */
    OTHER,        /* 0xc2ed */
    OTHER,        /* 0xc2ee */
    OTHER,        /* 0xc2ef */
    OTHER,        /* 0xc2f0 */
    OTHER,        /* 0xc2f1 */
    OTHER,        /* 0xc2f2 */
    OTHER,        /* 0xc2f3 */
    OTHER,        /* 0xc2f4 */
    OTHER,        /* 0xc2f5 */
    OTHER,        /* 0xc2f6 */
    OTHER,        /* 0xc2f7 */
    OTHER,        /* 0xc2f8 */
    OTHER,        /* 0xc2f9 */
    OTHER,        /* 0xc2fa */
    OTHER,        /* 0xc2fb */
    OTHER,        /* 0xc2fc */
    OTHER,        /* 0xc2fd */
    OTHER,        /* 0xc2fe */
    OTHER,        /* 0xc2ff */
    OTHER,        /* 0xc300 */
    OTHER,        /* 0xc301 */
    OTHER,        /* 0xc302 */
    OTHER,        /* 0xc303 */
    OTHER,        /* 0xc304 */
    OTHER,        /* 0xc305 */
    OTHER,        /* 0xc306 */
    OTHER,        /* 0xc307 */
    OTHER,        /* 0xc308 */
    OTHER,        /* 0xc309 */
    OTHER,        /* 0xc30a */
    OTHER,        /* 0xc30b */
    OTHER,        /* 0xc30c */
    OTHER,        /* 0xc30d */
    OTHER,        /* 0xc30e */
    OTHER,        /* 0xc30f */
    OTHER,        /* 0xc310 */
    OTHER,        /* 0xc311 */
    OTHER,        /* 0xc312 */
    OTHER,        /* 0xc313 */
    OTHER,        /* 0xc314 */
    OTHER,        /* 0xc315 */
    OTHER,        /* 0xc316 */
    OTHER,        /* 0xc317 */
    OTHER,        /* 0xc318 */
    OTHER,        /* 0xc319 */
    OTHER,        /* 0xc31a */
    OTHER,        /* 0xc31b */
    OTHER,        /* 0xc31c */
    OTHER,        /* 0xc31d */
    OTHER,        /* 0xc31e */
    OTHER,        /* 0xc31f */
    OTHER,        /* 0xc320 */
    OTHER,        /* 0xc321 */
    OTHER,        /* 0xc322 */
    OTHER,        /* 0xc323 */
    OTHER,        /* 0xc324 */
    OTHER,        /* 0xc325 */
    OTHER,        /* 0xc326 */
    OTHER,        /* 0xc327 */
    OTHER,        /* 0xc328 */
    OTHER,        /* 0xc329 */
    OTHER,        /* 0xc32a */
    OTHER,        /* 0xc32b */
    OTHER,        /* 0xc32c */
    OTHER,        /* 0xc32d */
    OTHER,        /* 0xc32e */
    OTHER,        /* 0xc32f */
    OTHER,        /* 0xc330 */
    OTHER,        /* 0xc331 */
    OTHER,        /* 0xc332 */
    OTHER,        /* 0xc333 */
    OTHER,        /* 0xc334 */
    OTHER,        /* 0xc335 */
    OTHER,        /* 0xc336 */
    OTHER,        /* 0xc337 */
    OTHER,        /* 0xc338 */
    OTHER,        /* 0xc339 */
    OTHER,        /* 0xc33a */
    OTHER,        /* 0xc33b */
    OTHER,        /* 0xc33c */
    OTHER,        /* 0xc33d */
    OTHER,        /* 0xc33e */
    OTHER,        /* 0xc33f */
    OTHER,        /* 0xc340 */
    OTHER,        /* 0xc341 */
    OTHER,        /* 0xc342 */
    OTHER,        /* 0xc343 */
    OTHER,        /* 0xc344 */
    OTHER,        /* 0xc345 */
    OTHER,        /* 0xc346 */
    OTHER,        /* 0xc347 */
    OTHER,        /* 0xc348 */
    OTHER,        /* 0xc349 */
    OTHER,        /* 0xc34a */
    OTHER,        /* 0xc34b */
    OTHER,        /* 0xc34c */
    OTHER,        /* 0xc34d */
    OTHER,        /* 0xc34e */
    OTHER,        /* 0xc34f */
    OTHER,        /* 0xc350 */
    OTHER,        /* 0xc351 */
    OTHER,        /* 0xc352 */
    OTHER,        /* 0xc353 */
    OTHER,        /* 0xc354 */
    OTHER,        /* 0xc355 */
    OTHER,        /* 0xc356 */
    OTHER,        /* 0xc357 */
    OTHER,        /* 0xc358 */
    OTHER,        /* 0xc359 */
    OTHER,        /* 0xc35a */
    OTHER,        /* 0xc35b */
    OTHER,        /* 0xc35c */
    OTHER,        /* 0xc35d */
    OTHER,        /* 0xc35e */
    OTHER,        /* 0xc35f */
    OTHER,        /* 0xc360 */
    OTHER,        /* 0xc361 */
    OTHER,        /* 0xc362 */
    OTHER,        /* 0xc363 */
    OTHER,        /* 0xc364 */
    OTHER,        /* 0xc365 */
    OTHER,        /* 0xc366 */
    OTHER,        /* 0xc367 */
    OTHER,        /* 0xc368 */
    OTHER,        /* 0xc369 */
    OTHER,        /* 0xc36a */
    OTHER,        /* 0xc36b */
    OTHER,        /* 0xc36c */
    OTHER,        /* 0xc36d */
    OTHER,        /* 0xc36e */
    OTHER,        /* 0xc36f */
    OTHER,        /* 0xc370 */
    OTHER,        /* 0xc371 */
    OTHER,        /* 0xc372 */
    OTHER,        /* 0xc373 */
    OTHER,        /* 0xc374 */
    OTHER,        /* 0xc375 */
    OTHER,        /* 0xc376 */
    OTHER,        /* 0xc377 */
    OTHER,        /* 0xc378 */
    OTHER,        /* 0xc379 */
    OTHER,        /* 0xc37a */
    OTHER,        /* 0xc37b */
    OTHER,        /* 0xc37c */
    OTHER,        /* 0xc37d */
    OTHER,        /* 0xc37e */
    OTHER,        /* 0xc37f */
    OTHER,        /* 0xc380 */
    OTHER,        /* 0xc381 */
    OTHER,        /* 0xc382 */
    OTHER,        /* 0xc383 */
    OTHER,        /* 0xc384 */
    OTHER,        /* 0xc385 */
    OTHER,        /* 0xc386 */
    OTHER,        /* 0xc387 */
    OTHER,        /* 0xc388 */
    OTHER,        /* 0xc389 */
    OTHER,        /* 0xc38a */
    OTHER,        /* 0xc38b */
    OTHER,        /* 0xc38c */
    OTHER,        /* 0xc38d */
    OTHER,        /* 0xc38e */
    OTHER,        /* 0xc38f */
    OTHER,        /* 0xc390 */
    OTHER,        /* 0xc391 */
    OTHER,        /* 0xc392 */
    OTHER,        /* 0xc393 */
    OTHER,        /* 0xc394 */
    OTHER,        /* 0xc395 */
    OTHER,        /* 0xc396 */
    OTHER,        /* 0xc397 */
    OTHER,        /* 0xc398 */
    OTHER,        /* 0xc399 */
    OTHER,        /* 0xc39a */
    OTHER,        /* 0xc39b */
    OTHER,        /* 0xc39c */
    OTHER,        /* 0xc39d */
    OTHER,        /* 0xc39e */
    OTHER,        /* 0xc39f */
    OTHER,        /* 0xc3a0 */
    OTHER,        /* 0xc3a1 */
    OTHER,        /* 0xc3a2 */
    OTHER,        /* 0xc3a3 */
    OTHER,        /* 0xc3a4 */
    OTHER,        /* 0xc3a5 */
    OTHER,        /* 0xc3a6 */
    OTHER,        /* 0xc3a7 */
    OTHER,        /* 0xc3a8 */
    OTHER,        /* 0xc3a9 */
    OTHER,        /* 0xc3aa */
    OTHER,        /* 0xc3ab */
    OTHER,        /* 0xc3ac */
    OTHER,        /* 0xc3ad */
    OTHER,        /* 0xc3ae */
    OTHER,        /* 0xc3af */
    OTHER,        /* 0xc3b0 */
    OTHER,        /* 0xc3b1 */
    OTHER,        /* 0xc3b2 */
    OTHER,        /* 0xc3b3 */
    OTHER,        /* 0xc3b4 */
    OTHER,        /* 0xc3b5 */
    OTHER,        /* 0xc3b6 */
    OTHER,        /* 0xc3b7 */
    OTHER,        /* 0xc3b8 */
    OTHER,        /* 0xc3b9 */
    OTHER,        /* 0xc3ba */
    OTHER,        /* 0xc3bb */
    OTHER,        /* 0xc3bc */
    OTHER,        /* 0xc3bd */
    OTHER,        /* 0xc3be */
    OTHER,        /* 0xc3bf */
    OTHER,        /* 0xc3c0 */
    OTHER,        /* 0xc3c1 */
    OTHER,        /* 0xc3c2 */
    OTHER,        /* 0xc3c3 */
    OTHER,        /* 0xc3c4 */
    OTHER,        /* 0xc3c5 */
    OTHER,        /* 0xc3c6 */
    OTHER,        /* 0xc3c7 */
    OTHER,        /* 0xc3c8 */
    OTHER,        /* 0xc3c9 */
    OTHER,        /* 0xc3ca */
    OTHER,        /* 0xc3cb */
    OTHER,        /* 0xc3cc */
    OTHER,        /* 0xc3cd */
    OTHER,        /* 0xc3ce */
    OTHER,        /* 0xc3cf */
    OTHER,        /* 0xc3d0 */
    OTHER,        /* 0xc3d1 */
    OTHER,        /* 0xc3d2 */
    OTHER,        /* 0xc3d3 */
    OTHER,        /* 0xc3d4 */
    OTHER,        /* 0xc3d5 */
    OTHER,        /* 0xc3d6 */
    OTHER,        /* 0xc3d7 */
    OTHER,        /* 0xc3d8 */
    OTHER,        /* 0xc3d9 */
    OTHER,        /* 0xc3da */
    OTHER,        /* 0xc3db */
    OTHER,        /* 0xc3dc */
    OTHER,        /* 0xc3dd */
    OTHER,        /* 0xc3de */
    OTHER,        /* 0xc3df */
    OTHER,        /* 0xc3e0 */
    OTHER,        /* 0xc3e1 */
    OTHER,        /* 0xc3e2 */
    OTHER,        /* 0xc3e3 */
    OTHER,        /* 0xc3e4 */
    OTHER,        /* 0xc3e5 */
    OTHER,        /* 0xc3e6 */
    OTHER,        /* 0xc3e7 */
    OTHER,        /* 0xc3e8 */
    OTHER,        /* 0xc3e9 */
    OTHER,        /* 0xc3ea */
    OTHER,        /* 0xc3eb */
    OTHER,        /* 0xc3ec */
    OTHER,        /* 0xc3ed */
    OTHER,        /* 0xc3ee */
    OTHER,        /* 0xc3ef */
    OTHER,        /* 0xc3f0 */
    OTHER,        /* 0xc3f1 */
    OTHER,        /* 0xc3f2 */
    OTHER,        /* 0xc3f3 */
    OTHER,        /* 0xc3f4 */
    OTHER,        /* 0xc3f5 */
    OTHER,        /* 0xc3f6 */
    OTHER,        /* 0xc3f7 */
    OTHER,        /* 0xc3f8 */
    OTHER,        /* 0xc3f9 */
    OTHER,        /* 0xc3fa */
    OTHER,        /* 0xc3fb */
    OTHER,        /* 0xc3fc */
    OTHER,        /* 0xc3fd */
    OTHER,        /* 0xc3fe */
    OTHER,        /* 0xc3ff */
    OTHER,        /* 0xc400 */
    OTHER,        /* 0xc401 */
    OTHER,        /* 0xc402 */
    OTHER,        /* 0xc403 */
    OTHER,        /* 0xc404 */
    OTHER,        /* 0xc405 */
    OTHER,        /* 0xc406 */
    OTHER,        /* 0xc407 */
    OTHER,        /* 0xc408 */
    OTHER,        /* 0xc409 */
    OTHER,        /* 0xc40a */
    OTHER,        /* 0xc40b */
    OTHER,        /* 0xc40c */
    OTHER,        /* 0xc40d */
    OTHER,        /* 0xc40e */
    OTHER,        /* 0xc40f */
    OTHER,        /* 0xc410 */
    OTHER,        /* 0xc411 */
    OTHER,        /* 0xc412 */
    OTHER,        /* 0xc413 */
    OTHER,        /* 0xc414 */
    OTHER,        /* 0xc415 */
    OTHER,        /* 0xc416 */
    OTHER,        /* 0xc417 */
    OTHER,        /* 0xc418 */
    OTHER,        /* 0xc419 */
    OTHER,        /* 0xc41a */
    OTHER,        /* 0xc41b */
    OTHER,        /* 0xc41c */
    OTHER,        /* 0xc41d */
    OTHER,        /* 0xc41e */
    OTHER,        /* 0xc41f */
    OTHER,        /* 0xc420 */
    OTHER,        /* 0xc421 */
    OTHER,        /* 0xc422 */
    OTHER,        /* 0xc423 */
    OTHER,        /* 0xc424 */
    OTHER,        /* 0xc425 */
    OTHER,        /* 0xc426 */
    OTHER,        /* 0xc427 */
    OTHER,        /* 0xc428 */
    OTHER,        /* 0xc429 */
    OTHER,        /* 0xc42a */
    OTHER,        /* 0xc42b */
    OTHER,        /* 0xc42c */
    OTHER,        /* 0xc42d */
    OTHER,        /* 0xc42e */
    OTHER,        /* 0xc42f */
    OTHER,        /* 0xc430 */
    OTHER,        /* 0xc431 */
    OTHER,        /* 0xc432 */
    OTHER,        /* 0xc433 */
    OTHER,        /* 0xc434 */
    OTHER,        /* 0xc435 */
    OTHER,        /* 0xc436 */
    OTHER,        /* 0xc437 */
    OTHER,        /* 0xc438 */
    OTHER,        /* 0xc439 */
    OTHER,        /* 0xc43a */
    OTHER,        /* 0xc43b */
    OTHER,        /* 0xc43c */
    OTHER,        /* 0xc43d */
    OTHER,        /* 0xc43e */
    OTHER,        /* 0xc43f */
    OTHER,        /* 0xc440 */
    OTHER,        /* 0xc441 */
    OTHER,        /* 0xc442 */
    OTHER,        /* 0xc443 */
    OTHER,        /* 0xc444 */
    OTHER,        /* 0xc445 */
    OTHER,        /* 0xc446 */
    OTHER,        /* 0xc447 */
    OTHER,        /* 0xc448 */
    OTHER,        /* 0xc449 */
    OTHER,        /* 0xc44a */
    OTHER,        /* 0xc44b */
    OTHER,        /* 0xc44c */
    OTHER,        /* 0xc44d */
    OTHER,        /* 0xc44e */
    OTHER,        /* 0xc44f */
    OTHER,        /* 0xc450 */
    OTHER,        /* 0xc451 */
    OTHER,        /* 0xc452 */
    OTHER,        /* 0xc453 */
    OTHER,        /* 0xc454 */
    OTHER,        /* 0xc455 */
    OTHER,        /* 0xc456 */
    OTHER,        /* 0xc457 */
    OTHER,        /* 0xc458 */
    OTHER,        /* 0xc459 */
    OTHER,        /* 0xc45a */
    OTHER,        /* 0xc45b */
    OTHER,        /* 0xc45c */
    OTHER,        /* 0xc45d */
    OTHER,        /* 0xc45e */
    OTHER,        /* 0xc45f */
    OTHER,        /* 0xc460 */
    OTHER,        /* 0xc461 */
    OTHER,        /* 0xc462 */
    OTHER,        /* 0xc463 */
    OTHER,        /* 0xc464 */
    OTHER,        /* 0xc465 */
    OTHER,        /* 0xc466 */
    OTHER,        /* 0xc467 */
    OTHER,        /* 0xc468 */
    OTHER,        /* 0xc469 */
    OTHER,        /* 0xc46a */
    OTHER,        /* 0xc46b */
    OTHER,        /* 0xc46c */
    OTHER,        /* 0xc46d */
    OTHER,        /* 0xc46e */
    OTHER,        /* 0xc46f */
    OTHER,        /* 0xc470 */
    OTHER,        /* 0xc471 */
    OTHER,        /* 0xc472 */
    OTHER,        /* 0xc473 */
    OTHER,        /* 0xc474 */
    OTHER,        /* 0xc475 */
    OTHER,        /* 0xc476 */
    OTHER,        /* 0xc477 */
    OTHER,        /* 0xc478 */
    OTHER,        /* 0xc479 */
    OTHER,        /* 0xc47a */
    OTHER,        /* 0xc47b */
    OTHER,        /* 0xc47c */
    OTHER,        /* 0xc47d */
    OTHER,        /* 0xc47e */
    OTHER,        /* 0xc47f */
    OTHER,        /* 0xc480 */
    OTHER,        /* 0xc481 */
    OTHER,        /* 0xc482 */
    OTHER,        /* 0xc483 */
    OTHER,        /* 0xc484 */
    OTHER,        /* 0xc485 */
    OTHER,        /* 0xc486 */
    OTHER,        /* 0xc487 */
    OTHER,        /* 0xc488 */
    OTHER,        /* 0xc489 */
    OTHER,        /* 0xc48a */
    OTHER,        /* 0xc48b */
    OTHER,        /* 0xc48c */
    OTHER,        /* 0xc48d */
    OTHER,        /* 0xc48e */
    OTHER,        /* 0xc48f */
    OTHER,        /* 0xc490 */
    OTHER,        /* 0xc491 */
    OTHER,        /* 0xc492 */
    OTHER,        /* 0xc493 */
    OTHER,        /* 0xc494 */
    OTHER,        /* 0xc495 */
    OTHER,        /* 0xc496 */
    OTHER,        /* 0xc497 */
    OTHER,        /* 0xc498 */
    OTHER,        /* 0xc499 */
    OTHER,        /* 0xc49a */
    OTHER,        /* 0xc49b */
    OTHER,        /* 0xc49c */
    OTHER,        /* 0xc49d */
    OTHER,        /* 0xc49e */
    OTHER,        /* 0xc49f */
    OTHER,        /* 0xc4a0 */
    OTHER,        /* 0xc4a1 */
    OTHER,        /* 0xc4a2 */
    OTHER,        /* 0xc4a3 */
    OTHER,        /* 0xc4a4 */
    OTHER,        /* 0xc4a5 */
    OTHER,        /* 0xc4a6 */
    OTHER,        /* 0xc4a7 */
    OTHER,        /* 0xc4a8 */
    OTHER,        /* 0xc4a9 */
    OTHER,        /* 0xc4aa */
    OTHER,        /* 0xc4ab */
    OTHER,        /* 0xc4ac */
    OTHER,        /* 0xc4ad */
    OTHER,        /* 0xc4ae */
    OTHER,        /* 0xc4af */
    OTHER,        /* 0xc4b0 */
    OTHER,        /* 0xc4b1 */
    OTHER,        /* 0xc4b2 */
    OTHER,        /* 0xc4b3 */
    OTHER,        /* 0xc4b4 */
    OTHER,        /* 0xc4b5 */
    OTHER,        /* 0xc4b6 */
    OTHER,        /* 0xc4b7 */
    OTHER,        /* 0xc4b8 */
    OTHER,        /* 0xc4b9 */
    OTHER,        /* 0xc4ba */
    OTHER,        /* 0xc4bb */
    OTHER,        /* 0xc4bc */
    OTHER,        /* 0xc4bd */
    OTHER,        /* 0xc4be */
    OTHER,        /* 0xc4bf */
    OTHER,        /* 0xc4c0 */
    OTHER,        /* 0xc4c1 */
    OTHER,        /* 0xc4c2 */
    OTHER,        /* 0xc4c3 */
    OTHER,        /* 0xc4c4 */
    OTHER,        /* 0xc4c5 */
    OTHER,        /* 0xc4c6 */
    OTHER,        /* 0xc4c7 */
    OTHER,        /* 0xc4c8 */
    OTHER,        /* 0xc4c9 */
    OTHER,        /* 0xc4ca */
    OTHER,        /* 0xc4cb */
    OTHER,        /* 0xc4cc */
    OTHER,        /* 0xc4cd */
    OTHER,        /* 0xc4ce */
    OTHER,        /* 0xc4cf */
    OTHER,        /* 0xc4d0 */
    OTHER,        /* 0xc4d1 */
    OTHER,        /* 0xc4d2 */
    OTHER,        /* 0xc4d3 */
    OTHER,        /* 0xc4d4 */
    OTHER,        /* 0xc4d5 */
    OTHER,        /* 0xc4d6 */
    OTHER,        /* 0xc4d7 */
    OTHER,        /* 0xc4d8 */
    OTHER,        /* 0xc4d9 */
    OTHER,        /* 0xc4da */
    OTHER,        /* 0xc4db */
    OTHER,        /* 0xc4dc */
    OTHER,        /* 0xc4dd */
    OTHER,        /* 0xc4de */
    OTHER,        /* 0xc4df */
    OTHER,        /* 0xc4e0 */
    OTHER,        /* 0xc4e1 */
    OTHER,        /* 0xc4e2 */
    OTHER,        /* 0xc4e3 */
    OTHER,        /* 0xc4e4 */
    OTHER,        /* 0xc4e5 */
    OTHER,        /* 0xc4e6 */
    OTHER,        /* 0xc4e7 */
    OTHER,        /* 0xc4e8 */
    OTHER,        /* 0xc4e9 */
    OTHER,        /* 0xc4ea */
    OTHER,        /* 0xc4eb */
    OTHER,        /* 0xc4ec */
    OTHER,        /* 0xc4ed */
    OTHER,        /* 0xc4ee */
    OTHER,        /* 0xc4ef */
    OTHER,        /* 0xc4f0 */
    OTHER,        /* 0xc4f1 */
    OTHER,        /* 0xc4f2 */
    OTHER,        /* 0xc4f3 */
    OTHER,        /* 0xc4f4 */
    OTHER,        /* 0xc4f5 */
    OTHER,        /* 0xc4f6 */
    OTHER,        /* 0xc4f7 */
    OTHER,        /* 0xc4f8 */
    OTHER,        /* 0xc4f9 */
    OTHER,        /* 0xc4fa */
    OTHER,        /* 0xc4fb */
    OTHER,        /* 0xc4fc */
    OTHER,        /* 0xc4fd */
    OTHER,        /* 0xc4fe */
    OTHER,        /* 0xc4ff */
    OTHER,        /* 0xc500 */
    OTHER,        /* 0xc501 */
    OTHER,        /* 0xc502 */
    OTHER,        /* 0xc503 */
    OTHER,        /* 0xc504 */
    OTHER,        /* 0xc505 */
    OTHER,        /* 0xc506 */
    OTHER,        /* 0xc507 */
    OTHER,        /* 0xc508 */
    OTHER,        /* 0xc509 */
    OTHER,        /* 0xc50a */
    OTHER,        /* 0xc50b */
    OTHER,        /* 0xc50c */
    OTHER,        /* 0xc50d */
    OTHER,        /* 0xc50e */
    OTHER,        /* 0xc50f */
    OTHER,        /* 0xc510 */
    OTHER,        /* 0xc511 */
    OTHER,        /* 0xc512 */
    OTHER,        /* 0xc513 */
    OTHER,        /* 0xc514 */
    OTHER,        /* 0xc515 */
    OTHER,        /* 0xc516 */
    OTHER,        /* 0xc517 */
    OTHER,        /* 0xc518 */
    OTHER,        /* 0xc519 */
    OTHER,        /* 0xc51a */
    OTHER,        /* 0xc51b */
    OTHER,        /* 0xc51c */
    OTHER,        /* 0xc51d */
    OTHER,        /* 0xc51e */
    OTHER,        /* 0xc51f */
    OTHER,        /* 0xc520 */
    OTHER,        /* 0xc521 */
    OTHER,        /* 0xc522 */
    OTHER,        /* 0xc523 */
    OTHER,        /* 0xc524 */
    OTHER,        /* 0xc525 */
    OTHER,        /* 0xc526 */
    OTHER,        /* 0xc527 */
    OTHER,        /* 0xc528 */
    OTHER,        /* 0xc529 */
    OTHER,        /* 0xc52a */
    OTHER,        /* 0xc52b */
    OTHER,        /* 0xc52c */
    OTHER,        /* 0xc52d */
    OTHER,        /* 0xc52e */
    OTHER,        /* 0xc52f */
    OTHER,        /* 0xc530 */
    OTHER,        /* 0xc531 */
    OTHER,        /* 0xc532 */
    OTHER,        /* 0xc533 */
    OTHER,        /* 0xc534 */
    OTHER,        /* 0xc535 */
    OTHER,        /* 0xc536 */
    OTHER,        /* 0xc537 */
    OTHER,        /* 0xc538 */
    OTHER,        /* 0xc539 */
    OTHER,        /* 0xc53a */
    OTHER,        /* 0xc53b */
    OTHER,        /* 0xc53c */
    OTHER,        /* 0xc53d */
    OTHER,        /* 0xc53e */
    OTHER,        /* 0xc53f */
    OTHER,        /* 0xc540 */
    OTHER,        /* 0xc541 */
    OTHER,        /* 0xc542 */
    OTHER,        /* 0xc543 */
    OTHER,        /* 0xc544 */
    OTHER,        /* 0xc545 */
    OTHER,        /* 0xc546 */
    OTHER,        /* 0xc547 */
    OTHER,        /* 0xc548 */
    OTHER,        /* 0xc549 */
    OTHER,        /* 0xc54a */
    OTHER,        /* 0xc54b */
    OTHER,        /* 0xc54c */
    OTHER,        /* 0xc54d */
    OTHER,        /* 0xc54e */
    OTHER,        /* 0xc54f */
    OTHER,        /* 0xc550 */
    OTHER,        /* 0xc551 */
    OTHER,        /* 0xc552 */
    OTHER,        /* 0xc553 */
    OTHER,        /* 0xc554 */
    OTHER,        /* 0xc555 */
    OTHER,        /* 0xc556 */
    OTHER,        /* 0xc557 */
    OTHER,        /* 0xc558 */
    OTHER,        /* 0xc559 */
    OTHER,        /* 0xc55a */
    OTHER,        /* 0xc55b */
    OTHER,        /* 0xc55c */
    OTHER,        /* 0xc55d */
    OTHER,        /* 0xc55e */
    OTHER,        /* 0xc55f */
    OTHER,        /* 0xc560 */
    OTHER,        /* 0xc561 */
    OTHER,        /* 0xc562 */
    OTHER,        /* 0xc563 */
    OTHER,        /* 0xc564 */
    OTHER,        /* 0xc565 */
    OTHER,        /* 0xc566 */
    OTHER,        /* 0xc567 */
    OTHER,        /* 0xc568 */
    OTHER,        /* 0xc569 */
    OTHER,        /* 0xc56a */
    OTHER,        /* 0xc56b */
    OTHER,        /* 0xc56c */
    OTHER,        /* 0xc56d */
    OTHER,        /* 0xc56e */
    OTHER,        /* 0xc56f */
    OTHER,        /* 0xc570 */
    OTHER,        /* 0xc571 */
    OTHER,        /* 0xc572 */
    OTHER,        /* 0xc573 */
    OTHER,        /* 0xc574 */
    OTHER,        /* 0xc575 */
    OTHER,        /* 0xc576 */
    OTHER,        /* 0xc577 */
    OTHER,        /* 0xc578 */
    OTHER,        /* 0xc579 */
    OTHER,        /* 0xc57a */
    OTHER,        /* 0xc57b */
    OTHER,        /* 0xc57c */
    OTHER,        /* 0xc57d */
    OTHER,        /* 0xc57e */
    OTHER,        /* 0xc57f */
    OTHER,        /* 0xc580 */
    OTHER,        /* 0xc581 */
    OTHER,        /* 0xc582 */
    OTHER,        /* 0xc583 */
    OTHER,        /* 0xc584 */
    OTHER,        /* 0xc585 */
    OTHER,        /* 0xc586 */
    OTHER,        /* 0xc587 */
    OTHER,        /* 0xc588 */
    OTHER,        /* 0xc589 */
    OTHER,        /* 0xc58a */
    OTHER,        /* 0xc58b */
    OTHER,        /* 0xc58c */
    OTHER,        /* 0xc58d */
    OTHER,        /* 0xc58e */
    OTHER,        /* 0xc58f */
    OTHER,        /* 0xc590 */
    OTHER,        /* 0xc591 */
    OTHER,        /* 0xc592 */
    OTHER,        /* 0xc593 */
    OTHER,        /* 0xc594 */
    OTHER,        /* 0xc595 */
    OTHER,        /* 0xc596 */
    OTHER,        /* 0xc597 */
    OTHER,        /* 0xc598 */
    OTHER,        /* 0xc599 */
    OTHER,        /* 0xc59a */
    OTHER,        /* 0xc59b */
    OTHER,        /* 0xc59c */
    OTHER,        /* 0xc59d */
    OTHER,        /* 0xc59e */
    OTHER,        /* 0xc59f */
    OTHER,        /* 0xc5a0 */
    OTHER,        /* 0xc5a1 */
    OTHER,        /* 0xc5a2 */
    OTHER,        /* 0xc5a3 */
    OTHER,        /* 0xc5a4 */
    OTHER,        /* 0xc5a5 */
    OTHER,        /* 0xc5a6 */
    OTHER,        /* 0xc5a7 */
    OTHER,        /* 0xc5a8 */
    OTHER,        /* 0xc5a9 */
    OTHER,        /* 0xc5aa */
    OTHER,        /* 0xc5ab */
    OTHER,        /* 0xc5ac */
    OTHER,        /* 0xc5ad */
    OTHER,        /* 0xc5ae */
    OTHER,        /* 0xc5af */
    OTHER,        /* 0xc5b0 */
    OTHER,        /* 0xc5b1 */
    OTHER,        /* 0xc5b2 */
    OTHER,        /* 0xc5b3 */
    OTHER,        /* 0xc5b4 */
    OTHER,        /* 0xc5b5 */
    OTHER,        /* 0xc5b6 */
    OTHER,        /* 0xc5b7 */
    OTHER,        /* 0xc5b8 */
    OTHER,        /* 0xc5b9 */
    OTHER,        /* 0xc5ba */
    OTHER,        /* 0xc5bb */
    OTHER,        /* 0xc5bc */
    OTHER,        /* 0xc5bd */
    OTHER,        /* 0xc5be */
    OTHER,        /* 0xc5bf */
    OTHER,        /* 0xc5c0 */
    OTHER,        /* 0xc5c1 */
    OTHER,        /* 0xc5c2 */
    OTHER,        /* 0xc5c3 */
    OTHER,        /* 0xc5c4 */
    OTHER,        /* 0xc5c5 */
    OTHER,        /* 0xc5c6 */
    OTHER,        /* 0xc5c7 */
    OTHER,        /* 0xc5c8 */
    OTHER,        /* 0xc5c9 */
    OTHER,        /* 0xc5ca */
    OTHER,        /* 0xc5cb */
    OTHER,        /* 0xc5cc */
    OTHER,        /* 0xc5cd */
    OTHER,        /* 0xc5ce */
    OTHER,        /* 0xc5cf */
    OTHER,        /* 0xc5d0 */
    OTHER,        /* 0xc5d1 */
    OTHER,        /* 0xc5d2 */
    OTHER,        /* 0xc5d3 */
    OTHER,        /* 0xc5d4 */
    OTHER,        /* 0xc5d5 */
    OTHER,        /* 0xc5d6 */
    OTHER,        /* 0xc5d7 */
    OTHER,        /* 0xc5d8 */
    OTHER,        /* 0xc5d9 */
    OTHER,        /* 0xc5da */
    OTHER,        /* 0xc5db */
    OTHER,        /* 0xc5dc */
    OTHER,        /* 0xc5dd */
    OTHER,        /* 0xc5de */
    OTHER,        /* 0xc5df */
    OTHER,        /* 0xc5e0 */
    OTHER,        /* 0xc5e1 */
    OTHER,        /* 0xc5e2 */
    OTHER,        /* 0xc5e3 */
    OTHER,        /* 0xc5e4 */
    OTHER,        /* 0xc5e5 */
    OTHER,        /* 0xc5e6 */
    OTHER,        /* 0xc5e7 */
    OTHER,        /* 0xc5e8 */
    OTHER,        /* 0xc5e9 */
    OTHER,        /* 0xc5ea */
    OTHER,        /* 0xc5eb */
    OTHER,        /* 0xc5ec */
    OTHER,        /* 0xc5ed */
    OTHER,        /* 0xc5ee */
    OTHER,        /* 0xc5ef */
    OTHER,        /* 0xc5f0 */
    OTHER,        /* 0xc5f1 */
    OTHER,        /* 0xc5f2 */
    OTHER,        /* 0xc5f3 */
    OTHER,        /* 0xc5f4 */
    OTHER,        /* 0xc5f5 */
    OTHER,        /* 0xc5f6 */
    OTHER,        /* 0xc5f7 */
    OTHER,        /* 0xc5f8 */
    OTHER,        /* 0xc5f9 */
    OTHER,        /* 0xc5fa */
    OTHER,        /* 0xc5fb */
    OTHER,        /* 0xc5fc */
    OTHER,        /* 0xc5fd */
    OTHER,        /* 0xc5fe */
    OTHER,        /* 0xc5ff */
    OTHER,        /* 0xc600 */
    OTHER,        /* 0xc601 */
    OTHER,        /* 0xc602 */
    OTHER,        /* 0xc603 */
    OTHER,        /* 0xc604 */
    OTHER,        /* 0xc605 */
    OTHER,        /* 0xc606 */
    OTHER,        /* 0xc607 */
    OTHER,        /* 0xc608 */
    OTHER,        /* 0xc609 */
    OTHER,        /* 0xc60a */
    OTHER,        /* 0xc60b */
    OTHER,        /* 0xc60c */
    OTHER,        /* 0xc60d */
    OTHER,        /* 0xc60e */
    OTHER,        /* 0xc60f */
    OTHER,        /* 0xc610 */
    OTHER,        /* 0xc611 */
    OTHER,        /* 0xc612 */
    OTHER,        /* 0xc613 */
    OTHER,        /* 0xc614 */
    OTHER,        /* 0xc615 */
    OTHER,        /* 0xc616 */
    OTHER,        /* 0xc617 */
    OTHER,        /* 0xc618 */
    OTHER,        /* 0xc619 */
    OTHER,        /* 0xc61a */
    OTHER,        /* 0xc61b */
    OTHER,        /* 0xc61c */
    OTHER,        /* 0xc61d */
    OTHER,        /* 0xc61e */
    OTHER,        /* 0xc61f */
    OTHER,        /* 0xc620 */
    OTHER,        /* 0xc621 */
    OTHER,        /* 0xc622 */
    OTHER,        /* 0xc623 */
    OTHER,        /* 0xc624 */
    OTHER,        /* 0xc625 */
    OTHER,        /* 0xc626 */
    OTHER,        /* 0xc627 */
    OTHER,        /* 0xc628 */
    OTHER,        /* 0xc629 */
    OTHER,        /* 0xc62a */
    OTHER,        /* 0xc62b */
    OTHER,        /* 0xc62c */
    OTHER,        /* 0xc62d */
    OTHER,        /* 0xc62e */
    OTHER,        /* 0xc62f */
    OTHER,        /* 0xc630 */
    OTHER,        /* 0xc631 */
    OTHER,        /* 0xc632 */
    OTHER,        /* 0xc633 */
    OTHER,        /* 0xc634 */
    OTHER,        /* 0xc635 */
    OTHER,        /* 0xc636 */
    OTHER,        /* 0xc637 */
    OTHER,        /* 0xc638 */
    OTHER,        /* 0xc639 */
    OTHER,        /* 0xc63a */
    OTHER,        /* 0xc63b */
    OTHER,        /* 0xc63c */
    OTHER,        /* 0xc63d */
    OTHER,        /* 0xc63e */
    OTHER,        /* 0xc63f */
    OTHER,        /* 0xc640 */
    OTHER,        /* 0xc641 */
    OTHER,        /* 0xc642 */
    OTHER,        /* 0xc643 */
    OTHER,        /* 0xc644 */
    OTHER,        /* 0xc645 */
    OTHER,        /* 0xc646 */
    OTHER,        /* 0xc647 */
    OTHER,        /* 0xc648 */
    OTHER,        /* 0xc649 */
    OTHER,        /* 0xc64a */
    OTHER,        /* 0xc64b */
    OTHER,        /* 0xc64c */
    OTHER,        /* 0xc64d */
    OTHER,        /* 0xc64e */
    OTHER,        /* 0xc64f */
    OTHER,        /* 0xc650 */
    OTHER,        /* 0xc651 */
    OTHER,        /* 0xc652 */
    OTHER,        /* 0xc653 */
    OTHER,        /* 0xc654 */
    OTHER,        /* 0xc655 */
    OTHER,        /* 0xc656 */
    OTHER,        /* 0xc657 */
    OTHER,        /* 0xc658 */
    OTHER,        /* 0xc659 */
    OTHER,        /* 0xc65a */
    OTHER,        /* 0xc65b */
    OTHER,        /* 0xc65c */
    OTHER,        /* 0xc65d */
    OTHER,        /* 0xc65e */
    OTHER,        /* 0xc65f */
    OTHER,        /* 0xc660 */
    OTHER,        /* 0xc661 */
    OTHER,        /* 0xc662 */
    OTHER,        /* 0xc663 */
    OTHER,        /* 0xc664 */
    OTHER,        /* 0xc665 */
    OTHER,        /* 0xc666 */
    OTHER,        /* 0xc667 */
    OTHER,        /* 0xc668 */
    OTHER,        /* 0xc669 */
    OTHER,        /* 0xc66a */
    OTHER,        /* 0xc66b */
    OTHER,        /* 0xc66c */
    OTHER,        /* 0xc66d */
    OTHER,        /* 0xc66e */
    OTHER,        /* 0xc66f */
    OTHER,        /* 0xc670 */
    OTHER,        /* 0xc671 */
    OTHER,        /* 0xc672 */
    OTHER,        /* 0xc673 */
    OTHER,        /* 0xc674 */
    OTHER,        /* 0xc675 */
    OTHER,        /* 0xc676 */
    OTHER,        /* 0xc677 */
    OTHER,        /* 0xc678 */
    OTHER,        /* 0xc679 */
    OTHER,        /* 0xc67a */
    OTHER,        /* 0xc67b */
    OTHER,        /* 0xc67c */
    OTHER,        /* 0xc67d */
    OTHER,        /* 0xc67e */
    OTHER,        /* 0xc67f */
    OTHER,        /* 0xc680 */
    OTHER,        /* 0xc681 */
    OTHER,        /* 0xc682 */
    OTHER,        /* 0xc683 */
    OTHER,        /* 0xc684 */
    OTHER,        /* 0xc685 */
    OTHER,        /* 0xc686 */
    OTHER,        /* 0xc687 */
    OTHER,        /* 0xc688 */
    OTHER,        /* 0xc689 */
    OTHER,        /* 0xc68a */
    OTHER,        /* 0xc68b */
    OTHER,        /* 0xc68c */
    OTHER,        /* 0xc68d */
    OTHER,        /* 0xc68e */
    OTHER,        /* 0xc68f */
    OTHER,        /* 0xc690 */
    OTHER,        /* 0xc691 */
    OTHER,        /* 0xc692 */
    OTHER,        /* 0xc693 */
    OTHER,        /* 0xc694 */
    OTHER,        /* 0xc695 */
    OTHER,        /* 0xc696 */
    OTHER,        /* 0xc697 */
    OTHER,        /* 0xc698 */
    OTHER,        /* 0xc699 */
    OTHER,        /* 0xc69a */
    OTHER,        /* 0xc69b */
    OTHER,        /* 0xc69c */
    OTHER,        /* 0xc69d */
    OTHER,        /* 0xc69e */
    OTHER,        /* 0xc69f */
    OTHER,        /* 0xc6a0 */
    OTHER,        /* 0xc6a1 */
    OTHER,        /* 0xc6a2 */
    OTHER,        /* 0xc6a3 */
    OTHER,        /* 0xc6a4 */
    OTHER,        /* 0xc6a5 */
    OTHER,        /* 0xc6a6 */
    OTHER,        /* 0xc6a7 */
    OTHER,        /* 0xc6a8 */
    OTHER,        /* 0xc6a9 */
    OTHER,        /* 0xc6aa */
    OTHER,        /* 0xc6ab */
    OTHER,        /* 0xc6ac */
    OTHER,        /* 0xc6ad */
    OTHER,        /* 0xc6ae */
    OTHER,        /* 0xc6af */
    OTHER,        /* 0xc6b0 */
    OTHER,        /* 0xc6b1 */
    OTHER,        /* 0xc6b2 */
    OTHER,        /* 0xc6b3 */
    OTHER,        /* 0xc6b4 */
    OTHER,        /* 0xc6b5 */
    OTHER,        /* 0xc6b6 */
    OTHER,        /* 0xc6b7 */
    OTHER,        /* 0xc6b8 */
    OTHER,        /* 0xc6b9 */
    OTHER,        /* 0xc6ba */
    OTHER,        /* 0xc6bb */
    OTHER,        /* 0xc6bc */
    OTHER,        /* 0xc6bd */
    OTHER,        /* 0xc6be */
    OTHER,        /* 0xc6bf */
    OTHER,        /* 0xc6c0 */
    OTHER,        /* 0xc6c1 */
    OTHER,        /* 0xc6c2 */
    OTHER,        /* 0xc6c3 */
    OTHER,        /* 0xc6c4 */
    OTHER,        /* 0xc6c5 */
    OTHER,        /* 0xc6c6 */
    OTHER,        /* 0xc6c7 */
    OTHER,        /* 0xc6c8 */
    OTHER,        /* 0xc6c9 */
    OTHER,        /* 0xc6ca */
    OTHER,        /* 0xc6cb */
    OTHER,        /* 0xc6cc */
    OTHER,        /* 0xc6cd */
    OTHER,        /* 0xc6ce */
    OTHER,        /* 0xc6cf */
    OTHER,        /* 0xc6d0 */
    OTHER,        /* 0xc6d1 */
    OTHER,        /* 0xc6d2 */
    OTHER,        /* 0xc6d3 */
    OTHER,        /* 0xc6d4 */
    OTHER,        /* 0xc6d5 */
    OTHER,        /* 0xc6d6 */
    OTHER,        /* 0xc6d7 */
    OTHER,        /* 0xc6d8 */
    OTHER,        /* 0xc6d9 */
    OTHER,        /* 0xc6da */
    OTHER,        /* 0xc6db */
    OTHER,        /* 0xc6dc */
    OTHER,        /* 0xc6dd */
    OTHER,        /* 0xc6de */
    OTHER,        /* 0xc6df */
    OTHER,        /* 0xc6e0 */
    OTHER,        /* 0xc6e1 */
    OTHER,        /* 0xc6e2 */
    OTHER,        /* 0xc6e3 */
    OTHER,        /* 0xc6e4 */
    OTHER,        /* 0xc6e5 */
    OTHER,        /* 0xc6e6 */
    OTHER,        /* 0xc6e7 */
    OTHER,        /* 0xc6e8 */
    OTHER,        /* 0xc6e9 */
    OTHER,        /* 0xc6ea */
    OTHER,        /* 0xc6eb */
    OTHER,        /* 0xc6ec */
    OTHER,        /* 0xc6ed */
    OTHER,        /* 0xc6ee */
    OTHER,        /* 0xc6ef */
    OTHER,        /* 0xc6f0 */
    OTHER,        /* 0xc6f1 */
    OTHER,        /* 0xc6f2 */
    OTHER,        /* 0xc6f3 */
    OTHER,        /* 0xc6f4 */
    OTHER,        /* 0xc6f5 */
    OTHER,        /* 0xc6f6 */
    OTHER,        /* 0xc6f7 */
    OTHER,        /* 0xc6f8 */
    OTHER,        /* 0xc6f9 */
    OTHER,        /* 0xc6fa */
    OTHER,        /* 0xc6fb */
    OTHER,        /* 0xc6fc */
    OTHER,        /* 0xc6fd */
    OTHER,        /* 0xc6fe */
    OTHER,        /* 0xc6ff */
    OTHER,        /* 0xc700 */
    OTHER,        /* 0xc701 */
    OTHER,        /* 0xc702 */
    OTHER,        /* 0xc703 */
    OTHER,        /* 0xc704 */
    OTHER,        /* 0xc705 */
    OTHER,        /* 0xc706 */
    OTHER,        /* 0xc707 */
    OTHER,        /* 0xc708 */
    OTHER,        /* 0xc709 */
    OTHER,        /* 0xc70a */
    OTHER,        /* 0xc70b */
    OTHER,        /* 0xc70c */
    OTHER,        /* 0xc70d */
    OTHER,        /* 0xc70e */
    OTHER,        /* 0xc70f */
    OTHER,        /* 0xc710 */
    OTHER,        /* 0xc711 */
    OTHER,        /* 0xc712 */
    OTHER,        /* 0xc713 */
    OTHER,        /* 0xc714 */
    OTHER,        /* 0xc715 */
    OTHER,        /* 0xc716 */
    OTHER,        /* 0xc717 */
    OTHER,        /* 0xc718 */
    OTHER,        /* 0xc719 */
    OTHER,        /* 0xc71a */
    OTHER,        /* 0xc71b */
    OTHER,        /* 0xc71c */
    OTHER,        /* 0xc71d */
    OTHER,        /* 0xc71e */
    OTHER,        /* 0xc71f */
    OTHER,        /* 0xc720 */
    OTHER,        /* 0xc721 */
    OTHER,        /* 0xc722 */
    OTHER,        /* 0xc723 */
    OTHER,        /* 0xc724 */
    OTHER,        /* 0xc725 */
    OTHER,        /* 0xc726 */
    OTHER,        /* 0xc727 */
    OTHER,        /* 0xc728 */
    OTHER,        /* 0xc729 */
    OTHER,        /* 0xc72a */
    OTHER,        /* 0xc72b */
    OTHER,        /* 0xc72c */
    OTHER,        /* 0xc72d */
    OTHER,        /* 0xc72e */
    OTHER,        /* 0xc72f */
    OTHER,        /* 0xc730 */
    OTHER,        /* 0xc731 */
    OTHER,        /* 0xc732 */
    OTHER,        /* 0xc733 */
    OTHER,        /* 0xc734 */
    OTHER,        /* 0xc735 */
    OTHER,        /* 0xc736 */
    OTHER,        /* 0xc737 */
    OTHER,        /* 0xc738 */
    OTHER,        /* 0xc739 */
    OTHER,        /* 0xc73a */
    OTHER,        /* 0xc73b */
    OTHER,        /* 0xc73c */
    OTHER,        /* 0xc73d */
    OTHER,        /* 0xc73e */
    OTHER,        /* 0xc73f */
    OTHER,        /* 0xc740 */
    OTHER,        /* 0xc741 */
    OTHER,        /* 0xc742 */
    OTHER,        /* 0xc743 */
    OTHER,        /* 0xc744 */
    OTHER,        /* 0xc745 */
    OTHER,        /* 0xc746 */
    OTHER,        /* 0xc747 */
    OTHER,        /* 0xc748 */
    OTHER,        /* 0xc749 */
    OTHER,        /* 0xc74a */
    OTHER,        /* 0xc74b */
    OTHER,        /* 0xc74c */
    OTHER,        /* 0xc74d */
    OTHER,        /* 0xc74e */
    OTHER,        /* 0xc74f */
    OTHER,        /* 0xc750 */
    OTHER,        /* 0xc751 */
    OTHER,        /* 0xc752 */
    OTHER,        /* 0xc753 */
    OTHER,        /* 0xc754 */
    OTHER,        /* 0xc755 */
    OTHER,        /* 0xc756 */
    OTHER,        /* 0xc757 */
    OTHER,        /* 0xc758 */
    OTHER,        /* 0xc759 */
    OTHER,        /* 0xc75a */
    OTHER,        /* 0xc75b */
    OTHER,        /* 0xc75c */
    OTHER,        /* 0xc75d */
    OTHER,        /* 0xc75e */
    OTHER,        /* 0xc75f */
    OTHER,        /* 0xc760 */
    OTHER,        /* 0xc761 */
    OTHER,        /* 0xc762 */
    OTHER,        /* 0xc763 */
    OTHER,        /* 0xc764 */
    OTHER,        /* 0xc765 */
    OTHER,        /* 0xc766 */
    OTHER,        /* 0xc767 */
    OTHER,        /* 0xc768 */
    OTHER,        /* 0xc769 */
    OTHER,        /* 0xc76a */
    OTHER,        /* 0xc76b */
    OTHER,        /* 0xc76c */
    OTHER,        /* 0xc76d */
    OTHER,        /* 0xc76e */
    OTHER,        /* 0xc76f */
    OTHER,        /* 0xc770 */
    OTHER,        /* 0xc771 */
    OTHER,        /* 0xc772 */
    OTHER,        /* 0xc773 */
    OTHER,        /* 0xc774 */
    OTHER,        /* 0xc775 */
    OTHER,        /* 0xc776 */
    OTHER,        /* 0xc777 */
    OTHER,        /* 0xc778 */
    OTHER,        /* 0xc779 */
    OTHER,        /* 0xc77a */
    OTHER,        /* 0xc77b */
    OTHER,        /* 0xc77c */
    OTHER,        /* 0xc77d */
    OTHER,        /* 0xc77e */
    OTHER,        /* 0xc77f */
    OTHER,        /* 0xc780 */
    OTHER,        /* 0xc781 */
    OTHER,        /* 0xc782 */
    OTHER,        /* 0xc783 */
    OTHER,        /* 0xc784 */
    OTHER,        /* 0xc785 */
    OTHER,        /* 0xc786 */
    OTHER,        /* 0xc787 */
    OTHER,        /* 0xc788 */
    OTHER,        /* 0xc789 */
    OTHER,        /* 0xc78a */
    OTHER,        /* 0xc78b */
    OTHER,        /* 0xc78c */
    OTHER,        /* 0xc78d */
    OTHER,        /* 0xc78e */
    OTHER,        /* 0xc78f */
    OTHER,        /* 0xc790 */
    OTHER,        /* 0xc791 */
    OTHER,        /* 0xc792 */
    OTHER,        /* 0xc793 */
    OTHER,        /* 0xc794 */
    OTHER,        /* 0xc795 */
    OTHER,        /* 0xc796 */
    OTHER,        /* 0xc797 */
    OTHER,        /* 0xc798 */
    OTHER,        /* 0xc799 */
    OTHER,        /* 0xc79a */
    OTHER,        /* 0xc79b */
    OTHER,        /* 0xc79c */
    OTHER,        /* 0xc79d */
    OTHER,        /* 0xc79e */
    OTHER,        /* 0xc79f */
    OTHER,        /* 0xc7a0 */
    OTHER,        /* 0xc7a1 */
    OTHER,        /* 0xc7a2 */
    OTHER,        /* 0xc7a3 */
    OTHER,        /* 0xc7a4 */
    OTHER,        /* 0xc7a5 */
    OTHER,        /* 0xc7a6 */
    OTHER,        /* 0xc7a7 */
    OTHER,        /* 0xc7a8 */
    OTHER,        /* 0xc7a9 */
    OTHER,        /* 0xc7aa */
    OTHER,        /* 0xc7ab */
    OTHER,        /* 0xc7ac */
    OTHER,        /* 0xc7ad */
    OTHER,        /* 0xc7ae */
    OTHER,        /* 0xc7af */
    OTHER,        /* 0xc7b0 */
    OTHER,        /* 0xc7b1 */
    OTHER,        /* 0xc7b2 */
    OTHER,        /* 0xc7b3 */
    OTHER,        /* 0xc7b4 */
    OTHER,        /* 0xc7b5 */
    OTHER,        /* 0xc7b6 */
    OTHER,        /* 0xc7b7 */
    OTHER,        /* 0xc7b8 */
    OTHER,        /* 0xc7b9 */
    OTHER,        /* 0xc7ba */
    OTHER,        /* 0xc7bb */
    OTHER,        /* 0xc7bc */
    OTHER,        /* 0xc7bd */
    OTHER,        /* 0xc7be */
    OTHER,        /* 0xc7bf */
    OTHER,        /* 0xc7c0 */
    OTHER,        /* 0xc7c1 */
    OTHER,        /* 0xc7c2 */
    OTHER,        /* 0xc7c3 */
    OTHER,        /* 0xc7c4 */
    OTHER,        /* 0xc7c5 */
    OTHER,        /* 0xc7c6 */
    OTHER,        /* 0xc7c7 */
    OTHER,        /* 0xc7c8 */
    OTHER,        /* 0xc7c9 */
    OTHER,        /* 0xc7ca */
    OTHER,        /* 0xc7cb */
    OTHER,        /* 0xc7cc */
    OTHER,        /* 0xc7cd */
    OTHER,        /* 0xc7ce */
    OTHER,        /* 0xc7cf */
    OTHER,        /* 0xc7d0 */
    OTHER,        /* 0xc7d1 */
    OTHER,        /* 0xc7d2 */
    OTHER,        /* 0xc7d3 */
    OTHER,        /* 0xc7d4 */
    OTHER,        /* 0xc7d5 */
    OTHER,        /* 0xc7d6 */
    OTHER,        /* 0xc7d7 */
    OTHER,        /* 0xc7d8 */
    OTHER,        /* 0xc7d9 */
    OTHER,        /* 0xc7da */
    OTHER,        /* 0xc7db */
    OTHER,        /* 0xc7dc */
    OTHER,        /* 0xc7dd */
    OTHER,        /* 0xc7de */
    OTHER,        /* 0xc7df */
    OTHER,        /* 0xc7e0 */
    OTHER,        /* 0xc7e1 */
    OTHER,        /* 0xc7e2 */
    OTHER,        /* 0xc7e3 */
    OTHER,        /* 0xc7e4 */
    OTHER,        /* 0xc7e5 */
    OTHER,        /* 0xc7e6 */
    OTHER,        /* 0xc7e7 */
    OTHER,        /* 0xc7e8 */
    OTHER,        /* 0xc7e9 */
    OTHER,        /* 0xc7ea */
    OTHER,        /* 0xc7eb */
    OTHER,        /* 0xc7ec */
    OTHER,        /* 0xc7ed */
    OTHER,        /* 0xc7ee */
    OTHER,        /* 0xc7ef */
    OTHER,        /* 0xc7f0 */
    OTHER,        /* 0xc7f1 */
    OTHER,        /* 0xc7f2 */
    OTHER,        /* 0xc7f3 */
    OTHER,        /* 0xc7f4 */
    OTHER,        /* 0xc7f5 */
    OTHER,        /* 0xc7f6 */
    OTHER,        /* 0xc7f7 */
    OTHER,        /* 0xc7f8 */
    OTHER,        /* 0xc7f9 */
    OTHER,        /* 0xc7fa */
    OTHER,        /* 0xc7fb */
    OTHER,        /* 0xc7fc */
    OTHER,        /* 0xc7fd */
    OTHER,        /* 0xc7fe */
    OTHER,        /* 0xc7ff */
    OTHER,        /* 0xc800 */
    OTHER,        /* 0xc801 */
    OTHER,        /* 0xc802 */
    OTHER,        /* 0xc803 */
    OTHER,        /* 0xc804 */
    OTHER,        /* 0xc805 */
    OTHER,        /* 0xc806 */
    OTHER,        /* 0xc807 */
    OTHER,        /* 0xc808 */
    OTHER,        /* 0xc809 */
    OTHER,        /* 0xc80a */
    OTHER,        /* 0xc80b */
    OTHER,        /* 0xc80c */
    OTHER,        /* 0xc80d */
    OTHER,        /* 0xc80e */
    OTHER,        /* 0xc80f */
    OTHER,        /* 0xc810 */
    OTHER,        /* 0xc811 */
    OTHER,        /* 0xc812 */
    OTHER,        /* 0xc813 */
    OTHER,        /* 0xc814 */
    OTHER,        /* 0xc815 */
    OTHER,        /* 0xc816 */
    OTHER,        /* 0xc817 */
    OTHER,        /* 0xc818 */
    OTHER,        /* 0xc819 */
    OTHER,        /* 0xc81a */
    OTHER,        /* 0xc81b */
    OTHER,        /* 0xc81c */
    OTHER,        /* 0xc81d */
    OTHER,        /* 0xc81e */
    OTHER,        /* 0xc81f */
    OTHER,        /* 0xc820 */
    OTHER,        /* 0xc821 */
    OTHER,        /* 0xc822 */
    OTHER,        /* 0xc823 */
    OTHER,        /* 0xc824 */
    OTHER,        /* 0xc825 */
    OTHER,        /* 0xc826 */
    OTHER,        /* 0xc827 */
    OTHER,        /* 0xc828 */
    OTHER,        /* 0xc829 */
    OTHER,        /* 0xc82a */
    OTHER,        /* 0xc82b */
    OTHER,        /* 0xc82c */
    OTHER,        /* 0xc82d */
    OTHER,        /* 0xc82e */
    OTHER,        /* 0xc82f */
    OTHER,        /* 0xc830 */
    OTHER,        /* 0xc831 */
    OTHER,        /* 0xc832 */
    OTHER,        /* 0xc833 */
    OTHER,        /* 0xc834 */
    OTHER,        /* 0xc835 */
    OTHER,        /* 0xc836 */
    OTHER,        /* 0xc837 */
    OTHER,        /* 0xc838 */
    OTHER,        /* 0xc839 */
    OTHER,        /* 0xc83a */
    OTHER,        /* 0xc83b */
    OTHER,        /* 0xc83c */
    OTHER,        /* 0xc83d */
    OTHER,        /* 0xc83e */
    OTHER,        /* 0xc83f */
    OTHER,        /* 0xc840 */
    OTHER,        /* 0xc841 */
    OTHER,        /* 0xc842 */
    OTHER,        /* 0xc843 */
    OTHER,        /* 0xc844 */
    OTHER,        /* 0xc845 */
    OTHER,        /* 0xc846 */
    OTHER,        /* 0xc847 */
    OTHER,        /* 0xc848 */
    OTHER,        /* 0xc849 */
    OTHER,        /* 0xc84a */
    OTHER,        /* 0xc84b */
    OTHER,        /* 0xc84c */
    OTHER,        /* 0xc84d */
    OTHER,        /* 0xc84e */
    OTHER,        /* 0xc84f */
    OTHER,        /* 0xc850 */
    OTHER,        /* 0xc851 */
    OTHER,        /* 0xc852 */
    OTHER,        /* 0xc853 */
    OTHER,        /* 0xc854 */
    OTHER,        /* 0xc855 */
    OTHER,        /* 0xc856 */
    OTHER,        /* 0xc857 */
    OTHER,        /* 0xc858 */
    OTHER,        /* 0xc859 */
    OTHER,        /* 0xc85a */
    OTHER,        /* 0xc85b */
    OTHER,        /* 0xc85c */
    OTHER,        /* 0xc85d */
    OTHER,        /* 0xc85e */
    OTHER,        /* 0xc85f */
    OTHER,        /* 0xc860 */
    OTHER,        /* 0xc861 */
    OTHER,        /* 0xc862 */
    OTHER,        /* 0xc863 */
    OTHER,        /* 0xc864 */
    OTHER,        /* 0xc865 */
    OTHER,        /* 0xc866 */
    OTHER,        /* 0xc867 */
    OTHER,        /* 0xc868 */
    OTHER,        /* 0xc869 */
    OTHER,        /* 0xc86a */
    OTHER,        /* 0xc86b */
    OTHER,        /* 0xc86c */
    OTHER,        /* 0xc86d */
    OTHER,        /* 0xc86e */
    OTHER,        /* 0xc86f */
    OTHER,        /* 0xc870 */
    OTHER,        /* 0xc871 */
    OTHER,        /* 0xc872 */
    OTHER,        /* 0xc873 */
    OTHER,        /* 0xc874 */
    OTHER,        /* 0xc875 */
    OTHER,        /* 0xc876 */
    OTHER,        /* 0xc877 */
    OTHER,        /* 0xc878 */
    OTHER,        /* 0xc879 */
    OTHER,        /* 0xc87a */
    OTHER,        /* 0xc87b */
    OTHER,        /* 0xc87c */
    OTHER,        /* 0xc87d */
    OTHER,        /* 0xc87e */
    OTHER,        /* 0xc87f */
    OTHER,        /* 0xc880 */
    OTHER,        /* 0xc881 */
    OTHER,        /* 0xc882 */
    OTHER,        /* 0xc883 */
    OTHER,        /* 0xc884 */
    OTHER,        /* 0xc885 */
    OTHER,        /* 0xc886 */
    OTHER,        /* 0xc887 */
    OTHER,        /* 0xc888 */
    OTHER,        /* 0xc889 */
    OTHER,        /* 0xc88a */
    OTHER,        /* 0xc88b */
    OTHER,        /* 0xc88c */
    OTHER,        /* 0xc88d */
    OTHER,        /* 0xc88e */
    OTHER,        /* 0xc88f */
    OTHER,        /* 0xc890 */
    OTHER,        /* 0xc891 */
    OTHER,        /* 0xc892 */
    OTHER,        /* 0xc893 */
    OTHER,        /* 0xc894 */
    OTHER,        /* 0xc895 */
    OTHER,        /* 0xc896 */
    OTHER,        /* 0xc897 */
    OTHER,        /* 0xc898 */
    OTHER,        /* 0xc899 */
    OTHER,        /* 0xc89a */
    OTHER,        /* 0xc89b */
    OTHER,        /* 0xc89c */
    OTHER,        /* 0xc89d */
    OTHER,        /* 0xc89e */
    OTHER,        /* 0xc89f */
    OTHER,        /* 0xc8a0 */
    OTHER,        /* 0xc8a1 */
    OTHER,        /* 0xc8a2 */
    OTHER,        /* 0xc8a3 */
    OTHER,        /* 0xc8a4 */
    OTHER,        /* 0xc8a5 */
    OTHER,        /* 0xc8a6 */
    OTHER,        /* 0xc8a7 */
    OTHER,        /* 0xc8a8 */
    OTHER,        /* 0xc8a9 */
    OTHER,        /* 0xc8aa */
    OTHER,        /* 0xc8ab */
    OTHER,        /* 0xc8ac */
    OTHER,        /* 0xc8ad */
    OTHER,        /* 0xc8ae */
    OTHER,        /* 0xc8af */
    OTHER,        /* 0xc8b0 */
    OTHER,        /* 0xc8b1 */
    OTHER,        /* 0xc8b2 */
    OTHER,        /* 0xc8b3 */
    OTHER,        /* 0xc8b4 */
    OTHER,        /* 0xc8b5 */
    OTHER,        /* 0xc8b6 */
    OTHER,        /* 0xc8b7 */
    OTHER,        /* 0xc8b8 */
    OTHER,        /* 0xc8b9 */
    OTHER,        /* 0xc8ba */
    OTHER,        /* 0xc8bb */
    OTHER,        /* 0xc8bc */
    OTHER,        /* 0xc8bd */
    OTHER,        /* 0xc8be */
    OTHER,        /* 0xc8bf */
    OTHER,        /* 0xc8c0 */
    OTHER,        /* 0xc8c1 */
    OTHER,        /* 0xc8c2 */
    OTHER,        /* 0xc8c3 */
    OTHER,        /* 0xc8c4 */
    OTHER,        /* 0xc8c5 */
    OTHER,        /* 0xc8c6 */
    OTHER,        /* 0xc8c7 */
    OTHER,        /* 0xc8c8 */
    OTHER,        /* 0xc8c9 */
    OTHER,        /* 0xc8ca */
    OTHER,        /* 0xc8cb */
    OTHER,        /* 0xc8cc */
    OTHER,        /* 0xc8cd */
    OTHER,        /* 0xc8ce */
    OTHER,        /* 0xc8cf */
    OTHER,        /* 0xc8d0 */
    OTHER,        /* 0xc8d1 */
    OTHER,        /* 0xc8d2 */
    OTHER,        /* 0xc8d3 */
    OTHER,        /* 0xc8d4 */
    OTHER,        /* 0xc8d5 */
    OTHER,        /* 0xc8d6 */
    OTHER,        /* 0xc8d7 */
    OTHER,        /* 0xc8d8 */
    OTHER,        /* 0xc8d9 */
    OTHER,        /* 0xc8da */
    OTHER,        /* 0xc8db */
    OTHER,        /* 0xc8dc */
    OTHER,        /* 0xc8dd */
    OTHER,        /* 0xc8de */
    OTHER,        /* 0xc8df */
    OTHER,        /* 0xc8e0 */
    OTHER,        /* 0xc8e1 */
    OTHER,        /* 0xc8e2 */
    OTHER,        /* 0xc8e3 */
    OTHER,        /* 0xc8e4 */
    OTHER,        /* 0xc8e5 */
    OTHER,        /* 0xc8e6 */
    OTHER,        /* 0xc8e7 */
    OTHER,        /* 0xc8e8 */
    OTHER,        /* 0xc8e9 */
    OTHER,        /* 0xc8ea */
    OTHER,        /* 0xc8eb */
    OTHER,        /* 0xc8ec */
    OTHER,        /* 0xc8ed */
    OTHER,        /* 0xc8ee */
    OTHER,        /* 0xc8ef */
    OTHER,        /* 0xc8f0 */
    OTHER,        /* 0xc8f1 */
    OTHER,        /* 0xc8f2 */
    OTHER,        /* 0xc8f3 */
    OTHER,        /* 0xc8f4 */
    OTHER,        /* 0xc8f5 */
    OTHER,        /* 0xc8f6 */
    OTHER,        /* 0xc8f7 */
    OTHER,        /* 0xc8f8 */
    OTHER,        /* 0xc8f9 */
    OTHER,        /* 0xc8fa */
    OTHER,        /* 0xc8fb */
    OTHER,        /* 0xc8fc */
    OTHER,        /* 0xc8fd */
    OTHER,        /* 0xc8fe */
    OTHER,        /* 0xc8ff */
    OTHER,        /* 0xc900 */
    OTHER,        /* 0xc901 */
    OTHER,        /* 0xc902 */
    OTHER,        /* 0xc903 */
    OTHER,        /* 0xc904 */
    OTHER,        /* 0xc905 */
    OTHER,        /* 0xc906 */
    OTHER,        /* 0xc907 */
    OTHER,        /* 0xc908 */
    OTHER,        /* 0xc909 */
    OTHER,        /* 0xc90a */
    OTHER,        /* 0xc90b */
    OTHER,        /* 0xc90c */
    OTHER,        /* 0xc90d */
    OTHER,        /* 0xc90e */
    OTHER,        /* 0xc90f */
    OTHER,        /* 0xc910 */
    OTHER,        /* 0xc911 */
    OTHER,        /* 0xc912 */
    OTHER,        /* 0xc913 */
    OTHER,        /* 0xc914 */
    OTHER,        /* 0xc915 */
    OTHER,        /* 0xc916 */
    OTHER,        /* 0xc917 */
    OTHER,        /* 0xc918 */
    OTHER,        /* 0xc919 */
    OTHER,        /* 0xc91a */
    OTHER,        /* 0xc91b */
    OTHER,        /* 0xc91c */
    OTHER,        /* 0xc91d */
    OTHER,        /* 0xc91e */
    OTHER,        /* 0xc91f */
    OTHER,        /* 0xc920 */
    OTHER,        /* 0xc921 */
    OTHER,        /* 0xc922 */
    OTHER,        /* 0xc923 */
    OTHER,        /* 0xc924 */
    OTHER,        /* 0xc925 */
    OTHER,        /* 0xc926 */
    OTHER,        /* 0xc927 */
    OTHER,        /* 0xc928 */
    OTHER,        /* 0xc929 */
    OTHER,        /* 0xc92a */
    OTHER,        /* 0xc92b */
    OTHER,        /* 0xc92c */
    OTHER,        /* 0xc92d */
    OTHER,        /* 0xc92e */
    OTHER,        /* 0xc92f */
    OTHER,        /* 0xc930 */
    OTHER,        /* 0xc931 */
    OTHER,        /* 0xc932 */
    OTHER,        /* 0xc933 */
    OTHER,        /* 0xc934 */
    OTHER,        /* 0xc935 */
    OTHER,        /* 0xc936 */
    OTHER,        /* 0xc937 */
    OTHER,        /* 0xc938 */
    OTHER,        /* 0xc939 */
    OTHER,        /* 0xc93a */
    OTHER,        /* 0xc93b */
    OTHER,        /* 0xc93c */
    OTHER,        /* 0xc93d */
    OTHER,        /* 0xc93e */
    OTHER,        /* 0xc93f */
    OTHER,        /* 0xc940 */
    OTHER,        /* 0xc941 */
    OTHER,        /* 0xc942 */
    OTHER,        /* 0xc943 */
    OTHER,        /* 0xc944 */
    OTHER,        /* 0xc945 */
    OTHER,        /* 0xc946 */
    OTHER,        /* 0xc947 */
    OTHER,        /* 0xc948 */
    OTHER,        /* 0xc949 */
    OTHER,        /* 0xc94a */
    OTHER,        /* 0xc94b */
    OTHER,        /* 0xc94c */
    OTHER,        /* 0xc94d */
    OTHER,        /* 0xc94e */
    OTHER,        /* 0xc94f */
    OTHER,        /* 0xc950 */
    OTHER,        /* 0xc951 */
    OTHER,        /* 0xc952 */
    OTHER,        /* 0xc953 */
    OTHER,        /* 0xc954 */
    OTHER,        /* 0xc955 */
    OTHER,        /* 0xc956 */
    OTHER,        /* 0xc957 */
    OTHER,        /* 0xc958 */
    OTHER,        /* 0xc959 */
    OTHER,        /* 0xc95a */
    OTHER,        /* 0xc95b */
    OTHER,        /* 0xc95c */
    OTHER,        /* 0xc95d */
    OTHER,        /* 0xc95e */
    OTHER,        /* 0xc95f */
    OTHER,        /* 0xc960 */
    OTHER,        /* 0xc961 */
    OTHER,        /* 0xc962 */
    OTHER,        /* 0xc963 */
    OTHER,        /* 0xc964 */
    OTHER,        /* 0xc965 */
    OTHER,        /* 0xc966 */
    OTHER,        /* 0xc967 */
    OTHER,        /* 0xc968 */
    OTHER,        /* 0xc969 */
    OTHER,        /* 0xc96a */
    OTHER,        /* 0xc96b */
    OTHER,        /* 0xc96c */
    OTHER,        /* 0xc96d */
    OTHER,        /* 0xc96e */
    OTHER,        /* 0xc96f */
    OTHER,        /* 0xc970 */
    OTHER,        /* 0xc971 */
    OTHER,        /* 0xc972 */
    OTHER,        /* 0xc973 */
    OTHER,        /* 0xc974 */
    OTHER,        /* 0xc975 */
    OTHER,        /* 0xc976 */
    OTHER,        /* 0xc977 */
    OTHER,        /* 0xc978 */
    OTHER,        /* 0xc979 */
    OTHER,        /* 0xc97a */
    OTHER,        /* 0xc97b */
    OTHER,        /* 0xc97c */
    OTHER,        /* 0xc97d */
    OTHER,        /* 0xc97e */
    OTHER,        /* 0xc97f */
    OTHER,        /* 0xc980 */
    OTHER,        /* 0xc981 */
    OTHER,        /* 0xc982 */
    OTHER,        /* 0xc983 */
    OTHER,        /* 0xc984 */
    OTHER,        /* 0xc985 */
    OTHER,        /* 0xc986 */
    OTHER,        /* 0xc987 */
    OTHER,        /* 0xc988 */
    OTHER,        /* 0xc989 */
    OTHER,        /* 0xc98a */
    OTHER,        /* 0xc98b */
    OTHER,        /* 0xc98c */
    OTHER,        /* 0xc98d */
    OTHER,        /* 0xc98e */
    OTHER,        /* 0xc98f */
    OTHER,        /* 0xc990 */
    OTHER,        /* 0xc991 */
    OTHER,        /* 0xc992 */
    OTHER,        /* 0xc993 */
    OTHER,        /* 0xc994 */
    OTHER,        /* 0xc995 */
    OTHER,        /* 0xc996 */
    OTHER,        /* 0xc997 */
    OTHER,        /* 0xc998 */
    OTHER,        /* 0xc999 */
    OTHER,        /* 0xc99a */
    OTHER,        /* 0xc99b */
    OTHER,        /* 0xc99c */
    OTHER,        /* 0xc99d */
    OTHER,        /* 0xc99e */
    OTHER,        /* 0xc99f */
    OTHER,        /* 0xc9a0 */
    OTHER,        /* 0xc9a1 */
    OTHER,        /* 0xc9a2 */
    OTHER,        /* 0xc9a3 */
    OTHER,        /* 0xc9a4 */
    OTHER,        /* 0xc9a5 */
    OTHER,        /* 0xc9a6 */
    OTHER,        /* 0xc9a7 */
    OTHER,        /* 0xc9a8 */
    OTHER,        /* 0xc9a9 */
    OTHER,        /* 0xc9aa */
    OTHER,        /* 0xc9ab */
    OTHER,        /* 0xc9ac */
    OTHER,        /* 0xc9ad */
    OTHER,        /* 0xc9ae */
    OTHER,        /* 0xc9af */
    OTHER,        /* 0xc9b0 */
    OTHER,        /* 0xc9b1 */
    OTHER,        /* 0xc9b2 */
    OTHER,        /* 0xc9b3 */
    OTHER,        /* 0xc9b4 */
    OTHER,        /* 0xc9b5 */
    OTHER,        /* 0xc9b6 */
    OTHER,        /* 0xc9b7 */
    OTHER,        /* 0xc9b8 */
    OTHER,        /* 0xc9b9 */
    OTHER,        /* 0xc9ba */
    OTHER,        /* 0xc9bb */
    OTHER,        /* 0xc9bc */
    OTHER,        /* 0xc9bd */
    OTHER,        /* 0xc9be */
    OTHER,        /* 0xc9bf */
    OTHER,        /* 0xc9c0 */
    OTHER,        /* 0xc9c1 */
    OTHER,        /* 0xc9c2 */
    OTHER,        /* 0xc9c3 */
    OTHER,        /* 0xc9c4 */
    OTHER,        /* 0xc9c5 */
    OTHER,        /* 0xc9c6 */
    OTHER,        /* 0xc9c7 */
    OTHER,        /* 0xc9c8 */
    OTHER,        /* 0xc9c9 */
    OTHER,        /* 0xc9ca */
    OTHER,        /* 0xc9cb */
    OTHER,        /* 0xc9cc */
    OTHER,        /* 0xc9cd */
    OTHER,        /* 0xc9ce */
    OTHER,        /* 0xc9cf */
    OTHER,        /* 0xc9d0 */
    OTHER,        /* 0xc9d1 */
    OTHER,        /* 0xc9d2 */
    OTHER,        /* 0xc9d3 */
    OTHER,        /* 0xc9d4 */
    OTHER,        /* 0xc9d5 */
    OTHER,        /* 0xc9d6 */
    OTHER,        /* 0xc9d7 */
    OTHER,        /* 0xc9d8 */
    OTHER,        /* 0xc9d9 */
    OTHER,        /* 0xc9da */
    OTHER,        /* 0xc9db */
    OTHER,        /* 0xc9dc */
    OTHER,        /* 0xc9dd */
    OTHER,        /* 0xc9de */
    OTHER,        /* 0xc9df */
    OTHER,        /* 0xc9e0 */
    OTHER,        /* 0xc9e1 */
    OTHER,        /* 0xc9e2 */
    OTHER,        /* 0xc9e3 */
    OTHER,        /* 0xc9e4 */
    OTHER,        /* 0xc9e5 */
    OTHER,        /* 0xc9e6 */
    OTHER,        /* 0xc9e7 */
    OTHER,        /* 0xc9e8 */
    OTHER,        /* 0xc9e9 */
    OTHER,        /* 0xc9ea */
    OTHER,        /* 0xc9eb */
    OTHER,        /* 0xc9ec */
    OTHER,        /* 0xc9ed */
    OTHER,        /* 0xc9ee */
    OTHER,        /* 0xc9ef */
    OTHER,        /* 0xc9f0 */
    OTHER,        /* 0xc9f1 */
    OTHER,        /* 0xc9f2 */
    OTHER,        /* 0xc9f3 */
    OTHER,        /* 0xc9f4 */
    OTHER,        /* 0xc9f5 */
    OTHER,        /* 0xc9f6 */
    OTHER,        /* 0xc9f7 */
    OTHER,        /* 0xc9f8 */
    OTHER,        /* 0xc9f9 */
    OTHER,        /* 0xc9fa */
    OTHER,        /* 0xc9fb */
    OTHER,        /* 0xc9fc */
    OTHER,        /* 0xc9fd */
    OTHER,        /* 0xc9fe */
    OTHER,        /* 0xc9ff */
    OTHER,        /* 0xca00 */
    OTHER,        /* 0xca01 */
    OTHER,        /* 0xca02 */
    OTHER,        /* 0xca03 */
    OTHER,        /* 0xca04 */
    OTHER,        /* 0xca05 */
    OTHER,        /* 0xca06 */
    OTHER,        /* 0xca07 */
    OTHER,        /* 0xca08 */
    OTHER,        /* 0xca09 */
    OTHER,        /* 0xca0a */
    OTHER,        /* 0xca0b */
    OTHER,        /* 0xca0c */
    OTHER,        /* 0xca0d */
    OTHER,        /* 0xca0e */
    OTHER,        /* 0xca0f */
    OTHER,        /* 0xca10 */
    OTHER,        /* 0xca11 */
    OTHER,        /* 0xca12 */
    OTHER,        /* 0xca13 */
    OTHER,        /* 0xca14 */
    OTHER,        /* 0xca15 */
    OTHER,        /* 0xca16 */
    OTHER,        /* 0xca17 */
    OTHER,        /* 0xca18 */
    OTHER,        /* 0xca19 */
    OTHER,        /* 0xca1a */
    OTHER,        /* 0xca1b */
    OTHER,        /* 0xca1c */
    OTHER,        /* 0xca1d */
    OTHER,        /* 0xca1e */
    OTHER,        /* 0xca1f */
    OTHER,        /* 0xca20 */
    OTHER,        /* 0xca21 */
    OTHER,        /* 0xca22 */
    OTHER,        /* 0xca23 */
    OTHER,        /* 0xca24 */
    OTHER,        /* 0xca25 */
    OTHER,        /* 0xca26 */
    OTHER,        /* 0xca27 */
    OTHER,        /* 0xca28 */
    OTHER,        /* 0xca29 */
    OTHER,        /* 0xca2a */
    OTHER,        /* 0xca2b */
    OTHER,        /* 0xca2c */
    OTHER,        /* 0xca2d */
    OTHER,        /* 0xca2e */
    OTHER,        /* 0xca2f */
    OTHER,        /* 0xca30 */
    OTHER,        /* 0xca31 */
    OTHER,        /* 0xca32 */
    OTHER,        /* 0xca33 */
    OTHER,        /* 0xca34 */
    OTHER,        /* 0xca35 */
    OTHER,        /* 0xca36 */
    OTHER,        /* 0xca37 */
    OTHER,        /* 0xca38 */
    OTHER,        /* 0xca39 */
    OTHER,        /* 0xca3a */
    OTHER,        /* 0xca3b */
    OTHER,        /* 0xca3c */
    OTHER,        /* 0xca3d */
    OTHER,        /* 0xca3e */
    OTHER,        /* 0xca3f */
    OTHER,        /* 0xca40 */
    OTHER,        /* 0xca41 */
    OTHER,        /* 0xca42 */
    OTHER,        /* 0xca43 */
    OTHER,        /* 0xca44 */
    OTHER,        /* 0xca45 */
    OTHER,        /* 0xca46 */
    OTHER,        /* 0xca47 */
    OTHER,        /* 0xca48 */
    OTHER,        /* 0xca49 */
    OTHER,        /* 0xca4a */
    OTHER,        /* 0xca4b */
    OTHER,        /* 0xca4c */
    OTHER,        /* 0xca4d */
    OTHER,        /* 0xca4e */
    OTHER,        /* 0xca4f */
    OTHER,        /* 0xca50 */
    OTHER,        /* 0xca51 */
    OTHER,        /* 0xca52 */
    OTHER,        /* 0xca53 */
    OTHER,        /* 0xca54 */
    OTHER,        /* 0xca55 */
    OTHER,        /* 0xca56 */
    OTHER,        /* 0xca57 */
    OTHER,        /* 0xca58 */
    OTHER,        /* 0xca59 */
    OTHER,        /* 0xca5a */
    OTHER,        /* 0xca5b */
    OTHER,        /* 0xca5c */
    OTHER,        /* 0xca5d */
    OTHER,        /* 0xca5e */
    OTHER,        /* 0xca5f */
    OTHER,        /* 0xca60 */
    OTHER,        /* 0xca61 */
    OTHER,        /* 0xca62 */
    OTHER,        /* 0xca63 */
    OTHER,        /* 0xca64 */
    OTHER,        /* 0xca65 */
    OTHER,        /* 0xca66 */
    OTHER,        /* 0xca67 */
    OTHER,        /* 0xca68 */
    OTHER,        /* 0xca69 */
    OTHER,        /* 0xca6a */
    OTHER,        /* 0xca6b */
    OTHER,        /* 0xca6c */
    OTHER,        /* 0xca6d */
    OTHER,        /* 0xca6e */
    OTHER,        /* 0xca6f */
    OTHER,        /* 0xca70 */
    OTHER,        /* 0xca71 */
    OTHER,        /* 0xca72 */
    OTHER,        /* 0xca73 */
    OTHER,        /* 0xca74 */
    OTHER,        /* 0xca75 */
    OTHER,        /* 0xca76 */
    OTHER,        /* 0xca77 */
    OTHER,        /* 0xca78 */
    OTHER,        /* 0xca79 */
    OTHER,        /* 0xca7a */
    OTHER,        /* 0xca7b */
    OTHER,        /* 0xca7c */
    OTHER,        /* 0xca7d */
    OTHER,        /* 0xca7e */
    OTHER,        /* 0xca7f */
    OTHER,        /* 0xca80 */
    OTHER,        /* 0xca81 */
    OTHER,        /* 0xca82 */
    OTHER,        /* 0xca83 */
    OTHER,        /* 0xca84 */
    OTHER,        /* 0xca85 */
    OTHER,        /* 0xca86 */
    OTHER,        /* 0xca87 */
    OTHER,        /* 0xca88 */
    OTHER,        /* 0xca89 */
    OTHER,        /* 0xca8a */
    OTHER,        /* 0xca8b */
    OTHER,        /* 0xca8c */
    OTHER,        /* 0xca8d */
    OTHER,        /* 0xca8e */
    OTHER,        /* 0xca8f */
    OTHER,        /* 0xca90 */
    OTHER,        /* 0xca91 */
    OTHER,        /* 0xca92 */
    OTHER,        /* 0xca93 */
    OTHER,        /* 0xca94 */
    OTHER,        /* 0xca95 */
    OTHER,        /* 0xca96 */
    OTHER,        /* 0xca97 */
    OTHER,        /* 0xca98 */
    OTHER,        /* 0xca99 */
    OTHER,        /* 0xca9a */
    OTHER,        /* 0xca9b */
    OTHER,        /* 0xca9c */
    OTHER,        /* 0xca9d */
    OTHER,        /* 0xca9e */
    OTHER,        /* 0xca9f */
    OTHER,        /* 0xcaa0 */
    OTHER,        /* 0xcaa1 */
    OTHER,        /* 0xcaa2 */
    OTHER,        /* 0xcaa3 */
    OTHER,        /* 0xcaa4 */
    OTHER,        /* 0xcaa5 */
    OTHER,        /* 0xcaa6 */
    OTHER,        /* 0xcaa7 */
    OTHER,        /* 0xcaa8 */
    OTHER,        /* 0xcaa9 */
    OTHER,        /* 0xcaaa */
    OTHER,        /* 0xcaab */
    OTHER,        /* 0xcaac */
    OTHER,        /* 0xcaad */
    OTHER,        /* 0xcaae */
    OTHER,        /* 0xcaaf */
    OTHER,        /* 0xcab0 */
    OTHER,        /* 0xcab1 */
    OTHER,        /* 0xcab2 */
    OTHER,        /* 0xcab3 */
    OTHER,        /* 0xcab4 */
    OTHER,        /* 0xcab5 */
    OTHER,        /* 0xcab6 */
    OTHER,        /* 0xcab7 */
    OTHER,        /* 0xcab8 */
    OTHER,        /* 0xcab9 */
    OTHER,        /* 0xcaba */
    OTHER,        /* 0xcabb */
    OTHER,        /* 0xcabc */
    OTHER,        /* 0xcabd */
    OTHER,        /* 0xcabe */
    OTHER,        /* 0xcabf */
    OTHER,        /* 0xcac0 */
    OTHER,        /* 0xcac1 */
    OTHER,        /* 0xcac2 */
    OTHER,        /* 0xcac3 */
    OTHER,        /* 0xcac4 */
    OTHER,        /* 0xcac5 */
    OTHER,        /* 0xcac6 */
    OTHER,        /* 0xcac7 */
    OTHER,        /* 0xcac8 */
    OTHER,        /* 0xcac9 */
    OTHER,        /* 0xcaca */
    OTHER,        /* 0xcacb */
    OTHER,        /* 0xcacc */
    OTHER,        /* 0xcacd */
    OTHER,        /* 0xcace */
    OTHER,        /* 0xcacf */
    OTHER,        /* 0xcad0 */
    OTHER,        /* 0xcad1 */
    OTHER,        /* 0xcad2 */
    OTHER,        /* 0xcad3 */
    OTHER,        /* 0xcad4 */
    OTHER,        /* 0xcad5 */
    OTHER,        /* 0xcad6 */
    OTHER,        /* 0xcad7 */
    OTHER,        /* 0xcad8 */
    OTHER,        /* 0xcad9 */
    OTHER,        /* 0xcada */
    OTHER,        /* 0xcadb */
    OTHER,        /* 0xcadc */
    OTHER,        /* 0xcadd */
    OTHER,        /* 0xcade */
    OTHER,        /* 0xcadf */
    OTHER,        /* 0xcae0 */
    OTHER,        /* 0xcae1 */
    OTHER,        /* 0xcae2 */
    OTHER,        /* 0xcae3 */
    OTHER,        /* 0xcae4 */
    OTHER,        /* 0xcae5 */
    OTHER,        /* 0xcae6 */
    OTHER,        /* 0xcae7 */
    OTHER,        /* 0xcae8 */
    OTHER,        /* 0xcae9 */
    OTHER,        /* 0xcaea */
    OTHER,        /* 0xcaeb */
    OTHER,        /* 0xcaec */
    OTHER,        /* 0xcaed */
    OTHER,        /* 0xcaee */
    OTHER,        /* 0xcaef */
    OTHER,        /* 0xcaf0 */
    OTHER,        /* 0xcaf1 */
    OTHER,        /* 0xcaf2 */
    OTHER,        /* 0xcaf3 */
    OTHER,        /* 0xcaf4 */
    OTHER,        /* 0xcaf5 */
    OTHER,        /* 0xcaf6 */
    OTHER,        /* 0xcaf7 */
    OTHER,        /* 0xcaf8 */
    OTHER,        /* 0xcaf9 */
    OTHER,        /* 0xcafa */
    OTHER,        /* 0xcafb */
    OTHER,        /* 0xcafc */
    OTHER,        /* 0xcafd */
    OTHER,        /* 0xcafe */
    OTHER,        /* 0xcaff */
    OTHER,        /* 0xcb00 */
    OTHER,        /* 0xcb01 */
    OTHER,        /* 0xcb02 */
    OTHER,        /* 0xcb03 */
    OTHER,        /* 0xcb04 */
    OTHER,        /* 0xcb05 */
    OTHER,        /* 0xcb06 */
    OTHER,        /* 0xcb07 */
    OTHER,        /* 0xcb08 */
    OTHER,        /* 0xcb09 */
    OTHER,        /* 0xcb0a */
    OTHER,        /* 0xcb0b */
    OTHER,        /* 0xcb0c */
    OTHER,        /* 0xcb0d */
    OTHER,        /* 0xcb0e */
    OTHER,        /* 0xcb0f */
    OTHER,        /* 0xcb10 */
    OTHER,        /* 0xcb11 */
    OTHER,        /* 0xcb12 */
    OTHER,        /* 0xcb13 */
    OTHER,        /* 0xcb14 */
    OTHER,        /* 0xcb15 */
    OTHER,        /* 0xcb16 */
    OTHER,        /* 0xcb17 */
    OTHER,        /* 0xcb18 */
    OTHER,        /* 0xcb19 */
    OTHER,        /* 0xcb1a */
    OTHER,        /* 0xcb1b */
    OTHER,        /* 0xcb1c */
    OTHER,        /* 0xcb1d */
    OTHER,        /* 0xcb1e */
    OTHER,        /* 0xcb1f */
    OTHER,        /* 0xcb20 */
    OTHER,        /* 0xcb21 */
    OTHER,        /* 0xcb22 */
    OTHER,        /* 0xcb23 */
    OTHER,        /* 0xcb24 */
    OTHER,        /* 0xcb25 */
    OTHER,        /* 0xcb26 */
    OTHER,        /* 0xcb27 */
    OTHER,        /* 0xcb28 */
    OTHER,        /* 0xcb29 */
    OTHER,        /* 0xcb2a */
    OTHER,        /* 0xcb2b */
    OTHER,        /* 0xcb2c */
    OTHER,        /* 0xcb2d */
    OTHER,        /* 0xcb2e */
    OTHER,        /* 0xcb2f */
    OTHER,        /* 0xcb30 */
    OTHER,        /* 0xcb31 */
    OTHER,        /* 0xcb32 */
    OTHER,        /* 0xcb33 */
    OTHER,        /* 0xcb34 */
    OTHER,        /* 0xcb35 */
    OTHER,        /* 0xcb36 */
    OTHER,        /* 0xcb37 */
    OTHER,        /* 0xcb38 */
    OTHER,        /* 0xcb39 */
    OTHER,        /* 0xcb3a */
    OTHER,        /* 0xcb3b */
    OTHER,        /* 0xcb3c */
    OTHER,        /* 0xcb3d */
    OTHER,        /* 0xcb3e */
    OTHER,        /* 0xcb3f */
    OTHER,        /* 0xcb40 */
    OTHER,        /* 0xcb41 */
    OTHER,        /* 0xcb42 */
    OTHER,        /* 0xcb43 */
    OTHER,        /* 0xcb44 */
    OTHER,        /* 0xcb45 */
    OTHER,        /* 0xcb46 */
    OTHER,        /* 0xcb47 */
    OTHER,        /* 0xcb48 */
    OTHER,        /* 0xcb49 */
    OTHER,        /* 0xcb4a */
    OTHER,        /* 0xcb4b */
    OTHER,        /* 0xcb4c */
    OTHER,        /* 0xcb4d */
    OTHER,        /* 0xcb4e */
    OTHER,        /* 0xcb4f */
    OTHER,        /* 0xcb50 */
    OTHER,        /* 0xcb51 */
    OTHER,        /* 0xcb52 */
    OTHER,        /* 0xcb53 */
    OTHER,        /* 0xcb54 */
    OTHER,        /* 0xcb55 */
    OTHER,        /* 0xcb56 */
    OTHER,        /* 0xcb57 */
    OTHER,        /* 0xcb58 */
    OTHER,        /* 0xcb59 */
    OTHER,        /* 0xcb5a */
    OTHER,        /* 0xcb5b */
    OTHER,        /* 0xcb5c */
    OTHER,        /* 0xcb5d */
    OTHER,        /* 0xcb5e */
    OTHER,        /* 0xcb5f */
    OTHER,        /* 0xcb60 */
    OTHER,        /* 0xcb61 */
    OTHER,        /* 0xcb62 */
    OTHER,        /* 0xcb63 */
    OTHER,        /* 0xcb64 */
    OTHER,        /* 0xcb65 */
    OTHER,        /* 0xcb66 */
    OTHER,        /* 0xcb67 */
    OTHER,        /* 0xcb68 */
    OTHER,        /* 0xcb69 */
    OTHER,        /* 0xcb6a */
    OTHER,        /* 0xcb6b */
    OTHER,        /* 0xcb6c */
    OTHER,        /* 0xcb6d */
    OTHER,        /* 0xcb6e */
    OTHER,        /* 0xcb6f */
    OTHER,        /* 0xcb70 */
    OTHER,        /* 0xcb71 */
    OTHER,        /* 0xcb72 */
    OTHER,        /* 0xcb73 */
    OTHER,        /* 0xcb74 */
    OTHER,        /* 0xcb75 */
    OTHER,        /* 0xcb76 */
    OTHER,        /* 0xcb77 */
    OTHER,        /* 0xcb78 */
    OTHER,        /* 0xcb79 */
    OTHER,        /* 0xcb7a */
    OTHER,        /* 0xcb7b */
    OTHER,        /* 0xcb7c */
    OTHER,        /* 0xcb7d */
    OTHER,        /* 0xcb7e */
    OTHER,        /* 0xcb7f */
    OTHER,        /* 0xcb80 */
    OTHER,        /* 0xcb81 */
    OTHER,        /* 0xcb82 */
    OTHER,        /* 0xcb83 */
    OTHER,        /* 0xcb84 */
    OTHER,        /* 0xcb85 */
    OTHER,        /* 0xcb86 */
    OTHER,        /* 0xcb87 */
    OTHER,        /* 0xcb88 */
    OTHER,        /* 0xcb89 */
    OTHER,        /* 0xcb8a */
    OTHER,        /* 0xcb8b */
    OTHER,        /* 0xcb8c */
    OTHER,        /* 0xcb8d */
    OTHER,        /* 0xcb8e */
    OTHER,        /* 0xcb8f */
    OTHER,        /* 0xcb90 */
    OTHER,        /* 0xcb91 */
    OTHER,        /* 0xcb92 */
    OTHER,        /* 0xcb93 */
    OTHER,        /* 0xcb94 */
    OTHER,        /* 0xcb95 */
    OTHER,        /* 0xcb96 */
    OTHER,        /* 0xcb97 */
    OTHER,        /* 0xcb98 */
    OTHER,        /* 0xcb99 */
    OTHER,        /* 0xcb9a */
    OTHER,        /* 0xcb9b */
    OTHER,        /* 0xcb9c */
    OTHER,        /* 0xcb9d */
    OTHER,        /* 0xcb9e */
    OTHER,        /* 0xcb9f */
    OTHER,        /* 0xcba0 */
    OTHER,        /* 0xcba1 */
    OTHER,        /* 0xcba2 */
    OTHER,        /* 0xcba3 */
    OTHER,        /* 0xcba4 */
    OTHER,        /* 0xcba5 */
    OTHER,        /* 0xcba6 */
    OTHER,        /* 0xcba7 */
    OTHER,        /* 0xcba8 */
    OTHER,        /* 0xcba9 */
    OTHER,        /* 0xcbaa */
    OTHER,        /* 0xcbab */
    OTHER,        /* 0xcbac */
    OTHER,        /* 0xcbad */
    OTHER,        /* 0xcbae */
    OTHER,        /* 0xcbaf */
    OTHER,        /* 0xcbb0 */
    OTHER,        /* 0xcbb1 */
    OTHER,        /* 0xcbb2 */
    OTHER,        /* 0xcbb3 */
    OTHER,        /* 0xcbb4 */
    OTHER,        /* 0xcbb5 */
    OTHER,        /* 0xcbb6 */
    OTHER,        /* 0xcbb7 */
    OTHER,        /* 0xcbb8 */
    OTHER,        /* 0xcbb9 */
    OTHER,        /* 0xcbba */
    OTHER,        /* 0xcbbb */
    OTHER,        /* 0xcbbc */
    OTHER,        /* 0xcbbd */
    OTHER,        /* 0xcbbe */
    OTHER,        /* 0xcbbf */
    OTHER,        /* 0xcbc0 */
    OTHER,        /* 0xcbc1 */
    OTHER,        /* 0xcbc2 */
    OTHER,        /* 0xcbc3 */
    OTHER,        /* 0xcbc4 */
    OTHER,        /* 0xcbc5 */
    OTHER,        /* 0xcbc6 */
    OTHER,        /* 0xcbc7 */
    OTHER,        /* 0xcbc8 */
    OTHER,        /* 0xcbc9 */
    OTHER,        /* 0xcbca */
    OTHER,        /* 0xcbcb */
    OTHER,        /* 0xcbcc */
    OTHER,        /* 0xcbcd */
    OTHER,        /* 0xcbce */
    OTHER,        /* 0xcbcf */
    OTHER,        /* 0xcbd0 */
    OTHER,        /* 0xcbd1 */
    OTHER,        /* 0xcbd2 */
    OTHER,        /* 0xcbd3 */
    OTHER,        /* 0xcbd4 */
    OTHER,        /* 0xcbd5 */
    OTHER,        /* 0xcbd6 */
    OTHER,        /* 0xcbd7 */
    OTHER,        /* 0xcbd8 */
    OTHER,        /* 0xcbd9 */
    OTHER,        /* 0xcbda */
    OTHER,        /* 0xcbdb */
    OTHER,        /* 0xcbdc */
    OTHER,        /* 0xcbdd */
    OTHER,        /* 0xcbde */
    OTHER,        /* 0xcbdf */
    OTHER,        /* 0xcbe0 */
    OTHER,        /* 0xcbe1 */
    OTHER,        /* 0xcbe2 */
    OTHER,        /* 0xcbe3 */
    OTHER,        /* 0xcbe4 */
    OTHER,        /* 0xcbe5 */
    OTHER,        /* 0xcbe6 */
    OTHER,        /* 0xcbe7 */
    OTHER,        /* 0xcbe8 */
    OTHER,        /* 0xcbe9 */
    OTHER,        /* 0xcbea */
    OTHER,        /* 0xcbeb */
    OTHER,        /* 0xcbec */
    OTHER,        /* 0xcbed */
    OTHER,        /* 0xcbee */
    OTHER,        /* 0xcbef */
    OTHER,        /* 0xcbf0 */
    OTHER,        /* 0xcbf1 */
    OTHER,        /* 0xcbf2 */
    OTHER,        /* 0xcbf3 */
    OTHER,        /* 0xcbf4 */
    OTHER,        /* 0xcbf5 */
    OTHER,        /* 0xcbf6 */
    OTHER,        /* 0xcbf7 */
    OTHER,        /* 0xcbf8 */
    OTHER,        /* 0xcbf9 */
    OTHER,        /* 0xcbfa */
    OTHER,        /* 0xcbfb */
    OTHER,        /* 0xcbfc */
    OTHER,        /* 0xcbfd */
    OTHER,        /* 0xcbfe */
    OTHER,        /* 0xcbff */
    OTHER,        /* 0xcc00 */
    OTHER,        /* 0xcc01 */
    OTHER,        /* 0xcc02 */
    OTHER,        /* 0xcc03 */
    OTHER,        /* 0xcc04 */
    OTHER,        /* 0xcc05 */
    OTHER,        /* 0xcc06 */
    OTHER,        /* 0xcc07 */
    OTHER,        /* 0xcc08 */
    OTHER,        /* 0xcc09 */
    OTHER,        /* 0xcc0a */
    OTHER,        /* 0xcc0b */
    OTHER,        /* 0xcc0c */
    OTHER,        /* 0xcc0d */
    OTHER,        /* 0xcc0e */
    OTHER,        /* 0xcc0f */
    OTHER,        /* 0xcc10 */
    OTHER,        /* 0xcc11 */
    OTHER,        /* 0xcc12 */
    OTHER,        /* 0xcc13 */
    OTHER,        /* 0xcc14 */
    OTHER,        /* 0xcc15 */
    OTHER,        /* 0xcc16 */
    OTHER,        /* 0xcc17 */
    OTHER,        /* 0xcc18 */
    OTHER,        /* 0xcc19 */
    OTHER,        /* 0xcc1a */
    OTHER,        /* 0xcc1b */
    OTHER,        /* 0xcc1c */
    OTHER,        /* 0xcc1d */
    OTHER,        /* 0xcc1e */
    OTHER,        /* 0xcc1f */
    OTHER,        /* 0xcc20 */
    OTHER,        /* 0xcc21 */
    OTHER,        /* 0xcc22 */
    OTHER,        /* 0xcc23 */
    OTHER,        /* 0xcc24 */
    OTHER,        /* 0xcc25 */
    OTHER,        /* 0xcc26 */
    OTHER,        /* 0xcc27 */
    OTHER,        /* 0xcc28 */
    OTHER,        /* 0xcc29 */
    OTHER,        /* 0xcc2a */
    OTHER,        /* 0xcc2b */
    OTHER,        /* 0xcc2c */
    OTHER,        /* 0xcc2d */
    OTHER,        /* 0xcc2e */
    OTHER,        /* 0xcc2f */
    OTHER,        /* 0xcc30 */
    OTHER,        /* 0xcc31 */
    OTHER,        /* 0xcc32 */
    OTHER,        /* 0xcc33 */
    OTHER,        /* 0xcc34 */
    OTHER,        /* 0xcc35 */
    OTHER,        /* 0xcc36 */
    OTHER,        /* 0xcc37 */
    OTHER,        /* 0xcc38 */
    OTHER,        /* 0xcc39 */
    OTHER,        /* 0xcc3a */
    OTHER,        /* 0xcc3b */
    OTHER,        /* 0xcc3c */
    OTHER,        /* 0xcc3d */
    OTHER,        /* 0xcc3e */
    OTHER,        /* 0xcc3f */
    OTHER,        /* 0xcc40 */
    OTHER,        /* 0xcc41 */
    OTHER,        /* 0xcc42 */
    OTHER,        /* 0xcc43 */
    OTHER,        /* 0xcc44 */
    OTHER,        /* 0xcc45 */
    OTHER,        /* 0xcc46 */
    OTHER,        /* 0xcc47 */
    OTHER,        /* 0xcc48 */
    OTHER,        /* 0xcc49 */
    OTHER,        /* 0xcc4a */
    OTHER,        /* 0xcc4b */
    OTHER,        /* 0xcc4c */
    OTHER,        /* 0xcc4d */
    OTHER,        /* 0xcc4e */
    OTHER,        /* 0xcc4f */
    OTHER,        /* 0xcc50 */
    OTHER,        /* 0xcc51 */
    OTHER,        /* 0xcc52 */
    OTHER,        /* 0xcc53 */
    OTHER,        /* 0xcc54 */
    OTHER,        /* 0xcc55 */
    OTHER,        /* 0xcc56 */
    OTHER,        /* 0xcc57 */
    OTHER,        /* 0xcc58 */
    OTHER,        /* 0xcc59 */
    OTHER,        /* 0xcc5a */
    OTHER,        /* 0xcc5b */
    OTHER,        /* 0xcc5c */
    OTHER,        /* 0xcc5d */
    OTHER,        /* 0xcc5e */
    OTHER,        /* 0xcc5f */
    OTHER,        /* 0xcc60 */
    OTHER,        /* 0xcc61 */
    OTHER,        /* 0xcc62 */
    OTHER,        /* 0xcc63 */
    OTHER,        /* 0xcc64 */
    OTHER,        /* 0xcc65 */
    OTHER,        /* 0xcc66 */
    OTHER,        /* 0xcc67 */
    OTHER,        /* 0xcc68 */
    OTHER,        /* 0xcc69 */
    OTHER,        /* 0xcc6a */
    OTHER,        /* 0xcc6b */
    OTHER,        /* 0xcc6c */
    OTHER,        /* 0xcc6d */
    OTHER,        /* 0xcc6e */
    OTHER,        /* 0xcc6f */
    OTHER,        /* 0xcc70 */
    OTHER,        /* 0xcc71 */
    OTHER,        /* 0xcc72 */
    OTHER,        /* 0xcc73 */
    OTHER,        /* 0xcc74 */
    OTHER,        /* 0xcc75 */
    OTHER,        /* 0xcc76 */
    OTHER,        /* 0xcc77 */
    OTHER,        /* 0xcc78 */
    OTHER,        /* 0xcc79 */
    OTHER,        /* 0xcc7a */
    OTHER,        /* 0xcc7b */
    OTHER,        /* 0xcc7c */
    OTHER,        /* 0xcc7d */
    OTHER,        /* 0xcc7e */
    OTHER,        /* 0xcc7f */
    OTHER,        /* 0xcc80 */
    OTHER,        /* 0xcc81 */
    OTHER,        /* 0xcc82 */
    OTHER,        /* 0xcc83 */
    OTHER,        /* 0xcc84 */
    OTHER,        /* 0xcc85 */
    OTHER,        /* 0xcc86 */
    OTHER,        /* 0xcc87 */
    OTHER,        /* 0xcc88 */
    OTHER,        /* 0xcc89 */
    OTHER,        /* 0xcc8a */
    OTHER,        /* 0xcc8b */
    OTHER,        /* 0xcc8c */
    OTHER,        /* 0xcc8d */
    OTHER,        /* 0xcc8e */
    OTHER,        /* 0xcc8f */
    OTHER,        /* 0xcc90 */
    OTHER,        /* 0xcc91 */
    OTHER,        /* 0xcc92 */
    OTHER,        /* 0xcc93 */
    OTHER,        /* 0xcc94 */
    OTHER,        /* 0xcc95 */
    OTHER,        /* 0xcc96 */
    OTHER,        /* 0xcc97 */
    OTHER,        /* 0xcc98 */
    OTHER,        /* 0xcc99 */
    OTHER,        /* 0xcc9a */
    OTHER,        /* 0xcc9b */
    OTHER,        /* 0xcc9c */
    OTHER,        /* 0xcc9d */
    OTHER,        /* 0xcc9e */
    OTHER,        /* 0xcc9f */
    OTHER,        /* 0xcca0 */
    OTHER,        /* 0xcca1 */
    OTHER,        /* 0xcca2 */
    OTHER,        /* 0xcca3 */
    OTHER,        /* 0xcca4 */
    OTHER,        /* 0xcca5 */
    OTHER,        /* 0xcca6 */
    OTHER,        /* 0xcca7 */
    OTHER,        /* 0xcca8 */
    OTHER,        /* 0xcca9 */
    OTHER,        /* 0xccaa */
    OTHER,        /* 0xccab */
    OTHER,        /* 0xccac */
    OTHER,        /* 0xccad */
    OTHER,        /* 0xccae */
    OTHER,        /* 0xccaf */
    OTHER,        /* 0xccb0 */
    OTHER,        /* 0xccb1 */
    OTHER,        /* 0xccb2 */
    OTHER,        /* 0xccb3 */
    OTHER,        /* 0xccb4 */
    OTHER,        /* 0xccb5 */
    OTHER,        /* 0xccb6 */
    OTHER,        /* 0xccb7 */
    OTHER,        /* 0xccb8 */
    OTHER,        /* 0xccb9 */
    OTHER,        /* 0xccba */
    OTHER,        /* 0xccbb */
    OTHER,        /* 0xccbc */
    OTHER,        /* 0xccbd */
    OTHER,        /* 0xccbe */
    OTHER,        /* 0xccbf */
    OTHER,        /* 0xccc0 */
    OTHER,        /* 0xccc1 */
    OTHER,        /* 0xccc2 */
    OTHER,        /* 0xccc3 */
    OTHER,        /* 0xccc4 */
    OTHER,        /* 0xccc5 */
    OTHER,        /* 0xccc6 */
    OTHER,        /* 0xccc7 */
    OTHER,        /* 0xccc8 */
    OTHER,        /* 0xccc9 */
    OTHER,        /* 0xccca */
    OTHER,        /* 0xcccb */
    OTHER,        /* 0xcccc */
    OTHER,        /* 0xcccd */
    OTHER,        /* 0xccce */
    OTHER,        /* 0xcccf */
    OTHER,        /* 0xccd0 */
    OTHER,        /* 0xccd1 */
    OTHER,        /* 0xccd2 */
    OTHER,        /* 0xccd3 */
    OTHER,        /* 0xccd4 */
    OTHER,        /* 0xccd5 */
    OTHER,        /* 0xccd6 */
    OTHER,        /* 0xccd7 */
    OTHER,        /* 0xccd8 */
    OTHER,        /* 0xccd9 */
    OTHER,        /* 0xccda */
    OTHER,        /* 0xccdb */
    OTHER,        /* 0xccdc */
    OTHER,        /* 0xccdd */
    OTHER,        /* 0xccde */
    OTHER,        /* 0xccdf */
    OTHER,        /* 0xcce0 */
    OTHER,        /* 0xcce1 */
    OTHER,        /* 0xcce2 */
    OTHER,        /* 0xcce3 */
    OTHER,        /* 0xcce4 */
    OTHER,        /* 0xcce5 */
    OTHER,        /* 0xcce6 */
    OTHER,        /* 0xcce7 */
    OTHER,        /* 0xcce8 */
    OTHER,        /* 0xcce9 */
    OTHER,        /* 0xccea */
    OTHER,        /* 0xcceb */
    OTHER,        /* 0xccec */
    OTHER,        /* 0xcced */
    OTHER,        /* 0xccee */
    OTHER,        /* 0xccef */
    OTHER,        /* 0xccf0 */
    OTHER,        /* 0xccf1 */
    OTHER,        /* 0xccf2 */
    OTHER,        /* 0xccf3 */
    OTHER,        /* 0xccf4 */
    OTHER,        /* 0xccf5 */
    OTHER,        /* 0xccf6 */
    OTHER,        /* 0xccf7 */
    OTHER,        /* 0xccf8 */
    OTHER,        /* 0xccf9 */
    OTHER,        /* 0xccfa */
    OTHER,        /* 0xccfb */
    OTHER,        /* 0xccfc */
    OTHER,        /* 0xccfd */
    OTHER,        /* 0xccfe */
    OTHER,        /* 0xccff */
    OTHER,        /* 0xcd00 */
    OTHER,        /* 0xcd01 */
    OTHER,        /* 0xcd02 */
    OTHER,        /* 0xcd03 */
    OTHER,        /* 0xcd04 */
    OTHER,        /* 0xcd05 */
    OTHER,        /* 0xcd06 */
    OTHER,        /* 0xcd07 */
    OTHER,        /* 0xcd08 */
    OTHER,        /* 0xcd09 */
    OTHER,        /* 0xcd0a */
    OTHER,        /* 0xcd0b */
    OTHER,        /* 0xcd0c */
    OTHER,        /* 0xcd0d */
    OTHER,        /* 0xcd0e */
    OTHER,        /* 0xcd0f */
    OTHER,        /* 0xcd10 */
    OTHER,        /* 0xcd11 */
    OTHER,        /* 0xcd12 */
    OTHER,        /* 0xcd13 */
    OTHER,        /* 0xcd14 */
    OTHER,        /* 0xcd15 */
    OTHER,        /* 0xcd16 */
    OTHER,        /* 0xcd17 */
    OTHER,        /* 0xcd18 */
    OTHER,        /* 0xcd19 */
    OTHER,        /* 0xcd1a */
    OTHER,        /* 0xcd1b */
    OTHER,        /* 0xcd1c */
    OTHER,        /* 0xcd1d */
    OTHER,        /* 0xcd1e */
    OTHER,        /* 0xcd1f */
    OTHER,        /* 0xcd20 */
    OTHER,        /* 0xcd21 */
    OTHER,        /* 0xcd22 */
    OTHER,        /* 0xcd23 */
    OTHER,        /* 0xcd24 */
    OTHER,        /* 0xcd25 */
    OTHER,        /* 0xcd26 */
    OTHER,        /* 0xcd27 */
    OTHER,        /* 0xcd28 */
    OTHER,        /* 0xcd29 */
    OTHER,        /* 0xcd2a */
    OTHER,        /* 0xcd2b */
    OTHER,        /* 0xcd2c */
    OTHER,        /* 0xcd2d */
    OTHER,        /* 0xcd2e */
    OTHER,        /* 0xcd2f */
    OTHER,        /* 0xcd30 */
    OTHER,        /* 0xcd31 */
    OTHER,        /* 0xcd32 */
    OTHER,        /* 0xcd33 */
    OTHER,        /* 0xcd34 */
    OTHER,        /* 0xcd35 */
    OTHER,        /* 0xcd36 */
    OTHER,        /* 0xcd37 */
    OTHER,        /* 0xcd38 */
    OTHER,        /* 0xcd39 */
    OTHER,        /* 0xcd3a */
    OTHER,        /* 0xcd3b */
    OTHER,        /* 0xcd3c */
    OTHER,        /* 0xcd3d */
    OTHER,        /* 0xcd3e */
    OTHER,        /* 0xcd3f */
    OTHER,        /* 0xcd40 */
    OTHER,        /* 0xcd41 */
    OTHER,        /* 0xcd42 */
    OTHER,        /* 0xcd43 */
    OTHER,        /* 0xcd44 */
    OTHER,        /* 0xcd45 */
    OTHER,        /* 0xcd46 */
    OTHER,        /* 0xcd47 */
    OTHER,        /* 0xcd48 */
    OTHER,        /* 0xcd49 */
    OTHER,        /* 0xcd4a */
    OTHER,        /* 0xcd4b */
    OTHER,        /* 0xcd4c */
    OTHER,        /* 0xcd4d */
    OTHER,        /* 0xcd4e */
    OTHER,        /* 0xcd4f */
    OTHER,        /* 0xcd50 */
    OTHER,        /* 0xcd51 */
    OTHER,        /* 0xcd52 */
    OTHER,        /* 0xcd53 */
    OTHER,        /* 0xcd54 */
    OTHER,        /* 0xcd55 */
    OTHER,        /* 0xcd56 */
    OTHER,        /* 0xcd57 */
    OTHER,        /* 0xcd58 */
    OTHER,        /* 0xcd59 */
    OTHER,        /* 0xcd5a */
    OTHER,        /* 0xcd5b */
    OTHER,        /* 0xcd5c */
    OTHER,        /* 0xcd5d */
    OTHER,        /* 0xcd5e */
    OTHER,        /* 0xcd5f */
    OTHER,        /* 0xcd60 */
    OTHER,        /* 0xcd61 */
    OTHER,        /* 0xcd62 */
    OTHER,        /* 0xcd63 */
    OTHER,        /* 0xcd64 */
    OTHER,        /* 0xcd65 */
    OTHER,        /* 0xcd66 */
    OTHER,        /* 0xcd67 */
    OTHER,        /* 0xcd68 */
    OTHER,        /* 0xcd69 */
    OTHER,        /* 0xcd6a */
    OTHER,        /* 0xcd6b */
    OTHER,        /* 0xcd6c */
    OTHER,        /* 0xcd6d */
    OTHER,        /* 0xcd6e */
    OTHER,        /* 0xcd6f */
    OTHER,        /* 0xcd70 */
    OTHER,        /* 0xcd71 */
    OTHER,        /* 0xcd72 */
    OTHER,        /* 0xcd73 */
    OTHER,        /* 0xcd74 */
    OTHER,        /* 0xcd75 */
    OTHER,        /* 0xcd76 */
    OTHER,        /* 0xcd77 */
    OTHER,        /* 0xcd78 */
    OTHER,        /* 0xcd79 */
    OTHER,        /* 0xcd7a */
    OTHER,        /* 0xcd7b */
    OTHER,        /* 0xcd7c */
    OTHER,        /* 0xcd7d */
    OTHER,        /* 0xcd7e */
    OTHER,        /* 0xcd7f */
    OTHER,        /* 0xcd80 */
    OTHER,        /* 0xcd81 */
    OTHER,        /* 0xcd82 */
    OTHER,        /* 0xcd83 */
    OTHER,        /* 0xcd84 */
    OTHER,        /* 0xcd85 */
    OTHER,        /* 0xcd86 */
    OTHER,        /* 0xcd87 */
    OTHER,        /* 0xcd88 */
    OTHER,        /* 0xcd89 */
    OTHER,        /* 0xcd8a */
    OTHER,        /* 0xcd8b */
    OTHER,        /* 0xcd8c */
    OTHER,        /* 0xcd8d */
    OTHER,        /* 0xcd8e */
    OTHER,        /* 0xcd8f */
    OTHER,        /* 0xcd90 */
    OTHER,        /* 0xcd91 */
    OTHER,        /* 0xcd92 */
    OTHER,        /* 0xcd93 */
    OTHER,        /* 0xcd94 */
    OTHER,        /* 0xcd95 */
    OTHER,        /* 0xcd96 */
    OTHER,        /* 0xcd97 */
    OTHER,        /* 0xcd98 */
    OTHER,        /* 0xcd99 */
    OTHER,        /* 0xcd9a */
    OTHER,        /* 0xcd9b */
    OTHER,        /* 0xcd9c */
    OTHER,        /* 0xcd9d */
    OTHER,        /* 0xcd9e */
    OTHER,        /* 0xcd9f */
    OTHER,        /* 0xcda0 */
    OTHER,        /* 0xcda1 */
    OTHER,        /* 0xcda2 */
    OTHER,        /* 0xcda3 */
    OTHER,        /* 0xcda4 */
    OTHER,        /* 0xcda5 */
    OTHER,        /* 0xcda6 */
    OTHER,        /* 0xcda7 */
    OTHER,        /* 0xcda8 */
    OTHER,        /* 0xcda9 */
    OTHER,        /* 0xcdaa */
    OTHER,        /* 0xcdab */
    OTHER,        /* 0xcdac */
    OTHER,        /* 0xcdad */
    OTHER,        /* 0xcdae */
    OTHER,        /* 0xcdaf */
    OTHER,        /* 0xcdb0 */
    OTHER,        /* 0xcdb1 */
    OTHER,        /* 0xcdb2 */
    OTHER,        /* 0xcdb3 */
    OTHER,        /* 0xcdb4 */
    OTHER,        /* 0xcdb5 */
    OTHER,        /* 0xcdb6 */
    OTHER,        /* 0xcdb7 */
    OTHER,        /* 0xcdb8 */
    OTHER,        /* 0xcdb9 */
    OTHER,        /* 0xcdba */
    OTHER,        /* 0xcdbb */
    OTHER,        /* 0xcdbc */
    OTHER,        /* 0xcdbd */
    OTHER,        /* 0xcdbe */
    OTHER,        /* 0xcdbf */
    OTHER,        /* 0xcdc0 */
    OTHER,        /* 0xcdc1 */
    OTHER,        /* 0xcdc2 */
    OTHER,        /* 0xcdc3 */
    OTHER,        /* 0xcdc4 */
    OTHER,        /* 0xcdc5 */
    OTHER,        /* 0xcdc6 */
    OTHER,        /* 0xcdc7 */
    OTHER,        /* 0xcdc8 */
    OTHER,        /* 0xcdc9 */
    OTHER,        /* 0xcdca */
    OTHER,        /* 0xcdcb */
    OTHER,        /* 0xcdcc */
    OTHER,        /* 0xcdcd */
    OTHER,        /* 0xcdce */
    OTHER,        /* 0xcdcf */
    OTHER,        /* 0xcdd0 */
    OTHER,        /* 0xcdd1 */
    OTHER,        /* 0xcdd2 */
    OTHER,        /* 0xcdd3 */
    OTHER,        /* 0xcdd4 */
    OTHER,        /* 0xcdd5 */
    OTHER,        /* 0xcdd6 */
    OTHER,        /* 0xcdd7 */
    OTHER,        /* 0xcdd8 */
    OTHER,        /* 0xcdd9 */
    OTHER,        /* 0xcdda */
    OTHER,        /* 0xcddb */
    OTHER,        /* 0xcddc */
    OTHER,        /* 0xcddd */
    OTHER,        /* 0xcdde */
    OTHER,        /* 0xcddf */
    OTHER,        /* 0xcde0 */
    OTHER,        /* 0xcde1 */
    OTHER,        /* 0xcde2 */
    OTHER,        /* 0xcde3 */
    OTHER,        /* 0xcde4 */
    OTHER,        /* 0xcde5 */
    OTHER,        /* 0xcde6 */
    OTHER,        /* 0xcde7 */
    OTHER,        /* 0xcde8 */
    OTHER,        /* 0xcde9 */
    OTHER,        /* 0xcdea */
    OTHER,        /* 0xcdeb */
    OTHER,        /* 0xcdec */
    OTHER,        /* 0xcded */
    OTHER,        /* 0xcdee */
    OTHER,        /* 0xcdef */
    OTHER,        /* 0xcdf0 */
    OTHER,        /* 0xcdf1 */
    OTHER,        /* 0xcdf2 */
    OTHER,        /* 0xcdf3 */
    OTHER,        /* 0xcdf4 */
    OTHER,        /* 0xcdf5 */
    OTHER,        /* 0xcdf6 */
    OTHER,        /* 0xcdf7 */
    OTHER,        /* 0xcdf8 */
    OTHER,        /* 0xcdf9 */
    OTHER,        /* 0xcdfa */
    OTHER,        /* 0xcdfb */
    OTHER,        /* 0xcdfc */
    OTHER,        /* 0xcdfd */
    OTHER,        /* 0xcdfe */
    OTHER,        /* 0xcdff */
    OTHER,        /* 0xce00 */
    OTHER,        /* 0xce01 */
    OTHER,        /* 0xce02 */
    OTHER,        /* 0xce03 */
    OTHER,        /* 0xce04 */
    OTHER,        /* 0xce05 */
    OTHER,        /* 0xce06 */
    OTHER,        /* 0xce07 */
    OTHER,        /* 0xce08 */
    OTHER,        /* 0xce09 */
    OTHER,        /* 0xce0a */
    OTHER,        /* 0xce0b */
    OTHER,        /* 0xce0c */
    OTHER,        /* 0xce0d */
    OTHER,        /* 0xce0e */
    OTHER,        /* 0xce0f */
    OTHER,        /* 0xce10 */
    OTHER,        /* 0xce11 */
    OTHER,        /* 0xce12 */
    OTHER,        /* 0xce13 */
    OTHER,        /* 0xce14 */
    OTHER,        /* 0xce15 */
    OTHER,        /* 0xce16 */
    OTHER,        /* 0xce17 */
    OTHER,        /* 0xce18 */
    OTHER,        /* 0xce19 */
    OTHER,        /* 0xce1a */
    OTHER,        /* 0xce1b */
    OTHER,        /* 0xce1c */
    OTHER,        /* 0xce1d */
    OTHER,        /* 0xce1e */
    OTHER,        /* 0xce1f */
    OTHER,        /* 0xce20 */
    OTHER,        /* 0xce21 */
    OTHER,        /* 0xce22 */
    OTHER,        /* 0xce23 */
    OTHER,        /* 0xce24 */
    OTHER,        /* 0xce25 */
    OTHER,        /* 0xce26 */
    OTHER,        /* 0xce27 */
    OTHER,        /* 0xce28 */
    OTHER,        /* 0xce29 */
    OTHER,        /* 0xce2a */
    OTHER,        /* 0xce2b */
    OTHER,        /* 0xce2c */
    OTHER,        /* 0xce2d */
    OTHER,        /* 0xce2e */
    OTHER,        /* 0xce2f */
    OTHER,        /* 0xce30 */
    OTHER,        /* 0xce31 */
    OTHER,        /* 0xce32 */
    OTHER,        /* 0xce33 */
    OTHER,        /* 0xce34 */
    OTHER,        /* 0xce35 */
    OTHER,        /* 0xce36 */
    OTHER,        /* 0xce37 */
    OTHER,        /* 0xce38 */
    OTHER,        /* 0xce39 */
    OTHER,        /* 0xce3a */
    OTHER,        /* 0xce3b */
    OTHER,        /* 0xce3c */
    OTHER,        /* 0xce3d */
    OTHER,        /* 0xce3e */
    OTHER,        /* 0xce3f */
    OTHER,        /* 0xce40 */
    OTHER,        /* 0xce41 */
    OTHER,        /* 0xce42 */
    OTHER,        /* 0xce43 */
    OTHER,        /* 0xce44 */
    OTHER,        /* 0xce45 */
    OTHER,        /* 0xce46 */
    OTHER,        /* 0xce47 */
    OTHER,        /* 0xce48 */
    OTHER,        /* 0xce49 */
    OTHER,        /* 0xce4a */
    OTHER,        /* 0xce4b */
    OTHER,        /* 0xce4c */
    OTHER,        /* 0xce4d */
    OTHER,        /* 0xce4e */
    OTHER,        /* 0xce4f */
    OTHER,        /* 0xce50 */
    OTHER,        /* 0xce51 */
    OTHER,        /* 0xce52 */
    OTHER,        /* 0xce53 */
    OTHER,        /* 0xce54 */
    OTHER,        /* 0xce55 */
    OTHER,        /* 0xce56 */
    OTHER,        /* 0xce57 */
    OTHER,        /* 0xce58 */
    OTHER,        /* 0xce59 */
    OTHER,        /* 0xce5a */
    OTHER,        /* 0xce5b */
    OTHER,        /* 0xce5c */
    OTHER,        /* 0xce5d */
    OTHER,        /* 0xce5e */
    OTHER,        /* 0xce5f */
    OTHER,        /* 0xce60 */
    OTHER,        /* 0xce61 */
    OTHER,        /* 0xce62 */
    OTHER,        /* 0xce63 */
    OTHER,        /* 0xce64 */
    OTHER,        /* 0xce65 */
    OTHER,        /* 0xce66 */
    OTHER,        /* 0xce67 */
    OTHER,        /* 0xce68 */
    OTHER,        /* 0xce69 */
    OTHER,        /* 0xce6a */
    OTHER,        /* 0xce6b */
    OTHER,        /* 0xce6c */
    OTHER,        /* 0xce6d */
    OTHER,        /* 0xce6e */
    OTHER,        /* 0xce6f */
    OTHER,        /* 0xce70 */
    OTHER,        /* 0xce71 */
    OTHER,        /* 0xce72 */
    OTHER,        /* 0xce73 */
    OTHER,        /* 0xce74 */
    OTHER,        /* 0xce75 */
    OTHER,        /* 0xce76 */
    OTHER,        /* 0xce77 */
    OTHER,        /* 0xce78 */
    OTHER,        /* 0xce79 */
    OTHER,        /* 0xce7a */
    OTHER,        /* 0xce7b */
    OTHER,        /* 0xce7c */
    OTHER,        /* 0xce7d */
    OTHER,        /* 0xce7e */
    OTHER,        /* 0xce7f */
    OTHER,        /* 0xce80 */
    OTHER,        /* 0xce81 */
    OTHER,        /* 0xce82 */
    OTHER,        /* 0xce83 */
    OTHER,        /* 0xce84 */
    OTHER,        /* 0xce85 */
    OTHER,        /* 0xce86 */
    OTHER,        /* 0xce87 */
    OTHER,        /* 0xce88 */
    OTHER,        /* 0xce89 */
    OTHER,        /* 0xce8a */
    OTHER,        /* 0xce8b */
    OTHER,        /* 0xce8c */
    OTHER,        /* 0xce8d */
    OTHER,        /* 0xce8e */
    OTHER,        /* 0xce8f */
    OTHER,        /* 0xce90 */
    OTHER,        /* 0xce91 */
    OTHER,        /* 0xce92 */
    OTHER,        /* 0xce93 */
    OTHER,        /* 0xce94 */
    OTHER,        /* 0xce95 */
    OTHER,        /* 0xce96 */
    OTHER,        /* 0xce97 */
    OTHER,        /* 0xce98 */
    OTHER,        /* 0xce99 */
    OTHER,        /* 0xce9a */
    OTHER,        /* 0xce9b */
    OTHER,        /* 0xce9c */
    OTHER,        /* 0xce9d */
    OTHER,        /* 0xce9e */
    OTHER,        /* 0xce9f */
    OTHER,        /* 0xcea0 */
    OTHER,        /* 0xcea1 */
    OTHER,        /* 0xcea2 */
    OTHER,        /* 0xcea3 */
    OTHER,        /* 0xcea4 */
    OTHER,        /* 0xcea5 */
    OTHER,        /* 0xcea6 */
    OTHER,        /* 0xcea7 */
    OTHER,        /* 0xcea8 */
    OTHER,        /* 0xcea9 */
    OTHER,        /* 0xceaa */
    OTHER,        /* 0xceab */
    OTHER,        /* 0xceac */
    OTHER,        /* 0xcead */
    OTHER,        /* 0xceae */
    OTHER,        /* 0xceaf */
    OTHER,        /* 0xceb0 */
    OTHER,        /* 0xceb1 */
    OTHER,        /* 0xceb2 */
    OTHER,        /* 0xceb3 */
    OTHER,        /* 0xceb4 */
    OTHER,        /* 0xceb5 */
    OTHER,        /* 0xceb6 */
    OTHER,        /* 0xceb7 */
    OTHER,        /* 0xceb8 */
    OTHER,        /* 0xceb9 */
    OTHER,        /* 0xceba */
    OTHER,        /* 0xcebb */
    OTHER,        /* 0xcebc */
    OTHER,        /* 0xcebd */
    OTHER,        /* 0xcebe */
    OTHER,        /* 0xcebf */
    OTHER,        /* 0xcec0 */
    OTHER,        /* 0xcec1 */
    OTHER,        /* 0xcec2 */
    OTHER,        /* 0xcec3 */
    OTHER,        /* 0xcec4 */
    OTHER,        /* 0xcec5 */
    OTHER,        /* 0xcec6 */
    OTHER,        /* 0xcec7 */
    OTHER,        /* 0xcec8 */
    OTHER,        /* 0xcec9 */
    OTHER,        /* 0xceca */
    OTHER,        /* 0xcecb */
    OTHER,        /* 0xcecc */
    OTHER,        /* 0xcecd */
    OTHER,        /* 0xcece */
    OTHER,        /* 0xcecf */
    OTHER,        /* 0xced0 */
    OTHER,        /* 0xced1 */
    OTHER,        /* 0xced2 */
    OTHER,        /* 0xced3 */
    OTHER,        /* 0xced4 */
    OTHER,        /* 0xced5 */
    OTHER,        /* 0xced6 */
    OTHER,        /* 0xced7 */
    OTHER,        /* 0xced8 */
    OTHER,        /* 0xced9 */
    OTHER,        /* 0xceda */
    OTHER,        /* 0xcedb */
    OTHER,        /* 0xcedc */
    OTHER,        /* 0xcedd */
    OTHER,        /* 0xcede */
    OTHER,        /* 0xcedf */
    OTHER,        /* 0xcee0 */
    OTHER,        /* 0xcee1 */
    OTHER,        /* 0xcee2 */
    OTHER,        /* 0xcee3 */
    OTHER,        /* 0xcee4 */
    OTHER,        /* 0xcee5 */
    OTHER,        /* 0xcee6 */
    OTHER,        /* 0xcee7 */
    OTHER,        /* 0xcee8 */
    OTHER,        /* 0xcee9 */
    OTHER,        /* 0xceea */
    OTHER,        /* 0xceeb */
    OTHER,        /* 0xceec */
    OTHER,        /* 0xceed */
    OTHER,        /* 0xceee */
    OTHER,        /* 0xceef */
    OTHER,        /* 0xcef0 */
    OTHER,        /* 0xcef1 */
    OTHER,        /* 0xcef2 */
    OTHER,        /* 0xcef3 */
    OTHER,        /* 0xcef4 */
    OTHER,        /* 0xcef5 */
    OTHER,        /* 0xcef6 */
    OTHER,        /* 0xcef7 */
    OTHER,        /* 0xcef8 */
    OTHER,        /* 0xcef9 */
    OTHER,        /* 0xcefa */
    OTHER,        /* 0xcefb */
    OTHER,        /* 0xcefc */
    OTHER,        /* 0xcefd */
    OTHER,        /* 0xcefe */
    OTHER,        /* 0xceff */
    OTHER,        /* 0xcf00 */
    OTHER,        /* 0xcf01 */
    OTHER,        /* 0xcf02 */
    OTHER,        /* 0xcf03 */
    OTHER,        /* 0xcf04 */
    OTHER,        /* 0xcf05 */
    OTHER,        /* 0xcf06 */
    OTHER,        /* 0xcf07 */
    OTHER,        /* 0xcf08 */
    OTHER,        /* 0xcf09 */
    OTHER,        /* 0xcf0a */
    OTHER,        /* 0xcf0b */
    OTHER,        /* 0xcf0c */
    OTHER,        /* 0xcf0d */
    OTHER,        /* 0xcf0e */
    OTHER,        /* 0xcf0f */
    OTHER,        /* 0xcf10 */
    OTHER,        /* 0xcf11 */
    OTHER,        /* 0xcf12 */
    OTHER,        /* 0xcf13 */
    OTHER,        /* 0xcf14 */
    OTHER,        /* 0xcf15 */
    OTHER,        /* 0xcf16 */
    OTHER,        /* 0xcf17 */
    OTHER,        /* 0xcf18 */
    OTHER,        /* 0xcf19 */
    OTHER,        /* 0xcf1a */
    OTHER,        /* 0xcf1b */
    OTHER,        /* 0xcf1c */
    OTHER,        /* 0xcf1d */
    OTHER,        /* 0xcf1e */
    OTHER,        /* 0xcf1f */
    OTHER,        /* 0xcf20 */
    OTHER,        /* 0xcf21 */
    OTHER,        /* 0xcf22 */
    OTHER,        /* 0xcf23 */
    OTHER,        /* 0xcf24 */
    OTHER,        /* 0xcf25 */
    OTHER,        /* 0xcf26 */
    OTHER,        /* 0xcf27 */
    OTHER,        /* 0xcf28 */
    OTHER,        /* 0xcf29 */
    OTHER,        /* 0xcf2a */
    OTHER,        /* 0xcf2b */
    OTHER,        /* 0xcf2c */
    OTHER,        /* 0xcf2d */
    OTHER,        /* 0xcf2e */
    OTHER,        /* 0xcf2f */
    OTHER,        /* 0xcf30 */
    OTHER,        /* 0xcf31 */
    OTHER,        /* 0xcf32 */
    OTHER,        /* 0xcf33 */
    OTHER,        /* 0xcf34 */
    OTHER,        /* 0xcf35 */
    OTHER,        /* 0xcf36 */
    OTHER,        /* 0xcf37 */
    OTHER,        /* 0xcf38 */
    OTHER,        /* 0xcf39 */
    OTHER,        /* 0xcf3a */
    OTHER,        /* 0xcf3b */
    OTHER,        /* 0xcf3c */
    OTHER,        /* 0xcf3d */
    OTHER,        /* 0xcf3e */
    OTHER,        /* 0xcf3f */
    OTHER,        /* 0xcf40 */
    OTHER,        /* 0xcf41 */
    OTHER,        /* 0xcf42 */
    OTHER,        /* 0xcf43 */
    OTHER,        /* 0xcf44 */
    OTHER,        /* 0xcf45 */
    OTHER,        /* 0xcf46 */
    OTHER,        /* 0xcf47 */
    OTHER,        /* 0xcf48 */
    OTHER,        /* 0xcf49 */
    OTHER,        /* 0xcf4a */
    OTHER,        /* 0xcf4b */
    OTHER,        /* 0xcf4c */
    OTHER,        /* 0xcf4d */
    OTHER,        /* 0xcf4e */
    OTHER,        /* 0xcf4f */
    OTHER,        /* 0xcf50 */
    OTHER,        /* 0xcf51 */
    OTHER,        /* 0xcf52 */
    OTHER,        /* 0xcf53 */
    OTHER,        /* 0xcf54 */
    OTHER,        /* 0xcf55 */
    OTHER,        /* 0xcf56 */
    OTHER,        /* 0xcf57 */
    OTHER,        /* 0xcf58 */
    OTHER,        /* 0xcf59 */
    OTHER,        /* 0xcf5a */
    OTHER,        /* 0xcf5b */
    OTHER,        /* 0xcf5c */
    OTHER,        /* 0xcf5d */
    OTHER,        /* 0xcf5e */
    OTHER,        /* 0xcf5f */
    OTHER,        /* 0xcf60 */
    OTHER,        /* 0xcf61 */
    OTHER,        /* 0xcf62 */
    OTHER,        /* 0xcf63 */
    OTHER,        /* 0xcf64 */
    OTHER,        /* 0xcf65 */
    OTHER,        /* 0xcf66 */
    OTHER,        /* 0xcf67 */
    OTHER,        /* 0xcf68 */
    OTHER,        /* 0xcf69 */
    OTHER,        /* 0xcf6a */
    OTHER,        /* 0xcf6b */
    OTHER,        /* 0xcf6c */
    OTHER,        /* 0xcf6d */
    OTHER,        /* 0xcf6e */
    OTHER,        /* 0xcf6f */
    OTHER,        /* 0xcf70 */
    OTHER,        /* 0xcf71 */
    OTHER,        /* 0xcf72 */
    OTHER,        /* 0xcf73 */
    OTHER,        /* 0xcf74 */
    OTHER,        /* 0xcf75 */
    OTHER,        /* 0xcf76 */
    OTHER,        /* 0xcf77 */
    OTHER,        /* 0xcf78 */
    OTHER,        /* 0xcf79 */
    OTHER,        /* 0xcf7a */
    OTHER,        /* 0xcf7b */
    OTHER,        /* 0xcf7c */
    OTHER,        /* 0xcf7d */
    OTHER,        /* 0xcf7e */
    OTHER,        /* 0xcf7f */
    OTHER,        /* 0xcf80 */
    OTHER,        /* 0xcf81 */
    OTHER,        /* 0xcf82 */
    OTHER,        /* 0xcf83 */
    OTHER,        /* 0xcf84 */
    OTHER,        /* 0xcf85 */
    OTHER,        /* 0xcf86 */
    OTHER,        /* 0xcf87 */
    OTHER,        /* 0xcf88 */
    OTHER,        /* 0xcf89 */
    OTHER,        /* 0xcf8a */
    OTHER,        /* 0xcf8b */
    OTHER,        /* 0xcf8c */
    OTHER,        /* 0xcf8d */
    OTHER,        /* 0xcf8e */
    OTHER,        /* 0xcf8f */
    OTHER,        /* 0xcf90 */
    OTHER,        /* 0xcf91 */
    OTHER,        /* 0xcf92 */
    OTHER,        /* 0xcf93 */
    OTHER,        /* 0xcf94 */
    OTHER,        /* 0xcf95 */
    OTHER,        /* 0xcf96 */
    OTHER,        /* 0xcf97 */
    OTHER,        /* 0xcf98 */
    OTHER,        /* 0xcf99 */
    OTHER,        /* 0xcf9a */
    OTHER,        /* 0xcf9b */
    OTHER,        /* 0xcf9c */
    OTHER,        /* 0xcf9d */
    OTHER,        /* 0xcf9e */
    OTHER,        /* 0xcf9f */
    OTHER,        /* 0xcfa0 */
    OTHER,        /* 0xcfa1 */
    OTHER,        /* 0xcfa2 */
    OTHER,        /* 0xcfa3 */
    OTHER,        /* 0xcfa4 */
    OTHER,        /* 0xcfa5 */
    OTHER,        /* 0xcfa6 */
    OTHER,        /* 0xcfa7 */
    OTHER,        /* 0xcfa8 */
    OTHER,        /* 0xcfa9 */
    OTHER,        /* 0xcfaa */
    OTHER,        /* 0xcfab */
    OTHER,        /* 0xcfac */
    OTHER,        /* 0xcfad */
    OTHER,        /* 0xcfae */
    OTHER,        /* 0xcfaf */
    OTHER,        /* 0xcfb0 */
    OTHER,        /* 0xcfb1 */
    OTHER,        /* 0xcfb2 */
    OTHER,        /* 0xcfb3 */
    OTHER,        /* 0xcfb4 */
    OTHER,        /* 0xcfb5 */
    OTHER,        /* 0xcfb6 */
    OTHER,        /* 0xcfb7 */
    OTHER,        /* 0xcfb8 */
    OTHER,        /* 0xcfb9 */
    OTHER,        /* 0xcfba */
    OTHER,        /* 0xcfbb */
    OTHER,        /* 0xcfbc */
    OTHER,        /* 0xcfbd */
    OTHER,        /* 0xcfbe */
    OTHER,        /* 0xcfbf */
    OTHER,        /* 0xcfc0 */
    OTHER,        /* 0xcfc1 */
    OTHER,        /* 0xcfc2 */
    OTHER,        /* 0xcfc3 */
    OTHER,        /* 0xcfc4 */
    OTHER,        /* 0xcfc5 */
    OTHER,        /* 0xcfc6 */
    OTHER,        /* 0xcfc7 */
    OTHER,        /* 0xcfc8 */
    OTHER,        /* 0xcfc9 */
    OTHER,        /* 0xcfca */
    OTHER,        /* 0xcfcb */
    OTHER,        /* 0xcfcc */
    OTHER,        /* 0xcfcd */
    OTHER,        /* 0xcfce */
    OTHER,        /* 0xcfcf */
    OTHER,        /* 0xcfd0 */
    OTHER,        /* 0xcfd1 */
    OTHER,        /* 0xcfd2 */
    OTHER,        /* 0xcfd3 */
    OTHER,        /* 0xcfd4 */
    OTHER,        /* 0xcfd5 */
    OTHER,        /* 0xcfd6 */
    OTHER,        /* 0xcfd7 */
    OTHER,        /* 0xcfd8 */
    OTHER,        /* 0xcfd9 */
    OTHER,        /* 0xcfda */
    OTHER,        /* 0xcfdb */
    OTHER,        /* 0xcfdc */
    OTHER,        /* 0xcfdd */
    OTHER,        /* 0xcfde */
    OTHER,        /* 0xcfdf */
    OTHER,        /* 0xcfe0 */
    OTHER,        /* 0xcfe1 */
    OTHER,        /* 0xcfe2 */
    OTHER,        /* 0xcfe3 */
    OTHER,        /* 0xcfe4 */
    OTHER,        /* 0xcfe5 */
    OTHER,        /* 0xcfe6 */
    OTHER,        /* 0xcfe7 */
    OTHER,        /* 0xcfe8 */
    OTHER,        /* 0xcfe9 */
    OTHER,        /* 0xcfea */
    OTHER,        /* 0xcfeb */
    OTHER,        /* 0xcfec */
    OTHER,        /* 0xcfed */
    OTHER,        /* 0xcfee */
    OTHER,        /* 0xcfef */
    OTHER,        /* 0xcff0 */
    OTHER,        /* 0xcff1 */
    OTHER,        /* 0xcff2 */
    OTHER,        /* 0xcff3 */
    OTHER,        /* 0xcff4 */
    OTHER,        /* 0xcff5 */
    OTHER,        /* 0xcff6 */
    OTHER,        /* 0xcff7 */
    OTHER,        /* 0xcff8 */
    OTHER,        /* 0xcff9 */
    OTHER,        /* 0xcffa */
    OTHER,        /* 0xcffb */
    OTHER,        /* 0xcffc */
    OTHER,        /* 0xcffd */
    OTHER,        /* 0xcffe */
    OTHER,        /* 0xcfff */
    OTHER,        /* 0xd000 */
    OTHER,        /* 0xd001 */
    OTHER,        /* 0xd002 */
    OTHER,        /* 0xd003 */
    OTHER,        /* 0xd004 */
    OTHER,        /* 0xd005 */
    OTHER,        /* 0xd006 */
    OTHER,        /* 0xd007 */
    OTHER,        /* 0xd008 */
    OTHER,        /* 0xd009 */
    OTHER,        /* 0xd00a */
    OTHER,        /* 0xd00b */
    OTHER,        /* 0xd00c */
    OTHER,        /* 0xd00d */
    OTHER,        /* 0xd00e */
    OTHER,        /* 0xd00f */
    OTHER,        /* 0xd010 */
    OTHER,        /* 0xd011 */
    OTHER,        /* 0xd012 */
    OTHER,        /* 0xd013 */
    OTHER,        /* 0xd014 */
    OTHER,        /* 0xd015 */
    OTHER,        /* 0xd016 */
    OTHER,        /* 0xd017 */
    OTHER,        /* 0xd018 */
    OTHER,        /* 0xd019 */
    OTHER,        /* 0xd01a */
    OTHER,        /* 0xd01b */
    OTHER,        /* 0xd01c */
    OTHER,        /* 0xd01d */
    OTHER,        /* 0xd01e */
    OTHER,        /* 0xd01f */
    OTHER,        /* 0xd020 */
    OTHER,        /* 0xd021 */
    OTHER,        /* 0xd022 */
    OTHER,        /* 0xd023 */
    OTHER,        /* 0xd024 */
    OTHER,        /* 0xd025 */
    OTHER,        /* 0xd026 */
    OTHER,        /* 0xd027 */
    OTHER,        /* 0xd028 */
    OTHER,        /* 0xd029 */
    OTHER,        /* 0xd02a */
    OTHER,        /* 0xd02b */
    OTHER,        /* 0xd02c */
    OTHER,        /* 0xd02d */
    OTHER,        /* 0xd02e */
    OTHER,        /* 0xd02f */
    OTHER,        /* 0xd030 */
    OTHER,        /* 0xd031 */
    OTHER,        /* 0xd032 */
    OTHER,        /* 0xd033 */
    OTHER,        /* 0xd034 */
    OTHER,        /* 0xd035 */
    OTHER,        /* 0xd036 */
    OTHER,        /* 0xd037 */
    OTHER,        /* 0xd038 */
    OTHER,        /* 0xd039 */
    OTHER,        /* 0xd03a */
    OTHER,        /* 0xd03b */
    OTHER,        /* 0xd03c */
    OTHER,        /* 0xd03d */
    OTHER,        /* 0xd03e */
    OTHER,        /* 0xd03f */
    OTHER,        /* 0xd040 */
    OTHER,        /* 0xd041 */
    OTHER,        /* 0xd042 */
    OTHER,        /* 0xd043 */
    OTHER,        /* 0xd044 */
    OTHER,        /* 0xd045 */
    OTHER,        /* 0xd046 */
    OTHER,        /* 0xd047 */
    OTHER,        /* 0xd048 */
    OTHER,        /* 0xd049 */
    OTHER,        /* 0xd04a */
    OTHER,        /* 0xd04b */
    OTHER,        /* 0xd04c */
    OTHER,        /* 0xd04d */
    OTHER,        /* 0xd04e */
    OTHER,        /* 0xd04f */
    OTHER,        /* 0xd050 */
    OTHER,        /* 0xd051 */
    OTHER,        /* 0xd052 */
    OTHER,        /* 0xd053 */
    OTHER,        /* 0xd054 */
    OTHER,        /* 0xd055 */
    OTHER,        /* 0xd056 */
    OTHER,        /* 0xd057 */
    OTHER,        /* 0xd058 */
    OTHER,        /* 0xd059 */
    OTHER,        /* 0xd05a */
    OTHER,        /* 0xd05b */
    OTHER,        /* 0xd05c */
    OTHER,        /* 0xd05d */
    OTHER,        /* 0xd05e */
    OTHER,        /* 0xd05f */
    OTHER,        /* 0xd060 */
    OTHER,        /* 0xd061 */
    OTHER,        /* 0xd062 */
    OTHER,        /* 0xd063 */
    OTHER,        /* 0xd064 */
    OTHER,        /* 0xd065 */
    OTHER,        /* 0xd066 */
    OTHER,        /* 0xd067 */
    OTHER,        /* 0xd068 */
    OTHER,        /* 0xd069 */
    OTHER,        /* 0xd06a */
    OTHER,        /* 0xd06b */
    OTHER,        /* 0xd06c */
    OTHER,        /* 0xd06d */
    OTHER,        /* 0xd06e */
    OTHER,        /* 0xd06f */
    OTHER,        /* 0xd070 */
    OTHER,        /* 0xd071 */
    OTHER,        /* 0xd072 */
    OTHER,        /* 0xd073 */
    OTHER,        /* 0xd074 */
    OTHER,        /* 0xd075 */
    OTHER,        /* 0xd076 */
    OTHER,        /* 0xd077 */
    OTHER,        /* 0xd078 */
    OTHER,        /* 0xd079 */
    OTHER,        /* 0xd07a */
    OTHER,        /* 0xd07b */
    OTHER,        /* 0xd07c */
    OTHER,        /* 0xd07d */
    OTHER,        /* 0xd07e */
    OTHER,        /* 0xd07f */
    OTHER,        /* 0xd080 */
    OTHER,        /* 0xd081 */
    OTHER,        /* 0xd082 */
    OTHER,        /* 0xd083 */
    OTHER,        /* 0xd084 */
    OTHER,        /* 0xd085 */
    OTHER,        /* 0xd086 */
    OTHER,        /* 0xd087 */
    OTHER,        /* 0xd088 */
    OTHER,        /* 0xd089 */
    OTHER,        /* 0xd08a */
    OTHER,        /* 0xd08b */
    OTHER,        /* 0xd08c */
    OTHER,        /* 0xd08d */
    OTHER,        /* 0xd08e */
    OTHER,        /* 0xd08f */
    OTHER,        /* 0xd090 */
    OTHER,        /* 0xd091 */
    OTHER,        /* 0xd092 */
    OTHER,        /* 0xd093 */
    OTHER,        /* 0xd094 */
    OTHER,        /* 0xd095 */
    OTHER,        /* 0xd096 */
    OTHER,        /* 0xd097 */
    OTHER,        /* 0xd098 */
    OTHER,        /* 0xd099 */
    OTHER,        /* 0xd09a */
    OTHER,        /* 0xd09b */
    OTHER,        /* 0xd09c */
    OTHER,        /* 0xd09d */
    OTHER,        /* 0xd09e */
    OTHER,        /* 0xd09f */
    OTHER,        /* 0xd0a0 */
    OTHER,        /* 0xd0a1 */
    OTHER,        /* 0xd0a2 */
    OTHER,        /* 0xd0a3 */
    OTHER,        /* 0xd0a4 */
    OTHER,        /* 0xd0a5 */
    OTHER,        /* 0xd0a6 */
    OTHER,        /* 0xd0a7 */
    OTHER,        /* 0xd0a8 */
    OTHER,        /* 0xd0a9 */
    OTHER,        /* 0xd0aa */
    OTHER,        /* 0xd0ab */
    OTHER,        /* 0xd0ac */
    OTHER,        /* 0xd0ad */
    OTHER,        /* 0xd0ae */
    OTHER,        /* 0xd0af */
    OTHER,        /* 0xd0b0 */
    OTHER,        /* 0xd0b1 */
    OTHER,        /* 0xd0b2 */
    OTHER,        /* 0xd0b3 */
    OTHER,        /* 0xd0b4 */
    OTHER,        /* 0xd0b5 */
    OTHER,        /* 0xd0b6 */
    OTHER,        /* 0xd0b7 */
    OTHER,        /* 0xd0b8 */
    OTHER,        /* 0xd0b9 */
    OTHER,        /* 0xd0ba */
    OTHER,        /* 0xd0bb */
    OTHER,        /* 0xd0bc */
    OTHER,        /* 0xd0bd */
    OTHER,        /* 0xd0be */
    OTHER,        /* 0xd0bf */
    OTHER,        /* 0xd0c0 */
    OTHER,        /* 0xd0c1 */
    OTHER,        /* 0xd0c2 */
    OTHER,        /* 0xd0c3 */
    OTHER,        /* 0xd0c4 */
    OTHER,        /* 0xd0c5 */
    OTHER,        /* 0xd0c6 */
    OTHER,        /* 0xd0c7 */
    OTHER,        /* 0xd0c8 */
    OTHER,        /* 0xd0c9 */
    OTHER,        /* 0xd0ca */
    OTHER,        /* 0xd0cb */
    OTHER,        /* 0xd0cc */
    OTHER,        /* 0xd0cd */
    OTHER,        /* 0xd0ce */
    OTHER,        /* 0xd0cf */
    OTHER,        /* 0xd0d0 */
    OTHER,        /* 0xd0d1 */
    OTHER,        /* 0xd0d2 */
    OTHER,        /* 0xd0d3 */
    OTHER,        /* 0xd0d4 */
    OTHER,        /* 0xd0d5 */
    OTHER,        /* 0xd0d6 */
    OTHER,        /* 0xd0d7 */
    OTHER,        /* 0xd0d8 */
    OTHER,        /* 0xd0d9 */
    OTHER,        /* 0xd0da */
    OTHER,        /* 0xd0db */
    OTHER,        /* 0xd0dc */
    OTHER,        /* 0xd0dd */
    OTHER,        /* 0xd0de */
    OTHER,        /* 0xd0df */
    OTHER,        /* 0xd0e0 */
    OTHER,        /* 0xd0e1 */
    OTHER,        /* 0xd0e2 */
    OTHER,        /* 0xd0e3 */
    OTHER,        /* 0xd0e4 */
    OTHER,        /* 0xd0e5 */
    OTHER,        /* 0xd0e6 */
    OTHER,        /* 0xd0e7 */
    OTHER,        /* 0xd0e8 */
    OTHER,        /* 0xd0e9 */
    OTHER,        /* 0xd0ea */
    OTHER,        /* 0xd0eb */
    OTHER,        /* 0xd0ec */
    OTHER,        /* 0xd0ed */
    OTHER,        /* 0xd0ee */
    OTHER,        /* 0xd0ef */
    OTHER,        /* 0xd0f0 */
    OTHER,        /* 0xd0f1 */
    OTHER,        /* 0xd0f2 */
    OTHER,        /* 0xd0f3 */
    OTHER,        /* 0xd0f4 */
    OTHER,        /* 0xd0f5 */
    OTHER,        /* 0xd0f6 */
    OTHER,        /* 0xd0f7 */
    OTHER,        /* 0xd0f8 */
    OTHER,        /* 0xd0f9 */
    OTHER,        /* 0xd0fa */
    OTHER,        /* 0xd0fb */
    OTHER,        /* 0xd0fc */
    OTHER,        /* 0xd0fd */
    OTHER,        /* 0xd0fe */
    OTHER,        /* 0xd0ff */
    OTHER,        /* 0xd100 */
    OTHER,        /* 0xd101 */
    OTHER,        /* 0xd102 */
    OTHER,        /* 0xd103 */
    OTHER,        /* 0xd104 */
    OTHER,        /* 0xd105 */
    OTHER,        /* 0xd106 */
    OTHER,        /* 0xd107 */
    OTHER,        /* 0xd108 */
    OTHER,        /* 0xd109 */
    OTHER,        /* 0xd10a */
    OTHER,        /* 0xd10b */
    OTHER,        /* 0xd10c */
    OTHER,        /* 0xd10d */
    OTHER,        /* 0xd10e */
    OTHER,        /* 0xd10f */
    OTHER,        /* 0xd110 */
    OTHER,        /* 0xd111 */
    OTHER,        /* 0xd112 */
    OTHER,        /* 0xd113 */
    OTHER,        /* 0xd114 */
    OTHER,        /* 0xd115 */
    OTHER,        /* 0xd116 */
    OTHER,        /* 0xd117 */
    OTHER,        /* 0xd118 */
    OTHER,        /* 0xd119 */
    OTHER,        /* 0xd11a */
    OTHER,        /* 0xd11b */
    OTHER,        /* 0xd11c */
    OTHER,        /* 0xd11d */
    OTHER,        /* 0xd11e */
    OTHER,        /* 0xd11f */
    OTHER,        /* 0xd120 */
    OTHER,        /* 0xd121 */
    OTHER,        /* 0xd122 */
    OTHER,        /* 0xd123 */
    OTHER,        /* 0xd124 */
    OTHER,        /* 0xd125 */
    OTHER,        /* 0xd126 */
    OTHER,        /* 0xd127 */
    OTHER,        /* 0xd128 */
    OTHER,        /* 0xd129 */
    OTHER,        /* 0xd12a */
    OTHER,        /* 0xd12b */
    OTHER,        /* 0xd12c */
    OTHER,        /* 0xd12d */
    OTHER,        /* 0xd12e */
    OTHER,        /* 0xd12f */
    OTHER,        /* 0xd130 */
    OTHER,        /* 0xd131 */
    OTHER,        /* 0xd132 */
    OTHER,        /* 0xd133 */
    OTHER,        /* 0xd134 */
    OTHER,        /* 0xd135 */
    OTHER,        /* 0xd136 */
    OTHER,        /* 0xd137 */
    OTHER,        /* 0xd138 */
    OTHER,        /* 0xd139 */
    OTHER,        /* 0xd13a */
    OTHER,        /* 0xd13b */
    OTHER,        /* 0xd13c */
    OTHER,        /* 0xd13d */
    OTHER,        /* 0xd13e */
    OTHER,        /* 0xd13f */
    OTHER,        /* 0xd140 */
    OTHER,        /* 0xd141 */
    OTHER,        /* 0xd142 */
    OTHER,        /* 0xd143 */
    OTHER,        /* 0xd144 */
    OTHER,        /* 0xd145 */
    OTHER,        /* 0xd146 */
    OTHER,        /* 0xd147 */
    OTHER,        /* 0xd148 */
    OTHER,        /* 0xd149 */
    OTHER,        /* 0xd14a */
    OTHER,        /* 0xd14b */
    OTHER,        /* 0xd14c */
    OTHER,        /* 0xd14d */
    OTHER,        /* 0xd14e */
    OTHER,        /* 0xd14f */
    OTHER,        /* 0xd150 */
    OTHER,        /* 0xd151 */
    OTHER,        /* 0xd152 */
    OTHER,        /* 0xd153 */
    OTHER,        /* 0xd154 */
    OTHER,        /* 0xd155 */
    OTHER,        /* 0xd156 */
    OTHER,        /* 0xd157 */
    OTHER,        /* 0xd158 */
    OTHER,        /* 0xd159 */
    OTHER,        /* 0xd15a */
    OTHER,        /* 0xd15b */
    OTHER,        /* 0xd15c */
    OTHER,        /* 0xd15d */
    OTHER,        /* 0xd15e */
    OTHER,        /* 0xd15f */
    OTHER,        /* 0xd160 */
    OTHER,        /* 0xd161 */
    OTHER,        /* 0xd162 */
    OTHER,        /* 0xd163 */
    OTHER,        /* 0xd164 */
    OTHER,        /* 0xd165 */
    OTHER,        /* 0xd166 */
    OTHER,        /* 0xd167 */
    OTHER,        /* 0xd168 */
    OTHER,        /* 0xd169 */
    OTHER,        /* 0xd16a */
    OTHER,        /* 0xd16b */
    OTHER,        /* 0xd16c */
    OTHER,        /* 0xd16d */
    OTHER,        /* 0xd16e */
    OTHER,        /* 0xd16f */
    OTHER,        /* 0xd170 */
    OTHER,        /* 0xd171 */
    OTHER,        /* 0xd172 */
    OTHER,        /* 0xd173 */
    OTHER,        /* 0xd174 */
    OTHER,        /* 0xd175 */
    OTHER,        /* 0xd176 */
    OTHER,        /* 0xd177 */
    OTHER,        /* 0xd178 */
    OTHER,        /* 0xd179 */
    OTHER,        /* 0xd17a */
    OTHER,        /* 0xd17b */
    OTHER,        /* 0xd17c */
    OTHER,        /* 0xd17d */
    OTHER,        /* 0xd17e */
    OTHER,        /* 0xd17f */
    OTHER,        /* 0xd180 */
    OTHER,        /* 0xd181 */
    OTHER,        /* 0xd182 */
    OTHER,        /* 0xd183 */
    OTHER,        /* 0xd184 */
    OTHER,        /* 0xd185 */
    OTHER,        /* 0xd186 */
    OTHER,        /* 0xd187 */
    OTHER,        /* 0xd188 */
    OTHER,        /* 0xd189 */
    OTHER,        /* 0xd18a */
    OTHER,        /* 0xd18b */
    OTHER,        /* 0xd18c */
    OTHER,        /* 0xd18d */
    OTHER,        /* 0xd18e */
    OTHER,        /* 0xd18f */
    OTHER,        /* 0xd190 */
    OTHER,        /* 0xd191 */
    OTHER,        /* 0xd192 */
    OTHER,        /* 0xd193 */
    OTHER,        /* 0xd194 */
    OTHER,        /* 0xd195 */
    OTHER,        /* 0xd196 */
    OTHER,        /* 0xd197 */
    OTHER,        /* 0xd198 */
    OTHER,        /* 0xd199 */
    OTHER,        /* 0xd19a */
    OTHER,        /* 0xd19b */
    OTHER,        /* 0xd19c */
    OTHER,        /* 0xd19d */
    OTHER,        /* 0xd19e */
    OTHER,        /* 0xd19f */
    OTHER,        /* 0xd1a0 */
    OTHER,        /* 0xd1a1 */
    OTHER,        /* 0xd1a2 */
    OTHER,        /* 0xd1a3 */
    OTHER,        /* 0xd1a4 */
    OTHER,        /* 0xd1a5 */
    OTHER,        /* 0xd1a6 */
    OTHER,        /* 0xd1a7 */
    OTHER,        /* 0xd1a8 */
    OTHER,        /* 0xd1a9 */
    OTHER,        /* 0xd1aa */
    OTHER,        /* 0xd1ab */
    OTHER,        /* 0xd1ac */
    OTHER,        /* 0xd1ad */
    OTHER,        /* 0xd1ae */
    OTHER,        /* 0xd1af */
    OTHER,        /* 0xd1b0 */
    OTHER,        /* 0xd1b1 */
    OTHER,        /* 0xd1b2 */
    OTHER,        /* 0xd1b3 */
    OTHER,        /* 0xd1b4 */
    OTHER,        /* 0xd1b5 */
    OTHER,        /* 0xd1b6 */
    OTHER,        /* 0xd1b7 */
    OTHER,        /* 0xd1b8 */
    OTHER,        /* 0xd1b9 */
    OTHER,        /* 0xd1ba */
    OTHER,        /* 0xd1bb */
    OTHER,        /* 0xd1bc */
    OTHER,        /* 0xd1bd */
    OTHER,        /* 0xd1be */
    OTHER,        /* 0xd1bf */
    OTHER,        /* 0xd1c0 */
    OTHER,        /* 0xd1c1 */
    OTHER,        /* 0xd1c2 */
    OTHER,        /* 0xd1c3 */
    OTHER,        /* 0xd1c4 */
    OTHER,        /* 0xd1c5 */
    OTHER,        /* 0xd1c6 */
    OTHER,        /* 0xd1c7 */
    OTHER,        /* 0xd1c8 */
    OTHER,        /* 0xd1c9 */
    OTHER,        /* 0xd1ca */
    OTHER,        /* 0xd1cb */
    OTHER,        /* 0xd1cc */
    OTHER,        /* 0xd1cd */
    OTHER,        /* 0xd1ce */
    OTHER,        /* 0xd1cf */
    OTHER,        /* 0xd1d0 */
    OTHER,        /* 0xd1d1 */
    OTHER,        /* 0xd1d2 */
    OTHER,        /* 0xd1d3 */
    OTHER,        /* 0xd1d4 */
    OTHER,        /* 0xd1d5 */
    OTHER,        /* 0xd1d6 */
    OTHER,        /* 0xd1d7 */
    OTHER,        /* 0xd1d8 */
    OTHER,        /* 0xd1d9 */
    OTHER,        /* 0xd1da */
    OTHER,        /* 0xd1db */
    OTHER,        /* 0xd1dc */
    OTHER,        /* 0xd1dd */
    OTHER,        /* 0xd1de */
    OTHER,        /* 0xd1df */
    OTHER,        /* 0xd1e0 */
    OTHER,        /* 0xd1e1 */
    OTHER,        /* 0xd1e2 */
    OTHER,        /* 0xd1e3 */
    OTHER,        /* 0xd1e4 */
    OTHER,        /* 0xd1e5 */
    OTHER,        /* 0xd1e6 */
    OTHER,        /* 0xd1e7 */
    OTHER,        /* 0xd1e8 */
    OTHER,        /* 0xd1e9 */
    OTHER,        /* 0xd1ea */
    OTHER,        /* 0xd1eb */
    OTHER,        /* 0xd1ec */
    OTHER,        /* 0xd1ed */
    OTHER,        /* 0xd1ee */
    OTHER,        /* 0xd1ef */
    OTHER,        /* 0xd1f0 */
    OTHER,        /* 0xd1f1 */
    OTHER,        /* 0xd1f2 */
    OTHER,        /* 0xd1f3 */
    OTHER,        /* 0xd1f4 */
    OTHER,        /* 0xd1f5 */
    OTHER,        /* 0xd1f6 */
    OTHER,        /* 0xd1f7 */
    OTHER,        /* 0xd1f8 */
    OTHER,        /* 0xd1f9 */
    OTHER,        /* 0xd1fa */
    OTHER,        /* 0xd1fb */
    OTHER,        /* 0xd1fc */
    OTHER,        /* 0xd1fd */
    OTHER,        /* 0xd1fe */
    OTHER,        /* 0xd1ff */
    OTHER,        /* 0xd200 */
    OTHER,        /* 0xd201 */
    OTHER,        /* 0xd202 */
    OTHER,        /* 0xd203 */
    OTHER,        /* 0xd204 */
    OTHER,        /* 0xd205 */
    OTHER,        /* 0xd206 */
    OTHER,        /* 0xd207 */
    OTHER,        /* 0xd208 */
    OTHER,        /* 0xd209 */
    OTHER,        /* 0xd20a */
    OTHER,        /* 0xd20b */
    OTHER,        /* 0xd20c */
    OTHER,        /* 0xd20d */
    OTHER,        /* 0xd20e */
    OTHER,        /* 0xd20f */
    OTHER,        /* 0xd210 */
    OTHER,        /* 0xd211 */
    OTHER,        /* 0xd212 */
    OTHER,        /* 0xd213 */
    OTHER,        /* 0xd214 */
    OTHER,        /* 0xd215 */
    OTHER,        /* 0xd216 */
    OTHER,        /* 0xd217 */
    OTHER,        /* 0xd218 */
    OTHER,        /* 0xd219 */
    OTHER,        /* 0xd21a */
    OTHER,        /* 0xd21b */
    OTHER,        /* 0xd21c */
    OTHER,        /* 0xd21d */
    OTHER,        /* 0xd21e */
    OTHER,        /* 0xd21f */
    OTHER,        /* 0xd220 */
    OTHER,        /* 0xd221 */
    OTHER,        /* 0xd222 */
    OTHER,        /* 0xd223 */
    OTHER,        /* 0xd224 */
    OTHER,        /* 0xd225 */
    OTHER,        /* 0xd226 */
    OTHER,        /* 0xd227 */
    OTHER,        /* 0xd228 */
    OTHER,        /* 0xd229 */
    OTHER,        /* 0xd22a */
    OTHER,        /* 0xd22b */
    OTHER,        /* 0xd22c */
    OTHER,        /* 0xd22d */
    OTHER,        /* 0xd22e */
    OTHER,        /* 0xd22f */
    OTHER,        /* 0xd230 */
    OTHER,        /* 0xd231 */
    OTHER,        /* 0xd232 */
    OTHER,        /* 0xd233 */
    OTHER,        /* 0xd234 */
    OTHER,        /* 0xd235 */
    OTHER,        /* 0xd236 */
    OTHER,        /* 0xd237 */
    OTHER,        /* 0xd238 */
    OTHER,        /* 0xd239 */
    OTHER,        /* 0xd23a */
    OTHER,        /* 0xd23b */
    OTHER,        /* 0xd23c */
    OTHER,        /* 0xd23d */
    OTHER,        /* 0xd23e */
    OTHER,        /* 0xd23f */
    OTHER,        /* 0xd240 */
    OTHER,        /* 0xd241 */
    OTHER,        /* 0xd242 */
    OTHER,        /* 0xd243 */
    OTHER,        /* 0xd244 */
    OTHER,        /* 0xd245 */
    OTHER,        /* 0xd246 */
    OTHER,        /* 0xd247 */
    OTHER,        /* 0xd248 */
    OTHER,        /* 0xd249 */
    OTHER,        /* 0xd24a */
    OTHER,        /* 0xd24b */
    OTHER,        /* 0xd24c */
    OTHER,        /* 0xd24d */
    OTHER,        /* 0xd24e */
    OTHER,        /* 0xd24f */
    OTHER,        /* 0xd250 */
    OTHER,        /* 0xd251 */
    OTHER,        /* 0xd252 */
    OTHER,        /* 0xd253 */
    OTHER,        /* 0xd254 */
    OTHER,        /* 0xd255 */
    OTHER,        /* 0xd256 */
    OTHER,        /* 0xd257 */
    OTHER,        /* 0xd258 */
    OTHER,        /* 0xd259 */
    OTHER,        /* 0xd25a */
    OTHER,        /* 0xd25b */
    OTHER,        /* 0xd25c */
    OTHER,        /* 0xd25d */
    OTHER,        /* 0xd25e */
    OTHER,        /* 0xd25f */
    OTHER,        /* 0xd260 */
    OTHER,        /* 0xd261 */
    OTHER,        /* 0xd262 */
    OTHER,        /* 0xd263 */
    OTHER,        /* 0xd264 */
    OTHER,        /* 0xd265 */
    OTHER,        /* 0xd266 */
    OTHER,        /* 0xd267 */
    OTHER,        /* 0xd268 */
    OTHER,        /* 0xd269 */
    OTHER,        /* 0xd26a */
    OTHER,        /* 0xd26b */
    OTHER,        /* 0xd26c */
    OTHER,        /* 0xd26d */
    OTHER,        /* 0xd26e */
    OTHER,        /* 0xd26f */
    OTHER,        /* 0xd270 */
    OTHER,        /* 0xd271 */
    OTHER,        /* 0xd272 */
    OTHER,        /* 0xd273 */
    OTHER,        /* 0xd274 */
    OTHER,        /* 0xd275 */
    OTHER,        /* 0xd276 */
    OTHER,        /* 0xd277 */
    OTHER,        /* 0xd278 */
    OTHER,        /* 0xd279 */
    OTHER,        /* 0xd27a */
    OTHER,        /* 0xd27b */
    OTHER,        /* 0xd27c */
    OTHER,        /* 0xd27d */
    OTHER,        /* 0xd27e */
    OTHER,        /* 0xd27f */
    OTHER,        /* 0xd280 */
    OTHER,        /* 0xd281 */
    OTHER,        /* 0xd282 */
    OTHER,        /* 0xd283 */
    OTHER,        /* 0xd284 */
    OTHER,        /* 0xd285 */
    OTHER,        /* 0xd286 */
    OTHER,        /* 0xd287 */
    OTHER,        /* 0xd288 */
    OTHER,        /* 0xd289 */
    OTHER,        /* 0xd28a */
    OTHER,        /* 0xd28b */
    OTHER,        /* 0xd28c */
    OTHER,        /* 0xd28d */
    OTHER,        /* 0xd28e */
    OTHER,        /* 0xd28f */
    OTHER,        /* 0xd290 */
    OTHER,        /* 0xd291 */
    OTHER,        /* 0xd292 */
    OTHER,        /* 0xd293 */
    OTHER,        /* 0xd294 */
    OTHER,        /* 0xd295 */
    OTHER,        /* 0xd296 */
    OTHER,        /* 0xd297 */
    OTHER,        /* 0xd298 */
    OTHER,        /* 0xd299 */
    OTHER,        /* 0xd29a */
    OTHER,        /* 0xd29b */
    OTHER,        /* 0xd29c */
    OTHER,        /* 0xd29d */
    OTHER,        /* 0xd29e */
    OTHER,        /* 0xd29f */
    OTHER,        /* 0xd2a0 */
    OTHER,        /* 0xd2a1 */
    OTHER,        /* 0xd2a2 */
    OTHER,        /* 0xd2a3 */
    OTHER,        /* 0xd2a4 */
    OTHER,        /* 0xd2a5 */
    OTHER,        /* 0xd2a6 */
    OTHER,        /* 0xd2a7 */
    OTHER,        /* 0xd2a8 */
    OTHER,        /* 0xd2a9 */
    OTHER,        /* 0xd2aa */
    OTHER,        /* 0xd2ab */
    OTHER,        /* 0xd2ac */
    OTHER,        /* 0xd2ad */
    OTHER,        /* 0xd2ae */
    OTHER,        /* 0xd2af */
    OTHER,        /* 0xd2b0 */
    OTHER,        /* 0xd2b1 */
    OTHER,        /* 0xd2b2 */
    OTHER,        /* 0xd2b3 */
    OTHER,        /* 0xd2b4 */
    OTHER,        /* 0xd2b5 */
    OTHER,        /* 0xd2b6 */
    OTHER,        /* 0xd2b7 */
    OTHER,        /* 0xd2b8 */
    OTHER,        /* 0xd2b9 */
    OTHER,        /* 0xd2ba */
    OTHER,        /* 0xd2bb */
    OTHER,        /* 0xd2bc */
    OTHER,        /* 0xd2bd */
    OTHER,        /* 0xd2be */
    OTHER,        /* 0xd2bf */
    OTHER,        /* 0xd2c0 */
    OTHER,        /* 0xd2c1 */
    OTHER,        /* 0xd2c2 */
    OTHER,        /* 0xd2c3 */
    OTHER,        /* 0xd2c4 */
    OTHER,        /* 0xd2c5 */
    OTHER,        /* 0xd2c6 */
    OTHER,        /* 0xd2c7 */
    OTHER,        /* 0xd2c8 */
    OTHER,        /* 0xd2c9 */
    OTHER,        /* 0xd2ca */
    OTHER,        /* 0xd2cb */
    OTHER,        /* 0xd2cc */
    OTHER,        /* 0xd2cd */
    OTHER,        /* 0xd2ce */
    OTHER,        /* 0xd2cf */
    OTHER,        /* 0xd2d0 */
    OTHER,        /* 0xd2d1 */
    OTHER,        /* 0xd2d2 */
    OTHER,        /* 0xd2d3 */
    OTHER,        /* 0xd2d4 */
    OTHER,        /* 0xd2d5 */
    OTHER,        /* 0xd2d6 */
    OTHER,        /* 0xd2d7 */
    OTHER,        /* 0xd2d8 */
    OTHER,        /* 0xd2d9 */
    OTHER,        /* 0xd2da */
    OTHER,        /* 0xd2db */
    OTHER,        /* 0xd2dc */
    OTHER,        /* 0xd2dd */
    OTHER,        /* 0xd2de */
    OTHER,        /* 0xd2df */
    OTHER,        /* 0xd2e0 */
    OTHER,        /* 0xd2e1 */
    OTHER,        /* 0xd2e2 */
    OTHER,        /* 0xd2e3 */
    OTHER,        /* 0xd2e4 */
    OTHER,        /* 0xd2e5 */
    OTHER,        /* 0xd2e6 */
    OTHER,        /* 0xd2e7 */
    OTHER,        /* 0xd2e8 */
    OTHER,        /* 0xd2e9 */
    OTHER,        /* 0xd2ea */
    OTHER,        /* 0xd2eb */
    OTHER,        /* 0xd2ec */
    OTHER,        /* 0xd2ed */
    OTHER,        /* 0xd2ee */
    OTHER,        /* 0xd2ef */
    OTHER,        /* 0xd2f0 */
    OTHER,        /* 0xd2f1 */
    OTHER,        /* 0xd2f2 */
    OTHER,        /* 0xd2f3 */
    OTHER,        /* 0xd2f4 */
    OTHER,        /* 0xd2f5 */
    OTHER,        /* 0xd2f6 */
    OTHER,        /* 0xd2f7 */
    OTHER,        /* 0xd2f8 */
    OTHER,        /* 0xd2f9 */
    OTHER,        /* 0xd2fa */
    OTHER,        /* 0xd2fb */
    OTHER,        /* 0xd2fc */
    OTHER,        /* 0xd2fd */
    OTHER,        /* 0xd2fe */
    OTHER,        /* 0xd2ff */
    OTHER,        /* 0xd300 */
    OTHER,        /* 0xd301 */
    OTHER,        /* 0xd302 */
    OTHER,        /* 0xd303 */
    OTHER,        /* 0xd304 */
    OTHER,        /* 0xd305 */
    OTHER,        /* 0xd306 */
    OTHER,        /* 0xd307 */
    OTHER,        /* 0xd308 */
    OTHER,        /* 0xd309 */
    OTHER,        /* 0xd30a */
    OTHER,        /* 0xd30b */
    OTHER,        /* 0xd30c */
    OTHER,        /* 0xd30d */
    OTHER,        /* 0xd30e */
    OTHER,        /* 0xd30f */
    OTHER,        /* 0xd310 */
    OTHER,        /* 0xd311 */
    OTHER,        /* 0xd312 */
    OTHER,        /* 0xd313 */
    OTHER,        /* 0xd314 */
    OTHER,        /* 0xd315 */
    OTHER,        /* 0xd316 */
    OTHER,        /* 0xd317 */
    OTHER,        /* 0xd318 */
    OTHER,        /* 0xd319 */
    OTHER,        /* 0xd31a */
    OTHER,        /* 0xd31b */
    OTHER,        /* 0xd31c */
    OTHER,        /* 0xd31d */
    OTHER,        /* 0xd31e */
    OTHER,        /* 0xd31f */
    OTHER,        /* 0xd320 */
    OTHER,        /* 0xd321 */
    OTHER,        /* 0xd322 */
    OTHER,        /* 0xd323 */
    OTHER,        /* 0xd324 */
    OTHER,        /* 0xd325 */
    OTHER,        /* 0xd326 */
    OTHER,        /* 0xd327 */
    OTHER,        /* 0xd328 */
    OTHER,        /* 0xd329 */
    OTHER,        /* 0xd32a */
    OTHER,        /* 0xd32b */
    OTHER,        /* 0xd32c */
    OTHER,        /* 0xd32d */
    OTHER,        /* 0xd32e */
    OTHER,        /* 0xd32f */
    OTHER,        /* 0xd330 */
    OTHER,        /* 0xd331 */
    OTHER,        /* 0xd332 */
    OTHER,        /* 0xd333 */
    OTHER,        /* 0xd334 */
    OTHER,        /* 0xd335 */
    OTHER,        /* 0xd336 */
    OTHER,        /* 0xd337 */
    OTHER,        /* 0xd338 */
    OTHER,        /* 0xd339 */
    OTHER,        /* 0xd33a */
    OTHER,        /* 0xd33b */
    OTHER,        /* 0xd33c */
    OTHER,        /* 0xd33d */
    OTHER,        /* 0xd33e */
    OTHER,        /* 0xd33f */
    OTHER,        /* 0xd340 */
    OTHER,        /* 0xd341 */
    OTHER,        /* 0xd342 */
    OTHER,        /* 0xd343 */
    OTHER,        /* 0xd344 */
    OTHER,        /* 0xd345 */
    OTHER,        /* 0xd346 */
    OTHER,        /* 0xd347 */
    OTHER,        /* 0xd348 */
    OTHER,        /* 0xd349 */
    OTHER,        /* 0xd34a */
    OTHER,        /* 0xd34b */
    OTHER,        /* 0xd34c */
    OTHER,        /* 0xd34d */
    OTHER,        /* 0xd34e */
    OTHER,        /* 0xd34f */
    OTHER,        /* 0xd350 */
    OTHER,        /* 0xd351 */
    OTHER,        /* 0xd352 */
    OTHER,        /* 0xd353 */
    OTHER,        /* 0xd354 */
    OTHER,        /* 0xd355 */
    OTHER,        /* 0xd356 */
    OTHER,        /* 0xd357 */
    OTHER,        /* 0xd358 */
    OTHER,        /* 0xd359 */
    OTHER,        /* 0xd35a */
    OTHER,        /* 0xd35b */
    OTHER,        /* 0xd35c */
    OTHER,        /* 0xd35d */
    OTHER,        /* 0xd35e */
    OTHER,        /* 0xd35f */
    OTHER,        /* 0xd360 */
    OTHER,        /* 0xd361 */
    OTHER,        /* 0xd362 */
    OTHER,        /* 0xd363 */
    OTHER,        /* 0xd364 */
    OTHER,        /* 0xd365 */
    OTHER,        /* 0xd366 */
    OTHER,        /* 0xd367 */
    OTHER,        /* 0xd368 */
    OTHER,        /* 0xd369 */
    OTHER,        /* 0xd36a */
    OTHER,        /* 0xd36b */
    OTHER,        /* 0xd36c */
    OTHER,        /* 0xd36d */
    OTHER,        /* 0xd36e */
    OTHER,        /* 0xd36f */
    OTHER,        /* 0xd370 */
    OTHER,        /* 0xd371 */
    OTHER,        /* 0xd372 */
    OTHER,        /* 0xd373 */
    OTHER,        /* 0xd374 */
    OTHER,        /* 0xd375 */
    OTHER,        /* 0xd376 */
    OTHER,        /* 0xd377 */
    OTHER,        /* 0xd378 */
    OTHER,        /* 0xd379 */
    OTHER,        /* 0xd37a */
    OTHER,        /* 0xd37b */
    OTHER,        /* 0xd37c */
    OTHER,        /* 0xd37d */
    OTHER,        /* 0xd37e */
    OTHER,        /* 0xd37f */
    OTHER,        /* 0xd380 */
    OTHER,        /* 0xd381 */
    OTHER,        /* 0xd382 */
    OTHER,        /* 0xd383 */
    OTHER,        /* 0xd384 */
    OTHER,        /* 0xd385 */
    OTHER,        /* 0xd386 */
    OTHER,        /* 0xd387 */
    OTHER,        /* 0xd388 */
    OTHER,        /* 0xd389 */
    OTHER,        /* 0xd38a */
    OTHER,        /* 0xd38b */
    OTHER,        /* 0xd38c */
    OTHER,        /* 0xd38d */
    OTHER,        /* 0xd38e */
    OTHER,        /* 0xd38f */
    OTHER,        /* 0xd390 */
    OTHER,        /* 0xd391 */
    OTHER,        /* 0xd392 */
    OTHER,        /* 0xd393 */
    OTHER,        /* 0xd394 */
    OTHER,        /* 0xd395 */
    OTHER,        /* 0xd396 */
    OTHER,        /* 0xd397 */
    OTHER,        /* 0xd398 */
    OTHER,        /* 0xd399 */
    OTHER,        /* 0xd39a */
    OTHER,        /* 0xd39b */
    OTHER,        /* 0xd39c */
    OTHER,        /* 0xd39d */
    OTHER,        /* 0xd39e */
    OTHER,        /* 0xd39f */
    OTHER,        /* 0xd3a0 */
    OTHER,        /* 0xd3a1 */
    OTHER,        /* 0xd3a2 */
    OTHER,        /* 0xd3a3 */
    OTHER,        /* 0xd3a4 */
    OTHER,        /* 0xd3a5 */
    OTHER,        /* 0xd3a6 */
    OTHER,        /* 0xd3a7 */
    OTHER,        /* 0xd3a8 */
    OTHER,        /* 0xd3a9 */
    OTHER,        /* 0xd3aa */
    OTHER,        /* 0xd3ab */
    OTHER,        /* 0xd3ac */
    OTHER,        /* 0xd3ad */
    OTHER,        /* 0xd3ae */
    OTHER,        /* 0xd3af */
    OTHER,        /* 0xd3b0 */
    OTHER,        /* 0xd3b1 */
    OTHER,        /* 0xd3b2 */
    OTHER,        /* 0xd3b3 */
    OTHER,        /* 0xd3b4 */
    OTHER,        /* 0xd3b5 */
    OTHER,        /* 0xd3b6 */
    OTHER,        /* 0xd3b7 */
    OTHER,        /* 0xd3b8 */
    OTHER,        /* 0xd3b9 */
    OTHER,        /* 0xd3ba */
    OTHER,        /* 0xd3bb */
    OTHER,        /* 0xd3bc */
    OTHER,        /* 0xd3bd */
    OTHER,        /* 0xd3be */
    OTHER,        /* 0xd3bf */
    OTHER,        /* 0xd3c0 */
    OTHER,        /* 0xd3c1 */
    OTHER,        /* 0xd3c2 */
    OTHER,        /* 0xd3c3 */
    OTHER,        /* 0xd3c4 */
    OTHER,        /* 0xd3c5 */
    OTHER,        /* 0xd3c6 */
    OTHER,        /* 0xd3c7 */
    OTHER,        /* 0xd3c8 */
    OTHER,        /* 0xd3c9 */
    OTHER,        /* 0xd3ca */
    OTHER,        /* 0xd3cb */
    OTHER,        /* 0xd3cc */
    OTHER,        /* 0xd3cd */
    OTHER,        /* 0xd3ce */
    OTHER,        /* 0xd3cf */
    OTHER,        /* 0xd3d0 */
    OTHER,        /* 0xd3d1 */
    OTHER,        /* 0xd3d2 */
    OTHER,        /* 0xd3d3 */
    OTHER,        /* 0xd3d4 */
    OTHER,        /* 0xd3d5 */
    OTHER,        /* 0xd3d6 */
    OTHER,        /* 0xd3d7 */
    OTHER,        /* 0xd3d8 */
    OTHER,        /* 0xd3d9 */
    OTHER,        /* 0xd3da */
    OTHER,        /* 0xd3db */
    OTHER,        /* 0xd3dc */
    OTHER,        /* 0xd3dd */
    OTHER,        /* 0xd3de */
    OTHER,        /* 0xd3df */
    OTHER,        /* 0xd3e0 */
    OTHER,        /* 0xd3e1 */
    OTHER,        /* 0xd3e2 */
    OTHER,        /* 0xd3e3 */
    OTHER,        /* 0xd3e4 */
    OTHER,        /* 0xd3e5 */
    OTHER,        /* 0xd3e6 */
    OTHER,        /* 0xd3e7 */
    OTHER,        /* 0xd3e8 */
    OTHER,        /* 0xd3e9 */
    OTHER,        /* 0xd3ea */
    OTHER,        /* 0xd3eb */
    OTHER,        /* 0xd3ec */
    OTHER,        /* 0xd3ed */
    OTHER,        /* 0xd3ee */
    OTHER,        /* 0xd3ef */
    OTHER,        /* 0xd3f0 */
    OTHER,        /* 0xd3f1 */
    OTHER,        /* 0xd3f2 */
    OTHER,        /* 0xd3f3 */
    OTHER,        /* 0xd3f4 */
    OTHER,        /* 0xd3f5 */
    OTHER,        /* 0xd3f6 */
    OTHER,        /* 0xd3f7 */
    OTHER,        /* 0xd3f8 */
    OTHER,        /* 0xd3f9 */
    OTHER,        /* 0xd3fa */
    OTHER,        /* 0xd3fb */
    OTHER,        /* 0xd3fc */
    OTHER,        /* 0xd3fd */
    OTHER,        /* 0xd3fe */
    OTHER,        /* 0xd3ff */
    OTHER,        /* 0xd400 */
    OTHER,        /* 0xd401 */
    OTHER,        /* 0xd402 */
    OTHER,        /* 0xd403 */
    OTHER,        /* 0xd404 */
    OTHER,        /* 0xd405 */
    OTHER,        /* 0xd406 */
    OTHER,        /* 0xd407 */
    OTHER,        /* 0xd408 */
    OTHER,        /* 0xd409 */
    OTHER,        /* 0xd40a */
    OTHER,        /* 0xd40b */
    OTHER,        /* 0xd40c */
    OTHER,        /* 0xd40d */
    OTHER,        /* 0xd40e */
    OTHER,        /* 0xd40f */
    OTHER,        /* 0xd410 */
    OTHER,        /* 0xd411 */
    OTHER,        /* 0xd412 */
    OTHER,        /* 0xd413 */
    OTHER,        /* 0xd414 */
    OTHER,        /* 0xd415 */
    OTHER,        /* 0xd416 */
    OTHER,        /* 0xd417 */
    OTHER,        /* 0xd418 */
    OTHER,        /* 0xd419 */
    OTHER,        /* 0xd41a */
    OTHER,        /* 0xd41b */
    OTHER,        /* 0xd41c */
    OTHER,        /* 0xd41d */
    OTHER,        /* 0xd41e */
    OTHER,        /* 0xd41f */
    OTHER,        /* 0xd420 */
    OTHER,        /* 0xd421 */
    OTHER,        /* 0xd422 */
    OTHER,        /* 0xd423 */
    OTHER,        /* 0xd424 */
    OTHER,        /* 0xd425 */
    OTHER,        /* 0xd426 */
    OTHER,        /* 0xd427 */
    OTHER,        /* 0xd428 */
    OTHER,        /* 0xd429 */
    OTHER,        /* 0xd42a */
    OTHER,        /* 0xd42b */
    OTHER,        /* 0xd42c */
    OTHER,        /* 0xd42d */
    OTHER,        /* 0xd42e */
    OTHER,        /* 0xd42f */
    OTHER,        /* 0xd430 */
    OTHER,        /* 0xd431 */
    OTHER,        /* 0xd432 */
    OTHER,        /* 0xd433 */
    OTHER,        /* 0xd434 */
    OTHER,        /* 0xd435 */
    OTHER,        /* 0xd436 */
    OTHER,        /* 0xd437 */
    OTHER,        /* 0xd438 */
    OTHER,        /* 0xd439 */
    OTHER,        /* 0xd43a */
    OTHER,        /* 0xd43b */
    OTHER,        /* 0xd43c */
    OTHER,        /* 0xd43d */
    OTHER,        /* 0xd43e */
    OTHER,        /* 0xd43f */
    OTHER,        /* 0xd440 */
    OTHER,        /* 0xd441 */
    OTHER,        /* 0xd442 */
    OTHER,        /* 0xd443 */
    OTHER,        /* 0xd444 */
    OTHER,        /* 0xd445 */
    OTHER,        /* 0xd446 */
    OTHER,        /* 0xd447 */
    OTHER,        /* 0xd448 */
    OTHER,        /* 0xd449 */
    OTHER,        /* 0xd44a */
    OTHER,        /* 0xd44b */
    OTHER,        /* 0xd44c */
    OTHER,        /* 0xd44d */
    OTHER,        /* 0xd44e */
    OTHER,        /* 0xd44f */
    OTHER,        /* 0xd450 */
    OTHER,        /* 0xd451 */
    OTHER,        /* 0xd452 */
    OTHER,        /* 0xd453 */
    OTHER,        /* 0xd454 */
    OTHER,        /* 0xd455 */
    OTHER,        /* 0xd456 */
    OTHER,        /* 0xd457 */
    OTHER,        /* 0xd458 */
    OTHER,        /* 0xd459 */
    OTHER,        /* 0xd45a */
    OTHER,        /* 0xd45b */
    OTHER,        /* 0xd45c */
    OTHER,        /* 0xd45d */
    OTHER,        /* 0xd45e */
    OTHER,        /* 0xd45f */
    OTHER,        /* 0xd460 */
    OTHER,        /* 0xd461 */
    OTHER,        /* 0xd462 */
    OTHER,        /* 0xd463 */
    OTHER,        /* 0xd464 */
    OTHER,        /* 0xd465 */
    OTHER,        /* 0xd466 */
    OTHER,        /* 0xd467 */
    OTHER,        /* 0xd468 */
    OTHER,        /* 0xd469 */
    OTHER,        /* 0xd46a */
    OTHER,        /* 0xd46b */
    OTHER,        /* 0xd46c */
    OTHER,        /* 0xd46d */
    OTHER,        /* 0xd46e */
    OTHER,        /* 0xd46f */
    OTHER,        /* 0xd470 */
    OTHER,        /* 0xd471 */
    OTHER,        /* 0xd472 */
    OTHER,        /* 0xd473 */
    OTHER,        /* 0xd474 */
    OTHER,        /* 0xd475 */
    OTHER,        /* 0xd476 */
    OTHER,        /* 0xd477 */
    OTHER,        /* 0xd478 */
    OTHER,        /* 0xd479 */
    OTHER,        /* 0xd47a */
    OTHER,        /* 0xd47b */
    OTHER,        /* 0xd47c */
    OTHER,        /* 0xd47d */
    OTHER,        /* 0xd47e */
    OTHER,        /* 0xd47f */
    OTHER,        /* 0xd480 */
    OTHER,        /* 0xd481 */
    OTHER,        /* 0xd482 */
    OTHER,        /* 0xd483 */
    OTHER,        /* 0xd484 */
    OTHER,        /* 0xd485 */
    OTHER,        /* 0xd486 */
    OTHER,        /* 0xd487 */
    OTHER,        /* 0xd488 */
    OTHER,        /* 0xd489 */
    OTHER,        /* 0xd48a */
    OTHER,        /* 0xd48b */
    OTHER,        /* 0xd48c */
    OTHER,        /* 0xd48d */
    OTHER,        /* 0xd48e */
    OTHER,        /* 0xd48f */
    OTHER,        /* 0xd490 */
    OTHER,        /* 0xd491 */
    OTHER,        /* 0xd492 */
    OTHER,        /* 0xd493 */
    OTHER,        /* 0xd494 */
    OTHER,        /* 0xd495 */
    OTHER,        /* 0xd496 */
    OTHER,        /* 0xd497 */
    OTHER,        /* 0xd498 */
    OTHER,        /* 0xd499 */
    OTHER,        /* 0xd49a */
    OTHER,        /* 0xd49b */
    OTHER,        /* 0xd49c */
    OTHER,        /* 0xd49d */
    OTHER,        /* 0xd49e */
    OTHER,        /* 0xd49f */
    OTHER,        /* 0xd4a0 */
    OTHER,        /* 0xd4a1 */
    OTHER,        /* 0xd4a2 */
    OTHER,        /* 0xd4a3 */
    OTHER,        /* 0xd4a4 */
    OTHER,        /* 0xd4a5 */
    OTHER,        /* 0xd4a6 */
    OTHER,        /* 0xd4a7 */
    OTHER,        /* 0xd4a8 */
    OTHER,        /* 0xd4a9 */
    OTHER,        /* 0xd4aa */
    OTHER,        /* 0xd4ab */
    OTHER,        /* 0xd4ac */
    OTHER,        /* 0xd4ad */
    OTHER,        /* 0xd4ae */
    OTHER,        /* 0xd4af */
    OTHER,        /* 0xd4b0 */
    OTHER,        /* 0xd4b1 */
    OTHER,        /* 0xd4b2 */
    OTHER,        /* 0xd4b3 */
    OTHER,        /* 0xd4b4 */
    OTHER,        /* 0xd4b5 */
    OTHER,        /* 0xd4b6 */
    OTHER,        /* 0xd4b7 */
    OTHER,        /* 0xd4b8 */
    OTHER,        /* 0xd4b9 */
    OTHER,        /* 0xd4ba */
    OTHER,        /* 0xd4bb */
    OTHER,        /* 0xd4bc */
    OTHER,        /* 0xd4bd */
    OTHER,        /* 0xd4be */
    OTHER,        /* 0xd4bf */
    OTHER,        /* 0xd4c0 */
    OTHER,        /* 0xd4c1 */
    OTHER,        /* 0xd4c2 */
    OTHER,        /* 0xd4c3 */
    OTHER,        /* 0xd4c4 */
    OTHER,        /* 0xd4c5 */
    OTHER,        /* 0xd4c6 */
    OTHER,        /* 0xd4c7 */
    OTHER,        /* 0xd4c8 */
    OTHER,        /* 0xd4c9 */
    OTHER,        /* 0xd4ca */
    OTHER,        /* 0xd4cb */
    OTHER,        /* 0xd4cc */
    OTHER,        /* 0xd4cd */
    OTHER,        /* 0xd4ce */
    OTHER,        /* 0xd4cf */
    OTHER,        /* 0xd4d0 */
    OTHER,        /* 0xd4d1 */
    OTHER,        /* 0xd4d2 */
    OTHER,        /* 0xd4d3 */
    OTHER,        /* 0xd4d4 */
    OTHER,        /* 0xd4d5 */
    OTHER,        /* 0xd4d6 */
    OTHER,        /* 0xd4d7 */
    OTHER,        /* 0xd4d8 */
    OTHER,        /* 0xd4d9 */
    OTHER,        /* 0xd4da */
    OTHER,        /* 0xd4db */
    OTHER,        /* 0xd4dc */
    OTHER,        /* 0xd4dd */
    OTHER,        /* 0xd4de */
    OTHER,        /* 0xd4df */
    OTHER,        /* 0xd4e0 */
    OTHER,        /* 0xd4e1 */
    OTHER,        /* 0xd4e2 */
    OTHER,        /* 0xd4e3 */
    OTHER,        /* 0xd4e4 */
    OTHER,        /* 0xd4e5 */
    OTHER,        /* 0xd4e6 */
    OTHER,        /* 0xd4e7 */
    OTHER,        /* 0xd4e8 */
    OTHER,        /* 0xd4e9 */
    OTHER,        /* 0xd4ea */
    OTHER,        /* 0xd4eb */
    OTHER,        /* 0xd4ec */
    OTHER,        /* 0xd4ed */
    OTHER,        /* 0xd4ee */
    OTHER,        /* 0xd4ef */
    OTHER,        /* 0xd4f0 */
    OTHER,        /* 0xd4f1 */
    OTHER,        /* 0xd4f2 */
    OTHER,        /* 0xd4f3 */
    OTHER,        /* 0xd4f4 */
    OTHER,        /* 0xd4f5 */
    OTHER,        /* 0xd4f6 */
    OTHER,        /* 0xd4f7 */
    OTHER,        /* 0xd4f8 */
    OTHER,        /* 0xd4f9 */
    OTHER,        /* 0xd4fa */
    OTHER,        /* 0xd4fb */
    OTHER,        /* 0xd4fc */
    OTHER,        /* 0xd4fd */
    OTHER,        /* 0xd4fe */
    OTHER,        /* 0xd4ff */
    OTHER,        /* 0xd500 */
    OTHER,        /* 0xd501 */
    OTHER,        /* 0xd502 */
    OTHER,        /* 0xd503 */
    OTHER,        /* 0xd504 */
    OTHER,        /* 0xd505 */
    OTHER,        /* 0xd506 */
    OTHER,        /* 0xd507 */
    OTHER,        /* 0xd508 */
    OTHER,        /* 0xd509 */
    OTHER,        /* 0xd50a */
    OTHER,        /* 0xd50b */
    OTHER,        /* 0xd50c */
    OTHER,        /* 0xd50d */
    OTHER,        /* 0xd50e */
    OTHER,        /* 0xd50f */
    OTHER,        /* 0xd510 */
    OTHER,        /* 0xd511 */
    OTHER,        /* 0xd512 */
    OTHER,        /* 0xd513 */
    OTHER,        /* 0xd514 */
    OTHER,        /* 0xd515 */
    OTHER,        /* 0xd516 */
    OTHER,        /* 0xd517 */
    OTHER,        /* 0xd518 */
    OTHER,        /* 0xd519 */
    OTHER,        /* 0xd51a */
    OTHER,        /* 0xd51b */
    OTHER,        /* 0xd51c */
    OTHER,        /* 0xd51d */
    OTHER,        /* 0xd51e */
    OTHER,        /* 0xd51f */
    OTHER,        /* 0xd520 */
    OTHER,        /* 0xd521 */
    OTHER,        /* 0xd522 */
    OTHER,        /* 0xd523 */
    OTHER,        /* 0xd524 */
    OTHER,        /* 0xd525 */
    OTHER,        /* 0xd526 */
    OTHER,        /* 0xd527 */
    OTHER,        /* 0xd528 */
    OTHER,        /* 0xd529 */
    OTHER,        /* 0xd52a */
    OTHER,        /* 0xd52b */
    OTHER,        /* 0xd52c */
    OTHER,        /* 0xd52d */
    OTHER,        /* 0xd52e */
    OTHER,        /* 0xd52f */
    OTHER,        /* 0xd530 */
    OTHER,        /* 0xd531 */
    OTHER,        /* 0xd532 */
    OTHER,        /* 0xd533 */
    OTHER,        /* 0xd534 */
    OTHER,        /* 0xd535 */
    OTHER,        /* 0xd536 */
    OTHER,        /* 0xd537 */
    OTHER,        /* 0xd538 */
    OTHER,        /* 0xd539 */
    OTHER,        /* 0xd53a */
    OTHER,        /* 0xd53b */
    OTHER,        /* 0xd53c */
    OTHER,        /* 0xd53d */
    OTHER,        /* 0xd53e */
    OTHER,        /* 0xd53f */
    OTHER,        /* 0xd540 */
    OTHER,        /* 0xd541 */
    OTHER,        /* 0xd542 */
    OTHER,        /* 0xd543 */
    OTHER,        /* 0xd544 */
    OTHER,        /* 0xd545 */
    OTHER,        /* 0xd546 */
    OTHER,        /* 0xd547 */
    OTHER,        /* 0xd548 */
    OTHER,        /* 0xd549 */
    OTHER,        /* 0xd54a */
    OTHER,        /* 0xd54b */
    OTHER,        /* 0xd54c */
    OTHER,        /* 0xd54d */
    OTHER,        /* 0xd54e */
    OTHER,        /* 0xd54f */
    OTHER,        /* 0xd550 */
    OTHER,        /* 0xd551 */
    OTHER,        /* 0xd552 */
    OTHER,        /* 0xd553 */
    OTHER,        /* 0xd554 */
    OTHER,        /* 0xd555 */
    OTHER,        /* 0xd556 */
    OTHER,        /* 0xd557 */
    OTHER,        /* 0xd558 */
    OTHER,        /* 0xd559 */
    OTHER,        /* 0xd55a */
    OTHER,        /* 0xd55b */
    OTHER,        /* 0xd55c */
    OTHER,        /* 0xd55d */
    OTHER,        /* 0xd55e */
    OTHER,        /* 0xd55f */
    OTHER,        /* 0xd560 */
    OTHER,        /* 0xd561 */
    OTHER,        /* 0xd562 */
    OTHER,        /* 0xd563 */
    OTHER,        /* 0xd564 */
    OTHER,        /* 0xd565 */
    OTHER,        /* 0xd566 */
    OTHER,        /* 0xd567 */
    OTHER,        /* 0xd568 */
    OTHER,        /* 0xd569 */
    OTHER,        /* 0xd56a */
    OTHER,        /* 0xd56b */
    OTHER,        /* 0xd56c */
    OTHER,        /* 0xd56d */
    OTHER,        /* 0xd56e */
    OTHER,        /* 0xd56f */
    OTHER,        /* 0xd570 */
    OTHER,        /* 0xd571 */
    OTHER,        /* 0xd572 */
    OTHER,        /* 0xd573 */
    OTHER,        /* 0xd574 */
    OTHER,        /* 0xd575 */
    OTHER,        /* 0xd576 */
    OTHER,        /* 0xd577 */
    OTHER,        /* 0xd578 */
    OTHER,        /* 0xd579 */
    OTHER,        /* 0xd57a */
    OTHER,        /* 0xd57b */
    OTHER,        /* 0xd57c */
    OTHER,        /* 0xd57d */
    OTHER,        /* 0xd57e */
    OTHER,        /* 0xd57f */
    OTHER,        /* 0xd580 */
    OTHER,        /* 0xd581 */
    OTHER,        /* 0xd582 */
    OTHER,        /* 0xd583 */
    OTHER,        /* 0xd584 */
    OTHER,        /* 0xd585 */
    OTHER,        /* 0xd586 */
    OTHER,        /* 0xd587 */
    OTHER,        /* 0xd588 */
    OTHER,        /* 0xd589 */
    OTHER,        /* 0xd58a */
    OTHER,        /* 0xd58b */
    OTHER,        /* 0xd58c */
    OTHER,        /* 0xd58d */
    OTHER,        /* 0xd58e */
    OTHER,        /* 0xd58f */
    OTHER,        /* 0xd590 */
    OTHER,        /* 0xd591 */
    OTHER,        /* 0xd592 */
    OTHER,        /* 0xd593 */
    OTHER,        /* 0xd594 */
    OTHER,        /* 0xd595 */
    OTHER,        /* 0xd596 */
    OTHER,        /* 0xd597 */
    OTHER,        /* 0xd598 */
    OTHER,        /* 0xd599 */
    OTHER,        /* 0xd59a */
    OTHER,        /* 0xd59b */
    OTHER,        /* 0xd59c */
    OTHER,        /* 0xd59d */
    OTHER,        /* 0xd59e */
    OTHER,        /* 0xd59f */
    OTHER,        /* 0xd5a0 */
    OTHER,        /* 0xd5a1 */
    OTHER,        /* 0xd5a2 */
    OTHER,        /* 0xd5a3 */
    OTHER,        /* 0xd5a4 */
    OTHER,        /* 0xd5a5 */
    OTHER,        /* 0xd5a6 */
    OTHER,        /* 0xd5a7 */
    OTHER,        /* 0xd5a8 */
    OTHER,        /* 0xd5a9 */
    OTHER,        /* 0xd5aa */
    OTHER,        /* 0xd5ab */
    OTHER,        /* 0xd5ac */
    OTHER,        /* 0xd5ad */
    OTHER,        /* 0xd5ae */
    OTHER,        /* 0xd5af */
    OTHER,        /* 0xd5b0 */
    OTHER,        /* 0xd5b1 */
    OTHER,        /* 0xd5b2 */
    OTHER,        /* 0xd5b3 */
    OTHER,        /* 0xd5b4 */
    OTHER,        /* 0xd5b5 */
    OTHER,        /* 0xd5b6 */
    OTHER,        /* 0xd5b7 */
    OTHER,        /* 0xd5b8 */
    OTHER,        /* 0xd5b9 */
    OTHER,        /* 0xd5ba */
    OTHER,        /* 0xd5bb */
    OTHER,        /* 0xd5bc */
    OTHER,        /* 0xd5bd */
    OTHER,        /* 0xd5be */
    OTHER,        /* 0xd5bf */
    OTHER,        /* 0xd5c0 */
    OTHER,        /* 0xd5c1 */
    OTHER,        /* 0xd5c2 */
    OTHER,        /* 0xd5c3 */
    OTHER,        /* 0xd5c4 */
    OTHER,        /* 0xd5c5 */
    OTHER,        /* 0xd5c6 */
    OTHER,        /* 0xd5c7 */
    OTHER,        /* 0xd5c8 */
    OTHER,        /* 0xd5c9 */
    OTHER,        /* 0xd5ca */
    OTHER,        /* 0xd5cb */
    OTHER,        /* 0xd5cc */
    OTHER,        /* 0xd5cd */
    OTHER,        /* 0xd5ce */
    OTHER,        /* 0xd5cf */
    OTHER,        /* 0xd5d0 */
    OTHER,        /* 0xd5d1 */
    OTHER,        /* 0xd5d2 */
    OTHER,        /* 0xd5d3 */
    OTHER,        /* 0xd5d4 */
    OTHER,        /* 0xd5d5 */
    OTHER,        /* 0xd5d6 */
    OTHER,        /* 0xd5d7 */
    OTHER,        /* 0xd5d8 */
    OTHER,        /* 0xd5d9 */
    OTHER,        /* 0xd5da */
    OTHER,        /* 0xd5db */
    OTHER,        /* 0xd5dc */
    OTHER,        /* 0xd5dd */
    OTHER,        /* 0xd5de */
    OTHER,        /* 0xd5df */
    OTHER,        /* 0xd5e0 */
    OTHER,        /* 0xd5e1 */
    OTHER,        /* 0xd5e2 */
    OTHER,        /* 0xd5e3 */
    OTHER,        /* 0xd5e4 */
    OTHER,        /* 0xd5e5 */
    OTHER,        /* 0xd5e6 */
    OTHER,        /* 0xd5e7 */
    OTHER,        /* 0xd5e8 */
    OTHER,        /* 0xd5e9 */
    OTHER,        /* 0xd5ea */
    OTHER,        /* 0xd5eb */
    OTHER,        /* 0xd5ec */
    OTHER,        /* 0xd5ed */
    OTHER,        /* 0xd5ee */
    OTHER,        /* 0xd5ef */
    OTHER,        /* 0xd5f0 */
    OTHER,        /* 0xd5f1 */
    OTHER,        /* 0xd5f2 */
    OTHER,        /* 0xd5f3 */
    OTHER,        /* 0xd5f4 */
    OTHER,        /* 0xd5f5 */
    OTHER,        /* 0xd5f6 */
    OTHER,        /* 0xd5f7 */
    OTHER,        /* 0xd5f8 */
    OTHER,        /* 0xd5f9 */
    OTHER,        /* 0xd5fa */
    OTHER,        /* 0xd5fb */
    OTHER,        /* 0xd5fc */
    OTHER,        /* 0xd5fd */
    OTHER,        /* 0xd5fe */
    OTHER,        /* 0xd5ff */
    OTHER,        /* 0xd600 */
    OTHER,        /* 0xd601 */
    OTHER,        /* 0xd602 */
    OTHER,        /* 0xd603 */
    OTHER,        /* 0xd604 */
    OTHER,        /* 0xd605 */
    OTHER,        /* 0xd606 */
    OTHER,        /* 0xd607 */
    OTHER,        /* 0xd608 */
    OTHER,        /* 0xd609 */
    OTHER,        /* 0xd60a */
    OTHER,        /* 0xd60b */
    OTHER,        /* 0xd60c */
    OTHER,        /* 0xd60d */
    OTHER,        /* 0xd60e */
    OTHER,        /* 0xd60f */
    OTHER,        /* 0xd610 */
    OTHER,        /* 0xd611 */
    OTHER,        /* 0xd612 */
    OTHER,        /* 0xd613 */
    OTHER,        /* 0xd614 */
    OTHER,        /* 0xd615 */
    OTHER,        /* 0xd616 */
    OTHER,        /* 0xd617 */
    OTHER,        /* 0xd618 */
    OTHER,        /* 0xd619 */
    OTHER,        /* 0xd61a */
    OTHER,        /* 0xd61b */
    OTHER,        /* 0xd61c */
    OTHER,        /* 0xd61d */
    OTHER,        /* 0xd61e */
    OTHER,        /* 0xd61f */
    OTHER,        /* 0xd620 */
    OTHER,        /* 0xd621 */
    OTHER,        /* 0xd622 */
    OTHER,        /* 0xd623 */
    OTHER,        /* 0xd624 */
    OTHER,        /* 0xd625 */
    OTHER,        /* 0xd626 */
    OTHER,        /* 0xd627 */
    OTHER,        /* 0xd628 */
    OTHER,        /* 0xd629 */
    OTHER,        /* 0xd62a */
    OTHER,        /* 0xd62b */
    OTHER,        /* 0xd62c */
    OTHER,        /* 0xd62d */
    OTHER,        /* 0xd62e */
    OTHER,        /* 0xd62f */
    OTHER,        /* 0xd630 */
    OTHER,        /* 0xd631 */
    OTHER,        /* 0xd632 */
    OTHER,        /* 0xd633 */
    OTHER,        /* 0xd634 */
    OTHER,        /* 0xd635 */
    OTHER,        /* 0xd636 */
    OTHER,        /* 0xd637 */
    OTHER,        /* 0xd638 */
    OTHER,        /* 0xd639 */
    OTHER,        /* 0xd63a */
    OTHER,        /* 0xd63b */
    OTHER,        /* 0xd63c */
    OTHER,        /* 0xd63d */
    OTHER,        /* 0xd63e */
    OTHER,        /* 0xd63f */
    OTHER,        /* 0xd640 */
    OTHER,        /* 0xd641 */
    OTHER,        /* 0xd642 */
    OTHER,        /* 0xd643 */
    OTHER,        /* 0xd644 */
    OTHER,        /* 0xd645 */
    OTHER,        /* 0xd646 */
    OTHER,        /* 0xd647 */
    OTHER,        /* 0xd648 */
    OTHER,        /* 0xd649 */
    OTHER,        /* 0xd64a */
    OTHER,        /* 0xd64b */
    OTHER,        /* 0xd64c */
    OTHER,        /* 0xd64d */
    OTHER,        /* 0xd64e */
    OTHER,        /* 0xd64f */
    OTHER,        /* 0xd650 */
    OTHER,        /* 0xd651 */
    OTHER,        /* 0xd652 */
    OTHER,        /* 0xd653 */
    OTHER,        /* 0xd654 */
    OTHER,        /* 0xd655 */
    OTHER,        /* 0xd656 */
    OTHER,        /* 0xd657 */
    OTHER,        /* 0xd658 */
    OTHER,        /* 0xd659 */
    OTHER,        /* 0xd65a */
    OTHER,        /* 0xd65b */
    OTHER,        /* 0xd65c */
    OTHER,        /* 0xd65d */
    OTHER,        /* 0xd65e */
    OTHER,        /* 0xd65f */
    OTHER,        /* 0xd660 */
    OTHER,        /* 0xd661 */
    OTHER,        /* 0xd662 */
    OTHER,        /* 0xd663 */
    OTHER,        /* 0xd664 */
    OTHER,        /* 0xd665 */
    OTHER,        /* 0xd666 */
    OTHER,        /* 0xd667 */
    OTHER,        /* 0xd668 */
    OTHER,        /* 0xd669 */
    OTHER,        /* 0xd66a */
    OTHER,        /* 0xd66b */
    OTHER,        /* 0xd66c */
    OTHER,        /* 0xd66d */
    OTHER,        /* 0xd66e */
    OTHER,        /* 0xd66f */
    OTHER,        /* 0xd670 */
    OTHER,        /* 0xd671 */
    OTHER,        /* 0xd672 */
    OTHER,        /* 0xd673 */
    OTHER,        /* 0xd674 */
    OTHER,        /* 0xd675 */
    OTHER,        /* 0xd676 */
    OTHER,        /* 0xd677 */
    OTHER,        /* 0xd678 */
    OTHER,        /* 0xd679 */
    OTHER,        /* 0xd67a */
    OTHER,        /* 0xd67b */
    OTHER,        /* 0xd67c */
    OTHER,        /* 0xd67d */
    OTHER,        /* 0xd67e */
    OTHER,        /* 0xd67f */
    OTHER,        /* 0xd680 */
    OTHER,        /* 0xd681 */
    OTHER,        /* 0xd682 */
    OTHER,        /* 0xd683 */
    OTHER,        /* 0xd684 */
    OTHER,        /* 0xd685 */
    OTHER,        /* 0xd686 */
    OTHER,        /* 0xd687 */
    OTHER,        /* 0xd688 */
    OTHER,        /* 0xd689 */
    OTHER,        /* 0xd68a */
    OTHER,        /* 0xd68b */
    OTHER,        /* 0xd68c */
    OTHER,        /* 0xd68d */
    OTHER,        /* 0xd68e */
    OTHER,        /* 0xd68f */
    OTHER,        /* 0xd690 */
    OTHER,        /* 0xd691 */
    OTHER,        /* 0xd692 */
    OTHER,        /* 0xd693 */
    OTHER,        /* 0xd694 */
    OTHER,        /* 0xd695 */
    OTHER,        /* 0xd696 */
    OTHER,        /* 0xd697 */
    OTHER,        /* 0xd698 */
    OTHER,        /* 0xd699 */
    OTHER,        /* 0xd69a */
    OTHER,        /* 0xd69b */
    OTHER,        /* 0xd69c */
    OTHER,        /* 0xd69d */
    OTHER,        /* 0xd69e */
    OTHER,        /* 0xd69f */
    OTHER,        /* 0xd6a0 */
    OTHER,        /* 0xd6a1 */
    OTHER,        /* 0xd6a2 */
    OTHER,        /* 0xd6a3 */
    OTHER,        /* 0xd6a4 */
    OTHER,        /* 0xd6a5 */
    OTHER,        /* 0xd6a6 */
    OTHER,        /* 0xd6a7 */
    OTHER,        /* 0xd6a8 */
    OTHER,        /* 0xd6a9 */
    OTHER,        /* 0xd6aa */
    OTHER,        /* 0xd6ab */
    OTHER,        /* 0xd6ac */
    OTHER,        /* 0xd6ad */
    OTHER,        /* 0xd6ae */
    OTHER,        /* 0xd6af */
    OTHER,        /* 0xd6b0 */
    OTHER,        /* 0xd6b1 */
    OTHER,        /* 0xd6b2 */
    OTHER,        /* 0xd6b3 */
    OTHER,        /* 0xd6b4 */
    OTHER,        /* 0xd6b5 */
    OTHER,        /* 0xd6b6 */
    OTHER,        /* 0xd6b7 */
    OTHER,        /* 0xd6b8 */
    OTHER,        /* 0xd6b9 */
    OTHER,        /* 0xd6ba */
    OTHER,        /* 0xd6bb */
    OTHER,        /* 0xd6bc */
    OTHER,        /* 0xd6bd */
    OTHER,        /* 0xd6be */
    OTHER,        /* 0xd6bf */
    OTHER,        /* 0xd6c0 */
    OTHER,        /* 0xd6c1 */
    OTHER,        /* 0xd6c2 */
    OTHER,        /* 0xd6c3 */
    OTHER,        /* 0xd6c4 */
    OTHER,        /* 0xd6c5 */
    OTHER,        /* 0xd6c6 */
    OTHER,        /* 0xd6c7 */
    OTHER,        /* 0xd6c8 */
    OTHER,        /* 0xd6c9 */
    OTHER,        /* 0xd6ca */
    OTHER,        /* 0xd6cb */
    OTHER,        /* 0xd6cc */
    OTHER,        /* 0xd6cd */
    OTHER,        /* 0xd6ce */
    OTHER,        /* 0xd6cf */
    OTHER,        /* 0xd6d0 */
    OTHER,        /* 0xd6d1 */
    OTHER,        /* 0xd6d2 */
    OTHER,        /* 0xd6d3 */
    OTHER,        /* 0xd6d4 */
    OTHER,        /* 0xd6d5 */
    OTHER,        /* 0xd6d6 */
    OTHER,        /* 0xd6d7 */
    OTHER,        /* 0xd6d8 */
    OTHER,        /* 0xd6d9 */
    OTHER,        /* 0xd6da */
    OTHER,        /* 0xd6db */
    OTHER,        /* 0xd6dc */
    OTHER,        /* 0xd6dd */
    OTHER,        /* 0xd6de */
    OTHER,        /* 0xd6df */
    OTHER,        /* 0xd6e0 */
    OTHER,        /* 0xd6e1 */
    OTHER,        /* 0xd6e2 */
    OTHER,        /* 0xd6e3 */
    OTHER,        /* 0xd6e4 */
    OTHER,        /* 0xd6e5 */
    OTHER,        /* 0xd6e6 */
    OTHER,        /* 0xd6e7 */
    OTHER,        /* 0xd6e8 */
    OTHER,        /* 0xd6e9 */
    OTHER,        /* 0xd6ea */
    OTHER,        /* 0xd6eb */
    OTHER,        /* 0xd6ec */
    OTHER,        /* 0xd6ed */
    OTHER,        /* 0xd6ee */
    OTHER,        /* 0xd6ef */
    OTHER,        /* 0xd6f0 */
    OTHER,        /* 0xd6f1 */
    OTHER,        /* 0xd6f2 */
    OTHER,        /* 0xd6f3 */
    OTHER,        /* 0xd6f4 */
    OTHER,        /* 0xd6f5 */
    OTHER,        /* 0xd6f6 */
    OTHER,        /* 0xd6f7 */
    OTHER,        /* 0xd6f8 */
    OTHER,        /* 0xd6f9 */
    OTHER,        /* 0xd6fa */
    OTHER,        /* 0xd6fb */
    OTHER,        /* 0xd6fc */
    OTHER,        /* 0xd6fd */
    OTHER,        /* 0xd6fe */
    OTHER,        /* 0xd6ff */
    OTHER,        /* 0xd700 */
    OTHER,        /* 0xd701 */
    OTHER,        /* 0xd702 */
    OTHER,        /* 0xd703 */
    OTHER,        /* 0xd704 */
    OTHER,        /* 0xd705 */
    OTHER,        /* 0xd706 */
    OTHER,        /* 0xd707 */
    OTHER,        /* 0xd708 */
    OTHER,        /* 0xd709 */
    OTHER,        /* 0xd70a */
    OTHER,        /* 0xd70b */
    OTHER,        /* 0xd70c */
    OTHER,        /* 0xd70d */
    OTHER,        /* 0xd70e */
    OTHER,        /* 0xd70f */
    OTHER,        /* 0xd710 */
    OTHER,        /* 0xd711 */
    OTHER,        /* 0xd712 */
    OTHER,        /* 0xd713 */
    OTHER,        /* 0xd714 */
    OTHER,        /* 0xd715 */
    OTHER,        /* 0xd716 */
    OTHER,        /* 0xd717 */
    OTHER,        /* 0xd718 */
    OTHER,        /* 0xd719 */
    OTHER,        /* 0xd71a */
    OTHER,        /* 0xd71b */
    OTHER,        /* 0xd71c */
    OTHER,        /* 0xd71d */
    OTHER,        /* 0xd71e */
    OTHER,        /* 0xd71f */
    OTHER,        /* 0xd720 */
    OTHER,        /* 0xd721 */
    OTHER,        /* 0xd722 */
    OTHER,        /* 0xd723 */
    OTHER,        /* 0xd724 */
    OTHER,        /* 0xd725 */
    OTHER,        /* 0xd726 */
    OTHER,        /* 0xd727 */
    OTHER,        /* 0xd728 */
    OTHER,        /* 0xd729 */
    OTHER,        /* 0xd72a */
    OTHER,        /* 0xd72b */
    OTHER,        /* 0xd72c */
    OTHER,        /* 0xd72d */
    OTHER,        /* 0xd72e */
    OTHER,        /* 0xd72f */
    OTHER,        /* 0xd730 */
    OTHER,        /* 0xd731 */
    OTHER,        /* 0xd732 */
    OTHER,        /* 0xd733 */
    OTHER,        /* 0xd734 */
    OTHER,        /* 0xd735 */
    OTHER,        /* 0xd736 */
    OTHER,        /* 0xd737 */
    OTHER,        /* 0xd738 */
    OTHER,        /* 0xd739 */
    OTHER,        /* 0xd73a */
    OTHER,        /* 0xd73b */
    OTHER,        /* 0xd73c */
    OTHER,        /* 0xd73d */
    OTHER,        /* 0xd73e */
    OTHER,        /* 0xd73f */
    OTHER,        /* 0xd740 */
    OTHER,        /* 0xd741 */
    OTHER,        /* 0xd742 */
    OTHER,        /* 0xd743 */
    OTHER,        /* 0xd744 */
    OTHER,        /* 0xd745 */
    OTHER,        /* 0xd746 */
    OTHER,        /* 0xd747 */
    OTHER,        /* 0xd748 */
    OTHER,        /* 0xd749 */
    OTHER,        /* 0xd74a */
    OTHER,        /* 0xd74b */
    OTHER,        /* 0xd74c */
    OTHER,        /* 0xd74d */
    OTHER,        /* 0xd74e */
    OTHER,        /* 0xd74f */
    OTHER,        /* 0xd750 */
    OTHER,        /* 0xd751 */
    OTHER,        /* 0xd752 */
    OTHER,        /* 0xd753 */
    OTHER,        /* 0xd754 */
    OTHER,        /* 0xd755 */
    OTHER,        /* 0xd756 */
    OTHER,        /* 0xd757 */
    OTHER,        /* 0xd758 */
    OTHER,        /* 0xd759 */
    OTHER,        /* 0xd75a */
    OTHER,        /* 0xd75b */
    OTHER,        /* 0xd75c */
    OTHER,        /* 0xd75d */
    OTHER,        /* 0xd75e */
    OTHER,        /* 0xd75f */
    OTHER,        /* 0xd760 */
    OTHER,        /* 0xd761 */
    OTHER,        /* 0xd762 */
    OTHER,        /* 0xd763 */
    OTHER,        /* 0xd764 */
    OTHER,        /* 0xd765 */
    OTHER,        /* 0xd766 */
    OTHER,        /* 0xd767 */
    OTHER,        /* 0xd768 */
    OTHER,        /* 0xd769 */
    OTHER,        /* 0xd76a */
    OTHER,        /* 0xd76b */
    OTHER,        /* 0xd76c */
    OTHER,        /* 0xd76d */
    OTHER,        /* 0xd76e */
    OTHER,        /* 0xd76f */
    OTHER,        /* 0xd770 */
    OTHER,        /* 0xd771 */
    OTHER,        /* 0xd772 */
    OTHER,        /* 0xd773 */
    OTHER,        /* 0xd774 */
    OTHER,        /* 0xd775 */
    OTHER,        /* 0xd776 */
    OTHER,        /* 0xd777 */
    OTHER,        /* 0xd778 */
    OTHER,        /* 0xd779 */
    OTHER,        /* 0xd77a */
    OTHER,        /* 0xd77b */
    OTHER,        /* 0xd77c */
    OTHER,        /* 0xd77d */
    OTHER,        /* 0xd77e */
    OTHER,        /* 0xd77f */
    OTHER,        /* 0xd780 */
    OTHER,        /* 0xd781 */
    OTHER,        /* 0xd782 */
    OTHER,        /* 0xd783 */
    OTHER,        /* 0xd784 */
    OTHER,        /* 0xd785 */
    OTHER,        /* 0xd786 */
    OTHER,        /* 0xd787 */
    OTHER,        /* 0xd788 */
    OTHER,        /* 0xd789 */
    OTHER,        /* 0xd78a */
    OTHER,        /* 0xd78b */
    OTHER,        /* 0xd78c */
    OTHER,        /* 0xd78d */
    OTHER,        /* 0xd78e */
    OTHER,        /* 0xd78f */
    OTHER,        /* 0xd790 */
    OTHER,        /* 0xd791 */
    OTHER,        /* 0xd792 */
    OTHER,        /* 0xd793 */
    OTHER,        /* 0xd794 */
    OTHER,        /* 0xd795 */
    OTHER,        /* 0xd796 */
    OTHER,        /* 0xd797 */
    OTHER,        /* 0xd798 */
    OTHER,        /* 0xd799 */
    OTHER,        /* 0xd79a */
    OTHER,        /* 0xd79b */
    OTHER,        /* 0xd79c */
    OTHER,        /* 0xd79d */
    OTHER,        /* 0xd79e */
    OTHER,        /* 0xd79f */
    OTHER,        /* 0xd7a0 */
    OTHER,        /* 0xd7a1 */
    OTHER,        /* 0xd7a2 */
    OTHER,        /* 0xd7a3 */
    OTHER,        /* 0xd7a4 */
    OTHER,        /* 0xd7a5 */
    OTHER,        /* 0xd7a6 */
    OTHER,        /* 0xd7a7 */
    OTHER,        /* 0xd7a8 */
    OTHER,        /* 0xd7a9 */
    OTHER,        /* 0xd7aa */
    OTHER,        /* 0xd7ab */
    OTHER,        /* 0xd7ac */
    OTHER,        /* 0xd7ad */
    OTHER,        /* 0xd7ae */
    OTHER,        /* 0xd7af */
    OTHER,        /* 0xd7b0 */
    OTHER,        /* 0xd7b1 */
    OTHER,        /* 0xd7b2 */
    OTHER,        /* 0xd7b3 */
    OTHER,        /* 0xd7b4 */
    OTHER,        /* 0xd7b5 */
    OTHER,        /* 0xd7b6 */
    OTHER,        /* 0xd7b7 */
    OTHER,        /* 0xd7b8 */
    OTHER,        /* 0xd7b9 */
    OTHER,        /* 0xd7ba */
    OTHER,        /* 0xd7bb */
    OTHER,        /* 0xd7bc */
    OTHER,        /* 0xd7bd */
    OTHER,        /* 0xd7be */
    OTHER,        /* 0xd7bf */
    OTHER,        /* 0xd7c0 */
    OTHER,        /* 0xd7c1 */
    OTHER,        /* 0xd7c2 */
    OTHER,        /* 0xd7c3 */
    OTHER,        /* 0xd7c4 */
    OTHER,        /* 0xd7c5 */
    OTHER,        /* 0xd7c6 */
    OTHER,        /* 0xd7c7 */
    OTHER,        /* 0xd7c8 */
    OTHER,        /* 0xd7c9 */
    OTHER,        /* 0xd7ca */
    OTHER,        /* 0xd7cb */
    OTHER,        /* 0xd7cc */
    OTHER,        /* 0xd7cd */
    OTHER,        /* 0xd7ce */
    OTHER,        /* 0xd7cf */
    OTHER,        /* 0xd7d0 */
    OTHER,        /* 0xd7d1 */
    OTHER,        /* 0xd7d2 */
    OTHER,        /* 0xd7d3 */
    OTHER,        /* 0xd7d4 */
    OTHER,        /* 0xd7d5 */
    OTHER,        /* 0xd7d6 */
    OTHER,        /* 0xd7d7 */
    OTHER,        /* 0xd7d8 */
    OTHER,        /* 0xd7d9 */
    OTHER,        /* 0xd7da */
    OTHER,        /* 0xd7db */
    OTHER,        /* 0xd7dc */
    OTHER,        /* 0xd7dd */
    OTHER,        /* 0xd7de */
    OTHER,        /* 0xd7df */
    OTHER,        /* 0xd7e0 */
    OTHER,        /* 0xd7e1 */
    OTHER,        /* 0xd7e2 */
    OTHER,        /* 0xd7e3 */
    OTHER,        /* 0xd7e4 */
    OTHER,        /* 0xd7e5 */
    OTHER,        /* 0xd7e6 */
    OTHER,        /* 0xd7e7 */
    OTHER,        /* 0xd7e8 */
    OTHER,        /* 0xd7e9 */
    OTHER,        /* 0xd7ea */
    OTHER,        /* 0xd7eb */
    OTHER,        /* 0xd7ec */
    OTHER,        /* 0xd7ed */
    OTHER,        /* 0xd7ee */
    OTHER,        /* 0xd7ef */
    OTHER,        /* 0xd7f0 */
    OTHER,        /* 0xd7f1 */
    OTHER,        /* 0xd7f2 */
    OTHER,        /* 0xd7f3 */
    OTHER,        /* 0xd7f4 */
    OTHER,        /* 0xd7f5 */
    OTHER,        /* 0xd7f6 */
    OTHER,        /* 0xd7f7 */
    OTHER,        /* 0xd7f8 */
    OTHER,        /* 0xd7f9 */
    OTHER,        /* 0xd7fa */
    OTHER,        /* 0xd7fb */
    OTHER,        /* 0xd7fc */
    OTHER,        /* 0xd7fd */
    OTHER,        /* 0xd7fe */
    OTHER,        /* 0xd7ff */
    OTHER,        /* 0xd800 */
    OTHER,        /* 0xd801 */
    OTHER,        /* 0xd802 */
    OTHER,        /* 0xd803 */
    OTHER,        /* 0xd804 */
    OTHER,        /* 0xd805 */
    OTHER,        /* 0xd806 */
    OTHER,        /* 0xd807 */
    OTHER,        /* 0xd808 */
    OTHER,        /* 0xd809 */
    OTHER,        /* 0xd80a */
    OTHER,        /* 0xd80b */
    OTHER,        /* 0xd80c */
    OTHER,        /* 0xd80d */
    OTHER,        /* 0xd80e */
    OTHER,        /* 0xd80f */
    OTHER,        /* 0xd810 */
    OTHER,        /* 0xd811 */
    OTHER,        /* 0xd812 */
    OTHER,        /* 0xd813 */
    OTHER,        /* 0xd814 */
    OTHER,        /* 0xd815 */
    OTHER,        /* 0xd816 */
    OTHER,        /* 0xd817 */
    OTHER,        /* 0xd818 */
    OTHER,        /* 0xd819 */
    OTHER,        /* 0xd81a */
    OTHER,        /* 0xd81b */
    OTHER,        /* 0xd81c */
    OTHER,        /* 0xd81d */
    OTHER,        /* 0xd81e */
    OTHER,        /* 0xd81f */
    OTHER,        /* 0xd820 */
    OTHER,        /* 0xd821 */
    OTHER,        /* 0xd822 */
    OTHER,        /* 0xd823 */
    OTHER,        /* 0xd824 */
    OTHER,        /* 0xd825 */
    OTHER,        /* 0xd826 */
    OTHER,        /* 0xd827 */
    OTHER,        /* 0xd828 */
    OTHER,        /* 0xd829 */
    OTHER,        /* 0xd82a */
    OTHER,        /* 0xd82b */
    OTHER,        /* 0xd82c */
    OTHER,        /* 0xd82d */
    OTHER,        /* 0xd82e */
    OTHER,        /* 0xd82f */
    OTHER,        /* 0xd830 */
    OTHER,        /* 0xd831 */
    OTHER,        /* 0xd832 */
    OTHER,        /* 0xd833 */
    OTHER,        /* 0xd834 */
    OTHER,        /* 0xd835 */
    OTHER,        /* 0xd836 */
    OTHER,        /* 0xd837 */
    OTHER,        /* 0xd838 */
    OTHER,        /* 0xd839 */
    OTHER,        /* 0xd83a */
    OTHER,        /* 0xd83b */
    OTHER,        /* 0xd83c */
    OTHER,        /* 0xd83d */
    OTHER,        /* 0xd83e */
    OTHER,        /* 0xd83f */
    OTHER,        /* 0xd840 */
    OTHER,        /* 0xd841 */
    OTHER,        /* 0xd842 */
    OTHER,        /* 0xd843 */
    OTHER,        /* 0xd844 */
    OTHER,        /* 0xd845 */
    OTHER,        /* 0xd846 */
    OTHER,        /* 0xd847 */
    OTHER,        /* 0xd848 */
    OTHER,        /* 0xd849 */
    OTHER,        /* 0xd84a */
    OTHER,        /* 0xd84b */
    OTHER,        /* 0xd84c */
    OTHER,        /* 0xd84d */
    OTHER,        /* 0xd84e */
    OTHER,        /* 0xd84f */
    OTHER,        /* 0xd850 */
    OTHER,        /* 0xd851 */
    OTHER,        /* 0xd852 */
    OTHER,        /* 0xd853 */
    OTHER,        /* 0xd854 */
    OTHER,        /* 0xd855 */
    OTHER,        /* 0xd856 */
    OTHER,        /* 0xd857 */
    OTHER,        /* 0xd858 */
    OTHER,        /* 0xd859 */
    OTHER,        /* 0xd85a */
    OTHER,        /* 0xd85b */
    OTHER,        /* 0xd85c */
    OTHER,        /* 0xd85d */
    OTHER,        /* 0xd85e */
    OTHER,        /* 0xd85f */
    OTHER,        /* 0xd860 */
    OTHER,        /* 0xd861 */
    OTHER,        /* 0xd862 */
    OTHER,        /* 0xd863 */
    OTHER,        /* 0xd864 */
    OTHER,        /* 0xd865 */
    OTHER,        /* 0xd866 */
    OTHER,        /* 0xd867 */
    OTHER,        /* 0xd868 */
    OTHER,        /* 0xd869 */
    OTHER,        /* 0xd86a */
    OTHER,        /* 0xd86b */
    OTHER,        /* 0xd86c */
    OTHER,        /* 0xd86d */
    OTHER,        /* 0xd86e */
    OTHER,        /* 0xd86f */
    OTHER,        /* 0xd870 */
    OTHER,        /* 0xd871 */
    OTHER,        /* 0xd872 */
    OTHER,        /* 0xd873 */
    OTHER,        /* 0xd874 */
    OTHER,        /* 0xd875 */
    OTHER,        /* 0xd876 */
    OTHER,        /* 0xd877 */
    OTHER,        /* 0xd878 */
    OTHER,        /* 0xd879 */
    OTHER,        /* 0xd87a */
    OTHER,        /* 0xd87b */
    OTHER,        /* 0xd87c */
    OTHER,        /* 0xd87d */
    OTHER,        /* 0xd87e */
    OTHER,        /* 0xd87f */
    OTHER,        /* 0xd880 */
    OTHER,        /* 0xd881 */
    OTHER,        /* 0xd882 */
    OTHER,        /* 0xd883 */
    OTHER,        /* 0xd884 */
    OTHER,        /* 0xd885 */
    OTHER,        /* 0xd886 */
    OTHER,        /* 0xd887 */
    OTHER,        /* 0xd888 */
    OTHER,        /* 0xd889 */
    OTHER,        /* 0xd88a */
    OTHER,        /* 0xd88b */
    OTHER,        /* 0xd88c */
    OTHER,        /* 0xd88d */
    OTHER,        /* 0xd88e */
    OTHER,        /* 0xd88f */
    OTHER,        /* 0xd890 */
    OTHER,        /* 0xd891 */
    OTHER,        /* 0xd892 */
    OTHER,        /* 0xd893 */
    OTHER,        /* 0xd894 */
    OTHER,        /* 0xd895 */
    OTHER,        /* 0xd896 */
    OTHER,        /* 0xd897 */
    OTHER,        /* 0xd898 */
    OTHER,        /* 0xd899 */
    OTHER,        /* 0xd89a */
    OTHER,        /* 0xd89b */
    OTHER,        /* 0xd89c */
    OTHER,        /* 0xd89d */
    OTHER,        /* 0xd89e */
    OTHER,        /* 0xd89f */
    OTHER,        /* 0xd8a0 */
    OTHER,        /* 0xd8a1 */
    OTHER,        /* 0xd8a2 */
    OTHER,        /* 0xd8a3 */
    OTHER,        /* 0xd8a4 */
    OTHER,        /* 0xd8a5 */
    OTHER,        /* 0xd8a6 */
    OTHER,        /* 0xd8a7 */
    OTHER,        /* 0xd8a8 */
    OTHER,        /* 0xd8a9 */
    OTHER,        /* 0xd8aa */
    OTHER,        /* 0xd8ab */
    OTHER,        /* 0xd8ac */
    OTHER,        /* 0xd8ad */
    OTHER,        /* 0xd8ae */
    OTHER,        /* 0xd8af */
    OTHER,        /* 0xd8b0 */
    OTHER,        /* 0xd8b1 */
    OTHER,        /* 0xd8b2 */
    OTHER,        /* 0xd8b3 */
    OTHER,        /* 0xd8b4 */
    OTHER,        /* 0xd8b5 */
    OTHER,        /* 0xd8b6 */
    OTHER,        /* 0xd8b7 */
    OTHER,        /* 0xd8b8 */
    OTHER,        /* 0xd8b9 */
    OTHER,        /* 0xd8ba */
    OTHER,        /* 0xd8bb */
    OTHER,        /* 0xd8bc */
    OTHER,        /* 0xd8bd */
    OTHER,        /* 0xd8be */
    OTHER,        /* 0xd8bf */
    OTHER,        /* 0xd8c0 */
    OTHER,        /* 0xd8c1 */
    OTHER,        /* 0xd8c2 */
    OTHER,        /* 0xd8c3 */
    OTHER,        /* 0xd8c4 */
    OTHER,        /* 0xd8c5 */
    OTHER,        /* 0xd8c6 */
    OTHER,        /* 0xd8c7 */
    OTHER,        /* 0xd8c8 */
    OTHER,        /* 0xd8c9 */
    OTHER,        /* 0xd8ca */
    OTHER,        /* 0xd8cb */
    OTHER,        /* 0xd8cc */
    OTHER,        /* 0xd8cd */
    OTHER,        /* 0xd8ce */
    OTHER,        /* 0xd8cf */
    OTHER,        /* 0xd8d0 */
    OTHER,        /* 0xd8d1 */
    OTHER,        /* 0xd8d2 */
    OTHER,        /* 0xd8d3 */
    OTHER,        /* 0xd8d4 */
    OTHER,        /* 0xd8d5 */
    OTHER,        /* 0xd8d6 */
    OTHER,        /* 0xd8d7 */
    OTHER,        /* 0xd8d8 */
    OTHER,        /* 0xd8d9 */
    OTHER,        /* 0xd8da */
    OTHER,        /* 0xd8db */
    OTHER,        /* 0xd8dc */
    OTHER,        /* 0xd8dd */
    OTHER,        /* 0xd8de */
    OTHER,        /* 0xd8df */
    OTHER,        /* 0xd8e0 */
    OTHER,        /* 0xd8e1 */
    OTHER,        /* 0xd8e2 */
    OTHER,        /* 0xd8e3 */
    OTHER,        /* 0xd8e4 */
    OTHER,        /* 0xd8e5 */
    OTHER,        /* 0xd8e6 */
    OTHER,        /* 0xd8e7 */
    OTHER,        /* 0xd8e8 */
    OTHER,        /* 0xd8e9 */
    OTHER,        /* 0xd8ea */
    OTHER,        /* 0xd8eb */
    OTHER,        /* 0xd8ec */
    OTHER,        /* 0xd8ed */
    OTHER,        /* 0xd8ee */
    OTHER,        /* 0xd8ef */
    OTHER,        /* 0xd8f0 */
    OTHER,        /* 0xd8f1 */
    OTHER,        /* 0xd8f2 */
    OTHER,        /* 0xd8f3 */
    OTHER,        /* 0xd8f4 */
    OTHER,        /* 0xd8f5 */
    OTHER,        /* 0xd8f6 */
    OTHER,        /* 0xd8f7 */
    OTHER,        /* 0xd8f8 */
    OTHER,        /* 0xd8f9 */
    OTHER,        /* 0xd8fa */
    OTHER,        /* 0xd8fb */
    OTHER,        /* 0xd8fc */
    OTHER,        /* 0xd8fd */
    OTHER,        /* 0xd8fe */
    OTHER,        /* 0xd8ff */
    OTHER,        /* 0xd900 */
    OTHER,        /* 0xd901 */
    OTHER,        /* 0xd902 */
    OTHER,        /* 0xd903 */
    OTHER,        /* 0xd904 */
    OTHER,        /* 0xd905 */
    OTHER,        /* 0xd906 */
    OTHER,        /* 0xd907 */
    OTHER,        /* 0xd908 */
    OTHER,        /* 0xd909 */
    OTHER,        /* 0xd90a */
    OTHER,        /* 0xd90b */
    OTHER,        /* 0xd90c */
    OTHER,        /* 0xd90d */
    OTHER,        /* 0xd90e */
    OTHER,        /* 0xd90f */
    OTHER,        /* 0xd910 */
    OTHER,        /* 0xd911 */
    OTHER,        /* 0xd912 */
    OTHER,        /* 0xd913 */
    OTHER,        /* 0xd914 */
    OTHER,        /* 0xd915 */
    OTHER,        /* 0xd916 */
    OTHER,        /* 0xd917 */
    OTHER,        /* 0xd918 */
    OTHER,        /* 0xd919 */
    OTHER,        /* 0xd91a */
    OTHER,        /* 0xd91b */
    OTHER,        /* 0xd91c */
    OTHER,        /* 0xd91d */
    OTHER,        /* 0xd91e */
    OTHER,        /* 0xd91f */
    OTHER,        /* 0xd920 */
    OTHER,        /* 0xd921 */
    OTHER,        /* 0xd922 */
    OTHER,        /* 0xd923 */
    OTHER,        /* 0xd924 */
    OTHER,        /* 0xd925 */
    OTHER,        /* 0xd926 */
    OTHER,        /* 0xd927 */
    OTHER,        /* 0xd928 */
    OTHER,        /* 0xd929 */
    OTHER,        /* 0xd92a */
    OTHER,        /* 0xd92b */
    OTHER,        /* 0xd92c */
    OTHER,        /* 0xd92d */
    OTHER,        /* 0xd92e */
    OTHER,        /* 0xd92f */
    OTHER,        /* 0xd930 */
    OTHER,        /* 0xd931 */
    OTHER,        /* 0xd932 */
    OTHER,        /* 0xd933 */
    OTHER,        /* 0xd934 */
    OTHER,        /* 0xd935 */
    OTHER,        /* 0xd936 */
    OTHER,        /* 0xd937 */
    OTHER,        /* 0xd938 */
    OTHER,        /* 0xd939 */
    OTHER,        /* 0xd93a */
    OTHER,        /* 0xd93b */
    OTHER,        /* 0xd93c */
    OTHER,        /* 0xd93d */
    OTHER,        /* 0xd93e */
    OTHER,        /* 0xd93f */
    OTHER,        /* 0xd940 */
    OTHER,        /* 0xd941 */
    OTHER,        /* 0xd942 */
    OTHER,        /* 0xd943 */
    OTHER,        /* 0xd944 */
    OTHER,        /* 0xd945 */
    OTHER,        /* 0xd946 */
    OTHER,        /* 0xd947 */
    OTHER,        /* 0xd948 */
    OTHER,        /* 0xd949 */
    OTHER,        /* 0xd94a */
    OTHER,        /* 0xd94b */
    OTHER,        /* 0xd94c */
    OTHER,        /* 0xd94d */
    OTHER,        /* 0xd94e */
    OTHER,        /* 0xd94f */
    OTHER,        /* 0xd950 */
    OTHER,        /* 0xd951 */
    OTHER,        /* 0xd952 */
    OTHER,        /* 0xd953 */
    OTHER,        /* 0xd954 */
    OTHER,        /* 0xd955 */
    OTHER,        /* 0xd956 */
    OTHER,        /* 0xd957 */
    OTHER,        /* 0xd958 */
    OTHER,        /* 0xd959 */
    OTHER,        /* 0xd95a */
    OTHER,        /* 0xd95b */
    OTHER,        /* 0xd95c */
    OTHER,        /* 0xd95d */
    OTHER,        /* 0xd95e */
    OTHER,        /* 0xd95f */
    OTHER,        /* 0xd960 */
    OTHER,        /* 0xd961 */
    OTHER,        /* 0xd962 */
    OTHER,        /* 0xd963 */
    OTHER,        /* 0xd964 */
    OTHER,        /* 0xd965 */
    OTHER,        /* 0xd966 */
    OTHER,        /* 0xd967 */
    OTHER,        /* 0xd968 */
    OTHER,        /* 0xd969 */
    OTHER,        /* 0xd96a */
    OTHER,        /* 0xd96b */
    OTHER,        /* 0xd96c */
    OTHER,        /* 0xd96d */
    OTHER,        /* 0xd96e */
    OTHER,        /* 0xd96f */
    OTHER,        /* 0xd970 */
    OTHER,        /* 0xd971 */
    OTHER,        /* 0xd972 */
    OTHER,        /* 0xd973 */
    OTHER,        /* 0xd974 */
    OTHER,        /* 0xd975 */
    OTHER,        /* 0xd976 */
    OTHER,        /* 0xd977 */
    OTHER,        /* 0xd978 */
    OTHER,        /* 0xd979 */
    OTHER,        /* 0xd97a */
    OTHER,        /* 0xd97b */
    OTHER,        /* 0xd97c */
    OTHER,        /* 0xd97d */
    OTHER,        /* 0xd97e */
    OTHER,        /* 0xd97f */
    OTHER,        /* 0xd980 */
    OTHER,        /* 0xd981 */
    OTHER,        /* 0xd982 */
    OTHER,        /* 0xd983 */
    OTHER,        /* 0xd984 */
    OTHER,        /* 0xd985 */
    OTHER,        /* 0xd986 */
    OTHER,        /* 0xd987 */
    OTHER,        /* 0xd988 */
    OTHER,        /* 0xd989 */
    OTHER,        /* 0xd98a */
    OTHER,        /* 0xd98b */
    OTHER,        /* 0xd98c */
    OTHER,        /* 0xd98d */
    OTHER,        /* 0xd98e */
    OTHER,        /* 0xd98f */
    OTHER,        /* 0xd990 */
    OTHER,        /* 0xd991 */
    OTHER,        /* 0xd992 */
    OTHER,        /* 0xd993 */
    OTHER,        /* 0xd994 */
    OTHER,        /* 0xd995 */
    OTHER,        /* 0xd996 */
    OTHER,        /* 0xd997 */
    OTHER,        /* 0xd998 */
    OTHER,        /* 0xd999 */
    OTHER,        /* 0xd99a */
    OTHER,        /* 0xd99b */
    OTHER,        /* 0xd99c */
    OTHER,        /* 0xd99d */
    OTHER,        /* 0xd99e */
    OTHER,        /* 0xd99f */
    OTHER,        /* 0xd9a0 */
    OTHER,        /* 0xd9a1 */
    OTHER,        /* 0xd9a2 */
    OTHER,        /* 0xd9a3 */
    OTHER,        /* 0xd9a4 */
    OTHER,        /* 0xd9a5 */
    OTHER,        /* 0xd9a6 */
    OTHER,        /* 0xd9a7 */
    OTHER,        /* 0xd9a8 */
    OTHER,        /* 0xd9a9 */
    OTHER,        /* 0xd9aa */
    OTHER,        /* 0xd9ab */
    OTHER,        /* 0xd9ac */
    OTHER,        /* 0xd9ad */
    OTHER,        /* 0xd9ae */
    OTHER,        /* 0xd9af */
    OTHER,        /* 0xd9b0 */
    OTHER,        /* 0xd9b1 */
    OTHER,        /* 0xd9b2 */
    OTHER,        /* 0xd9b3 */
    OTHER,        /* 0xd9b4 */
    OTHER,        /* 0xd9b5 */
    OTHER,        /* 0xd9b6 */
    OTHER,        /* 0xd9b7 */
    OTHER,        /* 0xd9b8 */
    OTHER,        /* 0xd9b9 */
    OTHER,        /* 0xd9ba */
    OTHER,        /* 0xd9bb */
    OTHER,        /* 0xd9bc */
    OTHER,        /* 0xd9bd */
    OTHER,        /* 0xd9be */
    OTHER,        /* 0xd9bf */
    OTHER,        /* 0xd9c0 */
    OTHER,        /* 0xd9c1 */
    OTHER,        /* 0xd9c2 */
    OTHER,        /* 0xd9c3 */
    OTHER,        /* 0xd9c4 */
    OTHER,        /* 0xd9c5 */
    OTHER,        /* 0xd9c6 */
    OTHER,        /* 0xd9c7 */
    OTHER,        /* 0xd9c8 */
    OTHER,        /* 0xd9c9 */
    OTHER,        /* 0xd9ca */
    OTHER,        /* 0xd9cb */
    OTHER,        /* 0xd9cc */
    OTHER,        /* 0xd9cd */
    OTHER,        /* 0xd9ce */
    OTHER,        /* 0xd9cf */
    OTHER,        /* 0xd9d0 */
    OTHER,        /* 0xd9d1 */
    OTHER,        /* 0xd9d2 */
    OTHER,        /* 0xd9d3 */
    OTHER,        /* 0xd9d4 */
    OTHER,        /* 0xd9d5 */
    OTHER,        /* 0xd9d6 */
    OTHER,        /* 0xd9d7 */
    OTHER,        /* 0xd9d8 */
    OTHER,        /* 0xd9d9 */
    OTHER,        /* 0xd9da */
    OTHER,        /* 0xd9db */
    OTHER,        /* 0xd9dc */
    OTHER,        /* 0xd9dd */
    OTHER,        /* 0xd9de */
    OTHER,        /* 0xd9df */
    OTHER,        /* 0xd9e0 */
    OTHER,        /* 0xd9e1 */
    OTHER,        /* 0xd9e2 */
    OTHER,        /* 0xd9e3 */
    OTHER,        /* 0xd9e4 */
    OTHER,        /* 0xd9e5 */
    OTHER,        /* 0xd9e6 */
    OTHER,        /* 0xd9e7 */
    OTHER,        /* 0xd9e8 */
    OTHER,        /* 0xd9e9 */
    OTHER,        /* 0xd9ea */
    OTHER,        /* 0xd9eb */
    OTHER,        /* 0xd9ec */
    OTHER,        /* 0xd9ed */
    OTHER,        /* 0xd9ee */
    OTHER,        /* 0xd9ef */
    OTHER,        /* 0xd9f0 */
    OTHER,        /* 0xd9f1 */
    OTHER,        /* 0xd9f2 */
    OTHER,        /* 0xd9f3 */
    OTHER,        /* 0xd9f4 */
    OTHER,        /* 0xd9f5 */
    OTHER,        /* 0xd9f6 */
    OTHER,        /* 0xd9f7 */
    OTHER,        /* 0xd9f8 */
    OTHER,        /* 0xd9f9 */
    OTHER,        /* 0xd9fa */
    OTHER,        /* 0xd9fb */
    OTHER,        /* 0xd9fc */
    OTHER,        /* 0xd9fd */
    OTHER,        /* 0xd9fe */
    OTHER,        /* 0xd9ff */
    OTHER,        /* 0xda00 */
    OTHER,        /* 0xda01 */
    OTHER,        /* 0xda02 */
    OTHER,        /* 0xda03 */
    OTHER,        /* 0xda04 */
    OTHER,        /* 0xda05 */
    OTHER,        /* 0xda06 */
    OTHER,        /* 0xda07 */
    OTHER,        /* 0xda08 */
    OTHER,        /* 0xda09 */
    OTHER,        /* 0xda0a */
    OTHER,        /* 0xda0b */
    OTHER,        /* 0xda0c */
    OTHER,        /* 0xda0d */
    OTHER,        /* 0xda0e */
    OTHER,        /* 0xda0f */
    OTHER,        /* 0xda10 */
    OTHER,        /* 0xda11 */
    OTHER,        /* 0xda12 */
    OTHER,        /* 0xda13 */
    OTHER,        /* 0xda14 */
    OTHER,        /* 0xda15 */
    OTHER,        /* 0xda16 */
    OTHER,        /* 0xda17 */
    OTHER,        /* 0xda18 */
    OTHER,        /* 0xda19 */
    OTHER,        /* 0xda1a */
    OTHER,        /* 0xda1b */
    OTHER,        /* 0xda1c */
    OTHER,        /* 0xda1d */
    OTHER,        /* 0xda1e */
    OTHER,        /* 0xda1f */
    OTHER,        /* 0xda20 */
    OTHER,        /* 0xda21 */
    OTHER,        /* 0xda22 */
    OTHER,        /* 0xda23 */
    OTHER,        /* 0xda24 */
    OTHER,        /* 0xda25 */
    OTHER,        /* 0xda26 */
    OTHER,        /* 0xda27 */
    OTHER,        /* 0xda28 */
    OTHER,        /* 0xda29 */
    OTHER,        /* 0xda2a */
    OTHER,        /* 0xda2b */
    OTHER,        /* 0xda2c */
    OTHER,        /* 0xda2d */
    OTHER,        /* 0xda2e */
    OTHER,        /* 0xda2f */
    OTHER,        /* 0xda30 */
    OTHER,        /* 0xda31 */
    OTHER,        /* 0xda32 */
    OTHER,        /* 0xda33 */
    OTHER,        /* 0xda34 */
    OTHER,        /* 0xda35 */
    OTHER,        /* 0xda36 */
    OTHER,        /* 0xda37 */
    OTHER,        /* 0xda38 */
    OTHER,        /* 0xda39 */
    OTHER,        /* 0xda3a */
    OTHER,        /* 0xda3b */
    OTHER,        /* 0xda3c */
    OTHER,        /* 0xda3d */
    OTHER,        /* 0xda3e */
    OTHER,        /* 0xda3f */
    OTHER,        /* 0xda40 */
    OTHER,        /* 0xda41 */
    OTHER,        /* 0xda42 */
    OTHER,        /* 0xda43 */
    OTHER,        /* 0xda44 */
    OTHER,        /* 0xda45 */
    OTHER,        /* 0xda46 */
    OTHER,        /* 0xda47 */
    OTHER,        /* 0xda48 */
    OTHER,        /* 0xda49 */
    OTHER,        /* 0xda4a */
    OTHER,        /* 0xda4b */
    OTHER,        /* 0xda4c */
    OTHER,        /* 0xda4d */
    OTHER,        /* 0xda4e */
    OTHER,        /* 0xda4f */
    OTHER,        /* 0xda50 */
    OTHER,        /* 0xda51 */
    OTHER,        /* 0xda52 */
    OTHER,        /* 0xda53 */
    OTHER,        /* 0xda54 */
    OTHER,        /* 0xda55 */
    OTHER,        /* 0xda56 */
    OTHER,        /* 0xda57 */
    OTHER,        /* 0xda58 */
    OTHER,        /* 0xda59 */
    OTHER,        /* 0xda5a */
    OTHER,        /* 0xda5b */
    OTHER,        /* 0xda5c */
    OTHER,        /* 0xda5d */
    OTHER,        /* 0xda5e */
    OTHER,        /* 0xda5f */
    OTHER,        /* 0xda60 */
    OTHER,        /* 0xda61 */
    OTHER,        /* 0xda62 */
    OTHER,        /* 0xda63 */
    OTHER,        /* 0xda64 */
    OTHER,        /* 0xda65 */
    OTHER,        /* 0xda66 */
    OTHER,        /* 0xda67 */
    OTHER,        /* 0xda68 */
    OTHER,        /* 0xda69 */
    OTHER,        /* 0xda6a */
    OTHER,        /* 0xda6b */
    OTHER,        /* 0xda6c */
    OTHER,        /* 0xda6d */
    OTHER,        /* 0xda6e */
    OTHER,        /* 0xda6f */
    OTHER,        /* 0xda70 */
    OTHER,        /* 0xda71 */
    OTHER,        /* 0xda72 */
    OTHER,        /* 0xda73 */
    OTHER,        /* 0xda74 */
    OTHER,        /* 0xda75 */
    OTHER,        /* 0xda76 */
    OTHER,        /* 0xda77 */
    OTHER,        /* 0xda78 */
    OTHER,        /* 0xda79 */
    OTHER,        /* 0xda7a */
    OTHER,        /* 0xda7b */
    OTHER,        /* 0xda7c */
    OTHER,        /* 0xda7d */
    OTHER,        /* 0xda7e */
    OTHER,        /* 0xda7f */
    OTHER,        /* 0xda80 */
    OTHER,        /* 0xda81 */
    OTHER,        /* 0xda82 */
    OTHER,        /* 0xda83 */
    OTHER,        /* 0xda84 */
    OTHER,        /* 0xda85 */
    OTHER,        /* 0xda86 */
    OTHER,        /* 0xda87 */
    OTHER,        /* 0xda88 */
    OTHER,        /* 0xda89 */
    OTHER,        /* 0xda8a */
    OTHER,        /* 0xda8b */
    OTHER,        /* 0xda8c */
    OTHER,        /* 0xda8d */
    OTHER,        /* 0xda8e */
    OTHER,        /* 0xda8f */
    OTHER,        /* 0xda90 */
    OTHER,        /* 0xda91 */
    OTHER,        /* 0xda92 */
    OTHER,        /* 0xda93 */
    OTHER,        /* 0xda94 */
    OTHER,        /* 0xda95 */
    OTHER,        /* 0xda96 */
    OTHER,        /* 0xda97 */
    OTHER,        /* 0xda98 */
    OTHER,        /* 0xda99 */
    OTHER,        /* 0xda9a */
    OTHER,        /* 0xda9b */
    OTHER,        /* 0xda9c */
    OTHER,        /* 0xda9d */
    OTHER,        /* 0xda9e */
    OTHER,        /* 0xda9f */
    OTHER,        /* 0xdaa0 */
    OTHER,        /* 0xdaa1 */
    OTHER,        /* 0xdaa2 */
    OTHER,        /* 0xdaa3 */
    OTHER,        /* 0xdaa4 */
    OTHER,        /* 0xdaa5 */
    OTHER,        /* 0xdaa6 */
    OTHER,        /* 0xdaa7 */
    OTHER,        /* 0xdaa8 */
    OTHER,        /* 0xdaa9 */
    OTHER,        /* 0xdaaa */
    OTHER,        /* 0xdaab */
    OTHER,        /* 0xdaac */
    OTHER,        /* 0xdaad */
    OTHER,        /* 0xdaae */
    OTHER,        /* 0xdaaf */
    OTHER,        /* 0xdab0 */
    OTHER,        /* 0xdab1 */
    OTHER,        /* 0xdab2 */
    OTHER,        /* 0xdab3 */
    OTHER,        /* 0xdab4 */
    OTHER,        /* 0xdab5 */
    OTHER,        /* 0xdab6 */
    OTHER,        /* 0xdab7 */
    OTHER,        /* 0xdab8 */
    OTHER,        /* 0xdab9 */
    OTHER,        /* 0xdaba */
    OTHER,        /* 0xdabb */
    OTHER,        /* 0xdabc */
    OTHER,        /* 0xdabd */
    OTHER,        /* 0xdabe */
    OTHER,        /* 0xdabf */
    OTHER,        /* 0xdac0 */
    OTHER,        /* 0xdac1 */
    OTHER,        /* 0xdac2 */
    OTHER,        /* 0xdac3 */
    OTHER,        /* 0xdac4 */
    OTHER,        /* 0xdac5 */
    OTHER,        /* 0xdac6 */
    OTHER,        /* 0xdac7 */
    OTHER,        /* 0xdac8 */
    OTHER,        /* 0xdac9 */
    OTHER,        /* 0xdaca */
    OTHER,        /* 0xdacb */
    OTHER,        /* 0xdacc */
    OTHER,        /* 0xdacd */
    OTHER,        /* 0xdace */
    OTHER,        /* 0xdacf */
    OTHER,        /* 0xdad0 */
    OTHER,        /* 0xdad1 */
    OTHER,        /* 0xdad2 */
    OTHER,        /* 0xdad3 */
    OTHER,        /* 0xdad4 */
    OTHER,        /* 0xdad5 */
    OTHER,        /* 0xdad6 */
    OTHER,        /* 0xdad7 */
    OTHER,        /* 0xdad8 */
    OTHER,        /* 0xdad9 */
    OTHER,        /* 0xdada */
    OTHER,        /* 0xdadb */
    OTHER,        /* 0xdadc */
    OTHER,        /* 0xdadd */
    OTHER,        /* 0xdade */
    OTHER,        /* 0xdadf */
    OTHER,        /* 0xdae0 */
    OTHER,        /* 0xdae1 */
    OTHER,        /* 0xdae2 */
    OTHER,        /* 0xdae3 */
    OTHER,        /* 0xdae4 */
    OTHER,        /* 0xdae5 */
    OTHER,        /* 0xdae6 */
    OTHER,        /* 0xdae7 */
    OTHER,        /* 0xdae8 */
    OTHER,        /* 0xdae9 */
    OTHER,        /* 0xdaea */
    OTHER,        /* 0xdaeb */
    OTHER,        /* 0xdaec */
    OTHER,        /* 0xdaed */
    OTHER,        /* 0xdaee */
    OTHER,        /* 0xdaef */
    OTHER,        /* 0xdaf0 */
    OTHER,        /* 0xdaf1 */
    OTHER,        /* 0xdaf2 */
    OTHER,        /* 0xdaf3 */
    OTHER,        /* 0xdaf4 */
    OTHER,        /* 0xdaf5 */
    OTHER,        /* 0xdaf6 */
    OTHER,        /* 0xdaf7 */
    OTHER,        /* 0xdaf8 */
    OTHER,        /* 0xdaf9 */
    OTHER,        /* 0xdafa */
    OTHER,        /* 0xdafb */
    OTHER,        /* 0xdafc */
    OTHER,        /* 0xdafd */
    OTHER,        /* 0xdafe */
    OTHER,        /* 0xdaff */
    OTHER,        /* 0xdb00 */
    OTHER,        /* 0xdb01 */
    OTHER,        /* 0xdb02 */
    OTHER,        /* 0xdb03 */
    OTHER,        /* 0xdb04 */
    OTHER,        /* 0xdb05 */
    OTHER,        /* 0xdb06 */
    OTHER,        /* 0xdb07 */
    OTHER,        /* 0xdb08 */
    OTHER,        /* 0xdb09 */
    OTHER,        /* 0xdb0a */
    OTHER,        /* 0xdb0b */
    OTHER,        /* 0xdb0c */
    OTHER,        /* 0xdb0d */
    OTHER,        /* 0xdb0e */
    OTHER,        /* 0xdb0f */
    OTHER,        /* 0xdb10 */
    OTHER,        /* 0xdb11 */
    OTHER,        /* 0xdb12 */
    OTHER,        /* 0xdb13 */
    OTHER,        /* 0xdb14 */
    OTHER,        /* 0xdb15 */
    OTHER,        /* 0xdb16 */
    OTHER,        /* 0xdb17 */
    OTHER,        /* 0xdb18 */
    OTHER,        /* 0xdb19 */
    OTHER,        /* 0xdb1a */
    OTHER,        /* 0xdb1b */
    OTHER,        /* 0xdb1c */
    OTHER,        /* 0xdb1d */
    OTHER,        /* 0xdb1e */
    OTHER,        /* 0xdb1f */
    OTHER,        /* 0xdb20 */
    OTHER,        /* 0xdb21 */
    OTHER,        /* 0xdb22 */
    OTHER,        /* 0xdb23 */
    OTHER,        /* 0xdb24 */
    OTHER,        /* 0xdb25 */
    OTHER,        /* 0xdb26 */
    OTHER,        /* 0xdb27 */
    OTHER,        /* 0xdb28 */
    OTHER,        /* 0xdb29 */
    OTHER,        /* 0xdb2a */
    OTHER,        /* 0xdb2b */
    OTHER,        /* 0xdb2c */
    OTHER,        /* 0xdb2d */
    OTHER,        /* 0xdb2e */
    OTHER,        /* 0xdb2f */
    OTHER,        /* 0xdb30 */
    OTHER,        /* 0xdb31 */
    OTHER,        /* 0xdb32 */
    OTHER,        /* 0xdb33 */
    OTHER,        /* 0xdb34 */
    OTHER,        /* 0xdb35 */
    OTHER,        /* 0xdb36 */
    OTHER,        /* 0xdb37 */
    OTHER,        /* 0xdb38 */
    OTHER,        /* 0xdb39 */
    OTHER,        /* 0xdb3a */
    OTHER,        /* 0xdb3b */
    OTHER,        /* 0xdb3c */
    OTHER,        /* 0xdb3d */
    OTHER,        /* 0xdb3e */
    OTHER,        /* 0xdb3f */
    OTHER,        /* 0xdb40 */
    OTHER,        /* 0xdb41 */
    OTHER,        /* 0xdb42 */
    OTHER,        /* 0xdb43 */
    OTHER,        /* 0xdb44 */
    OTHER,        /* 0xdb45 */
    OTHER,        /* 0xdb46 */
    OTHER,        /* 0xdb47 */
    OTHER,        /* 0xdb48 */
    OTHER,        /* 0xdb49 */
    OTHER,        /* 0xdb4a */
    OTHER,        /* 0xdb4b */
    OTHER,        /* 0xdb4c */
    OTHER,        /* 0xdb4d */
    OTHER,        /* 0xdb4e */
    OTHER,        /* 0xdb4f */
    OTHER,        /* 0xdb50 */
    OTHER,        /* 0xdb51 */
    OTHER,        /* 0xdb52 */
    OTHER,        /* 0xdb53 */
    OTHER,        /* 0xdb54 */
    OTHER,        /* 0xdb55 */
    OTHER,        /* 0xdb56 */
    OTHER,        /* 0xdb57 */
    OTHER,        /* 0xdb58 */
    OTHER,        /* 0xdb59 */
    OTHER,        /* 0xdb5a */
    OTHER,        /* 0xdb5b */
    OTHER,        /* 0xdb5c */
    OTHER,        /* 0xdb5d */
    OTHER,        /* 0xdb5e */
    OTHER,        /* 0xdb5f */
    OTHER,        /* 0xdb60 */
    OTHER,        /* 0xdb61 */
    OTHER,        /* 0xdb62 */
    OTHER,        /* 0xdb63 */
    OTHER,        /* 0xdb64 */
    OTHER,        /* 0xdb65 */
    OTHER,        /* 0xdb66 */
    OTHER,        /* 0xdb67 */
    OTHER,        /* 0xdb68 */
    OTHER,        /* 0xdb69 */
    OTHER,        /* 0xdb6a */
    OTHER,        /* 0xdb6b */
    OTHER,        /* 0xdb6c */
    OTHER,        /* 0xdb6d */
    OTHER,        /* 0xdb6e */
    OTHER,        /* 0xdb6f */
    OTHER,        /* 0xdb70 */
    OTHER,        /* 0xdb71 */
    OTHER,        /* 0xdb72 */
    OTHER,        /* 0xdb73 */
    OTHER,        /* 0xdb74 */
    OTHER,        /* 0xdb75 */
    OTHER,        /* 0xdb76 */
    OTHER,        /* 0xdb77 */
    OTHER,        /* 0xdb78 */
    OTHER,        /* 0xdb79 */
    OTHER,        /* 0xdb7a */
    OTHER,        /* 0xdb7b */
    OTHER,        /* 0xdb7c */
    OTHER,        /* 0xdb7d */
    OTHER,        /* 0xdb7e */
    OTHER,        /* 0xdb7f */
    OTHER,        /* 0xdb80 */
    OTHER,        /* 0xdb81 */
    OTHER,        /* 0xdb82 */
    OTHER,        /* 0xdb83 */
    OTHER,        /* 0xdb84 */
    OTHER,        /* 0xdb85 */
    OTHER,        /* 0xdb86 */
    OTHER,        /* 0xdb87 */
    OTHER,        /* 0xdb88 */
    OTHER,        /* 0xdb89 */
    OTHER,        /* 0xdb8a */
    OTHER,        /* 0xdb8b */
    OTHER,        /* 0xdb8c */
    OTHER,        /* 0xdb8d */
    OTHER,        /* 0xdb8e */
    OTHER,        /* 0xdb8f */
    OTHER,        /* 0xdb90 */
    OTHER,        /* 0xdb91 */
    OTHER,        /* 0xdb92 */
    OTHER,        /* 0xdb93 */
    OTHER,        /* 0xdb94 */
    OTHER,        /* 0xdb95 */
    OTHER,        /* 0xdb96 */
    OTHER,        /* 0xdb97 */
    OTHER,        /* 0xdb98 */
    OTHER,        /* 0xdb99 */
    OTHER,        /* 0xdb9a */
    OTHER,        /* 0xdb9b */
    OTHER,        /* 0xdb9c */
    OTHER,        /* 0xdb9d */
    OTHER,        /* 0xdb9e */
    OTHER,        /* 0xdb9f */
    OTHER,        /* 0xdba0 */
    OTHER,        /* 0xdba1 */
    OTHER,        /* 0xdba2 */
    OTHER,        /* 0xdba3 */
    OTHER,        /* 0xdba4 */
    OTHER,        /* 0xdba5 */
    OTHER,        /* 0xdba6 */
    OTHER,        /* 0xdba7 */
    OTHER,        /* 0xdba8 */
    OTHER,        /* 0xdba9 */
    OTHER,        /* 0xdbaa */
    OTHER,        /* 0xdbab */
    OTHER,        /* 0xdbac */
    OTHER,        /* 0xdbad */
    OTHER,        /* 0xdbae */
    OTHER,        /* 0xdbaf */
    OTHER,        /* 0xdbb0 */
    OTHER,        /* 0xdbb1 */
    OTHER,        /* 0xdbb2 */
    OTHER,        /* 0xdbb3 */
    OTHER,        /* 0xdbb4 */
    OTHER,        /* 0xdbb5 */
    OTHER,        /* 0xdbb6 */
    OTHER,        /* 0xdbb7 */
    OTHER,        /* 0xdbb8 */
    OTHER,        /* 0xdbb9 */
    OTHER,        /* 0xdbba */
    OTHER,        /* 0xdbbb */
    OTHER,        /* 0xdbbc */
    OTHER,        /* 0xdbbd */
    OTHER,        /* 0xdbbe */
    OTHER,        /* 0xdbbf */
    OTHER,        /* 0xdbc0 */
    OTHER,        /* 0xdbc1 */
    OTHER,        /* 0xdbc2 */
    OTHER,        /* 0xdbc3 */
    OTHER,        /* 0xdbc4 */
    OTHER,        /* 0xdbc5 */
    OTHER,        /* 0xdbc6 */
    OTHER,        /* 0xdbc7 */
    OTHER,        /* 0xdbc8 */
    OTHER,        /* 0xdbc9 */
    OTHER,        /* 0xdbca */
    OTHER,        /* 0xdbcb */
    OTHER,        /* 0xdbcc */
    OTHER,        /* 0xdbcd */
    OTHER,        /* 0xdbce */
    OTHER,        /* 0xdbcf */
    OTHER,        /* 0xdbd0 */
    OTHER,        /* 0xdbd1 */
    OTHER,        /* 0xdbd2 */
    OTHER,        /* 0xdbd3 */
    OTHER,        /* 0xdbd4 */
    OTHER,        /* 0xdbd5 */
    OTHER,        /* 0xdbd6 */
    OTHER,        /* 0xdbd7 */
    OTHER,        /* 0xdbd8 */
    OTHER,        /* 0xdbd9 */
    OTHER,        /* 0xdbda */
    OTHER,        /* 0xdbdb */
    OTHER,        /* 0xdbdc */
    OTHER,        /* 0xdbdd */
    OTHER,        /* 0xdbde */
    OTHER,        /* 0xdbdf */
    OTHER,        /* 0xdbe0 */
    OTHER,        /* 0xdbe1 */
    OTHER,        /* 0xdbe2 */
    OTHER,        /* 0xdbe3 */
    OTHER,        /* 0xdbe4 */
    OTHER,        /* 0xdbe5 */
    OTHER,        /* 0xdbe6 */
    OTHER,        /* 0xdbe7 */
    OTHER,        /* 0xdbe8 */
    OTHER,        /* 0xdbe9 */
    OTHER,        /* 0xdbea */
    OTHER,        /* 0xdbeb */
    OTHER,        /* 0xdbec */
    OTHER,        /* 0xdbed */
    OTHER,        /* 0xdbee */
    OTHER,        /* 0xdbef */
    OTHER,        /* 0xdbf0 */
    OTHER,        /* 0xdbf1 */
    OTHER,        /* 0xdbf2 */
    OTHER,        /* 0xdbf3 */
    OTHER,        /* 0xdbf4 */
    OTHER,        /* 0xdbf5 */
    OTHER,        /* 0xdbf6 */
    OTHER,        /* 0xdbf7 */
    OTHER,        /* 0xdbf8 */
    OTHER,        /* 0xdbf9 */
    OTHER,        /* 0xdbfa */
    OTHER,        /* 0xdbfb */
    OTHER,        /* 0xdbfc */
    OTHER,        /* 0xdbfd */
    OTHER,        /* 0xdbfe */
    OTHER,        /* 0xdbff */
    OTHER,        /* 0xdc00 */
    OTHER,        /* 0xdc01 */
    OTHER,        /* 0xdc02 */
    OTHER,        /* 0xdc03 */
    OTHER,        /* 0xdc04 */
    OTHER,        /* 0xdc05 */
    OTHER,        /* 0xdc06 */
    OTHER,        /* 0xdc07 */
    OTHER,        /* 0xdc08 */
    OTHER,        /* 0xdc09 */
    OTHER,        /* 0xdc0a */
    OTHER,        /* 0xdc0b */
    OTHER,        /* 0xdc0c */
    OTHER,        /* 0xdc0d */
    OTHER,        /* 0xdc0e */
    OTHER,        /* 0xdc0f */
    OTHER,        /* 0xdc10 */
    OTHER,        /* 0xdc11 */
    OTHER,        /* 0xdc12 */
    OTHER,        /* 0xdc13 */
    OTHER,        /* 0xdc14 */
    OTHER,        /* 0xdc15 */
    OTHER,        /* 0xdc16 */
    OTHER,        /* 0xdc17 */
    OTHER,        /* 0xdc18 */
    OTHER,        /* 0xdc19 */
    OTHER,        /* 0xdc1a */
    OTHER,        /* 0xdc1b */
    OTHER,        /* 0xdc1c */
    OTHER,        /* 0xdc1d */
    OTHER,        /* 0xdc1e */
    OTHER,        /* 0xdc1f */
    OTHER,        /* 0xdc20 */
    OTHER,        /* 0xdc21 */
    OTHER,        /* 0xdc22 */
    OTHER,        /* 0xdc23 */
    OTHER,        /* 0xdc24 */
    OTHER,        /* 0xdc25 */
    OTHER,        /* 0xdc26 */
    OTHER,        /* 0xdc27 */
    OTHER,        /* 0xdc28 */
    OTHER,        /* 0xdc29 */
    OTHER,        /* 0xdc2a */
    OTHER,        /* 0xdc2b */
    OTHER,        /* 0xdc2c */
    OTHER,        /* 0xdc2d */
    OTHER,        /* 0xdc2e */
    OTHER,        /* 0xdc2f */
    OTHER,        /* 0xdc30 */
    OTHER,        /* 0xdc31 */
    OTHER,        /* 0xdc32 */
    OTHER,        /* 0xdc33 */
    OTHER,        /* 0xdc34 */
    OTHER,        /* 0xdc35 */
    OTHER,        /* 0xdc36 */
    OTHER,        /* 0xdc37 */
    OTHER,        /* 0xdc38 */
    OTHER,        /* 0xdc39 */
    OTHER,        /* 0xdc3a */
    OTHER,        /* 0xdc3b */
    OTHER,        /* 0xdc3c */
    OTHER,        /* 0xdc3d */
    OTHER,        /* 0xdc3e */
    OTHER,        /* 0xdc3f */
    OTHER,        /* 0xdc40 */
    OTHER,        /* 0xdc41 */
    OTHER,        /* 0xdc42 */
    OTHER,        /* 0xdc43 */
    OTHER,        /* 0xdc44 */
    OTHER,        /* 0xdc45 */
    OTHER,        /* 0xdc46 */
    OTHER,        /* 0xdc47 */
    OTHER,        /* 0xdc48 */
    OTHER,        /* 0xdc49 */
    OTHER,        /* 0xdc4a */
    OTHER,        /* 0xdc4b */
    OTHER,        /* 0xdc4c */
    OTHER,        /* 0xdc4d */
    OTHER,        /* 0xdc4e */
    OTHER,        /* 0xdc4f */
    OTHER,        /* 0xdc50 */
    OTHER,        /* 0xdc51 */
    OTHER,        /* 0xdc52 */
    OTHER,        /* 0xdc53 */
    OTHER,        /* 0xdc54 */
    OTHER,        /* 0xdc55 */
    OTHER,        /* 0xdc56 */
    OTHER,        /* 0xdc57 */
    OTHER,        /* 0xdc58 */
    OTHER,        /* 0xdc59 */
    OTHER,        /* 0xdc5a */
    OTHER,        /* 0xdc5b */
    OTHER,        /* 0xdc5c */
    OTHER,        /* 0xdc5d */
    OTHER,        /* 0xdc5e */
    OTHER,        /* 0xdc5f */
    OTHER,        /* 0xdc60 */
    OTHER,        /* 0xdc61 */
    OTHER,        /* 0xdc62 */
    OTHER,        /* 0xdc63 */
    OTHER,        /* 0xdc64 */
    OTHER,        /* 0xdc65 */
    OTHER,        /* 0xdc66 */
    OTHER,        /* 0xdc67 */
    OTHER,        /* 0xdc68 */
    OTHER,        /* 0xdc69 */
    OTHER,        /* 0xdc6a */
    OTHER,        /* 0xdc6b */
    OTHER,        /* 0xdc6c */
    OTHER,        /* 0xdc6d */
    OTHER,        /* 0xdc6e */
    OTHER,        /* 0xdc6f */
    OTHER,        /* 0xdc70 */
    OTHER,        /* 0xdc71 */
    OTHER,        /* 0xdc72 */
    OTHER,        /* 0xdc73 */
    OTHER,        /* 0xdc74 */
    OTHER,        /* 0xdc75 */
    OTHER,        /* 0xdc76 */
    OTHER,        /* 0xdc77 */
    OTHER,        /* 0xdc78 */
    OTHER,        /* 0xdc79 */
    OTHER,        /* 0xdc7a */
    OTHER,        /* 0xdc7b */
    OTHER,        /* 0xdc7c */
    OTHER,        /* 0xdc7d */
    OTHER,        /* 0xdc7e */
    OTHER,        /* 0xdc7f */
    OTHER,        /* 0xdc80 */
    OTHER,        /* 0xdc81 */
    OTHER,        /* 0xdc82 */
    OTHER,        /* 0xdc83 */
    OTHER,        /* 0xdc84 */
    OTHER,        /* 0xdc85 */
    OTHER,        /* 0xdc86 */
    OTHER,        /* 0xdc87 */
    OTHER,        /* 0xdc88 */
    OTHER,        /* 0xdc89 */
    OTHER,        /* 0xdc8a */
    OTHER,        /* 0xdc8b */
    OTHER,        /* 0xdc8c */
    OTHER,        /* 0xdc8d */
    OTHER,        /* 0xdc8e */
    OTHER,        /* 0xdc8f */
    OTHER,        /* 0xdc90 */
    OTHER,        /* 0xdc91 */
    OTHER,        /* 0xdc92 */
    OTHER,        /* 0xdc93 */
    OTHER,        /* 0xdc94 */
    OTHER,        /* 0xdc95 */
    OTHER,        /* 0xdc96 */
    OTHER,        /* 0xdc97 */
    OTHER,        /* 0xdc98 */
    OTHER,        /* 0xdc99 */
    OTHER,        /* 0xdc9a */
    OTHER,        /* 0xdc9b */
    OTHER,        /* 0xdc9c */
    OTHER,        /* 0xdc9d */
    OTHER,        /* 0xdc9e */
    OTHER,        /* 0xdc9f */
    OTHER,        /* 0xdca0 */
    OTHER,        /* 0xdca1 */
    OTHER,        /* 0xdca2 */
    OTHER,        /* 0xdca3 */
    OTHER,        /* 0xdca4 */
    OTHER,        /* 0xdca5 */
    OTHER,        /* 0xdca6 */
    OTHER,        /* 0xdca7 */
    OTHER,        /* 0xdca8 */
    OTHER,        /* 0xdca9 */
    OTHER,        /* 0xdcaa */
    OTHER,        /* 0xdcab */
    OTHER,        /* 0xdcac */
    OTHER,        /* 0xdcad */
    OTHER,        /* 0xdcae */
    OTHER,        /* 0xdcaf */
    OTHER,        /* 0xdcb0 */
    OTHER,        /* 0xdcb1 */
    OTHER,        /* 0xdcb2 */
    OTHER,        /* 0xdcb3 */
    OTHER,        /* 0xdcb4 */
    OTHER,        /* 0xdcb5 */
    OTHER,        /* 0xdcb6 */
    OTHER,        /* 0xdcb7 */
    OTHER,        /* 0xdcb8 */
    OTHER,        /* 0xdcb9 */
    OTHER,        /* 0xdcba */
    OTHER,        /* 0xdcbb */
    OTHER,        /* 0xdcbc */
    OTHER,        /* 0xdcbd */
    OTHER,        /* 0xdcbe */
    OTHER,        /* 0xdcbf */
    OTHER,        /* 0xdcc0 */
    OTHER,        /* 0xdcc1 */
    OTHER,        /* 0xdcc2 */
    OTHER,        /* 0xdcc3 */
    OTHER,        /* 0xdcc4 */
    OTHER,        /* 0xdcc5 */
    OTHER,        /* 0xdcc6 */
    OTHER,        /* 0xdcc7 */
    OTHER,        /* 0xdcc8 */
    OTHER,        /* 0xdcc9 */
    OTHER,        /* 0xdcca */
    OTHER,        /* 0xdccb */
    OTHER,        /* 0xdccc */
    OTHER,        /* 0xdccd */
    OTHER,        /* 0xdcce */
    OTHER,        /* 0xdccf */
    OTHER,        /* 0xdcd0 */
    OTHER,        /* 0xdcd1 */
    OTHER,        /* 0xdcd2 */
    OTHER,        /* 0xdcd3 */
    OTHER,        /* 0xdcd4 */
    OTHER,        /* 0xdcd5 */
    OTHER,        /* 0xdcd6 */
    OTHER,        /* 0xdcd7 */
    OTHER,        /* 0xdcd8 */
    OTHER,        /* 0xdcd9 */
    OTHER,        /* 0xdcda */
    OTHER,        /* 0xdcdb */
    OTHER,        /* 0xdcdc */
    OTHER,        /* 0xdcdd */
    OTHER,        /* 0xdcde */
    OTHER,        /* 0xdcdf */
    OTHER,        /* 0xdce0 */
    OTHER,        /* 0xdce1 */
    OTHER,        /* 0xdce2 */
    OTHER,        /* 0xdce3 */
    OTHER,        /* 0xdce4 */
    OTHER,        /* 0xdce5 */
    OTHER,        /* 0xdce6 */
    OTHER,        /* 0xdce7 */
    OTHER,        /* 0xdce8 */
    OTHER,        /* 0xdce9 */
    OTHER,        /* 0xdcea */
    OTHER,        /* 0xdceb */
    OTHER,        /* 0xdcec */
    OTHER,        /* 0xdced */
    OTHER,        /* 0xdcee */
    OTHER,        /* 0xdcef */
    OTHER,        /* 0xdcf0 */
    OTHER,        /* 0xdcf1 */
    OTHER,        /* 0xdcf2 */
    OTHER,        /* 0xdcf3 */
    OTHER,        /* 0xdcf4 */
    OTHER,        /* 0xdcf5 */
    OTHER,        /* 0xdcf6 */
    OTHER,        /* 0xdcf7 */
    OTHER,        /* 0xdcf8 */
    OTHER,        /* 0xdcf9 */
    OTHER,        /* 0xdcfa */
    OTHER,        /* 0xdcfb */
    OTHER,        /* 0xdcfc */
    OTHER,        /* 0xdcfd */
    OTHER,        /* 0xdcfe */
    OTHER,        /* 0xdcff */
    OTHER,        /* 0xdd00 */
    OTHER,        /* 0xdd01 */
    OTHER,        /* 0xdd02 */
    OTHER,        /* 0xdd03 */
    OTHER,        /* 0xdd04 */
    OTHER,        /* 0xdd05 */
    OTHER,        /* 0xdd06 */
    OTHER,        /* 0xdd07 */
    OTHER,        /* 0xdd08 */
    OTHER,        /* 0xdd09 */
    OTHER,        /* 0xdd0a */
    OTHER,        /* 0xdd0b */
    OTHER,        /* 0xdd0c */
    OTHER,        /* 0xdd0d */
    OTHER,        /* 0xdd0e */
    OTHER,        /* 0xdd0f */
    OTHER,        /* 0xdd10 */
    OTHER,        /* 0xdd11 */
    OTHER,        /* 0xdd12 */
    OTHER,        /* 0xdd13 */
    OTHER,        /* 0xdd14 */
    OTHER,        /* 0xdd15 */
    OTHER,        /* 0xdd16 */
    OTHER,        /* 0xdd17 */
    OTHER,        /* 0xdd18 */
    OTHER,        /* 0xdd19 */
    OTHER,        /* 0xdd1a */
    OTHER,        /* 0xdd1b */
    OTHER,        /* 0xdd1c */
    OTHER,        /* 0xdd1d */
    OTHER,        /* 0xdd1e */
    OTHER,        /* 0xdd1f */
    OTHER,        /* 0xdd20 */
    OTHER,        /* 0xdd21 */
    OTHER,        /* 0xdd22 */
    OTHER,        /* 0xdd23 */
    OTHER,        /* 0xdd24 */
    OTHER,        /* 0xdd25 */
    OTHER,        /* 0xdd26 */
    OTHER,        /* 0xdd27 */
    OTHER,        /* 0xdd28 */
    OTHER,        /* 0xdd29 */
    OTHER,        /* 0xdd2a */
    OTHER,        /* 0xdd2b */
    OTHER,        /* 0xdd2c */
    OTHER,        /* 0xdd2d */
    OTHER,        /* 0xdd2e */
    OTHER,        /* 0xdd2f */
    OTHER,        /* 0xdd30 */
    OTHER,        /* 0xdd31 */
    OTHER,        /* 0xdd32 */
    OTHER,        /* 0xdd33 */
    OTHER,        /* 0xdd34 */
    OTHER,        /* 0xdd35 */
    OTHER,        /* 0xdd36 */
    OTHER,        /* 0xdd37 */
    OTHER,        /* 0xdd38 */
    OTHER,        /* 0xdd39 */
    OTHER,        /* 0xdd3a */
    OTHER,        /* 0xdd3b */
    OTHER,        /* 0xdd3c */
    OTHER,        /* 0xdd3d */
    OTHER,        /* 0xdd3e */
    OTHER,        /* 0xdd3f */
    OTHER,        /* 0xdd40 */
    OTHER,        /* 0xdd41 */
    OTHER,        /* 0xdd42 */
    OTHER,        /* 0xdd43 */
    OTHER,        /* 0xdd44 */
    OTHER,        /* 0xdd45 */
    OTHER,        /* 0xdd46 */
    OTHER,        /* 0xdd47 */
    OTHER,        /* 0xdd48 */
    OTHER,        /* 0xdd49 */
    OTHER,        /* 0xdd4a */
    OTHER,        /* 0xdd4b */
    OTHER,        /* 0xdd4c */
    OTHER,        /* 0xdd4d */
    OTHER,        /* 0xdd4e */
    OTHER,        /* 0xdd4f */
    OTHER,        /* 0xdd50 */
    OTHER,        /* 0xdd51 */
    OTHER,        /* 0xdd52 */
    OTHER,        /* 0xdd53 */
    OTHER,        /* 0xdd54 */
    OTHER,        /* 0xdd55 */
    OTHER,        /* 0xdd56 */
    OTHER,        /* 0xdd57 */
    OTHER,        /* 0xdd58 */
    OTHER,        /* 0xdd59 */
    OTHER,        /* 0xdd5a */
    OTHER,        /* 0xdd5b */
    OTHER,        /* 0xdd5c */
    OTHER,        /* 0xdd5d */
    OTHER,        /* 0xdd5e */
    OTHER,        /* 0xdd5f */
    OTHER,        /* 0xdd60 */
    OTHER,        /* 0xdd61 */
    OTHER,        /* 0xdd62 */
    OTHER,        /* 0xdd63 */
    OTHER,        /* 0xdd64 */
    OTHER,        /* 0xdd65 */
    OTHER,        /* 0xdd66 */
    OTHER,        /* 0xdd67 */
    OTHER,        /* 0xdd68 */
    OTHER,        /* 0xdd69 */
    OTHER,        /* 0xdd6a */
    OTHER,        /* 0xdd6b */
    OTHER,        /* 0xdd6c */
    OTHER,        /* 0xdd6d */
    OTHER,        /* 0xdd6e */
    OTHER,        /* 0xdd6f */
    OTHER,        /* 0xdd70 */
    OTHER,        /* 0xdd71 */
    OTHER,        /* 0xdd72 */
    OTHER,        /* 0xdd73 */
    OTHER,        /* 0xdd74 */
    OTHER,        /* 0xdd75 */
    OTHER,        /* 0xdd76 */
    OTHER,        /* 0xdd77 */
    OTHER,        /* 0xdd78 */
    OTHER,        /* 0xdd79 */
    OTHER,        /* 0xdd7a */
    OTHER,        /* 0xdd7b */
    OTHER,        /* 0xdd7c */
    OTHER,        /* 0xdd7d */
    OTHER,        /* 0xdd7e */
    OTHER,        /* 0xdd7f */
    OTHER,        /* 0xdd80 */
    OTHER,        /* 0xdd81 */
    OTHER,        /* 0xdd82 */
    OTHER,        /* 0xdd83 */
    OTHER,        /* 0xdd84 */
    OTHER,        /* 0xdd85 */
    OTHER,        /* 0xdd86 */
    OTHER,        /* 0xdd87 */
    OTHER,        /* 0xdd88 */
    OTHER,        /* 0xdd89 */
    OTHER,        /* 0xdd8a */
    OTHER,        /* 0xdd8b */
    OTHER,        /* 0xdd8c */
    OTHER,        /* 0xdd8d */
    OTHER,        /* 0xdd8e */
    OTHER,        /* 0xdd8f */
    OTHER,        /* 0xdd90 */
    OTHER,        /* 0xdd91 */
    OTHER,        /* 0xdd92 */
    OTHER,        /* 0xdd93 */
    OTHER,        /* 0xdd94 */
    OTHER,        /* 0xdd95 */
    OTHER,        /* 0xdd96 */
    OTHER,        /* 0xdd97 */
    OTHER,        /* 0xdd98 */
    OTHER,        /* 0xdd99 */
    OTHER,        /* 0xdd9a */
    OTHER,        /* 0xdd9b */
    OTHER,        /* 0xdd9c */
    OTHER,        /* 0xdd9d */
    OTHER,        /* 0xdd9e */
    OTHER,        /* 0xdd9f */
    OTHER,        /* 0xdda0 */
    OTHER,        /* 0xdda1 */
    OTHER,        /* 0xdda2 */
    OTHER,        /* 0xdda3 */
    OTHER,        /* 0xdda4 */
    OTHER,        /* 0xdda5 */
    OTHER,        /* 0xdda6 */
    OTHER,        /* 0xdda7 */
    OTHER,        /* 0xdda8 */
    OTHER,        /* 0xdda9 */
    OTHER,        /* 0xddaa */
    OTHER,        /* 0xddab */
    OTHER,        /* 0xddac */
    OTHER,        /* 0xddad */
    OTHER,        /* 0xddae */
    OTHER,        /* 0xddaf */
    OTHER,        /* 0xddb0 */
    OTHER,        /* 0xddb1 */
    OTHER,        /* 0xddb2 */
    OTHER,        /* 0xddb3 */
    OTHER,        /* 0xddb4 */
    OTHER,        /* 0xddb5 */
    OTHER,        /* 0xddb6 */
    OTHER,        /* 0xddb7 */
    OTHER,        /* 0xddb8 */
    OTHER,        /* 0xddb9 */
    OTHER,        /* 0xddba */
    OTHER,        /* 0xddbb */
    OTHER,        /* 0xddbc */
    OTHER,        /* 0xddbd */
    OTHER,        /* 0xddbe */
    OTHER,        /* 0xddbf */
    OTHER,        /* 0xddc0 */
    OTHER,        /* 0xddc1 */
    OTHER,        /* 0xddc2 */
    OTHER,        /* 0xddc3 */
    OTHER,        /* 0xddc4 */
    OTHER,        /* 0xddc5 */
    OTHER,        /* 0xddc6 */
    OTHER,        /* 0xddc7 */
    OTHER,        /* 0xddc8 */
    OTHER,        /* 0xddc9 */
    OTHER,        /* 0xddca */
    OTHER,        /* 0xddcb */
    OTHER,        /* 0xddcc */
    OTHER,        /* 0xddcd */
    OTHER,        /* 0xddce */
    OTHER,        /* 0xddcf */
    OTHER,        /* 0xddd0 */
    OTHER,        /* 0xddd1 */
    OTHER,        /* 0xddd2 */
    OTHER,        /* 0xddd3 */
    OTHER,        /* 0xddd4 */
    OTHER,        /* 0xddd5 */
    OTHER,        /* 0xddd6 */
    OTHER,        /* 0xddd7 */
    OTHER,        /* 0xddd8 */
    OTHER,        /* 0xddd9 */
    OTHER,        /* 0xddda */
    OTHER,        /* 0xdddb */
    OTHER,        /* 0xdddc */
    OTHER,        /* 0xdddd */
    OTHER,        /* 0xddde */
    OTHER,        /* 0xdddf */
    OTHER,        /* 0xdde0 */
    OTHER,        /* 0xdde1 */
    OTHER,        /* 0xdde2 */
    OTHER,        /* 0xdde3 */
    OTHER,        /* 0xdde4 */
    OTHER,        /* 0xdde5 */
    OTHER,        /* 0xdde6 */
    OTHER,        /* 0xdde7 */
    OTHER,        /* 0xdde8 */
    OTHER,        /* 0xdde9 */
    OTHER,        /* 0xddea */
    OTHER,        /* 0xddeb */
    OTHER,        /* 0xddec */
    OTHER,        /* 0xdded */
    OTHER,        /* 0xddee */
    OTHER,        /* 0xddef */
    OTHER,        /* 0xddf0 */
    OTHER,        /* 0xddf1 */
    OTHER,        /* 0xddf2 */
    OTHER,        /* 0xddf3 */
    OTHER,        /* 0xddf4 */
    OTHER,        /* 0xddf5 */
    OTHER,        /* 0xddf6 */
    OTHER,        /* 0xddf7 */
    OTHER,        /* 0xddf8 */
    OTHER,        /* 0xddf9 */
    OTHER,        /* 0xddfa */
    OTHER,        /* 0xddfb */
    OTHER,        /* 0xddfc */
    OTHER,        /* 0xddfd */
    OTHER,        /* 0xddfe */
    OTHER,        /* 0xddff */
    OTHER,        /* 0xde00 */
    OTHER,        /* 0xde01 */
    OTHER,        /* 0xde02 */
    OTHER,        /* 0xde03 */
    OTHER,        /* 0xde04 */
    OTHER,        /* 0xde05 */
    OTHER,        /* 0xde06 */
    OTHER,        /* 0xde07 */
    OTHER,        /* 0xde08 */
    OTHER,        /* 0xde09 */
    OTHER,        /* 0xde0a */
    OTHER,        /* 0xde0b */
    OTHER,        /* 0xde0c */
    OTHER,        /* 0xde0d */
    OTHER,        /* 0xde0e */
    OTHER,        /* 0xde0f */
    OTHER,        /* 0xde10 */
    OTHER,        /* 0xde11 */
    OTHER,        /* 0xde12 */
    OTHER,        /* 0xde13 */
    OTHER,        /* 0xde14 */
    OTHER,        /* 0xde15 */
    OTHER,        /* 0xde16 */
    OTHER,        /* 0xde17 */
    OTHER,        /* 0xde18 */
    OTHER,        /* 0xde19 */
    OTHER,        /* 0xde1a */
    OTHER,        /* 0xde1b */
    OTHER,        /* 0xde1c */
    OTHER,        /* 0xde1d */
    OTHER,        /* 0xde1e */
    OTHER,        /* 0xde1f */
    OTHER,        /* 0xde20 */
    OTHER,        /* 0xde21 */
    OTHER,        /* 0xde22 */
    OTHER,        /* 0xde23 */
    OTHER,        /* 0xde24 */
    OTHER,        /* 0xde25 */
    OTHER,        /* 0xde26 */
    OTHER,        /* 0xde27 */
    OTHER,        /* 0xde28 */
    OTHER,        /* 0xde29 */
    OTHER,        /* 0xde2a */
    OTHER,        /* 0xde2b */
    OTHER,        /* 0xde2c */
    OTHER,        /* 0xde2d */
    OTHER,        /* 0xde2e */
    OTHER,        /* 0xde2f */
    OTHER,        /* 0xde30 */
    OTHER,        /* 0xde31 */
    OTHER,        /* 0xde32 */
    OTHER,        /* 0xde33 */
    OTHER,        /* 0xde34 */
    OTHER,        /* 0xde35 */
    OTHER,        /* 0xde36 */
    OTHER,        /* 0xde37 */
    OTHER,        /* 0xde38 */
    OTHER,        /* 0xde39 */
    OTHER,        /* 0xde3a */
    OTHER,        /* 0xde3b */
    OTHER,        /* 0xde3c */
    OTHER,        /* 0xde3d */
    OTHER,        /* 0xde3e */
    OTHER,        /* 0xde3f */
    OTHER,        /* 0xde40 */
    OTHER,        /* 0xde41 */
    OTHER,        /* 0xde42 */
    OTHER,        /* 0xde43 */
    OTHER,        /* 0xde44 */
    OTHER,        /* 0xde45 */
    OTHER,        /* 0xde46 */
    OTHER,        /* 0xde47 */
    OTHER,        /* 0xde48 */
    OTHER,        /* 0xde49 */
    OTHER,        /* 0xde4a */
    OTHER,        /* 0xde4b */
    OTHER,        /* 0xde4c */
    OTHER,        /* 0xde4d */
    OTHER,        /* 0xde4e */
    OTHER,        /* 0xde4f */
    OTHER,        /* 0xde50 */
    OTHER,        /* 0xde51 */
    OTHER,        /* 0xde52 */
    OTHER,        /* 0xde53 */
    OTHER,        /* 0xde54 */
    OTHER,        /* 0xde55 */
    OTHER,        /* 0xde56 */
    OTHER,        /* 0xde57 */
    OTHER,        /* 0xde58 */
    OTHER,        /* 0xde59 */
    OTHER,        /* 0xde5a */
    OTHER,        /* 0xde5b */
    OTHER,        /* 0xde5c */
    OTHER,        /* 0xde5d */
    OTHER,        /* 0xde5e */
    OTHER,        /* 0xde5f */
    OTHER,        /* 0xde60 */
    OTHER,        /* 0xde61 */
    OTHER,        /* 0xde62 */
    OTHER,        /* 0xde63 */
    OTHER,        /* 0xde64 */
    OTHER,        /* 0xde65 */
    OTHER,        /* 0xde66 */
    OTHER,        /* 0xde67 */
    OTHER,        /* 0xde68 */
    OTHER,        /* 0xde69 */
    OTHER,        /* 0xde6a */
    OTHER,        /* 0xde6b */
    OTHER,        /* 0xde6c */
    OTHER,        /* 0xde6d */
    OTHER,        /* 0xde6e */
    OTHER,        /* 0xde6f */
    OTHER,        /* 0xde70 */
    OTHER,        /* 0xde71 */
    OTHER,        /* 0xde72 */
    OTHER,        /* 0xde73 */
    OTHER,        /* 0xde74 */
    OTHER,        /* 0xde75 */
    OTHER,        /* 0xde76 */
    OTHER,        /* 0xde77 */
    OTHER,        /* 0xde78 */
    OTHER,        /* 0xde79 */
    OTHER,        /* 0xde7a */
    OTHER,        /* 0xde7b */
    OTHER,        /* 0xde7c */
    OTHER,        /* 0xde7d */
    OTHER,        /* 0xde7e */
    OTHER,        /* 0xde7f */
    OTHER,        /* 0xde80 */
    OTHER,        /* 0xde81 */
    OTHER,        /* 0xde82 */
    OTHER,        /* 0xde83 */
    OTHER,        /* 0xde84 */
    OTHER,        /* 0xde85 */
    OTHER,        /* 0xde86 */
    OTHER,        /* 0xde87 */
    OTHER,        /* 0xde88 */
    OTHER,        /* 0xde89 */
    OTHER,        /* 0xde8a */
    OTHER,        /* 0xde8b */
    OTHER,        /* 0xde8c */
    OTHER,        /* 0xde8d */
    OTHER,        /* 0xde8e */
    OTHER,        /* 0xde8f */
    OTHER,        /* 0xde90 */
    OTHER,        /* 0xde91 */
    OTHER,        /* 0xde92 */
    OTHER,        /* 0xde93 */
    OTHER,        /* 0xde94 */
    OTHER,        /* 0xde95 */
    OTHER,        /* 0xde96 */
    OTHER,        /* 0xde97 */
    OTHER,        /* 0xde98 */
    OTHER,        /* 0xde99 */
    OTHER,        /* 0xde9a */
    OTHER,        /* 0xde9b */
    OTHER,        /* 0xde9c */
    OTHER,        /* 0xde9d */
    OTHER,        /* 0xde9e */
    OTHER,        /* 0xde9f */
    OTHER,        /* 0xdea0 */
    OTHER,        /* 0xdea1 */
    OTHER,        /* 0xdea2 */
    OTHER,        /* 0xdea3 */
    OTHER,        /* 0xdea4 */
    OTHER,        /* 0xdea5 */
    OTHER,        /* 0xdea6 */
    OTHER,        /* 0xdea7 */
    OTHER,        /* 0xdea8 */
    OTHER,        /* 0xdea9 */
    OTHER,        /* 0xdeaa */
    OTHER,        /* 0xdeab */
    OTHER,        /* 0xdeac */
    OTHER,        /* 0xdead */
    OTHER,        /* 0xdeae */
    OTHER,        /* 0xdeaf */
    OTHER,        /* 0xdeb0 */
    OTHER,        /* 0xdeb1 */
    OTHER,        /* 0xdeb2 */
    OTHER,        /* 0xdeb3 */
    OTHER,        /* 0xdeb4 */
    OTHER,        /* 0xdeb5 */
    OTHER,        /* 0xdeb6 */
    OTHER,        /* 0xdeb7 */
    OTHER,        /* 0xdeb8 */
    OTHER,        /* 0xdeb9 */
    OTHER,        /* 0xdeba */
    OTHER,        /* 0xdebb */
    OTHER,        /* 0xdebc */
    OTHER,        /* 0xdebd */
    OTHER,        /* 0xdebe */
    OTHER,        /* 0xdebf */
    OTHER,        /* 0xdec0 */
    OTHER,        /* 0xdec1 */
    OTHER,        /* 0xdec2 */
    OTHER,        /* 0xdec3 */
    OTHER,        /* 0xdec4 */
    OTHER,        /* 0xdec5 */
    OTHER,        /* 0xdec6 */
    OTHER,        /* 0xdec7 */
    OTHER,        /* 0xdec8 */
    OTHER,        /* 0xdec9 */
    OTHER,        /* 0xdeca */
    OTHER,        /* 0xdecb */
    OTHER,        /* 0xdecc */
    OTHER,        /* 0xdecd */
    OTHER,        /* 0xdece */
    OTHER,        /* 0xdecf */
    OTHER,        /* 0xded0 */
    OTHER,        /* 0xded1 */
    OTHER,        /* 0xded2 */
    OTHER,        /* 0xded3 */
    OTHER,        /* 0xded4 */
    OTHER,        /* 0xded5 */
    OTHER,        /* 0xded6 */
    OTHER,        /* 0xded7 */
    OTHER,        /* 0xded8 */
    OTHER,        /* 0xded9 */
    OTHER,        /* 0xdeda */
    OTHER,        /* 0xdedb */
    OTHER,        /* 0xdedc */
    OTHER,        /* 0xdedd */
    OTHER,        /* 0xdede */
    OTHER,        /* 0xdedf */
    OTHER,        /* 0xdee0 */
    OTHER,        /* 0xdee1 */
    OTHER,        /* 0xdee2 */
    OTHER,        /* 0xdee3 */
    OTHER,        /* 0xdee4 */
    OTHER,        /* 0xdee5 */
    OTHER,        /* 0xdee6 */
    OTHER,        /* 0xdee7 */
    OTHER,        /* 0xdee8 */
    OTHER,        /* 0xdee9 */
    OTHER,        /* 0xdeea */
    OTHER,        /* 0xdeeb */
    OTHER,        /* 0xdeec */
    OTHER,        /* 0xdeed */
    OTHER,        /* 0xdeee */
    OTHER,        /* 0xdeef */
    OTHER,        /* 0xdef0 */
    OTHER,        /* 0xdef1 */
    OTHER,        /* 0xdef2 */
    OTHER,        /* 0xdef3 */
    OTHER,        /* 0xdef4 */
    OTHER,        /* 0xdef5 */
    OTHER,        /* 0xdef6 */
    OTHER,        /* 0xdef7 */
    OTHER,        /* 0xdef8 */
    OTHER,        /* 0xdef9 */
    OTHER,        /* 0xdefa */
    OTHER,        /* 0xdefb */
    OTHER,        /* 0xdefc */
    OTHER,        /* 0xdefd */
    OTHER,        /* 0xdefe */
    OTHER,        /* 0xdeff */
    OTHER,        /* 0xdf00 */
    OTHER,        /* 0xdf01 */
    OTHER,        /* 0xdf02 */
    OTHER,        /* 0xdf03 */
    OTHER,        /* 0xdf04 */
    OTHER,        /* 0xdf05 */
    OTHER,        /* 0xdf06 */
    OTHER,        /* 0xdf07 */
    OTHER,        /* 0xdf08 */
    OTHER,        /* 0xdf09 */
    OTHER,        /* 0xdf0a */
    OTHER,        /* 0xdf0b */
    OTHER,        /* 0xdf0c */
    OTHER,        /* 0xdf0d */
    OTHER,        /* 0xdf0e */
    OTHER,        /* 0xdf0f */
    OTHER,        /* 0xdf10 */
    OTHER,        /* 0xdf11 */
    OTHER,        /* 0xdf12 */
    OTHER,        /* 0xdf13 */
    OTHER,        /* 0xdf14 */
    OTHER,        /* 0xdf15 */
    OTHER,        /* 0xdf16 */
    OTHER,        /* 0xdf17 */
    OTHER,        /* 0xdf18 */
    OTHER,        /* 0xdf19 */
    OTHER,        /* 0xdf1a */
    OTHER,        /* 0xdf1b */
    OTHER,        /* 0xdf1c */
    OTHER,        /* 0xdf1d */
    OTHER,        /* 0xdf1e */
    OTHER,        /* 0xdf1f */
    OTHER,        /* 0xdf20 */
    OTHER,        /* 0xdf21 */
    OTHER,        /* 0xdf22 */
    OTHER,        /* 0xdf23 */
    OTHER,        /* 0xdf24 */
    OTHER,        /* 0xdf25 */
    OTHER,        /* 0xdf26 */
    OTHER,        /* 0xdf27 */
    OTHER,        /* 0xdf28 */
    OTHER,        /* 0xdf29 */
    OTHER,        /* 0xdf2a */
    OTHER,        /* 0xdf2b */
    OTHER,        /* 0xdf2c */
    OTHER,        /* 0xdf2d */
    OTHER,        /* 0xdf2e */
    OTHER,        /* 0xdf2f */
    OTHER,        /* 0xdf30 */
    OTHER,        /* 0xdf31 */
    OTHER,        /* 0xdf32 */
    OTHER,        /* 0xdf33 */
    OTHER,        /* 0xdf34 */
    OTHER,        /* 0xdf35 */
    OTHER,        /* 0xdf36 */
    OTHER,        /* 0xdf37 */
    OTHER,        /* 0xdf38 */
    OTHER,        /* 0xdf39 */
    OTHER,        /* 0xdf3a */
    OTHER,        /* 0xdf3b */
    OTHER,        /* 0xdf3c */
    OTHER,        /* 0xdf3d */
    OTHER,        /* 0xdf3e */
    OTHER,        /* 0xdf3f */
    OTHER,        /* 0xdf40 */
    OTHER,        /* 0xdf41 */
    OTHER,        /* 0xdf42 */
    OTHER,        /* 0xdf43 */
    OTHER,        /* 0xdf44 */
    OTHER,        /* 0xdf45 */
    OTHER,        /* 0xdf46 */
    OTHER,        /* 0xdf47 */
    OTHER,        /* 0xdf48 */
    OTHER,        /* 0xdf49 */
    OTHER,        /* 0xdf4a */
    OTHER,        /* 0xdf4b */
    OTHER,        /* 0xdf4c */
    OTHER,        /* 0xdf4d */
    OTHER,        /* 0xdf4e */
    OTHER,        /* 0xdf4f */
    OTHER,        /* 0xdf50 */
    OTHER,        /* 0xdf51 */
    OTHER,        /* 0xdf52 */
    OTHER,        /* 0xdf53 */
    OTHER,        /* 0xdf54 */
    OTHER,        /* 0xdf55 */
    OTHER,        /* 0xdf56 */
    OTHER,        /* 0xdf57 */
    OTHER,        /* 0xdf58 */
    OTHER,        /* 0xdf59 */
    OTHER,        /* 0xdf5a */
    OTHER,        /* 0xdf5b */
    OTHER,        /* 0xdf5c */
    OTHER,        /* 0xdf5d */
    OTHER,        /* 0xdf5e */
    OTHER,        /* 0xdf5f */
    OTHER,        /* 0xdf60 */
    OTHER,        /* 0xdf61 */
    OTHER,        /* 0xdf62 */
    OTHER,        /* 0xdf63 */
    OTHER,        /* 0xdf64 */
    OTHER,        /* 0xdf65 */
    OTHER,        /* 0xdf66 */
    OTHER,        /* 0xdf67 */
    OTHER,        /* 0xdf68 */
    OTHER,        /* 0xdf69 */
    OTHER,        /* 0xdf6a */
    OTHER,        /* 0xdf6b */
    OTHER,        /* 0xdf6c */
    OTHER,        /* 0xdf6d */
    OTHER,        /* 0xdf6e */
    OTHER,        /* 0xdf6f */
    OTHER,        /* 0xdf70 */
    OTHER,        /* 0xdf71 */
    OTHER,        /* 0xdf72 */
    OTHER,        /* 0xdf73 */
    OTHER,        /* 0xdf74 */
    OTHER,        /* 0xdf75 */
    OTHER,        /* 0xdf76 */
    OTHER,        /* 0xdf77 */
    OTHER,        /* 0xdf78 */
    OTHER,        /* 0xdf79 */
    OTHER,        /* 0xdf7a */
    OTHER,        /* 0xdf7b */
    OTHER,        /* 0xdf7c */
    OTHER,        /* 0xdf7d */
    OTHER,        /* 0xdf7e */
    OTHER,        /* 0xdf7f */
    OTHER,        /* 0xdf80 */
    OTHER,        /* 0xdf81 */
    OTHER,        /* 0xdf82 */
    OTHER,        /* 0xdf83 */
    OTHER,        /* 0xdf84 */
    OTHER,        /* 0xdf85 */
    OTHER,        /* 0xdf86 */
    OTHER,        /* 0xdf87 */
    OTHER,        /* 0xdf88 */
    OTHER,        /* 0xdf89 */
    OTHER,        /* 0xdf8a */
    OTHER,        /* 0xdf8b */
    OTHER,        /* 0xdf8c */
    OTHER,        /* 0xdf8d */
    OTHER,        /* 0xdf8e */
    OTHER,        /* 0xdf8f */
    OTHER,        /* 0xdf90 */
    OTHER,        /* 0xdf91 */
    OTHER,        /* 0xdf92 */
    OTHER,        /* 0xdf93 */
    OTHER,        /* 0xdf94 */
    OTHER,        /* 0xdf95 */
    OTHER,        /* 0xdf96 */
    OTHER,        /* 0xdf97 */
    OTHER,        /* 0xdf98 */
    OTHER,        /* 0xdf99 */
    OTHER,        /* 0xdf9a */
    OTHER,        /* 0xdf9b */
    OTHER,        /* 0xdf9c */
    OTHER,        /* 0xdf9d */
    OTHER,        /* 0xdf9e */
    OTHER,        /* 0xdf9f */
    OTHER,        /* 0xdfa0 */
    OTHER,        /* 0xdfa1 */
    OTHER,        /* 0xdfa2 */
    OTHER,        /* 0xdfa3 */
    OTHER,        /* 0xdfa4 */
    OTHER,        /* 0xdfa5 */
    OTHER,        /* 0xdfa6 */
    OTHER,        /* 0xdfa7 */
    OTHER,        /* 0xdfa8 */
    OTHER,        /* 0xdfa9 */
    OTHER,        /* 0xdfaa */
    OTHER,        /* 0xdfab */
    OTHER,        /* 0xdfac */
    OTHER,        /* 0xdfad */
    OTHER,        /* 0xdfae */
    OTHER,        /* 0xdfaf */
    OTHER,        /* 0xdfb0 */
    OTHER,        /* 0xdfb1 */
    OTHER,        /* 0xdfb2 */
    OTHER,        /* 0xdfb3 */
    OTHER,        /* 0xdfb4 */
    OTHER,        /* 0xdfb5 */
    OTHER,        /* 0xdfb6 */
    OTHER,        /* 0xdfb7 */
    OTHER,        /* 0xdfb8 */
    OTHER,        /* 0xdfb9 */
    OTHER,        /* 0xdfba */
    OTHER,        /* 0xdfbb */
    OTHER,        /* 0xdfbc */
    OTHER,        /* 0xdfbd */
    OTHER,        /* 0xdfbe */
    OTHER,        /* 0xdfbf */
    OTHER,        /* 0xdfc0 */
    OTHER,        /* 0xdfc1 */
    OTHER,        /* 0xdfc2 */
    OTHER,        /* 0xdfc3 */
    OTHER,        /* 0xdfc4 */
    OTHER,        /* 0xdfc5 */
    OTHER,        /* 0xdfc6 */
    OTHER,        /* 0xdfc7 */
    OTHER,        /* 0xdfc8 */
    OTHER,        /* 0xdfc9 */
    OTHER,        /* 0xdfca */
    OTHER,        /* 0xdfcb */
    OTHER,        /* 0xdfcc */
    OTHER,        /* 0xdfcd */
    OTHER,        /* 0xdfce */
    OTHER,        /* 0xdfcf */
    OTHER,        /* 0xdfd0 */
    OTHER,        /* 0xdfd1 */
    OTHER,        /* 0xdfd2 */
    OTHER,        /* 0xdfd3 */
    OTHER,        /* 0xdfd4 */
    OTHER,        /* 0xdfd5 */
    OTHER,        /* 0xdfd6 */
    OTHER,        /* 0xdfd7 */
    OTHER,        /* 0xdfd8 */
    OTHER,        /* 0xdfd9 */
    OTHER,        /* 0xdfda */
    OTHER,        /* 0xdfdb */
    OTHER,        /* 0xdfdc */
    OTHER,        /* 0xdfdd */
    OTHER,        /* 0xdfde */
    OTHER,        /* 0xdfdf */
    OTHER,        /* 0xdfe0 */
    OTHER,        /* 0xdfe1 */
    OTHER,        /* 0xdfe2 */
    OTHER,        /* 0xdfe3 */
    OTHER,        /* 0xdfe4 */
    OTHER,        /* 0xdfe5 */
    OTHER,        /* 0xdfe6 */
    OTHER,        /* 0xdfe7 */
    OTHER,        /* 0xdfe8 */
    OTHER,        /* 0xdfe9 */
    OTHER,        /* 0xdfea */
    OTHER,        /* 0xdfeb */
    OTHER,        /* 0xdfec */
    OTHER,        /* 0xdfed */
    OTHER,        /* 0xdfee */
    OTHER,        /* 0xdfef */
    OTHER,        /* 0xdff0 */
    OTHER,        /* 0xdff1 */
    OTHER,        /* 0xdff2 */
    OTHER,        /* 0xdff3 */
    OTHER,        /* 0xdff4 */
    OTHER,        /* 0xdff5 */
    OTHER,        /* 0xdff6 */
    OTHER,        /* 0xdff7 */
    OTHER,        /* 0xdff8 */
    OTHER,        /* 0xdff9 */
    OTHER,        /* 0xdffa */
    OTHER,        /* 0xdffb */
    OTHER,        /* 0xdffc */
    OTHER,        /* 0xdffd */
    OTHER,        /* 0xdffe */
    OTHER,        /* 0xdfff */
    OTHER,        /* 0xe000 */
    OTHER,        /* 0xe001 */
    OTHER,        /* 0xe002 */
    OTHER,        /* 0xe003 */
    OTHER,        /* 0xe004 */
    OTHER,        /* 0xe005 */
    OTHER,        /* 0xe006 */
    OTHER,        /* 0xe007 */
    OTHER,        /* 0xe008 */
    OTHER,        /* 0xe009 */
    OTHER,        /* 0xe00a */
    OTHER,        /* 0xe00b */
    OTHER,        /* 0xe00c */
    OTHER,        /* 0xe00d */
    OTHER,        /* 0xe00e */
    OTHER,        /* 0xe00f */
    OTHER,        /* 0xe010 */
    OTHER,        /* 0xe011 */
    OTHER,        /* 0xe012 */
    OTHER,        /* 0xe013 */
    OTHER,        /* 0xe014 */
    OTHER,        /* 0xe015 */
    OTHER,        /* 0xe016 */
    OTHER,        /* 0xe017 */
    OTHER,        /* 0xe018 */
    OTHER,        /* 0xe019 */
    OTHER,        /* 0xe01a */
    OTHER,        /* 0xe01b */
    OTHER,        /* 0xe01c */
    OTHER,        /* 0xe01d */
    OTHER,        /* 0xe01e */
    OTHER,        /* 0xe01f */
    OTHER,        /* 0xe020 */
    OTHER,        /* 0xe021 */
    OTHER,        /* 0xe022 */
    OTHER,        /* 0xe023 */
    OTHER,        /* 0xe024 */
    OTHER,        /* 0xe025 */
    OTHER,        /* 0xe026 */
    OTHER,        /* 0xe027 */
    OTHER,        /* 0xe028 */
    OTHER,        /* 0xe029 */
    OTHER,        /* 0xe02a */
    OTHER,        /* 0xe02b */
    OTHER,        /* 0xe02c */
    OTHER,        /* 0xe02d */
    OTHER,        /* 0xe02e */
    OTHER,        /* 0xe02f */
    OTHER,        /* 0xe030 */
    OTHER,        /* 0xe031 */
    OTHER,        /* 0xe032 */
    OTHER,        /* 0xe033 */
    OTHER,        /* 0xe034 */
    OTHER,        /* 0xe035 */
    OTHER,        /* 0xe036 */
    OTHER,        /* 0xe037 */
    OTHER,        /* 0xe038 */
    OTHER,        /* 0xe039 */
    OTHER,        /* 0xe03a */
    OTHER,        /* 0xe03b */
    OTHER,        /* 0xe03c */
    OTHER,        /* 0xe03d */
    OTHER,        /* 0xe03e */
    OTHER,        /* 0xe03f */
    OTHER,        /* 0xe040 */
    OTHER,        /* 0xe041 */
    OTHER,        /* 0xe042 */
    OTHER,        /* 0xe043 */
    OTHER,        /* 0xe044 */
    OTHER,        /* 0xe045 */
    OTHER,        /* 0xe046 */
    OTHER,        /* 0xe047 */
    OTHER,        /* 0xe048 */
    OTHER,        /* 0xe049 */
    OTHER,        /* 0xe04a */
    OTHER,        /* 0xe04b */
    OTHER,        /* 0xe04c */
    OTHER,        /* 0xe04d */
    OTHER,        /* 0xe04e */
    OTHER,        /* 0xe04f */
    OTHER,        /* 0xe050 */
    OTHER,        /* 0xe051 */
    OTHER,        /* 0xe052 */
    OTHER,        /* 0xe053 */
    OTHER,        /* 0xe054 */
    OTHER,        /* 0xe055 */
    OTHER,        /* 0xe056 */
    OTHER,        /* 0xe057 */
    OTHER,        /* 0xe058 */
    OTHER,        /* 0xe059 */
    OTHER,        /* 0xe05a */
    OTHER,        /* 0xe05b */
    OTHER,        /* 0xe05c */
    OTHER,        /* 0xe05d */
    OTHER,        /* 0xe05e */
    OTHER,        /* 0xe05f */
    OTHER,        /* 0xe060 */
    OTHER,        /* 0xe061 */
    OTHER,        /* 0xe062 */
    OTHER,        /* 0xe063 */
    OTHER,        /* 0xe064 */
    OTHER,        /* 0xe065 */
    OTHER,        /* 0xe066 */
    OTHER,        /* 0xe067 */
    OTHER,        /* 0xe068 */
    OTHER,        /* 0xe069 */
    OTHER,        /* 0xe06a */
    OTHER,        /* 0xe06b */
    OTHER,        /* 0xe06c */
    OTHER,        /* 0xe06d */
    OTHER,        /* 0xe06e */
    OTHER,        /* 0xe06f */
    OTHER,        /* 0xe070 */
    OTHER,        /* 0xe071 */
    OTHER,        /* 0xe072 */
    OTHER,        /* 0xe073 */
    OTHER,        /* 0xe074 */
    OTHER,        /* 0xe075 */
    OTHER,        /* 0xe076 */
    OTHER,        /* 0xe077 */
    OTHER,        /* 0xe078 */
    OTHER,        /* 0xe079 */
    OTHER,        /* 0xe07a */
    OTHER,        /* 0xe07b */
    OTHER,        /* 0xe07c */
    OTHER,        /* 0xe07d */
    OTHER,        /* 0xe07e */
    OTHER,        /* 0xe07f */
    OTHER,        /* 0xe080 */
    OTHER,        /* 0xe081 */
    OTHER,        /* 0xe082 */
    OTHER,        /* 0xe083 */
    OTHER,        /* 0xe084 */
    OTHER,        /* 0xe085 */
    OTHER,        /* 0xe086 */
    OTHER,        /* 0xe087 */
    OTHER,        /* 0xe088 */
    OTHER,        /* 0xe089 */
    OTHER,        /* 0xe08a */
    OTHER,        /* 0xe08b */
    OTHER,        /* 0xe08c */
    OTHER,        /* 0xe08d */
    OTHER,        /* 0xe08e */
    OTHER,        /* 0xe08f */
    OTHER,        /* 0xe090 */
    OTHER,        /* 0xe091 */
    OTHER,        /* 0xe092 */
    OTHER,        /* 0xe093 */
    OTHER,        /* 0xe094 */
    OTHER,        /* 0xe095 */
    OTHER,        /* 0xe096 */
    OTHER,        /* 0xe097 */
    OTHER,        /* 0xe098 */
    OTHER,        /* 0xe099 */
    OTHER,        /* 0xe09a */
    OTHER,        /* 0xe09b */
    OTHER,        /* 0xe09c */
    OTHER,        /* 0xe09d */
    OTHER,        /* 0xe09e */
    OTHER,        /* 0xe09f */
    OTHER,        /* 0xe0a0 */
    OTHER,        /* 0xe0a1 */
    OTHER,        /* 0xe0a2 */
    OTHER,        /* 0xe0a3 */
    OTHER,        /* 0xe0a4 */
    OTHER,        /* 0xe0a5 */
    OTHER,        /* 0xe0a6 */
    OTHER,        /* 0xe0a7 */
    OTHER,        /* 0xe0a8 */
    OTHER,        /* 0xe0a9 */
    OTHER,        /* 0xe0aa */
    OTHER,        /* 0xe0ab */
    OTHER,        /* 0xe0ac */
    OTHER,        /* 0xe0ad */
    OTHER,        /* 0xe0ae */
    OTHER,        /* 0xe0af */
    OTHER,        /* 0xe0b0 */
    OTHER,        /* 0xe0b1 */
    OTHER,        /* 0xe0b2 */
    OTHER,        /* 0xe0b3 */
    OTHER,        /* 0xe0b4 */
    OTHER,        /* 0xe0b5 */
    OTHER,        /* 0xe0b6 */
    OTHER,        /* 0xe0b7 */
    OTHER,        /* 0xe0b8 */
    OTHER,        /* 0xe0b9 */
    OTHER,        /* 0xe0ba */
    OTHER,        /* 0xe0bb */
    OTHER,        /* 0xe0bc */
    OTHER,        /* 0xe0bd */
    OTHER,        /* 0xe0be */
    OTHER,        /* 0xe0bf */
    OTHER,        /* 0xe0c0 */
    OTHER,        /* 0xe0c1 */
    OTHER,        /* 0xe0c2 */
    OTHER,        /* 0xe0c3 */
    OTHER,        /* 0xe0c4 */
    OTHER,        /* 0xe0c5 */
    OTHER,        /* 0xe0c6 */
    OTHER,        /* 0xe0c7 */
    OTHER,        /* 0xe0c8 */
    OTHER,        /* 0xe0c9 */
    OTHER,        /* 0xe0ca */
    OTHER,        /* 0xe0cb */
    OTHER,        /* 0xe0cc */
    OTHER,        /* 0xe0cd */
    OTHER,        /* 0xe0ce */
    OTHER,        /* 0xe0cf */
    OTHER,        /* 0xe0d0 */
    OTHER,        /* 0xe0d1 */
    OTHER,        /* 0xe0d2 */
    OTHER,        /* 0xe0d3 */
    OTHER,        /* 0xe0d4 */
    OTHER,        /* 0xe0d5 */
    OTHER,        /* 0xe0d6 */
    OTHER,        /* 0xe0d7 */
    OTHER,        /* 0xe0d8 */
    OTHER,        /* 0xe0d9 */
    OTHER,        /* 0xe0da */
    OTHER,        /* 0xe0db */
    OTHER,        /* 0xe0dc */
    OTHER,        /* 0xe0dd */
    OTHER,        /* 0xe0de */
    OTHER,        /* 0xe0df */
    OTHER,        /* 0xe0e0 */
    OTHER,        /* 0xe0e1 */
    OTHER,        /* 0xe0e2 */
    OTHER,        /* 0xe0e3 */
    OTHER,        /* 0xe0e4 */
    OTHER,        /* 0xe0e5 */
    OTHER,        /* 0xe0e6 */
    OTHER,        /* 0xe0e7 */
    OTHER,        /* 0xe0e8 */
    OTHER,        /* 0xe0e9 */
    OTHER,        /* 0xe0ea */
    OTHER,        /* 0xe0eb */
    OTHER,        /* 0xe0ec */
    OTHER,        /* 0xe0ed */
    OTHER,        /* 0xe0ee */
    OTHER,        /* 0xe0ef */
    OTHER,        /* 0xe0f0 */
    OTHER,        /* 0xe0f1 */
    OTHER,        /* 0xe0f2 */
    OTHER,        /* 0xe0f3 */
    OTHER,        /* 0xe0f4 */
    OTHER,        /* 0xe0f5 */
    OTHER,        /* 0xe0f6 */
    OTHER,        /* 0xe0f7 */
    OTHER,        /* 0xe0f8 */
    OTHER,        /* 0xe0f9 */
    OTHER,        /* 0xe0fa */
    OTHER,        /* 0xe0fb */
    OTHER,        /* 0xe0fc */
    OTHER,        /* 0xe0fd */
    OTHER,        /* 0xe0fe */
    OTHER,        /* 0xe0ff */
    OTHER,        /* 0xe100 */
    OTHER,        /* 0xe101 */
    OTHER,        /* 0xe102 */
    OTHER,        /* 0xe103 */
    OTHER,        /* 0xe104 */
    OTHER,        /* 0xe105 */
    OTHER,        /* 0xe106 */
    OTHER,        /* 0xe107 */
    OTHER,        /* 0xe108 */
    OTHER,        /* 0xe109 */
    OTHER,        /* 0xe10a */
    OTHER,        /* 0xe10b */
    OTHER,        /* 0xe10c */
    OTHER,        /* 0xe10d */
    OTHER,        /* 0xe10e */
    OTHER,        /* 0xe10f */
    OTHER,        /* 0xe110 */
    OTHER,        /* 0xe111 */
    OTHER,        /* 0xe112 */
    OTHER,        /* 0xe113 */
    OTHER,        /* 0xe114 */
    OTHER,        /* 0xe115 */
    OTHER,        /* 0xe116 */
    OTHER,        /* 0xe117 */
    OTHER,        /* 0xe118 */
    OTHER,        /* 0xe119 */
    OTHER,        /* 0xe11a */
    OTHER,        /* 0xe11b */
    OTHER,        /* 0xe11c */
    OTHER,        /* 0xe11d */
    OTHER,        /* 0xe11e */
    OTHER,        /* 0xe11f */
    OTHER,        /* 0xe120 */
    OTHER,        /* 0xe121 */
    OTHER,        /* 0xe122 */
    OTHER,        /* 0xe123 */
    OTHER,        /* 0xe124 */
    OTHER,        /* 0xe125 */
    OTHER,        /* 0xe126 */
    OTHER,        /* 0xe127 */
    OTHER,        /* 0xe128 */
    OTHER,        /* 0xe129 */
    OTHER,        /* 0xe12a */
    OTHER,        /* 0xe12b */
    OTHER,        /* 0xe12c */
    OTHER,        /* 0xe12d */
    OTHER,        /* 0xe12e */
    OTHER,        /* 0xe12f */
    OTHER,        /* 0xe130 */
    OTHER,        /* 0xe131 */
    OTHER,        /* 0xe132 */
    OTHER,        /* 0xe133 */
    OTHER,        /* 0xe134 */
    OTHER,        /* 0xe135 */
    OTHER,        /* 0xe136 */
    OTHER,        /* 0xe137 */
    OTHER,        /* 0xe138 */
    OTHER,        /* 0xe139 */
    OTHER,        /* 0xe13a */
    OTHER,        /* 0xe13b */
    OTHER,        /* 0xe13c */
    OTHER,        /* 0xe13d */
    OTHER,        /* 0xe13e */
    OTHER,        /* 0xe13f */
    OTHER,        /* 0xe140 */
    OTHER,        /* 0xe141 */
    OTHER,        /* 0xe142 */
    OTHER,        /* 0xe143 */
    OTHER,        /* 0xe144 */
    OTHER,        /* 0xe145 */
    OTHER,        /* 0xe146 */
    OTHER,        /* 0xe147 */
    OTHER,        /* 0xe148 */
    OTHER,        /* 0xe149 */
    OTHER,        /* 0xe14a */
    OTHER,        /* 0xe14b */
    OTHER,        /* 0xe14c */
    OTHER,        /* 0xe14d */
    OTHER,        /* 0xe14e */
    OTHER,        /* 0xe14f */
    OTHER,        /* 0xe150 */
    OTHER,        /* 0xe151 */
    OTHER,        /* 0xe152 */
    OTHER,        /* 0xe153 */
    OTHER,        /* 0xe154 */
    OTHER,        /* 0xe155 */
    OTHER,        /* 0xe156 */
    OTHER,        /* 0xe157 */
    OTHER,        /* 0xe158 */
    OTHER,        /* 0xe159 */
    OTHER,        /* 0xe15a */
    OTHER,        /* 0xe15b */
    OTHER,        /* 0xe15c */
    OTHER,        /* 0xe15d */
    OTHER,        /* 0xe15e */
    OTHER,        /* 0xe15f */
    OTHER,        /* 0xe160 */
    OTHER,        /* 0xe161 */
    OTHER,        /* 0xe162 */
    OTHER,        /* 0xe163 */
    OTHER,        /* 0xe164 */
    OTHER,        /* 0xe165 */
    OTHER,        /* 0xe166 */
    OTHER,        /* 0xe167 */
    OTHER,        /* 0xe168 */
    OTHER,        /* 0xe169 */
    OTHER,        /* 0xe16a */
    OTHER,        /* 0xe16b */
    OTHER,        /* 0xe16c */
    OTHER,        /* 0xe16d */
    OTHER,        /* 0xe16e */
    OTHER,        /* 0xe16f */
    OTHER,        /* 0xe170 */
    OTHER,        /* 0xe171 */
    OTHER,        /* 0xe172 */
    OTHER,        /* 0xe173 */
    OTHER,        /* 0xe174 */
    OTHER,        /* 0xe175 */
    OTHER,        /* 0xe176 */
    OTHER,        /* 0xe177 */
    OTHER,        /* 0xe178 */
    OTHER,        /* 0xe179 */
    OTHER,        /* 0xe17a */
    OTHER,        /* 0xe17b */
    OTHER,        /* 0xe17c */
    OTHER,        /* 0xe17d */
    OTHER,        /* 0xe17e */
    OTHER,        /* 0xe17f */
    OTHER,        /* 0xe180 */
    OTHER,        /* 0xe181 */
    OTHER,        /* 0xe182 */
    OTHER,        /* 0xe183 */
    OTHER,        /* 0xe184 */
    OTHER,        /* 0xe185 */
    OTHER,        /* 0xe186 */
    OTHER,        /* 0xe187 */
    OTHER,        /* 0xe188 */
    OTHER,        /* 0xe189 */
    OTHER,        /* 0xe18a */
    OTHER,        /* 0xe18b */
    OTHER,        /* 0xe18c */
    OTHER,        /* 0xe18d */
    OTHER,        /* 0xe18e */
    OTHER,        /* 0xe18f */
    OTHER,        /* 0xe190 */
    OTHER,        /* 0xe191 */
    OTHER,        /* 0xe192 */
    OTHER,        /* 0xe193 */
    OTHER,        /* 0xe194 */
    OTHER,        /* 0xe195 */
    OTHER,        /* 0xe196 */
    OTHER,        /* 0xe197 */
    OTHER,        /* 0xe198 */
    OTHER,        /* 0xe199 */
    OTHER,        /* 0xe19a */
    OTHER,        /* 0xe19b */
    OTHER,        /* 0xe19c */
    OTHER,        /* 0xe19d */
    OTHER,        /* 0xe19e */
    OTHER,        /* 0xe19f */
    OTHER,        /* 0xe1a0 */
    OTHER,        /* 0xe1a1 */
    OTHER,        /* 0xe1a2 */
    OTHER,        /* 0xe1a3 */
    OTHER,        /* 0xe1a4 */
    OTHER,        /* 0xe1a5 */
    OTHER,        /* 0xe1a6 */
    OTHER,        /* 0xe1a7 */
    OTHER,        /* 0xe1a8 */
    OTHER,        /* 0xe1a9 */
    OTHER,        /* 0xe1aa */
    OTHER,        /* 0xe1ab */
    OTHER,        /* 0xe1ac */
    OTHER,        /* 0xe1ad */
    OTHER,        /* 0xe1ae */
    OTHER,        /* 0xe1af */
    OTHER,        /* 0xe1b0 */
    OTHER,        /* 0xe1b1 */
    OTHER,        /* 0xe1b2 */
    OTHER,        /* 0xe1b3 */
    OTHER,        /* 0xe1b4 */
    OTHER,        /* 0xe1b5 */
    OTHER,        /* 0xe1b6 */
    OTHER,        /* 0xe1b7 */
    OTHER,        /* 0xe1b8 */
    OTHER,        /* 0xe1b9 */
    OTHER,        /* 0xe1ba */
    OTHER,        /* 0xe1bb */
    OTHER,        /* 0xe1bc */
    OTHER,        /* 0xe1bd */
    OTHER,        /* 0xe1be */
    OTHER,        /* 0xe1bf */
    OTHER,        /* 0xe1c0 */
    OTHER,        /* 0xe1c1 */
    OTHER,        /* 0xe1c2 */
    OTHER,        /* 0xe1c3 */
    OTHER,        /* 0xe1c4 */
    OTHER,        /* 0xe1c5 */
    OTHER,        /* 0xe1c6 */
    OTHER,        /* 0xe1c7 */
    OTHER,        /* 0xe1c8 */
    OTHER,        /* 0xe1c9 */
    OTHER,        /* 0xe1ca */
    OTHER,        /* 0xe1cb */
    OTHER,        /* 0xe1cc */
    OTHER,        /* 0xe1cd */
    OTHER,        /* 0xe1ce */
    OTHER,        /* 0xe1cf */
    OTHER,        /* 0xe1d0 */
    OTHER,        /* 0xe1d1 */
    OTHER,        /* 0xe1d2 */
    OTHER,        /* 0xe1d3 */
    OTHER,        /* 0xe1d4 */
    OTHER,        /* 0xe1d5 */
    OTHER,        /* 0xe1d6 */
    OTHER,        /* 0xe1d7 */
    OTHER,        /* 0xe1d8 */
    OTHER,        /* 0xe1d9 */
    OTHER,        /* 0xe1da */
    OTHER,        /* 0xe1db */
    OTHER,        /* 0xe1dc */
    OTHER,        /* 0xe1dd */
    OTHER,        /* 0xe1de */
    OTHER,        /* 0xe1df */
    OTHER,        /* 0xe1e0 */
    OTHER,        /* 0xe1e1 */
    OTHER,        /* 0xe1e2 */
    OTHER,        /* 0xe1e3 */
    OTHER,        /* 0xe1e4 */
    OTHER,        /* 0xe1e5 */
    OTHER,        /* 0xe1e6 */
    OTHER,        /* 0xe1e7 */
    OTHER,        /* 0xe1e8 */
    OTHER,        /* 0xe1e9 */
    OTHER,        /* 0xe1ea */
    OTHER,        /* 0xe1eb */
    OTHER,        /* 0xe1ec */
    OTHER,        /* 0xe1ed */
    OTHER,        /* 0xe1ee */
    OTHER,        /* 0xe1ef */
    OTHER,        /* 0xe1f0 */
    OTHER,        /* 0xe1f1 */
    OTHER,        /* 0xe1f2 */
    OTHER,        /* 0xe1f3 */
    OTHER,        /* 0xe1f4 */
    OTHER,        /* 0xe1f5 */
    OTHER,        /* 0xe1f6 */
    OTHER,        /* 0xe1f7 */
    OTHER,        /* 0xe1f8 */
    OTHER,        /* 0xe1f9 */
    OTHER,        /* 0xe1fa */
    OTHER,        /* 0xe1fb */
    OTHER,        /* 0xe1fc */
    OTHER,        /* 0xe1fd */
    OTHER,        /* 0xe1fe */
    OTHER,        /* 0xe1ff */
    OTHER,        /* 0xe200 */
    OTHER,        /* 0xe201 */
    OTHER,        /* 0xe202 */
    OTHER,        /* 0xe203 */
    OTHER,        /* 0xe204 */
    OTHER,        /* 0xe205 */
    OTHER,        /* 0xe206 */
    OTHER,        /* 0xe207 */
    OTHER,        /* 0xe208 */
    OTHER,        /* 0xe209 */
    OTHER,        /* 0xe20a */
    OTHER,        /* 0xe20b */
    OTHER,        /* 0xe20c */
    OTHER,        /* 0xe20d */
    OTHER,        /* 0xe20e */
    OTHER,        /* 0xe20f */
    OTHER,        /* 0xe210 */
    OTHER,        /* 0xe211 */
    OTHER,        /* 0xe212 */
    OTHER,        /* 0xe213 */
    OTHER,        /* 0xe214 */
    OTHER,        /* 0xe215 */
    OTHER,        /* 0xe216 */
    OTHER,        /* 0xe217 */
    OTHER,        /* 0xe218 */
    OTHER,        /* 0xe219 */
    OTHER,        /* 0xe21a */
    OTHER,        /* 0xe21b */
    OTHER,        /* 0xe21c */
    OTHER,        /* 0xe21d */
    OTHER,        /* 0xe21e */
    OTHER,        /* 0xe21f */
    OTHER,        /* 0xe220 */
    OTHER,        /* 0xe221 */
    OTHER,        /* 0xe222 */
    OTHER,        /* 0xe223 */
    OTHER,        /* 0xe224 */
    OTHER,        /* 0xe225 */
    OTHER,        /* 0xe226 */
    OTHER,        /* 0xe227 */
    OTHER,        /* 0xe228 */
    OTHER,        /* 0xe229 */
    OTHER,        /* 0xe22a */
    OTHER,        /* 0xe22b */
    OTHER,        /* 0xe22c */
    OTHER,        /* 0xe22d */
    OTHER,        /* 0xe22e */
    OTHER,        /* 0xe22f */
    OTHER,        /* 0xe230 */
    OTHER,        /* 0xe231 */
    OTHER,        /* 0xe232 */
    OTHER,        /* 0xe233 */
    OTHER,        /* 0xe234 */
    OTHER,        /* 0xe235 */
    OTHER,        /* 0xe236 */
    OTHER,        /* 0xe237 */
    OTHER,        /* 0xe238 */
    OTHER,        /* 0xe239 */
    OTHER,        /* 0xe23a */
    OTHER,        /* 0xe23b */
    OTHER,        /* 0xe23c */
    OTHER,        /* 0xe23d */
    OTHER,        /* 0xe23e */
    OTHER,        /* 0xe23f */
    OTHER,        /* 0xe240 */
    OTHER,        /* 0xe241 */
    OTHER,        /* 0xe242 */
    OTHER,        /* 0xe243 */
    OTHER,        /* 0xe244 */
    OTHER,        /* 0xe245 */
    OTHER,        /* 0xe246 */
    OTHER,        /* 0xe247 */
    OTHER,        /* 0xe248 */
    OTHER,        /* 0xe249 */
    OTHER,        /* 0xe24a */
    OTHER,        /* 0xe24b */
    OTHER,        /* 0xe24c */
    OTHER,        /* 0xe24d */
    OTHER,        /* 0xe24e */
    OTHER,        /* 0xe24f */
    OTHER,        /* 0xe250 */
    OTHER,        /* 0xe251 */
    OTHER,        /* 0xe252 */
    OTHER,        /* 0xe253 */
    OTHER,        /* 0xe254 */
    OTHER,        /* 0xe255 */
    OTHER,        /* 0xe256 */
    OTHER,        /* 0xe257 */
    OTHER,        /* 0xe258 */
    OTHER,        /* 0xe259 */
    OTHER,        /* 0xe25a */
    OTHER,        /* 0xe25b */
    OTHER,        /* 0xe25c */
    OTHER,        /* 0xe25d */
    OTHER,        /* 0xe25e */
    OTHER,        /* 0xe25f */
    OTHER,        /* 0xe260 */
    OTHER,        /* 0xe261 */
    OTHER,        /* 0xe262 */
    OTHER,        /* 0xe263 */
    OTHER,        /* 0xe264 */
    OTHER,        /* 0xe265 */
    OTHER,        /* 0xe266 */
    OTHER,        /* 0xe267 */
    OTHER,        /* 0xe268 */
    OTHER,        /* 0xe269 */
    OTHER,        /* 0xe26a */
    OTHER,        /* 0xe26b */
    OTHER,        /* 0xe26c */
    OTHER,        /* 0xe26d */
    OTHER,        /* 0xe26e */
    OTHER,        /* 0xe26f */
    OTHER,        /* 0xe270 */
    OTHER,        /* 0xe271 */
    OTHER,        /* 0xe272 */
    OTHER,        /* 0xe273 */
    OTHER,        /* 0xe274 */
    OTHER,        /* 0xe275 */
    OTHER,        /* 0xe276 */
    OTHER,        /* 0xe277 */
    OTHER,        /* 0xe278 */
    OTHER,        /* 0xe279 */
    OTHER,        /* 0xe27a */
    OTHER,        /* 0xe27b */
    OTHER,        /* 0xe27c */
    OTHER,        /* 0xe27d */
    OTHER,        /* 0xe27e */
    OTHER,        /* 0xe27f */
    OTHER,        /* 0xe280 */
    OTHER,        /* 0xe281 */
    OTHER,        /* 0xe282 */
    OTHER,        /* 0xe283 */
    OTHER,        /* 0xe284 */
    OTHER,        /* 0xe285 */
    OTHER,        /* 0xe286 */
    OTHER,        /* 0xe287 */
    OTHER,        /* 0xe288 */
    OTHER,        /* 0xe289 */
    OTHER,        /* 0xe28a */
    OTHER,        /* 0xe28b */
    OTHER,        /* 0xe28c */
    OTHER,        /* 0xe28d */
    OTHER,        /* 0xe28e */
    OTHER,        /* 0xe28f */
    OTHER,        /* 0xe290 */
    OTHER,        /* 0xe291 */
    OTHER,        /* 0xe292 */
    OTHER,        /* 0xe293 */
    OTHER,        /* 0xe294 */
    OTHER,        /* 0xe295 */
    OTHER,        /* 0xe296 */
    OTHER,        /* 0xe297 */
    OTHER,        /* 0xe298 */
    OTHER,        /* 0xe299 */
    OTHER,        /* 0xe29a */
    OTHER,        /* 0xe29b */
    OTHER,        /* 0xe29c */
    OTHER,        /* 0xe29d */
    OTHER,        /* 0xe29e */
    OTHER,        /* 0xe29f */
    OTHER,        /* 0xe2a0 */
    OTHER,        /* 0xe2a1 */
    OTHER,        /* 0xe2a2 */
    OTHER,        /* 0xe2a3 */
    OTHER,        /* 0xe2a4 */
    OTHER,        /* 0xe2a5 */
    OTHER,        /* 0xe2a6 */
    OTHER,        /* 0xe2a7 */
    OTHER,        /* 0xe2a8 */
    OTHER,        /* 0xe2a9 */
    OTHER,        /* 0xe2aa */
    OTHER,        /* 0xe2ab */
    OTHER,        /* 0xe2ac */
    OTHER,        /* 0xe2ad */
    OTHER,        /* 0xe2ae */
    OTHER,        /* 0xe2af */
    OTHER,        /* 0xe2b0 */
    OTHER,        /* 0xe2b1 */
    OTHER,        /* 0xe2b2 */
    OTHER,        /* 0xe2b3 */
    OTHER,        /* 0xe2b4 */
    OTHER,        /* 0xe2b5 */
    OTHER,        /* 0xe2b6 */
    OTHER,        /* 0xe2b7 */
    OTHER,        /* 0xe2b8 */
    OTHER,        /* 0xe2b9 */
    OTHER,        /* 0xe2ba */
    OTHER,        /* 0xe2bb */
    OTHER,        /* 0xe2bc */
    OTHER,        /* 0xe2bd */
    OTHER,        /* 0xe2be */
    OTHER,        /* 0xe2bf */
    OTHER,        /* 0xe2c0 */
    OTHER,        /* 0xe2c1 */
    OTHER,        /* 0xe2c2 */
    OTHER,        /* 0xe2c3 */
    OTHER,        /* 0xe2c4 */
    OTHER,        /* 0xe2c5 */
    OTHER,        /* 0xe2c6 */
    OTHER,        /* 0xe2c7 */
    OTHER,        /* 0xe2c8 */
    OTHER,        /* 0xe2c9 */
    OTHER,        /* 0xe2ca */
    OTHER,        /* 0xe2cb */
    OTHER,        /* 0xe2cc */
    OTHER,        /* 0xe2cd */
    OTHER,        /* 0xe2ce */
    OTHER,        /* 0xe2cf */
    OTHER,        /* 0xe2d0 */
    OTHER,        /* 0xe2d1 */
    OTHER,        /* 0xe2d2 */
    OTHER,        /* 0xe2d3 */
    OTHER,        /* 0xe2d4 */
    OTHER,        /* 0xe2d5 */
    OTHER,        /* 0xe2d6 */
    OTHER,        /* 0xe2d7 */
    OTHER,        /* 0xe2d8 */
    OTHER,        /* 0xe2d9 */
    OTHER,        /* 0xe2da */
    OTHER,        /* 0xe2db */
    OTHER,        /* 0xe2dc */
    OTHER,        /* 0xe2dd */
    OTHER,        /* 0xe2de */
    OTHER,        /* 0xe2df */
    OTHER,        /* 0xe2e0 */
    OTHER,        /* 0xe2e1 */
    OTHER,        /* 0xe2e2 */
    OTHER,        /* 0xe2e3 */
    OTHER,        /* 0xe2e4 */
    OTHER,        /* 0xe2e5 */
    OTHER,        /* 0xe2e6 */
    OTHER,        /* 0xe2e7 */
    OTHER,        /* 0xe2e8 */
    OTHER,        /* 0xe2e9 */
    OTHER,        /* 0xe2ea */
    OTHER,        /* 0xe2eb */
    OTHER,        /* 0xe2ec */
    OTHER,        /* 0xe2ed */
    OTHER,        /* 0xe2ee */
    OTHER,        /* 0xe2ef */
    OTHER,        /* 0xe2f0 */
    OTHER,        /* 0xe2f1 */
    OTHER,        /* 0xe2f2 */
    OTHER,        /* 0xe2f3 */
    OTHER,        /* 0xe2f4 */
    OTHER,        /* 0xe2f5 */
    OTHER,        /* 0xe2f6 */
    OTHER,        /* 0xe2f7 */
    OTHER,        /* 0xe2f8 */
    OTHER,        /* 0xe2f9 */
    OTHER,        /* 0xe2fa */
    OTHER,        /* 0xe2fb */
    OTHER,        /* 0xe2fc */
    OTHER,        /* 0xe2fd */
    OTHER,        /* 0xe2fe */
    OTHER,        /* 0xe2ff */
    OTHER,        /* 0xe300 */
    OTHER,        /* 0xe301 */
    OTHER,        /* 0xe302 */
    OTHER,        /* 0xe303 */
    OTHER,        /* 0xe304 */
    OTHER,        /* 0xe305 */
    OTHER,        /* 0xe306 */
    OTHER,        /* 0xe307 */
    OTHER,        /* 0xe308 */
    OTHER,        /* 0xe309 */
    OTHER,        /* 0xe30a */
    OTHER,        /* 0xe30b */
    OTHER,        /* 0xe30c */
    OTHER,        /* 0xe30d */
    OTHER,        /* 0xe30e */
    OTHER,        /* 0xe30f */
    OTHER,        /* 0xe310 */
    OTHER,        /* 0xe311 */
    OTHER,        /* 0xe312 */
    OTHER,        /* 0xe313 */
    OTHER,        /* 0xe314 */
    OTHER,        /* 0xe315 */
    OTHER,        /* 0xe316 */
    OTHER,        /* 0xe317 */
    OTHER,        /* 0xe318 */
    OTHER,        /* 0xe319 */
    OTHER,        /* 0xe31a */
    OTHER,        /* 0xe31b */
    OTHER,        /* 0xe31c */
    OTHER,        /* 0xe31d */
    OTHER,        /* 0xe31e */
    OTHER,        /* 0xe31f */
    OTHER,        /* 0xe320 */
    OTHER,        /* 0xe321 */
    OTHER,        /* 0xe322 */
    OTHER,        /* 0xe323 */
    OTHER,        /* 0xe324 */
    OTHER,        /* 0xe325 */
    OTHER,        /* 0xe326 */
    OTHER,        /* 0xe327 */
    OTHER,        /* 0xe328 */
    OTHER,        /* 0xe329 */
    OTHER,        /* 0xe32a */
    OTHER,        /* 0xe32b */
    OTHER,        /* 0xe32c */
    OTHER,        /* 0xe32d */
    OTHER,        /* 0xe32e */
    OTHER,        /* 0xe32f */
    OTHER,        /* 0xe330 */
    OTHER,        /* 0xe331 */
    OTHER,        /* 0xe332 */
    OTHER,        /* 0xe333 */
    OTHER,        /* 0xe334 */
    OTHER,        /* 0xe335 */
    OTHER,        /* 0xe336 */
    OTHER,        /* 0xe337 */
    OTHER,        /* 0xe338 */
    OTHER,        /* 0xe339 */
    OTHER,        /* 0xe33a */
    OTHER,        /* 0xe33b */
    OTHER,        /* 0xe33c */
    OTHER,        /* 0xe33d */
    OTHER,        /* 0xe33e */
    OTHER,        /* 0xe33f */
    OTHER,        /* 0xe340 */
    OTHER,        /* 0xe341 */
    OTHER,        /* 0xe342 */
    OTHER,        /* 0xe343 */
    OTHER,        /* 0xe344 */
    OTHER,        /* 0xe345 */
    OTHER,        /* 0xe346 */
    OTHER,        /* 0xe347 */
    OTHER,        /* 0xe348 */
    OTHER,        /* 0xe349 */
    OTHER,        /* 0xe34a */
    OTHER,        /* 0xe34b */
    OTHER,        /* 0xe34c */
    OTHER,        /* 0xe34d */
    OTHER,        /* 0xe34e */
    OTHER,        /* 0xe34f */
    OTHER,        /* 0xe350 */
    OTHER,        /* 0xe351 */
    OTHER,        /* 0xe352 */
    OTHER,        /* 0xe353 */
    OTHER,        /* 0xe354 */
    OTHER,        /* 0xe355 */
    OTHER,        /* 0xe356 */
    OTHER,        /* 0xe357 */
    OTHER,        /* 0xe358 */
    OTHER,        /* 0xe359 */
    OTHER,        /* 0xe35a */
    OTHER,        /* 0xe35b */
    OTHER,        /* 0xe35c */
    OTHER,        /* 0xe35d */
    OTHER,        /* 0xe35e */
    OTHER,        /* 0xe35f */
    OTHER,        /* 0xe360 */
    OTHER,        /* 0xe361 */
    OTHER,        /* 0xe362 */
    OTHER,        /* 0xe363 */
    OTHER,        /* 0xe364 */
    OTHER,        /* 0xe365 */
    OTHER,        /* 0xe366 */
    OTHER,        /* 0xe367 */
    OTHER,        /* 0xe368 */
    OTHER,        /* 0xe369 */
    OTHER,        /* 0xe36a */
    OTHER,        /* 0xe36b */
    OTHER,        /* 0xe36c */
    OTHER,        /* 0xe36d */
    OTHER,        /* 0xe36e */
    OTHER,        /* 0xe36f */
    OTHER,        /* 0xe370 */
    OTHER,        /* 0xe371 */
    OTHER,        /* 0xe372 */
    OTHER,        /* 0xe373 */
    OTHER,        /* 0xe374 */
    OTHER,        /* 0xe375 */
    OTHER,        /* 0xe376 */
    OTHER,        /* 0xe377 */
    OTHER,        /* 0xe378 */
    OTHER,        /* 0xe379 */
    OTHER,        /* 0xe37a */
    OTHER,        /* 0xe37b */
    OTHER,        /* 0xe37c */
    OTHER,        /* 0xe37d */
    OTHER,        /* 0xe37e */
    OTHER,        /* 0xe37f */
    OTHER,        /* 0xe380 */
    OTHER,        /* 0xe381 */
    OTHER,        /* 0xe382 */
    OTHER,        /* 0xe383 */
    OTHER,        /* 0xe384 */
    OTHER,        /* 0xe385 */
    OTHER,        /* 0xe386 */
    OTHER,        /* 0xe387 */
    OTHER,        /* 0xe388 */
    OTHER,        /* 0xe389 */
    OTHER,        /* 0xe38a */
    OTHER,        /* 0xe38b */
    OTHER,        /* 0xe38c */
    OTHER,        /* 0xe38d */
    OTHER,        /* 0xe38e */
    OTHER,        /* 0xe38f */
    OTHER,        /* 0xe390 */
    OTHER,        /* 0xe391 */
    OTHER,        /* 0xe392 */
    OTHER,        /* 0xe393 */
    OTHER,        /* 0xe394 */
    OTHER,        /* 0xe395 */
    OTHER,        /* 0xe396 */
    OTHER,        /* 0xe397 */
    OTHER,        /* 0xe398 */
    OTHER,        /* 0xe399 */
    OTHER,        /* 0xe39a */
    OTHER,        /* 0xe39b */
    OTHER,        /* 0xe39c */
    OTHER,        /* 0xe39d */
    OTHER,        /* 0xe39e */
    OTHER,        /* 0xe39f */
    OTHER,        /* 0xe3a0 */
    OTHER,        /* 0xe3a1 */
    OTHER,        /* 0xe3a2 */
    OTHER,        /* 0xe3a3 */
    OTHER,        /* 0xe3a4 */
    OTHER,        /* 0xe3a5 */
    OTHER,        /* 0xe3a6 */
    OTHER,        /* 0xe3a7 */
    OTHER,        /* 0xe3a8 */
    OTHER,        /* 0xe3a9 */
    OTHER,        /* 0xe3aa */
    OTHER,        /* 0xe3ab */
    OTHER,        /* 0xe3ac */
    OTHER,        /* 0xe3ad */
    OTHER,        /* 0xe3ae */
    OTHER,        /* 0xe3af */
    OTHER,        /* 0xe3b0 */
    OTHER,        /* 0xe3b1 */
    OTHER,        /* 0xe3b2 */
    OTHER,        /* 0xe3b3 */
    OTHER,        /* 0xe3b4 */
    OTHER,        /* 0xe3b5 */
    OTHER,        /* 0xe3b6 */
    OTHER,        /* 0xe3b7 */
    OTHER,        /* 0xe3b8 */
    OTHER,        /* 0xe3b9 */
    OTHER,        /* 0xe3ba */
    OTHER,        /* 0xe3bb */
    OTHER,        /* 0xe3bc */
    OTHER,        /* 0xe3bd */
    OTHER,        /* 0xe3be */
    OTHER,        /* 0xe3bf */
    OTHER,        /* 0xe3c0 */
    OTHER,        /* 0xe3c1 */
    OTHER,        /* 0xe3c2 */
    OTHER,        /* 0xe3c3 */
    OTHER,        /* 0xe3c4 */
    OTHER,        /* 0xe3c5 */
    OTHER,        /* 0xe3c6 */
    OTHER,        /* 0xe3c7 */
    OTHER,        /* 0xe3c8 */
    OTHER,        /* 0xe3c9 */
    OTHER,        /* 0xe3ca */
    OTHER,        /* 0xe3cb */
    OTHER,        /* 0xe3cc */
    OTHER,        /* 0xe3cd */
    OTHER,        /* 0xe3ce */
    OTHER,        /* 0xe3cf */
    OTHER,        /* 0xe3d0 */
    OTHER,        /* 0xe3d1 */
    OTHER,        /* 0xe3d2 */
    OTHER,        /* 0xe3d3 */
    OTHER,        /* 0xe3d4 */
    OTHER,        /* 0xe3d5 */
    OTHER,        /* 0xe3d6 */
    OTHER,        /* 0xe3d7 */
    OTHER,        /* 0xe3d8 */
    OTHER,        /* 0xe3d9 */
    OTHER,        /* 0xe3da */
    OTHER,        /* 0xe3db */
    OTHER,        /* 0xe3dc */
    OTHER,        /* 0xe3dd */
    OTHER,        /* 0xe3de */
    OTHER,        /* 0xe3df */
    OTHER,        /* 0xe3e0 */
    OTHER,        /* 0xe3e1 */
    OTHER,        /* 0xe3e2 */
    OTHER,        /* 0xe3e3 */
    OTHER,        /* 0xe3e4 */
    OTHER,        /* 0xe3e5 */
    OTHER,        /* 0xe3e6 */
    OTHER,        /* 0xe3e7 */
    OTHER,        /* 0xe3e8 */
    OTHER,        /* 0xe3e9 */
    OTHER,        /* 0xe3ea */
    OTHER,        /* 0xe3eb */
    OTHER,        /* 0xe3ec */
    OTHER,        /* 0xe3ed */
    OTHER,        /* 0xe3ee */
    OTHER,        /* 0xe3ef */
    OTHER,        /* 0xe3f0 */
    OTHER,        /* 0xe3f1 */
    OTHER,        /* 0xe3f2 */
    OTHER,        /* 0xe3f3 */
    OTHER,        /* 0xe3f4 */
    OTHER,        /* 0xe3f5 */
    OTHER,        /* 0xe3f6 */
    OTHER,        /* 0xe3f7 */
    OTHER,        /* 0xe3f8 */
    OTHER,        /* 0xe3f9 */
    OTHER,        /* 0xe3fa */
    OTHER,        /* 0xe3fb */
    OTHER,        /* 0xe3fc */
    OTHER,        /* 0xe3fd */
    OTHER,        /* 0xe3fe */
    OTHER,        /* 0xe3ff */
    OTHER,        /* 0xe400 */
    OTHER,        /* 0xe401 */
    OTHER,        /* 0xe402 */
    OTHER,        /* 0xe403 */
    OTHER,        /* 0xe404 */
    OTHER,        /* 0xe405 */
    OTHER,        /* 0xe406 */
    OTHER,        /* 0xe407 */
    OTHER,        /* 0xe408 */
    OTHER,        /* 0xe409 */
    OTHER,        /* 0xe40a */
    OTHER,        /* 0xe40b */
    OTHER,        /* 0xe40c */
    OTHER,        /* 0xe40d */
    OTHER,        /* 0xe40e */
    OTHER,        /* 0xe40f */
    OTHER,        /* 0xe410 */
    OTHER,        /* 0xe411 */
    OTHER,        /* 0xe412 */
    OTHER,        /* 0xe413 */
    OTHER,        /* 0xe414 */
    OTHER,        /* 0xe415 */
    OTHER,        /* 0xe416 */
    OTHER,        /* 0xe417 */
    OTHER,        /* 0xe418 */
    OTHER,        /* 0xe419 */
    OTHER,        /* 0xe41a */
    OTHER,        /* 0xe41b */
    OTHER,        /* 0xe41c */
    OTHER,        /* 0xe41d */
    OTHER,        /* 0xe41e */
    OTHER,        /* 0xe41f */
    OTHER,        /* 0xe420 */
    OTHER,        /* 0xe421 */
    OTHER,        /* 0xe422 */
    OTHER,        /* 0xe423 */
    OTHER,        /* 0xe424 */
    OTHER,        /* 0xe425 */
    OTHER,        /* 0xe426 */
    OTHER,        /* 0xe427 */
    OTHER,        /* 0xe428 */
    OTHER,        /* 0xe429 */
    OTHER,        /* 0xe42a */
    OTHER,        /* 0xe42b */
    OTHER,        /* 0xe42c */
    OTHER,        /* 0xe42d */
    OTHER,        /* 0xe42e */
    OTHER,        /* 0xe42f */
    OTHER,        /* 0xe430 */
    OTHER,        /* 0xe431 */
    OTHER,        /* 0xe432 */
    OTHER,        /* 0xe433 */
    OTHER,        /* 0xe434 */
    OTHER,        /* 0xe435 */
    OTHER,        /* 0xe436 */
    OTHER,        /* 0xe437 */
    OTHER,        /* 0xe438 */
    OTHER,        /* 0xe439 */
    OTHER,        /* 0xe43a */
    OTHER,        /* 0xe43b */
    OTHER,        /* 0xe43c */
    OTHER,        /* 0xe43d */
    OTHER,        /* 0xe43e */
    OTHER,        /* 0xe43f */
    OTHER,        /* 0xe440 */
    OTHER,        /* 0xe441 */
    OTHER,        /* 0xe442 */
    OTHER,        /* 0xe443 */
    OTHER,        /* 0xe444 */
    OTHER,        /* 0xe445 */
    OTHER,        /* 0xe446 */
    OTHER,        /* 0xe447 */
    OTHER,        /* 0xe448 */
    OTHER,        /* 0xe449 */
    OTHER,        /* 0xe44a */
    OTHER,        /* 0xe44b */
    OTHER,        /* 0xe44c */
    OTHER,        /* 0xe44d */
    OTHER,        /* 0xe44e */
    OTHER,        /* 0xe44f */
    OTHER,        /* 0xe450 */
    OTHER,        /* 0xe451 */
    OTHER,        /* 0xe452 */
    OTHER,        /* 0xe453 */
    OTHER,        /* 0xe454 */
    OTHER,        /* 0xe455 */
    OTHER,        /* 0xe456 */
    OTHER,        /* 0xe457 */
    OTHER,        /* 0xe458 */
    OTHER,        /* 0xe459 */
    OTHER,        /* 0xe45a */
    OTHER,        /* 0xe45b */
    OTHER,        /* 0xe45c */
    OTHER,        /* 0xe45d */
    OTHER,        /* 0xe45e */
    OTHER,        /* 0xe45f */
    OTHER,        /* 0xe460 */
    OTHER,        /* 0xe461 */
    OTHER,        /* 0xe462 */
    OTHER,        /* 0xe463 */
    OTHER,        /* 0xe464 */
    OTHER,        /* 0xe465 */
    OTHER,        /* 0xe466 */
    OTHER,        /* 0xe467 */
    OTHER,        /* 0xe468 */
    OTHER,        /* 0xe469 */
    OTHER,        /* 0xe46a */
    OTHER,        /* 0xe46b */
    OTHER,        /* 0xe46c */
    OTHER,        /* 0xe46d */
    OTHER,        /* 0xe46e */
    OTHER,        /* 0xe46f */
    OTHER,        /* 0xe470 */
    OTHER,        /* 0xe471 */
    OTHER,        /* 0xe472 */
    OTHER,        /* 0xe473 */
    OTHER,        /* 0xe474 */
    OTHER,        /* 0xe475 */
    OTHER,        /* 0xe476 */
    OTHER,        /* 0xe477 */
    OTHER,        /* 0xe478 */
    OTHER,        /* 0xe479 */
    OTHER,        /* 0xe47a */
    OTHER,        /* 0xe47b */
    OTHER,        /* 0xe47c */
    OTHER,        /* 0xe47d */
    OTHER,        /* 0xe47e */
    OTHER,        /* 0xe47f */
    OTHER,        /* 0xe480 */
    OTHER,        /* 0xe481 */
    OTHER,        /* 0xe482 */
    OTHER,        /* 0xe483 */
    OTHER,        /* 0xe484 */
    OTHER,        /* 0xe485 */
    OTHER,        /* 0xe486 */
    OTHER,        /* 0xe487 */
    OTHER,        /* 0xe488 */
    OTHER,        /* 0xe489 */
    OTHER,        /* 0xe48a */
    OTHER,        /* 0xe48b */
    OTHER,        /* 0xe48c */
    OTHER,        /* 0xe48d */
    OTHER,        /* 0xe48e */
    OTHER,        /* 0xe48f */
    OTHER,        /* 0xe490 */
    OTHER,        /* 0xe491 */
    OTHER,        /* 0xe492 */
    OTHER,        /* 0xe493 */
    OTHER,        /* 0xe494 */
    OTHER,        /* 0xe495 */
    OTHER,        /* 0xe496 */
    OTHER,        /* 0xe497 */
    OTHER,        /* 0xe498 */
    OTHER,        /* 0xe499 */
    OTHER,        /* 0xe49a */
    OTHER,        /* 0xe49b */
    OTHER,        /* 0xe49c */
    OTHER,        /* 0xe49d */
    OTHER,        /* 0xe49e */
    OTHER,        /* 0xe49f */
    OTHER,        /* 0xe4a0 */
    OTHER,        /* 0xe4a1 */
    OTHER,        /* 0xe4a2 */
    OTHER,        /* 0xe4a3 */
    OTHER,        /* 0xe4a4 */
    OTHER,        /* 0xe4a5 */
    OTHER,        /* 0xe4a6 */
    OTHER,        /* 0xe4a7 */
    OTHER,        /* 0xe4a8 */
    OTHER,        /* 0xe4a9 */
    OTHER,        /* 0xe4aa */
    OTHER,        /* 0xe4ab */
    OTHER,        /* 0xe4ac */
    OTHER,        /* 0xe4ad */
    OTHER,        /* 0xe4ae */
    OTHER,        /* 0xe4af */
    OTHER,        /* 0xe4b0 */
    OTHER,        /* 0xe4b1 */
    OTHER,        /* 0xe4b2 */
    OTHER,        /* 0xe4b3 */
    OTHER,        /* 0xe4b4 */
    OTHER,        /* 0xe4b5 */
    OTHER,        /* 0xe4b6 */
    OTHER,        /* 0xe4b7 */
    OTHER,        /* 0xe4b8 */
    OTHER,        /* 0xe4b9 */
    OTHER,        /* 0xe4ba */
    OTHER,        /* 0xe4bb */
    OTHER,        /* 0xe4bc */
    OTHER,        /* 0xe4bd */
    OTHER,        /* 0xe4be */
    OTHER,        /* 0xe4bf */
    OTHER,        /* 0xe4c0 */
    OTHER,        /* 0xe4c1 */
    OTHER,        /* 0xe4c2 */
    OTHER,        /* 0xe4c3 */
    OTHER,        /* 0xe4c4 */
    OTHER,        /* 0xe4c5 */
    OTHER,        /* 0xe4c6 */
    OTHER,        /* 0xe4c7 */
    OTHER,        /* 0xe4c8 */
    OTHER,        /* 0xe4c9 */
    OTHER,        /* 0xe4ca */
    OTHER,        /* 0xe4cb */
    OTHER,        /* 0xe4cc */
    OTHER,        /* 0xe4cd */
    OTHER,        /* 0xe4ce */
    OTHER,        /* 0xe4cf */
    OTHER,        /* 0xe4d0 */
    OTHER,        /* 0xe4d1 */
    OTHER,        /* 0xe4d2 */
    OTHER,        /* 0xe4d3 */
    OTHER,        /* 0xe4d4 */
    OTHER,        /* 0xe4d5 */
    OTHER,        /* 0xe4d6 */
    OTHER,        /* 0xe4d7 */
    OTHER,        /* 0xe4d8 */
    OTHER,        /* 0xe4d9 */
    OTHER,        /* 0xe4da */
    OTHER,        /* 0xe4db */
    OTHER,        /* 0xe4dc */
    OTHER,        /* 0xe4dd */
    OTHER,        /* 0xe4de */
    OTHER,        /* 0xe4df */
    OTHER,        /* 0xe4e0 */
    OTHER,        /* 0xe4e1 */
    OTHER,        /* 0xe4e2 */
    OTHER,        /* 0xe4e3 */
    OTHER,        /* 0xe4e4 */
    OTHER,        /* 0xe4e5 */
    OTHER,        /* 0xe4e6 */
    OTHER,        /* 0xe4e7 */
    OTHER,        /* 0xe4e8 */
    OTHER,        /* 0xe4e9 */
    OTHER,        /* 0xe4ea */
    OTHER,        /* 0xe4eb */
    OTHER,        /* 0xe4ec */
    OTHER,        /* 0xe4ed */
    OTHER,        /* 0xe4ee */
    OTHER,        /* 0xe4ef */
    OTHER,        /* 0xe4f0 */
    OTHER,        /* 0xe4f1 */
    OTHER,        /* 0xe4f2 */
    OTHER,        /* 0xe4f3 */
    OTHER,        /* 0xe4f4 */
    OTHER,        /* 0xe4f5 */
    OTHER,        /* 0xe4f6 */
    OTHER,        /* 0xe4f7 */
    OTHER,        /* 0xe4f8 */
    OTHER,        /* 0xe4f9 */
    OTHER,        /* 0xe4fa */
    OTHER,        /* 0xe4fb */
    OTHER,        /* 0xe4fc */
    OTHER,        /* 0xe4fd */
    OTHER,        /* 0xe4fe */
    OTHER,        /* 0xe4ff */
    OTHER,        /* 0xe500 */
    OTHER,        /* 0xe501 */
    OTHER,        /* 0xe502 */
    OTHER,        /* 0xe503 */
    OTHER,        /* 0xe504 */
    OTHER,        /* 0xe505 */
    OTHER,        /* 0xe506 */
    OTHER,        /* 0xe507 */
    OTHER,        /* 0xe508 */
    OTHER,        /* 0xe509 */
    OTHER,        /* 0xe50a */
    OTHER,        /* 0xe50b */
    OTHER,        /* 0xe50c */
    OTHER,        /* 0xe50d */
    OTHER,        /* 0xe50e */
    OTHER,        /* 0xe50f */
    OTHER,        /* 0xe510 */
    OTHER,        /* 0xe511 */
    OTHER,        /* 0xe512 */
    OTHER,        /* 0xe513 */
    OTHER,        /* 0xe514 */
    OTHER,        /* 0xe515 */
    OTHER,        /* 0xe516 */
    OTHER,        /* 0xe517 */
    OTHER,        /* 0xe518 */
    OTHER,        /* 0xe519 */
    OTHER,        /* 0xe51a */
    OTHER,        /* 0xe51b */
    OTHER,        /* 0xe51c */
    OTHER,        /* 0xe51d */
    OTHER,        /* 0xe51e */
    OTHER,        /* 0xe51f */
    OTHER,        /* 0xe520 */
    OTHER,        /* 0xe521 */
    OTHER,        /* 0xe522 */
    OTHER,        /* 0xe523 */
    OTHER,        /* 0xe524 */
    OTHER,        /* 0xe525 */
    OTHER,        /* 0xe526 */
    OTHER,        /* 0xe527 */
    OTHER,        /* 0xe528 */
    OTHER,        /* 0xe529 */
    OTHER,        /* 0xe52a */
    OTHER,        /* 0xe52b */
    OTHER,        /* 0xe52c */
    OTHER,        /* 0xe52d */
    OTHER,        /* 0xe52e */
    OTHER,        /* 0xe52f */
    OTHER,        /* 0xe530 */
    OTHER,        /* 0xe531 */
    OTHER,        /* 0xe532 */
    OTHER,        /* 0xe533 */
    OTHER,        /* 0xe534 */
    OTHER,        /* 0xe535 */
    OTHER,        /* 0xe536 */
    OTHER,        /* 0xe537 */
    OTHER,        /* 0xe538 */
    OTHER,        /* 0xe539 */
    OTHER,        /* 0xe53a */
    OTHER,        /* 0xe53b */
    OTHER,        /* 0xe53c */
    OTHER,        /* 0xe53d */
    OTHER,        /* 0xe53e */
    OTHER,        /* 0xe53f */
    OTHER,        /* 0xe540 */
    OTHER,        /* 0xe541 */
    OTHER,        /* 0xe542 */
    OTHER,        /* 0xe543 */
    OTHER,        /* 0xe544 */
    OTHER,        /* 0xe545 */
    OTHER,        /* 0xe546 */
    OTHER,        /* 0xe547 */
    OTHER,        /* 0xe548 */
    OTHER,        /* 0xe549 */
    OTHER,        /* 0xe54a */
    OTHER,        /* 0xe54b */
    OTHER,        /* 0xe54c */
    OTHER,        /* 0xe54d */
    OTHER,        /* 0xe54e */
    OTHER,        /* 0xe54f */
    OTHER,        /* 0xe550 */
    OTHER,        /* 0xe551 */
    OTHER,        /* 0xe552 */
    OTHER,        /* 0xe553 */
    OTHER,        /* 0xe554 */
    OTHER,        /* 0xe555 */
    OTHER,        /* 0xe556 */
    OTHER,        /* 0xe557 */
    OTHER,        /* 0xe558 */
    OTHER,        /* 0xe559 */
    OTHER,        /* 0xe55a */
    OTHER,        /* 0xe55b */
    OTHER,        /* 0xe55c */
    OTHER,        /* 0xe55d */
    OTHER,        /* 0xe55e */
    OTHER,        /* 0xe55f */
    OTHER,        /* 0xe560 */
    OTHER,        /* 0xe561 */
    OTHER,        /* 0xe562 */
    OTHER,        /* 0xe563 */
    OTHER,        /* 0xe564 */
    OTHER,        /* 0xe565 */
    OTHER,        /* 0xe566 */
    OTHER,        /* 0xe567 */
    OTHER,        /* 0xe568 */
    OTHER,        /* 0xe569 */
    OTHER,        /* 0xe56a */
    OTHER,        /* 0xe56b */
    OTHER,        /* 0xe56c */
    OTHER,        /* 0xe56d */
    OTHER,        /* 0xe56e */
    OTHER,        /* 0xe56f */
    OTHER,        /* 0xe570 */
    OTHER,        /* 0xe571 */
    OTHER,        /* 0xe572 */
    OTHER,        /* 0xe573 */
    OTHER,        /* 0xe574 */
    OTHER,        /* 0xe575 */
    OTHER,        /* 0xe576 */
    OTHER,        /* 0xe577 */
    OTHER,        /* 0xe578 */
    OTHER,        /* 0xe579 */
    OTHER,        /* 0xe57a */
    OTHER,        /* 0xe57b */
    OTHER,        /* 0xe57c */
    OTHER,        /* 0xe57d */
    OTHER,        /* 0xe57e */
    OTHER,        /* 0xe57f */
    OTHER,        /* 0xe580 */
    OTHER,        /* 0xe581 */
    OTHER,        /* 0xe582 */
    OTHER,        /* 0xe583 */
    OTHER,        /* 0xe584 */
    OTHER,        /* 0xe585 */
    OTHER,        /* 0xe586 */
    OTHER,        /* 0xe587 */
    OTHER,        /* 0xe588 */
    OTHER,        /* 0xe589 */
    OTHER,        /* 0xe58a */
    OTHER,        /* 0xe58b */
    OTHER,        /* 0xe58c */
    OTHER,        /* 0xe58d */
    OTHER,        /* 0xe58e */
    OTHER,        /* 0xe58f */
    OTHER,        /* 0xe590 */
    OTHER,        /* 0xe591 */
    OTHER,        /* 0xe592 */
    OTHER,        /* 0xe593 */
    OTHER,        /* 0xe594 */
    OTHER,        /* 0xe595 */
    OTHER,        /* 0xe596 */
    OTHER,        /* 0xe597 */
    OTHER,        /* 0xe598 */
    OTHER,        /* 0xe599 */
    OTHER,        /* 0xe59a */
    OTHER,        /* 0xe59b */
    OTHER,        /* 0xe59c */
    OTHER,        /* 0xe59d */
    OTHER,        /* 0xe59e */
    OTHER,        /* 0xe59f */
    OTHER,        /* 0xe5a0 */
    OTHER,        /* 0xe5a1 */
    OTHER,        /* 0xe5a2 */
    OTHER,        /* 0xe5a3 */
    OTHER,        /* 0xe5a4 */
    OTHER,        /* 0xe5a5 */
    OTHER,        /* 0xe5a6 */
    OTHER,        /* 0xe5a7 */
    OTHER,        /* 0xe5a8 */
    OTHER,        /* 0xe5a9 */
    OTHER,        /* 0xe5aa */
    OTHER,        /* 0xe5ab */
    OTHER,        /* 0xe5ac */
    OTHER,        /* 0xe5ad */
    OTHER,        /* 0xe5ae */
    OTHER,        /* 0xe5af */
    OTHER,        /* 0xe5b0 */
    OTHER,        /* 0xe5b1 */
    OTHER,        /* 0xe5b2 */
    OTHER,        /* 0xe5b3 */
    OTHER,        /* 0xe5b4 */
    OTHER,        /* 0xe5b5 */
    OTHER,        /* 0xe5b6 */
    OTHER,        /* 0xe5b7 */
    OTHER,        /* 0xe5b8 */
    OTHER,        /* 0xe5b9 */
    OTHER,        /* 0xe5ba */
    OTHER,        /* 0xe5bb */
    OTHER,        /* 0xe5bc */
    OTHER,        /* 0xe5bd */
    OTHER,        /* 0xe5be */
    OTHER,        /* 0xe5bf */
    OTHER,        /* 0xe5c0 */
    OTHER,        /* 0xe5c1 */
    OTHER,        /* 0xe5c2 */
    OTHER,        /* 0xe5c3 */
    OTHER,        /* 0xe5c4 */
    OTHER,        /* 0xe5c5 */
    OTHER,        /* 0xe5c6 */
    OTHER,        /* 0xe5c7 */
    OTHER,        /* 0xe5c8 */
    OTHER,        /* 0xe5c9 */
    OTHER,        /* 0xe5ca */
    OTHER,        /* 0xe5cb */
    OTHER,        /* 0xe5cc */
    OTHER,        /* 0xe5cd */
    OTHER,        /* 0xe5ce */
    OTHER,        /* 0xe5cf */
    OTHER,        /* 0xe5d0 */
    OTHER,        /* 0xe5d1 */
    OTHER,        /* 0xe5d2 */
    OTHER,        /* 0xe5d3 */
    OTHER,        /* 0xe5d4 */
    OTHER,        /* 0xe5d5 */
    OTHER,        /* 0xe5d6 */
    OTHER,        /* 0xe5d7 */
    OTHER,        /* 0xe5d8 */
    OTHER,        /* 0xe5d9 */
    OTHER,        /* 0xe5da */
    OTHER,        /* 0xe5db */
    OTHER,        /* 0xe5dc */
    OTHER,        /* 0xe5dd */
    OTHER,        /* 0xe5de */
    OTHER,        /* 0xe5df */
    OTHER,        /* 0xe5e0 */
    OTHER,        /* 0xe5e1 */
    OTHER,        /* 0xe5e2 */
    OTHER,        /* 0xe5e3 */
    OTHER,        /* 0xe5e4 */
    OTHER,        /* 0xe5e5 */
    OTHER,        /* 0xe5e6 */
    OTHER,        /* 0xe5e7 */
    OTHER,        /* 0xe5e8 */
    OTHER,        /* 0xe5e9 */
    OTHER,        /* 0xe5ea */
    OTHER,        /* 0xe5eb */
    OTHER,        /* 0xe5ec */
    OTHER,        /* 0xe5ed */
    OTHER,        /* 0xe5ee */
    OTHER,        /* 0xe5ef */
    OTHER,        /* 0xe5f0 */
    OTHER,        /* 0xe5f1 */
    OTHER,        /* 0xe5f2 */
    OTHER,        /* 0xe5f3 */
    OTHER,        /* 0xe5f4 */
    OTHER,        /* 0xe5f5 */
    OTHER,        /* 0xe5f6 */
    OTHER,        /* 0xe5f7 */
    OTHER,        /* 0xe5f8 */
    OTHER,        /* 0xe5f9 */
    OTHER,        /* 0xe5fa */
    OTHER,        /* 0xe5fb */
    OTHER,        /* 0xe5fc */
    OTHER,        /* 0xe5fd */
    OTHER,        /* 0xe5fe */
    OTHER,        /* 0xe5ff */
    OTHER,        /* 0xe600 */
    OTHER,        /* 0xe601 */
    OTHER,        /* 0xe602 */
    OTHER,        /* 0xe603 */
    OTHER,        /* 0xe604 */
    OTHER,        /* 0xe605 */
    OTHER,        /* 0xe606 */
    OTHER,        /* 0xe607 */
    OTHER,        /* 0xe608 */
    OTHER,        /* 0xe609 */
    OTHER,        /* 0xe60a */
    OTHER,        /* 0xe60b */
    OTHER,        /* 0xe60c */
    OTHER,        /* 0xe60d */
    OTHER,        /* 0xe60e */
    OTHER,        /* 0xe60f */
    OTHER,        /* 0xe610 */
    OTHER,        /* 0xe611 */
    OTHER,        /* 0xe612 */
    OTHER,        /* 0xe613 */
    OTHER,        /* 0xe614 */
    OTHER,        /* 0xe615 */
    OTHER,        /* 0xe616 */
    OTHER,        /* 0xe617 */
    OTHER,        /* 0xe618 */
    OTHER,        /* 0xe619 */
    OTHER,        /* 0xe61a */
    OTHER,        /* 0xe61b */
    OTHER,        /* 0xe61c */
    OTHER,        /* 0xe61d */
    OTHER,        /* 0xe61e */
    OTHER,        /* 0xe61f */
    OTHER,        /* 0xe620 */
    OTHER,        /* 0xe621 */
    OTHER,        /* 0xe622 */
    OTHER,        /* 0xe623 */
    OTHER,        /* 0xe624 */
    OTHER,        /* 0xe625 */
    OTHER,        /* 0xe626 */
    OTHER,        /* 0xe627 */
    OTHER,        /* 0xe628 */
    OTHER,        /* 0xe629 */
    OTHER,        /* 0xe62a */
    OTHER,        /* 0xe62b */
    OTHER,        /* 0xe62c */
    OTHER,        /* 0xe62d */
    OTHER,        /* 0xe62e */
    OTHER,        /* 0xe62f */
    OTHER,        /* 0xe630 */
    OTHER,        /* 0xe631 */
    OTHER,        /* 0xe632 */
    OTHER,        /* 0xe633 */
    OTHER,        /* 0xe634 */
    OTHER,        /* 0xe635 */
    OTHER,        /* 0xe636 */
    OTHER,        /* 0xe637 */
    OTHER,        /* 0xe638 */
    OTHER,        /* 0xe639 */
    OTHER,        /* 0xe63a */
    OTHER,        /* 0xe63b */
    OTHER,        /* 0xe63c */
    OTHER,        /* 0xe63d */
    OTHER,        /* 0xe63e */
    OTHER,        /* 0xe63f */
    OTHER,        /* 0xe640 */
    OTHER,        /* 0xe641 */
    OTHER,        /* 0xe642 */
    OTHER,        /* 0xe643 */
    OTHER,        /* 0xe644 */
    OTHER,        /* 0xe645 */
    OTHER,        /* 0xe646 */
    OTHER,        /* 0xe647 */
    OTHER,        /* 0xe648 */
    OTHER,        /* 0xe649 */
    OTHER,        /* 0xe64a */
    OTHER,        /* 0xe64b */
    OTHER,        /* 0xe64c */
    OTHER,        /* 0xe64d */
    OTHER,        /* 0xe64e */
    OTHER,        /* 0xe64f */
    OTHER,        /* 0xe650 */
    OTHER,        /* 0xe651 */
    OTHER,        /* 0xe652 */
    OTHER,        /* 0xe653 */
    OTHER,        /* 0xe654 */
    OTHER,        /* 0xe655 */
    OTHER,        /* 0xe656 */
    OTHER,        /* 0xe657 */
    OTHER,        /* 0xe658 */
    OTHER,        /* 0xe659 */
    OTHER,        /* 0xe65a */
    OTHER,        /* 0xe65b */
    OTHER,        /* 0xe65c */
    OTHER,        /* 0xe65d */
    OTHER,        /* 0xe65e */
    OTHER,        /* 0xe65f */
    OTHER,        /* 0xe660 */
    OTHER,        /* 0xe661 */
    OTHER,        /* 0xe662 */
    OTHER,        /* 0xe663 */
    OTHER,        /* 0xe664 */
    OTHER,        /* 0xe665 */
    OTHER,        /* 0xe666 */
    OTHER,        /* 0xe667 */
    OTHER,        /* 0xe668 */
    OTHER,        /* 0xe669 */
    OTHER,        /* 0xe66a */
    OTHER,        /* 0xe66b */
    OTHER,        /* 0xe66c */
    OTHER,        /* 0xe66d */
    OTHER,        /* 0xe66e */
    OTHER,        /* 0xe66f */
    OTHER,        /* 0xe670 */
    OTHER,        /* 0xe671 */
    OTHER,        /* 0xe672 */
    OTHER,        /* 0xe673 */
    OTHER,        /* 0xe674 */
    OTHER,        /* 0xe675 */
    OTHER,        /* 0xe676 */
    OTHER,        /* 0xe677 */
    OTHER,        /* 0xe678 */
    OTHER,        /* 0xe679 */
    OTHER,        /* 0xe67a */
    OTHER,        /* 0xe67b */
    OTHER,        /* 0xe67c */
    OTHER,        /* 0xe67d */
    OTHER,        /* 0xe67e */
    OTHER,        /* 0xe67f */
    OTHER,        /* 0xe680 */
    OTHER,        /* 0xe681 */
    OTHER,        /* 0xe682 */
    OTHER,        /* 0xe683 */
    OTHER,        /* 0xe684 */
    OTHER,        /* 0xe685 */
    OTHER,        /* 0xe686 */
    OTHER,        /* 0xe687 */
    OTHER,        /* 0xe688 */
    OTHER,        /* 0xe689 */
    OTHER,        /* 0xe68a */
    OTHER,        /* 0xe68b */
    OTHER,        /* 0xe68c */
    OTHER,        /* 0xe68d */
    OTHER,        /* 0xe68e */
    OTHER,        /* 0xe68f */
    OTHER,        /* 0xe690 */
    OTHER,        /* 0xe691 */
    OTHER,        /* 0xe692 */
    OTHER,        /* 0xe693 */
    OTHER,        /* 0xe694 */
    OTHER,        /* 0xe695 */
    OTHER,        /* 0xe696 */
    OTHER,        /* 0xe697 */
    OTHER,        /* 0xe698 */
    OTHER,        /* 0xe699 */
    OTHER,        /* 0xe69a */
    OTHER,        /* 0xe69b */
    OTHER,        /* 0xe69c */
    OTHER,        /* 0xe69d */
    OTHER,        /* 0xe69e */
    OTHER,        /* 0xe69f */
    OTHER,        /* 0xe6a0 */
    OTHER,        /* 0xe6a1 */
    OTHER,        /* 0xe6a2 */
    OTHER,        /* 0xe6a3 */
    OTHER,        /* 0xe6a4 */
    OTHER,        /* 0xe6a5 */
    OTHER,        /* 0xe6a6 */
    OTHER,        /* 0xe6a7 */
    OTHER,        /* 0xe6a8 */
    OTHER,        /* 0xe6a9 */
    OTHER,        /* 0xe6aa */
    OTHER,        /* 0xe6ab */
    OTHER,        /* 0xe6ac */
    OTHER,        /* 0xe6ad */
    OTHER,        /* 0xe6ae */
    OTHER,        /* 0xe6af */
    OTHER,        /* 0xe6b0 */
    OTHER,        /* 0xe6b1 */
    OTHER,        /* 0xe6b2 */
    OTHER,        /* 0xe6b3 */
    OTHER,        /* 0xe6b4 */
    OTHER,        /* 0xe6b5 */
    OTHER,        /* 0xe6b6 */
    OTHER,        /* 0xe6b7 */
    OTHER,        /* 0xe6b8 */
    OTHER,        /* 0xe6b9 */
    OTHER,        /* 0xe6ba */
    OTHER,        /* 0xe6bb */
    OTHER,        /* 0xe6bc */
    OTHER,        /* 0xe6bd */
    OTHER,        /* 0xe6be */
    OTHER,        /* 0xe6bf */
    OTHER,        /* 0xe6c0 */
    OTHER,        /* 0xe6c1 */
    OTHER,        /* 0xe6c2 */
    OTHER,        /* 0xe6c3 */
    OTHER,        /* 0xe6c4 */
    OTHER,        /* 0xe6c5 */
    OTHER,        /* 0xe6c6 */
    OTHER,        /* 0xe6c7 */
    OTHER,        /* 0xe6c8 */
    OTHER,        /* 0xe6c9 */
    OTHER,        /* 0xe6ca */
    OTHER,        /* 0xe6cb */
    OTHER,        /* 0xe6cc */
    OTHER,        /* 0xe6cd */
    OTHER,        /* 0xe6ce */
    OTHER,        /* 0xe6cf */
    OTHER,        /* 0xe6d0 */
    OTHER,        /* 0xe6d1 */
    OTHER,        /* 0xe6d2 */
    OTHER,        /* 0xe6d3 */
    OTHER,        /* 0xe6d4 */
    OTHER,        /* 0xe6d5 */
    OTHER,        /* 0xe6d6 */
    OTHER,        /* 0xe6d7 */
    OTHER,        /* 0xe6d8 */
    OTHER,        /* 0xe6d9 */
    OTHER,        /* 0xe6da */
    OTHER,        /* 0xe6db */
    OTHER,        /* 0xe6dc */
    OTHER,        /* 0xe6dd */
    OTHER,        /* 0xe6de */
    OTHER,        /* 0xe6df */
    OTHER,        /* 0xe6e0 */
    OTHER,        /* 0xe6e1 */
    OTHER,        /* 0xe6e2 */
    OTHER,        /* 0xe6e3 */
    OTHER,        /* 0xe6e4 */
    OTHER,        /* 0xe6e5 */
    OTHER,        /* 0xe6e6 */
    OTHER,        /* 0xe6e7 */
    OTHER,        /* 0xe6e8 */
    OTHER,        /* 0xe6e9 */
    OTHER,        /* 0xe6ea */
    OTHER,        /* 0xe6eb */
    OTHER,        /* 0xe6ec */
    OTHER,        /* 0xe6ed */
    OTHER,        /* 0xe6ee */
    OTHER,        /* 0xe6ef */
    OTHER,        /* 0xe6f0 */
    OTHER,        /* 0xe6f1 */
    OTHER,        /* 0xe6f2 */
    OTHER,        /* 0xe6f3 */
    OTHER,        /* 0xe6f4 */
    OTHER,        /* 0xe6f5 */
    OTHER,        /* 0xe6f6 */
    OTHER,        /* 0xe6f7 */
    OTHER,        /* 0xe6f8 */
    OTHER,        /* 0xe6f9 */
    OTHER,        /* 0xe6fa */
    OTHER,        /* 0xe6fb */
    OTHER,        /* 0xe6fc */
    OTHER,        /* 0xe6fd */
    OTHER,        /* 0xe6fe */
    OTHER,        /* 0xe6ff */
    OTHER,        /* 0xe700 */
    OTHER,        /* 0xe701 */
    OTHER,        /* 0xe702 */
    OTHER,        /* 0xe703 */
    OTHER,        /* 0xe704 */
    OTHER,        /* 0xe705 */
    OTHER,        /* 0xe706 */
    OTHER,        /* 0xe707 */
    OTHER,        /* 0xe708 */
    OTHER,        /* 0xe709 */
    OTHER,        /* 0xe70a */
    OTHER,        /* 0xe70b */
    OTHER,        /* 0xe70c */
    OTHER,        /* 0xe70d */
    OTHER,        /* 0xe70e */
    OTHER,        /* 0xe70f */
    OTHER,        /* 0xe710 */
    OTHER,        /* 0xe711 */
    OTHER,        /* 0xe712 */
    OTHER,        /* 0xe713 */
    OTHER,        /* 0xe714 */
    OTHER,        /* 0xe715 */
    OTHER,        /* 0xe716 */
    OTHER,        /* 0xe717 */
    OTHER,        /* 0xe718 */
    OTHER,        /* 0xe719 */
    OTHER,        /* 0xe71a */
    OTHER,        /* 0xe71b */
    OTHER,        /* 0xe71c */
    OTHER,        /* 0xe71d */
    OTHER,        /* 0xe71e */
    OTHER,        /* 0xe71f */
    OTHER,        /* 0xe720 */
    OTHER,        /* 0xe721 */
    OTHER,        /* 0xe722 */
    OTHER,        /* 0xe723 */
    OTHER,        /* 0xe724 */
    OTHER,        /* 0xe725 */
    OTHER,        /* 0xe726 */
    OTHER,        /* 0xe727 */
    OTHER,        /* 0xe728 */
    OTHER,        /* 0xe729 */
    OTHER,        /* 0xe72a */
    OTHER,        /* 0xe72b */
    OTHER,        /* 0xe72c */
    OTHER,        /* 0xe72d */
    OTHER,        /* 0xe72e */
    OTHER,        /* 0xe72f */
    OTHER,        /* 0xe730 */
    OTHER,        /* 0xe731 */
    OTHER,        /* 0xe732 */
    OTHER,        /* 0xe733 */
    OTHER,        /* 0xe734 */
    OTHER,        /* 0xe735 */
    OTHER,        /* 0xe736 */
    OTHER,        /* 0xe737 */
    OTHER,        /* 0xe738 */
    OTHER,        /* 0xe739 */
    OTHER,        /* 0xe73a */
    OTHER,        /* 0xe73b */
    OTHER,        /* 0xe73c */
    OTHER,        /* 0xe73d */
    OTHER,        /* 0xe73e */
    OTHER,        /* 0xe73f */
    OTHER,        /* 0xe740 */
    OTHER,        /* 0xe741 */
    OTHER,        /* 0xe742 */
    OTHER,        /* 0xe743 */
    OTHER,        /* 0xe744 */
    OTHER,        /* 0xe745 */
    OTHER,        /* 0xe746 */
    OTHER,        /* 0xe747 */
    OTHER,        /* 0xe748 */
    OTHER,        /* 0xe749 */
    OTHER,        /* 0xe74a */
    OTHER,        /* 0xe74b */
    OTHER,        /* 0xe74c */
    OTHER,        /* 0xe74d */
    OTHER,        /* 0xe74e */
    OTHER,        /* 0xe74f */
    OTHER,        /* 0xe750 */
    OTHER,        /* 0xe751 */
    OTHER,        /* 0xe752 */
    OTHER,        /* 0xe753 */
    OTHER,        /* 0xe754 */
    OTHER,        /* 0xe755 */
    OTHER,        /* 0xe756 */
    OTHER,        /* 0xe757 */
    OTHER,        /* 0xe758 */
    OTHER,        /* 0xe759 */
    OTHER,        /* 0xe75a */
    OTHER,        /* 0xe75b */
    OTHER,        /* 0xe75c */
    OTHER,        /* 0xe75d */
    OTHER,        /* 0xe75e */
    OTHER,        /* 0xe75f */
    OTHER,        /* 0xe760 */
    OTHER,        /* 0xe761 */
    OTHER,        /* 0xe762 */
    OTHER,        /* 0xe763 */
    OTHER,        /* 0xe764 */
    OTHER,        /* 0xe765 */
    OTHER,        /* 0xe766 */
    OTHER,        /* 0xe767 */
    OTHER,        /* 0xe768 */
    OTHER,        /* 0xe769 */
    OTHER,        /* 0xe76a */
    OTHER,        /* 0xe76b */
    OTHER,        /* 0xe76c */
    OTHER,        /* 0xe76d */
    OTHER,        /* 0xe76e */
    OTHER,        /* 0xe76f */
    OTHER,        /* 0xe770 */
    OTHER,        /* 0xe771 */
    OTHER,        /* 0xe772 */
    OTHER,        /* 0xe773 */
    OTHER,        /* 0xe774 */
    OTHER,        /* 0xe775 */
    OTHER,        /* 0xe776 */
    OTHER,        /* 0xe777 */
    OTHER,        /* 0xe778 */
    OTHER,        /* 0xe779 */
    OTHER,        /* 0xe77a */
    OTHER,        /* 0xe77b */
    OTHER,        /* 0xe77c */
    OTHER,        /* 0xe77d */
    OTHER,        /* 0xe77e */
    OTHER,        /* 0xe77f */
    OTHER,        /* 0xe780 */
    OTHER,        /* 0xe781 */
    OTHER,        /* 0xe782 */
    OTHER,        /* 0xe783 */
    OTHER,        /* 0xe784 */
    OTHER,        /* 0xe785 */
    OTHER,        /* 0xe786 */
    OTHER,        /* 0xe787 */
    OTHER,        /* 0xe788 */
    OTHER,        /* 0xe789 */
    OTHER,        /* 0xe78a */
    OTHER,        /* 0xe78b */
    OTHER,        /* 0xe78c */
    OTHER,        /* 0xe78d */
    OTHER,        /* 0xe78e */
    OTHER,        /* 0xe78f */
    OTHER,        /* 0xe790 */
    OTHER,        /* 0xe791 */
    OTHER,        /* 0xe792 */
    OTHER,        /* 0xe793 */
    OTHER,        /* 0xe794 */
    OTHER,        /* 0xe795 */
    OTHER,        /* 0xe796 */
    OTHER,        /* 0xe797 */
    OTHER,        /* 0xe798 */
    OTHER,        /* 0xe799 */
    OTHER,        /* 0xe79a */
    OTHER,        /* 0xe79b */
    OTHER,        /* 0xe79c */
    OTHER,        /* 0xe79d */
    OTHER,        /* 0xe79e */
    OTHER,        /* 0xe79f */
    OTHER,        /* 0xe7a0 */
    OTHER,        /* 0xe7a1 */
    OTHER,        /* 0xe7a2 */
    OTHER,        /* 0xe7a3 */
    OTHER,        /* 0xe7a4 */
    OTHER,        /* 0xe7a5 */
    OTHER,        /* 0xe7a6 */
    OTHER,        /* 0xe7a7 */
    OTHER,        /* 0xe7a8 */
    OTHER,        /* 0xe7a9 */
    OTHER,        /* 0xe7aa */
    OTHER,        /* 0xe7ab */
    OTHER,        /* 0xe7ac */
    OTHER,        /* 0xe7ad */
    OTHER,        /* 0xe7ae */
    OTHER,        /* 0xe7af */
    OTHER,        /* 0xe7b0 */
    OTHER,        /* 0xe7b1 */
    OTHER,        /* 0xe7b2 */
    OTHER,        /* 0xe7b3 */
    OTHER,        /* 0xe7b4 */
    OTHER,        /* 0xe7b5 */
    OTHER,        /* 0xe7b6 */
    OTHER,        /* 0xe7b7 */
    OTHER,        /* 0xe7b8 */
    OTHER,        /* 0xe7b9 */
    OTHER,        /* 0xe7ba */
    OTHER,        /* 0xe7bb */
    OTHER,        /* 0xe7bc */
    OTHER,        /* 0xe7bd */
    OTHER,        /* 0xe7be */
    OTHER,        /* 0xe7bf */
    OTHER,        /* 0xe7c0 */
    OTHER,        /* 0xe7c1 */
    OTHER,        /* 0xe7c2 */
    OTHER,        /* 0xe7c3 */
    OTHER,        /* 0xe7c4 */
    OTHER,        /* 0xe7c5 */
    OTHER,        /* 0xe7c6 */
    OTHER,        /* 0xe7c7 */
    OTHER,        /* 0xe7c8 */
    OTHER,        /* 0xe7c9 */
    OTHER,        /* 0xe7ca */
    OTHER,        /* 0xe7cb */
    OTHER,        /* 0xe7cc */
    OTHER,        /* 0xe7cd */
    OTHER,        /* 0xe7ce */
    OTHER,        /* 0xe7cf */
    OTHER,        /* 0xe7d0 */
    OTHER,        /* 0xe7d1 */
    OTHER,        /* 0xe7d2 */
    OTHER,        /* 0xe7d3 */
    OTHER,        /* 0xe7d4 */
    OTHER,        /* 0xe7d5 */
    OTHER,        /* 0xe7d6 */
    OTHER,        /* 0xe7d7 */
    OTHER,        /* 0xe7d8 */
    OTHER,        /* 0xe7d9 */
    OTHER,        /* 0xe7da */
    OTHER,        /* 0xe7db */
    OTHER,        /* 0xe7dc */
    OTHER,        /* 0xe7dd */
    OTHER,        /* 0xe7de */
    OTHER,        /* 0xe7df */
    OTHER,        /* 0xe7e0 */
    OTHER,        /* 0xe7e1 */
    OTHER,        /* 0xe7e2 */
    OTHER,        /* 0xe7e3 */
    OTHER,        /* 0xe7e4 */
    OTHER,        /* 0xe7e5 */
    OTHER,        /* 0xe7e6 */
    OTHER,        /* 0xe7e7 */
    OTHER,        /* 0xe7e8 */
    OTHER,        /* 0xe7e9 */
    OTHER,        /* 0xe7ea */
    OTHER,        /* 0xe7eb */
    OTHER,        /* 0xe7ec */
    OTHER,        /* 0xe7ed */
    OTHER,        /* 0xe7ee */
    OTHER,        /* 0xe7ef */
    OTHER,        /* 0xe7f0 */
    OTHER,        /* 0xe7f1 */
    OTHER,        /* 0xe7f2 */
    OTHER,        /* 0xe7f3 */
    OTHER,        /* 0xe7f4 */
    OTHER,        /* 0xe7f5 */
    OTHER,        /* 0xe7f6 */
    OTHER,        /* 0xe7f7 */
    OTHER,        /* 0xe7f8 */
    OTHER,        /* 0xe7f9 */
    OTHER,        /* 0xe7fa */
    OTHER,        /* 0xe7fb */
    OTHER,        /* 0xe7fc */
    OTHER,        /* 0xe7fd */
    OTHER,        /* 0xe7fe */
    OTHER,        /* 0xe7ff */
    OTHER,        /* 0xe800 */
    OTHER,        /* 0xe801 */
    OTHER,        /* 0xe802 */
    OTHER,        /* 0xe803 */
    OTHER,        /* 0xe804 */
    OTHER,        /* 0xe805 */
    OTHER,        /* 0xe806 */
    OTHER,        /* 0xe807 */
    OTHER,        /* 0xe808 */
    OTHER,        /* 0xe809 */
    OTHER,        /* 0xe80a */
    OTHER,        /* 0xe80b */
    OTHER,        /* 0xe80c */
    OTHER,        /* 0xe80d */
    OTHER,        /* 0xe80e */
    OTHER,        /* 0xe80f */
    OTHER,        /* 0xe810 */
    OTHER,        /* 0xe811 */
    OTHER,        /* 0xe812 */
    OTHER,        /* 0xe813 */
    OTHER,        /* 0xe814 */
    OTHER,        /* 0xe815 */
    OTHER,        /* 0xe816 */
    OTHER,        /* 0xe817 */
    OTHER,        /* 0xe818 */
    OTHER,        /* 0xe819 */
    OTHER,        /* 0xe81a */
    OTHER,        /* 0xe81b */
    OTHER,        /* 0xe81c */
    OTHER,        /* 0xe81d */
    OTHER,        /* 0xe81e */
    OTHER,        /* 0xe81f */
    OTHER,        /* 0xe820 */
    OTHER,        /* 0xe821 */
    OTHER,        /* 0xe822 */
    OTHER,        /* 0xe823 */
    OTHER,        /* 0xe824 */
    OTHER,        /* 0xe825 */
    OTHER,        /* 0xe826 */
    OTHER,        /* 0xe827 */
    OTHER,        /* 0xe828 */
    OTHER,        /* 0xe829 */
    OTHER,        /* 0xe82a */
    OTHER,        /* 0xe82b */
    OTHER,        /* 0xe82c */
    OTHER,        /* 0xe82d */
    OTHER,        /* 0xe82e */
    OTHER,        /* 0xe82f */
    OTHER,        /* 0xe830 */
    OTHER,        /* 0xe831 */
    OTHER,        /* 0xe832 */
    OTHER,        /* 0xe833 */
    OTHER,        /* 0xe834 */
    OTHER,        /* 0xe835 */
    OTHER,        /* 0xe836 */
    OTHER,        /* 0xe837 */
    OTHER,        /* 0xe838 */
    OTHER,        /* 0xe839 */
    OTHER,        /* 0xe83a */
    OTHER,        /* 0xe83b */
    OTHER,        /* 0xe83c */
    OTHER,        /* 0xe83d */
    OTHER,        /* 0xe83e */
    OTHER,        /* 0xe83f */
    OTHER,        /* 0xe840 */
    OTHER,        /* 0xe841 */
    OTHER,        /* 0xe842 */
    OTHER,        /* 0xe843 */
    OTHER,        /* 0xe844 */
    OTHER,        /* 0xe845 */
    OTHER,        /* 0xe846 */
    OTHER,        /* 0xe847 */
    OTHER,        /* 0xe848 */
    OTHER,        /* 0xe849 */
    OTHER,        /* 0xe84a */
    OTHER,        /* 0xe84b */
    OTHER,        /* 0xe84c */
    OTHER,        /* 0xe84d */
    OTHER,        /* 0xe84e */
    OTHER,        /* 0xe84f */
    OTHER,        /* 0xe850 */
    OTHER,        /* 0xe851 */
    OTHER,        /* 0xe852 */
    OTHER,        /* 0xe853 */
    OTHER,        /* 0xe854 */
    OTHER,        /* 0xe855 */
    OTHER,        /* 0xe856 */
    OTHER,        /* 0xe857 */
    OTHER,        /* 0xe858 */
    OTHER,        /* 0xe859 */
    OTHER,        /* 0xe85a */
    OTHER,        /* 0xe85b */
    OTHER,        /* 0xe85c */
    OTHER,        /* 0xe85d */
    OTHER,        /* 0xe85e */
    OTHER,        /* 0xe85f */
    OTHER,        /* 0xe860 */
    OTHER,        /* 0xe861 */
    OTHER,        /* 0xe862 */
    OTHER,        /* 0xe863 */
    OTHER,        /* 0xe864 */
    OTHER,        /* 0xe865 */
    OTHER,        /* 0xe866 */
    OTHER,        /* 0xe867 */
    OTHER,        /* 0xe868 */
    OTHER,        /* 0xe869 */
    OTHER,        /* 0xe86a */
    OTHER,        /* 0xe86b */
    OTHER,        /* 0xe86c */
    OTHER,        /* 0xe86d */
    OTHER,        /* 0xe86e */
    OTHER,        /* 0xe86f */
    OTHER,        /* 0xe870 */
    OTHER,        /* 0xe871 */
    OTHER,        /* 0xe872 */
    OTHER,        /* 0xe873 */
    OTHER,        /* 0xe874 */
    OTHER,        /* 0xe875 */
    OTHER,        /* 0xe876 */
    OTHER,        /* 0xe877 */
    OTHER,        /* 0xe878 */
    OTHER,        /* 0xe879 */
    OTHER,        /* 0xe87a */
    OTHER,        /* 0xe87b */
    OTHER,        /* 0xe87c */
    OTHER,        /* 0xe87d */
    OTHER,        /* 0xe87e */
    OTHER,        /* 0xe87f */
    OTHER,        /* 0xe880 */
    OTHER,        /* 0xe881 */
    OTHER,        /* 0xe882 */
    OTHER,        /* 0xe883 */
    OTHER,        /* 0xe884 */
    OTHER,        /* 0xe885 */
    OTHER,        /* 0xe886 */
    OTHER,        /* 0xe887 */
    OTHER,        /* 0xe888 */
    OTHER,        /* 0xe889 */
    OTHER,        /* 0xe88a */
    OTHER,        /* 0xe88b */
    OTHER,        /* 0xe88c */
    OTHER,        /* 0xe88d */
    OTHER,        /* 0xe88e */
    OTHER,        /* 0xe88f */
    OTHER,        /* 0xe890 */
    OTHER,        /* 0xe891 */
    OTHER,        /* 0xe892 */
    OTHER,        /* 0xe893 */
    OTHER,        /* 0xe894 */
    OTHER,        /* 0xe895 */
    OTHER,        /* 0xe896 */
    OTHER,        /* 0xe897 */
    OTHER,        /* 0xe898 */
    OTHER,        /* 0xe899 */
    OTHER,        /* 0xe89a */
    OTHER,        /* 0xe89b */
    OTHER,        /* 0xe89c */
    OTHER,        /* 0xe89d */
    OTHER,        /* 0xe89e */
    OTHER,        /* 0xe89f */
    OTHER,        /* 0xe8a0 */
    OTHER,        /* 0xe8a1 */
    OTHER,        /* 0xe8a2 */
    OTHER,        /* 0xe8a3 */
    OTHER,        /* 0xe8a4 */
    OTHER,        /* 0xe8a5 */
    OTHER,        /* 0xe8a6 */
    OTHER,        /* 0xe8a7 */
    OTHER,        /* 0xe8a8 */
    OTHER,        /* 0xe8a9 */
    OTHER,        /* 0xe8aa */
    OTHER,        /* 0xe8ab */
    OTHER,        /* 0xe8ac */
    OTHER,        /* 0xe8ad */
    OTHER,        /* 0xe8ae */
    OTHER,        /* 0xe8af */
    OTHER,        /* 0xe8b0 */
    OTHER,        /* 0xe8b1 */
    OTHER,        /* 0xe8b2 */
    OTHER,        /* 0xe8b3 */
    OTHER,        /* 0xe8b4 */
    OTHER,        /* 0xe8b5 */
    OTHER,        /* 0xe8b6 */
    OTHER,        /* 0xe8b7 */
    OTHER,        /* 0xe8b8 */
    OTHER,        /* 0xe8b9 */
    OTHER,        /* 0xe8ba */
    OTHER,        /* 0xe8bb */
    OTHER,        /* 0xe8bc */
    OTHER,        /* 0xe8bd */
    OTHER,        /* 0xe8be */
    OTHER,        /* 0xe8bf */
    OTHER,        /* 0xe8c0 */
    OTHER,        /* 0xe8c1 */
    OTHER,        /* 0xe8c2 */
    OTHER,        /* 0xe8c3 */
    OTHER,        /* 0xe8c4 */
    OTHER,        /* 0xe8c5 */
    OTHER,        /* 0xe8c6 */
    OTHER,        /* 0xe8c7 */
    OTHER,        /* 0xe8c8 */
    OTHER,        /* 0xe8c9 */
    OTHER,        /* 0xe8ca */
    OTHER,        /* 0xe8cb */
    OTHER,        /* 0xe8cc */
    OTHER,        /* 0xe8cd */
    OTHER,        /* 0xe8ce */
    OTHER,        /* 0xe8cf */
    OTHER,        /* 0xe8d0 */
    OTHER,        /* 0xe8d1 */
    OTHER,        /* 0xe8d2 */
    OTHER,        /* 0xe8d3 */
    OTHER,        /* 0xe8d4 */
    OTHER,        /* 0xe8d5 */
    OTHER,        /* 0xe8d6 */
    OTHER,        /* 0xe8d7 */
    OTHER,        /* 0xe8d8 */
    OTHER,        /* 0xe8d9 */
    OTHER,        /* 0xe8da */
    OTHER,        /* 0xe8db */
    OTHER,        /* 0xe8dc */
    OTHER,        /* 0xe8dd */
    OTHER,        /* 0xe8de */
    OTHER,        /* 0xe8df */
    OTHER,        /* 0xe8e0 */
    OTHER,        /* 0xe8e1 */
    OTHER,        /* 0xe8e2 */
    OTHER,        /* 0xe8e3 */
    OTHER,        /* 0xe8e4 */
    OTHER,        /* 0xe8e5 */
    OTHER,        /* 0xe8e6 */
    OTHER,        /* 0xe8e7 */
    OTHER,        /* 0xe8e8 */
    OTHER,        /* 0xe8e9 */
    OTHER,        /* 0xe8ea */
    OTHER,        /* 0xe8eb */
    OTHER,        /* 0xe8ec */
    OTHER,        /* 0xe8ed */
    OTHER,        /* 0xe8ee */
    OTHER,        /* 0xe8ef */
    OTHER,        /* 0xe8f0 */
    OTHER,        /* 0xe8f1 */
    OTHER,        /* 0xe8f2 */
    OTHER,        /* 0xe8f3 */
    OTHER,        /* 0xe8f4 */
    OTHER,        /* 0xe8f5 */
    OTHER,        /* 0xe8f6 */
    OTHER,        /* 0xe8f7 */
    OTHER,        /* 0xe8f8 */
    OTHER,        /* 0xe8f9 */
    OTHER,        /* 0xe8fa */
    OTHER,        /* 0xe8fb */
    OTHER,        /* 0xe8fc */
    OTHER,        /* 0xe8fd */
    OTHER,        /* 0xe8fe */
    OTHER,        /* 0xe8ff */
    OTHER,        /* 0xe900 */
    OTHER,        /* 0xe901 */
    OTHER,        /* 0xe902 */
    OTHER,        /* 0xe903 */
    OTHER,        /* 0xe904 */
    OTHER,        /* 0xe905 */
    OTHER,        /* 0xe906 */
    OTHER,        /* 0xe907 */
    OTHER,        /* 0xe908 */
    OTHER,        /* 0xe909 */
    OTHER,        /* 0xe90a */
    OTHER,        /* 0xe90b */
    OTHER,        /* 0xe90c */
    OTHER,        /* 0xe90d */
    OTHER,        /* 0xe90e */
    OTHER,        /* 0xe90f */
    OTHER,        /* 0xe910 */
    OTHER,        /* 0xe911 */
    OTHER,        /* 0xe912 */
    OTHER,        /* 0xe913 */
    OTHER,        /* 0xe914 */
    OTHER,        /* 0xe915 */
    OTHER,        /* 0xe916 */
    OTHER,        /* 0xe917 */
    OTHER,        /* 0xe918 */
    OTHER,        /* 0xe919 */
    OTHER,        /* 0xe91a */
    OTHER,        /* 0xe91b */
    OTHER,        /* 0xe91c */
    OTHER,        /* 0xe91d */
    OTHER,        /* 0xe91e */
    OTHER,        /* 0xe91f */
    OTHER,        /* 0xe920 */
    OTHER,        /* 0xe921 */
    OTHER,        /* 0xe922 */
    OTHER,        /* 0xe923 */
    OTHER,        /* 0xe924 */
    OTHER,        /* 0xe925 */
    OTHER,        /* 0xe926 */
    OTHER,        /* 0xe927 */
    OTHER,        /* 0xe928 */
    OTHER,        /* 0xe929 */
    OTHER,        /* 0xe92a */
    OTHER,        /* 0xe92b */
    OTHER,        /* 0xe92c */
    OTHER,        /* 0xe92d */
    OTHER,        /* 0xe92e */
    OTHER,        /* 0xe92f */
    OTHER,        /* 0xe930 */
    OTHER,        /* 0xe931 */
    OTHER,        /* 0xe932 */
    OTHER,        /* 0xe933 */
    OTHER,        /* 0xe934 */
    OTHER,        /* 0xe935 */
    OTHER,        /* 0xe936 */
    OTHER,        /* 0xe937 */
    OTHER,        /* 0xe938 */
    OTHER,        /* 0xe939 */
    OTHER,        /* 0xe93a */
    OTHER,        /* 0xe93b */
    OTHER,        /* 0xe93c */
    OTHER,        /* 0xe93d */
    OTHER,        /* 0xe93e */
    OTHER,        /* 0xe93f */
    OTHER,        /* 0xe940 */
    OTHER,        /* 0xe941 */
    OTHER,        /* 0xe942 */
    OTHER,        /* 0xe943 */
    OTHER,        /* 0xe944 */
    OTHER,        /* 0xe945 */
    OTHER,        /* 0xe946 */
    OTHER,        /* 0xe947 */
    OTHER,        /* 0xe948 */
    OTHER,        /* 0xe949 */
    OTHER,        /* 0xe94a */
    OTHER,        /* 0xe94b */
    OTHER,        /* 0xe94c */
    OTHER,        /* 0xe94d */
    OTHER,        /* 0xe94e */
    OTHER,        /* 0xe94f */
    OTHER,        /* 0xe950 */
    OTHER,        /* 0xe951 */
    OTHER,        /* 0xe952 */
    OTHER,        /* 0xe953 */
    OTHER,        /* 0xe954 */
    OTHER,        /* 0xe955 */
    OTHER,        /* 0xe956 */
    OTHER,        /* 0xe957 */
    OTHER,        /* 0xe958 */
    OTHER,        /* 0xe959 */
    OTHER,        /* 0xe95a */
    OTHER,        /* 0xe95b */
    OTHER,        /* 0xe95c */
    OTHER,        /* 0xe95d */
    OTHER,        /* 0xe95e */
    OTHER,        /* 0xe95f */
    OTHER,        /* 0xe960 */
    OTHER,        /* 0xe961 */
    OTHER,        /* 0xe962 */
    OTHER,        /* 0xe963 */
    OTHER,        /* 0xe964 */
    OTHER,        /* 0xe965 */
    OTHER,        /* 0xe966 */
    OTHER,        /* 0xe967 */
    OTHER,        /* 0xe968 */
    OTHER,        /* 0xe969 */
    OTHER,        /* 0xe96a */
    OTHER,        /* 0xe96b */
    OTHER,        /* 0xe96c */
    OTHER,        /* 0xe96d */
    OTHER,        /* 0xe96e */
    OTHER,        /* 0xe96f */
    OTHER,        /* 0xe970 */
    OTHER,        /* 0xe971 */
    OTHER,        /* 0xe972 */
    OTHER,        /* 0xe973 */
    OTHER,        /* 0xe974 */
    OTHER,        /* 0xe975 */
    OTHER,        /* 0xe976 */
    OTHER,        /* 0xe977 */
    OTHER,        /* 0xe978 */
    OTHER,        /* 0xe979 */
    OTHER,        /* 0xe97a */
    OTHER,        /* 0xe97b */
    OTHER,        /* 0xe97c */
    OTHER,        /* 0xe97d */
    OTHER,        /* 0xe97e */
    OTHER,        /* 0xe97f */
    OTHER,        /* 0xe980 */
    OTHER,        /* 0xe981 */
    OTHER,        /* 0xe982 */
    OTHER,        /* 0xe983 */
    OTHER,        /* 0xe984 */
    OTHER,        /* 0xe985 */
    OTHER,        /* 0xe986 */
    OTHER,        /* 0xe987 */
    OTHER,        /* 0xe988 */
    OTHER,        /* 0xe989 */
    OTHER,        /* 0xe98a */
    OTHER,        /* 0xe98b */
    OTHER,        /* 0xe98c */
    OTHER,        /* 0xe98d */
    OTHER,        /* 0xe98e */
    OTHER,        /* 0xe98f */
    OTHER,        /* 0xe990 */
    OTHER,        /* 0xe991 */
    OTHER,        /* 0xe992 */
    OTHER,        /* 0xe993 */
    OTHER,        /* 0xe994 */
    OTHER,        /* 0xe995 */
    OTHER,        /* 0xe996 */
    OTHER,        /* 0xe997 */
    OTHER,        /* 0xe998 */
    OTHER,        /* 0xe999 */
    OTHER,        /* 0xe99a */
    OTHER,        /* 0xe99b */
    OTHER,        /* 0xe99c */
    OTHER,        /* 0xe99d */
    OTHER,        /* 0xe99e */
    OTHER,        /* 0xe99f */
    OTHER,        /* 0xe9a0 */
    OTHER,        /* 0xe9a1 */
    OTHER,        /* 0xe9a2 */
    OTHER,        /* 0xe9a3 */
    OTHER,        /* 0xe9a4 */
    OTHER,        /* 0xe9a5 */
    OTHER,        /* 0xe9a6 */
    OTHER,        /* 0xe9a7 */
    OTHER,        /* 0xe9a8 */
    OTHER,        /* 0xe9a9 */
    OTHER,        /* 0xe9aa */
    OTHER,        /* 0xe9ab */
    OTHER,        /* 0xe9ac */
    OTHER,        /* 0xe9ad */
    OTHER,        /* 0xe9ae */
    OTHER,        /* 0xe9af */
    OTHER,        /* 0xe9b0 */
    OTHER,        /* 0xe9b1 */
    OTHER,        /* 0xe9b2 */
    OTHER,        /* 0xe9b3 */
    OTHER,        /* 0xe9b4 */
    OTHER,        /* 0xe9b5 */
    OTHER,        /* 0xe9b6 */
    OTHER,        /* 0xe9b7 */
    OTHER,        /* 0xe9b8 */
    OTHER,        /* 0xe9b9 */
    OTHER,        /* 0xe9ba */
    OTHER,        /* 0xe9bb */
    OTHER,        /* 0xe9bc */
    OTHER,        /* 0xe9bd */
    OTHER,        /* 0xe9be */
    OTHER,        /* 0xe9bf */
    OTHER,        /* 0xe9c0 */
    OTHER,        /* 0xe9c1 */
    OTHER,        /* 0xe9c2 */
    OTHER,        /* 0xe9c3 */
    OTHER,        /* 0xe9c4 */
    OTHER,        /* 0xe9c5 */
    OTHER,        /* 0xe9c6 */
    OTHER,        /* 0xe9c7 */
    OTHER,        /* 0xe9c8 */
    OTHER,        /* 0xe9c9 */
    OTHER,        /* 0xe9ca */
    OTHER,        /* 0xe9cb */
    OTHER,        /* 0xe9cc */
    OTHER,        /* 0xe9cd */
    OTHER,        /* 0xe9ce */
    OTHER,        /* 0xe9cf */
    OTHER,        /* 0xe9d0 */
    OTHER,        /* 0xe9d1 */
    OTHER,        /* 0xe9d2 */
    OTHER,        /* 0xe9d3 */
    OTHER,        /* 0xe9d4 */
    OTHER,        /* 0xe9d5 */
    OTHER,        /* 0xe9d6 */
    OTHER,        /* 0xe9d7 */
    OTHER,        /* 0xe9d8 */
    OTHER,        /* 0xe9d9 */
    OTHER,        /* 0xe9da */
    OTHER,        /* 0xe9db */
    OTHER,        /* 0xe9dc */
    OTHER,        /* 0xe9dd */
    OTHER,        /* 0xe9de */
    OTHER,        /* 0xe9df */
    OTHER,        /* 0xe9e0 */
    OTHER,        /* 0xe9e1 */
    OTHER,        /* 0xe9e2 */
    OTHER,        /* 0xe9e3 */
    OTHER,        /* 0xe9e4 */
    OTHER,        /* 0xe9e5 */
    OTHER,        /* 0xe9e6 */
    OTHER,        /* 0xe9e7 */
    OTHER,        /* 0xe9e8 */
    OTHER,        /* 0xe9e9 */
    OTHER,        /* 0xe9ea */
    OTHER,        /* 0xe9eb */
    OTHER,        /* 0xe9ec */
    OTHER,        /* 0xe9ed */
    OTHER,        /* 0xe9ee */
    OTHER,        /* 0xe9ef */
    OTHER,        /* 0xe9f0 */
    OTHER,        /* 0xe9f1 */
    OTHER,        /* 0xe9f2 */
    OTHER,        /* 0xe9f3 */
    OTHER,        /* 0xe9f4 */
    OTHER,        /* 0xe9f5 */
    OTHER,        /* 0xe9f6 */
    OTHER,        /* 0xe9f7 */
    OTHER,        /* 0xe9f8 */
    OTHER,        /* 0xe9f9 */
    OTHER,        /* 0xe9fa */
    OTHER,        /* 0xe9fb */
    OTHER,        /* 0xe9fc */
    OTHER,        /* 0xe9fd */
    OTHER,        /* 0xe9fe */
    OTHER,        /* 0xe9ff */
    OTHER,        /* 0xea00 */
    OTHER,        /* 0xea01 */
    OTHER,        /* 0xea02 */
    OTHER,        /* 0xea03 */
    OTHER,        /* 0xea04 */
    OTHER,        /* 0xea05 */
    OTHER,        /* 0xea06 */
    OTHER,        /* 0xea07 */
    OTHER,        /* 0xea08 */
    OTHER,        /* 0xea09 */
    OTHER,        /* 0xea0a */
    OTHER,        /* 0xea0b */
    OTHER,        /* 0xea0c */
    OTHER,        /* 0xea0d */
    OTHER,        /* 0xea0e */
    OTHER,        /* 0xea0f */
    OTHER,        /* 0xea10 */
    OTHER,        /* 0xea11 */
    OTHER,        /* 0xea12 */
    OTHER,        /* 0xea13 */
    OTHER,        /* 0xea14 */
    OTHER,        /* 0xea15 */
    OTHER,        /* 0xea16 */
    OTHER,        /* 0xea17 */
    OTHER,        /* 0xea18 */
    OTHER,        /* 0xea19 */
    OTHER,        /* 0xea1a */
    OTHER,        /* 0xea1b */
    OTHER,        /* 0xea1c */
    OTHER,        /* 0xea1d */
    OTHER,        /* 0xea1e */
    OTHER,        /* 0xea1f */
    OTHER,        /* 0xea20 */
    OTHER,        /* 0xea21 */
    OTHER,        /* 0xea22 */
    OTHER,        /* 0xea23 */
    OTHER,        /* 0xea24 */
    OTHER,        /* 0xea25 */
    OTHER,        /* 0xea26 */
    OTHER,        /* 0xea27 */
    OTHER,        /* 0xea28 */
    OTHER,        /* 0xea29 */
    OTHER,        /* 0xea2a */
    OTHER,        /* 0xea2b */
    OTHER,        /* 0xea2c */
    OTHER,        /* 0xea2d */
    OTHER,        /* 0xea2e */
    OTHER,        /* 0xea2f */
    OTHER,        /* 0xea30 */
    OTHER,        /* 0xea31 */
    OTHER,        /* 0xea32 */
    OTHER,        /* 0xea33 */
    OTHER,        /* 0xea34 */
    OTHER,        /* 0xea35 */
    OTHER,        /* 0xea36 */
    OTHER,        /* 0xea37 */
    OTHER,        /* 0xea38 */
    OTHER,        /* 0xea39 */
    OTHER,        /* 0xea3a */
    OTHER,        /* 0xea3b */
    OTHER,        /* 0xea3c */
    OTHER,        /* 0xea3d */
    OTHER,        /* 0xea3e */
    OTHER,        /* 0xea3f */
    OTHER,        /* 0xea40 */
    OTHER,        /* 0xea41 */
    OTHER,        /* 0xea42 */
    OTHER,        /* 0xea43 */
    OTHER,        /* 0xea44 */
    OTHER,        /* 0xea45 */
    OTHER,        /* 0xea46 */
    OTHER,        /* 0xea47 */
    OTHER,        /* 0xea48 */
    OTHER,        /* 0xea49 */
    OTHER,        /* 0xea4a */
    OTHER,        /* 0xea4b */
    OTHER,        /* 0xea4c */
    OTHER,        /* 0xea4d */
    OTHER,        /* 0xea4e */
    OTHER,        /* 0xea4f */
    OTHER,        /* 0xea50 */
    OTHER,        /* 0xea51 */
    OTHER,        /* 0xea52 */
    OTHER,        /* 0xea53 */
    OTHER,        /* 0xea54 */
    OTHER,        /* 0xea55 */
    OTHER,        /* 0xea56 */
    OTHER,        /* 0xea57 */
    OTHER,        /* 0xea58 */
    OTHER,        /* 0xea59 */
    OTHER,        /* 0xea5a */
    OTHER,        /* 0xea5b */
    OTHER,        /* 0xea5c */
    OTHER,        /* 0xea5d */
    OTHER,        /* 0xea5e */
    OTHER,        /* 0xea5f */
    OTHER,        /* 0xea60 */
    OTHER,        /* 0xea61 */
    OTHER,        /* 0xea62 */
    OTHER,        /* 0xea63 */
    OTHER,        /* 0xea64 */
    OTHER,        /* 0xea65 */
    OTHER,        /* 0xea66 */
    OTHER,        /* 0xea67 */
    OTHER,        /* 0xea68 */
    OTHER,        /* 0xea69 */
    OTHER,        /* 0xea6a */
    OTHER,        /* 0xea6b */
    OTHER,        /* 0xea6c */
    OTHER,        /* 0xea6d */
    OTHER,        /* 0xea6e */
    OTHER,        /* 0xea6f */
    OTHER,        /* 0xea70 */
    OTHER,        /* 0xea71 */
    OTHER,        /* 0xea72 */
    OTHER,        /* 0xea73 */
    OTHER,        /* 0xea74 */
    OTHER,        /* 0xea75 */
    OTHER,        /* 0xea76 */
    OTHER,        /* 0xea77 */
    OTHER,        /* 0xea78 */
    OTHER,        /* 0xea79 */
    OTHER,        /* 0xea7a */
    OTHER,        /* 0xea7b */
    OTHER,        /* 0xea7c */
    OTHER,        /* 0xea7d */
    OTHER,        /* 0xea7e */
    OTHER,        /* 0xea7f */
    OTHER,        /* 0xea80 */
    OTHER,        /* 0xea81 */
    OTHER,        /* 0xea82 */
    OTHER,        /* 0xea83 */
    OTHER,        /* 0xea84 */
    OTHER,        /* 0xea85 */
    OTHER,        /* 0xea86 */
    OTHER,        /* 0xea87 */
    OTHER,        /* 0xea88 */
    OTHER,        /* 0xea89 */
    OTHER,        /* 0xea8a */
    OTHER,        /* 0xea8b */
    OTHER,        /* 0xea8c */
    OTHER,        /* 0xea8d */
    OTHER,        /* 0xea8e */
    OTHER,        /* 0xea8f */
    OTHER,        /* 0xea90 */
    OTHER,        /* 0xea91 */
    OTHER,        /* 0xea92 */
    OTHER,        /* 0xea93 */
    OTHER,        /* 0xea94 */
    OTHER,        /* 0xea95 */
    OTHER,        /* 0xea96 */
    OTHER,        /* 0xea97 */
    OTHER,        /* 0xea98 */
    OTHER,        /* 0xea99 */
    OTHER,        /* 0xea9a */
    OTHER,        /* 0xea9b */
    OTHER,        /* 0xea9c */
    OTHER,        /* 0xea9d */
    OTHER,        /* 0xea9e */
    OTHER,        /* 0xea9f */
    OTHER,        /* 0xeaa0 */
    OTHER,        /* 0xeaa1 */
    OTHER,        /* 0xeaa2 */
    OTHER,        /* 0xeaa3 */
    OTHER,        /* 0xeaa4 */
    OTHER,        /* 0xeaa5 */
    OTHER,        /* 0xeaa6 */
    OTHER,        /* 0xeaa7 */
    OTHER,        /* 0xeaa8 */
    OTHER,        /* 0xeaa9 */
    OTHER,        /* 0xeaaa */
    OTHER,        /* 0xeaab */
    OTHER,        /* 0xeaac */
    OTHER,        /* 0xeaad */
    OTHER,        /* 0xeaae */
    OTHER,        /* 0xeaaf */
    OTHER,        /* 0xeab0 */
    OTHER,        /* 0xeab1 */
    OTHER,        /* 0xeab2 */
    OTHER,        /* 0xeab3 */
    OTHER,        /* 0xeab4 */
    OTHER,        /* 0xeab5 */
    OTHER,        /* 0xeab6 */
    OTHER,        /* 0xeab7 */
    OTHER,        /* 0xeab8 */
    OTHER,        /* 0xeab9 */
    OTHER,        /* 0xeaba */
    OTHER,        /* 0xeabb */
    OTHER,        /* 0xeabc */
    OTHER,        /* 0xeabd */
    OTHER,        /* 0xeabe */
    OTHER,        /* 0xeabf */
    OTHER,        /* 0xeac0 */
    OTHER,        /* 0xeac1 */
    OTHER,        /* 0xeac2 */
    OTHER,        /* 0xeac3 */
    OTHER,        /* 0xeac4 */
    OTHER,        /* 0xeac5 */
    OTHER,        /* 0xeac6 */
    OTHER,        /* 0xeac7 */
    OTHER,        /* 0xeac8 */
    OTHER,        /* 0xeac9 */
    OTHER,        /* 0xeaca */
    OTHER,        /* 0xeacb */
    OTHER,        /* 0xeacc */
    OTHER,        /* 0xeacd */
    OTHER,        /* 0xeace */
    OTHER,        /* 0xeacf */
    OTHER,        /* 0xead0 */
    OTHER,        /* 0xead1 */
    OTHER,        /* 0xead2 */
    OTHER,        /* 0xead3 */
    OTHER,        /* 0xead4 */
    OTHER,        /* 0xead5 */
    OTHER,        /* 0xead6 */
    OTHER,        /* 0xead7 */
    OTHER,        /* 0xead8 */
    OTHER,        /* 0xead9 */
    OTHER,        /* 0xeada */
    OTHER,        /* 0xeadb */
    OTHER,        /* 0xeadc */
    OTHER,        /* 0xeadd */
    OTHER,        /* 0xeade */
    OTHER,        /* 0xeadf */
    OTHER,        /* 0xeae0 */
    OTHER,        /* 0xeae1 */
    OTHER,        /* 0xeae2 */
    OTHER,        /* 0xeae3 */
    OTHER,        /* 0xeae4 */
    OTHER,        /* 0xeae5 */
    OTHER,        /* 0xeae6 */
    OTHER,        /* 0xeae7 */
    OTHER,        /* 0xeae8 */
    OTHER,        /* 0xeae9 */
    OTHER,        /* 0xeaea */
    OTHER,        /* 0xeaeb */
    OTHER,        /* 0xeaec */
    OTHER,        /* 0xeaed */
    OTHER,        /* 0xeaee */
    OTHER,        /* 0xeaef */
    OTHER,        /* 0xeaf0 */
    OTHER,        /* 0xeaf1 */
    OTHER,        /* 0xeaf2 */
    OTHER,        /* 0xeaf3 */
    OTHER,        /* 0xeaf4 */
    OTHER,        /* 0xeaf5 */
    OTHER,        /* 0xeaf6 */
    OTHER,        /* 0xeaf7 */
    OTHER,        /* 0xeaf8 */
    OTHER,        /* 0xeaf9 */
    OTHER,        /* 0xeafa */
    OTHER,        /* 0xeafb */
    OTHER,        /* 0xeafc */
    OTHER,        /* 0xeafd */
    OTHER,        /* 0xeafe */
    OTHER,        /* 0xeaff */
    OTHER,        /* 0xeb00 */
    OTHER,        /* 0xeb01 */
    OTHER,        /* 0xeb02 */
    OTHER,        /* 0xeb03 */
    OTHER,        /* 0xeb04 */
    OTHER,        /* 0xeb05 */
    OTHER,        /* 0xeb06 */
    OTHER,        /* 0xeb07 */
    OTHER,        /* 0xeb08 */
    OTHER,        /* 0xeb09 */
    OTHER,        /* 0xeb0a */
    OTHER,        /* 0xeb0b */
    OTHER,        /* 0xeb0c */
    OTHER,        /* 0xeb0d */
    OTHER,        /* 0xeb0e */
    OTHER,        /* 0xeb0f */
    OTHER,        /* 0xeb10 */
    OTHER,        /* 0xeb11 */
    OTHER,        /* 0xeb12 */
    OTHER,        /* 0xeb13 */
    OTHER,        /* 0xeb14 */
    OTHER,        /* 0xeb15 */
    OTHER,        /* 0xeb16 */
    OTHER,        /* 0xeb17 */
    OTHER,        /* 0xeb18 */
    OTHER,        /* 0xeb19 */
    OTHER,        /* 0xeb1a */
    OTHER,        /* 0xeb1b */
    OTHER,        /* 0xeb1c */
    OTHER,        /* 0xeb1d */
    OTHER,        /* 0xeb1e */
    OTHER,        /* 0xeb1f */
    OTHER,        /* 0xeb20 */
    OTHER,        /* 0xeb21 */
    OTHER,        /* 0xeb22 */
    OTHER,        /* 0xeb23 */
    OTHER,        /* 0xeb24 */
    OTHER,        /* 0xeb25 */
    OTHER,        /* 0xeb26 */
    OTHER,        /* 0xeb27 */
    OTHER,        /* 0xeb28 */
    OTHER,        /* 0xeb29 */
    OTHER,        /* 0xeb2a */
    OTHER,        /* 0xeb2b */
    OTHER,        /* 0xeb2c */
    OTHER,        /* 0xeb2d */
    OTHER,        /* 0xeb2e */
    OTHER,        /* 0xeb2f */
    OTHER,        /* 0xeb30 */
    OTHER,        /* 0xeb31 */
    OTHER,        /* 0xeb32 */
    OTHER,        /* 0xeb33 */
    OTHER,        /* 0xeb34 */
    OTHER,        /* 0xeb35 */
    OTHER,        /* 0xeb36 */
    OTHER,        /* 0xeb37 */
    OTHER,        /* 0xeb38 */
    OTHER,        /* 0xeb39 */
    OTHER,        /* 0xeb3a */
    OTHER,        /* 0xeb3b */
    OTHER,        /* 0xeb3c */
    OTHER,        /* 0xeb3d */
    OTHER,        /* 0xeb3e */
    OTHER,        /* 0xeb3f */
    OTHER,        /* 0xeb40 */
    OTHER,        /* 0xeb41 */
    OTHER,        /* 0xeb42 */
    OTHER,        /* 0xeb43 */
    OTHER,        /* 0xeb44 */
    OTHER,        /* 0xeb45 */
    OTHER,        /* 0xeb46 */
    OTHER,        /* 0xeb47 */
    OTHER,        /* 0xeb48 */
    OTHER,        /* 0xeb49 */
    OTHER,        /* 0xeb4a */
    OTHER,        /* 0xeb4b */
    OTHER,        /* 0xeb4c */
    OTHER,        /* 0xeb4d */
    OTHER,        /* 0xeb4e */
    OTHER,        /* 0xeb4f */
    OTHER,        /* 0xeb50 */
    OTHER,        /* 0xeb51 */
    OTHER,        /* 0xeb52 */
    OTHER,        /* 0xeb53 */
    OTHER,        /* 0xeb54 */
    OTHER,        /* 0xeb55 */
    OTHER,        /* 0xeb56 */
    OTHER,        /* 0xeb57 */
    OTHER,        /* 0xeb58 */
    OTHER,        /* 0xeb59 */
    OTHER,        /* 0xeb5a */
    OTHER,        /* 0xeb5b */
    OTHER,        /* 0xeb5c */
    OTHER,        /* 0xeb5d */
    OTHER,        /* 0xeb5e */
    OTHER,        /* 0xeb5f */
    OTHER,        /* 0xeb60 */
    OTHER,        /* 0xeb61 */
    OTHER,        /* 0xeb62 */
    OTHER,        /* 0xeb63 */
    OTHER,        /* 0xeb64 */
    OTHER,        /* 0xeb65 */
    OTHER,        /* 0xeb66 */
    OTHER,        /* 0xeb67 */
    OTHER,        /* 0xeb68 */
    OTHER,        /* 0xeb69 */
    OTHER,        /* 0xeb6a */
    OTHER,        /* 0xeb6b */
    OTHER,        /* 0xeb6c */
    OTHER,        /* 0xeb6d */
    OTHER,        /* 0xeb6e */
    OTHER,        /* 0xeb6f */
    OTHER,        /* 0xeb70 */
    OTHER,        /* 0xeb71 */
    OTHER,        /* 0xeb72 */
    OTHER,        /* 0xeb73 */
    OTHER,        /* 0xeb74 */
    OTHER,        /* 0xeb75 */
    OTHER,        /* 0xeb76 */
    OTHER,        /* 0xeb77 */
    OTHER,        /* 0xeb78 */
    OTHER,        /* 0xeb79 */
    OTHER,        /* 0xeb7a */
    OTHER,        /* 0xeb7b */
    OTHER,        /* 0xeb7c */
    OTHER,        /* 0xeb7d */
    OTHER,        /* 0xeb7e */
    OTHER,        /* 0xeb7f */
    OTHER,        /* 0xeb80 */
    OTHER,        /* 0xeb81 */
    OTHER,        /* 0xeb82 */
    OTHER,        /* 0xeb83 */
    OTHER,        /* 0xeb84 */
    OTHER,        /* 0xeb85 */
    OTHER,        /* 0xeb86 */
    OTHER,        /* 0xeb87 */
    OTHER,        /* 0xeb88 */
    OTHER,        /* 0xeb89 */
    OTHER,        /* 0xeb8a */
    OTHER,        /* 0xeb8b */
    OTHER,        /* 0xeb8c */
    OTHER,        /* 0xeb8d */
    OTHER,        /* 0xeb8e */
    OTHER,        /* 0xeb8f */
    OTHER,        /* 0xeb90 */
    OTHER,        /* 0xeb91 */
    OTHER,        /* 0xeb92 */
    OTHER,        /* 0xeb93 */
    OTHER,        /* 0xeb94 */
    OTHER,        /* 0xeb95 */
    OTHER,        /* 0xeb96 */
    OTHER,        /* 0xeb97 */
    OTHER,        /* 0xeb98 */
    OTHER,        /* 0xeb99 */
    OTHER,        /* 0xeb9a */
    OTHER,        /* 0xeb9b */
    OTHER,        /* 0xeb9c */
    OTHER,        /* 0xeb9d */
    OTHER,        /* 0xeb9e */
    OTHER,        /* 0xeb9f */
    OTHER,        /* 0xeba0 */
    OTHER,        /* 0xeba1 */
    OTHER,        /* 0xeba2 */
    OTHER,        /* 0xeba3 */
    OTHER,        /* 0xeba4 */
    OTHER,        /* 0xeba5 */
    OTHER,        /* 0xeba6 */
    OTHER,        /* 0xeba7 */
    OTHER,        /* 0xeba8 */
    OTHER,        /* 0xeba9 */
    OTHER,        /* 0xebaa */
    OTHER,        /* 0xebab */
    OTHER,        /* 0xebac */
    OTHER,        /* 0xebad */
    OTHER,        /* 0xebae */
    OTHER,        /* 0xebaf */
    OTHER,        /* 0xebb0 */
    OTHER,        /* 0xebb1 */
    OTHER,        /* 0xebb2 */
    OTHER,        /* 0xebb3 */
    OTHER,        /* 0xebb4 */
    OTHER,        /* 0xebb5 */
    OTHER,        /* 0xebb6 */
    OTHER,        /* 0xebb7 */
    OTHER,        /* 0xebb8 */
    OTHER,        /* 0xebb9 */
    OTHER,        /* 0xebba */
    OTHER,        /* 0xebbb */
    OTHER,        /* 0xebbc */
    OTHER,        /* 0xebbd */
    OTHER,        /* 0xebbe */
    OTHER,        /* 0xebbf */
    OTHER,        /* 0xebc0 */
    OTHER,        /* 0xebc1 */
    OTHER,        /* 0xebc2 */
    OTHER,        /* 0xebc3 */
    OTHER,        /* 0xebc4 */
    OTHER,        /* 0xebc5 */
    OTHER,        /* 0xebc6 */
    OTHER,        /* 0xebc7 */
    OTHER,        /* 0xebc8 */
    OTHER,        /* 0xebc9 */
    OTHER,        /* 0xebca */
    OTHER,        /* 0xebcb */
    OTHER,        /* 0xebcc */
    OTHER,        /* 0xebcd */
    OTHER,        /* 0xebce */
    OTHER,        /* 0xebcf */
    OTHER,        /* 0xebd0 */
    OTHER,        /* 0xebd1 */
    OTHER,        /* 0xebd2 */
    OTHER,        /* 0xebd3 */
    OTHER,        /* 0xebd4 */
    OTHER,        /* 0xebd5 */
    OTHER,        /* 0xebd6 */
    OTHER,        /* 0xebd7 */
    OTHER,        /* 0xebd8 */
    OTHER,        /* 0xebd9 */
    OTHER,        /* 0xebda */
    OTHER,        /* 0xebdb */
    OTHER,        /* 0xebdc */
    OTHER,        /* 0xebdd */
    OTHER,        /* 0xebde */
    OTHER,        /* 0xebdf */
    OTHER,        /* 0xebe0 */
    OTHER,        /* 0xebe1 */
    OTHER,        /* 0xebe2 */
    OTHER,        /* 0xebe3 */
    OTHER,        /* 0xebe4 */
    OTHER,        /* 0xebe5 */
    OTHER,        /* 0xebe6 */
    OTHER,        /* 0xebe7 */
    OTHER,        /* 0xebe8 */
    OTHER,        /* 0xebe9 */
    OTHER,        /* 0xebea */
    OTHER,        /* 0xebeb */
    OTHER,        /* 0xebec */
    OTHER,        /* 0xebed */
    OTHER,        /* 0xebee */
    OTHER,        /* 0xebef */
    OTHER,        /* 0xebf0 */
    OTHER,        /* 0xebf1 */
    OTHER,        /* 0xebf2 */
    OTHER,        /* 0xebf3 */
    OTHER,        /* 0xebf4 */
    OTHER,        /* 0xebf5 */
    OTHER,        /* 0xebf6 */
    OTHER,        /* 0xebf7 */
    OTHER,        /* 0xebf8 */
    OTHER,        /* 0xebf9 */
    OTHER,        /* 0xebfa */
    OTHER,        /* 0xebfb */
    OTHER,        /* 0xebfc */
    OTHER,        /* 0xebfd */
    OTHER,        /* 0xebfe */
    OTHER,        /* 0xebff */
    OTHER,        /* 0xec00 */
    OTHER,        /* 0xec01 */
    OTHER,        /* 0xec02 */
    OTHER,        /* 0xec03 */
    OTHER,        /* 0xec04 */
    OTHER,        /* 0xec05 */
    OTHER,        /* 0xec06 */
    OTHER,        /* 0xec07 */
    OTHER,        /* 0xec08 */
    OTHER,        /* 0xec09 */
    OTHER,        /* 0xec0a */
    OTHER,        /* 0xec0b */
    OTHER,        /* 0xec0c */
    OTHER,        /* 0xec0d */
    OTHER,        /* 0xec0e */
    OTHER,        /* 0xec0f */
    OTHER,        /* 0xec10 */
    OTHER,        /* 0xec11 */
    OTHER,        /* 0xec12 */
    OTHER,        /* 0xec13 */
    OTHER,        /* 0xec14 */
    OTHER,        /* 0xec15 */
    OTHER,        /* 0xec16 */
    OTHER,        /* 0xec17 */
    OTHER,        /* 0xec18 */
    OTHER,        /* 0xec19 */
    OTHER,        /* 0xec1a */
    OTHER,        /* 0xec1b */
    OTHER,        /* 0xec1c */
    OTHER,        /* 0xec1d */
    OTHER,        /* 0xec1e */
    OTHER,        /* 0xec1f */
    OTHER,        /* 0xec20 */
    OTHER,        /* 0xec21 */
    OTHER,        /* 0xec22 */
    OTHER,        /* 0xec23 */
    OTHER,        /* 0xec24 */
    OTHER,        /* 0xec25 */
    OTHER,        /* 0xec26 */
    OTHER,        /* 0xec27 */
    OTHER,        /* 0xec28 */
    OTHER,        /* 0xec29 */
    OTHER,        /* 0xec2a */
    OTHER,        /* 0xec2b */
    OTHER,        /* 0xec2c */
    OTHER,        /* 0xec2d */
    OTHER,        /* 0xec2e */
    OTHER,        /* 0xec2f */
    OTHER,        /* 0xec30 */
    OTHER,        /* 0xec31 */
    OTHER,        /* 0xec32 */
    OTHER,        /* 0xec33 */
    OTHER,        /* 0xec34 */
    OTHER,        /* 0xec35 */
    OTHER,        /* 0xec36 */
    OTHER,        /* 0xec37 */
    OTHER,        /* 0xec38 */
    OTHER,        /* 0xec39 */
    OTHER,        /* 0xec3a */
    OTHER,        /* 0xec3b */
    OTHER,        /* 0xec3c */
    OTHER,        /* 0xec3d */
    OTHER,        /* 0xec3e */
    OTHER,        /* 0xec3f */
    OTHER,        /* 0xec40 */
    OTHER,        /* 0xec41 */
    OTHER,        /* 0xec42 */
    OTHER,        /* 0xec43 */
    OTHER,        /* 0xec44 */
    OTHER,        /* 0xec45 */
    OTHER,        /* 0xec46 */
    OTHER,        /* 0xec47 */
    OTHER,        /* 0xec48 */
    OTHER,        /* 0xec49 */
    OTHER,        /* 0xec4a */
    OTHER,        /* 0xec4b */
    OTHER,        /* 0xec4c */
    OTHER,        /* 0xec4d */
    OTHER,        /* 0xec4e */
    OTHER,        /* 0xec4f */
    OTHER,        /* 0xec50 */
    OTHER,        /* 0xec51 */
    OTHER,        /* 0xec52 */
    OTHER,        /* 0xec53 */
    OTHER,        /* 0xec54 */
    OTHER,        /* 0xec55 */
    OTHER,        /* 0xec56 */
    OTHER,        /* 0xec57 */
    OTHER,        /* 0xec58 */
    OTHER,        /* 0xec59 */
    OTHER,        /* 0xec5a */
    OTHER,        /* 0xec5b */
    OTHER,        /* 0xec5c */
    OTHER,        /* 0xec5d */
    OTHER,        /* 0xec5e */
    OTHER,        /* 0xec5f */
    OTHER,        /* 0xec60 */
    OTHER,        /* 0xec61 */
    OTHER,        /* 0xec62 */
    OTHER,        /* 0xec63 */
    OTHER,        /* 0xec64 */
    OTHER,        /* 0xec65 */
    OTHER,        /* 0xec66 */
    OTHER,        /* 0xec67 */
    OTHER,        /* 0xec68 */
    OTHER,        /* 0xec69 */
    OTHER,        /* 0xec6a */
    OTHER,        /* 0xec6b */
    OTHER,        /* 0xec6c */
    OTHER,        /* 0xec6d */
    OTHER,        /* 0xec6e */
    OTHER,        /* 0xec6f */
    OTHER,        /* 0xec70 */
    OTHER,        /* 0xec71 */
    OTHER,        /* 0xec72 */
    OTHER,        /* 0xec73 */
    OTHER,        /* 0xec74 */
    OTHER,        /* 0xec75 */
    OTHER,        /* 0xec76 */
    OTHER,        /* 0xec77 */
    OTHER,        /* 0xec78 */
    OTHER,        /* 0xec79 */
    OTHER,        /* 0xec7a */
    OTHER,        /* 0xec7b */
    OTHER,        /* 0xec7c */
    OTHER,        /* 0xec7d */
    OTHER,        /* 0xec7e */
    OTHER,        /* 0xec7f */
    OTHER,        /* 0xec80 */
    OTHER,        /* 0xec81 */
    OTHER,        /* 0xec82 */
    OTHER,        /* 0xec83 */
    OTHER,        /* 0xec84 */
    OTHER,        /* 0xec85 */
    OTHER,        /* 0xec86 */
    OTHER,        /* 0xec87 */
    OTHER,        /* 0xec88 */
    OTHER,        /* 0xec89 */
    OTHER,        /* 0xec8a */
    OTHER,        /* 0xec8b */
    OTHER,        /* 0xec8c */
    OTHER,        /* 0xec8d */
    OTHER,        /* 0xec8e */
    OTHER,        /* 0xec8f */
    OTHER,        /* 0xec90 */
    OTHER,        /* 0xec91 */
    OTHER,        /* 0xec92 */
    OTHER,        /* 0xec93 */
    OTHER,        /* 0xec94 */
    OTHER,        /* 0xec95 */
    OTHER,        /* 0xec96 */
    OTHER,        /* 0xec97 */
    OTHER,        /* 0xec98 */
    OTHER,        /* 0xec99 */
    OTHER,        /* 0xec9a */
    OTHER,        /* 0xec9b */
    OTHER,        /* 0xec9c */
    OTHER,        /* 0xec9d */
    OTHER,        /* 0xec9e */
    OTHER,        /* 0xec9f */
    OTHER,        /* 0xeca0 */
    OTHER,        /* 0xeca1 */
    OTHER,        /* 0xeca2 */
    OTHER,        /* 0xeca3 */
    OTHER,        /* 0xeca4 */
    OTHER,        /* 0xeca5 */
    OTHER,        /* 0xeca6 */
    OTHER,        /* 0xeca7 */
    OTHER,        /* 0xeca8 */
    OTHER,        /* 0xeca9 */
    OTHER,        /* 0xecaa */
    OTHER,        /* 0xecab */
    OTHER,        /* 0xecac */
    OTHER,        /* 0xecad */
    OTHER,        /* 0xecae */
    OTHER,        /* 0xecaf */
    OTHER,        /* 0xecb0 */
    OTHER,        /* 0xecb1 */
    OTHER,        /* 0xecb2 */
    OTHER,        /* 0xecb3 */
    OTHER,        /* 0xecb4 */
    OTHER,        /* 0xecb5 */
    OTHER,        /* 0xecb6 */
    OTHER,        /* 0xecb7 */
    OTHER,        /* 0xecb8 */
    OTHER,        /* 0xecb9 */
    OTHER,        /* 0xecba */
    OTHER,        /* 0xecbb */
    OTHER,        /* 0xecbc */
    OTHER,        /* 0xecbd */
    OTHER,        /* 0xecbe */
    OTHER,        /* 0xecbf */
    OTHER,        /* 0xecc0 */
    OTHER,        /* 0xecc1 */
    OTHER,        /* 0xecc2 */
    OTHER,        /* 0xecc3 */
    OTHER,        /* 0xecc4 */
    OTHER,        /* 0xecc5 */
    OTHER,        /* 0xecc6 */
    OTHER,        /* 0xecc7 */
    OTHER,        /* 0xecc8 */
    OTHER,        /* 0xecc9 */
    OTHER,        /* 0xecca */
    OTHER,        /* 0xeccb */
    OTHER,        /* 0xeccc */
    OTHER,        /* 0xeccd */
    OTHER,        /* 0xecce */
    OTHER,        /* 0xeccf */
    OTHER,        /* 0xecd0 */
    OTHER,        /* 0xecd1 */
    OTHER,        /* 0xecd2 */
    OTHER,        /* 0xecd3 */
    OTHER,        /* 0xecd4 */
    OTHER,        /* 0xecd5 */
    OTHER,        /* 0xecd6 */
    OTHER,        /* 0xecd7 */
    OTHER,        /* 0xecd8 */
    OTHER,        /* 0xecd9 */
    OTHER,        /* 0xecda */
    OTHER,        /* 0xecdb */
    OTHER,        /* 0xecdc */
    OTHER,        /* 0xecdd */
    OTHER,        /* 0xecde */
    OTHER,        /* 0xecdf */
    OTHER,        /* 0xece0 */
    OTHER,        /* 0xece1 */
    OTHER,        /* 0xece2 */
    OTHER,        /* 0xece3 */
    OTHER,        /* 0xece4 */
    OTHER,        /* 0xece5 */
    OTHER,        /* 0xece6 */
    OTHER,        /* 0xece7 */
    OTHER,        /* 0xece8 */
    OTHER,        /* 0xece9 */
    OTHER,        /* 0xecea */
    OTHER,        /* 0xeceb */
    OTHER,        /* 0xecec */
    OTHER,        /* 0xeced */
    OTHER,        /* 0xecee */
    OTHER,        /* 0xecef */
    OTHER,        /* 0xecf0 */
    OTHER,        /* 0xecf1 */
    OTHER,        /* 0xecf2 */
    OTHER,        /* 0xecf3 */
    OTHER,        /* 0xecf4 */
    OTHER,        /* 0xecf5 */
    OTHER,        /* 0xecf6 */
    OTHER,        /* 0xecf7 */
    OTHER,        /* 0xecf8 */
    OTHER,        /* 0xecf9 */
    OTHER,        /* 0xecfa */
    OTHER,        /* 0xecfb */
    OTHER,        /* 0xecfc */
    OTHER,        /* 0xecfd */
    OTHER,        /* 0xecfe */
    OTHER,        /* 0xecff */
    OTHER,        /* 0xed00 */
    OTHER,        /* 0xed01 */
    OTHER,        /* 0xed02 */
    OTHER,        /* 0xed03 */
    OTHER,        /* 0xed04 */
    OTHER,        /* 0xed05 */
    OTHER,        /* 0xed06 */
    OTHER,        /* 0xed07 */
    OTHER,        /* 0xed08 */
    OTHER,        /* 0xed09 */
    OTHER,        /* 0xed0a */
    OTHER,        /* 0xed0b */
    OTHER,        /* 0xed0c */
    OTHER,        /* 0xed0d */
    OTHER,        /* 0xed0e */
    OTHER,        /* 0xed0f */
    OTHER,        /* 0xed10 */
    OTHER,        /* 0xed11 */
    OTHER,        /* 0xed12 */
    OTHER,        /* 0xed13 */
    OTHER,        /* 0xed14 */
    OTHER,        /* 0xed15 */
    OTHER,        /* 0xed16 */
    OTHER,        /* 0xed17 */
    OTHER,        /* 0xed18 */
    OTHER,        /* 0xed19 */
    OTHER,        /* 0xed1a */
    OTHER,        /* 0xed1b */
    OTHER,        /* 0xed1c */
    OTHER,        /* 0xed1d */
    OTHER,        /* 0xed1e */
    OTHER,        /* 0xed1f */
    OTHER,        /* 0xed20 */
    OTHER,        /* 0xed21 */
    OTHER,        /* 0xed22 */
    OTHER,        /* 0xed23 */
    OTHER,        /* 0xed24 */
    OTHER,        /* 0xed25 */
    OTHER,        /* 0xed26 */
    OTHER,        /* 0xed27 */
    OTHER,        /* 0xed28 */
    OTHER,        /* 0xed29 */
    OTHER,        /* 0xed2a */
    OTHER,        /* 0xed2b */
    OTHER,        /* 0xed2c */
    OTHER,        /* 0xed2d */
    OTHER,        /* 0xed2e */
    OTHER,        /* 0xed2f */
    OTHER,        /* 0xed30 */
    OTHER,        /* 0xed31 */
    OTHER,        /* 0xed32 */
    OTHER,        /* 0xed33 */
    OTHER,        /* 0xed34 */
    OTHER,        /* 0xed35 */
    OTHER,        /* 0xed36 */
    OTHER,        /* 0xed37 */
    OTHER,        /* 0xed38 */
    OTHER,        /* 0xed39 */
    OTHER,        /* 0xed3a */
    OTHER,        /* 0xed3b */
    OTHER,        /* 0xed3c */
    OTHER,        /* 0xed3d */
    OTHER,        /* 0xed3e */
    OTHER,        /* 0xed3f */
    OTHER,        /* 0xed40 */
    OTHER,        /* 0xed41 */
    OTHER,        /* 0xed42 */
    OTHER,        /* 0xed43 */
    OTHER,        /* 0xed44 */
    OTHER,        /* 0xed45 */
    OTHER,        /* 0xed46 */
    OTHER,        /* 0xed47 */
    OTHER,        /* 0xed48 */
    OTHER,        /* 0xed49 */
    OTHER,        /* 0xed4a */
    OTHER,        /* 0xed4b */
    OTHER,        /* 0xed4c */
    OTHER,        /* 0xed4d */
    OTHER,        /* 0xed4e */
    OTHER,        /* 0xed4f */
    OTHER,        /* 0xed50 */
    OTHER,        /* 0xed51 */
    OTHER,        /* 0xed52 */
    OTHER,        /* 0xed53 */
    OTHER,        /* 0xed54 */
    OTHER,        /* 0xed55 */
    OTHER,        /* 0xed56 */
    OTHER,        /* 0xed57 */
    OTHER,        /* 0xed58 */
    OTHER,        /* 0xed59 */
    OTHER,        /* 0xed5a */
    OTHER,        /* 0xed5b */
    OTHER,        /* 0xed5c */
    OTHER,        /* 0xed5d */
    OTHER,        /* 0xed5e */
    OTHER,        /* 0xed5f */
    OTHER,        /* 0xed60 */
    OTHER,        /* 0xed61 */
    OTHER,        /* 0xed62 */
    OTHER,        /* 0xed63 */
    OTHER,        /* 0xed64 */
    OTHER,        /* 0xed65 */
    OTHER,        /* 0xed66 */
    OTHER,        /* 0xed67 */
    OTHER,        /* 0xed68 */
    OTHER,        /* 0xed69 */
    OTHER,        /* 0xed6a */
    OTHER,        /* 0xed6b */
    OTHER,        /* 0xed6c */
    OTHER,        /* 0xed6d */
    OTHER,        /* 0xed6e */
    OTHER,        /* 0xed6f */
    OTHER,        /* 0xed70 */
    OTHER,        /* 0xed71 */
    OTHER,        /* 0xed72 */
    OTHER,        /* 0xed73 */
    OTHER,        /* 0xed74 */
    OTHER,        /* 0xed75 */
    OTHER,        /* 0xed76 */
    OTHER,        /* 0xed77 */
    OTHER,        /* 0xed78 */
    OTHER,        /* 0xed79 */
    OTHER,        /* 0xed7a */
    OTHER,        /* 0xed7b */
    OTHER,        /* 0xed7c */
    OTHER,        /* 0xed7d */
    OTHER,        /* 0xed7e */
    OTHER,        /* 0xed7f */
    OTHER,        /* 0xed80 */
    OTHER,        /* 0xed81 */
    OTHER,        /* 0xed82 */
    OTHER,        /* 0xed83 */
    OTHER,        /* 0xed84 */
    OTHER,        /* 0xed85 */
    OTHER,        /* 0xed86 */
    OTHER,        /* 0xed87 */
    OTHER,        /* 0xed88 */
    OTHER,        /* 0xed89 */
    OTHER,        /* 0xed8a */
    OTHER,        /* 0xed8b */
    OTHER,        /* 0xed8c */
    OTHER,        /* 0xed8d */
    OTHER,        /* 0xed8e */
    OTHER,        /* 0xed8f */
    OTHER,        /* 0xed90 */
    OTHER,        /* 0xed91 */
    OTHER,        /* 0xed92 */
    OTHER,        /* 0xed93 */
    OTHER,        /* 0xed94 */
    OTHER,        /* 0xed95 */
    OTHER,        /* 0xed96 */
    OTHER,        /* 0xed97 */
    OTHER,        /* 0xed98 */
    OTHER,        /* 0xed99 */
    OTHER,        /* 0xed9a */
    OTHER,        /* 0xed9b */
    OTHER,        /* 0xed9c */
    OTHER,        /* 0xed9d */
    OTHER,        /* 0xed9e */
    OTHER,        /* 0xed9f */
    OTHER,        /* 0xeda0 */
    OTHER,        /* 0xeda1 */
    OTHER,        /* 0xeda2 */
    OTHER,        /* 0xeda3 */
    OTHER,        /* 0xeda4 */
    OTHER,        /* 0xeda5 */
    OTHER,        /* 0xeda6 */
    OTHER,        /* 0xeda7 */
    OTHER,        /* 0xeda8 */
    OTHER,        /* 0xeda9 */
    OTHER,        /* 0xedaa */
    OTHER,        /* 0xedab */
    OTHER,        /* 0xedac */
    OTHER,        /* 0xedad */
    OTHER,        /* 0xedae */
    OTHER,        /* 0xedaf */
    OTHER,        /* 0xedb0 */
    OTHER,        /* 0xedb1 */
    OTHER,        /* 0xedb2 */
    OTHER,        /* 0xedb3 */
    OTHER,        /* 0xedb4 */
    OTHER,        /* 0xedb5 */
    OTHER,        /* 0xedb6 */
    OTHER,        /* 0xedb7 */
    OTHER,        /* 0xedb8 */
    OTHER,        /* 0xedb9 */
    OTHER,        /* 0xedba */
    OTHER,        /* 0xedbb */
    OTHER,        /* 0xedbc */
    OTHER,        /* 0xedbd */
    OTHER,        /* 0xedbe */
    OTHER,        /* 0xedbf */
    OTHER,        /* 0xedc0 */
    OTHER,        /* 0xedc1 */
    OTHER,        /* 0xedc2 */
    OTHER,        /* 0xedc3 */
    OTHER,        /* 0xedc4 */
    OTHER,        /* 0xedc5 */
    OTHER,        /* 0xedc6 */
    OTHER,        /* 0xedc7 */
    OTHER,        /* 0xedc8 */
    OTHER,        /* 0xedc9 */
    OTHER,        /* 0xedca */
    OTHER,        /* 0xedcb */
    OTHER,        /* 0xedcc */
    OTHER,        /* 0xedcd */
    OTHER,        /* 0xedce */
    OTHER,        /* 0xedcf */
    OTHER,        /* 0xedd0 */
    OTHER,        /* 0xedd1 */
    OTHER,        /* 0xedd2 */
    OTHER,        /* 0xedd3 */
    OTHER,        /* 0xedd4 */
    OTHER,        /* 0xedd5 */
    OTHER,        /* 0xedd6 */
    OTHER,        /* 0xedd7 */
    OTHER,        /* 0xedd8 */
    OTHER,        /* 0xedd9 */
    OTHER,        /* 0xedda */
    OTHER,        /* 0xeddb */
    OTHER,        /* 0xeddc */
    OTHER,        /* 0xeddd */
    OTHER,        /* 0xedde */
    OTHER,        /* 0xeddf */
    OTHER,        /* 0xede0 */
    OTHER,        /* 0xede1 */
    OTHER,        /* 0xede2 */
    OTHER,        /* 0xede3 */
    OTHER,        /* 0xede4 */
    OTHER,        /* 0xede5 */
    OTHER,        /* 0xede6 */
    OTHER,        /* 0xede7 */
    OTHER,        /* 0xede8 */
    OTHER,        /* 0xede9 */
    OTHER,        /* 0xedea */
    OTHER,        /* 0xedeb */
    OTHER,        /* 0xedec */
    OTHER,        /* 0xeded */
    OTHER,        /* 0xedee */
    OTHER,        /* 0xedef */
    OTHER,        /* 0xedf0 */
    OTHER,        /* 0xedf1 */
    OTHER,        /* 0xedf2 */
    OTHER,        /* 0xedf3 */
    OTHER,        /* 0xedf4 */
    OTHER,        /* 0xedf5 */
    OTHER,        /* 0xedf6 */
    OTHER,        /* 0xedf7 */
    OTHER,        /* 0xedf8 */
    OTHER,        /* 0xedf9 */
    OTHER,        /* 0xedfa */
    OTHER,        /* 0xedfb */
    OTHER,        /* 0xedfc */
    OTHER,        /* 0xedfd */
    OTHER,        /* 0xedfe */
    OTHER,        /* 0xedff */
    OTHER,        /* 0xee00 */
    OTHER,        /* 0xee01 */
    OTHER,        /* 0xee02 */
    OTHER,        /* 0xee03 */
    OTHER,        /* 0xee04 */
    OTHER,        /* 0xee05 */
    OTHER,        /* 0xee06 */
    OTHER,        /* 0xee07 */
    OTHER,        /* 0xee08 */
    OTHER,        /* 0xee09 */
    OTHER,        /* 0xee0a */
    OTHER,        /* 0xee0b */
    OTHER,        /* 0xee0c */
    OTHER,        /* 0xee0d */
    OTHER,        /* 0xee0e */
    OTHER,        /* 0xee0f */
    OTHER,        /* 0xee10 */
    OTHER,        /* 0xee11 */
    OTHER,        /* 0xee12 */
    OTHER,        /* 0xee13 */
    OTHER,        /* 0xee14 */
    OTHER,        /* 0xee15 */
    OTHER,        /* 0xee16 */
    OTHER,        /* 0xee17 */
    OTHER,        /* 0xee18 */
    OTHER,        /* 0xee19 */
    OTHER,        /* 0xee1a */
    OTHER,        /* 0xee1b */
    OTHER,        /* 0xee1c */
    OTHER,        /* 0xee1d */
    OTHER,        /* 0xee1e */
    OTHER,        /* 0xee1f */
    OTHER,        /* 0xee20 */
    OTHER,        /* 0xee21 */
    OTHER,        /* 0xee22 */
    OTHER,        /* 0xee23 */
    OTHER,        /* 0xee24 */
    OTHER,        /* 0xee25 */
    OTHER,        /* 0xee26 */
    OTHER,        /* 0xee27 */
    OTHER,        /* 0xee28 */
    OTHER,        /* 0xee29 */
    OTHER,        /* 0xee2a */
    OTHER,        /* 0xee2b */
    OTHER,        /* 0xee2c */
    OTHER,        /* 0xee2d */
    OTHER,        /* 0xee2e */
    OTHER,        /* 0xee2f */
    OTHER,        /* 0xee30 */
    OTHER,        /* 0xee31 */
    OTHER,        /* 0xee32 */
    OTHER,        /* 0xee33 */
    OTHER,        /* 0xee34 */
    OTHER,        /* 0xee35 */
    OTHER,        /* 0xee36 */
    OTHER,        /* 0xee37 */
    OTHER,        /* 0xee38 */
    OTHER,        /* 0xee39 */
    OTHER,        /* 0xee3a */
    OTHER,        /* 0xee3b */
    OTHER,        /* 0xee3c */
    OTHER,        /* 0xee3d */
    OTHER,        /* 0xee3e */
    OTHER,        /* 0xee3f */
    OTHER,        /* 0xee40 */
    OTHER,        /* 0xee41 */
    OTHER,        /* 0xee42 */
    OTHER,        /* 0xee43 */
    OTHER,        /* 0xee44 */
    OTHER,        /* 0xee45 */
    OTHER,        /* 0xee46 */
    OTHER,        /* 0xee47 */
    OTHER,        /* 0xee48 */
    OTHER,        /* 0xee49 */
    OTHER,        /* 0xee4a */
    OTHER,        /* 0xee4b */
    OTHER,        /* 0xee4c */
    OTHER,        /* 0xee4d */
    OTHER,        /* 0xee4e */
    OTHER,        /* 0xee4f */
    OTHER,        /* 0xee50 */
    OTHER,        /* 0xee51 */
    OTHER,        /* 0xee52 */
    OTHER,        /* 0xee53 */
    OTHER,        /* 0xee54 */
    OTHER,        /* 0xee55 */
    OTHER,        /* 0xee56 */
    OTHER,        /* 0xee57 */
    OTHER,        /* 0xee58 */
    OTHER,        /* 0xee59 */
    OTHER,        /* 0xee5a */
    OTHER,        /* 0xee5b */
    OTHER,        /* 0xee5c */
    OTHER,        /* 0xee5d */
    OTHER,        /* 0xee5e */
    OTHER,        /* 0xee5f */
    OTHER,        /* 0xee60 */
    OTHER,        /* 0xee61 */
    OTHER,        /* 0xee62 */
    OTHER,        /* 0xee63 */
    OTHER,        /* 0xee64 */
    OTHER,        /* 0xee65 */
    OTHER,        /* 0xee66 */
    OTHER,        /* 0xee67 */
    OTHER,        /* 0xee68 */
    OTHER,        /* 0xee69 */
    OTHER,        /* 0xee6a */
    OTHER,        /* 0xee6b */
    OTHER,        /* 0xee6c */
    OTHER,        /* 0xee6d */
    OTHER,        /* 0xee6e */
    OTHER,        /* 0xee6f */
    OTHER,        /* 0xee70 */
    OTHER,        /* 0xee71 */
    OTHER,        /* 0xee72 */
    OTHER,        /* 0xee73 */
    OTHER,        /* 0xee74 */
    OTHER,        /* 0xee75 */
    OTHER,        /* 0xee76 */
    OTHER,        /* 0xee77 */
    OTHER,        /* 0xee78 */
    OTHER,        /* 0xee79 */
    OTHER,        /* 0xee7a */
    OTHER,        /* 0xee7b */
    OTHER,        /* 0xee7c */
    OTHER,        /* 0xee7d */
    OTHER,        /* 0xee7e */
    OTHER,        /* 0xee7f */
    OTHER,        /* 0xee80 */
    OTHER,        /* 0xee81 */
    OTHER,        /* 0xee82 */
    OTHER,        /* 0xee83 */
    OTHER,        /* 0xee84 */
    OTHER,        /* 0xee85 */
    OTHER,        /* 0xee86 */
    OTHER,        /* 0xee87 */
    OTHER,        /* 0xee88 */
    OTHER,        /* 0xee89 */
    OTHER,        /* 0xee8a */
    OTHER,        /* 0xee8b */
    OTHER,        /* 0xee8c */
    OTHER,        /* 0xee8d */
    OTHER,        /* 0xee8e */
    OTHER,        /* 0xee8f */
    OTHER,        /* 0xee90 */
    OTHER,        /* 0xee91 */
    OTHER,        /* 0xee92 */
    OTHER,        /* 0xee93 */
    OTHER,        /* 0xee94 */
    OTHER,        /* 0xee95 */
    OTHER,        /* 0xee96 */
    OTHER,        /* 0xee97 */
    OTHER,        /* 0xee98 */
    OTHER,        /* 0xee99 */
    OTHER,        /* 0xee9a */
    OTHER,        /* 0xee9b */
    OTHER,        /* 0xee9c */
    OTHER,        /* 0xee9d */
    OTHER,        /* 0xee9e */
    OTHER,        /* 0xee9f */
    OTHER,        /* 0xeea0 */
    OTHER,        /* 0xeea1 */
    OTHER,        /* 0xeea2 */
    OTHER,        /* 0xeea3 */
    OTHER,        /* 0xeea4 */
    OTHER,        /* 0xeea5 */
    OTHER,        /* 0xeea6 */
    OTHER,        /* 0xeea7 */
    OTHER,        /* 0xeea8 */
    OTHER,        /* 0xeea9 */
    OTHER,        /* 0xeeaa */
    OTHER,        /* 0xeeab */
    OTHER,        /* 0xeeac */
    OTHER,        /* 0xeead */
    OTHER,        /* 0xeeae */
    OTHER,        /* 0xeeaf */
    OTHER,        /* 0xeeb0 */
    OTHER,        /* 0xeeb1 */
    OTHER,        /* 0xeeb2 */
    OTHER,        /* 0xeeb3 */
    OTHER,        /* 0xeeb4 */
    OTHER,        /* 0xeeb5 */
    OTHER,        /* 0xeeb6 */
    OTHER,        /* 0xeeb7 */
    OTHER,        /* 0xeeb8 */
    OTHER,        /* 0xeeb9 */
    OTHER,        /* 0xeeba */
    OTHER,        /* 0xeebb */
    OTHER,        /* 0xeebc */
    OTHER,        /* 0xeebd */
    OTHER,        /* 0xeebe */
    OTHER,        /* 0xeebf */
    OTHER,        /* 0xeec0 */
    OTHER,        /* 0xeec1 */
    OTHER,        /* 0xeec2 */
    OTHER,        /* 0xeec3 */
    OTHER,        /* 0xeec4 */
    OTHER,        /* 0xeec5 */
    OTHER,        /* 0xeec6 */
    OTHER,        /* 0xeec7 */
    OTHER,        /* 0xeec8 */
    OTHER,        /* 0xeec9 */
    OTHER,        /* 0xeeca */
    OTHER,        /* 0xeecb */
    OTHER,        /* 0xeecc */
    OTHER,        /* 0xeecd */
    OTHER,        /* 0xeece */
    OTHER,        /* 0xeecf */
    OTHER,        /* 0xeed0 */
    OTHER,        /* 0xeed1 */
    OTHER,        /* 0xeed2 */
    OTHER,        /* 0xeed3 */
    OTHER,        /* 0xeed4 */
    OTHER,        /* 0xeed5 */
    OTHER,        /* 0xeed6 */
    OTHER,        /* 0xeed7 */
    OTHER,        /* 0xeed8 */
    OTHER,        /* 0xeed9 */
    OTHER,        /* 0xeeda */
    OTHER,        /* 0xeedb */
    OTHER,        /* 0xeedc */
    OTHER,        /* 0xeedd */
    OTHER,        /* 0xeede */
    OTHER,        /* 0xeedf */
    OTHER,        /* 0xeee0 */
    OTHER,        /* 0xeee1 */
    OTHER,        /* 0xeee2 */
    OTHER,        /* 0xeee3 */
    OTHER,        /* 0xeee4 */
    OTHER,        /* 0xeee5 */
    OTHER,        /* 0xeee6 */
    OTHER,        /* 0xeee7 */
    OTHER,        /* 0xeee8 */
    OTHER,        /* 0xeee9 */
    OTHER,        /* 0xeeea */
    OTHER,        /* 0xeeeb */
    OTHER,        /* 0xeeec */
    OTHER,        /* 0xeeed */
    OTHER,        /* 0xeeee */
    OTHER,        /* 0xeeef */
    OTHER,        /* 0xeef0 */
    OTHER,        /* 0xeef1 */
    OTHER,        /* 0xeef2 */
    OTHER,        /* 0xeef3 */
    OTHER,        /* 0xeef4 */
    OTHER,        /* 0xeef5 */
    OTHER,        /* 0xeef6 */
    OTHER,        /* 0xeef7 */
    OTHER,        /* 0xeef8 */
    OTHER,        /* 0xeef9 */
    OTHER,        /* 0xeefa */
    OTHER,        /* 0xeefb */
    OTHER,        /* 0xeefc */
    OTHER,        /* 0xeefd */
    OTHER,        /* 0xeefe */
    OTHER,        /* 0xeeff */
    OTHER,        /* 0xef00 */
    OTHER,        /* 0xef01 */
    OTHER,        /* 0xef02 */
    OTHER,        /* 0xef03 */
    OTHER,        /* 0xef04 */
    OTHER,        /* 0xef05 */
    OTHER,        /* 0xef06 */
    OTHER,        /* 0xef07 */
    OTHER,        /* 0xef08 */
    OTHER,        /* 0xef09 */
    OTHER,        /* 0xef0a */
    OTHER,        /* 0xef0b */
    OTHER,        /* 0xef0c */
    OTHER,        /* 0xef0d */
    OTHER,        /* 0xef0e */
    OTHER,        /* 0xef0f */
    OTHER,        /* 0xef10 */
    OTHER,        /* 0xef11 */
    OTHER,        /* 0xef12 */
    OTHER,        /* 0xef13 */
    OTHER,        /* 0xef14 */
    OTHER,        /* 0xef15 */
    OTHER,        /* 0xef16 */
    OTHER,        /* 0xef17 */
    OTHER,        /* 0xef18 */
    OTHER,        /* 0xef19 */
    OTHER,        /* 0xef1a */
    OTHER,        /* 0xef1b */
    OTHER,        /* 0xef1c */
    OTHER,        /* 0xef1d */
    OTHER,        /* 0xef1e */
    OTHER,        /* 0xef1f */
    OTHER,        /* 0xef20 */
    OTHER,        /* 0xef21 */
    OTHER,        /* 0xef22 */
    OTHER,        /* 0xef23 */
    OTHER,        /* 0xef24 */
    OTHER,        /* 0xef25 */
    OTHER,        /* 0xef26 */
    OTHER,        /* 0xef27 */
    OTHER,        /* 0xef28 */
    OTHER,        /* 0xef29 */
    OTHER,        /* 0xef2a */
    OTHER,        /* 0xef2b */
    OTHER,        /* 0xef2c */
    OTHER,        /* 0xef2d */
    OTHER,        /* 0xef2e */
    OTHER,        /* 0xef2f */
    OTHER,        /* 0xef30 */
    OTHER,        /* 0xef31 */
    OTHER,        /* 0xef32 */
    OTHER,        /* 0xef33 */
    OTHER,        /* 0xef34 */
    OTHER,        /* 0xef35 */
    OTHER,        /* 0xef36 */
    OTHER,        /* 0xef37 */
    OTHER,        /* 0xef38 */
    OTHER,        /* 0xef39 */
    OTHER,        /* 0xef3a */
    OTHER,        /* 0xef3b */
    OTHER,        /* 0xef3c */
    OTHER,        /* 0xef3d */
    OTHER,        /* 0xef3e */
    OTHER,        /* 0xef3f */
    OTHER,        /* 0xef40 */
    OTHER,        /* 0xef41 */
    OTHER,        /* 0xef42 */
    OTHER,        /* 0xef43 */
    OTHER,        /* 0xef44 */
    OTHER,        /* 0xef45 */
    OTHER,        /* 0xef46 */
    OTHER,        /* 0xef47 */
    OTHER,        /* 0xef48 */
    OTHER,        /* 0xef49 */
    OTHER,        /* 0xef4a */
    OTHER,        /* 0xef4b */
    OTHER,        /* 0xef4c */
    OTHER,        /* 0xef4d */
    OTHER,        /* 0xef4e */
    OTHER,        /* 0xef4f */
    OTHER,        /* 0xef50 */
    OTHER,        /* 0xef51 */
    OTHER,        /* 0xef52 */
    OTHER,        /* 0xef53 */
    OTHER,        /* 0xef54 */
    OTHER,        /* 0xef55 */
    OTHER,        /* 0xef56 */
    OTHER,        /* 0xef57 */
    OTHER,        /* 0xef58 */
    OTHER,        /* 0xef59 */
    OTHER,        /* 0xef5a */
    OTHER,        /* 0xef5b */
    OTHER,        /* 0xef5c */
    OTHER,        /* 0xef5d */
    OTHER,        /* 0xef5e */
    OTHER,        /* 0xef5f */
    OTHER,        /* 0xef60 */
    OTHER,        /* 0xef61 */
    OTHER,        /* 0xef62 */
    OTHER,        /* 0xef63 */
    OTHER,        /* 0xef64 */
    OTHER,        /* 0xef65 */
    OTHER,        /* 0xef66 */
    OTHER,        /* 0xef67 */
    OTHER,        /* 0xef68 */
    OTHER,        /* 0xef69 */
    OTHER,        /* 0xef6a */
    OTHER,        /* 0xef6b */
    OTHER,        /* 0xef6c */
    OTHER,        /* 0xef6d */
    OTHER,        /* 0xef6e */
    OTHER,        /* 0xef6f */
    OTHER,        /* 0xef70 */
    OTHER,        /* 0xef71 */
    OTHER,        /* 0xef72 */
    OTHER,        /* 0xef73 */
    OTHER,        /* 0xef74 */
    OTHER,        /* 0xef75 */
    OTHER,        /* 0xef76 */
    OTHER,        /* 0xef77 */
    OTHER,        /* 0xef78 */
    OTHER,        /* 0xef79 */
    OTHER,        /* 0xef7a */
    OTHER,        /* 0xef7b */
    OTHER,        /* 0xef7c */
    OTHER,        /* 0xef7d */
    OTHER,        /* 0xef7e */
    OTHER,        /* 0xef7f */
    OTHER,        /* 0xef80 */
    OTHER,        /* 0xef81 */
    OTHER,        /* 0xef82 */
    OTHER,        /* 0xef83 */
    OTHER,        /* 0xef84 */
    OTHER,        /* 0xef85 */
    OTHER,        /* 0xef86 */
    OTHER,        /* 0xef87 */
    OTHER,        /* 0xef88 */
    OTHER,        /* 0xef89 */
    OTHER,        /* 0xef8a */
    OTHER,        /* 0xef8b */
    OTHER,        /* 0xef8c */
    OTHER,        /* 0xef8d */
    OTHER,        /* 0xef8e */
    OTHER,        /* 0xef8f */
    OTHER,        /* 0xef90 */
    OTHER,        /* 0xef91 */
    OTHER,        /* 0xef92 */
    OTHER,        /* 0xef93 */
    OTHER,        /* 0xef94 */
    OTHER,        /* 0xef95 */
    OTHER,        /* 0xef96 */
    OTHER,        /* 0xef97 */
    OTHER,        /* 0xef98 */
    OTHER,        /* 0xef99 */
    OTHER,        /* 0xef9a */
    OTHER,        /* 0xef9b */
    OTHER,        /* 0xef9c */
    OTHER,        /* 0xef9d */
    OTHER,        /* 0xef9e */
    OTHER,        /* 0xef9f */
    OTHER,        /* 0xefa0 */
    OTHER,        /* 0xefa1 */
    OTHER,        /* 0xefa2 */
    OTHER,        /* 0xefa3 */
    OTHER,        /* 0xefa4 */
    OTHER,        /* 0xefa5 */
    OTHER,        /* 0xefa6 */
    OTHER,        /* 0xefa7 */
    OTHER,        /* 0xefa8 */
    OTHER,        /* 0xefa9 */
    OTHER,        /* 0xefaa */
    OTHER,        /* 0xefab */
    OTHER,        /* 0xefac */
    OTHER,        /* 0xefad */
    OTHER,        /* 0xefae */
    OTHER,        /* 0xefaf */
    OTHER,        /* 0xefb0 */
    OTHER,        /* 0xefb1 */
    OTHER,        /* 0xefb2 */
    OTHER,        /* 0xefb3 */
    OTHER,        /* 0xefb4 */
    OTHER,        /* 0xefb5 */
    OTHER,        /* 0xefb6 */
    OTHER,        /* 0xefb7 */
    OTHER,        /* 0xefb8 */
    OTHER,        /* 0xefb9 */
    OTHER,        /* 0xefba */
    OTHER,        /* 0xefbb */
    OTHER,        /* 0xefbc */
    OTHER,        /* 0xefbd */
    OTHER,        /* 0xefbe */
    OTHER,        /* 0xefbf */
    OTHER,        /* 0xefc0 */
    OTHER,        /* 0xefc1 */
    OTHER,        /* 0xefc2 */
    OTHER,        /* 0xefc3 */
    OTHER,        /* 0xefc4 */
    OTHER,        /* 0xefc5 */
    OTHER,        /* 0xefc6 */
    OTHER,        /* 0xefc7 */
    OTHER,        /* 0xefc8 */
    OTHER,        /* 0xefc9 */
    OTHER,        /* 0xefca */
    OTHER,        /* 0xefcb */
    OTHER,        /* 0xefcc */
    OTHER,        /* 0xefcd */
    OTHER,        /* 0xefce */
    OTHER,        /* 0xefcf */
    OTHER,        /* 0xefd0 */
    OTHER,        /* 0xefd1 */
    OTHER,        /* 0xefd2 */
    OTHER,        /* 0xefd3 */
    OTHER,        /* 0xefd4 */
    OTHER,        /* 0xefd5 */
    OTHER,        /* 0xefd6 */
    OTHER,        /* 0xefd7 */
    OTHER,        /* 0xefd8 */
    OTHER,        /* 0xefd9 */
    OTHER,        /* 0xefda */
    OTHER,        /* 0xefdb */
    OTHER,        /* 0xefdc */
    OTHER,        /* 0xefdd */
    OTHER,        /* 0xefde */
    OTHER,        /* 0xefdf */
    OTHER,        /* 0xefe0 */
    OTHER,        /* 0xefe1 */
    OTHER,        /* 0xefe2 */
    OTHER,        /* 0xefe3 */
    OTHER,        /* 0xefe4 */
    OTHER,        /* 0xefe5 */
    OTHER,        /* 0xefe6 */
    OTHER,        /* 0xefe7 */
    OTHER,        /* 0xefe8 */
    OTHER,        /* 0xefe9 */
    OTHER,        /* 0xefea */
    OTHER,        /* 0xefeb */
    OTHER,        /* 0xefec */
    OTHER,        /* 0xefed */
    OTHER,        /* 0xefee */
    OTHER,        /* 0xefef */
    OTHER,        /* 0xeff0 */
    OTHER,        /* 0xeff1 */
    OTHER,        /* 0xeff2 */
    OTHER,        /* 0xeff3 */
    OTHER,        /* 0xeff4 */
    OTHER,        /* 0xeff5 */
    OTHER,        /* 0xeff6 */
    OTHER,        /* 0xeff7 */
    OTHER,        /* 0xeff8 */
    OTHER,        /* 0xeff9 */
    OTHER,        /* 0xeffa */
    OTHER,        /* 0xeffb */
    OTHER,        /* 0xeffc */
    OTHER,        /* 0xeffd */
    OTHER,        /* 0xeffe */
    OTHER,        /* 0xefff */
    OTHER,        /* 0xf000 */
    OTHER,        /* 0xf001 */
    OTHER,        /* 0xf002 */
    OTHER,        /* 0xf003 */
    OTHER,        /* 0xf004 */
    OTHER,        /* 0xf005 */
    OTHER,        /* 0xf006 */
    OTHER,        /* 0xf007 */
    OTHER,        /* 0xf008 */
    OTHER,        /* 0xf009 */
    OTHER,        /* 0xf00a */
    OTHER,        /* 0xf00b */
    OTHER,        /* 0xf00c */
    OTHER,        /* 0xf00d */
    OTHER,        /* 0xf00e */
    OTHER,        /* 0xf00f */
    OTHER,        /* 0xf010 */
    OTHER,        /* 0xf011 */
    OTHER,        /* 0xf012 */
    OTHER,        /* 0xf013 */
    OTHER,        /* 0xf014 */
    OTHER,        /* 0xf015 */
    OTHER,        /* 0xf016 */
    OTHER,        /* 0xf017 */
    OTHER,        /* 0xf018 */
    OTHER,        /* 0xf019 */
    OTHER,        /* 0xf01a */
    OTHER,        /* 0xf01b */
    OTHER,        /* 0xf01c */
    OTHER,        /* 0xf01d */
    OTHER,        /* 0xf01e */
    OTHER,        /* 0xf01f */
    OTHER,        /* 0xf020 */
    OTHER,        /* 0xf021 */
    OTHER,        /* 0xf022 */
    OTHER,        /* 0xf023 */
    OTHER,        /* 0xf024 */
    OTHER,        /* 0xf025 */
    OTHER,        /* 0xf026 */
    OTHER,        /* 0xf027 */
    OTHER,        /* 0xf028 */
    OTHER,        /* 0xf029 */
    OTHER,        /* 0xf02a */
    OTHER,        /* 0xf02b */
    OTHER,        /* 0xf02c */
    OTHER,        /* 0xf02d */
    OTHER,        /* 0xf02e */
    OTHER,        /* 0xf02f */
    OTHER,        /* 0xf030 */
    OTHER,        /* 0xf031 */
    OTHER,        /* 0xf032 */
    OTHER,        /* 0xf033 */
    OTHER,        /* 0xf034 */
    OTHER,        /* 0xf035 */
    OTHER,        /* 0xf036 */
    OTHER,        /* 0xf037 */
    OTHER,        /* 0xf038 */
    OTHER,        /* 0xf039 */
    OTHER,        /* 0xf03a */
    OTHER,        /* 0xf03b */
    OTHER,        /* 0xf03c */
    OTHER,        /* 0xf03d */
    OTHER,        /* 0xf03e */
    OTHER,        /* 0xf03f */
    OTHER,        /* 0xf040 */
    OTHER,        /* 0xf041 */
    OTHER,        /* 0xf042 */
    OTHER,        /* 0xf043 */
    OTHER,        /* 0xf044 */
    OTHER,        /* 0xf045 */
    OTHER,        /* 0xf046 */
    OTHER,        /* 0xf047 */
    OTHER,        /* 0xf048 */
    OTHER,        /* 0xf049 */
    OTHER,        /* 0xf04a */
    OTHER,        /* 0xf04b */
    OTHER,        /* 0xf04c */
    OTHER,        /* 0xf04d */
    OTHER,        /* 0xf04e */
    OTHER,        /* 0xf04f */
    OTHER,        /* 0xf050 */
    OTHER,        /* 0xf051 */
    OTHER,        /* 0xf052 */
    OTHER,        /* 0xf053 */
    OTHER,        /* 0xf054 */
    OTHER,        /* 0xf055 */
    OTHER,        /* 0xf056 */
    OTHER,        /* 0xf057 */
    OTHER,        /* 0xf058 */
    OTHER,        /* 0xf059 */
    OTHER,        /* 0xf05a */
    OTHER,        /* 0xf05b */
    OTHER,        /* 0xf05c */
    OTHER,        /* 0xf05d */
    OTHER,        /* 0xf05e */
    OTHER,        /* 0xf05f */
    OTHER,        /* 0xf060 */
    OTHER,        /* 0xf061 */
    OTHER,        /* 0xf062 */
    OTHER,        /* 0xf063 */
    OTHER,        /* 0xf064 */
    OTHER,        /* 0xf065 */
    OTHER,        /* 0xf066 */
    OTHER,        /* 0xf067 */
    OTHER,        /* 0xf068 */
    OTHER,        /* 0xf069 */
    OTHER,        /* 0xf06a */
    OTHER,        /* 0xf06b */
    OTHER,        /* 0xf06c */
    OTHER,        /* 0xf06d */
    OTHER,        /* 0xf06e */
    OTHER,        /* 0xf06f */
    OTHER,        /* 0xf070 */
    OTHER,        /* 0xf071 */
    OTHER,        /* 0xf072 */
    OTHER,        /* 0xf073 */
    OTHER,        /* 0xf074 */
    OTHER,        /* 0xf075 */
    OTHER,        /* 0xf076 */
    OTHER,        /* 0xf077 */
    OTHER,        /* 0xf078 */
    OTHER,        /* 0xf079 */
    OTHER,        /* 0xf07a */
    OTHER,        /* 0xf07b */
    OTHER,        /* 0xf07c */
    OTHER,        /* 0xf07d */
    OTHER,        /* 0xf07e */
    OTHER,        /* 0xf07f */
    OTHER,        /* 0xf080 */
    OTHER,        /* 0xf081 */
    OTHER,        /* 0xf082 */
    OTHER,        /* 0xf083 */
    OTHER,        /* 0xf084 */
    OTHER,        /* 0xf085 */
    OTHER,        /* 0xf086 */
    OTHER,        /* 0xf087 */
    OTHER,        /* 0xf088 */
    OTHER,        /* 0xf089 */
    OTHER,        /* 0xf08a */
    OTHER,        /* 0xf08b */
    OTHER,        /* 0xf08c */
    OTHER,        /* 0xf08d */
    OTHER,        /* 0xf08e */
    OTHER,        /* 0xf08f */
    OTHER,        /* 0xf090 */
    OTHER,        /* 0xf091 */
    OTHER,        /* 0xf092 */
    OTHER,        /* 0xf093 */
    OTHER,        /* 0xf094 */
    OTHER,        /* 0xf095 */
    OTHER,        /* 0xf096 */
    OTHER,        /* 0xf097 */
    OTHER,        /* 0xf098 */
    OTHER,        /* 0xf099 */
    OTHER,        /* 0xf09a */
    OTHER,        /* 0xf09b */
    OTHER,        /* 0xf09c */
    OTHER,        /* 0xf09d */
    OTHER,        /* 0xf09e */
    OTHER,        /* 0xf09f */
    OTHER,        /* 0xf0a0 */
    OTHER,        /* 0xf0a1 */
    OTHER,        /* 0xf0a2 */
    OTHER,        /* 0xf0a3 */
    OTHER,        /* 0xf0a4 */
    OTHER,        /* 0xf0a5 */
    OTHER,        /* 0xf0a6 */
    OTHER,        /* 0xf0a7 */
    OTHER,        /* 0xf0a8 */
    OTHER,        /* 0xf0a9 */
    OTHER,        /* 0xf0aa */
    OTHER,        /* 0xf0ab */
    OTHER,        /* 0xf0ac */
    OTHER,        /* 0xf0ad */
    OTHER,        /* 0xf0ae */
    OTHER,        /* 0xf0af */
    OTHER,        /* 0xf0b0 */
    OTHER,        /* 0xf0b1 */
    OTHER,        /* 0xf0b2 */
    OTHER,        /* 0xf0b3 */
    OTHER,        /* 0xf0b4 */
    OTHER,        /* 0xf0b5 */
    OTHER,        /* 0xf0b6 */
    OTHER,        /* 0xf0b7 */
    OTHER,        /* 0xf0b8 */
    OTHER,        /* 0xf0b9 */
    OTHER,        /* 0xf0ba */
    OTHER,        /* 0xf0bb */
    OTHER,        /* 0xf0bc */
    OTHER,        /* 0xf0bd */
    OTHER,        /* 0xf0be */
    OTHER,        /* 0xf0bf */
    OTHER,        /* 0xf0c0 */
    OTHER,        /* 0xf0c1 */
    OTHER,        /* 0xf0c2 */
    OTHER,        /* 0xf0c3 */
    OTHER,        /* 0xf0c4 */
    OTHER,        /* 0xf0c5 */
    OTHER,        /* 0xf0c6 */
    OTHER,        /* 0xf0c7 */
    OTHER,        /* 0xf0c8 */
    OTHER,        /* 0xf0c9 */
    OTHER,        /* 0xf0ca */
    OTHER,        /* 0xf0cb */
    OTHER,        /* 0xf0cc */
    OTHER,        /* 0xf0cd */
    OTHER,        /* 0xf0ce */
    OTHER,        /* 0xf0cf */
    OTHER,        /* 0xf0d0 */
    OTHER,        /* 0xf0d1 */
    OTHER,        /* 0xf0d2 */
    OTHER,        /* 0xf0d3 */
    OTHER,        /* 0xf0d4 */
    OTHER,        /* 0xf0d5 */
    OTHER,        /* 0xf0d6 */
    OTHER,        /* 0xf0d7 */
    OTHER,        /* 0xf0d8 */
    OTHER,        /* 0xf0d9 */
    OTHER,        /* 0xf0da */
    OTHER,        /* 0xf0db */
    OTHER,        /* 0xf0dc */
    OTHER,        /* 0xf0dd */
    OTHER,        /* 0xf0de */
    OTHER,        /* 0xf0df */
    OTHER,        /* 0xf0e0 */
    OTHER,        /* 0xf0e1 */
    OTHER,        /* 0xf0e2 */
    OTHER,        /* 0xf0e3 */
    OTHER,        /* 0xf0e4 */
    OTHER,        /* 0xf0e5 */
    OTHER,        /* 0xf0e6 */
    OTHER,        /* 0xf0e7 */
    OTHER,        /* 0xf0e8 */
    OTHER,        /* 0xf0e9 */
    OTHER,        /* 0xf0ea */
    OTHER,        /* 0xf0eb */
    OTHER,        /* 0xf0ec */
    OTHER,        /* 0xf0ed */
    OTHER,        /* 0xf0ee */
    OTHER,        /* 0xf0ef */
    OTHER,        /* 0xf0f0 */
    OTHER,        /* 0xf0f1 */
    OTHER,        /* 0xf0f2 */
    OTHER,        /* 0xf0f3 */
    OTHER,        /* 0xf0f4 */
    OTHER,        /* 0xf0f5 */
    OTHER,        /* 0xf0f6 */
    OTHER,        /* 0xf0f7 */
    OTHER,        /* 0xf0f8 */
    OTHER,        /* 0xf0f9 */
    OTHER,        /* 0xf0fa */
    OTHER,        /* 0xf0fb */
    OTHER,        /* 0xf0fc */
    OTHER,        /* 0xf0fd */
    OTHER,        /* 0xf0fe */
    OTHER,        /* 0xf0ff */
    OTHER,        /* 0xf100 */
    OTHER,        /* 0xf101 */
    OTHER,        /* 0xf102 */
    OTHER,        /* 0xf103 */
    OTHER,        /* 0xf104 */
    OTHER,        /* 0xf105 */
    OTHER,        /* 0xf106 */
    OTHER,        /* 0xf107 */
    OTHER,        /* 0xf108 */
    OTHER,        /* 0xf109 */
    OTHER,        /* 0xf10a */
    OTHER,        /* 0xf10b */
    OTHER,        /* 0xf10c */
    OTHER,        /* 0xf10d */
    OTHER,        /* 0xf10e */
    OTHER,        /* 0xf10f */
    OTHER,        /* 0xf110 */
    OTHER,        /* 0xf111 */
    OTHER,        /* 0xf112 */
    OTHER,        /* 0xf113 */
    OTHER,        /* 0xf114 */
    OTHER,        /* 0xf115 */
    OTHER,        /* 0xf116 */
    OTHER,        /* 0xf117 */
    OTHER,        /* 0xf118 */
    OTHER,        /* 0xf119 */
    OTHER,        /* 0xf11a */
    OTHER,        /* 0xf11b */
    OTHER,        /* 0xf11c */
    OTHER,        /* 0xf11d */
    OTHER,        /* 0xf11e */
    OTHER,        /* 0xf11f */
    OTHER,        /* 0xf120 */
    OTHER,        /* 0xf121 */
    OTHER,        /* 0xf122 */
    OTHER,        /* 0xf123 */
    OTHER,        /* 0xf124 */
    OTHER,        /* 0xf125 */
    OTHER,        /* 0xf126 */
    OTHER,        /* 0xf127 */
    OTHER,        /* 0xf128 */
    OTHER,        /* 0xf129 */
    OTHER,        /* 0xf12a */
    OTHER,        /* 0xf12b */
    OTHER,        /* 0xf12c */
    OTHER,        /* 0xf12d */
    OTHER,        /* 0xf12e */
    OTHER,        /* 0xf12f */
    OTHER,        /* 0xf130 */
    OTHER,        /* 0xf131 */
    OTHER,        /* 0xf132 */
    OTHER,        /* 0xf133 */
    OTHER,        /* 0xf134 */
    OTHER,        /* 0xf135 */
    OTHER,        /* 0xf136 */
    OTHER,        /* 0xf137 */
    OTHER,        /* 0xf138 */
    OTHER,        /* 0xf139 */
    OTHER,        /* 0xf13a */
    OTHER,        /* 0xf13b */
    OTHER,        /* 0xf13c */
    OTHER,        /* 0xf13d */
    OTHER,        /* 0xf13e */
    OTHER,        /* 0xf13f */
    OTHER,        /* 0xf140 */
    OTHER,        /* 0xf141 */
    OTHER,        /* 0xf142 */
    OTHER,        /* 0xf143 */
    OTHER,        /* 0xf144 */
    OTHER,        /* 0xf145 */
    OTHER,        /* 0xf146 */
    OTHER,        /* 0xf147 */
    OTHER,        /* 0xf148 */
    OTHER,        /* 0xf149 */
    OTHER,        /* 0xf14a */
    OTHER,        /* 0xf14b */
    OTHER,        /* 0xf14c */
    OTHER,        /* 0xf14d */
    OTHER,        /* 0xf14e */
    OTHER,        /* 0xf14f */
    OTHER,        /* 0xf150 */
    OTHER,        /* 0xf151 */
    OTHER,        /* 0xf152 */
    OTHER,        /* 0xf153 */
    OTHER,        /* 0xf154 */
    OTHER,        /* 0xf155 */
    OTHER,        /* 0xf156 */
    OTHER,        /* 0xf157 */
    OTHER,        /* 0xf158 */
    OTHER,        /* 0xf159 */
    OTHER,        /* 0xf15a */
    OTHER,        /* 0xf15b */
    OTHER,        /* 0xf15c */
    OTHER,        /* 0xf15d */
    OTHER,        /* 0xf15e */
    OTHER,        /* 0xf15f */
    OTHER,        /* 0xf160 */
    OTHER,        /* 0xf161 */
    OTHER,        /* 0xf162 */
    OTHER,        /* 0xf163 */
    OTHER,        /* 0xf164 */
    OTHER,        /* 0xf165 */
    OTHER,        /* 0xf166 */
    OTHER,        /* 0xf167 */
    OTHER,        /* 0xf168 */
    OTHER,        /* 0xf169 */
    OTHER,        /* 0xf16a */
    OTHER,        /* 0xf16b */
    OTHER,        /* 0xf16c */
    OTHER,        /* 0xf16d */
    OTHER,        /* 0xf16e */
    OTHER,        /* 0xf16f */
    OTHER,        /* 0xf170 */
    OTHER,        /* 0xf171 */
    OTHER,        /* 0xf172 */
    OTHER,        /* 0xf173 */
    OTHER,        /* 0xf174 */
    OTHER,        /* 0xf175 */
    OTHER,        /* 0xf176 */
    OTHER,        /* 0xf177 */
    OTHER,        /* 0xf178 */
    OTHER,        /* 0xf179 */
    OTHER,        /* 0xf17a */
    OTHER,        /* 0xf17b */
    OTHER,        /* 0xf17c */
    OTHER,        /* 0xf17d */
    OTHER,        /* 0xf17e */
    OTHER,        /* 0xf17f */
    OTHER,        /* 0xf180 */
    OTHER,        /* 0xf181 */
    OTHER,        /* 0xf182 */
    OTHER,        /* 0xf183 */
    OTHER,        /* 0xf184 */
    OTHER,        /* 0xf185 */
    OTHER,        /* 0xf186 */
    OTHER,        /* 0xf187 */
    OTHER,        /* 0xf188 */
    OTHER,        /* 0xf189 */
    OTHER,        /* 0xf18a */
    OTHER,        /* 0xf18b */
    OTHER,        /* 0xf18c */
    OTHER,        /* 0xf18d */
    OTHER,        /* 0xf18e */
    OTHER,        /* 0xf18f */
    OTHER,        /* 0xf190 */
    OTHER,        /* 0xf191 */
    OTHER,        /* 0xf192 */
    OTHER,        /* 0xf193 */
    OTHER,        /* 0xf194 */
    OTHER,        /* 0xf195 */
    OTHER,        /* 0xf196 */
    OTHER,        /* 0xf197 */
    OTHER,        /* 0xf198 */
    OTHER,        /* 0xf199 */
    OTHER,        /* 0xf19a */
    OTHER,        /* 0xf19b */
    OTHER,        /* 0xf19c */
    OTHER,        /* 0xf19d */
    OTHER,        /* 0xf19e */
    OTHER,        /* 0xf19f */
    OTHER,        /* 0xf1a0 */
    OTHER,        /* 0xf1a1 */
    OTHER,        /* 0xf1a2 */
    OTHER,        /* 0xf1a3 */
    OTHER,        /* 0xf1a4 */
    OTHER,        /* 0xf1a5 */
    OTHER,        /* 0xf1a6 */
    OTHER,        /* 0xf1a7 */
    OTHER,        /* 0xf1a8 */
    OTHER,        /* 0xf1a9 */
    OTHER,        /* 0xf1aa */
    OTHER,        /* 0xf1ab */
    OTHER,        /* 0xf1ac */
    OTHER,        /* 0xf1ad */
    OTHER,        /* 0xf1ae */
    OTHER,        /* 0xf1af */
    OTHER,        /* 0xf1b0 */
    OTHER,        /* 0xf1b1 */
    OTHER,        /* 0xf1b2 */
    OTHER,        /* 0xf1b3 */
    OTHER,        /* 0xf1b4 */
    OTHER,        /* 0xf1b5 */
    OTHER,        /* 0xf1b6 */
    OTHER,        /* 0xf1b7 */
    OTHER,        /* 0xf1b8 */
    OTHER,        /* 0xf1b9 */
    OTHER,        /* 0xf1ba */
    OTHER,        /* 0xf1bb */
    OTHER,        /* 0xf1bc */
    OTHER,        /* 0xf1bd */
    OTHER,        /* 0xf1be */
    OTHER,        /* 0xf1bf */
    OTHER,        /* 0xf1c0 */
    OTHER,        /* 0xf1c1 */
    OTHER,        /* 0xf1c2 */
    OTHER,        /* 0xf1c3 */
    OTHER,        /* 0xf1c4 */
    OTHER,        /* 0xf1c5 */
    OTHER,        /* 0xf1c6 */
    OTHER,        /* 0xf1c7 */
    OTHER,        /* 0xf1c8 */
    OTHER,        /* 0xf1c9 */
    OTHER,        /* 0xf1ca */
    OTHER,        /* 0xf1cb */
    OTHER,        /* 0xf1cc */
    OTHER,        /* 0xf1cd */
    OTHER,        /* 0xf1ce */
    OTHER,        /* 0xf1cf */
    OTHER,        /* 0xf1d0 */
    OTHER,        /* 0xf1d1 */
    OTHER,        /* 0xf1d2 */
    OTHER,        /* 0xf1d3 */
    OTHER,        /* 0xf1d4 */
    OTHER,        /* 0xf1d5 */
    OTHER,        /* 0xf1d6 */
    OTHER,        /* 0xf1d7 */
    OTHER,        /* 0xf1d8 */
    OTHER,        /* 0xf1d9 */
    OTHER,        /* 0xf1da */
    OTHER,        /* 0xf1db */
    OTHER,        /* 0xf1dc */
    OTHER,        /* 0xf1dd */
    OTHER,        /* 0xf1de */
    OTHER,        /* 0xf1df */
    OTHER,        /* 0xf1e0 */
    OTHER,        /* 0xf1e1 */
    OTHER,        /* 0xf1e2 */
    OTHER,        /* 0xf1e3 */
    OTHER,        /* 0xf1e4 */
    OTHER,        /* 0xf1e5 */
    OTHER,        /* 0xf1e6 */
    OTHER,        /* 0xf1e7 */
    OTHER,        /* 0xf1e8 */
    OTHER,        /* 0xf1e9 */
    OTHER,        /* 0xf1ea */
    OTHER,        /* 0xf1eb */
    OTHER,        /* 0xf1ec */
    OTHER,        /* 0xf1ed */
    OTHER,        /* 0xf1ee */
    OTHER,        /* 0xf1ef */
    OTHER,        /* 0xf1f0 */
    OTHER,        /* 0xf1f1 */
    OTHER,        /* 0xf1f2 */
    OTHER,        /* 0xf1f3 */
    OTHER,        /* 0xf1f4 */
    OTHER,        /* 0xf1f5 */
    OTHER,        /* 0xf1f6 */
    OTHER,        /* 0xf1f7 */
    OTHER,        /* 0xf1f8 */
    OTHER,        /* 0xf1f9 */
    OTHER,        /* 0xf1fa */
    OTHER,        /* 0xf1fb */
    OTHER,        /* 0xf1fc */
    OTHER,        /* 0xf1fd */
    OTHER,        /* 0xf1fe */
    OTHER,        /* 0xf1ff */
    OTHER,        /* 0xf200 */
    OTHER,        /* 0xf201 */
    OTHER,        /* 0xf202 */
    OTHER,        /* 0xf203 */
    OTHER,        /* 0xf204 */
    OTHER,        /* 0xf205 */
    OTHER,        /* 0xf206 */
    OTHER,        /* 0xf207 */
    OTHER,        /* 0xf208 */
    OTHER,        /* 0xf209 */
    OTHER,        /* 0xf20a */
    OTHER,        /* 0xf20b */
    OTHER,        /* 0xf20c */
    OTHER,        /* 0xf20d */
    OTHER,        /* 0xf20e */
    OTHER,        /* 0xf20f */
    OTHER,        /* 0xf210 */
    OTHER,        /* 0xf211 */
    OTHER,        /* 0xf212 */
    OTHER,        /* 0xf213 */
    OTHER,        /* 0xf214 */
    OTHER,        /* 0xf215 */
    OTHER,        /* 0xf216 */
    OTHER,        /* 0xf217 */
    OTHER,        /* 0xf218 */
    OTHER,        /* 0xf219 */
    OTHER,        /* 0xf21a */
    OTHER,        /* 0xf21b */
    OTHER,        /* 0xf21c */
    OTHER,        /* 0xf21d */
    OTHER,        /* 0xf21e */
    OTHER,        /* 0xf21f */
    OTHER,        /* 0xf220 */
    OTHER,        /* 0xf221 */
    OTHER,        /* 0xf222 */
    OTHER,        /* 0xf223 */
    OTHER,        /* 0xf224 */
    OTHER,        /* 0xf225 */
    OTHER,        /* 0xf226 */
    OTHER,        /* 0xf227 */
    OTHER,        /* 0xf228 */
    OTHER,        /* 0xf229 */
    OTHER,        /* 0xf22a */
    OTHER,        /* 0xf22b */
    OTHER,        /* 0xf22c */
    OTHER,        /* 0xf22d */
    OTHER,        /* 0xf22e */
    OTHER,        /* 0xf22f */
    OTHER,        /* 0xf230 */
    OTHER,        /* 0xf231 */
    OTHER,        /* 0xf232 */
    OTHER,        /* 0xf233 */
    OTHER,        /* 0xf234 */
    OTHER,        /* 0xf235 */
    OTHER,        /* 0xf236 */
    OTHER,        /* 0xf237 */
    OTHER,        /* 0xf238 */
    OTHER,        /* 0xf239 */
    OTHER,        /* 0xf23a */
    OTHER,        /* 0xf23b */
    OTHER,        /* 0xf23c */
    OTHER,        /* 0xf23d */
    OTHER,        /* 0xf23e */
    OTHER,        /* 0xf23f */
    OTHER,        /* 0xf240 */
    OTHER,        /* 0xf241 */
    OTHER,        /* 0xf242 */
    OTHER,        /* 0xf243 */
    OTHER,        /* 0xf244 */
    OTHER,        /* 0xf245 */
    OTHER,        /* 0xf246 */
    OTHER,        /* 0xf247 */
    OTHER,        /* 0xf248 */
    OTHER,        /* 0xf249 */
    OTHER,        /* 0xf24a */
    OTHER,        /* 0xf24b */
    OTHER,        /* 0xf24c */
    OTHER,        /* 0xf24d */
    OTHER,        /* 0xf24e */
    OTHER,        /* 0xf24f */
    OTHER,        /* 0xf250 */
    OTHER,        /* 0xf251 */
    OTHER,        /* 0xf252 */
    OTHER,        /* 0xf253 */
    OTHER,        /* 0xf254 */
    OTHER,        /* 0xf255 */
    OTHER,        /* 0xf256 */
    OTHER,        /* 0xf257 */
    OTHER,        /* 0xf258 */
    OTHER,        /* 0xf259 */
    OTHER,        /* 0xf25a */
    OTHER,        /* 0xf25b */
    OTHER,        /* 0xf25c */
    OTHER,        /* 0xf25d */
    OTHER,        /* 0xf25e */
    OTHER,        /* 0xf25f */
    OTHER,        /* 0xf260 */
    OTHER,        /* 0xf261 */
    OTHER,        /* 0xf262 */
    OTHER,        /* 0xf263 */
    OTHER,        /* 0xf264 */
    OTHER,        /* 0xf265 */
    OTHER,        /* 0xf266 */
    OTHER,        /* 0xf267 */
    OTHER,        /* 0xf268 */
    OTHER,        /* 0xf269 */
    OTHER,        /* 0xf26a */
    OTHER,        /* 0xf26b */
    OTHER,        /* 0xf26c */
    OTHER,        /* 0xf26d */
    OTHER,        /* 0xf26e */
    OTHER,        /* 0xf26f */
    OTHER,        /* 0xf270 */
    OTHER,        /* 0xf271 */
    OTHER,        /* 0xf272 */
    OTHER,        /* 0xf273 */
    OTHER,        /* 0xf274 */
    OTHER,        /* 0xf275 */
    OTHER,        /* 0xf276 */
    OTHER,        /* 0xf277 */
    OTHER,        /* 0xf278 */
    OTHER,        /* 0xf279 */
    OTHER,        /* 0xf27a */
    OTHER,        /* 0xf27b */
    OTHER,        /* 0xf27c */
    OTHER,        /* 0xf27d */
    OTHER,        /* 0xf27e */
    OTHER,        /* 0xf27f */
    OTHER,        /* 0xf280 */
    OTHER,        /* 0xf281 */
    OTHER,        /* 0xf282 */
    OTHER,        /* 0xf283 */
    OTHER,        /* 0xf284 */
    OTHER,        /* 0xf285 */
    OTHER,        /* 0xf286 */
    OTHER,        /* 0xf287 */
    OTHER,        /* 0xf288 */
    OTHER,        /* 0xf289 */
    OTHER,        /* 0xf28a */
    OTHER,        /* 0xf28b */
    OTHER,        /* 0xf28c */
    OTHER,        /* 0xf28d */
    OTHER,        /* 0xf28e */
    OTHER,        /* 0xf28f */
    OTHER,        /* 0xf290 */
    OTHER,        /* 0xf291 */
    OTHER,        /* 0xf292 */
    OTHER,        /* 0xf293 */
    OTHER,        /* 0xf294 */
    OTHER,        /* 0xf295 */
    OTHER,        /* 0xf296 */
    OTHER,        /* 0xf297 */
    OTHER,        /* 0xf298 */
    OTHER,        /* 0xf299 */
    OTHER,        /* 0xf29a */
    OTHER,        /* 0xf29b */
    OTHER,        /* 0xf29c */
    OTHER,        /* 0xf29d */
    OTHER,        /* 0xf29e */
    OTHER,        /* 0xf29f */
    OTHER,        /* 0xf2a0 */
    OTHER,        /* 0xf2a1 */
    OTHER,        /* 0xf2a2 */
    OTHER,        /* 0xf2a3 */
    OTHER,        /* 0xf2a4 */
    OTHER,        /* 0xf2a5 */
    OTHER,        /* 0xf2a6 */
    OTHER,        /* 0xf2a7 */
    OTHER,        /* 0xf2a8 */
    OTHER,        /* 0xf2a9 */
    OTHER,        /* 0xf2aa */
    OTHER,        /* 0xf2ab */
    OTHER,        /* 0xf2ac */
    OTHER,        /* 0xf2ad */
    OTHER,        /* 0xf2ae */
    OTHER,        /* 0xf2af */
    OTHER,        /* 0xf2b0 */
    OTHER,        /* 0xf2b1 */
    OTHER,        /* 0xf2b2 */
    OTHER,        /* 0xf2b3 */
    OTHER,        /* 0xf2b4 */
    OTHER,        /* 0xf2b5 */
    OTHER,        /* 0xf2b6 */
    OTHER,        /* 0xf2b7 */
    OTHER,        /* 0xf2b8 */
    OTHER,        /* 0xf2b9 */
    OTHER,        /* 0xf2ba */
    OTHER,        /* 0xf2bb */
    OTHER,        /* 0xf2bc */
    OTHER,        /* 0xf2bd */
    OTHER,        /* 0xf2be */
    OTHER,        /* 0xf2bf */
    OTHER,        /* 0xf2c0 */
    OTHER,        /* 0xf2c1 */
    OTHER,        /* 0xf2c2 */
    OTHER,        /* 0xf2c3 */
    OTHER,        /* 0xf2c4 */
    OTHER,        /* 0xf2c5 */
    OTHER,        /* 0xf2c6 */
    OTHER,        /* 0xf2c7 */
    OTHER,        /* 0xf2c8 */
    OTHER,        /* 0xf2c9 */
    OTHER,        /* 0xf2ca */
    OTHER,        /* 0xf2cb */
    OTHER,        /* 0xf2cc */
    OTHER,        /* 0xf2cd */
    OTHER,        /* 0xf2ce */
    OTHER,        /* 0xf2cf */
    OTHER,        /* 0xf2d0 */
    OTHER,        /* 0xf2d1 */
    OTHER,        /* 0xf2d2 */
    OTHER,        /* 0xf2d3 */
    OTHER,        /* 0xf2d4 */
    OTHER,        /* 0xf2d5 */
    OTHER,        /* 0xf2d6 */
    OTHER,        /* 0xf2d7 */
    OTHER,        /* 0xf2d8 */
    OTHER,        /* 0xf2d9 */
    OTHER,        /* 0xf2da */
    OTHER,        /* 0xf2db */
    OTHER,        /* 0xf2dc */
    OTHER,        /* 0xf2dd */
    OTHER,        /* 0xf2de */
    OTHER,        /* 0xf2df */
    OTHER,        /* 0xf2e0 */
    OTHER,        /* 0xf2e1 */
    OTHER,        /* 0xf2e2 */
    OTHER,        /* 0xf2e3 */
    OTHER,        /* 0xf2e4 */
    OTHER,        /* 0xf2e5 */
    OTHER,        /* 0xf2e6 */
    OTHER,        /* 0xf2e7 */
    OTHER,        /* 0xf2e8 */
    OTHER,        /* 0xf2e9 */
    OTHER,        /* 0xf2ea */
    OTHER,        /* 0xf2eb */
    OTHER,        /* 0xf2ec */
    OTHER,        /* 0xf2ed */
    OTHER,        /* 0xf2ee */
    OTHER,        /* 0xf2ef */
    OTHER,        /* 0xf2f0 */
    OTHER,        /* 0xf2f1 */
    OTHER,        /* 0xf2f2 */
    OTHER,        /* 0xf2f3 */
    OTHER,        /* 0xf2f4 */
    OTHER,        /* 0xf2f5 */
    OTHER,        /* 0xf2f6 */
    OTHER,        /* 0xf2f7 */
    OTHER,        /* 0xf2f8 */
    OTHER,        /* 0xf2f9 */
    OTHER,        /* 0xf2fa */
    OTHER,        /* 0xf2fb */
    OTHER,        /* 0xf2fc */
    OTHER,        /* 0xf2fd */
    OTHER,        /* 0xf2fe */
    OTHER,        /* 0xf2ff */
    OTHER,        /* 0xf300 */
    OTHER,        /* 0xf301 */
    OTHER,        /* 0xf302 */
    OTHER,        /* 0xf303 */
    OTHER,        /* 0xf304 */
    OTHER,        /* 0xf305 */
    OTHER,        /* 0xf306 */
    OTHER,        /* 0xf307 */
    OTHER,        /* 0xf308 */
    OTHER,        /* 0xf309 */
    OTHER,        /* 0xf30a */
    OTHER,        /* 0xf30b */
    OTHER,        /* 0xf30c */
    OTHER,        /* 0xf30d */
    OTHER,        /* 0xf30e */
    OTHER,        /* 0xf30f */
    OTHER,        /* 0xf310 */
    OTHER,        /* 0xf311 */
    OTHER,        /* 0xf312 */
    OTHER,        /* 0xf313 */
    OTHER,        /* 0xf314 */
    OTHER,        /* 0xf315 */
    OTHER,        /* 0xf316 */
    OTHER,        /* 0xf317 */
    OTHER,        /* 0xf318 */
    OTHER,        /* 0xf319 */
    OTHER,        /* 0xf31a */
    OTHER,        /* 0xf31b */
    OTHER,        /* 0xf31c */
    OTHER,        /* 0xf31d */
    OTHER,        /* 0xf31e */
    OTHER,        /* 0xf31f */
    OTHER,        /* 0xf320 */
    OTHER,        /* 0xf321 */
    OTHER,        /* 0xf322 */
    OTHER,        /* 0xf323 */
    OTHER,        /* 0xf324 */
    OTHER,        /* 0xf325 */
    OTHER,        /* 0xf326 */
    OTHER,        /* 0xf327 */
    OTHER,        /* 0xf328 */
    OTHER,        /* 0xf329 */
    OTHER,        /* 0xf32a */
    OTHER,        /* 0xf32b */
    OTHER,        /* 0xf32c */
    OTHER,        /* 0xf32d */
    OTHER,        /* 0xf32e */
    OTHER,        /* 0xf32f */
    OTHER,        /* 0xf330 */
    OTHER,        /* 0xf331 */
    OTHER,        /* 0xf332 */
    OTHER,        /* 0xf333 */
    OTHER,        /* 0xf334 */
    OTHER,        /* 0xf335 */
    OTHER,        /* 0xf336 */
    OTHER,        /* 0xf337 */
    OTHER,        /* 0xf338 */
    OTHER,        /* 0xf339 */
    OTHER,        /* 0xf33a */
    OTHER,        /* 0xf33b */
    OTHER,        /* 0xf33c */
    OTHER,        /* 0xf33d */
    OTHER,        /* 0xf33e */
    OTHER,        /* 0xf33f */
    OTHER,        /* 0xf340 */
    OTHER,        /* 0xf341 */
    OTHER,        /* 0xf342 */
    OTHER,        /* 0xf343 */
    OTHER,        /* 0xf344 */
    OTHER,        /* 0xf345 */
    OTHER,        /* 0xf346 */
    OTHER,        /* 0xf347 */
    OTHER,        /* 0xf348 */
    OTHER,        /* 0xf349 */
    OTHER,        /* 0xf34a */
    OTHER,        /* 0xf34b */
    OTHER,        /* 0xf34c */
    OTHER,        /* 0xf34d */
    OTHER,        /* 0xf34e */
    OTHER,        /* 0xf34f */
    OTHER,        /* 0xf350 */
    OTHER,        /* 0xf351 */
    OTHER,        /* 0xf352 */
    OTHER,        /* 0xf353 */
    OTHER,        /* 0xf354 */
    OTHER,        /* 0xf355 */
    OTHER,        /* 0xf356 */
    OTHER,        /* 0xf357 */
    OTHER,        /* 0xf358 */
    OTHER,        /* 0xf359 */
    OTHER,        /* 0xf35a */
    OTHER,        /* 0xf35b */
    OTHER,        /* 0xf35c */
    OTHER,        /* 0xf35d */
    OTHER,        /* 0xf35e */
    OTHER,        /* 0xf35f */
    OTHER,        /* 0xf360 */
    OTHER,        /* 0xf361 */
    OTHER,        /* 0xf362 */
    OTHER,        /* 0xf363 */
    OTHER,        /* 0xf364 */
    OTHER,        /* 0xf365 */
    OTHER,        /* 0xf366 */
    OTHER,        /* 0xf367 */
    OTHER,        /* 0xf368 */
    OTHER,        /* 0xf369 */
    OTHER,        /* 0xf36a */
    OTHER,        /* 0xf36b */
    OTHER,        /* 0xf36c */
    OTHER,        /* 0xf36d */
    OTHER,        /* 0xf36e */
    OTHER,        /* 0xf36f */
    OTHER,        /* 0xf370 */
    OTHER,        /* 0xf371 */
    OTHER,        /* 0xf372 */
    OTHER,        /* 0xf373 */
    OTHER,        /* 0xf374 */
    OTHER,        /* 0xf375 */
    OTHER,        /* 0xf376 */
    OTHER,        /* 0xf377 */
    OTHER,        /* 0xf378 */
    OTHER,        /* 0xf379 */
    OTHER,        /* 0xf37a */
    OTHER,        /* 0xf37b */
    OTHER,        /* 0xf37c */
    OTHER,        /* 0xf37d */
    OTHER,        /* 0xf37e */
    OTHER,        /* 0xf37f */
    OTHER,        /* 0xf380 */
    OTHER,        /* 0xf381 */
    OTHER,        /* 0xf382 */
    OTHER,        /* 0xf383 */
    OTHER,        /* 0xf384 */
    OTHER,        /* 0xf385 */
    OTHER,        /* 0xf386 */
    OTHER,        /* 0xf387 */
    OTHER,        /* 0xf388 */
    OTHER,        /* 0xf389 */
    OTHER,        /* 0xf38a */
    OTHER,        /* 0xf38b */
    OTHER,        /* 0xf38c */
    OTHER,        /* 0xf38d */
    OTHER,        /* 0xf38e */
    OTHER,        /* 0xf38f */
    OTHER,        /* 0xf390 */
    OTHER,        /* 0xf391 */
    OTHER,        /* 0xf392 */
    OTHER,        /* 0xf393 */
    OTHER,        /* 0xf394 */
    OTHER,        /* 0xf395 */
    OTHER,        /* 0xf396 */
    OTHER,        /* 0xf397 */
    OTHER,        /* 0xf398 */
    OTHER,        /* 0xf399 */
    OTHER,        /* 0xf39a */
    OTHER,        /* 0xf39b */
    OTHER,        /* 0xf39c */
    OTHER,        /* 0xf39d */
    OTHER,        /* 0xf39e */
    OTHER,        /* 0xf39f */
    OTHER,        /* 0xf3a0 */
    OTHER,        /* 0xf3a1 */
    OTHER,        /* 0xf3a2 */
    OTHER,        /* 0xf3a3 */
    OTHER,        /* 0xf3a4 */
    OTHER,        /* 0xf3a5 */
    OTHER,        /* 0xf3a6 */
    OTHER,        /* 0xf3a7 */
    OTHER,        /* 0xf3a8 */
    OTHER,        /* 0xf3a9 */
    OTHER,        /* 0xf3aa */
    OTHER,        /* 0xf3ab */
    OTHER,        /* 0xf3ac */
    OTHER,        /* 0xf3ad */
    OTHER,        /* 0xf3ae */
    OTHER,        /* 0xf3af */
    OTHER,        /* 0xf3b0 */
    OTHER,        /* 0xf3b1 */
    OTHER,        /* 0xf3b2 */
    OTHER,        /* 0xf3b3 */
    OTHER,        /* 0xf3b4 */
    OTHER,        /* 0xf3b5 */
    OTHER,        /* 0xf3b6 */
    OTHER,        /* 0xf3b7 */
    OTHER,        /* 0xf3b8 */
    OTHER,        /* 0xf3b9 */
    OTHER,        /* 0xf3ba */
    OTHER,        /* 0xf3bb */
    OTHER,        /* 0xf3bc */
    OTHER,        /* 0xf3bd */
    OTHER,        /* 0xf3be */
    OTHER,        /* 0xf3bf */
    OTHER,        /* 0xf3c0 */
    OTHER,        /* 0xf3c1 */
    OTHER,        /* 0xf3c2 */
    OTHER,        /* 0xf3c3 */
    OTHER,        /* 0xf3c4 */
    OTHER,        /* 0xf3c5 */
    OTHER,        /* 0xf3c6 */
    OTHER,        /* 0xf3c7 */
    OTHER,        /* 0xf3c8 */
    OTHER,        /* 0xf3c9 */
    OTHER,        /* 0xf3ca */
    OTHER,        /* 0xf3cb */
    OTHER,        /* 0xf3cc */
    OTHER,        /* 0xf3cd */
    OTHER,        /* 0xf3ce */
    OTHER,        /* 0xf3cf */
    OTHER,        /* 0xf3d0 */
    OTHER,        /* 0xf3d1 */
    OTHER,        /* 0xf3d2 */
    OTHER,        /* 0xf3d3 */
    OTHER,        /* 0xf3d4 */
    OTHER,        /* 0xf3d5 */
    OTHER,        /* 0xf3d6 */
    OTHER,        /* 0xf3d7 */
    OTHER,        /* 0xf3d8 */
    OTHER,        /* 0xf3d9 */
    OTHER,        /* 0xf3da */
    OTHER,        /* 0xf3db */
    OTHER,        /* 0xf3dc */
    OTHER,        /* 0xf3dd */
    OTHER,        /* 0xf3de */
    OTHER,        /* 0xf3df */
    OTHER,        /* 0xf3e0 */
    OTHER,        /* 0xf3e1 */
    OTHER,        /* 0xf3e2 */
    OTHER,        /* 0xf3e3 */
    OTHER,        /* 0xf3e4 */
    OTHER,        /* 0xf3e5 */
    OTHER,        /* 0xf3e6 */
    OTHER,        /* 0xf3e7 */
    OTHER,        /* 0xf3e8 */
    OTHER,        /* 0xf3e9 */
    OTHER,        /* 0xf3ea */
    OTHER,        /* 0xf3eb */
    OTHER,        /* 0xf3ec */
    OTHER,        /* 0xf3ed */
    OTHER,        /* 0xf3ee */
    OTHER,        /* 0xf3ef */
    OTHER,        /* 0xf3f0 */
    OTHER,        /* 0xf3f1 */
    OTHER,        /* 0xf3f2 */
    OTHER,        /* 0xf3f3 */
    OTHER,        /* 0xf3f4 */
    OTHER,        /* 0xf3f5 */
    OTHER,        /* 0xf3f6 */
    OTHER,        /* 0xf3f7 */
    OTHER,        /* 0xf3f8 */
    OTHER,        /* 0xf3f9 */
    OTHER,        /* 0xf3fa */
    OTHER,        /* 0xf3fb */
    OTHER,        /* 0xf3fc */
    OTHER,        /* 0xf3fd */
    OTHER,        /* 0xf3fe */
    OTHER,        /* 0xf3ff */
    OTHER,        /* 0xf400 */
    OTHER,        /* 0xf401 */
    OTHER,        /* 0xf402 */
    OTHER,        /* 0xf403 */
    OTHER,        /* 0xf404 */
    OTHER,        /* 0xf405 */
    OTHER,        /* 0xf406 */
    OTHER,        /* 0xf407 */
    OTHER,        /* 0xf408 */
    OTHER,        /* 0xf409 */
    OTHER,        /* 0xf40a */
    OTHER,        /* 0xf40b */
    OTHER,        /* 0xf40c */
    OTHER,        /* 0xf40d */
    OTHER,        /* 0xf40e */
    OTHER,        /* 0xf40f */
    OTHER,        /* 0xf410 */
    OTHER,        /* 0xf411 */
    OTHER,        /* 0xf412 */
    OTHER,        /* 0xf413 */
    OTHER,        /* 0xf414 */
    OTHER,        /* 0xf415 */
    OTHER,        /* 0xf416 */
    OTHER,        /* 0xf417 */
    OTHER,        /* 0xf418 */
    OTHER,        /* 0xf419 */
    OTHER,        /* 0xf41a */
    OTHER,        /* 0xf41b */
    OTHER,        /* 0xf41c */
    OTHER,        /* 0xf41d */
    OTHER,        /* 0xf41e */
    OTHER,        /* 0xf41f */
    OTHER,        /* 0xf420 */
    OTHER,        /* 0xf421 */
    OTHER,        /* 0xf422 */
    OTHER,        /* 0xf423 */
    OTHER,        /* 0xf424 */
    OTHER,        /* 0xf425 */
    OTHER,        /* 0xf426 */
    OTHER,        /* 0xf427 */
    OTHER,        /* 0xf428 */
    OTHER,        /* 0xf429 */
    OTHER,        /* 0xf42a */
    OTHER,        /* 0xf42b */
    OTHER,        /* 0xf42c */
    OTHER,        /* 0xf42d */
    OTHER,        /* 0xf42e */
    OTHER,        /* 0xf42f */
    OTHER,        /* 0xf430 */
    OTHER,        /* 0xf431 */
    OTHER,        /* 0xf432 */
    OTHER,        /* 0xf433 */
    OTHER,        /* 0xf434 */
    OTHER,        /* 0xf435 */
    OTHER,        /* 0xf436 */
    OTHER,        /* 0xf437 */
    OTHER,        /* 0xf438 */
    OTHER,        /* 0xf439 */
    OTHER,        /* 0xf43a */
    OTHER,        /* 0xf43b */
    OTHER,        /* 0xf43c */
    OTHER,        /* 0xf43d */
    OTHER,        /* 0xf43e */
    OTHER,        /* 0xf43f */
    OTHER,        /* 0xf440 */
    OTHER,        /* 0xf441 */
    OTHER,        /* 0xf442 */
    OTHER,        /* 0xf443 */
    OTHER,        /* 0xf444 */
    OTHER,        /* 0xf445 */
    OTHER,        /* 0xf446 */
    OTHER,        /* 0xf447 */
    OTHER,        /* 0xf448 */
    OTHER,        /* 0xf449 */
    OTHER,        /* 0xf44a */
    OTHER,        /* 0xf44b */
    OTHER,        /* 0xf44c */
    OTHER,        /* 0xf44d */
    OTHER,        /* 0xf44e */
    OTHER,        /* 0xf44f */
    OTHER,        /* 0xf450 */
    OTHER,        /* 0xf451 */
    OTHER,        /* 0xf452 */
    OTHER,        /* 0xf453 */
    OTHER,        /* 0xf454 */
    OTHER,        /* 0xf455 */
    OTHER,        /* 0xf456 */
    OTHER,        /* 0xf457 */
    OTHER,        /* 0xf458 */
    OTHER,        /* 0xf459 */
    OTHER,        /* 0xf45a */
    OTHER,        /* 0xf45b */
    OTHER,        /* 0xf45c */
    OTHER,        /* 0xf45d */
    OTHER,        /* 0xf45e */
    OTHER,        /* 0xf45f */
    OTHER,        /* 0xf460 */
    OTHER,        /* 0xf461 */
    OTHER,        /* 0xf462 */
    OTHER,        /* 0xf463 */
    OTHER,        /* 0xf464 */
    OTHER,        /* 0xf465 */
    OTHER,        /* 0xf466 */
    OTHER,        /* 0xf467 */
    OTHER,        /* 0xf468 */
    OTHER,        /* 0xf469 */
    OTHER,        /* 0xf46a */
    OTHER,        /* 0xf46b */
    OTHER,        /* 0xf46c */
    OTHER,        /* 0xf46d */
    OTHER,        /* 0xf46e */
    OTHER,        /* 0xf46f */
    OTHER,        /* 0xf470 */
    OTHER,        /* 0xf471 */
    OTHER,        /* 0xf472 */
    OTHER,        /* 0xf473 */
    OTHER,        /* 0xf474 */
    OTHER,        /* 0xf475 */
    OTHER,        /* 0xf476 */
    OTHER,        /* 0xf477 */
    OTHER,        /* 0xf478 */
    OTHER,        /* 0xf479 */
    OTHER,        /* 0xf47a */
    OTHER,        /* 0xf47b */
    OTHER,        /* 0xf47c */
    OTHER,        /* 0xf47d */
    OTHER,        /* 0xf47e */
    OTHER,        /* 0xf47f */
    OTHER,        /* 0xf480 */
    OTHER,        /* 0xf481 */
    OTHER,        /* 0xf482 */
    OTHER,        /* 0xf483 */
    OTHER,        /* 0xf484 */
    OTHER,        /* 0xf485 */
    OTHER,        /* 0xf486 */
    OTHER,        /* 0xf487 */
    OTHER,        /* 0xf488 */
    OTHER,        /* 0xf489 */
    OTHER,        /* 0xf48a */
    OTHER,        /* 0xf48b */
    OTHER,        /* 0xf48c */
    OTHER,        /* 0xf48d */
    OTHER,        /* 0xf48e */
    OTHER,        /* 0xf48f */
    OTHER,        /* 0xf490 */
    OTHER,        /* 0xf491 */
    OTHER,        /* 0xf492 */
    OTHER,        /* 0xf493 */
    OTHER,        /* 0xf494 */
    OTHER,        /* 0xf495 */
    OTHER,        /* 0xf496 */
    OTHER,        /* 0xf497 */
    OTHER,        /* 0xf498 */
    OTHER,        /* 0xf499 */
    OTHER,        /* 0xf49a */
    OTHER,        /* 0xf49b */
    OTHER,        /* 0xf49c */
    OTHER,        /* 0xf49d */
    OTHER,        /* 0xf49e */
    OTHER,        /* 0xf49f */
    OTHER,        /* 0xf4a0 */
    OTHER,        /* 0xf4a1 */
    OTHER,        /* 0xf4a2 */
    OTHER,        /* 0xf4a3 */
    OTHER,        /* 0xf4a4 */
    OTHER,        /* 0xf4a5 */
    OTHER,        /* 0xf4a6 */
    OTHER,        /* 0xf4a7 */
    OTHER,        /* 0xf4a8 */
    OTHER,        /* 0xf4a9 */
    OTHER,        /* 0xf4aa */
    OTHER,        /* 0xf4ab */
    OTHER,        /* 0xf4ac */
    OTHER,        /* 0xf4ad */
    OTHER,        /* 0xf4ae */
    OTHER,        /* 0xf4af */
    OTHER,        /* 0xf4b0 */
    OTHER,        /* 0xf4b1 */
    OTHER,        /* 0xf4b2 */
    OTHER,        /* 0xf4b3 */
    OTHER,        /* 0xf4b4 */
    OTHER,        /* 0xf4b5 */
    OTHER,        /* 0xf4b6 */
    OTHER,        /* 0xf4b7 */
    OTHER,        /* 0xf4b8 */
    OTHER,        /* 0xf4b9 */
    OTHER,        /* 0xf4ba */
    OTHER,        /* 0xf4bb */
    OTHER,        /* 0xf4bc */
    OTHER,        /* 0xf4bd */
    OTHER,        /* 0xf4be */
    OTHER,        /* 0xf4bf */
    OTHER,        /* 0xf4c0 */
    OTHER,        /* 0xf4c1 */
    OTHER,        /* 0xf4c2 */
    OTHER,        /* 0xf4c3 */
    OTHER,        /* 0xf4c4 */
    OTHER,        /* 0xf4c5 */
    OTHER,        /* 0xf4c6 */
    OTHER,        /* 0xf4c7 */
    OTHER,        /* 0xf4c8 */
    OTHER,        /* 0xf4c9 */
    OTHER,        /* 0xf4ca */
    OTHER,        /* 0xf4cb */
    OTHER,        /* 0xf4cc */
    OTHER,        /* 0xf4cd */
    OTHER,        /* 0xf4ce */
    OTHER,        /* 0xf4cf */
    OTHER,        /* 0xf4d0 */
    OTHER,        /* 0xf4d1 */
    OTHER,        /* 0xf4d2 */
    OTHER,        /* 0xf4d3 */
    OTHER,        /* 0xf4d4 */
    OTHER,        /* 0xf4d5 */
    OTHER,        /* 0xf4d6 */
    OTHER,        /* 0xf4d7 */
    OTHER,        /* 0xf4d8 */
    OTHER,        /* 0xf4d9 */
    OTHER,        /* 0xf4da */
    OTHER,        /* 0xf4db */
    OTHER,        /* 0xf4dc */
    OTHER,        /* 0xf4dd */
    OTHER,        /* 0xf4de */
    OTHER,        /* 0xf4df */
    OTHER,        /* 0xf4e0 */
    OTHER,        /* 0xf4e1 */
    OTHER,        /* 0xf4e2 */
    OTHER,        /* 0xf4e3 */
    OTHER,        /* 0xf4e4 */
    OTHER,        /* 0xf4e5 */
    OTHER,        /* 0xf4e6 */
    OTHER,        /* 0xf4e7 */
    OTHER,        /* 0xf4e8 */
    OTHER,        /* 0xf4e9 */
    OTHER,        /* 0xf4ea */
    OTHER,        /* 0xf4eb */
    OTHER,        /* 0xf4ec */
    OTHER,        /* 0xf4ed */
    OTHER,        /* 0xf4ee */
    OTHER,        /* 0xf4ef */
    OTHER,        /* 0xf4f0 */
    OTHER,        /* 0xf4f1 */
    OTHER,        /* 0xf4f2 */
    OTHER,        /* 0xf4f3 */
    OTHER,        /* 0xf4f4 */
    OTHER,        /* 0xf4f5 */
    OTHER,        /* 0xf4f6 */
    OTHER,        /* 0xf4f7 */
    OTHER,        /* 0xf4f8 */
    OTHER,        /* 0xf4f9 */
    OTHER,        /* 0xf4fa */
    OTHER,        /* 0xf4fb */
    OTHER,        /* 0xf4fc */
    OTHER,        /* 0xf4fd */
    OTHER,        /* 0xf4fe */
    OTHER,        /* 0xf4ff */
    OTHER,        /* 0xf500 */
    OTHER,        /* 0xf501 */
    OTHER,        /* 0xf502 */
    OTHER,        /* 0xf503 */
    OTHER,        /* 0xf504 */
    OTHER,        /* 0xf505 */
    OTHER,        /* 0xf506 */
    OTHER,        /* 0xf507 */
    OTHER,        /* 0xf508 */
    OTHER,        /* 0xf509 */
    OTHER,        /* 0xf50a */
    OTHER,        /* 0xf50b */
    OTHER,        /* 0xf50c */
    OTHER,        /* 0xf50d */
    OTHER,        /* 0xf50e */
    OTHER,        /* 0xf50f */
    OTHER,        /* 0xf510 */
    OTHER,        /* 0xf511 */
    OTHER,        /* 0xf512 */
    OTHER,        /* 0xf513 */
    OTHER,        /* 0xf514 */
    OTHER,        /* 0xf515 */
    OTHER,        /* 0xf516 */
    OTHER,        /* 0xf517 */
    OTHER,        /* 0xf518 */
    OTHER,        /* 0xf519 */
    OTHER,        /* 0xf51a */
    OTHER,        /* 0xf51b */
    OTHER,        /* 0xf51c */
    OTHER,        /* 0xf51d */
    OTHER,        /* 0xf51e */
    OTHER,        /* 0xf51f */
    OTHER,        /* 0xf520 */
    OTHER,        /* 0xf521 */
    OTHER,        /* 0xf522 */
    OTHER,        /* 0xf523 */
    OTHER,        /* 0xf524 */
    OTHER,        /* 0xf525 */
    OTHER,        /* 0xf526 */
    OTHER,        /* 0xf527 */
    OTHER,        /* 0xf528 */
    OTHER,        /* 0xf529 */
    OTHER,        /* 0xf52a */
    OTHER,        /* 0xf52b */
    OTHER,        /* 0xf52c */
    OTHER,        /* 0xf52d */
    OTHER,        /* 0xf52e */
    OTHER,        /* 0xf52f */
    OTHER,        /* 0xf530 */
    OTHER,        /* 0xf531 */
    OTHER,        /* 0xf532 */
    OTHER,        /* 0xf533 */
    OTHER,        /* 0xf534 */
    OTHER,        /* 0xf535 */
    OTHER,        /* 0xf536 */
    OTHER,        /* 0xf537 */
    OTHER,        /* 0xf538 */
    OTHER,        /* 0xf539 */
    OTHER,        /* 0xf53a */
    OTHER,        /* 0xf53b */
    OTHER,        /* 0xf53c */
    OTHER,        /* 0xf53d */
    OTHER,        /* 0xf53e */
    OTHER,        /* 0xf53f */
    OTHER,        /* 0xf540 */
    OTHER,        /* 0xf541 */
    OTHER,        /* 0xf542 */
    OTHER,        /* 0xf543 */
    OTHER,        /* 0xf544 */
    OTHER,        /* 0xf545 */
    OTHER,        /* 0xf546 */
    OTHER,        /* 0xf547 */
    OTHER,        /* 0xf548 */
    OTHER,        /* 0xf549 */
    OTHER,        /* 0xf54a */
    OTHER,        /* 0xf54b */
    OTHER,        /* 0xf54c */
    OTHER,        /* 0xf54d */
    OTHER,        /* 0xf54e */
    OTHER,        /* 0xf54f */
    OTHER,        /* 0xf550 */
    OTHER,        /* 0xf551 */
    OTHER,        /* 0xf552 */
    OTHER,        /* 0xf553 */
    OTHER,        /* 0xf554 */
    OTHER,        /* 0xf555 */
    OTHER,        /* 0xf556 */
    OTHER,        /* 0xf557 */
    OTHER,        /* 0xf558 */
    OTHER,        /* 0xf559 */
    OTHER,        /* 0xf55a */
    OTHER,        /* 0xf55b */
    OTHER,        /* 0xf55c */
    OTHER,        /* 0xf55d */
    OTHER,        /* 0xf55e */
    OTHER,        /* 0xf55f */
    OTHER,        /* 0xf560 */
    OTHER,        /* 0xf561 */
    OTHER,        /* 0xf562 */
    OTHER,        /* 0xf563 */
    OTHER,        /* 0xf564 */
    OTHER,        /* 0xf565 */
    OTHER,        /* 0xf566 */
    OTHER,        /* 0xf567 */
    OTHER,        /* 0xf568 */
    OTHER,        /* 0xf569 */
    OTHER,        /* 0xf56a */
    OTHER,        /* 0xf56b */
    OTHER,        /* 0xf56c */
    OTHER,        /* 0xf56d */
    OTHER,        /* 0xf56e */
    OTHER,        /* 0xf56f */
    OTHER,        /* 0xf570 */
    OTHER,        /* 0xf571 */
    OTHER,        /* 0xf572 */
    OTHER,        /* 0xf573 */
    OTHER,        /* 0xf574 */
    OTHER,        /* 0xf575 */
    OTHER,        /* 0xf576 */
    OTHER,        /* 0xf577 */
    OTHER,        /* 0xf578 */
    OTHER,        /* 0xf579 */
    OTHER,        /* 0xf57a */
    OTHER,        /* 0xf57b */
    OTHER,        /* 0xf57c */
    OTHER,        /* 0xf57d */
    OTHER,        /* 0xf57e */
    OTHER,        /* 0xf57f */
    OTHER,        /* 0xf580 */
    OTHER,        /* 0xf581 */
    OTHER,        /* 0xf582 */
    OTHER,        /* 0xf583 */
    OTHER,        /* 0xf584 */
    OTHER,        /* 0xf585 */
    OTHER,        /* 0xf586 */
    OTHER,        /* 0xf587 */
    OTHER,        /* 0xf588 */
    OTHER,        /* 0xf589 */
    OTHER,        /* 0xf58a */
    OTHER,        /* 0xf58b */
    OTHER,        /* 0xf58c */
    OTHER,        /* 0xf58d */
    OTHER,        /* 0xf58e */
    OTHER,        /* 0xf58f */
    OTHER,        /* 0xf590 */
    OTHER,        /* 0xf591 */
    OTHER,        /* 0xf592 */
    OTHER,        /* 0xf593 */
    OTHER,        /* 0xf594 */
    OTHER,        /* 0xf595 */
    OTHER,        /* 0xf596 */
    OTHER,        /* 0xf597 */
    OTHER,        /* 0xf598 */
    OTHER,        /* 0xf599 */
    OTHER,        /* 0xf59a */
    OTHER,        /* 0xf59b */
    OTHER,        /* 0xf59c */
    OTHER,        /* 0xf59d */
    OTHER,        /* 0xf59e */
    OTHER,        /* 0xf59f */
    OTHER,        /* 0xf5a0 */
    OTHER,        /* 0xf5a1 */
    OTHER,        /* 0xf5a2 */
    OTHER,        /* 0xf5a3 */
    OTHER,        /* 0xf5a4 */
    OTHER,        /* 0xf5a5 */
    OTHER,        /* 0xf5a6 */
    OTHER,        /* 0xf5a7 */
    OTHER,        /* 0xf5a8 */
    OTHER,        /* 0xf5a9 */
    OTHER,        /* 0xf5aa */
    OTHER,        /* 0xf5ab */
    OTHER,        /* 0xf5ac */
    OTHER,        /* 0xf5ad */
    OTHER,        /* 0xf5ae */
    OTHER,        /* 0xf5af */
    OTHER,        /* 0xf5b0 */
    OTHER,        /* 0xf5b1 */
    OTHER,        /* 0xf5b2 */
    OTHER,        /* 0xf5b3 */
    OTHER,        /* 0xf5b4 */
    OTHER,        /* 0xf5b5 */
    OTHER,        /* 0xf5b6 */
    OTHER,        /* 0xf5b7 */
    OTHER,        /* 0xf5b8 */
    OTHER,        /* 0xf5b9 */
    OTHER,        /* 0xf5ba */
    OTHER,        /* 0xf5bb */
    OTHER,        /* 0xf5bc */
    OTHER,        /* 0xf5bd */
    OTHER,        /* 0xf5be */
    OTHER,        /* 0xf5bf */
    OTHER,        /* 0xf5c0 */
    OTHER,        /* 0xf5c1 */
    OTHER,        /* 0xf5c2 */
    OTHER,        /* 0xf5c3 */
    OTHER,        /* 0xf5c4 */
    OTHER,        /* 0xf5c5 */
    OTHER,        /* 0xf5c6 */
    OTHER,        /* 0xf5c7 */
    OTHER,        /* 0xf5c8 */
    OTHER,        /* 0xf5c9 */
    OTHER,        /* 0xf5ca */
    OTHER,        /* 0xf5cb */
    OTHER,        /* 0xf5cc */
    OTHER,        /* 0xf5cd */
    OTHER,        /* 0xf5ce */
    OTHER,        /* 0xf5cf */
    OTHER,        /* 0xf5d0 */
    OTHER,        /* 0xf5d1 */
    OTHER,        /* 0xf5d2 */
    OTHER,        /* 0xf5d3 */
    OTHER,        /* 0xf5d4 */
    OTHER,        /* 0xf5d5 */
    OTHER,        /* 0xf5d6 */
    OTHER,        /* 0xf5d7 */
    OTHER,        /* 0xf5d8 */
    OTHER,        /* 0xf5d9 */
    OTHER,        /* 0xf5da */
    OTHER,        /* 0xf5db */
    OTHER,        /* 0xf5dc */
    OTHER,        /* 0xf5dd */
    OTHER,        /* 0xf5de */
    OTHER,        /* 0xf5df */
    OTHER,        /* 0xf5e0 */
    OTHER,        /* 0xf5e1 */
    OTHER,        /* 0xf5e2 */
    OTHER,        /* 0xf5e3 */
    OTHER,        /* 0xf5e4 */
    OTHER,        /* 0xf5e5 */
    OTHER,        /* 0xf5e6 */
    OTHER,        /* 0xf5e7 */
    OTHER,        /* 0xf5e8 */
    OTHER,        /* 0xf5e9 */
    OTHER,        /* 0xf5ea */
    OTHER,        /* 0xf5eb */
    OTHER,        /* 0xf5ec */
    OTHER,        /* 0xf5ed */
    OTHER,        /* 0xf5ee */
    OTHER,        /* 0xf5ef */
    OTHER,        /* 0xf5f0 */
    OTHER,        /* 0xf5f1 */
    OTHER,        /* 0xf5f2 */
    OTHER,        /* 0xf5f3 */
    OTHER,        /* 0xf5f4 */
    OTHER,        /* 0xf5f5 */
    OTHER,        /* 0xf5f6 */
    OTHER,        /* 0xf5f7 */
    OTHER,        /* 0xf5f8 */
    OTHER,        /* 0xf5f9 */
    OTHER,        /* 0xf5fa */
    OTHER,        /* 0xf5fb */
    OTHER,        /* 0xf5fc */
    OTHER,        /* 0xf5fd */
    OTHER,        /* 0xf5fe */
    OTHER,        /* 0xf5ff */
    OTHER,        /* 0xf600 */
    OTHER,        /* 0xf601 */
    OTHER,        /* 0xf602 */
    OTHER,        /* 0xf603 */
    OTHER,        /* 0xf604 */
    OTHER,        /* 0xf605 */
    OTHER,        /* 0xf606 */
    OTHER,        /* 0xf607 */
    OTHER,        /* 0xf608 */
    OTHER,        /* 0xf609 */
    OTHER,        /* 0xf60a */
    OTHER,        /* 0xf60b */
    OTHER,        /* 0xf60c */
    OTHER,        /* 0xf60d */
    OTHER,        /* 0xf60e */
    OTHER,        /* 0xf60f */
    OTHER,        /* 0xf610 */
    OTHER,        /* 0xf611 */
    OTHER,        /* 0xf612 */
    OTHER,        /* 0xf613 */
    OTHER,        /* 0xf614 */
    OTHER,        /* 0xf615 */
    OTHER,        /* 0xf616 */
    OTHER,        /* 0xf617 */
    OTHER,        /* 0xf618 */
    OTHER,        /* 0xf619 */
    OTHER,        /* 0xf61a */
    OTHER,        /* 0xf61b */
    OTHER,        /* 0xf61c */
    OTHER,        /* 0xf61d */
    OTHER,        /* 0xf61e */
    OTHER,        /* 0xf61f */
    OTHER,        /* 0xf620 */
    OTHER,        /* 0xf621 */
    OTHER,        /* 0xf622 */
    OTHER,        /* 0xf623 */
    OTHER,        /* 0xf624 */
    OTHER,        /* 0xf625 */
    OTHER,        /* 0xf626 */
    OTHER,        /* 0xf627 */
    OTHER,        /* 0xf628 */
    OTHER,        /* 0xf629 */
    OTHER,        /* 0xf62a */
    OTHER,        /* 0xf62b */
    OTHER,        /* 0xf62c */
    OTHER,        /* 0xf62d */
    OTHER,        /* 0xf62e */
    OTHER,        /* 0xf62f */
    OTHER,        /* 0xf630 */
    OTHER,        /* 0xf631 */
    OTHER,        /* 0xf632 */
    OTHER,        /* 0xf633 */
    OTHER,        /* 0xf634 */
    OTHER,        /* 0xf635 */
    OTHER,        /* 0xf636 */
    OTHER,        /* 0xf637 */
    OTHER,        /* 0xf638 */
    OTHER,        /* 0xf639 */
    OTHER,        /* 0xf63a */
    OTHER,        /* 0xf63b */
    OTHER,        /* 0xf63c */
    OTHER,        /* 0xf63d */
    OTHER,        /* 0xf63e */
    OTHER,        /* 0xf63f */
    OTHER,        /* 0xf640 */
    OTHER,        /* 0xf641 */
    OTHER,        /* 0xf642 */
    OTHER,        /* 0xf643 */
    OTHER,        /* 0xf644 */
    OTHER,        /* 0xf645 */
    OTHER,        /* 0xf646 */
    OTHER,        /* 0xf647 */
    OTHER,        /* 0xf648 */
    OTHER,        /* 0xf649 */
    OTHER,        /* 0xf64a */
    OTHER,        /* 0xf64b */
    OTHER,        /* 0xf64c */
    OTHER,        /* 0xf64d */
    OTHER,        /* 0xf64e */
    OTHER,        /* 0xf64f */
    OTHER,        /* 0xf650 */
    OTHER,        /* 0xf651 */
    OTHER,        /* 0xf652 */
    OTHER,        /* 0xf653 */
    OTHER,        /* 0xf654 */
    OTHER,        /* 0xf655 */
    OTHER,        /* 0xf656 */
    OTHER,        /* 0xf657 */
    OTHER,        /* 0xf658 */
    OTHER,        /* 0xf659 */
    OTHER,        /* 0xf65a */
    OTHER,        /* 0xf65b */
    OTHER,        /* 0xf65c */
    OTHER,        /* 0xf65d */
    OTHER,        /* 0xf65e */
    OTHER,        /* 0xf65f */
    OTHER,        /* 0xf660 */
    OTHER,        /* 0xf661 */
    OTHER,        /* 0xf662 */
    OTHER,        /* 0xf663 */
    OTHER,        /* 0xf664 */
    OTHER,        /* 0xf665 */
    OTHER,        /* 0xf666 */
    OTHER,        /* 0xf667 */
    OTHER,        /* 0xf668 */
    OTHER,        /* 0xf669 */
    OTHER,        /* 0xf66a */
    OTHER,        /* 0xf66b */
    OTHER,        /* 0xf66c */
    OTHER,        /* 0xf66d */
    OTHER,        /* 0xf66e */
    OTHER,        /* 0xf66f */
    OTHER,        /* 0xf670 */
    OTHER,        /* 0xf671 */
    OTHER,        /* 0xf672 */
    OTHER,        /* 0xf673 */
    OTHER,        /* 0xf674 */
    OTHER,        /* 0xf675 */
    OTHER,        /* 0xf676 */
    OTHER,        /* 0xf677 */
    OTHER,        /* 0xf678 */
    OTHER,        /* 0xf679 */
    OTHER,        /* 0xf67a */
    OTHER,        /* 0xf67b */
    OTHER,        /* 0xf67c */
    OTHER,        /* 0xf67d */
    OTHER,        /* 0xf67e */
    OTHER,        /* 0xf67f */
    OTHER,        /* 0xf680 */
    OTHER,        /* 0xf681 */
    OTHER,        /* 0xf682 */
    OTHER,        /* 0xf683 */
    OTHER,        /* 0xf684 */
    OTHER,        /* 0xf685 */
    OTHER,        /* 0xf686 */
    OTHER,        /* 0xf687 */
    OTHER,        /* 0xf688 */
    OTHER,        /* 0xf689 */
    OTHER,        /* 0xf68a */
    OTHER,        /* 0xf68b */
    OTHER,        /* 0xf68c */
    OTHER,        /* 0xf68d */
    OTHER,        /* 0xf68e */
    OTHER,        /* 0xf68f */
    OTHER,        /* 0xf690 */
    OTHER,        /* 0xf691 */
    OTHER,        /* 0xf692 */
    OTHER,        /* 0xf693 */
    OTHER,        /* 0xf694 */
    OTHER,        /* 0xf695 */
    OTHER,        /* 0xf696 */
    OTHER,        /* 0xf697 */
    OTHER,        /* 0xf698 */
    OTHER,        /* 0xf699 */
    OTHER,        /* 0xf69a */
    OTHER,        /* 0xf69b */
    OTHER,        /* 0xf69c */
    OTHER,        /* 0xf69d */
    OTHER,        /* 0xf69e */
    OTHER,        /* 0xf69f */
    OTHER,        /* 0xf6a0 */
    OTHER,        /* 0xf6a1 */
    OTHER,        /* 0xf6a2 */
    OTHER,        /* 0xf6a3 */
    OTHER,        /* 0xf6a4 */
    OTHER,        /* 0xf6a5 */
    OTHER,        /* 0xf6a6 */
    OTHER,        /* 0xf6a7 */
    OTHER,        /* 0xf6a8 */
    OTHER,        /* 0xf6a9 */
    OTHER,        /* 0xf6aa */
    OTHER,        /* 0xf6ab */
    OTHER,        /* 0xf6ac */
    OTHER,        /* 0xf6ad */
    OTHER,        /* 0xf6ae */
    OTHER,        /* 0xf6af */
    OTHER,        /* 0xf6b0 */
    OTHER,        /* 0xf6b1 */
    OTHER,        /* 0xf6b2 */
    OTHER,        /* 0xf6b3 */
    OTHER,        /* 0xf6b4 */
    OTHER,        /* 0xf6b5 */
    OTHER,        /* 0xf6b6 */
    OTHER,        /* 0xf6b7 */
    OTHER,        /* 0xf6b8 */
    OTHER,        /* 0xf6b9 */
    OTHER,        /* 0xf6ba */
    OTHER,        /* 0xf6bb */
    OTHER,        /* 0xf6bc */
    OTHER,        /* 0xf6bd */
    OTHER,        /* 0xf6be */
    OTHER,        /* 0xf6bf */
    OTHER,        /* 0xf6c0 */
    OTHER,        /* 0xf6c1 */
    OTHER,        /* 0xf6c2 */
    OTHER,        /* 0xf6c3 */
    OTHER,        /* 0xf6c4 */
    OTHER,        /* 0xf6c5 */
    OTHER,        /* 0xf6c6 */
    OTHER,        /* 0xf6c7 */
    OTHER,        /* 0xf6c8 */
    OTHER,        /* 0xf6c9 */
    OTHER,        /* 0xf6ca */
    OTHER,        /* 0xf6cb */
    OTHER,        /* 0xf6cc */
    OTHER,        /* 0xf6cd */
    OTHER,        /* 0xf6ce */
    OTHER,        /* 0xf6cf */
    OTHER,        /* 0xf6d0 */
    OTHER,        /* 0xf6d1 */
    OTHER,        /* 0xf6d2 */
    OTHER,        /* 0xf6d3 */
    OTHER,        /* 0xf6d4 */
    OTHER,        /* 0xf6d5 */
    OTHER,        /* 0xf6d6 */
    OTHER,        /* 0xf6d7 */
    OTHER,        /* 0xf6d8 */
    OTHER,        /* 0xf6d9 */
    OTHER,        /* 0xf6da */
    OTHER,        /* 0xf6db */
    OTHER,        /* 0xf6dc */
    OTHER,        /* 0xf6dd */
    OTHER,        /* 0xf6de */
    OTHER,        /* 0xf6df */
    OTHER,        /* 0xf6e0 */
    OTHER,        /* 0xf6e1 */
    OTHER,        /* 0xf6e2 */
    OTHER,        /* 0xf6e3 */
    OTHER,        /* 0xf6e4 */
    OTHER,        /* 0xf6e5 */
    OTHER,        /* 0xf6e6 */
    OTHER,        /* 0xf6e7 */
    OTHER,        /* 0xf6e8 */
    OTHER,        /* 0xf6e9 */
    OTHER,        /* 0xf6ea */
    OTHER,        /* 0xf6eb */
    OTHER,        /* 0xf6ec */
    OTHER,        /* 0xf6ed */
    OTHER,        /* 0xf6ee */
    OTHER,        /* 0xf6ef */
    OTHER,        /* 0xf6f0 */
    OTHER,        /* 0xf6f1 */
    OTHER,        /* 0xf6f2 */
    OTHER,        /* 0xf6f3 */
    OTHER,        /* 0xf6f4 */
    OTHER,        /* 0xf6f5 */
    OTHER,        /* 0xf6f6 */
    OTHER,        /* 0xf6f7 */
    OTHER,        /* 0xf6f8 */
    OTHER,        /* 0xf6f9 */
    OTHER,        /* 0xf6fa */
    OTHER,        /* 0xf6fb */
    OTHER,        /* 0xf6fc */
    OTHER,        /* 0xf6fd */
    OTHER,        /* 0xf6fe */
    OTHER,        /* 0xf6ff */
    OTHER,        /* 0xf700 */
    OTHER,        /* 0xf701 */
    OTHER,        /* 0xf702 */
    OTHER,        /* 0xf703 */
    OTHER,        /* 0xf704 */
    OTHER,        /* 0xf705 */
    OTHER,        /* 0xf706 */
    OTHER,        /* 0xf707 */
    OTHER,        /* 0xf708 */
    OTHER,        /* 0xf709 */
    OTHER,        /* 0xf70a */
    OTHER,        /* 0xf70b */
    OTHER,        /* 0xf70c */
    OTHER,        /* 0xf70d */
    OTHER,        /* 0xf70e */
    OTHER,        /* 0xf70f */
    OTHER,        /* 0xf710 */
    OTHER,        /* 0xf711 */
    OTHER,        /* 0xf712 */
    OTHER,        /* 0xf713 */
    OTHER,        /* 0xf714 */
    OTHER,        /* 0xf715 */
    OTHER,        /* 0xf716 */
    OTHER,        /* 0xf717 */
    OTHER,        /* 0xf718 */
    OTHER,        /* 0xf719 */
    OTHER,        /* 0xf71a */
    OTHER,        /* 0xf71b */
    OTHER,        /* 0xf71c */
    OTHER,        /* 0xf71d */
    OTHER,        /* 0xf71e */
    OTHER,        /* 0xf71f */
    OTHER,        /* 0xf720 */
    OTHER,        /* 0xf721 */
    OTHER,        /* 0xf722 */
    OTHER,        /* 0xf723 */
    OTHER,        /* 0xf724 */
    OTHER,        /* 0xf725 */
    OTHER,        /* 0xf726 */
    OTHER,        /* 0xf727 */
    OTHER,        /* 0xf728 */
    OTHER,        /* 0xf729 */
    OTHER,        /* 0xf72a */
    OTHER,        /* 0xf72b */
    OTHER,        /* 0xf72c */
    OTHER,        /* 0xf72d */
    OTHER,        /* 0xf72e */
    OTHER,        /* 0xf72f */
    OTHER,        /* 0xf730 */
    OTHER,        /* 0xf731 */
    OTHER,        /* 0xf732 */
    OTHER,        /* 0xf733 */
    OTHER,        /* 0xf734 */
    OTHER,        /* 0xf735 */
    OTHER,        /* 0xf736 */
    OTHER,        /* 0xf737 */
    OTHER,        /* 0xf738 */
    OTHER,        /* 0xf739 */
    OTHER,        /* 0xf73a */
    OTHER,        /* 0xf73b */
    OTHER,        /* 0xf73c */
    OTHER,        /* 0xf73d */
    OTHER,        /* 0xf73e */
    OTHER,        /* 0xf73f */
    OTHER,        /* 0xf740 */
    OTHER,        /* 0xf741 */
    OTHER,        /* 0xf742 */
    OTHER,        /* 0xf743 */
    OTHER,        /* 0xf744 */
    OTHER,        /* 0xf745 */
    OTHER,        /* 0xf746 */
    OTHER,        /* 0xf747 */
    OTHER,        /* 0xf748 */
    OTHER,        /* 0xf749 */
    OTHER,        /* 0xf74a */
    OTHER,        /* 0xf74b */
    OTHER,        /* 0xf74c */
    OTHER,        /* 0xf74d */
    OTHER,        /* 0xf74e */
    OTHER,        /* 0xf74f */
    OTHER,        /* 0xf750 */
    OTHER,        /* 0xf751 */
    OTHER,        /* 0xf752 */
    OTHER,        /* 0xf753 */
    OTHER,        /* 0xf754 */
    OTHER,        /* 0xf755 */
    OTHER,        /* 0xf756 */
    OTHER,        /* 0xf757 */
    OTHER,        /* 0xf758 */
    OTHER,        /* 0xf759 */
    OTHER,        /* 0xf75a */
    OTHER,        /* 0xf75b */
    OTHER,        /* 0xf75c */
    OTHER,        /* 0xf75d */
    OTHER,        /* 0xf75e */
    OTHER,        /* 0xf75f */
    OTHER,        /* 0xf760 */
    OTHER,        /* 0xf761 */
    OTHER,        /* 0xf762 */
    OTHER,        /* 0xf763 */
    OTHER,        /* 0xf764 */
    OTHER,        /* 0xf765 */
    OTHER,        /* 0xf766 */
    OTHER,        /* 0xf767 */
    OTHER,        /* 0xf768 */
    OTHER,        /* 0xf769 */
    OTHER,        /* 0xf76a */
    OTHER,        /* 0xf76b */
    OTHER,        /* 0xf76c */
    OTHER,        /* 0xf76d */
    OTHER,        /* 0xf76e */
    OTHER,        /* 0xf76f */
    OTHER,        /* 0xf770 */
    OTHER,        /* 0xf771 */
    OTHER,        /* 0xf772 */
    OTHER,        /* 0xf773 */
    OTHER,        /* 0xf774 */
    OTHER,        /* 0xf775 */
    OTHER,        /* 0xf776 */
    OTHER,        /* 0xf777 */
    OTHER,        /* 0xf778 */
    OTHER,        /* 0xf779 */
    OTHER,        /* 0xf77a */
    OTHER,        /* 0xf77b */
    OTHER,        /* 0xf77c */
    OTHER,        /* 0xf77d */
    OTHER,        /* 0xf77e */
    OTHER,        /* 0xf77f */
    OTHER,        /* 0xf780 */
    OTHER,        /* 0xf781 */
    OTHER,        /* 0xf782 */
    OTHER,        /* 0xf783 */
    OTHER,        /* 0xf784 */
    OTHER,        /* 0xf785 */
    OTHER,        /* 0xf786 */
    OTHER,        /* 0xf787 */
    OTHER,        /* 0xf788 */
    OTHER,        /* 0xf789 */
    OTHER,        /* 0xf78a */
    OTHER,        /* 0xf78b */
    OTHER,        /* 0xf78c */
    OTHER,        /* 0xf78d */
    OTHER,        /* 0xf78e */
    OTHER,        /* 0xf78f */
    OTHER,        /* 0xf790 */
    OTHER,        /* 0xf791 */
    OTHER,        /* 0xf792 */
    OTHER,        /* 0xf793 */
    OTHER,        /* 0xf794 */
    OTHER,        /* 0xf795 */
    OTHER,        /* 0xf796 */
    OTHER,        /* 0xf797 */
    OTHER,        /* 0xf798 */
    OTHER,        /* 0xf799 */
    OTHER,        /* 0xf79a */
    OTHER,        /* 0xf79b */
    OTHER,        /* 0xf79c */
    OTHER,        /* 0xf79d */
    OTHER,        /* 0xf79e */
    OTHER,        /* 0xf79f */
    OTHER,        /* 0xf7a0 */
    OTHER,        /* 0xf7a1 */
    OTHER,        /* 0xf7a2 */
    OTHER,        /* 0xf7a3 */
    OTHER,        /* 0xf7a4 */
    OTHER,        /* 0xf7a5 */
    OTHER,        /* 0xf7a6 */
    OTHER,        /* 0xf7a7 */
    OTHER,        /* 0xf7a8 */
    OTHER,        /* 0xf7a9 */
    OTHER,        /* 0xf7aa */
    OTHER,        /* 0xf7ab */
    OTHER,        /* 0xf7ac */
    OTHER,        /* 0xf7ad */
    OTHER,        /* 0xf7ae */
    OTHER,        /* 0xf7af */
    OTHER,        /* 0xf7b0 */
    OTHER,        /* 0xf7b1 */
    OTHER,        /* 0xf7b2 */
    OTHER,        /* 0xf7b3 */
    OTHER,        /* 0xf7b4 */
    OTHER,        /* 0xf7b5 */
    OTHER,        /* 0xf7b6 */
    OTHER,        /* 0xf7b7 */
    OTHER,        /* 0xf7b8 */
    OTHER,        /* 0xf7b9 */
    OTHER,        /* 0xf7ba */
    OTHER,        /* 0xf7bb */
    OTHER,        /* 0xf7bc */
    OTHER,        /* 0xf7bd */
    OTHER,        /* 0xf7be */
    OTHER,        /* 0xf7bf */
    OTHER,        /* 0xf7c0 */
    OTHER,        /* 0xf7c1 */
    OTHER,        /* 0xf7c2 */
    OTHER,        /* 0xf7c3 */
    OTHER,        /* 0xf7c4 */
    OTHER,        /* 0xf7c5 */
    OTHER,        /* 0xf7c6 */
    OTHER,        /* 0xf7c7 */
    OTHER,        /* 0xf7c8 */
    OTHER,        /* 0xf7c9 */
    OTHER,        /* 0xf7ca */
    OTHER,        /* 0xf7cb */
    OTHER,        /* 0xf7cc */
    OTHER,        /* 0xf7cd */
    OTHER,        /* 0xf7ce */
    OTHER,        /* 0xf7cf */
    OTHER,        /* 0xf7d0 */
    OTHER,        /* 0xf7d1 */
    OTHER,        /* 0xf7d2 */
    OTHER,        /* 0xf7d3 */
    OTHER,        /* 0xf7d4 */
    OTHER,        /* 0xf7d5 */
    OTHER,        /* 0xf7d6 */
    OTHER,        /* 0xf7d7 */
    OTHER,        /* 0xf7d8 */
    OTHER,        /* 0xf7d9 */
    OTHER,        /* 0xf7da */
    OTHER,        /* 0xf7db */
    OTHER,        /* 0xf7dc */
    OTHER,        /* 0xf7dd */
    OTHER,        /* 0xf7de */
    OTHER,        /* 0xf7df */
    OTHER,        /* 0xf7e0 */
    OTHER,        /* 0xf7e1 */
    OTHER,        /* 0xf7e2 */
    OTHER,        /* 0xf7e3 */
    OTHER,        /* 0xf7e4 */
    OTHER,        /* 0xf7e5 */
    OTHER,        /* 0xf7e6 */
    OTHER,        /* 0xf7e7 */
    OTHER,        /* 0xf7e8 */
    OTHER,        /* 0xf7e9 */
    OTHER,        /* 0xf7ea */
    OTHER,        /* 0xf7eb */
    OTHER,        /* 0xf7ec */
    OTHER,        /* 0xf7ed */
    OTHER,        /* 0xf7ee */
    OTHER,        /* 0xf7ef */
    OTHER,        /* 0xf7f0 */
    OTHER,        /* 0xf7f1 */
    OTHER,        /* 0xf7f2 */
    OTHER,        /* 0xf7f3 */
    OTHER,        /* 0xf7f4 */
    OTHER,        /* 0xf7f5 */
    OTHER,        /* 0xf7f6 */
    OTHER,        /* 0xf7f7 */
    OTHER,        /* 0xf7f8 */
    OTHER,        /* 0xf7f9 */
    OTHER,        /* 0xf7fa */
    OTHER,        /* 0xf7fb */
    OTHER,        /* 0xf7fc */
    OTHER,        /* 0xf7fd */
    OTHER,        /* 0xf7fe */
    OTHER,        /* 0xf7ff */
    OTHER,        /* 0xf800 */
    OTHER,        /* 0xf801 */
    OTHER,        /* 0xf802 */
    OTHER,        /* 0xf803 */
    OTHER,        /* 0xf804 */
    OTHER,        /* 0xf805 */
    OTHER,        /* 0xf806 */
    OTHER,        /* 0xf807 */
    OTHER,        /* 0xf808 */
    OTHER,        /* 0xf809 */
    OTHER,        /* 0xf80a */
    OTHER,        /* 0xf80b */
    OTHER,        /* 0xf80c */
    OTHER,        /* 0xf80d */
    OTHER,        /* 0xf80e */
    OTHER,        /* 0xf80f */
    OTHER,        /* 0xf810 */
    OTHER,        /* 0xf811 */
    OTHER,        /* 0xf812 */
    OTHER,        /* 0xf813 */
    OTHER,        /* 0xf814 */
    OTHER,        /* 0xf815 */
    OTHER,        /* 0xf816 */
    OTHER,        /* 0xf817 */
    OTHER,        /* 0xf818 */
    OTHER,        /* 0xf819 */
    OTHER,        /* 0xf81a */
    OTHER,        /* 0xf81b */
    OTHER,        /* 0xf81c */
    OTHER,        /* 0xf81d */
    OTHER,        /* 0xf81e */
    OTHER,        /* 0xf81f */
    OTHER,        /* 0xf820 */
    OTHER,        /* 0xf821 */
    OTHER,        /* 0xf822 */
    OTHER,        /* 0xf823 */
    OTHER,        /* 0xf824 */
    OTHER,        /* 0xf825 */
    OTHER,        /* 0xf826 */
    OTHER,        /* 0xf827 */
    OTHER,        /* 0xf828 */
    OTHER,        /* 0xf829 */
    OTHER,        /* 0xf82a */
    OTHER,        /* 0xf82b */
    OTHER,        /* 0xf82c */
    OTHER,        /* 0xf82d */
    OTHER,        /* 0xf82e */
    OTHER,        /* 0xf82f */
    OTHER,        /* 0xf830 */
    OTHER,        /* 0xf831 */
    OTHER,        /* 0xf832 */
    OTHER,        /* 0xf833 */
    OTHER,        /* 0xf834 */
    OTHER,        /* 0xf835 */
    OTHER,        /* 0xf836 */
    OTHER,        /* 0xf837 */
    OTHER,        /* 0xf838 */
    OTHER,        /* 0xf839 */
    OTHER,        /* 0xf83a */
    OTHER,        /* 0xf83b */
    OTHER,        /* 0xf83c */
    OTHER,        /* 0xf83d */
    OTHER,        /* 0xf83e */
    OTHER,        /* 0xf83f */
    OTHER,        /* 0xf840 */
    OTHER,        /* 0xf841 */
    OTHER,        /* 0xf842 */
    OTHER,        /* 0xf843 */
    OTHER,        /* 0xf844 */
    OTHER,        /* 0xf845 */
    OTHER,        /* 0xf846 */
    OTHER,        /* 0xf847 */
    OTHER,        /* 0xf848 */
    OTHER,        /* 0xf849 */
    OTHER,        /* 0xf84a */
    OTHER,        /* 0xf84b */
    OTHER,        /* 0xf84c */
    OTHER,        /* 0xf84d */
    OTHER,        /* 0xf84e */
    OTHER,        /* 0xf84f */
    OTHER,        /* 0xf850 */
    OTHER,        /* 0xf851 */
    OTHER,        /* 0xf852 */
    OTHER,        /* 0xf853 */
    OTHER,        /* 0xf854 */
    OTHER,        /* 0xf855 */
    OTHER,        /* 0xf856 */
    OTHER,        /* 0xf857 */
    OTHER,        /* 0xf858 */
    OTHER,        /* 0xf859 */
    OTHER,        /* 0xf85a */
    OTHER,        /* 0xf85b */
    OTHER,        /* 0xf85c */
    OTHER,        /* 0xf85d */
    OTHER,        /* 0xf85e */
    OTHER,        /* 0xf85f */
    OTHER,        /* 0xf860 */
    OTHER,        /* 0xf861 */
    OTHER,        /* 0xf862 */
    OTHER,        /* 0xf863 */
    OTHER,        /* 0xf864 */
    OTHER,        /* 0xf865 */
    OTHER,        /* 0xf866 */
    OTHER,        /* 0xf867 */
    OTHER,        /* 0xf868 */
    OTHER,        /* 0xf869 */
    OTHER,        /* 0xf86a */
    OTHER,        /* 0xf86b */
    OTHER,        /* 0xf86c */
    OTHER,        /* 0xf86d */
    OTHER,        /* 0xf86e */
    OTHER,        /* 0xf86f */
    OTHER,        /* 0xf870 */
    OTHER,        /* 0xf871 */
    OTHER,        /* 0xf872 */
    OTHER,        /* 0xf873 */
    OTHER,        /* 0xf874 */
    OTHER,        /* 0xf875 */
    OTHER,        /* 0xf876 */
    OTHER,        /* 0xf877 */
    OTHER,        /* 0xf878 */
    OTHER,        /* 0xf879 */
    OTHER,        /* 0xf87a */
    OTHER,        /* 0xf87b */
    OTHER,        /* 0xf87c */
    OTHER,        /* 0xf87d */
    OTHER,        /* 0xf87e */
    OTHER,        /* 0xf87f */
    OTHER,        /* 0xf880 */
    OTHER,        /* 0xf881 */
    OTHER,        /* 0xf882 */
    OTHER,        /* 0xf883 */
    OTHER,        /* 0xf884 */
    OTHER,        /* 0xf885 */
    OTHER,        /* 0xf886 */
    OTHER,        /* 0xf887 */
    OTHER,        /* 0xf888 */
    OTHER,        /* 0xf889 */
    OTHER,        /* 0xf88a */
    OTHER,        /* 0xf88b */
    OTHER,        /* 0xf88c */
    OTHER,        /* 0xf88d */
    OTHER,        /* 0xf88e */
    OTHER,        /* 0xf88f */
    OTHER,        /* 0xf890 */
    OTHER,        /* 0xf891 */
    OTHER,        /* 0xf892 */
    OTHER,        /* 0xf893 */
    OTHER,        /* 0xf894 */
    OTHER,        /* 0xf895 */
    OTHER,        /* 0xf896 */
    OTHER,        /* 0xf897 */
    OTHER,        /* 0xf898 */
    OTHER,        /* 0xf899 */
    OTHER,        /* 0xf89a */
    OTHER,        /* 0xf89b */
    OTHER,        /* 0xf89c */
    OTHER,        /* 0xf89d */
    OTHER,        /* 0xf89e */
    OTHER,        /* 0xf89f */
    OTHER,        /* 0xf8a0 */
    OTHER,        /* 0xf8a1 */
    OTHER,        /* 0xf8a2 */
    OTHER,        /* 0xf8a3 */
    OTHER,        /* 0xf8a4 */
    OTHER,        /* 0xf8a5 */
    OTHER,        /* 0xf8a6 */
    OTHER,        /* 0xf8a7 */
    OTHER,        /* 0xf8a8 */
    OTHER,        /* 0xf8a9 */
    OTHER,        /* 0xf8aa */
    OTHER,        /* 0xf8ab */
    OTHER,        /* 0xf8ac */
    OTHER,        /* 0xf8ad */
    OTHER,        /* 0xf8ae */
    OTHER,        /* 0xf8af */
    OTHER,        /* 0xf8b0 */
    OTHER,        /* 0xf8b1 */
    OTHER,        /* 0xf8b2 */
    OTHER,        /* 0xf8b3 */
    OTHER,        /* 0xf8b4 */
    OTHER,        /* 0xf8b5 */
    OTHER,        /* 0xf8b6 */
    OTHER,        /* 0xf8b7 */
    OTHER,        /* 0xf8b8 */
    OTHER,        /* 0xf8b9 */
    OTHER,        /* 0xf8ba */
    OTHER,        /* 0xf8bb */
    OTHER,        /* 0xf8bc */
    OTHER,        /* 0xf8bd */
    OTHER,        /* 0xf8be */
    OTHER,        /* 0xf8bf */
    OTHER,        /* 0xf8c0 */
    OTHER,        /* 0xf8c1 */
    OTHER,        /* 0xf8c2 */
    OTHER,        /* 0xf8c3 */
    OTHER,        /* 0xf8c4 */
    OTHER,        /* 0xf8c5 */
    OTHER,        /* 0xf8c6 */
    OTHER,        /* 0xf8c7 */
    OTHER,        /* 0xf8c8 */
    OTHER,        /* 0xf8c9 */
    OTHER,        /* 0xf8ca */
    OTHER,        /* 0xf8cb */
    OTHER,        /* 0xf8cc */
    OTHER,        /* 0xf8cd */
    OTHER,        /* 0xf8ce */
    OTHER,        /* 0xf8cf */
    OTHER,        /* 0xf8d0 */
    OTHER,        /* 0xf8d1 */
    OTHER,        /* 0xf8d2 */
    OTHER,        /* 0xf8d3 */
    OTHER,        /* 0xf8d4 */
    OTHER,        /* 0xf8d5 */
    OTHER,        /* 0xf8d6 */
    OTHER,        /* 0xf8d7 */
    OTHER,        /* 0xf8d8 */
    OTHER,        /* 0xf8d9 */
    OTHER,        /* 0xf8da */
    OTHER,        /* 0xf8db */
    OTHER,        /* 0xf8dc */
    OTHER,        /* 0xf8dd */
    OTHER,        /* 0xf8de */
    OTHER,        /* 0xf8df */
    OTHER,        /* 0xf8e0 */
    OTHER,        /* 0xf8e1 */
    OTHER,        /* 0xf8e2 */
    OTHER,        /* 0xf8e3 */
    OTHER,        /* 0xf8e4 */
    OTHER,        /* 0xf8e5 */
    OTHER,        /* 0xf8e6 */
    OTHER,        /* 0xf8e7 */
    OTHER,        /* 0xf8e8 */
    OTHER,        /* 0xf8e9 */
    OTHER,        /* 0xf8ea */
    OTHER,        /* 0xf8eb */
    OTHER,        /* 0xf8ec */
    OTHER,        /* 0xf8ed */
    OTHER,        /* 0xf8ee */
    OTHER,        /* 0xf8ef */
    OTHER,        /* 0xf8f0 */
    OTHER,        /* 0xf8f1 */
    OTHER,        /* 0xf8f2 */
    OTHER,        /* 0xf8f3 */
    OTHER,        /* 0xf8f4 */
    OTHER,        /* 0xf8f5 */
    OTHER,        /* 0xf8f6 */
    OTHER,        /* 0xf8f7 */
    OTHER,        /* 0xf8f8 */
    OTHER,        /* 0xf8f9 */
    OTHER,        /* 0xf8fa */
    OTHER,        /* 0xf8fb */
    OTHER,        /* 0xf8fc */
    OTHER,        /* 0xf8fd */
    OTHER,        /* 0xf8fe */
    OTHER,        /* 0xf8ff */
    KANJI,        /* 0xf900 */
    KANJI,        /* 0xf901 */
    KANJI,        /* 0xf902 */
    KANJI,        /* 0xf903 */
    KANJI,        /* 0xf904 */
    KANJI,        /* 0xf905 */
    KANJI,        /* 0xf906 */
    KANJI,        /* 0xf907 */
    KANJI,        /* 0xf908 */
    KANJI,        /* 0xf909 */
    KANJI,        /* 0xf90a */
    KANJI,        /* 0xf90b */
    KANJI,        /* 0xf90c */
    KANJI,        /* 0xf90d */
    KANJI,        /* 0xf90e */
    KANJI,        /* 0xf90f */
    KANJI,        /* 0xf910 */
    KANJI,        /* 0xf911 */
    KANJI,        /* 0xf912 */
    KANJI,        /* 0xf913 */
    KANJI,        /* 0xf914 */
    KANJI,        /* 0xf915 */
    KANJI,        /* 0xf916 */
    KANJI,        /* 0xf917 */
    KANJI,        /* 0xf918 */
    KANJI,        /* 0xf919 */
    KANJI,        /* 0xf91a */
    KANJI,        /* 0xf91b */
    KANJI,        /* 0xf91c */
    KANJI,        /* 0xf91d */
    KANJI,        /* 0xf91e */
    KANJI,        /* 0xf91f */
    KANJI,        /* 0xf920 */
    KANJI,        /* 0xf921 */
    KANJI,        /* 0xf922 */
    KANJI,        /* 0xf923 */
    KANJI,        /* 0xf924 */
    KANJI,        /* 0xf925 */
    KANJI,        /* 0xf926 */
    KANJI,        /* 0xf927 */
    KANJI,        /* 0xf928 */
    KANJI,        /* 0xf929 */
    KANJI,        /* 0xf92a */
    KANJI,        /* 0xf92b */
    KANJI,        /* 0xf92c */
    KANJI,        /* 0xf92d */
    KANJI,        /* 0xf92e */
    KANJI,        /* 0xf92f */
    KANJI,        /* 0xf930 */
    KANJI,        /* 0xf931 */
    KANJI,        /* 0xf932 */
    KANJI,        /* 0xf933 */
    KANJI,        /* 0xf934 */
    KANJI,        /* 0xf935 */
    KANJI,        /* 0xf936 */
    KANJI,        /* 0xf937 */
    KANJI,        /* 0xf938 */
    KANJI,        /* 0xf939 */
    KANJI,        /* 0xf93a */
    KANJI,        /* 0xf93b */
    KANJI,        /* 0xf93c */
    KANJI,        /* 0xf93d */
    KANJI,        /* 0xf93e */
    KANJI,        /* 0xf93f */
    KANJI,        /* 0xf940 */
    KANJI,        /* 0xf941 */
    KANJI,        /* 0xf942 */
    KANJI,        /* 0xf943 */
    KANJI,        /* 0xf944 */
    KANJI,        /* 0xf945 */
    KANJI,        /* 0xf946 */
    KANJI,        /* 0xf947 */
    KANJI,        /* 0xf948 */
    KANJI,        /* 0xf949 */
    KANJI,        /* 0xf94a */
    KANJI,        /* 0xf94b */
    KANJI,        /* 0xf94c */
    KANJI,        /* 0xf94d */
    KANJI,        /* 0xf94e */
    KANJI,        /* 0xf94f */
    KANJI,        /* 0xf950 */
    KANJI,        /* 0xf951 */
    KANJI,        /* 0xf952 */
    KANJI,        /* 0xf953 */
    KANJI,        /* 0xf954 */
    KANJI,        /* 0xf955 */
    KANJI,        /* 0xf956 */
    KANJI,        /* 0xf957 */
    KANJI,        /* 0xf958 */
    KANJI,        /* 0xf959 */
    KANJI,        /* 0xf95a */
    KANJI,        /* 0xf95b */
    KANJI,        /* 0xf95c */
    KANJI,        /* 0xf95d */
    KANJI,        /* 0xf95e */
    KANJI,        /* 0xf95f */
    KANJI,        /* 0xf960 */
    KANJI,        /* 0xf961 */
    KANJI,        /* 0xf962 */
    KANJI,        /* 0xf963 */
    KANJI,        /* 0xf964 */
    KANJI,        /* 0xf965 */
    KANJI,        /* 0xf966 */
    KANJI,        /* 0xf967 */
    KANJI,        /* 0xf968 */
    KANJI,        /* 0xf969 */
    KANJI,        /* 0xf96a */
    KANJI,        /* 0xf96b */
    KANJI,        /* 0xf96c */
    KANJI,        /* 0xf96d */
    KANJI,        /* 0xf96e */
    KANJI,        /* 0xf96f */
    KANJI,        /* 0xf970 */
    KANJI,        /* 0xf971 */
    KANJI,        /* 0xf972 */
    KANJI,        /* 0xf973 */
    KANJI,        /* 0xf974 */
    KANJI,        /* 0xf975 */
    KANJI,        /* 0xf976 */
    KANJI,        /* 0xf977 */
    KANJI,        /* 0xf978 */
    KANJI,        /* 0xf979 */
    KANJI,        /* 0xf97a */
    KANJI,        /* 0xf97b */
    KANJI,        /* 0xf97c */
    KANJI,        /* 0xf97d */
    KANJI,        /* 0xf97e */
    KANJI,        /* 0xf97f */
    KANJI,        /* 0xf980 */
    KANJI,        /* 0xf981 */
    KANJI,        /* 0xf982 */
    KANJI,        /* 0xf983 */
    KANJI,        /* 0xf984 */
    KANJI,        /* 0xf985 */
    KANJI,        /* 0xf986 */
    KANJI,        /* 0xf987 */
    KANJI,        /* 0xf988 */
    KANJI,        /* 0xf989 */
    KANJI,        /* 0xf98a */
    KANJI,        /* 0xf98b */
    KANJI,        /* 0xf98c */
    KANJI,        /* 0xf98d */
    KANJI,        /* 0xf98e */
    KANJI,        /* 0xf98f */
    KANJI,        /* 0xf990 */
    KANJI,        /* 0xf991 */
    KANJI,        /* 0xf992 */
    KANJI,        /* 0xf993 */
    KANJI,        /* 0xf994 */
    KANJI,        /* 0xf995 */
    KANJI,        /* 0xf996 */
    KANJI,        /* 0xf997 */
    KANJI,        /* 0xf998 */
    KANJI,        /* 0xf999 */
    KANJI,        /* 0xf99a */
    KANJI,        /* 0xf99b */
    KANJI,        /* 0xf99c */
    KANJI,        /* 0xf99d */
    KANJI,        /* 0xf99e */
    KANJI,        /* 0xf99f */
    KANJI,        /* 0xf9a0 */
    KANJI,        /* 0xf9a1 */
    KANJI,        /* 0xf9a2 */
    KANJI,        /* 0xf9a3 */
    KANJI,        /* 0xf9a4 */
    KANJI,        /* 0xf9a5 */
    KANJI,        /* 0xf9a6 */
    KANJI,        /* 0xf9a7 */
    KANJI,        /* 0xf9a8 */
    KANJI,        /* 0xf9a9 */
    KANJI,        /* 0xf9aa */
    KANJI,        /* 0xf9ab */
    KANJI,        /* 0xf9ac */
    KANJI,        /* 0xf9ad */
    KANJI,        /* 0xf9ae */
    KANJI,        /* 0xf9af */
    KANJI,        /* 0xf9b0 */
    KANJI,        /* 0xf9b1 */
    KANJI,        /* 0xf9b2 */
    KANJI,        /* 0xf9b3 */
    KANJI,        /* 0xf9b4 */
    KANJI,        /* 0xf9b5 */
    KANJI,        /* 0xf9b6 */
    KANJI,        /* 0xf9b7 */
    KANJI,        /* 0xf9b8 */
    KANJI,        /* 0xf9b9 */
    KANJI,        /* 0xf9ba */
    KANJI,        /* 0xf9bb */
    KANJI,        /* 0xf9bc */
    KANJI,        /* 0xf9bd */
    KANJI,        /* 0xf9be */
    KANJI,        /* 0xf9bf */
    KANJI,        /* 0xf9c0 */
    KANJI,        /* 0xf9c1 */
    KANJI,        /* 0xf9c2 */
    KANJI,        /* 0xf9c3 */
    KANJI,        /* 0xf9c4 */
    KANJI,        /* 0xf9c5 */
    KANJI,        /* 0xf9c6 */
    KANJI,        /* 0xf9c7 */
    KANJI,        /* 0xf9c8 */
    KANJI,        /* 0xf9c9 */
    KANJI,        /* 0xf9ca */
    KANJI,        /* 0xf9cb */
    KANJI,        /* 0xf9cc */
    KANJI,        /* 0xf9cd */
    KANJI,        /* 0xf9ce */
    KANJI,        /* 0xf9cf */
    KANJI,        /* 0xf9d0 */
    KANJI,        /* 0xf9d1 */
    KANJI,        /* 0xf9d2 */
    KANJI,        /* 0xf9d3 */
    KANJI,        /* 0xf9d4 */
    KANJI,        /* 0xf9d5 */
    KANJI,        /* 0xf9d6 */
    KANJI,        /* 0xf9d7 */
    KANJI,        /* 0xf9d8 */
    KANJI,        /* 0xf9d9 */
    KANJI,        /* 0xf9da */
    KANJI,        /* 0xf9db */
    KANJI,        /* 0xf9dc */
    KANJI,        /* 0xf9dd */
    KANJI,        /* 0xf9de */
    KANJI,        /* 0xf9df */
    KANJI,        /* 0xf9e0 */
    KANJI,        /* 0xf9e1 */
    KANJI,        /* 0xf9e2 */
    KANJI,        /* 0xf9e3 */
    KANJI,        /* 0xf9e4 */
    KANJI,        /* 0xf9e5 */
    KANJI,        /* 0xf9e6 */
    KANJI,        /* 0xf9e7 */
    KANJI,        /* 0xf9e8 */
    KANJI,        /* 0xf9e9 */
    KANJI,        /* 0xf9ea */
    KANJI,        /* 0xf9eb */
    KANJI,        /* 0xf9ec */
    KANJI,        /* 0xf9ed */
    KANJI,        /* 0xf9ee */
    KANJI,        /* 0xf9ef */
    KANJI,        /* 0xf9f0 */
    KANJI,        /* 0xf9f1 */
    KANJI,        /* 0xf9f2 */
    KANJI,        /* 0xf9f3 */
    KANJI,        /* 0xf9f4 */
    KANJI,        /* 0xf9f5 */
    KANJI,        /* 0xf9f6 */
    KANJI,        /* 0xf9f7 */
    KANJI,        /* 0xf9f8 */
    KANJI,        /* 0xf9f9 */
    KANJI,        /* 0xf9fa */
    KANJI,        /* 0xf9fb */
    KANJI,        /* 0xf9fc */
    KANJI,        /* 0xf9fd */
    KANJI,        /* 0xf9fe */
    KANJI,        /* 0xf9ff */
    KANJI,        /* 0xfa00 */
    KANJI,        /* 0xfa01 */
    KANJI,        /* 0xfa02 */
    KANJI,        /* 0xfa03 */
    KANJI,        /* 0xfa04 */
    KANJI,        /* 0xfa05 */
    KANJI,        /* 0xfa06 */
    KANJI,        /* 0xfa07 */
    KANJI,        /* 0xfa08 */
    KANJI,        /* 0xfa09 */
    KANJI,        /* 0xfa0a */
    KANJI,        /* 0xfa0b */
    KANJI,        /* 0xfa0c */
    KANJI,        /* 0xfa0d */
    KANJI,        /* 0xfa0e */
    KANJI,        /* 0xfa0f */
    KANJI,        /* 0xfa10 */
    KANJI,        /* 0xfa11 */
    KANJI,        /* 0xfa12 */
    KANJI,        /* 0xfa13 */
    KANJI,        /* 0xfa14 */
    KANJI,        /* 0xfa15 */
    KANJI,        /* 0xfa16 */
    KANJI,        /* 0xfa17 */
    KANJI,        /* 0xfa18 */
    KANJI,        /* 0xfa19 */
    KANJI,        /* 0xfa1a */
    KANJI,        /* 0xfa1b */
    KANJI,        /* 0xfa1c */
    KANJI,        /* 0xfa1d */
    KANJI,        /* 0xfa1e */
    KANJI,        /* 0xfa1f */
    KANJI,        /* 0xfa20 */
    KANJI,        /* 0xfa21 */
    KANJI,        /* 0xfa22 */
    KANJI,        /* 0xfa23 */
    KANJI,        /* 0xfa24 */
    KANJI,        /* 0xfa25 */
    KANJI,        /* 0xfa26 */
    KANJI,        /* 0xfa27 */
    KANJI,        /* 0xfa28 */
    KANJI,        /* 0xfa29 */
    KANJI,        /* 0xfa2a */
    KANJI,        /* 0xfa2b */
    KANJI,        /* 0xfa2c */
    KANJI,        /* 0xfa2d */
    OTHER,        /* 0xfa2e */
    OTHER,        /* 0xfa2f */
    KANJI,        /* 0xfa30 */
    KANJI,        /* 0xfa31 */
    KANJI,        /* 0xfa32 */
    KANJI,        /* 0xfa33 */
    KANJI,        /* 0xfa34 */
    KANJI,        /* 0xfa35 */
    KANJI,        /* 0xfa36 */
    KANJI,        /* 0xfa37 */
    KANJI,        /* 0xfa38 */
    KANJI,        /* 0xfa39 */
    KANJI,        /* 0xfa3a */
    KANJI,        /* 0xfa3b */
    KANJI,        /* 0xfa3c */
    KANJI,        /* 0xfa3d */
    KANJI,        /* 0xfa3e */
    KANJI,        /* 0xfa3f */
    KANJI,        /* 0xfa40 */
    KANJI,        /* 0xfa41 */
    KANJI,        /* 0xfa42 */
    KANJI,        /* 0xfa43 */
    KANJI,        /* 0xfa44 */
    KANJI,        /* 0xfa45 */
    KANJI,        /* 0xfa46 */
    KANJI,        /* 0xfa47 */
    KANJI,        /* 0xfa48 */
    KANJI,        /* 0xfa49 */
    KANJI,        /* 0xfa4a */
    KANJI,        /* 0xfa4b */
    KANJI,        /* 0xfa4c */
    KANJI,        /* 0xfa4d */
    KANJI,        /* 0xfa4e */
    KANJI,        /* 0xfa4f */
    KANJI,        /* 0xfa50 */
    KANJI,        /* 0xfa51 */
    KANJI,        /* 0xfa52 */
    KANJI,        /* 0xfa53 */
    KANJI,        /* 0xfa54 */
    KANJI,        /* 0xfa55 */
    KANJI,        /* 0xfa56 */
    KANJI,        /* 0xfa57 */
    KANJI,        /* 0xfa58 */
    KANJI,        /* 0xfa59 */
    KANJI,        /* 0xfa5a */
    KANJI,        /* 0xfa5b */
    KANJI,        /* 0xfa5c */
    KANJI,        /* 0xfa5d */
    KANJI,        /* 0xfa5e */
    KANJI,        /* 0xfa5f */
    KANJI,        /* 0xfa60 */
    KANJI,        /* 0xfa61 */
    KANJI,        /* 0xfa62 */
    KANJI,        /* 0xfa63 */
    KANJI,        /* 0xfa64 */
    KANJI,        /* 0xfa65 */
    KANJI,        /* 0xfa66 */
    KANJI,        /* 0xfa67 */
    KANJI,        /* 0xfa68 */
    KANJI,        /* 0xfa69 */
    KANJI,        /* 0xfa6a */
    OTHER,        /* 0xfa6b */
    OTHER,        /* 0xfa6c */
    OTHER,        /* 0xfa6d */
    OTHER,        /* 0xfa6e */
    OTHER,        /* 0xfa6f */
    OTHER,        /* 0xfa70 */
    OTHER,        /* 0xfa71 */
    OTHER,        /* 0xfa72 */
    OTHER,        /* 0xfa73 */
    OTHER,        /* 0xfa74 */
    OTHER,        /* 0xfa75 */
    OTHER,        /* 0xfa76 */
    OTHER,        /* 0xfa77 */
    OTHER,        /* 0xfa78 */
    OTHER,        /* 0xfa79 */
    OTHER,        /* 0xfa7a */
    OTHER,        /* 0xfa7b */
    OTHER,        /* 0xfa7c */
    OTHER,        /* 0xfa7d */
    OTHER,        /* 0xfa7e */
    OTHER,        /* 0xfa7f */
    OTHER,        /* 0xfa80 */
    OTHER,        /* 0xfa81 */
    OTHER,        /* 0xfa82 */
    OTHER,        /* 0xfa83 */
    OTHER,        /* 0xfa84 */
    OTHER,        /* 0xfa85 */
    OTHER,        /* 0xfa86 */
    OTHER,        /* 0xfa87 */
    OTHER,        /* 0xfa88 */
    OTHER,        /* 0xfa89 */
    OTHER,        /* 0xfa8a */
    OTHER,        /* 0xfa8b */
    OTHER,        /* 0xfa8c */
    OTHER,        /* 0xfa8d */
    OTHER,        /* 0xfa8e */
    OTHER,        /* 0xfa8f */
    OTHER,        /* 0xfa90 */
    OTHER,        /* 0xfa91 */
    OTHER,        /* 0xfa92 */
    OTHER,        /* 0xfa93 */
    OTHER,        /* 0xfa94 */
    OTHER,        /* 0xfa95 */
    OTHER,        /* 0xfa96 */
    OTHER,        /* 0xfa97 */
    OTHER,        /* 0xfa98 */
    OTHER,        /* 0xfa99 */
    OTHER,        /* 0xfa9a */
    OTHER,        /* 0xfa9b */
    OTHER,        /* 0xfa9c */
    OTHER,        /* 0xfa9d */
    OTHER,        /* 0xfa9e */
    OTHER,        /* 0xfa9f */
    OTHER,        /* 0xfaa0 */
    OTHER,        /* 0xfaa1 */
    OTHER,        /* 0xfaa2 */
    OTHER,        /* 0xfaa3 */
    OTHER,        /* 0xfaa4 */
    OTHER,        /* 0xfaa5 */
    OTHER,        /* 0xfaa6 */
    OTHER,        /* 0xfaa7 */
    OTHER,        /* 0xfaa8 */
    OTHER,        /* 0xfaa9 */
    OTHER,        /* 0xfaaa */
    OTHER,        /* 0xfaab */
    OTHER,        /* 0xfaac */
    OTHER,        /* 0xfaad */
    OTHER,        /* 0xfaae */
    OTHER,        /* 0xfaaf */
    OTHER,        /* 0xfab0 */
    OTHER,        /* 0xfab1 */
    OTHER,        /* 0xfab2 */
    OTHER,        /* 0xfab3 */
    OTHER,        /* 0xfab4 */
    OTHER,        /* 0xfab5 */
    OTHER,        /* 0xfab6 */
    OTHER,        /* 0xfab7 */
    OTHER,        /* 0xfab8 */
    OTHER,        /* 0xfab9 */
    OTHER,        /* 0xfaba */
    OTHER,        /* 0xfabb */
    OTHER,        /* 0xfabc */
    OTHER,        /* 0xfabd */
    OTHER,        /* 0xfabe */
    OTHER,        /* 0xfabf */
    OTHER,        /* 0xfac0 */
    OTHER,        /* 0xfac1 */
    OTHER,        /* 0xfac2 */
    OTHER,        /* 0xfac3 */
    OTHER,        /* 0xfac4 */
    OTHER,        /* 0xfac5 */
    OTHER,        /* 0xfac6 */
    OTHER,        /* 0xfac7 */
    OTHER,        /* 0xfac8 */
    OTHER,        /* 0xfac9 */
    OTHER,        /* 0xfaca */
    OTHER,        /* 0xfacb */
    OTHER,        /* 0xfacc */
    OTHER,        /* 0xfacd */
    OTHER,        /* 0xface */
    OTHER,        /* 0xfacf */
    OTHER,        /* 0xfad0 */
    OTHER,        /* 0xfad1 */
    OTHER,        /* 0xfad2 */
    OTHER,        /* 0xfad3 */
    OTHER,        /* 0xfad4 */
    OTHER,        /* 0xfad5 */
    OTHER,        /* 0xfad6 */
    OTHER,        /* 0xfad7 */
    OTHER,        /* 0xfad8 */
    OTHER,        /* 0xfad9 */
    OTHER,        /* 0xfada */
    OTHER,        /* 0xfadb */
    OTHER,        /* 0xfadc */
    OTHER,        /* 0xfadd */
    OTHER,        /* 0xfade */
    OTHER,        /* 0xfadf */
    OTHER,        /* 0xfae0 */
    OTHER,        /* 0xfae1 */
    OTHER,        /* 0xfae2 */
    OTHER,        /* 0xfae3 */
    OTHER,        /* 0xfae4 */
    OTHER,        /* 0xfae5 */
    OTHER,        /* 0xfae6 */
    OTHER,        /* 0xfae7 */
    OTHER,        /* 0xfae8 */
    OTHER,        /* 0xfae9 */
    OTHER,        /* 0xfaea */
    OTHER,        /* 0xfaeb */
    OTHER,        /* 0xfaec */
    OTHER,        /* 0xfaed */
    OTHER,        /* 0xfaee */
    OTHER,        /* 0xfaef */
    OTHER,        /* 0xfaf0 */
    OTHER,        /* 0xfaf1 */
    OTHER,        /* 0xfaf2 */
    OTHER,        /* 0xfaf3 */
    OTHER,        /* 0xfaf4 */
    OTHER,        /* 0xfaf5 */
    OTHER,        /* 0xfaf6 */
    OTHER,        /* 0xfaf7 */
    OTHER,        /* 0xfaf8 */
    OTHER,        /* 0xfaf9 */
    OTHER,        /* 0xfafa */
    OTHER,        /* 0xfafb */
    OTHER,        /* 0xfafc */
    OTHER,        /* 0xfafd */
    OTHER,        /* 0xfafe */
    OTHER,        /* 0xfaff */
    OTHER,        /* 0xfb00 */
    OTHER,        /* 0xfb01 */
    OTHER,        /* 0xfb02 */
    OTHER,        /* 0xfb03 */
    OTHER,        /* 0xfb04 */
    OTHER,        /* 0xfb05 */
    OTHER,        /* 0xfb06 */
    OTHER,        /* 0xfb07 */
    OTHER,        /* 0xfb08 */
    OTHER,        /* 0xfb09 */
    OTHER,        /* 0xfb0a */
    OTHER,        /* 0xfb0b */
    OTHER,        /* 0xfb0c */
    OTHER,        /* 0xfb0d */
    OTHER,        /* 0xfb0e */
    OTHER,        /* 0xfb0f */
    OTHER,        /* 0xfb10 */
    OTHER,        /* 0xfb11 */
    OTHER,        /* 0xfb12 */
    OTHER,        /* 0xfb13 */
    OTHER,        /* 0xfb14 */
    OTHER,        /* 0xfb15 */
    OTHER,        /* 0xfb16 */
    OTHER,        /* 0xfb17 */
    OTHER,        /* 0xfb18 */
    OTHER,        /* 0xfb19 */
    OTHER,        /* 0xfb1a */
    OTHER,        /* 0xfb1b */
    OTHER,        /* 0xfb1c */
    OTHER,        /* 0xfb1d */
    OTHER,        /* 0xfb1e */
    OTHER,        /* 0xfb1f */
    OTHER,        /* 0xfb20 */
    OTHER,        /* 0xfb21 */
    OTHER,        /* 0xfb22 */
    OTHER,        /* 0xfb23 */
    OTHER,        /* 0xfb24 */
    OTHER,        /* 0xfb25 */
    OTHER,        /* 0xfb26 */
    OTHER,        /* 0xfb27 */
    OTHER,        /* 0xfb28 */
    OTHER,        /* 0xfb29 */
    OTHER,        /* 0xfb2a */
    OTHER,        /* 0xfb2b */
    OTHER,        /* 0xfb2c */
    OTHER,        /* 0xfb2d */
    OTHER,        /* 0xfb2e */
    OTHER,        /* 0xfb2f */
    OTHER,        /* 0xfb30 */
    OTHER,        /* 0xfb31 */
    OTHER,        /* 0xfb32 */
    OTHER,        /* 0xfb33 */
    OTHER,        /* 0xfb34 */
    OTHER,        /* 0xfb35 */
    OTHER,        /* 0xfb36 */
    OTHER,        /* 0xfb37 */
    OTHER,        /* 0xfb38 */
    OTHER,        /* 0xfb39 */
    OTHER,        /* 0xfb3a */
    OTHER,        /* 0xfb3b */
    OTHER,        /* 0xfb3c */
    OTHER,        /* 0xfb3d */
    OTHER,        /* 0xfb3e */
    OTHER,        /* 0xfb3f */
    OTHER,        /* 0xfb40 */
    OTHER,        /* 0xfb41 */
    OTHER,        /* 0xfb42 */
    OTHER,        /* 0xfb43 */
    OTHER,        /* 0xfb44 */
    OTHER,        /* 0xfb45 */
    OTHER,        /* 0xfb46 */
    OTHER,        /* 0xfb47 */
    OTHER,        /* 0xfb48 */
    OTHER,        /* 0xfb49 */
    OTHER,        /* 0xfb4a */
    OTHER,        /* 0xfb4b */
    OTHER,        /* 0xfb4c */
    OTHER,        /* 0xfb4d */
    OTHER,        /* 0xfb4e */
    OTHER,        /* 0xfb4f */
    OTHER,        /* 0xfb50 */
    OTHER,        /* 0xfb51 */
    OTHER,        /* 0xfb52 */
    OTHER,        /* 0xfb53 */
    OTHER,        /* 0xfb54 */
    OTHER,        /* 0xfb55 */
    OTHER,        /* 0xfb56 */
    OTHER,        /* 0xfb57 */
    OTHER,        /* 0xfb58 */
    OTHER,        /* 0xfb59 */
    OTHER,        /* 0xfb5a */
    OTHER,        /* 0xfb5b */
    OTHER,        /* 0xfb5c */
    OTHER,        /* 0xfb5d */
    OTHER,        /* 0xfb5e */
    OTHER,        /* 0xfb5f */
    OTHER,        /* 0xfb60 */
    OTHER,        /* 0xfb61 */
    OTHER,        /* 0xfb62 */
    OTHER,        /* 0xfb63 */
    OTHER,        /* 0xfb64 */
    OTHER,        /* 0xfb65 */
    OTHER,        /* 0xfb66 */
    OTHER,        /* 0xfb67 */
    OTHER,        /* 0xfb68 */
    OTHER,        /* 0xfb69 */
    OTHER,        /* 0xfb6a */
    OTHER,        /* 0xfb6b */
    OTHER,        /* 0xfb6c */
    OTHER,        /* 0xfb6d */
    OTHER,        /* 0xfb6e */
    OTHER,        /* 0xfb6f */
    OTHER,        /* 0xfb70 */
    OTHER,        /* 0xfb71 */
    OTHER,        /* 0xfb72 */
    OTHER,        /* 0xfb73 */
    OTHER,        /* 0xfb74 */
    OTHER,        /* 0xfb75 */
    OTHER,        /* 0xfb76 */
    OTHER,        /* 0xfb77 */
    OTHER,        /* 0xfb78 */
    OTHER,        /* 0xfb79 */
    OTHER,        /* 0xfb7a */
    OTHER,        /* 0xfb7b */
    OTHER,        /* 0xfb7c */
    OTHER,        /* 0xfb7d */
    OTHER,        /* 0xfb7e */
    OTHER,        /* 0xfb7f */
    OTHER,        /* 0xfb80 */
    OTHER,        /* 0xfb81 */
    OTHER,        /* 0xfb82 */
    OTHER,        /* 0xfb83 */
    OTHER,        /* 0xfb84 */
    OTHER,        /* 0xfb85 */
    OTHER,        /* 0xfb86 */
    OTHER,        /* 0xfb87 */
    OTHER,        /* 0xfb88 */
    OTHER,        /* 0xfb89 */
    OTHER,        /* 0xfb8a */
    OTHER,        /* 0xfb8b */
    OTHER,        /* 0xfb8c */
    OTHER,        /* 0xfb8d */
    OTHER,        /* 0xfb8e */
    OTHER,        /* 0xfb8f */
    OTHER,        /* 0xfb90 */
    OTHER,        /* 0xfb91 */
    OTHER,        /* 0xfb92 */
    OTHER,        /* 0xfb93 */
    OTHER,        /* 0xfb94 */
    OTHER,        /* 0xfb95 */
    OTHER,        /* 0xfb96 */
    OTHER,        /* 0xfb97 */
    OTHER,        /* 0xfb98 */
    OTHER,        /* 0xfb99 */
    OTHER,        /* 0xfb9a */
    OTHER,        /* 0xfb9b */
    OTHER,        /* 0xfb9c */
    OTHER,        /* 0xfb9d */
    OTHER,        /* 0xfb9e */
    OTHER,        /* 0xfb9f */
    OTHER,        /* 0xfba0 */
    OTHER,        /* 0xfba1 */
    OTHER,        /* 0xfba2 */
    OTHER,        /* 0xfba3 */
    OTHER,        /* 0xfba4 */
    OTHER,        /* 0xfba5 */
    OTHER,        /* 0xfba6 */
    OTHER,        /* 0xfba7 */
    OTHER,        /* 0xfba8 */
    OTHER,        /* 0xfba9 */
    OTHER,        /* 0xfbaa */
    OTHER,        /* 0xfbab */
    OTHER,        /* 0xfbac */
    OTHER,        /* 0xfbad */
    OTHER,        /* 0xfbae */
    OTHER,        /* 0xfbaf */
    OTHER,        /* 0xfbb0 */
    OTHER,        /* 0xfbb1 */
    OTHER,        /* 0xfbb2 */
    OTHER,        /* 0xfbb3 */
    OTHER,        /* 0xfbb4 */
    OTHER,        /* 0xfbb5 */
    OTHER,        /* 0xfbb6 */
    OTHER,        /* 0xfbb7 */
    OTHER,        /* 0xfbb8 */
    OTHER,        /* 0xfbb9 */
    OTHER,        /* 0xfbba */
    OTHER,        /* 0xfbbb */
    OTHER,        /* 0xfbbc */
    OTHER,        /* 0xfbbd */
    OTHER,        /* 0xfbbe */
    OTHER,        /* 0xfbbf */
    OTHER,        /* 0xfbc0 */
    OTHER,        /* 0xfbc1 */
    OTHER,        /* 0xfbc2 */
    OTHER,        /* 0xfbc3 */
    OTHER,        /* 0xfbc4 */
    OTHER,        /* 0xfbc5 */
    OTHER,        /* 0xfbc6 */
    OTHER,        /* 0xfbc7 */
    OTHER,        /* 0xfbc8 */
    OTHER,        /* 0xfbc9 */
    OTHER,        /* 0xfbca */
    OTHER,        /* 0xfbcb */
    OTHER,        /* 0xfbcc */
    OTHER,        /* 0xfbcd */
    OTHER,        /* 0xfbce */
    OTHER,        /* 0xfbcf */
    OTHER,        /* 0xfbd0 */
    OTHER,        /* 0xfbd1 */
    OTHER,        /* 0xfbd2 */
    OTHER,        /* 0xfbd3 */
    OTHER,        /* 0xfbd4 */
    OTHER,        /* 0xfbd5 */
    OTHER,        /* 0xfbd6 */
    OTHER,        /* 0xfbd7 */
    OTHER,        /* 0xfbd8 */
    OTHER,        /* 0xfbd9 */
    OTHER,        /* 0xfbda */
    OTHER,        /* 0xfbdb */
    OTHER,        /* 0xfbdc */
    OTHER,        /* 0xfbdd */
    OTHER,        /* 0xfbde */
    OTHER,        /* 0xfbdf */
    OTHER,        /* 0xfbe0 */
    OTHER,        /* 0xfbe1 */
    OTHER,        /* 0xfbe2 */
    OTHER,        /* 0xfbe3 */
    OTHER,        /* 0xfbe4 */
    OTHER,        /* 0xfbe5 */
    OTHER,        /* 0xfbe6 */
    OTHER,        /* 0xfbe7 */
    OTHER,        /* 0xfbe8 */
    OTHER,        /* 0xfbe9 */
    OTHER,        /* 0xfbea */
    OTHER,        /* 0xfbeb */
    OTHER,        /* 0xfbec */
    OTHER,        /* 0xfbed */
    OTHER,        /* 0xfbee */
    OTHER,        /* 0xfbef */
    OTHER,        /* 0xfbf0 */
    OTHER,        /* 0xfbf1 */
    OTHER,        /* 0xfbf2 */
    OTHER,        /* 0xfbf3 */
    OTHER,        /* 0xfbf4 */
    OTHER,        /* 0xfbf5 */
    OTHER,        /* 0xfbf6 */
    OTHER,        /* 0xfbf7 */
    OTHER,        /* 0xfbf8 */
    OTHER,        /* 0xfbf9 */
    OTHER,        /* 0xfbfa */
    OTHER,        /* 0xfbfb */
    OTHER,        /* 0xfbfc */
    OTHER,        /* 0xfbfd */
    OTHER,        /* 0xfbfe */
    OTHER,        /* 0xfbff */
    OTHER,        /* 0xfc00 */
    OTHER,        /* 0xfc01 */
    OTHER,        /* 0xfc02 */
    OTHER,        /* 0xfc03 */
    OTHER,        /* 0xfc04 */
    OTHER,        /* 0xfc05 */
    OTHER,        /* 0xfc06 */
    OTHER,        /* 0xfc07 */
    OTHER,        /* 0xfc08 */
    OTHER,        /* 0xfc09 */
    OTHER,        /* 0xfc0a */
    OTHER,        /* 0xfc0b */
    OTHER,        /* 0xfc0c */
    OTHER,        /* 0xfc0d */
    OTHER,        /* 0xfc0e */
    OTHER,        /* 0xfc0f */
    OTHER,        /* 0xfc10 */
    OTHER,        /* 0xfc11 */
    OTHER,        /* 0xfc12 */
    OTHER,        /* 0xfc13 */
    OTHER,        /* 0xfc14 */
    OTHER,        /* 0xfc15 */
    OTHER,        /* 0xfc16 */
    OTHER,        /* 0xfc17 */
    OTHER,        /* 0xfc18 */
    OTHER,        /* 0xfc19 */
    OTHER,        /* 0xfc1a */
    OTHER,        /* 0xfc1b */
    OTHER,        /* 0xfc1c */
    OTHER,        /* 0xfc1d */
    OTHER,        /* 0xfc1e */
    OTHER,        /* 0xfc1f */
    OTHER,        /* 0xfc20 */
    OTHER,        /* 0xfc21 */
    OTHER,        /* 0xfc22 */
    OTHER,        /* 0xfc23 */
    OTHER,        /* 0xfc24 */
    OTHER,        /* 0xfc25 */
    OTHER,        /* 0xfc26 */
    OTHER,        /* 0xfc27 */
    OTHER,        /* 0xfc28 */
    OTHER,        /* 0xfc29 */
    OTHER,        /* 0xfc2a */
    OTHER,        /* 0xfc2b */
    OTHER,        /* 0xfc2c */
    OTHER,        /* 0xfc2d */
    OTHER,        /* 0xfc2e */
    OTHER,        /* 0xfc2f */
    OTHER,        /* 0xfc30 */
    OTHER,        /* 0xfc31 */
    OTHER,        /* 0xfc32 */
    OTHER,        /* 0xfc33 */
    OTHER,        /* 0xfc34 */
    OTHER,        /* 0xfc35 */
    OTHER,        /* 0xfc36 */
    OTHER,        /* 0xfc37 */
    OTHER,        /* 0xfc38 */
    OTHER,        /* 0xfc39 */
    OTHER,        /* 0xfc3a */
    OTHER,        /* 0xfc3b */
    OTHER,        /* 0xfc3c */
    OTHER,        /* 0xfc3d */
    OTHER,        /* 0xfc3e */
    OTHER,        /* 0xfc3f */
    OTHER,        /* 0xfc40 */
    OTHER,        /* 0xfc41 */
    OTHER,        /* 0xfc42 */
    OTHER,        /* 0xfc43 */
    OTHER,        /* 0xfc44 */
    OTHER,        /* 0xfc45 */
    OTHER,        /* 0xfc46 */
    OTHER,        /* 0xfc47 */
    OTHER,        /* 0xfc48 */
    OTHER,        /* 0xfc49 */
    OTHER,        /* 0xfc4a */
    OTHER,        /* 0xfc4b */
    OTHER,        /* 0xfc4c */
    OTHER,        /* 0xfc4d */
    OTHER,        /* 0xfc4e */
    OTHER,        /* 0xfc4f */
    OTHER,        /* 0xfc50 */
    OTHER,        /* 0xfc51 */
    OTHER,        /* 0xfc52 */
    OTHER,        /* 0xfc53 */
    OTHER,        /* 0xfc54 */
    OTHER,        /* 0xfc55 */
    OTHER,        /* 0xfc56 */
    OTHER,        /* 0xfc57 */
    OTHER,        /* 0xfc58 */
    OTHER,        /* 0xfc59 */
    OTHER,        /* 0xfc5a */
    OTHER,        /* 0xfc5b */
    OTHER,        /* 0xfc5c */
    OTHER,        /* 0xfc5d */
    OTHER,        /* 0xfc5e */
    OTHER,        /* 0xfc5f */
    OTHER,        /* 0xfc60 */
    OTHER,        /* 0xfc61 */
    OTHER,        /* 0xfc62 */
    OTHER,        /* 0xfc63 */
    OTHER,        /* 0xfc64 */
    OTHER,        /* 0xfc65 */
    OTHER,        /* 0xfc66 */
    OTHER,        /* 0xfc67 */
    OTHER,        /* 0xfc68 */
    OTHER,        /* 0xfc69 */
    OTHER,        /* 0xfc6a */
    OTHER,        /* 0xfc6b */
    OTHER,        /* 0xfc6c */
    OTHER,        /* 0xfc6d */
    OTHER,        /* 0xfc6e */
    OTHER,        /* 0xfc6f */
    OTHER,        /* 0xfc70 */
    OTHER,        /* 0xfc71 */
    OTHER,        /* 0xfc72 */
    OTHER,        /* 0xfc73 */
    OTHER,        /* 0xfc74 */
    OTHER,        /* 0xfc75 */
    OTHER,        /* 0xfc76 */
    OTHER,        /* 0xfc77 */
    OTHER,        /* 0xfc78 */
    OTHER,        /* 0xfc79 */
    OTHER,        /* 0xfc7a */
    OTHER,        /* 0xfc7b */
    OTHER,        /* 0xfc7c */
    OTHER,        /* 0xfc7d */
    OTHER,        /* 0xfc7e */
    OTHER,        /* 0xfc7f */
    OTHER,        /* 0xfc80 */
    OTHER,        /* 0xfc81 */
    OTHER,        /* 0xfc82 */
    OTHER,        /* 0xfc83 */
    OTHER,        /* 0xfc84 */
    OTHER,        /* 0xfc85 */
    OTHER,        /* 0xfc86 */
    OTHER,        /* 0xfc87 */
    OTHER,        /* 0xfc88 */
    OTHER,        /* 0xfc89 */
    OTHER,        /* 0xfc8a */
    OTHER,        /* 0xfc8b */
    OTHER,        /* 0xfc8c */
    OTHER,        /* 0xfc8d */
    OTHER,        /* 0xfc8e */
    OTHER,        /* 0xfc8f */
    OTHER,        /* 0xfc90 */
    OTHER,        /* 0xfc91 */
    OTHER,        /* 0xfc92 */
    OTHER,        /* 0xfc93 */
    OTHER,        /* 0xfc94 */
    OTHER,        /* 0xfc95 */
    OTHER,        /* 0xfc96 */
    OTHER,        /* 0xfc97 */
    OTHER,        /* 0xfc98 */
    OTHER,        /* 0xfc99 */
    OTHER,        /* 0xfc9a */
    OTHER,        /* 0xfc9b */
    OTHER,        /* 0xfc9c */
    OTHER,        /* 0xfc9d */
    OTHER,        /* 0xfc9e */
    OTHER,        /* 0xfc9f */
    OTHER,        /* 0xfca0 */
    OTHER,        /* 0xfca1 */
    OTHER,        /* 0xfca2 */
    OTHER,        /* 0xfca3 */
    OTHER,        /* 0xfca4 */
    OTHER,        /* 0xfca5 */
    OTHER,        /* 0xfca6 */
    OTHER,        /* 0xfca7 */
    OTHER,        /* 0xfca8 */
    OTHER,        /* 0xfca9 */
    OTHER,        /* 0xfcaa */
    OTHER,        /* 0xfcab */
    OTHER,        /* 0xfcac */
    OTHER,        /* 0xfcad */
    OTHER,        /* 0xfcae */
    OTHER,        /* 0xfcaf */
    OTHER,        /* 0xfcb0 */
    OTHER,        /* 0xfcb1 */
    OTHER,        /* 0xfcb2 */
    OTHER,        /* 0xfcb3 */
    OTHER,        /* 0xfcb4 */
    OTHER,        /* 0xfcb5 */
    OTHER,        /* 0xfcb6 */
    OTHER,        /* 0xfcb7 */
    OTHER,        /* 0xfcb8 */
    OTHER,        /* 0xfcb9 */
    OTHER,        /* 0xfcba */
    OTHER,        /* 0xfcbb */
    OTHER,        /* 0xfcbc */
    OTHER,        /* 0xfcbd */
    OTHER,        /* 0xfcbe */
    OTHER,        /* 0xfcbf */
    OTHER,        /* 0xfcc0 */
    OTHER,        /* 0xfcc1 */
    OTHER,        /* 0xfcc2 */
    OTHER,        /* 0xfcc3 */
    OTHER,        /* 0xfcc4 */
    OTHER,        /* 0xfcc5 */
    OTHER,        /* 0xfcc6 */
    OTHER,        /* 0xfcc7 */
    OTHER,        /* 0xfcc8 */
    OTHER,        /* 0xfcc9 */
    OTHER,        /* 0xfcca */
    OTHER,        /* 0xfccb */
    OTHER,        /* 0xfccc */
    OTHER,        /* 0xfccd */
    OTHER,        /* 0xfcce */
    OTHER,        /* 0xfccf */
    OTHER,        /* 0xfcd0 */
    OTHER,        /* 0xfcd1 */
    OTHER,        /* 0xfcd2 */
    OTHER,        /* 0xfcd3 */
    OTHER,        /* 0xfcd4 */
    OTHER,        /* 0xfcd5 */
    OTHER,        /* 0xfcd6 */
    OTHER,        /* 0xfcd7 */
    OTHER,        /* 0xfcd8 */
    OTHER,        /* 0xfcd9 */
    OTHER,        /* 0xfcda */
    OTHER,        /* 0xfcdb */
    OTHER,        /* 0xfcdc */
    OTHER,        /* 0xfcdd */
    OTHER,        /* 0xfcde */
    OTHER,        /* 0xfcdf */
    OTHER,        /* 0xfce0 */
    OTHER,        /* 0xfce1 */
    OTHER,        /* 0xfce2 */
    OTHER,        /* 0xfce3 */
    OTHER,        /* 0xfce4 */
    OTHER,        /* 0xfce5 */
    OTHER,        /* 0xfce6 */
    OTHER,        /* 0xfce7 */
    OTHER,        /* 0xfce8 */
    OTHER,        /* 0xfce9 */
    OTHER,        /* 0xfcea */
    OTHER,        /* 0xfceb */
    OTHER,        /* 0xfcec */
    OTHER,        /* 0xfced */
    OTHER,        /* 0xfcee */
    OTHER,        /* 0xfcef */
    OTHER,        /* 0xfcf0 */
    OTHER,        /* 0xfcf1 */
    OTHER,        /* 0xfcf2 */
    OTHER,        /* 0xfcf3 */
    OTHER,        /* 0xfcf4 */
    OTHER,        /* 0xfcf5 */
    OTHER,        /* 0xfcf6 */
    OTHER,        /* 0xfcf7 */
    OTHER,        /* 0xfcf8 */
    OTHER,        /* 0xfcf9 */
    OTHER,        /* 0xfcfa */
    OTHER,        /* 0xfcfb */
    OTHER,        /* 0xfcfc */
    OTHER,        /* 0xfcfd */
    OTHER,        /* 0xfcfe */
    OTHER,        /* 0xfcff */
    OTHER,        /* 0xfd00 */
    OTHER,        /* 0xfd01 */
    OTHER,        /* 0xfd02 */
    OTHER,        /* 0xfd03 */
    OTHER,        /* 0xfd04 */
    OTHER,        /* 0xfd05 */
    OTHER,        /* 0xfd06 */
    OTHER,        /* 0xfd07 */
    OTHER,        /* 0xfd08 */
    OTHER,        /* 0xfd09 */
    OTHER,        /* 0xfd0a */
    OTHER,        /* 0xfd0b */
    OTHER,        /* 0xfd0c */
    OTHER,        /* 0xfd0d */
    OTHER,        /* 0xfd0e */
    OTHER,        /* 0xfd0f */
    OTHER,        /* 0xfd10 */
    OTHER,        /* 0xfd11 */
    OTHER,        /* 0xfd12 */
    OTHER,        /* 0xfd13 */
    OTHER,        /* 0xfd14 */
    OTHER,        /* 0xfd15 */
    OTHER,        /* 0xfd16 */
    OTHER,        /* 0xfd17 */
    OTHER,        /* 0xfd18 */
    OTHER,        /* 0xfd19 */
    OTHER,        /* 0xfd1a */
    OTHER,        /* 0xfd1b */
    OTHER,        /* 0xfd1c */
    OTHER,        /* 0xfd1d */
    OTHER,        /* 0xfd1e */
    OTHER,        /* 0xfd1f */
    OTHER,        /* 0xfd20 */
    OTHER,        /* 0xfd21 */
    OTHER,        /* 0xfd22 */
    OTHER,        /* 0xfd23 */
    OTHER,        /* 0xfd24 */
    OTHER,        /* 0xfd25 */
    OTHER,        /* 0xfd26 */
    OTHER,        /* 0xfd27 */
    OTHER,        /* 0xfd28 */
    OTHER,        /* 0xfd29 */
    OTHER,        /* 0xfd2a */
    OTHER,        /* 0xfd2b */
    OTHER,        /* 0xfd2c */
    OTHER,        /* 0xfd2d */
    OTHER,        /* 0xfd2e */
    OTHER,        /* 0xfd2f */
    OTHER,        /* 0xfd30 */
    OTHER,        /* 0xfd31 */
    OTHER,        /* 0xfd32 */
    OTHER,        /* 0xfd33 */
    OTHER,        /* 0xfd34 */
    OTHER,        /* 0xfd35 */
    OTHER,        /* 0xfd36 */
    OTHER,        /* 0xfd37 */
    OTHER,        /* 0xfd38 */
    OTHER,        /* 0xfd39 */
    OTHER,        /* 0xfd3a */
    OTHER,        /* 0xfd3b */
    OTHER,        /* 0xfd3c */
    OTHER,        /* 0xfd3d */
    OTHER,        /* 0xfd3e */
    OTHER,        /* 0xfd3f */
    OTHER,        /* 0xfd40 */
    OTHER,        /* 0xfd41 */
    OTHER,        /* 0xfd42 */
    OTHER,        /* 0xfd43 */
    OTHER,        /* 0xfd44 */
    OTHER,        /* 0xfd45 */
    OTHER,        /* 0xfd46 */
    OTHER,        /* 0xfd47 */
    OTHER,        /* 0xfd48 */
    OTHER,        /* 0xfd49 */
    OTHER,        /* 0xfd4a */
    OTHER,        /* 0xfd4b */
    OTHER,        /* 0xfd4c */
    OTHER,        /* 0xfd4d */
    OTHER,        /* 0xfd4e */
    OTHER,        /* 0xfd4f */
    OTHER,        /* 0xfd50 */
    OTHER,        /* 0xfd51 */
    OTHER,        /* 0xfd52 */
    OTHER,        /* 0xfd53 */
    OTHER,        /* 0xfd54 */
    OTHER,        /* 0xfd55 */
    OTHER,        /* 0xfd56 */
    OTHER,        /* 0xfd57 */
    OTHER,        /* 0xfd58 */
    OTHER,        /* 0xfd59 */
    OTHER,        /* 0xfd5a */
    OTHER,        /* 0xfd5b */
    OTHER,        /* 0xfd5c */
    OTHER,        /* 0xfd5d */
    OTHER,        /* 0xfd5e */
    OTHER,        /* 0xfd5f */
    OTHER,        /* 0xfd60 */
    OTHER,        /* 0xfd61 */
    OTHER,        /* 0xfd62 */
    OTHER,        /* 0xfd63 */
    OTHER,        /* 0xfd64 */
    OTHER,        /* 0xfd65 */
    OTHER,        /* 0xfd66 */
    OTHER,        /* 0xfd67 */
    OTHER,        /* 0xfd68 */
    OTHER,        /* 0xfd69 */
    OTHER,        /* 0xfd6a */
    OTHER,        /* 0xfd6b */
    OTHER,        /* 0xfd6c */
    OTHER,        /* 0xfd6d */
    OTHER,        /* 0xfd6e */
    OTHER,        /* 0xfd6f */
    OTHER,        /* 0xfd70 */
    OTHER,        /* 0xfd71 */
    OTHER,        /* 0xfd72 */
    OTHER,        /* 0xfd73 */
    OTHER,        /* 0xfd74 */
    OTHER,        /* 0xfd75 */
    OTHER,        /* 0xfd76 */
    OTHER,        /* 0xfd77 */
    OTHER,        /* 0xfd78 */
    OTHER,        /* 0xfd79 */
    OTHER,        /* 0xfd7a */
    OTHER,        /* 0xfd7b */
    OTHER,        /* 0xfd7c */
    OTHER,        /* 0xfd7d */
    OTHER,        /* 0xfd7e */
    OTHER,        /* 0xfd7f */
    OTHER,        /* 0xfd80 */
    OTHER,        /* 0xfd81 */
    OTHER,        /* 0xfd82 */
    OTHER,        /* 0xfd83 */
    OTHER,        /* 0xfd84 */
    OTHER,        /* 0xfd85 */
    OTHER,        /* 0xfd86 */
    OTHER,        /* 0xfd87 */
    OTHER,        /* 0xfd88 */
    OTHER,        /* 0xfd89 */
    OTHER,        /* 0xfd8a */
    OTHER,        /* 0xfd8b */
    OTHER,        /* 0xfd8c */
    OTHER,        /* 0xfd8d */
    OTHER,        /* 0xfd8e */
    OTHER,        /* 0xfd8f */
    OTHER,        /* 0xfd90 */
    OTHER,        /* 0xfd91 */
    OTHER,        /* 0xfd92 */
    OTHER,        /* 0xfd93 */
    OTHER,        /* 0xfd94 */
    OTHER,        /* 0xfd95 */
    OTHER,        /* 0xfd96 */
    OTHER,        /* 0xfd97 */
    OTHER,        /* 0xfd98 */
    OTHER,        /* 0xfd99 */
    OTHER,        /* 0xfd9a */
    OTHER,        /* 0xfd9b */
    OTHER,        /* 0xfd9c */
    OTHER,        /* 0xfd9d */
    OTHER,        /* 0xfd9e */
    OTHER,        /* 0xfd9f */
    OTHER,        /* 0xfda0 */
    OTHER,        /* 0xfda1 */
    OTHER,        /* 0xfda2 */
    OTHER,        /* 0xfda3 */
    OTHER,        /* 0xfda4 */
    OTHER,        /* 0xfda5 */
    OTHER,        /* 0xfda6 */
    OTHER,        /* 0xfda7 */
    OTHER,        /* 0xfda8 */
    OTHER,        /* 0xfda9 */
    OTHER,        /* 0xfdaa */
    OTHER,        /* 0xfdab */
    OTHER,        /* 0xfdac */
    OTHER,        /* 0xfdad */
    OTHER,        /* 0xfdae */
    OTHER,        /* 0xfdaf */
    OTHER,        /* 0xfdb0 */
    OTHER,        /* 0xfdb1 */
    OTHER,        /* 0xfdb2 */
    OTHER,        /* 0xfdb3 */
    OTHER,        /* 0xfdb4 */
    OTHER,        /* 0xfdb5 */
    OTHER,        /* 0xfdb6 */
    OTHER,        /* 0xfdb7 */
    OTHER,        /* 0xfdb8 */
    OTHER,        /* 0xfdb9 */
    OTHER,        /* 0xfdba */
    OTHER,        /* 0xfdbb */
    OTHER,        /* 0xfdbc */
    OTHER,        /* 0xfdbd */
    OTHER,        /* 0xfdbe */
    OTHER,        /* 0xfdbf */
    OTHER,        /* 0xfdc0 */
    OTHER,        /* 0xfdc1 */
    OTHER,        /* 0xfdc2 */
    OTHER,        /* 0xfdc3 */
    OTHER,        /* 0xfdc4 */
    OTHER,        /* 0xfdc5 */
    OTHER,        /* 0xfdc6 */
    OTHER,        /* 0xfdc7 */
    OTHER,        /* 0xfdc8 */
    OTHER,        /* 0xfdc9 */
    OTHER,        /* 0xfdca */
    OTHER,        /* 0xfdcb */
    OTHER,        /* 0xfdcc */
    OTHER,        /* 0xfdcd */
    OTHER,        /* 0xfdce */
    OTHER,        /* 0xfdcf */
    OTHER,        /* 0xfdd0 */
    OTHER,        /* 0xfdd1 */
    OTHER,        /* 0xfdd2 */
    OTHER,        /* 0xfdd3 */
    OTHER,        /* 0xfdd4 */
    OTHER,        /* 0xfdd5 */
    OTHER,        /* 0xfdd6 */
    OTHER,        /* 0xfdd7 */
    OTHER,        /* 0xfdd8 */
    OTHER,        /* 0xfdd9 */
    OTHER,        /* 0xfdda */
    OTHER,        /* 0xfddb */
    OTHER,        /* 0xfddc */
    OTHER,        /* 0xfddd */
    OTHER,        /* 0xfdde */
    OTHER,        /* 0xfddf */
    OTHER,        /* 0xfde0 */
    OTHER,        /* 0xfde1 */
    OTHER,        /* 0xfde2 */
    OTHER,        /* 0xfde3 */
    OTHER,        /* 0xfde4 */
    OTHER,        /* 0xfde5 */
    OTHER,        /* 0xfde6 */
    OTHER,        /* 0xfde7 */
    OTHER,        /* 0xfde8 */
    OTHER,        /* 0xfde9 */
    OTHER,        /* 0xfdea */
    OTHER,        /* 0xfdeb */
    OTHER,        /* 0xfdec */
    OTHER,        /* 0xfded */
    OTHER,        /* 0xfdee */
    OTHER,        /* 0xfdef */
    OTHER,        /* 0xfdf0 */
    OTHER,        /* 0xfdf1 */
    OTHER,        /* 0xfdf2 */
    OTHER,        /* 0xfdf3 */
    OTHER,        /* 0xfdf4 */
    OTHER,        /* 0xfdf5 */
    OTHER,        /* 0xfdf6 */
    OTHER,        /* 0xfdf7 */
    OTHER,        /* 0xfdf8 */
    OTHER,        /* 0xfdf9 */
    OTHER,        /* 0xfdfa */
    OTHER,        /* 0xfdfb */
    OTHER,        /* 0xfdfc */
    OTHER,        /* 0xfdfd */
    OTHER,        /* 0xfdfe */
    OTHER,        /* 0xfdff */
    OTHER,        /* 0xfe00 */
    OTHER,        /* 0xfe01 */
    OTHER,        /* 0xfe02 */
    OTHER,        /* 0xfe03 */
    OTHER,        /* 0xfe04 */
    OTHER,        /* 0xfe05 */
    OTHER,        /* 0xfe06 */
    OTHER,        /* 0xfe07 */
    OTHER,        /* 0xfe08 */
    OTHER,        /* 0xfe09 */
    OTHER,        /* 0xfe0a */
    OTHER,        /* 0xfe0b */
    OTHER,        /* 0xfe0c */
    OTHER,        /* 0xfe0d */
    OTHER,        /* 0xfe0e */
    OTHER,        /* 0xfe0f */
    OTHER,        /* 0xfe10 */
    OTHER,        /* 0xfe11 */
    OTHER,        /* 0xfe12 */
    OTHER,        /* 0xfe13 */
    OTHER,        /* 0xfe14 */
    OTHER,        /* 0xfe15 */
    OTHER,        /* 0xfe16 */
    OTHER,        /* 0xfe17 */
    OTHER,        /* 0xfe18 */
    OTHER,        /* 0xfe19 */
    OTHER,        /* 0xfe1a */
    OTHER,        /* 0xfe1b */
    OTHER,        /* 0xfe1c */
    OTHER,        /* 0xfe1d */
    OTHER,        /* 0xfe1e */
    OTHER,        /* 0xfe1f */
    OTHER,        /* 0xfe20 */
    OTHER,        /* 0xfe21 */
    OTHER,        /* 0xfe22 */
    OTHER,        /* 0xfe23 */
    OTHER,        /* 0xfe24 */
    OTHER,        /* 0xfe25 */
    OTHER,        /* 0xfe26 */
    OTHER,        /* 0xfe27 */
    OTHER,        /* 0xfe28 */
    OTHER,        /* 0xfe29 */
    OTHER,        /* 0xfe2a */
    OTHER,        /* 0xfe2b */
    OTHER,        /* 0xfe2c */
    OTHER,        /* 0xfe2d */
    OTHER,        /* 0xfe2e */
    OTHER,        /* 0xfe2f */
    SYMBOL,        /* 0xfe30 */
    SYMBOL,        /* 0xfe31 */
    SYMBOL,        /* 0xfe32 */
    SYMBOL,        /* 0xfe33 */
    SYMBOL,        /* 0xfe34 */
    SYMBOL,        /* 0xfe35 */
    SYMBOL,        /* 0xfe36 */
    SYMBOL,        /* 0xfe37 */
    SYMBOL,        /* 0xfe38 */
    SYMBOL,        /* 0xfe39 */
    SYMBOL,        /* 0xfe3a */
    SYMBOL,        /* 0xfe3b */
    SYMBOL,        /* 0xfe3c */
    SYMBOL,        /* 0xfe3d */
    SYMBOL,        /* 0xfe3e */
    SYMBOL,        /* 0xfe3f */
    SYMBOL,        /* 0xfe40 */
    SYMBOL,        /* 0xfe41 */
    SYMBOL,        /* 0xfe42 */
    SYMBOL,        /* 0xfe43 */
    SYMBOL,        /* 0xfe44 */
    SYMBOL,        /* 0xfe45 */
    SYMBOL,        /* 0xfe46 */
    SYMBOL,        /* 0xfe47 */
    SYMBOL,        /* 0xfe48 */
    SYMBOL,        /* 0xfe49 */
    SYMBOL,        /* 0xfe4a */
    SYMBOL,        /* 0xfe4b */
    SYMBOL,        /* 0xfe4c */
    SYMBOL,        /* 0xfe4d */
    SYMBOL,        /* 0xfe4e */
    SYMBOL,        /* 0xfe4f */
    SYMBOL,        /* 0xfe50 */
    SYMBOL,        /* 0xfe51 */
    SYMBOL,        /* 0xfe52 */
    SYMBOL,        /* 0xfe53 */
    SYMBOL,        /* 0xfe54 */
    SYMBOL,        /* 0xfe55 */
    SYMBOL,        /* 0xfe56 */
    SYMBOL,        /* 0xfe57 */
    SYMBOL,        /* 0xfe58 */
    SYMBOL,        /* 0xfe59 */
    SYMBOL,        /* 0xfe5a */
    SYMBOL,        /* 0xfe5b */
    SYMBOL,        /* 0xfe5c */
    SYMBOL,        /* 0xfe5d */
    SYMBOL,        /* 0xfe5e */
    SYMBOL,        /* 0xfe5f */
    SYMBOL,        /* 0xfe60 */
    SYMBOL,        /* 0xfe61 */
    SYMBOL,        /* 0xfe62 */
    SYMBOL,        /* 0xfe63 */
    SYMBOL,        /* 0xfe64 */
    SYMBOL,        /* 0xfe65 */
    SYMBOL,        /* 0xfe66 */
    SYMBOL,        /* 0xfe67 */
    SYMBOL,        /* 0xfe68 */
    SYMBOL,        /* 0xfe69 */
    SYMBOL,        /* 0xfe6a */
    SYMBOL,        /* 0xfe6b */
    OTHER,        /* 0xfe6c */
    OTHER,        /* 0xfe6d */
    OTHER,        /* 0xfe6e */
    OTHER,        /* 0xfe6f */
    OTHER,        /* 0xfe70 */
    OTHER,        /* 0xfe71 */
    OTHER,        /* 0xfe72 */
    OTHER,        /* 0xfe73 */
    OTHER,        /* 0xfe74 */
    OTHER,        /* 0xfe75 */
    OTHER,        /* 0xfe76 */
    OTHER,        /* 0xfe77 */
    OTHER,        /* 0xfe78 */
    OTHER,        /* 0xfe79 */
    OTHER,        /* 0xfe7a */
    OTHER,        /* 0xfe7b */
    OTHER,        /* 0xfe7c */
    OTHER,        /* 0xfe7d */
    OTHER,        /* 0xfe7e */
    OTHER,        /* 0xfe7f */
    OTHER,        /* 0xfe80 */
    OTHER,        /* 0xfe81 */
    OTHER,        /* 0xfe82 */
    OTHER,        /* 0xfe83 */
    OTHER,        /* 0xfe84 */
    OTHER,        /* 0xfe85 */
    OTHER,        /* 0xfe86 */
    OTHER,        /* 0xfe87 */
    OTHER,        /* 0xfe88 */
    OTHER,        /* 0xfe89 */
    OTHER,        /* 0xfe8a */
    OTHER,        /* 0xfe8b */
    OTHER,        /* 0xfe8c */
    OTHER,        /* 0xfe8d */
    OTHER,        /* 0xfe8e */
    OTHER,        /* 0xfe8f */
    OTHER,        /* 0xfe90 */
    OTHER,        /* 0xfe91 */
    OTHER,        /* 0xfe92 */
    OTHER,        /* 0xfe93 */
    OTHER,        /* 0xfe94 */
    OTHER,        /* 0xfe95 */
    OTHER,        /* 0xfe96 */
    OTHER,        /* 0xfe97 */
    OTHER,        /* 0xfe98 */
    OTHER,        /* 0xfe99 */
    OTHER,        /* 0xfe9a */
    OTHER,        /* 0xfe9b */
    OTHER,        /* 0xfe9c */
    OTHER,        /* 0xfe9d */
    OTHER,        /* 0xfe9e */
    OTHER,        /* 0xfe9f */
    OTHER,        /* 0xfea0 */
    OTHER,        /* 0xfea1 */
    OTHER,        /* 0xfea2 */
    OTHER,        /* 0xfea3 */
    OTHER,        /* 0xfea4 */
    OTHER,        /* 0xfea5 */
    OTHER,        /* 0xfea6 */
    OTHER,        /* 0xfea7 */
    OTHER,        /* 0xfea8 */
    OTHER,        /* 0xfea9 */
    OTHER,        /* 0xfeaa */
    OTHER,        /* 0xfeab */
    OTHER,        /* 0xfeac */
    OTHER,        /* 0xfead */
    OTHER,        /* 0xfeae */
    OTHER,        /* 0xfeaf */
    OTHER,        /* 0xfeb0 */
    OTHER,        /* 0xfeb1 */
    OTHER,        /* 0xfeb2 */
    OTHER,        /* 0xfeb3 */
    OTHER,        /* 0xfeb4 */
    OTHER,        /* 0xfeb5 */
    OTHER,        /* 0xfeb6 */
    OTHER,        /* 0xfeb7 */
    OTHER,        /* 0xfeb8 */
    OTHER,        /* 0xfeb9 */
    OTHER,        /* 0xfeba */
    OTHER,        /* 0xfebb */
    OTHER,        /* 0xfebc */
    OTHER,        /* 0xfebd */
    OTHER,        /* 0xfebe */
    OTHER,        /* 0xfebf */
    OTHER,        /* 0xfec0 */
    OTHER,        /* 0xfec1 */
    OTHER,        /* 0xfec2 */
    OTHER,        /* 0xfec3 */
    OTHER,        /* 0xfec4 */
    OTHER,        /* 0xfec5 */
    OTHER,        /* 0xfec6 */
    OTHER,        /* 0xfec7 */
    OTHER,        /* 0xfec8 */
    OTHER,        /* 0xfec9 */
    OTHER,        /* 0xfeca */
    OTHER,        /* 0xfecb */
    OTHER,        /* 0xfecc */
    OTHER,        /* 0xfecd */
    OTHER,        /* 0xfece */
    OTHER,        /* 0xfecf */
    OTHER,        /* 0xfed0 */
    OTHER,        /* 0xfed1 */
    OTHER,        /* 0xfed2 */
    OTHER,        /* 0xfed3 */
    OTHER,        /* 0xfed4 */
    OTHER,        /* 0xfed5 */
    OTHER,        /* 0xfed6 */
    OTHER,        /* 0xfed7 */
    OTHER,        /* 0xfed8 */
    OTHER,        /* 0xfed9 */
    OTHER,        /* 0xfeda */
    OTHER,        /* 0xfedb */
    OTHER,        /* 0xfedc */
    OTHER,        /* 0xfedd */
    OTHER,        /* 0xfede */
    OTHER,        /* 0xfedf */
    OTHER,        /* 0xfee0 */
    OTHER,        /* 0xfee1 */
    OTHER,        /* 0xfee2 */
    OTHER,        /* 0xfee3 */
    OTHER,        /* 0xfee4 */
    OTHER,        /* 0xfee5 */
    OTHER,        /* 0xfee6 */
    OTHER,        /* 0xfee7 */
    OTHER,        /* 0xfee8 */
    OTHER,        /* 0xfee9 */
    OTHER,        /* 0xfeea */
    OTHER,        /* 0xfeeb */
    OTHER,        /* 0xfeec */
    OTHER,        /* 0xfeed */
    OTHER,        /* 0xfeee */
    OTHER,        /* 0xfeef */
    OTHER,        /* 0xfef0 */
    OTHER,        /* 0xfef1 */
    OTHER,        /* 0xfef2 */
    OTHER,        /* 0xfef3 */
    OTHER,        /* 0xfef4 */
    OTHER,        /* 0xfef5 */
    OTHER,        /* 0xfef6 */
    OTHER,        /* 0xfef7 */
    OTHER,        /* 0xfef8 */
    OTHER,        /* 0xfef9 */
    OTHER,        /* 0xfefa */
    OTHER,        /* 0xfefb */
    OTHER,        /* 0xfefc */
    OTHER,        /* 0xfefd */
    OTHER,        /* 0xfefe */
    OTHER,        /* 0xfeff */
    OTHER,        /* 0xff00 */
    SYMBOL,        /* 0xff01 */
    SYMBOL,        /* 0xff02 */
    SYMBOL,        /* 0xff03 */
    SYMBOL,        /* 0xff04 */
    SYMBOL,        /* 0xff05 */
    SYMBOL,        /* 0xff06 */
    SYMBOL,        /* 0xff07 */
    SYMBOL,        /* 0xff08 */
    SYMBOL,        /* 0xff09 */
    SYMBOL,        /* 0xff0a */
    SYMBOL,        /* 0xff0b */
    SYMBOL,        /* 0xff0c */
    SYMBOL,        /* 0xff0d */
    SYMBOL,        /* 0xff0e */
    SYMBOL,        /* 0xff0f */
    ALPHANUMERIC,        /* 0xff10 */
    ALPHANUMERIC,        /* 0xff11 */
    ALPHANUMERIC,        /* 0xff12 */
    ALPHANUMERIC,        /* 0xff13 */
    ALPHANUMERIC,        /* 0xff14 */
    ALPHANUMERIC,        /* 0xff15 */
    ALPHANUMERIC,        /* 0xff16 */
    ALPHANUMERIC,        /* 0xff17 */
    ALPHANUMERIC,        /* 0xff18 */
    ALPHANUMERIC,        /* 0xff19 */
    SYMBOL,        /* 0xff1a */
    SYMBOL,        /* 0xff1b */
    SYMBOL,        /* 0xff1c */
    SYMBOL,        /* 0xff1d */
    SYMBOL,        /* 0xff1e */
    SYMBOL,        /* 0xff1f */
    OTHER,        /* 0xff20 */
    ALPHA,        /* 0xff21 */
    ALPHA,        /* 0xff22 */
    ALPHA,        /* 0xff23 */
    ALPHA,        /* 0xff24 */
    ALPHA,        /* 0xff25 */
    ALPHA,        /* 0xff26 */
    ALPHA,        /* 0xff27 */
    ALPHA,        /* 0xff28 */
    ALPHA,        /* 0xff29 */
    ALPHA,        /* 0xff2a */
    ALPHA,        /* 0xff2b */
    ALPHA,        /* 0xff2c */
    ALPHA,        /* 0xff2d */
    ALPHA,        /* 0xff2e */
    ALPHA,        /* 0xff2f */
    ALPHA,        /* 0xff30 */
    ALPHA,        /* 0xff31 */
    ALPHA,        /* 0xff32 */
    ALPHA,        /* 0xff33 */
    ALPHA,        /* 0xff34 */
    ALPHA,        /* 0xff35 */
    ALPHA,        /* 0xff36 */
    ALPHA,        /* 0xff37 */
    ALPHA,        /* 0xff38 */
    ALPHA,        /* 0xff39 */
    ALPHA,        /* 0xff3a */
    SYMBOL,        /* 0xff3b */
    SYMBOL,        /* 0xff3c */
    SYMBOL,        /* 0xff3d */
    SYMBOL,        /* 0xff3e */
    SYMBOL,        /* 0xff3f */
    SYMBOL,        /* 0xff40 */
    ALPHA,        /* 0xff41 */
    ALPHA,        /* 0xff42 */
    ALPHA,        /* 0xff43 */
    ALPHA,        /* 0xff44 */
    ALPHA,        /* 0xff45 */
    ALPHA,        /* 0xff46 */
    ALPHA,        /* 0xff47 */
    ALPHA,        /* 0xff48 */
    ALPHA,        /* 0xff49 */
    ALPHA,        /* 0xff4a */
    ALPHA,        /* 0xff4b */
    ALPHA,        /* 0xff4c */
    ALPHA,        /* 0xff4d */
    ALPHA,        /* 0xff4e */
    ALPHA,        /* 0xff4f */
    ALPHA,        /* 0xff50 */
    ALPHA,        /* 0xff51 */
    ALPHA,        /* 0xff52 */
    ALPHA,        /* 0xff53 */
    ALPHA,        /* 0xff54 */
    ALPHA,        /* 0xff55 */
    ALPHA,        /* 0xff56 */
    ALPHA,        /* 0xff57 */
    ALPHA,        /* 0xff58 */
    ALPHA,        /* 0xff59 */
    ALPHA,        /* 0xff5a */
    SYMBOL,        /* 0xff5b */
    SYMBOL,        /* 0xff5c */
    SYMBOL,        /* 0xff5d */
    SYMBOL,        /* 0xff5e */
    SYMBOL,        /* 0xff5f */
    SYMBOL,        /* 0xff60 */
    SYMBOL,        /* 0xff61 */
    SYMBOL,        /* 0xff62 */
    SYMBOL,        /* 0xff63 */
    SYMBOL,        /* 0xff64 */
    SYMBOL,        /* 0xff65 */
    KATAKANA,        /* 0xff66 */
    KATAKANA,        /* 0xff67 */
    KATAKANA,        /* 0xff68 */
    KATAKANA,        /* 0xff69 */
    KATAKANA,        /* 0xff6a */
    KATAKANA,        /* 0xff6b */
    KATAKANA,        /* 0xff6c */
    KATAKANA,        /* 0xff6d */
    KATAKANA,        /* 0xff6e */
    KATAKANA,        /* 0xff6f */
    KATAKANA,        /* 0xff70 */
    KATAKANA,        /* 0xff71 */
    KATAKANA,        /* 0xff72 */
    KATAKANA,        /* 0xff73 */
    KATAKANA,        /* 0xff74 */
    KATAKANA,        /* 0xff75 */
    KATAKANA,        /* 0xff76 */
    KATAKANA,        /* 0xff77 */
    KATAKANA,        /* 0xff78 */
    KATAKANA,        /* 0xff79 */
    KATAKANA,        /* 0xff7a */
    KATAKANA,        /* 0xff7b */
    KATAKANA,        /* 0xff7c */
    KATAKANA,        /* 0xff7d */
    KATAKANA,        /* 0xff7e */
    KATAKANA,        /* 0xff7f */
    KATAKANA,        /* 0xff80 */
    KATAKANA,        /* 0xff81 */
    KATAKANA,        /* 0xff82 */
    KATAKANA,        /* 0xff83 */
    KATAKANA,        /* 0xff84 */
    KATAKANA,        /* 0xff85 */
    KATAKANA,        /* 0xff86 */
    KATAKANA,        /* 0xff87 */
    KATAKANA,        /* 0xff88 */
    KATAKANA,        /* 0xff89 */
    KATAKANA,        /* 0xff8a */
    KATAKANA,        /* 0xff8b */
    KATAKANA,        /* 0xff8c */
    KATAKANA,        /* 0xff8d */
    KATAKANA,        /* 0xff8e */
    KATAKANA,        /* 0xff8f */
    KATAKANA,        /* 0xff90 */
    KATAKANA,        /* 0xff91 */
    KATAKANA,        /* 0xff92 */
    KATAKANA,        /* 0xff93 */
    KATAKANA,        /* 0xff94 */
    KATAKANA,        /* 0xff95 */
    KATAKANA,        /* 0xff96 */
    KATAKANA,        /* 0xff97 */
    KATAKANA,        /* 0xff98 */
    KATAKANA,        /* 0xff99 */
    KATAKANA,        /* 0xff9a */
    KATAKANA,        /* 0xff9b */
    KATAKANA,        /* 0xff9c */
    KATAKANA,        /* 0xff9d */
    KATAKANA,        /* 0xff9e */
    KATAKANA,        /* 0xff9f */
    OTHER,        /* 0xffa0 */
    OTHER,        /* 0xffa1 */
    OTHER,        /* 0xffa2 */
    OTHER,        /* 0xffa3 */
    OTHER,        /* 0xffa4 */
    OTHER,        /* 0xffa5 */
    OTHER,        /* 0xffa6 */
    OTHER,        /* 0xffa7 */
    OTHER,        /* 0xffa8 */
    OTHER,        /* 0xffa9 */
    OTHER,        /* 0xffaa */
    OTHER,        /* 0xffab */
    OTHER,        /* 0xffac */
    OTHER,        /* 0xffad */
    OTHER,        /* 0xffae */
    OTHER,        /* 0xffaf */
    OTHER,        /* 0xffb0 */
    OTHER,        /* 0xffb1 */
    OTHER,        /* 0xffb2 */
    OTHER,        /* 0xffb3 */
    OTHER,        /* 0xffb4 */
    OTHER,        /* 0xffb5 */
    OTHER,        /* 0xffb6 */
    OTHER,        /* 0xffb7 */
    OTHER,        /* 0xffb8 */
    OTHER,        /* 0xffb9 */
    OTHER,        /* 0xffba */
    OTHER,        /* 0xffbb */
    OTHER,        /* 0xffbc */
    OTHER,        /* 0xffbd */
    OTHER,        /* 0xffbe */
    OTHER,        /* 0xffbf */
    OTHER,        /* 0xffc0 */
    OTHER,        /* 0xffc1 */
    OTHER,        /* 0xffc2 */
    OTHER,        /* 0xffc3 */
    OTHER,        /* 0xffc4 */
    OTHER,        /* 0xffc5 */
    OTHER,        /* 0xffc6 */
    OTHER,        /* 0xffc7 */
    OTHER,        /* 0xffc8 */
    OTHER,        /* 0xffc9 */
    OTHER,        /* 0xffca */
    OTHER,        /* 0xffcb */
    OTHER,        /* 0xffcc */
    OTHER,        /* 0xffcd */
    OTHER,        /* 0xffce */
    OTHER,        /* 0xffcf */
    OTHER,        /* 0xffd0 */
    OTHER,        /* 0xffd1 */
    OTHER,        /* 0xffd2 */
    OTHER,        /* 0xffd3 */
    OTHER,        /* 0xffd4 */
    OTHER,        /* 0xffd5 */
    OTHER,        /* 0xffd6 */
    OTHER,        /* 0xffd7 */
    OTHER,        /* 0xffd8 */
    OTHER,        /* 0xffd9 */
    OTHER,        /* 0xffda */
    OTHER,        /* 0xffdb */
    OTHER,        /* 0xffdc */
    OTHER,        /* 0xffdd */
    OTHER,        /* 0xffde */
    OTHER,        /* 0xffdf */
    SYMBOL,        /* 0xffe0 */
    SYMBOL,        /* 0xffe1 */
    SYMBOL,        /* 0xffe2 */
    SYMBOL,        /* 0xffe3 */
    SYMBOL,        /* 0xffe4 */
    SYMBOL,        /* 0xffe5 */
    SYMBOL,        /* 0xffe6 */
    SYMBOL,        /* 0xffe7 */
    SYMBOL,        /* 0xffe8 */
    SYMBOL,        /* 0xffe9 */
    SYMBOL,        /* 0xffea */
    SYMBOL,        /* 0xffeb */
    SYMBOL,        /* 0xffec */
    SYMBOL,        /* 0xffed */
    SYMBOL,        /* 0xffee */
    SYMBOL,        /* 0xffef */
    OTHER,        /* 0xfff0 */
    OTHER,        /* 0xfff1 */
    OTHER,        /* 0xfff2 */
    OTHER,        /* 0xfff3 */
    OTHER,        /* 0xfff4 */
    OTHER,        /* 0xfff5 */
    OTHER,        /* 0xfff6 */
    OTHER,        /* 0xfff7 */
    OTHER,        /* 0xfff8 */
    OTHER,        /* 0xfff9 */
    OTHER,        /* 0xfffa */
    OTHER,        /* 0xfffb */
    OTHER,        /* 0xfffc */
    OTHER,        /* 0xfffd */
    OTHER        /* 0xfffe */
  };
}
#endif
